#############################################################################
##
## Copyright (C) 2018 The Qt Company Ltd.
## Contact: https://www.qt.io/licensing/
##
## This file is part of Qt for Python.
##
## $QT_BEGIN_LICENSE:LGPL$
## Commercial License Usage
## Licensees holding valid commercial Qt licenses may use this file in
## accordance with the commercial license agreement provided with the
## Software or, alternatively, in accordance with the terms contained in
## a written agreement between you and The Qt Company. For licensing terms
## and conditions see https://www.qt.io/terms-conditions. For further
## information use the contact form at https://www.qt.io/contact-us.
##
## GNU Lesser General Public License Usage
## Alternatively, this file may be used under the terms of the GNU Lesser
## General Public License version 3 as published by the Free Software
## Foundation and appearing in the file LICENSE.LGPL3 included in the
## packaging of this file. Please review the following information to
## ensure the GNU Lesser General Public License version 3 requirements
## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
##
## GNU General Public License Usage
## Alternatively, this file may be used under the terms of the GNU
## General Public License version 2.0 or (at your option) the GNU General
## Public license version 3 or any later version approved by the KDE Free
## Qt Foundation. The licenses are as published by the Free Software
## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
## included in the packaging of this file. Please review the following
## information to ensure the GNU General Public License requirements will
## be met: https://www.gnu.org/licenses/gpl-2.0.html and
## https://www.gnu.org/licenses/gpl-3.0.html.
##
## $QT_END_LICENSE$
##
#############################################################################

"""
This file contains the simplified signatures for all functions in PySide
for module 'exists_darwin_5_14_0_ci' using
Python 2.7.16 (v2.7.16:413a49145e, Mar  2 2019, 15:28:37)  [GCC 4.2.1 (Apple Inc. build 5666) (dot 3)]
Qt 5.14.0 (x86_64-little_endian-lp64 shared (dynamic) release build; by Clang 10.0.0 (clang-1000.11.45.5) (Apple))

There are no default values, no variable names and no self
parameter. Only types are present after simplification. The
functions 'next' resp. '__next__' are removed to make the output
identical for Python 2 and 3. '__div__' is also removed,
since it exists in Python 2, only.
"""

import sys

sig_dict = {}

# Module PySide2.QtCore
sig_dict.update({

# class PySide2.QtCore.ClassInfo:
    "PySide2.QtCore.ClassInfo.__init__": ('typing.Dict[str, str]',),

# class PySide2.QtCore.MetaFunction:
    "PySide2.QtCore.MetaFunction.__call__": ('typing.Any',),

# class PySide2.QtCore.MetaSignal:
    "PySide2.QtCore.MetaSignal.__instancecheck__": ('object',),

# class PySide2.QtCore.Property:
    "PySide2.QtCore.Property.__init__": ('type', 'typing.Callable', 'typing.Callable', 'typing.Callable', 'typing.Callable', 'str', 'typing.Callable', 'bool', 'bool', 'bool', 'bool', 'bool', 'bool'),
    "PySide2.QtCore.Property.getter": ('typing.Callable',),
    "PySide2.QtCore.Property.read": ('typing.Callable',),
    "PySide2.QtCore.Property.setter": ('typing.Callable',),
    "PySide2.QtCore.Property.write": ('typing.Callable',),

# class PySide2.QtCore.QAbstractAnimation:

# class PySide2.QtCore.QAbstractAnimation.DeletionPolicy:

# class PySide2.QtCore.QAbstractAnimation.Direction:

# class PySide2.QtCore.QAbstractAnimation.State:
    "PySide2.QtCore.QAbstractAnimation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractAnimation.currentLoop": (),
    "PySide2.QtCore.QAbstractAnimation.currentLoopTime": (),
    "PySide2.QtCore.QAbstractAnimation.currentTime": (),
    "PySide2.QtCore.QAbstractAnimation.direction": (),
    "PySide2.QtCore.QAbstractAnimation.duration": (),
    "PySide2.QtCore.QAbstractAnimation.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractAnimation.group": (),
    "PySide2.QtCore.QAbstractAnimation.loopCount": (),
    "PySide2.QtCore.QAbstractAnimation.pause": (),
    "PySide2.QtCore.QAbstractAnimation.resume": (),
    "PySide2.QtCore.QAbstractAnimation.setCurrentTime": ('int',),
    "PySide2.QtCore.QAbstractAnimation.setDirection": ('PySide2.QtCore.QAbstractAnimation.Direction',),
    "PySide2.QtCore.QAbstractAnimation.setLoopCount": ('int',),
    "PySide2.QtCore.QAbstractAnimation.setPaused": ('bool',),
    "PySide2.QtCore.QAbstractAnimation.start": ('PySide2.QtCore.QAbstractAnimation.DeletionPolicy',),
    "PySide2.QtCore.QAbstractAnimation.state": (),
    "PySide2.QtCore.QAbstractAnimation.stop": (),
    "PySide2.QtCore.QAbstractAnimation.totalDuration": (),
    "PySide2.QtCore.QAbstractAnimation.updateCurrentTime": ('int',),
    "PySide2.QtCore.QAbstractAnimation.updateDirection": ('PySide2.QtCore.QAbstractAnimation.Direction',),
    "PySide2.QtCore.QAbstractAnimation.updateState": ('PySide2.QtCore.QAbstractAnimation.State', 'PySide2.QtCore.QAbstractAnimation.State'),

# class PySide2.QtCore.QAbstractEventDispatcher:

# class PySide2.QtCore.QAbstractEventDispatcher.TimerInfo:
    "PySide2.QtCore.QAbstractEventDispatcher.TimerInfo.__init__": ('int', 'int', 'PySide2.QtCore.Qt.TimerType'),

    "PySide2.QtCore.QAbstractEventDispatcher.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractEventDispatcher.closingDown": (),
    "PySide2.QtCore.QAbstractEventDispatcher.filterNativeEvent": ('PySide2.QtCore.QByteArray', 'int'),
    "PySide2.QtCore.QAbstractEventDispatcher.flush": (),
    "PySide2.QtCore.QAbstractEventDispatcher.hasPendingEvents": (),
    "PySide2.QtCore.QAbstractEventDispatcher.installNativeEventFilter": ('PySide2.QtCore.QAbstractNativeEventFilter',),
    "PySide2.QtCore.QAbstractEventDispatcher.instance": ('PySide2.QtCore.QThread',),
    "PySide2.QtCore.QAbstractEventDispatcher.interrupt": (),
    "PySide2.QtCore.QAbstractEventDispatcher.processEvents": ('PySide2.QtCore.QEventLoop.ProcessEventsFlags',),
    "PySide2.QtCore.QAbstractEventDispatcher.registerSocketNotifier": ('PySide2.QtCore.QSocketNotifier',),
    "PySide2.QtCore.QAbstractEventDispatcher.registerTimer": [('int', 'PySide2.QtCore.Qt.TimerType', 'PySide2.QtCore.QObject'), ('int', 'int', 'PySide2.QtCore.Qt.TimerType', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QAbstractEventDispatcher.registeredTimers": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractEventDispatcher.remainingTime": ('int',),
    "PySide2.QtCore.QAbstractEventDispatcher.removeNativeEventFilter": ('PySide2.QtCore.QAbstractNativeEventFilter',),
    "PySide2.QtCore.QAbstractEventDispatcher.startingUp": (),
    "PySide2.QtCore.QAbstractEventDispatcher.unregisterSocketNotifier": ('PySide2.QtCore.QSocketNotifier',),
    "PySide2.QtCore.QAbstractEventDispatcher.unregisterTimer": ('int',),
    "PySide2.QtCore.QAbstractEventDispatcher.unregisterTimers": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractEventDispatcher.wakeUp": (),

# class PySide2.QtCore.QAbstractItemModel:

# class PySide2.QtCore.QAbstractItemModel.CheckIndexOption:

# class PySide2.QtCore.QAbstractItemModel.CheckIndexOptions:

# class PySide2.QtCore.QAbstractItemModel.LayoutChangeHint:
    "PySide2.QtCore.QAbstractItemModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractItemModel.beginInsertColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtCore.QAbstractItemModel.beginInsertRows": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtCore.QAbstractItemModel.beginMoveColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.beginMoveRows": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.beginRemoveColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtCore.QAbstractItemModel.beginRemoveRows": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtCore.QAbstractItemModel.beginResetModel": (),
    "PySide2.QtCore.QAbstractItemModel.buddy": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.canDropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.canFetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.changePersistentIndex": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.changePersistentIndexList": ('typing.List[int]', 'typing.List[int]'),
    "PySide2.QtCore.QAbstractItemModel.checkIndex": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QAbstractItemModel.CheckIndexOptions'),
    "PySide2.QtCore.QAbstractItemModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.createIndex": [('int', 'int', 'int'), ('int', 'int', 'object')],
    "PySide2.QtCore.QAbstractItemModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.decodeData": ('int', 'int', 'PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QDataStream'),
    "PySide2.QtCore.QAbstractItemModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.encodeData": ('typing.List[int]', 'PySide2.QtCore.QDataStream'),
    "PySide2.QtCore.QAbstractItemModel.endInsertColumns": (),
    "PySide2.QtCore.QAbstractItemModel.endInsertRows": (),
    "PySide2.QtCore.QAbstractItemModel.endMoveColumns": (),
    "PySide2.QtCore.QAbstractItemModel.endMoveRows": (),
    "PySide2.QtCore.QAbstractItemModel.endRemoveColumns": (),
    "PySide2.QtCore.QAbstractItemModel.endRemoveRows": (),
    "PySide2.QtCore.QAbstractItemModel.endResetModel": (),
    "PySide2.QtCore.QAbstractItemModel.fetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.hasIndex": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtCore.QAbstractItemModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.insertColumn": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.insertColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.insertRow": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.itemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.match": ('PySide2.QtCore.QModelIndex', 'int', 'typing.Any', 'int', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtCore.QAbstractItemModel.mimeData": ('typing.List[int]',),
    "PySide2.QtCore.QAbstractItemModel.mimeTypes": (),
    "PySide2.QtCore.QAbstractItemModel.moveColumn": ('PySide2.QtCore.QModelIndex', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.moveColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.moveRow": ('PySide2.QtCore.QModelIndex', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.moveRows": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractItemModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QAbstractItemModel.persistentIndexList": (),
    "PySide2.QtCore.QAbstractItemModel.removeColumn": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.removeRow": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.resetInternalData": (),
    "PySide2.QtCore.QAbstractItemModel.revert": (),
    "PySide2.QtCore.QAbstractItemModel.roleNames": (),
    "PySide2.QtCore.QAbstractItemModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtCore.QAbstractItemModel.setHeaderData": ('int', 'PySide2.QtCore.Qt.Orientation', 'typing.Any', 'int'),
    "PySide2.QtCore.QAbstractItemModel.setItemData": ('PySide2.QtCore.QModelIndex', 'typing.Dict[int, typing.Any]'),
    "PySide2.QtCore.QAbstractItemModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractItemModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtCore.QAbstractItemModel.span": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractItemModel.submit": (),
    "PySide2.QtCore.QAbstractItemModel.supportedDragActions": (),
    "PySide2.QtCore.QAbstractItemModel.supportedDropActions": (),

# class PySide2.QtCore.QAbstractListModel:
    "PySide2.QtCore.QAbstractListModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractListModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractListModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractListModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractListModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractListModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractListModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QAbstractListModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtCore.QAbstractNativeEventFilter:
    "PySide2.QtCore.QAbstractNativeEventFilter.__init__": (),
    "PySide2.QtCore.QAbstractNativeEventFilter.nativeEventFilter": ('PySide2.QtCore.QByteArray', 'int'),

# class PySide2.QtCore.QAbstractProxyModel:
    "PySide2.QtCore.QAbstractProxyModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractProxyModel.buddy": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.canDropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractProxyModel.canFetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QAbstractProxyModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractProxyModel.fetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtCore.QAbstractProxyModel.itemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.mapFromSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.mapSelectionFromSource": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtCore.QAbstractProxyModel.mapSelectionToSource": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtCore.QAbstractProxyModel.mapToSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.mimeData": ('typing.List[int]',),
    "PySide2.QtCore.QAbstractProxyModel.mimeTypes": (),
    "PySide2.QtCore.QAbstractProxyModel.resetInternalData": (),
    "PySide2.QtCore.QAbstractProxyModel.revert": (),
    "PySide2.QtCore.QAbstractProxyModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtCore.QAbstractProxyModel.setHeaderData": ('int', 'PySide2.QtCore.Qt.Orientation', 'typing.Any', 'int'),
    "PySide2.QtCore.QAbstractProxyModel.setItemData": ('PySide2.QtCore.QModelIndex', 'typing.Dict[int, typing.Any]'),
    "PySide2.QtCore.QAbstractProxyModel.setSourceModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCore.QAbstractProxyModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractProxyModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtCore.QAbstractProxyModel.sourceModel": (),
    "PySide2.QtCore.QAbstractProxyModel.span": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractProxyModel.submit": (),
    "PySide2.QtCore.QAbstractProxyModel.supportedDragActions": (),
    "PySide2.QtCore.QAbstractProxyModel.supportedDropActions": (),

# class PySide2.QtCore.QAbstractState:
    "PySide2.QtCore.QAbstractState.__init__": ('PySide2.QtCore.QState',),
    "PySide2.QtCore.QAbstractState.active": (),
    "PySide2.QtCore.QAbstractState.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractState.machine": (),
    "PySide2.QtCore.QAbstractState.onEntry": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractState.onExit": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractState.parentState": (),

# class PySide2.QtCore.QAbstractTableModel:
    "PySide2.QtCore.QAbstractTableModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAbstractTableModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractTableModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractTableModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QAbstractTableModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QAbstractTableModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QAbstractTableModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtCore.QAbstractTransition:

# class PySide2.QtCore.QAbstractTransition.TransitionType:
    "PySide2.QtCore.QAbstractTransition.__init__": ('PySide2.QtCore.QState',),
    "PySide2.QtCore.QAbstractTransition.addAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QAbstractTransition.animations": (),
    "PySide2.QtCore.QAbstractTransition.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractTransition.eventTest": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractTransition.machine": (),
    "PySide2.QtCore.QAbstractTransition.onTransition": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAbstractTransition.removeAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QAbstractTransition.setTargetState": ('PySide2.QtCore.QAbstractState',),
    "PySide2.QtCore.QAbstractTransition.setTargetStates": ('typing.Sequence[PySide2.QtCore.QAbstractState]',),
    "PySide2.QtCore.QAbstractTransition.setTransitionType": ('PySide2.QtCore.QAbstractTransition.TransitionType',),
    "PySide2.QtCore.QAbstractTransition.sourceState": (),
    "PySide2.QtCore.QAbstractTransition.targetState": (),
    "PySide2.QtCore.QAbstractTransition.targetStates": (),
    "PySide2.QtCore.QAbstractTransition.transitionType": (),

# class PySide2.QtCore.QAnimationGroup:
    "PySide2.QtCore.QAnimationGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QAnimationGroup.addAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QAnimationGroup.animationAt": ('int',),
    "PySide2.QtCore.QAnimationGroup.animationCount": (),
    "PySide2.QtCore.QAnimationGroup.clear": (),
    "PySide2.QtCore.QAnimationGroup.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QAnimationGroup.indexOfAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QAnimationGroup.insertAnimation": ('int', 'PySide2.QtCore.QAbstractAnimation'),
    "PySide2.QtCore.QAnimationGroup.removeAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QAnimationGroup.takeAnimation": ('int',),

# class PySide2.QtCore.QBasicMutex:
    "PySide2.QtCore.QBasicMutex.__init__": (),
    "PySide2.QtCore.QBasicMutex.isRecursive": (),
    "PySide2.QtCore.QBasicMutex.lock": (),
    "PySide2.QtCore.QBasicMutex.tryLock": (),
    "PySide2.QtCore.QBasicMutex.try_lock": (),
    "PySide2.QtCore.QBasicMutex.unlock": (),

# class PySide2.QtCore.QBasicTimer:
    "PySide2.QtCore.QBasicTimer.__init__": [(), ('PySide2.QtCore.QBasicTimer',)],
    "PySide2.QtCore.QBasicTimer.__copy__": (),
    "PySide2.QtCore.QBasicTimer.isActive": (),
    "PySide2.QtCore.QBasicTimer.start": [('int', 'PySide2.QtCore.QObject'), ('int', 'PySide2.QtCore.Qt.TimerType', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QBasicTimer.stop": (),
    "PySide2.QtCore.QBasicTimer.swap": ('PySide2.QtCore.QBasicTimer',),
    "PySide2.QtCore.QBasicTimer.timerId": (),

# class PySide2.QtCore.QBitArray:
    "PySide2.QtCore.QBitArray.__init__": [(), ('PySide2.QtCore.QBitArray',), ('int', 'bool')],
    "PySide2.QtCore.QBitArray.__and__": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.__copy__": (),
    "PySide2.QtCore.QBitArray.__iand__": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.__invert__": (),
    "PySide2.QtCore.QBitArray.__ior__": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.__ixor__": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.__or__": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.__xor__": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.at": ('int',),
    "PySide2.QtCore.QBitArray.bits": (),
    "PySide2.QtCore.QBitArray.clear": (),
    "PySide2.QtCore.QBitArray.clearBit": ('int',),
    "PySide2.QtCore.QBitArray.count": [(), ('bool',)],
    "PySide2.QtCore.QBitArray.fill": [('bool', 'int'), ('bool', 'int', 'int')],
    "PySide2.QtCore.QBitArray.fromBits": ('str', 'int'),
    "PySide2.QtCore.QBitArray.isEmpty": (),
    "PySide2.QtCore.QBitArray.isNull": (),
    "PySide2.QtCore.QBitArray.resize": ('int',),
    "PySide2.QtCore.QBitArray.setBit": [('int',), ('int', 'bool')],
    "PySide2.QtCore.QBitArray.size": (),
    "PySide2.QtCore.QBitArray.swap": ('PySide2.QtCore.QBitArray',),
    "PySide2.QtCore.QBitArray.testBit": ('int',),
    "PySide2.QtCore.QBitArray.toggleBit": ('int',),
    "PySide2.QtCore.QBitArray.truncate": ('int',),

# class PySide2.QtCore.QBuffer:
    "PySide2.QtCore.QBuffer.__init__": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',)],
    "PySide2.QtCore.QBuffer.atEnd": (),
    "PySide2.QtCore.QBuffer.buffer": (),
    "PySide2.QtCore.QBuffer.canReadLine": (),
    "PySide2.QtCore.QBuffer.close": (),
    "PySide2.QtCore.QBuffer.connectNotify": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtCore.QBuffer.data": (),
    "PySide2.QtCore.QBuffer.disconnectNotify": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtCore.QBuffer.open": ('PySide2.QtCore.QIODevice.OpenMode',),
    "PySide2.QtCore.QBuffer.pos": (),
    "PySide2.QtCore.QBuffer.readData": ('str', 'int'),
    "PySide2.QtCore.QBuffer.seek": ('int',),
    "PySide2.QtCore.QBuffer.setBuffer": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QBuffer.setData": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QBuffer.size": (),
    "PySide2.QtCore.QBuffer.writeData": ('str', 'int'),

# class PySide2.QtCore.QByteArray:

# class PySide2.QtCore.QByteArray.Base64Option:

# class PySide2.QtCore.QByteArray.Base64Options:
    "PySide2.QtCore.QByteArray.__init__": [(), ('PySide2.QtCore.QByteArray',), ('bytearray',), ('int', 'typing.Char'), ('str',)],
    "PySide2.QtCore.QByteArray.__add__": [('PySide2.QtCore.QByteArray',), ('bytearray',), ('str',), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.__copy__": (),
    "PySide2.QtCore.QByteArray.__iadd__": [('PySide2.QtCore.QByteArray',), ('bytearray',), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.__reduce__": (),
    "PySide2.QtCore.QByteArray.__repr__": (),
    "PySide2.QtCore.QByteArray.__str__": (),
    "PySide2.QtCore.QByteArray.append": [('PySide2.QtCore.QByteArray',), ('int', 'typing.Char'), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.at": ('int',),
    "PySide2.QtCore.QByteArray.back": (),
    "PySide2.QtCore.QByteArray.capacity": (),
    "PySide2.QtCore.QByteArray.cbegin": (),
    "PySide2.QtCore.QByteArray.cend": (),
    "PySide2.QtCore.QByteArray.chop": ('int',),
    "PySide2.QtCore.QByteArray.chopped": ('int',),
    "PySide2.QtCore.QByteArray.clear": (),
    "PySide2.QtCore.QByteArray.compare": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.Qt.CaseSensitivity'), ('str', 'PySide2.QtCore.Qt.CaseSensitivity')],
    "PySide2.QtCore.QByteArray.contains": [('PySide2.QtCore.QByteArray',), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.count": [(), ('PySide2.QtCore.QByteArray',), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.data": (),
    "PySide2.QtCore.QByteArray.endsWith": [('PySide2.QtCore.QByteArray',), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.fill": ('typing.Char', 'int'),
    "PySide2.QtCore.QByteArray.fromBase64": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray.Base64Options')],
    "PySide2.QtCore.QByteArray.fromHex": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QByteArray.fromPercentEncoding": ('PySide2.QtCore.QByteArray', 'typing.Char'),
    "PySide2.QtCore.QByteArray.fromRawData": ('str', 'int'),
    "PySide2.QtCore.QByteArray.front": (),
    "PySide2.QtCore.QByteArray.indexOf": ('PySide2.QtCore.QByteArray', 'int'),
    "PySide2.QtCore.QByteArray.insert": [('int', 'PySide2.QtCore.QByteArray'), ('int', 'int', 'typing.Char')],
    "PySide2.QtCore.QByteArray.isEmpty": (),
    "PySide2.QtCore.QByteArray.isLower": (),
    "PySide2.QtCore.QByteArray.isNull": (),
    "PySide2.QtCore.QByteArray.isSharedWith": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QByteArray.isUpper": (),
    "PySide2.QtCore.QByteArray.lastIndexOf": ('PySide2.QtCore.QByteArray', 'int'),
    "PySide2.QtCore.QByteArray.left": ('int',),
    "PySide2.QtCore.QByteArray.leftJustified": ('int', 'typing.Char', 'bool'),
    "PySide2.QtCore.QByteArray.length": (),
    "PySide2.QtCore.QByteArray.mid": ('int', 'int'),
    "PySide2.QtCore.QByteArray.number": [('float', 'typing.Char', 'int'), ('int', 'int')],
    "PySide2.QtCore.QByteArray.prepend": [('PySide2.QtCore.QByteArray',), ('int', 'typing.Char'), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.remove": ('int', 'int'),
    "PySide2.QtCore.QByteArray.repeated": ('int',),
    "PySide2.QtCore.QByteArray.replace": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'), ('int', 'int', 'PySide2.QtCore.QByteArray'), ('str', 'PySide2.QtCore.QByteArray'), ('typing.Char', 'PySide2.QtCore.QByteArray'), ('typing.Char', 'typing.Char')],
    "PySide2.QtCore.QByteArray.reserve": ('int',),
    "PySide2.QtCore.QByteArray.resize": ('int',),
    "PySide2.QtCore.QByteArray.right": ('int',),
    "PySide2.QtCore.QByteArray.rightJustified": ('int', 'typing.Char', 'bool'),
    "PySide2.QtCore.QByteArray.setNum": [('float', 'typing.Char', 'int'), ('int', 'int')],
    "PySide2.QtCore.QByteArray.setRawData": ('str', 'int'),
    "PySide2.QtCore.QByteArray.shrink_to_fit": (),
    "PySide2.QtCore.QByteArray.simplified": (),
    "PySide2.QtCore.QByteArray.size": (),
    "PySide2.QtCore.QByteArray.split": ('typing.Char',),
    "PySide2.QtCore.QByteArray.squeeze": (),
    "PySide2.QtCore.QByteArray.startsWith": [('PySide2.QtCore.QByteArray',), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.swap": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QByteArray.toBase64": [(), ('PySide2.QtCore.QByteArray.Base64Options',)],
    "PySide2.QtCore.QByteArray.toDouble": (),
    "PySide2.QtCore.QByteArray.toFloat": (),
    "PySide2.QtCore.QByteArray.toHex": [(), ('typing.Char',)],
    "PySide2.QtCore.QByteArray.toInt": ('int',),
    "PySide2.QtCore.QByteArray.toLong": ('int',),
    "PySide2.QtCore.QByteArray.toLongLong": ('int',),
    "PySide2.QtCore.QByteArray.toLower": (),
    "PySide2.QtCore.QByteArray.toPercentEncoding": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray', 'typing.Char'),
    "PySide2.QtCore.QByteArray.toShort": ('int',),
    "PySide2.QtCore.QByteArray.toUInt": ('int',),
    "PySide2.QtCore.QByteArray.toULong": ('int',),
    "PySide2.QtCore.QByteArray.toULongLong": ('int',),
    "PySide2.QtCore.QByteArray.toUShort": ('int',),
    "PySide2.QtCore.QByteArray.toUpper": (),
    "PySide2.QtCore.QByteArray.trimmed": (),
    "PySide2.QtCore.QByteArray.truncate": ('int',),

# class PySide2.QtCore.QByteArrayMatcher:
    "PySide2.QtCore.QByteArrayMatcher.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArrayMatcher',), ('str', 'int')],
    "PySide2.QtCore.QByteArrayMatcher.__copy__": (),
    "PySide2.QtCore.QByteArrayMatcher.indexIn": [('PySide2.QtCore.QByteArray', 'int'), ('str', 'int', 'int')],
    "PySide2.QtCore.QByteArrayMatcher.pattern": (),
    "PySide2.QtCore.QByteArrayMatcher.setPattern": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtCore.QCalendar:

# class PySide2.QtCore.QCalendar.System:

# class PySide2.QtCore.QCalendar.YearMonthDay:
    "PySide2.QtCore.QCalendar.YearMonthDay.__init__": [(), ('PySide2.QtCore.QCalendar.YearMonthDay',), ('int', 'int', 'int')],
    "PySide2.QtCore.QCalendar.YearMonthDay.__copy__": (),
    "PySide2.QtCore.QCalendar.YearMonthDay.isValid": (),

    "PySide2.QtCore.QCalendar.__init__": [(), ('PySide2.QtCore.QCalendar.System',)],
    "PySide2.QtCore.QCalendar.__copy__": (),
    "PySide2.QtCore.QCalendar.availableCalendars": (),
    "PySide2.QtCore.QCalendar.dateFromParts": [('PySide2.QtCore.QCalendar.YearMonthDay',), ('int', 'int', 'int')],
    "PySide2.QtCore.QCalendar.dayOfWeek": ('PySide2.QtCore.QDate',),
    "PySide2.QtCore.QCalendar.daysInMonth": ('int', 'int'),
    "PySide2.QtCore.QCalendar.daysInYear": ('int',),
    "PySide2.QtCore.QCalendar.hasYearZero": (),
    "PySide2.QtCore.QCalendar.isDateValid": ('int', 'int', 'int'),
    "PySide2.QtCore.QCalendar.isGregorian": (),
    "PySide2.QtCore.QCalendar.isLeapYear": ('int',),
    "PySide2.QtCore.QCalendar.isLunar": (),
    "PySide2.QtCore.QCalendar.isLuniSolar": (),
    "PySide2.QtCore.QCalendar.isProleptic": (),
    "PySide2.QtCore.QCalendar.isSolar": (),
    "PySide2.QtCore.QCalendar.isValid": (),
    "PySide2.QtCore.QCalendar.maximumDaysInMonth": (),
    "PySide2.QtCore.QCalendar.maximumMonthsInYear": (),
    "PySide2.QtCore.QCalendar.minimumDaysInMonth": (),
    "PySide2.QtCore.QCalendar.monthName": ('PySide2.QtCore.QLocale', 'int', 'int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QCalendar.monthsInYear": ('int',),
    "PySide2.QtCore.QCalendar.name": (),
    "PySide2.QtCore.QCalendar.partsFromDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtCore.QCalendar.standaloneMonthName": ('PySide2.QtCore.QLocale', 'int', 'int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QCalendar.standaloneWeekDayName": ('PySide2.QtCore.QLocale', 'int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QCalendar.weekDayName": ('PySide2.QtCore.QLocale', 'int', 'PySide2.QtCore.QLocale.FormatType'),

# class PySide2.QtCore.QCborArray:
    "PySide2.QtCore.QCborArray.__init__": [(), ('PySide2.QtCore.QCborArray',)],
    "PySide2.QtCore.QCborArray.__add__": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.__copy__": (),
    "PySide2.QtCore.QCborArray.__iadd__": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.__lshift__": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.append": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.at": ('int',),
    "PySide2.QtCore.QCborArray.clear": (),
    "PySide2.QtCore.QCborArray.compare": ('PySide2.QtCore.QCborArray',),
    "PySide2.QtCore.QCborArray.contains": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.empty": (),
    "PySide2.QtCore.QCborArray.first": (),
    "PySide2.QtCore.QCborArray.fromJsonArray": ('PySide2.QtCore.QJsonArray',),
    "PySide2.QtCore.QCborArray.fromStringList": ('typing.Sequence[str]',),
    "PySide2.QtCore.QCborArray.fromVariantList": ('typing.Sequence[typing.Any]',),
    "PySide2.QtCore.QCborArray.insert": ('int', 'PySide2.QtCore.QCborValue'),
    "PySide2.QtCore.QCborArray.isEmpty": (),
    "PySide2.QtCore.QCborArray.last": (),
    "PySide2.QtCore.QCborArray.pop_back": (),
    "PySide2.QtCore.QCborArray.pop_front": (),
    "PySide2.QtCore.QCborArray.prepend": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.push_back": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.push_front": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborArray.removeAt": ('int',),
    "PySide2.QtCore.QCborArray.removeFirst": (),
    "PySide2.QtCore.QCborArray.removeLast": (),
    "PySide2.QtCore.QCborArray.size": (),
    "PySide2.QtCore.QCborArray.swap": ('PySide2.QtCore.QCborArray',),
    "PySide2.QtCore.QCborArray.takeAt": ('int',),
    "PySide2.QtCore.QCborArray.takeFirst": (),
    "PySide2.QtCore.QCborArray.takeLast": (),
    "PySide2.QtCore.QCborArray.toCborValue": (),
    "PySide2.QtCore.QCborArray.toJsonArray": (),
    "PySide2.QtCore.QCborArray.toVariantList": (),

# class PySide2.QtCore.QCborError:

# class PySide2.QtCore.QCborError.Code:
    "PySide2.QtCore.QCborError.__init__": [(), ('PySide2.QtCore.QCborError',)],
    "PySide2.QtCore.QCborError.__copy__": (),
    "PySide2.QtCore.QCborError.toString": (),

# class PySide2.QtCore.QCborKnownTags:

# class PySide2.QtCore.QCborMap:
    "PySide2.QtCore.QCborMap.__init__": [(), ('PySide2.QtCore.QCborMap',)],
    "PySide2.QtCore.QCborMap.__copy__": (),
    "PySide2.QtCore.QCborMap.clear": (),
    "PySide2.QtCore.QCborMap.compare": ('PySide2.QtCore.QCborMap',),
    "PySide2.QtCore.QCborMap.contains": [('PySide2.QtCore.QCborValue',), ('int',), ('str',)],
    "PySide2.QtCore.QCborMap.empty": (),
    "PySide2.QtCore.QCborMap.fromJsonObject": ('typing.Dict[str, PySide2.QtCore.QJsonValue]',),
    "PySide2.QtCore.QCborMap.fromVariantHash": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtCore.QCborMap.fromVariantMap": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtCore.QCborMap.isEmpty": (),
    "PySide2.QtCore.QCborMap.keys": (),
    "PySide2.QtCore.QCborMap.remove": [('PySide2.QtCore.QCborValue',), ('int',), ('str',)],
    "PySide2.QtCore.QCborMap.size": (),
    "PySide2.QtCore.QCborMap.swap": ('PySide2.QtCore.QCborMap',),
    "PySide2.QtCore.QCborMap.take": [('PySide2.QtCore.QCborValue',), ('int',), ('str',)],
    "PySide2.QtCore.QCborMap.toCborValue": (),
    "PySide2.QtCore.QCborMap.toJsonObject": (),
    "PySide2.QtCore.QCborMap.toVariantHash": (),
    "PySide2.QtCore.QCborMap.toVariantMap": (),
    "PySide2.QtCore.QCborMap.value": [('PySide2.QtCore.QCborValue',), ('int',), ('str',)],

# class PySide2.QtCore.QCborParserError:
    "PySide2.QtCore.QCborParserError.__init__": [(), ('PySide2.QtCore.QCborParserError',)],
    "PySide2.QtCore.QCborParserError.__copy__": (),
    "PySide2.QtCore.QCborParserError.errorString": (),

# class PySide2.QtCore.QCborSimpleType:

# class PySide2.QtCore.QCborStreamReader:

# class PySide2.QtCore.QCborStreamReader.StringResultCode:

# class PySide2.QtCore.QCborStreamReader.Type:
    "PySide2.QtCore.QCborStreamReader.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',), ('bytearray', 'int'), ('str', 'int')],
    "PySide2.QtCore.QCborStreamReader.addData": [('PySide2.QtCore.QByteArray',), ('bytearray', 'int'), ('str', 'int')],
    "PySide2.QtCore.QCborStreamReader.clear": (),
    "PySide2.QtCore.QCborStreamReader.containerDepth": (),
    "PySide2.QtCore.QCborStreamReader.currentOffset": (),
    "PySide2.QtCore.QCborStreamReader.currentStringChunkSize": (),
    "PySide2.QtCore.QCborStreamReader.device": (),
    "PySide2.QtCore.QCborStreamReader.enterContainer": (),
    "PySide2.QtCore.QCborStreamReader.hasNext": (),
    "PySide2.QtCore.QCborStreamReader.isArray": (),
    "PySide2.QtCore.QCborStreamReader.isBool": (),
    "PySide2.QtCore.QCborStreamReader.isByteArray": (),
    "PySide2.QtCore.QCborStreamReader.isContainer": (),
    "PySide2.QtCore.QCborStreamReader.isDouble": (),
    "PySide2.QtCore.QCborStreamReader.isFalse": (),
    "PySide2.QtCore.QCborStreamReader.isFloat": (),
    "PySide2.QtCore.QCborStreamReader.isFloat16": (),
    "PySide2.QtCore.QCborStreamReader.isInteger": (),
    "PySide2.QtCore.QCborStreamReader.isInvalid": (),
    "PySide2.QtCore.QCborStreamReader.isLengthKnown": (),
    "PySide2.QtCore.QCborStreamReader.isMap": (),
    "PySide2.QtCore.QCborStreamReader.isNegativeInteger": (),
    "PySide2.QtCore.QCborStreamReader.isNull": (),
    "PySide2.QtCore.QCborStreamReader.isSimpleType": [(), ('PySide2.QtCore.QCborSimpleType',)],
    "PySide2.QtCore.QCborStreamReader.isString": (),
    "PySide2.QtCore.QCborStreamReader.isTag": (),
    "PySide2.QtCore.QCborStreamReader.isTrue": (),
    "PySide2.QtCore.QCborStreamReader.isUndefined": (),
    "PySide2.QtCore.QCborStreamReader.isUnsignedInteger": (),
    "PySide2.QtCore.QCborStreamReader.isValid": (),
    "PySide2.QtCore.QCborStreamReader.lastError": (),
    "PySide2.QtCore.QCborStreamReader.leaveContainer": (),
    "PySide2.QtCore.QCborStreamReader.length": (),
    "PySide2.QtCore.QCborStreamReader.parentContainerType": (),
    "PySide2.QtCore.QCborStreamReader.readByteArray": (),
    "PySide2.QtCore.QCborStreamReader.readString": (),
    "PySide2.QtCore.QCborStreamReader.reparse": (),
    "PySide2.QtCore.QCborStreamReader.reset": (),
    "PySide2.QtCore.QCborStreamReader.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtCore.QCborStreamReader.toBool": (),
    "PySide2.QtCore.QCborStreamReader.toDouble": (),
    "PySide2.QtCore.QCborStreamReader.toFloat": (),
    "PySide2.QtCore.QCborStreamReader.toInteger": (),
    "PySide2.QtCore.QCborStreamReader.toSimpleType": (),
    "PySide2.QtCore.QCborStreamReader.toUnsignedInteger": (),
    "PySide2.QtCore.QCborStreamReader.type": (),

# class PySide2.QtCore.QCborStreamWriter:
    "PySide2.QtCore.QCborStreamWriter.__init__": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtCore.QCborStreamWriter.append": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QCborKnownTags',), ('PySide2.QtCore.QCborSimpleType',), ('bool',), ('float',), ('int',), ('str', 'int')],
    "PySide2.QtCore.QCborStreamWriter.appendByteString": ('str', 'int'),
    "PySide2.QtCore.QCborStreamWriter.appendNull": (),
    "PySide2.QtCore.QCborStreamWriter.appendTextString": ('str', 'int'),
    "PySide2.QtCore.QCborStreamWriter.appendUndefined": (),
    "PySide2.QtCore.QCborStreamWriter.device": (),
    "PySide2.QtCore.QCborStreamWriter.endArray": (),
    "PySide2.QtCore.QCborStreamWriter.endMap": (),
    "PySide2.QtCore.QCborStreamWriter.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtCore.QCborStreamWriter.startArray": [(), ('int',)],
    "PySide2.QtCore.QCborStreamWriter.startMap": [(), ('int',)],

# class PySide2.QtCore.QCborStringResultByteArray:
    "PySide2.QtCore.QCborStringResultByteArray.__init__": [(), ('PySide2.QtCore.QCborStringResultByteArray',)],
    "PySide2.QtCore.QCborStringResultByteArray.__copy__": (),

# class PySide2.QtCore.QCborStringResultString:
    "PySide2.QtCore.QCborStringResultString.__init__": [(), ('PySide2.QtCore.QCborStringResultString',)],
    "PySide2.QtCore.QCborStringResultString.__copy__": (),

# class PySide2.QtCore.QCborValue:

# class PySide2.QtCore.QCborValue.DiagnosticNotationOption:

# class PySide2.QtCore.QCborValue.DiagnosticNotationOptions:

# class PySide2.QtCore.QCborValue.EncodingOption:

# class PySide2.QtCore.QCborValue.EncodingOptions:

# class PySide2.QtCore.QCborValue.Type:
    "PySide2.QtCore.QCborValue.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QCborArray',), ('PySide2.QtCore.QCborKnownTags', 'PySide2.QtCore.QCborValue'), ('PySide2.QtCore.QCborMap',), ('PySide2.QtCore.QCborSimpleType',), ('PySide2.QtCore.QCborValue',), ('PySide2.QtCore.QCborValue.Type',), ('PySide2.QtCore.QDateTime',), ('PySide2.QtCore.QRegularExpression',), ('PySide2.QtCore.QUrl',), ('PySide2.QtCore.QUuid',), ('bool',), ('float',), ('int',), ('str',)],
    "PySide2.QtCore.QCborValue.__copy__": (),
    "PySide2.QtCore.QCborValue.compare": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborValue.fromCbor": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QCborParserError'), ('PySide2.QtCore.QCborStreamReader',), ('bytearray', 'int', 'PySide2.QtCore.QCborParserError'), ('str', 'int', 'PySide2.QtCore.QCborParserError')],
    "PySide2.QtCore.QCborValue.fromJsonValue": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QCborValue.fromVariant": ('typing.Any',),
    "PySide2.QtCore.QCborValue.isArray": (),
    "PySide2.QtCore.QCborValue.isBool": (),
    "PySide2.QtCore.QCborValue.isByteArray": (),
    "PySide2.QtCore.QCborValue.isContainer": (),
    "PySide2.QtCore.QCborValue.isDateTime": (),
    "PySide2.QtCore.QCborValue.isDouble": (),
    "PySide2.QtCore.QCborValue.isFalse": (),
    "PySide2.QtCore.QCborValue.isInteger": (),
    "PySide2.QtCore.QCborValue.isInvalid": (),
    "PySide2.QtCore.QCborValue.isMap": (),
    "PySide2.QtCore.QCborValue.isNull": (),
    "PySide2.QtCore.QCborValue.isRegularExpression": (),
    "PySide2.QtCore.QCborValue.isSimpleType": [(), ('PySide2.QtCore.QCborSimpleType',)],
    "PySide2.QtCore.QCborValue.isString": (),
    "PySide2.QtCore.QCborValue.isTag": (),
    "PySide2.QtCore.QCborValue.isTrue": (),
    "PySide2.QtCore.QCborValue.isUndefined": (),
    "PySide2.QtCore.QCborValue.isUrl": (),
    "PySide2.QtCore.QCborValue.isUuid": (),
    "PySide2.QtCore.QCborValue.swap": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborValue.taggedValue": ('PySide2.QtCore.QCborValue',),
    "PySide2.QtCore.QCborValue.toArray": [(), ('PySide2.QtCore.QCborArray',)],
    "PySide2.QtCore.QCborValue.toBool": ('bool',),
    "PySide2.QtCore.QCborValue.toByteArray": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QCborValue.toCbor": [('PySide2.QtCore.QCborStreamWriter', 'PySide2.QtCore.QCborValue.EncodingOptions'), ('PySide2.QtCore.QCborValue.EncodingOptions',)],
    "PySide2.QtCore.QCborValue.toDateTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QCborValue.toDiagnosticNotation": ('PySide2.QtCore.QCborValue.DiagnosticNotationOptions',),
    "PySide2.QtCore.QCborValue.toDouble": ('float',),
    "PySide2.QtCore.QCborValue.toInteger": ('int',),
    "PySide2.QtCore.QCborValue.toJsonValue": (),
    "PySide2.QtCore.QCborValue.toMap": [(), ('PySide2.QtCore.QCborMap',)],
    "PySide2.QtCore.QCborValue.toRegularExpression": ('PySide2.QtCore.QRegularExpression',),
    "PySide2.QtCore.QCborValue.toSimpleType": ('PySide2.QtCore.QCborSimpleType',),
    "PySide2.QtCore.QCborValue.toString": ('str',),
    "PySide2.QtCore.QCborValue.toUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtCore.QCborValue.toUuid": ('PySide2.QtCore.QUuid',),
    "PySide2.QtCore.QCborValue.toVariant": (),
    "PySide2.QtCore.QCborValue.type": (),

# class PySide2.QtCore.QChildEvent:
    "PySide2.QtCore.QChildEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QObject'),
    "PySide2.QtCore.QChildEvent.added": (),
    "PySide2.QtCore.QChildEvent.child": (),
    "PySide2.QtCore.QChildEvent.polished": (),
    "PySide2.QtCore.QChildEvent.removed": (),

# class PySide2.QtCore.QCollator:
    "PySide2.QtCore.QCollator.__init__": [(), ('PySide2.QtCore.QCollator',), ('PySide2.QtCore.QLocale',)],
    "PySide2.QtCore.QCollator.__call__": ('str', 'str'),
    "PySide2.QtCore.QCollator.caseSensitivity": (),
    "PySide2.QtCore.QCollator.compare": [('str', 'int', 'str', 'int'), ('str', 'str')],
    "PySide2.QtCore.QCollator.ignorePunctuation": (),
    "PySide2.QtCore.QCollator.locale": (),
    "PySide2.QtCore.QCollator.numericMode": (),
    "PySide2.QtCore.QCollator.setCaseSensitivity": ('PySide2.QtCore.Qt.CaseSensitivity',),
    "PySide2.QtCore.QCollator.setIgnorePunctuation": ('bool',),
    "PySide2.QtCore.QCollator.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtCore.QCollator.setNumericMode": ('bool',),
    "PySide2.QtCore.QCollator.sortKey": ('str',),
    "PySide2.QtCore.QCollator.swap": ('PySide2.QtCore.QCollator',),

# class PySide2.QtCore.QCollatorSortKey:
    "PySide2.QtCore.QCollatorSortKey.__init__": ('PySide2.QtCore.QCollatorSortKey',),
    "PySide2.QtCore.QCollatorSortKey.compare": ('PySide2.QtCore.QCollatorSortKey',),
    "PySide2.QtCore.QCollatorSortKey.swap": ('PySide2.QtCore.QCollatorSortKey',),

# class PySide2.QtCore.QCommandLineOption:

# class PySide2.QtCore.QCommandLineOption.Flag:

# class PySide2.QtCore.QCommandLineOption.Flags:
    "PySide2.QtCore.QCommandLineOption.__init__": [('PySide2.QtCore.QCommandLineOption',), ('str',), ('str', 'str', 'str', 'str'), ('typing.Sequence[str]',), ('typing.Sequence[str]', 'str', 'str', 'str')],
    "PySide2.QtCore.QCommandLineOption.defaultValues": (),
    "PySide2.QtCore.QCommandLineOption.description": (),
    "PySide2.QtCore.QCommandLineOption.flags": (),
    "PySide2.QtCore.QCommandLineOption.isHidden": (),
    "PySide2.QtCore.QCommandLineOption.names": (),
    "PySide2.QtCore.QCommandLineOption.setDefaultValue": ('str',),
    "PySide2.QtCore.QCommandLineOption.setDefaultValues": ('typing.Sequence[str]',),
    "PySide2.QtCore.QCommandLineOption.setDescription": ('str',),
    "PySide2.QtCore.QCommandLineOption.setFlags": ('PySide2.QtCore.QCommandLineOption.Flags',),
    "PySide2.QtCore.QCommandLineOption.setHidden": ('bool',),
    "PySide2.QtCore.QCommandLineOption.setValueName": ('str',),
    "PySide2.QtCore.QCommandLineOption.swap": ('PySide2.QtCore.QCommandLineOption',),
    "PySide2.QtCore.QCommandLineOption.valueName": (),

# class PySide2.QtCore.QCommandLineParser:

# class PySide2.QtCore.QCommandLineParser.OptionsAfterPositionalArgumentsMode:

# class PySide2.QtCore.QCommandLineParser.SingleDashWordOptionMode:
    "PySide2.QtCore.QCommandLineParser.__init__": (),
    "PySide2.QtCore.QCommandLineParser.addHelpOption": (),
    "PySide2.QtCore.QCommandLineParser.addOption": ('PySide2.QtCore.QCommandLineOption',),
    "PySide2.QtCore.QCommandLineParser.addOptions": ('typing.Sequence[PySide2.QtCore.QCommandLineOption]',),
    "PySide2.QtCore.QCommandLineParser.addPositionalArgument": ('str', 'str', 'str'),
    "PySide2.QtCore.QCommandLineParser.addVersionOption": (),
    "PySide2.QtCore.QCommandLineParser.applicationDescription": (),
    "PySide2.QtCore.QCommandLineParser.clearPositionalArguments": (),
    "PySide2.QtCore.QCommandLineParser.errorText": (),
    "PySide2.QtCore.QCommandLineParser.helpText": (),
    "PySide2.QtCore.QCommandLineParser.isSet": [('PySide2.QtCore.QCommandLineOption',), ('str',)],
    "PySide2.QtCore.QCommandLineParser.optionNames": (),
    "PySide2.QtCore.QCommandLineParser.parse": ('typing.Sequence[str]',),
    "PySide2.QtCore.QCommandLineParser.positionalArguments": (),
    "PySide2.QtCore.QCommandLineParser.process": [('PySide2.QtCore.QCoreApplication',), ('typing.Sequence[str]',)],
    "PySide2.QtCore.QCommandLineParser.setApplicationDescription": ('str',),
    "PySide2.QtCore.QCommandLineParser.setOptionsAfterPositionalArgumentsMode": ('PySide2.QtCore.QCommandLineParser.OptionsAfterPositionalArgumentsMode',),
    "PySide2.QtCore.QCommandLineParser.setSingleDashWordOptionMode": ('PySide2.QtCore.QCommandLineParser.SingleDashWordOptionMode',),
    "PySide2.QtCore.QCommandLineParser.showHelp": ('int',),
    "PySide2.QtCore.QCommandLineParser.showVersion": (),
    "PySide2.QtCore.QCommandLineParser.unknownOptionNames": (),
    "PySide2.QtCore.QCommandLineParser.value": [('PySide2.QtCore.QCommandLineOption',), ('str',)],
    "PySide2.QtCore.QCommandLineParser.values": [('PySide2.QtCore.QCommandLineOption',), ('str',)],

# class PySide2.QtCore.QConcatenateTablesProxyModel:
    "PySide2.QtCore.QConcatenateTablesProxyModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.addSourceModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.canDropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.itemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.mapFromSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.mapToSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.mimeData": ('typing.List[int]',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.mimeTypes": (),
    "PySide2.QtCore.QConcatenateTablesProxyModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QConcatenateTablesProxyModel.removeSourceModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QConcatenateTablesProxyModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.setItemData": ('PySide2.QtCore.QModelIndex', 'typing.Dict[int, typing.Any]'),
    "PySide2.QtCore.QConcatenateTablesProxyModel.span": ('PySide2.QtCore.QModelIndex',),

# class PySide2.QtCore.QCoreApplication:
    "PySide2.QtCore.QCoreApplication.__init__": [(), ('typing.Sequence[str]',)],
    "PySide2.QtCore.QCoreApplication.addLibraryPath": ('str',),
    "PySide2.QtCore.QCoreApplication.applicationDirPath": (),
    "PySide2.QtCore.QCoreApplication.applicationFilePath": (),
    "PySide2.QtCore.QCoreApplication.applicationName": (),
    "PySide2.QtCore.QCoreApplication.applicationPid": (),
    "PySide2.QtCore.QCoreApplication.applicationVersion": (),
    "PySide2.QtCore.QCoreApplication.arguments": (),
    "PySide2.QtCore.QCoreApplication.closingDown": (),
    "PySide2.QtCore.QCoreApplication.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QCoreApplication.eventDispatcher": (),
    "PySide2.QtCore.QCoreApplication.exec_": (),
    "PySide2.QtCore.QCoreApplication.exit": ('int',),
    "PySide2.QtCore.QCoreApplication.flush": (),
    "PySide2.QtCore.QCoreApplication.hasPendingEvents": (),
    "PySide2.QtCore.QCoreApplication.installNativeEventFilter": ('PySide2.QtCore.QAbstractNativeEventFilter',),
    "PySide2.QtCore.QCoreApplication.installTranslator": ('PySide2.QtCore.QTranslator',),
    "PySide2.QtCore.QCoreApplication.instance": (),
    "PySide2.QtCore.QCoreApplication.isQuitLockEnabled": (),
    "PySide2.QtCore.QCoreApplication.isSetuidAllowed": (),
    "PySide2.QtCore.QCoreApplication.libraryPaths": (),
    "PySide2.QtCore.QCoreApplication.notify": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtCore.QCoreApplication.organizationDomain": (),
    "PySide2.QtCore.QCoreApplication.organizationName": (),
    "PySide2.QtCore.QCoreApplication.postEvent": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent', 'int'),
    "PySide2.QtCore.QCoreApplication.processEvents": [('PySide2.QtCore.QEventLoop.ProcessEventsFlags',), ('PySide2.QtCore.QEventLoop.ProcessEventsFlags', 'int')],
    "PySide2.QtCore.QCoreApplication.quit": (),
    "PySide2.QtCore.QCoreApplication.removeLibraryPath": ('str',),
    "PySide2.QtCore.QCoreApplication.removeNativeEventFilter": ('PySide2.QtCore.QAbstractNativeEventFilter',),
    "PySide2.QtCore.QCoreApplication.removePostedEvents": ('PySide2.QtCore.QObject', 'int'),
    "PySide2.QtCore.QCoreApplication.removeTranslator": ('PySide2.QtCore.QTranslator',),
    "PySide2.QtCore.QCoreApplication.sendEvent": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtCore.QCoreApplication.sendPostedEvents": ('PySide2.QtCore.QObject', 'int'),
    "PySide2.QtCore.QCoreApplication.setApplicationName": ('str',),
    "PySide2.QtCore.QCoreApplication.setApplicationVersion": ('str',),
    "PySide2.QtCore.QCoreApplication.setAttribute": ('PySide2.QtCore.Qt.ApplicationAttribute', 'bool'),
    "PySide2.QtCore.QCoreApplication.setEventDispatcher": ('PySide2.QtCore.QAbstractEventDispatcher',),
    "PySide2.QtCore.QCoreApplication.setLibraryPaths": ('typing.Sequence[str]',),
    "PySide2.QtCore.QCoreApplication.setOrganizationDomain": ('str',),
    "PySide2.QtCore.QCoreApplication.setOrganizationName": ('str',),
    "PySide2.QtCore.QCoreApplication.setQuitLockEnabled": ('bool',),
    "PySide2.QtCore.QCoreApplication.setSetuidAllowed": ('bool',),
    "PySide2.QtCore.QCoreApplication.startingUp": (),
    "PySide2.QtCore.QCoreApplication.testAttribute": ('PySide2.QtCore.Qt.ApplicationAttribute',),
    "PySide2.QtCore.QCoreApplication.translate": ('str', 'str', 'str', 'int'),

# class PySide2.QtCore.QCryptographicHash:

# class PySide2.QtCore.QCryptographicHash.Algorithm:
    "PySide2.QtCore.QCryptographicHash.__init__": ('PySide2.QtCore.QCryptographicHash.Algorithm',),
    "PySide2.QtCore.QCryptographicHash.addData": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',), ('str', 'int')],
    "PySide2.QtCore.QCryptographicHash.hash": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QCryptographicHash.Algorithm'),
    "PySide2.QtCore.QCryptographicHash.hashLength": ('PySide2.QtCore.QCryptographicHash.Algorithm',),
    "PySide2.QtCore.QCryptographicHash.reset": (),
    "PySide2.QtCore.QCryptographicHash.result": (),

# class PySide2.QtCore.QDataStream:

# class PySide2.QtCore.QDataStream.ByteOrder:

# class PySide2.QtCore.QDataStream.FloatingPointPrecision:

# class PySide2.QtCore.QDataStream.Status:

# class PySide2.QtCore.QDataStream.Version:
    "PySide2.QtCore.QDataStream.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QIODevice.OpenMode'), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtCore.QDataStream.__lshift__": [('PySide2.QtCore.QBitArray',), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QCborArray',), ('PySide2.QtCore.QCborMap',), ('PySide2.QtCore.QCborValue',), ('PySide2.QtCore.QDate',), ('PySide2.QtCore.QDateTime',), ('PySide2.QtCore.QEasingCurve',), ('PySide2.QtCore.QJsonArray',), ('PySide2.QtCore.QJsonDocument',), ('PySide2.QtCore.QJsonValue',), ('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QLocale',), ('PySide2.QtCore.QMargins',), ('PySide2.QtCore.QMarginsF',), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('PySide2.QtCore.QRegExp',), ('PySide2.QtCore.QRegularExpression',), ('PySide2.QtCore.QSize',), ('PySide2.QtCore.QSizeF',), ('PySide2.QtCore.QTime',), ('PySide2.QtCore.QTimeZone',), ('PySide2.QtCore.QUrl',), ('PySide2.QtCore.QUuid',), ('PySide2.QtCore.QVersionNumber',), ('str',)],
    "PySide2.QtCore.QDataStream.__rshift__": [('PySide2.QtCore.QBitArray',), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QCborArray',), ('PySide2.QtCore.QCborMap',), ('PySide2.QtCore.QCborValue',), ('PySide2.QtCore.QDate',), ('PySide2.QtCore.QDateTime',), ('PySide2.QtCore.QEasingCurve',), ('PySide2.QtCore.QJsonArray',), ('PySide2.QtCore.QJsonDocument',), ('PySide2.QtCore.QJsonValue',), ('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QLocale',), ('PySide2.QtCore.QMargins',), ('PySide2.QtCore.QMarginsF',), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('PySide2.QtCore.QRegExp',), ('PySide2.QtCore.QRegularExpression',), ('PySide2.QtCore.QSize',), ('PySide2.QtCore.QSizeF',), ('PySide2.QtCore.QTime',), ('PySide2.QtCore.QTimeZone',), ('PySide2.QtCore.QUrl',), ('PySide2.QtCore.QUuid',), ('PySide2.QtCore.QVersionNumber',)],
    "PySide2.QtCore.QDataStream.abortTransaction": (),
    "PySide2.QtCore.QDataStream.atEnd": (),
    "PySide2.QtCore.QDataStream.byteOrder": (),
    "PySide2.QtCore.QDataStream.commitTransaction": (),
    "PySide2.QtCore.QDataStream.device": (),
    "PySide2.QtCore.QDataStream.floatingPointPrecision": (),
    "PySide2.QtCore.QDataStream.readBool": (),
    "PySide2.QtCore.QDataStream.readDouble": (),
    "PySide2.QtCore.QDataStream.readFloat": (),
    "PySide2.QtCore.QDataStream.readInt16": (),
    "PySide2.QtCore.QDataStream.readInt32": (),
    "PySide2.QtCore.QDataStream.readInt64": (),
    "PySide2.QtCore.QDataStream.readInt8": (),
    "PySide2.QtCore.QDataStream.readQChar": (),
    "PySide2.QtCore.QDataStream.readQString": (),
    "PySide2.QtCore.QDataStream.readQStringList": (),
    "PySide2.QtCore.QDataStream.readQVariant": (),
    "PySide2.QtCore.QDataStream.readRawData": ('str', 'int'),
    "PySide2.QtCore.QDataStream.readString": (),
    "PySide2.QtCore.QDataStream.readUInt16": (),
    "PySide2.QtCore.QDataStream.readUInt32": (),
    "PySide2.QtCore.QDataStream.readUInt64": (),
    "PySide2.QtCore.QDataStream.readUInt8": (),
    "PySide2.QtCore.QDataStream.resetStatus": (),
    "PySide2.QtCore.QDataStream.rollbackTransaction": (),
    "PySide2.QtCore.QDataStream.setByteOrder": ('PySide2.QtCore.QDataStream.ByteOrder',),
    "PySide2.QtCore.QDataStream.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtCore.QDataStream.setFloatingPointPrecision": ('PySide2.QtCore.QDataStream.FloatingPointPrecision',),
    "PySide2.QtCore.QDataStream.setStatus": ('PySide2.QtCore.QDataStream.Status',),
    "PySide2.QtCore.QDataStream.setVersion": ('int',),
    "PySide2.QtCore.QDataStream.skipRawData": ('int',),
    "PySide2.QtCore.QDataStream.startTransaction": (),
    "PySide2.QtCore.QDataStream.status": (),
    "PySide2.QtCore.QDataStream.unsetDevice": (),
    "PySide2.QtCore.QDataStream.version": (),
    "PySide2.QtCore.QDataStream.writeBool": ('bool',),
    "PySide2.QtCore.QDataStream.writeDouble": ('float',),
    "PySide2.QtCore.QDataStream.writeFloat": ('float',),
    "PySide2.QtCore.QDataStream.writeInt16": ('int',),
    "PySide2.QtCore.QDataStream.writeInt32": ('int',),
    "PySide2.QtCore.QDataStream.writeInt64": ('int',),
    "PySide2.QtCore.QDataStream.writeInt8": ('int',),
    "PySide2.QtCore.QDataStream.writeQChar": ('typing.Char',),
    "PySide2.QtCore.QDataStream.writeQString": ('str',),
    "PySide2.QtCore.QDataStream.writeQStringList": ('typing.Sequence[str]',),
    "PySide2.QtCore.QDataStream.writeQVariant": ('typing.Any',),
    "PySide2.QtCore.QDataStream.writeRawData": ('str', 'int'),
    "PySide2.QtCore.QDataStream.writeString": ('str',),
    "PySide2.QtCore.QDataStream.writeUInt16": ('int',),
    "PySide2.QtCore.QDataStream.writeUInt32": ('int',),
    "PySide2.QtCore.QDataStream.writeUInt64": ('int',),
    "PySide2.QtCore.QDataStream.writeUInt8": ('int',),

# class PySide2.QtCore.QDate:

# class PySide2.QtCore.QDate.MonthNameType:
    "PySide2.QtCore.QDate.__init__": [(), ('PySide2.QtCore.QDate',), ('int', 'int', 'int'), ('int', 'int', 'int', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDate.__copy__": (),
    "PySide2.QtCore.QDate.__reduce__": (),
    "PySide2.QtCore.QDate.__repr__": (),
    "PySide2.QtCore.QDate.addDays": ('int',),
    "PySide2.QtCore.QDate.addMonths": [('int',), ('int', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDate.addYears": [('int',), ('int', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDate.currentDate": (),
    "PySide2.QtCore.QDate.day": [(), ('PySide2.QtCore.QCalendar',)],
    "PySide2.QtCore.QDate.dayOfWeek": [(), ('PySide2.QtCore.QCalendar',)],
    "PySide2.QtCore.QDate.dayOfYear": [(), ('PySide2.QtCore.QCalendar',)],
    "PySide2.QtCore.QDate.daysInMonth": [(), ('PySide2.QtCore.QCalendar',)],
    "PySide2.QtCore.QDate.daysInYear": [(), ('PySide2.QtCore.QCalendar',)],
    "PySide2.QtCore.QDate.daysTo": ('PySide2.QtCore.QDate',),
    "PySide2.QtCore.QDate.endOfDay": [('PySide2.QtCore.QTimeZone',), ('PySide2.QtCore.Qt.TimeSpec', 'int')],
    "PySide2.QtCore.QDate.fromJulianDay": ('int',),
    "PySide2.QtCore.QDate.fromString": [('str', 'PySide2.QtCore.Qt.DateFormat'), ('str', 'str'), ('str', 'str', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDate.getDate": (),
    "PySide2.QtCore.QDate.isLeapYear": ('int',),
    "PySide2.QtCore.QDate.isNull": (),
    "PySide2.QtCore.QDate.isValid": [(), ('int', 'int', 'int')],
    "PySide2.QtCore.QDate.longDayName": ('int', 'PySide2.QtCore.QDate.MonthNameType'),
    "PySide2.QtCore.QDate.longMonthName": ('int', 'PySide2.QtCore.QDate.MonthNameType'),
    "PySide2.QtCore.QDate.month": [(), ('PySide2.QtCore.QCalendar',)],
    "PySide2.QtCore.QDate.setDate": [('int', 'int', 'int'), ('int', 'int', 'int', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDate.shortDayName": ('int', 'PySide2.QtCore.QDate.MonthNameType'),
    "PySide2.QtCore.QDate.shortMonthName": ('int', 'PySide2.QtCore.QDate.MonthNameType'),
    "PySide2.QtCore.QDate.startOfDay": [('PySide2.QtCore.QTimeZone',), ('PySide2.QtCore.Qt.TimeSpec', 'int')],
    "PySide2.QtCore.QDate.toJulianDay": (),
    "PySide2.QtCore.QDate.toPython": (),
    "PySide2.QtCore.QDate.toString": [('PySide2.QtCore.Qt.DateFormat',), ('PySide2.QtCore.Qt.DateFormat', 'PySide2.QtCore.QCalendar'), ('str',), ('str', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDate.weekNumber": (),
    "PySide2.QtCore.QDate.year": [(), ('PySide2.QtCore.QCalendar',)],

# class PySide2.QtCore.QDateTime:

# class PySide2.QtCore.QDateTime.YearRange:
    "PySide2.QtCore.QDateTime.__init__": [(), ('PySide2.QtCore.QDate',), ('PySide2.QtCore.QDate', 'PySide2.QtCore.QTime', 'PySide2.QtCore.QTimeZone'), ('PySide2.QtCore.QDate', 'PySide2.QtCore.QTime', 'PySide2.QtCore.Qt.TimeSpec'), ('PySide2.QtCore.QDate', 'PySide2.QtCore.QTime', 'PySide2.QtCore.Qt.TimeSpec', 'int'), ('PySide2.QtCore.QDateTime',), ('int', 'int', 'int', 'int', 'int', 'int'), ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int')],
    "PySide2.QtCore.QDateTime.__copy__": (),
    "PySide2.QtCore.QDateTime.__reduce__": (),
    "PySide2.QtCore.QDateTime.__repr__": (),
    "PySide2.QtCore.QDateTime.addDays": ('int',),
    "PySide2.QtCore.QDateTime.addMSecs": ('int',),
    "PySide2.QtCore.QDateTime.addMonths": ('int',),
    "PySide2.QtCore.QDateTime.addSecs": ('int',),
    "PySide2.QtCore.QDateTime.addYears": ('int',),
    "PySide2.QtCore.QDateTime.currentDateTime": (),
    "PySide2.QtCore.QDateTime.currentDateTimeUtc": (),
    "PySide2.QtCore.QDateTime.currentMSecsSinceEpoch": (),
    "PySide2.QtCore.QDateTime.currentSecsSinceEpoch": (),
    "PySide2.QtCore.QDateTime.date": (),
    "PySide2.QtCore.QDateTime.daysTo": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QDateTime.fromMSecsSinceEpoch": [('int',), ('int', 'PySide2.QtCore.QTimeZone'), ('int', 'PySide2.QtCore.Qt.TimeSpec', 'int')],
    "PySide2.QtCore.QDateTime.fromSecsSinceEpoch": [('int', 'PySide2.QtCore.QTimeZone'), ('int', 'PySide2.QtCore.Qt.TimeSpec', 'int')],
    "PySide2.QtCore.QDateTime.fromString": [('str', 'PySide2.QtCore.Qt.DateFormat'), ('str', 'str'), ('str', 'str', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QDateTime.fromTime_t": [('int',), ('int', 'PySide2.QtCore.QTimeZone'), ('int', 'PySide2.QtCore.Qt.TimeSpec', 'int')],
    "PySide2.QtCore.QDateTime.isDaylightTime": (),
    "PySide2.QtCore.QDateTime.isNull": (),
    "PySide2.QtCore.QDateTime.isValid": (),
    "PySide2.QtCore.QDateTime.msecsTo": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QDateTime.offsetFromUtc": (),
    "PySide2.QtCore.QDateTime.secsTo": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QDateTime.setDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtCore.QDateTime.setMSecsSinceEpoch": ('int',),
    "PySide2.QtCore.QDateTime.setOffsetFromUtc": ('int',),
    "PySide2.QtCore.QDateTime.setSecsSinceEpoch": ('int',),
    "PySide2.QtCore.QDateTime.setTime": ('PySide2.QtCore.QTime',),
    "PySide2.QtCore.QDateTime.setTimeSpec": ('PySide2.QtCore.Qt.TimeSpec',),
    "PySide2.QtCore.QDateTime.setTimeZone": ('PySide2.QtCore.QTimeZone',),
    "PySide2.QtCore.QDateTime.setTime_t": ('int',),
    "PySide2.QtCore.QDateTime.setUtcOffset": ('int',),
    "PySide2.QtCore.QDateTime.swap": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QDateTime.time": (),
    "PySide2.QtCore.QDateTime.timeSpec": (),
    "PySide2.QtCore.QDateTime.timeZone": (),
    "PySide2.QtCore.QDateTime.timeZoneAbbreviation": (),
    "PySide2.QtCore.QDateTime.toLocalTime": (),
    "PySide2.QtCore.QDateTime.toMSecsSinceEpoch": (),
    "PySide2.QtCore.QDateTime.toOffsetFromUtc": ('int',),
    "PySide2.QtCore.QDateTime.toPython": (),
    "PySide2.QtCore.QDateTime.toSecsSinceEpoch": (),
    "PySide2.QtCore.QDateTime.toString": [('PySide2.QtCore.Qt.DateFormat',), ('str',)],
    "PySide2.QtCore.QDateTime.toTimeSpec": ('PySide2.QtCore.Qt.TimeSpec',),
    "PySide2.QtCore.QDateTime.toTimeZone": ('PySide2.QtCore.QTimeZone',),
    "PySide2.QtCore.QDateTime.toTime_t": (),
    "PySide2.QtCore.QDateTime.toUTC": (),
    "PySide2.QtCore.QDateTime.utcOffset": (),

# class PySide2.QtCore.QDir:

# class PySide2.QtCore.QDir.Filter:

# class PySide2.QtCore.QDir.Filters:

# class PySide2.QtCore.QDir.SortFlag:

# class PySide2.QtCore.QDir.SortFlags:
    "PySide2.QtCore.QDir.__init__": [('PySide2.QtCore.QDir',), ('str',), ('str', 'str', 'PySide2.QtCore.QDir.SortFlags', 'PySide2.QtCore.QDir.Filters')],
    "PySide2.QtCore.QDir.__copy__": (),
    "PySide2.QtCore.QDir.__reduce__": (),
    "PySide2.QtCore.QDir.absoluteFilePath": ('str',),
    "PySide2.QtCore.QDir.absolutePath": (),
    "PySide2.QtCore.QDir.addResourceSearchPath": ('str',),
    "PySide2.QtCore.QDir.addSearchPath": ('str', 'str'),
    "PySide2.QtCore.QDir.canonicalPath": (),
    "PySide2.QtCore.QDir.cd": ('str',),
    "PySide2.QtCore.QDir.cdUp": (),
    "PySide2.QtCore.QDir.cleanPath": ('str',),
    "PySide2.QtCore.QDir.count": (),
    "PySide2.QtCore.QDir.current": (),
    "PySide2.QtCore.QDir.currentPath": (),
    "PySide2.QtCore.QDir.dirName": (),
    "PySide2.QtCore.QDir.drives": (),
    "PySide2.QtCore.QDir.entryInfoList": [('PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDir.SortFlags'), ('typing.Sequence[str]', 'PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDir.SortFlags')],
    "PySide2.QtCore.QDir.entryList": [('PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDir.SortFlags'), ('typing.Sequence[str]', 'PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDir.SortFlags')],
    "PySide2.QtCore.QDir.exists": [(), ('str',)],
    "PySide2.QtCore.QDir.filePath": ('str',),
    "PySide2.QtCore.QDir.filter": (),
    "PySide2.QtCore.QDir.fromNativeSeparators": ('str',),
    "PySide2.QtCore.QDir.home": (),
    "PySide2.QtCore.QDir.homePath": (),
    "PySide2.QtCore.QDir.isAbsolute": (),
    "PySide2.QtCore.QDir.isAbsolutePath": ('str',),
    "PySide2.QtCore.QDir.isEmpty": ('PySide2.QtCore.QDir.Filters',),
    "PySide2.QtCore.QDir.isReadable": (),
    "PySide2.QtCore.QDir.isRelative": (),
    "PySide2.QtCore.QDir.isRelativePath": ('str',),
    "PySide2.QtCore.QDir.isRoot": (),
    "PySide2.QtCore.QDir.listSeparator": (),
    "PySide2.QtCore.QDir.makeAbsolute": (),
    "PySide2.QtCore.QDir.match": [('str', 'str'), ('typing.Sequence[str]', 'str')],
    "PySide2.QtCore.QDir.mkdir": ('str',),
    "PySide2.QtCore.QDir.mkpath": ('str',),
    "PySide2.QtCore.QDir.nameFilters": (),
    "PySide2.QtCore.QDir.nameFiltersFromString": ('str',),
    "PySide2.QtCore.QDir.path": (),
    "PySide2.QtCore.QDir.refresh": (),
    "PySide2.QtCore.QDir.relativeFilePath": ('str',),
    "PySide2.QtCore.QDir.remove": ('str',),
    "PySide2.QtCore.QDir.removeRecursively": (),
    "PySide2.QtCore.QDir.rename": ('str', 'str'),
    "PySide2.QtCore.QDir.rmdir": ('str',),
    "PySide2.QtCore.QDir.rmpath": ('str',),
    "PySide2.QtCore.QDir.root": (),
    "PySide2.QtCore.QDir.rootPath": (),
    "PySide2.QtCore.QDir.searchPaths": ('str',),
    "PySide2.QtCore.QDir.separator": (),
    "PySide2.QtCore.QDir.setCurrent": ('str',),
    "PySide2.QtCore.QDir.setFilter": ('PySide2.QtCore.QDir.Filters',),
    "PySide2.QtCore.QDir.setNameFilters": ('typing.Sequence[str]',),
    "PySide2.QtCore.QDir.setPath": ('str',),
    "PySide2.QtCore.QDir.setSearchPaths": ('str', 'typing.Sequence[str]'),
    "PySide2.QtCore.QDir.setSorting": ('PySide2.QtCore.QDir.SortFlags',),
    "PySide2.QtCore.QDir.sorting": (),
    "PySide2.QtCore.QDir.swap": ('PySide2.QtCore.QDir',),
    "PySide2.QtCore.QDir.temp": (),
    "PySide2.QtCore.QDir.tempPath": (),
    "PySide2.QtCore.QDir.toNativeSeparators": ('str',),

# class PySide2.QtCore.QDirIterator:

# class PySide2.QtCore.QDirIterator.IteratorFlag:

# class PySide2.QtCore.QDirIterator.IteratorFlags:
    "PySide2.QtCore.QDirIterator.__init__": [('PySide2.QtCore.QDir', 'PySide2.QtCore.QDirIterator.IteratorFlags'), ('str', 'PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDirIterator.IteratorFlags'), ('str', 'PySide2.QtCore.QDirIterator.IteratorFlags'), ('str', 'typing.Sequence[str]', 'PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDirIterator.IteratorFlags')],
    "PySide2.QtCore.QDirIterator.fileInfo": (),
    "PySide2.QtCore.QDirIterator.fileName": (),
    "PySide2.QtCore.QDirIterator.filePath": (),
    "PySide2.QtCore.QDirIterator.hasNext": (),
    "PySide2.QtCore.QDirIterator.path": (),

# class PySide2.QtCore.QDynamicPropertyChangeEvent:
    "PySide2.QtCore.QDynamicPropertyChangeEvent.__init__": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QDynamicPropertyChangeEvent.propertyName": (),

# class PySide2.QtCore.QEasingCurve:

# class PySide2.QtCore.QEasingCurve.Type:
    "PySide2.QtCore.QEasingCurve.__init__": [('PySide2.QtCore.QEasingCurve',), ('PySide2.QtCore.QEasingCurve.Type',)],
    "PySide2.QtCore.QEasingCurve.__copy__": (),
    "PySide2.QtCore.QEasingCurve.addCubicBezierSegment": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'),
    "PySide2.QtCore.QEasingCurve.addTCBSegment": ('PySide2.QtCore.QPointF', 'float', 'float', 'float'),
    "PySide2.QtCore.QEasingCurve.amplitude": (),
    "PySide2.QtCore.QEasingCurve.customType": (),
    "PySide2.QtCore.QEasingCurve.overshoot": (),
    "PySide2.QtCore.QEasingCurve.period": (),
    "PySide2.QtCore.QEasingCurve.setAmplitude": ('float',),
    "PySide2.QtCore.QEasingCurve.setCustomType": ('object',),
    "PySide2.QtCore.QEasingCurve.setOvershoot": ('float',),
    "PySide2.QtCore.QEasingCurve.setPeriod": ('float',),
    "PySide2.QtCore.QEasingCurve.setType": ('PySide2.QtCore.QEasingCurve.Type',),
    "PySide2.QtCore.QEasingCurve.swap": ('PySide2.QtCore.QEasingCurve',),
    "PySide2.QtCore.QEasingCurve.toCubicSpline": (),
    "PySide2.QtCore.QEasingCurve.type": (),
    "PySide2.QtCore.QEasingCurve.valueForProgress": ('float',),

# class PySide2.QtCore.QElapsedTimer:

# class PySide2.QtCore.QElapsedTimer.ClockType:
    "PySide2.QtCore.QElapsedTimer.__init__": [(), ('PySide2.QtCore.QElapsedTimer',)],
    "PySide2.QtCore.QElapsedTimer.__copy__": (),
    "PySide2.QtCore.QElapsedTimer.clockType": (),
    "PySide2.QtCore.QElapsedTimer.elapsed": (),
    "PySide2.QtCore.QElapsedTimer.hasExpired": ('int',),
    "PySide2.QtCore.QElapsedTimer.invalidate": (),
    "PySide2.QtCore.QElapsedTimer.isMonotonic": (),
    "PySide2.QtCore.QElapsedTimer.isValid": (),
    "PySide2.QtCore.QElapsedTimer.msecsSinceReference": (),
    "PySide2.QtCore.QElapsedTimer.msecsTo": ('PySide2.QtCore.QElapsedTimer',),
    "PySide2.QtCore.QElapsedTimer.nsecsElapsed": (),
    "PySide2.QtCore.QElapsedTimer.restart": (),
    "PySide2.QtCore.QElapsedTimer.secsTo": ('PySide2.QtCore.QElapsedTimer',),
    "PySide2.QtCore.QElapsedTimer.start": (),

# class PySide2.QtCore.QEvent:

# class PySide2.QtCore.QEvent.Type:
    "PySide2.QtCore.QEvent.__init__": [('PySide2.QtCore.QEvent',), ('PySide2.QtCore.QEvent.Type',)],
    "PySide2.QtCore.QEvent.accept": (),
    "PySide2.QtCore.QEvent.ignore": (),
    "PySide2.QtCore.QEvent.isAccepted": (),
    "PySide2.QtCore.QEvent.registerEventType": ('int',),
    "PySide2.QtCore.QEvent.setAccepted": ('bool',),
    "PySide2.QtCore.QEvent.spontaneous": (),
    "PySide2.QtCore.QEvent.type": (),

# class PySide2.QtCore.QEventLoop:

# class PySide2.QtCore.QEventLoop.ProcessEventsFlag:

# class PySide2.QtCore.QEventLoop.ProcessEventsFlags:
    "PySide2.QtCore.QEventLoop.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QEventLoop.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QEventLoop.exec_": ('PySide2.QtCore.QEventLoop.ProcessEventsFlags',),
    "PySide2.QtCore.QEventLoop.exit": ('int',),
    "PySide2.QtCore.QEventLoop.isRunning": (),
    "PySide2.QtCore.QEventLoop.processEvents": [('PySide2.QtCore.QEventLoop.ProcessEventsFlags',), ('PySide2.QtCore.QEventLoop.ProcessEventsFlags', 'int')],
    "PySide2.QtCore.QEventLoop.quit": (),
    "PySide2.QtCore.QEventLoop.wakeUp": (),

# class PySide2.QtCore.QEventTransition:
    "PySide2.QtCore.QEventTransition.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QState'), ('PySide2.QtCore.QState',)],
    "PySide2.QtCore.QEventTransition.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QEventTransition.eventSource": (),
    "PySide2.QtCore.QEventTransition.eventTest": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QEventTransition.eventType": (),
    "PySide2.QtCore.QEventTransition.onTransition": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QEventTransition.setEventSource": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QEventTransition.setEventType": ('PySide2.QtCore.QEvent.Type',),

# class PySide2.QtCore.QFactoryInterface:
    "PySide2.QtCore.QFactoryInterface.__init__": (),
    "PySide2.QtCore.QFactoryInterface.keys": (),

# class PySide2.QtCore.QFile:
    "PySide2.QtCore.QFile.__init__": [(), ('PySide2.QtCore.QObject',), ('str',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QFile.copy": [('str',), ('str', 'str')],
    "PySide2.QtCore.QFile.decodeName": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtCore.QFile.encodeName": ('str',),
    "PySide2.QtCore.QFile.exists": [(), ('str',)],
    "PySide2.QtCore.QFile.fileName": (),
    "PySide2.QtCore.QFile.link": [('str',), ('str', 'str')],
    "PySide2.QtCore.QFile.open": [('PySide2.QtCore.QIODevice.OpenMode',), ('int', 'PySide2.QtCore.QIODevice.OpenMode', 'PySide2.QtCore.QFileDevice.FileHandleFlags')],
    "PySide2.QtCore.QFile.permissions": [(), ('str',)],
    "PySide2.QtCore.QFile.readLink": [(), ('str',)],
    "PySide2.QtCore.QFile.remove": [(), ('str',)],
    "PySide2.QtCore.QFile.rename": [('str',), ('str', 'str')],
    "PySide2.QtCore.QFile.resize": [('int',), ('str', 'int')],
    "PySide2.QtCore.QFile.setFileName": ('str',),
    "PySide2.QtCore.QFile.setPermissions": [('PySide2.QtCore.QFileDevice.Permissions',), ('str', 'PySide2.QtCore.QFileDevice.Permissions')],
    "PySide2.QtCore.QFile.size": (),
    "PySide2.QtCore.QFile.symLinkTarget": [(), ('str',)],

# class PySide2.QtCore.QFileDevice:

# class PySide2.QtCore.QFileDevice.FileError:

# class PySide2.QtCore.QFileDevice.FileHandleFlag:

# class PySide2.QtCore.QFileDevice.FileHandleFlags:

# class PySide2.QtCore.QFileDevice.FileTime:

# class PySide2.QtCore.QFileDevice.MemoryMapFlags:

# class PySide2.QtCore.QFileDevice.Permission:

# class PySide2.QtCore.QFileDevice.Permissions:
    "PySide2.QtCore.QFileDevice.__init__": [(), ('PySide2.QtCore.QObject',)],
    "PySide2.QtCore.QFileDevice.atEnd": (),
    "PySide2.QtCore.QFileDevice.close": (),
    "PySide2.QtCore.QFileDevice.error": (),
    "PySide2.QtCore.QFileDevice.fileName": (),
    "PySide2.QtCore.QFileDevice.fileTime": ('PySide2.QtCore.QFileDevice.FileTime',),
    "PySide2.QtCore.QFileDevice.flush": (),
    "PySide2.QtCore.QFileDevice.handle": (),
    "PySide2.QtCore.QFileDevice.isSequential": (),
    "PySide2.QtCore.QFileDevice.map": ('int', 'int', 'PySide2.QtCore.QFileDevice.MemoryMapFlags'),
    "PySide2.QtCore.QFileDevice.permissions": (),
    "PySide2.QtCore.QFileDevice.pos": (),
    "PySide2.QtCore.QFileDevice.readData": ('str', 'int'),
    "PySide2.QtCore.QFileDevice.readLineData": ('str', 'int'),
    "PySide2.QtCore.QFileDevice.resize": ('int',),
    "PySide2.QtCore.QFileDevice.seek": ('int',),
    "PySide2.QtCore.QFileDevice.setFileTime": ('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QFileDevice.FileTime'),
    "PySide2.QtCore.QFileDevice.setPermissions": ('PySide2.QtCore.QFileDevice.Permissions',),
    "PySide2.QtCore.QFileDevice.size": (),
    "PySide2.QtCore.QFileDevice.unmap": ('str',),
    "PySide2.QtCore.QFileDevice.unsetError": (),
    "PySide2.QtCore.QFileDevice.writeData": ('str', 'int'),

# class PySide2.QtCore.QFileInfo:
    "PySide2.QtCore.QFileInfo.__init__": [(), ('PySide2.QtCore.QDir', 'str'), ('PySide2.QtCore.QFile',), ('PySide2.QtCore.QFileInfo',), ('str',)],
    "PySide2.QtCore.QFileInfo.__copy__": (),
    "PySide2.QtCore.QFileInfo.__reduce__": (),
    "PySide2.QtCore.QFileInfo.absoluteDir": (),
    "PySide2.QtCore.QFileInfo.absoluteFilePath": (),
    "PySide2.QtCore.QFileInfo.absolutePath": (),
    "PySide2.QtCore.QFileInfo.baseName": (),
    "PySide2.QtCore.QFileInfo.birthTime": (),
    "PySide2.QtCore.QFileInfo.bundleName": (),
    "PySide2.QtCore.QFileInfo.caching": (),
    "PySide2.QtCore.QFileInfo.canonicalFilePath": (),
    "PySide2.QtCore.QFileInfo.canonicalPath": (),
    "PySide2.QtCore.QFileInfo.completeBaseName": (),
    "PySide2.QtCore.QFileInfo.completeSuffix": (),
    "PySide2.QtCore.QFileInfo.created": (),
    "PySide2.QtCore.QFileInfo.dir": (),
    "PySide2.QtCore.QFileInfo.exists": [(), ('str',)],
    "PySide2.QtCore.QFileInfo.fileName": (),
    "PySide2.QtCore.QFileInfo.filePath": (),
    "PySide2.QtCore.QFileInfo.group": (),
    "PySide2.QtCore.QFileInfo.groupId": (),
    "PySide2.QtCore.QFileInfo.isAbsolute": (),
    "PySide2.QtCore.QFileInfo.isBundle": (),
    "PySide2.QtCore.QFileInfo.isDir": (),
    "PySide2.QtCore.QFileInfo.isExecutable": (),
    "PySide2.QtCore.QFileInfo.isFile": (),
    "PySide2.QtCore.QFileInfo.isHidden": (),
    "PySide2.QtCore.QFileInfo.isNativePath": (),
    "PySide2.QtCore.QFileInfo.isReadable": (),
    "PySide2.QtCore.QFileInfo.isRelative": (),
    "PySide2.QtCore.QFileInfo.isRoot": (),
    "PySide2.QtCore.QFileInfo.isShortcut": (),
    "PySide2.QtCore.QFileInfo.isSymLink": (),
    "PySide2.QtCore.QFileInfo.isSymbolicLink": (),
    "PySide2.QtCore.QFileInfo.isWritable": (),
    "PySide2.QtCore.QFileInfo.lastModified": (),
    "PySide2.QtCore.QFileInfo.lastRead": (),
    "PySide2.QtCore.QFileInfo.makeAbsolute": (),
    "PySide2.QtCore.QFileInfo.metadataChangeTime": (),
    "PySide2.QtCore.QFileInfo.owner": (),
    "PySide2.QtCore.QFileInfo.ownerId": (),
    "PySide2.QtCore.QFileInfo.path": (),
    "PySide2.QtCore.QFileInfo.readLink": (),
    "PySide2.QtCore.QFileInfo.refresh": (),
    "PySide2.QtCore.QFileInfo.setCaching": ('bool',),
    "PySide2.QtCore.QFileInfo.setFile": [('PySide2.QtCore.QDir', 'str'), ('PySide2.QtCore.QFile',), ('str',)],
    "PySide2.QtCore.QFileInfo.size": (),
    "PySide2.QtCore.QFileInfo.suffix": (),
    "PySide2.QtCore.QFileInfo.swap": ('PySide2.QtCore.QFileInfo',),
    "PySide2.QtCore.QFileInfo.symLinkTarget": (),

# class PySide2.QtCore.QFileSelector:
    "PySide2.QtCore.QFileSelector.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QFileSelector.allSelectors": (),
    "PySide2.QtCore.QFileSelector.extraSelectors": (),
    "PySide2.QtCore.QFileSelector.select": [('PySide2.QtCore.QUrl',), ('str',)],
    "PySide2.QtCore.QFileSelector.setExtraSelectors": ('typing.Sequence[str]',),

# class PySide2.QtCore.QFileSystemWatcher:
    "PySide2.QtCore.QFileSystemWatcher.__init__": [('PySide2.QtCore.QObject',), ('typing.Sequence[str]', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QFileSystemWatcher.addPath": ('str',),
    "PySide2.QtCore.QFileSystemWatcher.addPaths": ('typing.Sequence[str]',),
    "PySide2.QtCore.QFileSystemWatcher.directories": (),
    "PySide2.QtCore.QFileSystemWatcher.files": (),
    "PySide2.QtCore.QFileSystemWatcher.removePath": ('str',),
    "PySide2.QtCore.QFileSystemWatcher.removePaths": ('typing.Sequence[str]',),

# class PySide2.QtCore.QFinalState:
    "PySide2.QtCore.QFinalState.__init__": ('PySide2.QtCore.QState',),
    "PySide2.QtCore.QFinalState.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QFinalState.onEntry": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QFinalState.onExit": ('PySide2.QtCore.QEvent',),

# class PySide2.QtCore.QGenericArgument:
    "PySide2.QtCore.QGenericArgument.__init__": [('PySide2.QtCore.QGenericArgument',), ('str', 'int')],
    "PySide2.QtCore.QGenericArgument.__copy__": (),
    "PySide2.QtCore.QGenericArgument.data": (),
    "PySide2.QtCore.QGenericArgument.name": (),

# class PySide2.QtCore.QGenericReturnArgument:
    "PySide2.QtCore.QGenericReturnArgument.__init__": [('PySide2.QtCore.QGenericReturnArgument',), ('str', 'int')],
    "PySide2.QtCore.QGenericReturnArgument.__copy__": (),

# class PySide2.QtCore.QHistoryState:

# class PySide2.QtCore.QHistoryState.HistoryType:
    "PySide2.QtCore.QHistoryState.__init__": [('PySide2.QtCore.QHistoryState.HistoryType', 'PySide2.QtCore.QState'), ('PySide2.QtCore.QState',)],
    "PySide2.QtCore.QHistoryState.defaultState": (),
    "PySide2.QtCore.QHistoryState.defaultTransition": (),
    "PySide2.QtCore.QHistoryState.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QHistoryState.historyType": (),
    "PySide2.QtCore.QHistoryState.onEntry": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QHistoryState.onExit": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QHistoryState.setDefaultState": ('PySide2.QtCore.QAbstractState',),
    "PySide2.QtCore.QHistoryState.setDefaultTransition": ('PySide2.QtCore.QAbstractTransition',),
    "PySide2.QtCore.QHistoryState.setHistoryType": ('PySide2.QtCore.QHistoryState.HistoryType',),

# class PySide2.QtCore.QIODevice:

# class PySide2.QtCore.QIODevice.OpenMode:

# class PySide2.QtCore.QIODevice.OpenModeFlag:
    "PySide2.QtCore.QIODevice.__init__": [(), ('PySide2.QtCore.QObject',)],
    "PySide2.QtCore.QIODevice.atEnd": (),
    "PySide2.QtCore.QIODevice.bytesAvailable": (),
    "PySide2.QtCore.QIODevice.bytesToWrite": (),
    "PySide2.QtCore.QIODevice.canReadLine": (),
    "PySide2.QtCore.QIODevice.close": (),
    "PySide2.QtCore.QIODevice.commitTransaction": (),
    "PySide2.QtCore.QIODevice.currentReadChannel": (),
    "PySide2.QtCore.QIODevice.currentWriteChannel": (),
    "PySide2.QtCore.QIODevice.errorString": (),
    "PySide2.QtCore.QIODevice.getChar": ('str',),
    "PySide2.QtCore.QIODevice.isOpen": (),
    "PySide2.QtCore.QIODevice.isReadable": (),
    "PySide2.QtCore.QIODevice.isSequential": (),
    "PySide2.QtCore.QIODevice.isTextModeEnabled": (),
    "PySide2.QtCore.QIODevice.isTransactionStarted": (),
    "PySide2.QtCore.QIODevice.isWritable": (),
    "PySide2.QtCore.QIODevice.open": ('PySide2.QtCore.QIODevice.OpenMode',),
    "PySide2.QtCore.QIODevice.openMode": (),
    "PySide2.QtCore.QIODevice.peek": ('int',),
    "PySide2.QtCore.QIODevice.pos": (),
    "PySide2.QtCore.QIODevice.putChar": ('typing.Char',),
    "PySide2.QtCore.QIODevice.read": ('int',),
    "PySide2.QtCore.QIODevice.readAll": (),
    "PySide2.QtCore.QIODevice.readChannelCount": (),
    "PySide2.QtCore.QIODevice.readData": ('str', 'int'),
    "PySide2.QtCore.QIODevice.readLine": ('int',),
    "PySide2.QtCore.QIODevice.readLineData": ('str', 'int'),
    "PySide2.QtCore.QIODevice.reset": (),
    "PySide2.QtCore.QIODevice.rollbackTransaction": (),
    "PySide2.QtCore.QIODevice.seek": ('int',),
    "PySide2.QtCore.QIODevice.setCurrentReadChannel": ('int',),
    "PySide2.QtCore.QIODevice.setCurrentWriteChannel": ('int',),
    "PySide2.QtCore.QIODevice.setErrorString": ('str',),
    "PySide2.QtCore.QIODevice.setOpenMode": ('PySide2.QtCore.QIODevice.OpenMode',),
    "PySide2.QtCore.QIODevice.setTextModeEnabled": ('bool',),
    "PySide2.QtCore.QIODevice.size": (),
    "PySide2.QtCore.QIODevice.skip": ('int',),
    "PySide2.QtCore.QIODevice.startTransaction": (),
    "PySide2.QtCore.QIODevice.ungetChar": ('typing.Char',),
    "PySide2.QtCore.QIODevice.waitForBytesWritten": ('int',),
    "PySide2.QtCore.QIODevice.waitForReadyRead": ('int',),
    "PySide2.QtCore.QIODevice.write": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QIODevice.writeChannelCount": (),
    "PySide2.QtCore.QIODevice.writeData": ('str', 'int'),

# class PySide2.QtCore.QIdentityProxyModel:
    "PySide2.QtCore.QIdentityProxyModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QIdentityProxyModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QIdentityProxyModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QIdentityProxyModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtCore.QIdentityProxyModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QIdentityProxyModel.insertColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QIdentityProxyModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QIdentityProxyModel.mapFromSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QIdentityProxyModel.mapSelectionFromSource": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtCore.QIdentityProxyModel.mapSelectionToSource": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtCore.QIdentityProxyModel.mapToSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QIdentityProxyModel.match": ('PySide2.QtCore.QModelIndex', 'int', 'typing.Any', 'int', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtCore.QIdentityProxyModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QIdentityProxyModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QIdentityProxyModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QIdentityProxyModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QIdentityProxyModel.setSourceModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCore.QIdentityProxyModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtCore.QItemSelection:
    "PySide2.QtCore.QItemSelection.__init__": [(), ('PySide2.QtCore.QItemSelection',), ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex')],
    "PySide2.QtCore.QItemSelection.__add__": ('typing.Sequence[PySide2.QtCore.QItemSelectionRange]',),
    "PySide2.QtCore.QItemSelection.__copy__": (),
    "PySide2.QtCore.QItemSelection.__iadd__": [('PySide2.QtCore.QItemSelectionRange',), ('typing.Sequence[PySide2.QtCore.QItemSelectionRange]',)],
    "PySide2.QtCore.QItemSelection.__lshift__": [('PySide2.QtCore.QItemSelectionRange',), ('typing.Sequence[PySide2.QtCore.QItemSelectionRange]',)],
    "PySide2.QtCore.QItemSelection.append": [('PySide2.QtCore.QItemSelectionRange',), ('typing.Sequence[PySide2.QtCore.QItemSelectionRange]',)],
    "PySide2.QtCore.QItemSelection.at": ('int',),
    "PySide2.QtCore.QItemSelection.back": (),
    "PySide2.QtCore.QItemSelection.clear": (),
    "PySide2.QtCore.QItemSelection.constFirst": (),
    "PySide2.QtCore.QItemSelection.constLast": (),
    "PySide2.QtCore.QItemSelection.contains": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QItemSelection.count": [(), ('PySide2.QtCore.QItemSelectionRange',)],
    "PySide2.QtCore.QItemSelection.detachShared": (),
    "PySide2.QtCore.QItemSelection.empty": (),
    "PySide2.QtCore.QItemSelection.endsWith": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.first": (),
    "PySide2.QtCore.QItemSelection.fromSet": ('typing.Set[PySide2.QtCore.QItemSelectionRange]',),
    "PySide2.QtCore.QItemSelection.fromVector": ('typing.List[PySide2.QtCore.QItemSelectionRange]',),
    "PySide2.QtCore.QItemSelection.front": (),
    "PySide2.QtCore.QItemSelection.indexOf": ('PySide2.QtCore.QItemSelectionRange', 'int'),
    "PySide2.QtCore.QItemSelection.indexes": (),
    "PySide2.QtCore.QItemSelection.insert": ('int', 'PySide2.QtCore.QItemSelectionRange'),
    "PySide2.QtCore.QItemSelection.isEmpty": (),
    "PySide2.QtCore.QItemSelection.isSharedWith": ('typing.Sequence[PySide2.QtCore.QItemSelectionRange]',),
    "PySide2.QtCore.QItemSelection.last": (),
    "PySide2.QtCore.QItemSelection.lastIndexOf": ('PySide2.QtCore.QItemSelectionRange', 'int'),
    "PySide2.QtCore.QItemSelection.length": (),
    "PySide2.QtCore.QItemSelection.merge": ('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtCore.QItemSelection.mid": ('int', 'int'),
    "PySide2.QtCore.QItemSelection.move": ('int', 'int'),
    "PySide2.QtCore.QItemSelection.pop_back": (),
    "PySide2.QtCore.QItemSelection.pop_front": (),
    "PySide2.QtCore.QItemSelection.prepend": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.push_back": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.push_front": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.removeAll": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.removeAt": ('int',),
    "PySide2.QtCore.QItemSelection.removeFirst": (),
    "PySide2.QtCore.QItemSelection.removeLast": (),
    "PySide2.QtCore.QItemSelection.removeOne": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.replace": ('int', 'PySide2.QtCore.QItemSelectionRange'),
    "PySide2.QtCore.QItemSelection.reserve": ('int',),
    "PySide2.QtCore.QItemSelection.select": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QItemSelection.setSharable": ('bool',),
    "PySide2.QtCore.QItemSelection.size": (),
    "PySide2.QtCore.QItemSelection.split": ('PySide2.QtCore.QItemSelectionRange', 'PySide2.QtCore.QItemSelectionRange', 'PySide2.QtCore.QItemSelection'),
    "PySide2.QtCore.QItemSelection.startsWith": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelection.swap": [('int', 'int'), ('typing.Sequence[PySide2.QtCore.QItemSelectionRange]',)],
    "PySide2.QtCore.QItemSelection.swapItemsAt": ('int', 'int'),
    "PySide2.QtCore.QItemSelection.takeAt": ('int',),
    "PySide2.QtCore.QItemSelection.takeFirst": (),
    "PySide2.QtCore.QItemSelection.takeLast": (),
    "PySide2.QtCore.QItemSelection.toSet": (),
    "PySide2.QtCore.QItemSelection.toVector": (),
    "PySide2.QtCore.QItemSelection.value": [('int',), ('int', 'PySide2.QtCore.QItemSelectionRange')],

# class PySide2.QtCore.QItemSelectionModel:

# class PySide2.QtCore.QItemSelectionModel.SelectionFlag:

# class PySide2.QtCore.QItemSelectionModel.SelectionFlags:
    "PySide2.QtCore.QItemSelectionModel.__init__": [('PySide2.QtCore.QAbstractItemModel',), ('PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QItemSelectionModel.clear": (),
    "PySide2.QtCore.QItemSelectionModel.clearCurrentIndex": (),
    "PySide2.QtCore.QItemSelectionModel.clearSelection": (),
    "PySide2.QtCore.QItemSelectionModel.columnIntersectsSelection": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QItemSelectionModel.currentIndex": (),
    "PySide2.QtCore.QItemSelectionModel.emitSelectionChanged": ('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelection'),
    "PySide2.QtCore.QItemSelectionModel.hasSelection": (),
    "PySide2.QtCore.QItemSelectionModel.isColumnSelected": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QItemSelectionModel.isRowSelected": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QItemSelectionModel.isSelected": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QItemSelectionModel.model": (),
    "PySide2.QtCore.QItemSelectionModel.reset": (),
    "PySide2.QtCore.QItemSelectionModel.rowIntersectsSelection": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QItemSelectionModel.select": [('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'), ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags')],
    "PySide2.QtCore.QItemSelectionModel.selectedColumns": ('int',),
    "PySide2.QtCore.QItemSelectionModel.selectedIndexes": (),
    "PySide2.QtCore.QItemSelectionModel.selectedRows": ('int',),
    "PySide2.QtCore.QItemSelectionModel.selection": (),
    "PySide2.QtCore.QItemSelectionModel.setCurrentIndex": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtCore.QItemSelectionModel.setModel": ('PySide2.QtCore.QAbstractItemModel',),

# class PySide2.QtCore.QItemSelectionRange:
    "PySide2.QtCore.QItemSelectionRange.__init__": [(), ('PySide2.QtCore.QItemSelectionRange',), ('PySide2.QtCore.QModelIndex',), ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex')],
    "PySide2.QtCore.QItemSelectionRange.__copy__": (),
    "PySide2.QtCore.QItemSelectionRange.bottom": (),
    "PySide2.QtCore.QItemSelectionRange.bottomRight": (),
    "PySide2.QtCore.QItemSelectionRange.contains": [('PySide2.QtCore.QModelIndex',), ('int', 'int', 'PySide2.QtCore.QModelIndex')],
    "PySide2.QtCore.QItemSelectionRange.height": (),
    "PySide2.QtCore.QItemSelectionRange.indexes": (),
    "PySide2.QtCore.QItemSelectionRange.intersected": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelectionRange.intersects": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelectionRange.isEmpty": (),
    "PySide2.QtCore.QItemSelectionRange.isValid": (),
    "PySide2.QtCore.QItemSelectionRange.left": (),
    "PySide2.QtCore.QItemSelectionRange.model": (),
    "PySide2.QtCore.QItemSelectionRange.parent": (),
    "PySide2.QtCore.QItemSelectionRange.right": (),
    "PySide2.QtCore.QItemSelectionRange.swap": ('PySide2.QtCore.QItemSelectionRange',),
    "PySide2.QtCore.QItemSelectionRange.top": (),
    "PySide2.QtCore.QItemSelectionRange.topLeft": (),
    "PySide2.QtCore.QItemSelectionRange.width": (),

# class PySide2.QtCore.QJsonArray:
    "PySide2.QtCore.QJsonArray.__init__": [(), ('PySide2.QtCore.QJsonArray',)],
    "PySide2.QtCore.QJsonArray.__add__": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.__copy__": (),
    "PySide2.QtCore.QJsonArray.__iadd__": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.__lshift__": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.append": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.at": ('int',),
    "PySide2.QtCore.QJsonArray.contains": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.count": (),
    "PySide2.QtCore.QJsonArray.empty": (),
    "PySide2.QtCore.QJsonArray.first": (),
    "PySide2.QtCore.QJsonArray.fromStringList": ('typing.Sequence[str]',),
    "PySide2.QtCore.QJsonArray.fromVariantList": ('typing.Sequence[typing.Any]',),
    "PySide2.QtCore.QJsonArray.insert": ('int', 'PySide2.QtCore.QJsonValue'),
    "PySide2.QtCore.QJsonArray.isEmpty": (),
    "PySide2.QtCore.QJsonArray.last": (),
    "PySide2.QtCore.QJsonArray.pop_back": (),
    "PySide2.QtCore.QJsonArray.pop_front": (),
    "PySide2.QtCore.QJsonArray.prepend": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.push_back": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.push_front": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonArray.removeAt": ('int',),
    "PySide2.QtCore.QJsonArray.removeFirst": (),
    "PySide2.QtCore.QJsonArray.removeLast": (),
    "PySide2.QtCore.QJsonArray.replace": ('int', 'PySide2.QtCore.QJsonValue'),
    "PySide2.QtCore.QJsonArray.size": (),
    "PySide2.QtCore.QJsonArray.swap": ('PySide2.QtCore.QJsonArray',),
    "PySide2.QtCore.QJsonArray.takeAt": ('int',),
    "PySide2.QtCore.QJsonArray.toVariantList": (),

# class PySide2.QtCore.QJsonDocument:

# class PySide2.QtCore.QJsonDocument.DataValidation:

# class PySide2.QtCore.QJsonDocument.JsonFormat:
    "PySide2.QtCore.QJsonDocument.__init__": [(), ('PySide2.QtCore.QJsonArray',), ('PySide2.QtCore.QJsonDocument',), ('typing.Dict[str, PySide2.QtCore.QJsonValue]',)],
    "PySide2.QtCore.QJsonDocument.__copy__": (),
    "PySide2.QtCore.QJsonDocument.array": (),
    "PySide2.QtCore.QJsonDocument.fromBinaryData": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QJsonDocument.DataValidation'),
    "PySide2.QtCore.QJsonDocument.fromJson": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QJsonParseError'),
    "PySide2.QtCore.QJsonDocument.fromRawData": ('str', 'int', 'PySide2.QtCore.QJsonDocument.DataValidation'),
    "PySide2.QtCore.QJsonDocument.fromVariant": ('typing.Any',),
    "PySide2.QtCore.QJsonDocument.isArray": (),
    "PySide2.QtCore.QJsonDocument.isEmpty": (),
    "PySide2.QtCore.QJsonDocument.isNull": (),
    "PySide2.QtCore.QJsonDocument.isObject": (),
    "PySide2.QtCore.QJsonDocument.object": (),
    "PySide2.QtCore.QJsonDocument.rawData": (),
    "PySide2.QtCore.QJsonDocument.setArray": ('PySide2.QtCore.QJsonArray',),
    "PySide2.QtCore.QJsonDocument.setObject": ('typing.Dict[str, PySide2.QtCore.QJsonValue]',),
    "PySide2.QtCore.QJsonDocument.swap": ('PySide2.QtCore.QJsonDocument',),
    "PySide2.QtCore.QJsonDocument.toBinaryData": (),
    "PySide2.QtCore.QJsonDocument.toJson": [(), ('PySide2.QtCore.QJsonDocument.JsonFormat',)],
    "PySide2.QtCore.QJsonDocument.toVariant": (),

# class PySide2.QtCore.QJsonParseError:

# class PySide2.QtCore.QJsonParseError.ParseError:
    "PySide2.QtCore.QJsonParseError.__init__": [(), ('PySide2.QtCore.QJsonParseError',)],
    "PySide2.QtCore.QJsonParseError.__copy__": (),
    "PySide2.QtCore.QJsonParseError.errorString": (),

# class PySide2.QtCore.QJsonValue:

# class PySide2.QtCore.QJsonValue.Type:
    "PySide2.QtCore.QJsonValue.__init__": [('PySide2.QtCore.QJsonArray',), ('PySide2.QtCore.QJsonValue',), ('PySide2.QtCore.QJsonValue.Type',), ('bool',), ('float',), ('int',), ('str',), ('typing.Dict[str, PySide2.QtCore.QJsonValue]',)],
    "PySide2.QtCore.QJsonValue.__copy__": (),
    "PySide2.QtCore.QJsonValue.fromVariant": ('typing.Any',),
    "PySide2.QtCore.QJsonValue.isArray": (),
    "PySide2.QtCore.QJsonValue.isBool": (),
    "PySide2.QtCore.QJsonValue.isDouble": (),
    "PySide2.QtCore.QJsonValue.isNull": (),
    "PySide2.QtCore.QJsonValue.isObject": (),
    "PySide2.QtCore.QJsonValue.isString": (),
    "PySide2.QtCore.QJsonValue.isUndefined": (),
    "PySide2.QtCore.QJsonValue.swap": ('PySide2.QtCore.QJsonValue',),
    "PySide2.QtCore.QJsonValue.toArray": [(), ('PySide2.QtCore.QJsonArray',)],
    "PySide2.QtCore.QJsonValue.toBool": ('bool',),
    "PySide2.QtCore.QJsonValue.toDouble": ('float',),
    "PySide2.QtCore.QJsonValue.toInt": ('int',),
    "PySide2.QtCore.QJsonValue.toObject": [(), ('typing.Dict[str, PySide2.QtCore.QJsonValue]',)],
    "PySide2.QtCore.QJsonValue.toString": [(), ('str',)],
    "PySide2.QtCore.QJsonValue.toVariant": (),
    "PySide2.QtCore.QJsonValue.type": (),

# class PySide2.QtCore.QLibraryInfo:

# class PySide2.QtCore.QLibraryInfo.LibraryLocation:
    "PySide2.QtCore.QLibraryInfo.build": (),
    "PySide2.QtCore.QLibraryInfo.buildDate": (),
    "PySide2.QtCore.QLibraryInfo.isDebugBuild": (),
    "PySide2.QtCore.QLibraryInfo.licensedProducts": (),
    "PySide2.QtCore.QLibraryInfo.licensee": (),
    "PySide2.QtCore.QLibraryInfo.location": ('PySide2.QtCore.QLibraryInfo.LibraryLocation',),
    "PySide2.QtCore.QLibraryInfo.platformPluginArguments": ('str',),
    "PySide2.QtCore.QLibraryInfo.version": (),

# class PySide2.QtCore.QLine:
    "PySide2.QtCore.QLine.__init__": [(), ('PySide2.QtCore.QLine',), ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'), ('int', 'int', 'int', 'int')],
    "PySide2.QtCore.QLine.__copy__": (),
    "PySide2.QtCore.QLine.__reduce__": (),
    "PySide2.QtCore.QLine.__repr__": (),
    "PySide2.QtCore.QLine.center": (),
    "PySide2.QtCore.QLine.dx": (),
    "PySide2.QtCore.QLine.dy": (),
    "PySide2.QtCore.QLine.isNull": (),
    "PySide2.QtCore.QLine.p1": (),
    "PySide2.QtCore.QLine.p2": (),
    "PySide2.QtCore.QLine.setLine": ('int', 'int', 'int', 'int'),
    "PySide2.QtCore.QLine.setP1": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QLine.setP2": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QLine.setPoints": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'),
    "PySide2.QtCore.QLine.toTuple": (),
    "PySide2.QtCore.QLine.translate": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtCore.QLine.translated": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtCore.QLine.x1": (),
    "PySide2.QtCore.QLine.x2": (),
    "PySide2.QtCore.QLine.y1": (),
    "PySide2.QtCore.QLine.y2": (),

# class PySide2.QtCore.QLineF:

# class PySide2.QtCore.QLineF.IntersectType:
    "PySide2.QtCore.QLineF.__init__": [(), ('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('float', 'float', 'float', 'float')],
    "PySide2.QtCore.QLineF.__copy__": (),
    "PySide2.QtCore.QLineF.__reduce__": (),
    "PySide2.QtCore.QLineF.__repr__": (),
    "PySide2.QtCore.QLineF.angle": [(), ('PySide2.QtCore.QLineF',)],
    "PySide2.QtCore.QLineF.angleTo": ('PySide2.QtCore.QLineF',),
    "PySide2.QtCore.QLineF.center": (),
    "PySide2.QtCore.QLineF.dx": (),
    "PySide2.QtCore.QLineF.dy": (),
    "PySide2.QtCore.QLineF.fromPolar": ('float', 'float'),
    "PySide2.QtCore.QLineF.intersect": ('PySide2.QtCore.QLineF', 'PySide2.QtCore.QPointF'),
    "PySide2.QtCore.QLineF.intersects": ('PySide2.QtCore.QLineF', 'PySide2.QtCore.QPointF'),
    "PySide2.QtCore.QLineF.isNull": (),
    "PySide2.QtCore.QLineF.length": (),
    "PySide2.QtCore.QLineF.normalVector": (),
    "PySide2.QtCore.QLineF.p1": (),
    "PySide2.QtCore.QLineF.p2": (),
    "PySide2.QtCore.QLineF.pointAt": ('float',),
    "PySide2.QtCore.QLineF.setAngle": ('float',),
    "PySide2.QtCore.QLineF.setLength": ('float',),
    "PySide2.QtCore.QLineF.setLine": ('float', 'float', 'float', 'float'),
    "PySide2.QtCore.QLineF.setP1": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QLineF.setP2": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QLineF.setPoints": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'),
    "PySide2.QtCore.QLineF.toLine": (),
    "PySide2.QtCore.QLineF.toTuple": (),
    "PySide2.QtCore.QLineF.translate": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtCore.QLineF.translated": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtCore.QLineF.unitVector": (),
    "PySide2.QtCore.QLineF.x1": (),
    "PySide2.QtCore.QLineF.x2": (),
    "PySide2.QtCore.QLineF.y1": (),
    "PySide2.QtCore.QLineF.y2": (),

# class PySide2.QtCore.QLocale:

# class PySide2.QtCore.QLocale.Country:

# class PySide2.QtCore.QLocale.CurrencySymbolFormat:

# class PySide2.QtCore.QLocale.DataSizeFormat:

# class PySide2.QtCore.QLocale.DataSizeFormats:

# class PySide2.QtCore.QLocale.FloatingPointPrecisionOption:

# class PySide2.QtCore.QLocale.FormatType:

# class PySide2.QtCore.QLocale.Language:

# class PySide2.QtCore.QLocale.MeasurementSystem:

# class PySide2.QtCore.QLocale.NumberOption:

# class PySide2.QtCore.QLocale.NumberOptions:

# class PySide2.QtCore.QLocale.QuotationStyle:

# class PySide2.QtCore.QLocale.Script:
    "PySide2.QtCore.QLocale.__init__": [(), ('PySide2.QtCore.QLocale',), ('PySide2.QtCore.QLocale.Language', 'PySide2.QtCore.QLocale.Country'), ('PySide2.QtCore.QLocale.Language', 'PySide2.QtCore.QLocale.Script', 'PySide2.QtCore.QLocale.Country'), ('str',)],
    "PySide2.QtCore.QLocale.__copy__": (),
    "PySide2.QtCore.QLocale.amText": (),
    "PySide2.QtCore.QLocale.bcp47Name": (),
    "PySide2.QtCore.QLocale.c": (),
    "PySide2.QtCore.QLocale.collation": (),
    "PySide2.QtCore.QLocale.countriesForLanguage": ('PySide2.QtCore.QLocale.Language',),
    "PySide2.QtCore.QLocale.country": (),
    "PySide2.QtCore.QLocale.countryToString": ('PySide2.QtCore.QLocale.Country',),
    "PySide2.QtCore.QLocale.createSeparatedList": ('typing.Sequence[str]',),
    "PySide2.QtCore.QLocale.currencySymbol": ('PySide2.QtCore.QLocale.CurrencySymbolFormat',),
    "PySide2.QtCore.QLocale.dateFormat": ('PySide2.QtCore.QLocale.FormatType',),
    "PySide2.QtCore.QLocale.dateTimeFormat": ('PySide2.QtCore.QLocale.FormatType',),
    "PySide2.QtCore.QLocale.dayName": ('int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QLocale.decimalPoint": (),
    "PySide2.QtCore.QLocale.exponential": (),
    "PySide2.QtCore.QLocale.firstDayOfWeek": (),
    "PySide2.QtCore.QLocale.formattedDataSize": ('int', 'int', 'PySide2.QtCore.QLocale.DataSizeFormats'),
    "PySide2.QtCore.QLocale.groupSeparator": (),
    "PySide2.QtCore.QLocale.language": (),
    "PySide2.QtCore.QLocale.languageToString": ('PySide2.QtCore.QLocale.Language',),
    "PySide2.QtCore.QLocale.matchingLocales": ('PySide2.QtCore.QLocale.Language', 'PySide2.QtCore.QLocale.Script', 'PySide2.QtCore.QLocale.Country'),
    "PySide2.QtCore.QLocale.measurementSystem": (),
    "PySide2.QtCore.QLocale.monthName": ('int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QLocale.name": (),
    "PySide2.QtCore.QLocale.nativeCountryName": (),
    "PySide2.QtCore.QLocale.nativeLanguageName": (),
    "PySide2.QtCore.QLocale.negativeSign": (),
    "PySide2.QtCore.QLocale.numberOptions": (),
    "PySide2.QtCore.QLocale.percent": (),
    "PySide2.QtCore.QLocale.pmText": (),
    "PySide2.QtCore.QLocale.positiveSign": (),
    "PySide2.QtCore.QLocale.quoteString": ('str', 'PySide2.QtCore.QLocale.QuotationStyle'),
    "PySide2.QtCore.QLocale.script": (),
    "PySide2.QtCore.QLocale.scriptToString": ('PySide2.QtCore.QLocale.Script',),
    "PySide2.QtCore.QLocale.setDefault": ('PySide2.QtCore.QLocale',),
    "PySide2.QtCore.QLocale.setNumberOptions": ('PySide2.QtCore.QLocale.NumberOptions',),
    "PySide2.QtCore.QLocale.standaloneDayName": ('int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QLocale.standaloneMonthName": ('int', 'PySide2.QtCore.QLocale.FormatType'),
    "PySide2.QtCore.QLocale.swap": ('PySide2.QtCore.QLocale',),
    "PySide2.QtCore.QLocale.system": (),
    "PySide2.QtCore.QLocale.textDirection": (),
    "PySide2.QtCore.QLocale.timeFormat": ('PySide2.QtCore.QLocale.FormatType',),
    "PySide2.QtCore.QLocale.toCurrencyString": [('float', 'str'), ('float', 'str', 'int'), ('int', 'str')],
    "PySide2.QtCore.QLocale.toDate": [('str', 'PySide2.QtCore.QLocale.FormatType'), ('str', 'PySide2.QtCore.QLocale.FormatType', 'PySide2.QtCore.QCalendar'), ('str', 'str'), ('str', 'str', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QLocale.toDateTime": [('str', 'PySide2.QtCore.QLocale.FormatType'), ('str', 'PySide2.QtCore.QLocale.FormatType', 'PySide2.QtCore.QCalendar'), ('str', 'str'), ('str', 'str', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QLocale.toDouble": ('str',),
    "PySide2.QtCore.QLocale.toFloat": ('str',),
    "PySide2.QtCore.QLocale.toInt": ('str',),
    "PySide2.QtCore.QLocale.toLong": ('str',),
    "PySide2.QtCore.QLocale.toLongLong": ('str',),
    "PySide2.QtCore.QLocale.toLower": ('str',),
    "PySide2.QtCore.QLocale.toShort": ('str',),
    "PySide2.QtCore.QLocale.toString": [('PySide2.QtCore.QDate', 'PySide2.QtCore.QLocale.FormatType'), ('PySide2.QtCore.QDate', 'PySide2.QtCore.QLocale.FormatType', 'PySide2.QtCore.QCalendar'), ('PySide2.QtCore.QDate', 'str'), ('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QLocale.FormatType'), ('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QLocale.FormatType', 'PySide2.QtCore.QCalendar'), ('PySide2.QtCore.QDateTime', 'str'), ('PySide2.QtCore.QTime', 'PySide2.QtCore.QLocale.FormatType'), ('PySide2.QtCore.QTime', 'str'), ('float', 'typing.Char', 'int'), ('int',)],
    "PySide2.QtCore.QLocale.toTime": [('str', 'PySide2.QtCore.QLocale.FormatType'), ('str', 'PySide2.QtCore.QLocale.FormatType', 'PySide2.QtCore.QCalendar'), ('str', 'str'), ('str', 'str', 'PySide2.QtCore.QCalendar')],
    "PySide2.QtCore.QLocale.toUInt": ('str',),
    "PySide2.QtCore.QLocale.toULong": ('str',),
    "PySide2.QtCore.QLocale.toULongLong": ('str',),
    "PySide2.QtCore.QLocale.toUShort": ('str',),
    "PySide2.QtCore.QLocale.toUpper": ('str',),
    "PySide2.QtCore.QLocale.uiLanguages": (),
    "PySide2.QtCore.QLocale.weekdays": (),
    "PySide2.QtCore.QLocale.zeroDigit": (),

# class PySide2.QtCore.QLockFile:

# class PySide2.QtCore.QLockFile.LockError:
    "PySide2.QtCore.QLockFile.__init__": ('str',),
    "PySide2.QtCore.QLockFile.error": (),
    "PySide2.QtCore.QLockFile.getLockInfo": (),
    "PySide2.QtCore.QLockFile.isLocked": (),
    "PySide2.QtCore.QLockFile.lock": (),
    "PySide2.QtCore.QLockFile.removeStaleLockFile": (),
    "PySide2.QtCore.QLockFile.setStaleLockTime": ('int',),
    "PySide2.QtCore.QLockFile.staleLockTime": (),
    "PySide2.QtCore.QLockFile.tryLock": ('int',),
    "PySide2.QtCore.QLockFile.unlock": (),

# class PySide2.QtCore.QMargins:
    "PySide2.QtCore.QMargins.__init__": [(), ('PySide2.QtCore.QMargins',), ('int', 'int', 'int', 'int')],
    "PySide2.QtCore.QMargins.__add__": [('PySide2.QtCore.QMargins',), ('int',)],
    "PySide2.QtCore.QMargins.__copy__": (),
    "PySide2.QtCore.QMargins.__iadd__": [('PySide2.QtCore.QMargins',), ('int',)],
    "PySide2.QtCore.QMargins.__imul__": [('float',), ('int',)],
    "PySide2.QtCore.QMargins.__isub__": [('PySide2.QtCore.QMargins',), ('int',)],
    "PySide2.QtCore.QMargins.__mul__": [('float',), ('int',)],
    "PySide2.QtCore.QMargins.__neg__": (),
    "PySide2.QtCore.QMargins.__pos__": (),
    "PySide2.QtCore.QMargins.__sub__": [('PySide2.QtCore.QMargins',), ('int',)],
    "PySide2.QtCore.QMargins.bottom": (),
    "PySide2.QtCore.QMargins.isNull": (),
    "PySide2.QtCore.QMargins.left": (),
    "PySide2.QtCore.QMargins.right": (),
    "PySide2.QtCore.QMargins.setBottom": ('int',),
    "PySide2.QtCore.QMargins.setLeft": ('int',),
    "PySide2.QtCore.QMargins.setRight": ('int',),
    "PySide2.QtCore.QMargins.setTop": ('int',),
    "PySide2.QtCore.QMargins.top": (),

# class PySide2.QtCore.QMarginsF:
    "PySide2.QtCore.QMarginsF.__init__": [(), ('PySide2.QtCore.QMargins',), ('PySide2.QtCore.QMarginsF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtCore.QMarginsF.__add__": [('PySide2.QtCore.QMarginsF',), ('float',)],
    "PySide2.QtCore.QMarginsF.__copy__": (),
    "PySide2.QtCore.QMarginsF.__iadd__": [('PySide2.QtCore.QMarginsF',), ('float',)],
    "PySide2.QtCore.QMarginsF.__imul__": ('float',),
    "PySide2.QtCore.QMarginsF.__isub__": [('PySide2.QtCore.QMarginsF',), ('float',)],
    "PySide2.QtCore.QMarginsF.__mul__": ('float',),
    "PySide2.QtCore.QMarginsF.__neg__": (),
    "PySide2.QtCore.QMarginsF.__pos__": (),
    "PySide2.QtCore.QMarginsF.__sub__": [('PySide2.QtCore.QMarginsF',), ('float',)],
    "PySide2.QtCore.QMarginsF.bottom": (),
    "PySide2.QtCore.QMarginsF.isNull": (),
    "PySide2.QtCore.QMarginsF.left": (),
    "PySide2.QtCore.QMarginsF.right": (),
    "PySide2.QtCore.QMarginsF.setBottom": ('float',),
    "PySide2.QtCore.QMarginsF.setLeft": ('float',),
    "PySide2.QtCore.QMarginsF.setRight": ('float',),
    "PySide2.QtCore.QMarginsF.setTop": ('float',),
    "PySide2.QtCore.QMarginsF.toMargins": (),
    "PySide2.QtCore.QMarginsF.top": (),

# class PySide2.QtCore.QMessageAuthenticationCode:
    "PySide2.QtCore.QMessageAuthenticationCode.__init__": ('PySide2.QtCore.QCryptographicHash.Algorithm', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtCore.QMessageAuthenticationCode.addData": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',), ('str', 'int')],
    "PySide2.QtCore.QMessageAuthenticationCode.hash": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QCryptographicHash.Algorithm'),
    "PySide2.QtCore.QMessageAuthenticationCode.reset": (),
    "PySide2.QtCore.QMessageAuthenticationCode.result": (),
    "PySide2.QtCore.QMessageAuthenticationCode.setKey": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtCore.QMessageLogContext:
    "PySide2.QtCore.QMessageLogContext.__init__": [(), ('str', 'int', 'str', 'str')],

# class PySide2.QtCore.QMetaClassInfo:
    "PySide2.QtCore.QMetaClassInfo.__init__": [(), ('PySide2.QtCore.QMetaClassInfo',)],
    "PySide2.QtCore.QMetaClassInfo.__copy__": (),
    "PySide2.QtCore.QMetaClassInfo.name": (),
    "PySide2.QtCore.QMetaClassInfo.value": (),

# class PySide2.QtCore.QMetaEnum:
    "PySide2.QtCore.QMetaEnum.__init__": [(), ('PySide2.QtCore.QMetaEnum',)],
    "PySide2.QtCore.QMetaEnum.__copy__": (),
    "PySide2.QtCore.QMetaEnum.enumName": (),
    "PySide2.QtCore.QMetaEnum.isFlag": (),
    "PySide2.QtCore.QMetaEnum.isScoped": (),
    "PySide2.QtCore.QMetaEnum.isValid": (),
    "PySide2.QtCore.QMetaEnum.key": ('int',),
    "PySide2.QtCore.QMetaEnum.keyCount": (),
    "PySide2.QtCore.QMetaEnum.keyToValue": ('str',),
    "PySide2.QtCore.QMetaEnum.keysToValue": ('str',),
    "PySide2.QtCore.QMetaEnum.name": (),
    "PySide2.QtCore.QMetaEnum.scope": (),
    "PySide2.QtCore.QMetaEnum.value": ('int',),
    "PySide2.QtCore.QMetaEnum.valueToKey": ('int',),
    "PySide2.QtCore.QMetaEnum.valueToKeys": ('int',),

# class PySide2.QtCore.QMetaMethod:

# class PySide2.QtCore.QMetaMethod.Access:

# class PySide2.QtCore.QMetaMethod.MethodType:
    "PySide2.QtCore.QMetaMethod.__init__": [(), ('PySide2.QtCore.QMetaMethod',)],
    "PySide2.QtCore.QMetaMethod.__copy__": (),
    "PySide2.QtCore.QMetaMethod.access": (),
    "PySide2.QtCore.QMetaMethod.enclosingMetaObject": (),
    "PySide2.QtCore.QMetaMethod.invoke": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('PySide2.QtCore.QObject', 'PySide2.QtCore.QGenericReturnArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('PySide2.QtCore.QObject', 'PySide2.QtCore.Qt.ConnectionType', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('PySide2.QtCore.QObject', 'PySide2.QtCore.Qt.ConnectionType', 'PySide2.QtCore.QGenericReturnArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument')],
    "PySide2.QtCore.QMetaMethod.invokeOnGadget": [('int', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('int', 'PySide2.QtCore.QGenericReturnArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument')],
    "PySide2.QtCore.QMetaMethod.isValid": (),
    "PySide2.QtCore.QMetaMethod.methodIndex": (),
    "PySide2.QtCore.QMetaMethod.methodSignature": (),
    "PySide2.QtCore.QMetaMethod.methodType": (),
    "PySide2.QtCore.QMetaMethod.name": (),
    "PySide2.QtCore.QMetaMethod.parameterCount": (),
    "PySide2.QtCore.QMetaMethod.parameterNames": (),
    "PySide2.QtCore.QMetaMethod.parameterType": ('int',),
    "PySide2.QtCore.QMetaMethod.parameterTypes": (),
    "PySide2.QtCore.QMetaMethod.returnType": (),
    "PySide2.QtCore.QMetaMethod.revision": (),
    "PySide2.QtCore.QMetaMethod.tag": (),
    "PySide2.QtCore.QMetaMethod.typeName": (),

# class PySide2.QtCore.QMetaObject:

# class PySide2.QtCore.QMetaObject.Call:

# class PySide2.QtCore.QMetaObject.Connection:
    "PySide2.QtCore.QMetaObject.Connection.__init__": [(), ('PySide2.QtCore.QMetaObject.Connection',)],

    "PySide2.QtCore.QMetaObject.__init__": (),
    "PySide2.QtCore.QMetaObject.cast": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaObject.checkConnectArgs": [('PySide2.QtCore.QMetaMethod', 'PySide2.QtCore.QMetaMethod'), ('str', 'str')],
    "PySide2.QtCore.QMetaObject.classInfo": ('int',),
    "PySide2.QtCore.QMetaObject.classInfoCount": (),
    "PySide2.QtCore.QMetaObject.classInfoOffset": (),
    "PySide2.QtCore.QMetaObject.className": (),
    "PySide2.QtCore.QMetaObject.connectSlotsByName": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaObject.constructor": ('int',),
    "PySide2.QtCore.QMetaObject.constructorCount": (),
    "PySide2.QtCore.QMetaObject.disconnect": ('PySide2.QtCore.QObject', 'int', 'PySide2.QtCore.QObject', 'int'),
    "PySide2.QtCore.QMetaObject.disconnectOne": ('PySide2.QtCore.QObject', 'int', 'PySide2.QtCore.QObject', 'int'),
    "PySide2.QtCore.QMetaObject.enumerator": ('int',),
    "PySide2.QtCore.QMetaObject.enumeratorCount": (),
    "PySide2.QtCore.QMetaObject.enumeratorOffset": (),
    "PySide2.QtCore.QMetaObject.indexOfClassInfo": ('str',),
    "PySide2.QtCore.QMetaObject.indexOfConstructor": ('str',),
    "PySide2.QtCore.QMetaObject.indexOfEnumerator": ('str',),
    "PySide2.QtCore.QMetaObject.indexOfMethod": ('str',),
    "PySide2.QtCore.QMetaObject.indexOfProperty": ('str',),
    "PySide2.QtCore.QMetaObject.indexOfSignal": ('str',),
    "PySide2.QtCore.QMetaObject.indexOfSlot": ('str',),
    "PySide2.QtCore.QMetaObject.inherits": ('PySide2.QtCore.QMetaObject',),
    "PySide2.QtCore.QMetaObject.invokeMethod": [('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QGenericReturnArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.Qt.ConnectionType', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.Qt.ConnectionType', 'PySide2.QtCore.QGenericReturnArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument')],
    "PySide2.QtCore.QMetaObject.method": ('int',),
    "PySide2.QtCore.QMetaObject.methodCount": (),
    "PySide2.QtCore.QMetaObject.methodOffset": (),
    "PySide2.QtCore.QMetaObject.newInstance": ('PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument', 'PySide2.QtCore.QGenericArgument'),
    "PySide2.QtCore.QMetaObject.normalizedSignature": ('str',),
    "PySide2.QtCore.QMetaObject.normalizedType": ('str',),
    "PySide2.QtCore.QMetaObject.property": ('int',),
    "PySide2.QtCore.QMetaObject.propertyCount": (),
    "PySide2.QtCore.QMetaObject.propertyOffset": (),
    "PySide2.QtCore.QMetaObject.superClass": (),
    "PySide2.QtCore.QMetaObject.userProperty": (),

# class PySide2.QtCore.QMetaProperty:
    "PySide2.QtCore.QMetaProperty.__init__": [(), ('PySide2.QtCore.QMetaProperty',)],
    "PySide2.QtCore.QMetaProperty.__copy__": (),
    "PySide2.QtCore.QMetaProperty.enumerator": (),
    "PySide2.QtCore.QMetaProperty.hasNotifySignal": (),
    "PySide2.QtCore.QMetaProperty.hasStdCppSet": (),
    "PySide2.QtCore.QMetaProperty.isConstant": (),
    "PySide2.QtCore.QMetaProperty.isDesignable": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.isEditable": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.isEnumType": (),
    "PySide2.QtCore.QMetaProperty.isFinal": (),
    "PySide2.QtCore.QMetaProperty.isFlagType": (),
    "PySide2.QtCore.QMetaProperty.isReadable": (),
    "PySide2.QtCore.QMetaProperty.isResettable": (),
    "PySide2.QtCore.QMetaProperty.isScriptable": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.isStored": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.isUser": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.isValid": (),
    "PySide2.QtCore.QMetaProperty.isWritable": (),
    "PySide2.QtCore.QMetaProperty.name": (),
    "PySide2.QtCore.QMetaProperty.notifySignal": (),
    "PySide2.QtCore.QMetaProperty.notifySignalIndex": (),
    "PySide2.QtCore.QMetaProperty.propertyIndex": (),
    "PySide2.QtCore.QMetaProperty.read": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.readOnGadget": ('int',),
    "PySide2.QtCore.QMetaProperty.relativePropertyIndex": (),
    "PySide2.QtCore.QMetaProperty.reset": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QMetaProperty.resetOnGadget": ('int',),
    "PySide2.QtCore.QMetaProperty.revision": (),
    "PySide2.QtCore.QMetaProperty.type": (),
    "PySide2.QtCore.QMetaProperty.typeName": (),
    "PySide2.QtCore.QMetaProperty.userType": (),
    "PySide2.QtCore.QMetaProperty.write": ('PySide2.QtCore.QObject', 'typing.Any'),
    "PySide2.QtCore.QMetaProperty.writeOnGadget": ('int', 'typing.Any'),

# class PySide2.QtCore.QMimeData:
    "PySide2.QtCore.QMimeData.__init__": (),
    "PySide2.QtCore.QMimeData.clear": (),
    "PySide2.QtCore.QMimeData.colorData": (),
    "PySide2.QtCore.QMimeData.data": ('str',),
    "PySide2.QtCore.QMimeData.formats": (),
    "PySide2.QtCore.QMimeData.hasColor": (),
    "PySide2.QtCore.QMimeData.hasFormat": ('str',),
    "PySide2.QtCore.QMimeData.hasHtml": (),
    "PySide2.QtCore.QMimeData.hasImage": (),
    "PySide2.QtCore.QMimeData.hasText": (),
    "PySide2.QtCore.QMimeData.hasUrls": (),
    "PySide2.QtCore.QMimeData.html": (),
    "PySide2.QtCore.QMimeData.imageData": (),
    "PySide2.QtCore.QMimeData.removeFormat": ('str',),
    "PySide2.QtCore.QMimeData.retrieveData": ('str', 'type'),
    "PySide2.QtCore.QMimeData.setColorData": ('typing.Any',),
    "PySide2.QtCore.QMimeData.setData": ('str', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtCore.QMimeData.setHtml": ('str',),
    "PySide2.QtCore.QMimeData.setImageData": ('typing.Any',),
    "PySide2.QtCore.QMimeData.setText": ('str',),
    "PySide2.QtCore.QMimeData.setUrls": ('typing.Sequence[PySide2.QtCore.QUrl]',),
    "PySide2.QtCore.QMimeData.text": (),
    "PySide2.QtCore.QMimeData.urls": (),

# class PySide2.QtCore.QMimeDatabase:

# class PySide2.QtCore.QMimeDatabase.MatchMode:
    "PySide2.QtCore.QMimeDatabase.__init__": (),
    "PySide2.QtCore.QMimeDatabase.allMimeTypes": (),
    "PySide2.QtCore.QMimeDatabase.mimeTypeForData": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtCore.QMimeDatabase.mimeTypeForFile": [('PySide2.QtCore.QFileInfo', 'PySide2.QtCore.QMimeDatabase.MatchMode'), ('str', 'PySide2.QtCore.QMimeDatabase.MatchMode')],
    "PySide2.QtCore.QMimeDatabase.mimeTypeForFileNameAndData": [('str', 'PySide2.QtCore.QByteArray'), ('str', 'PySide2.QtCore.QIODevice')],
    "PySide2.QtCore.QMimeDatabase.mimeTypeForName": ('str',),
    "PySide2.QtCore.QMimeDatabase.mimeTypeForUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtCore.QMimeDatabase.mimeTypesForFileName": ('str',),
    "PySide2.QtCore.QMimeDatabase.suffixForFileName": ('str',),

# class PySide2.QtCore.QMimeType:
    "PySide2.QtCore.QMimeType.__init__": [(), ('PySide2.QtCore.QMimeType',)],
    "PySide2.QtCore.QMimeType.__copy__": (),
    "PySide2.QtCore.QMimeType.aliases": (),
    "PySide2.QtCore.QMimeType.allAncestors": (),
    "PySide2.QtCore.QMimeType.comment": (),
    "PySide2.QtCore.QMimeType.filterString": (),
    "PySide2.QtCore.QMimeType.genericIconName": (),
    "PySide2.QtCore.QMimeType.globPatterns": (),
    "PySide2.QtCore.QMimeType.iconName": (),
    "PySide2.QtCore.QMimeType.inherits": ('str',),
    "PySide2.QtCore.QMimeType.isDefault": (),
    "PySide2.QtCore.QMimeType.isValid": (),
    "PySide2.QtCore.QMimeType.name": (),
    "PySide2.QtCore.QMimeType.parentMimeTypes": (),
    "PySide2.QtCore.QMimeType.preferredSuffix": (),
    "PySide2.QtCore.QMimeType.suffixes": (),
    "PySide2.QtCore.QMimeType.swap": ('PySide2.QtCore.QMimeType',),

# class PySide2.QtCore.QModelIndex:
    "PySide2.QtCore.QModelIndex.__init__": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QModelIndex.__copy__": (),
    "PySide2.QtCore.QModelIndex.child": ('int', 'int'),
    "PySide2.QtCore.QModelIndex.column": (),
    "PySide2.QtCore.QModelIndex.data": ('int',),
    "PySide2.QtCore.QModelIndex.flags": (),
    "PySide2.QtCore.QModelIndex.internalId": (),
    "PySide2.QtCore.QModelIndex.internalPointer": (),
    "PySide2.QtCore.QModelIndex.isValid": (),
    "PySide2.QtCore.QModelIndex.model": (),
    "PySide2.QtCore.QModelIndex.parent": (),
    "PySide2.QtCore.QModelIndex.row": (),
    "PySide2.QtCore.QModelIndex.sibling": ('int', 'int'),
    "PySide2.QtCore.QModelIndex.siblingAtColumn": ('int',),
    "PySide2.QtCore.QModelIndex.siblingAtRow": ('int',),

# class PySide2.QtCore.QMutex:

# class PySide2.QtCore.QMutex.RecursionMode:
    "PySide2.QtCore.QMutex.__init__": [(), ('PySide2.QtCore.QMutex.RecursionMode',)],
    "PySide2.QtCore.QMutex.isRecursive": (),
    "PySide2.QtCore.QMutex.lock": (),
    "PySide2.QtCore.QMutex.tryLock": [(), ('int',)],
    "PySide2.QtCore.QMutex.try_lock": (),
    "PySide2.QtCore.QMutex.unlock": (),

# class PySide2.QtCore.QMutexLocker:
    "PySide2.QtCore.QMutexLocker.__init__": [('PySide2.QtCore.QBasicMutex',), ('PySide2.QtCore.QRecursiveMutex',)],
    "PySide2.QtCore.QMutexLocker.__enter__": (),
    "PySide2.QtCore.QMutexLocker.__exit__": ('object', 'object', 'object'),
    "PySide2.QtCore.QMutexLocker.mutex": (),
    "PySide2.QtCore.QMutexLocker.relock": (),
    "PySide2.QtCore.QMutexLocker.unlock": (),

# class PySide2.QtCore.QObject:
    "PySide2.QtCore.QObject.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QObject.blockSignals": ('bool',),
    "PySide2.QtCore.QObject.childEvent": ('PySide2.QtCore.QChildEvent',),
    "PySide2.QtCore.QObject.children": (),
    "PySide2.QtCore.QObject.connect": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QMetaMethod', 'PySide2.QtCore.QObject', 'PySide2.QtCore.QMetaMethod', 'PySide2.QtCore.Qt.ConnectionType'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.Qt.ConnectionType'), ('PySide2.QtCore.QObject', 'str', 'str', 'PySide2.QtCore.Qt.ConnectionType'), ('PySide2.QtCore.QObject', 'str', 'typing.Callable', 'PySide2.QtCore.Qt.ConnectionType'), ('str', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.Qt.ConnectionType'), ('str', 'typing.Callable', 'PySide2.QtCore.Qt.ConnectionType')],
    "PySide2.QtCore.QObject.connectNotify": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtCore.QObject.customEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QObject.deleteLater": (),
    "PySide2.QtCore.QObject.disconnect": [('PySide2.QtCore.QMetaObject.Connection',), ('PySide2.QtCore.QObject', 'PySide2.QtCore.QMetaMethod', 'PySide2.QtCore.QObject', 'PySide2.QtCore.QMetaMethod'), ('PySide2.QtCore.QObject', 'str'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QObject', 'str'), ('PySide2.QtCore.QObject', 'str', 'typing.Callable'), ('str', 'PySide2.QtCore.QObject', 'str'), ('str', 'typing.Callable')],
    "PySide2.QtCore.QObject.disconnectNotify": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtCore.QObject.dumpObjectInfo": (),
    "PySide2.QtCore.QObject.dumpObjectTree": (),
    "PySide2.QtCore.QObject.dynamicPropertyNames": (),
    "PySide2.QtCore.QObject.emit": ('str', 'None'),
    "PySide2.QtCore.QObject.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QObject.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtCore.QObject.findChild": ('type', 'str'),
    "PySide2.QtCore.QObject.findChildren": [('type', 'PySide2.QtCore.QRegExp'), ('type', 'str')],
    "PySide2.QtCore.QObject.inherits": ('str',),
    "PySide2.QtCore.QObject.installEventFilter": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QObject.isSignalConnected": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtCore.QObject.isWidgetType": (),
    "PySide2.QtCore.QObject.isWindowType": (),
    "PySide2.QtCore.QObject.killTimer": ('int',),
    "PySide2.QtCore.QObject.metaObject": (),
    "PySide2.QtCore.QObject.moveToThread": ('PySide2.QtCore.QThread',),
    "PySide2.QtCore.QObject.objectName": (),
    "PySide2.QtCore.QObject.parent": (),
    "PySide2.QtCore.QObject.property": ('str',),
    "PySide2.QtCore.QObject.receivers": ('str',),
    "PySide2.QtCore.QObject.registerUserData": (),
    "PySide2.QtCore.QObject.removeEventFilter": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QObject.sender": (),
    "PySide2.QtCore.QObject.senderSignalIndex": (),
    "PySide2.QtCore.QObject.setObjectName": ('str',),
    "PySide2.QtCore.QObject.setParent": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QObject.setProperty": ('str', 'typing.Any'),
    "PySide2.QtCore.QObject.signalsBlocked": (),
    "PySide2.QtCore.QObject.startTimer": ('int', 'PySide2.QtCore.Qt.TimerType'),
    "PySide2.QtCore.QObject.thread": (),
    "PySide2.QtCore.QObject.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtCore.QObject.tr": ('str', 'str', 'int'),

# class PySide2.QtCore.QOperatingSystemVersion:

# class PySide2.QtCore.QOperatingSystemVersion.OSType:
    "PySide2.QtCore.QOperatingSystemVersion.__init__": [('PySide2.QtCore.QOperatingSystemVersion',), ('PySide2.QtCore.QOperatingSystemVersion.OSType', 'int', 'int', 'int')],
    "PySide2.QtCore.QOperatingSystemVersion.__copy__": (),
    "PySide2.QtCore.QOperatingSystemVersion.current": (),
    "PySide2.QtCore.QOperatingSystemVersion.currentType": (),
    "PySide2.QtCore.QOperatingSystemVersion.majorVersion": (),
    "PySide2.QtCore.QOperatingSystemVersion.microVersion": (),
    "PySide2.QtCore.QOperatingSystemVersion.minorVersion": (),
    "PySide2.QtCore.QOperatingSystemVersion.name": (),
    "PySide2.QtCore.QOperatingSystemVersion.segmentCount": (),
    "PySide2.QtCore.QOperatingSystemVersion.type": (),

# class PySide2.QtCore.QParallelAnimationGroup:
    "PySide2.QtCore.QParallelAnimationGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QParallelAnimationGroup.duration": (),
    "PySide2.QtCore.QParallelAnimationGroup.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QParallelAnimationGroup.updateCurrentTime": ('int',),
    "PySide2.QtCore.QParallelAnimationGroup.updateDirection": ('PySide2.QtCore.QAbstractAnimation.Direction',),
    "PySide2.QtCore.QParallelAnimationGroup.updateState": ('PySide2.QtCore.QAbstractAnimation.State', 'PySide2.QtCore.QAbstractAnimation.State'),

# class PySide2.QtCore.QPauseAnimation:
    "PySide2.QtCore.QPauseAnimation.__init__": [('PySide2.QtCore.QObject',), ('int', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QPauseAnimation.duration": (),
    "PySide2.QtCore.QPauseAnimation.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QPauseAnimation.setDuration": ('int',),
    "PySide2.QtCore.QPauseAnimation.updateCurrentTime": ('int',),

# class PySide2.QtCore.QPersistentModelIndex:
    "PySide2.QtCore.QPersistentModelIndex.__init__": [(), ('PySide2.QtCore.QModelIndex',), ('PySide2.QtCore.QPersistentModelIndex',)],
    "PySide2.QtCore.QPersistentModelIndex.__copy__": (),
    "PySide2.QtCore.QPersistentModelIndex.child": ('int', 'int'),
    "PySide2.QtCore.QPersistentModelIndex.column": (),
    "PySide2.QtCore.QPersistentModelIndex.data": ('int',),
    "PySide2.QtCore.QPersistentModelIndex.flags": (),
    "PySide2.QtCore.QPersistentModelIndex.internalId": (),
    "PySide2.QtCore.QPersistentModelIndex.internalPointer": (),
    "PySide2.QtCore.QPersistentModelIndex.isValid": (),
    "PySide2.QtCore.QPersistentModelIndex.model": (),
    "PySide2.QtCore.QPersistentModelIndex.parent": (),
    "PySide2.QtCore.QPersistentModelIndex.row": (),
    "PySide2.QtCore.QPersistentModelIndex.sibling": ('int', 'int'),
    "PySide2.QtCore.QPersistentModelIndex.swap": ('PySide2.QtCore.QPersistentModelIndex',),

# class PySide2.QtCore.QPluginLoader:
    "PySide2.QtCore.QPluginLoader.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QPluginLoader.errorString": (),
    "PySide2.QtCore.QPluginLoader.fileName": (),
    "PySide2.QtCore.QPluginLoader.instance": (),
    "PySide2.QtCore.QPluginLoader.isLoaded": (),
    "PySide2.QtCore.QPluginLoader.load": (),
    "PySide2.QtCore.QPluginLoader.metaData": (),
    "PySide2.QtCore.QPluginLoader.setFileName": ('str',),
    "PySide2.QtCore.QPluginLoader.staticInstances": (),
    "PySide2.QtCore.QPluginLoader.unload": (),

# class PySide2.QtCore.QPoint:
    "PySide2.QtCore.QPoint.__init__": [(), ('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtCore.QPoint.__add__": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QPoint.__copy__": (),
    "PySide2.QtCore.QPoint.__iadd__": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QPoint.__imul__": [('float',), ('int',)],
    "PySide2.QtCore.QPoint.__isub__": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QPoint.__mul__": [('float',), ('int',)],
    "PySide2.QtCore.QPoint.__neg__": (),
    "PySide2.QtCore.QPoint.__pos__": (),
    "PySide2.QtCore.QPoint.__reduce__": (),
    "PySide2.QtCore.QPoint.__repr__": (),
    "PySide2.QtCore.QPoint.__sub__": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QPoint.dotProduct": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'),
    "PySide2.QtCore.QPoint.isNull": (),
    "PySide2.QtCore.QPoint.manhattanLength": (),
    "PySide2.QtCore.QPoint.setX": ('int',),
    "PySide2.QtCore.QPoint.setY": ('int',),
    "PySide2.QtCore.QPoint.toTuple": (),
    "PySide2.QtCore.QPoint.transposed": (),
    "PySide2.QtCore.QPoint.x": (),
    "PySide2.QtCore.QPoint.y": (),

# class PySide2.QtCore.QPointF:
    "PySide2.QtCore.QPointF.__init__": [(), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtCore.QPointF.__add__": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QPointF.__copy__": (),
    "PySide2.QtCore.QPointF.__iadd__": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QPointF.__imul__": ('float',),
    "PySide2.QtCore.QPointF.__isub__": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QPointF.__mul__": ('float',),
    "PySide2.QtCore.QPointF.__neg__": (),
    "PySide2.QtCore.QPointF.__pos__": (),
    "PySide2.QtCore.QPointF.__reduce__": (),
    "PySide2.QtCore.QPointF.__repr__": (),
    "PySide2.QtCore.QPointF.__sub__": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QPointF.dotProduct": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'),
    "PySide2.QtCore.QPointF.isNull": (),
    "PySide2.QtCore.QPointF.manhattanLength": (),
    "PySide2.QtCore.QPointF.setX": ('float',),
    "PySide2.QtCore.QPointF.setY": ('float',),
    "PySide2.QtCore.QPointF.toPoint": (),
    "PySide2.QtCore.QPointF.toTuple": (),
    "PySide2.QtCore.QPointF.transposed": (),
    "PySide2.QtCore.QPointF.x": (),
    "PySide2.QtCore.QPointF.y": (),

# class PySide2.QtCore.QProcess:

# class PySide2.QtCore.QProcess.ExitStatus:

# class PySide2.QtCore.QProcess.InputChannelMode:

# class PySide2.QtCore.QProcess.ProcessChannel:

# class PySide2.QtCore.QProcess.ProcessChannelMode:

# class PySide2.QtCore.QProcess.ProcessError:

# class PySide2.QtCore.QProcess.ProcessState:
    "PySide2.QtCore.QProcess.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QProcess.arguments": (),
    "PySide2.QtCore.QProcess.atEnd": (),
    "PySide2.QtCore.QProcess.bytesAvailable": (),
    "PySide2.QtCore.QProcess.bytesToWrite": (),
    "PySide2.QtCore.QProcess.canReadLine": (),
    "PySide2.QtCore.QProcess.close": (),
    "PySide2.QtCore.QProcess.closeReadChannel": ('PySide2.QtCore.QProcess.ProcessChannel',),
    "PySide2.QtCore.QProcess.closeWriteChannel": (),
    "PySide2.QtCore.QProcess.environment": (),
    "PySide2.QtCore.QProcess.error": (),
    "PySide2.QtCore.QProcess.execute": [('str',), ('str', 'typing.Sequence[str]')],
    "PySide2.QtCore.QProcess.exitCode": (),
    "PySide2.QtCore.QProcess.exitStatus": (),
    "PySide2.QtCore.QProcess.inputChannelMode": (),
    "PySide2.QtCore.QProcess.isSequential": (),
    "PySide2.QtCore.QProcess.kill": (),
    "PySide2.QtCore.QProcess.nullDevice": (),
    "PySide2.QtCore.QProcess.open": ('PySide2.QtCore.QIODevice.OpenMode',),
    "PySide2.QtCore.QProcess.pid": (),
    "PySide2.QtCore.QProcess.processChannelMode": (),
    "PySide2.QtCore.QProcess.processEnvironment": (),
    "PySide2.QtCore.QProcess.processId": (),
    "PySide2.QtCore.QProcess.program": (),
    "PySide2.QtCore.QProcess.readAllStandardError": (),
    "PySide2.QtCore.QProcess.readAllStandardOutput": (),
    "PySide2.QtCore.QProcess.readChannel": (),
    "PySide2.QtCore.QProcess.readData": ('str', 'int'),
    "PySide2.QtCore.QProcess.setArguments": ('typing.Sequence[str]',),
    "PySide2.QtCore.QProcess.setEnvironment": ('typing.Sequence[str]',),
    "PySide2.QtCore.QProcess.setInputChannelMode": ('PySide2.QtCore.QProcess.InputChannelMode',),
    "PySide2.QtCore.QProcess.setProcessChannelMode": ('PySide2.QtCore.QProcess.ProcessChannelMode',),
    "PySide2.QtCore.QProcess.setProcessEnvironment": ('PySide2.QtCore.QProcessEnvironment',),
    "PySide2.QtCore.QProcess.setProcessState": ('PySide2.QtCore.QProcess.ProcessState',),
    "PySide2.QtCore.QProcess.setProgram": ('str',),
    "PySide2.QtCore.QProcess.setReadChannel": ('PySide2.QtCore.QProcess.ProcessChannel',),
    "PySide2.QtCore.QProcess.setStandardErrorFile": ('str', 'PySide2.QtCore.QIODevice.OpenMode'),
    "PySide2.QtCore.QProcess.setStandardInputFile": ('str',),
    "PySide2.QtCore.QProcess.setStandardOutputFile": ('str', 'PySide2.QtCore.QIODevice.OpenMode'),
    "PySide2.QtCore.QProcess.setStandardOutputProcess": ('PySide2.QtCore.QProcess',),
    "PySide2.QtCore.QProcess.setWorkingDirectory": ('str',),
    "PySide2.QtCore.QProcess.setupChildProcess": (),
    "PySide2.QtCore.QProcess.start": [('PySide2.QtCore.QIODevice.OpenMode',), ('str', 'PySide2.QtCore.QIODevice.OpenMode'), ('str', 'typing.Sequence[str]', 'PySide2.QtCore.QIODevice.OpenMode')],
    "PySide2.QtCore.QProcess.startDetached": [(), ('str',), ('str', 'typing.Sequence[str]'), ('str', 'typing.Sequence[str]', 'str')],
    "PySide2.QtCore.QProcess.state": (),
    "PySide2.QtCore.QProcess.systemEnvironment": (),
    "PySide2.QtCore.QProcess.terminate": (),
    "PySide2.QtCore.QProcess.waitForBytesWritten": ('int',),
    "PySide2.QtCore.QProcess.waitForFinished": ('int',),
    "PySide2.QtCore.QProcess.waitForReadyRead": ('int',),
    "PySide2.QtCore.QProcess.waitForStarted": ('int',),
    "PySide2.QtCore.QProcess.workingDirectory": (),
    "PySide2.QtCore.QProcess.writeData": ('str', 'int'),

# class PySide2.QtCore.QProcessEnvironment:
    "PySide2.QtCore.QProcessEnvironment.__init__": [(), ('PySide2.QtCore.QProcessEnvironment',)],
    "PySide2.QtCore.QProcessEnvironment.__copy__": (),
    "PySide2.QtCore.QProcessEnvironment.clear": (),
    "PySide2.QtCore.QProcessEnvironment.contains": ('str',),
    "PySide2.QtCore.QProcessEnvironment.insert": [('PySide2.QtCore.QProcessEnvironment',), ('str', 'str')],
    "PySide2.QtCore.QProcessEnvironment.isEmpty": (),
    "PySide2.QtCore.QProcessEnvironment.keys": (),
    "PySide2.QtCore.QProcessEnvironment.remove": ('str',),
    "PySide2.QtCore.QProcessEnvironment.swap": ('PySide2.QtCore.QProcessEnvironment',),
    "PySide2.QtCore.QProcessEnvironment.systemEnvironment": (),
    "PySide2.QtCore.QProcessEnvironment.toStringList": (),
    "PySide2.QtCore.QProcessEnvironment.value": ('str', 'str'),

# class PySide2.QtCore.QPropertyAnimation:
    "PySide2.QtCore.QPropertyAnimation.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QObject', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QPropertyAnimation.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QPropertyAnimation.propertyName": (),
    "PySide2.QtCore.QPropertyAnimation.setPropertyName": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QPropertyAnimation.setTargetObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QPropertyAnimation.targetObject": (),
    "PySide2.QtCore.QPropertyAnimation.updateCurrentValue": ('typing.Any',),
    "PySide2.QtCore.QPropertyAnimation.updateState": ('PySide2.QtCore.QAbstractAnimation.State', 'PySide2.QtCore.QAbstractAnimation.State'),

# class PySide2.QtCore.QRandomGenerator:
    "PySide2.QtCore.QRandomGenerator.__init__": [('PySide2.QtCore.QRandomGenerator',), ('int',), ('int', 'int')],
    "PySide2.QtCore.QRandomGenerator.bounded": [('float',), ('int',), ('int', 'int')],
    "PySide2.QtCore.QRandomGenerator.discard": ('int',),
    "PySide2.QtCore.QRandomGenerator.generate": (),
    "PySide2.QtCore.QRandomGenerator.generate64": (),
    "PySide2.QtCore.QRandomGenerator.generateDouble": (),
    "PySide2.QtCore.QRandomGenerator.global_": (),
    "PySide2.QtCore.QRandomGenerator.max": (),
    "PySide2.QtCore.QRandomGenerator.min": (),
    "PySide2.QtCore.QRandomGenerator.securelySeeded": (),
    "PySide2.QtCore.QRandomGenerator.seed": ('int',),
    "PySide2.QtCore.QRandomGenerator.system": (),

# class PySide2.QtCore.QRandomGenerator64:
    "PySide2.QtCore.QRandomGenerator64.__init__": [('PySide2.QtCore.QRandomGenerator',), ('int',), ('int', 'int')],
    "PySide2.QtCore.QRandomGenerator64.discard": ('int',),
    "PySide2.QtCore.QRandomGenerator64.generate": (),
    "PySide2.QtCore.QRandomGenerator64.global_": (),
    "PySide2.QtCore.QRandomGenerator64.max": (),
    "PySide2.QtCore.QRandomGenerator64.min": (),
    "PySide2.QtCore.QRandomGenerator64.securelySeeded": (),
    "PySide2.QtCore.QRandomGenerator64.system": (),

# class PySide2.QtCore.QReadLocker:
    "PySide2.QtCore.QReadLocker.__init__": ('PySide2.QtCore.QReadWriteLock',),
    "PySide2.QtCore.QReadLocker.__enter__": (),
    "PySide2.QtCore.QReadLocker.__exit__": ('object', 'object', 'object'),
    "PySide2.QtCore.QReadLocker.readWriteLock": (),
    "PySide2.QtCore.QReadLocker.relock": (),
    "PySide2.QtCore.QReadLocker.unlock": (),

# class PySide2.QtCore.QReadWriteLock:

# class PySide2.QtCore.QReadWriteLock.RecursionMode:
    "PySide2.QtCore.QReadWriteLock.__init__": ('PySide2.QtCore.QReadWriteLock.RecursionMode',),
    "PySide2.QtCore.QReadWriteLock.lockForRead": (),
    "PySide2.QtCore.QReadWriteLock.lockForWrite": (),
    "PySide2.QtCore.QReadWriteLock.tryLockForRead": [(), ('int',)],
    "PySide2.QtCore.QReadWriteLock.tryLockForWrite": [(), ('int',)],
    "PySide2.QtCore.QReadWriteLock.unlock": (),

# class PySide2.QtCore.QRect:
    "PySide2.QtCore.QRect.__init__": [(), ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'), ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QSize'), ('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtCore.QRect.__add__": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QRect.__and__": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.__copy__": (),
    "PySide2.QtCore.QRect.__iadd__": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QRect.__iand__": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.__ior__": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.__isub__": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QRect.__or__": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.__reduce__": (),
    "PySide2.QtCore.QRect.__repr__": (),
    "PySide2.QtCore.QRect.__sub__": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QRect.adjust": ('int', 'int', 'int', 'int'),
    "PySide2.QtCore.QRect.adjusted": ('int', 'int', 'int', 'int'),
    "PySide2.QtCore.QRect.bottom": (),
    "PySide2.QtCore.QRect.bottomLeft": (),
    "PySide2.QtCore.QRect.bottomRight": (),
    "PySide2.QtCore.QRect.center": (),
    "PySide2.QtCore.QRect.contains": [('PySide2.QtCore.QPoint', 'bool'), ('PySide2.QtCore.QRect', 'bool'), ('int', 'int'), ('int', 'int', 'bool')],
    "PySide2.QtCore.QRect.getCoords": (),
    "PySide2.QtCore.QRect.getRect": (),
    "PySide2.QtCore.QRect.height": (),
    "PySide2.QtCore.QRect.intersected": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.intersects": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.isEmpty": (),
    "PySide2.QtCore.QRect.isNull": (),
    "PySide2.QtCore.QRect.isValid": (),
    "PySide2.QtCore.QRect.left": (),
    "PySide2.QtCore.QRect.marginsAdded": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QRect.marginsRemoved": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QRect.moveBottom": ('int',),
    "PySide2.QtCore.QRect.moveBottomLeft": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.moveBottomRight": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.moveCenter": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.moveLeft": ('int',),
    "PySide2.QtCore.QRect.moveRight": ('int',),
    "PySide2.QtCore.QRect.moveTo": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtCore.QRect.moveTop": ('int',),
    "PySide2.QtCore.QRect.moveTopLeft": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.moveTopRight": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.normalized": (),
    "PySide2.QtCore.QRect.right": (),
    "PySide2.QtCore.QRect.setBottom": ('int',),
    "PySide2.QtCore.QRect.setBottomLeft": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.setBottomRight": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.setCoords": ('int', 'int', 'int', 'int'),
    "PySide2.QtCore.QRect.setHeight": ('int',),
    "PySide2.QtCore.QRect.setLeft": ('int',),
    "PySide2.QtCore.QRect.setRect": ('int', 'int', 'int', 'int'),
    "PySide2.QtCore.QRect.setRight": ('int',),
    "PySide2.QtCore.QRect.setSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QRect.setTop": ('int',),
    "PySide2.QtCore.QRect.setTopLeft": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.setTopRight": ('PySide2.QtCore.QPoint',),
    "PySide2.QtCore.QRect.setWidth": ('int',),
    "PySide2.QtCore.QRect.setX": ('int',),
    "PySide2.QtCore.QRect.setY": ('int',),
    "PySide2.QtCore.QRect.size": (),
    "PySide2.QtCore.QRect.top": (),
    "PySide2.QtCore.QRect.topLeft": (),
    "PySide2.QtCore.QRect.topRight": (),
    "PySide2.QtCore.QRect.translate": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtCore.QRect.translated": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtCore.QRect.transposed": (),
    "PySide2.QtCore.QRect.united": ('PySide2.QtCore.QRect',),
    "PySide2.QtCore.QRect.width": (),
    "PySide2.QtCore.QRect.x": (),
    "PySide2.QtCore.QRect.y": (),

# class PySide2.QtCore.QRectF:
    "PySide2.QtCore.QRectF.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QSizeF'), ('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtCore.QRectF.__add__": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QRectF.__and__": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.__copy__": (),
    "PySide2.QtCore.QRectF.__iadd__": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QRectF.__iand__": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.__ior__": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.__isub__": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QRectF.__or__": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.__reduce__": (),
    "PySide2.QtCore.QRectF.__repr__": (),
    "PySide2.QtCore.QRectF.__sub__": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QRectF.adjust": ('float', 'float', 'float', 'float'),
    "PySide2.QtCore.QRectF.adjusted": ('float', 'float', 'float', 'float'),
    "PySide2.QtCore.QRectF.bottom": (),
    "PySide2.QtCore.QRectF.bottomLeft": (),
    "PySide2.QtCore.QRectF.bottomRight": (),
    "PySide2.QtCore.QRectF.center": (),
    "PySide2.QtCore.QRectF.contains": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('float', 'float')],
    "PySide2.QtCore.QRectF.getCoords": (),
    "PySide2.QtCore.QRectF.getRect": (),
    "PySide2.QtCore.QRectF.height": (),
    "PySide2.QtCore.QRectF.intersected": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.intersects": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.isEmpty": (),
    "PySide2.QtCore.QRectF.isNull": (),
    "PySide2.QtCore.QRectF.isValid": (),
    "PySide2.QtCore.QRectF.left": (),
    "PySide2.QtCore.QRectF.marginsAdded": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QRectF.marginsRemoved": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QRectF.moveBottom": ('float',),
    "PySide2.QtCore.QRectF.moveBottomLeft": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.moveBottomRight": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.moveCenter": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.moveLeft": ('float',),
    "PySide2.QtCore.QRectF.moveRight": ('float',),
    "PySide2.QtCore.QRectF.moveTo": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtCore.QRectF.moveTop": ('float',),
    "PySide2.QtCore.QRectF.moveTopLeft": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.moveTopRight": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.normalized": (),
    "PySide2.QtCore.QRectF.right": (),
    "PySide2.QtCore.QRectF.setBottom": ('float',),
    "PySide2.QtCore.QRectF.setBottomLeft": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.setBottomRight": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.setCoords": ('float', 'float', 'float', 'float'),
    "PySide2.QtCore.QRectF.setHeight": ('float',),
    "PySide2.QtCore.QRectF.setLeft": ('float',),
    "PySide2.QtCore.QRectF.setRect": ('float', 'float', 'float', 'float'),
    "PySide2.QtCore.QRectF.setRight": ('float',),
    "PySide2.QtCore.QRectF.setSize": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QRectF.setTop": ('float',),
    "PySide2.QtCore.QRectF.setTopLeft": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.setTopRight": ('PySide2.QtCore.QPointF',),
    "PySide2.QtCore.QRectF.setWidth": ('float',),
    "PySide2.QtCore.QRectF.setX": ('float',),
    "PySide2.QtCore.QRectF.setY": ('float',),
    "PySide2.QtCore.QRectF.size": (),
    "PySide2.QtCore.QRectF.toAlignedRect": (),
    "PySide2.QtCore.QRectF.toRect": (),
    "PySide2.QtCore.QRectF.top": (),
    "PySide2.QtCore.QRectF.topLeft": (),
    "PySide2.QtCore.QRectF.topRight": (),
    "PySide2.QtCore.QRectF.translate": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtCore.QRectF.translated": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtCore.QRectF.transposed": (),
    "PySide2.QtCore.QRectF.united": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCore.QRectF.width": (),
    "PySide2.QtCore.QRectF.x": (),
    "PySide2.QtCore.QRectF.y": (),

# class PySide2.QtCore.QRecursiveMutex:
    "PySide2.QtCore.QRecursiveMutex.__init__": (),

# class PySide2.QtCore.QRegExp:

# class PySide2.QtCore.QRegExp.CaretMode:

# class PySide2.QtCore.QRegExp.PatternSyntax:
    "PySide2.QtCore.QRegExp.__init__": [(), ('PySide2.QtCore.QRegExp',), ('str', 'PySide2.QtCore.Qt.CaseSensitivity', 'PySide2.QtCore.QRegExp.PatternSyntax')],
    "PySide2.QtCore.QRegExp.__copy__": (),
    "PySide2.QtCore.QRegExp.__reduce__": (),
    "PySide2.QtCore.QRegExp.__repr__": (),
    "PySide2.QtCore.QRegExp.cap": ('int',),
    "PySide2.QtCore.QRegExp.captureCount": (),
    "PySide2.QtCore.QRegExp.capturedTexts": (),
    "PySide2.QtCore.QRegExp.caseSensitivity": (),
    "PySide2.QtCore.QRegExp.errorString": (),
    "PySide2.QtCore.QRegExp.escape": ('str',),
    "PySide2.QtCore.QRegExp.exactMatch": ('str',),
    "PySide2.QtCore.QRegExp.indexIn": ('str', 'int', 'PySide2.QtCore.QRegExp.CaretMode'),
    "PySide2.QtCore.QRegExp.isEmpty": (),
    "PySide2.QtCore.QRegExp.isMinimal": (),
    "PySide2.QtCore.QRegExp.isValid": (),
    "PySide2.QtCore.QRegExp.lastIndexIn": ('str', 'int', 'PySide2.QtCore.QRegExp.CaretMode'),
    "PySide2.QtCore.QRegExp.matchedLength": (),
    "PySide2.QtCore.QRegExp.pattern": (),
    "PySide2.QtCore.QRegExp.patternSyntax": (),
    "PySide2.QtCore.QRegExp.pos": ('int',),
    "PySide2.QtCore.QRegExp.replace": ('str', 'str'),
    "PySide2.QtCore.QRegExp.setCaseSensitivity": ('PySide2.QtCore.Qt.CaseSensitivity',),
    "PySide2.QtCore.QRegExp.setMinimal": ('bool',),
    "PySide2.QtCore.QRegExp.setPattern": ('str',),
    "PySide2.QtCore.QRegExp.setPatternSyntax": ('PySide2.QtCore.QRegExp.PatternSyntax',),
    "PySide2.QtCore.QRegExp.swap": ('PySide2.QtCore.QRegExp',),

# class PySide2.QtCore.QRegularExpression:

# class PySide2.QtCore.QRegularExpression.MatchOption:

# class PySide2.QtCore.QRegularExpression.MatchOptions:

# class PySide2.QtCore.QRegularExpression.MatchType:

# class PySide2.QtCore.QRegularExpression.PatternOption:

# class PySide2.QtCore.QRegularExpression.PatternOptions:
    "PySide2.QtCore.QRegularExpression.__init__": [(), ('PySide2.QtCore.QRegularExpression',), ('str', 'PySide2.QtCore.QRegularExpression.PatternOptions')],
    "PySide2.QtCore.QRegularExpression.__copy__": (),
    "PySide2.QtCore.QRegularExpression.anchoredPattern": ('str',),
    "PySide2.QtCore.QRegularExpression.captureCount": (),
    "PySide2.QtCore.QRegularExpression.errorString": (),
    "PySide2.QtCore.QRegularExpression.escape": ('str',),
    "PySide2.QtCore.QRegularExpression.globalMatch": ('str', 'int', 'PySide2.QtCore.QRegularExpression.MatchType', 'PySide2.QtCore.QRegularExpression.MatchOptions'),
    "PySide2.QtCore.QRegularExpression.isValid": (),
    "PySide2.QtCore.QRegularExpression.match": ('str', 'int', 'PySide2.QtCore.QRegularExpression.MatchType', 'PySide2.QtCore.QRegularExpression.MatchOptions'),
    "PySide2.QtCore.QRegularExpression.namedCaptureGroups": (),
    "PySide2.QtCore.QRegularExpression.optimize": (),
    "PySide2.QtCore.QRegularExpression.pattern": (),
    "PySide2.QtCore.QRegularExpression.patternErrorOffset": (),
    "PySide2.QtCore.QRegularExpression.patternOptions": (),
    "PySide2.QtCore.QRegularExpression.setPattern": ('str',),
    "PySide2.QtCore.QRegularExpression.setPatternOptions": ('PySide2.QtCore.QRegularExpression.PatternOptions',),
    "PySide2.QtCore.QRegularExpression.swap": ('PySide2.QtCore.QRegularExpression',),
    "PySide2.QtCore.QRegularExpression.wildcardToRegularExpression": ('str',),

# class PySide2.QtCore.QRegularExpressionMatch:
    "PySide2.QtCore.QRegularExpressionMatch.__init__": [(), ('PySide2.QtCore.QRegularExpressionMatch',)],
    "PySide2.QtCore.QRegularExpressionMatch.__copy__": (),
    "PySide2.QtCore.QRegularExpressionMatch.captured": [('int',), ('str',)],
    "PySide2.QtCore.QRegularExpressionMatch.capturedEnd": [('int',), ('str',)],
    "PySide2.QtCore.QRegularExpressionMatch.capturedLength": [('int',), ('str',)],
    "PySide2.QtCore.QRegularExpressionMatch.capturedRef": [('int',), ('str',)],
    "PySide2.QtCore.QRegularExpressionMatch.capturedStart": [('int',), ('str',)],
    "PySide2.QtCore.QRegularExpressionMatch.capturedTexts": (),
    "PySide2.QtCore.QRegularExpressionMatch.hasMatch": (),
    "PySide2.QtCore.QRegularExpressionMatch.hasPartialMatch": (),
    "PySide2.QtCore.QRegularExpressionMatch.isValid": (),
    "PySide2.QtCore.QRegularExpressionMatch.lastCapturedIndex": (),
    "PySide2.QtCore.QRegularExpressionMatch.matchOptions": (),
    "PySide2.QtCore.QRegularExpressionMatch.matchType": (),
    "PySide2.QtCore.QRegularExpressionMatch.regularExpression": (),
    "PySide2.QtCore.QRegularExpressionMatch.swap": ('PySide2.QtCore.QRegularExpressionMatch',),

# class PySide2.QtCore.QRegularExpressionMatchIterator:
    "PySide2.QtCore.QRegularExpressionMatchIterator.__init__": [(), ('PySide2.QtCore.QRegularExpressionMatchIterator',)],
    "PySide2.QtCore.QRegularExpressionMatchIterator.__copy__": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.hasNext": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.isValid": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.matchOptions": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.matchType": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.peekNext": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.regularExpression": (),
    "PySide2.QtCore.QRegularExpressionMatchIterator.swap": ('PySide2.QtCore.QRegularExpressionMatchIterator',),

# class PySide2.QtCore.QResource:

# class PySide2.QtCore.QResource.Compression:
    "PySide2.QtCore.QResource.__init__": ('str', 'PySide2.QtCore.QLocale'),
    "PySide2.QtCore.QResource.absoluteFilePath": (),
    "PySide2.QtCore.QResource.addSearchPath": ('str',),
    "PySide2.QtCore.QResource.children": (),
    "PySide2.QtCore.QResource.compressionAlgorithm": (),
    "PySide2.QtCore.QResource.data": (),
    "PySide2.QtCore.QResource.fileName": (),
    "PySide2.QtCore.QResource.isCompressed": (),
    "PySide2.QtCore.QResource.isDir": (),
    "PySide2.QtCore.QResource.isFile": (),
    "PySide2.QtCore.QResource.isValid": (),
    "PySide2.QtCore.QResource.lastModified": (),
    "PySide2.QtCore.QResource.locale": (),
    "PySide2.QtCore.QResource.registerResource": ('str', 'str'),
    "PySide2.QtCore.QResource.registerResourceData": ('str', 'str'),
    "PySide2.QtCore.QResource.searchPaths": (),
    "PySide2.QtCore.QResource.setFileName": ('str',),
    "PySide2.QtCore.QResource.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtCore.QResource.size": (),
    "PySide2.QtCore.QResource.unregisterResource": ('str', 'str'),
    "PySide2.QtCore.QResource.unregisterResourceData": ('str', 'str'),

# class PySide2.QtCore.QRunnable:
    "PySide2.QtCore.QRunnable.__init__": (),
    "PySide2.QtCore.QRunnable.autoDelete": (),
    "PySide2.QtCore.QRunnable.run": (),
    "PySide2.QtCore.QRunnable.setAutoDelete": ('bool',),

# class PySide2.QtCore.QSaveFile:
    "PySide2.QtCore.QSaveFile.__init__": [('PySide2.QtCore.QObject',), ('str',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QSaveFile.cancelWriting": (),
    "PySide2.QtCore.QSaveFile.close": (),
    "PySide2.QtCore.QSaveFile.commit": (),
    "PySide2.QtCore.QSaveFile.directWriteFallback": (),
    "PySide2.QtCore.QSaveFile.fileName": (),
    "PySide2.QtCore.QSaveFile.open": ('PySide2.QtCore.QIODevice.OpenMode',),
    "PySide2.QtCore.QSaveFile.setDirectWriteFallback": ('bool',),
    "PySide2.QtCore.QSaveFile.setFileName": ('str',),
    "PySide2.QtCore.QSaveFile.writeData": ('str', 'int'),

# class PySide2.QtCore.QSemaphore:
    "PySide2.QtCore.QSemaphore.__init__": ('int',),
    "PySide2.QtCore.QSemaphore.acquire": ('int',),
    "PySide2.QtCore.QSemaphore.available": (),
    "PySide2.QtCore.QSemaphore.release": ('int',),
    "PySide2.QtCore.QSemaphore.tryAcquire": [('int',), ('int', 'int')],

# class PySide2.QtCore.QSemaphoreReleaser:
    "PySide2.QtCore.QSemaphoreReleaser.__init__": [(), ('PySide2.QtCore.QSemaphore', 'int')],
    "PySide2.QtCore.QSemaphoreReleaser.cancel": (),
    "PySide2.QtCore.QSemaphoreReleaser.semaphore": (),
    "PySide2.QtCore.QSemaphoreReleaser.swap": ('PySide2.QtCore.QSemaphoreReleaser',),

# class PySide2.QtCore.QSequentialAnimationGroup:
    "PySide2.QtCore.QSequentialAnimationGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QSequentialAnimationGroup.addPause": ('int',),
    "PySide2.QtCore.QSequentialAnimationGroup.currentAnimation": (),
    "PySide2.QtCore.QSequentialAnimationGroup.duration": (),
    "PySide2.QtCore.QSequentialAnimationGroup.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QSequentialAnimationGroup.insertPause": ('int', 'int'),
    "PySide2.QtCore.QSequentialAnimationGroup.updateCurrentTime": ('int',),
    "PySide2.QtCore.QSequentialAnimationGroup.updateDirection": ('PySide2.QtCore.QAbstractAnimation.Direction',),
    "PySide2.QtCore.QSequentialAnimationGroup.updateState": ('PySide2.QtCore.QAbstractAnimation.State', 'PySide2.QtCore.QAbstractAnimation.State'),

# class PySide2.QtCore.QSettings:

# class PySide2.QtCore.QSettings.Format:

# class PySide2.QtCore.QSettings.Scope:

# class PySide2.QtCore.QSettings.Status:
    "PySide2.QtCore.QSettings.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QSettings.Format', 'PySide2.QtCore.QSettings.Scope', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QSettings.Scope', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QSettings.Scope', 'str', 'str', 'PySide2.QtCore.QObject'), ('str', 'PySide2.QtCore.QSettings.Format', 'PySide2.QtCore.QObject'), ('str', 'str', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QSettings.allKeys": (),
    "PySide2.QtCore.QSettings.applicationName": (),
    "PySide2.QtCore.QSettings.beginGroup": ('str',),
    "PySide2.QtCore.QSettings.beginReadArray": ('str',),
    "PySide2.QtCore.QSettings.beginWriteArray": ('str', 'int'),
    "PySide2.QtCore.QSettings.childGroups": (),
    "PySide2.QtCore.QSettings.childKeys": (),
    "PySide2.QtCore.QSettings.clear": (),
    "PySide2.QtCore.QSettings.contains": ('str',),
    "PySide2.QtCore.QSettings.defaultFormat": (),
    "PySide2.QtCore.QSettings.endArray": (),
    "PySide2.QtCore.QSettings.endGroup": (),
    "PySide2.QtCore.QSettings.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QSettings.fallbacksEnabled": (),
    "PySide2.QtCore.QSettings.fileName": (),
    "PySide2.QtCore.QSettings.format": (),
    "PySide2.QtCore.QSettings.group": (),
    "PySide2.QtCore.QSettings.iniCodec": (),
    "PySide2.QtCore.QSettings.isAtomicSyncRequired": (),
    "PySide2.QtCore.QSettings.isWritable": (),
    "PySide2.QtCore.QSettings.organizationName": (),
    "PySide2.QtCore.QSettings.remove": ('str',),
    "PySide2.QtCore.QSettings.scope": (),
    "PySide2.QtCore.QSettings.setArrayIndex": ('int',),
    "PySide2.QtCore.QSettings.setAtomicSyncRequired": ('bool',),
    "PySide2.QtCore.QSettings.setDefaultFormat": ('PySide2.QtCore.QSettings.Format',),
    "PySide2.QtCore.QSettings.setFallbacksEnabled": ('bool',),
    "PySide2.QtCore.QSettings.setIniCodec": [('PySide2.QtCore.QTextCodec',), ('str',)],
    "PySide2.QtCore.QSettings.setPath": ('PySide2.QtCore.QSettings.Format', 'PySide2.QtCore.QSettings.Scope', 'str'),
    "PySide2.QtCore.QSettings.setValue": ('str', 'typing.Any'),
    "PySide2.QtCore.QSettings.status": (),
    "PySide2.QtCore.QSettings.sync": (),
    "PySide2.QtCore.QSettings.value": ('str', 'typing.Any', 'object'),

# class PySide2.QtCore.QSignalBlocker:
    "PySide2.QtCore.QSignalBlocker.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QSignalBlocker.reblock": (),
    "PySide2.QtCore.QSignalBlocker.unblock": (),

# class PySide2.QtCore.QSignalMapper:
    "PySide2.QtCore.QSignalMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QSignalMapper.map": [(), ('PySide2.QtCore.QObject',)],
    "PySide2.QtCore.QSignalMapper.mapping": [('PySide2.QtCore.QObject',), ('int',), ('str',)],
    "PySide2.QtCore.QSignalMapper.removeMappings": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QSignalMapper.setMapping": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject', 'int'), ('PySide2.QtCore.QObject', 'str')],

# class PySide2.QtCore.QSignalTransition:
    "PySide2.QtCore.QSignalTransition.__init__": [('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QState'), ('PySide2.QtCore.QState',), ('object', 'PySide2.QtCore.QState')],
    "PySide2.QtCore.QSignalTransition.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QSignalTransition.eventTest": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QSignalTransition.onTransition": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QSignalTransition.senderObject": (),
    "PySide2.QtCore.QSignalTransition.setSenderObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QSignalTransition.setSignal": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QSignalTransition.signal": (),

# class PySide2.QtCore.QSize:
    "PySide2.QtCore.QSize.__init__": [(), ('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtCore.QSize.__add__": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QSize.__copy__": (),
    "PySide2.QtCore.QSize.__iadd__": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QSize.__imul__": ('float',),
    "PySide2.QtCore.QSize.__isub__": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QSize.__mul__": ('float',),
    "PySide2.QtCore.QSize.__reduce__": (),
    "PySide2.QtCore.QSize.__repr__": (),
    "PySide2.QtCore.QSize.__sub__": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QSize.boundedTo": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QSize.expandedTo": ('PySide2.QtCore.QSize',),
    "PySide2.QtCore.QSize.grownBy": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QSize.height": (),
    "PySide2.QtCore.QSize.isEmpty": (),
    "PySide2.QtCore.QSize.isNull": (),
    "PySide2.QtCore.QSize.isValid": (),
    "PySide2.QtCore.QSize.scale": [('PySide2.QtCore.QSize', 'PySide2.QtCore.Qt.AspectRatioMode'), ('int', 'int', 'PySide2.QtCore.Qt.AspectRatioMode')],
    "PySide2.QtCore.QSize.scaled": [('PySide2.QtCore.QSize', 'PySide2.QtCore.Qt.AspectRatioMode'), ('int', 'int', 'PySide2.QtCore.Qt.AspectRatioMode')],
    "PySide2.QtCore.QSize.setHeight": ('int',),
    "PySide2.QtCore.QSize.setWidth": ('int',),
    "PySide2.QtCore.QSize.shrunkBy": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCore.QSize.toTuple": (),
    "PySide2.QtCore.QSize.transpose": (),
    "PySide2.QtCore.QSize.transposed": (),
    "PySide2.QtCore.QSize.width": (),

# class PySide2.QtCore.QSizeF:
    "PySide2.QtCore.QSizeF.__init__": [(), ('PySide2.QtCore.QSize',), ('PySide2.QtCore.QSizeF',), ('float', 'float')],
    "PySide2.QtCore.QSizeF.__add__": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QSizeF.__copy__": (),
    "PySide2.QtCore.QSizeF.__iadd__": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QSizeF.__imul__": ('float',),
    "PySide2.QtCore.QSizeF.__isub__": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QSizeF.__mul__": ('float',),
    "PySide2.QtCore.QSizeF.__reduce__": (),
    "PySide2.QtCore.QSizeF.__repr__": (),
    "PySide2.QtCore.QSizeF.__sub__": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QSizeF.boundedTo": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QSizeF.expandedTo": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtCore.QSizeF.grownBy": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QSizeF.height": (),
    "PySide2.QtCore.QSizeF.isEmpty": (),
    "PySide2.QtCore.QSizeF.isNull": (),
    "PySide2.QtCore.QSizeF.isValid": (),
    "PySide2.QtCore.QSizeF.scale": [('PySide2.QtCore.QSizeF', 'PySide2.QtCore.Qt.AspectRatioMode'), ('float', 'float', 'PySide2.QtCore.Qt.AspectRatioMode')],
    "PySide2.QtCore.QSizeF.scaled": [('PySide2.QtCore.QSizeF', 'PySide2.QtCore.Qt.AspectRatioMode'), ('float', 'float', 'PySide2.QtCore.Qt.AspectRatioMode')],
    "PySide2.QtCore.QSizeF.setHeight": ('float',),
    "PySide2.QtCore.QSizeF.setWidth": ('float',),
    "PySide2.QtCore.QSizeF.shrunkBy": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtCore.QSizeF.toSize": (),
    "PySide2.QtCore.QSizeF.toTuple": (),
    "PySide2.QtCore.QSizeF.transpose": (),
    "PySide2.QtCore.QSizeF.transposed": (),
    "PySide2.QtCore.QSizeF.width": (),

# class PySide2.QtCore.QSocketNotifier:

# class PySide2.QtCore.QSocketNotifier.Type:
    "PySide2.QtCore.QSocketNotifier.__init__": [('int', 'PySide2.QtCore.QSocketNotifier.Type', 'PySide2.QtCore.QObject'), ('object', 'PySide2.QtCore.QSocketNotifier.Type', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QSocketNotifier.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QSocketNotifier.isEnabled": (),
    "PySide2.QtCore.QSocketNotifier.setEnabled": ('bool',),
    "PySide2.QtCore.QSocketNotifier.socket": (),
    "PySide2.QtCore.QSocketNotifier.type": (),

# class PySide2.QtCore.QSortFilterProxyModel:
    "PySide2.QtCore.QSortFilterProxyModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QSortFilterProxyModel.buddy": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.canFetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QSortFilterProxyModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.dynamicSortFilter": (),
    "PySide2.QtCore.QSortFilterProxyModel.fetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.filterAcceptsColumn": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.filterAcceptsRow": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.filterCaseSensitivity": (),
    "PySide2.QtCore.QSortFilterProxyModel.filterKeyColumn": (),
    "PySide2.QtCore.QSortFilterProxyModel.filterRegExp": (),
    "PySide2.QtCore.QSortFilterProxyModel.filterRegularExpression": (),
    "PySide2.QtCore.QSortFilterProxyModel.filterRole": (),
    "PySide2.QtCore.QSortFilterProxyModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtCore.QSortFilterProxyModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.insertColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.invalidate": (),
    "PySide2.QtCore.QSortFilterProxyModel.invalidateFilter": (),
    "PySide2.QtCore.QSortFilterProxyModel.isRecursiveFilteringEnabled": (),
    "PySide2.QtCore.QSortFilterProxyModel.isSortLocaleAware": (),
    "PySide2.QtCore.QSortFilterProxyModel.lessThan": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.mapFromSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.mapSelectionFromSource": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtCore.QSortFilterProxyModel.mapSelectionToSource": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtCore.QSortFilterProxyModel.mapToSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.match": ('PySide2.QtCore.QModelIndex', 'int', 'typing.Any', 'int', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtCore.QSortFilterProxyModel.mimeData": ('typing.List[int]',),
    "PySide2.QtCore.QSortFilterProxyModel.mimeTypes": (),
    "PySide2.QtCore.QSortFilterProxyModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QSortFilterProxyModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtCore.QSortFilterProxyModel.setDynamicSortFilter": ('bool',),
    "PySide2.QtCore.QSortFilterProxyModel.setFilterCaseSensitivity": ('PySide2.QtCore.Qt.CaseSensitivity',),
    "PySide2.QtCore.QSortFilterProxyModel.setFilterFixedString": ('str',),
    "PySide2.QtCore.QSortFilterProxyModel.setFilterKeyColumn": ('int',),
    "PySide2.QtCore.QSortFilterProxyModel.setFilterRegExp": [('PySide2.QtCore.QRegExp',), ('str',)],
    "PySide2.QtCore.QSortFilterProxyModel.setFilterRegularExpression": [('PySide2.QtCore.QRegularExpression',), ('str',)],
    "PySide2.QtCore.QSortFilterProxyModel.setFilterRole": ('int',),
    "PySide2.QtCore.QSortFilterProxyModel.setFilterWildcard": ('str',),
    "PySide2.QtCore.QSortFilterProxyModel.setHeaderData": ('int', 'PySide2.QtCore.Qt.Orientation', 'typing.Any', 'int'),
    "PySide2.QtCore.QSortFilterProxyModel.setRecursiveFilteringEnabled": ('bool',),
    "PySide2.QtCore.QSortFilterProxyModel.setSortCaseSensitivity": ('PySide2.QtCore.Qt.CaseSensitivity',),
    "PySide2.QtCore.QSortFilterProxyModel.setSortLocaleAware": ('bool',),
    "PySide2.QtCore.QSortFilterProxyModel.setSortRole": ('int',),
    "PySide2.QtCore.QSortFilterProxyModel.setSourceModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCore.QSortFilterProxyModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QSortFilterProxyModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtCore.QSortFilterProxyModel.sortCaseSensitivity": (),
    "PySide2.QtCore.QSortFilterProxyModel.sortColumn": (),
    "PySide2.QtCore.QSortFilterProxyModel.sortOrder": (),
    "PySide2.QtCore.QSortFilterProxyModel.sortRole": (),
    "PySide2.QtCore.QSortFilterProxyModel.span": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QSortFilterProxyModel.supportedDropActions": (),

# class PySide2.QtCore.QStandardPaths:

# class PySide2.QtCore.QStandardPaths.LocateOption:

# class PySide2.QtCore.QStandardPaths.LocateOptions:

# class PySide2.QtCore.QStandardPaths.StandardLocation:
    "PySide2.QtCore.QStandardPaths.displayName": ('PySide2.QtCore.QStandardPaths.StandardLocation',),
    "PySide2.QtCore.QStandardPaths.enableTestMode": ('bool',),
    "PySide2.QtCore.QStandardPaths.findExecutable": ('str', 'typing.Sequence[str]'),
    "PySide2.QtCore.QStandardPaths.isTestModeEnabled": (),
    "PySide2.QtCore.QStandardPaths.locate": ('PySide2.QtCore.QStandardPaths.StandardLocation', 'str', 'PySide2.QtCore.QStandardPaths.LocateOptions'),
    "PySide2.QtCore.QStandardPaths.locateAll": ('PySide2.QtCore.QStandardPaths.StandardLocation', 'str', 'PySide2.QtCore.QStandardPaths.LocateOptions'),
    "PySide2.QtCore.QStandardPaths.setTestModeEnabled": ('bool',),
    "PySide2.QtCore.QStandardPaths.standardLocations": ('PySide2.QtCore.QStandardPaths.StandardLocation',),
    "PySide2.QtCore.QStandardPaths.writableLocation": ('PySide2.QtCore.QStandardPaths.StandardLocation',),

# class PySide2.QtCore.QState:

# class PySide2.QtCore.QState.ChildMode:

# class PySide2.QtCore.QState.RestorePolicy:
    "PySide2.QtCore.QState.__init__": [('PySide2.QtCore.QState',), ('PySide2.QtCore.QState.ChildMode', 'PySide2.QtCore.QState')],
    "PySide2.QtCore.QState.addTransition": [('PySide2.QtCore.QAbstractState',), ('PySide2.QtCore.QAbstractTransition',), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QAbstractState'), ('object', 'PySide2.QtCore.QAbstractState')],
    "PySide2.QtCore.QState.assignProperty": ('PySide2.QtCore.QObject', 'str', 'typing.Any'),
    "PySide2.QtCore.QState.childMode": (),
    "PySide2.QtCore.QState.errorState": (),
    "PySide2.QtCore.QState.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QState.initialState": (),
    "PySide2.QtCore.QState.onEntry": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QState.onExit": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QState.removeTransition": ('PySide2.QtCore.QAbstractTransition',),
    "PySide2.QtCore.QState.setChildMode": ('PySide2.QtCore.QState.ChildMode',),
    "PySide2.QtCore.QState.setErrorState": ('PySide2.QtCore.QAbstractState',),
    "PySide2.QtCore.QState.setInitialState": ('PySide2.QtCore.QAbstractState',),
    "PySide2.QtCore.QState.transitions": (),

# class PySide2.QtCore.QStateMachine:

# class PySide2.QtCore.QStateMachine.Error:

# class PySide2.QtCore.QStateMachine.EventPriority:

# class PySide2.QtCore.QStateMachine.SignalEvent:
    "PySide2.QtCore.QStateMachine.SignalEvent.__init__": [('PySide2.QtCore.QObject', 'int', 'typing.Sequence[typing.Any]'), ('PySide2.QtCore.QStateMachine.SignalEvent',)],
    "PySide2.QtCore.QStateMachine.SignalEvent.__copy__": (),
    "PySide2.QtCore.QStateMachine.SignalEvent.arguments": (),
    "PySide2.QtCore.QStateMachine.SignalEvent.sender": (),
    "PySide2.QtCore.QStateMachine.SignalEvent.signalIndex": (),

# class PySide2.QtCore.QStateMachine.WrappedEvent:
    "PySide2.QtCore.QStateMachine.WrappedEvent.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'), ('PySide2.QtCore.QStateMachine.WrappedEvent',)],
    "PySide2.QtCore.QStateMachine.WrappedEvent.__copy__": (),
    "PySide2.QtCore.QStateMachine.WrappedEvent.event": (),
    "PySide2.QtCore.QStateMachine.WrappedEvent.object": (),

    "PySide2.QtCore.QStateMachine.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QState.ChildMode', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QStateMachine.addDefaultAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QStateMachine.addState": ('PySide2.QtCore.QAbstractState',),
    "PySide2.QtCore.QStateMachine.beginMicrostep": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.beginSelectTransitions": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.cancelDelayedEvent": ('int',),
    "PySide2.QtCore.QStateMachine.clearError": (),
    "PySide2.QtCore.QStateMachine.configuration": (),
    "PySide2.QtCore.QStateMachine.defaultAnimations": (),
    "PySide2.QtCore.QStateMachine.endMicrostep": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.endSelectTransitions": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.error": (),
    "PySide2.QtCore.QStateMachine.errorString": (),
    "PySide2.QtCore.QStateMachine.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtCore.QStateMachine.globalRestorePolicy": (),
    "PySide2.QtCore.QStateMachine.isAnimated": (),
    "PySide2.QtCore.QStateMachine.isRunning": (),
    "PySide2.QtCore.QStateMachine.onEntry": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.onExit": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QStateMachine.postDelayedEvent": ('PySide2.QtCore.QEvent', 'int'),
    "PySide2.QtCore.QStateMachine.postEvent": ('PySide2.QtCore.QEvent', 'PySide2.QtCore.QStateMachine.EventPriority'),
    "PySide2.QtCore.QStateMachine.removeDefaultAnimation": ('PySide2.QtCore.QAbstractAnimation',),
    "PySide2.QtCore.QStateMachine.removeState": ('PySide2.QtCore.QAbstractState',),
    "PySide2.QtCore.QStateMachine.setAnimated": ('bool',),
    "PySide2.QtCore.QStateMachine.setGlobalRestorePolicy": ('PySide2.QtCore.QState.RestorePolicy',),
    "PySide2.QtCore.QStateMachine.setRunning": ('bool',),
    "PySide2.QtCore.QStateMachine.start": (),
    "PySide2.QtCore.QStateMachine.stop": (),

# class PySide2.QtCore.QStorageInfo:
    "PySide2.QtCore.QStorageInfo.__init__": [(), ('PySide2.QtCore.QDir',), ('PySide2.QtCore.QStorageInfo',), ('str',)],
    "PySide2.QtCore.QStorageInfo.__copy__": (),
    "PySide2.QtCore.QStorageInfo.blockSize": (),
    "PySide2.QtCore.QStorageInfo.bytesAvailable": (),
    "PySide2.QtCore.QStorageInfo.bytesFree": (),
    "PySide2.QtCore.QStorageInfo.bytesTotal": (),
    "PySide2.QtCore.QStorageInfo.device": (),
    "PySide2.QtCore.QStorageInfo.displayName": (),
    "PySide2.QtCore.QStorageInfo.fileSystemType": (),
    "PySide2.QtCore.QStorageInfo.isReadOnly": (),
    "PySide2.QtCore.QStorageInfo.isReady": (),
    "PySide2.QtCore.QStorageInfo.isRoot": (),
    "PySide2.QtCore.QStorageInfo.isValid": (),
    "PySide2.QtCore.QStorageInfo.mountedVolumes": (),
    "PySide2.QtCore.QStorageInfo.name": (),
    "PySide2.QtCore.QStorageInfo.refresh": (),
    "PySide2.QtCore.QStorageInfo.root": (),
    "PySide2.QtCore.QStorageInfo.rootPath": (),
    "PySide2.QtCore.QStorageInfo.setPath": ('str',),
    "PySide2.QtCore.QStorageInfo.subvolume": (),
    "PySide2.QtCore.QStorageInfo.swap": ('PySide2.QtCore.QStorageInfo',),

# class PySide2.QtCore.QStringListModel:
    "PySide2.QtCore.QStringListModel.__init__": [('PySide2.QtCore.QObject',), ('typing.Sequence[str]', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QStringListModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QStringListModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QStringListModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QStringListModel.itemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QStringListModel.moveRows": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QStringListModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QStringListModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QStringListModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtCore.QStringListModel.setItemData": ('PySide2.QtCore.QModelIndex', 'typing.Dict[int, typing.Any]'),
    "PySide2.QtCore.QStringListModel.setStringList": ('typing.Sequence[str]',),
    "PySide2.QtCore.QStringListModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QStringListModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtCore.QStringListModel.stringList": (),
    "PySide2.QtCore.QStringListModel.supportedDropActions": (),

# class PySide2.QtCore.QSysInfo:

# class PySide2.QtCore.QSysInfo.Endian:

# class PySide2.QtCore.QSysInfo.MacVersion:

# class PySide2.QtCore.QSysInfo.Sizes:
    "PySide2.QtCore.QSysInfo.__init__": (),
    "PySide2.QtCore.QSysInfo.bootUniqueId": (),
    "PySide2.QtCore.QSysInfo.buildAbi": (),
    "PySide2.QtCore.QSysInfo.buildCpuArchitecture": (),
    "PySide2.QtCore.QSysInfo.currentCpuArchitecture": (),
    "PySide2.QtCore.QSysInfo.kernelType": (),
    "PySide2.QtCore.QSysInfo.kernelVersion": (),
    "PySide2.QtCore.QSysInfo.macVersion": (),
    "PySide2.QtCore.QSysInfo.machineHostName": (),
    "PySide2.QtCore.QSysInfo.machineUniqueId": (),
    "PySide2.QtCore.QSysInfo.prettyProductName": (),
    "PySide2.QtCore.QSysInfo.productType": (),
    "PySide2.QtCore.QSysInfo.productVersion": (),

# class PySide2.QtCore.QSystemSemaphore:

# class PySide2.QtCore.QSystemSemaphore.AccessMode:

# class PySide2.QtCore.QSystemSemaphore.SystemSemaphoreError:
    "PySide2.QtCore.QSystemSemaphore.__init__": ('str', 'int', 'PySide2.QtCore.QSystemSemaphore.AccessMode'),
    "PySide2.QtCore.QSystemSemaphore.acquire": (),
    "PySide2.QtCore.QSystemSemaphore.error": (),
    "PySide2.QtCore.QSystemSemaphore.errorString": (),
    "PySide2.QtCore.QSystemSemaphore.key": (),
    "PySide2.QtCore.QSystemSemaphore.release": ('int',),
    "PySide2.QtCore.QSystemSemaphore.setKey": ('str', 'int', 'PySide2.QtCore.QSystemSemaphore.AccessMode'),

# class PySide2.QtCore.QTemporaryDir:
    "PySide2.QtCore.QTemporaryDir.__init__": [(), ('str',)],
    "PySide2.QtCore.QTemporaryDir.autoRemove": (),
    "PySide2.QtCore.QTemporaryDir.errorString": (),
    "PySide2.QtCore.QTemporaryDir.filePath": ('str',),
    "PySide2.QtCore.QTemporaryDir.isValid": (),
    "PySide2.QtCore.QTemporaryDir.path": (),
    "PySide2.QtCore.QTemporaryDir.remove": (),
    "PySide2.QtCore.QTemporaryDir.setAutoRemove": ('bool',),

# class PySide2.QtCore.QTemporaryFile:
    "PySide2.QtCore.QTemporaryFile.__init__": [(), ('PySide2.QtCore.QObject',), ('str',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtCore.QTemporaryFile.autoRemove": (),
    "PySide2.QtCore.QTemporaryFile.createLocalFile": [('PySide2.QtCore.QFile',), ('str',)],
    "PySide2.QtCore.QTemporaryFile.createNativeFile": [('PySide2.QtCore.QFile',), ('str',)],
    "PySide2.QtCore.QTemporaryFile.fileName": (),
    "PySide2.QtCore.QTemporaryFile.fileTemplate": (),
    "PySide2.QtCore.QTemporaryFile.open": [(), ('PySide2.QtCore.QIODevice.OpenMode',)],
    "PySide2.QtCore.QTemporaryFile.rename": ('str',),
    "PySide2.QtCore.QTemporaryFile.setAutoRemove": ('bool',),
    "PySide2.QtCore.QTemporaryFile.setFileTemplate": ('str',),

# class PySide2.QtCore.QTextBoundaryFinder:

# class PySide2.QtCore.QTextBoundaryFinder.BoundaryReason:

# class PySide2.QtCore.QTextBoundaryFinder.BoundaryReasons:

# class PySide2.QtCore.QTextBoundaryFinder.BoundaryType:
    "PySide2.QtCore.QTextBoundaryFinder.__init__": [(), ('PySide2.QtCore.QTextBoundaryFinder',), ('PySide2.QtCore.QTextBoundaryFinder.BoundaryType', 'str')],
    "PySide2.QtCore.QTextBoundaryFinder.__copy__": (),
    "PySide2.QtCore.QTextBoundaryFinder.boundaryReasons": (),
    "PySide2.QtCore.QTextBoundaryFinder.isAtBoundary": (),
    "PySide2.QtCore.QTextBoundaryFinder.isValid": (),
    "PySide2.QtCore.QTextBoundaryFinder.position": (),
    "PySide2.QtCore.QTextBoundaryFinder.setPosition": ('int',),
    "PySide2.QtCore.QTextBoundaryFinder.string": (),
    "PySide2.QtCore.QTextBoundaryFinder.toEnd": (),
    "PySide2.QtCore.QTextBoundaryFinder.toNextBoundary": (),
    "PySide2.QtCore.QTextBoundaryFinder.toPreviousBoundary": (),
    "PySide2.QtCore.QTextBoundaryFinder.toStart": (),
    "PySide2.QtCore.QTextBoundaryFinder.type": (),

# class PySide2.QtCore.QTextCodec:

# class PySide2.QtCore.QTextCodec.ConversionFlag:

# class PySide2.QtCore.QTextCodec.ConversionFlags:

# class PySide2.QtCore.QTextCodec.ConverterState:
    "PySide2.QtCore.QTextCodec.ConverterState.__init__": ('PySide2.QtCore.QTextCodec.ConversionFlags',),

    "PySide2.QtCore.QTextCodec.__init__": (),
    "PySide2.QtCore.QTextCodec.aliases": (),
    "PySide2.QtCore.QTextCodec.availableCodecs": (),
    "PySide2.QtCore.QTextCodec.availableMibs": (),
    "PySide2.QtCore.QTextCodec.canEncode": [('str',), ('typing.Char',)],
    "PySide2.QtCore.QTextCodec.codecForHtml": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QTextCodec')],
    "PySide2.QtCore.QTextCodec.codecForLocale": (),
    "PySide2.QtCore.QTextCodec.codecForMib": ('int',),
    "PySide2.QtCore.QTextCodec.codecForName": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtCore.QTextCodec.codecForUtfText": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QTextCodec')],
    "PySide2.QtCore.QTextCodec.convertToUnicode": ('str', 'int', 'PySide2.QtCore.QTextCodec.ConverterState'),
    "PySide2.QtCore.QTextCodec.fromUnicode": ('str',),
    "PySide2.QtCore.QTextCodec.makeDecoder": ('PySide2.QtCore.QTextCodec.ConversionFlags',),
    "PySide2.QtCore.QTextCodec.makeEncoder": ('PySide2.QtCore.QTextCodec.ConversionFlags',),
    "PySide2.QtCore.QTextCodec.mibEnum": (),
    "PySide2.QtCore.QTextCodec.name": (),
    "PySide2.QtCore.QTextCodec.setCodecForLocale": ('PySide2.QtCore.QTextCodec',),
    "PySide2.QtCore.QTextCodec.toUnicode": [('PySide2.QtCore.QByteArray',), ('str',), ('str', 'int', 'PySide2.QtCore.QTextCodec.ConverterState')],

# class PySide2.QtCore.QTextDecoder:
    "PySide2.QtCore.QTextDecoder.__init__": [('PySide2.QtCore.QTextCodec',), ('PySide2.QtCore.QTextCodec', 'PySide2.QtCore.QTextCodec.ConversionFlags')],
    "PySide2.QtCore.QTextDecoder.hasFailure": (),
    "PySide2.QtCore.QTextDecoder.needsMoreData": (),
    "PySide2.QtCore.QTextDecoder.toUnicode": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtCore.QTextEncoder:
    "PySide2.QtCore.QTextEncoder.__init__": [('PySide2.QtCore.QTextCodec',), ('PySide2.QtCore.QTextCodec', 'PySide2.QtCore.QTextCodec.ConversionFlags')],
    "PySide2.QtCore.QTextEncoder.fromUnicode": ('str',),
    "PySide2.QtCore.QTextEncoder.hasFailure": (),

# class PySide2.QtCore.QTextStream:

# class PySide2.QtCore.QTextStream.FieldAlignment:

# class PySide2.QtCore.QTextStream.NumberFlag:

# class PySide2.QtCore.QTextStream.NumberFlags:

# class PySide2.QtCore.QTextStream.RealNumberNotation:

# class PySide2.QtCore.QTextStream.Status:
    "PySide2.QtCore.QTextStream.__init__": [(), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QIODevice.OpenMode'), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtCore.QTextStream.__lshift__": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QTextStreamManipulator',), ('float',), ('int',), ('str',), ('typing.Char',)],
    "PySide2.QtCore.QTextStream.__rshift__": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QTextStream.atEnd": (),
    "PySide2.QtCore.QTextStream.autoDetectUnicode": (),
    "PySide2.QtCore.QTextStream.codec": (),
    "PySide2.QtCore.QTextStream.device": (),
    "PySide2.QtCore.QTextStream.fieldAlignment": (),
    "PySide2.QtCore.QTextStream.fieldWidth": (),
    "PySide2.QtCore.QTextStream.flush": (),
    "PySide2.QtCore.QTextStream.generateByteOrderMark": (),
    "PySide2.QtCore.QTextStream.integerBase": (),
    "PySide2.QtCore.QTextStream.locale": (),
    "PySide2.QtCore.QTextStream.numberFlags": (),
    "PySide2.QtCore.QTextStream.padChar": (),
    "PySide2.QtCore.QTextStream.pos": (),
    "PySide2.QtCore.QTextStream.read": ('int',),
    "PySide2.QtCore.QTextStream.readAll": (),
    "PySide2.QtCore.QTextStream.readLine": ('int',),
    "PySide2.QtCore.QTextStream.realNumberNotation": (),
    "PySide2.QtCore.QTextStream.realNumberPrecision": (),
    "PySide2.QtCore.QTextStream.reset": (),
    "PySide2.QtCore.QTextStream.resetStatus": (),
    "PySide2.QtCore.QTextStream.seek": ('int',),
    "PySide2.QtCore.QTextStream.setAutoDetectUnicode": ('bool',),
    "PySide2.QtCore.QTextStream.setCodec": [('PySide2.QtCore.QTextCodec',), ('str',)],
    "PySide2.QtCore.QTextStream.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtCore.QTextStream.setFieldAlignment": ('PySide2.QtCore.QTextStream.FieldAlignment',),
    "PySide2.QtCore.QTextStream.setFieldWidth": ('int',),
    "PySide2.QtCore.QTextStream.setGenerateByteOrderMark": ('bool',),
    "PySide2.QtCore.QTextStream.setIntegerBase": ('int',),
    "PySide2.QtCore.QTextStream.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtCore.QTextStream.setNumberFlags": ('PySide2.QtCore.QTextStream.NumberFlags',),
    "PySide2.QtCore.QTextStream.setPadChar": ('typing.Char',),
    "PySide2.QtCore.QTextStream.setRealNumberNotation": ('PySide2.QtCore.QTextStream.RealNumberNotation',),
    "PySide2.QtCore.QTextStream.setRealNumberPrecision": ('int',),
    "PySide2.QtCore.QTextStream.setStatus": ('PySide2.QtCore.QTextStream.Status',),
    "PySide2.QtCore.QTextStream.skipWhiteSpace": (),
    "PySide2.QtCore.QTextStream.status": (),
    "PySide2.QtCore.QTextStream.string": (),

# class PySide2.QtCore.QTextStreamManipulator:
    "PySide2.QtCore.QTextStreamManipulator.__copy__": (),
    "PySide2.QtCore.QTextStreamManipulator.exec_": ('PySide2.QtCore.QTextStream',),

# class PySide2.QtCore.QThread:

# class PySide2.QtCore.QThread.Priority:
    "PySide2.QtCore.QThread.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QThread.currentThread": (),
    "PySide2.QtCore.QThread.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QThread.eventDispatcher": (),
    "PySide2.QtCore.QThread.exec_": (),
    "PySide2.QtCore.QThread.exit": ('int',),
    "PySide2.QtCore.QThread.idealThreadCount": (),
    "PySide2.QtCore.QThread.isFinished": (),
    "PySide2.QtCore.QThread.isInterruptionRequested": (),
    "PySide2.QtCore.QThread.isRunning": (),
    "PySide2.QtCore.QThread.loopLevel": (),
    "PySide2.QtCore.QThread.msleep": ('int',),
    "PySide2.QtCore.QThread.priority": (),
    "PySide2.QtCore.QThread.quit": (),
    "PySide2.QtCore.QThread.requestInterruption": (),
    "PySide2.QtCore.QThread.run": (),
    "PySide2.QtCore.QThread.setEventDispatcher": ('PySide2.QtCore.QAbstractEventDispatcher',),
    "PySide2.QtCore.QThread.setPriority": ('PySide2.QtCore.QThread.Priority',),
    "PySide2.QtCore.QThread.setStackSize": ('int',),
    "PySide2.QtCore.QThread.setTerminationEnabled": ('bool',),
    "PySide2.QtCore.QThread.sleep": ('int',),
    "PySide2.QtCore.QThread.stackSize": (),
    "PySide2.QtCore.QThread.start": ('PySide2.QtCore.QThread.Priority',),
    "PySide2.QtCore.QThread.terminate": (),
    "PySide2.QtCore.QThread.usleep": ('int',),
    "PySide2.QtCore.QThread.wait": ('int',),
    "PySide2.QtCore.QThread.yieldCurrentThread": (),

# class PySide2.QtCore.QThreadPool:
    "PySide2.QtCore.QThreadPool.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QThreadPool.activeThreadCount": (),
    "PySide2.QtCore.QThreadPool.cancel": ('PySide2.QtCore.QRunnable',),
    "PySide2.QtCore.QThreadPool.clear": (),
    "PySide2.QtCore.QThreadPool.expiryTimeout": (),
    "PySide2.QtCore.QThreadPool.globalInstance": (),
    "PySide2.QtCore.QThreadPool.maxThreadCount": (),
    "PySide2.QtCore.QThreadPool.releaseThread": (),
    "PySide2.QtCore.QThreadPool.reserveThread": (),
    "PySide2.QtCore.QThreadPool.setExpiryTimeout": ('int',),
    "PySide2.QtCore.QThreadPool.setMaxThreadCount": ('int',),
    "PySide2.QtCore.QThreadPool.setStackSize": ('int',),
    "PySide2.QtCore.QThreadPool.stackSize": (),
    "PySide2.QtCore.QThreadPool.start": ('PySide2.QtCore.QRunnable', 'int'),
    "PySide2.QtCore.QThreadPool.tryStart": ('PySide2.QtCore.QRunnable',),
    "PySide2.QtCore.QThreadPool.tryTake": ('PySide2.QtCore.QRunnable',),
    "PySide2.QtCore.QThreadPool.waitForDone": ('int',),

# class PySide2.QtCore.QTime:
    "PySide2.QtCore.QTime.__init__": [(), ('PySide2.QtCore.QTime',), ('int', 'int', 'int', 'int')],
    "PySide2.QtCore.QTime.__copy__": (),
    "PySide2.QtCore.QTime.__reduce__": (),
    "PySide2.QtCore.QTime.__repr__": (),
    "PySide2.QtCore.QTime.addMSecs": ('int',),
    "PySide2.QtCore.QTime.addSecs": ('int',),
    "PySide2.QtCore.QTime.currentTime": (),
    "PySide2.QtCore.QTime.elapsed": (),
    "PySide2.QtCore.QTime.fromMSecsSinceStartOfDay": ('int',),
    "PySide2.QtCore.QTime.fromString": [('str', 'PySide2.QtCore.Qt.DateFormat'), ('str', 'str')],
    "PySide2.QtCore.QTime.hour": (),
    "PySide2.QtCore.QTime.isNull": (),
    "PySide2.QtCore.QTime.isValid": [(), ('int', 'int', 'int', 'int')],
    "PySide2.QtCore.QTime.minute": (),
    "PySide2.QtCore.QTime.msec": (),
    "PySide2.QtCore.QTime.msecsSinceStartOfDay": (),
    "PySide2.QtCore.QTime.msecsTo": ('PySide2.QtCore.QTime',),
    "PySide2.QtCore.QTime.restart": (),
    "PySide2.QtCore.QTime.second": (),
    "PySide2.QtCore.QTime.secsTo": ('PySide2.QtCore.QTime',),
    "PySide2.QtCore.QTime.setHMS": ('int', 'int', 'int', 'int'),
    "PySide2.QtCore.QTime.start": (),
    "PySide2.QtCore.QTime.toPython": (),
    "PySide2.QtCore.QTime.toString": [('PySide2.QtCore.Qt.DateFormat',), ('str',)],

# class PySide2.QtCore.QTimeLine:

# class PySide2.QtCore.QTimeLine.CurveShape:

# class PySide2.QtCore.QTimeLine.Direction:

# class PySide2.QtCore.QTimeLine.State:
    "PySide2.QtCore.QTimeLine.__init__": ('int', 'PySide2.QtCore.QObject'),
    "PySide2.QtCore.QTimeLine.currentFrame": (),
    "PySide2.QtCore.QTimeLine.currentTime": (),
    "PySide2.QtCore.QTimeLine.currentValue": (),
    "PySide2.QtCore.QTimeLine.curveShape": (),
    "PySide2.QtCore.QTimeLine.direction": (),
    "PySide2.QtCore.QTimeLine.duration": (),
    "PySide2.QtCore.QTimeLine.easingCurve": (),
    "PySide2.QtCore.QTimeLine.endFrame": (),
    "PySide2.QtCore.QTimeLine.frameForTime": ('int',),
    "PySide2.QtCore.QTimeLine.loopCount": (),
    "PySide2.QtCore.QTimeLine.resume": (),
    "PySide2.QtCore.QTimeLine.setCurrentTime": ('int',),
    "PySide2.QtCore.QTimeLine.setCurveShape": ('PySide2.QtCore.QTimeLine.CurveShape',),
    "PySide2.QtCore.QTimeLine.setDirection": ('PySide2.QtCore.QTimeLine.Direction',),
    "PySide2.QtCore.QTimeLine.setDuration": ('int',),
    "PySide2.QtCore.QTimeLine.setEasingCurve": ('PySide2.QtCore.QEasingCurve',),
    "PySide2.QtCore.QTimeLine.setEndFrame": ('int',),
    "PySide2.QtCore.QTimeLine.setFrameRange": ('int', 'int'),
    "PySide2.QtCore.QTimeLine.setLoopCount": ('int',),
    "PySide2.QtCore.QTimeLine.setPaused": ('bool',),
    "PySide2.QtCore.QTimeLine.setStartFrame": ('int',),
    "PySide2.QtCore.QTimeLine.setUpdateInterval": ('int',),
    "PySide2.QtCore.QTimeLine.start": (),
    "PySide2.QtCore.QTimeLine.startFrame": (),
    "PySide2.QtCore.QTimeLine.state": (),
    "PySide2.QtCore.QTimeLine.stop": (),
    "PySide2.QtCore.QTimeLine.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtCore.QTimeLine.toggleDirection": (),
    "PySide2.QtCore.QTimeLine.updateInterval": (),
    "PySide2.QtCore.QTimeLine.valueForTime": ('int',),

# class PySide2.QtCore.QTimeZone:

# class PySide2.QtCore.QTimeZone.NameType:

# class PySide2.QtCore.QTimeZone.OffsetData:
    "PySide2.QtCore.QTimeZone.OffsetData.__init__": [(), ('PySide2.QtCore.QTimeZone.OffsetData',)],
    "PySide2.QtCore.QTimeZone.OffsetData.__copy__": (),

# class PySide2.QtCore.QTimeZone.TimeType:

    "PySide2.QtCore.QTimeZone.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'int', 'str', 'str', 'PySide2.QtCore.QLocale.Country', 'str'), ('PySide2.QtCore.QTimeZone',), ('int',)],
    "PySide2.QtCore.QTimeZone.__copy__": (),
    "PySide2.QtCore.QTimeZone.abbreviation": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.availableTimeZoneIds": [(), ('PySide2.QtCore.QLocale.Country',), ('int',)],
    "PySide2.QtCore.QTimeZone.comment": (),
    "PySide2.QtCore.QTimeZone.country": (),
    "PySide2.QtCore.QTimeZone.daylightTimeOffset": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.displayName": [('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QTimeZone.NameType', 'PySide2.QtCore.QLocale'), ('PySide2.QtCore.QTimeZone.TimeType', 'PySide2.QtCore.QTimeZone.NameType', 'PySide2.QtCore.QLocale')],
    "PySide2.QtCore.QTimeZone.hasDaylightTime": (),
    "PySide2.QtCore.QTimeZone.hasTransitions": (),
    "PySide2.QtCore.QTimeZone.ianaIdToWindowsId": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QTimeZone.id": (),
    "PySide2.QtCore.QTimeZone.isDaylightTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.isTimeZoneIdAvailable": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QTimeZone.isValid": (),
    "PySide2.QtCore.QTimeZone.nextTransition": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.offsetData": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.offsetFromUtc": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.previousTransition": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.standardTimeOffset": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtCore.QTimeZone.swap": ('PySide2.QtCore.QTimeZone',),
    "PySide2.QtCore.QTimeZone.systemTimeZone": (),
    "PySide2.QtCore.QTimeZone.systemTimeZoneId": (),
    "PySide2.QtCore.QTimeZone.transitions": ('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QDateTime'),
    "PySide2.QtCore.QTimeZone.utc": (),
    "PySide2.QtCore.QTimeZone.windowsIdToDefaultIanaId": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QLocale.Country')],
    "PySide2.QtCore.QTimeZone.windowsIdToIanaIds": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QLocale.Country')],

# class PySide2.QtCore.QTimer:
    "PySide2.QtCore.QTimer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QTimer.interval": (),
    "PySide2.QtCore.QTimer.isActive": (),
    "PySide2.QtCore.QTimer.isSingleShot": (),
    "PySide2.QtCore.QTimer.killTimer": ('int',),
    "PySide2.QtCore.QTimer.remainingTime": (),
    "PySide2.QtCore.QTimer.setInterval": ('int',),
    "PySide2.QtCore.QTimer.setSingleShot": ('bool',),
    "PySide2.QtCore.QTimer.setTimerType": ('PySide2.QtCore.Qt.TimerType',),
    "PySide2.QtCore.QTimer.singleShot": [('int', 'PySide2.QtCore.QObject', 'str'), ('int', 'PySide2.QtCore.Qt.TimerType', 'PySide2.QtCore.QObject', 'str'), ('int', 'typing.Callable')],
    "PySide2.QtCore.QTimer.start": [(), ('int',)],
    "PySide2.QtCore.QTimer.stop": (),
    "PySide2.QtCore.QTimer.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtCore.QTimer.timerId": (),
    "PySide2.QtCore.QTimer.timerType": (),

# class PySide2.QtCore.QTimerEvent:
    "PySide2.QtCore.QTimerEvent.__init__": ('int',),
    "PySide2.QtCore.QTimerEvent.timerId": (),

# class PySide2.QtCore.QTranslator:
    "PySide2.QtCore.QTranslator.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QTranslator.isEmpty": (),
    "PySide2.QtCore.QTranslator.load": [('PySide2.QtCore.QLocale', 'str', 'str', 'str', 'str'), ('str', 'int', 'str'), ('str', 'str', 'str', 'str')],
    "PySide2.QtCore.QTranslator.translate": ('str', 'str', 'str', 'int'),

# class PySide2.QtCore.QTransposeProxyModel:
    "PySide2.QtCore.QTransposeProxyModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QTransposeProxyModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QTransposeProxyModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtCore.QTransposeProxyModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QTransposeProxyModel.insertColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QTransposeProxyModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QTransposeProxyModel.itemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QTransposeProxyModel.mapFromSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QTransposeProxyModel.mapToSource": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QTransposeProxyModel.moveColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QTransposeProxyModel.moveRows": ('PySide2.QtCore.QModelIndex', 'int', 'int', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtCore.QTransposeProxyModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtCore.QTransposeProxyModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QTransposeProxyModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtCore.QTransposeProxyModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtCore.QTransposeProxyModel.setHeaderData": ('int', 'PySide2.QtCore.Qt.Orientation', 'typing.Any', 'int'),
    "PySide2.QtCore.QTransposeProxyModel.setItemData": ('PySide2.QtCore.QModelIndex', 'typing.Dict[int, typing.Any]'),
    "PySide2.QtCore.QTransposeProxyModel.setSourceModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCore.QTransposeProxyModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtCore.QTransposeProxyModel.span": ('PySide2.QtCore.QModelIndex',),

# class PySide2.QtCore.QUrl:

# class PySide2.QtCore.QUrl.ComponentFormattingOption:

# class PySide2.QtCore.QUrl.FormattingOptions:

# class PySide2.QtCore.QUrl.ParsingMode:

# class PySide2.QtCore.QUrl.UrlFormattingOption:

# class PySide2.QtCore.QUrl.UserInputResolutionOption:

# class PySide2.QtCore.QUrl.UserInputResolutionOptions:
    "PySide2.QtCore.QUrl.__init__": [(), ('PySide2.QtCore.QUrl',), ('str', 'PySide2.QtCore.QUrl.ParsingMode')],
    "PySide2.QtCore.QUrl.__copy__": (),
    "PySide2.QtCore.QUrl.__reduce__": (),
    "PySide2.QtCore.QUrl.__repr__": (),
    "PySide2.QtCore.QUrl.adjusted": ('PySide2.QtCore.QUrl.FormattingOptions',),
    "PySide2.QtCore.QUrl.authority": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.clear": (),
    "PySide2.QtCore.QUrl.errorString": (),
    "PySide2.QtCore.QUrl.fileName": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.fragment": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.fromAce": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QUrl.fromEncoded": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.fromLocalFile": ('str',),
    "PySide2.QtCore.QUrl.fromPercentEncoding": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QUrl.fromStringList": ('typing.Sequence[str]', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.fromUserInput": [('str',), ('str', 'str', 'PySide2.QtCore.QUrl.UserInputResolutionOptions')],
    "PySide2.QtCore.QUrl.hasFragment": (),
    "PySide2.QtCore.QUrl.hasQuery": (),
    "PySide2.QtCore.QUrl.host": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.idnWhitelist": (),
    "PySide2.QtCore.QUrl.isEmpty": (),
    "PySide2.QtCore.QUrl.isLocalFile": (),
    "PySide2.QtCore.QUrl.isParentOf": ('PySide2.QtCore.QUrl',),
    "PySide2.QtCore.QUrl.isRelative": (),
    "PySide2.QtCore.QUrl.isValid": (),
    "PySide2.QtCore.QUrl.matches": ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QUrl.FormattingOptions'),
    "PySide2.QtCore.QUrl.password": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.path": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.port": ('int',),
    "PySide2.QtCore.QUrl.query": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.resolved": ('PySide2.QtCore.QUrl',),
    "PySide2.QtCore.QUrl.scheme": (),
    "PySide2.QtCore.QUrl.setAuthority": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setFragment": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setHost": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setIdnWhitelist": ('typing.Sequence[str]',),
    "PySide2.QtCore.QUrl.setPassword": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setPath": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setPort": ('int',),
    "PySide2.QtCore.QUrl.setQuery": [('PySide2.QtCore.QUrlQuery',), ('str', 'PySide2.QtCore.QUrl.ParsingMode')],
    "PySide2.QtCore.QUrl.setScheme": ('str',),
    "PySide2.QtCore.QUrl.setUrl": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setUserInfo": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.setUserName": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtCore.QUrl.swap": ('PySide2.QtCore.QUrl',),
    "PySide2.QtCore.QUrl.toAce": ('str',),
    "PySide2.QtCore.QUrl.toDisplayString": ('PySide2.QtCore.QUrl.FormattingOptions',),
    "PySide2.QtCore.QUrl.toEncoded": ('PySide2.QtCore.QUrl.FormattingOptions',),
    "PySide2.QtCore.QUrl.toLocalFile": (),
    "PySide2.QtCore.QUrl.toPercentEncoding": ('str', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtCore.QUrl.toString": ('PySide2.QtCore.QUrl.FormattingOptions',),
    "PySide2.QtCore.QUrl.toStringList": ('typing.Sequence[PySide2.QtCore.QUrl]', 'PySide2.QtCore.QUrl.FormattingOptions'),
    "PySide2.QtCore.QUrl.topLevelDomain": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.url": ('PySide2.QtCore.QUrl.FormattingOptions',),
    "PySide2.QtCore.QUrl.userInfo": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrl.userName": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),

# class PySide2.QtCore.QUrlQuery:
    "PySide2.QtCore.QUrlQuery.__init__": [(), ('PySide2.QtCore.QUrl',), ('PySide2.QtCore.QUrlQuery',), ('str',)],
    "PySide2.QtCore.QUrlQuery.__copy__": (),
    "PySide2.QtCore.QUrlQuery.addQueryItem": ('str', 'str'),
    "PySide2.QtCore.QUrlQuery.allQueryItemValues": ('str', 'PySide2.QtCore.QUrl.ComponentFormattingOption'),
    "PySide2.QtCore.QUrlQuery.clear": (),
    "PySide2.QtCore.QUrlQuery.defaultQueryPairDelimiter": (),
    "PySide2.QtCore.QUrlQuery.defaultQueryValueDelimiter": (),
    "PySide2.QtCore.QUrlQuery.hasQueryItem": ('str',),
    "PySide2.QtCore.QUrlQuery.isEmpty": (),
    "PySide2.QtCore.QUrlQuery.query": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrlQuery.queryItemValue": ('str', 'PySide2.QtCore.QUrl.ComponentFormattingOption'),
    "PySide2.QtCore.QUrlQuery.queryItems": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtCore.QUrlQuery.queryPairDelimiter": (),
    "PySide2.QtCore.QUrlQuery.queryValueDelimiter": (),
    "PySide2.QtCore.QUrlQuery.removeAllQueryItems": ('str',),
    "PySide2.QtCore.QUrlQuery.removeQueryItem": ('str',),
    "PySide2.QtCore.QUrlQuery.setQuery": ('str',),
    "PySide2.QtCore.QUrlQuery.setQueryDelimiters": ('typing.Char', 'typing.Char'),
    "PySide2.QtCore.QUrlQuery.setQueryItems": ('typing.Sequence[typing.Tuple]',),
    "PySide2.QtCore.QUrlQuery.swap": ('PySide2.QtCore.QUrlQuery',),
    "PySide2.QtCore.QUrlQuery.toString": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),

# class PySide2.QtCore.QUuid:

# class PySide2.QtCore.QUuid.StringFormat:

# class PySide2.QtCore.QUuid.Variant:

# class PySide2.QtCore.QUuid.Version:
    "PySide2.QtCore.QUuid.__init__": [(), ('PySide2.QtCore.QByteArray',), ('int', 'int', 'int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'), ('str',)],
    "PySide2.QtCore.QUuid.__copy__": (),
    "PySide2.QtCore.QUuid.__reduce__": (),
    "PySide2.QtCore.QUuid.__repr__": (),
    "PySide2.QtCore.QUuid.createUuid": (),
    "PySide2.QtCore.QUuid.createUuidV3": [('PySide2.QtCore.QUuid', 'PySide2.QtCore.QByteArray'), ('PySide2.QtCore.QUuid', 'str')],
    "PySide2.QtCore.QUuid.createUuidV5": [('PySide2.QtCore.QUuid', 'PySide2.QtCore.QByteArray'), ('PySide2.QtCore.QUuid', 'str')],
    "PySide2.QtCore.QUuid.fromRfc4122": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtCore.QUuid.isNull": (),
    "PySide2.QtCore.QUuid.toByteArray": [(), ('PySide2.QtCore.QUuid.StringFormat',)],
    "PySide2.QtCore.QUuid.toRfc4122": (),
    "PySide2.QtCore.QUuid.toString": [(), ('PySide2.QtCore.QUuid.StringFormat',)],
    "PySide2.QtCore.QUuid.variant": (),
    "PySide2.QtCore.QUuid.version": (),

# class PySide2.QtCore.QVariantAnimation:
    "PySide2.QtCore.QVariantAnimation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCore.QVariantAnimation.currentValue": (),
    "PySide2.QtCore.QVariantAnimation.duration": (),
    "PySide2.QtCore.QVariantAnimation.easingCurve": (),
    "PySide2.QtCore.QVariantAnimation.endValue": (),
    "PySide2.QtCore.QVariantAnimation.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtCore.QVariantAnimation.interpolated": ('typing.Any', 'typing.Any', 'float'),
    "PySide2.QtCore.QVariantAnimation.keyValueAt": ('float',),
    "PySide2.QtCore.QVariantAnimation.keyValues": (),
    "PySide2.QtCore.QVariantAnimation.setDuration": ('int',),
    "PySide2.QtCore.QVariantAnimation.setEasingCurve": ('PySide2.QtCore.QEasingCurve',),
    "PySide2.QtCore.QVariantAnimation.setEndValue": ('typing.Any',),
    "PySide2.QtCore.QVariantAnimation.setKeyValueAt": ('float', 'typing.Any'),
    "PySide2.QtCore.QVariantAnimation.setKeyValues": ('typing.List[typing.Tuple]',),
    "PySide2.QtCore.QVariantAnimation.setStartValue": ('typing.Any',),
    "PySide2.QtCore.QVariantAnimation.startValue": (),
    "PySide2.QtCore.QVariantAnimation.updateCurrentTime": ('int',),
    "PySide2.QtCore.QVariantAnimation.updateCurrentValue": ('typing.Any',),
    "PySide2.QtCore.QVariantAnimation.updateState": ('PySide2.QtCore.QAbstractAnimation.State', 'PySide2.QtCore.QAbstractAnimation.State'),

# class PySide2.QtCore.QVersionNumber:
    "PySide2.QtCore.QVersionNumber.__init__": [(), ('int',), ('int', 'int'), ('int', 'int', 'int'), ('typing.List[int]',)],
    "PySide2.QtCore.QVersionNumber.__copy__": (),
    "PySide2.QtCore.QVersionNumber.commonPrefix": ('PySide2.QtCore.QVersionNumber', 'PySide2.QtCore.QVersionNumber'),
    "PySide2.QtCore.QVersionNumber.compare": ('PySide2.QtCore.QVersionNumber', 'PySide2.QtCore.QVersionNumber'),
    "PySide2.QtCore.QVersionNumber.fromString": ('str',),
    "PySide2.QtCore.QVersionNumber.isNormalized": (),
    "PySide2.QtCore.QVersionNumber.isNull": (),
    "PySide2.QtCore.QVersionNumber.isPrefixOf": ('PySide2.QtCore.QVersionNumber',),
    "PySide2.QtCore.QVersionNumber.majorVersion": (),
    "PySide2.QtCore.QVersionNumber.microVersion": (),
    "PySide2.QtCore.QVersionNumber.minorVersion": (),
    "PySide2.QtCore.QVersionNumber.normalized": (),
    "PySide2.QtCore.QVersionNumber.segmentAt": ('int',),
    "PySide2.QtCore.QVersionNumber.segmentCount": (),
    "PySide2.QtCore.QVersionNumber.segments": (),
    "PySide2.QtCore.QVersionNumber.toString": (),

# class PySide2.QtCore.QWaitCondition:
    "PySide2.QtCore.QWaitCondition.__init__": (),
    "PySide2.QtCore.QWaitCondition.notify_all": (),
    "PySide2.QtCore.QWaitCondition.notify_one": (),
    "PySide2.QtCore.QWaitCondition.wait": [('PySide2.QtCore.QMutex', 'int'), ('PySide2.QtCore.QReadWriteLock', 'int')],
    "PySide2.QtCore.QWaitCondition.wakeAll": (),
    "PySide2.QtCore.QWaitCondition.wakeOne": (),

# class PySide2.QtCore.QWriteLocker:
    "PySide2.QtCore.QWriteLocker.__init__": ('PySide2.QtCore.QReadWriteLock',),
    "PySide2.QtCore.QWriteLocker.__enter__": (),
    "PySide2.QtCore.QWriteLocker.__exit__": ('object', 'object', 'object'),
    "PySide2.QtCore.QWriteLocker.readWriteLock": (),
    "PySide2.QtCore.QWriteLocker.relock": (),
    "PySide2.QtCore.QWriteLocker.unlock": (),

# class PySide2.QtCore.QXmlStreamAttribute:
    "PySide2.QtCore.QXmlStreamAttribute.__init__": [(), ('PySide2.QtCore.QXmlStreamAttribute',), ('str', 'str'), ('str', 'str', 'str')],
    "PySide2.QtCore.QXmlStreamAttribute.__copy__": (),
    "PySide2.QtCore.QXmlStreamAttribute.isDefault": (),
    "PySide2.QtCore.QXmlStreamAttribute.name": (),
    "PySide2.QtCore.QXmlStreamAttribute.namespaceUri": (),
    "PySide2.QtCore.QXmlStreamAttribute.prefix": (),
    "PySide2.QtCore.QXmlStreamAttribute.qualifiedName": (),
    "PySide2.QtCore.QXmlStreamAttribute.value": (),

# class PySide2.QtCore.QXmlStreamAttributes:
    "PySide2.QtCore.QXmlStreamAttributes.__init__": [(), ('PySide2.QtCore.QXmlStreamAttributes',)],
    "PySide2.QtCore.QXmlStreamAttributes.__add__": ('typing.List[PySide2.QtCore.QXmlStreamAttribute]',),
    "PySide2.QtCore.QXmlStreamAttributes.__copy__": (),
    "PySide2.QtCore.QXmlStreamAttributes.__iadd__": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.__lshift__": [('PySide2.QtCore.QXmlStreamAttribute',), ('typing.List[PySide2.QtCore.QXmlStreamAttribute]',)],
    "PySide2.QtCore.QXmlStreamAttributes.append": [('str', 'str'), ('str', 'str', 'str')],
    "PySide2.QtCore.QXmlStreamAttributes.at": ('int',),
    "PySide2.QtCore.QXmlStreamAttributes.back": (),
    "PySide2.QtCore.QXmlStreamAttributes.capacity": (),
    "PySide2.QtCore.QXmlStreamAttributes.clear": (),
    "PySide2.QtCore.QXmlStreamAttributes.constData": (),
    "PySide2.QtCore.QXmlStreamAttributes.constFirst": (),
    "PySide2.QtCore.QXmlStreamAttributes.constLast": (),
    "PySide2.QtCore.QXmlStreamAttributes.contains": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.count": [(), ('PySide2.QtCore.QXmlStreamAttribute',)],
    "PySide2.QtCore.QXmlStreamAttributes.data": (),
    "PySide2.QtCore.QXmlStreamAttributes.empty": (),
    "PySide2.QtCore.QXmlStreamAttributes.endsWith": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.fill": ('PySide2.QtCore.QXmlStreamAttribute', 'int'),
    "PySide2.QtCore.QXmlStreamAttributes.first": (),
    "PySide2.QtCore.QXmlStreamAttributes.front": (),
    "PySide2.QtCore.QXmlStreamAttributes.hasAttribute": [('str',), ('str', 'str')],
    "PySide2.QtCore.QXmlStreamAttributes.indexOf": ('PySide2.QtCore.QXmlStreamAttribute', 'int'),
    "PySide2.QtCore.QXmlStreamAttributes.insert": [('int', 'PySide2.QtCore.QXmlStreamAttribute'), ('int', 'int', 'PySide2.QtCore.QXmlStreamAttribute')],
    "PySide2.QtCore.QXmlStreamAttributes.isEmpty": (),
    "PySide2.QtCore.QXmlStreamAttributes.isSharedWith": ('typing.List[PySide2.QtCore.QXmlStreamAttribute]',),
    "PySide2.QtCore.QXmlStreamAttributes.last": (),
    "PySide2.QtCore.QXmlStreamAttributes.lastIndexOf": ('PySide2.QtCore.QXmlStreamAttribute', 'int'),
    "PySide2.QtCore.QXmlStreamAttributes.length": (),
    "PySide2.QtCore.QXmlStreamAttributes.mid": ('int', 'int'),
    "PySide2.QtCore.QXmlStreamAttributes.move": ('int', 'int'),
    "PySide2.QtCore.QXmlStreamAttributes.prepend": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.remove": [('int',), ('int', 'int')],
    "PySide2.QtCore.QXmlStreamAttributes.removeAll": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.removeAt": ('int',),
    "PySide2.QtCore.QXmlStreamAttributes.removeFirst": (),
    "PySide2.QtCore.QXmlStreamAttributes.removeLast": (),
    "PySide2.QtCore.QXmlStreamAttributes.removeOne": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.replace": ('int', 'PySide2.QtCore.QXmlStreamAttribute'),
    "PySide2.QtCore.QXmlStreamAttributes.reserve": ('int',),
    "PySide2.QtCore.QXmlStreamAttributes.resize": ('int',),
    "PySide2.QtCore.QXmlStreamAttributes.setSharable": ('bool',),
    "PySide2.QtCore.QXmlStreamAttributes.shrink_to_fit": (),
    "PySide2.QtCore.QXmlStreamAttributes.size": (),
    "PySide2.QtCore.QXmlStreamAttributes.squeeze": (),
    "PySide2.QtCore.QXmlStreamAttributes.startsWith": ('PySide2.QtCore.QXmlStreamAttribute',),
    "PySide2.QtCore.QXmlStreamAttributes.swap": ('typing.List[PySide2.QtCore.QXmlStreamAttribute]',),
    "PySide2.QtCore.QXmlStreamAttributes.swapItemsAt": ('int', 'int'),
    "PySide2.QtCore.QXmlStreamAttributes.takeAt": ('int',),
    "PySide2.QtCore.QXmlStreamAttributes.takeFirst": (),
    "PySide2.QtCore.QXmlStreamAttributes.takeLast": (),
    "PySide2.QtCore.QXmlStreamAttributes.value": [('str',), ('str', 'str')],

# class PySide2.QtCore.QXmlStreamEntityDeclaration:
    "PySide2.QtCore.QXmlStreamEntityDeclaration.__init__": [(), ('PySide2.QtCore.QXmlStreamEntityDeclaration',)],
    "PySide2.QtCore.QXmlStreamEntityDeclaration.__copy__": (),
    "PySide2.QtCore.QXmlStreamEntityDeclaration.name": (),
    "PySide2.QtCore.QXmlStreamEntityDeclaration.notationName": (),
    "PySide2.QtCore.QXmlStreamEntityDeclaration.publicId": (),
    "PySide2.QtCore.QXmlStreamEntityDeclaration.systemId": (),
    "PySide2.QtCore.QXmlStreamEntityDeclaration.value": (),

# class PySide2.QtCore.QXmlStreamEntityResolver:
    "PySide2.QtCore.QXmlStreamEntityResolver.__init__": (),
    "PySide2.QtCore.QXmlStreamEntityResolver.resolveEntity": ('str', 'str'),
    "PySide2.QtCore.QXmlStreamEntityResolver.resolveUndeclaredEntity": ('str',),

# class PySide2.QtCore.QXmlStreamNamespaceDeclaration:
    "PySide2.QtCore.QXmlStreamNamespaceDeclaration.__init__": [(), ('PySide2.QtCore.QXmlStreamNamespaceDeclaration',), ('str', 'str')],
    "PySide2.QtCore.QXmlStreamNamespaceDeclaration.__copy__": (),
    "PySide2.QtCore.QXmlStreamNamespaceDeclaration.namespaceUri": (),
    "PySide2.QtCore.QXmlStreamNamespaceDeclaration.prefix": (),

# class PySide2.QtCore.QXmlStreamNotationDeclaration:
    "PySide2.QtCore.QXmlStreamNotationDeclaration.__init__": [(), ('PySide2.QtCore.QXmlStreamNotationDeclaration',)],
    "PySide2.QtCore.QXmlStreamNotationDeclaration.__copy__": (),
    "PySide2.QtCore.QXmlStreamNotationDeclaration.name": (),
    "PySide2.QtCore.QXmlStreamNotationDeclaration.publicId": (),
    "PySide2.QtCore.QXmlStreamNotationDeclaration.systemId": (),

# class PySide2.QtCore.QXmlStreamReader:

# class PySide2.QtCore.QXmlStreamReader.Error:

# class PySide2.QtCore.QXmlStreamReader.ReadElementTextBehaviour:

# class PySide2.QtCore.QXmlStreamReader.TokenType:
    "PySide2.QtCore.QXmlStreamReader.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',), ('str',)],
    "PySide2.QtCore.QXmlStreamReader.addData": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtCore.QXmlStreamReader.addExtraNamespaceDeclaration": ('PySide2.QtCore.QXmlStreamNamespaceDeclaration',),
    "PySide2.QtCore.QXmlStreamReader.addExtraNamespaceDeclarations": ('typing.List[PySide2.QtCore.QXmlStreamNamespaceDeclaration]',),
    "PySide2.QtCore.QXmlStreamReader.atEnd": (),
    "PySide2.QtCore.QXmlStreamReader.attributes": (),
    "PySide2.QtCore.QXmlStreamReader.characterOffset": (),
    "PySide2.QtCore.QXmlStreamReader.clear": (),
    "PySide2.QtCore.QXmlStreamReader.columnNumber": (),
    "PySide2.QtCore.QXmlStreamReader.device": (),
    "PySide2.QtCore.QXmlStreamReader.documentEncoding": (),
    "PySide2.QtCore.QXmlStreamReader.documentVersion": (),
    "PySide2.QtCore.QXmlStreamReader.dtdName": (),
    "PySide2.QtCore.QXmlStreamReader.dtdPublicId": (),
    "PySide2.QtCore.QXmlStreamReader.dtdSystemId": (),
    "PySide2.QtCore.QXmlStreamReader.entityDeclarations": (),
    "PySide2.QtCore.QXmlStreamReader.entityResolver": (),
    "PySide2.QtCore.QXmlStreamReader.error": (),
    "PySide2.QtCore.QXmlStreamReader.errorString": (),
    "PySide2.QtCore.QXmlStreamReader.hasError": (),
    "PySide2.QtCore.QXmlStreamReader.isCDATA": (),
    "PySide2.QtCore.QXmlStreamReader.isCharacters": (),
    "PySide2.QtCore.QXmlStreamReader.isComment": (),
    "PySide2.QtCore.QXmlStreamReader.isDTD": (),
    "PySide2.QtCore.QXmlStreamReader.isEndDocument": (),
    "PySide2.QtCore.QXmlStreamReader.isEndElement": (),
    "PySide2.QtCore.QXmlStreamReader.isEntityReference": (),
    "PySide2.QtCore.QXmlStreamReader.isProcessingInstruction": (),
    "PySide2.QtCore.QXmlStreamReader.isStandaloneDocument": (),
    "PySide2.QtCore.QXmlStreamReader.isStartDocument": (),
    "PySide2.QtCore.QXmlStreamReader.isStartElement": (),
    "PySide2.QtCore.QXmlStreamReader.isWhitespace": (),
    "PySide2.QtCore.QXmlStreamReader.lineNumber": (),
    "PySide2.QtCore.QXmlStreamReader.name": (),
    "PySide2.QtCore.QXmlStreamReader.namespaceDeclarations": (),
    "PySide2.QtCore.QXmlStreamReader.namespaceProcessing": (),
    "PySide2.QtCore.QXmlStreamReader.namespaceUri": (),
    "PySide2.QtCore.QXmlStreamReader.notationDeclarations": (),
    "PySide2.QtCore.QXmlStreamReader.prefix": (),
    "PySide2.QtCore.QXmlStreamReader.processingInstructionData": (),
    "PySide2.QtCore.QXmlStreamReader.processingInstructionTarget": (),
    "PySide2.QtCore.QXmlStreamReader.qualifiedName": (),
    "PySide2.QtCore.QXmlStreamReader.raiseError": ('str',),
    "PySide2.QtCore.QXmlStreamReader.readElementText": ('PySide2.QtCore.QXmlStreamReader.ReadElementTextBehaviour',),
    "PySide2.QtCore.QXmlStreamReader.readNext": (),
    "PySide2.QtCore.QXmlStreamReader.readNextStartElement": (),
    "PySide2.QtCore.QXmlStreamReader.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtCore.QXmlStreamReader.setEntityResolver": ('PySide2.QtCore.QXmlStreamEntityResolver',),
    "PySide2.QtCore.QXmlStreamReader.setNamespaceProcessing": ('bool',),
    "PySide2.QtCore.QXmlStreamReader.skipCurrentElement": (),
    "PySide2.QtCore.QXmlStreamReader.text": (),
    "PySide2.QtCore.QXmlStreamReader.tokenString": (),
    "PySide2.QtCore.QXmlStreamReader.tokenType": (),

# class PySide2.QtCore.QXmlStreamWriter:
    "PySide2.QtCore.QXmlStreamWriter.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtCore.QXmlStreamWriter.autoFormatting": (),
    "PySide2.QtCore.QXmlStreamWriter.autoFormattingIndent": (),
    "PySide2.QtCore.QXmlStreamWriter.codec": (),
    "PySide2.QtCore.QXmlStreamWriter.device": (),
    "PySide2.QtCore.QXmlStreamWriter.hasError": (),
    "PySide2.QtCore.QXmlStreamWriter.setAutoFormatting": ('bool',),
    "PySide2.QtCore.QXmlStreamWriter.setAutoFormattingIndent": ('int',),
    "PySide2.QtCore.QXmlStreamWriter.setCodec": [('PySide2.QtCore.QTextCodec',), ('str',)],
    "PySide2.QtCore.QXmlStreamWriter.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtCore.QXmlStreamWriter.writeAttribute": [('PySide2.QtCore.QXmlStreamAttribute',), ('str', 'str'), ('str', 'str', 'str')],
    "PySide2.QtCore.QXmlStreamWriter.writeAttributes": ('PySide2.QtCore.QXmlStreamAttributes',),
    "PySide2.QtCore.QXmlStreamWriter.writeCDATA": ('str',),
    "PySide2.QtCore.QXmlStreamWriter.writeCharacters": ('str',),
    "PySide2.QtCore.QXmlStreamWriter.writeComment": ('str',),
    "PySide2.QtCore.QXmlStreamWriter.writeCurrentToken": ('PySide2.QtCore.QXmlStreamReader',),
    "PySide2.QtCore.QXmlStreamWriter.writeDTD": ('str',),
    "PySide2.QtCore.QXmlStreamWriter.writeDefaultNamespace": ('str',),
    "PySide2.QtCore.QXmlStreamWriter.writeEmptyElement": [('str',), ('str', 'str')],
    "PySide2.QtCore.QXmlStreamWriter.writeEndDocument": (),
    "PySide2.QtCore.QXmlStreamWriter.writeEndElement": (),
    "PySide2.QtCore.QXmlStreamWriter.writeEntityReference": ('str',),
    "PySide2.QtCore.QXmlStreamWriter.writeNamespace": ('str', 'str'),
    "PySide2.QtCore.QXmlStreamWriter.writeProcessingInstruction": ('str', 'str'),
    "PySide2.QtCore.QXmlStreamWriter.writeStartDocument": [(), ('str',), ('str', 'bool')],
    "PySide2.QtCore.QXmlStreamWriter.writeStartElement": [('str',), ('str', 'str')],
    "PySide2.QtCore.QXmlStreamWriter.writeTextElement": [('str', 'str'), ('str', 'str', 'str')],

# class PySide2.QtCore.Qt:

# class PySide2.QtCore.Qt.Alignment:

# class PySide2.QtCore.Qt.AlignmentFlag:

# class PySide2.QtCore.Qt.AnchorPoint:

# class PySide2.QtCore.Qt.ApplicationAttribute:

# class PySide2.QtCore.Qt.ApplicationState:

# class PySide2.QtCore.Qt.ApplicationStates:

# class PySide2.QtCore.Qt.ArrowType:

# class PySide2.QtCore.Qt.AspectRatioMode:

# class PySide2.QtCore.Qt.Axis:

# class PySide2.QtCore.Qt.BGMode:

# class PySide2.QtCore.Qt.BrushStyle:

# class PySide2.QtCore.Qt.CaseSensitivity:

# class PySide2.QtCore.Qt.CheckState:

# class PySide2.QtCore.Qt.ChecksumType:

# class PySide2.QtCore.Qt.ClipOperation:

# class PySide2.QtCore.Qt.ConnectionType:

# class PySide2.QtCore.Qt.ContextMenuPolicy:

# class PySide2.QtCore.Qt.CoordinateSystem:

# class PySide2.QtCore.Qt.Corner:

# class PySide2.QtCore.Qt.CursorMoveStyle:

# class PySide2.QtCore.Qt.CursorShape:

# class PySide2.QtCore.Qt.DateFormat:

# class PySide2.QtCore.Qt.DayOfWeek:

# class PySide2.QtCore.Qt.DockWidgetArea:

# class PySide2.QtCore.Qt.DockWidgetAreaSizes:

# class PySide2.QtCore.Qt.DockWidgetAreas:

# class PySide2.QtCore.Qt.DropAction:

# class PySide2.QtCore.Qt.DropActions:

# class PySide2.QtCore.Qt.Edge:

# class PySide2.QtCore.Qt.Edges:

# class PySide2.QtCore.Qt.EnterKeyType:

# class PySide2.QtCore.Qt.EventPriority:

# class PySide2.QtCore.Qt.FillRule:

# class PySide2.QtCore.Qt.FindChildOption:

# class PySide2.QtCore.Qt.FindChildOptions:

# class PySide2.QtCore.Qt.FocusPolicy:

# class PySide2.QtCore.Qt.FocusReason:

# class PySide2.QtCore.Qt.GestureFlag:

# class PySide2.QtCore.Qt.GestureFlags:

# class PySide2.QtCore.Qt.GestureState:

# class PySide2.QtCore.Qt.GestureType:

# class PySide2.QtCore.Qt.GlobalColor:

# class PySide2.QtCore.Qt.HighDpiScaleFactorRoundingPolicy:

# class PySide2.QtCore.Qt.HitTestAccuracy:

# class PySide2.QtCore.Qt.ImageConversionFlag:

# class PySide2.QtCore.Qt.ImageConversionFlags:

# class PySide2.QtCore.Qt.InputMethodHint:

# class PySide2.QtCore.Qt.InputMethodHints:

# class PySide2.QtCore.Qt.InputMethodQueries:

# class PySide2.QtCore.Qt.InputMethodQuery:

# class PySide2.QtCore.Qt.ItemDataRole:

# class PySide2.QtCore.Qt.ItemFlag:

# class PySide2.QtCore.Qt.ItemFlags:

# class PySide2.QtCore.Qt.ItemSelectionMode:

# class PySide2.QtCore.Qt.ItemSelectionOperation:

# class PySide2.QtCore.Qt.Key:

# class PySide2.QtCore.Qt.KeyboardModifier:

# class PySide2.QtCore.Qt.KeyboardModifiers:

# class PySide2.QtCore.Qt.LayoutDirection:

# class PySide2.QtCore.Qt.MaskMode:

# class PySide2.QtCore.Qt.MatchFlag:

# class PySide2.QtCore.Qt.MatchFlags:

# class PySide2.QtCore.Qt.Modifier:

# class PySide2.QtCore.Qt.MouseButton:

# class PySide2.QtCore.Qt.MouseButtons:

# class PySide2.QtCore.Qt.MouseEventFlag:

# class PySide2.QtCore.Qt.MouseEventFlags:

# class PySide2.QtCore.Qt.MouseEventSource:

# class PySide2.QtCore.Qt.NativeGestureType:

# class PySide2.QtCore.Qt.NavigationMode:

# class PySide2.QtCore.Qt.Orientation:

# class PySide2.QtCore.Qt.Orientations:

# class PySide2.QtCore.Qt.PenCapStyle:

# class PySide2.QtCore.Qt.PenJoinStyle:

# class PySide2.QtCore.Qt.PenStyle:

# class PySide2.QtCore.Qt.ScreenOrientation:

# class PySide2.QtCore.Qt.ScreenOrientations:

# class PySide2.QtCore.Qt.ScrollBarPolicy:

# class PySide2.QtCore.Qt.ScrollPhase:

# class PySide2.QtCore.Qt.ShortcutContext:

# class PySide2.QtCore.Qt.SizeHint:

# class PySide2.QtCore.Qt.SizeMode:

# class PySide2.QtCore.Qt.SortOrder:

# class PySide2.QtCore.Qt.SplitBehavior:

# class PySide2.QtCore.Qt.SplitBehaviorFlags:

# class PySide2.QtCore.Qt.TabFocusBehavior:

# class PySide2.QtCore.Qt.TextElideMode:

# class PySide2.QtCore.Qt.TextFlag:

# class PySide2.QtCore.Qt.TextFormat:

# class PySide2.QtCore.Qt.TextInteractionFlag:

# class PySide2.QtCore.Qt.TextInteractionFlags:

# class PySide2.QtCore.Qt.TileRule:

# class PySide2.QtCore.Qt.TimeSpec:

# class PySide2.QtCore.Qt.TimerType:

# class PySide2.QtCore.Qt.ToolBarArea:

# class PySide2.QtCore.Qt.ToolBarAreaSizes:

# class PySide2.QtCore.Qt.ToolBarAreas:

# class PySide2.QtCore.Qt.ToolButtonStyle:

# class PySide2.QtCore.Qt.TouchPointState:

# class PySide2.QtCore.Qt.TouchPointStates:

# class PySide2.QtCore.Qt.TransformationMode:

# class PySide2.QtCore.Qt.UIEffect:

# class PySide2.QtCore.Qt.WhiteSpaceMode:

# class PySide2.QtCore.Qt.WidgetAttribute:

# class PySide2.QtCore.Qt.WindowFlags:

# class PySide2.QtCore.Qt.WindowFrameSection:

# class PySide2.QtCore.Qt.WindowModality:

# class PySide2.QtCore.Qt.WindowState:

# class PySide2.QtCore.Qt.WindowStates:

# class PySide2.QtCore.Qt.WindowType:

# class PySide2.QtCore.QtMsgType:

# class PySide2.QtCore.Signal:
    "PySide2.QtCore.Signal.__init__": ('type', 'str', 'str'),

# class PySide2.QtCore.SignalInstance:
    "PySide2.QtCore.SignalInstance.connect": ('object', 'type'),
    "PySide2.QtCore.SignalInstance.disconnect": ('object',),
    "PySide2.QtCore.SignalInstance.emit": ('typing.Any',),

# class PySide2.QtCore.Slot:
    "PySide2.QtCore.Slot.__init__": ('type', 'str', 'str'),

    "PySide2.QtCore.Slot.QT_TRANSLATE_NOOP": ('object', 'object'),
    "PySide2.QtCore.Slot.QT_TRANSLATE_NOOP3": ('object', 'object', 'object'),
    "PySide2.QtCore.Slot.QT_TRANSLATE_NOOP_UTF8": ('object',),
    "PySide2.QtCore.Slot.QT_TR_NOOP": ('object',),
    "PySide2.QtCore.Slot.QT_TR_NOOP_UTF8": ('object',),
    "PySide2.QtCore.Slot.SIGNAL": ('str',),
    "PySide2.QtCore.Slot.SLOT": ('str',),
    "PySide2.QtCore.Slot.__moduleShutdown": (),
    "PySide2.QtCore.Slot.qAbs": ('float',),
    "PySide2.QtCore.Slot.qAcos": ('float',),
    "PySide2.QtCore.Slot.qAddPostRoutine": ('object',),
    "PySide2.QtCore.Slot.qAsin": ('float',),
    "PySide2.QtCore.Slot.qAtan": ('float',),
    "PySide2.QtCore.Slot.qAtan2": ('float', 'float'),
    "PySide2.QtCore.Slot.qChecksum": ('str', 'int'),
    "PySide2.QtCore.Slot.qCompress": [('PySide2.QtCore.QByteArray', 'int'), ('str', 'int', 'int')],
    "PySide2.QtCore.Slot.qCritical": ('str',),
    "PySide2.QtCore.Slot.qDebug": ('str',),
    "PySide2.QtCore.Slot.qExp": ('float',),
    "PySide2.QtCore.Slot.qFabs": ('float',),
    "PySide2.QtCore.Slot.qFastCos": ('float',),
    "PySide2.QtCore.Slot.qFastSin": ('float',),
    "PySide2.QtCore.Slot.qFatal": ('str',),
    "PySide2.QtCore.Slot.qFuzzyCompare": ('float', 'float'),
    "PySide2.QtCore.Slot.qFuzzyIsNull": ('float',),
    "PySide2.QtCore.Slot.qInstallMessageHandler": ('object',),
    "PySide2.QtCore.Slot.qIsFinite": ('float',),
    "PySide2.QtCore.Slot.qIsInf": ('float',),
    "PySide2.QtCore.Slot.qIsNaN": ('float',),
    "PySide2.QtCore.Slot.qIsNull": ('float',),
    "PySide2.QtCore.Slot.qRegisterResourceData": ('int', 'str', 'str', 'str'),
    "PySide2.QtCore.Slot.qTan": ('float',),
    "PySide2.QtCore.Slot.qUncompress": [('PySide2.QtCore.QByteArray',), ('str', 'int')],
    "PySide2.QtCore.Slot.qUnregisterResourceData": ('int', 'str', 'str', 'str'),
    "PySide2.QtCore.Slot.qVersion": (),
    "PySide2.QtCore.Slot.qWarning": ('str',),
    "PySide2.QtCore.Slot.qrand": (),
    "PySide2.QtCore.Slot.qsrand": ('int',),
    "PySide2.QtCore.Slot.qtTrId": ('str', 'int'),
    }) if "PySide2.QtCore" in sys.modules else None

# Module PySide2.QtGui
sig_dict.update({

# class PySide2.QtGui.QAbstractOpenGLFunctions:
    "PySide2.QtGui.QAbstractOpenGLFunctions.__init__": (),
    "PySide2.QtGui.QAbstractOpenGLFunctions.initializeOpenGLFunctions": (),
    "PySide2.QtGui.QAbstractOpenGLFunctions.isInitialized": (),
    "PySide2.QtGui.QAbstractOpenGLFunctions.owningContext": (),
    "PySide2.QtGui.QAbstractOpenGLFunctions.setOwningContext": ('PySide2.QtGui.QOpenGLContext',),

# class PySide2.QtGui.QAbstractTextDocumentLayout:

# class PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext:
    "PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext.__init__": [(), ('PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext',)],
    "PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext.__copy__": (),

# class PySide2.QtGui.QAbstractTextDocumentLayout.Selection:
    "PySide2.QtGui.QAbstractTextDocumentLayout.Selection.__init__": [(), ('PySide2.QtGui.QAbstractTextDocumentLayout.Selection',)],
    "PySide2.QtGui.QAbstractTextDocumentLayout.Selection.__copy__": (),

    "PySide2.QtGui.QAbstractTextDocumentLayout.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.anchorAt": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.blockBoundingRect": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.blockWithMarkerAt": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.document": (),
    "PySide2.QtGui.QAbstractTextDocumentLayout.documentChanged": ('int', 'int', 'int'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.documentSize": (),
    "PySide2.QtGui.QAbstractTextDocumentLayout.draw": ('PySide2.QtGui.QPainter', 'PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.drawInlineObject": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF', 'PySide2.QtGui.QTextInlineObject', 'int', 'PySide2.QtGui.QTextFormat'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.format": ('int',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.formatAt": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.formatIndex": ('int',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.frameBoundingRect": ('PySide2.QtGui.QTextFrame',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.handlerForObject": ('int',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.hitTest": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.HitTestAccuracy'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.imageAt": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.pageCount": (),
    "PySide2.QtGui.QAbstractTextDocumentLayout.paintDevice": (),
    "PySide2.QtGui.QAbstractTextDocumentLayout.positionInlineObject": ('PySide2.QtGui.QTextInlineObject', 'int', 'PySide2.QtGui.QTextFormat'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.registerHandler": ('int', 'PySide2.QtCore.QObject'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.resizeInlineObject": ('PySide2.QtGui.QTextInlineObject', 'int', 'PySide2.QtGui.QTextFormat'),
    "PySide2.QtGui.QAbstractTextDocumentLayout.setPaintDevice": ('PySide2.QtGui.QPaintDevice',),
    "PySide2.QtGui.QAbstractTextDocumentLayout.unregisterHandler": ('int', 'PySide2.QtCore.QObject'),

# class PySide2.QtGui.QAccessible:

# class PySide2.QtGui.QAccessible.Event:

# class PySide2.QtGui.QAccessible.InterfaceType:

# class PySide2.QtGui.QAccessible.Relation:

# class PySide2.QtGui.QAccessible.RelationFlag:

# class PySide2.QtGui.QAccessible.Role:

# class PySide2.QtGui.QAccessible.State:
    "PySide2.QtGui.QAccessible.State.__init__": [(), ('PySide2.QtGui.QAccessible.State',)],
    "PySide2.QtGui.QAccessible.State.__copy__": (),

# class PySide2.QtGui.QAccessible.Text:

# class PySide2.QtGui.QAccessible.TextBoundaryType:

    "PySide2.QtGui.QAccessible.__copy__": (),
    "PySide2.QtGui.QAccessible.accessibleInterface": ('int',),
    "PySide2.QtGui.QAccessible.cleanup": (),
    "PySide2.QtGui.QAccessible.deleteAccessibleInterface": ('int',),
    "PySide2.QtGui.QAccessible.isActive": (),
    "PySide2.QtGui.QAccessible.qAccessibleTextBoundaryHelper": ('PySide2.QtGui.QTextCursor', 'PySide2.QtGui.QAccessible.TextBoundaryType'),
    "PySide2.QtGui.QAccessible.queryAccessibleInterface": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QAccessible.registerAccessibleInterface": ('PySide2.QtGui.QAccessibleInterface',),
    "PySide2.QtGui.QAccessible.setActive": ('bool',),
    "PySide2.QtGui.QAccessible.setRootObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QAccessible.uniqueId": ('PySide2.QtGui.QAccessibleInterface',),
    "PySide2.QtGui.QAccessible.updateAccessibility": ('PySide2.QtGui.QAccessibleEvent',),

# class PySide2.QtGui.QAccessibleEditableTextInterface:
    "PySide2.QtGui.QAccessibleEditableTextInterface.__init__": (),
    "PySide2.QtGui.QAccessibleEditableTextInterface.deleteText": ('int', 'int'),
    "PySide2.QtGui.QAccessibleEditableTextInterface.insertText": ('int', 'str'),
    "PySide2.QtGui.QAccessibleEditableTextInterface.replaceText": ('int', 'int', 'str'),

# class PySide2.QtGui.QAccessibleEvent:
    "PySide2.QtGui.QAccessibleEvent.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtGui.QAccessible.Event'), ('PySide2.QtGui.QAccessibleInterface', 'PySide2.QtGui.QAccessible.Event')],
    "PySide2.QtGui.QAccessibleEvent.accessibleInterface": (),
    "PySide2.QtGui.QAccessibleEvent.child": (),
    "PySide2.QtGui.QAccessibleEvent.object": (),
    "PySide2.QtGui.QAccessibleEvent.setChild": ('int',),
    "PySide2.QtGui.QAccessibleEvent.type": (),
    "PySide2.QtGui.QAccessibleEvent.uniqueId": (),

# class PySide2.QtGui.QAccessibleInterface:
    "PySide2.QtGui.QAccessibleInterface.__init__": (),
    "PySide2.QtGui.QAccessibleInterface.backgroundColor": (),
    "PySide2.QtGui.QAccessibleInterface.child": ('int',),
    "PySide2.QtGui.QAccessibleInterface.childAt": ('int', 'int'),
    "PySide2.QtGui.QAccessibleInterface.childCount": (),
    "PySide2.QtGui.QAccessibleInterface.editableTextInterface": (),
    "PySide2.QtGui.QAccessibleInterface.focusChild": (),
    "PySide2.QtGui.QAccessibleInterface.foregroundColor": (),
    "PySide2.QtGui.QAccessibleInterface.indexOfChild": ('PySide2.QtGui.QAccessibleInterface',),
    "PySide2.QtGui.QAccessibleInterface.interface_cast": ('PySide2.QtGui.QAccessible.InterfaceType',),
    "PySide2.QtGui.QAccessibleInterface.isValid": (),
    "PySide2.QtGui.QAccessibleInterface.object": (),
    "PySide2.QtGui.QAccessibleInterface.parent": (),
    "PySide2.QtGui.QAccessibleInterface.rect": (),
    "PySide2.QtGui.QAccessibleInterface.relations": ('PySide2.QtGui.QAccessible.Relation',),
    "PySide2.QtGui.QAccessibleInterface.role": (),
    "PySide2.QtGui.QAccessibleInterface.setText": ('PySide2.QtGui.QAccessible.Text', 'str'),
    "PySide2.QtGui.QAccessibleInterface.state": (),
    "PySide2.QtGui.QAccessibleInterface.tableCellInterface": (),
    "PySide2.QtGui.QAccessibleInterface.text": ('PySide2.QtGui.QAccessible.Text',),
    "PySide2.QtGui.QAccessibleInterface.textInterface": (),
    "PySide2.QtGui.QAccessibleInterface.valueInterface": (),
    "PySide2.QtGui.QAccessibleInterface.virtual_hook": ('int', 'int'),
    "PySide2.QtGui.QAccessibleInterface.window": (),

# class PySide2.QtGui.QAccessibleObject:
    "PySide2.QtGui.QAccessibleObject.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QAccessibleObject.childAt": ('int', 'int'),
    "PySide2.QtGui.QAccessibleObject.isValid": (),
    "PySide2.QtGui.QAccessibleObject.object": (),
    "PySide2.QtGui.QAccessibleObject.rect": (),
    "PySide2.QtGui.QAccessibleObject.setText": ('PySide2.QtGui.QAccessible.Text', 'str'),

# class PySide2.QtGui.QAccessibleStateChangeEvent:
    "PySide2.QtGui.QAccessibleStateChangeEvent.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtGui.QAccessible.State'), ('PySide2.QtGui.QAccessibleInterface', 'PySide2.QtGui.QAccessible.State')],
    "PySide2.QtGui.QAccessibleStateChangeEvent.changedStates": (),

# class PySide2.QtGui.QAccessibleTableCellInterface:
    "PySide2.QtGui.QAccessibleTableCellInterface.__init__": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.columnExtent": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.columnHeaderCells": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.columnIndex": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.isSelected": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.rowExtent": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.rowHeaderCells": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.rowIndex": (),
    "PySide2.QtGui.QAccessibleTableCellInterface.table": (),

# class PySide2.QtGui.QAccessibleTableModelChangeEvent:

# class PySide2.QtGui.QAccessibleTableModelChangeEvent.ModelChangeType:
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtGui.QAccessibleTableModelChangeEvent.ModelChangeType'), ('PySide2.QtGui.QAccessibleInterface', 'PySide2.QtGui.QAccessibleTableModelChangeEvent.ModelChangeType')],
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.firstColumn": (),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.firstRow": (),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.lastColumn": (),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.lastRow": (),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.modelChangeType": (),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.setFirstColumn": ('int',),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.setFirstRow": ('int',),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.setLastColumn": ('int',),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.setLastRow": ('int',),
    "PySide2.QtGui.QAccessibleTableModelChangeEvent.setModelChangeType": ('PySide2.QtGui.QAccessibleTableModelChangeEvent.ModelChangeType',),

# class PySide2.QtGui.QAccessibleTextCursorEvent:
    "PySide2.QtGui.QAccessibleTextCursorEvent.__init__": [('PySide2.QtCore.QObject', 'int'), ('PySide2.QtGui.QAccessibleInterface', 'int')],
    "PySide2.QtGui.QAccessibleTextCursorEvent.cursorPosition": (),
    "PySide2.QtGui.QAccessibleTextCursorEvent.setCursorPosition": ('int',),

# class PySide2.QtGui.QAccessibleTextInsertEvent:
    "PySide2.QtGui.QAccessibleTextInsertEvent.__init__": [('PySide2.QtCore.QObject', 'int', 'str'), ('PySide2.QtGui.QAccessibleInterface', 'int', 'str')],
    "PySide2.QtGui.QAccessibleTextInsertEvent.changePosition": (),
    "PySide2.QtGui.QAccessibleTextInsertEvent.textInserted": (),

# class PySide2.QtGui.QAccessibleTextInterface:
    "PySide2.QtGui.QAccessibleTextInterface.__init__": (),
    "PySide2.QtGui.QAccessibleTextInterface.addSelection": ('int', 'int'),
    "PySide2.QtGui.QAccessibleTextInterface.attributes": ('int',),
    "PySide2.QtGui.QAccessibleTextInterface.characterCount": (),
    "PySide2.QtGui.QAccessibleTextInterface.characterRect": ('int',),
    "PySide2.QtGui.QAccessibleTextInterface.cursorPosition": (),
    "PySide2.QtGui.QAccessibleTextInterface.offsetAtPoint": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QAccessibleTextInterface.removeSelection": ('int',),
    "PySide2.QtGui.QAccessibleTextInterface.scrollToSubstring": ('int', 'int'),
    "PySide2.QtGui.QAccessibleTextInterface.selection": ('int',),
    "PySide2.QtGui.QAccessibleTextInterface.selectionCount": (),
    "PySide2.QtGui.QAccessibleTextInterface.setCursorPosition": ('int',),
    "PySide2.QtGui.QAccessibleTextInterface.setSelection": ('int', 'int', 'int'),
    "PySide2.QtGui.QAccessibleTextInterface.text": ('int', 'int'),
    "PySide2.QtGui.QAccessibleTextInterface.textAfterOffset": ('int', 'PySide2.QtGui.QAccessible.TextBoundaryType'),
    "PySide2.QtGui.QAccessibleTextInterface.textAtOffset": ('int', 'PySide2.QtGui.QAccessible.TextBoundaryType'),
    "PySide2.QtGui.QAccessibleTextInterface.textBeforeOffset": ('int', 'PySide2.QtGui.QAccessible.TextBoundaryType'),

# class PySide2.QtGui.QAccessibleTextRemoveEvent:
    "PySide2.QtGui.QAccessibleTextRemoveEvent.__init__": [('PySide2.QtCore.QObject', 'int', 'str'), ('PySide2.QtGui.QAccessibleInterface', 'int', 'str')],
    "PySide2.QtGui.QAccessibleTextRemoveEvent.changePosition": (),
    "PySide2.QtGui.QAccessibleTextRemoveEvent.textRemoved": (),

# class PySide2.QtGui.QAccessibleTextSelectionEvent:
    "PySide2.QtGui.QAccessibleTextSelectionEvent.__init__": [('PySide2.QtCore.QObject', 'int', 'int'), ('PySide2.QtGui.QAccessibleInterface', 'int', 'int')],
    "PySide2.QtGui.QAccessibleTextSelectionEvent.selectionEnd": (),
    "PySide2.QtGui.QAccessibleTextSelectionEvent.selectionStart": (),
    "PySide2.QtGui.QAccessibleTextSelectionEvent.setSelection": ('int', 'int'),

# class PySide2.QtGui.QAccessibleTextUpdateEvent:
    "PySide2.QtGui.QAccessibleTextUpdateEvent.__init__": [('PySide2.QtCore.QObject', 'int', 'str', 'str'), ('PySide2.QtGui.QAccessibleInterface', 'int', 'str', 'str')],
    "PySide2.QtGui.QAccessibleTextUpdateEvent.changePosition": (),
    "PySide2.QtGui.QAccessibleTextUpdateEvent.textInserted": (),
    "PySide2.QtGui.QAccessibleTextUpdateEvent.textRemoved": (),

# class PySide2.QtGui.QAccessibleValueChangeEvent:
    "PySide2.QtGui.QAccessibleValueChangeEvent.__init__": [('PySide2.QtCore.QObject', 'typing.Any'), ('PySide2.QtGui.QAccessibleInterface', 'typing.Any')],
    "PySide2.QtGui.QAccessibleValueChangeEvent.setValue": ('typing.Any',),
    "PySide2.QtGui.QAccessibleValueChangeEvent.value": (),

# class PySide2.QtGui.QAccessibleValueInterface:
    "PySide2.QtGui.QAccessibleValueInterface.__init__": (),
    "PySide2.QtGui.QAccessibleValueInterface.currentValue": (),
    "PySide2.QtGui.QAccessibleValueInterface.maximumValue": (),
    "PySide2.QtGui.QAccessibleValueInterface.minimumStepSize": (),
    "PySide2.QtGui.QAccessibleValueInterface.minimumValue": (),
    "PySide2.QtGui.QAccessibleValueInterface.setCurrentValue": ('typing.Any',),

# class PySide2.QtGui.QActionEvent:

# class PySide2.QtGui.QBackingStore:
    "PySide2.QtGui.QBackingStore.__init__": ('PySide2.QtGui.QWindow',),
    "PySide2.QtGui.QBackingStore.beginPaint": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QBackingStore.endPaint": (),
    "PySide2.QtGui.QBackingStore.flush": ('PySide2.QtGui.QRegion', 'PySide2.QtGui.QWindow', 'PySide2.QtCore.QPoint'),
    "PySide2.QtGui.QBackingStore.hasStaticContents": (),
    "PySide2.QtGui.QBackingStore.paintDevice": (),
    "PySide2.QtGui.QBackingStore.resize": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QBackingStore.scroll": ('PySide2.QtGui.QRegion', 'int', 'int'),
    "PySide2.QtGui.QBackingStore.setStaticContents": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QBackingStore.size": (),
    "PySide2.QtGui.QBackingStore.staticContents": (),
    "PySide2.QtGui.QBackingStore.window": (),

# class PySide2.QtGui.QBitmap:
    "PySide2.QtGui.QBitmap.__init__": [(), ('PySide2.QtCore.QSize',), ('PySide2.QtGui.QBitmap',), ('PySide2.QtGui.QPixmap',), ('int', 'int'), ('str', 'str')],
    "PySide2.QtGui.QBitmap.__copy__": (),
    "PySide2.QtGui.QBitmap.clear": (),
    "PySide2.QtGui.QBitmap.fromData": ('PySide2.QtCore.QSize', 'str', 'PySide2.QtGui.QImage.Format'),
    "PySide2.QtGui.QBitmap.fromImage": ('PySide2.QtGui.QImage', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QBitmap.swap": [('PySide2.QtGui.QBitmap',), ('PySide2.QtGui.QPixmap',)],
    "PySide2.QtGui.QBitmap.transformed": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QMatrix', 'PySide2.QtCore.Qt.TransformationMode'), ('PySide2.QtGui.QTransform',)],

# class PySide2.QtGui.QBrush:
    "PySide2.QtGui.QBrush.__init__": [(), ('PySide2.QtCore.Qt.BrushStyle',), ('PySide2.QtCore.Qt.GlobalColor', 'PySide2.QtCore.Qt.BrushStyle'), ('PySide2.QtCore.Qt.GlobalColor', 'PySide2.QtGui.QPixmap'), ('PySide2.QtGui.QBrush',), ('PySide2.QtGui.QColor', 'PySide2.QtCore.Qt.BrushStyle'), ('PySide2.QtGui.QColor', 'PySide2.QtGui.QPixmap'), ('PySide2.QtGui.QGradient',), ('PySide2.QtGui.QImage',), ('PySide2.QtGui.QPixmap',)],
    "PySide2.QtGui.QBrush.__copy__": (),
    "PySide2.QtGui.QBrush.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QBrush.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QBrush.color": (),
    "PySide2.QtGui.QBrush.gradient": (),
    "PySide2.QtGui.QBrush.isOpaque": (),
    "PySide2.QtGui.QBrush.matrix": (),
    "PySide2.QtGui.QBrush.setColor": [('PySide2.QtCore.Qt.GlobalColor',), ('PySide2.QtGui.QColor',)],
    "PySide2.QtGui.QBrush.setMatrix": ('PySide2.QtGui.QMatrix',),
    "PySide2.QtGui.QBrush.setStyle": ('PySide2.QtCore.Qt.BrushStyle',),
    "PySide2.QtGui.QBrush.setTexture": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtGui.QBrush.setTextureImage": ('PySide2.QtGui.QImage',),
    "PySide2.QtGui.QBrush.setTransform": ('PySide2.QtGui.QTransform',),
    "PySide2.QtGui.QBrush.style": (),
    "PySide2.QtGui.QBrush.swap": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QBrush.texture": (),
    "PySide2.QtGui.QBrush.textureImage": (),
    "PySide2.QtGui.QBrush.transform": (),

# class PySide2.QtGui.QClipboard:

# class PySide2.QtGui.QClipboard.Mode:
    "PySide2.QtGui.QClipboard.clear": ('PySide2.QtGui.QClipboard.Mode',),
    "PySide2.QtGui.QClipboard.image": ('PySide2.QtGui.QClipboard.Mode',),
    "PySide2.QtGui.QClipboard.mimeData": ('PySide2.QtGui.QClipboard.Mode',),
    "PySide2.QtGui.QClipboard.ownsClipboard": (),
    "PySide2.QtGui.QClipboard.ownsFindBuffer": (),
    "PySide2.QtGui.QClipboard.ownsSelection": (),
    "PySide2.QtGui.QClipboard.pixmap": ('PySide2.QtGui.QClipboard.Mode',),
    "PySide2.QtGui.QClipboard.setImage": ('PySide2.QtGui.QImage', 'PySide2.QtGui.QClipboard.Mode'),
    "PySide2.QtGui.QClipboard.setMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtGui.QClipboard.Mode'),
    "PySide2.QtGui.QClipboard.setPixmap": ('PySide2.QtGui.QPixmap', 'PySide2.QtGui.QClipboard.Mode'),
    "PySide2.QtGui.QClipboard.setText": ('str', 'PySide2.QtGui.QClipboard.Mode'),
    "PySide2.QtGui.QClipboard.supportsFindBuffer": (),
    "PySide2.QtGui.QClipboard.supportsSelection": (),
    "PySide2.QtGui.QClipboard.text": [('PySide2.QtGui.QClipboard.Mode',), ('str', 'PySide2.QtGui.QClipboard.Mode')],

# class PySide2.QtGui.QCloseEvent:
    "PySide2.QtGui.QCloseEvent.__init__": (),

# class PySide2.QtGui.QColor:

# class PySide2.QtGui.QColor.NameFormat:

# class PySide2.QtGui.QColor.Spec:
    "PySide2.QtGui.QColor.__init__": [(), ('PySide2.QtCore.Qt.GlobalColor',), ('PySide2.QtGui.QColor',), ('PySide2.QtGui.QColor.Spec', 'int', 'int', 'int', 'int', 'int'), ('int',), ('int', 'int', 'int', 'int'), ('str',), ('typing.Any',)],
    "PySide2.QtGui.QColor.__copy__": (),
    "PySide2.QtGui.QColor.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QColor.__reduce__": (),
    "PySide2.QtGui.QColor.__repr__": (),
    "PySide2.QtGui.QColor.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QColor.__setstate__": ('object',),
    "PySide2.QtGui.QColor.__str__": (),
    "PySide2.QtGui.QColor.alpha": (),
    "PySide2.QtGui.QColor.alphaF": (),
    "PySide2.QtGui.QColor.black": (),
    "PySide2.QtGui.QColor.blackF": (),
    "PySide2.QtGui.QColor.blue": (),
    "PySide2.QtGui.QColor.blueF": (),
    "PySide2.QtGui.QColor.colorNames": (),
    "PySide2.QtGui.QColor.convertTo": ('PySide2.QtGui.QColor.Spec',),
    "PySide2.QtGui.QColor.cyan": (),
    "PySide2.QtGui.QColor.cyanF": (),
    "PySide2.QtGui.QColor.dark": ('int',),
    "PySide2.QtGui.QColor.darker": ('int',),
    "PySide2.QtGui.QColor.fromCmyk": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.fromCmykF": ('float', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.fromHsl": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.fromHslF": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.fromHsv": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.fromHsvF": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.fromRgb": [('int',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QColor.fromRgbF": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.fromRgba": ('int',),
    "PySide2.QtGui.QColor.fromRgba64": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.getCmyk": (),
    "PySide2.QtGui.QColor.getCmykF": (),
    "PySide2.QtGui.QColor.getHsl": (),
    "PySide2.QtGui.QColor.getHslF": (),
    "PySide2.QtGui.QColor.getHsv": (),
    "PySide2.QtGui.QColor.getHsvF": (),
    "PySide2.QtGui.QColor.getRgb": (),
    "PySide2.QtGui.QColor.getRgbF": (),
    "PySide2.QtGui.QColor.green": (),
    "PySide2.QtGui.QColor.greenF": (),
    "PySide2.QtGui.QColor.hslHue": (),
    "PySide2.QtGui.QColor.hslHueF": (),
    "PySide2.QtGui.QColor.hslSaturation": (),
    "PySide2.QtGui.QColor.hslSaturationF": (),
    "PySide2.QtGui.QColor.hsvHue": (),
    "PySide2.QtGui.QColor.hsvHueF": (),
    "PySide2.QtGui.QColor.hsvSaturation": (),
    "PySide2.QtGui.QColor.hsvSaturationF": (),
    "PySide2.QtGui.QColor.hue": (),
    "PySide2.QtGui.QColor.hueF": (),
    "PySide2.QtGui.QColor.isValid": (),
    "PySide2.QtGui.QColor.isValidColor": ('str',),
    "PySide2.QtGui.QColor.light": ('int',),
    "PySide2.QtGui.QColor.lighter": ('int',),
    "PySide2.QtGui.QColor.lightness": (),
    "PySide2.QtGui.QColor.lightnessF": (),
    "PySide2.QtGui.QColor.magenta": (),
    "PySide2.QtGui.QColor.magentaF": (),
    "PySide2.QtGui.QColor.name": [(), ('PySide2.QtGui.QColor.NameFormat',)],
    "PySide2.QtGui.QColor.red": (),
    "PySide2.QtGui.QColor.redF": (),
    "PySide2.QtGui.QColor.rgb": (),
    "PySide2.QtGui.QColor.rgba": (),
    "PySide2.QtGui.QColor.saturation": (),
    "PySide2.QtGui.QColor.saturationF": (),
    "PySide2.QtGui.QColor.setAlpha": ('int',),
    "PySide2.QtGui.QColor.setAlphaF": ('float',),
    "PySide2.QtGui.QColor.setBlue": ('int',),
    "PySide2.QtGui.QColor.setBlueF": ('float',),
    "PySide2.QtGui.QColor.setCmyk": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.setCmykF": ('float', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.setGreen": ('int',),
    "PySide2.QtGui.QColor.setGreenF": ('float',),
    "PySide2.QtGui.QColor.setHsl": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.setHslF": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.setHsv": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QColor.setHsvF": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.setNamedColor": ('str',),
    "PySide2.QtGui.QColor.setRed": ('int',),
    "PySide2.QtGui.QColor.setRedF": ('float',),
    "PySide2.QtGui.QColor.setRgb": [('int',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QColor.setRgbF": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QColor.setRgba": ('int',),
    "PySide2.QtGui.QColor.spec": (),
    "PySide2.QtGui.QColor.toCmyk": (),
    "PySide2.QtGui.QColor.toExtendedRgb": (),
    "PySide2.QtGui.QColor.toHsl": (),
    "PySide2.QtGui.QColor.toHsv": (),
    "PySide2.QtGui.QColor.toRgb": (),
    "PySide2.QtGui.QColor.toTuple": (),
    "PySide2.QtGui.QColor.value": (),
    "PySide2.QtGui.QColor.valueF": (),
    "PySide2.QtGui.QColor.yellow": (),
    "PySide2.QtGui.QColor.yellowF": (),

# class PySide2.QtGui.QColorSpace:

# class PySide2.QtGui.QColorSpace.NamedColorSpace:

# class PySide2.QtGui.QColorSpace.Primaries:

# class PySide2.QtGui.QColorSpace.TransferFunction:
    "PySide2.QtGui.QColorSpace.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtGui.QColorSpace.TransferFunction', 'float'), ('PySide2.QtGui.QColorSpace',), ('PySide2.QtGui.QColorSpace.NamedColorSpace',), ('PySide2.QtGui.QColorSpace.Primaries', 'PySide2.QtGui.QColorSpace.TransferFunction', 'float'), ('PySide2.QtGui.QColorSpace.Primaries', 'float')],
    "PySide2.QtGui.QColorSpace.__copy__": (),
    "PySide2.QtGui.QColorSpace.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QColorSpace.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QColorSpace.fromIccProfile": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QColorSpace.gamma": (),
    "PySide2.QtGui.QColorSpace.iccProfile": (),
    "PySide2.QtGui.QColorSpace.isValid": (),
    "PySide2.QtGui.QColorSpace.primaries": (),
    "PySide2.QtGui.QColorSpace.setPrimaries": [('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('PySide2.QtGui.QColorSpace.Primaries',)],
    "PySide2.QtGui.QColorSpace.setTransferFunction": ('PySide2.QtGui.QColorSpace.TransferFunction', 'float'),
    "PySide2.QtGui.QColorSpace.swap": ('PySide2.QtGui.QColorSpace',),
    "PySide2.QtGui.QColorSpace.transferFunction": (),
    "PySide2.QtGui.QColorSpace.withTransferFunction": ('PySide2.QtGui.QColorSpace.TransferFunction', 'float'),

# class PySide2.QtGui.QConicalGradient:
    "PySide2.QtGui.QConicalGradient.__init__": [(), ('PySide2.QtCore.QPointF', 'float'), ('PySide2.QtGui.QConicalGradient',), ('float', 'float', 'float')],
    "PySide2.QtGui.QConicalGradient.__copy__": (),
    "PySide2.QtGui.QConicalGradient.angle": (),
    "PySide2.QtGui.QConicalGradient.center": (),
    "PySide2.QtGui.QConicalGradient.setAngle": ('float',),
    "PySide2.QtGui.QConicalGradient.setCenter": [('PySide2.QtCore.QPointF',), ('float', 'float')],

# class PySide2.QtGui.QContextMenuEvent:

# class PySide2.QtGui.QContextMenuEvent.Reason:
    "PySide2.QtGui.QContextMenuEvent.__init__": [('PySide2.QtGui.QContextMenuEvent.Reason', 'PySide2.QtCore.QPoint'), ('PySide2.QtGui.QContextMenuEvent.Reason', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'), ('PySide2.QtGui.QContextMenuEvent.Reason', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.Qt.KeyboardModifiers')],
    "PySide2.QtGui.QContextMenuEvent.globalPos": (),
    "PySide2.QtGui.QContextMenuEvent.globalX": (),
    "PySide2.QtGui.QContextMenuEvent.global""Y": (),
    "PySide2.QtGui.QContextMenuEvent.pos": (),
    "PySide2.QtGui.QContextMenuEvent.reason": (),
    "PySide2.QtGui.QContextMenuEvent.x": (),
    "PySide2.QtGui.QContextMenuEvent.y": (),

# class PySide2.QtGui.QCursor:
    "PySide2.QtGui.QCursor.__init__": [(), ('PySide2.QtCore.Qt.CursorShape',), ('PySide2.QtGui.QBitmap', 'PySide2.QtGui.QBitmap', 'int', 'int'), ('PySide2.QtGui.QCursor',), ('PySide2.QtGui.QPixmap', 'int', 'int')],
    "PySide2.QtGui.QCursor.__copy__": (),
    "PySide2.QtGui.QCursor.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QCursor.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QCursor.bitmap": (),
    "PySide2.QtGui.QCursor.hotSpot": (),
    "PySide2.QtGui.QCursor.mask": (),
    "PySide2.QtGui.QCursor.pixmap": (),
    "PySide2.QtGui.QCursor.pos": [(), ('PySide2.QtGui.QScreen',)],
    "PySide2.QtGui.QCursor.setPos": [('PySide2.QtCore.QPoint',), ('PySide2.QtGui.QScreen', 'PySide2.QtCore.QPoint'), ('PySide2.QtGui.QScreen', 'int', 'int'), ('int', 'int')],
    "PySide2.QtGui.QCursor.setShape": ('PySide2.QtCore.Qt.CursorShape',),
    "PySide2.QtGui.QCursor.shape": (),
    "PySide2.QtGui.QCursor.swap": ('PySide2.QtGui.QCursor',),

# class PySide2.QtGui.QDesktopServices:
    "PySide2.QtGui.QDesktopServices.__init__": (),
    "PySide2.QtGui.QDesktopServices.openUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtGui.QDesktopServices.setUrlHandler": ('str', 'PySide2.QtCore.QObject', 'str'),
    "PySide2.QtGui.QDesktopServices.unsetUrlHandler": ('str',),

# class PySide2.QtGui.QDoubleValidator:

# class PySide2.QtGui.QDoubleValidator.Notation:
    "PySide2.QtGui.QDoubleValidator.__init__": [('PySide2.QtCore.QObject',), ('float', 'float', 'int', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QDoubleValidator.bottom": (),
    "PySide2.QtGui.QDoubleValidator.decimals": (),
    "PySide2.QtGui.QDoubleValidator.notation": (),
    "PySide2.QtGui.QDoubleValidator.setBottom": ('float',),
    "PySide2.QtGui.QDoubleValidator.setDecimals": ('int',),
    "PySide2.QtGui.QDoubleValidator.setNotation": ('PySide2.QtGui.QDoubleValidator.Notation',),
    "PySide2.QtGui.QDoubleValidator.setRange": ('float', 'float', 'int'),
    "PySide2.QtGui.QDoubleValidator.setTop": ('float',),
    "PySide2.QtGui.QDoubleValidator.top": (),
    "PySide2.QtGui.QDoubleValidator.validate": ('str', 'int'),

# class PySide2.QtGui.QDrag:
    "PySide2.QtGui.QDrag.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QDrag.cancel": (),
    "PySide2.QtGui.QDrag.defaultAction": (),
    "PySide2.QtGui.QDrag.dragCursor": ('PySide2.QtCore.Qt.DropAction',),
    "PySide2.QtGui.QDrag.exec_": [('PySide2.QtCore.Qt.DropActions',), ('PySide2.QtCore.Qt.DropActions', 'PySide2.QtCore.Qt.DropAction')],
    "PySide2.QtGui.QDrag.hotSpot": (),
    "PySide2.QtGui.QDrag.mimeData": (),
    "PySide2.QtGui.QDrag.pixmap": (),
    "PySide2.QtGui.QDrag.setDragCursor": ('PySide2.QtGui.QPixmap', 'PySide2.QtCore.Qt.DropAction'),
    "PySide2.QtGui.QDrag.setHotSpot": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QDrag.setMimeData": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtGui.QDrag.setPixmap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtGui.QDrag.source": (),
    "PySide2.QtGui.QDrag.start": ('PySide2.QtCore.Qt.DropActions',),
    "PySide2.QtGui.QDrag.supportedActions": (),
    "PySide2.QtGui.QDrag.target": (),

# class PySide2.QtGui.QDragEnterEvent:
    "PySide2.QtGui.QDragEnterEvent.__init__": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.Qt.DropActions', 'PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers'),

# class PySide2.QtGui.QDragLeaveEvent:
    "PySide2.QtGui.QDragLeaveEvent.__init__": (),

# class PySide2.QtGui.QDragMoveEvent:
    "PySide2.QtGui.QDragMoveEvent.__init__": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.Qt.DropActions', 'PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QEvent.Type'),
    "PySide2.QtGui.QDragMoveEvent.accept": [(), ('PySide2.QtCore.QRect',)],
    "PySide2.QtGui.QDragMoveEvent.answerRect": (),
    "PySide2.QtGui.QDragMoveEvent.ignore": [(), ('PySide2.QtCore.QRect',)],

# class PySide2.QtGui.QDropEvent:
    "PySide2.QtGui.QDropEvent.__init__": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.DropActions', 'PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QEvent.Type'),
    "PySide2.QtGui.QDropEvent.acceptProposedAction": (),
    "PySide2.QtGui.QDropEvent.dropAction": (),
    "PySide2.QtGui.QDropEvent.keyboardModifiers": (),
    "PySide2.QtGui.QDropEvent.mimeData": (),
    "PySide2.QtGui.QDropEvent.mouseButtons": (),
    "PySide2.QtGui.QDropEvent.pos": (),
    "PySide2.QtGui.QDropEvent.posF": (),
    "PySide2.QtGui.QDropEvent.possibleActions": (),
    "PySide2.QtGui.QDropEvent.proposedAction": (),
    "PySide2.QtGui.QDropEvent.setDropAction": ('PySide2.QtCore.Qt.DropAction',),
    "PySide2.QtGui.QDropEvent.source": (),

# class PySide2.QtGui.QEnterEvent:
    "PySide2.QtGui.QEnterEvent.__init__": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'),
    "PySide2.QtGui.QEnterEvent.globalPos": (),
    "PySide2.QtGui.QEnterEvent.globalX": (),
    "PySide2.QtGui.QEnterEvent.global""Y": (),
    "PySide2.QtGui.QEnterEvent.localPos": (),
    "PySide2.QtGui.QEnterEvent.pos": (),
    "PySide2.QtGui.QEnterEvent.screenPos": (),
    "PySide2.QtGui.QEnterEvent.windowPos": (),
    "PySide2.QtGui.QEnterEvent.x": (),
    "PySide2.QtGui.QEnterEvent.y": (),

# class PySide2.QtGui.QExposeEvent:
    "PySide2.QtGui.QExposeEvent.__init__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QExposeEvent.region": (),

# class PySide2.QtGui.QFileOpenEvent:
    "PySide2.QtGui.QFileOpenEvent.__init__": [('PySide2.QtCore.QUrl',), ('str',)],
    "PySide2.QtGui.QFileOpenEvent.file": (),
    "PySide2.QtGui.QFileOpenEvent.openFile": ('PySide2.QtCore.QFile', 'PySide2.QtCore.QIODevice.OpenMode'),
    "PySide2.QtGui.QFileOpenEvent.url": (),

# class PySide2.QtGui.QFocusEvent:
    "PySide2.QtGui.QFocusEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.Qt.FocusReason'),
    "PySide2.QtGui.QFocusEvent.gotFocus": (),
    "PySide2.QtGui.QFocusEvent.lostFocus": (),
    "PySide2.QtGui.QFocusEvent.reason": (),

# class PySide2.QtGui.QFont:

# class PySide2.QtGui.QFont.Capitalization:

# class PySide2.QtGui.QFont.HintingPreference:

# class PySide2.QtGui.QFont.SpacingType:

# class PySide2.QtGui.QFont.Stretch:

# class PySide2.QtGui.QFont.Style:

# class PySide2.QtGui.QFont.StyleHint:

# class PySide2.QtGui.QFont.StyleStrategy:

# class PySide2.QtGui.QFont.Weight:
    "PySide2.QtGui.QFont.__init__": [(), ('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFont', 'PySide2.QtGui.QPaintDevice'), ('str', 'int', 'int', 'bool')],
    "PySide2.QtGui.QFont.__copy__": (),
    "PySide2.QtGui.QFont.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QFont.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QFont.bold": (),
    "PySide2.QtGui.QFont.cacheStatistics": (),
    "PySide2.QtGui.QFont.capitalization": (),
    "PySide2.QtGui.QFont.cleanup": (),
    "PySide2.QtGui.QFont.defaultFamily": (),
    "PySide2.QtGui.QFont.exactMatch": (),
    "PySide2.QtGui.QFont.families": (),
    "PySide2.QtGui.QFont.family": (),
    "PySide2.QtGui.QFont.fixedPitch": (),
    "PySide2.QtGui.QFont.fromString": ('str',),
    "PySide2.QtGui.QFont.hintingPreference": (),
    "PySide2.QtGui.QFont.initialize": (),
    "PySide2.QtGui.QFont.insertSubstitution": ('str', 'str'),
    "PySide2.QtGui.QFont.insertSubstitutions": ('str', 'typing.Sequence[str]'),
    "PySide2.QtGui.QFont.isCopyOf": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QFont.italic": (),
    "PySide2.QtGui.QFont.kerning": (),
    "PySide2.QtGui.QFont.key": (),
    "PySide2.QtGui.QFont.lastResortFamily": (),
    "PySide2.QtGui.QFont.lastResortFont": (),
    "PySide2.QtGui.QFont.letterSpacing": (),
    "PySide2.QtGui.QFont.letterSpacingType": (),
    "PySide2.QtGui.QFont.overline": (),
    "PySide2.QtGui.QFont.pixelSize": (),
    "PySide2.QtGui.QFont.pointSize": (),
    "PySide2.QtGui.QFont.pointSizeF": (),
    "PySide2.QtGui.QFont.rawMode": (),
    "PySide2.QtGui.QFont.rawName": (),
    "PySide2.QtGui.QFont.removeSubstitutions": ('str',),
    "PySide2.QtGui.QFont.resolve": [(), ('PySide2.QtGui.QFont',), ('int',)],
    "PySide2.QtGui.QFont.setBold": ('bool',),
    "PySide2.QtGui.QFont.setCapitalization": ('PySide2.QtGui.QFont.Capitalization',),
    "PySide2.QtGui.QFont.setFamilies": ('typing.Sequence[str]',),
    "PySide2.QtGui.QFont.setFamily": ('str',),
    "PySide2.QtGui.QFont.setFixedPitch": ('bool',),
    "PySide2.QtGui.QFont.setHintingPreference": ('PySide2.QtGui.QFont.HintingPreference',),
    "PySide2.QtGui.QFont.setItalic": ('bool',),
    "PySide2.QtGui.QFont.setKerning": ('bool',),
    "PySide2.QtGui.QFont.setLetterSpacing": ('PySide2.QtGui.QFont.SpacingType', 'float'),
    "PySide2.QtGui.QFont.setOverline": ('bool',),
    "PySide2.QtGui.QFont.setPixelSize": ('int',),
    "PySide2.QtGui.QFont.setPointSize": ('int',),
    "PySide2.QtGui.QFont.setPointSizeF": ('float',),
    "PySide2.QtGui.QFont.setRawMode": ('bool',),
    "PySide2.QtGui.QFont.setRawName": ('str',),
    "PySide2.QtGui.QFont.setStretch": ('int',),
    "PySide2.QtGui.QFont.setStrikeOut": ('bool',),
    "PySide2.QtGui.QFont.setStyle": ('PySide2.QtGui.QFont.Style',),
    "PySide2.QtGui.QFont.setStyleHint": ('PySide2.QtGui.QFont.StyleHint', 'PySide2.QtGui.QFont.StyleStrategy'),
    "PySide2.QtGui.QFont.setStyleName": ('str',),
    "PySide2.QtGui.QFont.setStyleStrategy": ('PySide2.QtGui.QFont.StyleStrategy',),
    "PySide2.QtGui.QFont.setUnderline": ('bool',),
    "PySide2.QtGui.QFont.setWeight": ('int',),
    "PySide2.QtGui.QFont.setWordSpacing": ('float',),
    "PySide2.QtGui.QFont.stretch": (),
    "PySide2.QtGui.QFont.strikeOut": (),
    "PySide2.QtGui.QFont.style": (),
    "PySide2.QtGui.QFont.styleHint": (),
    "PySide2.QtGui.QFont.styleName": (),
    "PySide2.QtGui.QFont.styleStrategy": (),
    "PySide2.QtGui.QFont.substitute": ('str',),
    "PySide2.QtGui.QFont.substitutes": ('str',),
    "PySide2.QtGui.QFont.substitutions": (),
    "PySide2.QtGui.QFont.swap": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QFont.toString": (),
    "PySide2.QtGui.QFont.underline": (),
    "PySide2.QtGui.QFont.weight": (),
    "PySide2.QtGui.QFont.wordSpacing": (),

# class PySide2.QtGui.QFontDatabase:

# class PySide2.QtGui.QFontDatabase.SystemFont:

# class PySide2.QtGui.QFontDatabase.WritingSystem:
    "PySide2.QtGui.QFontDatabase.__init__": [(), ('PySide2.QtGui.QFontDatabase',)],
    "PySide2.QtGui.QFontDatabase.__copy__": (),
    "PySide2.QtGui.QFontDatabase.addApplicationFont": ('str',),
    "PySide2.QtGui.QFontDatabase.addApplicationFontFromData": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QFontDatabase.applicationFontFamilies": ('int',),
    "PySide2.QtGui.QFontDatabase.bold": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.families": ('PySide2.QtGui.QFontDatabase.WritingSystem',),
    "PySide2.QtGui.QFontDatabase.font": ('str', 'str', 'int'),
    "PySide2.QtGui.QFontDatabase.hasFamily": ('str',),
    "PySide2.QtGui.QFontDatabase.isBitmapScalable": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.isFixedPitch": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.isPrivateFamily": ('str',),
    "PySide2.QtGui.QFontDatabase.isScalable": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.isSmoothlyScalable": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.italic": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.pointSizes": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.removeAllApplicationFonts": (),
    "PySide2.QtGui.QFontDatabase.removeApplicationFont": ('int',),
    "PySide2.QtGui.QFontDatabase.smoothSizes": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.standardSizes": (),
    "PySide2.QtGui.QFontDatabase.styleString": [('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFontInfo',)],
    "PySide2.QtGui.QFontDatabase.styles": ('str',),
    "PySide2.QtGui.QFontDatabase.supportsThreadedFontRendering": (),
    "PySide2.QtGui.QFontDatabase.systemFont": ('PySide2.QtGui.QFontDatabase.SystemFont',),
    "PySide2.QtGui.QFontDatabase.weight": ('str', 'str'),
    "PySide2.QtGui.QFontDatabase.writingSystemName": ('PySide2.QtGui.QFontDatabase.WritingSystem',),
    "PySide2.QtGui.QFontDatabase.writingSystemSample": ('PySide2.QtGui.QFontDatabase.WritingSystem',),
    "PySide2.QtGui.QFontDatabase.writingSystems": [(), ('str',)],

# class PySide2.QtGui.QFontInfo:
    "PySide2.QtGui.QFontInfo.__init__": [('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFontInfo',)],
    "PySide2.QtGui.QFontInfo.__copy__": (),
    "PySide2.QtGui.QFontInfo.bold": (),
    "PySide2.QtGui.QFontInfo.exactMatch": (),
    "PySide2.QtGui.QFontInfo.family": (),
    "PySide2.QtGui.QFontInfo.fixedPitch": (),
    "PySide2.QtGui.QFontInfo.italic": (),
    "PySide2.QtGui.QFontInfo.overline": (),
    "PySide2.QtGui.QFontInfo.pixelSize": (),
    "PySide2.QtGui.QFontInfo.pointSize": (),
    "PySide2.QtGui.QFontInfo.pointSizeF": (),
    "PySide2.QtGui.QFontInfo.rawMode": (),
    "PySide2.QtGui.QFontInfo.strikeOut": (),
    "PySide2.QtGui.QFontInfo.style": (),
    "PySide2.QtGui.QFontInfo.styleHint": (),
    "PySide2.QtGui.QFontInfo.styleName": (),
    "PySide2.QtGui.QFontInfo.swap": ('PySide2.QtGui.QFontInfo',),
    "PySide2.QtGui.QFontInfo.underline": (),
    "PySide2.QtGui.QFontInfo.weight": (),

# class PySide2.QtGui.QFontMetrics:
    "PySide2.QtGui.QFontMetrics.__init__": [('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFont', 'PySide2.QtGui.QPaintDevice'), ('PySide2.QtGui.QFontMetrics',)],
    "PySide2.QtGui.QFontMetrics.__copy__": (),
    "PySide2.QtGui.QFontMetrics.ascent": (),
    "PySide2.QtGui.QFontMetrics.averageCharWidth": (),
    "PySide2.QtGui.QFontMetrics.boundingRect": [('PySide2.QtCore.QRect', 'int', 'str', 'int', 'shibokensupport.typing27.Sequence'), ('int', 'int', 'int', 'int', 'int', 'str', 'int', 'shibokensupport.typing27.Sequence'), ('str',)],
    "PySide2.QtGui.QFontMetrics.boundingRectChar": ('typing.Char',),
    "PySide2.QtGui.QFontMetrics.capHeight": (),
    "PySide2.QtGui.QFontMetrics.charWidth": ('str', 'int'),
    "PySide2.QtGui.QFontMetrics.descent": (),
    "PySide2.QtGui.QFontMetrics.elidedText": ('str', 'PySide2.QtCore.Qt.TextElideMode', 'int', 'int'),
    "PySide2.QtGui.QFontMetrics.fontDpi": (),
    "PySide2.QtGui.QFontMetrics.height": (),
    "PySide2.QtGui.QFontMetrics.horizontalAdvance": [('str', 'int'), ('typing.Char',)],
    "PySide2.QtGui.QFontMetrics.inFont": ('typing.Char',),
    "PySide2.QtGui.QFontMetrics.inFontUcs4": ('int',),
    "PySide2.QtGui.QFontMetrics.leading": (),
    "PySide2.QtGui.QFontMetrics.leftBearing": ('typing.Char',),
    "PySide2.QtGui.QFontMetrics.lineSpacing": (),
    "PySide2.QtGui.QFontMetrics.lineWidth": (),
    "PySide2.QtGui.QFontMetrics.maxWidth": (),
    "PySide2.QtGui.QFontMetrics.minLeftBearing": (),
    "PySide2.QtGui.QFontMetrics.minRightBearing": (),
    "PySide2.QtGui.QFontMetrics.overlinePos": (),
    "PySide2.QtGui.QFontMetrics.rightBearing": ('typing.Char',),
    "PySide2.QtGui.QFontMetrics.size": ('int', 'str', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QFontMetrics.strikeOutPos": (),
    "PySide2.QtGui.QFontMetrics.swap": ('PySide2.QtGui.QFontMetrics',),
    "PySide2.QtGui.QFontMetrics.tightBoundingRect": ('str',),
    "PySide2.QtGui.QFontMetrics.underlinePos": (),
    "PySide2.QtGui.QFontMetrics.width": [('str', 'int'), ('str', 'int', 'int')],
    "PySide2.QtGui.QFontMetrics.widthChar": ('typing.Char',),
    "PySide2.QtGui.QFontMetrics.xHeight": (),

# class PySide2.QtGui.QFontMetricsF:
    "PySide2.QtGui.QFontMetricsF.__init__": [('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFont', 'PySide2.QtGui.QPaintDevice'), ('PySide2.QtGui.QFontMetrics',), ('PySide2.QtGui.QFontMetricsF',)],
    "PySide2.QtGui.QFontMetricsF.__copy__": (),
    "PySide2.QtGui.QFontMetricsF.ascent": (),
    "PySide2.QtGui.QFontMetricsF.averageCharWidth": (),
    "PySide2.QtGui.QFontMetricsF.boundingRect": [('PySide2.QtCore.QRectF', 'int', 'str', 'int', 'shibokensupport.typing27.Sequence'), ('str',)],
    "PySide2.QtGui.QFontMetricsF.boundingRectChar": ('typing.Char',),
    "PySide2.QtGui.QFontMetricsF.capHeight": (),
    "PySide2.QtGui.QFontMetricsF.descent": (),
    "PySide2.QtGui.QFontMetricsF.elidedText": ('str', 'PySide2.QtCore.Qt.TextElideMode', 'float', 'int'),
    "PySide2.QtGui.QFontMetricsF.fontDpi": (),
    "PySide2.QtGui.QFontMetricsF.height": (),
    "PySide2.QtGui.QFontMetricsF.horizontalAdvance": [('str', 'int'), ('typing.Char',)],
    "PySide2.QtGui.QFontMetricsF.inFont": ('typing.Char',),
    "PySide2.QtGui.QFontMetricsF.inFontUcs4": ('int',),
    "PySide2.QtGui.QFontMetricsF.leading": (),
    "PySide2.QtGui.QFontMetricsF.leftBearing": ('typing.Char',),
    "PySide2.QtGui.QFontMetricsF.lineSpacing": (),
    "PySide2.QtGui.QFontMetricsF.lineWidth": (),
    "PySide2.QtGui.QFontMetricsF.maxWidth": (),
    "PySide2.QtGui.QFontMetricsF.minLeftBearing": (),
    "PySide2.QtGui.QFontMetricsF.minRightBearing": (),
    "PySide2.QtGui.QFontMetricsF.overlinePos": (),
    "PySide2.QtGui.QFontMetricsF.rightBearing": ('typing.Char',),
    "PySide2.QtGui.QFontMetricsF.size": ('int', 'str', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QFontMetricsF.strikeOutPos": (),
    "PySide2.QtGui.QFontMetricsF.swap": ('PySide2.QtGui.QFontMetricsF',),
    "PySide2.QtGui.QFontMetricsF.tightBoundingRect": ('str',),
    "PySide2.QtGui.QFontMetricsF.underlinePos": (),
    "PySide2.QtGui.QFontMetricsF.width": ('str',),
    "PySide2.QtGui.QFontMetricsF.widthChar": ('typing.Char',),
    "PySide2.QtGui.QFontMetricsF.xHeight": (),

# class PySide2.QtGui.QGradient:

# class PySide2.QtGui.QGradient.CoordinateMode:

# class PySide2.QtGui.QGradient.InterpolationMode:

# class PySide2.QtGui.QGradient.Preset:

# class PySide2.QtGui.QGradient.Spread:

# class PySide2.QtGui.QGradient.Type:
    "PySide2.QtGui.QGradient.__init__": [(), ('PySide2.QtGui.QGradient',), ('PySide2.QtGui.QGradient.Preset',)],
    "PySide2.QtGui.QGradient.__copy__": (),
    "PySide2.QtGui.QGradient.coordinateMode": (),
    "PySide2.QtGui.QGradient.interpolationMode": (),
    "PySide2.QtGui.QGradient.setColorAt": ('float', 'PySide2.QtGui.QColor'),
    "PySide2.QtGui.QGradient.setCoordinateMode": ('PySide2.QtGui.QGradient.CoordinateMode',),
    "PySide2.QtGui.QGradient.setInterpolationMode": ('PySide2.QtGui.QGradient.InterpolationMode',),
    "PySide2.QtGui.QGradient.setSpread": ('PySide2.QtGui.QGradient.Spread',),
    "PySide2.QtGui.QGradient.setStops": ('typing.List[typing.Tuple]',),
    "PySide2.QtGui.QGradient.spread": (),
    "PySide2.QtGui.QGradient.stops": (),
    "PySide2.QtGui.QGradient.type": (),

# class PySide2.QtGui.QGuiApplication:
    "PySide2.QtGui.QGuiApplication.__init__": [(), ('typing.Sequence[str]',)],
    "PySide2.QtGui.QGuiApplication.allWindows": (),
    "PySide2.QtGui.QGuiApplication.applicationDisplayName": (),
    "PySide2.QtGui.QGuiApplication.applicationState": (),
    "PySide2.QtGui.QGuiApplication.changeOverrideCursor": ('PySide2.QtGui.QCursor',),
    "PySide2.QtGui.QGuiApplication.clipboard": (),
    "PySide2.QtGui.QGuiApplication.desktopFileName": (),
    "PySide2.QtGui.QGuiApplication.desktopSettingsAware": (),
    "PySide2.QtGui.QGuiApplication.devicePixelRatio": (),
    "PySide2.QtGui.QGuiApplication.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtGui.QGuiApplication.exec_": (),
    "PySide2.QtGui.QGuiApplication.focusObject": (),
    "PySide2.QtGui.QGuiApplication.focusWindow": (),
    "PySide2.QtGui.QGuiApplication.font": (),
    "PySide2.QtGui.QGuiApplication.highDpiScaleFactorRoundingPolicy": (),
    "PySide2.QtGui.QGuiApplication.inputMethod": (),
    "PySide2.QtGui.QGuiApplication.isFallbackSessionManagementEnabled": (),
    "PySide2.QtGui.QGuiApplication.isLeftToRight": (),
    "PySide2.QtGui.QGuiApplication.isRightToLeft": (),
    "PySide2.QtGui.QGuiApplication.isSavingSession": (),
    "PySide2.QtGui.QGuiApplication.isSessionRestored": (),
    "PySide2.QtGui.QGuiApplication.keyboardModifiers": (),
    "PySide2.QtGui.QGuiApplication.layoutDirection": (),
    "PySide2.QtGui.QGuiApplication.modalWindow": (),
    "PySide2.QtGui.QGuiApplication.mouseButtons": (),
    "PySide2.QtGui.QGuiApplication.notify": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtGui.QGuiApplication.overrideCursor": (),
    "PySide2.QtGui.QGuiApplication.palette": (),
    "PySide2.QtGui.QGuiApplication.platformName": (),
    "PySide2.QtGui.QGuiApplication.primaryScreen": (),
    "PySide2.QtGui.QGuiApplication.queryKeyboardModifiers": (),
    "PySide2.QtGui.QGuiApplication.quitOnLastWindowClosed": (),
    "PySide2.QtGui.QGuiApplication.restoreOverrideCursor": (),
    "PySide2.QtGui.QGuiApplication.screenAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QGuiApplication.screens": (),
    "PySide2.QtGui.QGuiApplication.sessionId": (),
    "PySide2.QtGui.QGuiApplication.sessionKey": (),
    "PySide2.QtGui.QGuiApplication.setApplicationDisplayName": ('str',),
    "PySide2.QtGui.QGuiApplication.setDesktopFileName": ('str',),
    "PySide2.QtGui.QGuiApplication.setDesktopSettingsAware": ('bool',),
    "PySide2.QtGui.QGuiApplication.setFallbackSessionManagementEnabled": ('bool',),
    "PySide2.QtGui.QGuiApplication.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QGuiApplication.setHighDpiScaleFactorRoundingPolicy": ('PySide2.QtCore.Qt.HighDpiScaleFactorRoundingPolicy',),
    "PySide2.QtGui.QGuiApplication.setLayoutDirection": ('PySide2.QtCore.Qt.LayoutDirection',),
    "PySide2.QtGui.QGuiApplication.setOverrideCursor": ('PySide2.QtGui.QCursor',),
    "PySide2.QtGui.QGuiApplication.setPalette": ('PySide2.QtGui.QPalette',),
    "PySide2.QtGui.QGuiApplication.setQuitOnLastWindowClosed": ('bool',),
    "PySide2.QtGui.QGuiApplication.setWindowIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtGui.QGuiApplication.styleHints": (),
    "PySide2.QtGui.QGuiApplication.sync": (),
    "PySide2.QtGui.QGuiApplication.topLevelAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QGuiApplication.topLevelWindows": (),
    "PySide2.QtGui.QGuiApplication.windowIcon": (),

# class PySide2.QtGui.QHelpEvent:
    "PySide2.QtGui.QHelpEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'),
    "PySide2.QtGui.QHelpEvent.globalPos": (),
    "PySide2.QtGui.QHelpEvent.globalX": (),
    "PySide2.QtGui.QHelpEvent.global""Y": (),
    "PySide2.QtGui.QHelpEvent.pos": (),
    "PySide2.QtGui.QHelpEvent.x": (),
    "PySide2.QtGui.QHelpEvent.y": (),

# class PySide2.QtGui.QHideEvent:
    "PySide2.QtGui.QHideEvent.__init__": (),

# class PySide2.QtGui.QHoverEvent:
    "PySide2.QtGui.QHoverEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtGui.QHoverEvent.oldPos": (),
    "PySide2.QtGui.QHoverEvent.oldPosF": (),
    "PySide2.QtGui.QHoverEvent.pos": (),
    "PySide2.QtGui.QHoverEvent.posF": (),

# class PySide2.QtGui.QIcon:

# class PySide2.QtGui.QIcon.Mode:

# class PySide2.QtGui.QIcon.State:
    "PySide2.QtGui.QIcon.__init__": [(), ('PySide2.QtGui.QIcon',), ('PySide2.QtGui.QIconEngine',), ('PySide2.QtGui.QPixmap',), ('str',)],
    "PySide2.QtGui.QIcon.__copy__": (),
    "PySide2.QtGui.QIcon.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QIcon.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QIcon.actualSize": [('PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'), ('PySide2.QtGui.QWindow', 'PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State')],
    "PySide2.QtGui.QIcon.addFile": ('str', 'PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIcon.addPixmap": ('PySide2.QtGui.QPixmap', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIcon.availableSizes": ('PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIcon.cacheKey": (),
    "PySide2.QtGui.QIcon.fallbackSearchPaths": (),
    "PySide2.QtGui.QIcon.fallbackThemeName": (),
    "PySide2.QtGui.QIcon.fromTheme": [('str',), ('str', 'PySide2.QtGui.QIcon')],
    "PySide2.QtGui.QIcon.hasThemeIcon": ('str',),
    "PySide2.QtGui.QIcon.isMask": (),
    "PySide2.QtGui.QIcon.isNull": (),
    "PySide2.QtGui.QIcon.name": (),
    "PySide2.QtGui.QIcon.paint": [('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.Alignment', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'), ('PySide2.QtGui.QPainter', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.Alignment', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State')],
    "PySide2.QtGui.QIcon.pixmap": [('PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'), ('PySide2.QtGui.QWindow', 'PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'), ('int', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'), ('int', 'int', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State')],
    "PySide2.QtGui.QIcon.setFallbackSearchPaths": ('typing.Sequence[str]',),
    "PySide2.QtGui.QIcon.setFallbackThemeName": ('str',),
    "PySide2.QtGui.QIcon.setIsMask": ('bool',),
    "PySide2.QtGui.QIcon.setThemeName": ('str',),
    "PySide2.QtGui.QIcon.setThemeSearchPaths": ('typing.Sequence[str]',),
    "PySide2.QtGui.QIcon.swap": ('PySide2.QtGui.QIcon',),
    "PySide2.QtGui.QIcon.themeName": (),
    "PySide2.QtGui.QIcon.themeSearchPaths": (),

# class PySide2.QtGui.QIconDragEvent:
    "PySide2.QtGui.QIconDragEvent.__init__": (),

# class PySide2.QtGui.QIconEngine:

# class PySide2.QtGui.QIconEngine.AvailableSizesArgument:
    "PySide2.QtGui.QIconEngine.AvailableSizesArgument.__init__": (),

# class PySide2.QtGui.QIconEngine.IconEngineHook:

    "PySide2.QtGui.QIconEngine.__init__": [(), ('PySide2.QtGui.QIconEngine',)],
    "PySide2.QtGui.QIconEngine.actualSize": ('PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIconEngine.addFile": ('str', 'PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIconEngine.addPixmap": ('PySide2.QtGui.QPixmap', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIconEngine.availableSizes": ('PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIconEngine.clone": (),
    "PySide2.QtGui.QIconEngine.iconName": (),
    "PySide2.QtGui.QIconEngine.isNull": (),
    "PySide2.QtGui.QIconEngine.key": (),
    "PySide2.QtGui.QIconEngine.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIconEngine.pixmap": ('PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State'),
    "PySide2.QtGui.QIconEngine.read": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QIconEngine.scaledPixmap": ('PySide2.QtCore.QSize', 'PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QIcon.State', 'float'),
    "PySide2.QtGui.QIconEngine.write": ('PySide2.QtCore.QDataStream',),

# class PySide2.QtGui.QImage:

# class PySide2.QtGui.QImage.Format:

# class PySide2.QtGui.QImage.InvertMode:
    "PySide2.QtGui.QImage.__init__": [(), ('PySide2.QtCore.QSize', 'PySide2.QtGui.QImage.Format'), ('PySide2.QtGui.QImage',), ('int', 'int', 'PySide2.QtGui.QImage.Format'), ('str', 'int', 'int', 'PySide2.QtGui.QImage.Format'), ('str', 'int', 'int', 'PySide2.QtGui.QImage.Format', 'typing.Callable', 'int'), ('str', 'int', 'int', 'int', 'PySide2.QtGui.QImage.Format'), ('str', 'int', 'int', 'int', 'PySide2.QtGui.QImage.Format', 'typing.Callable', 'int'), ('str', 'str'), ('typing.Sequence[str]',)],
    "PySide2.QtGui.QImage.__copy__": (),
    "PySide2.QtGui.QImage.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QImage.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QImage.allGray": (),
    "PySide2.QtGui.QImage.alphaChannel": (),
    "PySide2.QtGui.QImage.bitPlaneCount": (),
    "PySide2.QtGui.QImage.bits": (),
    "PySide2.QtGui.QImage.byteCount": (),
    "PySide2.QtGui.QImage.bytesPerLine": (),
    "PySide2.QtGui.QImage.cacheKey": (),
    "PySide2.QtGui.QImage.color": ('int',),
    "PySide2.QtGui.QImage.colorCount": (),
    "PySide2.QtGui.QImage.colorSpace": (),
    "PySide2.QtGui.QImage.colorTable": (),
    "PySide2.QtGui.QImage.constBits": (),
    "PySide2.QtGui.QImage.constScanLine": ('int',),
    "PySide2.QtGui.QImage.convertTo": ('PySide2.QtGui.QImage.Format', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QImage.convertToColorSpace": ('PySide2.QtGui.QColorSpace',),
    "PySide2.QtGui.QImage.convertToFormat": [('PySide2.QtGui.QImage.Format', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('PySide2.QtGui.QImage.Format', 'typing.List[int]', 'PySide2.QtCore.Qt.ImageConversionFlags')],
    "PySide2.QtGui.QImage.convertToFormat_helper": ('PySide2.QtGui.QImage.Format', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QImage.convertToFormat_inplace": ('PySide2.QtGui.QImage.Format', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QImage.convertedToColorSpace": ('PySide2.QtGui.QColorSpace',),
    "PySide2.QtGui.QImage.copy": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QImage.createAlphaMask": ('PySide2.QtCore.Qt.ImageConversionFlags',),
    "PySide2.QtGui.QImage.createHeuristicMask": ('bool',),
    "PySide2.QtGui.QImage.createMaskFromColor": ('int', 'PySide2.QtCore.Qt.MaskMode'),
    "PySide2.QtGui.QImage.depth": (),
    "PySide2.QtGui.QImage.devType": (),
    "PySide2.QtGui.QImage.devicePixelRatio": (),
    "PySide2.QtGui.QImage.dotsPerMeterX": (),
    "PySide2.QtGui.QImage.dotsPerMeterY": (),
    "PySide2.QtGui.QImage.fill": [('PySide2.QtCore.Qt.GlobalColor',), ('PySide2.QtGui.QColor',), ('int',)],
    "PySide2.QtGui.QImage.format": (),
    "PySide2.QtGui.QImage.fromData": ('PySide2.QtCore.QByteArray', 'str'),
    "PySide2.QtGui.QImage.hasAlphaChannel": (),
    "PySide2.QtGui.QImage.height": (),
    "PySide2.QtGui.QImage.invertPixels": ('PySide2.QtGui.QImage.InvertMode',),
    "PySide2.QtGui.QImage.isGrayscale": (),
    "PySide2.QtGui.QImage.isNull": (),
    "PySide2.QtGui.QImage.load": [('PySide2.QtCore.QIODevice', 'str'), ('str', 'str')],
    "PySide2.QtGui.QImage.loadFromData": ('PySide2.QtCore.QByteArray', 'str'),
    "PySide2.QtGui.QImage.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QImage.mirrored": ('bool', 'bool'),
    "PySide2.QtGui.QImage.mirrored_helper": ('bool', 'bool'),
    "PySide2.QtGui.QImage.mirrored_inplace": ('bool', 'bool'),
    "PySide2.QtGui.QImage.offset": (),
    "PySide2.QtGui.QImage.paintEngine": (),
    "PySide2.QtGui.QImage.pixel": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QImage.pixelColor": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QImage.pixelFormat": (),
    "PySide2.QtGui.QImage.pixelIndex": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QImage.rect": (),
    "PySide2.QtGui.QImage.reinterpretAsFormat": ('PySide2.QtGui.QImage.Format',),
    "PySide2.QtGui.QImage.rgbSwapped": (),
    "PySide2.QtGui.QImage.rgbSwapped_helper": (),
    "PySide2.QtGui.QImage.rgbSwapped_inplace": (),
    "PySide2.QtGui.QImage.save": [('PySide2.QtCore.QIODevice', 'str', 'int'), ('str', 'str', 'int')],
    "PySide2.QtGui.QImage.scaled": [('PySide2.QtCore.QSize', 'PySide2.QtCore.Qt.AspectRatioMode', 'PySide2.QtCore.Qt.TransformationMode'), ('int', 'int', 'PySide2.QtCore.Qt.AspectRatioMode', 'PySide2.QtCore.Qt.TransformationMode')],
    "PySide2.QtGui.QImage.scaledToHeight": ('int', 'PySide2.QtCore.Qt.TransformationMode'),
    "PySide2.QtGui.QImage.scaledToWidth": ('int', 'PySide2.QtCore.Qt.TransformationMode'),
    "PySide2.QtGui.QImage.scanLine": ('int',),
    "PySide2.QtGui.QImage.setAlphaChannel": ('PySide2.QtGui.QImage',),
    "PySide2.QtGui.QImage.setColor": ('int', 'int'),
    "PySide2.QtGui.QImage.setColorCount": ('int',),
    "PySide2.QtGui.QImage.setColorSpace": ('PySide2.QtGui.QColorSpace',),
    "PySide2.QtGui.QImage.setColorTable": ('typing.List[int]',),
    "PySide2.QtGui.QImage.setDevicePixelRatio": ('float',),
    "PySide2.QtGui.QImage.setDotsPerMeterX": ('int',),
    "PySide2.QtGui.QImage.setDotsPerMeterY": ('int',),
    "PySide2.QtGui.QImage.setOffset": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QImage.setPixel": [('PySide2.QtCore.QPoint', 'int'), ('int', 'int', 'int')],
    "PySide2.QtGui.QImage.setPixelColor": [('PySide2.QtCore.QPoint', 'PySide2.QtGui.QColor'), ('int', 'int', 'PySide2.QtGui.QColor')],
    "PySide2.QtGui.QImage.setText": ('str', 'str'),
    "PySide2.QtGui.QImage.size": (),
    "PySide2.QtGui.QImage.sizeInBytes": (),
    "PySide2.QtGui.QImage.smoothScaled": ('int', 'int'),
    "PySide2.QtGui.QImage.swap": ('PySide2.QtGui.QImage',),
    "PySide2.QtGui.QImage.text": ('str',),
    "PySide2.QtGui.QImage.textKeys": (),
    "PySide2.QtGui.QImage.toImageFormat": ('PySide2.QtGui.QPixelFormat',),
    "PySide2.QtGui.QImage.toPixelFormat": ('PySide2.QtGui.QImage.Format',),
    "PySide2.QtGui.QImage.transformed": [('PySide2.QtGui.QMatrix', 'PySide2.QtCore.Qt.TransformationMode'), ('PySide2.QtGui.QTransform', 'PySide2.QtCore.Qt.TransformationMode')],
    "PySide2.QtGui.QImage.trueMatrix": [('PySide2.QtGui.QMatrix', 'int', 'int'), ('PySide2.QtGui.QTransform', 'int', 'int')],
    "PySide2.QtGui.QImage.valid": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QImage.width": (),

# class PySide2.QtGui.QImageIOHandler:

# class PySide2.QtGui.QImageIOHandler.ImageOption:

# class PySide2.QtGui.QImageIOHandler.Transformation:

# class PySide2.QtGui.QImageIOHandler.Transformations:
    "PySide2.QtGui.QImageIOHandler.__init__": (),
    "PySide2.QtGui.QImageIOHandler.canRead": (),
    "PySide2.QtGui.QImageIOHandler.currentImageNumber": (),
    "PySide2.QtGui.QImageIOHandler.currentImageRect": (),
    "PySide2.QtGui.QImageIOHandler.device": (),
    "PySide2.QtGui.QImageIOHandler.format": (),
    "PySide2.QtGui.QImageIOHandler.imageCount": (),
    "PySide2.QtGui.QImageIOHandler.jumpToImage": ('int',),
    "PySide2.QtGui.QImageIOHandler.jumpToNextImage": (),
    "PySide2.QtGui.QImageIOHandler.loopCount": (),
    "PySide2.QtGui.QImageIOHandler.name": (),
    "PySide2.QtGui.QImageIOHandler.nextImageDelay": (),
    "PySide2.QtGui.QImageIOHandler.option": ('PySide2.QtGui.QImageIOHandler.ImageOption',),
    "PySide2.QtGui.QImageIOHandler.read": ('PySide2.QtGui.QImage',),
    "PySide2.QtGui.QImageIOHandler.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtGui.QImageIOHandler.setFormat": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QImageIOHandler.setOption": ('PySide2.QtGui.QImageIOHandler.ImageOption', 'typing.Any'),
    "PySide2.QtGui.QImageIOHandler.supportsOption": ('PySide2.QtGui.QImageIOHandler.ImageOption',),
    "PySide2.QtGui.QImageIOHandler.write": ('PySide2.QtGui.QImage',),

# class PySide2.QtGui.QImageReader:

# class PySide2.QtGui.QImageReader.ImageReaderError:
    "PySide2.QtGui.QImageReader.__init__": [(), ('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QByteArray'), ('str', 'PySide2.QtCore.QByteArray')],
    "PySide2.QtGui.QImageReader.autoDetectImageFormat": (),
    "PySide2.QtGui.QImageReader.autoTransform": (),
    "PySide2.QtGui.QImageReader.backgroundColor": (),
    "PySide2.QtGui.QImageReader.canRead": (),
    "PySide2.QtGui.QImageReader.clipRect": (),
    "PySide2.QtGui.QImageReader.currentImageNumber": (),
    "PySide2.QtGui.QImageReader.currentImageRect": (),
    "PySide2.QtGui.QImageReader.decideFormatFromContent": (),
    "PySide2.QtGui.QImageReader.device": (),
    "PySide2.QtGui.QImageReader.error": (),
    "PySide2.QtGui.QImageReader.errorString": (),
    "PySide2.QtGui.QImageReader.fileName": (),
    "PySide2.QtGui.QImageReader.format": (),
    "PySide2.QtGui.QImageReader.gamma": (),
    "PySide2.QtGui.QImageReader.imageCount": (),
    "PySide2.QtGui.QImageReader.imageFormat": [(), ('PySide2.QtCore.QIODevice',), ('str',)],
    "PySide2.QtGui.QImageReader.imageFormatsForMimeType": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QImageReader.jumpToImage": ('int',),
    "PySide2.QtGui.QImageReader.jumpToNextImage": (),
    "PySide2.QtGui.QImageReader.loopCount": (),
    "PySide2.QtGui.QImageReader.nextImageDelay": (),
    "PySide2.QtGui.QImageReader.quality": (),
    "PySide2.QtGui.QImageReader.read": (),
    "PySide2.QtGui.QImageReader.scaledClipRect": (),
    "PySide2.QtGui.QImageReader.scaledSize": (),
    "PySide2.QtGui.QImageReader.setAutoDetectImageFormat": ('bool',),
    "PySide2.QtGui.QImageReader.setAutoTransform": ('bool',),
    "PySide2.QtGui.QImageReader.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtGui.QImageReader.setClipRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtGui.QImageReader.setDecideFormatFromContent": ('bool',),
    "PySide2.QtGui.QImageReader.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtGui.QImageReader.setFileName": ('str',),
    "PySide2.QtGui.QImageReader.setFormat": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QImageReader.setGamma": ('float',),
    "PySide2.QtGui.QImageReader.setQuality": ('int',),
    "PySide2.QtGui.QImageReader.setScaledClipRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtGui.QImageReader.setScaledSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QImageReader.size": (),
    "PySide2.QtGui.QImageReader.subType": (),
    "PySide2.QtGui.QImageReader.supportedImageFormats": (),
    "PySide2.QtGui.QImageReader.supportedMimeTypes": (),
    "PySide2.QtGui.QImageReader.supportedSubTypes": (),
    "PySide2.QtGui.QImageReader.supportsAnimation": (),
    "PySide2.QtGui.QImageReader.supportsOption": ('PySide2.QtGui.QImageIOHandler.ImageOption',),
    "PySide2.QtGui.QImageReader.text": ('str',),
    "PySide2.QtGui.QImageReader.textKeys": (),
    "PySide2.QtGui.QImageReader.transformation": (),

# class PySide2.QtGui.QImageWriter:

# class PySide2.QtGui.QImageWriter.ImageWriterError:
    "PySide2.QtGui.QImageWriter.__init__": [(), ('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QByteArray'), ('str', 'PySide2.QtCore.QByteArray')],
    "PySide2.QtGui.QImageWriter.canWrite": (),
    "PySide2.QtGui.QImageWriter.compression": (),
    "PySide2.QtGui.QImageWriter.description": (),
    "PySide2.QtGui.QImageWriter.device": (),
    "PySide2.QtGui.QImageWriter.error": (),
    "PySide2.QtGui.QImageWriter.errorString": (),
    "PySide2.QtGui.QImageWriter.fileName": (),
    "PySide2.QtGui.QImageWriter.format": (),
    "PySide2.QtGui.QImageWriter.gamma": (),
    "PySide2.QtGui.QImageWriter.imageFormatsForMimeType": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QImageWriter.optimizedWrite": (),
    "PySide2.QtGui.QImageWriter.progressiveScanWrite": (),
    "PySide2.QtGui.QImageWriter.quality": (),
    "PySide2.QtGui.QImageWriter.setCompression": ('int',),
    "PySide2.QtGui.QImageWriter.setDescription": ('str',),
    "PySide2.QtGui.QImageWriter.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtGui.QImageWriter.setFileName": ('str',),
    "PySide2.QtGui.QImageWriter.setFormat": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QImageWriter.setGamma": ('float',),
    "PySide2.QtGui.QImageWriter.setOptimizedWrite": ('bool',),
    "PySide2.QtGui.QImageWriter.setProgressiveScanWrite": ('bool',),
    "PySide2.QtGui.QImageWriter.setQuality": ('int',),
    "PySide2.QtGui.QImageWriter.setSubType": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QImageWriter.setText": ('str', 'str'),
    "PySide2.QtGui.QImageWriter.setTransformation": ('PySide2.QtGui.QImageIOHandler.Transformations',),
    "PySide2.QtGui.QImageWriter.subType": (),
    "PySide2.QtGui.QImageWriter.supportedImageFormats": (),
    "PySide2.QtGui.QImageWriter.supportedMimeTypes": (),
    "PySide2.QtGui.QImageWriter.supportedSubTypes": (),
    "PySide2.QtGui.QImageWriter.supportsOption": ('PySide2.QtGui.QImageIOHandler.ImageOption',),
    "PySide2.QtGui.QImageWriter.transformation": (),
    "PySide2.QtGui.QImageWriter.write": ('PySide2.QtGui.QImage',),

# class PySide2.QtGui.QInputEvent:
    "PySide2.QtGui.QInputEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtGui.QInputEvent.modifiers": (),
    "PySide2.QtGui.QInputEvent.setModifiers": ('PySide2.QtCore.Qt.KeyboardModifiers',),
    "PySide2.QtGui.QInputEvent.setTimestamp": ('int',),
    "PySide2.QtGui.QInputEvent.timestamp": (),

# class PySide2.QtGui.QInputMethod:

# class PySide2.QtGui.QInputMethod.Action:
    "PySide2.QtGui.QInputMethod.anchorRectangle": (),
    "PySide2.QtGui.QInputMethod.commit": (),
    "PySide2.QtGui.QInputMethod.cursorRectangle": (),
    "PySide2.QtGui.QInputMethod.hide": (),
    "PySide2.QtGui.QInputMethod.inputDirection": (),
    "PySide2.QtGui.QInputMethod.inputItemClipRectangle": (),
    "PySide2.QtGui.QInputMethod.inputItemRectangle": (),
    "PySide2.QtGui.QInputMethod.inputItemTransform": (),
    "PySide2.QtGui.QInputMethod.invokeAction": ('PySide2.QtGui.QInputMethod.Action', 'int'),
    "PySide2.QtGui.QInputMethod.isAnimating": (),
    "PySide2.QtGui.QInputMethod.isVisible": (),
    "PySide2.QtGui.QInputMethod.keyboardRectangle": (),
    "PySide2.QtGui.QInputMethod.locale": (),
    "PySide2.QtGui.QInputMethod.queryFocusObject": ('PySide2.QtCore.Qt.InputMethodQuery', 'typing.Any'),
    "PySide2.QtGui.QInputMethod.reset": (),
    "PySide2.QtGui.QInputMethod.setInputItemRectangle": ('PySide2.QtCore.QRectF',),
    "PySide2.QtGui.QInputMethod.setInputItemTransform": ('PySide2.QtGui.QTransform',),
    "PySide2.QtGui.QInputMethod.setVisible": ('bool',),
    "PySide2.QtGui.QInputMethod.show": (),
    "PySide2.QtGui.QInputMethod.update": ('PySide2.QtCore.Qt.InputMethodQueries',),

# class PySide2.QtGui.QInputMethodEvent:

# class PySide2.QtGui.QInputMethodEvent.Attribute:
    "PySide2.QtGui.QInputMethodEvent.Attribute.__init__": [('PySide2.QtGui.QInputMethodEvent.Attribute',), ('PySide2.QtGui.QInputMethodEvent.AttributeType', 'int', 'int'), ('PySide2.QtGui.QInputMethodEvent.AttributeType', 'int', 'int', 'typing.Any')],
    "PySide2.QtGui.QInputMethodEvent.Attribute.__copy__": (),

# class PySide2.QtGui.QInputMethodEvent.AttributeType:

    "PySide2.QtGui.QInputMethodEvent.__init__": [(), ('PySide2.QtGui.QInputMethodEvent',), ('str', 'typing.Sequence[PySide2.QtGui.QInputMethodEvent.Attribute]')],
    "PySide2.QtGui.QInputMethodEvent.attributes": (),
    "PySide2.QtGui.QInputMethodEvent.commitString": (),
    "PySide2.QtGui.QInputMethodEvent.preeditString": (),
    "PySide2.QtGui.QInputMethodEvent.replacementLength": (),
    "PySide2.QtGui.QInputMethodEvent.replacementStart": (),
    "PySide2.QtGui.QInputMethodEvent.setCommitString": ('str', 'int', 'int'),

# class PySide2.QtGui.QInputMethodQueryEvent:
    "PySide2.QtGui.QInputMethodQueryEvent.__init__": ('PySide2.QtCore.Qt.InputMethodQueries',),
    "PySide2.QtGui.QInputMethodQueryEvent.queries": (),
    "PySide2.QtGui.QInputMethodQueryEvent.setValue": ('PySide2.QtCore.Qt.InputMethodQuery', 'typing.Any'),
    "PySide2.QtGui.QInputMethodQueryEvent.value": ('PySide2.QtCore.Qt.InputMethodQuery',),

# class PySide2.QtGui.QIntValidator:
    "PySide2.QtGui.QIntValidator.__init__": [('PySide2.QtCore.QObject',), ('int', 'int', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QIntValidator.bottom": (),
    "PySide2.QtGui.QIntValidator.fixup": ('str',),
    "PySide2.QtGui.QIntValidator.setBottom": ('int',),
    "PySide2.QtGui.QIntValidator.setRange": ('int', 'int'),
    "PySide2.QtGui.QIntValidator.setTop": ('int',),
    "PySide2.QtGui.QIntValidator.top": (),
    "PySide2.QtGui.QIntValidator.validate": ('str', 'int'),

# class PySide2.QtGui.QKeyEvent:
    "PySide2.QtGui.QKeyEvent.__init__": [('PySide2.QtCore.QEvent.Type', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int', 'int', 'int', 'str', 'bool', 'int'), ('PySide2.QtCore.QEvent.Type', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'str', 'bool', 'int')],
    "PySide2.QtGui.QKeyEvent.count": (),
    "PySide2.QtGui.QKeyEvent.isAutoRepeat": (),
    "PySide2.QtGui.QKeyEvent.key": (),
    "PySide2.QtGui.QKeyEvent.matches": ('PySide2.QtGui.QKeySequence.StandardKey',),
    "PySide2.QtGui.QKeyEvent.modifiers": (),
    "PySide2.QtGui.QKeyEvent.nativeModifiers": (),
    "PySide2.QtGui.QKeyEvent.nativeScanCode": (),
    "PySide2.QtGui.QKeyEvent.nativeVirtualKey": (),
    "PySide2.QtGui.QKeyEvent.text": (),

# class PySide2.QtGui.QKeySequence:

# class PySide2.QtGui.QKeySequence.SequenceFormat:

# class PySide2.QtGui.QKeySequence.SequenceMatch:

# class PySide2.QtGui.QKeySequence.StandardKey:
    "PySide2.QtGui.QKeySequence.__init__": [(), ('PySide2.QtGui.QKeySequence',), ('PySide2.QtGui.QKeySequence.StandardKey',), ('int', 'int', 'int', 'int'), ('str', 'PySide2.QtGui.QKeySequence.SequenceFormat')],
    "PySide2.QtGui.QKeySequence.__copy__": (),
    "PySide2.QtGui.QKeySequence.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QKeySequence.__reduce__": (),
    "PySide2.QtGui.QKeySequence.__repr__": (),
    "PySide2.QtGui.QKeySequence.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QKeySequence.count": (),
    "PySide2.QtGui.QKeySequence.fromString": ('str', 'PySide2.QtGui.QKeySequence.SequenceFormat'),
    "PySide2.QtGui.QKeySequence.isEmpty": (),
    "PySide2.QtGui.QKeySequence.keyBindings": ('PySide2.QtGui.QKeySequence.StandardKey',),
    "PySide2.QtGui.QKeySequence.listFromString": ('str', 'PySide2.QtGui.QKeySequence.SequenceFormat'),
    "PySide2.QtGui.QKeySequence.listToString": ('typing.Sequence[PySide2.QtGui.QKeySequence]', 'PySide2.QtGui.QKeySequence.SequenceFormat'),
    "PySide2.QtGui.QKeySequence.matches": ('PySide2.QtGui.QKeySequence',),
    "PySide2.QtGui.QKeySequence.mnemonic": ('str',),
    "PySide2.QtGui.QKeySequence.swap": ('PySide2.QtGui.QKeySequence',),
    "PySide2.QtGui.QKeySequence.toString": ('PySide2.QtGui.QKeySequence.SequenceFormat',),

# class PySide2.QtGui.QLinearGradient:
    "PySide2.QtGui.QLinearGradient.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('PySide2.QtGui.QLinearGradient',), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QLinearGradient.__copy__": (),
    "PySide2.QtGui.QLinearGradient.finalStop": (),
    "PySide2.QtGui.QLinearGradient.setFinalStop": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QLinearGradient.setStart": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QLinearGradient.start": (),

# class PySide2.QtGui.QMatrix:
    "PySide2.QtGui.QMatrix.__init__": [(), ('PySide2.QtGui.QMatrix',), ('float', 'float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QMatrix.__copy__": (),
    "PySide2.QtGui.QMatrix.__imul__": ('PySide2.QtGui.QMatrix',),
    "PySide2.QtGui.QMatrix.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QMatrix.__mul__": [('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QMatrix',)],
    "PySide2.QtGui.QMatrix.__reduce__": (),
    "PySide2.QtGui.QMatrix.__repr__": (),
    "PySide2.QtGui.QMatrix.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QMatrix.determinant": (),
    "PySide2.QtGui.QMatrix.dx": (),
    "PySide2.QtGui.QMatrix.dy": (),
    "PySide2.QtGui.QMatrix.inverted": (),
    "PySide2.QtGui.QMatrix.isIdentity": (),
    "PySide2.QtGui.QMatrix.isInvertible": (),
    "PySide2.QtGui.QMatrix.m11": (),
    "PySide2.QtGui.QMatrix.m12": (),
    "PySide2.QtGui.QMatrix.m21": (),
    "PySide2.QtGui.QMatrix.m22": (),
    "PySide2.QtGui.QMatrix.map": [('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygon',), ('PySide2.QtGui.QPolygonF',), ('PySide2.QtGui.QRegion',), ('float', 'float'), ('int', 'int')],
    "PySide2.QtGui.QMatrix.mapRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtGui.QMatrix.mapToPolygon": ('PySide2.QtCore.QRect',),
    "PySide2.QtGui.QMatrix.reset": (),
    "PySide2.QtGui.QMatrix.rotate": ('float',),
    "PySide2.QtGui.QMatrix.scale": ('float', 'float'),
    "PySide2.QtGui.QMatrix.setMatrix": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QMatrix.shear": ('float', 'float'),
    "PySide2.QtGui.QMatrix.translate": ('float', 'float'),

# class PySide2.QtGui.QMatrix2x2:
    "PySide2.QtGui.QMatrix2x2.__init__": [(), ('PySide2.QtGui.QMatrix2x2',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix2x2.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix2x2.__copy__": (),
    "PySide2.QtGui.QMatrix2x2.__iadd__": ('PySide2.QtGui.QMatrix2x2',),
    "PySide2.QtGui.QMatrix2x2.__imul__": ('float',),
    "PySide2.QtGui.QMatrix2x2.__isub__": ('PySide2.QtGui.QMatrix2x2',),
    "PySide2.QtGui.QMatrix2x2.__reduce__": (),
    "PySide2.QtGui.QMatrix2x2.__repr__": (),
    "PySide2.QtGui.QMatrix2x2.data": (),
    "PySide2.QtGui.QMatrix2x2.fill": ('float',),
    "PySide2.QtGui.QMatrix2x2.isIdentity": (),
    "PySide2.QtGui.QMatrix2x2.setToIdentity": (),
    "PySide2.QtGui.QMatrix2x2.transposed": (),

# class PySide2.QtGui.QMatrix2x3:
    "PySide2.QtGui.QMatrix2x3.__init__": [(), ('PySide2.QtGui.QMatrix2x3',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix2x3.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix2x3.__copy__": (),
    "PySide2.QtGui.QMatrix2x3.__iadd__": ('PySide2.QtGui.QMatrix2x3',),
    "PySide2.QtGui.QMatrix2x3.__imul__": ('float',),
    "PySide2.QtGui.QMatrix2x3.__isub__": ('PySide2.QtGui.QMatrix2x3',),
    "PySide2.QtGui.QMatrix2x3.__reduce__": (),
    "PySide2.QtGui.QMatrix2x3.__repr__": (),
    "PySide2.QtGui.QMatrix2x3.data": (),
    "PySide2.QtGui.QMatrix2x3.fill": ('float',),
    "PySide2.QtGui.QMatrix2x3.isIdentity": (),
    "PySide2.QtGui.QMatrix2x3.setToIdentity": (),
    "PySide2.QtGui.QMatrix2x3.transposed": (),

# class PySide2.QtGui.QMatrix2x4:
    "PySide2.QtGui.QMatrix2x4.__init__": [(), ('PySide2.QtGui.QMatrix2x4',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix2x4.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix2x4.__copy__": (),
    "PySide2.QtGui.QMatrix2x4.__iadd__": ('PySide2.QtGui.QMatrix2x4',),
    "PySide2.QtGui.QMatrix2x4.__imul__": ('float',),
    "PySide2.QtGui.QMatrix2x4.__isub__": ('PySide2.QtGui.QMatrix2x4',),
    "PySide2.QtGui.QMatrix2x4.__reduce__": (),
    "PySide2.QtGui.QMatrix2x4.__repr__": (),
    "PySide2.QtGui.QMatrix2x4.data": (),
    "PySide2.QtGui.QMatrix2x4.fill": ('float',),
    "PySide2.QtGui.QMatrix2x4.isIdentity": (),
    "PySide2.QtGui.QMatrix2x4.setToIdentity": (),
    "PySide2.QtGui.QMatrix2x4.transposed": (),

# class PySide2.QtGui.QMatrix3x2:
    "PySide2.QtGui.QMatrix3x2.__init__": [(), ('PySide2.QtGui.QMatrix3x2',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix3x2.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix3x2.__copy__": (),
    "PySide2.QtGui.QMatrix3x2.__iadd__": ('PySide2.QtGui.QMatrix3x2',),
    "PySide2.QtGui.QMatrix3x2.__imul__": ('float',),
    "PySide2.QtGui.QMatrix3x2.__isub__": ('PySide2.QtGui.QMatrix3x2',),
    "PySide2.QtGui.QMatrix3x2.__reduce__": (),
    "PySide2.QtGui.QMatrix3x2.__repr__": (),
    "PySide2.QtGui.QMatrix3x2.data": (),
    "PySide2.QtGui.QMatrix3x2.fill": ('float',),
    "PySide2.QtGui.QMatrix3x2.isIdentity": (),
    "PySide2.QtGui.QMatrix3x2.setToIdentity": (),
    "PySide2.QtGui.QMatrix3x2.transposed": (),

# class PySide2.QtGui.QMatrix3x3:
    "PySide2.QtGui.QMatrix3x3.__init__": [(), ('PySide2.QtGui.QMatrix3x3',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix3x3.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix3x3.__copy__": (),
    "PySide2.QtGui.QMatrix3x3.__iadd__": ('PySide2.QtGui.QMatrix3x3',),
    "PySide2.QtGui.QMatrix3x3.__imul__": ('float',),
    "PySide2.QtGui.QMatrix3x3.__isub__": ('PySide2.QtGui.QMatrix3x3',),
    "PySide2.QtGui.QMatrix3x3.__reduce__": (),
    "PySide2.QtGui.QMatrix3x3.__repr__": (),
    "PySide2.QtGui.QMatrix3x3.data": (),
    "PySide2.QtGui.QMatrix3x3.fill": ('float',),
    "PySide2.QtGui.QMatrix3x3.isIdentity": (),
    "PySide2.QtGui.QMatrix3x3.setToIdentity": (),
    "PySide2.QtGui.QMatrix3x3.transposed": (),

# class PySide2.QtGui.QMatrix3x4:
    "PySide2.QtGui.QMatrix3x4.__init__": [(), ('PySide2.QtGui.QMatrix3x4',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix3x4.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix3x4.__copy__": (),
    "PySide2.QtGui.QMatrix3x4.__iadd__": ('PySide2.QtGui.QMatrix3x4',),
    "PySide2.QtGui.QMatrix3x4.__imul__": ('float',),
    "PySide2.QtGui.QMatrix3x4.__isub__": ('PySide2.QtGui.QMatrix3x4',),
    "PySide2.QtGui.QMatrix3x4.__reduce__": (),
    "PySide2.QtGui.QMatrix3x4.__repr__": (),
    "PySide2.QtGui.QMatrix3x4.data": (),
    "PySide2.QtGui.QMatrix3x4.fill": ('float',),
    "PySide2.QtGui.QMatrix3x4.isIdentity": (),
    "PySide2.QtGui.QMatrix3x4.setToIdentity": (),
    "PySide2.QtGui.QMatrix3x4.transposed": (),

# class PySide2.QtGui.QMatrix4x2:
    "PySide2.QtGui.QMatrix4x2.__init__": [(), ('PySide2.QtGui.QMatrix4x2',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix4x2.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix4x2.__copy__": (),
    "PySide2.QtGui.QMatrix4x2.__iadd__": ('PySide2.QtGui.QMatrix4x2',),
    "PySide2.QtGui.QMatrix4x2.__imul__": ('float',),
    "PySide2.QtGui.QMatrix4x2.__isub__": ('PySide2.QtGui.QMatrix4x2',),
    "PySide2.QtGui.QMatrix4x2.__reduce__": (),
    "PySide2.QtGui.QMatrix4x2.__repr__": (),
    "PySide2.QtGui.QMatrix4x2.data": (),
    "PySide2.QtGui.QMatrix4x2.fill": ('float',),
    "PySide2.QtGui.QMatrix4x2.isIdentity": (),
    "PySide2.QtGui.QMatrix4x2.setToIdentity": (),
    "PySide2.QtGui.QMatrix4x2.transposed": (),

# class PySide2.QtGui.QMatrix4x3:
    "PySide2.QtGui.QMatrix4x3.__init__": [(), ('PySide2.QtGui.QMatrix4x3',), ('typing.Iterable',)],
    "PySide2.QtGui.QMatrix4x3.__call__": ('int', 'int'),
    "PySide2.QtGui.QMatrix4x3.__copy__": (),
    "PySide2.QtGui.QMatrix4x3.__iadd__": ('PySide2.QtGui.QMatrix4x3',),
    "PySide2.QtGui.QMatrix4x3.__imul__": ('float',),
    "PySide2.QtGui.QMatrix4x3.__isub__": ('PySide2.QtGui.QMatrix4x3',),
    "PySide2.QtGui.QMatrix4x3.__reduce__": (),
    "PySide2.QtGui.QMatrix4x3.__repr__": (),
    "PySide2.QtGui.QMatrix4x3.data": (),
    "PySide2.QtGui.QMatrix4x3.fill": ('float',),
    "PySide2.QtGui.QMatrix4x3.isIdentity": (),
    "PySide2.QtGui.QMatrix4x3.setToIdentity": (),
    "PySide2.QtGui.QMatrix4x3.transposed": (),

# class PySide2.QtGui.QMatrix4x4:
    "PySide2.QtGui.QMatrix4x4.__init__": [(), ('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',), ('float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float'), ('typing.Sequence[float]',)],
    "PySide2.QtGui.QMatrix4x4.__add__": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtGui.QMatrix4x4.__copy__": (),
    "PySide2.QtGui.QMatrix4x4.__dummy": ('typing.Sequence[float]',),
    "PySide2.QtGui.QMatrix4x4.__iadd__": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtGui.QMatrix4x4.__imul__": [('PySide2.QtGui.QMatrix4x4',), ('float',)],
    "PySide2.QtGui.QMatrix4x4.__isub__": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtGui.QMatrix4x4.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QMatrix4x4.__mul__": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QMatrix4x4',), ('float',)],
    "PySide2.QtGui.QMatrix4x4.__neg__": (),
    "PySide2.QtGui.QMatrix4x4.__reduce__": (),
    "PySide2.QtGui.QMatrix4x4.__repr__": (),
    "PySide2.QtGui.QMatrix4x4.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QMatrix4x4.__sub__": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtGui.QMatrix4x4.column": ('int',),
    "PySide2.QtGui.QMatrix4x4.copyDataTo": (),
    "PySide2.QtGui.QMatrix4x4.data": (),
    "PySide2.QtGui.QMatrix4x4.determinant": (),
    "PySide2.QtGui.QMatrix4x4.fill": ('float',),
    "PySide2.QtGui.QMatrix4x4.flipCoordinates": (),
    "PySide2.QtGui.QMatrix4x4.frustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QMatrix4x4.inverted": (),
    "PySide2.QtGui.QMatrix4x4.isAffine": (),
    "PySide2.QtGui.QMatrix4x4.isIdentity": (),
    "PySide2.QtGui.QMatrix4x4.lookAt": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QMatrix4x4.map": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QVector3D',), ('PySide2.QtGui.QVector4D',)],
    "PySide2.QtGui.QMatrix4x4.mapRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtGui.QMatrix4x4.mapVector": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QMatrix4x4.normalMatrix": (),
    "PySide2.QtGui.QMatrix4x4.optimize": (),
    "PySide2.QtGui.QMatrix4x4.ortho": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QMatrix4x4.perspective": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QMatrix4x4.rotate": [('PySide2.QtGui.QQuaternion',), ('float', 'PySide2.QtGui.QVector3D'), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QMatrix4x4.row": ('int',),
    "PySide2.QtGui.QMatrix4x4.scale": [('PySide2.QtGui.QVector3D',), ('float',), ('float', 'float'), ('float', 'float', 'float')],
    "PySide2.QtGui.QMatrix4x4.setColumn": ('int', 'PySide2.QtGui.QVector4D'),
    "PySide2.QtGui.QMatrix4x4.setRow": ('int', 'PySide2.QtGui.QVector4D'),
    "PySide2.QtGui.QMatrix4x4.setToIdentity": (),
    "PySide2.QtGui.QMatrix4x4.toAffine": (),
    "PySide2.QtGui.QMatrix4x4.toTransform": [(), ('float',)],
    "PySide2.QtGui.QMatrix4x4.translate": [('PySide2.QtGui.QVector3D',), ('float', 'float'), ('float', 'float', 'float')],
    "PySide2.QtGui.QMatrix4x4.transposed": (),
    "PySide2.QtGui.QMatrix4x4.viewport": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float', 'float', 'float')],

# class PySide2.QtGui.QMouseEvent:
    "PySide2.QtGui.QMouseEvent.__init__": [('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers'), ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.MouseEventSource'), ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers'), ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers')],
    "PySide2.QtGui.QMouseEvent.button": (),
    "PySide2.QtGui.QMouseEvent.buttons": (),
    "PySide2.QtGui.QMouseEvent.flags": (),
    "PySide2.QtGui.QMouseEvent.globalPos": (),
    "PySide2.QtGui.QMouseEvent.globalX": (),
    "PySide2.QtGui.QMouseEvent.global""Y": (),
    "PySide2.QtGui.QMouseEvent.localPos": (),
    "PySide2.QtGui.QMouseEvent.pos": (),
    "PySide2.QtGui.QMouseEvent.screenPos": (),
    "PySide2.QtGui.QMouseEvent.setLocalPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QMouseEvent.source": (),
    "PySide2.QtGui.QMouseEvent.windowPos": (),
    "PySide2.QtGui.QMouseEvent.x": (),
    "PySide2.QtGui.QMouseEvent.y": (),

# class PySide2.QtGui.QMoveEvent:
    "PySide2.QtGui.QMoveEvent.__init__": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'),
    "PySide2.QtGui.QMoveEvent.oldPos": (),
    "PySide2.QtGui.QMoveEvent.pos": (),

# class PySide2.QtGui.QMovie:

# class PySide2.QtGui.QMovie.CacheMode:

# class PySide2.QtGui.QMovie.MovieState:
    "PySide2.QtGui.QMovie.__init__": [('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',), ('str', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QMovie.backgroundColor": (),
    "PySide2.QtGui.QMovie.cacheMode": (),
    "PySide2.QtGui.QMovie.currentFrameNumber": (),
    "PySide2.QtGui.QMovie.currentImage": (),
    "PySide2.QtGui.QMovie.currentPixmap": (),
    "PySide2.QtGui.QMovie.device": (),
    "PySide2.QtGui.QMovie.fileName": (),
    "PySide2.QtGui.QMovie.format": (),
    "PySide2.QtGui.QMovie.frameCount": (),
    "PySide2.QtGui.QMovie.frameRect": (),
    "PySide2.QtGui.QMovie.isValid": (),
    "PySide2.QtGui.QMovie.jumpToFrame": ('int',),
    "PySide2.QtGui.QMovie.jumpToNextFrame": (),
    "PySide2.QtGui.QMovie.lastError": (),
    "PySide2.QtGui.QMovie.lastErrorString": (),
    "PySide2.QtGui.QMovie.loopCount": (),
    "PySide2.QtGui.QMovie.nextFrameDelay": (),
    "PySide2.QtGui.QMovie.scaledSize": (),
    "PySide2.QtGui.QMovie.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtGui.QMovie.setCacheMode": ('PySide2.QtGui.QMovie.CacheMode',),
    "PySide2.QtGui.QMovie.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtGui.QMovie.setFileName": ('str',),
    "PySide2.QtGui.QMovie.setFormat": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QMovie.setPaused": ('bool',),
    "PySide2.QtGui.QMovie.setScaledSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QMovie.setSpeed": ('int',),
    "PySide2.QtGui.QMovie.speed": (),
    "PySide2.QtGui.QMovie.start": (),
    "PySide2.QtGui.QMovie.state": (),
    "PySide2.QtGui.QMovie.stop": (),
    "PySide2.QtGui.QMovie.supportedFormats": (),

# class PySide2.QtGui.QNativeGestureEvent:
    "PySide2.QtGui.QNativeGestureEvent.__init__": [('PySide2.QtCore.Qt.NativeGestureType', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'float', 'int', 'int'), ('PySide2.QtCore.Qt.NativeGestureType', 'PySide2.QtGui.QTouchDevice', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'float', 'int', 'int')],
    "PySide2.QtGui.QNativeGestureEvent.device": (),
    "PySide2.QtGui.QNativeGestureEvent.gestureType": (),
    "PySide2.QtGui.QNativeGestureEvent.globalPos": (),
    "PySide2.QtGui.QNativeGestureEvent.localPos": (),
    "PySide2.QtGui.QNativeGestureEvent.pos": (),
    "PySide2.QtGui.QNativeGestureEvent.screenPos": (),
    "PySide2.QtGui.QNativeGestureEvent.value": (),
    "PySide2.QtGui.QNativeGestureEvent.windowPos": (),

# class PySide2.QtGui.QOffscreenSurface:
    "PySide2.QtGui.QOffscreenSurface.__init__": [('PySide2.QtGui.QScreen',), ('PySide2.QtGui.QScreen', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QOffscreenSurface.create": (),
    "PySide2.QtGui.QOffscreenSurface.destroy": (),
    "PySide2.QtGui.QOffscreenSurface.format": (),
    "PySide2.QtGui.QOffscreenSurface.isValid": (),
    "PySide2.QtGui.QOffscreenSurface.nativeHandle": (),
    "PySide2.QtGui.QOffscreenSurface.requestedFormat": (),
    "PySide2.QtGui.QOffscreenSurface.screen": (),
    "PySide2.QtGui.QOffscreenSurface.setFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtGui.QOffscreenSurface.setNativeHandle": ('int',),
    "PySide2.QtGui.QOffscreenSurface.setScreen": ('PySide2.QtGui.QScreen',),
    "PySide2.QtGui.QOffscreenSurface.size": (),
    "PySide2.QtGui.QOffscreenSurface.surfaceHandle": (),
    "PySide2.QtGui.QOffscreenSurface.surfaceType": (),

# class PySide2.QtGui.QOpenGLBuffer:

# class PySide2.QtGui.QOpenGLBuffer.Access:

# class PySide2.QtGui.QOpenGLBuffer.RangeAccessFlag:

# class PySide2.QtGui.QOpenGLBuffer.RangeAccessFlags:

# class PySide2.QtGui.QOpenGLBuffer.Type:

# class PySide2.QtGui.QOpenGLBuffer.UsagePattern:
    "PySide2.QtGui.QOpenGLBuffer.__init__": [(), ('PySide2.QtGui.QOpenGLBuffer',), ('PySide2.QtGui.QOpenGLBuffer.Type',)],
    "PySide2.QtGui.QOpenGLBuffer.allocate": [('int',), ('int', 'int')],
    "PySide2.QtGui.QOpenGLBuffer.bind": (),
    "PySide2.QtGui.QOpenGLBuffer.bufferId": (),
    "PySide2.QtGui.QOpenGLBuffer.create": (),
    "PySide2.QtGui.QOpenGLBuffer.destroy": (),
    "PySide2.QtGui.QOpenGLBuffer.isCreated": (),
    "PySide2.QtGui.QOpenGLBuffer.map": ('PySide2.QtGui.QOpenGLBuffer.Access',),
    "PySide2.QtGui.QOpenGLBuffer.mapRange": ('int', 'int', 'PySide2.QtGui.QOpenGLBuffer.RangeAccessFlags'),
    "PySide2.QtGui.QOpenGLBuffer.read": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLBuffer.release": [(), ('PySide2.QtGui.QOpenGLBuffer.Type',)],
    "PySide2.QtGui.QOpenGLBuffer.setUsagePattern": ('PySide2.QtGui.QOpenGLBuffer.UsagePattern',),
    "PySide2.QtGui.QOpenGLBuffer.size": (),
    "PySide2.QtGui.QOpenGLBuffer.type": (),
    "PySide2.QtGui.QOpenGLBuffer.unmap": (),
    "PySide2.QtGui.QOpenGLBuffer.usagePattern": (),
    "PySide2.QtGui.QOpenGLBuffer.write": ('int', 'int', 'int'),

# class PySide2.QtGui.QOpenGLContext:

# class PySide2.QtGui.QOpenGLContext.OpenGLModuleType:
    "PySide2.QtGui.QOpenGLContext.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QOpenGLContext.areSharing": ('PySide2.QtGui.QOpenGLContext', 'PySide2.QtGui.QOpenGLContext'),
    "PySide2.QtGui.QOpenGLContext.create": (),
    "PySide2.QtGui.QOpenGLContext.currentContext": (),
    "PySide2.QtGui.QOpenGLContext.defaultFramebufferObject": (),
    "PySide2.QtGui.QOpenGLContext.doneCurrent": (),
    "PySide2.QtGui.QOpenGLContext.extensions": (),
    "PySide2.QtGui.QOpenGLContext.extraFunctions": (),
    "PySide2.QtGui.QOpenGLContext.format": (),
    "PySide2.QtGui.QOpenGLContext.functions": (),
    "PySide2.QtGui.QOpenGLContext.globalShareContext": (),
    "PySide2.QtGui.QOpenGLContext.hasExtension": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QOpenGLContext.isOpenGLES": (),
    "PySide2.QtGui.QOpenGLContext.isValid": (),
    "PySide2.QtGui.QOpenGLContext.makeCurrent": ('PySide2.QtGui.QSurface',),
    "PySide2.QtGui.QOpenGLContext.nativeHandle": (),
    "PySide2.QtGui.QOpenGLContext.openGLModuleHandle": (),
    "PySide2.QtGui.QOpenGLContext.openGLModuleType": (),
    "PySide2.QtGui.QOpenGLContext.screen": (),
    "PySide2.QtGui.QOpenGLContext.setFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtGui.QOpenGLContext.setNativeHandle": ('typing.Any',),
    "PySide2.QtGui.QOpenGLContext.setScreen": ('PySide2.QtGui.QScreen',),
    "PySide2.QtGui.QOpenGLContext.setShareContext": ('PySide2.QtGui.QOpenGLContext',),
    "PySide2.QtGui.QOpenGLContext.shareContext": (),
    "PySide2.QtGui.QOpenGLContext.shareGroup": (),
    "PySide2.QtGui.QOpenGLContext.supportsThreadedOpenGL": (),
    "PySide2.QtGui.QOpenGLContext.surface": (),
    "PySide2.QtGui.QOpenGLContext.swapBuffers": ('PySide2.QtGui.QSurface',),
    "PySide2.QtGui.QOpenGLContext.versionFunctions": ('PySide2.QtGui.QOpenGLVersionProfile',),

# class PySide2.QtGui.QOpenGLContextGroup:
    "PySide2.QtGui.QOpenGLContextGroup.currentContextGroup": (),
    "PySide2.QtGui.QOpenGLContextGroup.shares": (),

# class PySide2.QtGui.QOpenGLDebugLogger:

# class PySide2.QtGui.QOpenGLDebugLogger.LoggingMode:
    "PySide2.QtGui.QOpenGLDebugLogger.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QOpenGLDebugLogger.disableMessages": [('PySide2.QtGui.QOpenGLDebugMessage.Sources', 'PySide2.QtGui.QOpenGLDebugMessage.Types', 'PySide2.QtGui.QOpenGLDebugMessage.Severities'), ('typing.List[int]', 'PySide2.QtGui.QOpenGLDebugMessage.Sources', 'PySide2.QtGui.QOpenGLDebugMessage.Types')],
    "PySide2.QtGui.QOpenGLDebugLogger.enableMessages": [('PySide2.QtGui.QOpenGLDebugMessage.Sources', 'PySide2.QtGui.QOpenGLDebugMessage.Types', 'PySide2.QtGui.QOpenGLDebugMessage.Severities'), ('typing.List[int]', 'PySide2.QtGui.QOpenGLDebugMessage.Sources', 'PySide2.QtGui.QOpenGLDebugMessage.Types')],
    "PySide2.QtGui.QOpenGLDebugLogger.initialize": (),
    "PySide2.QtGui.QOpenGLDebugLogger.isLogging": (),
    "PySide2.QtGui.QOpenGLDebugLogger.logMessage": ('PySide2.QtGui.QOpenGLDebugMessage',),
    "PySide2.QtGui.QOpenGLDebugLogger.loggedMessages": (),
    "PySide2.QtGui.QOpenGLDebugLogger.loggingMode": (),
    "PySide2.QtGui.QOpenGLDebugLogger.maximumMessageLength": (),
    "PySide2.QtGui.QOpenGLDebugLogger.popGroup": (),
    "PySide2.QtGui.QOpenGLDebugLogger.pushGroup": ('str', 'int', 'PySide2.QtGui.QOpenGLDebugMessage.Source'),
    "PySide2.QtGui.QOpenGLDebugLogger.startLogging": ('PySide2.QtGui.QOpenGLDebugLogger.LoggingMode',),
    "PySide2.QtGui.QOpenGLDebugLogger.stopLogging": (),

# class PySide2.QtGui.QOpenGLDebugMessage:

# class PySide2.QtGui.QOpenGLDebugMessage.Severities:

# class PySide2.QtGui.QOpenGLDebugMessage.Severity:

# class PySide2.QtGui.QOpenGLDebugMessage.Source:

# class PySide2.QtGui.QOpenGLDebugMessage.Sources:

# class PySide2.QtGui.QOpenGLDebugMessage.Type:

# class PySide2.QtGui.QOpenGLDebugMessage.Types:
    "PySide2.QtGui.QOpenGLDebugMessage.__init__": [(), ('PySide2.QtGui.QOpenGLDebugMessage',)],
    "PySide2.QtGui.QOpenGLDebugMessage.__copy__": (),
    "PySide2.QtGui.QOpenGLDebugMessage.createApplicationMessage": ('str', 'int', 'PySide2.QtGui.QOpenGLDebugMessage.Severity', 'PySide2.QtGui.QOpenGLDebugMessage.Type'),
    "PySide2.QtGui.QOpenGLDebugMessage.createThirdPartyMessage": ('str', 'int', 'PySide2.QtGui.QOpenGLDebugMessage.Severity', 'PySide2.QtGui.QOpenGLDebugMessage.Type'),
    "PySide2.QtGui.QOpenGLDebugMessage.id": (),
    "PySide2.QtGui.QOpenGLDebugMessage.message": (),
    "PySide2.QtGui.QOpenGLDebugMessage.severity": (),
    "PySide2.QtGui.QOpenGLDebugMessage.source": (),
    "PySide2.QtGui.QOpenGLDebugMessage.swap": ('PySide2.QtGui.QOpenGLDebugMessage',),
    "PySide2.QtGui.QOpenGLDebugMessage.type": (),

# class PySide2.QtGui.QOpenGLExtraFunctions:
    "PySide2.QtGui.QOpenGLExtraFunctions.__init__": [(), ('PySide2.QtGui.QOpenGLContext',)],
    "PySide2.QtGui.QOpenGLExtraFunctions.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBeginQuery": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBeginTransformFeedback": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBindProgramPipeline": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBindSampler": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBindVertexArray": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBlendBarrier": (),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBlendEquationi": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glClearBufferiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glClearBufferuiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDebugMessageControl": ('int', 'int', 'int', 'int', 'shibokensupport.typing27.Sequence', 'typing.Char'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDebugMessageInsert": ('int', 'int', 'int', 'int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDeleteProgramPipelines": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDeleteQueries": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDeleteSamplers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDeleteTransformFeedbacks": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDeleteVertexArrays": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDisablei": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawBuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glEnablei": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glEndQuery": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGenProgramPipelines": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGenQueries": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGenSamplers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGenTransformFeedbacks": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGenVertexArrays": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetActiveUniformBlockiv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetActiveUniformsiv": ('int', 'int', 'shibokensupport.typing27.Sequence', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetBufferParameteri64v": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetFramebufferParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetGraphicsResetStatus": (),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetInteger64i_v": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetInteger64v": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetIntegeri_v": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetInternalformativ": ('int', 'int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetMultisamplefv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetProgramBinary": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetProgramInterfaceiv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetProgramPipelineiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetProgramResourceiv": ('int', 'int', 'int', 'int', 'shibokensupport.typing27.Sequence', 'int', 'shibokensupport.typing27.Sequence', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetQueryObjectuiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetQueryiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetSamplerParameterIiv": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetSamplerParameterIuiv": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetSamplerParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetStringi": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetTexLevelParameterfv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetTexLevelParameteriv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetTexParameterIiv": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetTexParameterIuiv": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetUniformuiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetVertexAttribIiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetVertexAttribIuiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetnUniformfv": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetnUniformiv": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glGetnUniformuiv": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glInvalidateFramebuffer": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glInvalidateSubFramebuffer": ('int', 'int', 'shibokensupport.typing27.Sequence', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glIsEnabledi": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glIsProgramPipeline": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glIsQuery": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glIsSampler": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glIsTransformFeedback": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glIsVertexArray": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glMemoryBarrier": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glMemoryBarrierByRegion": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glMinSampleShading": ('float',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glObjectLabel": ('int', 'int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glObjectPtrLabel": ('int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glPatchParameteri": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glPopDebugGroup": (),
    "PySide2.QtGui.QOpenGLExtraFunctions.glPrimitiveBoundingBox": ('float', 'float', 'float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform1iv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform1uiv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform2iv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform2uiv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform3iv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform3uiv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform4iv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniform4uiv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glPushDebugGroup": ('int', 'int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glReadBuffer": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glReadnPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSampleMaski": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSamplerParameterIiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSamplerParameterIuiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glSamplerParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexParameterIiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexParameterIuiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform1ui": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform1uiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform2uiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform3uiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniform4uiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUnmapBuffer": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glValidateProgramPipeline": ('int',),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribI4iv": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribI4uiv": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLExtraFunctions.glVertexBindingDivisor": ('int', 'int'),

# class PySide2.QtGui.QOpenGLFramebufferObject:

# class PySide2.QtGui.QOpenGLFramebufferObject.Attachment:

# class PySide2.QtGui.QOpenGLFramebufferObject.FramebufferRestorePolicy:
    "PySide2.QtGui.QOpenGLFramebufferObject.__init__": [('PySide2.QtCore.QSize', 'PySide2.QtGui.QOpenGLFramebufferObject.Attachment', 'int', 'int'), ('PySide2.QtCore.QSize', 'PySide2.QtGui.QOpenGLFramebufferObjectFormat'), ('PySide2.QtCore.QSize', 'int'), ('int', 'int', 'PySide2.QtGui.QOpenGLFramebufferObject.Attachment', 'int', 'int'), ('int', 'int', 'PySide2.QtGui.QOpenGLFramebufferObjectFormat'), ('int', 'int', 'int')],
    "PySide2.QtGui.QOpenGLFramebufferObject.addColorAttachment": [('PySide2.QtCore.QSize', 'int'), ('int', 'int', 'int')],
    "PySide2.QtGui.QOpenGLFramebufferObject.attachment": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.bind": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.bindDefault": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.blitFramebuffer": [('PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtCore.QRect', 'int', 'int'), ('PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtCore.QRect', 'int', 'int', 'int', 'int'), ('PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtCore.QRect', 'int', 'int', 'int', 'int', 'PySide2.QtGui.QOpenGLFramebufferObject.FramebufferRestorePolicy'), ('PySide2.QtGui.QOpenGLFramebufferObject', 'PySide2.QtGui.QOpenGLFramebufferObject', 'int', 'int')],
    "PySide2.QtGui.QOpenGLFramebufferObject.format": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.handle": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.hasOpenGLFramebufferBlit": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.hasOpenGLFramebufferObjects": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.height": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.isBound": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.isValid": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.release": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.setAttachment": ('PySide2.QtGui.QOpenGLFramebufferObject.Attachment',),
    "PySide2.QtGui.QOpenGLFramebufferObject.size": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.sizes": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.takeTexture": [(), ('int',)],
    "PySide2.QtGui.QOpenGLFramebufferObject.texture": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.textures": (),
    "PySide2.QtGui.QOpenGLFramebufferObject.toImage": [(), ('bool',), ('bool', 'int')],
    "PySide2.QtGui.QOpenGLFramebufferObject.width": (),

# class PySide2.QtGui.QOpenGLFramebufferObjectFormat:
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.__init__": [(), ('PySide2.QtGui.QOpenGLFramebufferObjectFormat',)],
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.__copy__": (),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.attachment": (),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.internalTextureFormat": (),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.mipmap": (),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.samples": (),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.setAttachment": ('PySide2.QtGui.QOpenGLFramebufferObject.Attachment',),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.setInternalTextureFormat": ('int',),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.setMipmap": ('bool',),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.setSamples": ('int',),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.setTextureTarget": ('int',),
    "PySide2.QtGui.QOpenGLFramebufferObjectFormat.textureTarget": (),

# class PySide2.QtGui.QOpenGLFunctions:

# class PySide2.QtGui.QOpenGLFunctions.OpenGLFeature:

# class PySide2.QtGui.QOpenGLFunctions.OpenGLFeatures:
    "PySide2.QtGui.QOpenGLFunctions.__init__": [(), ('PySide2.QtGui.QOpenGLContext',)],
    "PySide2.QtGui.QOpenGLFunctions.glActiveTexture": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glAttachShader": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtGui.QOpenGLFunctions.glBindBuffer": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBindTexture": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glBlendEquation": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBlendFunc": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glCheckFramebufferStatus": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glClear": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glClearDepthf": ('float',),
    "PySide2.QtGui.QOpenGLFunctions.glClearStencil": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtGui.QOpenGLFunctions.glCompileShader": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glCreateProgram": (),
    "PySide2.QtGui.QOpenGLFunctions.glCreateShader": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glCullFace": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glDeleteBuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glDeleteFramebuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glDeleteProgram": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glDeleteRenderbuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glDeleteShader": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glDeleteTextures": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glDepthFunc": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glDepthMask": ('typing.Char',),
    "PySide2.QtGui.QOpenGLFunctions.glDepthRangef": ('float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glDetachShader": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glDisable": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glDisableVertexAttribArray": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glEnable": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glEnableVertexAttribArray": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glFinish": (),
    "PySide2.QtGui.QOpenGLFunctions.glFlush": (),
    "PySide2.QtGui.QOpenGLFunctions.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glFrontFace": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glGenBuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGenFramebuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGenRenderbuffers": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGenTextures": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGenerateMipmap": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glGetAttachedShaders": ('int', 'int', 'shibokensupport.typing27.Sequence', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtGui.QOpenGLFunctions.glGetBufferParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetError": (),
    "PySide2.QtGui.QOpenGLFunctions.glGetFloatv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glGetFramebufferAttachmentParameteriv": ('int', 'int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetIntegerv": ('int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetProgramiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetRenderbufferParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetShaderPrecisionFormat": ('int', 'int', 'shibokensupport.typing27.Sequence', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetShaderiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetString": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glGetTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glGetTexParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtGui.QOpenGLFunctions.glGetUniformfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glGetUniformiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glGetVertexAttribfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glGetVertexAttribiv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glHint": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glIsBuffer": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glIsEnabled": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glIsFramebuffer": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glIsProgram": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glIsRenderbuffer": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glIsShader": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glIsTexture": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glLineWidth": ('float',),
    "PySide2.QtGui.QOpenGLFunctions.glLinkProgram": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glPixelStorei": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glPolygonOffset": ('float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glReadPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glReleaseShaderCompiler": (),
    "PySide2.QtGui.QOpenGLFunctions.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtGui.QOpenGLFunctions.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glShaderBinary": ('int', 'shibokensupport.typing27.Sequence', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glStencilMask": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glTexParameteriv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform1f": ('int', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform1i": ('int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform1iv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform2iv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform3iv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glUniform4iv": ('int', 'int', 'shibokensupport.typing27.Sequence'),
    "PySide2.QtGui.QOpenGLFunctions.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glUseProgram": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glValidateProgram": ('int',),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtGui.QOpenGLFunctions.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLFunctions.hasOpenGLFeature": ('PySide2.QtGui.QOpenGLFunctions.OpenGLFeature',),
    "PySide2.QtGui.QOpenGLFunctions.initializeOpenGLFunctions": (),
    "PySide2.QtGui.QOpenGLFunctions.openGLFeatures": (),

# class PySide2.QtGui.QOpenGLPixelTransferOptions:
    "PySide2.QtGui.QOpenGLPixelTransferOptions.__init__": [(), ('PySide2.QtGui.QOpenGLPixelTransferOptions',)],
    "PySide2.QtGui.QOpenGLPixelTransferOptions.__copy__": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.alignment": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.imageHeight": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.isLeastSignificantBitFirst": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.isSwapBytesEnabled": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.rowLength": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setAlignment": ('int',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setImageHeight": ('int',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setLeastSignificantByteFirst": ('bool',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setRowLength": ('int',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setSkipImages": ('int',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setSkipPixels": ('int',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setSkipRows": ('int',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.setSwapBytesEnabled": ('bool',),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.skipImages": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.skipPixels": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.skipRows": (),
    "PySide2.QtGui.QOpenGLPixelTransferOptions.swap": ('PySide2.QtGui.QOpenGLPixelTransferOptions',),

# class PySide2.QtGui.QOpenGLShader:

# class PySide2.QtGui.QOpenGLShader.ShaderType:

# class PySide2.QtGui.QOpenGLShader.ShaderTypeBit:
    "PySide2.QtGui.QOpenGLShader.__init__": ('PySide2.QtGui.QOpenGLShader.ShaderType', 'PySide2.QtCore.QObject'),
    "PySide2.QtGui.QOpenGLShader.compileSourceCode": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtGui.QOpenGLShader.compileSourceFile": ('str',),
    "PySide2.QtGui.QOpenGLShader.hasOpenGLShaders": ('PySide2.QtGui.QOpenGLShader.ShaderType', 'PySide2.QtGui.QOpenGLContext'),
    "PySide2.QtGui.QOpenGLShader.isCompiled": (),
    "PySide2.QtGui.QOpenGLShader.log": (),
    "PySide2.QtGui.QOpenGLShader.shaderId": (),
    "PySide2.QtGui.QOpenGLShader.shaderType": (),
    "PySide2.QtGui.QOpenGLShader.sourceCode": (),

# class PySide2.QtGui.QOpenGLShaderProgram:
    "PySide2.QtGui.QOpenGLShaderProgram.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QOpenGLShaderProgram.addCacheableShaderFromSourceCode": [('PySide2.QtGui.QOpenGLShader.ShaderType', 'PySide2.QtCore.QByteArray'), ('PySide2.QtGui.QOpenGLShader.ShaderType', 'str')],
    "PySide2.QtGui.QOpenGLShaderProgram.addCacheableShaderFromSourceFile": ('PySide2.QtGui.QOpenGLShader.ShaderType', 'str'),
    "PySide2.QtGui.QOpenGLShaderProgram.addShader": ('PySide2.QtGui.QOpenGLShader',),
    "PySide2.QtGui.QOpenGLShaderProgram.addShaderFromSourceCode": [('PySide2.QtGui.QOpenGLShader.ShaderType', 'PySide2.QtCore.QByteArray'), ('PySide2.QtGui.QOpenGLShader.ShaderType', 'str')],
    "PySide2.QtGui.QOpenGLShaderProgram.addShaderFromSourceFile": ('PySide2.QtGui.QOpenGLShader.ShaderType', 'str'),
    "PySide2.QtGui.QOpenGLShaderProgram.attributeLocation": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtGui.QOpenGLShaderProgram.bind": (),
    "PySide2.QtGui.QOpenGLShaderProgram.bindAttributeLocation": [('PySide2.QtCore.QByteArray', 'int'), ('str', 'int')],
    "PySide2.QtGui.QOpenGLShaderProgram.create": (),
    "PySide2.QtGui.QOpenGLShaderProgram.defaultInnerTessellationLevels": (),
    "PySide2.QtGui.QOpenGLShaderProgram.defaultOuterTessellationLevels": (),
    "PySide2.QtGui.QOpenGLShaderProgram.disableAttributeArray": [('int',), ('str',)],
    "PySide2.QtGui.QOpenGLShaderProgram.enableAttributeArray": [('int',), ('str',)],
    "PySide2.QtGui.QOpenGLShaderProgram.hasOpenGLShaderPrograms": ('PySide2.QtGui.QOpenGLContext',),
    "PySide2.QtGui.QOpenGLShaderProgram.isLinked": (),
    "PySide2.QtGui.QOpenGLShaderProgram.link": (),
    "PySide2.QtGui.QOpenGLShaderProgram.log": (),
    "PySide2.QtGui.QOpenGLShaderProgram.maxGeometryOutputVertices": (),
    "PySide2.QtGui.QOpenGLShaderProgram.patchVertexCount": (),
    "PySide2.QtGui.QOpenGLShaderProgram.programId": (),
    "PySide2.QtGui.QOpenGLShaderProgram.release": (),
    "PySide2.QtGui.QOpenGLShaderProgram.removeAllShaders": (),
    "PySide2.QtGui.QOpenGLShaderProgram.removeShader": ('PySide2.QtGui.QOpenGLShader',),
    "PySide2.QtGui.QOpenGLShaderProgram.setAttributeArray": [('int', 'int', 'int', 'int', 'int'), ('int', 'typing.Sequence[float]', 'int', 'int'), ('str', 'int', 'int', 'int', 'int'), ('str', 'typing.Sequence[float]', 'int', 'int')],
    "PySide2.QtGui.QOpenGLShaderProgram.setAttributeBuffer": [('int', 'int', 'int', 'int', 'int'), ('str', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QOpenGLShaderProgram.setAttributeValue": [('int', 'PySide2.QtGui.QColor'), ('int', 'PySide2.QtGui.QVector2D'), ('int', 'PySide2.QtGui.QVector3D'), ('int', 'PySide2.QtGui.QVector4D'), ('int', 'float'), ('int', 'float', 'float'), ('int', 'float', 'float', 'float'), ('int', 'float', 'float', 'float', 'float'), ('int', 'typing.Sequence[float]', 'int', 'int'), ('str', 'PySide2.QtGui.QColor'), ('str', 'PySide2.QtGui.QVector2D'), ('str', 'PySide2.QtGui.QVector3D'), ('str', 'PySide2.QtGui.QVector4D'), ('str', 'float'), ('str', 'float', 'float'), ('str', 'float', 'float', 'float'), ('str', 'float', 'float', 'float', 'float'), ('str', 'typing.Sequence[float]', 'int', 'int')],
    "PySide2.QtGui.QOpenGLShaderProgram.setDefaultInnerTessellationLevels": ('typing.List[float]',),
    "PySide2.QtGui.QOpenGLShaderProgram.setDefaultOuterTessellationLevels": ('typing.List[float]',),
    "PySide2.QtGui.QOpenGLShaderProgram.setPatchVertexCount": ('int',),
    "PySide2.QtGui.QOpenGLShaderProgram.setUniformValue": [('int', 'PySide2.QtCore.QPoint'), ('int', 'PySide2.QtCore.QPointF'), ('int', 'PySide2.QtCore.QSize'), ('int', 'PySide2.QtCore.QSizeF'), ('int', 'PySide2.QtGui.QColor'), ('int', 'PySide2.QtGui.QMatrix2x2'), ('int', 'PySide2.QtGui.QMatrix2x3'), ('int', 'PySide2.QtGui.QMatrix2x4'), ('int', 'PySide2.QtGui.QMatrix3x2'), ('int', 'PySide2.QtGui.QMatrix3x3'), ('int', 'PySide2.QtGui.QMatrix3x4'), ('int', 'PySide2.QtGui.QMatrix4x2'), ('int', 'PySide2.QtGui.QMatrix4x3'), ('int', 'PySide2.QtGui.QMatrix4x4'), ('int', 'PySide2.QtGui.QTransform'), ('int', 'PySide2.QtGui.QVector2D'), ('int', 'PySide2.QtGui.QVector3D'), ('int', 'PySide2.QtGui.QVector4D'), ('int', 'float'), ('int', 'float', 'float'), ('int', 'float', 'float', 'float'), ('int', 'float', 'float', 'float', 'float'), ('int', 'int'), ('int', 'typing.Tuple[typing.Tuple, typing.Tuple, typing.Tuple, typing.Tuple]'), ('int', 'typing.Tuple[typing.Tuple, typing.Tuple, typing.Tuple]'), ('int', 'typing.Tuple[typing.Tuple, typing.Tuple]'), ('str', 'PySide2.QtCore.QPoint'), ('str', 'PySide2.QtCore.QPointF'), ('str', 'PySide2.QtCore.QSize'), ('str', 'PySide2.QtCore.QSizeF'), ('str', 'PySide2.QtGui.QColor'), ('str', 'PySide2.QtGui.QMatrix2x2'), ('str', 'PySide2.QtGui.QMatrix2x3'), ('str', 'PySide2.QtGui.QMatrix2x4'), ('str', 'PySide2.QtGui.QMatrix3x2'), ('str', 'PySide2.QtGui.QMatrix3x3'), ('str', 'PySide2.QtGui.QMatrix3x4'), ('str', 'PySide2.QtGui.QMatrix4x2'), ('str', 'PySide2.QtGui.QMatrix4x3'), ('str', 'PySide2.QtGui.QMatrix4x4'), ('str', 'PySide2.QtGui.QTransform'), ('str', 'PySide2.QtGui.QVector2D'), ('str', 'PySide2.QtGui.QVector3D'), ('str', 'PySide2.QtGui.QVector4D'), ('str', 'float', 'float'), ('str', 'float', 'float', 'float'), ('str', 'float', 'float', 'float', 'float'), ('str', 'typing.Tuple[typing.Tuple, typing.Tuple, typing.Tuple, typing.Tuple]'), ('str', 'typing.Tuple[typing.Tuple, typing.Tuple, typing.Tuple]'), ('str', 'typing.Tuple[typing.Tuple, typing.Tuple]')],
    "PySide2.QtGui.QOpenGLShaderProgram.setUniformValue1f": [('int', 'float'), ('str', 'float')],
    "PySide2.QtGui.QOpenGLShaderProgram.setUniformValue1i": [('int', 'int'), ('str', 'int')],
    "PySide2.QtGui.QOpenGLShaderProgram.setUniformValueArray": [('int', 'shibokensupport.typing27.Sequence', 'int'), ('int', 'typing.Sequence[float]', 'int', 'int'), ('str', 'shibokensupport.typing27.Sequence', 'int'), ('str', 'typing.Sequence[float]', 'int', 'int')],
    "PySide2.QtGui.QOpenGLShaderProgram.shaders": (),
    "PySide2.QtGui.QOpenGLShaderProgram.uniformLocation": [('PySide2.QtCore.QByteArray',), ('str',)],

# class PySide2.QtGui.QOpenGLTexture:

# class PySide2.QtGui.QOpenGLTexture.BindingTarget:

# class PySide2.QtGui.QOpenGLTexture.ComparisonFunction:

# class PySide2.QtGui.QOpenGLTexture.ComparisonMode:

# class PySide2.QtGui.QOpenGLTexture.CoordinateDirection:

# class PySide2.QtGui.QOpenGLTexture.CubeMapFace:

# class PySide2.QtGui.QOpenGLTexture.DepthStencilMode:

# class PySide2.QtGui.QOpenGLTexture.Feature:

# class PySide2.QtGui.QOpenGLTexture.Features:

# class PySide2.QtGui.QOpenGLTexture.Filter:

# class PySide2.QtGui.QOpenGLTexture.MipMapGeneration:

# class PySide2.QtGui.QOpenGLTexture.PixelFormat:

# class PySide2.QtGui.QOpenGLTexture.PixelType:

# class PySide2.QtGui.QOpenGLTexture.SwizzleComponent:

# class PySide2.QtGui.QOpenGLTexture.SwizzleValue:

# class PySide2.QtGui.QOpenGLTexture.Target:

# class PySide2.QtGui.QOpenGLTexture.TextureFormat:

# class PySide2.QtGui.QOpenGLTexture.TextureFormatClass:

# class PySide2.QtGui.QOpenGLTexture.TextureUnitReset:

# class PySide2.QtGui.QOpenGLTexture.WrapMode:
    "PySide2.QtGui.QOpenGLTexture.__init__": [('PySide2.QtGui.QImage', 'PySide2.QtGui.QOpenGLTexture.MipMapGeneration'), ('PySide2.QtGui.QOpenGLTexture.Target',)],
    "PySide2.QtGui.QOpenGLTexture.allocateStorage": [(), ('PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType')],
    "PySide2.QtGui.QOpenGLTexture.bind": [(), ('int', 'PySide2.QtGui.QOpenGLTexture.TextureUnitReset')],
    "PySide2.QtGui.QOpenGLTexture.borderColor": (),
    "PySide2.QtGui.QOpenGLTexture.boundTextureId": [('PySide2.QtGui.QOpenGLTexture.BindingTarget',), ('int', 'PySide2.QtGui.QOpenGLTexture.BindingTarget')],
    "PySide2.QtGui.QOpenGLTexture.comparisonFunction": (),
    "PySide2.QtGui.QOpenGLTexture.comparisonMode": (),
    "PySide2.QtGui.QOpenGLTexture.create": (),
    "PySide2.QtGui.QOpenGLTexture.createTextureView": ('PySide2.QtGui.QOpenGLTexture.Target', 'PySide2.QtGui.QOpenGLTexture.TextureFormat', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLTexture.depth": (),
    "PySide2.QtGui.QOpenGLTexture.depthStencilMode": (),
    "PySide2.QtGui.QOpenGLTexture.destroy": (),
    "PySide2.QtGui.QOpenGLTexture.faces": (),
    "PySide2.QtGui.QOpenGLTexture.format": (),
    "PySide2.QtGui.QOpenGLTexture.generateMipMaps": [(), ('int', 'bool')],
    "PySide2.QtGui.QOpenGLTexture.hasFeature": ('PySide2.QtGui.QOpenGLTexture.Feature',),
    "PySide2.QtGui.QOpenGLTexture.height": (),
    "PySide2.QtGui.QOpenGLTexture.isAutoMipMapGenerationEnabled": (),
    "PySide2.QtGui.QOpenGLTexture.isBound": [(), ('int',)],
    "PySide2.QtGui.QOpenGLTexture.isCreated": (),
    "PySide2.QtGui.QOpenGLTexture.isFixedSamplePositions": (),
    "PySide2.QtGui.QOpenGLTexture.isStorageAllocated": (),
    "PySide2.QtGui.QOpenGLTexture.isTextureView": (),
    "PySide2.QtGui.QOpenGLTexture.layers": (),
    "PySide2.QtGui.QOpenGLTexture.levelOfDetailRange": (),
    "PySide2.QtGui.QOpenGLTexture.levelofDetailBias": (),
    "PySide2.QtGui.QOpenGLTexture.magnificationFilter": (),
    "PySide2.QtGui.QOpenGLTexture.maximumAnisotropy": (),
    "PySide2.QtGui.QOpenGLTexture.maximumLevelOfDetail": (),
    "PySide2.QtGui.QOpenGLTexture.maximumMipLevels": (),
    "PySide2.QtGui.QOpenGLTexture.minMagFilters": (),
    "PySide2.QtGui.QOpenGLTexture.minificationFilter": (),
    "PySide2.QtGui.QOpenGLTexture.minimumLevelOfDetail": (),
    "PySide2.QtGui.QOpenGLTexture.mipBaseLevel": (),
    "PySide2.QtGui.QOpenGLTexture.mipLevelRange": (),
    "PySide2.QtGui.QOpenGLTexture.mipLevels": (),
    "PySide2.QtGui.QOpenGLTexture.mipMaxLevel": (),
    "PySide2.QtGui.QOpenGLTexture.release": [(), ('int', 'PySide2.QtGui.QOpenGLTexture.TextureUnitReset')],
    "PySide2.QtGui.QOpenGLTexture.samples": (),
    "PySide2.QtGui.QOpenGLTexture.setAutoMipMapGenerationEnabled": ('bool',),
    "PySide2.QtGui.QOpenGLTexture.setBorderColor": [('PySide2.QtGui.QColor',), ('float', 'float', 'float', 'float'), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QOpenGLTexture.setComparisonFunction": ('PySide2.QtGui.QOpenGLTexture.ComparisonFunction',),
    "PySide2.QtGui.QOpenGLTexture.setComparisonMode": ('PySide2.QtGui.QOpenGLTexture.ComparisonMode',),
    "PySide2.QtGui.QOpenGLTexture.setCompressedData": [('int', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'PySide2.QtGui.QOpenGLTexture.CubeMapFace', 'int', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'PySide2.QtGui.QOpenGLTexture.CubeMapFace', 'int', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions')],
    "PySide2.QtGui.QOpenGLTexture.setData": [('PySide2.QtGui.QImage', 'PySide2.QtGui.QOpenGLTexture.MipMapGeneration'), ('PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'PySide2.QtGui.QOpenGLTexture.CubeMapFace', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'PySide2.QtGui.QOpenGLTexture.CubeMapFace', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'int', 'int', 'int', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'PySide2.QtGui.QOpenGLTexture.CubeMapFace', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'PySide2.QtGui.QOpenGLTexture.CubeMapFace', 'int', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions'), ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'PySide2.QtGui.QOpenGLTexture.PixelFormat', 'PySide2.QtGui.QOpenGLTexture.PixelType', 'int', 'PySide2.QtGui.QOpenGLPixelTransferOptions')],
    "PySide2.QtGui.QOpenGLTexture.setDepthStencilMode": ('PySide2.QtGui.QOpenGLTexture.DepthStencilMode',),
    "PySide2.QtGui.QOpenGLTexture.setFixedSamplePositions": ('bool',),
    "PySide2.QtGui.QOpenGLTexture.setFormat": ('PySide2.QtGui.QOpenGLTexture.TextureFormat',),
    "PySide2.QtGui.QOpenGLTexture.setLayers": ('int',),
    "PySide2.QtGui.QOpenGLTexture.setLevelOfDetailRange": ('float', 'float'),
    "PySide2.QtGui.QOpenGLTexture.setLevelofDetailBias": ('float',),
    "PySide2.QtGui.QOpenGLTexture.setMagnificationFilter": ('PySide2.QtGui.QOpenGLTexture.Filter',),
    "PySide2.QtGui.QOpenGLTexture.setMaximumAnisotropy": ('float',),
    "PySide2.QtGui.QOpenGLTexture.setMaximumLevelOfDetail": ('float',),
    "PySide2.QtGui.QOpenGLTexture.setMinMagFilters": ('PySide2.QtGui.QOpenGLTexture.Filter', 'PySide2.QtGui.QOpenGLTexture.Filter'),
    "PySide2.QtGui.QOpenGLTexture.setMinificationFilter": ('PySide2.QtGui.QOpenGLTexture.Filter',),
    "PySide2.QtGui.QOpenGLTexture.setMinimumLevelOfDetail": ('float',),
    "PySide2.QtGui.QOpenGLTexture.setMipBaseLevel": ('int',),
    "PySide2.QtGui.QOpenGLTexture.setMipLevelRange": ('int', 'int'),
    "PySide2.QtGui.QOpenGLTexture.setMipLevels": ('int',),
    "PySide2.QtGui.QOpenGLTexture.setMipMaxLevel": ('int',),
    "PySide2.QtGui.QOpenGLTexture.setSamples": ('int',),
    "PySide2.QtGui.QOpenGLTexture.setSize": ('int', 'int', 'int'),
    "PySide2.QtGui.QOpenGLTexture.setSwizzleMask": [('PySide2.QtGui.QOpenGLTexture.SwizzleComponent', 'PySide2.QtGui.QOpenGLTexture.SwizzleValue'), ('PySide2.QtGui.QOpenGLTexture.SwizzleValue', 'PySide2.QtGui.QOpenGLTexture.SwizzleValue', 'PySide2.QtGui.QOpenGLTexture.SwizzleValue', 'PySide2.QtGui.QOpenGLTexture.SwizzleValue')],
    "PySide2.QtGui.QOpenGLTexture.setWrapMode": [('PySide2.QtGui.QOpenGLTexture.CoordinateDirection', 'PySide2.QtGui.QOpenGLTexture.WrapMode'), ('PySide2.QtGui.QOpenGLTexture.WrapMode',)],
    "PySide2.QtGui.QOpenGLTexture.swizzleMask": ('PySide2.QtGui.QOpenGLTexture.SwizzleComponent',),
    "PySide2.QtGui.QOpenGLTexture.target": (),
    "PySide2.QtGui.QOpenGLTexture.textureId": (),
    "PySide2.QtGui.QOpenGLTexture.width": (),
    "PySide2.QtGui.QOpenGLTexture.wrapMode": ('PySide2.QtGui.QOpenGLTexture.CoordinateDirection',),

# class PySide2.QtGui.QOpenGLTextureBlitter:

# class PySide2.QtGui.QOpenGLTextureBlitter.Origin:
    "PySide2.QtGui.QOpenGLTextureBlitter.__init__": (),
    "PySide2.QtGui.QOpenGLTextureBlitter.bind": ('int',),
    "PySide2.QtGui.QOpenGLTextureBlitter.blit": [('int', 'PySide2.QtGui.QMatrix4x4', 'PySide2.QtGui.QMatrix3x3'), ('int', 'PySide2.QtGui.QMatrix4x4', 'PySide2.QtGui.QOpenGLTextureBlitter.Origin')],
    "PySide2.QtGui.QOpenGLTextureBlitter.create": (),
    "PySide2.QtGui.QOpenGLTextureBlitter.destroy": (),
    "PySide2.QtGui.QOpenGLTextureBlitter.isCreated": (),
    "PySide2.QtGui.QOpenGLTextureBlitter.release": (),
    "PySide2.QtGui.QOpenGLTextureBlitter.setOpacity": ('float',),
    "PySide2.QtGui.QOpenGLTextureBlitter.setRedBlueSwizzle": ('bool',),
    "PySide2.QtGui.QOpenGLTextureBlitter.sourceTransform": ('PySide2.QtCore.QRectF', 'PySide2.QtCore.QSize', 'PySide2.QtGui.QOpenGLTextureBlitter.Origin'),
    "PySide2.QtGui.QOpenGLTextureBlitter.supportsExternalOESTarget": (),
    "PySide2.QtGui.QOpenGLTextureBlitter.targetTransform": ('PySide2.QtCore.QRectF', 'PySide2.QtCore.QRect'),

# class PySide2.QtGui.QOpenGLTimeMonitor:
    "PySide2.QtGui.QOpenGLTimeMonitor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QOpenGLTimeMonitor.create": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.destroy": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.isCreated": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.isResultAvailable": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.objectIds": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.recordSample": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.reset": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.sampleCount": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.setSampleCount": ('int',),
    "PySide2.QtGui.QOpenGLTimeMonitor.waitForIntervals": (),
    "PySide2.QtGui.QOpenGLTimeMonitor.waitForSamples": (),

# class PySide2.QtGui.QOpenGLTimerQuery:
    "PySide2.QtGui.QOpenGLTimerQuery.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QOpenGLTimerQuery.begin": (),
    "PySide2.QtGui.QOpenGLTimerQuery.create": (),
    "PySide2.QtGui.QOpenGLTimerQuery.destroy": (),
    "PySide2.QtGui.QOpenGLTimerQuery.end": (),
    "PySide2.QtGui.QOpenGLTimerQuery.isCreated": (),
    "PySide2.QtGui.QOpenGLTimerQuery.isResultAvailable": (),
    "PySide2.QtGui.QOpenGLTimerQuery.objectId": (),
    "PySide2.QtGui.QOpenGLTimerQuery.recordTimestamp": (),
    "PySide2.QtGui.QOpenGLTimerQuery.waitForResult": (),
    "PySide2.QtGui.QOpenGLTimerQuery.waitForTimestamp": (),

# class PySide2.QtGui.QOpenGLVersionProfile:
    "PySide2.QtGui.QOpenGLVersionProfile.__init__": [(), ('PySide2.QtGui.QOpenGLVersionProfile',), ('PySide2.QtGui.QSurfaceFormat',)],
    "PySide2.QtGui.QOpenGLVersionProfile.__copy__": (),
    "PySide2.QtGui.QOpenGLVersionProfile.hasProfiles": (),
    "PySide2.QtGui.QOpenGLVersionProfile.isLegacyVersion": (),
    "PySide2.QtGui.QOpenGLVersionProfile.isValid": (),
    "PySide2.QtGui.QOpenGLVersionProfile.profile": (),
    "PySide2.QtGui.QOpenGLVersionProfile.setProfile": ('PySide2.QtGui.QSurfaceFormat.OpenGLContextProfile',),
    "PySide2.QtGui.QOpenGLVersionProfile.setVersion": ('int', 'int'),
    "PySide2.QtGui.QOpenGLVersionProfile.version": (),

# class PySide2.QtGui.QOpenGLVertexArrayObject:

# class PySide2.QtGui.QOpenGLVertexArrayObject.Binder:
    "PySide2.QtGui.QOpenGLVertexArrayObject.Binder.__init__": ('PySide2.QtGui.QOpenGLVertexArrayObject',),
    "PySide2.QtGui.QOpenGLVertexArrayObject.Binder.rebind": (),
    "PySide2.QtGui.QOpenGLVertexArrayObject.Binder.release": (),

    "PySide2.QtGui.QOpenGLVertexArrayObject.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QOpenGLVertexArrayObject.bind": (),
    "PySide2.QtGui.QOpenGLVertexArrayObject.create": (),
    "PySide2.QtGui.QOpenGLVertexArrayObject.destroy": (),
    "PySide2.QtGui.QOpenGLVertexArrayObject.isCreated": (),
    "PySide2.QtGui.QOpenGLVertexArrayObject.objectId": (),
    "PySide2.QtGui.QOpenGLVertexArrayObject.release": (),

# class PySide2.QtGui.QOpenGLWindow:

# class PySide2.QtGui.QOpenGLWindow.UpdateBehavior:
    "PySide2.QtGui.QOpenGLWindow.__init__": [('PySide2.QtGui.QOpenGLContext', 'PySide2.QtGui.QOpenGLWindow.UpdateBehavior', 'PySide2.QtGui.QWindow'), ('PySide2.QtGui.QOpenGLWindow.UpdateBehavior', 'PySide2.QtGui.QWindow')],
    "PySide2.QtGui.QOpenGLWindow.context": (),
    "PySide2.QtGui.QOpenGLWindow.defaultFramebufferObject": (),
    "PySide2.QtGui.QOpenGLWindow.doneCurrent": (),
    "PySide2.QtGui.QOpenGLWindow.grabFramebuffer": (),
    "PySide2.QtGui.QOpenGLWindow.initializeGL": (),
    "PySide2.QtGui.QOpenGLWindow.isValid": (),
    "PySide2.QtGui.QOpenGLWindow.makeCurrent": (),
    "PySide2.QtGui.QOpenGLWindow.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QOpenGLWindow.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtGui.QOpenGLWindow.paintGL": (),
    "PySide2.QtGui.QOpenGLWindow.paintOverGL": (),
    "PySide2.QtGui.QOpenGLWindow.paintUnderGL": (),
    "PySide2.QtGui.QOpenGLWindow.redirected": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QOpenGLWindow.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtGui.QOpenGLWindow.resizeGL": ('int', 'int'),
    "PySide2.QtGui.QOpenGLWindow.shareContext": (),
    "PySide2.QtGui.QOpenGLWindow.updateBehavior": (),

# class PySide2.QtGui.QPageLayout:

# class PySide2.QtGui.QPageLayout.Mode:

# class PySide2.QtGui.QPageLayout.Orientation:

# class PySide2.QtGui.QPageLayout.Unit:
    "PySide2.QtGui.QPageLayout.__init__": [(), ('PySide2.QtGui.QPageLayout',), ('PySide2.QtGui.QPageSize', 'PySide2.QtGui.QPageLayout.Orientation', 'PySide2.QtCore.QMarginsF', 'PySide2.QtGui.QPageLayout.Unit', 'PySide2.QtCore.QMarginsF')],
    "PySide2.QtGui.QPageLayout.__copy__": (),
    "PySide2.QtGui.QPageLayout.fullRect": [(), ('PySide2.QtGui.QPageLayout.Unit',)],
    "PySide2.QtGui.QPageLayout.fullRectPixels": ('int',),
    "PySide2.QtGui.QPageLayout.fullRectPoints": (),
    "PySide2.QtGui.QPageLayout.isEquivalentTo": ('PySide2.QtGui.QPageLayout',),
    "PySide2.QtGui.QPageLayout.isValid": (),
    "PySide2.QtGui.QPageLayout.margins": [(), ('PySide2.QtGui.QPageLayout.Unit',)],
    "PySide2.QtGui.QPageLayout.marginsPixels": ('int',),
    "PySide2.QtGui.QPageLayout.marginsPoints": (),
    "PySide2.QtGui.QPageLayout.maximumMargins": (),
    "PySide2.QtGui.QPageLayout.minimumMargins": (),
    "PySide2.QtGui.QPageLayout.mode": (),
    "PySide2.QtGui.QPageLayout.orientation": (),
    "PySide2.QtGui.QPageLayout.pageSize": (),
    "PySide2.QtGui.QPageLayout.paintRect": [(), ('PySide2.QtGui.QPageLayout.Unit',)],
    "PySide2.QtGui.QPageLayout.paintRectPixels": ('int',),
    "PySide2.QtGui.QPageLayout.paintRectPoints": (),
    "PySide2.QtGui.QPageLayout.setBottomMargin": ('float',),
    "PySide2.QtGui.QPageLayout.setLeftMargin": ('float',),
    "PySide2.QtGui.QPageLayout.setMargins": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtGui.QPageLayout.setMinimumMargins": ('PySide2.QtCore.QMarginsF',),
    "PySide2.QtGui.QPageLayout.setMode": ('PySide2.QtGui.QPageLayout.Mode',),
    "PySide2.QtGui.QPageLayout.setOrientation": ('PySide2.QtGui.QPageLayout.Orientation',),
    "PySide2.QtGui.QPageLayout.setPageSize": ('PySide2.QtGui.QPageSize', 'PySide2.QtCore.QMarginsF'),
    "PySide2.QtGui.QPageLayout.setRightMargin": ('float',),
    "PySide2.QtGui.QPageLayout.setTopMargin": ('float',),
    "PySide2.QtGui.QPageLayout.setUnits": ('PySide2.QtGui.QPageLayout.Unit',),
    "PySide2.QtGui.QPageLayout.swap": ('PySide2.QtGui.QPageLayout',),
    "PySide2.QtGui.QPageLayout.units": (),

# class PySide2.QtGui.QPageSize:

# class PySide2.QtGui.QPageSize.PageSizeId:

# class PySide2.QtGui.QPageSize.SizeMatchPolicy:

# class PySide2.QtGui.QPageSize.Unit:
    "PySide2.QtGui.QPageSize.__init__": [(), ('PySide2.QtCore.QSize', 'str', 'PySide2.QtGui.QPageSize.SizeMatchPolicy'), ('PySide2.QtCore.QSizeF', 'PySide2.QtGui.QPageSize.Unit', 'str', 'PySide2.QtGui.QPageSize.SizeMatchPolicy'), ('PySide2.QtGui.QPageSize',), ('PySide2.QtGui.QPageSize.PageSizeId',)],
    "PySide2.QtGui.QPageSize.__copy__": (),
    "PySide2.QtGui.QPageSize.definitionSize": [(), ('PySide2.QtGui.QPageSize.PageSizeId',)],
    "PySide2.QtGui.QPageSize.definitionUnits": [(), ('PySide2.QtGui.QPageSize.PageSizeId',)],
    "PySide2.QtGui.QPageSize.id": [(), ('PySide2.QtCore.QSize', 'PySide2.QtGui.QPageSize.SizeMatchPolicy'), ('PySide2.QtCore.QSizeF', 'PySide2.QtGui.QPageSize.Unit', 'PySide2.QtGui.QPageSize.SizeMatchPolicy'), ('int',)],
    "PySide2.QtGui.QPageSize.isEquivalentTo": ('PySide2.QtGui.QPageSize',),
    "PySide2.QtGui.QPageSize.isValid": (),
    "PySide2.QtGui.QPageSize.key": [(), ('PySide2.QtGui.QPageSize.PageSizeId',)],
    "PySide2.QtGui.QPageSize.name": [(), ('PySide2.QtGui.QPageSize.PageSizeId',)],
    "PySide2.QtGui.QPageSize.rect": ('PySide2.QtGui.QPageSize.Unit',),
    "PySide2.QtGui.QPageSize.rectPixels": ('int',),
    "PySide2.QtGui.QPageSize.rectPoints": (),
    "PySide2.QtGui.QPageSize.size": [('PySide2.QtGui.QPageSize.PageSizeId', 'PySide2.QtGui.QPageSize.Unit'), ('PySide2.QtGui.QPageSize.Unit',)],
    "PySide2.QtGui.QPageSize.sizePixels": [('PySide2.QtGui.QPageSize.PageSizeId', 'int'), ('int',)],
    "PySide2.QtGui.QPageSize.sizePoints": [(), ('PySide2.QtGui.QPageSize.PageSizeId',)],
    "PySide2.QtGui.QPageSize.swap": ('PySide2.QtGui.QPageSize',),
    "PySide2.QtGui.QPageSize.windowsId": [(), ('PySide2.QtGui.QPageSize.PageSizeId',)],

# class PySide2.QtGui.QPagedPaintDevice:

# class PySide2.QtGui.QPagedPaintDevice.Margins:
    "PySide2.QtGui.QPagedPaintDevice.Margins.__init__": [(), ('PySide2.QtGui.QPagedPaintDevice.Margins',)],
    "PySide2.QtGui.QPagedPaintDevice.Margins.__copy__": (),

# class PySide2.QtGui.QPagedPaintDevice.PageSize:

# class PySide2.QtGui.QPagedPaintDevice.PdfVersion:

    "PySide2.QtGui.QPagedPaintDevice.__init__": (),
    "PySide2.QtGui.QPagedPaintDevice.devicePageLayout": (),
    "PySide2.QtGui.QPagedPaintDevice.margins": (),
    "PySide2.QtGui.QPagedPaintDevice.newPage": (),
    "PySide2.QtGui.QPagedPaintDevice.pageLayout": (),
    "PySide2.QtGui.QPagedPaintDevice.pageSize": (),
    "PySide2.QtGui.QPagedPaintDevice.pageSizeMM": (),
    "PySide2.QtGui.QPagedPaintDevice.setMargins": ('PySide2.QtGui.QPagedPaintDevice.Margins',),
    "PySide2.QtGui.QPagedPaintDevice.setPageLayout": ('PySide2.QtGui.QPageLayout',),
    "PySide2.QtGui.QPagedPaintDevice.setPageMargins": [('PySide2.QtCore.QMarginsF',), ('PySide2.QtCore.QMarginsF', 'PySide2.QtGui.QPageLayout.Unit')],
    "PySide2.QtGui.QPagedPaintDevice.setPageOrientation": ('PySide2.QtGui.QPageLayout.Orientation',),
    "PySide2.QtGui.QPagedPaintDevice.setPageSize": [('PySide2.QtGui.QPageSize',), ('PySide2.QtGui.QPagedPaintDevice.PageSize',)],
    "PySide2.QtGui.QPagedPaintDevice.setPageSizeMM": ('PySide2.QtCore.QSizeF',),

# class PySide2.QtGui.QPaintDevice:

# class PySide2.QtGui.QPaintDevice.PaintDeviceMetric:
    "PySide2.QtGui.QPaintDevice.__init__": (),
    "PySide2.QtGui.QPaintDevice.colorCount": (),
    "PySide2.QtGui.QPaintDevice.depth": (),
    "PySide2.QtGui.QPaintDevice.devType": (),
    "PySide2.QtGui.QPaintDevice.devicePixelRatio": (),
    "PySide2.QtGui.QPaintDevice.devicePixelRatioF": (),
    "PySide2.QtGui.QPaintDevice.devicePixelRatioFScale": (),
    "PySide2.QtGui.QPaintDevice.height": (),
    "PySide2.QtGui.QPaintDevice.heightMM": (),
    "PySide2.QtGui.QPaintDevice.initPainter": ('PySide2.QtGui.QPainter',),
    "PySide2.QtGui.QPaintDevice.logicalDpiX": (),
    "PySide2.QtGui.QPaintDevice.logicalDpiY": (),
    "PySide2.QtGui.QPaintDevice.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QPaintDevice.paintEngine": (),
    "PySide2.QtGui.QPaintDevice.paintingActive": (),
    "PySide2.QtGui.QPaintDevice.physicalDpiX": (),
    "PySide2.QtGui.QPaintDevice.physicalDpiY": (),
    "PySide2.QtGui.QPaintDevice.redirected": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPaintDevice.sharedPainter": (),
    "PySide2.QtGui.QPaintDevice.width": (),
    "PySide2.QtGui.QPaintDevice.widthMM": (),

# class PySide2.QtGui.QPaintDeviceWindow:
    "PySide2.QtGui.QPaintDeviceWindow.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtGui.QPaintDeviceWindow.exposeEvent": ('PySide2.QtGui.QExposeEvent',),
    "PySide2.QtGui.QPaintDeviceWindow.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QPaintDeviceWindow.paintEngine": (),
    "PySide2.QtGui.QPaintDeviceWindow.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtGui.QPaintDeviceWindow.update": [(), ('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],

# class PySide2.QtGui.QPaintEngine:

# class PySide2.QtGui.QPaintEngine.DirtyFlag:

# class PySide2.QtGui.QPaintEngine.DirtyFlags:

# class PySide2.QtGui.QPaintEngine.PaintEngineFeature:

# class PySide2.QtGui.QPaintEngine.PaintEngineFeatures:

# class PySide2.QtGui.QPaintEngine.PolygonDrawMode:

# class PySide2.QtGui.QPaintEngine.Type:
    "PySide2.QtGui.QPaintEngine.__init__": ('PySide2.QtGui.QPaintEngine.PaintEngineFeatures',),
    "PySide2.QtGui.QPaintEngine.begin": ('PySide2.QtGui.QPaintDevice',),
    "PySide2.QtGui.QPaintEngine.clearDirty": ('PySide2.QtGui.QPaintEngine.DirtyFlags',),
    "PySide2.QtGui.QPaintEngine.coordinateOffset": (),
    "PySide2.QtGui.QPaintEngine.drawEllipse": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtGui.QPaintEngine.drawImage": ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QImage', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QPaintEngine.drawLines": [('PySide2.QtCore.QLine', 'int'), ('PySide2.QtCore.QLineF', 'int')],
    "PySide2.QtGui.QPaintEngine.drawPath": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPaintEngine.drawPixmap": ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QRectF'),
    "PySide2.QtGui.QPaintEngine.drawPoints": [('PySide2.QtCore.QPoint', 'int'), ('PySide2.QtCore.QPointF', 'int')],
    "PySide2.QtGui.QPaintEngine.drawPolygon": [('PySide2.QtCore.QPoint', 'int', 'PySide2.QtGui.QPaintEngine.PolygonDrawMode'), ('PySide2.QtCore.QPointF', 'int', 'PySide2.QtGui.QPaintEngine.PolygonDrawMode')],
    "PySide2.QtGui.QPaintEngine.drawRects": [('PySide2.QtCore.QRect', 'int'), ('PySide2.QtCore.QRectF', 'int')],
    "PySide2.QtGui.QPaintEngine.drawTextItem": ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QTextItem'),
    "PySide2.QtGui.QPaintEngine.drawTiledPixmap": ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QPointF'),
    "PySide2.QtGui.QPaintEngine.end": (),
    "PySide2.QtGui.QPaintEngine.hasFeature": ('PySide2.QtGui.QPaintEngine.PaintEngineFeatures',),
    "PySide2.QtGui.QPaintEngine.isActive": (),
    "PySide2.QtGui.QPaintEngine.isExtended": (),
    "PySide2.QtGui.QPaintEngine.paintDevice": (),
    "PySide2.QtGui.QPaintEngine.painter": (),
    "PySide2.QtGui.QPaintEngine.setActive": ('bool',),
    "PySide2.QtGui.QPaintEngine.setDirty": ('PySide2.QtGui.QPaintEngine.DirtyFlags',),
    "PySide2.QtGui.QPaintEngine.setSystemClip": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QPaintEngine.setSystemRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtGui.QPaintEngine.syncState": (),
    "PySide2.QtGui.QPaintEngine.systemClip": (),
    "PySide2.QtGui.QPaintEngine.systemRect": (),
    "PySide2.QtGui.QPaintEngine.testDirty": ('PySide2.QtGui.QPaintEngine.DirtyFlags',),
    "PySide2.QtGui.QPaintEngine.type": (),
    "PySide2.QtGui.QPaintEngine.updateState": ('PySide2.QtGui.QPaintEngineState',),

# class PySide2.QtGui.QPaintEngineState:
    "PySide2.QtGui.QPaintEngineState.__init__": (),
    "PySide2.QtGui.QPaintEngineState.backgroundBrush": (),
    "PySide2.QtGui.QPaintEngineState.backgroundMode": (),
    "PySide2.QtGui.QPaintEngineState.brush": (),
    "PySide2.QtGui.QPaintEngineState.brushNeedsResolving": (),
    "PySide2.QtGui.QPaintEngineState.brushOrigin": (),
    "PySide2.QtGui.QPaintEngineState.clipOperation": (),
    "PySide2.QtGui.QPaintEngineState.clipPath": (),
    "PySide2.QtGui.QPaintEngineState.clipRegion": (),
    "PySide2.QtGui.QPaintEngineState.compositionMode": (),
    "PySide2.QtGui.QPaintEngineState.font": (),
    "PySide2.QtGui.QPaintEngineState.isClipEnabled": (),
    "PySide2.QtGui.QPaintEngineState.matrix": (),
    "PySide2.QtGui.QPaintEngineState.opacity": (),
    "PySide2.QtGui.QPaintEngineState.painter": (),
    "PySide2.QtGui.QPaintEngineState.pen": (),
    "PySide2.QtGui.QPaintEngineState.penNeedsResolving": (),
    "PySide2.QtGui.QPaintEngineState.renderHints": (),
    "PySide2.QtGui.QPaintEngineState.state": (),
    "PySide2.QtGui.QPaintEngineState.transform": (),

# class PySide2.QtGui.QPaintEvent:
    "PySide2.QtGui.QPaintEvent.__init__": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QPaintEvent.rect": (),
    "PySide2.QtGui.QPaintEvent.region": (),

# class PySide2.QtGui.QPainter:

# class PySide2.QtGui.QPainter.CompositionMode:

# class PySide2.QtGui.QPainter.PixmapFragment:
    "PySide2.QtGui.QPainter.PixmapFragment.__init__": [(), ('PySide2.QtGui.QPainter.PixmapFragment',)],
    "PySide2.QtGui.QPainter.PixmapFragment.__copy__": (),
    "PySide2.QtGui.QPainter.PixmapFragment.create": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QRectF', 'float', 'float', 'float', 'float'),

# class PySide2.QtGui.QPainter.PixmapFragmentHint:

# class PySide2.QtGui.QPainter.PixmapFragmentHints:

# class PySide2.QtGui.QPainter.RenderHint:

# class PySide2.QtGui.QPainter.RenderHints:

    "PySide2.QtGui.QPainter.__init__": [(), ('PySide2.QtGui.QPaintDevice',)],
    "PySide2.QtGui.QPainter.background": (),
    "PySide2.QtGui.QPainter.backgroundMode": (),
    "PySide2.QtGui.QPainter.begin": ('PySide2.QtGui.QPaintDevice',),
    "PySide2.QtGui.QPainter.beginNativePainting": (),
    "PySide2.QtGui.QPainter.boundingRect": [('PySide2.QtCore.QRect', 'int', 'str'), ('PySide2.QtCore.QRectF', 'int', 'str'), ('PySide2.QtCore.QRectF', 'str', 'PySide2.QtGui.QTextOption'), ('int', 'int', 'int', 'int', 'int', 'str')],
    "PySide2.QtGui.QPainter.brush": (),
    "PySide2.QtGui.QPainter.brushOrigin": (),
    "PySide2.QtGui.QPainter.clipBoundingRect": (),
    "PySide2.QtGui.QPainter.clipPath": (),
    "PySide2.QtGui.QPainter.clipRegion": (),
    "PySide2.QtGui.QPainter.combinedMatrix": (),
    "PySide2.QtGui.QPainter.combinedTransform": (),
    "PySide2.QtGui.QPainter.compositionMode": (),
    "PySide2.QtGui.QPainter.device": (),
    "PySide2.QtGui.QPainter.deviceMatrix": (),
    "PySide2.QtGui.QPainter.deviceTransform": (),
    "PySide2.QtGui.QPainter.drawArc": [('PySide2.QtCore.QRect', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int'), ('int', 'int', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawChord": [('PySide2.QtCore.QRect', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int'), ('int', 'int', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawConvexPolygon": [('PySide2.QtGui.QPolygon',), ('PySide2.QtGui.QPolygonF',), ('typing.List[PySide2.QtCore.QPointF]',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPainter.drawEllipse": [('PySide2.QtCore.QPoint', 'int', 'int'), ('PySide2.QtCore.QPointF', 'float', 'float'), ('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawImage": [('PySide2.QtCore.QPoint', 'PySide2.QtGui.QImage'), ('PySide2.QtCore.QPoint', 'PySide2.QtGui.QImage', 'PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QImage'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QImage', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QImage'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QImage', 'PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QImage'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QImage', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('int', 'int', 'PySide2.QtGui.QImage', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.ImageConversionFlags')],
    "PySide2.QtGui.QPainter.drawLine": [('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawLines": [('typing.List[PySide2.QtCore.QLineF]',), ('typing.List[PySide2.QtCore.QLine]',), ('typing.List[PySide2.QtCore.QPointF]',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPainter.drawPath": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainter.drawPicture": [('PySide2.QtCore.QPoint', 'PySide2.QtGui.QPicture'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QPicture'), ('int', 'int', 'PySide2.QtGui.QPicture')],
    "PySide2.QtGui.QPainter.drawPie": [('PySide2.QtCore.QRect', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int'), ('int', 'int', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawPixmap": [('PySide2.QtCore.QPoint', 'PySide2.QtGui.QPixmap'), ('PySide2.QtCore.QPoint', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QRect'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QPixmap'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QRectF'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QPixmap'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QRect'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QRectF'), ('int', 'int', 'PySide2.QtGui.QPixmap'), ('int', 'int', 'PySide2.QtGui.QPixmap', 'int', 'int', 'int', 'int'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QPixmap'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QPixmap', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawPixmapFragments": ('PySide2.QtGui.QPainter.PixmapFragment', 'int', 'PySide2.QtGui.QPixmap', 'PySide2.QtGui.QPainter.PixmapFragmentHints'),
    "PySide2.QtGui.QPainter.drawPoint": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('int', 'int')],
    "PySide2.QtGui.QPainter.drawPoints": [('PySide2.QtGui.QPolygon',), ('PySide2.QtGui.QPolygonF',), ('typing.List[PySide2.QtCore.QPointF]',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPainter.drawPolygon": [('PySide2.QtGui.QPolygon', 'PySide2.QtCore.Qt.FillRule'), ('PySide2.QtGui.QPolygonF', 'PySide2.QtCore.Qt.FillRule'), ('typing.List[PySide2.QtCore.QPointF]', 'PySide2.QtCore.Qt.FillRule'), ('typing.List[PySide2.QtCore.QPoint]', 'PySide2.QtCore.Qt.FillRule')],
    "PySide2.QtGui.QPainter.drawPolyline": [('PySide2.QtGui.QPolygon',), ('PySide2.QtGui.QPolygonF',), ('typing.List[PySide2.QtCore.QPointF]',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPainter.drawRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawRects": [('typing.List[PySide2.QtCore.QRectF]',), ('typing.List[PySide2.QtCore.QRect]',)],
    "PySide2.QtGui.QPainter.drawRoundRect": [('PySide2.QtCore.QRect', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int'), ('int', 'int', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.drawRoundedRect": [('PySide2.QtCore.QRect', 'float', 'float', 'PySide2.QtCore.Qt.SizeMode'), ('PySide2.QtCore.QRectF', 'float', 'float', 'PySide2.QtCore.Qt.SizeMode'), ('int', 'int', 'int', 'int', 'float', 'float', 'PySide2.QtCore.Qt.SizeMode')],
    "PySide2.QtGui.QPainter.drawStaticText": [('PySide2.QtCore.QPoint', 'PySide2.QtGui.QStaticText'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QStaticText'), ('int', 'int', 'PySide2.QtGui.QStaticText')],
    "PySide2.QtGui.QPainter.drawText": [('PySide2.QtCore.QPoint', 'str'), ('PySide2.QtCore.QPointF', 'str'), ('PySide2.QtCore.QRect', 'int', 'str', 'PySide2.QtCore.QRect'), ('PySide2.QtCore.QRectF', 'int', 'str', 'PySide2.QtCore.QRectF'), ('PySide2.QtCore.QRectF', 'str', 'PySide2.QtGui.QTextOption'), ('int', 'int', 'int', 'int', 'int', 'str', 'PySide2.QtCore.QRect'), ('int', 'int', 'str')],
    "PySide2.QtGui.QPainter.drawTextItem": [('PySide2.QtCore.QPoint', 'PySide2.QtGui.QTextItem'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QTextItem'), ('int', 'int', 'PySide2.QtGui.QTextItem')],
    "PySide2.QtGui.QPainter.drawTiledPixmap": [('PySide2.QtCore.QRect', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QPoint'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.QPointF'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QPixmap', 'int', 'int')],
    "PySide2.QtGui.QPainter.end": (),
    "PySide2.QtGui.QPainter.endNativePainting": (),
    "PySide2.QtGui.QPainter.eraseRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.fillPath": ('PySide2.QtGui.QPainterPath', 'PySide2.QtGui.QBrush'),
    "PySide2.QtGui.QPainter.fillRect": [('PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.BrushStyle'), ('PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.GlobalColor'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QBrush'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QColor'), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QGradient.Preset'), ('PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.BrushStyle'), ('PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.GlobalColor'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QBrush'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QColor'), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QGradient.Preset'), ('int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.BrushStyle'), ('int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.GlobalColor'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QBrush'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QColor'), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QGradient.Preset')],
    "PySide2.QtGui.QPainter.font": (),
    "PySide2.QtGui.QPainter.fontInfo": (),
    "PySide2.QtGui.QPainter.fontMetrics": (),
    "PySide2.QtGui.QPainter.hasClipping": (),
    "PySide2.QtGui.QPainter.initFrom": ('PySide2.QtGui.QPaintDevice',),
    "PySide2.QtGui.QPainter.isActive": (),
    "PySide2.QtGui.QPainter.layoutDirection": (),
    "PySide2.QtGui.QPainter.matrix": (),
    "PySide2.QtGui.QPainter.matrixEnabled": (),
    "PySide2.QtGui.QPainter.opacity": (),
    "PySide2.QtGui.QPainter.paintEngine": (),
    "PySide2.QtGui.QPainter.pen": (),
    "PySide2.QtGui.QPainter.redirected": ('PySide2.QtGui.QPaintDevice', 'PySide2.QtCore.QPoint'),
    "PySide2.QtGui.QPainter.renderHints": (),
    "PySide2.QtGui.QPainter.resetMatrix": (),
    "PySide2.QtGui.QPainter.resetTransform": (),
    "PySide2.QtGui.QPainter.restore": (),
    "PySide2.QtGui.QPainter.restoreRedirected": ('PySide2.QtGui.QPaintDevice',),
    "PySide2.QtGui.QPainter.rotate": ('float',),
    "PySide2.QtGui.QPainter.save": (),
    "PySide2.QtGui.QPainter.scale": ('float', 'float'),
    "PySide2.QtGui.QPainter.setBackground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QPainter.setBackgroundMode": ('PySide2.QtCore.Qt.BGMode',),
    "PySide2.QtGui.QPainter.setBrush": [('PySide2.QtCore.Qt.BrushStyle',), ('PySide2.QtGui.QBrush',)],
    "PySide2.QtGui.QPainter.setBrushOrigin": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('int', 'int')],
    "PySide2.QtGui.QPainter.setClipPath": ('PySide2.QtGui.QPainterPath', 'PySide2.QtCore.Qt.ClipOperation'),
    "PySide2.QtGui.QPainter.setClipRect": [('PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.ClipOperation'), ('PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.ClipOperation'), ('int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.ClipOperation')],
    "PySide2.QtGui.QPainter.setClipRegion": ('PySide2.QtGui.QRegion', 'PySide2.QtCore.Qt.ClipOperation'),
    "PySide2.QtGui.QPainter.setClipping": ('bool',),
    "PySide2.QtGui.QPainter.setCompositionMode": ('PySide2.QtGui.QPainter.CompositionMode',),
    "PySide2.QtGui.QPainter.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QPainter.setLayoutDirection": ('PySide2.QtCore.Qt.LayoutDirection',),
    "PySide2.QtGui.QPainter.setMatrix": ('PySide2.QtGui.QMatrix', 'bool'),
    "PySide2.QtGui.QPainter.setMatrixEnabled": ('bool',),
    "PySide2.QtGui.QPainter.setOpacity": ('float',),
    "PySide2.QtGui.QPainter.setPen": [('PySide2.QtCore.Qt.PenStyle',), ('PySide2.QtGui.QColor',), ('PySide2.QtGui.QPen',)],
    "PySide2.QtGui.QPainter.setRedirected": ('PySide2.QtGui.QPaintDevice', 'PySide2.QtGui.QPaintDevice', 'PySide2.QtCore.QPoint'),
    "PySide2.QtGui.QPainter.setRenderHint": ('PySide2.QtGui.QPainter.RenderHint', 'bool'),
    "PySide2.QtGui.QPainter.setRenderHints": ('PySide2.QtGui.QPainter.RenderHints', 'bool'),
    "PySide2.QtGui.QPainter.setTransform": ('PySide2.QtGui.QTransform', 'bool'),
    "PySide2.QtGui.QPainter.setViewTransformEnabled": ('bool',),
    "PySide2.QtGui.QPainter.setViewport": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.setWindow": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPainter.setWorldMatrix": ('PySide2.QtGui.QMatrix', 'bool'),
    "PySide2.QtGui.QPainter.setWorldMatrixEnabled": ('bool',),
    "PySide2.QtGui.QPainter.setWorldTransform": ('PySide2.QtGui.QTransform', 'bool'),
    "PySide2.QtGui.QPainter.shear": ('float', 'float'),
    "PySide2.QtGui.QPainter.strokePath": ('PySide2.QtGui.QPainterPath', 'PySide2.QtGui.QPen'),
    "PySide2.QtGui.QPainter.testRenderHint": ('PySide2.QtGui.QPainter.RenderHint',),
    "PySide2.QtGui.QPainter.transform": (),
    "PySide2.QtGui.QPainter.translate": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPainter.viewTransformEnabled": (),
    "PySide2.QtGui.QPainter.viewport": (),
    "PySide2.QtGui.QPainter.window": (),
    "PySide2.QtGui.QPainter.worldMatrix": (),
    "PySide2.QtGui.QPainter.worldMatrixEnabled": (),
    "PySide2.QtGui.QPainter.worldTransform": (),

# class PySide2.QtGui.QPainterPath:

# class PySide2.QtGui.QPainterPath.Element:
    "PySide2.QtGui.QPainterPath.Element.__init__": [(), ('PySide2.QtGui.QPainterPath.Element',)],
    "PySide2.QtGui.QPainterPath.Element.__copy__": (),
    "PySide2.QtGui.QPainterPath.Element.isCurveTo": (),
    "PySide2.QtGui.QPainterPath.Element.isLineTo": (),
    "PySide2.QtGui.QPainterPath.Element.isMoveTo": (),

# class PySide2.QtGui.QPainterPath.ElementType:

    "PySide2.QtGui.QPainterPath.__init__": [(), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QPainterPath',)],
    "PySide2.QtGui.QPainterPath.__add__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__and__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__copy__": (),
    "PySide2.QtGui.QPainterPath.__iadd__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__iand__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__ior__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__isub__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPainterPath.__mul__": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QPainterPath.__or__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPainterPath.__sub__": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.addEllipse": [('PySide2.QtCore.QPointF', 'float', 'float'), ('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QPainterPath.addPath": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.addPolygon": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtGui.QPainterPath.addRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QPainterPath.addRegion": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QPainterPath.addRoundRect": [('PySide2.QtCore.QRectF', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int'), ('float', 'float', 'float', 'float', 'int'), ('float', 'float', 'float', 'float', 'int', 'int')],
    "PySide2.QtGui.QPainterPath.addRoundedRect": [('PySide2.QtCore.QRectF', 'float', 'float', 'PySide2.QtCore.Qt.SizeMode'), ('float', 'float', 'float', 'float', 'float', 'float', 'PySide2.QtCore.Qt.SizeMode')],
    "PySide2.QtGui.QPainterPath.addText": [('PySide2.QtCore.QPointF', 'PySide2.QtGui.QFont', 'str'), ('float', 'float', 'PySide2.QtGui.QFont', 'str')],
    "PySide2.QtGui.QPainterPath.angleAtPercent": ('float',),
    "PySide2.QtGui.QPainterPath.arcMoveTo": [('PySide2.QtCore.QRectF', 'float'), ('float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QPainterPath.arcTo": [('PySide2.QtCore.QRectF', 'float', 'float'), ('float', 'float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QPainterPath.boundingRect": (),
    "PySide2.QtGui.QPainterPath.capacity": (),
    "PySide2.QtGui.QPainterPath.clear": (),
    "PySide2.QtGui.QPainterPath.closeSubpath": (),
    "PySide2.QtGui.QPainterPath.connectPath": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.contains": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',)],
    "PySide2.QtGui.QPainterPath.controlPointRect": (),
    "PySide2.QtGui.QPainterPath.cubicTo": [('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('float', 'float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QPainterPath.currentPosition": (),
    "PySide2.QtGui.QPainterPath.elementAt": ('int',),
    "PySide2.QtGui.QPainterPath.elementCount": (),
    "PySide2.QtGui.QPainterPath.fillRule": (),
    "PySide2.QtGui.QPainterPath.intersected": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.intersects": [('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',)],
    "PySide2.QtGui.QPainterPath.isEmpty": (),
    "PySide2.QtGui.QPainterPath.length": (),
    "PySide2.QtGui.QPainterPath.lineTo": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPainterPath.moveTo": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPainterPath.percentAtLength": ('float',),
    "PySide2.QtGui.QPainterPath.pointAtPercent": ('float',),
    "PySide2.QtGui.QPainterPath.quadTo": [('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QPainterPath.reserve": ('int',),
    "PySide2.QtGui.QPainterPath.setElementPositionAt": ('int', 'float', 'float'),
    "PySide2.QtGui.QPainterPath.setFillRule": ('PySide2.QtCore.Qt.FillRule',),
    "PySide2.QtGui.QPainterPath.simplified": (),
    "PySide2.QtGui.QPainterPath.slopeAtPercent": ('float',),
    "PySide2.QtGui.QPainterPath.subtracted": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.subtractedInverted": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.swap": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPath.toFillPolygon": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QPainterPath.toFillPolygons": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QPainterPath.toReversed": (),
    "PySide2.QtGui.QPainterPath.toSubpathPolygons": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QPainterPath.translate": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPainterPath.translated": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPainterPath.united": ('PySide2.QtGui.QPainterPath',),

# class PySide2.QtGui.QPainterPathStroker:
    "PySide2.QtGui.QPainterPathStroker.__init__": [(), ('PySide2.QtGui.QPen',)],
    "PySide2.QtGui.QPainterPathStroker.capStyle": (),
    "PySide2.QtGui.QPainterPathStroker.createStroke": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtGui.QPainterPathStroker.curveThreshold": (),
    "PySide2.QtGui.QPainterPathStroker.dashOffset": (),
    "PySide2.QtGui.QPainterPathStroker.dashPattern": (),
    "PySide2.QtGui.QPainterPathStroker.joinStyle": (),
    "PySide2.QtGui.QPainterPathStroker.miterLimit": (),
    "PySide2.QtGui.QPainterPathStroker.setCapStyle": ('PySide2.QtCore.Qt.PenCapStyle',),
    "PySide2.QtGui.QPainterPathStroker.setCurveThreshold": ('float',),
    "PySide2.QtGui.QPainterPathStroker.setDashOffset": ('float',),
    "PySide2.QtGui.QPainterPathStroker.setDashPattern": [('PySide2.QtCore.Qt.PenStyle',), ('typing.List[float]',)],
    "PySide2.QtGui.QPainterPathStroker.setJoinStyle": ('PySide2.QtCore.Qt.PenJoinStyle',),
    "PySide2.QtGui.QPainterPathStroker.setMiterLimit": ('float',),
    "PySide2.QtGui.QPainterPathStroker.setWidth": ('float',),
    "PySide2.QtGui.QPainterPathStroker.width": (),

# class PySide2.QtGui.QPalette:

# class PySide2.QtGui.QPalette.ColorGroup:

# class PySide2.QtGui.QPalette.ColorRole:
    "PySide2.QtGui.QPalette.__init__": [(), ('PySide2.QtCore.Qt.GlobalColor',), ('PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush'), ('PySide2.QtGui.QColor',), ('PySide2.QtGui.QColor', 'PySide2.QtGui.QColor'), ('PySide2.QtGui.QColor', 'PySide2.QtGui.QColor', 'PySide2.QtGui.QColor', 'PySide2.QtGui.QColor', 'PySide2.QtGui.QColor', 'PySide2.QtGui.QColor', 'PySide2.QtGui.QColor'), ('PySide2.QtGui.QPalette',)],
    "PySide2.QtGui.QPalette.__copy__": (),
    "PySide2.QtGui.QPalette.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPalette.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPalette.alternateBase": (),
    "PySide2.QtGui.QPalette.background": (),
    "PySide2.QtGui.QPalette.base": (),
    "PySide2.QtGui.QPalette.brightText": (),
    "PySide2.QtGui.QPalette.brush": [('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QPalette.ColorRole'), ('PySide2.QtGui.QPalette.ColorRole',)],
    "PySide2.QtGui.QPalette.button": (),
    "PySide2.QtGui.QPalette.buttonText": (),
    "PySide2.QtGui.QPalette.cacheKey": (),
    "PySide2.QtGui.QPalette.color": [('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QPalette.ColorRole'), ('PySide2.QtGui.QPalette.ColorRole',)],
    "PySide2.QtGui.QPalette.currentColorGroup": (),
    "PySide2.QtGui.QPalette.dark": (),
    "PySide2.QtGui.QPalette.foreground": (),
    "PySide2.QtGui.QPalette.highlight": (),
    "PySide2.QtGui.QPalette.highlightedText": (),
    "PySide2.QtGui.QPalette.isBrushSet": ('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QPalette.ColorRole'),
    "PySide2.QtGui.QPalette.isCopyOf": ('PySide2.QtGui.QPalette',),
    "PySide2.QtGui.QPalette.isEqual": ('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QPalette.ColorGroup'),
    "PySide2.QtGui.QPalette.light": (),
    "PySide2.QtGui.QPalette.link": (),
    "PySide2.QtGui.QPalette.linkVisited": (),
    "PySide2.QtGui.QPalette.mid": (),
    "PySide2.QtGui.QPalette.midlight": (),
    "PySide2.QtGui.QPalette.placeholderText": (),
    "PySide2.QtGui.QPalette.resolve": [(), ('PySide2.QtGui.QPalette',), ('int',)],
    "PySide2.QtGui.QPalette.setBrush": [('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QPalette.ColorRole', 'PySide2.QtGui.QBrush'), ('PySide2.QtGui.QPalette.ColorRole', 'PySide2.QtGui.QBrush')],
    "PySide2.QtGui.QPalette.setColor": [('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QPalette.ColorRole', 'PySide2.QtGui.QColor'), ('PySide2.QtGui.QPalette.ColorRole', 'PySide2.QtGui.QColor')],
    "PySide2.QtGui.QPalette.setColorGroup": ('PySide2.QtGui.QPalette.ColorGroup', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush', 'PySide2.QtGui.QBrush'),
    "PySide2.QtGui.QPalette.setCurrentColorGroup": ('PySide2.QtGui.QPalette.ColorGroup',),
    "PySide2.QtGui.QPalette.shadow": (),
    "PySide2.QtGui.QPalette.swap": ('PySide2.QtGui.QPalette',),
    "PySide2.QtGui.QPalette.text": (),
    "PySide2.QtGui.QPalette.toolTipBase": (),
    "PySide2.QtGui.QPalette.toolTipText": (),
    "PySide2.QtGui.QPalette.window": (),
    "PySide2.QtGui.QPalette.windowText": (),

# class PySide2.QtGui.QPdfWriter:
    "PySide2.QtGui.QPdfWriter.__init__": [('PySide2.QtCore.QIODevice',), ('str',)],
    "PySide2.QtGui.QPdfWriter.creator": (),
    "PySide2.QtGui.QPdfWriter.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QPdfWriter.newPage": (),
    "PySide2.QtGui.QPdfWriter.paintEngine": (),
    "PySide2.QtGui.QPdfWriter.pdfVersion": (),
    "PySide2.QtGui.QPdfWriter.resolution": (),
    "PySide2.QtGui.QPdfWriter.setCreator": ('str',),
    "PySide2.QtGui.QPdfWriter.setMargins": ('PySide2.QtGui.QPagedPaintDevice.Margins',),
    "PySide2.QtGui.QPdfWriter.setPageSize": ('PySide2.QtGui.QPagedPaintDevice.PageSize',),
    "PySide2.QtGui.QPdfWriter.setPageSizeMM": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtGui.QPdfWriter.setPdfVersion": ('PySide2.QtGui.QPagedPaintDevice.PdfVersion',),
    "PySide2.QtGui.QPdfWriter.setResolution": ('int',),
    "PySide2.QtGui.QPdfWriter.setTitle": ('str',),
    "PySide2.QtGui.QPdfWriter.title": (),

# class PySide2.QtGui.QPen:
    "PySide2.QtGui.QPen.__init__": [(), ('PySide2.QtCore.Qt.PenStyle',), ('PySide2.QtGui.QBrush', 'float', 'PySide2.QtCore.Qt.PenStyle', 'PySide2.QtCore.Qt.PenCapStyle', 'PySide2.QtCore.Qt.PenJoinStyle'), ('PySide2.QtGui.QColor',), ('PySide2.QtGui.QPen',)],
    "PySide2.QtGui.QPen.__copy__": (),
    "PySide2.QtGui.QPen.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPen.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPen.brush": (),
    "PySide2.QtGui.QPen.capStyle": (),
    "PySide2.QtGui.QPen.color": (),
    "PySide2.QtGui.QPen.dashOffset": (),
    "PySide2.QtGui.QPen.dashPattern": (),
    "PySide2.QtGui.QPen.isCosmetic": (),
    "PySide2.QtGui.QPen.isSolid": (),
    "PySide2.QtGui.QPen.joinStyle": (),
    "PySide2.QtGui.QPen.miterLimit": (),
    "PySide2.QtGui.QPen.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QPen.setCapStyle": ('PySide2.QtCore.Qt.PenCapStyle',),
    "PySide2.QtGui.QPen.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtGui.QPen.setCosmetic": ('bool',),
    "PySide2.QtGui.QPen.setDashOffset": ('float',),
    "PySide2.QtGui.QPen.setDashPattern": ('typing.List[float]',),
    "PySide2.QtGui.QPen.setJoinStyle": ('PySide2.QtCore.Qt.PenJoinStyle',),
    "PySide2.QtGui.QPen.setMiterLimit": ('float',),
    "PySide2.QtGui.QPen.setStyle": ('PySide2.QtCore.Qt.PenStyle',),
    "PySide2.QtGui.QPen.setWidth": ('int',),
    "PySide2.QtGui.QPen.setWidthF": ('float',),
    "PySide2.QtGui.QPen.style": (),
    "PySide2.QtGui.QPen.swap": ('PySide2.QtGui.QPen',),
    "PySide2.QtGui.QPen.width": (),
    "PySide2.QtGui.QPen.widthF": (),

# class PySide2.QtGui.QPicture:
    "PySide2.QtGui.QPicture.__init__": [('PySide2.QtGui.QPicture',), ('int',)],
    "PySide2.QtGui.QPicture.__copy__": (),
    "PySide2.QtGui.QPicture.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPicture.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPicture.boundingRect": (),
    "PySide2.QtGui.QPicture.data": (),
    "PySide2.QtGui.QPicture.devType": (),
    "PySide2.QtGui.QPicture.inputFormatList": (),
    "PySide2.QtGui.QPicture.inputFormats": (),
    "PySide2.QtGui.QPicture.isNull": (),
    "PySide2.QtGui.QPicture.load": [('PySide2.QtCore.QIODevice', 'str'), ('str', 'str')],
    "PySide2.QtGui.QPicture.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QPicture.outputFormatList": (),
    "PySide2.QtGui.QPicture.outputFormats": (),
    "PySide2.QtGui.QPicture.paintEngine": (),
    "PySide2.QtGui.QPicture.pictureFormat": ('str',),
    "PySide2.QtGui.QPicture.play": ('PySide2.QtGui.QPainter',),
    "PySide2.QtGui.QPicture.save": [('PySide2.QtCore.QIODevice', 'str'), ('str', 'str')],
    "PySide2.QtGui.QPicture.setBoundingRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtGui.QPicture.setData": ('str', 'int'),
    "PySide2.QtGui.QPicture.size": (),
    "PySide2.QtGui.QPicture.swap": ('PySide2.QtGui.QPicture',),

# class PySide2.QtGui.QPictureIO:
    "PySide2.QtGui.QPictureIO.__init__": [(), ('PySide2.QtCore.QIODevice', 'str'), ('str', 'str')],
    "PySide2.QtGui.QPictureIO.description": (),
    "PySide2.QtGui.QPictureIO.fileName": (),
    "PySide2.QtGui.QPictureIO.format": (),
    "PySide2.QtGui.QPictureIO.gamma": (),
    "PySide2.QtGui.QPictureIO.inputFormats": (),
    "PySide2.QtGui.QPictureIO.ioDevice": (),
    "PySide2.QtGui.QPictureIO.outputFormats": (),
    "PySide2.QtGui.QPictureIO.parameters": (),
    "PySide2.QtGui.QPictureIO.picture": (),
    "PySide2.QtGui.QPictureIO.pictureFormat": [('PySide2.QtCore.QIODevice',), ('str',)],
    "PySide2.QtGui.QPictureIO.quality": (),
    "PySide2.QtGui.QPictureIO.read": (),
    "PySide2.QtGui.QPictureIO.setDescription": ('str',),
    "PySide2.QtGui.QPictureIO.setFileName": ('str',),
    "PySide2.QtGui.QPictureIO.setFormat": ('str',),
    "PySide2.QtGui.QPictureIO.setGamma": ('float',),
    "PySide2.QtGui.QPictureIO.setIODevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtGui.QPictureIO.setParameters": ('str',),
    "PySide2.QtGui.QPictureIO.setPicture": ('PySide2.QtGui.QPicture',),
    "PySide2.QtGui.QPictureIO.setQuality": ('int',),
    "PySide2.QtGui.QPictureIO.setStatus": ('int',),
    "PySide2.QtGui.QPictureIO.status": (),
    "PySide2.QtGui.QPictureIO.write": (),

# class PySide2.QtGui.QPixelFormat:

# class PySide2.QtGui.QPixelFormat.AlphaPosition:

# class PySide2.QtGui.QPixelFormat.AlphaPremultiplied:

# class PySide2.QtGui.QPixelFormat.AlphaUsage:

# class PySide2.QtGui.QPixelFormat.ByteOrder:

# class PySide2.QtGui.QPixelFormat.ColorModel:

# class PySide2.QtGui.QPixelFormat.TypeInterpretation:

# class PySide2.QtGui.QPixelFormat.YUVLayout:
    "PySide2.QtGui.QPixelFormat.__init__": [(), ('PySide2.QtGui.QPixelFormat',), ('PySide2.QtGui.QPixelFormat.ColorModel', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char', 'PySide2.QtGui.QPixelFormat.AlphaUsage', 'PySide2.QtGui.QPixelFormat.AlphaPosition', 'PySide2.QtGui.QPixelFormat.AlphaPremultiplied', 'PySide2.QtGui.QPixelFormat.TypeInterpretation', 'PySide2.QtGui.QPixelFormat.ByteOrder', 'typing.Char')],
    "PySide2.QtGui.QPixelFormat.__copy__": (),
    "PySide2.QtGui.QPixelFormat.alphaPosition": (),
    "PySide2.QtGui.QPixelFormat.alphaSize": (),
    "PySide2.QtGui.QPixelFormat.alphaUsage": (),
    "PySide2.QtGui.QPixelFormat.bitsPerPixel": (),
    "PySide2.QtGui.QPixelFormat.blackSize": (),
    "PySide2.QtGui.QPixelFormat.blueSize": (),
    "PySide2.QtGui.QPixelFormat.brightnessSize": (),
    "PySide2.QtGui.QPixelFormat.byteOrder": (),
    "PySide2.QtGui.QPixelFormat.channelCount": (),
    "PySide2.QtGui.QPixelFormat.colorModel": (),
    "PySide2.QtGui.QPixelFormat.cyanSize": (),
    "PySide2.QtGui.QPixelFormat.greenSize": (),
    "PySide2.QtGui.QPixelFormat.hueSize": (),
    "PySide2.QtGui.QPixelFormat.lightnessSize": (),
    "PySide2.QtGui.QPixelFormat.magentaSize": (),
    "PySide2.QtGui.QPixelFormat.premultiplied": (),
    "PySide2.QtGui.QPixelFormat.redSize": (),
    "PySide2.QtGui.QPixelFormat.saturationSize": (),
    "PySide2.QtGui.QPixelFormat.subEnum": (),
    "PySide2.QtGui.QPixelFormat.typeInterpretation": (),
    "PySide2.QtGui.QPixelFormat.yellowSize": (),
    "PySide2.QtGui.QPixelFormat.yuvLayout": (),

# class PySide2.QtGui.QPixmap:
    "PySide2.QtGui.QPixmap.__init__": [(), ('PySide2.QtCore.QSize',), ('PySide2.QtGui.QImage',), ('PySide2.QtGui.QPixmap',), ('int', 'int'), ('str', 'str', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('typing.Sequence[str]',)],
    "PySide2.QtGui.QPixmap.__copy__": (),
    "PySide2.QtGui.QPixmap.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPixmap.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPixmap.cacheKey": (),
    "PySide2.QtGui.QPixmap.convertFromImage": ('PySide2.QtGui.QImage', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QPixmap.copy": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPixmap.createHeuristicMask": ('bool',),
    "PySide2.QtGui.QPixmap.createMaskFromColor": ('PySide2.QtGui.QColor', 'PySide2.QtCore.Qt.MaskMode'),
    "PySide2.QtGui.QPixmap.defaultDepth": (),
    "PySide2.QtGui.QPixmap.depth": (),
    "PySide2.QtGui.QPixmap.devType": (),
    "PySide2.QtGui.QPixmap.devicePixelRatio": (),
    "PySide2.QtGui.QPixmap.fill": [('PySide2.QtGui.QColor',), ('PySide2.QtGui.QPaintDevice', 'PySide2.QtCore.QPoint'), ('PySide2.QtGui.QPaintDevice', 'int', 'int')],
    "PySide2.QtGui.QPixmap.fromImage": ('PySide2.QtGui.QImage', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QPixmap.fromImageInPlace": ('PySide2.QtGui.QImage', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QPixmap.fromImageReader": ('PySide2.QtGui.QImageReader', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QPixmap.grabWidget": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QRect'), ('PySide2.QtCore.QObject', 'int', 'int', 'int', 'int')],
    "PySide2.QtGui.QPixmap.grabWindow": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QPixmap.hasAlpha": (),
    "PySide2.QtGui.QPixmap.hasAlphaChannel": (),
    "PySide2.QtGui.QPixmap.height": (),
    "PySide2.QtGui.QPixmap.isNull": (),
    "PySide2.QtGui.QPixmap.isQBitmap": (),
    "PySide2.QtGui.QPixmap.load": ('str', 'str', 'PySide2.QtCore.Qt.ImageConversionFlags'),
    "PySide2.QtGui.QPixmap.loadFromData": [('PySide2.QtCore.QByteArray', 'str', 'PySide2.QtCore.Qt.ImageConversionFlags'), ('str', 'int', 'str', 'PySide2.QtCore.Qt.ImageConversionFlags')],
    "PySide2.QtGui.QPixmap.mask": (),
    "PySide2.QtGui.QPixmap.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QPixmap.paintEngine": (),
    "PySide2.QtGui.QPixmap.rect": (),
    "PySide2.QtGui.QPixmap.save": [('PySide2.QtCore.QIODevice', 'str', 'int'), ('str', 'str', 'int')],
    "PySide2.QtGui.QPixmap.scaled": [('PySide2.QtCore.QSize', 'PySide2.QtCore.Qt.AspectRatioMode', 'PySide2.QtCore.Qt.TransformationMode'), ('int', 'int', 'PySide2.QtCore.Qt.AspectRatioMode', 'PySide2.QtCore.Qt.TransformationMode')],
    "PySide2.QtGui.QPixmap.scaledToHeight": ('int', 'PySide2.QtCore.Qt.TransformationMode'),
    "PySide2.QtGui.QPixmap.scaledToWidth": ('int', 'PySide2.QtCore.Qt.TransformationMode'),
    "PySide2.QtGui.QPixmap.scroll": [('int', 'int', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QRegion'), ('int', 'int', 'int', 'int', 'int', 'int', 'PySide2.QtGui.QRegion')],
    "PySide2.QtGui.QPixmap.setDevicePixelRatio": ('float',),
    "PySide2.QtGui.QPixmap.setMask": ('PySide2.QtGui.QBitmap',),
    "PySide2.QtGui.QPixmap.size": (),
    "PySide2.QtGui.QPixmap.swap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtGui.QPixmap.toImage": (),
    "PySide2.QtGui.QPixmap.transformed": [('PySide2.QtGui.QMatrix', 'PySide2.QtCore.Qt.TransformationMode'), ('PySide2.QtGui.QTransform', 'PySide2.QtCore.Qt.TransformationMode')],
    "PySide2.QtGui.QPixmap.trueMatrix": [('PySide2.QtGui.QMatrix', 'int', 'int'), ('PySide2.QtGui.QTransform', 'int', 'int')],
    "PySide2.QtGui.QPixmap.width": (),

# class PySide2.QtGui.QPixmapCache:

# class PySide2.QtGui.QPixmapCache.Key:
    "PySide2.QtGui.QPixmapCache.Key.__init__": [(), ('PySide2.QtGui.QPixmapCache.Key',)],
    "PySide2.QtGui.QPixmapCache.Key.__copy__": (),
    "PySide2.QtGui.QPixmapCache.Key.isValid": (),
    "PySide2.QtGui.QPixmapCache.Key.swap": ('PySide2.QtGui.QPixmapCache.Key',),

    "PySide2.QtGui.QPixmapCache.__init__": (),
    "PySide2.QtGui.QPixmapCache.cacheLimit": (),
    "PySide2.QtGui.QPixmapCache.clear": (),
    "PySide2.QtGui.QPixmapCache.find": [('PySide2.QtGui.QPixmapCache.Key',), ('PySide2.QtGui.QPixmapCache.Key', 'PySide2.QtGui.QPixmap'), ('str',), ('str', 'PySide2.QtGui.QPixmap')],
    "PySide2.QtGui.QPixmapCache.insert": [('PySide2.QtGui.QPixmap',), ('str', 'PySide2.QtGui.QPixmap')],
    "PySide2.QtGui.QPixmapCache.remove": [('PySide2.QtGui.QPixmapCache.Key',), ('str',)],
    "PySide2.QtGui.QPixmapCache.replace": ('PySide2.QtGui.QPixmapCache.Key', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtGui.QPixmapCache.setCacheLimit": ('int',),

# class PySide2.QtGui.QPointingDeviceUniqueId:
    "PySide2.QtGui.QPointingDeviceUniqueId.__init__": [(), ('PySide2.QtGui.QPointingDeviceUniqueId',)],
    "PySide2.QtGui.QPointingDeviceUniqueId.__copy__": (),
    "PySide2.QtGui.QPointingDeviceUniqueId.fromNumericId": ('int',),
    "PySide2.QtGui.QPointingDeviceUniqueId.isValid": (),
    "PySide2.QtGui.QPointingDeviceUniqueId.numericId": (),

# class PySide2.QtGui.QPolygon:
    "PySide2.QtGui.QPolygon.__init__": [(), ('PySide2.QtCore.QRect', 'bool'), ('PySide2.QtGui.QPolygon',), ('int',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPolygon.__add__": ('typing.List[PySide2.QtCore.QPoint]',),
    "PySide2.QtGui.QPolygon.__copy__": (),
    "PySide2.QtGui.QPolygon.__iadd__": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.__lshift__": [('PySide2.QtCore.QDataStream',), ('PySide2.QtCore.QPoint',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPolygon.__mul__": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QPolygon.__reduce__": (),
    "PySide2.QtGui.QPolygon.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPolygon.append": [('PySide2.QtCore.QPoint',), ('typing.List[PySide2.QtCore.QPoint]',)],
    "PySide2.QtGui.QPolygon.at": ('int',),
    "PySide2.QtGui.QPolygon.back": (),
    "PySide2.QtGui.QPolygon.boundingRect": (),
    "PySide2.QtGui.QPolygon.capacity": (),
    "PySide2.QtGui.QPolygon.clear": (),
    "PySide2.QtGui.QPolygon.constData": (),
    "PySide2.QtGui.QPolygon.constFirst": (),
    "PySide2.QtGui.QPolygon.constLast": (),
    "PySide2.QtGui.QPolygon.contains": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.containsPoint": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.Qt.FillRule'),
    "PySide2.QtGui.QPolygon.count": [(), ('PySide2.QtCore.QPoint',)],
    "PySide2.QtGui.QPolygon.data": (),
    "PySide2.QtGui.QPolygon.empty": (),
    "PySide2.QtGui.QPolygon.endsWith": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.fill": ('PySide2.QtCore.QPoint', 'int'),
    "PySide2.QtGui.QPolygon.first": (),
    "PySide2.QtGui.QPolygon.fromList": ('typing.Sequence[PySide2.QtCore.QPoint]',),
    "PySide2.QtGui.QPolygon.front": (),
    "PySide2.QtGui.QPolygon.indexOf": ('PySide2.QtCore.QPoint', 'int'),
    "PySide2.QtGui.QPolygon.insert": [('int', 'PySide2.QtCore.QPoint'), ('int', 'int', 'PySide2.QtCore.QPoint')],
    "PySide2.QtGui.QPolygon.intersected": ('PySide2.QtGui.QPolygon',),
    "PySide2.QtGui.QPolygon.intersects": ('PySide2.QtGui.QPolygon',),
    "PySide2.QtGui.QPolygon.isEmpty": (),
    "PySide2.QtGui.QPolygon.isSharedWith": ('typing.List[PySide2.QtCore.QPoint]',),
    "PySide2.QtGui.QPolygon.last": (),
    "PySide2.QtGui.QPolygon.lastIndexOf": ('PySide2.QtCore.QPoint', 'int'),
    "PySide2.QtGui.QPolygon.length": (),
    "PySide2.QtGui.QPolygon.mid": ('int', 'int'),
    "PySide2.QtGui.QPolygon.move": ('int', 'int'),
    "PySide2.QtGui.QPolygon.pop_back": (),
    "PySide2.QtGui.QPolygon.pop_front": (),
    "PySide2.QtGui.QPolygon.prepend": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.push_back": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.push_front": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.remove": [('int',), ('int', 'int')],
    "PySide2.QtGui.QPolygon.removeAll": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.removeAt": ('int',),
    "PySide2.QtGui.QPolygon.removeFirst": (),
    "PySide2.QtGui.QPolygon.removeLast": (),
    "PySide2.QtGui.QPolygon.removeOne": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.replace": ('int', 'PySide2.QtCore.QPoint'),
    "PySide2.QtGui.QPolygon.reserve": ('int',),
    "PySide2.QtGui.QPolygon.resize": ('int',),
    "PySide2.QtGui.QPolygon.setSharable": ('bool',),
    "PySide2.QtGui.QPolygon.shrink_to_fit": (),
    "PySide2.QtGui.QPolygon.size": (),
    "PySide2.QtGui.QPolygon.squeeze": (),
    "PySide2.QtGui.QPolygon.startsWith": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QPolygon.subtracted": ('PySide2.QtGui.QPolygon',),
    "PySide2.QtGui.QPolygon.swap": ('PySide2.QtGui.QPolygon',),
    "PySide2.QtGui.QPolygon.swapItemsAt": ('int', 'int'),
    "PySide2.QtGui.QPolygon.takeAt": ('int',),
    "PySide2.QtGui.QPolygon.takeFirst": (),
    "PySide2.QtGui.QPolygon.takeLast": (),
    "PySide2.QtGui.QPolygon.toList": (),
    "PySide2.QtGui.QPolygon.translate": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QPolygon.translated": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QPolygon.united": ('PySide2.QtGui.QPolygon',),
    "PySide2.QtGui.QPolygon.value": [('int',), ('int', 'PySide2.QtCore.QPoint')],

# class PySide2.QtGui.QPolygonF:
    "PySide2.QtGui.QPolygonF.__init__": [(), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPolygon',), ('PySide2.QtGui.QPolygonF',), ('int',), ('typing.List[PySide2.QtCore.QPointF]',)],
    "PySide2.QtGui.QPolygonF.__add__": ('typing.List[PySide2.QtCore.QPointF]',),
    "PySide2.QtGui.QPolygonF.__copy__": (),
    "PySide2.QtGui.QPolygonF.__iadd__": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPolygonF.__mul__": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QPolygonF.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QPolygonF.append": [('PySide2.QtCore.QPointF',), ('typing.List[PySide2.QtCore.QPointF]',)],
    "PySide2.QtGui.QPolygonF.at": ('int',),
    "PySide2.QtGui.QPolygonF.back": (),
    "PySide2.QtGui.QPolygonF.boundingRect": (),
    "PySide2.QtGui.QPolygonF.capacity": (),
    "PySide2.QtGui.QPolygonF.clear": (),
    "PySide2.QtGui.QPolygonF.constData": (),
    "PySide2.QtGui.QPolygonF.constFirst": (),
    "PySide2.QtGui.QPolygonF.constLast": (),
    "PySide2.QtGui.QPolygonF.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.containsPoint": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.FillRule'),
    "PySide2.QtGui.QPolygonF.count": [(), ('PySide2.QtCore.QPointF',)],
    "PySide2.QtGui.QPolygonF.data": (),
    "PySide2.QtGui.QPolygonF.empty": (),
    "PySide2.QtGui.QPolygonF.endsWith": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.fill": ('PySide2.QtCore.QPointF', 'int'),
    "PySide2.QtGui.QPolygonF.first": (),
    "PySide2.QtGui.QPolygonF.fromList": ('typing.Sequence[PySide2.QtCore.QPointF]',),
    "PySide2.QtGui.QPolygonF.front": (),
    "PySide2.QtGui.QPolygonF.indexOf": ('PySide2.QtCore.QPointF', 'int'),
    "PySide2.QtGui.QPolygonF.insert": [('int', 'PySide2.QtCore.QPointF'), ('int', 'int', 'PySide2.QtCore.QPointF')],
    "PySide2.QtGui.QPolygonF.intersected": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtGui.QPolygonF.intersects": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtGui.QPolygonF.isClosed": (),
    "PySide2.QtGui.QPolygonF.isEmpty": (),
    "PySide2.QtGui.QPolygonF.isSharedWith": ('typing.List[PySide2.QtCore.QPointF]',),
    "PySide2.QtGui.QPolygonF.last": (),
    "PySide2.QtGui.QPolygonF.lastIndexOf": ('PySide2.QtCore.QPointF', 'int'),
    "PySide2.QtGui.QPolygonF.length": (),
    "PySide2.QtGui.QPolygonF.mid": ('int', 'int'),
    "PySide2.QtGui.QPolygonF.move": ('int', 'int'),
    "PySide2.QtGui.QPolygonF.pop_back": (),
    "PySide2.QtGui.QPolygonF.pop_front": (),
    "PySide2.QtGui.QPolygonF.prepend": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.push_back": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.push_front": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.remove": [('int',), ('int', 'int')],
    "PySide2.QtGui.QPolygonF.removeAll": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.removeAt": ('int',),
    "PySide2.QtGui.QPolygonF.removeFirst": (),
    "PySide2.QtGui.QPolygonF.removeLast": (),
    "PySide2.QtGui.QPolygonF.removeOne": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.replace": ('int', 'PySide2.QtCore.QPointF'),
    "PySide2.QtGui.QPolygonF.reserve": ('int',),
    "PySide2.QtGui.QPolygonF.resize": ('int',),
    "PySide2.QtGui.QPolygonF.setSharable": ('bool',),
    "PySide2.QtGui.QPolygonF.shrink_to_fit": (),
    "PySide2.QtGui.QPolygonF.size": (),
    "PySide2.QtGui.QPolygonF.squeeze": (),
    "PySide2.QtGui.QPolygonF.startsWith": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QPolygonF.subtracted": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtGui.QPolygonF.swap": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtGui.QPolygonF.swapItemsAt": ('int', 'int'),
    "PySide2.QtGui.QPolygonF.takeAt": ('int',),
    "PySide2.QtGui.QPolygonF.takeFirst": (),
    "PySide2.QtGui.QPolygonF.takeLast": (),
    "PySide2.QtGui.QPolygonF.toList": (),
    "PySide2.QtGui.QPolygonF.toPolygon": (),
    "PySide2.QtGui.QPolygonF.translate": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPolygonF.translated": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QPolygonF.united": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtGui.QPolygonF.value": [('int',), ('int', 'PySide2.QtCore.QPointF')],

# class PySide2.QtGui.QPyTextObject:
    "PySide2.QtGui.QPyTextObject.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QPyTextObject.drawObject": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF', 'PySide2.QtGui.QTextDocument', 'int', 'PySide2.QtGui.QTextFormat'),
    "PySide2.QtGui.QPyTextObject.intrinsicSize": ('PySide2.QtGui.QTextDocument', 'int', 'PySide2.QtGui.QTextFormat'),

# class PySide2.QtGui.QQuaternion:
    "PySide2.QtGui.QQuaternion.__init__": [(), ('PySide2.QtGui.QVector4D',), ('float', 'PySide2.QtGui.QVector3D'), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QQuaternion.__add__": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtGui.QQuaternion.__copy__": (),
    "PySide2.QtGui.QQuaternion.__iadd__": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtGui.QQuaternion.__imul__": [('PySide2.QtGui.QQuaternion',), ('float',)],
    "PySide2.QtGui.QQuaternion.__isub__": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtGui.QQuaternion.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QQuaternion.__mul__": [('PySide2.QtGui.QQuaternion',), ('float',)],
    "PySide2.QtGui.QQuaternion.__neg__": (),
    "PySide2.QtGui.QQuaternion.__reduce__": (),
    "PySide2.QtGui.QQuaternion.__repr__": (),
    "PySide2.QtGui.QQuaternion.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QQuaternion.__sub__": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtGui.QQuaternion.conjugate": (),
    "PySide2.QtGui.QQuaternion.conjugated": (),
    "PySide2.QtGui.QQuaternion.dotProduct": ('PySide2.QtGui.QQuaternion', 'PySide2.QtGui.QQuaternion'),
    "PySide2.QtGui.QQuaternion.fromAxes": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QQuaternion.fromAxisAndAngle": [('PySide2.QtGui.QVector3D', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QQuaternion.fromDirection": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QQuaternion.fromEulerAngles": [('PySide2.QtGui.QVector3D',), ('float', 'float', 'float')],
    "PySide2.QtGui.QQuaternion.fromRotationMatrix": ('PySide2.QtGui.QMatrix3x3',),
    "PySide2.QtGui.QQuaternion.getAxes": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QQuaternion.inverted": (),
    "PySide2.QtGui.QQuaternion.isIdentity": (),
    "PySide2.QtGui.QQuaternion.isNull": (),
    "PySide2.QtGui.QQuaternion.length": (),
    "PySide2.QtGui.QQuaternion.lengthSquared": (),
    "PySide2.QtGui.QQuaternion.nlerp": ('PySide2.QtGui.QQuaternion', 'PySide2.QtGui.QQuaternion', 'float'),
    "PySide2.QtGui.QQuaternion.normalize": (),
    "PySide2.QtGui.QQuaternion.normalized": (),
    "PySide2.QtGui.QQuaternion.rotatedVector": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QQuaternion.rotationTo": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QQuaternion.scalar": (),
    "PySide2.QtGui.QQuaternion.setScalar": ('float',),
    "PySide2.QtGui.QQuaternion.setVector": [('PySide2.QtGui.QVector3D',), ('float', 'float', 'float')],
    "PySide2.QtGui.QQuaternion.setX": ('float',),
    "PySide2.QtGui.QQuaternion.setY": ('float',),
    "PySide2.QtGui.QQuaternion.setZ": ('float',),
    "PySide2.QtGui.QQuaternion.slerp": ('PySide2.QtGui.QQuaternion', 'PySide2.QtGui.QQuaternion', 'float'),
    "PySide2.QtGui.QQuaternion.toEulerAngles": (),
    "PySide2.QtGui.QQuaternion.toRotationMatrix": (),
    "PySide2.QtGui.QQuaternion.toVector4D": (),
    "PySide2.QtGui.QQuaternion.vector": (),
    "PySide2.QtGui.QQuaternion.x": (),
    "PySide2.QtGui.QQuaternion.y": (),
    "PySide2.QtGui.QQuaternion.z": (),

# class PySide2.QtGui.QRadialGradient:
    "PySide2.QtGui.QRadialGradient.__init__": [(), ('PySide2.QtCore.QPointF', 'float'), ('PySide2.QtCore.QPointF', 'float', 'PySide2.QtCore.QPointF'), ('PySide2.QtCore.QPointF', 'float', 'PySide2.QtCore.QPointF', 'float'), ('PySide2.QtGui.QRadialGradient',), ('float', 'float', 'float'), ('float', 'float', 'float', 'float', 'float'), ('float', 'float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QRadialGradient.__copy__": (),
    "PySide2.QtGui.QRadialGradient.center": (),
    "PySide2.QtGui.QRadialGradient.centerRadius": (),
    "PySide2.QtGui.QRadialGradient.focalPoint": (),
    "PySide2.QtGui.QRadialGradient.focalRadius": (),
    "PySide2.QtGui.QRadialGradient.radius": (),
    "PySide2.QtGui.QRadialGradient.setCenter": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QRadialGradient.setCenterRadius": ('float',),
    "PySide2.QtGui.QRadialGradient.setFocalPoint": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtGui.QRadialGradient.setFocalRadius": ('float',),
    "PySide2.QtGui.QRadialGradient.setRadius": ('float',),

# class PySide2.QtGui.QRasterWindow:
    "PySide2.QtGui.QRasterWindow.__init__": ('PySide2.QtGui.QWindow',),
    "PySide2.QtGui.QRasterWindow.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtGui.QRasterWindow.redirected": ('PySide2.QtCore.QPoint',),

# class PySide2.QtGui.QRawFont:

# class PySide2.QtGui.QRawFont.AntialiasingType:

# class PySide2.QtGui.QRawFont.LayoutFlag:

# class PySide2.QtGui.QRawFont.LayoutFlags:
    "PySide2.QtGui.QRawFont.__init__": [(), ('PySide2.QtCore.QByteArray', 'float', 'PySide2.QtGui.QFont.HintingPreference'), ('PySide2.QtGui.QRawFont',), ('str', 'float', 'PySide2.QtGui.QFont.HintingPreference')],
    "PySide2.QtGui.QRawFont.__copy__": (),
    "PySide2.QtGui.QRawFont.advancesForGlyphIndexes": [('typing.List[int]',), ('typing.List[int]', 'PySide2.QtGui.QRawFont.LayoutFlags')],
    "PySide2.QtGui.QRawFont.alphaMapForGlyph": ('int', 'PySide2.QtGui.QRawFont.AntialiasingType', 'PySide2.QtGui.QTransform'),
    "PySide2.QtGui.QRawFont.ascent": (),
    "PySide2.QtGui.QRawFont.averageCharWidth": (),
    "PySide2.QtGui.QRawFont.boundingRect": ('int',),
    "PySide2.QtGui.QRawFont.capHeight": (),
    "PySide2.QtGui.QRawFont.descent": (),
    "PySide2.QtGui.QRawFont.familyName": (),
    "PySide2.QtGui.QRawFont.fontTable": ('str',),
    "PySide2.QtGui.QRawFont.fromFont": ('PySide2.QtGui.QFont', 'PySide2.QtGui.QFontDatabase.WritingSystem'),
    "PySide2.QtGui.QRawFont.glyphIndexesForString": ('str',),
    "PySide2.QtGui.QRawFont.hintingPreference": (),
    "PySide2.QtGui.QRawFont.isValid": (),
    "PySide2.QtGui.QRawFont.leading": (),
    "PySide2.QtGui.QRawFont.lineThickness": (),
    "PySide2.QtGui.QRawFont.loadFromData": ('PySide2.QtCore.QByteArray', 'float', 'PySide2.QtGui.QFont.HintingPreference'),
    "PySide2.QtGui.QRawFont.loadFromFile": ('str', 'float', 'PySide2.QtGui.QFont.HintingPreference'),
    "PySide2.QtGui.QRawFont.maxCharWidth": (),
    "PySide2.QtGui.QRawFont.pathForGlyph": ('int',),
    "PySide2.QtGui.QRawFont.pixelSize": (),
    "PySide2.QtGui.QRawFont.setPixelSize": ('float',),
    "PySide2.QtGui.QRawFont.style": (),
    "PySide2.QtGui.QRawFont.styleName": (),
    "PySide2.QtGui.QRawFont.supportedWritingSystems": (),
    "PySide2.QtGui.QRawFont.supportsCharacter": [('int',), ('typing.Char',)],
    "PySide2.QtGui.QRawFont.swap": ('PySide2.QtGui.QRawFont',),
    "PySide2.QtGui.QRawFont.underlinePosition": (),
    "PySide2.QtGui.QRawFont.unitsPerEm": (),
    "PySide2.QtGui.QRawFont.weight": (),
    "PySide2.QtGui.QRawFont.xHeight": (),

# class PySide2.QtGui.QRegExpValidator:
    "PySide2.QtGui.QRegExpValidator.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QRegExp', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QRegExpValidator.regExp": (),
    "PySide2.QtGui.QRegExpValidator.setRegExp": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtGui.QRegExpValidator.validate": ('str', 'int'),

# class PySide2.QtGui.QRegion:

# class PySide2.QtGui.QRegion.RegionType:
    "PySide2.QtGui.QRegion.__init__": [(), ('PySide2.QtCore.QRect', 'PySide2.QtGui.QRegion.RegionType'), ('PySide2.QtGui.QBitmap',), ('PySide2.QtGui.QPolygon', 'PySide2.QtCore.Qt.FillRule'), ('PySide2.QtGui.QRegion',), ('int', 'int', 'int', 'int', 'PySide2.QtGui.QRegion.RegionType')],
    "PySide2.QtGui.QRegion.__add__": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QRegion.__and__": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QRegion.__copy__": (),
    "PySide2.QtGui.QRegion.__iadd__": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QRegion.__ior__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.__isub__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.__ixor__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QRegion.__mul__": [('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',)],
    "PySide2.QtGui.QRegion.__or__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QRegion.__sub__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.__xor__": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.begin": (),
    "PySide2.QtGui.QRegion.boundingRect": (),
    "PySide2.QtGui.QRegion.cbegin": (),
    "PySide2.QtGui.QRegion.cend": (),
    "PySide2.QtGui.QRegion.contains": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QRect',)],
    "PySide2.QtGui.QRegion.end": (),
    "PySide2.QtGui.QRegion.intersected": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QRegion.intersects": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QRegion.isEmpty": (),
    "PySide2.QtGui.QRegion.isNull": (),
    "PySide2.QtGui.QRegion.rectCount": (),
    "PySide2.QtGui.QRegion.rects": (),
    "PySide2.QtGui.QRegion.setRects": ('PySide2.QtCore.QRect', 'int'),
    "PySide2.QtGui.QRegion.subtracted": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.swap": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QRegion.translate": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QRegion.translated": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QRegion.united": [('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtGui.QRegion.xored": ('PySide2.QtGui.QRegion',),

# class PySide2.QtGui.QResizeEvent:
    "PySide2.QtGui.QResizeEvent.__init__": ('PySide2.QtCore.QSize', 'PySide2.QtCore.QSize'),
    "PySide2.QtGui.QResizeEvent.oldSize": (),
    "PySide2.QtGui.QResizeEvent.size": (),

# class PySide2.QtGui.QScreen:
    "PySide2.QtGui.QScreen.angleBetween": ('PySide2.QtCore.Qt.ScreenOrientation', 'PySide2.QtCore.Qt.ScreenOrientation'),
    "PySide2.QtGui.QScreen.availableGeometry": (),
    "PySide2.QtGui.QScreen.availableSize": (),
    "PySide2.QtGui.QScreen.availableVirtualGeometry": (),
    "PySide2.QtGui.QScreen.availableVirtualSize": (),
    "PySide2.QtGui.QScreen.depth": (),
    "PySide2.QtGui.QScreen.devicePixelRatio": (),
    "PySide2.QtGui.QScreen.geometry": (),
    "PySide2.QtGui.QScreen.grabWindow": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtGui.QScreen.isLandscape": ('PySide2.QtCore.Qt.ScreenOrientation',),
    "PySide2.QtGui.QScreen.isPortrait": ('PySide2.QtCore.Qt.ScreenOrientation',),
    "PySide2.QtGui.QScreen.logicalDotsPerInch": (),
    "PySide2.QtGui.QScreen.logicalDotsPerInchX": (),
    "PySide2.QtGui.QScreen.logicalDotsPerInchY": (),
    "PySide2.QtGui.QScreen.manufacturer": (),
    "PySide2.QtGui.QScreen.mapBetween": ('PySide2.QtCore.Qt.ScreenOrientation', 'PySide2.QtCore.Qt.ScreenOrientation', 'PySide2.QtCore.QRect'),
    "PySide2.QtGui.QScreen.model": (),
    "PySide2.QtGui.QScreen.name": (),
    "PySide2.QtGui.QScreen.nativeOrientation": (),
    "PySide2.QtGui.QScreen.orientation": (),
    "PySide2.QtGui.QScreen.orientationUpdateMask": (),
    "PySide2.QtGui.QScreen.physicalDotsPerInch": (),
    "PySide2.QtGui.QScreen.physicalDotsPerInchX": (),
    "PySide2.QtGui.QScreen.physicalDotsPerInchY": (),
    "PySide2.QtGui.QScreen.physicalSize": (),
    "PySide2.QtGui.QScreen.primaryOrientation": (),
    "PySide2.QtGui.QScreen.refreshRate": (),
    "PySide2.QtGui.QScreen.serialNumber": (),
    "PySide2.QtGui.QScreen.setOrientationUpdateMask": ('PySide2.QtCore.Qt.ScreenOrientations',),
    "PySide2.QtGui.QScreen.size": (),
    "PySide2.QtGui.QScreen.transformBetween": ('PySide2.QtCore.Qt.ScreenOrientation', 'PySide2.QtCore.Qt.ScreenOrientation', 'PySide2.QtCore.QRect'),
    "PySide2.QtGui.QScreen.virtualGeometry": (),
    "PySide2.QtGui.QScreen.virtualSiblings": (),
    "PySide2.QtGui.QScreen.virtualSize": (),

# class PySide2.QtGui.QScrollEvent:

# class PySide2.QtGui.QScrollEvent.ScrollState:
    "PySide2.QtGui.QScrollEvent.__init__": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtGui.QScrollEvent.ScrollState'),
    "PySide2.QtGui.QScrollEvent.contentPos": (),
    "PySide2.QtGui.QScrollEvent.overshootDistance": (),
    "PySide2.QtGui.QScrollEvent.scrollState": (),

# class PySide2.QtGui.QScrollPrepareEvent:
    "PySide2.QtGui.QScrollPrepareEvent.__init__": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QScrollPrepareEvent.contentPos": (),
    "PySide2.QtGui.QScrollPrepareEvent.contentPosRange": (),
    "PySide2.QtGui.QScrollPrepareEvent.setContentPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QScrollPrepareEvent.setContentPosRange": ('PySide2.QtCore.QRectF',),
    "PySide2.QtGui.QScrollPrepareEvent.setViewportSize": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtGui.QScrollPrepareEvent.startPos": (),
    "PySide2.QtGui.QScrollPrepareEvent.viewportSize": (),

# class PySide2.QtGui.QSessionManager:

# class PySide2.QtGui.QSessionManager.RestartHint:
    "PySide2.QtGui.QSessionManager.allowsErrorInteraction": (),
    "PySide2.QtGui.QSessionManager.allowsInteraction": (),
    "PySide2.QtGui.QSessionManager.cancel": (),
    "PySide2.QtGui.QSessionManager.discardCommand": (),
    "PySide2.QtGui.QSessionManager.isPhase2": (),
    "PySide2.QtGui.QSessionManager.release": (),
    "PySide2.QtGui.QSessionManager.requestPhase2": (),
    "PySide2.QtGui.QSessionManager.restartCommand": (),
    "PySide2.QtGui.QSessionManager.restartHint": (),
    "PySide2.QtGui.QSessionManager.sessionId": (),
    "PySide2.QtGui.QSessionManager.sessionKey": (),
    "PySide2.QtGui.QSessionManager.setDiscardCommand": ('typing.Sequence[str]',),
    "PySide2.QtGui.QSessionManager.setManagerProperty": [('str', 'str'), ('str', 'typing.Sequence[str]')],
    "PySide2.QtGui.QSessionManager.setRestartCommand": ('typing.Sequence[str]',),
    "PySide2.QtGui.QSessionManager.setRestartHint": ('PySide2.QtGui.QSessionManager.RestartHint',),

# class PySide2.QtGui.QShortcutEvent:
    "PySide2.QtGui.QShortcutEvent.__init__": ('PySide2.QtGui.QKeySequence', 'int', 'bool'),
    "PySide2.QtGui.QShortcutEvent.isAmbiguous": (),
    "PySide2.QtGui.QShortcutEvent.key": (),
    "PySide2.QtGui.QShortcutEvent.shortcutId": (),

# class PySide2.QtGui.QShowEvent:
    "PySide2.QtGui.QShowEvent.__init__": (),

# class PySide2.QtGui.QStandardItem:

# class PySide2.QtGui.QStandardItem.ItemType:
    "PySide2.QtGui.QStandardItem.__init__": [(), ('PySide2.QtGui.QIcon', 'str'), ('PySide2.QtGui.QStandardItem',), ('int', 'int'), ('str',)],
    "PySide2.QtGui.QStandardItem.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QStandardItem.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QStandardItem.accessibleDescription": (),
    "PySide2.QtGui.QStandardItem.accessibleText": (),
    "PySide2.QtGui.QStandardItem.appendColumn": ('typing.Sequence[PySide2.QtGui.QStandardItem]',),
    "PySide2.QtGui.QStandardItem.appendRow": [('PySide2.QtGui.QStandardItem',), ('typing.Sequence[PySide2.QtGui.QStandardItem]',)],
    "PySide2.QtGui.QStandardItem.appendRows": ('typing.Sequence[PySide2.QtGui.QStandardItem]',),
    "PySide2.QtGui.QStandardItem.background": (),
    "PySide2.QtGui.QStandardItem.checkState": (),
    "PySide2.QtGui.QStandardItem.child": ('int', 'int'),
    "PySide2.QtGui.QStandardItem.clearData": (),
    "PySide2.QtGui.QStandardItem.clone": (),
    "PySide2.QtGui.QStandardItem.column": (),
    "PySide2.QtGui.QStandardItem.columnCount": (),
    "PySide2.QtGui.QStandardItem.data": ('int',),
    "PySide2.QtGui.QStandardItem.emitDataChanged": (),
    "PySide2.QtGui.QStandardItem.flags": (),
    "PySide2.QtGui.QStandardItem.font": (),
    "PySide2.QtGui.QStandardItem.foreground": (),
    "PySide2.QtGui.QStandardItem.hasChildren": (),
    "PySide2.QtGui.QStandardItem.icon": (),
    "PySide2.QtGui.QStandardItem.index": (),
    "PySide2.QtGui.QStandardItem.insertColumn": ('int', 'typing.Sequence[PySide2.QtGui.QStandardItem]'),
    "PySide2.QtGui.QStandardItem.insertColumns": ('int', 'int'),
    "PySide2.QtGui.QStandardItem.insertRow": [('int', 'PySide2.QtGui.QStandardItem'), ('int', 'typing.Sequence[PySide2.QtGui.QStandardItem]')],
    "PySide2.QtGui.QStandardItem.insertRows": [('int', 'int'), ('int', 'typing.Sequence[PySide2.QtGui.QStandardItem]')],
    "PySide2.QtGui.QStandardItem.isAutoTristate": (),
    "PySide2.QtGui.QStandardItem.isCheckable": (),
    "PySide2.QtGui.QStandardItem.isDragEnabled": (),
    "PySide2.QtGui.QStandardItem.isDropEnabled": (),
    "PySide2.QtGui.QStandardItem.isEditable": (),
    "PySide2.QtGui.QStandardItem.isEnabled": (),
    "PySide2.QtGui.QStandardItem.isSelectable": (),
    "PySide2.QtGui.QStandardItem.isTristate": (),
    "PySide2.QtGui.QStandardItem.isUserTristate": (),
    "PySide2.QtGui.QStandardItem.model": (),
    "PySide2.QtGui.QStandardItem.parent": (),
    "PySide2.QtGui.QStandardItem.read": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QStandardItem.removeColumn": ('int',),
    "PySide2.QtGui.QStandardItem.removeColumns": ('int', 'int'),
    "PySide2.QtGui.QStandardItem.removeRow": ('int',),
    "PySide2.QtGui.QStandardItem.removeRows": ('int', 'int'),
    "PySide2.QtGui.QStandardItem.row": (),
    "PySide2.QtGui.QStandardItem.rowCount": (),
    "PySide2.QtGui.QStandardItem.setAccessibleDescription": ('str',),
    "PySide2.QtGui.QStandardItem.setAccessibleText": ('str',),
    "PySide2.QtGui.QStandardItem.setAutoTristate": ('bool',),
    "PySide2.QtGui.QStandardItem.setBackground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QStandardItem.setCheckState": ('PySide2.QtCore.Qt.CheckState',),
    "PySide2.QtGui.QStandardItem.setCheckable": ('bool',),
    "PySide2.QtGui.QStandardItem.setChild": [('int', 'PySide2.QtGui.QStandardItem'), ('int', 'int', 'PySide2.QtGui.QStandardItem')],
    "PySide2.QtGui.QStandardItem.setColumnCount": ('int',),
    "PySide2.QtGui.QStandardItem.setData": ('typing.Any', 'int'),
    "PySide2.QtGui.QStandardItem.setDragEnabled": ('bool',),
    "PySide2.QtGui.QStandardItem.setDropEnabled": ('bool',),
    "PySide2.QtGui.QStandardItem.setEditable": ('bool',),
    "PySide2.QtGui.QStandardItem.setEnabled": ('bool',),
    "PySide2.QtGui.QStandardItem.setFlags": ('PySide2.QtCore.Qt.ItemFlags',),
    "PySide2.QtGui.QStandardItem.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QStandardItem.setForeground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QStandardItem.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtGui.QStandardItem.setRowCount": ('int',),
    "PySide2.QtGui.QStandardItem.setSelectable": ('bool',),
    "PySide2.QtGui.QStandardItem.setSizeHint": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QStandardItem.setStatusTip": ('str',),
    "PySide2.QtGui.QStandardItem.setText": ('str',),
    "PySide2.QtGui.QStandardItem.setTextAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtGui.QStandardItem.setToolTip": ('str',),
    "PySide2.QtGui.QStandardItem.setTristate": ('bool',),
    "PySide2.QtGui.QStandardItem.setUserTristate": ('bool',),
    "PySide2.QtGui.QStandardItem.setWhatsThis": ('str',),
    "PySide2.QtGui.QStandardItem.sizeHint": (),
    "PySide2.QtGui.QStandardItem.sortChildren": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtGui.QStandardItem.statusTip": (),
    "PySide2.QtGui.QStandardItem.takeChild": ('int', 'int'),
    "PySide2.QtGui.QStandardItem.takeColumn": ('int',),
    "PySide2.QtGui.QStandardItem.takeRow": ('int',),
    "PySide2.QtGui.QStandardItem.text": (),
    "PySide2.QtGui.QStandardItem.textAlignment": (),
    "PySide2.QtGui.QStandardItem.toolTip": (),
    "PySide2.QtGui.QStandardItem.type": (),
    "PySide2.QtGui.QStandardItem.whatsThis": (),
    "PySide2.QtGui.QStandardItem.write": ('PySide2.QtCore.QDataStream',),

# class PySide2.QtGui.QStandardItemModel:
    "PySide2.QtGui.QStandardItemModel.__init__": [('PySide2.QtCore.QObject',), ('int', 'int', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QStandardItemModel.appendColumn": ('typing.Sequence[PySide2.QtGui.QStandardItem]',),
    "PySide2.QtGui.QStandardItemModel.appendRow": [('PySide2.QtGui.QStandardItem',), ('typing.Sequence[PySide2.QtGui.QStandardItem]',)],
    "PySide2.QtGui.QStandardItemModel.clear": (),
    "PySide2.QtGui.QStandardItemModel.clearItemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtGui.QStandardItemModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.findItems": ('str', 'PySide2.QtCore.Qt.MatchFlags', 'int'),
    "PySide2.QtGui.QStandardItemModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtGui.QStandardItemModel.horizontalHeaderItem": ('int',),
    "PySide2.QtGui.QStandardItemModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.indexFromItem": ('PySide2.QtGui.QStandardItem',),
    "PySide2.QtGui.QStandardItemModel.insertColumn": [('int', 'PySide2.QtCore.QModelIndex'), ('int', 'typing.Sequence[PySide2.QtGui.QStandardItem]')],
    "PySide2.QtGui.QStandardItemModel.insertColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.insertRow": [('int', 'PySide2.QtCore.QModelIndex'), ('int', 'PySide2.QtGui.QStandardItem'), ('int', 'typing.Sequence[PySide2.QtGui.QStandardItem]')],
    "PySide2.QtGui.QStandardItemModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.invisibleRootItem": (),
    "PySide2.QtGui.QStandardItemModel.item": ('int', 'int'),
    "PySide2.QtGui.QStandardItemModel.itemData": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.itemFromIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.itemPrototype": (),
    "PySide2.QtGui.QStandardItemModel.mimeData": ('typing.List[int]',),
    "PySide2.QtGui.QStandardItemModel.mimeTypes": (),
    "PySide2.QtGui.QStandardItemModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtGui.QStandardItemModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtGui.QStandardItemModel.setColumnCount": ('int',),
    "PySide2.QtGui.QStandardItemModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtGui.QStandardItemModel.setHeaderData": ('int', 'PySide2.QtCore.Qt.Orientation', 'typing.Any', 'int'),
    "PySide2.QtGui.QStandardItemModel.setHorizontalHeaderItem": ('int', 'PySide2.QtGui.QStandardItem'),
    "PySide2.QtGui.QStandardItemModel.setHorizontalHeaderLabels": ('typing.Sequence[str]',),
    "PySide2.QtGui.QStandardItemModel.setItem": [('int', 'PySide2.QtGui.QStandardItem'), ('int', 'int', 'PySide2.QtGui.QStandardItem')],
    "PySide2.QtGui.QStandardItemModel.setItemData": ('PySide2.QtCore.QModelIndex', 'typing.Dict[int, typing.Any]'),
    "PySide2.QtGui.QStandardItemModel.setItemPrototype": ('PySide2.QtGui.QStandardItem',),
    "PySide2.QtGui.QStandardItemModel.setItemRoleNames": ('typing.Dict[int, PySide2.QtCore.QByteArray]',),
    "PySide2.QtGui.QStandardItemModel.setRowCount": ('int',),
    "PySide2.QtGui.QStandardItemModel.setSortRole": ('int',),
    "PySide2.QtGui.QStandardItemModel.setVerticalHeaderItem": ('int', 'PySide2.QtGui.QStandardItem'),
    "PySide2.QtGui.QStandardItemModel.setVerticalHeaderLabels": ('typing.Sequence[str]',),
    "PySide2.QtGui.QStandardItemModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtGui.QStandardItemModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtGui.QStandardItemModel.sortRole": (),
    "PySide2.QtGui.QStandardItemModel.supportedDropActions": (),
    "PySide2.QtGui.QStandardItemModel.takeColumn": ('int',),
    "PySide2.QtGui.QStandardItemModel.takeHorizontalHeaderItem": ('int',),
    "PySide2.QtGui.QStandardItemModel.takeItem": ('int', 'int'),
    "PySide2.QtGui.QStandardItemModel.takeRow": ('int',),
    "PySide2.QtGui.QStandardItemModel.takeVerticalHeaderItem": ('int',),
    "PySide2.QtGui.QStandardItemModel.verticalHeaderItem": ('int',),

# class PySide2.QtGui.QStaticText:

# class PySide2.QtGui.QStaticText.PerformanceHint:
    "PySide2.QtGui.QStaticText.__init__": [(), ('PySide2.QtGui.QStaticText',), ('str',)],
    "PySide2.QtGui.QStaticText.__copy__": (),
    "PySide2.QtGui.QStaticText.performanceHint": (),
    "PySide2.QtGui.QStaticText.prepare": ('PySide2.QtGui.QTransform', 'PySide2.QtGui.QFont'),
    "PySide2.QtGui.QStaticText.setPerformanceHint": ('PySide2.QtGui.QStaticText.PerformanceHint',),
    "PySide2.QtGui.QStaticText.setText": ('str',),
    "PySide2.QtGui.QStaticText.setTextFormat": ('PySide2.QtCore.Qt.TextFormat',),
    "PySide2.QtGui.QStaticText.setTextOption": ('PySide2.QtGui.QTextOption',),
    "PySide2.QtGui.QStaticText.setTextWidth": ('float',),
    "PySide2.QtGui.QStaticText.size": (),
    "PySide2.QtGui.QStaticText.swap": ('PySide2.QtGui.QStaticText',),
    "PySide2.QtGui.QStaticText.text": (),
    "PySide2.QtGui.QStaticText.textFormat": (),
    "PySide2.QtGui.QStaticText.textOption": (),
    "PySide2.QtGui.QStaticText.textWidth": (),

# class PySide2.QtGui.QStatusTipEvent:
    "PySide2.QtGui.QStatusTipEvent.__init__": ('str',),
    "PySide2.QtGui.QStatusTipEvent.tip": (),

# class PySide2.QtGui.QStyleHints:
    "PySide2.QtGui.QStyleHints.cursorFlashTime": (),
    "PySide2.QtGui.QStyleHints.fontSmoothingGamma": (),
    "PySide2.QtGui.QStyleHints.keyboardAutoRepeatRate": (),
    "PySide2.QtGui.QStyleHints.keyboardInputInterval": (),
    "PySide2.QtGui.QStyleHints.mouseDoubleClickDistance": (),
    "PySide2.QtGui.QStyleHints.mouseDoubleClickInterval": (),
    "PySide2.QtGui.QStyleHints.mousePressAndHoldInterval": (),
    "PySide2.QtGui.QStyleHints.mouseQuickSelectionThreshold": (),
    "PySide2.QtGui.QStyleHints.passwordMaskCharacter": (),
    "PySide2.QtGui.QStyleHints.passwordMaskDelay": (),
    "PySide2.QtGui.QStyleHints.setCursorFlashTime": ('int',),
    "PySide2.QtGui.QStyleHints.setFocusOnTouchRelease": (),
    "PySide2.QtGui.QStyleHints.setKeyboardInputInterval": ('int',),
    "PySide2.QtGui.QStyleHints.setMouseDoubleClickInterval": ('int',),
    "PySide2.QtGui.QStyleHints.setMousePressAndHoldInterval": ('int',),
    "PySide2.QtGui.QStyleHints.setMouseQuickSelectionThreshold": ('int',),
    "PySide2.QtGui.QStyleHints.setShowShortcutsInContextMenus": ('bool',),
    "PySide2.QtGui.QStyleHints.setStartDragDistance": ('int',),
    "PySide2.QtGui.QStyleHints.setStartDragTime": ('int',),
    "PySide2.QtGui.QStyleHints.setTabFocusBehavior": ('PySide2.QtCore.Qt.TabFocusBehavior',),
    "PySide2.QtGui.QStyleHints.setUseHoverEffects": ('bool',),
    "PySide2.QtGui.QStyleHints.setWheelScrollLines": ('int',),
    "PySide2.QtGui.QStyleHints.showIsFullScreen": (),
    "PySide2.QtGui.QStyleHints.showIsMaximized": (),
    "PySide2.QtGui.QStyleHints.showShortcutsInContextMenus": (),
    "PySide2.QtGui.QStyleHints.singleClickActivation": (),
    "PySide2.QtGui.QStyleHints.startDragDistance": (),
    "PySide2.QtGui.QStyleHints.startDragTime": (),
    "PySide2.QtGui.QStyleHints.startDragVelocity": (),
    "PySide2.QtGui.QStyleHints.tabFocusBehavior": (),
    "PySide2.QtGui.QStyleHints.touchDoubleTapDistance": (),
    "PySide2.QtGui.QStyleHints.useHoverEffects": (),
    "PySide2.QtGui.QStyleHints.useRtlExtensions": (),
    "PySide2.QtGui.QStyleHints.wheelScrollLines": (),

# class PySide2.QtGui.QSurface:

# class PySide2.QtGui.QSurface.SurfaceClass:

# class PySide2.QtGui.QSurface.SurfaceType:
    "PySide2.QtGui.QSurface.__init__": ('PySide2.QtGui.QSurface.SurfaceClass',),
    "PySide2.QtGui.QSurface.format": (),
    "PySide2.QtGui.QSurface.size": (),
    "PySide2.QtGui.QSurface.supportsOpenGL": (),
    "PySide2.QtGui.QSurface.surfaceClass": (),
    "PySide2.QtGui.QSurface.surfaceHandle": (),
    "PySide2.QtGui.QSurface.surfaceType": (),

# class PySide2.QtGui.QSurfaceFormat:

# class PySide2.QtGui.QSurfaceFormat.ColorSpace:

# class PySide2.QtGui.QSurfaceFormat.FormatOption:

# class PySide2.QtGui.QSurfaceFormat.FormatOptions:

# class PySide2.QtGui.QSurfaceFormat.OpenGLContextProfile:

# class PySide2.QtGui.QSurfaceFormat.RenderableType:

# class PySide2.QtGui.QSurfaceFormat.SwapBehavior:
    "PySide2.QtGui.QSurfaceFormat.__init__": [(), ('PySide2.QtGui.QSurfaceFormat',), ('PySide2.QtGui.QSurfaceFormat.FormatOptions',)],
    "PySide2.QtGui.QSurfaceFormat.__copy__": (),
    "PySide2.QtGui.QSurfaceFormat.alphaBufferSize": (),
    "PySide2.QtGui.QSurfaceFormat.blueBufferSize": (),
    "PySide2.QtGui.QSurfaceFormat.colorSpace": (),
    "PySide2.QtGui.QSurfaceFormat.defaultFormat": (),
    "PySide2.QtGui.QSurfaceFormat.depthBufferSize": (),
    "PySide2.QtGui.QSurfaceFormat.greenBufferSize": (),
    "PySide2.QtGui.QSurfaceFormat.hasAlpha": (),
    "PySide2.QtGui.QSurfaceFormat.majorVersion": (),
    "PySide2.QtGui.QSurfaceFormat.minorVersion": (),
    "PySide2.QtGui.QSurfaceFormat.options": (),
    "PySide2.QtGui.QSurfaceFormat.profile": (),
    "PySide2.QtGui.QSurfaceFormat.redBufferSize": (),
    "PySide2.QtGui.QSurfaceFormat.renderableType": (),
    "PySide2.QtGui.QSurfaceFormat.samples": (),
    "PySide2.QtGui.QSurfaceFormat.setAlphaBufferSize": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setBlueBufferSize": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setColorSpace": ('PySide2.QtGui.QSurfaceFormat.ColorSpace',),
    "PySide2.QtGui.QSurfaceFormat.setDefaultFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtGui.QSurfaceFormat.setDepthBufferSize": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setGreenBufferSize": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setMajorVersion": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setMinorVersion": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setOption": [('PySide2.QtGui.QSurfaceFormat.FormatOption', 'bool'), ('PySide2.QtGui.QSurfaceFormat.FormatOptions',)],
    "PySide2.QtGui.QSurfaceFormat.setOptions": ('PySide2.QtGui.QSurfaceFormat.FormatOptions',),
    "PySide2.QtGui.QSurfaceFormat.setProfile": ('PySide2.QtGui.QSurfaceFormat.OpenGLContextProfile',),
    "PySide2.QtGui.QSurfaceFormat.setRedBufferSize": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setRenderableType": ('PySide2.QtGui.QSurfaceFormat.RenderableType',),
    "PySide2.QtGui.QSurfaceFormat.setSamples": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setStencilBufferSize": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setStereo": ('bool',),
    "PySide2.QtGui.QSurfaceFormat.setSwapBehavior": ('PySide2.QtGui.QSurfaceFormat.SwapBehavior',),
    "PySide2.QtGui.QSurfaceFormat.setSwapInterval": ('int',),
    "PySide2.QtGui.QSurfaceFormat.setVersion": ('int', 'int'),
    "PySide2.QtGui.QSurfaceFormat.stencilBufferSize": (),
    "PySide2.QtGui.QSurfaceFormat.stereo": (),
    "PySide2.QtGui.QSurfaceFormat.swapBehavior": (),
    "PySide2.QtGui.QSurfaceFormat.swapInterval": (),
    "PySide2.QtGui.QSurfaceFormat.testOption": [('PySide2.QtGui.QSurfaceFormat.FormatOption',), ('PySide2.QtGui.QSurfaceFormat.FormatOptions',)],
    "PySide2.QtGui.QSurfaceFormat.version": (),

# class PySide2.QtGui.QSyntaxHighlighter:
    "PySide2.QtGui.QSyntaxHighlighter.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtGui.QTextDocument',)],
    "PySide2.QtGui.QSyntaxHighlighter.currentBlock": (),
    "PySide2.QtGui.QSyntaxHighlighter.currentBlockState": (),
    "PySide2.QtGui.QSyntaxHighlighter.currentBlockUserData": (),
    "PySide2.QtGui.QSyntaxHighlighter.document": (),
    "PySide2.QtGui.QSyntaxHighlighter.format": ('int',),
    "PySide2.QtGui.QSyntaxHighlighter.highlightBlock": ('str',),
    "PySide2.QtGui.QSyntaxHighlighter.previousBlockState": (),
    "PySide2.QtGui.QSyntaxHighlighter.rehighlight": (),
    "PySide2.QtGui.QSyntaxHighlighter.rehighlightBlock": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QSyntaxHighlighter.setCurrentBlockState": ('int',),
    "PySide2.QtGui.QSyntaxHighlighter.setCurrentBlockUserData": ('PySide2.QtGui.QTextBlockUserData',),
    "PySide2.QtGui.QSyntaxHighlighter.setDocument": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QSyntaxHighlighter.setFormat": [('int', 'int', 'PySide2.QtGui.QColor'), ('int', 'int', 'PySide2.QtGui.QFont'), ('int', 'int', 'PySide2.QtGui.QTextCharFormat')],

# class PySide2.QtGui.QTabletEvent:

# class PySide2.QtGui.QTabletEvent.PointerType:

# class PySide2.QtGui.QTabletEvent.TabletDevice:
    "PySide2.QtGui.QTabletEvent.__init__": [('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'int', 'int', 'float', 'int', 'int', 'float', 'float', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'int', 'int', 'float', 'int', 'int', 'float', 'float', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.MouseButtons')],
    "PySide2.QtGui.QTabletEvent.button": (),
    "PySide2.QtGui.QTabletEvent.buttons": (),
    "PySide2.QtGui.QTabletEvent.device": (),
    "PySide2.QtGui.QTabletEvent.globalPos": (),
    "PySide2.QtGui.QTabletEvent.globalPosF": (),
    "PySide2.QtGui.QTabletEvent.globalX": (),
    "PySide2.QtGui.QTabletEvent.global""Y": (),
    "PySide2.QtGui.QTabletEvent.hiResGlobalX": (),
    "PySide2.QtGui.QTabletEvent.hiResGlobal""Y": (),
    "PySide2.QtGui.QTabletEvent.pointerType": (),
    "PySide2.QtGui.QTabletEvent.pos": (),
    "PySide2.QtGui.QTabletEvent.posF": (),
    "PySide2.QtGui.QTabletEvent.pressure": (),
    "PySide2.QtGui.QTabletEvent.rotation": (),
    "PySide2.QtGui.QTabletEvent.tangentialPressure": (),
    "PySide2.QtGui.QTabletEvent.uniqueId": (),
    "PySide2.QtGui.QTabletEvent.x": (),
    "PySide2.QtGui.QTabletEvent.xTilt": (),
    "PySide2.QtGui.QTabletEvent.y": (),
    "PySide2.QtGui.QTabletEvent.yTilt": (),
    "PySide2.QtGui.QTabletEvent.z": (),

# class PySide2.QtGui.QTextBlock:

# class PySide2.QtGui.QTextBlock.iterator:
    "PySide2.QtGui.QTextBlock.iterator.__init__": [(), ('PySide2.QtGui.QTextBlock.iterator',)],
    "PySide2.QtGui.QTextBlock.iterator.__copy__": (),
    "PySide2.QtGui.QTextBlock.iterator.__iadd__": ('int',),
    "PySide2.QtGui.QTextBlock.iterator.__isub__": ('int',),
    "PySide2.QtGui.QTextBlock.iterator.__iter__": (),
    "PySide2.QtGui.QTextBlock.iterator.atEnd": (),
    "PySide2.QtGui.QTextBlock.iterator.fragment": (),

    "PySide2.QtGui.QTextBlock.__init__": [(), ('PySide2.QtGui.QTextBlock',)],
    "PySide2.QtGui.QTextBlock.__copy__": (),
    "PySide2.QtGui.QTextBlock.__iter__": (),
    "PySide2.QtGui.QTextBlock.begin": (),
    "PySide2.QtGui.QTextBlock.blockFormat": (),
    "PySide2.QtGui.QTextBlock.blockFormatIndex": (),
    "PySide2.QtGui.QTextBlock.blockNumber": (),
    "PySide2.QtGui.QTextBlock.charFormat": (),
    "PySide2.QtGui.QTextBlock.charFormatIndex": (),
    "PySide2.QtGui.QTextBlock.clearLayout": (),
    "PySide2.QtGui.QTextBlock.contains": ('int',),
    "PySide2.QtGui.QTextBlock.document": (),
    "PySide2.QtGui.QTextBlock.end": (),
    "PySide2.QtGui.QTextBlock.firstLineNumber": (),
    "PySide2.QtGui.QTextBlock.fragmentIndex": (),
    "PySide2.QtGui.QTextBlock.isValid": (),
    "PySide2.QtGui.QTextBlock.isVisible": (),
    "PySide2.QtGui.QTextBlock.layout": (),
    "PySide2.QtGui.QTextBlock.length": (),
    "PySide2.QtGui.QTextBlock.lineCount": (),
    "PySide2.QtGui.QTextBlock.position": (),
    "PySide2.QtGui.QTextBlock.previous": (),
    "PySide2.QtGui.QTextBlock.revision": (),
    "PySide2.QtGui.QTextBlock.setLineCount": ('int',),
    "PySide2.QtGui.QTextBlock.setRevision": ('int',),
    "PySide2.QtGui.QTextBlock.setUserData": ('PySide2.QtGui.QTextBlockUserData',),
    "PySide2.QtGui.QTextBlock.setUserState": ('int',),
    "PySide2.QtGui.QTextBlock.setVisible": ('bool',),
    "PySide2.QtGui.QTextBlock.text": (),
    "PySide2.QtGui.QTextBlock.textDirection": (),
    "PySide2.QtGui.QTextBlock.textFormats": (),
    "PySide2.QtGui.QTextBlock.textList": (),
    "PySide2.QtGui.QTextBlock.userData": (),
    "PySide2.QtGui.QTextBlock.userState": (),

# class PySide2.QtGui.QTextBlockFormat:

# class PySide2.QtGui.QTextBlockFormat.LineHeightTypes:

# class PySide2.QtGui.QTextBlockFormat.MarkerType:
    "PySide2.QtGui.QTextBlockFormat.__init__": [(), ('PySide2.QtGui.QTextBlockFormat',), ('PySide2.QtGui.QTextFormat',)],
    "PySide2.QtGui.QTextBlockFormat.__copy__": (),
    "PySide2.QtGui.QTextBlockFormat.alignment": (),
    "PySide2.QtGui.QTextBlockFormat.bottomMargin": (),
    "PySide2.QtGui.QTextBlockFormat.headingLevel": (),
    "PySide2.QtGui.QTextBlockFormat.indent": (),
    "PySide2.QtGui.QTextBlockFormat.isValid": (),
    "PySide2.QtGui.QTextBlockFormat.leftMargin": (),
    "PySide2.QtGui.QTextBlockFormat.lineHeight": [(), ('float', 'float')],
    "PySide2.QtGui.QTextBlockFormat.lineHeightType": (),
    "PySide2.QtGui.QTextBlockFormat.marker": (),
    "PySide2.QtGui.QTextBlockFormat.nonBreakableLines": (),
    "PySide2.QtGui.QTextBlockFormat.pageBreakPolicy": (),
    "PySide2.QtGui.QTextBlockFormat.rightMargin": (),
    "PySide2.QtGui.QTextBlockFormat.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtGui.QTextBlockFormat.setBottomMargin": ('float',),
    "PySide2.QtGui.QTextBlockFormat.setHeadingLevel": ('int',),
    "PySide2.QtGui.QTextBlockFormat.setIndent": ('int',),
    "PySide2.QtGui.QTextBlockFormat.setLeftMargin": ('float',),
    "PySide2.QtGui.QTextBlockFormat.setLineHeight": ('float', 'int'),
    "PySide2.QtGui.QTextBlockFormat.setMarker": ('PySide2.QtGui.QTextBlockFormat.MarkerType',),
    "PySide2.QtGui.QTextBlockFormat.setNonBreakableLines": ('bool',),
    "PySide2.QtGui.QTextBlockFormat.setPageBreakPolicy": ('PySide2.QtGui.QTextFormat.PageBreakFlags',),
    "PySide2.QtGui.QTextBlockFormat.setRightMargin": ('float',),
    "PySide2.QtGui.QTextBlockFormat.setTabPositions": ('typing.Sequence[PySide2.QtGui.QTextOption.Tab]',),
    "PySide2.QtGui.QTextBlockFormat.setTextIndent": ('float',),
    "PySide2.QtGui.QTextBlockFormat.setTopMargin": ('float',),
    "PySide2.QtGui.QTextBlockFormat.tabPositions": (),
    "PySide2.QtGui.QTextBlockFormat.textIndent": (),
    "PySide2.QtGui.QTextBlockFormat.topMargin": (),

# class PySide2.QtGui.QTextBlockGroup:
    "PySide2.QtGui.QTextBlockGroup.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QTextBlockGroup.blockFormatChanged": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QTextBlockGroup.blockInserted": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QTextBlockGroup.blockList": (),
    "PySide2.QtGui.QTextBlockGroup.blockRemoved": ('PySide2.QtGui.QTextBlock',),

# class PySide2.QtGui.QTextBlockUserData:
    "PySide2.QtGui.QTextBlockUserData.__init__": (),

# class PySide2.QtGui.QTextCharFormat:

# class PySide2.QtGui.QTextCharFormat.FontPropertiesInheritanceBehavior:

# class PySide2.QtGui.QTextCharFormat.UnderlineStyle:

# class PySide2.QtGui.QTextCharFormat.VerticalAlignment:
    "PySide2.QtGui.QTextCharFormat.__init__": [(), ('PySide2.QtGui.QTextCharFormat',), ('PySide2.QtGui.QTextFormat',)],
    "PySide2.QtGui.QTextCharFormat.__copy__": (),
    "PySide2.QtGui.QTextCharFormat.anchorHref": (),
    "PySide2.QtGui.QTextCharFormat.anchorName": (),
    "PySide2.QtGui.QTextCharFormat.anchorNames": (),
    "PySide2.QtGui.QTextCharFormat.font": (),
    "PySide2.QtGui.QTextCharFormat.fontCapitalization": (),
    "PySide2.QtGui.QTextCharFormat.fontFamilies": (),
    "PySide2.QtGui.QTextCharFormat.fontFamily": (),
    "PySide2.QtGui.QTextCharFormat.fontFixedPitch": (),
    "PySide2.QtGui.QTextCharFormat.fontHintingPreference": (),
    "PySide2.QtGui.QTextCharFormat.fontItalic": (),
    "PySide2.QtGui.QTextCharFormat.fontKerning": (),
    "PySide2.QtGui.QTextCharFormat.fontLetterSpacing": (),
    "PySide2.QtGui.QTextCharFormat.fontLetterSpacingType": (),
    "PySide2.QtGui.QTextCharFormat.fontOverline": (),
    "PySide2.QtGui.QTextCharFormat.fontPointSize": (),
    "PySide2.QtGui.QTextCharFormat.fontStretch": (),
    "PySide2.QtGui.QTextCharFormat.fontStrikeOut": (),
    "PySide2.QtGui.QTextCharFormat.fontStyleHint": (),
    "PySide2.QtGui.QTextCharFormat.fontStyleName": (),
    "PySide2.QtGui.QTextCharFormat.fontStyleStrategy": (),
    "PySide2.QtGui.QTextCharFormat.fontUnderline": (),
    "PySide2.QtGui.QTextCharFormat.fontWeight": (),
    "PySide2.QtGui.QTextCharFormat.fontWordSpacing": (),
    "PySide2.QtGui.QTextCharFormat.isAnchor": (),
    "PySide2.QtGui.QTextCharFormat.isValid": (),
    "PySide2.QtGui.QTextCharFormat.setAnchor": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setAnchorHref": ('str',),
    "PySide2.QtGui.QTextCharFormat.setAnchorName": ('str',),
    "PySide2.QtGui.QTextCharFormat.setAnchorNames": ('typing.Sequence[str]',),
    "PySide2.QtGui.QTextCharFormat.setFont": [('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFont', 'PySide2.QtGui.QTextCharFormat.FontPropertiesInheritanceBehavior')],
    "PySide2.QtGui.QTextCharFormat.setFontCapitalization": ('PySide2.QtGui.QFont.Capitalization',),
    "PySide2.QtGui.QTextCharFormat.setFontFamilies": ('typing.Sequence[str]',),
    "PySide2.QtGui.QTextCharFormat.setFontFamily": ('str',),
    "PySide2.QtGui.QTextCharFormat.setFontFixedPitch": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setFontHintingPreference": ('PySide2.QtGui.QFont.HintingPreference',),
    "PySide2.QtGui.QTextCharFormat.setFontItalic": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setFontKerning": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setFontLetterSpacing": ('float',),
    "PySide2.QtGui.QTextCharFormat.setFontLetterSpacingType": ('PySide2.QtGui.QFont.SpacingType',),
    "PySide2.QtGui.QTextCharFormat.setFontOverline": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setFontPointSize": ('float',),
    "PySide2.QtGui.QTextCharFormat.setFontStretch": ('int',),
    "PySide2.QtGui.QTextCharFormat.setFontStrikeOut": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setFontStyleHint": ('PySide2.QtGui.QFont.StyleHint', 'PySide2.QtGui.QFont.StyleStrategy'),
    "PySide2.QtGui.QTextCharFormat.setFontStyleName": ('str',),
    "PySide2.QtGui.QTextCharFormat.setFontStyleStrategy": ('PySide2.QtGui.QFont.StyleStrategy',),
    "PySide2.QtGui.QTextCharFormat.setFontUnderline": ('bool',),
    "PySide2.QtGui.QTextCharFormat.setFontWeight": ('int',),
    "PySide2.QtGui.QTextCharFormat.setFontWordSpacing": ('float',),
    "PySide2.QtGui.QTextCharFormat.setTableCellColumnSpan": ('int',),
    "PySide2.QtGui.QTextCharFormat.setTableCellRowSpan": ('int',),
    "PySide2.QtGui.QTextCharFormat.setTextOutline": ('PySide2.QtGui.QPen',),
    "PySide2.QtGui.QTextCharFormat.setToolTip": ('str',),
    "PySide2.QtGui.QTextCharFormat.setUnderlineColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtGui.QTextCharFormat.setUnderlineStyle": ('PySide2.QtGui.QTextCharFormat.UnderlineStyle',),
    "PySide2.QtGui.QTextCharFormat.setVerticalAlignment": ('PySide2.QtGui.QTextCharFormat.VerticalAlignment',),
    "PySide2.QtGui.QTextCharFormat.tableCellColumnSpan": (),
    "PySide2.QtGui.QTextCharFormat.tableCellRowSpan": (),
    "PySide2.QtGui.QTextCharFormat.textOutline": (),
    "PySide2.QtGui.QTextCharFormat.toolTip": (),
    "PySide2.QtGui.QTextCharFormat.underlineColor": (),
    "PySide2.QtGui.QTextCharFormat.underlineStyle": (),
    "PySide2.QtGui.QTextCharFormat.verticalAlignment": (),

# class PySide2.QtGui.QTextCursor:

# class PySide2.QtGui.QTextCursor.MoveMode:

# class PySide2.QtGui.QTextCursor.MoveOperation:

# class PySide2.QtGui.QTextCursor.SelectionType:
    "PySide2.QtGui.QTextCursor.__init__": [(), ('PySide2.QtGui.QTextBlock',), ('PySide2.QtGui.QTextCursor',), ('PySide2.QtGui.QTextDocument',), ('PySide2.QtGui.QTextFrame',)],
    "PySide2.QtGui.QTextCursor.__copy__": (),
    "PySide2.QtGui.QTextCursor.anchor": (),
    "PySide2.QtGui.QTextCursor.atBlockEnd": (),
    "PySide2.QtGui.QTextCursor.atBlockStart": (),
    "PySide2.QtGui.QTextCursor.atEnd": (),
    "PySide2.QtGui.QTextCursor.atStart": (),
    "PySide2.QtGui.QTextCursor.beginEditBlock": (),
    "PySide2.QtGui.QTextCursor.block": (),
    "PySide2.QtGui.QTextCursor.blockCharFormat": (),
    "PySide2.QtGui.QTextCursor.blockFormat": (),
    "PySide2.QtGui.QTextCursor.blockNumber": (),
    "PySide2.QtGui.QTextCursor.charFormat": (),
    "PySide2.QtGui.QTextCursor.clearSelection": (),
    "PySide2.QtGui.QTextCursor.columnNumber": (),
    "PySide2.QtGui.QTextCursor.createList": [('PySide2.QtGui.QTextListFormat',), ('PySide2.QtGui.QTextListFormat.Style',)],
    "PySide2.QtGui.QTextCursor.currentFrame": (),
    "PySide2.QtGui.QTextCursor.currentList": (),
    "PySide2.QtGui.QTextCursor.currentTable": (),
    "PySide2.QtGui.QTextCursor.deleteChar": (),
    "PySide2.QtGui.QTextCursor.deletePreviousChar": (),
    "PySide2.QtGui.QTextCursor.document": (),
    "PySide2.QtGui.QTextCursor.endEditBlock": (),
    "PySide2.QtGui.QTextCursor.hasComplexSelection": (),
    "PySide2.QtGui.QTextCursor.hasSelection": (),
    "PySide2.QtGui.QTextCursor.insertBlock": [(), ('PySide2.QtGui.QTextBlockFormat',), ('PySide2.QtGui.QTextBlockFormat', 'PySide2.QtGui.QTextCharFormat')],
    "PySide2.QtGui.QTextCursor.insertFragment": ('PySide2.QtGui.QTextDocumentFragment',),
    "PySide2.QtGui.QTextCursor.insertFrame": ('PySide2.QtGui.QTextFrameFormat',),
    "PySide2.QtGui.QTextCursor.insertHtml": ('str',),
    "PySide2.QtGui.QTextCursor.insertImage": [('PySide2.QtGui.QImage', 'str'), ('PySide2.QtGui.QTextImageFormat',), ('PySide2.QtGui.QTextImageFormat', 'PySide2.QtGui.QTextFrameFormat.Position'), ('str',)],
    "PySide2.QtGui.QTextCursor.insertList": [('PySide2.QtGui.QTextListFormat',), ('PySide2.QtGui.QTextListFormat.Style',)],
    "PySide2.QtGui.QTextCursor.insertTable": [('int', 'int'), ('int', 'int', 'PySide2.QtGui.QTextTableFormat')],
    "PySide2.QtGui.QTextCursor.insertText": [('str',), ('str', 'PySide2.QtGui.QTextCharFormat')],
    "PySide2.QtGui.QTextCursor.isCopyOf": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtGui.QTextCursor.isNull": (),
    "PySide2.QtGui.QTextCursor.joinPreviousEditBlock": (),
    "PySide2.QtGui.QTextCursor.keepPositionOnInsert": (),
    "PySide2.QtGui.QTextCursor.mergeBlockCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtGui.QTextCursor.mergeBlockFormat": ('PySide2.QtGui.QTextBlockFormat',),
    "PySide2.QtGui.QTextCursor.mergeCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtGui.QTextCursor.movePosition": ('PySide2.QtGui.QTextCursor.MoveOperation', 'PySide2.QtGui.QTextCursor.MoveMode', 'int'),
    "PySide2.QtGui.QTextCursor.position": (),
    "PySide2.QtGui.QTextCursor.positionInBlock": (),
    "PySide2.QtGui.QTextCursor.removeSelectedText": (),
    "PySide2.QtGui.QTextCursor.select": ('PySide2.QtGui.QTextCursor.SelectionType',),
    "PySide2.QtGui.QTextCursor.selectedTableCells": (),
    "PySide2.QtGui.QTextCursor.selectedText": (),
    "PySide2.QtGui.QTextCursor.selection": (),
    "PySide2.QtGui.QTextCursor.selectionEnd": (),
    "PySide2.QtGui.QTextCursor.selectionStart": (),
    "PySide2.QtGui.QTextCursor.setBlockCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtGui.QTextCursor.setBlockFormat": ('PySide2.QtGui.QTextBlockFormat',),
    "PySide2.QtGui.QTextCursor.setCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtGui.QTextCursor.setKeepPositionOnInsert": ('bool',),
    "PySide2.QtGui.QTextCursor.setPosition": ('int', 'PySide2.QtGui.QTextCursor.MoveMode'),
    "PySide2.QtGui.QTextCursor.setVerticalMovementX": ('int',),
    "PySide2.QtGui.QTextCursor.setVisualNavigation": ('bool',),
    "PySide2.QtGui.QTextCursor.swap": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtGui.QTextCursor.verticalMovementX": (),
    "PySide2.QtGui.QTextCursor.visualNavigation": (),

# class PySide2.QtGui.QTextDocument:

# class PySide2.QtGui.QTextDocument.FindFlag:

# class PySide2.QtGui.QTextDocument.FindFlags:

# class PySide2.QtGui.QTextDocument.MarkdownFeature:

# class PySide2.QtGui.QTextDocument.MarkdownFeatures:

# class PySide2.QtGui.QTextDocument.MetaInformation:

# class PySide2.QtGui.QTextDocument.ResourceType:

# class PySide2.QtGui.QTextDocument.Stacks:
    "PySide2.QtGui.QTextDocument.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtGui.QTextDocument.addResource": ('int', 'PySide2.QtCore.QUrl', 'typing.Any'),
    "PySide2.QtGui.QTextDocument.adjustSize": (),
    "PySide2.QtGui.QTextDocument.allFormats": (),
    "PySide2.QtGui.QTextDocument.availableRedoSteps": (),
    "PySide2.QtGui.QTextDocument.availableUndoSteps": (),
    "PySide2.QtGui.QTextDocument.baseUrl": (),
    "PySide2.QtGui.QTextDocument.begin": (),
    "PySide2.QtGui.QTextDocument.blockCount": (),
    "PySide2.QtGui.QTextDocument.characterAt": ('int',),
    "PySide2.QtGui.QTextDocument.characterCount": (),
    "PySide2.QtGui.QTextDocument.clear": (),
    "PySide2.QtGui.QTextDocument.clearUndoRedoStacks": ('PySide2.QtGui.QTextDocument.Stacks',),
    "PySide2.QtGui.QTextDocument.clone": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QTextDocument.createObject": ('PySide2.QtGui.QTextFormat',),
    "PySide2.QtGui.QTextDocument.defaultCursorMoveStyle": (),
    "PySide2.QtGui.QTextDocument.defaultFont": (),
    "PySide2.QtGui.QTextDocument.defaultStyleSheet": (),
    "PySide2.QtGui.QTextDocument.defaultTextOption": (),
    "PySide2.QtGui.QTextDocument.documentLayout": (),
    "PySide2.QtGui.QTextDocument.documentMargin": (),
    "PySide2.QtGui.QTextDocument.drawContents": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF'),
    "PySide2.QtGui.QTextDocument.end": (),
    "PySide2.QtGui.QTextDocument.find": [('PySide2.QtCore.QRegExp', 'PySide2.QtGui.QTextCursor', 'PySide2.QtGui.QTextDocument.FindFlags'), ('PySide2.QtCore.QRegExp', 'int', 'PySide2.QtGui.QTextDocument.FindFlags'), ('PySide2.QtCore.QRegularExpression', 'PySide2.QtGui.QTextCursor', 'PySide2.QtGui.QTextDocument.FindFlags'), ('PySide2.QtCore.QRegularExpression', 'int', 'PySide2.QtGui.QTextDocument.FindFlags'), ('str', 'PySide2.QtGui.QTextCursor', 'PySide2.QtGui.QTextDocument.FindFlags'), ('str', 'int', 'PySide2.QtGui.QTextDocument.FindFlags')],
    "PySide2.QtGui.QTextDocument.findBlock": ('int',),
    "PySide2.QtGui.QTextDocument.findBlockByLineNumber": ('int',),
    "PySide2.QtGui.QTextDocument.findBlockByNumber": ('int',),
    "PySide2.QtGui.QTextDocument.firstBlock": (),
    "PySide2.QtGui.QTextDocument.frameAt": ('int',),
    "PySide2.QtGui.QTextDocument.idealWidth": (),
    "PySide2.QtGui.QTextDocument.indentWidth": (),
    "PySide2.QtGui.QTextDocument.isEmpty": (),
    "PySide2.QtGui.QTextDocument.isModified": (),
    "PySide2.QtGui.QTextDocument.isRedoAvailable": (),
    "PySide2.QtGui.QTextDocument.isUndoAvailable": (),
    "PySide2.QtGui.QTextDocument.isUndoRedoEnabled": (),
    "PySide2.QtGui.QTextDocument.lastBlock": (),
    "PySide2.QtGui.QTextDocument.lineCount": (),
    "PySide2.QtGui.QTextDocument.loadResource": ('int', 'PySide2.QtCore.QUrl'),
    "PySide2.QtGui.QTextDocument.markContentsDirty": ('int', 'int'),
    "PySide2.QtGui.QTextDocument.maximumBlockCount": (),
    "PySide2.QtGui.QTextDocument.metaInformation": ('PySide2.QtGui.QTextDocument.MetaInformation',),
    "PySide2.QtGui.QTextDocument.object": ('int',),
    "PySide2.QtGui.QTextDocument.objectForFormat": ('PySide2.QtGui.QTextFormat',),
    "PySide2.QtGui.QTextDocument.pageCount": (),
    "PySide2.QtGui.QTextDocument.pageSize": (),
    "PySide2.QtGui.QTextDocument.print_": ('PySide2.QtGui.QPagedPaintDevice',),
    "PySide2.QtGui.QTextDocument.redo": [(), ('PySide2.QtGui.QTextCursor',)],
    "PySide2.QtGui.QTextDocument.resource": ('int', 'PySide2.QtCore.QUrl'),
    "PySide2.QtGui.QTextDocument.revision": (),
    "PySide2.QtGui.QTextDocument.rootFrame": (),
    "PySide2.QtGui.QTextDocument.setBaseUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtGui.QTextDocument.setDefaultCursorMoveStyle": ('PySide2.QtCore.Qt.CursorMoveStyle',),
    "PySide2.QtGui.QTextDocument.setDefaultFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QTextDocument.setDefaultStyleSheet": ('str',),
    "PySide2.QtGui.QTextDocument.setDefaultTextOption": ('PySide2.QtGui.QTextOption',),
    "PySide2.QtGui.QTextDocument.setDocumentLayout": ('PySide2.QtGui.QAbstractTextDocumentLayout',),
    "PySide2.QtGui.QTextDocument.setDocumentMargin": ('float',),
    "PySide2.QtGui.QTextDocument.setHtml": ('str',),
    "PySide2.QtGui.QTextDocument.setIndentWidth": ('float',),
    "PySide2.QtGui.QTextDocument.setMarkdown": ('str', 'PySide2.QtGui.QTextDocument.MarkdownFeatures'),
    "PySide2.QtGui.QTextDocument.setMaximumBlockCount": ('int',),
    "PySide2.QtGui.QTextDocument.setMetaInformation": ('PySide2.QtGui.QTextDocument.MetaInformation', 'str'),
    "PySide2.QtGui.QTextDocument.setModified": ('bool',),
    "PySide2.QtGui.QTextDocument.setPageSize": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtGui.QTextDocument.setPlainText": ('str',),
    "PySide2.QtGui.QTextDocument.setTextWidth": ('float',),
    "PySide2.QtGui.QTextDocument.setUndoRedoEnabled": ('bool',),
    "PySide2.QtGui.QTextDocument.setUseDesignMetrics": ('bool',),
    "PySide2.QtGui.QTextDocument.size": (),
    "PySide2.QtGui.QTextDocument.textWidth": (),
    "PySide2.QtGui.QTextDocument.toHtml": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QTextDocument.toMarkdown": ('PySide2.QtGui.QTextDocument.MarkdownFeatures',),
    "PySide2.QtGui.QTextDocument.toPlainText": (),
    "PySide2.QtGui.QTextDocument.toRawText": (),
    "PySide2.QtGui.QTextDocument.undo": [(), ('PySide2.QtGui.QTextCursor',)],
    "PySide2.QtGui.QTextDocument.useDesignMetrics": (),

# class PySide2.QtGui.QTextDocumentFragment:
    "PySide2.QtGui.QTextDocumentFragment.__init__": [(), ('PySide2.QtGui.QTextCursor',), ('PySide2.QtGui.QTextDocument',), ('PySide2.QtGui.QTextDocumentFragment',)],
    "PySide2.QtGui.QTextDocumentFragment.__copy__": (),
    "PySide2.QtGui.QTextDocumentFragment.fromHtml": [('str',), ('str', 'PySide2.QtGui.QTextDocument')],
    "PySide2.QtGui.QTextDocumentFragment.fromPlainText": ('str',),
    "PySide2.QtGui.QTextDocumentFragment.isEmpty": (),
    "PySide2.QtGui.QTextDocumentFragment.toHtml": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QTextDocumentFragment.toPlainText": (),

# class PySide2.QtGui.QTextDocumentWriter:
    "PySide2.QtGui.QTextDocumentWriter.__init__": [(), ('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QByteArray'), ('str', 'PySide2.QtCore.QByteArray')],
    "PySide2.QtGui.QTextDocumentWriter.codec": (),
    "PySide2.QtGui.QTextDocumentWriter.device": (),
    "PySide2.QtGui.QTextDocumentWriter.fileName": (),
    "PySide2.QtGui.QTextDocumentWriter.format": (),
    "PySide2.QtGui.QTextDocumentWriter.setCodec": ('PySide2.QtCore.QTextCodec',),
    "PySide2.QtGui.QTextDocumentWriter.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtGui.QTextDocumentWriter.setFileName": ('str',),
    "PySide2.QtGui.QTextDocumentWriter.setFormat": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.QTextDocumentWriter.supportedDocumentFormats": (),
    "PySide2.QtGui.QTextDocumentWriter.write": [('PySide2.QtGui.QTextDocument',), ('PySide2.QtGui.QTextDocumentFragment',)],

# class PySide2.QtGui.QTextFormat:

# class PySide2.QtGui.QTextFormat.FormatType:

# class PySide2.QtGui.QTextFormat.ObjectTypes:

# class PySide2.QtGui.QTextFormat.PageBreakFlag:

# class PySide2.QtGui.QTextFormat.PageBreakFlags:

# class PySide2.QtGui.QTextFormat.Property:
    "PySide2.QtGui.QTextFormat.__init__": [(), ('PySide2.QtGui.QTextFormat',), ('int',)],
    "PySide2.QtGui.QTextFormat.__copy__": (),
    "PySide2.QtGui.QTextFormat.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QTextFormat.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QTextFormat.background": (),
    "PySide2.QtGui.QTextFormat.boolProperty": ('int',),
    "PySide2.QtGui.QTextFormat.brushProperty": ('int',),
    "PySide2.QtGui.QTextFormat.clearBackground": (),
    "PySide2.QtGui.QTextFormat.clearForeground": (),
    "PySide2.QtGui.QTextFormat.clearProperty": ('int',),
    "PySide2.QtGui.QTextFormat.colorProperty": ('int',),
    "PySide2.QtGui.QTextFormat.doubleProperty": ('int',),
    "PySide2.QtGui.QTextFormat.foreground": (),
    "PySide2.QtGui.QTextFormat.hasProperty": ('int',),
    "PySide2.QtGui.QTextFormat.intProperty": ('int',),
    "PySide2.QtGui.QTextFormat.isBlockFormat": (),
    "PySide2.QtGui.QTextFormat.isCharFormat": (),
    "PySide2.QtGui.QTextFormat.isEmpty": (),
    "PySide2.QtGui.QTextFormat.isFrameFormat": (),
    "PySide2.QtGui.QTextFormat.isImageFormat": (),
    "PySide2.QtGui.QTextFormat.isListFormat": (),
    "PySide2.QtGui.QTextFormat.isTableCellFormat": (),
    "PySide2.QtGui.QTextFormat.isTableFormat": (),
    "PySide2.QtGui.QTextFormat.isValid": (),
    "PySide2.QtGui.QTextFormat.layoutDirection": (),
    "PySide2.QtGui.QTextFormat.lengthProperty": ('int',),
    "PySide2.QtGui.QTextFormat.lengthVectorProperty": ('int',),
    "PySide2.QtGui.QTextFormat.merge": ('PySide2.QtGui.QTextFormat',),
    "PySide2.QtGui.QTextFormat.objectIndex": (),
    "PySide2.QtGui.QTextFormat.objectType": (),
    "PySide2.QtGui.QTextFormat.penProperty": ('int',),
    "PySide2.QtGui.QTextFormat.properties": (),
    "PySide2.QtGui.QTextFormat.property": ('int',),
    "PySide2.QtGui.QTextFormat.propertyCount": (),
    "PySide2.QtGui.QTextFormat.setBackground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextFormat.setForeground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextFormat.setLayoutDirection": ('PySide2.QtCore.Qt.LayoutDirection',),
    "PySide2.QtGui.QTextFormat.setObjectIndex": ('int',),
    "PySide2.QtGui.QTextFormat.setObjectType": ('int',),
    "PySide2.QtGui.QTextFormat.setProperty": [('int', 'typing.Any'), ('int', 'typing.List[PySide2.QtGui.QTextLength]')],
    "PySide2.QtGui.QTextFormat.stringProperty": ('int',),
    "PySide2.QtGui.QTextFormat.swap": ('PySide2.QtGui.QTextFormat',),
    "PySide2.QtGui.QTextFormat.toBlockFormat": (),
    "PySide2.QtGui.QTextFormat.toCharFormat": (),
    "PySide2.QtGui.QTextFormat.toFrameFormat": (),
    "PySide2.QtGui.QTextFormat.toImageFormat": (),
    "PySide2.QtGui.QTextFormat.toListFormat": (),
    "PySide2.QtGui.QTextFormat.toTableCellFormat": (),
    "PySide2.QtGui.QTextFormat.toTableFormat": (),
    "PySide2.QtGui.QTextFormat.type": (),

# class PySide2.QtGui.QTextFragment:
    "PySide2.QtGui.QTextFragment.__init__": [(), ('PySide2.QtGui.QTextFragment',)],
    "PySide2.QtGui.QTextFragment.__copy__": (),
    "PySide2.QtGui.QTextFragment.charFormat": (),
    "PySide2.QtGui.QTextFragment.charFormatIndex": (),
    "PySide2.QtGui.QTextFragment.contains": ('int',),
    "PySide2.QtGui.QTextFragment.isValid": (),
    "PySide2.QtGui.QTextFragment.length": (),
    "PySide2.QtGui.QTextFragment.position": (),
    "PySide2.QtGui.QTextFragment.text": (),

# class PySide2.QtGui.QTextFrame:

# class PySide2.QtGui.QTextFrame.iterator:
    "PySide2.QtGui.QTextFrame.iterator.__init__": [(), ('PySide2.QtGui.QTextFrame.iterator',)],
    "PySide2.QtGui.QTextFrame.iterator.__copy__": (),
    "PySide2.QtGui.QTextFrame.iterator.__iadd__": ('int',),
    "PySide2.QtGui.QTextFrame.iterator.__isub__": ('int',),
    "PySide2.QtGui.QTextFrame.iterator.__iter__": (),
    "PySide2.QtGui.QTextFrame.iterator.atEnd": (),
    "PySide2.QtGui.QTextFrame.iterator.currentBlock": (),
    "PySide2.QtGui.QTextFrame.iterator.currentFrame": (),
    "PySide2.QtGui.QTextFrame.iterator.parentFrame": (),

    "PySide2.QtGui.QTextFrame.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QTextFrame.__iter__": (),
    "PySide2.QtGui.QTextFrame.begin": (),
    "PySide2.QtGui.QTextFrame.childFrames": (),
    "PySide2.QtGui.QTextFrame.end": (),
    "PySide2.QtGui.QTextFrame.firstCursorPosition": (),
    "PySide2.QtGui.QTextFrame.firstPosition": (),
    "PySide2.QtGui.QTextFrame.frameFormat": (),
    "PySide2.QtGui.QTextFrame.lastCursorPosition": (),
    "PySide2.QtGui.QTextFrame.lastPosition": (),
    "PySide2.QtGui.QTextFrame.parentFrame": (),
    "PySide2.QtGui.QTextFrame.setFrameFormat": ('PySide2.QtGui.QTextFrameFormat',),

# class PySide2.QtGui.QTextFrameFormat:

# class PySide2.QtGui.QTextFrameFormat.BorderStyle:

# class PySide2.QtGui.QTextFrameFormat.Position:
    "PySide2.QtGui.QTextFrameFormat.__init__": [(), ('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextFrameFormat',)],
    "PySide2.QtGui.QTextFrameFormat.__copy__": (),
    "PySide2.QtGui.QTextFrameFormat.border": (),
    "PySide2.QtGui.QTextFrameFormat.borderBrush": (),
    "PySide2.QtGui.QTextFrameFormat.borderStyle": (),
    "PySide2.QtGui.QTextFrameFormat.bottomMargin": (),
    "PySide2.QtGui.QTextFrameFormat.height": (),
    "PySide2.QtGui.QTextFrameFormat.isValid": (),
    "PySide2.QtGui.QTextFrameFormat.leftMargin": (),
    "PySide2.QtGui.QTextFrameFormat.margin": (),
    "PySide2.QtGui.QTextFrameFormat.padding": (),
    "PySide2.QtGui.QTextFrameFormat.pageBreakPolicy": (),
    "PySide2.QtGui.QTextFrameFormat.position": (),
    "PySide2.QtGui.QTextFrameFormat.rightMargin": (),
    "PySide2.QtGui.QTextFrameFormat.setBorder": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setBorderBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextFrameFormat.setBorderStyle": ('PySide2.QtGui.QTextFrameFormat.BorderStyle',),
    "PySide2.QtGui.QTextFrameFormat.setBottomMargin": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setHeight": [('PySide2.QtGui.QTextLength',), ('float',)],
    "PySide2.QtGui.QTextFrameFormat.setLeftMargin": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setMargin": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setPadding": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setPageBreakPolicy": ('PySide2.QtGui.QTextFormat.PageBreakFlags',),
    "PySide2.QtGui.QTextFrameFormat.setPosition": ('PySide2.QtGui.QTextFrameFormat.Position',),
    "PySide2.QtGui.QTextFrameFormat.setRightMargin": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setTopMargin": ('float',),
    "PySide2.QtGui.QTextFrameFormat.setWidth": [('PySide2.QtGui.QTextLength',), ('float',)],
    "PySide2.QtGui.QTextFrameFormat.topMargin": (),
    "PySide2.QtGui.QTextFrameFormat.width": (),

# class PySide2.QtGui.QTextImageFormat:
    "PySide2.QtGui.QTextImageFormat.__init__": [(), ('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextImageFormat',)],
    "PySide2.QtGui.QTextImageFormat.__copy__": (),
    "PySide2.QtGui.QTextImageFormat.height": (),
    "PySide2.QtGui.QTextImageFormat.isValid": (),
    "PySide2.QtGui.QTextImageFormat.name": (),
    "PySide2.QtGui.QTextImageFormat.quality": (),
    "PySide2.QtGui.QTextImageFormat.setHeight": ('float',),
    "PySide2.QtGui.QTextImageFormat.setName": ('str',),
    "PySide2.QtGui.QTextImageFormat.setQuality": ('int',),
    "PySide2.QtGui.QTextImageFormat.setWidth": ('float',),
    "PySide2.QtGui.QTextImageFormat.width": (),

# class PySide2.QtGui.QTextInlineObject:
    "PySide2.QtGui.QTextInlineObject.__init__": (),
    "PySide2.QtGui.QTextInlineObject.__copy__": (),
    "PySide2.QtGui.QTextInlineObject.ascent": (),
    "PySide2.QtGui.QTextInlineObject.descent": (),
    "PySide2.QtGui.QTextInlineObject.format": (),
    "PySide2.QtGui.QTextInlineObject.formatIndex": (),
    "PySide2.QtGui.QTextInlineObject.height": (),
    "PySide2.QtGui.QTextInlineObject.isValid": (),
    "PySide2.QtGui.QTextInlineObject.rect": (),
    "PySide2.QtGui.QTextInlineObject.setAscent": ('float',),
    "PySide2.QtGui.QTextInlineObject.setDescent": ('float',),
    "PySide2.QtGui.QTextInlineObject.setWidth": ('float',),
    "PySide2.QtGui.QTextInlineObject.textDirection": (),
    "PySide2.QtGui.QTextInlineObject.textPosition": (),
    "PySide2.QtGui.QTextInlineObject.width": (),

# class PySide2.QtGui.QTextItem:

# class PySide2.QtGui.QTextItem.RenderFlag:

# class PySide2.QtGui.QTextItem.RenderFlags:
    "PySide2.QtGui.QTextItem.__init__": (),
    "PySide2.QtGui.QTextItem.ascent": (),
    "PySide2.QtGui.QTextItem.descent": (),
    "PySide2.QtGui.QTextItem.font": (),
    "PySide2.QtGui.QTextItem.renderFlags": (),
    "PySide2.QtGui.QTextItem.text": (),
    "PySide2.QtGui.QTextItem.width": (),

# class PySide2.QtGui.QTextLayout:

# class PySide2.QtGui.QTextLayout.CursorMode:

# class PySide2.QtGui.QTextLayout.FormatRange:
    "PySide2.QtGui.QTextLayout.FormatRange.__init__": [(), ('PySide2.QtGui.QTextLayout.FormatRange',)],
    "PySide2.QtGui.QTextLayout.FormatRange.__copy__": (),

    "PySide2.QtGui.QTextLayout.__init__": [(), ('PySide2.QtGui.QTextBlock',), ('str',), ('str', 'PySide2.QtGui.QFont', 'PySide2.QtGui.QPaintDevice')],
    "PySide2.QtGui.QTextLayout.additionalFormats": (),
    "PySide2.QtGui.QTextLayout.beginLayout": (),
    "PySide2.QtGui.QTextLayout.boundingRect": (),
    "PySide2.QtGui.QTextLayout.cacheEnabled": (),
    "PySide2.QtGui.QTextLayout.clearAdditionalFormats": (),
    "PySide2.QtGui.QTextLayout.clearFormats": (),
    "PySide2.QtGui.QTextLayout.clearLayout": (),
    "PySide2.QtGui.QTextLayout.createLine": (),
    "PySide2.QtGui.QTextLayout.cursorMoveStyle": (),
    "PySide2.QtGui.QTextLayout.draw": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QPointF', 'typing.List[PySide2.QtGui.QTextLayout.FormatRange]', 'PySide2.QtCore.QRectF'),
    "PySide2.QtGui.QTextLayout.drawCursor": [('PySide2.QtGui.QPainter', 'PySide2.QtCore.QPointF', 'int'), ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QPointF', 'int', 'int')],
    "PySide2.QtGui.QTextLayout.endLayout": (),
    "PySide2.QtGui.QTextLayout.font": (),
    "PySide2.QtGui.QTextLayout.formats": (),
    "PySide2.QtGui.QTextLayout.isValidCursorPosition": ('int',),
    "PySide2.QtGui.QTextLayout.leftCursorPosition": ('int',),
    "PySide2.QtGui.QTextLayout.lineAt": ('int',),
    "PySide2.QtGui.QTextLayout.lineCount": (),
    "PySide2.QtGui.QTextLayout.lineForTextPosition": ('int',),
    "PySide2.QtGui.QTextLayout.maximumWidth": (),
    "PySide2.QtGui.QTextLayout.minimumWidth": (),
    "PySide2.QtGui.QTextLayout.nextCursorPosition": ('int', 'PySide2.QtGui.QTextLayout.CursorMode'),
    "PySide2.QtGui.QTextLayout.position": (),
    "PySide2.QtGui.QTextLayout.preeditAreaPosition": (),
    "PySide2.QtGui.QTextLayout.preeditAreaText": (),
    "PySide2.QtGui.QTextLayout.previousCursorPosition": ('int', 'PySide2.QtGui.QTextLayout.CursorMode'),
    "PySide2.QtGui.QTextLayout.rightCursorPosition": ('int',),
    "PySide2.QtGui.QTextLayout.setAdditionalFormats": ('typing.Sequence[PySide2.QtGui.QTextLayout.FormatRange]',),
    "PySide2.QtGui.QTextLayout.setCacheEnabled": ('bool',),
    "PySide2.QtGui.QTextLayout.setCursorMoveStyle": ('PySide2.QtCore.Qt.CursorMoveStyle',),
    "PySide2.QtGui.QTextLayout.setFlags": ('int',),
    "PySide2.QtGui.QTextLayout.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtGui.QTextLayout.setFormats": ('typing.List[PySide2.QtGui.QTextLayout.FormatRange]',),
    "PySide2.QtGui.QTextLayout.setPosition": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTextLayout.setPreeditArea": ('int', 'str'),
    "PySide2.QtGui.QTextLayout.setRawFont": ('PySide2.QtGui.QRawFont',),
    "PySide2.QtGui.QTextLayout.setText": ('str',),
    "PySide2.QtGui.QTextLayout.setTextOption": ('PySide2.QtGui.QTextOption',),
    "PySide2.QtGui.QTextLayout.text": (),
    "PySide2.QtGui.QTextLayout.textOption": (),

# class PySide2.QtGui.QTextLength:

# class PySide2.QtGui.QTextLength.Type:
    "PySide2.QtGui.QTextLength.__init__": [(), ('PySide2.QtGui.QTextLength',), ('PySide2.QtGui.QTextLength.Type', 'float')],
    "PySide2.QtGui.QTextLength.__copy__": (),
    "PySide2.QtGui.QTextLength.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QTextLength.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QTextLength.rawValue": (),
    "PySide2.QtGui.QTextLength.type": (),
    "PySide2.QtGui.QTextLength.value": ('float',),

# class PySide2.QtGui.QTextLine:

# class PySide2.QtGui.QTextLine.CursorPosition:

# class PySide2.QtGui.QTextLine.Edge:
    "PySide2.QtGui.QTextLine.__init__": (),
    "PySide2.QtGui.QTextLine.__copy__": (),
    "PySide2.QtGui.QTextLine.ascent": (),
    "PySide2.QtGui.QTextLine.cursorToX": ('int', 'PySide2.QtGui.QTextLine.Edge'),
    "PySide2.QtGui.QTextLine.descent": (),
    "PySide2.QtGui.QTextLine.draw": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QPointF', 'PySide2.QtGui.QTextLayout.FormatRange'),
    "PySide2.QtGui.QTextLine.height": (),
    "PySide2.QtGui.QTextLine.horizontalAdvance": (),
    "PySide2.QtGui.QTextLine.isValid": (),
    "PySide2.QtGui.QTextLine.leading": (),
    "PySide2.QtGui.QTextLine.leadingIncluded": (),
    "PySide2.QtGui.QTextLine.lineNumber": (),
    "PySide2.QtGui.QTextLine.naturalTextRect": (),
    "PySide2.QtGui.QTextLine.naturalTextWidth": (),
    "PySide2.QtGui.QTextLine.position": (),
    "PySide2.QtGui.QTextLine.rect": (),
    "PySide2.QtGui.QTextLine.setLeadingIncluded": ('bool',),
    "PySide2.QtGui.QTextLine.setLineWidth": ('float',),
    "PySide2.QtGui.QTextLine.setNumColumns": [('int',), ('int', 'float')],
    "PySide2.QtGui.QTextLine.setPosition": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTextLine.textLength": (),
    "PySide2.QtGui.QTextLine.textStart": (),
    "PySide2.QtGui.QTextLine.width": (),
    "PySide2.QtGui.QTextLine.x": (),
    "PySide2.QtGui.QTextLine.xToCursor": ('float', 'PySide2.QtGui.QTextLine.CursorPosition'),
    "PySide2.QtGui.QTextLine.y": (),

# class PySide2.QtGui.QTextList:
    "PySide2.QtGui.QTextList.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QTextList.add": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QTextList.count": (),
    "PySide2.QtGui.QTextList.format": (),
    "PySide2.QtGui.QTextList.item": ('int',),
    "PySide2.QtGui.QTextList.itemNumber": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QTextList.itemText": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QTextList.remove": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtGui.QTextList.removeItem": ('int',),
    "PySide2.QtGui.QTextList.setFormat": [('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextListFormat',)],

# class PySide2.QtGui.QTextListFormat:

# class PySide2.QtGui.QTextListFormat.Style:
    "PySide2.QtGui.QTextListFormat.__init__": [(), ('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextListFormat',)],
    "PySide2.QtGui.QTextListFormat.__copy__": (),
    "PySide2.QtGui.QTextListFormat.indent": (),
    "PySide2.QtGui.QTextListFormat.isValid": (),
    "PySide2.QtGui.QTextListFormat.numberPrefix": (),
    "PySide2.QtGui.QTextListFormat.numberSuffix": (),
    "PySide2.QtGui.QTextListFormat.setIndent": ('int',),
    "PySide2.QtGui.QTextListFormat.setNumberPrefix": ('str',),
    "PySide2.QtGui.QTextListFormat.setNumberSuffix": ('str',),
    "PySide2.QtGui.QTextListFormat.setStyle": ('PySide2.QtGui.QTextListFormat.Style',),
    "PySide2.QtGui.QTextListFormat.style": (),

# class PySide2.QtGui.QTextObject:
    "PySide2.QtGui.QTextObject.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QTextObject.document": (),
    "PySide2.QtGui.QTextObject.format": (),
    "PySide2.QtGui.QTextObject.formatIndex": (),
    "PySide2.QtGui.QTextObject.objectIndex": (),
    "PySide2.QtGui.QTextObject.setFormat": ('PySide2.QtGui.QTextFormat',),

# class PySide2.QtGui.QTextObjectInterface:
    "PySide2.QtGui.QTextObjectInterface.__init__": (),
    "PySide2.QtGui.QTextObjectInterface.drawObject": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF', 'PySide2.QtGui.QTextDocument', 'int', 'PySide2.QtGui.QTextFormat'),
    "PySide2.QtGui.QTextObjectInterface.intrinsicSize": ('PySide2.QtGui.QTextDocument', 'int', 'PySide2.QtGui.QTextFormat'),

# class PySide2.QtGui.QTextOption:

# class PySide2.QtGui.QTextOption.Flag:

# class PySide2.QtGui.QTextOption.Flags:

# class PySide2.QtGui.QTextOption.Tab:
    "PySide2.QtGui.QTextOption.Tab.__init__": [(), ('PySide2.QtGui.QTextOption.Tab',), ('float', 'PySide2.QtGui.QTextOption.TabType', 'typing.Char')],
    "PySide2.QtGui.QTextOption.Tab.__copy__": (),

# class PySide2.QtGui.QTextOption.TabType:

# class PySide2.QtGui.QTextOption.WrapMode:

    "PySide2.QtGui.QTextOption.__init__": [(), ('PySide2.QtCore.Qt.Alignment',), ('PySide2.QtGui.QTextOption',)],
    "PySide2.QtGui.QTextOption.__copy__": (),
    "PySide2.QtGui.QTextOption.alignment": (),
    "PySide2.QtGui.QTextOption.flags": (),
    "PySide2.QtGui.QTextOption.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtGui.QTextOption.setFlags": ('PySide2.QtGui.QTextOption.Flags',),
    "PySide2.QtGui.QTextOption.setTabArray": ('typing.Sequence[float]',),
    "PySide2.QtGui.QTextOption.setTabStop": ('float',),
    "PySide2.QtGui.QTextOption.setTabStopDistance": ('float',),
    "PySide2.QtGui.QTextOption.setTabs": ('typing.Sequence[PySide2.QtGui.QTextOption.Tab]',),
    "PySide2.QtGui.QTextOption.setTextDirection": ('PySide2.QtCore.Qt.LayoutDirection',),
    "PySide2.QtGui.QTextOption.setUseDesignMetrics": ('bool',),
    "PySide2.QtGui.QTextOption.setWrapMode": ('PySide2.QtGui.QTextOption.WrapMode',),
    "PySide2.QtGui.QTextOption.tabArray": (),
    "PySide2.QtGui.QTextOption.tabStop": (),
    "PySide2.QtGui.QTextOption.tabStopDistance": (),
    "PySide2.QtGui.QTextOption.tabs": (),
    "PySide2.QtGui.QTextOption.textDirection": (),
    "PySide2.QtGui.QTextOption.useDesignMetrics": (),
    "PySide2.QtGui.QTextOption.wrapMode": (),

# class PySide2.QtGui.QTextTable:
    "PySide2.QtGui.QTextTable.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtGui.QTextTable.appendColumns": ('int',),
    "PySide2.QtGui.QTextTable.appendRows": ('int',),
    "PySide2.QtGui.QTextTable.cellAt": [('PySide2.QtGui.QTextCursor',), ('int',), ('int', 'int')],
    "PySide2.QtGui.QTextTable.columns": (),
    "PySide2.QtGui.QTextTable.format": (),
    "PySide2.QtGui.QTextTable.insertColumns": ('int', 'int'),
    "PySide2.QtGui.QTextTable.insertRows": ('int', 'int'),
    "PySide2.QtGui.QTextTable.mergeCells": [('PySide2.QtGui.QTextCursor',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QTextTable.removeColumns": ('int', 'int'),
    "PySide2.QtGui.QTextTable.removeRows": ('int', 'int'),
    "PySide2.QtGui.QTextTable.resize": ('int', 'int'),
    "PySide2.QtGui.QTextTable.rowEnd": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtGui.QTextTable.rowStart": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtGui.QTextTable.rows": (),
    "PySide2.QtGui.QTextTable.setFormat": [('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextTableFormat',)],
    "PySide2.QtGui.QTextTable.splitCell": ('int', 'int', 'int', 'int'),

# class PySide2.QtGui.QTextTableCell:
    "PySide2.QtGui.QTextTableCell.__init__": [(), ('PySide2.QtGui.QTextTableCell',)],
    "PySide2.QtGui.QTextTableCell.__copy__": (),
    "PySide2.QtGui.QTextTableCell.begin": (),
    "PySide2.QtGui.QTextTableCell.column": (),
    "PySide2.QtGui.QTextTableCell.columnSpan": (),
    "PySide2.QtGui.QTextTableCell.end": (),
    "PySide2.QtGui.QTextTableCell.firstCursorPosition": (),
    "PySide2.QtGui.QTextTableCell.firstPosition": (),
    "PySide2.QtGui.QTextTableCell.format": (),
    "PySide2.QtGui.QTextTableCell.isValid": (),
    "PySide2.QtGui.QTextTableCell.lastCursorPosition": (),
    "PySide2.QtGui.QTextTableCell.lastPosition": (),
    "PySide2.QtGui.QTextTableCell.row": (),
    "PySide2.QtGui.QTextTableCell.rowSpan": (),
    "PySide2.QtGui.QTextTableCell.setFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtGui.QTextTableCell.tableCellFormatIndex": (),

# class PySide2.QtGui.QTextTableCellFormat:
    "PySide2.QtGui.QTextTableCellFormat.__init__": [(), ('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextTableCellFormat',)],
    "PySide2.QtGui.QTextTableCellFormat.__copy__": (),
    "PySide2.QtGui.QTextTableCellFormat.bottomBorder": (),
    "PySide2.QtGui.QTextTableCellFormat.bottomBorderBrush": (),
    "PySide2.QtGui.QTextTableCellFormat.bottomBorderStyle": (),
    "PySide2.QtGui.QTextTableCellFormat.bottomPadding": (),
    "PySide2.QtGui.QTextTableCellFormat.isValid": (),
    "PySide2.QtGui.QTextTableCellFormat.leftBorder": (),
    "PySide2.QtGui.QTextTableCellFormat.leftBorderBrush": (),
    "PySide2.QtGui.QTextTableCellFormat.leftBorderStyle": (),
    "PySide2.QtGui.QTextTableCellFormat.leftPadding": (),
    "PySide2.QtGui.QTextTableCellFormat.rightBorder": (),
    "PySide2.QtGui.QTextTableCellFormat.rightBorderBrush": (),
    "PySide2.QtGui.QTextTableCellFormat.rightBorderStyle": (),
    "PySide2.QtGui.QTextTableCellFormat.rightPadding": (),
    "PySide2.QtGui.QTextTableCellFormat.setBorder": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setBorderBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextTableCellFormat.setBorderStyle": ('PySide2.QtGui.QTextFrameFormat.BorderStyle',),
    "PySide2.QtGui.QTextTableCellFormat.setBottomBorder": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setBottomBorderBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextTableCellFormat.setBottomBorderStyle": ('PySide2.QtGui.QTextFrameFormat.BorderStyle',),
    "PySide2.QtGui.QTextTableCellFormat.setBottomPadding": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setLeftBorder": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setLeftBorderBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextTableCellFormat.setLeftBorderStyle": ('PySide2.QtGui.QTextFrameFormat.BorderStyle',),
    "PySide2.QtGui.QTextTableCellFormat.setLeftPadding": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setPadding": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setRightBorder": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setRightBorderBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextTableCellFormat.setRightBorderStyle": ('PySide2.QtGui.QTextFrameFormat.BorderStyle',),
    "PySide2.QtGui.QTextTableCellFormat.setRightPadding": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setTopBorder": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.setTopBorderBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtGui.QTextTableCellFormat.setTopBorderStyle": ('PySide2.QtGui.QTextFrameFormat.BorderStyle',),
    "PySide2.QtGui.QTextTableCellFormat.setTopPadding": ('float',),
    "PySide2.QtGui.QTextTableCellFormat.topBorder": (),
    "PySide2.QtGui.QTextTableCellFormat.topBorderBrush": (),
    "PySide2.QtGui.QTextTableCellFormat.topBorderStyle": (),
    "PySide2.QtGui.QTextTableCellFormat.topPadding": (),

# class PySide2.QtGui.QTextTableFormat:
    "PySide2.QtGui.QTextTableFormat.__init__": [(), ('PySide2.QtGui.QTextFormat',), ('PySide2.QtGui.QTextTableFormat',)],
    "PySide2.QtGui.QTextTableFormat.__copy__": (),
    "PySide2.QtGui.QTextTableFormat.alignment": (),
    "PySide2.QtGui.QTextTableFormat.borderCollapse": (),
    "PySide2.QtGui.QTextTableFormat.cellPadding": (),
    "PySide2.QtGui.QTextTableFormat.cellSpacing": (),
    "PySide2.QtGui.QTextTableFormat.clearColumnWidthConstraints": (),
    "PySide2.QtGui.QTextTableFormat.columnWidthConstraints": (),
    "PySide2.QtGui.QTextTableFormat.columns": (),
    "PySide2.QtGui.QTextTableFormat.headerRowCount": (),
    "PySide2.QtGui.QTextTableFormat.isValid": (),
    "PySide2.QtGui.QTextTableFormat.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtGui.QTextTableFormat.setBorderCollapse": ('bool',),
    "PySide2.QtGui.QTextTableFormat.setCellPadding": ('float',),
    "PySide2.QtGui.QTextTableFormat.setCellSpacing": ('float',),
    "PySide2.QtGui.QTextTableFormat.setColumnWidthConstraints": ('typing.List[PySide2.QtGui.QTextLength]',),
    "PySide2.QtGui.QTextTableFormat.setColumns": ('int',),
    "PySide2.QtGui.QTextTableFormat.setHeaderRowCount": ('int',),

# class PySide2.QtGui.QToolBarChangeEvent:
    "PySide2.QtGui.QToolBarChangeEvent.__init__": ('bool',),
    "PySide2.QtGui.QToolBarChangeEvent.toggle": (),

# class PySide2.QtGui.QTouchDevice:

# class PySide2.QtGui.QTouchDevice.Capabilities:

# class PySide2.QtGui.QTouchDevice.CapabilityFlag:

# class PySide2.QtGui.QTouchDevice.DeviceType:
    "PySide2.QtGui.QTouchDevice.__init__": (),
    "PySide2.QtGui.QTouchDevice.capabilities": (),
    "PySide2.QtGui.QTouchDevice.devices": (),
    "PySide2.QtGui.QTouchDevice.maximumTouchPoints": (),
    "PySide2.QtGui.QTouchDevice.name": (),
    "PySide2.QtGui.QTouchDevice.setCapabilities": ('PySide2.QtGui.QTouchDevice.Capabilities',),
    "PySide2.QtGui.QTouchDevice.setMaximumTouchPoints": ('int',),
    "PySide2.QtGui.QTouchDevice.setName": ('str',),
    "PySide2.QtGui.QTouchDevice.setType": ('PySide2.QtGui.QTouchDevice.DeviceType',),
    "PySide2.QtGui.QTouchDevice.type": (),

# class PySide2.QtGui.QTouchEvent:

# class PySide2.QtGui.QTouchEvent.TouchPoint:

# class PySide2.QtGui.QTouchEvent.TouchPoint.InfoFlag:

# class PySide2.QtGui.QTouchEvent.TouchPoint.InfoFlags:
    "PySide2.QtGui.QTouchEvent.TouchPoint.__init__": [('PySide2.QtGui.QTouchEvent.TouchPoint',), ('int',)],
    "PySide2.QtGui.QTouchEvent.TouchPoint.__copy__": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.ellipseDiameters": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.flags": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.id": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.lastNormalizedPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.lastPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.lastScenePos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.lastScreenPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.normalizedPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.pos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.pressure": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.rawScreenPositions": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.rect": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.rotation": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.scenePos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.sceneRect": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.screenPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.screenRect": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setEllipseDiameters": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setFlags": ('PySide2.QtGui.QTouchEvent.TouchPoint.InfoFlags',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setId": ('int',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setLastNormalizedPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setLastPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setLastScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setLastScreenPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setNormalizedPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setPressure": ('float',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setRawScreenPositions": ('typing.List[PySide2.QtCore.QPointF]',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setRect": ('PySide2.QtCore.QRectF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setRotation": ('float',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setSceneRect": ('PySide2.QtCore.QRectF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setScreenPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setScreenRect": ('PySide2.QtCore.QRectF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setStartNormalizedPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setStartPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setStartScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setStartScreenPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setState": ('PySide2.QtCore.Qt.TouchPointStates',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setUniqueId": ('int',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.setVelocity": ('PySide2.QtGui.QVector2D',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.startNormalizedPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.startPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.startScenePos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.startScreenPos": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.state": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.swap": ('PySide2.QtGui.QTouchEvent.TouchPoint',),
    "PySide2.QtGui.QTouchEvent.TouchPoint.uniqueId": (),
    "PySide2.QtGui.QTouchEvent.TouchPoint.velocity": (),

    "PySide2.QtGui.QTouchEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'PySide2.QtGui.QTouchDevice', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.TouchPointStates', 'typing.Sequence[PySide2.QtGui.QTouchEvent.TouchPoint]'),
    "PySide2.QtGui.QTouchEvent.device": (),
    "PySide2.QtGui.QTouchEvent.setDevice": ('PySide2.QtGui.QTouchDevice',),
    "PySide2.QtGui.QTouchEvent.setTarget": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QTouchEvent.setTouchPointStates": ('PySide2.QtCore.Qt.TouchPointStates',),
    "PySide2.QtGui.QTouchEvent.setTouchPoints": ('typing.Sequence[PySide2.QtGui.QTouchEvent.TouchPoint]',),
    "PySide2.QtGui.QTouchEvent.setWindow": ('PySide2.QtGui.QWindow',),
    "PySide2.QtGui.QTouchEvent.target": (),
    "PySide2.QtGui.QTouchEvent.touchPointStates": (),
    "PySide2.QtGui.QTouchEvent.touchPoints": (),
    "PySide2.QtGui.QTouchEvent.window": (),

# class PySide2.QtGui.QTransform:

# class PySide2.QtGui.QTransform.TransformationType:
    "PySide2.QtGui.QTransform.__init__": [(), ('PySide2.QtGui.QMatrix',), ('PySide2.QtGui.QTransform',), ('float', 'float', 'float', 'float', 'float', 'float'), ('float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float')],
    "PySide2.QtGui.QTransform.__add__": ('float',),
    "PySide2.QtGui.QTransform.__copy__": (),
    "PySide2.QtGui.QTransform.__iadd__": ('float',),
    "PySide2.QtGui.QTransform.__imul__": [('PySide2.QtGui.QTransform',), ('float',)],
    "PySide2.QtGui.QTransform.__isub__": ('float',),
    "PySide2.QtGui.QTransform.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QTransform.__mul__": [('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QTransform',), ('float',)],
    "PySide2.QtGui.QTransform.__reduce__": (),
    "PySide2.QtGui.QTransform.__repr__": (),
    "PySide2.QtGui.QTransform.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QTransform.__sub__": ('float',),
    "PySide2.QtGui.QTransform.adjoint": (),
    "PySide2.QtGui.QTransform.det": (),
    "PySide2.QtGui.QTransform.determinant": (),
    "PySide2.QtGui.QTransform.dx": (),
    "PySide2.QtGui.QTransform.dy": (),
    "PySide2.QtGui.QTransform.fromScale": ('float', 'float'),
    "PySide2.QtGui.QTransform.fromTranslate": ('float', 'float'),
    "PySide2.QtGui.QTransform.inverted": (),
    "PySide2.QtGui.QTransform.isAffine": (),
    "PySide2.QtGui.QTransform.isIdentity": (),
    "PySide2.QtGui.QTransform.isInvertible": (),
    "PySide2.QtGui.QTransform.isRotating": (),
    "PySide2.QtGui.QTransform.isScaling": (),
    "PySide2.QtGui.QTransform.isTranslating": (),
    "PySide2.QtGui.QTransform.m11": (),
    "PySide2.QtGui.QTransform.m12": (),
    "PySide2.QtGui.QTransform.m13": (),
    "PySide2.QtGui.QTransform.m21": (),
    "PySide2.QtGui.QTransform.m22": (),
    "PySide2.QtGui.QTransform.m23": (),
    "PySide2.QtGui.QTransform.m31": (),
    "PySide2.QtGui.QTransform.m32": (),
    "PySide2.QtGui.QTransform.m33": (),
    "PySide2.QtGui.QTransform.map": [('PySide2.QtCore.QLine',), ('PySide2.QtCore.QLineF',), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygon',), ('PySide2.QtGui.QPolygonF',), ('PySide2.QtGui.QRegion',), ('float', 'float')],
    "PySide2.QtGui.QTransform.mapRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtGui.QTransform.mapToPolygon": ('PySide2.QtCore.QRect',),
    "PySide2.QtGui.QTransform.quadToQuad": [('PySide2.QtGui.QPolygonF', 'PySide2.QtGui.QPolygonF'), ('PySide2.QtGui.QPolygonF', 'PySide2.QtGui.QPolygonF', 'PySide2.QtGui.QTransform')],
    "PySide2.QtGui.QTransform.quadToSquare": [('PySide2.QtGui.QPolygonF',), ('PySide2.QtGui.QPolygonF', 'PySide2.QtGui.QTransform')],
    "PySide2.QtGui.QTransform.reset": (),
    "PySide2.QtGui.QTransform.rotate": ('float', 'PySide2.QtCore.Qt.Axis'),
    "PySide2.QtGui.QTransform.rotateRadians": ('float', 'PySide2.QtCore.Qt.Axis'),
    "PySide2.QtGui.QTransform.scale": ('float', 'float'),
    "PySide2.QtGui.QTransform.setMatrix": ('float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtGui.QTransform.shear": ('float', 'float'),
    "PySide2.QtGui.QTransform.squareToQuad": [('PySide2.QtGui.QPolygonF',), ('PySide2.QtGui.QPolygonF', 'PySide2.QtGui.QTransform')],
    "PySide2.QtGui.QTransform.toAffine": (),
    "PySide2.QtGui.QTransform.translate": ('float', 'float'),
    "PySide2.QtGui.QTransform.transposed": (),
    "PySide2.QtGui.QTransform.type": (),

# class PySide2.QtGui.QValidator:

# class PySide2.QtGui.QValidator.State:
    "PySide2.QtGui.QValidator.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtGui.QValidator.fixup": ('str',),
    "PySide2.QtGui.QValidator.locale": (),
    "PySide2.QtGui.QValidator.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtGui.QValidator.validate": ('str', 'int'),

# class PySide2.QtGui.QVector2D:
    "PySide2.QtGui.QVector2D.__init__": [(), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QVector3D',), ('PySide2.QtGui.QVector4D',), ('float', 'float')],
    "PySide2.QtGui.QVector2D.__add__": ('PySide2.QtGui.QVector2D',),
    "PySide2.QtGui.QVector2D.__copy__": (),
    "PySide2.QtGui.QVector2D.__iadd__": ('PySide2.QtGui.QVector2D',),
    "PySide2.QtGui.QVector2D.__imul__": [('PySide2.QtGui.QVector2D',), ('float',)],
    "PySide2.QtGui.QVector2D.__isub__": ('PySide2.QtGui.QVector2D',),
    "PySide2.QtGui.QVector2D.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QVector2D.__mul__": [('PySide2.QtGui.QVector2D',), ('float',)],
    "PySide2.QtGui.QVector2D.__neg__": (),
    "PySide2.QtGui.QVector2D.__reduce__": (),
    "PySide2.QtGui.QVector2D.__repr__": (),
    "PySide2.QtGui.QVector2D.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QVector2D.__sub__": ('PySide2.QtGui.QVector2D',),
    "PySide2.QtGui.QVector2D.distanceToLine": ('PySide2.QtGui.QVector2D', 'PySide2.QtGui.QVector2D'),
    "PySide2.QtGui.QVector2D.distanceToPoint": ('PySide2.QtGui.QVector2D',),
    "PySide2.QtGui.QVector2D.dotProduct": ('PySide2.QtGui.QVector2D', 'PySide2.QtGui.QVector2D'),
    "PySide2.QtGui.QVector2D.isNull": (),
    "PySide2.QtGui.QVector2D.length": (),
    "PySide2.QtGui.QVector2D.lengthSquared": (),
    "PySide2.QtGui.QVector2D.normalize": (),
    "PySide2.QtGui.QVector2D.normalized": (),
    "PySide2.QtGui.QVector2D.setX": ('float',),
    "PySide2.QtGui.QVector2D.setY": ('float',),
    "PySide2.QtGui.QVector2D.toPoint": (),
    "PySide2.QtGui.QVector2D.toPointF": (),
    "PySide2.QtGui.QVector2D.toTuple": (),
    "PySide2.QtGui.QVector2D.toVector3D": (),
    "PySide2.QtGui.QVector2D.toVector4D": (),
    "PySide2.QtGui.QVector2D.x": (),
    "PySide2.QtGui.QVector2D.y": (),

# class PySide2.QtGui.QVector3D:
    "PySide2.QtGui.QVector3D.__init__": [(), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QVector2D',), ('PySide2.QtGui.QVector2D', 'float'), ('PySide2.QtGui.QVector4D',), ('float', 'float', 'float')],
    "PySide2.QtGui.QVector3D.__add__": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QVector3D.__copy__": (),
    "PySide2.QtGui.QVector3D.__iadd__": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QVector3D.__imul__": [('PySide2.QtGui.QVector3D',), ('float',)],
    "PySide2.QtGui.QVector3D.__isub__": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QVector3D.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QVector3D.__mul__": [('PySide2.QtGui.QMatrix4x4',), ('PySide2.QtGui.QQuaternion',), ('PySide2.QtGui.QVector3D',), ('float',)],
    "PySide2.QtGui.QVector3D.__neg__": (),
    "PySide2.QtGui.QVector3D.__reduce__": (),
    "PySide2.QtGui.QVector3D.__repr__": (),
    "PySide2.QtGui.QVector3D.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QVector3D.__sub__": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QVector3D.crossProduct": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QVector3D.distanceToLine": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QVector3D.distanceToPlane": [('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'), ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D')],
    "PySide2.QtGui.QVector3D.distanceToPoint": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtGui.QVector3D.dotProduct": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.QtGui.QVector3D.isNull": (),
    "PySide2.QtGui.QVector3D.length": (),
    "PySide2.QtGui.QVector3D.lengthSquared": (),
    "PySide2.QtGui.QVector3D.normal": [('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'), ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D')],
    "PySide2.QtGui.QVector3D.normalize": (),
    "PySide2.QtGui.QVector3D.normalized": (),
    "PySide2.QtGui.QVector3D.project": ('PySide2.QtGui.QMatrix4x4', 'PySide2.QtGui.QMatrix4x4', 'PySide2.QtCore.QRect'),
    "PySide2.QtGui.QVector3D.setX": ('float',),
    "PySide2.QtGui.QVector3D.setY": ('float',),
    "PySide2.QtGui.QVector3D.setZ": ('float',),
    "PySide2.QtGui.QVector3D.toPoint": (),
    "PySide2.QtGui.QVector3D.toPointF": (),
    "PySide2.QtGui.QVector3D.toTuple": (),
    "PySide2.QtGui.QVector3D.toVector2D": (),
    "PySide2.QtGui.QVector3D.toVector4D": (),
    "PySide2.QtGui.QVector3D.unproject": ('PySide2.QtGui.QMatrix4x4', 'PySide2.QtGui.QMatrix4x4', 'PySide2.QtCore.QRect'),
    "PySide2.QtGui.QVector3D.x": (),
    "PySide2.QtGui.QVector3D.y": (),
    "PySide2.QtGui.QVector3D.z": (),

# class PySide2.QtGui.QVector4D:
    "PySide2.QtGui.QVector4D.__init__": [(), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QPointF',), ('PySide2.QtGui.QVector2D',), ('PySide2.QtGui.QVector2D', 'float', 'float'), ('PySide2.QtGui.QVector3D',), ('PySide2.QtGui.QVector3D', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtGui.QVector4D.__add__": ('PySide2.QtGui.QVector4D',),
    "PySide2.QtGui.QVector4D.__copy__": (),
    "PySide2.QtGui.QVector4D.__iadd__": ('PySide2.QtGui.QVector4D',),
    "PySide2.QtGui.QVector4D.__imul__": [('PySide2.QtGui.QVector4D',), ('float',)],
    "PySide2.QtGui.QVector4D.__isub__": ('PySide2.QtGui.QVector4D',),
    "PySide2.QtGui.QVector4D.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QVector4D.__mul__": [('PySide2.QtGui.QMatrix4x4',), ('PySide2.QtGui.QVector4D',), ('float',)],
    "PySide2.QtGui.QVector4D.__neg__": (),
    "PySide2.QtGui.QVector4D.__reduce__": (),
    "PySide2.QtGui.QVector4D.__repr__": (),
    "PySide2.QtGui.QVector4D.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtGui.QVector4D.__sub__": ('PySide2.QtGui.QVector4D',),
    "PySide2.QtGui.QVector4D.dotProduct": ('PySide2.QtGui.QVector4D', 'PySide2.QtGui.QVector4D'),
    "PySide2.QtGui.QVector4D.isNull": (),
    "PySide2.QtGui.QVector4D.length": (),
    "PySide2.QtGui.QVector4D.lengthSquared": (),
    "PySide2.QtGui.QVector4D.normalize": (),
    "PySide2.QtGui.QVector4D.normalized": (),
    "PySide2.QtGui.QVector4D.setW": ('float',),
    "PySide2.QtGui.QVector4D.setX": ('float',),
    "PySide2.QtGui.QVector4D.setY": ('float',),
    "PySide2.QtGui.QVector4D.setZ": ('float',),
    "PySide2.QtGui.QVector4D.toPoint": (),
    "PySide2.QtGui.QVector4D.toPointF": (),
    "PySide2.QtGui.QVector4D.toTuple": (),
    "PySide2.QtGui.QVector4D.toVector2D": (),
    "PySide2.QtGui.QVector4D.toVector2DAffine": (),
    "PySide2.QtGui.QVector4D.toVector3D": (),
    "PySide2.QtGui.QVector4D.toVector3DAffine": (),
    "PySide2.QtGui.QVector4D.w": (),
    "PySide2.QtGui.QVector4D.x": (),
    "PySide2.QtGui.QVector4D.y": (),
    "PySide2.QtGui.QVector4D.z": (),

# class PySide2.QtGui.QWhatsThisClickedEvent:
    "PySide2.QtGui.QWhatsThisClickedEvent.__init__": ('str',),
    "PySide2.QtGui.QWhatsThisClickedEvent.href": (),

# class PySide2.QtGui.QWheelEvent:
    "PySide2.QtGui.QWheelEvent.__init__": [('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.ScrollPhase', 'bool', 'PySide2.QtCore.Qt.MouseEventSource'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint', 'int', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint', 'int', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.ScrollPhase'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint', 'int', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.ScrollPhase', 'PySide2.QtCore.Qt.MouseEventSource'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'PySide2.QtCore.QPoint', 'PySide2.QtCore.QPoint', 'int', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.ScrollPhase', 'PySide2.QtCore.Qt.MouseEventSource', 'bool'), ('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF', 'int', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.Orientation'), ('PySide2.QtCore.QPointF', 'int', 'PySide2.QtCore.Qt.MouseButtons', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.Qt.Orientation')],
    "PySide2.QtGui.QWheelEvent.angleDelta": (),
    "PySide2.QtGui.QWheelEvent.buttons": (),
    "PySide2.QtGui.QWheelEvent.delta": (),
    "PySide2.QtGui.QWheelEvent.globalPos": (),
    "PySide2.QtGui.QWheelEvent.globalPosF": (),
    "PySide2.QtGui.QWheelEvent.globalPosition": (),
    "PySide2.QtGui.QWheelEvent.globalX": (),
    "PySide2.QtGui.QWheelEvent.global""Y": (),
    "PySide2.QtGui.QWheelEvent.inverted": (),
    "PySide2.QtGui.QWheelEvent.orientation": (),
    "PySide2.QtGui.QWheelEvent.phase": (),
    "PySide2.QtGui.QWheelEvent.pixelDelta": (),
    "PySide2.QtGui.QWheelEvent.pos": (),
    "PySide2.QtGui.QWheelEvent.posF": (),
    "PySide2.QtGui.QWheelEvent.position": (),
    "PySide2.QtGui.QWheelEvent.source": (),
    "PySide2.QtGui.QWheelEvent.x": (),
    "PySide2.QtGui.QWheelEvent.y": (),

# class PySide2.QtGui.QWindow:

# class PySide2.QtGui.QWindow.AncestorMode:

# class PySide2.QtGui.QWindow.Visibility:
    "PySide2.QtGui.QWindow.__init__": [('PySide2.QtGui.QScreen',), ('PySide2.QtGui.QWindow',)],
    "PySide2.QtGui.QWindow.accessibleRoot": (),
    "PySide2.QtGui.QWindow.alert": ('int',),
    "PySide2.QtGui.QWindow.baseSize": (),
    "PySide2.QtGui.QWindow.close": (),
    "PySide2.QtGui.QWindow.contentOrientation": (),
    "PySide2.QtGui.QWindow.create": (),
    "PySide2.QtGui.QWindow.cursor": (),
    "PySide2.QtGui.QWindow.destroy": (),
    "PySide2.QtGui.QWindow.devicePixelRatio": (),
    "PySide2.QtGui.QWindow.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtGui.QWindow.exposeEvent": ('PySide2.QtGui.QExposeEvent',),
    "PySide2.QtGui.QWindow.filePath": (),
    "PySide2.QtGui.QWindow.flags": (),
    "PySide2.QtGui.QWindow.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtGui.QWindow.focusObject": (),
    "PySide2.QtGui.QWindow.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtGui.QWindow.format": (),
    "PySide2.QtGui.QWindow.frameGeometry": (),
    "PySide2.QtGui.QWindow.frameMargins": (),
    "PySide2.QtGui.QWindow.framePosition": (),
    "PySide2.QtGui.QWindow.fromWinId": ('int',),
    "PySide2.QtGui.QWindow.geometry": (),
    "PySide2.QtGui.QWindow.height": (),
    "PySide2.QtGui.QWindow.hide": (),
    "PySide2.QtGui.QWindow.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtGui.QWindow.icon": (),
    "PySide2.QtGui.QWindow.isActive": (),
    "PySide2.QtGui.QWindow.isAncestorOf": ('PySide2.QtGui.QWindow', 'PySide2.QtGui.QWindow.AncestorMode'),
    "PySide2.QtGui.QWindow.isExposed": (),
    "PySide2.QtGui.QWindow.isModal": (),
    "PySide2.QtGui.QWindow.isTopLevel": (),
    "PySide2.QtGui.QWindow.isVisible": (),
    "PySide2.QtGui.QWindow.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtGui.QWindow.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtGui.QWindow.lower": (),
    "PySide2.QtGui.QWindow.mapFromGlobal": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QWindow.mapToGlobal": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QWindow.mask": (),
    "PySide2.QtGui.QWindow.maximumHeight": (),
    "PySide2.QtGui.QWindow.maximumSize": (),
    "PySide2.QtGui.QWindow.maximumWidth": (),
    "PySide2.QtGui.QWindow.minimumHeight": (),
    "PySide2.QtGui.QWindow.minimumSize": (),
    "PySide2.QtGui.QWindow.minimumWidth": (),
    "PySide2.QtGui.QWindow.modality": (),
    "PySide2.QtGui.QWindow.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtGui.QWindow.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtGui.QWindow.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtGui.QWindow.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtGui.QWindow.moveEvent": ('PySide2.QtGui.QMoveEvent',),
    "PySide2.QtGui.QWindow.nativeEvent": ('PySide2.QtCore.QByteArray', 'int'),
    "PySide2.QtGui.QWindow.opacity": (),
    "PySide2.QtGui.QWindow.parent": [(), ('PySide2.QtGui.QWindow.AncestorMode',)],
    "PySide2.QtGui.QWindow.position": (),
    "PySide2.QtGui.QWindow.raise_": (),
    "PySide2.QtGui.QWindow.reportContentOrientationChange": ('PySide2.QtCore.Qt.ScreenOrientation',),
    "PySide2.QtGui.QWindow.requestActivate": (),
    "PySide2.QtGui.QWindow.requestUpdate": (),
    "PySide2.QtGui.QWindow.requestedFormat": (),
    "PySide2.QtGui.QWindow.resize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtGui.QWindow.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtGui.QWindow.screen": (),
    "PySide2.QtGui.QWindow.setBaseSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QWindow.setCursor": ('PySide2.QtGui.QCursor',),
    "PySide2.QtGui.QWindow.setFilePath": ('str',),
    "PySide2.QtGui.QWindow.setFlag": ('PySide2.QtCore.Qt.WindowType', 'bool'),
    "PySide2.QtGui.QWindow.setFlags": ('PySide2.QtCore.Qt.WindowFlags',),
    "PySide2.QtGui.QWindow.setFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtGui.QWindow.setFramePosition": ('PySide2.QtCore.QPoint',),
    "PySide2.QtGui.QWindow.setGeometry": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtGui.QWindow.setHeight": ('int',),
    "PySide2.QtGui.QWindow.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtGui.QWindow.setKeyboardGrabEnabled": ('bool',),
    "PySide2.QtGui.QWindow.setMask": ('PySide2.QtGui.QRegion',),
    "PySide2.QtGui.QWindow.setMaximumHeight": ('int',),
    "PySide2.QtGui.QWindow.setMaximumSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QWindow.setMaximumWidth": ('int',),
    "PySide2.QtGui.QWindow.setMinimumHeight": ('int',),
    "PySide2.QtGui.QWindow.setMinimumSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QWindow.setMinimumWidth": ('int',),
    "PySide2.QtGui.QWindow.setModality": ('PySide2.QtCore.Qt.WindowModality',),
    "PySide2.QtGui.QWindow.setMouseGrabEnabled": ('bool',),
    "PySide2.QtGui.QWindow.setOpacity": ('float',),
    "PySide2.QtGui.QWindow.setParent": ('PySide2.QtGui.QWindow',),
    "PySide2.QtGui.QWindow.setPosition": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtGui.QWindow.setScreen": ('PySide2.QtGui.QScreen',),
    "PySide2.QtGui.QWindow.setSizeIncrement": ('PySide2.QtCore.QSize',),
    "PySide2.QtGui.QWindow.setSurfaceType": ('PySide2.QtGui.QSurface.SurfaceType',),
    "PySide2.QtGui.QWindow.setTitle": ('str',),
    "PySide2.QtGui.QWindow.setTransientParent": ('PySide2.QtGui.QWindow',),
    "PySide2.QtGui.QWindow.setVisibility": ('PySide2.QtGui.QWindow.Visibility',),
    "PySide2.QtGui.QWindow.setVisible": ('bool',),
    "PySide2.QtGui.QWindow.setWidth": ('int',),
    "PySide2.QtGui.QWindow.setWindowState": ('PySide2.QtCore.Qt.WindowState',),
    "PySide2.QtGui.QWindow.setWindowStates": ('PySide2.QtCore.Qt.WindowStates',),
    "PySide2.QtGui.QWindow.setX": ('int',),
    "PySide2.QtGui.QWindow.setY": ('int',),
    "PySide2.QtGui.QWindow.show": (),
    "PySide2.QtGui.QWindow.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtGui.QWindow.showFullScreen": (),
    "PySide2.QtGui.QWindow.showMaximized": (),
    "PySide2.QtGui.QWindow.showMinimized": (),
    "PySide2.QtGui.QWindow.showNormal": (),
    "PySide2.QtGui.QWindow.size": (),
    "PySide2.QtGui.QWindow.sizeIncrement": (),
    "PySide2.QtGui.QWindow.surfaceHandle": (),
    "PySide2.QtGui.QWindow.surfaceType": (),
    "PySide2.QtGui.QWindow.tabletEvent": ('PySide2.QtGui.QTabletEvent',),
    "PySide2.QtGui.QWindow.title": (),
    "PySide2.QtGui.QWindow.touchEvent": ('PySide2.QtGui.QTouchEvent',),
    "PySide2.QtGui.QWindow.transientParent": (),
    "PySide2.QtGui.QWindow.type": (),
    "PySide2.QtGui.QWindow.unsetCursor": (),
    "PySide2.QtGui.QWindow.visibility": (),
    "PySide2.QtGui.QWindow.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtGui.QWindow.width": (),
    "PySide2.QtGui.QWindow.winId": (),
    "PySide2.QtGui.QWindow.windowState": (),
    "PySide2.QtGui.QWindow.windowStates": (),
    "PySide2.QtGui.QWindow.x": (),
    "PySide2.QtGui.QWindow.y": (),

# class PySide2.QtGui.QWindowStateChangeEvent:
    "PySide2.QtGui.QWindowStateChangeEvent.__init__": ('PySide2.QtCore.Qt.WindowStates', 'bool'),
    "PySide2.QtGui.QWindowStateChangeEvent.isOverride": (),
    "PySide2.QtGui.QWindowStateChangeEvent.oldState": (),

# class PySide2.QtGui.Qt:
    "PySide2.QtGui.Qt.codecForHtml": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtGui.Qt.convertFromPlainText": ('str', 'PySide2.QtCore.Qt.WhiteSpaceMode'),
    "PySide2.QtGui.Qt.mightBeRichText": ('str',),

    "PySide2.QtGui.Qt.qAlpha": ('int',),
    "PySide2.QtGui.Qt.qBlue": ('int',),
    "PySide2.QtGui.Qt.qGray": [('int',), ('int', 'int', 'int')],
    "PySide2.QtGui.Qt.qGreen": ('int',),
    "PySide2.QtGui.Qt.qIsGray": ('int',),
    "PySide2.QtGui.Qt.qRed": ('int',),
    "PySide2.QtGui.Qt.qRgb": ('int', 'int', 'int'),
    "PySide2.QtGui.Qt.qRgba": ('int', 'int', 'int', 'int'),
    }) if "PySide2.QtGui" in sys.modules else None

# Module PySide2.QtWidgets
sig_dict.update({

# class PySide2.QtWidgets.QAbstractButton:
    "PySide2.QtWidgets.QAbstractButton.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractButton.animateClick": ('int',),
    "PySide2.QtWidgets.QAbstractButton.autoExclusive": (),
    "PySide2.QtWidgets.QAbstractButton.autoRepeat": (),
    "PySide2.QtWidgets.QAbstractButton.autoRepeatDelay": (),
    "PySide2.QtWidgets.QAbstractButton.autoRepeatInterval": (),
    "PySide2.QtWidgets.QAbstractButton.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractButton.checkStateSet": (),
    "PySide2.QtWidgets.QAbstractButton.click": (),
    "PySide2.QtWidgets.QAbstractButton.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractButton.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QAbstractButton.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QAbstractButton.group": (),
    "PySide2.QtWidgets.QAbstractButton.hitButton": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QAbstractButton.icon": (),
    "PySide2.QtWidgets.QAbstractButton.iconSize": (),
    "PySide2.QtWidgets.QAbstractButton.isCheckable": (),
    "PySide2.QtWidgets.QAbstractButton.isChecked": (),
    "PySide2.QtWidgets.QAbstractButton.isDown": (),
    "PySide2.QtWidgets.QAbstractButton.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractButton.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractButton.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractButton.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractButton.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractButton.nextCheckState": (),
    "PySide2.QtWidgets.QAbstractButton.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QAbstractButton.setAutoExclusive": ('bool',),
    "PySide2.QtWidgets.QAbstractButton.setAutoRepeat": ('bool',),
    "PySide2.QtWidgets.QAbstractButton.setAutoRepeatDelay": ('int',),
    "PySide2.QtWidgets.QAbstractButton.setAutoRepeatInterval": ('int',),
    "PySide2.QtWidgets.QAbstractButton.setCheckable": ('bool',),
    "PySide2.QtWidgets.QAbstractButton.setChecked": ('bool',),
    "PySide2.QtWidgets.QAbstractButton.setDown": ('bool',),
    "PySide2.QtWidgets.QAbstractButton.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QAbstractButton.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QAbstractButton.setShortcut": ('PySide2.QtGui.QKeySequence',),
    "PySide2.QtWidgets.QAbstractButton.setText": ('str',),
    "PySide2.QtWidgets.QAbstractButton.shortcut": (),
    "PySide2.QtWidgets.QAbstractButton.text": (),
    "PySide2.QtWidgets.QAbstractButton.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QAbstractButton.toggle": (),

# class PySide2.QtWidgets.QAbstractGraphicsShapeItem:
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.__init__": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.brush": (),
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.opaqueArea": (),
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.pen": (),
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QAbstractGraphicsShapeItem.setPen": ('PySide2.QtGui.QPen',),

# class PySide2.QtWidgets.QAbstractItemDelegate:

# class PySide2.QtWidgets.QAbstractItemDelegate.EndEditHint:
    "PySide2.QtWidgets.QAbstractItemDelegate.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QAbstractItemDelegate.createEditor": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.destroyEditor": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.editorEvent": ('PySide2.QtCore.QEvent', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.elidedText": ('PySide2.QtGui.QFontMetrics', 'int', 'PySide2.QtCore.Qt.TextElideMode', 'str'),
    "PySide2.QtWidgets.QAbstractItemDelegate.helpEvent": ('PySide2.QtGui.QHelpEvent', 'PySide2.QtWidgets.QAbstractItemView', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.paintingRoles": (),
    "PySide2.QtWidgets.QAbstractItemDelegate.setEditorData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.setModelData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.sizeHint": ('PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemDelegate.updateEditorGeometry": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtWidgets.QAbstractItemView:

# class PySide2.QtWidgets.QAbstractItemView.CursorAction:

# class PySide2.QtWidgets.QAbstractItemView.DragDropMode:

# class PySide2.QtWidgets.QAbstractItemView.DropIndicatorPosition:

# class PySide2.QtWidgets.QAbstractItemView.EditTrigger:

# class PySide2.QtWidgets.QAbstractItemView.EditTriggers:

# class PySide2.QtWidgets.QAbstractItemView.ScrollHint:

# class PySide2.QtWidgets.QAbstractItemView.ScrollMode:

# class PySide2.QtWidgets.QAbstractItemView.SelectionBehavior:

# class PySide2.QtWidgets.QAbstractItemView.SelectionMode:

# class PySide2.QtWidgets.QAbstractItemView.State:
    "PySide2.QtWidgets.QAbstractItemView.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractItemView.alternatingRowColors": (),
    "PySide2.QtWidgets.QAbstractItemView.autoScrollMargin": (),
    "PySide2.QtWidgets.QAbstractItemView.clearSelection": (),
    "PySide2.QtWidgets.QAbstractItemView.closeEditor": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QAbstractItemDelegate.EndEditHint'),
    "PySide2.QtWidgets.QAbstractItemView.closePersistentEditor": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.commitData": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractItemView.currentChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QAbstractItemView.currentIndex": (),
    "PySide2.QtWidgets.QAbstractItemView.dataChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex', 'typing.List[int]'),
    "PySide2.QtWidgets.QAbstractItemView.defaultDropAction": (),
    "PySide2.QtWidgets.QAbstractItemView.dirtyRegionOffset": (),
    "PySide2.QtWidgets.QAbstractItemView.doAutoScroll": (),
    "PySide2.QtWidgets.QAbstractItemView.doItemsLayout": (),
    "PySide2.QtWidgets.QAbstractItemView.dragDropMode": (),
    "PySide2.QtWidgets.QAbstractItemView.dragDropOverwriteMode": (),
    "PySide2.QtWidgets.QAbstractItemView.dragEnabled": (),
    "PySide2.QtWidgets.QAbstractItemView.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QAbstractItemView.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QAbstractItemView.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QAbstractItemView.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QAbstractItemView.dropIndicatorPosition": (),
    "PySide2.QtWidgets.QAbstractItemView.edit": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.EditTrigger', 'PySide2.QtCore.QEvent')],
    "PySide2.QtWidgets.QAbstractItemView.editTriggers": (),
    "PySide2.QtWidgets.QAbstractItemView.editorDestroyed": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QAbstractItemView.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractItemView.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QAbstractItemView.executeDelayedItemsLayout": (),
    "PySide2.QtWidgets.QAbstractItemView.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QAbstractItemView.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QAbstractItemView.hasAutoScroll": (),
    "PySide2.QtWidgets.QAbstractItemView.horizontalOffset": (),
    "PySide2.QtWidgets.QAbstractItemView.horizontalScrollMode": (),
    "PySide2.QtWidgets.QAbstractItemView.horizontalScrollbarAction": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.horizontalScrollbarValueChanged": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.horizontalStepsPerItem": (),
    "PySide2.QtWidgets.QAbstractItemView.iconSize": (),
    "PySide2.QtWidgets.QAbstractItemView.indexAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QAbstractItemView.indexWidget": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QAbstractItemView.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QAbstractItemView.isIndexHidden": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.isPersistentEditorOpen": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.itemDelegate": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtWidgets.QAbstractItemView.itemDelegateForColumn": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.itemDelegateForRow": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractItemView.keyboardSearch": ('str',),
    "PySide2.QtWidgets.QAbstractItemView.model": (),
    "PySide2.QtWidgets.QAbstractItemView.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractItemView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractItemView.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractItemView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractItemView.moveCursor": ('PySide2.QtWidgets.QAbstractItemView.CursorAction', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtWidgets.QAbstractItemView.openPersistentEditor": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.reset": (),
    "PySide2.QtWidgets.QAbstractItemView.resetHorizontalScrollMode": (),
    "PySide2.QtWidgets.QAbstractItemView.resetVerticalScrollMode": (),
    "PySide2.QtWidgets.QAbstractItemView.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QAbstractItemView.rootIndex": (),
    "PySide2.QtWidgets.QAbstractItemView.rowsAboutToBeRemoved": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QAbstractItemView.rowsInserted": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QAbstractItemView.scheduleDelayedItemsLayout": (),
    "PySide2.QtWidgets.QAbstractItemView.scrollDirtyRegion": ('int', 'int'),
    "PySide2.QtWidgets.QAbstractItemView.scrollTo": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QAbstractItemView.scrollToBottom": (),
    "PySide2.QtWidgets.QAbstractItemView.scrollToTop": (),
    "PySide2.QtWidgets.QAbstractItemView.selectAll": (),
    "PySide2.QtWidgets.QAbstractItemView.selectedIndexes": (),
    "PySide2.QtWidgets.QAbstractItemView.selectionBehavior": (),
    "PySide2.QtWidgets.QAbstractItemView.selectionChanged": ('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelection'),
    "PySide2.QtWidgets.QAbstractItemView.selectionCommand": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QAbstractItemView.selectionMode": (),
    "PySide2.QtWidgets.QAbstractItemView.selectionModel": (),
    "PySide2.QtWidgets.QAbstractItemView.setAlternatingRowColors": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.setAutoScroll": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.setAutoScrollMargin": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.setCurrentIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.setDefaultDropAction": ('PySide2.QtCore.Qt.DropAction',),
    "PySide2.QtWidgets.QAbstractItemView.setDirtyRegion": ('PySide2.QtGui.QRegion',),
    "PySide2.QtWidgets.QAbstractItemView.setDragDropMode": ('PySide2.QtWidgets.QAbstractItemView.DragDropMode',),
    "PySide2.QtWidgets.QAbstractItemView.setDragDropOverwriteMode": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.setDragEnabled": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.setDropIndicatorShown": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.setEditTriggers": ('PySide2.QtWidgets.QAbstractItemView.EditTriggers',),
    "PySide2.QtWidgets.QAbstractItemView.setHorizontalScrollMode": ('PySide2.QtWidgets.QAbstractItemView.ScrollMode',),
    "PySide2.QtWidgets.QAbstractItemView.setHorizontalStepsPerItem": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QAbstractItemView.setIndexWidget": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QAbstractItemView.setItemDelegate": ('PySide2.QtWidgets.QAbstractItemDelegate',),
    "PySide2.QtWidgets.QAbstractItemView.setItemDelegateForColumn": ('int', 'PySide2.QtWidgets.QAbstractItemDelegate'),
    "PySide2.QtWidgets.QAbstractItemView.setItemDelegateForRow": ('int', 'PySide2.QtWidgets.QAbstractItemDelegate'),
    "PySide2.QtWidgets.QAbstractItemView.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QAbstractItemView.setRootIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.setSelection": ('PySide2.QtCore.QRect', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtWidgets.QAbstractItemView.setSelectionBehavior": ('PySide2.QtWidgets.QAbstractItemView.SelectionBehavior',),
    "PySide2.QtWidgets.QAbstractItemView.setSelectionMode": ('PySide2.QtWidgets.QAbstractItemView.SelectionMode',),
    "PySide2.QtWidgets.QAbstractItemView.setSelectionModel": ('PySide2.QtCore.QItemSelectionModel',),
    "PySide2.QtWidgets.QAbstractItemView.setState": ('PySide2.QtWidgets.QAbstractItemView.State',),
    "PySide2.QtWidgets.QAbstractItemView.setTabKeyNavigation": ('bool',),
    "PySide2.QtWidgets.QAbstractItemView.setTextElideMode": ('PySide2.QtCore.Qt.TextElideMode',),
    "PySide2.QtWidgets.QAbstractItemView.setVerticalScrollMode": ('PySide2.QtWidgets.QAbstractItemView.ScrollMode',),
    "PySide2.QtWidgets.QAbstractItemView.setVerticalStepsPerItem": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.showDropIndicator": (),
    "PySide2.QtWidgets.QAbstractItemView.sizeHintForColumn": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.sizeHintForIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.sizeHintForRow": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.startAutoScroll": (),
    "PySide2.QtWidgets.QAbstractItemView.startDrag": ('PySide2.QtCore.Qt.DropActions',),
    "PySide2.QtWidgets.QAbstractItemView.state": (),
    "PySide2.QtWidgets.QAbstractItemView.stopAutoScroll": (),
    "PySide2.QtWidgets.QAbstractItemView.tabKeyNavigation": (),
    "PySide2.QtWidgets.QAbstractItemView.textElideMode": (),
    "PySide2.QtWidgets.QAbstractItemView.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QAbstractItemView.update": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtWidgets.QAbstractItemView.updateEditorData": (),
    "PySide2.QtWidgets.QAbstractItemView.updateEditorGeometries": (),
    "PySide2.QtWidgets.QAbstractItemView.updateGeometries": (),
    "PySide2.QtWidgets.QAbstractItemView.verticalOffset": (),
    "PySide2.QtWidgets.QAbstractItemView.verticalScrollMode": (),
    "PySide2.QtWidgets.QAbstractItemView.verticalScrollbarAction": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.verticalScrollbarValueChanged": ('int',),
    "PySide2.QtWidgets.QAbstractItemView.verticalStepsPerItem": (),
    "PySide2.QtWidgets.QAbstractItemView.viewOptions": (),
    "PySide2.QtWidgets.QAbstractItemView.viewportEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractItemView.viewportSizeHint": (),
    "PySide2.QtWidgets.QAbstractItemView.visualRect": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QAbstractItemView.visualRegionForSelection": ('PySide2.QtCore.QItemSelection',),

# class PySide2.QtWidgets.QAbstractScrollArea:

# class PySide2.QtWidgets.QAbstractScrollArea.SizeAdjustPolicy:
    "PySide2.QtWidgets.QAbstractScrollArea.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractScrollArea.addScrollBarWidget": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QAbstractScrollArea.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.cornerWidget": (),
    "PySide2.QtWidgets.QAbstractScrollArea.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QAbstractScrollArea.horizontalScrollBar": (),
    "PySide2.QtWidgets.QAbstractScrollArea.horizontalScrollBarPolicy": (),
    "PySide2.QtWidgets.QAbstractScrollArea.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.maximumViewportSize": (),
    "PySide2.QtWidgets.QAbstractScrollArea.minimumSizeHint": (),
    "PySide2.QtWidgets.QAbstractScrollArea.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.scrollBarWidgets": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QAbstractScrollArea.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QAbstractScrollArea.setCornerWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractScrollArea.setHorizontalScrollBar": ('PySide2.QtWidgets.QScrollBar',),
    "PySide2.QtWidgets.QAbstractScrollArea.setHorizontalScrollBarPolicy": ('PySide2.QtCore.Qt.ScrollBarPolicy',),
    "PySide2.QtWidgets.QAbstractScrollArea.setSizeAdjustPolicy": ('PySide2.QtWidgets.QAbstractScrollArea.SizeAdjustPolicy',),
    "PySide2.QtWidgets.QAbstractScrollArea.setVerticalScrollBar": ('PySide2.QtWidgets.QScrollBar',),
    "PySide2.QtWidgets.QAbstractScrollArea.setVerticalScrollBarPolicy": ('PySide2.QtCore.Qt.ScrollBarPolicy',),
    "PySide2.QtWidgets.QAbstractScrollArea.setViewport": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractScrollArea.setViewportMargins": [('PySide2.QtCore.QMargins',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QAbstractScrollArea.setupViewport": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractScrollArea.sizeAdjustPolicy": (),
    "PySide2.QtWidgets.QAbstractScrollArea.sizeHint": (),
    "PySide2.QtWidgets.QAbstractScrollArea.verticalScrollBar": (),
    "PySide2.QtWidgets.QAbstractScrollArea.verticalScrollBarPolicy": (),
    "PySide2.QtWidgets.QAbstractScrollArea.viewport": (),
    "PySide2.QtWidgets.QAbstractScrollArea.viewportEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractScrollArea.viewportMargins": (),
    "PySide2.QtWidgets.QAbstractScrollArea.viewportSizeHint": (),
    "PySide2.QtWidgets.QAbstractScrollArea.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QAbstractSlider:

# class PySide2.QtWidgets.QAbstractSlider.SliderAction:

# class PySide2.QtWidgets.QAbstractSlider.SliderChange:
    "PySide2.QtWidgets.QAbstractSlider.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractSlider.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractSlider.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractSlider.hasTracking": (),
    "PySide2.QtWidgets.QAbstractSlider.invertedAppearance": (),
    "PySide2.QtWidgets.QAbstractSlider.invertedControls": (),
    "PySide2.QtWidgets.QAbstractSlider.isSliderDown": (),
    "PySide2.QtWidgets.QAbstractSlider.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractSlider.maximum": (),
    "PySide2.QtWidgets.QAbstractSlider.minimum": (),
    "PySide2.QtWidgets.QAbstractSlider.orientation": (),
    "PySide2.QtWidgets.QAbstractSlider.pageStep": (),
    "PySide2.QtWidgets.QAbstractSlider.repeatAction": (),
    "PySide2.QtWidgets.QAbstractSlider.setInvertedAppearance": ('bool',),
    "PySide2.QtWidgets.QAbstractSlider.setInvertedControls": ('bool',),
    "PySide2.QtWidgets.QAbstractSlider.setMaximum": ('int',),
    "PySide2.QtWidgets.QAbstractSlider.setMinimum": ('int',),
    "PySide2.QtWidgets.QAbstractSlider.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QAbstractSlider.setPageStep": ('int',),
    "PySide2.QtWidgets.QAbstractSlider.setRange": ('int', 'int'),
    "PySide2.QtWidgets.QAbstractSlider.setRepeatAction": ('PySide2.QtWidgets.QAbstractSlider.SliderAction', 'int', 'int'),
    "PySide2.QtWidgets.QAbstractSlider.setSingleStep": ('int',),
    "PySide2.QtWidgets.QAbstractSlider.setSliderDown": ('bool',),
    "PySide2.QtWidgets.QAbstractSlider.setSliderPosition": ('int',),
    "PySide2.QtWidgets.QAbstractSlider.setTracking": ('bool',),
    "PySide2.QtWidgets.QAbstractSlider.setValue": ('int',),
    "PySide2.QtWidgets.QAbstractSlider.singleStep": (),
    "PySide2.QtWidgets.QAbstractSlider.sliderChange": ('PySide2.QtWidgets.QAbstractSlider.SliderChange',),
    "PySide2.QtWidgets.QAbstractSlider.sliderPosition": (),
    "PySide2.QtWidgets.QAbstractSlider.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QAbstractSlider.triggerAction": ('PySide2.QtWidgets.QAbstractSlider.SliderAction',),
    "PySide2.QtWidgets.QAbstractSlider.value": (),
    "PySide2.QtWidgets.QAbstractSlider.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QAbstractSpinBox:

# class PySide2.QtWidgets.QAbstractSpinBox.ButtonSymbols:

# class PySide2.QtWidgets.QAbstractSpinBox.CorrectionMode:

# class PySide2.QtWidgets.QAbstractSpinBox.StepEnabled:

# class PySide2.QtWidgets.QAbstractSpinBox.StepEnabledFlag:

# class PySide2.QtWidgets.QAbstractSpinBox.StepType:
    "PySide2.QtWidgets.QAbstractSpinBox.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAbstractSpinBox.alignment": (),
    "PySide2.QtWidgets.QAbstractSpinBox.buttonSymbols": (),
    "PySide2.QtWidgets.QAbstractSpinBox.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.clear": (),
    "PySide2.QtWidgets.QAbstractSpinBox.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.correctionMode": (),
    "PySide2.QtWidgets.QAbstractSpinBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.fixup": ('str',),
    "PySide2.QtWidgets.QAbstractSpinBox.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.hasAcceptableInput": (),
    "PySide2.QtWidgets.QAbstractSpinBox.hasFrame": (),
    "PySide2.QtWidgets.QAbstractSpinBox.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.initStyleOption": ('PySide2.QtWidgets.QStyleOptionSpinBox',),
    "PySide2.QtWidgets.QAbstractSpinBox.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QAbstractSpinBox.interpretText": (),
    "PySide2.QtWidgets.QAbstractSpinBox.isAccelerated": (),
    "PySide2.QtWidgets.QAbstractSpinBox.isGroupSeparatorShown": (),
    "PySide2.QtWidgets.QAbstractSpinBox.isReadOnly": (),
    "PySide2.QtWidgets.QAbstractSpinBox.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.keyboardTracking": (),
    "PySide2.QtWidgets.QAbstractSpinBox.lineEdit": (),
    "PySide2.QtWidgets.QAbstractSpinBox.minimumSizeHint": (),
    "PySide2.QtWidgets.QAbstractSpinBox.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.selectAll": (),
    "PySide2.QtWidgets.QAbstractSpinBox.setAccelerated": ('bool',),
    "PySide2.QtWidgets.QAbstractSpinBox.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QAbstractSpinBox.setButtonSymbols": ('PySide2.QtWidgets.QAbstractSpinBox.ButtonSymbols',),
    "PySide2.QtWidgets.QAbstractSpinBox.setCorrectionMode": ('PySide2.QtWidgets.QAbstractSpinBox.CorrectionMode',),
    "PySide2.QtWidgets.QAbstractSpinBox.setFrame": ('bool',),
    "PySide2.QtWidgets.QAbstractSpinBox.setGroupSeparatorShown": ('bool',),
    "PySide2.QtWidgets.QAbstractSpinBox.setKeyboardTracking": ('bool',),
    "PySide2.QtWidgets.QAbstractSpinBox.setLineEdit": ('PySide2.QtWidgets.QLineEdit',),
    "PySide2.QtWidgets.QAbstractSpinBox.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QAbstractSpinBox.setSpecialValueText": ('str',),
    "PySide2.QtWidgets.QAbstractSpinBox.setWrapping": ('bool',),
    "PySide2.QtWidgets.QAbstractSpinBox.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.sizeHint": (),
    "PySide2.QtWidgets.QAbstractSpinBox.specialValueText": (),
    "PySide2.QtWidgets.QAbstractSpinBox.stepBy": ('int',),
    "PySide2.QtWidgets.QAbstractSpinBox.stepDown": (),
    "PySide2.QtWidgets.QAbstractSpinBox.stepEnabled": (),
    "PySide2.QtWidgets.QAbstractSpinBox.stepUp": (),
    "PySide2.QtWidgets.QAbstractSpinBox.text": (),
    "PySide2.QtWidgets.QAbstractSpinBox.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.validate": ('str', 'int'),
    "PySide2.QtWidgets.QAbstractSpinBox.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtWidgets.QAbstractSpinBox.wrapping": (),

# class PySide2.QtWidgets.QAccessibleWidget:
    "PySide2.QtWidgets.QAccessibleWidget.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QAccessible.Role', 'str'),
    "PySide2.QtWidgets.QAccessibleWidget.actionNames": (),
    "PySide2.QtWidgets.QAccessibleWidget.addControllingSignal": ('str',),
    "PySide2.QtWidgets.QAccessibleWidget.backgroundColor": (),
    "PySide2.QtWidgets.QAccessibleWidget.child": ('int',),
    "PySide2.QtWidgets.QAccessibleWidget.childCount": (),
    "PySide2.QtWidgets.QAccessibleWidget.doAction": ('str',),
    "PySide2.QtWidgets.QAccessibleWidget.focusChild": (),
    "PySide2.QtWidgets.QAccessibleWidget.foregroundColor": (),
    "PySide2.QtWidgets.QAccessibleWidget.indexOfChild": ('PySide2.QtGui.QAccessibleInterface',),
    "PySide2.QtWidgets.QAccessibleWidget.interface_cast": ('PySide2.QtGui.QAccessible.InterfaceType',),
    "PySide2.QtWidgets.QAccessibleWidget.isValid": (),
    "PySide2.QtWidgets.QAccessibleWidget.keyBindingsForAction": ('str',),
    "PySide2.QtWidgets.QAccessibleWidget.parent": (),
    "PySide2.QtWidgets.QAccessibleWidget.parentObject": (),
    "PySide2.QtWidgets.QAccessibleWidget.rect": (),
    "PySide2.QtWidgets.QAccessibleWidget.relations": ('PySide2.QtGui.QAccessible.Relation',),
    "PySide2.QtWidgets.QAccessibleWidget.role": (),
    "PySide2.QtWidgets.QAccessibleWidget.state": (),
    "PySide2.QtWidgets.QAccessibleWidget.text": ('PySide2.QtGui.QAccessible.Text',),
    "PySide2.QtWidgets.QAccessibleWidget.widget": (),
    "PySide2.QtWidgets.QAccessibleWidget.window": (),

# class PySide2.QtWidgets.QAction:

# class PySide2.QtWidgets.QAction.ActionEvent:

# class PySide2.QtWidgets.QAction.MenuRole:

# class PySide2.QtWidgets.QAction.Priority:
    "PySide2.QtWidgets.QAction.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtGui.QIcon', 'str', 'PySide2.QtCore.QObject'), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtWidgets.QAction.actionGroup": (),
    "PySide2.QtWidgets.QAction.activate": ('PySide2.QtWidgets.QAction.ActionEvent',),
    "PySide2.QtWidgets.QAction.associatedGraphicsWidgets": (),
    "PySide2.QtWidgets.QAction.associatedWidgets": (),
    "PySide2.QtWidgets.QAction.autoRepeat": (),
    "PySide2.QtWidgets.QAction.data": (),
    "PySide2.QtWidgets.QAction.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QAction.font": (),
    "PySide2.QtWidgets.QAction.hover": (),
    "PySide2.QtWidgets.QAction.icon": (),
    "PySide2.QtWidgets.QAction.iconText": (),
    "PySide2.QtWidgets.QAction.isCheckable": (),
    "PySide2.QtWidgets.QAction.isChecked": (),
    "PySide2.QtWidgets.QAction.isEnabled": (),
    "PySide2.QtWidgets.QAction.isIconVisibleInMenu": (),
    "PySide2.QtWidgets.QAction.isSeparator": (),
    "PySide2.QtWidgets.QAction.isShortcutVisibleInContextMenu": (),
    "PySide2.QtWidgets.QAction.isVisible": (),
    "PySide2.QtWidgets.QAction.menu": (),
    "PySide2.QtWidgets.QAction.menuRole": (),
    "PySide2.QtWidgets.QAction.parentWidget": (),
    "PySide2.QtWidgets.QAction.priority": (),
    "PySide2.QtWidgets.QAction.setActionGroup": ('PySide2.QtWidgets.QActionGroup',),
    "PySide2.QtWidgets.QAction.setAutoRepeat": ('bool',),
    "PySide2.QtWidgets.QAction.setCheckable": ('bool',),
    "PySide2.QtWidgets.QAction.setChecked": ('bool',),
    "PySide2.QtWidgets.QAction.setData": ('typing.Any',),
    "PySide2.QtWidgets.QAction.setDisabled": ('bool',),
    "PySide2.QtWidgets.QAction.setEnabled": ('bool',),
    "PySide2.QtWidgets.QAction.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QAction.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QAction.setIconText": ('str',),
    "PySide2.QtWidgets.QAction.setIconVisibleInMenu": ('bool',),
    "PySide2.QtWidgets.QAction.setMenu": ('PySide2.QtWidgets.QMenu',),
    "PySide2.QtWidgets.QAction.setMenuRole": ('PySide2.QtWidgets.QAction.MenuRole',),
    "PySide2.QtWidgets.QAction.setPriority": ('PySide2.QtWidgets.QAction.Priority',),
    "PySide2.QtWidgets.QAction.setSeparator": ('bool',),
    "PySide2.QtWidgets.QAction.setShortcut": ('PySide2.QtGui.QKeySequence',),
    "PySide2.QtWidgets.QAction.setShortcutContext": ('PySide2.QtCore.Qt.ShortcutContext',),
    "PySide2.QtWidgets.QAction.setShortcutVisibleInContextMenu": ('bool',),
    "PySide2.QtWidgets.QAction.setShortcuts": [('PySide2.QtGui.QKeySequence.StandardKey',), ('typing.Sequence[PySide2.QtGui.QKeySequence]',)],
    "PySide2.QtWidgets.QAction.setStatusTip": ('str',),
    "PySide2.QtWidgets.QAction.setText": ('str',),
    "PySide2.QtWidgets.QAction.setToolTip": ('str',),
    "PySide2.QtWidgets.QAction.setVisible": ('bool',),
    "PySide2.QtWidgets.QAction.setWhatsThis": ('str',),
    "PySide2.QtWidgets.QAction.shortcut": (),
    "PySide2.QtWidgets.QAction.shortcutContext": (),
    "PySide2.QtWidgets.QAction.shortcuts": (),
    "PySide2.QtWidgets.QAction.showStatusText": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QAction.statusTip": (),
    "PySide2.QtWidgets.QAction.text": (),
    "PySide2.QtWidgets.QAction.toggle": (),
    "PySide2.QtWidgets.QAction.toolTip": (),
    "PySide2.QtWidgets.QAction.trigger": (),
    "PySide2.QtWidgets.QAction.whatsThis": (),

# class PySide2.QtWidgets.QActionGroup:

# class PySide2.QtWidgets.QActionGroup.ExclusionPolicy:
    "PySide2.QtWidgets.QActionGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QActionGroup.actions": (),
    "PySide2.QtWidgets.QActionGroup.addAction": [('PySide2.QtGui.QIcon', 'str'), ('PySide2.QtWidgets.QAction',), ('str',)],
    "PySide2.QtWidgets.QActionGroup.checkedAction": (),
    "PySide2.QtWidgets.QActionGroup.exclusionPolicy": (),
    "PySide2.QtWidgets.QActionGroup.isEnabled": (),
    "PySide2.QtWidgets.QActionGroup.isExclusive": (),
    "PySide2.QtWidgets.QActionGroup.isVisible": (),
    "PySide2.QtWidgets.QActionGroup.removeAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QActionGroup.setDisabled": ('bool',),
    "PySide2.QtWidgets.QActionGroup.setEnabled": ('bool',),
    "PySide2.QtWidgets.QActionGroup.setExclusionPolicy": ('PySide2.QtWidgets.QActionGroup.ExclusionPolicy',),
    "PySide2.QtWidgets.QActionGroup.setExclusive": ('bool',),
    "PySide2.QtWidgets.QActionGroup.setVisible": ('bool',),

# class PySide2.QtWidgets.QApplication:

# class PySide2.QtWidgets.QApplication.ColorSpec:
    "PySide2.QtWidgets.QApplication.__init__": [(), ('typing.Sequence[str]',)],
    "PySide2.QtWidgets.QApplication.aboutQt": (),
    "PySide2.QtWidgets.QApplication.activeModalWidget": (),
    "PySide2.QtWidgets.QApplication.activePopupWidget": (),
    "PySide2.QtWidgets.QApplication.activeWindow": (),
    "PySide2.QtWidgets.QApplication.alert": ('PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtWidgets.QApplication.allWidgets": (),
    "PySide2.QtWidgets.QApplication.autoSipEnabled": (),
    "PySide2.QtWidgets.QApplication.beep": (),
    "PySide2.QtWidgets.QApplication.closeAllWindows": (),
    "PySide2.QtWidgets.QApplication.colorSpec": (),
    "PySide2.QtWidgets.QApplication.cursorFlashTime": (),
    "PySide2.QtWidgets.QApplication.desktop": (),
    "PySide2.QtWidgets.QApplication.doubleClickInterval": (),
    "PySide2.QtWidgets.QApplication.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QApplication.exec_": (),
    "PySide2.QtWidgets.QApplication.focusWidget": (),
    "PySide2.QtWidgets.QApplication.font": [(), ('PySide2.QtWidgets.QWidget',), ('str',)],
    "PySide2.QtWidgets.QApplication.fontMetrics": (),
    "PySide2.QtWidgets.QApplication.globalStrut": (),
    "PySide2.QtWidgets.QApplication.isEffectEnabled": ('PySide2.QtCore.Qt.UIEffect',),
    "PySide2.QtWidgets.QApplication.keyboardInputInterval": (),
    "PySide2.QtWidgets.QApplication.notify": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QApplication.palette": [(), ('PySide2.QtWidgets.QWidget',), ('str',)],
    "PySide2.QtWidgets.QApplication.setActiveWindow": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QApplication.setAutoSipEnabled": ('bool',),
    "PySide2.QtWidgets.QApplication.setColorSpec": ('int',),
    "PySide2.QtWidgets.QApplication.setCursorFlashTime": ('int',),
    "PySide2.QtWidgets.QApplication.setDoubleClickInterval": ('int',),
    "PySide2.QtWidgets.QApplication.setEffectEnabled": ('PySide2.QtCore.Qt.UIEffect', 'bool'),
    "PySide2.QtWidgets.QApplication.setFont": [('PySide2.QtGui.QFont',), ('PySide2.QtGui.QFont', 'str')],
    "PySide2.QtWidgets.QApplication.setGlobalStrut": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QApplication.setKeyboardInputInterval": ('int',),
    "PySide2.QtWidgets.QApplication.setPalette": [('PySide2.QtGui.QPalette',), ('PySide2.QtGui.QPalette', 'str')],
    "PySide2.QtWidgets.QApplication.setStartDragDistance": ('int',),
    "PySide2.QtWidgets.QApplication.setStartDragTime": ('int',),
    "PySide2.QtWidgets.QApplication.setStyle": [('PySide2.QtWidgets.QStyle',), ('str',)],
    "PySide2.QtWidgets.QApplication.setStyleSheet": ('str',),
    "PySide2.QtWidgets.QApplication.setWheelScrollLines": ('int',),
    "PySide2.QtWidgets.QApplication.setWindowIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QApplication.startDragDistance": (),
    "PySide2.QtWidgets.QApplication.startDragTime": (),
    "PySide2.QtWidgets.QApplication.style": (),
    "PySide2.QtWidgets.QApplication.styleSheet": (),
    "PySide2.QtWidgets.QApplication.topLevelAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QApplication.topLevelWidgets": (),
    "PySide2.QtWidgets.QApplication.wheelScrollLines": (),
    "PySide2.QtWidgets.QApplication.widgetAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QApplication.windowIcon": (),

# class PySide2.QtWidgets.QBoxLayout:

# class PySide2.QtWidgets.QBoxLayout.Direction:
    "PySide2.QtWidgets.QBoxLayout.__init__": ('PySide2.QtWidgets.QBoxLayout.Direction', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QBoxLayout.addItem": ('PySide2.QtWidgets.QLayoutItem',),
    "PySide2.QtWidgets.QBoxLayout.addLayout": ('PySide2.QtWidgets.QLayout', 'int'),
    "PySide2.QtWidgets.QBoxLayout.addSpacerItem": ('PySide2.QtWidgets.QSpacerItem',),
    "PySide2.QtWidgets.QBoxLayout.addSpacing": ('int',),
    "PySide2.QtWidgets.QBoxLayout.addStretch": ('int',),
    "PySide2.QtWidgets.QBoxLayout.addStrut": ('int',),
    "PySide2.QtWidgets.QBoxLayout.addWidget": [('PySide2.QtWidgets.QWidget',), ('PySide2.QtWidgets.QWidget', 'int', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtWidgets.QBoxLayout.count": (),
    "PySide2.QtWidgets.QBoxLayout.direction": (),
    "PySide2.QtWidgets.QBoxLayout.expandingDirections": (),
    "PySide2.QtWidgets.QBoxLayout.hasHeightForWidth": (),
    "PySide2.QtWidgets.QBoxLayout.heightForWidth": ('int',),
    "PySide2.QtWidgets.QBoxLayout.insertItem": ('int', 'PySide2.QtWidgets.QLayoutItem'),
    "PySide2.QtWidgets.QBoxLayout.insertLayout": ('int', 'PySide2.QtWidgets.QLayout', 'int'),
    "PySide2.QtWidgets.QBoxLayout.insertSpacerItem": ('int', 'PySide2.QtWidgets.QSpacerItem'),
    "PySide2.QtWidgets.QBoxLayout.insertSpacing": ('int', 'int'),
    "PySide2.QtWidgets.QBoxLayout.insertStretch": ('int', 'int'),
    "PySide2.QtWidgets.QBoxLayout.insertWidget": ('int', 'PySide2.QtWidgets.QWidget', 'int', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QBoxLayout.invalidate": (),
    "PySide2.QtWidgets.QBoxLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QBoxLayout.maximumSize": (),
    "PySide2.QtWidgets.QBoxLayout.minimumHeightForWidth": ('int',),
    "PySide2.QtWidgets.QBoxLayout.minimumSize": (),
    "PySide2.QtWidgets.QBoxLayout.setDirection": ('PySide2.QtWidgets.QBoxLayout.Direction',),
    "PySide2.QtWidgets.QBoxLayout.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QBoxLayout.setSpacing": ('int',),
    "PySide2.QtWidgets.QBoxLayout.setStretch": ('int', 'int'),
    "PySide2.QtWidgets.QBoxLayout.setStretchFactor": [('PySide2.QtWidgets.QLayout', 'int'), ('PySide2.QtWidgets.QWidget', 'int')],
    "PySide2.QtWidgets.QBoxLayout.sizeHint": (),
    "PySide2.QtWidgets.QBoxLayout.spacing": (),
    "PySide2.QtWidgets.QBoxLayout.stretch": ('int',),
    "PySide2.QtWidgets.QBoxLayout.takeAt": ('int',),

# class PySide2.QtWidgets.QButtonGroup:
    "PySide2.QtWidgets.QButtonGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QButtonGroup.addButton": ('PySide2.QtWidgets.QAbstractButton', 'int'),
    "PySide2.QtWidgets.QButtonGroup.button": ('int',),
    "PySide2.QtWidgets.QButtonGroup.buttons": (),
    "PySide2.QtWidgets.QButtonGroup.checkedButton": (),
    "PySide2.QtWidgets.QButtonGroup.checkedId": (),
    "PySide2.QtWidgets.QButtonGroup.exclusive": (),
    "PySide2.QtWidgets.QButtonGroup.id": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QButtonGroup.removeButton": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QButtonGroup.setExclusive": ('bool',),
    "PySide2.QtWidgets.QButtonGroup.setId": ('PySide2.QtWidgets.QAbstractButton', 'int'),

# class PySide2.QtWidgets.QCalendarWidget:

# class PySide2.QtWidgets.QCalendarWidget.HorizontalHeaderFormat:

# class PySide2.QtWidgets.QCalendarWidget.SelectionMode:

# class PySide2.QtWidgets.QCalendarWidget.VerticalHeaderFormat:
    "PySide2.QtWidgets.QCalendarWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QCalendarWidget.calendar": (),
    "PySide2.QtWidgets.QCalendarWidget.dateEditAcceptDelay": (),
    "PySide2.QtWidgets.QCalendarWidget.dateTextFormat": [(), ('PySide2.QtCore.QDate',)],
    "PySide2.QtWidgets.QCalendarWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QCalendarWidget.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QCalendarWidget.firstDayOfWeek": (),
    "PySide2.QtWidgets.QCalendarWidget.headerTextFormat": (),
    "PySide2.QtWidgets.QCalendarWidget.horizontalHeaderFormat": (),
    "PySide2.QtWidgets.QCalendarWidget.isDateEditEnabled": (),
    "PySide2.QtWidgets.QCalendarWidget.isGridVisible": (),
    "PySide2.QtWidgets.QCalendarWidget.isNavigationBarVisible": (),
    "PySide2.QtWidgets.QCalendarWidget.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QCalendarWidget.maximumDate": (),
    "PySide2.QtWidgets.QCalendarWidget.minimumDate": (),
    "PySide2.QtWidgets.QCalendarWidget.minimumSizeHint": (),
    "PySide2.QtWidgets.QCalendarWidget.monthShown": (),
    "PySide2.QtWidgets.QCalendarWidget.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QCalendarWidget.paintCell": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'PySide2.QtCore.QDate'),
    "PySide2.QtWidgets.QCalendarWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QCalendarWidget.selectedDate": (),
    "PySide2.QtWidgets.QCalendarWidget.selectionMode": (),
    "PySide2.QtWidgets.QCalendarWidget.setCalendar": ('PySide2.QtCore.QCalendar',),
    "PySide2.QtWidgets.QCalendarWidget.setCurrentPage": ('int', 'int'),
    "PySide2.QtWidgets.QCalendarWidget.setDateEditAcceptDelay": ('int',),
    "PySide2.QtWidgets.QCalendarWidget.setDateEditEnabled": ('bool',),
    "PySide2.QtWidgets.QCalendarWidget.setDateRange": ('PySide2.QtCore.QDate', 'PySide2.QtCore.QDate'),
    "PySide2.QtWidgets.QCalendarWidget.setDateTextFormat": ('PySide2.QtCore.QDate', 'PySide2.QtGui.QTextCharFormat'),
    "PySide2.QtWidgets.QCalendarWidget.setFirstDayOfWeek": ('PySide2.QtCore.Qt.DayOfWeek',),
    "PySide2.QtWidgets.QCalendarWidget.setGridVisible": ('bool',),
    "PySide2.QtWidgets.QCalendarWidget.setHeaderTextFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtWidgets.QCalendarWidget.setHorizontalHeaderFormat": ('PySide2.QtWidgets.QCalendarWidget.HorizontalHeaderFormat',),
    "PySide2.QtWidgets.QCalendarWidget.setMaximumDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QCalendarWidget.setMinimumDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QCalendarWidget.setNavigationBarVisible": ('bool',),
    "PySide2.QtWidgets.QCalendarWidget.setSelectedDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QCalendarWidget.setSelectionMode": ('PySide2.QtWidgets.QCalendarWidget.SelectionMode',),
    "PySide2.QtWidgets.QCalendarWidget.setVerticalHeaderFormat": ('PySide2.QtWidgets.QCalendarWidget.VerticalHeaderFormat',),
    "PySide2.QtWidgets.QCalendarWidget.setWeekdayTextFormat": ('PySide2.QtCore.Qt.DayOfWeek', 'PySide2.QtGui.QTextCharFormat'),
    "PySide2.QtWidgets.QCalendarWidget.showNextMonth": (),
    "PySide2.QtWidgets.QCalendarWidget.showNextYear": (),
    "PySide2.QtWidgets.QCalendarWidget.showPreviousMonth": (),
    "PySide2.QtWidgets.QCalendarWidget.showPreviousYear": (),
    "PySide2.QtWidgets.QCalendarWidget.showSelectedDate": (),
    "PySide2.QtWidgets.QCalendarWidget.showToday": (),
    "PySide2.QtWidgets.QCalendarWidget.sizeHint": (),
    "PySide2.QtWidgets.QCalendarWidget.updateCell": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QCalendarWidget.updateCells": (),
    "PySide2.QtWidgets.QCalendarWidget.verticalHeaderFormat": (),
    "PySide2.QtWidgets.QCalendarWidget.weekdayTextFormat": ('PySide2.QtCore.Qt.DayOfWeek',),
    "PySide2.QtWidgets.QCalendarWidget.yearShown": (),

# class PySide2.QtWidgets.QCheckBox:
    "PySide2.QtWidgets.QCheckBox.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QCheckBox.checkState": (),
    "PySide2.QtWidgets.QCheckBox.checkStateSet": (),
    "PySide2.QtWidgets.QCheckBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QCheckBox.hitButton": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QCheckBox.initStyleOption": ('PySide2.QtWidgets.QStyleOptionButton',),
    "PySide2.QtWidgets.QCheckBox.isTristate": (),
    "PySide2.QtWidgets.QCheckBox.minimumSizeHint": (),
    "PySide2.QtWidgets.QCheckBox.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QCheckBox.nextCheckState": (),
    "PySide2.QtWidgets.QCheckBox.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QCheckBox.setCheckState": ('PySide2.QtCore.Qt.CheckState',),
    "PySide2.QtWidgets.QCheckBox.setTristate": ('bool',),
    "PySide2.QtWidgets.QCheckBox.sizeHint": (),

# class PySide2.QtWidgets.QColorDialog:

# class PySide2.QtWidgets.QColorDialog.ColorDialogOption:

# class PySide2.QtWidgets.QColorDialog.ColorDialogOptions:
    "PySide2.QtWidgets.QColorDialog.__init__": [('PySide2.QtGui.QColor', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QColorDialog.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QColorDialog.currentColor": (),
    "PySide2.QtWidgets.QColorDialog.customColor": ('int',),
    "PySide2.QtWidgets.QColorDialog.customCount": (),
    "PySide2.QtWidgets.QColorDialog.done": ('int',),
    "PySide2.QtWidgets.QColorDialog.getColor": ('PySide2.QtGui.QColor', 'PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtWidgets.QColorDialog.ColorDialogOptions'),
    "PySide2.QtWidgets.QColorDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QColorDialog.options": (),
    "PySide2.QtWidgets.QColorDialog.selectedColor": (),
    "PySide2.QtWidgets.QColorDialog.setCurrentColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QColorDialog.setCustomColor": ('int', 'PySide2.QtGui.QColor'),
    "PySide2.QtWidgets.QColorDialog.setOption": ('PySide2.QtWidgets.QColorDialog.ColorDialogOption', 'bool'),
    "PySide2.QtWidgets.QColorDialog.setOptions": ('PySide2.QtWidgets.QColorDialog.ColorDialogOptions',),
    "PySide2.QtWidgets.QColorDialog.setStandardColor": ('int', 'PySide2.QtGui.QColor'),
    "PySide2.QtWidgets.QColorDialog.setVisible": ('bool',),
    "PySide2.QtWidgets.QColorDialog.standardColor": ('int',),
    "PySide2.QtWidgets.QColorDialog.testOption": ('PySide2.QtWidgets.QColorDialog.ColorDialogOption',),

# class PySide2.QtWidgets.QColormap:

# class PySide2.QtWidgets.QColormap.Mode:
    "PySide2.QtWidgets.QColormap.__init__": ('PySide2.QtWidgets.QColormap',),
    "PySide2.QtWidgets.QColormap.__copy__": (),
    "PySide2.QtWidgets.QColormap.cleanup": (),
    "PySide2.QtWidgets.QColormap.colorAt": ('int',),
    "PySide2.QtWidgets.QColormap.colormap": (),
    "PySide2.QtWidgets.QColormap.depth": (),
    "PySide2.QtWidgets.QColormap.initialize": (),
    "PySide2.QtWidgets.QColormap.instance": ('int',),
    "PySide2.QtWidgets.QColormap.mode": (),
    "PySide2.QtWidgets.QColormap.pixel": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QColormap.size": (),

# class PySide2.QtWidgets.QColumnView:
    "PySide2.QtWidgets.QColumnView.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QColumnView.columnWidths": (),
    "PySide2.QtWidgets.QColumnView.createColumn": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QColumnView.currentChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QColumnView.horizontalOffset": (),
    "PySide2.QtWidgets.QColumnView.indexAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QColumnView.initializeColumn": ('PySide2.QtWidgets.QAbstractItemView',),
    "PySide2.QtWidgets.QColumnView.isIndexHidden": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QColumnView.moveCursor": ('PySide2.QtWidgets.QAbstractItemView.CursorAction', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtWidgets.QColumnView.previewWidget": (),
    "PySide2.QtWidgets.QColumnView.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QColumnView.resizeGripsVisible": (),
    "PySide2.QtWidgets.QColumnView.rowsInserted": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QColumnView.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QColumnView.scrollTo": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QColumnView.selectAll": (),
    "PySide2.QtWidgets.QColumnView.setColumnWidths": ('typing.Sequence[int]',),
    "PySide2.QtWidgets.QColumnView.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QColumnView.setPreviewWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QColumnView.setResizeGripsVisible": ('bool',),
    "PySide2.QtWidgets.QColumnView.setRootIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QColumnView.setSelection": ('PySide2.QtCore.QRect', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtWidgets.QColumnView.setSelectionModel": ('PySide2.QtCore.QItemSelectionModel',),
    "PySide2.QtWidgets.QColumnView.sizeHint": (),
    "PySide2.QtWidgets.QColumnView.verticalOffset": (),
    "PySide2.QtWidgets.QColumnView.visualRect": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QColumnView.visualRegionForSelection": ('PySide2.QtCore.QItemSelection',),

# class PySide2.QtWidgets.QComboBox:

# class PySide2.QtWidgets.QComboBox.InsertPolicy:

# class PySide2.QtWidgets.QComboBox.SizeAdjustPolicy:
    "PySide2.QtWidgets.QComboBox.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QComboBox.addItem": [('PySide2.QtGui.QIcon', 'str', 'typing.Any'), ('str', 'typing.Any')],
    "PySide2.QtWidgets.QComboBox.addItems": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QComboBox.autoCompletion": (),
    "PySide2.QtWidgets.QComboBox.autoCompletionCaseSensitivity": (),
    "PySide2.QtWidgets.QComboBox.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QComboBox.clear": (),
    "PySide2.QtWidgets.QComboBox.clearEditText": (),
    "PySide2.QtWidgets.QComboBox.completer": (),
    "PySide2.QtWidgets.QComboBox.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QComboBox.count": (),
    "PySide2.QtWidgets.QComboBox.currentData": ('int',),
    "PySide2.QtWidgets.QComboBox.currentIndex": (),
    "PySide2.QtWidgets.QComboBox.currentText": (),
    "PySide2.QtWidgets.QComboBox.duplicatesEnabled": (),
    "PySide2.QtWidgets.QComboBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QComboBox.findData": ('typing.Any', 'int', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtWidgets.QComboBox.findText": ('str', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtWidgets.QComboBox.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QComboBox.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QComboBox.hasFrame": (),
    "PySide2.QtWidgets.QComboBox.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QComboBox.hidePopup": (),
    "PySide2.QtWidgets.QComboBox.iconSize": (),
    "PySide2.QtWidgets.QComboBox.initStyleOption": ('PySide2.QtWidgets.QStyleOptionComboBox',),
    "PySide2.QtWidgets.QComboBox.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QComboBox.inputMethodQuery": [('PySide2.QtCore.Qt.InputMethodQuery',), ('PySide2.QtCore.Qt.InputMethodQuery', 'typing.Any')],
    "PySide2.QtWidgets.QComboBox.insertItem": [('int', 'PySide2.QtGui.QIcon', 'str', 'typing.Any'), ('int', 'str', 'typing.Any')],
    "PySide2.QtWidgets.QComboBox.insertItems": ('int', 'typing.Sequence[str]'),
    "PySide2.QtWidgets.QComboBox.insertPolicy": (),
    "PySide2.QtWidgets.QComboBox.insertSeparator": ('int',),
    "PySide2.QtWidgets.QComboBox.isEditable": (),
    "PySide2.QtWidgets.QComboBox.itemData": ('int', 'int'),
    "PySide2.QtWidgets.QComboBox.itemDelegate": (),
    "PySide2.QtWidgets.QComboBox.itemIcon": ('int',),
    "PySide2.QtWidgets.QComboBox.itemText": ('int',),
    "PySide2.QtWidgets.QComboBox.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QComboBox.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QComboBox.lineEdit": (),
    "PySide2.QtWidgets.QComboBox.maxCount": (),
    "PySide2.QtWidgets.QComboBox.maxVisibleItems": (),
    "PySide2.QtWidgets.QComboBox.minimumContentsLength": (),
    "PySide2.QtWidgets.QComboBox.minimumSizeHint": (),
    "PySide2.QtWidgets.QComboBox.model": (),
    "PySide2.QtWidgets.QComboBox.modelColumn": (),
    "PySide2.QtWidgets.QComboBox.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QComboBox.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QComboBox.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QComboBox.removeItem": ('int',),
    "PySide2.QtWidgets.QComboBox.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QComboBox.rootModelIndex": (),
    "PySide2.QtWidgets.QComboBox.setAutoCompletion": ('bool',),
    "PySide2.QtWidgets.QComboBox.setAutoCompletionCaseSensitivity": ('PySide2.QtCore.Qt.CaseSensitivity',),
    "PySide2.QtWidgets.QComboBox.setCompleter": ('PySide2.QtWidgets.QCompleter',),
    "PySide2.QtWidgets.QComboBox.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QComboBox.setCurrentText": ('str',),
    "PySide2.QtWidgets.QComboBox.setDuplicatesEnabled": ('bool',),
    "PySide2.QtWidgets.QComboBox.setEditText": ('str',),
    "PySide2.QtWidgets.QComboBox.setEditable": ('bool',),
    "PySide2.QtWidgets.QComboBox.setFrame": ('bool',),
    "PySide2.QtWidgets.QComboBox.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QComboBox.setInsertPolicy": ('PySide2.QtWidgets.QComboBox.InsertPolicy',),
    "PySide2.QtWidgets.QComboBox.setItemData": ('int', 'typing.Any', 'int'),
    "PySide2.QtWidgets.QComboBox.setItemDelegate": ('PySide2.QtWidgets.QAbstractItemDelegate',),
    "PySide2.QtWidgets.QComboBox.setItemIcon": ('int', 'PySide2.QtGui.QIcon'),
    "PySide2.QtWidgets.QComboBox.setItemText": ('int', 'str'),
    "PySide2.QtWidgets.QComboBox.setLineEdit": ('PySide2.QtWidgets.QLineEdit',),
    "PySide2.QtWidgets.QComboBox.setMaxCount": ('int',),
    "PySide2.QtWidgets.QComboBox.setMaxVisibleItems": ('int',),
    "PySide2.QtWidgets.QComboBox.setMinimumContentsLength": ('int',),
    "PySide2.QtWidgets.QComboBox.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QComboBox.setModelColumn": ('int',),
    "PySide2.QtWidgets.QComboBox.setRootModelIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QComboBox.setSizeAdjustPolicy": ('PySide2.QtWidgets.QComboBox.SizeAdjustPolicy',),
    "PySide2.QtWidgets.QComboBox.setValidator": ('PySide2.QtGui.QValidator',),
    "PySide2.QtWidgets.QComboBox.setView": ('PySide2.QtWidgets.QAbstractItemView',),
    "PySide2.QtWidgets.QComboBox.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QComboBox.showPopup": (),
    "PySide2.QtWidgets.QComboBox.sizeAdjustPolicy": (),
    "PySide2.QtWidgets.QComboBox.sizeHint": (),
    "PySide2.QtWidgets.QComboBox.validator": (),
    "PySide2.QtWidgets.QComboBox.view": (),
    "PySide2.QtWidgets.QComboBox.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QCommandLinkButton:
    "PySide2.QtWidgets.QCommandLinkButton.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget'), ('str', 'str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QCommandLinkButton.description": (),
    "PySide2.QtWidgets.QCommandLinkButton.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QCommandLinkButton.heightForWidth": ('int',),
    "PySide2.QtWidgets.QCommandLinkButton.minimumSizeHint": (),
    "PySide2.QtWidgets.QCommandLinkButton.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QCommandLinkButton.setDescription": ('str',),
    "PySide2.QtWidgets.QCommandLinkButton.sizeHint": (),

# class PySide2.QtWidgets.QCommonStyle:
    "PySide2.QtWidgets.QCommonStyle.__init__": (),
    "PySide2.QtWidgets.QCommonStyle.drawComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.drawControl": ('PySide2.QtWidgets.QStyle.ControlElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.drawPrimitive": ('PySide2.QtWidgets.QStyle.PrimitiveElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.generatedIconPixmap": ('PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QPixmap', 'PySide2.QtWidgets.QStyleOption'),
    "PySide2.QtWidgets.QCommonStyle.hitTestComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.layoutSpacing": ('PySide2.QtWidgets.QSizePolicy.ControlType', 'PySide2.QtWidgets.QSizePolicy.ControlType', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.pixelMetric": ('PySide2.QtWidgets.QStyle.PixelMetric', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.polish": [('PySide2.QtGui.QPalette',), ('PySide2.QtWidgets.QApplication',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QCommonStyle.sizeFromContents": ('PySide2.QtWidgets.QStyle.ContentsType', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtCore.QSize', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.standardIcon": ('PySide2.QtWidgets.QStyle.StandardPixmap', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.standardPixmap": ('PySide2.QtWidgets.QStyle.StandardPixmap', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.styleHint": ('PySide2.QtWidgets.QStyle.StyleHint', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleHintReturn'),
    "PySide2.QtWidgets.QCommonStyle.subControlRect": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtWidgets.QStyle.SubControl', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.subElementRect": ('PySide2.QtWidgets.QStyle.SubElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QCommonStyle.unpolish": [('PySide2.QtWidgets.QApplication',), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QCompleter:

# class PySide2.QtWidgets.QCompleter.CompletionMode:

# class PySide2.QtWidgets.QCompleter.ModelSorting:
    "PySide2.QtWidgets.QCompleter.__init__": [('PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',), ('typing.Sequence[str]', 'PySide2.QtCore.QObject')],
    "PySide2.QtWidgets.QCompleter.caseSensitivity": (),
    "PySide2.QtWidgets.QCompleter.complete": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QCompleter.completionColumn": (),
    "PySide2.QtWidgets.QCompleter.completionCount": (),
    "PySide2.QtWidgets.QCompleter.completionMode": (),
    "PySide2.QtWidgets.QCompleter.completionModel": (),
    "PySide2.QtWidgets.QCompleter.completionPrefix": (),
    "PySide2.QtWidgets.QCompleter.completionRole": (),
    "PySide2.QtWidgets.QCompleter.currentCompletion": (),
    "PySide2.QtWidgets.QCompleter.currentIndex": (),
    "PySide2.QtWidgets.QCompleter.currentRow": (),
    "PySide2.QtWidgets.QCompleter.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QCompleter.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QCompleter.filterMode": (),
    "PySide2.QtWidgets.QCompleter.maxVisibleItems": (),
    "PySide2.QtWidgets.QCompleter.model": (),
    "PySide2.QtWidgets.QCompleter.modelSorting": (),
    "PySide2.QtWidgets.QCompleter.pathFromIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QCompleter.popup": (),
    "PySide2.QtWidgets.QCompleter.setCaseSensitivity": ('PySide2.QtCore.Qt.CaseSensitivity',),
    "PySide2.QtWidgets.QCompleter.setCompletionColumn": ('int',),
    "PySide2.QtWidgets.QCompleter.setCompletionMode": ('PySide2.QtWidgets.QCompleter.CompletionMode',),
    "PySide2.QtWidgets.QCompleter.setCompletionPrefix": ('str',),
    "PySide2.QtWidgets.QCompleter.setCompletionRole": ('int',),
    "PySide2.QtWidgets.QCompleter.setCurrentRow": ('int',),
    "PySide2.QtWidgets.QCompleter.setFilterMode": ('PySide2.QtCore.Qt.MatchFlags',),
    "PySide2.QtWidgets.QCompleter.setMaxVisibleItems": ('int',),
    "PySide2.QtWidgets.QCompleter.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QCompleter.setModelSorting": ('PySide2.QtWidgets.QCompleter.ModelSorting',),
    "PySide2.QtWidgets.QCompleter.setPopup": ('PySide2.QtWidgets.QAbstractItemView',),
    "PySide2.QtWidgets.QCompleter.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QCompleter.setWrapAround": ('bool',),
    "PySide2.QtWidgets.QCompleter.splitPath": ('str',),
    "PySide2.QtWidgets.QCompleter.widget": (),
    "PySide2.QtWidgets.QCompleter.wrapAround": (),

# class PySide2.QtWidgets.QDataWidgetMapper:

# class PySide2.QtWidgets.QDataWidgetMapper.SubmitPolicy:
    "PySide2.QtWidgets.QDataWidgetMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QDataWidgetMapper.addMapping": [('PySide2.QtWidgets.QWidget', 'int'), ('PySide2.QtWidgets.QWidget', 'int', 'PySide2.QtCore.QByteArray')],
    "PySide2.QtWidgets.QDataWidgetMapper.clearMapping": (),
    "PySide2.QtWidgets.QDataWidgetMapper.currentIndex": (),
    "PySide2.QtWidgets.QDataWidgetMapper.itemDelegate": (),
    "PySide2.QtWidgets.QDataWidgetMapper.mappedPropertyName": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDataWidgetMapper.mappedSection": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDataWidgetMapper.mappedWidgetAt": ('int',),
    "PySide2.QtWidgets.QDataWidgetMapper.model": (),
    "PySide2.QtWidgets.QDataWidgetMapper.orientation": (),
    "PySide2.QtWidgets.QDataWidgetMapper.removeMapping": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDataWidgetMapper.revert": (),
    "PySide2.QtWidgets.QDataWidgetMapper.rootIndex": (),
    "PySide2.QtWidgets.QDataWidgetMapper.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QDataWidgetMapper.setCurrentModelIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDataWidgetMapper.setItemDelegate": ('PySide2.QtWidgets.QAbstractItemDelegate',),
    "PySide2.QtWidgets.QDataWidgetMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QDataWidgetMapper.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QDataWidgetMapper.setRootIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDataWidgetMapper.setSubmitPolicy": ('PySide2.QtWidgets.QDataWidgetMapper.SubmitPolicy',),
    "PySide2.QtWidgets.QDataWidgetMapper.submit": (),
    "PySide2.QtWidgets.QDataWidgetMapper.submitPolicy": (),
    "PySide2.QtWidgets.QDataWidgetMapper.toFirst": (),
    "PySide2.QtWidgets.QDataWidgetMapper.toLast": (),
    "PySide2.QtWidgets.QDataWidgetMapper.toNext": (),
    "PySide2.QtWidgets.QDataWidgetMapper.toPrevious": (),

# class PySide2.QtWidgets.QDateEdit:
    "PySide2.QtWidgets.QDateEdit.__init__": [('PySide2.QtCore.QDate', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QDateTimeEdit:

# class PySide2.QtWidgets.QDateTimeEdit.Section:

# class PySide2.QtWidgets.QDateTimeEdit.Sections:
    "PySide2.QtWidgets.QDateTimeEdit.__init__": [('PySide2.QtCore.QDate', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtCore.QDateTime', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtCore.QTime', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',), ('typing.Any', 'type', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QDateTimeEdit.calendar": (),
    "PySide2.QtWidgets.QDateTimeEdit.calendarPopup": (),
    "PySide2.QtWidgets.QDateTimeEdit.calendarWidget": (),
    "PySide2.QtWidgets.QDateTimeEdit.clear": (),
    "PySide2.QtWidgets.QDateTimeEdit.clearMaximumDate": (),
    "PySide2.QtWidgets.QDateTimeEdit.clearMaximumDateTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.clearMaximumTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.clearMinimumDate": (),
    "PySide2.QtWidgets.QDateTimeEdit.clearMinimumDateTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.clearMinimumTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.currentSection": (),
    "PySide2.QtWidgets.QDateTimeEdit.currentSectionIndex": (),
    "PySide2.QtWidgets.QDateTimeEdit.date": (),
    "PySide2.QtWidgets.QDateTimeEdit.dateTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.dateTimeFromText": ('str',),
    "PySide2.QtWidgets.QDateTimeEdit.displayFormat": (),
    "PySide2.QtWidgets.QDateTimeEdit.displayedSections": (),
    "PySide2.QtWidgets.QDateTimeEdit.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QDateTimeEdit.fixup": ('str',),
    "PySide2.QtWidgets.QDateTimeEdit.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QDateTimeEdit.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QDateTimeEdit.initStyleOption": ('PySide2.QtWidgets.QStyleOptionSpinBox',),
    "PySide2.QtWidgets.QDateTimeEdit.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QDateTimeEdit.maximumDate": (),
    "PySide2.QtWidgets.QDateTimeEdit.maximumDateTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.maximumTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.minimumDate": (),
    "PySide2.QtWidgets.QDateTimeEdit.minimumDateTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.minimumTime": (),
    "PySide2.QtWidgets.QDateTimeEdit.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QDateTimeEdit.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QDateTimeEdit.sectionAt": ('int',),
    "PySide2.QtWidgets.QDateTimeEdit.sectionCount": (),
    "PySide2.QtWidgets.QDateTimeEdit.sectionText": ('PySide2.QtWidgets.QDateTimeEdit.Section',),
    "PySide2.QtWidgets.QDateTimeEdit.setCalendar": ('PySide2.QtCore.QCalendar',),
    "PySide2.QtWidgets.QDateTimeEdit.setCalendarPopup": ('bool',),
    "PySide2.QtWidgets.QDateTimeEdit.setCalendarWidget": ('PySide2.QtWidgets.QCalendarWidget',),
    "PySide2.QtWidgets.QDateTimeEdit.setCurrentSection": ('PySide2.QtWidgets.QDateTimeEdit.Section',),
    "PySide2.QtWidgets.QDateTimeEdit.setCurrentSectionIndex": ('int',),
    "PySide2.QtWidgets.QDateTimeEdit.setDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QDateTimeEdit.setDateRange": ('PySide2.QtCore.QDate', 'PySide2.QtCore.QDate'),
    "PySide2.QtWidgets.QDateTimeEdit.setDateTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtWidgets.QDateTimeEdit.setDateTimeRange": ('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QDateTime'),
    "PySide2.QtWidgets.QDateTimeEdit.setDisplayFormat": ('str',),
    "PySide2.QtWidgets.QDateTimeEdit.setMaximumDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QDateTimeEdit.setMaximumDateTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtWidgets.QDateTimeEdit.setMaximumTime": ('PySide2.QtCore.QTime',),
    "PySide2.QtWidgets.QDateTimeEdit.setMinimumDate": ('PySide2.QtCore.QDate',),
    "PySide2.QtWidgets.QDateTimeEdit.setMinimumDateTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtWidgets.QDateTimeEdit.setMinimumTime": ('PySide2.QtCore.QTime',),
    "PySide2.QtWidgets.QDateTimeEdit.setSelectedSection": ('PySide2.QtWidgets.QDateTimeEdit.Section',),
    "PySide2.QtWidgets.QDateTimeEdit.setTime": ('PySide2.QtCore.QTime',),
    "PySide2.QtWidgets.QDateTimeEdit.setTimeRange": ('PySide2.QtCore.QTime', 'PySide2.QtCore.QTime'),
    "PySide2.QtWidgets.QDateTimeEdit.setTimeSpec": ('PySide2.QtCore.Qt.TimeSpec',),
    "PySide2.QtWidgets.QDateTimeEdit.sizeHint": (),
    "PySide2.QtWidgets.QDateTimeEdit.stepBy": ('int',),
    "PySide2.QtWidgets.QDateTimeEdit.stepEnabled": (),
    "PySide2.QtWidgets.QDateTimeEdit.textFromDateTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtWidgets.QDateTimeEdit.time": (),
    "PySide2.QtWidgets.QDateTimeEdit.timeSpec": (),
    "PySide2.QtWidgets.QDateTimeEdit.validate": ('str', 'int'),
    "PySide2.QtWidgets.QDateTimeEdit.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QDesktopWidget:
    "PySide2.QtWidgets.QDesktopWidget.__init__": (),
    "PySide2.QtWidgets.QDesktopWidget.availableGeometry": [('PySide2.QtCore.QPoint',), ('PySide2.QtWidgets.QWidget',), ('int',)],
    "PySide2.QtWidgets.QDesktopWidget.isVirtualDesktop": (),
    "PySide2.QtWidgets.QDesktopWidget.numScreens": (),
    "PySide2.QtWidgets.QDesktopWidget.primaryScreen": (),
    "PySide2.QtWidgets.QDesktopWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QDesktopWidget.screen": [(), ('int',)],
    "PySide2.QtWidgets.QDesktopWidget.screenCount": (),
    "PySide2.QtWidgets.QDesktopWidget.screenGeometry": [('PySide2.QtCore.QPoint',), ('PySide2.QtWidgets.QWidget',), ('int',)],
    "PySide2.QtWidgets.QDesktopWidget.screenNumber": [('PySide2.QtCore.QPoint',), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QDial:
    "PySide2.QtWidgets.QDial.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDial.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QDial.initStyleOption": ('PySide2.QtWidgets.QStyleOptionSlider',),
    "PySide2.QtWidgets.QDial.minimumSizeHint": (),
    "PySide2.QtWidgets.QDial.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QDial.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QDial.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QDial.notchSize": (),
    "PySide2.QtWidgets.QDial.notchTarget": (),
    "PySide2.QtWidgets.QDial.notchesVisible": (),
    "PySide2.QtWidgets.QDial.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QDial.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QDial.setNotchTarget": ('float',),
    "PySide2.QtWidgets.QDial.setNotchesVisible": ('bool',),
    "PySide2.QtWidgets.QDial.setWrapping": ('bool',),
    "PySide2.QtWidgets.QDial.sizeHint": (),
    "PySide2.QtWidgets.QDial.sliderChange": ('PySide2.QtWidgets.QAbstractSlider.SliderChange',),
    "PySide2.QtWidgets.QDial.wrapping": (),

# class PySide2.QtWidgets.QDialog:

# class PySide2.QtWidgets.QDialog.DialogCode:
    "PySide2.QtWidgets.QDialog.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QDialog.accept": (),
    "PySide2.QtWidgets.QDialog.adjustPosition": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDialog.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QDialog.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QDialog.done": ('int',),
    "PySide2.QtWidgets.QDialog.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QDialog.exec_": (),
    "PySide2.QtWidgets.QDialog.extension": (),
    "PySide2.QtWidgets.QDialog.isSizeGripEnabled": (),
    "PySide2.QtWidgets.QDialog.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QDialog.minimumSizeHint": (),
    "PySide2.QtWidgets.QDialog.open": (),
    "PySide2.QtWidgets.QDialog.orientation": (),
    "PySide2.QtWidgets.QDialog.reject": (),
    "PySide2.QtWidgets.QDialog.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QDialog.result": (),
    "PySide2.QtWidgets.QDialog.setExtension": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDialog.setModal": ('bool',),
    "PySide2.QtWidgets.QDialog.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QDialog.setResult": ('int',),
    "PySide2.QtWidgets.QDialog.setSizeGripEnabled": ('bool',),
    "PySide2.QtWidgets.QDialog.setVisible": ('bool',),
    "PySide2.QtWidgets.QDialog.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QDialog.showExtension": ('bool',),
    "PySide2.QtWidgets.QDialog.sizeHint": (),

# class PySide2.QtWidgets.QDialogButtonBox:

# class PySide2.QtWidgets.QDialogButtonBox.ButtonLayout:

# class PySide2.QtWidgets.QDialogButtonBox.ButtonRole:

# class PySide2.QtWidgets.QDialogButtonBox.StandardButton:

# class PySide2.QtWidgets.QDialogButtonBox.StandardButtons:
    "PySide2.QtWidgets.QDialogButtonBox.__init__": [('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QDialogButtonBox.StandardButtons', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QDialogButtonBox.StandardButtons', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QDialogButtonBox.addButton": [('PySide2.QtWidgets.QAbstractButton', 'PySide2.QtWidgets.QDialogButtonBox.ButtonRole'), ('PySide2.QtWidgets.QDialogButtonBox.StandardButton',), ('str', 'PySide2.QtWidgets.QDialogButtonBox.ButtonRole')],
    "PySide2.QtWidgets.QDialogButtonBox.button": ('PySide2.QtWidgets.QDialogButtonBox.StandardButton',),
    "PySide2.QtWidgets.QDialogButtonBox.buttonRole": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QDialogButtonBox.buttons": (),
    "PySide2.QtWidgets.QDialogButtonBox.centerButtons": (),
    "PySide2.QtWidgets.QDialogButtonBox.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QDialogButtonBox.clear": (),
    "PySide2.QtWidgets.QDialogButtonBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QDialogButtonBox.orientation": (),
    "PySide2.QtWidgets.QDialogButtonBox.removeButton": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QDialogButtonBox.setCenterButtons": ('bool',),
    "PySide2.QtWidgets.QDialogButtonBox.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QDialogButtonBox.setStandardButtons": ('PySide2.QtWidgets.QDialogButtonBox.StandardButtons',),
    "PySide2.QtWidgets.QDialogButtonBox.standardButton": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QDialogButtonBox.standardButtons": (),

# class PySide2.QtWidgets.QDirModel:

# class PySide2.QtWidgets.QDirModel.Roles:
    "PySide2.QtWidgets.QDirModel.__init__": [('PySide2.QtCore.QObject',), ('typing.Sequence[str]', 'PySide2.QtCore.QDir.Filters', 'PySide2.QtCore.QDir.SortFlags', 'PySide2.QtCore.QObject')],
    "PySide2.QtWidgets.QDirModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtWidgets.QDirModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QDirModel.fileIcon": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.fileInfo": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.fileName": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.filePath": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.filter": (),
    "PySide2.QtWidgets.QDirModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtWidgets.QDirModel.iconProvider": (),
    "PySide2.QtWidgets.QDirModel.index": [('int', 'int', 'PySide2.QtCore.QModelIndex'), ('str', 'int')],
    "PySide2.QtWidgets.QDirModel.isDir": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.isReadOnly": (),
    "PySide2.QtWidgets.QDirModel.lazyChildCount": (),
    "PySide2.QtWidgets.QDirModel.mimeData": ('typing.List[int]',),
    "PySide2.QtWidgets.QDirModel.mimeTypes": (),
    "PySide2.QtWidgets.QDirModel.mkdir": ('PySide2.QtCore.QModelIndex', 'str'),
    "PySide2.QtWidgets.QDirModel.nameFilters": (),
    "PySide2.QtWidgets.QDirModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtWidgets.QDirModel.refresh": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.remove": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.resolveSymlinks": (),
    "PySide2.QtWidgets.QDirModel.rmdir": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QDirModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtWidgets.QDirModel.setFilter": ('PySide2.QtCore.QDir.Filters',),
    "PySide2.QtWidgets.QDirModel.setIconProvider": ('PySide2.QtWidgets.QFileIconProvider',),
    "PySide2.QtWidgets.QDirModel.setLazyChildCount": ('bool',),
    "PySide2.QtWidgets.QDirModel.setNameFilters": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QDirModel.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QDirModel.setResolveSymlinks": ('bool',),
    "PySide2.QtWidgets.QDirModel.setSorting": ('PySide2.QtCore.QDir.SortFlags',),
    "PySide2.QtWidgets.QDirModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtWidgets.QDirModel.sorting": (),
    "PySide2.QtWidgets.QDirModel.supportedDropActions": (),

# class PySide2.QtWidgets.QDockWidget:

# class PySide2.QtWidgets.QDockWidget.DockWidgetFeature:

# class PySide2.QtWidgets.QDockWidget.DockWidgetFeatures:
    "PySide2.QtWidgets.QDockWidget.__init__": [('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('str', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtWidgets.QDockWidget.allowedAreas": (),
    "PySide2.QtWidgets.QDockWidget.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QDockWidget.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QDockWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QDockWidget.features": (),
    "PySide2.QtWidgets.QDockWidget.initStyleOption": ('PySide2.QtWidgets.QStyleOptionDockWidget',),
    "PySide2.QtWidgets.QDockWidget.isAreaAllowed": ('PySide2.QtCore.Qt.DockWidgetArea',),
    "PySide2.QtWidgets.QDockWidget.isFloating": (),
    "PySide2.QtWidgets.QDockWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QDockWidget.setAllowedAreas": ('PySide2.QtCore.Qt.DockWidgetAreas',),
    "PySide2.QtWidgets.QDockWidget.setFeatures": ('PySide2.QtWidgets.QDockWidget.DockWidgetFeatures',),
    "PySide2.QtWidgets.QDockWidget.setFloating": ('bool',),
    "PySide2.QtWidgets.QDockWidget.setTitleBarWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDockWidget.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDockWidget.titleBarWidget": (),
    "PySide2.QtWidgets.QDockWidget.toggleViewAction": (),
    "PySide2.QtWidgets.QDockWidget.widget": (),

# class PySide2.QtWidgets.QDoubleSpinBox:
    "PySide2.QtWidgets.QDoubleSpinBox.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QDoubleSpinBox.cleanText": (),
    "PySide2.QtWidgets.QDoubleSpinBox.decimals": (),
    "PySide2.QtWidgets.QDoubleSpinBox.fixup": ('str',),
    "PySide2.QtWidgets.QDoubleSpinBox.maximum": (),
    "PySide2.QtWidgets.QDoubleSpinBox.minimum": (),
    "PySide2.QtWidgets.QDoubleSpinBox.prefix": (),
    "PySide2.QtWidgets.QDoubleSpinBox.setDecimals": ('int',),
    "PySide2.QtWidgets.QDoubleSpinBox.setMaximum": ('float',),
    "PySide2.QtWidgets.QDoubleSpinBox.setMinimum": ('float',),
    "PySide2.QtWidgets.QDoubleSpinBox.setPrefix": ('str',),
    "PySide2.QtWidgets.QDoubleSpinBox.setRange": ('float', 'float'),
    "PySide2.QtWidgets.QDoubleSpinBox.setSingleStep": ('float',),
    "PySide2.QtWidgets.QDoubleSpinBox.setStepType": ('PySide2.QtWidgets.QAbstractSpinBox.StepType',),
    "PySide2.QtWidgets.QDoubleSpinBox.setSuffix": ('str',),
    "PySide2.QtWidgets.QDoubleSpinBox.setValue": ('float',),
    "PySide2.QtWidgets.QDoubleSpinBox.singleStep": (),
    "PySide2.QtWidgets.QDoubleSpinBox.stepType": (),
    "PySide2.QtWidgets.QDoubleSpinBox.suffix": (),
    "PySide2.QtWidgets.QDoubleSpinBox.textFromValue": ('float',),
    "PySide2.QtWidgets.QDoubleSpinBox.validate": ('str', 'int'),
    "PySide2.QtWidgets.QDoubleSpinBox.value": (),
    "PySide2.QtWidgets.QDoubleSpinBox.valueFromText": ('str',),

# class PySide2.QtWidgets.QErrorMessage:
    "PySide2.QtWidgets.QErrorMessage.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QErrorMessage.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QErrorMessage.done": ('int',),
    "PySide2.QtWidgets.QErrorMessage.qtHandler": (),
    "PySide2.QtWidgets.QErrorMessage.showMessage": [('str',), ('str', 'str')],

# class PySide2.QtWidgets.QFileDialog:

# class PySide2.QtWidgets.QFileDialog.AcceptMode:

# class PySide2.QtWidgets.QFileDialog.DialogLabel:

# class PySide2.QtWidgets.QFileDialog.FileMode:

# class PySide2.QtWidgets.QFileDialog.Option:

# class PySide2.QtWidgets.QFileDialog.Options:

# class PySide2.QtWidgets.QFileDialog.ViewMode:
    "PySide2.QtWidgets.QFileDialog.__init__": [('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget', 'str', 'str', 'str')],
    "PySide2.QtWidgets.QFileDialog.accept": (),
    "PySide2.QtWidgets.QFileDialog.acceptMode": (),
    "PySide2.QtWidgets.QFileDialog.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFileDialog.confirmOverwrite": (),
    "PySide2.QtWidgets.QFileDialog.defaultSuffix": (),
    "PySide2.QtWidgets.QFileDialog.directory": (),
    "PySide2.QtWidgets.QFileDialog.directoryUrl": (),
    "PySide2.QtWidgets.QFileDialog.done": ('int',),
    "PySide2.QtWidgets.QFileDialog.fileMode": (),
    "PySide2.QtWidgets.QFileDialog.filter": (),
    "PySide2.QtWidgets.QFileDialog.getExistingDirectory": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QFileDialog.Options'),
    "PySide2.QtWidgets.QFileDialog.getExistingDirectoryUrl": ('PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtCore.QUrl', 'PySide2.QtWidgets.QFileDialog.Options', 'typing.Sequence[str]'),
    "PySide2.QtWidgets.QFileDialog.getOpenFileName": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'str', 'PySide2.QtWidgets.QFileDialog.Options'),
    "PySide2.QtWidgets.QFileDialog.getOpenFileNames": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'str', 'PySide2.QtWidgets.QFileDialog.Options'),
    "PySide2.QtWidgets.QFileDialog.getOpenFileUrl": ('PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtCore.QUrl', 'str', 'PySide2.QtWidgets.QFileDialog.Options', 'typing.Sequence[str]'),
    "PySide2.QtWidgets.QFileDialog.getOpenFileUrls": ('PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtCore.QUrl', 'str', 'PySide2.QtWidgets.QFileDialog.Options', 'typing.Sequence[str]'),
    "PySide2.QtWidgets.QFileDialog.getSaveFileName": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'str', 'PySide2.QtWidgets.QFileDialog.Options'),
    "PySide2.QtWidgets.QFileDialog.getSaveFileUrl": ('PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtCore.QUrl', 'str', 'PySide2.QtWidgets.QFileDialog.Options', 'typing.Sequence[str]'),
    "PySide2.QtWidgets.QFileDialog.history": (),
    "PySide2.QtWidgets.QFileDialog.iconProvider": (),
    "PySide2.QtWidgets.QFileDialog.isNameFilterDetailsVisible": (),
    "PySide2.QtWidgets.QFileDialog.isReadOnly": (),
    "PySide2.QtWidgets.QFileDialog.itemDelegate": (),
    "PySide2.QtWidgets.QFileDialog.labelText": ('PySide2.QtWidgets.QFileDialog.DialogLabel',),
    "PySide2.QtWidgets.QFileDialog.mimeTypeFilters": (),
    "PySide2.QtWidgets.QFileDialog.nameFilters": (),
    "PySide2.QtWidgets.QFileDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QFileDialog.options": (),
    "PySide2.QtWidgets.QFileDialog.proxyModel": (),
    "PySide2.QtWidgets.QFileDialog.resolveSymlinks": (),
    "PySide2.QtWidgets.QFileDialog.restoreState": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWidgets.QFileDialog.saveFileContent": ('PySide2.QtCore.QByteArray', 'str'),
    "PySide2.QtWidgets.QFileDialog.saveState": (),
    "PySide2.QtWidgets.QFileDialog.selectFile": ('str',),
    "PySide2.QtWidgets.QFileDialog.selectMimeTypeFilter": ('str',),
    "PySide2.QtWidgets.QFileDialog.selectNameFilter": ('str',),
    "PySide2.QtWidgets.QFileDialog.selectUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWidgets.QFileDialog.selectedFiles": (),
    "PySide2.QtWidgets.QFileDialog.selectedMimeTypeFilter": (),
    "PySide2.QtWidgets.QFileDialog.selectedNameFilter": (),
    "PySide2.QtWidgets.QFileDialog.selectedUrls": (),
    "PySide2.QtWidgets.QFileDialog.setAcceptMode": ('PySide2.QtWidgets.QFileDialog.AcceptMode',),
    "PySide2.QtWidgets.QFileDialog.setConfirmOverwrite": ('bool',),
    "PySide2.QtWidgets.QFileDialog.setDefaultSuffix": ('str',),
    "PySide2.QtWidgets.QFileDialog.setDirectory": [('PySide2.QtCore.QDir',), ('str',)],
    "PySide2.QtWidgets.QFileDialog.setDirectoryUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWidgets.QFileDialog.setFileMode": ('PySide2.QtWidgets.QFileDialog.FileMode',),
    "PySide2.QtWidgets.QFileDialog.setFilter": ('PySide2.QtCore.QDir.Filters',),
    "PySide2.QtWidgets.QFileDialog.setHistory": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QFileDialog.setIconProvider": ('PySide2.QtWidgets.QFileIconProvider',),
    "PySide2.QtWidgets.QFileDialog.setItemDelegate": ('PySide2.QtWidgets.QAbstractItemDelegate',),
    "PySide2.QtWidgets.QFileDialog.setLabelText": ('PySide2.QtWidgets.QFileDialog.DialogLabel', 'str'),
    "PySide2.QtWidgets.QFileDialog.setMimeTypeFilters": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QFileDialog.setNameFilter": ('str',),
    "PySide2.QtWidgets.QFileDialog.setNameFilterDetailsVisible": ('bool',),
    "PySide2.QtWidgets.QFileDialog.setNameFilters": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QFileDialog.setOption": ('PySide2.QtWidgets.QFileDialog.Option', 'bool'),
    "PySide2.QtWidgets.QFileDialog.setOptions": ('PySide2.QtWidgets.QFileDialog.Options',),
    "PySide2.QtWidgets.QFileDialog.setProxyModel": ('PySide2.QtCore.QAbstractProxyModel',),
    "PySide2.QtWidgets.QFileDialog.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QFileDialog.setResolveSymlinks": ('bool',),
    "PySide2.QtWidgets.QFileDialog.setSidebarUrls": ('typing.Sequence[PySide2.QtCore.QUrl]',),
    "PySide2.QtWidgets.QFileDialog.setSupportedSchemes": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QFileDialog.setViewMode": ('PySide2.QtWidgets.QFileDialog.ViewMode',),
    "PySide2.QtWidgets.QFileDialog.setVisible": ('bool',),
    "PySide2.QtWidgets.QFileDialog.sidebarUrls": (),
    "PySide2.QtWidgets.QFileDialog.supportedSchemes": (),
    "PySide2.QtWidgets.QFileDialog.testOption": ('PySide2.QtWidgets.QFileDialog.Option',),
    "PySide2.QtWidgets.QFileDialog.viewMode": (),

# class PySide2.QtWidgets.QFileIconProvider:

# class PySide2.QtWidgets.QFileIconProvider.IconType:

# class PySide2.QtWidgets.QFileIconProvider.Option:

# class PySide2.QtWidgets.QFileIconProvider.Options:
    "PySide2.QtWidgets.QFileIconProvider.__init__": (),
    "PySide2.QtWidgets.QFileIconProvider.icon": [('PySide2.QtCore.QFileInfo',), ('PySide2.QtWidgets.QFileIconProvider.IconType',)],
    "PySide2.QtWidgets.QFileIconProvider.options": (),
    "PySide2.QtWidgets.QFileIconProvider.setOptions": ('PySide2.QtWidgets.QFileIconProvider.Options',),
    "PySide2.QtWidgets.QFileIconProvider.type": ('PySide2.QtCore.QFileInfo',),

# class PySide2.QtWidgets.QFileSystemModel:

# class PySide2.QtWidgets.QFileSystemModel.Option:

# class PySide2.QtWidgets.QFileSystemModel.Options:

# class PySide2.QtWidgets.QFileSystemModel.Roles:
    "PySide2.QtWidgets.QFileSystemModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QFileSystemModel.canFetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtWidgets.QFileSystemModel.dropMimeData": ('PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction', 'int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QFileSystemModel.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFileSystemModel.fetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.fileIcon": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.fileInfo": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.fileName": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.filePath": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.filter": (),
    "PySide2.QtWidgets.QFileSystemModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtWidgets.QFileSystemModel.iconProvider": (),
    "PySide2.QtWidgets.QFileSystemModel.index": [('int', 'int', 'PySide2.QtCore.QModelIndex'), ('str', 'int')],
    "PySide2.QtWidgets.QFileSystemModel.isDir": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.isReadOnly": (),
    "PySide2.QtWidgets.QFileSystemModel.lastModified": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.mimeData": ('typing.List[int]',),
    "PySide2.QtWidgets.QFileSystemModel.mimeTypes": (),
    "PySide2.QtWidgets.QFileSystemModel.mkdir": ('PySide2.QtCore.QModelIndex', 'str'),
    "PySide2.QtWidgets.QFileSystemModel.myComputer": ('int',),
    "PySide2.QtWidgets.QFileSystemModel.nameFilterDisables": (),
    "PySide2.QtWidgets.QFileSystemModel.nameFilters": (),
    "PySide2.QtWidgets.QFileSystemModel.options": (),
    "PySide2.QtWidgets.QFileSystemModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtWidgets.QFileSystemModel.remove": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.resolveSymlinks": (),
    "PySide2.QtWidgets.QFileSystemModel.rmdir": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.rootDirectory": (),
    "PySide2.QtWidgets.QFileSystemModel.rootPath": (),
    "PySide2.QtWidgets.QFileSystemModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtWidgets.QFileSystemModel.setFilter": ('PySide2.QtCore.QDir.Filters',),
    "PySide2.QtWidgets.QFileSystemModel.setIconProvider": ('PySide2.QtWidgets.QFileIconProvider',),
    "PySide2.QtWidgets.QFileSystemModel.setNameFilterDisables": ('bool',),
    "PySide2.QtWidgets.QFileSystemModel.setNameFilters": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QFileSystemModel.setOption": ('PySide2.QtWidgets.QFileSystemModel.Option', 'bool'),
    "PySide2.QtWidgets.QFileSystemModel.setOptions": ('PySide2.QtWidgets.QFileSystemModel.Options',),
    "PySide2.QtWidgets.QFileSystemModel.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QFileSystemModel.setResolveSymlinks": ('bool',),
    "PySide2.QtWidgets.QFileSystemModel.setRootPath": ('str',),
    "PySide2.QtWidgets.QFileSystemModel.sibling": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QFileSystemModel.size": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QFileSystemModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtWidgets.QFileSystemModel.supportedDropActions": (),
    "PySide2.QtWidgets.QFileSystemModel.testOption": ('PySide2.QtWidgets.QFileSystemModel.Option',),
    "PySide2.QtWidgets.QFileSystemModel.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QFileSystemModel.type": ('PySide2.QtCore.QModelIndex',),

# class PySide2.QtWidgets.QFocusFrame:
    "PySide2.QtWidgets.QFocusFrame.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QFocusFrame.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFocusFrame.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QFocusFrame.initStyleOption": ('PySide2.QtWidgets.QStyleOption',),
    "PySide2.QtWidgets.QFocusFrame.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QFocusFrame.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QFocusFrame.widget": (),

# class PySide2.QtWidgets.QFontComboBox:

# class PySide2.QtWidgets.QFontComboBox.FontFilter:

# class PySide2.QtWidgets.QFontComboBox.FontFilters:
    "PySide2.QtWidgets.QFontComboBox.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QFontComboBox.currentFont": (),
    "PySide2.QtWidgets.QFontComboBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFontComboBox.fontFilters": (),
    "PySide2.QtWidgets.QFontComboBox.setCurrentFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QFontComboBox.setFontFilters": ('PySide2.QtWidgets.QFontComboBox.FontFilters',),
    "PySide2.QtWidgets.QFontComboBox.setWritingSystem": ('PySide2.QtGui.QFontDatabase.WritingSystem',),
    "PySide2.QtWidgets.QFontComboBox.sizeHint": (),
    "PySide2.QtWidgets.QFontComboBox.writingSystem": (),

# class PySide2.QtWidgets.QFontDialog:

# class PySide2.QtWidgets.QFontDialog.FontDialogOption:

# class PySide2.QtWidgets.QFontDialog.FontDialogOptions:
    "PySide2.QtWidgets.QFontDialog.__init__": [('PySide2.QtGui.QFont', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QFontDialog.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFontDialog.currentFont": (),
    "PySide2.QtWidgets.QFontDialog.done": ('int',),
    "PySide2.QtWidgets.QFontDialog.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QFontDialog.getFont": [('PySide2.QtGui.QFont', 'PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtWidgets.QFontDialog.FontDialogOptions'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QFontDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QFontDialog.options": (),
    "PySide2.QtWidgets.QFontDialog.selectedFont": (),
    "PySide2.QtWidgets.QFontDialog.setCurrentFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QFontDialog.setOption": ('PySide2.QtWidgets.QFontDialog.FontDialogOption', 'bool'),
    "PySide2.QtWidgets.QFontDialog.setOptions": ('PySide2.QtWidgets.QFontDialog.FontDialogOptions',),
    "PySide2.QtWidgets.QFontDialog.setVisible": ('bool',),
    "PySide2.QtWidgets.QFontDialog.testOption": ('PySide2.QtWidgets.QFontDialog.FontDialogOption',),

# class PySide2.QtWidgets.QFormLayout:

# class PySide2.QtWidgets.QFormLayout.FieldGrowthPolicy:

# class PySide2.QtWidgets.QFormLayout.ItemRole:

# class PySide2.QtWidgets.QFormLayout.RowWrapPolicy:
    "PySide2.QtWidgets.QFormLayout.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QFormLayout.addItem": ('PySide2.QtWidgets.QLayoutItem',),
    "PySide2.QtWidgets.QFormLayout.addRow": [('PySide2.QtWidgets.QLayout',), ('PySide2.QtWidgets.QWidget',), ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QLayout'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QWidget'), ('str', 'PySide2.QtWidgets.QLayout'), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QFormLayout.count": (),
    "PySide2.QtWidgets.QFormLayout.expandingDirections": (),
    "PySide2.QtWidgets.QFormLayout.fieldGrowthPolicy": (),
    "PySide2.QtWidgets.QFormLayout.formAlignment": (),
    "PySide2.QtWidgets.QFormLayout.getItemPosition": ('int', 'PySide2.QtWidgets.QFormLayout.ItemRole'),
    "PySide2.QtWidgets.QFormLayout.getLayoutPosition": ('PySide2.QtWidgets.QLayout', 'PySide2.QtWidgets.QFormLayout.ItemRole'),
    "PySide2.QtWidgets.QFormLayout.getWidgetPosition": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QFormLayout.ItemRole'),
    "PySide2.QtWidgets.QFormLayout.hasHeightForWidth": (),
    "PySide2.QtWidgets.QFormLayout.heightForWidth": ('int',),
    "PySide2.QtWidgets.QFormLayout.horizontalSpacing": (),
    "PySide2.QtWidgets.QFormLayout.insertRow": [('int', 'PySide2.QtWidgets.QLayout'), ('int', 'PySide2.QtWidgets.QWidget'), ('int', 'PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QLayout'), ('int', 'PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QWidget'), ('int', 'str', 'PySide2.QtWidgets.QLayout'), ('int', 'str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QFormLayout.invalidate": (),
    "PySide2.QtWidgets.QFormLayout.itemAt": [('int',), ('int', 'PySide2.QtWidgets.QFormLayout.ItemRole')],
    "PySide2.QtWidgets.QFormLayout.labelAlignment": (),
    "PySide2.QtWidgets.QFormLayout.labelForField": [('PySide2.QtWidgets.QLayout',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QFormLayout.minimumSize": (),
    "PySide2.QtWidgets.QFormLayout.removeRow": [('PySide2.QtWidgets.QLayout',), ('PySide2.QtWidgets.QWidget',), ('int',)],
    "PySide2.QtWidgets.QFormLayout.rowCount": (),
    "PySide2.QtWidgets.QFormLayout.rowWrapPolicy": (),
    "PySide2.QtWidgets.QFormLayout.setFieldGrowthPolicy": ('PySide2.QtWidgets.QFormLayout.FieldGrowthPolicy',),
    "PySide2.QtWidgets.QFormLayout.setFormAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QFormLayout.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QFormLayout.setHorizontalSpacing": ('int',),
    "PySide2.QtWidgets.QFormLayout.setItem": ('int', 'PySide2.QtWidgets.QFormLayout.ItemRole', 'PySide2.QtWidgets.QLayoutItem'),
    "PySide2.QtWidgets.QFormLayout.setLabelAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QFormLayout.setLayout": ('int', 'PySide2.QtWidgets.QFormLayout.ItemRole', 'PySide2.QtWidgets.QLayout'),
    "PySide2.QtWidgets.QFormLayout.setRowWrapPolicy": ('PySide2.QtWidgets.QFormLayout.RowWrapPolicy',),
    "PySide2.QtWidgets.QFormLayout.setSpacing": ('int',),
    "PySide2.QtWidgets.QFormLayout.setVerticalSpacing": ('int',),
    "PySide2.QtWidgets.QFormLayout.setWidget": ('int', 'PySide2.QtWidgets.QFormLayout.ItemRole', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QFormLayout.sizeHint": (),
    "PySide2.QtWidgets.QFormLayout.spacing": (),
    "PySide2.QtWidgets.QFormLayout.takeAt": ('int',),
    "PySide2.QtWidgets.QFormLayout.verticalSpacing": (),

# class PySide2.QtWidgets.QFrame:

# class PySide2.QtWidgets.QFrame.Shadow:

# class PySide2.QtWidgets.QFrame.Shape:

# class PySide2.QtWidgets.QFrame.StyleMask:
    "PySide2.QtWidgets.QFrame.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QFrame.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFrame.drawFrame": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QFrame.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QFrame.frameRect": (),
    "PySide2.QtWidgets.QFrame.frameShadow": (),
    "PySide2.QtWidgets.QFrame.frameShape": (),
    "PySide2.QtWidgets.QFrame.frameStyle": (),
    "PySide2.QtWidgets.QFrame.frameWidth": (),
    "PySide2.QtWidgets.QFrame.initStyleOption": ('PySide2.QtWidgets.QStyleOptionFrame',),
    "PySide2.QtWidgets.QFrame.lineWidth": (),
    "PySide2.QtWidgets.QFrame.midLineWidth": (),
    "PySide2.QtWidgets.QFrame.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QFrame.setFrameRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QFrame.setFrameShadow": ('PySide2.QtWidgets.QFrame.Shadow',),
    "PySide2.QtWidgets.QFrame.setFrameShape": ('PySide2.QtWidgets.QFrame.Shape',),
    "PySide2.QtWidgets.QFrame.setFrameStyle": ('int',),
    "PySide2.QtWidgets.QFrame.setLineWidth": ('int',),
    "PySide2.QtWidgets.QFrame.setMidLineWidth": ('int',),
    "PySide2.QtWidgets.QFrame.sizeHint": (),

# class PySide2.QtWidgets.QGesture:

# class PySide2.QtWidgets.QGesture.GestureCancelPolicy:
    "PySide2.QtWidgets.QGesture.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGesture.gestureCancelPolicy": (),
    "PySide2.QtWidgets.QGesture.gestureType": (),
    "PySide2.QtWidgets.QGesture.hasHotSpot": (),
    "PySide2.QtWidgets.QGesture.hotSpot": (),
    "PySide2.QtWidgets.QGesture.setGestureCancelPolicy": ('PySide2.QtWidgets.QGesture.GestureCancelPolicy',),
    "PySide2.QtWidgets.QGesture.setHotSpot": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGesture.state": (),
    "PySide2.QtWidgets.QGesture.unsetHotSpot": (),

# class PySide2.QtWidgets.QGestureEvent:
    "PySide2.QtWidgets.QGestureEvent.__init__": ('typing.Sequence[PySide2.QtWidgets.QGesture]',),
    "PySide2.QtWidgets.QGestureEvent.accept": [(), ('PySide2.QtCore.Qt.GestureType',), ('PySide2.QtWidgets.QGesture',)],
    "PySide2.QtWidgets.QGestureEvent.activeGestures": (),
    "PySide2.QtWidgets.QGestureEvent.canceledGestures": (),
    "PySide2.QtWidgets.QGestureEvent.gesture": ('PySide2.QtCore.Qt.GestureType',),
    "PySide2.QtWidgets.QGestureEvent.gestures": (),
    "PySide2.QtWidgets.QGestureEvent.ignore": [(), ('PySide2.QtCore.Qt.GestureType',), ('PySide2.QtWidgets.QGesture',)],
    "PySide2.QtWidgets.QGestureEvent.isAccepted": [(), ('PySide2.QtCore.Qt.GestureType',), ('PySide2.QtWidgets.QGesture',)],
    "PySide2.QtWidgets.QGestureEvent.mapToGraphicsScene": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGestureEvent.setAccepted": [('PySide2.QtCore.Qt.GestureType', 'bool'), ('PySide2.QtWidgets.QGesture', 'bool'), ('bool',)],
    "PySide2.QtWidgets.QGestureEvent.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QGestureEvent.widget": (),

# class PySide2.QtWidgets.QGestureRecognizer:

# class PySide2.QtWidgets.QGestureRecognizer.Result:

# class PySide2.QtWidgets.QGestureRecognizer.ResultFlag:
    "PySide2.QtWidgets.QGestureRecognizer.__init__": (),
    "PySide2.QtWidgets.QGestureRecognizer.create": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGestureRecognizer.recognize": ('PySide2.QtWidgets.QGesture', 'PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QGestureRecognizer.registerRecognizer": ('PySide2.QtWidgets.QGestureRecognizer',),
    "PySide2.QtWidgets.QGestureRecognizer.reset": ('PySide2.QtWidgets.QGesture',),
    "PySide2.QtWidgets.QGestureRecognizer.unregisterRecognizer": ('PySide2.QtCore.Qt.GestureType',),

# class PySide2.QtWidgets.QGraphicsAnchor:
    "PySide2.QtWidgets.QGraphicsAnchor.setSizePolicy": ('PySide2.QtWidgets.QSizePolicy.Policy',),
    "PySide2.QtWidgets.QGraphicsAnchor.setSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsAnchor.sizePolicy": (),
    "PySide2.QtWidgets.QGraphicsAnchor.spacing": (),
    "PySide2.QtWidgets.QGraphicsAnchor.unsetSpacing": (),

# class PySide2.QtWidgets.QGraphicsAnchorLayout:
    "PySide2.QtWidgets.QGraphicsAnchorLayout.__init__": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.addAnchor": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.AnchorPoint', 'PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.AnchorPoint'),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.addAnchors": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.Orientations'),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.addCornerAnchors": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.Corner', 'PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.Corner'),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.anchor": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.AnchorPoint', 'PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.AnchorPoint'),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.count": (),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.horizontalSpacing": (),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.invalidate": (),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.removeAt": ('int',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.setGeometry": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.setHorizontalSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.setSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.setVerticalSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.sizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsAnchorLayout.verticalSpacing": (),

# class PySide2.QtWidgets.QGraphicsBlurEffect:

# class PySide2.QtWidgets.QGraphicsBlurEffect.BlurHint:

# class PySide2.QtWidgets.QGraphicsBlurEffect.BlurHints:
    "PySide2.QtWidgets.QGraphicsBlurEffect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsBlurEffect.blurHints": (),
    "PySide2.QtWidgets.QGraphicsBlurEffect.blurRadius": (),
    "PySide2.QtWidgets.QGraphicsBlurEffect.boundingRectFor": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsBlurEffect.draw": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QGraphicsBlurEffect.setBlurHints": ('PySide2.QtWidgets.QGraphicsBlurEffect.BlurHints',),
    "PySide2.QtWidgets.QGraphicsBlurEffect.setBlurRadius": ('float',),

# class PySide2.QtWidgets.QGraphicsColorizeEffect:
    "PySide2.QtWidgets.QGraphicsColorizeEffect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsColorizeEffect.color": (),
    "PySide2.QtWidgets.QGraphicsColorizeEffect.draw": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QGraphicsColorizeEffect.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QGraphicsColorizeEffect.setStrength": ('float',),
    "PySide2.QtWidgets.QGraphicsColorizeEffect.strength": (),

# class PySide2.QtWidgets.QGraphicsDropShadowEffect:
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.blurRadius": (),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.boundingRectFor": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.color": (),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.draw": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.offset": (),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.setBlurRadius": ('float',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.setOffset": [('PySide2.QtCore.QPointF',), ('float',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.setXOffset": ('float',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.setYOffset": ('float',),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.xOffset": (),
    "PySide2.QtWidgets.QGraphicsDropShadowEffect.yOffset": (),

# class PySide2.QtWidgets.QGraphicsEffect:

# class PySide2.QtWidgets.QGraphicsEffect.ChangeFlag:

# class PySide2.QtWidgets.QGraphicsEffect.ChangeFlags:

# class PySide2.QtWidgets.QGraphicsEffect.PixmapPadMode:
    "PySide2.QtWidgets.QGraphicsEffect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsEffect.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsEffect.boundingRectFor": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsEffect.draw": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QGraphicsEffect.drawSource": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QGraphicsEffect.isEnabled": (),
    "PySide2.QtWidgets.QGraphicsEffect.setEnabled": ('bool',),
    "PySide2.QtWidgets.QGraphicsEffect.sourceBoundingRect": ('PySide2.QtCore.Qt.CoordinateSystem',),
    "PySide2.QtWidgets.QGraphicsEffect.sourceChanged": ('PySide2.QtWidgets.QGraphicsEffect.ChangeFlags',),
    "PySide2.QtWidgets.QGraphicsEffect.sourceIsPixmap": (),
    "PySide2.QtWidgets.QGraphicsEffect.sourcePixmap": ('PySide2.QtCore.Qt.CoordinateSystem', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QGraphicsEffect.PixmapPadMode'),
    "PySide2.QtWidgets.QGraphicsEffect.update": (),
    "PySide2.QtWidgets.QGraphicsEffect.updateBoundingRect": (),

# class PySide2.QtWidgets.QGraphicsEllipseItem:
    "PySide2.QtWidgets.QGraphicsEllipseItem.__init__": [('PySide2.QtCore.QRectF', 'PySide2.QtWidgets.QGraphicsItem'), ('PySide2.QtWidgets.QGraphicsItem',), ('float', 'float', 'float', 'float', 'PySide2.QtWidgets.QGraphicsItem')],
    "PySide2.QtWidgets.QGraphicsEllipseItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsEllipseItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsEllipseItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsEllipseItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsEllipseItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsEllipseItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsEllipseItem.rect": (),
    "PySide2.QtWidgets.QGraphicsEllipseItem.setRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsEllipseItem.setSpanAngle": ('int',),
    "PySide2.QtWidgets.QGraphicsEllipseItem.setStartAngle": ('int',),
    "PySide2.QtWidgets.QGraphicsEllipseItem.shape": (),
    "PySide2.QtWidgets.QGraphicsEllipseItem.spanAngle": (),
    "PySide2.QtWidgets.QGraphicsEllipseItem.startAngle": (),
    "PySide2.QtWidgets.QGraphicsEllipseItem.type": (),

# class PySide2.QtWidgets.QGraphicsGridLayout:
    "PySide2.QtWidgets.QGraphicsGridLayout.__init__": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsGridLayout.addItem": [('PySide2.QtWidgets.QGraphicsLayoutItem', 'int', 'int', 'PySide2.QtCore.Qt.Alignment'), ('PySide2.QtWidgets.QGraphicsLayoutItem', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtWidgets.QGraphicsGridLayout.alignment": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnAlignment": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnCount": (),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnMaximumWidth": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnMinimumWidth": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnPreferredWidth": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnSpacing": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.columnStretchFactor": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.count": (),
    "PySide2.QtWidgets.QGraphicsGridLayout.horizontalSpacing": (),
    "PySide2.QtWidgets.QGraphicsGridLayout.invalidate": (),
    "PySide2.QtWidgets.QGraphicsGridLayout.itemAt": [('int',), ('int', 'int')],
    "PySide2.QtWidgets.QGraphicsGridLayout.removeAt": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.removeItem": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowAlignment": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowCount": (),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowMaximumHeight": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowMinimumHeight": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowPreferredHeight": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowSpacing": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.rowStretchFactor": ('int',),
    "PySide2.QtWidgets.QGraphicsGridLayout.setAlignment": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnAlignment": ('int', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnFixedWidth": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnMaximumWidth": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnMinimumWidth": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnPreferredWidth": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnSpacing": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setColumnStretchFactor": ('int', 'int'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setGeometry": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsGridLayout.setHorizontalSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowAlignment": ('int', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowFixedHeight": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowMaximumHeight": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowMinimumHeight": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowPreferredHeight": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowSpacing": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setRowStretchFactor": ('int', 'int'),
    "PySide2.QtWidgets.QGraphicsGridLayout.setSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsGridLayout.setVerticalSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsGridLayout.sizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsGridLayout.verticalSpacing": (),

# class PySide2.QtWidgets.QGraphicsItem:

# class PySide2.QtWidgets.QGraphicsItem.CacheMode:

# class PySide2.QtWidgets.QGraphicsItem.Extension:

# class PySide2.QtWidgets.QGraphicsItem.GraphicsItemChange:

# class PySide2.QtWidgets.QGraphicsItem.GraphicsItemFlag:

# class PySide2.QtWidgets.QGraphicsItem.GraphicsItemFlags:

# class PySide2.QtWidgets.QGraphicsItem.PanelModality:
    "PySide2.QtWidgets.QGraphicsItem.__init__": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.acceptDrops": (),
    "PySide2.QtWidgets.QGraphicsItem.acceptHoverEvents": (),
    "PySide2.QtWidgets.QGraphicsItem.acceptTouchEvents": (),
    "PySide2.QtWidgets.QGraphicsItem.acceptedMouseButtons": (),
    "PySide2.QtWidgets.QGraphicsItem.addToIndex": (),
    "PySide2.QtWidgets.QGraphicsItem.advance": ('int',),
    "PySide2.QtWidgets.QGraphicsItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsItem.boundingRegion": ('PySide2.QtGui.QTransform',),
    "PySide2.QtWidgets.QGraphicsItem.boundingRegionGranularity": (),
    "PySide2.QtWidgets.QGraphicsItem.cacheMode": (),
    "PySide2.QtWidgets.QGraphicsItem.childItems": (),
    "PySide2.QtWidgets.QGraphicsItem.childrenBoundingRect": (),
    "PySide2.QtWidgets.QGraphicsItem.clearFocus": (),
    "PySide2.QtWidgets.QGraphicsItem.clipPath": (),
    "PySide2.QtWidgets.QGraphicsItem.collidesWithItem": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.ItemSelectionMode'),
    "PySide2.QtWidgets.QGraphicsItem.collidesWithPath": ('PySide2.QtGui.QPainterPath', 'PySide2.QtCore.Qt.ItemSelectionMode'),
    "PySide2.QtWidgets.QGraphicsItem.collidingItems": ('PySide2.QtCore.Qt.ItemSelectionMode',),
    "PySide2.QtWidgets.QGraphicsItem.commonAncestorItem": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsItem.contextMenuEvent": ('PySide2.QtWidgets.QGraphicsSceneContextMenuEvent',),
    "PySide2.QtWidgets.QGraphicsItem.cursor": (),
    "PySide2.QtWidgets.QGraphicsItem.data": ('int',),
    "PySide2.QtWidgets.QGraphicsItem.deviceTransform": ('PySide2.QtGui.QTransform',),
    "PySide2.QtWidgets.QGraphicsItem.dragEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsItem.dragLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsItem.dragMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsItem.dropEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsItem.effectiveOpacity": (),
    "PySide2.QtWidgets.QGraphicsItem.ensureVisible": [('PySide2.QtCore.QRectF', 'int', 'int'), ('float', 'float', 'float', 'float', 'int', 'int')],
    "PySide2.QtWidgets.QGraphicsItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsItem.filtersChildEvents": (),
    "PySide2.QtWidgets.QGraphicsItem.flags": (),
    "PySide2.QtWidgets.QGraphicsItem.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsItem.focusItem": (),
    "PySide2.QtWidgets.QGraphicsItem.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsItem.focusProxy": (),
    "PySide2.QtWidgets.QGraphicsItem.focusScopeItem": (),
    "PySide2.QtWidgets.QGraphicsItem.grabKeyboard": (),
    "PySide2.QtWidgets.QGraphicsItem.grabMouse": (),
    "PySide2.QtWidgets.QGraphicsItem.graphicsEffect": (),
    "PySide2.QtWidgets.QGraphicsItem.group": (),
    "PySide2.QtWidgets.QGraphicsItem.handlesChildEvents": (),
    "PySide2.QtWidgets.QGraphicsItem.hasCursor": (),
    "PySide2.QtWidgets.QGraphicsItem.hasFocus": (),
    "PySide2.QtWidgets.QGraphicsItem.hide": (),
    "PySide2.QtWidgets.QGraphicsItem.hoverEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsItem.hoverLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsItem.hoverMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsItem.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QGraphicsItem.inputMethodHints": (),
    "PySide2.QtWidgets.QGraphicsItem.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QGraphicsItem.installSceneEventFilter": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.isActive": (),
    "PySide2.QtWidgets.QGraphicsItem.isAncestorOf": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.isBlockedByModalPanel": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.isClipped": (),
    "PySide2.QtWidgets.QGraphicsItem.isEnabled": (),
    "PySide2.QtWidgets.QGraphicsItem.isObscured": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.isPanel": (),
    "PySide2.QtWidgets.QGraphicsItem.isSelected": (),
    "PySide2.QtWidgets.QGraphicsItem.isUnderMouse": (),
    "PySide2.QtWidgets.QGraphicsItem.isVisible": (),
    "PySide2.QtWidgets.QGraphicsItem.isVisibleTo": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.isWidget": (),
    "PySide2.QtWidgets.QGraphicsItem.isWindow": (),
    "PySide2.QtWidgets.QGraphicsItem.itemChange": ('PySide2.QtWidgets.QGraphicsItem.GraphicsItemChange', 'typing.Any'),
    "PySide2.QtWidgets.QGraphicsItem.itemTransform": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsItem.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsItem.mapFromItem": [('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QPointF'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QRectF'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtGui.QPainterPath'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtGui.QPolygonF'), ('PySide2.QtWidgets.QGraphicsItem', 'float', 'float'), ('PySide2.QtWidgets.QGraphicsItem', 'float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapFromParent": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygonF',), ('float', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapFromScene": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygonF',), ('float', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapRectFromItem": [('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QRectF'), ('PySide2.QtWidgets.QGraphicsItem', 'float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapRectFromParent": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapRectFromScene": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapRectToItem": [('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QRectF'), ('PySide2.QtWidgets.QGraphicsItem', 'float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapRectToParent": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapRectToScene": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapToItem": [('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QPointF'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QRectF'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtGui.QPainterPath'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtGui.QPolygonF'), ('PySide2.QtWidgets.QGraphicsItem', 'float', 'float'), ('PySide2.QtWidgets.QGraphicsItem', 'float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapToParent": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygonF',), ('float', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.mapToScene": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygonF',), ('float', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.matrix": (),
    "PySide2.QtWidgets.QGraphicsItem.mouseDoubleClickEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsItem.mouseMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsItem.mousePressEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsItem.mouseReleaseEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsItem.moveBy": ('float', 'float'),
    "PySide2.QtWidgets.QGraphicsItem.opacity": (),
    "PySide2.QtWidgets.QGraphicsItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsItem.panel": (),
    "PySide2.QtWidgets.QGraphicsItem.panelModality": (),
    "PySide2.QtWidgets.QGraphicsItem.parentItem": (),
    "PySide2.QtWidgets.QGraphicsItem.parentObject": (),
    "PySide2.QtWidgets.QGraphicsItem.parentWidget": (),
    "PySide2.QtWidgets.QGraphicsItem.pos": (),
    "PySide2.QtWidgets.QGraphicsItem.prepareGeometryChange": (),
    "PySide2.QtWidgets.QGraphicsItem.removeFromIndex": (),
    "PySide2.QtWidgets.QGraphicsItem.removeSceneEventFilter": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.resetMatrix": (),
    "PySide2.QtWidgets.QGraphicsItem.resetTransform": (),
    "PySide2.QtWidgets.QGraphicsItem.rotation": (),
    "PySide2.QtWidgets.QGraphicsItem.scale": (),
    "PySide2.QtWidgets.QGraphicsItem.scene": (),
    "PySide2.QtWidgets.QGraphicsItem.sceneBoundingRect": (),
    "PySide2.QtWidgets.QGraphicsItem.sceneEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsItem.sceneEventFilter": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QGraphicsItem.sceneMatrix": (),
    "PySide2.QtWidgets.QGraphicsItem.scenePos": (),
    "PySide2.QtWidgets.QGraphicsItem.sceneTransform": (),
    "PySide2.QtWidgets.QGraphicsItem.scroll": ('float', 'float', 'PySide2.QtCore.QRectF'),
    "PySide2.QtWidgets.QGraphicsItem.setAcceptDrops": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setAcceptHoverEvents": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setAcceptTouchEvents": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setAcceptedMouseButtons": ('PySide2.QtCore.Qt.MouseButtons',),
    "PySide2.QtWidgets.QGraphicsItem.setActive": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setBoundingRegionGranularity": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.setCacheMode": ('PySide2.QtWidgets.QGraphicsItem.CacheMode', 'PySide2.QtCore.QSize'),
    "PySide2.QtWidgets.QGraphicsItem.setCursor": ('PySide2.QtGui.QCursor',),
    "PySide2.QtWidgets.QGraphicsItem.setData": ('int', 'typing.Any'),
    "PySide2.QtWidgets.QGraphicsItem.setEnabled": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setFiltersChildEvents": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setFlag": ('PySide2.QtWidgets.QGraphicsItem.GraphicsItemFlag', 'bool'),
    "PySide2.QtWidgets.QGraphicsItem.setFlags": ('PySide2.QtWidgets.QGraphicsItem.GraphicsItemFlags',),
    "PySide2.QtWidgets.QGraphicsItem.setFocus": ('PySide2.QtCore.Qt.FocusReason',),
    "PySide2.QtWidgets.QGraphicsItem.setFocusProxy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.setGraphicsEffect": ('PySide2.QtWidgets.QGraphicsEffect',),
    "PySide2.QtWidgets.QGraphicsItem.setGroup": ('PySide2.QtWidgets.QGraphicsItemGroup',),
    "PySide2.QtWidgets.QGraphicsItem.setHandlesChildEvents": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setInputMethodHints": ('PySide2.QtCore.Qt.InputMethodHints',),
    "PySide2.QtWidgets.QGraphicsItem.setMatrix": ('PySide2.QtGui.QMatrix', 'bool'),
    "PySide2.QtWidgets.QGraphicsItem.setOpacity": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.setPanelModality": ('PySide2.QtWidgets.QGraphicsItem.PanelModality',),
    "PySide2.QtWidgets.QGraphicsItem.setParentItem": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.setPos": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.setRotation": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.setScale": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.setSelected": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setToolTip": ('str',),
    "PySide2.QtWidgets.QGraphicsItem.setTransform": ('PySide2.QtGui.QTransform', 'bool'),
    "PySide2.QtWidgets.QGraphicsItem.setTransformOriginPoint": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.setTransformations": ('typing.Sequence[PySide2.QtWidgets.QGraphicsTransform]',),
    "PySide2.QtWidgets.QGraphicsItem.setVisible": ('bool',),
    "PySide2.QtWidgets.QGraphicsItem.setX": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.setY": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.setZValue": ('float',),
    "PySide2.QtWidgets.QGraphicsItem.shape": (),
    "PySide2.QtWidgets.QGraphicsItem.show": (),
    "PySide2.QtWidgets.QGraphicsItem.stackBefore": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItem.toGraphicsObject": (),
    "PySide2.QtWidgets.QGraphicsItem.toolTip": (),
    "PySide2.QtWidgets.QGraphicsItem.topLevelItem": (),
    "PySide2.QtWidgets.QGraphicsItem.topLevelWidget": (),
    "PySide2.QtWidgets.QGraphicsItem.transform": (),
    "PySide2.QtWidgets.QGraphicsItem.transformOriginPoint": (),
    "PySide2.QtWidgets.QGraphicsItem.transformations": (),
    "PySide2.QtWidgets.QGraphicsItem.type": (),
    "PySide2.QtWidgets.QGraphicsItem.ungrabKeyboard": (),
    "PySide2.QtWidgets.QGraphicsItem.ungrabMouse": (),
    "PySide2.QtWidgets.QGraphicsItem.unsetCursor": (),
    "PySide2.QtWidgets.QGraphicsItem.update": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsItem.updateMicroFocus": (),
    "PySide2.QtWidgets.QGraphicsItem.wheelEvent": ('PySide2.QtWidgets.QGraphicsSceneWheelEvent',),
    "PySide2.QtWidgets.QGraphicsItem.window": (),
    "PySide2.QtWidgets.QGraphicsItem.x": (),
    "PySide2.QtWidgets.QGraphicsItem.y": (),
    "PySide2.QtWidgets.QGraphicsItem.zValue": (),

# class PySide2.QtWidgets.QGraphicsItemAnimation:
    "PySide2.QtWidgets.QGraphicsItemAnimation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.afterAnimationStep": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.beforeAnimationStep": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.clear": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.horizontalScaleAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.horizontalShearAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.item": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.matrixAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.posAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.posList": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.reset": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.rotationAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.rotationList": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.scaleList": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setItem": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setPosAt": ('float', 'PySide2.QtCore.QPointF'),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setRotationAt": ('float', 'float'),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setScaleAt": ('float', 'float', 'float'),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setShearAt": ('float', 'float', 'float'),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setStep": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setTimeLine": ('PySide2.QtCore.QTimeLine',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.setTranslationAt": ('float', 'float', 'float'),
    "PySide2.QtWidgets.QGraphicsItemAnimation.shearList": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.timeLine": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.transformAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.translationList": (),
    "PySide2.QtWidgets.QGraphicsItemAnimation.verticalScaleAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.verticalShearAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.xTranslationAt": ('float',),
    "PySide2.QtWidgets.QGraphicsItemAnimation.yTranslationAt": ('float',),

# class PySide2.QtWidgets.QGraphicsItemGroup:
    "PySide2.QtWidgets.QGraphicsItemGroup.__init__": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItemGroup.addToGroup": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItemGroup.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsItemGroup.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItemGroup.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsItemGroup.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsItemGroup.removeFromGroup": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsItemGroup.type": (),

# class PySide2.QtWidgets.QGraphicsLayout:
    "PySide2.QtWidgets.QGraphicsLayout.__init__": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsLayout.activate": (),
    "PySide2.QtWidgets.QGraphicsLayout.addChildLayoutItem": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsLayout.count": (),
    "PySide2.QtWidgets.QGraphicsLayout.getContentsMargins": (),
    "PySide2.QtWidgets.QGraphicsLayout.instantInvalidatePropagation": (),
    "PySide2.QtWidgets.QGraphicsLayout.invalidate": (),
    "PySide2.QtWidgets.QGraphicsLayout.isActivated": (),
    "PySide2.QtWidgets.QGraphicsLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QGraphicsLayout.removeAt": ('int',),
    "PySide2.QtWidgets.QGraphicsLayout.setContentsMargins": ('float', 'float', 'float', 'float'),
    "PySide2.QtWidgets.QGraphicsLayout.setInstantInvalidatePropagation": ('bool',),
    "PySide2.QtWidgets.QGraphicsLayout.updateGeometry": (),
    "PySide2.QtWidgets.QGraphicsLayout.widgetEvent": ('PySide2.QtCore.QEvent',),

# class PySide2.QtWidgets.QGraphicsLayoutItem:
    "PySide2.QtWidgets.QGraphicsLayoutItem.__init__": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'bool'),
    "PySide2.QtWidgets.QGraphicsLayoutItem.contentsRect": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.effectiveSizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsLayoutItem.geometry": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.getContentsMargins": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.graphicsItem": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.isLayout": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.maximumHeight": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.maximumSize": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.maximumWidth": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.minimumHeight": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.minimumSize": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.minimumWidth": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.ownedByLayout": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.parentLayoutItem": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.preferredHeight": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.preferredSize": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.preferredWidth": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setGeometry": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setGraphicsItem": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setMaximumHeight": ('float',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setMaximumSize": [('PySide2.QtCore.QSizeF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsLayoutItem.setMaximumWidth": ('float',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setMinimumHeight": ('float',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setMinimumSize": [('PySide2.QtCore.QSizeF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsLayoutItem.setMinimumWidth": ('float',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setOwnedByLayout": ('bool',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setParentLayoutItem": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setPreferredHeight": ('float',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setPreferredSize": [('PySide2.QtCore.QSizeF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsLayoutItem.setPreferredWidth": ('float',),
    "PySide2.QtWidgets.QGraphicsLayoutItem.setSizePolicy": [('PySide2.QtWidgets.QSizePolicy',), ('PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.ControlType')],
    "PySide2.QtWidgets.QGraphicsLayoutItem.sizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsLayoutItem.sizePolicy": (),
    "PySide2.QtWidgets.QGraphicsLayoutItem.updateGeometry": (),

# class PySide2.QtWidgets.QGraphicsLineItem:
    "PySide2.QtWidgets.QGraphicsLineItem.__init__": [('PySide2.QtCore.QLineF', 'PySide2.QtWidgets.QGraphicsItem'), ('PySide2.QtWidgets.QGraphicsItem',), ('float', 'float', 'float', 'float', 'PySide2.QtWidgets.QGraphicsItem')],
    "PySide2.QtWidgets.QGraphicsLineItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsLineItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsLineItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsLineItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsLineItem.line": (),
    "PySide2.QtWidgets.QGraphicsLineItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsLineItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsLineItem.pen": (),
    "PySide2.QtWidgets.QGraphicsLineItem.setLine": [('PySide2.QtCore.QLineF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsLineItem.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtWidgets.QGraphicsLineItem.shape": (),
    "PySide2.QtWidgets.QGraphicsLineItem.type": (),

# class PySide2.QtWidgets.QGraphicsLinearLayout:
    "PySide2.QtWidgets.QGraphicsLinearLayout.__init__": [('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QGraphicsLayoutItem'), ('PySide2.QtWidgets.QGraphicsLayoutItem',)],
    "PySide2.QtWidgets.QGraphicsLinearLayout.addItem": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.addStretch": ('int',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.alignment": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.count": (),
    "PySide2.QtWidgets.QGraphicsLinearLayout.dump": ('int',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.insertItem": ('int', 'PySide2.QtWidgets.QGraphicsLayoutItem'),
    "PySide2.QtWidgets.QGraphicsLinearLayout.insertStretch": ('int', 'int'),
    "PySide2.QtWidgets.QGraphicsLinearLayout.invalidate": (),
    "PySide2.QtWidgets.QGraphicsLinearLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.itemSpacing": ('int',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.orientation": (),
    "PySide2.QtWidgets.QGraphicsLinearLayout.removeAt": ('int',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.removeItem": ('PySide2.QtWidgets.QGraphicsLayoutItem',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.setAlignment": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QGraphicsLinearLayout.setGeometry": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.setItemSpacing": ('int', 'float'),
    "PySide2.QtWidgets.QGraphicsLinearLayout.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.setSpacing": ('float',),
    "PySide2.QtWidgets.QGraphicsLinearLayout.setStretchFactor": ('PySide2.QtWidgets.QGraphicsLayoutItem', 'int'),
    "PySide2.QtWidgets.QGraphicsLinearLayout.sizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsLinearLayout.spacing": (),
    "PySide2.QtWidgets.QGraphicsLinearLayout.stretchFactor": ('PySide2.QtWidgets.QGraphicsLayoutItem',),

# class PySide2.QtWidgets.QGraphicsObject:
    "PySide2.QtWidgets.QGraphicsObject.__init__": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsObject.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsObject.grabGesture": ('PySide2.QtCore.Qt.GestureType', 'PySide2.QtCore.Qt.GestureFlags'),
    "PySide2.QtWidgets.QGraphicsObject.ungrabGesture": ('PySide2.QtCore.Qt.GestureType',),
    "PySide2.QtWidgets.QGraphicsObject.updateMicroFocus": (),

# class PySide2.QtWidgets.QGraphicsOpacityEffect:
    "PySide2.QtWidgets.QGraphicsOpacityEffect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsOpacityEffect.draw": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QGraphicsOpacityEffect.opacity": (),
    "PySide2.QtWidgets.QGraphicsOpacityEffect.opacityMask": (),
    "PySide2.QtWidgets.QGraphicsOpacityEffect.setOpacity": ('float',),
    "PySide2.QtWidgets.QGraphicsOpacityEffect.setOpacityMask": ('PySide2.QtGui.QBrush',),

# class PySide2.QtWidgets.QGraphicsPathItem:
    "PySide2.QtWidgets.QGraphicsPathItem.__init__": [('PySide2.QtGui.QPainterPath', 'PySide2.QtWidgets.QGraphicsItem'), ('PySide2.QtWidgets.QGraphicsItem',)],
    "PySide2.QtWidgets.QGraphicsPathItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsPathItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsPathItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsPathItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsPathItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsPathItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsPathItem.path": (),
    "PySide2.QtWidgets.QGraphicsPathItem.setPath": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtWidgets.QGraphicsPathItem.shape": (),
    "PySide2.QtWidgets.QGraphicsPathItem.type": (),

# class PySide2.QtWidgets.QGraphicsPixmapItem:

# class PySide2.QtWidgets.QGraphicsPixmapItem.ShapeMode:
    "PySide2.QtWidgets.QGraphicsPixmapItem.__init__": [('PySide2.QtGui.QPixmap', 'PySide2.QtWidgets.QGraphicsItem'), ('PySide2.QtWidgets.QGraphicsItem',)],
    "PySide2.QtWidgets.QGraphicsPixmapItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsPixmapItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsPixmapItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsPixmapItem.offset": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsPixmapItem.pixmap": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.setOffset": [('PySide2.QtCore.QPointF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsPixmapItem.setPixmap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtWidgets.QGraphicsPixmapItem.setShapeMode": ('PySide2.QtWidgets.QGraphicsPixmapItem.ShapeMode',),
    "PySide2.QtWidgets.QGraphicsPixmapItem.setTransformationMode": ('PySide2.QtCore.Qt.TransformationMode',),
    "PySide2.QtWidgets.QGraphicsPixmapItem.shape": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.shapeMode": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.transformationMode": (),
    "PySide2.QtWidgets.QGraphicsPixmapItem.type": (),

# class PySide2.QtWidgets.QGraphicsPolygonItem:
    "PySide2.QtWidgets.QGraphicsPolygonItem.__init__": [('PySide2.QtGui.QPolygonF', 'PySide2.QtWidgets.QGraphicsItem'), ('PySide2.QtWidgets.QGraphicsItem',)],
    "PySide2.QtWidgets.QGraphicsPolygonItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsPolygonItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsPolygonItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsPolygonItem.fillRule": (),
    "PySide2.QtWidgets.QGraphicsPolygonItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsPolygonItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsPolygonItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsPolygonItem.polygon": (),
    "PySide2.QtWidgets.QGraphicsPolygonItem.setFillRule": ('PySide2.QtCore.Qt.FillRule',),
    "PySide2.QtWidgets.QGraphicsPolygonItem.setPolygon": ('PySide2.QtGui.QPolygonF',),
    "PySide2.QtWidgets.QGraphicsPolygonItem.shape": (),
    "PySide2.QtWidgets.QGraphicsPolygonItem.type": (),

# class PySide2.QtWidgets.QGraphicsProxyWidget:
    "PySide2.QtWidgets.QGraphicsProxyWidget.__init__": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QGraphicsProxyWidget.contextMenuEvent": ('PySide2.QtWidgets.QGraphicsSceneContextMenuEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.createProxyForChildWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.dragEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.dragLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.dragMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.dropEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QGraphicsProxyWidget.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.grabMouseEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.hoverEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.hoverLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.hoverMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.itemChange": ('PySide2.QtWidgets.QGraphicsItem.GraphicsItemChange', 'typing.Any'),
    "PySide2.QtWidgets.QGraphicsProxyWidget.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.mouseDoubleClickEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.mouseMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.mousePressEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.mouseReleaseEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.newProxyWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsProxyWidget.resizeEvent": ('PySide2.QtWidgets.QGraphicsSceneResizeEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.setGeometry": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.sizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsProxyWidget.subWidgetRect": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.type": (),
    "PySide2.QtWidgets.QGraphicsProxyWidget.ungrabMouseEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.wheelEvent": ('PySide2.QtWidgets.QGraphicsSceneWheelEvent',),
    "PySide2.QtWidgets.QGraphicsProxyWidget.widget": (),

# class PySide2.QtWidgets.QGraphicsRectItem:
    "PySide2.QtWidgets.QGraphicsRectItem.__init__": [('PySide2.QtCore.QRectF', 'PySide2.QtWidgets.QGraphicsItem'), ('PySide2.QtWidgets.QGraphicsItem',), ('float', 'float', 'float', 'float', 'PySide2.QtWidgets.QGraphicsItem')],
    "PySide2.QtWidgets.QGraphicsRectItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsRectItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsRectItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsRectItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsRectItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsRectItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsRectItem.rect": (),
    "PySide2.QtWidgets.QGraphicsRectItem.setRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsRectItem.shape": (),
    "PySide2.QtWidgets.QGraphicsRectItem.type": (),

# class PySide2.QtWidgets.QGraphicsRotation:
    "PySide2.QtWidgets.QGraphicsRotation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsRotation.angle": (),
    "PySide2.QtWidgets.QGraphicsRotation.applyTo": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtWidgets.QGraphicsRotation.axis": (),
    "PySide2.QtWidgets.QGraphicsRotation.origin": (),
    "PySide2.QtWidgets.QGraphicsRotation.setAngle": ('float',),
    "PySide2.QtWidgets.QGraphicsRotation.setAxis": [('PySide2.QtCore.Qt.Axis',), ('PySide2.QtGui.QVector3D',)],
    "PySide2.QtWidgets.QGraphicsRotation.setOrigin": ('PySide2.QtGui.QVector3D',),

# class PySide2.QtWidgets.QGraphicsScale:
    "PySide2.QtWidgets.QGraphicsScale.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsScale.applyTo": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtWidgets.QGraphicsScale.origin": (),
    "PySide2.QtWidgets.QGraphicsScale.setOrigin": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtWidgets.QGraphicsScale.setXScale": ('float',),
    "PySide2.QtWidgets.QGraphicsScale.setYScale": ('float',),
    "PySide2.QtWidgets.QGraphicsScale.setZScale": ('float',),
    "PySide2.QtWidgets.QGraphicsScale.xScale": (),
    "PySide2.QtWidgets.QGraphicsScale.yScale": (),
    "PySide2.QtWidgets.QGraphicsScale.zScale": (),

# class PySide2.QtWidgets.QGraphicsScene:

# class PySide2.QtWidgets.QGraphicsScene.ItemIndexMethod:

# class PySide2.QtWidgets.QGraphicsScene.SceneLayer:

# class PySide2.QtWidgets.QGraphicsScene.SceneLayers:
    "PySide2.QtWidgets.QGraphicsScene.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QRectF', 'PySide2.QtCore.QObject'), ('float', 'float', 'float', 'float', 'PySide2.QtCore.QObject')],
    "PySide2.QtWidgets.QGraphicsScene.activePanel": (),
    "PySide2.QtWidgets.QGraphicsScene.activeWindow": (),
    "PySide2.QtWidgets.QGraphicsScene.addEllipse": [('PySide2.QtCore.QRectF', 'PySide2.QtGui.QPen', 'PySide2.QtGui.QBrush'), ('float', 'float', 'float', 'float', 'PySide2.QtGui.QPen', 'PySide2.QtGui.QBrush')],
    "PySide2.QtWidgets.QGraphicsScene.addItem": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsScene.addLine": [('PySide2.QtCore.QLineF', 'PySide2.QtGui.QPen'), ('float', 'float', 'float', 'float', 'PySide2.QtGui.QPen')],
    "PySide2.QtWidgets.QGraphicsScene.addPath": ('PySide2.QtGui.QPainterPath', 'PySide2.QtGui.QPen', 'PySide2.QtGui.QBrush'),
    "PySide2.QtWidgets.QGraphicsScene.addPixmap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtWidgets.QGraphicsScene.addPolygon": ('PySide2.QtGui.QPolygonF', 'PySide2.QtGui.QPen', 'PySide2.QtGui.QBrush'),
    "PySide2.QtWidgets.QGraphicsScene.addRect": [('PySide2.QtCore.QRectF', 'PySide2.QtGui.QPen', 'PySide2.QtGui.QBrush'), ('float', 'float', 'float', 'float', 'PySide2.QtGui.QPen', 'PySide2.QtGui.QBrush')],
    "PySide2.QtWidgets.QGraphicsScene.addSimpleText": ('str', 'PySide2.QtGui.QFont'),
    "PySide2.QtWidgets.QGraphicsScene.addText": ('str', 'PySide2.QtGui.QFont'),
    "PySide2.QtWidgets.QGraphicsScene.addWidget": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QGraphicsScene.advance": (),
    "PySide2.QtWidgets.QGraphicsScene.backgroundBrush": (),
    "PySide2.QtWidgets.QGraphicsScene.bspTreeDepth": (),
    "PySide2.QtWidgets.QGraphicsScene.clear": (),
    "PySide2.QtWidgets.QGraphicsScene.clearFocus": (),
    "PySide2.QtWidgets.QGraphicsScene.clearSelection": (),
    "PySide2.QtWidgets.QGraphicsScene.collidingItems": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.ItemSelectionMode'),
    "PySide2.QtWidgets.QGraphicsScene.contextMenuEvent": ('PySide2.QtWidgets.QGraphicsSceneContextMenuEvent',),
    "PySide2.QtWidgets.QGraphicsScene.createItemGroup": ('typing.Sequence[PySide2.QtWidgets.QGraphicsItem]',),
    "PySide2.QtWidgets.QGraphicsScene.destroyItemGroup": ('PySide2.QtWidgets.QGraphicsItemGroup',),
    "PySide2.QtWidgets.QGraphicsScene.dragEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsScene.dragLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsScene.dragMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsScene.drawBackground": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF'),
    "PySide2.QtWidgets.QGraphicsScene.drawForeground": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF'),
    "PySide2.QtWidgets.QGraphicsScene.dropEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsScene.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsScene.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QGraphicsScene.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsScene.focusItem": (),
    "PySide2.QtWidgets.QGraphicsScene.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QGraphicsScene.focusOnTouch": (),
    "PySide2.QtWidgets.QGraphicsScene.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsScene.font": (),
    "PySide2.QtWidgets.QGraphicsScene.foregroundBrush": (),
    "PySide2.QtWidgets.QGraphicsScene.hasFocus": (),
    "PySide2.QtWidgets.QGraphicsScene.height": (),
    "PySide2.QtWidgets.QGraphicsScene.helpEvent": ('PySide2.QtWidgets.QGraphicsSceneHelpEvent',),
    "PySide2.QtWidgets.QGraphicsScene.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QGraphicsScene.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QGraphicsScene.invalidate": [('PySide2.QtCore.QRectF', 'PySide2.QtWidgets.QGraphicsScene.SceneLayers'), ('float', 'float', 'float', 'float', 'PySide2.QtWidgets.QGraphicsScene.SceneLayers')],
    "PySide2.QtWidgets.QGraphicsScene.isActive": (),
    "PySide2.QtWidgets.QGraphicsScene.isSortCacheEnabled": (),
    "PySide2.QtWidgets.QGraphicsScene.itemAt": [('PySide2.QtCore.QPointF', 'PySide2.QtGui.QTransform'), ('float', 'float', 'PySide2.QtGui.QTransform')],
    "PySide2.QtWidgets.QGraphicsScene.itemIndexMethod": (),
    "PySide2.QtWidgets.QGraphicsScene.items": [('PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtCore.Qt.SortOrder', 'PySide2.QtGui.QTransform'), ('PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtCore.Qt.SortOrder', 'PySide2.QtGui.QTransform'), ('PySide2.QtCore.Qt.SortOrder',), ('PySide2.QtGui.QPainterPath', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtCore.Qt.SortOrder', 'PySide2.QtGui.QTransform'), ('PySide2.QtGui.QPolygonF', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtCore.Qt.SortOrder', 'PySide2.QtGui.QTransform'), ('float', 'float', 'float', 'float', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtCore.Qt.SortOrder', 'PySide2.QtGui.QTransform')],
    "PySide2.QtWidgets.QGraphicsScene.itemsBoundingRect": (),
    "PySide2.QtWidgets.QGraphicsScene.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsScene.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsScene.minimumRenderSize": (),
    "PySide2.QtWidgets.QGraphicsScene.mouseDoubleClickEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsScene.mouseGrabberItem": (),
    "PySide2.QtWidgets.QGraphicsScene.mouseMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsScene.mousePressEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsScene.mouseReleaseEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsScene.palette": (),
    "PySide2.QtWidgets.QGraphicsScene.removeItem": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsScene.render": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.AspectRatioMode'),
    "PySide2.QtWidgets.QGraphicsScene.sceneRect": (),
    "PySide2.QtWidgets.QGraphicsScene.selectedItems": (),
    "PySide2.QtWidgets.QGraphicsScene.selectionArea": (),
    "PySide2.QtWidgets.QGraphicsScene.sendEvent": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QGraphicsScene.setActivePanel": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsScene.setActiveWindow": ('PySide2.QtWidgets.QGraphicsWidget',),
    "PySide2.QtWidgets.QGraphicsScene.setBackgroundBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QGraphicsScene.setBspTreeDepth": ('int',),
    "PySide2.QtWidgets.QGraphicsScene.setFocus": ('PySide2.QtCore.Qt.FocusReason',),
    "PySide2.QtWidgets.QGraphicsScene.setFocusItem": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.FocusReason'),
    "PySide2.QtWidgets.QGraphicsScene.setFocusOnTouch": ('bool',),
    "PySide2.QtWidgets.QGraphicsScene.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QGraphicsScene.setForegroundBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QGraphicsScene.setItemIndexMethod": ('PySide2.QtWidgets.QGraphicsScene.ItemIndexMethod',),
    "PySide2.QtWidgets.QGraphicsScene.setMinimumRenderSize": ('float',),
    "PySide2.QtWidgets.QGraphicsScene.setPalette": ('PySide2.QtGui.QPalette',),
    "PySide2.QtWidgets.QGraphicsScene.setSceneRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsScene.setSelectionArea": [('PySide2.QtGui.QPainterPath', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtGui.QTransform'), ('PySide2.QtGui.QPainterPath', 'PySide2.QtCore.Qt.ItemSelectionOperation', 'PySide2.QtCore.Qt.ItemSelectionMode', 'PySide2.QtGui.QTransform'), ('PySide2.QtGui.QPainterPath', 'PySide2.QtGui.QTransform')],
    "PySide2.QtWidgets.QGraphicsScene.setSortCacheEnabled": ('bool',),
    "PySide2.QtWidgets.QGraphicsScene.setStickyFocus": ('bool',),
    "PySide2.QtWidgets.QGraphicsScene.setStyle": ('PySide2.QtWidgets.QStyle',),
    "PySide2.QtWidgets.QGraphicsScene.stickyFocus": (),
    "PySide2.QtWidgets.QGraphicsScene.style": (),
    "PySide2.QtWidgets.QGraphicsScene.update": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsScene.views": (),
    "PySide2.QtWidgets.QGraphicsScene.wheelEvent": ('PySide2.QtWidgets.QGraphicsSceneWheelEvent',),
    "PySide2.QtWidgets.QGraphicsScene.width": (),

# class PySide2.QtWidgets.QGraphicsSceneContextMenuEvent:

# class PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.Reason:
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.modifiers": (),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.pos": (),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.reason": (),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.scenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.screenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.setModifiers": ('PySide2.QtCore.Qt.KeyboardModifiers',),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.setPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.setReason": ('PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.Reason',),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.setScreenPos": ('PySide2.QtCore.QPoint',),

# class PySide2.QtWidgets.QGraphicsSceneDragDropEvent:
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.acceptProposedAction": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.buttons": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.dropAction": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.mimeData": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.modifiers": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.pos": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.possibleActions": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.proposedAction": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.scenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.screenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setButtons": ('PySide2.QtCore.Qt.MouseButtons',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setDropAction": ('PySide2.QtCore.Qt.DropAction',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setModifiers": ('PySide2.QtCore.Qt.KeyboardModifiers',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setPossibleActions": ('PySide2.QtCore.Qt.DropActions',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setProposedAction": ('PySide2.QtCore.Qt.DropAction',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.setScreenPos": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QGraphicsSceneDragDropEvent.source": (),

# class PySide2.QtWidgets.QGraphicsSceneEvent:
    "PySide2.QtWidgets.QGraphicsSceneEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneEvent.widget": (),

# class PySide2.QtWidgets.QGraphicsSceneHelpEvent:
    "PySide2.QtWidgets.QGraphicsSceneHelpEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneHelpEvent.scenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneHelpEvent.screenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneHelpEvent.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneHelpEvent.setScreenPos": ('PySide2.QtCore.QPoint',),

# class PySide2.QtWidgets.QGraphicsSceneHoverEvent:
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.lastPos": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.lastScenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.lastScreenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.modifiers": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.pos": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.scenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.screenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setLastPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setLastScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setLastScreenPos": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setModifiers": ('PySide2.QtCore.Qt.KeyboardModifiers',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneHoverEvent.setScreenPos": ('PySide2.QtCore.QPoint',),

# class PySide2.QtWidgets.QGraphicsSceneMouseEvent:
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.button": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.buttonDownPos": ('PySide2.QtCore.Qt.MouseButton',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.buttonDownScenePos": ('PySide2.QtCore.Qt.MouseButton',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.buttonDownScreenPos": ('PySide2.QtCore.Qt.MouseButton',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.buttons": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.flags": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.lastPos": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.lastScenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.lastScreenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.modifiers": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.pos": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.scenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.screenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setButton": ('PySide2.QtCore.Qt.MouseButton',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setButtonDownPos": ('PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.QPointF'),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setButtonDownScenePos": ('PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.QPointF'),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setButtonDownScreenPos": ('PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.QPoint'),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setButtons": ('PySide2.QtCore.Qt.MouseButtons',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setFlags": ('PySide2.QtCore.Qt.MouseEventFlags',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setLastPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setLastScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setLastScreenPos": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setModifiers": ('PySide2.QtCore.Qt.KeyboardModifiers',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setScreenPos": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.setSource": ('PySide2.QtCore.Qt.MouseEventSource',),
    "PySide2.QtWidgets.QGraphicsSceneMouseEvent.source": (),

# class PySide2.QtWidgets.QGraphicsSceneMoveEvent:
    "PySide2.QtWidgets.QGraphicsSceneMoveEvent.__init__": (),
    "PySide2.QtWidgets.QGraphicsSceneMoveEvent.newPos": (),
    "PySide2.QtWidgets.QGraphicsSceneMoveEvent.oldPos": (),
    "PySide2.QtWidgets.QGraphicsSceneMoveEvent.setNewPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneMoveEvent.setOldPos": ('PySide2.QtCore.QPointF',),

# class PySide2.QtWidgets.QGraphicsSceneResizeEvent:
    "PySide2.QtWidgets.QGraphicsSceneResizeEvent.__init__": (),
    "PySide2.QtWidgets.QGraphicsSceneResizeEvent.newSize": (),
    "PySide2.QtWidgets.QGraphicsSceneResizeEvent.oldSize": (),
    "PySide2.QtWidgets.QGraphicsSceneResizeEvent.setNewSize": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtWidgets.QGraphicsSceneResizeEvent.setOldSize": ('PySide2.QtCore.QSizeF',),

# class PySide2.QtWidgets.QGraphicsSceneWheelEvent:
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.__init__": ('PySide2.QtCore.QEvent.Type',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.buttons": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.delta": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.modifiers": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.orientation": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.pos": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.scenePos": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.screenPos": (),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setButtons": ('PySide2.QtCore.Qt.MouseButtons',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setDelta": ('int',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setModifiers": ('PySide2.QtCore.Qt.KeyboardModifiers',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setPos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setScenePos": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSceneWheelEvent.setScreenPos": ('PySide2.QtCore.QPoint',),

# class PySide2.QtWidgets.QGraphicsSimpleTextItem:
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.__init__": [('PySide2.QtWidgets.QGraphicsItem',), ('str', 'PySide2.QtWidgets.QGraphicsItem')],
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.font": (),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.setText": ('str',),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.shape": (),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.text": (),
    "PySide2.QtWidgets.QGraphicsSimpleTextItem.type": (),

# class PySide2.QtWidgets.QGraphicsTextItem:
    "PySide2.QtWidgets.QGraphicsTextItem.__init__": [('PySide2.QtWidgets.QGraphicsItem',), ('str', 'PySide2.QtWidgets.QGraphicsItem')],
    "PySide2.QtWidgets.QGraphicsTextItem.adjustSize": (),
    "PySide2.QtWidgets.QGraphicsTextItem.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsTextItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsTextItem.contextMenuEvent": ('PySide2.QtWidgets.QGraphicsSceneContextMenuEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.defaultTextColor": (),
    "PySide2.QtWidgets.QGraphicsTextItem.document": (),
    "PySide2.QtWidgets.QGraphicsTextItem.dragEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.dragLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.dragMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.dropEvent": ('PySide2.QtWidgets.QGraphicsSceneDragDropEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.extension": ('typing.Any',),
    "PySide2.QtWidgets.QGraphicsTextItem.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.font": (),
    "PySide2.QtWidgets.QGraphicsTextItem.hoverEnterEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.hoverLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.hoverMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QGraphicsTextItem.isObscuredBy": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtWidgets.QGraphicsTextItem.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.mouseDoubleClickEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.mouseMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.mousePressEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.mouseReleaseEvent": ('PySide2.QtWidgets.QGraphicsSceneMouseEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.opaqueArea": (),
    "PySide2.QtWidgets.QGraphicsTextItem.openExternalLinks": (),
    "PySide2.QtWidgets.QGraphicsTextItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsTextItem.sceneEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsTextItem.setDefaultTextColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QGraphicsTextItem.setDocument": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtWidgets.QGraphicsTextItem.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QGraphicsTextItem.setHtml": ('str',),
    "PySide2.QtWidgets.QGraphicsTextItem.setOpenExternalLinks": ('bool',),
    "PySide2.QtWidgets.QGraphicsTextItem.setPlainText": ('str',),
    "PySide2.QtWidgets.QGraphicsTextItem.setTabChangesFocus": ('bool',),
    "PySide2.QtWidgets.QGraphicsTextItem.setTextCursor": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtWidgets.QGraphicsTextItem.setTextInteractionFlags": ('PySide2.QtCore.Qt.TextInteractionFlags',),
    "PySide2.QtWidgets.QGraphicsTextItem.setTextWidth": ('float',),
    "PySide2.QtWidgets.QGraphicsTextItem.shape": (),
    "PySide2.QtWidgets.QGraphicsTextItem.tabChangesFocus": (),
    "PySide2.QtWidgets.QGraphicsTextItem.textCursor": (),
    "PySide2.QtWidgets.QGraphicsTextItem.textInteractionFlags": (),
    "PySide2.QtWidgets.QGraphicsTextItem.textWidth": (),
    "PySide2.QtWidgets.QGraphicsTextItem.toHtml": (),
    "PySide2.QtWidgets.QGraphicsTextItem.toPlainText": (),
    "PySide2.QtWidgets.QGraphicsTextItem.type": (),

# class PySide2.QtWidgets.QGraphicsTransform:
    "PySide2.QtWidgets.QGraphicsTransform.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QGraphicsTransform.applyTo": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtWidgets.QGraphicsTransform.update": (),

# class PySide2.QtWidgets.QGraphicsView:

# class PySide2.QtWidgets.QGraphicsView.CacheMode:

# class PySide2.QtWidgets.QGraphicsView.CacheModeFlag:

# class PySide2.QtWidgets.QGraphicsView.DragMode:

# class PySide2.QtWidgets.QGraphicsView.OptimizationFlag:

# class PySide2.QtWidgets.QGraphicsView.OptimizationFlags:

# class PySide2.QtWidgets.QGraphicsView.ViewportAnchor:

# class PySide2.QtWidgets.QGraphicsView.ViewportUpdateMode:
    "PySide2.QtWidgets.QGraphicsView.__init__": [('PySide2.QtWidgets.QGraphicsScene', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QGraphicsView.alignment": (),
    "PySide2.QtWidgets.QGraphicsView.backgroundBrush": (),
    "PySide2.QtWidgets.QGraphicsView.cacheMode": (),
    "PySide2.QtWidgets.QGraphicsView.centerOn": [('PySide2.QtCore.QPointF',), ('PySide2.QtWidgets.QGraphicsItem',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsView.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QGraphicsView.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QGraphicsView.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QGraphicsView.dragMode": (),
    "PySide2.QtWidgets.QGraphicsView.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QGraphicsView.drawBackground": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF'),
    "PySide2.QtWidgets.QGraphicsView.drawForeground": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF'),
    "PySide2.QtWidgets.QGraphicsView.drawItems": ('PySide2.QtGui.QPainter', 'int', 'typing.Sequence[PySide2.QtWidgets.QGraphicsItem]', 'typing.Sequence[PySide2.QtWidgets.QStyleOptionGraphicsItem]'),
    "PySide2.QtWidgets.QGraphicsView.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QGraphicsView.ensureVisible": [('PySide2.QtCore.QRectF', 'int', 'int'), ('PySide2.QtWidgets.QGraphicsItem', 'int', 'int'), ('float', 'float', 'float', 'float', 'int', 'int')],
    "PySide2.QtWidgets.QGraphicsView.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsView.fitInView": [('PySide2.QtCore.QRectF', 'PySide2.QtCore.Qt.AspectRatioMode'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.AspectRatioMode'), ('float', 'float', 'float', 'float', 'PySide2.QtCore.Qt.AspectRatioMode')],
    "PySide2.QtWidgets.QGraphicsView.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsView.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QGraphicsView.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsView.foregroundBrush": (),
    "PySide2.QtWidgets.QGraphicsView.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QGraphicsView.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QGraphicsView.invalidateScene": ('PySide2.QtCore.QRectF', 'PySide2.QtWidgets.QGraphicsScene.SceneLayers'),
    "PySide2.QtWidgets.QGraphicsView.isInteractive": (),
    "PySide2.QtWidgets.QGraphicsView.isTransformed": (),
    "PySide2.QtWidgets.QGraphicsView.itemAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QGraphicsView.items": [(), ('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.ItemSelectionMode'), ('PySide2.QtGui.QPainterPath', 'PySide2.QtCore.Qt.ItemSelectionMode'), ('PySide2.QtGui.QPolygon', 'PySide2.QtCore.Qt.ItemSelectionMode'), ('int', 'int'), ('int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.ItemSelectionMode')],
    "PySide2.QtWidgets.QGraphicsView.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsView.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QGraphicsView.mapFromScene": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QRectF',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygonF',), ('float', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsView.mapToScene": [('PySide2.QtCore.QPoint',), ('PySide2.QtCore.QRect',), ('PySide2.QtGui.QPainterPath',), ('PySide2.QtGui.QPolygon',), ('int', 'int'), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QGraphicsView.matrix": (),
    "PySide2.QtWidgets.QGraphicsView.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGraphicsView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGraphicsView.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGraphicsView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGraphicsView.optimizationFlags": (),
    "PySide2.QtWidgets.QGraphicsView.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QGraphicsView.render": [('PySide2.QtGui.QPaintDevice', 'PySide2.QtCore.QPoint', 'PySide2.QtGui.QRegion', 'PySide2.QtWidgets.QWidget.RenderFlags'), ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.AspectRatioMode')],
    "PySide2.QtWidgets.QGraphicsView.renderHints": (),
    "PySide2.QtWidgets.QGraphicsView.resetCachedContent": (),
    "PySide2.QtWidgets.QGraphicsView.resetMatrix": (),
    "PySide2.QtWidgets.QGraphicsView.resetTransform": (),
    "PySide2.QtWidgets.QGraphicsView.resizeAnchor": (),
    "PySide2.QtWidgets.QGraphicsView.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QGraphicsView.rotate": ('float',),
    "PySide2.QtWidgets.QGraphicsView.rubberBandRect": (),
    "PySide2.QtWidgets.QGraphicsView.rubberBandSelectionMode": (),
    "PySide2.QtWidgets.QGraphicsView.scale": ('float', 'float'),
    "PySide2.QtWidgets.QGraphicsView.scene": (),
    "PySide2.QtWidgets.QGraphicsView.sceneRect": (),
    "PySide2.QtWidgets.QGraphicsView.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QGraphicsView.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QGraphicsView.setBackgroundBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QGraphicsView.setCacheMode": ('PySide2.QtWidgets.QGraphicsView.CacheMode',),
    "PySide2.QtWidgets.QGraphicsView.setDragMode": ('PySide2.QtWidgets.QGraphicsView.DragMode',),
    "PySide2.QtWidgets.QGraphicsView.setForegroundBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QGraphicsView.setInteractive": ('bool',),
    "PySide2.QtWidgets.QGraphicsView.setMatrix": ('PySide2.QtGui.QMatrix', 'bool'),
    "PySide2.QtWidgets.QGraphicsView.setOptimizationFlag": ('PySide2.QtWidgets.QGraphicsView.OptimizationFlag', 'bool'),
    "PySide2.QtWidgets.QGraphicsView.setOptimizationFlags": ('PySide2.QtWidgets.QGraphicsView.OptimizationFlags',),
    "PySide2.QtWidgets.QGraphicsView.setRenderHint": ('PySide2.QtGui.QPainter.RenderHint', 'bool'),
    "PySide2.QtWidgets.QGraphicsView.setRenderHints": ('PySide2.QtGui.QPainter.RenderHints',),
    "PySide2.QtWidgets.QGraphicsView.setResizeAnchor": ('PySide2.QtWidgets.QGraphicsView.ViewportAnchor',),
    "PySide2.QtWidgets.QGraphicsView.setRubberBandSelectionMode": ('PySide2.QtCore.Qt.ItemSelectionMode',),
    "PySide2.QtWidgets.QGraphicsView.setScene": ('PySide2.QtWidgets.QGraphicsScene',),
    "PySide2.QtWidgets.QGraphicsView.setSceneRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsView.setTransform": ('PySide2.QtGui.QTransform', 'bool'),
    "PySide2.QtWidgets.QGraphicsView.setTransformationAnchor": ('PySide2.QtWidgets.QGraphicsView.ViewportAnchor',),
    "PySide2.QtWidgets.QGraphicsView.setViewportUpdateMode": ('PySide2.QtWidgets.QGraphicsView.ViewportUpdateMode',),
    "PySide2.QtWidgets.QGraphicsView.setupViewport": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QGraphicsView.shear": ('float', 'float'),
    "PySide2.QtWidgets.QGraphicsView.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QGraphicsView.sizeHint": (),
    "PySide2.QtWidgets.QGraphicsView.transform": (),
    "PySide2.QtWidgets.QGraphicsView.transformationAnchor": (),
    "PySide2.QtWidgets.QGraphicsView.translate": ('float', 'float'),
    "PySide2.QtWidgets.QGraphicsView.updateScene": ('typing.Sequence[PySide2.QtCore.QRectF]',),
    "PySide2.QtWidgets.QGraphicsView.updateSceneRect": ('PySide2.QtCore.QRectF',),
    "PySide2.QtWidgets.QGraphicsView.viewportEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsView.viewportTransform": (),
    "PySide2.QtWidgets.QGraphicsView.viewportUpdateMode": (),
    "PySide2.QtWidgets.QGraphicsView.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QGraphicsWidget:
    "PySide2.QtWidgets.QGraphicsWidget.__init__": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QGraphicsWidget.actions": (),
    "PySide2.QtWidgets.QGraphicsWidget.addAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QGraphicsWidget.addActions": ('typing.Sequence[PySide2.QtWidgets.QAction]',),
    "PySide2.QtWidgets.QGraphicsWidget.adjustSize": (),
    "PySide2.QtWidgets.QGraphicsWidget.autoFillBackground": (),
    "PySide2.QtWidgets.QGraphicsWidget.boundingRect": (),
    "PySide2.QtWidgets.QGraphicsWidget.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.close": (),
    "PySide2.QtWidgets.QGraphicsWidget.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QGraphicsWidget.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.focusPolicy": (),
    "PySide2.QtWidgets.QGraphicsWidget.focusWidget": (),
    "PySide2.QtWidgets.QGraphicsWidget.font": (),
    "PySide2.QtWidgets.QGraphicsWidget.getContentsMargins": (),
    "PySide2.QtWidgets.QGraphicsWidget.getWindowFrameMargins": (),
    "PySide2.QtWidgets.QGraphicsWidget.grabKeyboardEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.grabMouseEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.grabShortcut": ('PySide2.QtGui.QKeySequence', 'PySide2.QtCore.Qt.ShortcutContext'),
    "PySide2.QtWidgets.QGraphicsWidget.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.hoverLeaveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.hoverMoveEvent": ('PySide2.QtWidgets.QGraphicsSceneHoverEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.initStyleOption": ('PySide2.QtWidgets.QStyleOption',),
    "PySide2.QtWidgets.QGraphicsWidget.insertAction": ('PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QAction'),
    "PySide2.QtWidgets.QGraphicsWidget.insertActions": ('PySide2.QtWidgets.QAction', 'typing.Sequence[PySide2.QtWidgets.QAction]'),
    "PySide2.QtWidgets.QGraphicsWidget.isActiveWindow": (),
    "PySide2.QtWidgets.QGraphicsWidget.itemChange": ('PySide2.QtWidgets.QGraphicsItem.GraphicsItemChange', 'typing.Any'),
    "PySide2.QtWidgets.QGraphicsWidget.layout": (),
    "PySide2.QtWidgets.QGraphicsWidget.layoutDirection": (),
    "PySide2.QtWidgets.QGraphicsWidget.moveEvent": ('PySide2.QtWidgets.QGraphicsSceneMoveEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsWidget.paintWindowFrame": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QGraphicsWidget.palette": (),
    "PySide2.QtWidgets.QGraphicsWidget.polishEvent": (),
    "PySide2.QtWidgets.QGraphicsWidget.propertyChange": ('str', 'typing.Any'),
    "PySide2.QtWidgets.QGraphicsWidget.rect": (),
    "PySide2.QtWidgets.QGraphicsWidget.releaseShortcut": ('int',),
    "PySide2.QtWidgets.QGraphicsWidget.removeAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QGraphicsWidget.resize": [('PySide2.QtCore.QSizeF',), ('float', 'float')],
    "PySide2.QtWidgets.QGraphicsWidget.resizeEvent": ('PySide2.QtWidgets.QGraphicsSceneResizeEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.sceneEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.setAttribute": ('PySide2.QtCore.Qt.WidgetAttribute', 'bool'),
    "PySide2.QtWidgets.QGraphicsWidget.setAutoFillBackground": ('bool',),
    "PySide2.QtWidgets.QGraphicsWidget.setContentsMargins": [('PySide2.QtCore.QMarginsF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsWidget.setFocusPolicy": ('PySide2.QtCore.Qt.FocusPolicy',),
    "PySide2.QtWidgets.QGraphicsWidget.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QGraphicsWidget.setGeometry": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsWidget.setLayout": ('PySide2.QtWidgets.QGraphicsLayout',),
    "PySide2.QtWidgets.QGraphicsWidget.setLayoutDirection": ('PySide2.QtCore.Qt.LayoutDirection',),
    "PySide2.QtWidgets.QGraphicsWidget.setPalette": ('PySide2.QtGui.QPalette',),
    "PySide2.QtWidgets.QGraphicsWidget.setShortcutAutoRepeat": ('int', 'bool'),
    "PySide2.QtWidgets.QGraphicsWidget.setShortcutEnabled": ('int', 'bool'),
    "PySide2.QtWidgets.QGraphicsWidget.setStyle": ('PySide2.QtWidgets.QStyle',),
    "PySide2.QtWidgets.QGraphicsWidget.setTabOrder": ('PySide2.QtWidgets.QGraphicsWidget', 'PySide2.QtWidgets.QGraphicsWidget'),
    "PySide2.QtWidgets.QGraphicsWidget.setWindowFlags": ('PySide2.QtCore.Qt.WindowFlags',),
    "PySide2.QtWidgets.QGraphicsWidget.setWindowFrameMargins": [('PySide2.QtCore.QMarginsF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtWidgets.QGraphicsWidget.setWindowTitle": ('str',),
    "PySide2.QtWidgets.QGraphicsWidget.shape": (),
    "PySide2.QtWidgets.QGraphicsWidget.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.size": (),
    "PySide2.QtWidgets.QGraphicsWidget.sizeHint": ('PySide2.QtCore.Qt.SizeHint', 'PySide2.QtCore.QSizeF'),
    "PySide2.QtWidgets.QGraphicsWidget.style": (),
    "PySide2.QtWidgets.QGraphicsWidget.testAttribute": ('PySide2.QtCore.Qt.WidgetAttribute',),
    "PySide2.QtWidgets.QGraphicsWidget.type": (),
    "PySide2.QtWidgets.QGraphicsWidget.ungrabKeyboardEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.ungrabMouseEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.unsetLayoutDirection": (),
    "PySide2.QtWidgets.QGraphicsWidget.unsetWindowFrameMargins": (),
    "PySide2.QtWidgets.QGraphicsWidget.updateGeometry": (),
    "PySide2.QtWidgets.QGraphicsWidget.windowFlags": (),
    "PySide2.QtWidgets.QGraphicsWidget.windowFrameEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGraphicsWidget.windowFrameGeometry": (),
    "PySide2.QtWidgets.QGraphicsWidget.windowFrameRect": (),
    "PySide2.QtWidgets.QGraphicsWidget.windowFrameSectionAt": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QGraphicsWidget.windowTitle": (),
    "PySide2.QtWidgets.QGraphicsWidget.windowType": (),

# class PySide2.QtWidgets.QGridLayout:
    "PySide2.QtWidgets.QGridLayout.__init__": [(), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QGridLayout.addItem": [('PySide2.QtWidgets.QLayoutItem',), ('PySide2.QtWidgets.QLayoutItem', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtWidgets.QGridLayout.addLayout": [('PySide2.QtWidgets.QLayout', 'int', 'int', 'PySide2.QtCore.Qt.Alignment'), ('PySide2.QtWidgets.QLayout', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtWidgets.QGridLayout.addWidget": [('PySide2.QtWidgets.QWidget',), ('PySide2.QtWidgets.QWidget', 'int', 'int', 'PySide2.QtCore.Qt.Alignment'), ('PySide2.QtWidgets.QWidget', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtWidgets.QGridLayout.cellRect": ('int', 'int'),
    "PySide2.QtWidgets.QGridLayout.columnCount": (),
    "PySide2.QtWidgets.QGridLayout.columnMinimumWidth": ('int',),
    "PySide2.QtWidgets.QGridLayout.columnStretch": ('int',),
    "PySide2.QtWidgets.QGridLayout.count": (),
    "PySide2.QtWidgets.QGridLayout.expandingDirections": (),
    "PySide2.QtWidgets.QGridLayout.getItemPosition": ('int',),
    "PySide2.QtWidgets.QGridLayout.hasHeightForWidth": (),
    "PySide2.QtWidgets.QGridLayout.heightForWidth": ('int',),
    "PySide2.QtWidgets.QGridLayout.horizontalSpacing": (),
    "PySide2.QtWidgets.QGridLayout.invalidate": (),
    "PySide2.QtWidgets.QGridLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QGridLayout.itemAtPosition": ('int', 'int'),
    "PySide2.QtWidgets.QGridLayout.maximumSize": (),
    "PySide2.QtWidgets.QGridLayout.minimumHeightForWidth": ('int',),
    "PySide2.QtWidgets.QGridLayout.minimumSize": (),
    "PySide2.QtWidgets.QGridLayout.originCorner": (),
    "PySide2.QtWidgets.QGridLayout.rowCount": (),
    "PySide2.QtWidgets.QGridLayout.rowMinimumHeight": ('int',),
    "PySide2.QtWidgets.QGridLayout.rowStretch": ('int',),
    "PySide2.QtWidgets.QGridLayout.setColumnMinimumWidth": ('int', 'int'),
    "PySide2.QtWidgets.QGridLayout.setColumnStretch": ('int', 'int'),
    "PySide2.QtWidgets.QGridLayout.setDefaultPositioning": ('int', 'PySide2.QtCore.Qt.Orientation'),
    "PySide2.QtWidgets.QGridLayout.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QGridLayout.setHorizontalSpacing": ('int',),
    "PySide2.QtWidgets.QGridLayout.setOriginCorner": ('PySide2.QtCore.Qt.Corner',),
    "PySide2.QtWidgets.QGridLayout.setRowMinimumHeight": ('int', 'int'),
    "PySide2.QtWidgets.QGridLayout.setRowStretch": ('int', 'int'),
    "PySide2.QtWidgets.QGridLayout.setSpacing": ('int',),
    "PySide2.QtWidgets.QGridLayout.setVerticalSpacing": ('int',),
    "PySide2.QtWidgets.QGridLayout.sizeHint": (),
    "PySide2.QtWidgets.QGridLayout.spacing": (),
    "PySide2.QtWidgets.QGridLayout.takeAt": ('int',),
    "PySide2.QtWidgets.QGridLayout.verticalSpacing": (),

# class PySide2.QtWidgets.QGroupBox:
    "PySide2.QtWidgets.QGroupBox.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QGroupBox.alignment": (),
    "PySide2.QtWidgets.QGroupBox.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGroupBox.childEvent": ('PySide2.QtCore.QChildEvent',),
    "PySide2.QtWidgets.QGroupBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QGroupBox.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QGroupBox.initStyleOption": ('PySide2.QtWidgets.QStyleOptionGroupBox',),
    "PySide2.QtWidgets.QGroupBox.isCheckable": (),
    "PySide2.QtWidgets.QGroupBox.isChecked": (),
    "PySide2.QtWidgets.QGroupBox.isFlat": (),
    "PySide2.QtWidgets.QGroupBox.minimumSizeHint": (),
    "PySide2.QtWidgets.QGroupBox.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGroupBox.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGroupBox.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QGroupBox.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QGroupBox.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QGroupBox.setAlignment": ('int',),
    "PySide2.QtWidgets.QGroupBox.setCheckable": ('bool',),
    "PySide2.QtWidgets.QGroupBox.setChecked": ('bool',),
    "PySide2.QtWidgets.QGroupBox.setFlat": ('bool',),
    "PySide2.QtWidgets.QGroupBox.setTitle": ('str',),
    "PySide2.QtWidgets.QGroupBox.title": (),

# class PySide2.QtWidgets.QHBoxLayout:
    "PySide2.QtWidgets.QHBoxLayout.__init__": [(), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QHeaderView:

# class PySide2.QtWidgets.QHeaderView.ResizeMode:
    "PySide2.QtWidgets.QHeaderView.__init__": ('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QHeaderView.cascadingSectionResizes": (),
    "PySide2.QtWidgets.QHeaderView.count": (),
    "PySide2.QtWidgets.QHeaderView.currentChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QHeaderView.dataChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex', 'typing.List[int]'),
    "PySide2.QtWidgets.QHeaderView.defaultAlignment": (),
    "PySide2.QtWidgets.QHeaderView.defaultSectionSize": (),
    "PySide2.QtWidgets.QHeaderView.doItemsLayout": (),
    "PySide2.QtWidgets.QHeaderView.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QHeaderView.headerDataChanged": ('PySide2.QtCore.Qt.Orientation', 'int', 'int'),
    "PySide2.QtWidgets.QHeaderView.hiddenSectionCount": (),
    "PySide2.QtWidgets.QHeaderView.hideSection": ('int',),
    "PySide2.QtWidgets.QHeaderView.highlightSections": (),
    "PySide2.QtWidgets.QHeaderView.horizontalOffset": (),
    "PySide2.QtWidgets.QHeaderView.indexAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QHeaderView.initStyleOption": [('PySide2.QtWidgets.QStyleOptionFrame',), ('PySide2.QtWidgets.QStyleOptionHeader',)],
    "PySide2.QtWidgets.QHeaderView.initialize": (),
    "PySide2.QtWidgets.QHeaderView.initializeSections": [(), ('int', 'int')],
    "PySide2.QtWidgets.QHeaderView.isFirstSectionMovable": (),
    "PySide2.QtWidgets.QHeaderView.isIndexHidden": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QHeaderView.isSectionHidden": ('int',),
    "PySide2.QtWidgets.QHeaderView.isSortIndicatorShown": (),
    "PySide2.QtWidgets.QHeaderView.length": (),
    "PySide2.QtWidgets.QHeaderView.logicalIndex": ('int',),
    "PySide2.QtWidgets.QHeaderView.logicalIndexAt": [('PySide2.QtCore.QPoint',), ('int',), ('int', 'int')],
    "PySide2.QtWidgets.QHeaderView.maximumSectionSize": (),
    "PySide2.QtWidgets.QHeaderView.minimumSectionSize": (),
    "PySide2.QtWidgets.QHeaderView.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QHeaderView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QHeaderView.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QHeaderView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QHeaderView.moveCursor": ('PySide2.QtWidgets.QAbstractItemView.CursorAction', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtWidgets.QHeaderView.moveSection": ('int', 'int'),
    "PySide2.QtWidgets.QHeaderView.offset": (),
    "PySide2.QtWidgets.QHeaderView.orientation": (),
    "PySide2.QtWidgets.QHeaderView.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QHeaderView.paintSection": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'int'),
    "PySide2.QtWidgets.QHeaderView.reset": (),
    "PySide2.QtWidgets.QHeaderView.resetDefaultSectionSize": (),
    "PySide2.QtWidgets.QHeaderView.resizeContentsPrecision": (),
    "PySide2.QtWidgets.QHeaderView.resizeSection": ('int', 'int'),
    "PySide2.QtWidgets.QHeaderView.resizeSections": [(), ('PySide2.QtWidgets.QHeaderView.ResizeMode',)],
    "PySide2.QtWidgets.QHeaderView.restoreState": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWidgets.QHeaderView.rowsInserted": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QHeaderView.saveState": (),
    "PySide2.QtWidgets.QHeaderView.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QHeaderView.scrollTo": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QHeaderView.sectionPosition": ('int',),
    "PySide2.QtWidgets.QHeaderView.sectionResizeMode": ('int',),
    "PySide2.QtWidgets.QHeaderView.sectionSize": ('int',),
    "PySide2.QtWidgets.QHeaderView.sectionSizeFromContents": ('int',),
    "PySide2.QtWidgets.QHeaderView.sectionSizeHint": ('int',),
    "PySide2.QtWidgets.QHeaderView.sectionViewportPosition": ('int',),
    "PySide2.QtWidgets.QHeaderView.sectionsAboutToBeRemoved": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QHeaderView.sectionsClickable": (),
    "PySide2.QtWidgets.QHeaderView.sectionsHidden": (),
    "PySide2.QtWidgets.QHeaderView.sectionsInserted": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QHeaderView.sectionsMovable": (),
    "PySide2.QtWidgets.QHeaderView.sectionsMoved": (),
    "PySide2.QtWidgets.QHeaderView.setCascadingSectionResizes": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setDefaultAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QHeaderView.setDefaultSectionSize": ('int',),
    "PySide2.QtWidgets.QHeaderView.setFirstSectionMovable": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setHighlightSections": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setMaximumSectionSize": ('int',),
    "PySide2.QtWidgets.QHeaderView.setMinimumSectionSize": ('int',),
    "PySide2.QtWidgets.QHeaderView.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QHeaderView.setOffset": ('int',),
    "PySide2.QtWidgets.QHeaderView.setOffsetToLastSection": (),
    "PySide2.QtWidgets.QHeaderView.setOffsetToSectionPosition": ('int',),
    "PySide2.QtWidgets.QHeaderView.setResizeContentsPrecision": ('int',),
    "PySide2.QtWidgets.QHeaderView.setSectionHidden": ('int', 'bool'),
    "PySide2.QtWidgets.QHeaderView.setSectionResizeMode": [('PySide2.QtWidgets.QHeaderView.ResizeMode',), ('int', 'PySide2.QtWidgets.QHeaderView.ResizeMode')],
    "PySide2.QtWidgets.QHeaderView.setSectionsClickable": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setSectionsMovable": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setSelection": ('PySide2.QtCore.QRect', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtWidgets.QHeaderView.setSortIndicator": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtWidgets.QHeaderView.setSortIndicatorShown": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setStretchLastSection": ('bool',),
    "PySide2.QtWidgets.QHeaderView.setVisible": ('bool',),
    "PySide2.QtWidgets.QHeaderView.showSection": ('int',),
    "PySide2.QtWidgets.QHeaderView.sizeHint": (),
    "PySide2.QtWidgets.QHeaderView.sortIndicatorOrder": (),
    "PySide2.QtWidgets.QHeaderView.sortIndicatorSection": (),
    "PySide2.QtWidgets.QHeaderView.stretchLastSection": (),
    "PySide2.QtWidgets.QHeaderView.stretchSectionCount": (),
    "PySide2.QtWidgets.QHeaderView.swapSections": ('int', 'int'),
    "PySide2.QtWidgets.QHeaderView.updateGeometries": (),
    "PySide2.QtWidgets.QHeaderView.updateSection": ('int',),
    "PySide2.QtWidgets.QHeaderView.verticalOffset": (),
    "PySide2.QtWidgets.QHeaderView.viewportEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QHeaderView.visualIndex": ('int',),
    "PySide2.QtWidgets.QHeaderView.visualIndexAt": ('int',),
    "PySide2.QtWidgets.QHeaderView.visualRect": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QHeaderView.visualRegionForSelection": ('PySide2.QtCore.QItemSelection',),

# class PySide2.QtWidgets.QInputDialog:

# class PySide2.QtWidgets.QInputDialog.InputDialogOption:

# class PySide2.QtWidgets.QInputDialog.InputMode:
    "PySide2.QtWidgets.QInputDialog.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QInputDialog.cancelButtonText": (),
    "PySide2.QtWidgets.QInputDialog.comboBoxItems": (),
    "PySide2.QtWidgets.QInputDialog.done": ('int',),
    "PySide2.QtWidgets.QInputDialog.doubleDecimals": (),
    "PySide2.QtWidgets.QInputDialog.doubleMaximum": (),
    "PySide2.QtWidgets.QInputDialog.doubleMinimum": (),
    "PySide2.QtWidgets.QInputDialog.doubleStep": (),
    "PySide2.QtWidgets.QInputDialog.doubleValue": (),
    "PySide2.QtWidgets.QInputDialog.getDouble": [('PySide2.QtWidgets.QWidget', 'str', 'str', 'float', 'float', 'float', 'int', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget', 'str', 'str', 'float', 'float', 'float', 'int', 'PySide2.QtCore.Qt.WindowFlags', 'float')],
    "PySide2.QtWidgets.QInputDialog.getInt": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'int', 'int', 'int', 'int', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QInputDialog.getItem": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'typing.Sequence[str]', 'int', 'bool', 'PySide2.QtCore.Qt.WindowFlags', 'PySide2.QtCore.Qt.InputMethodHints'),
    "PySide2.QtWidgets.QInputDialog.getMultiLineText": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'str', 'PySide2.QtCore.Qt.WindowFlags', 'PySide2.QtCore.Qt.InputMethodHints'),
    "PySide2.QtWidgets.QInputDialog.getText": ('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QLineEdit.EchoMode', 'str', 'PySide2.QtCore.Qt.WindowFlags', 'PySide2.QtCore.Qt.InputMethodHints'),
    "PySide2.QtWidgets.QInputDialog.inputMode": (),
    "PySide2.QtWidgets.QInputDialog.intMaximum": (),
    "PySide2.QtWidgets.QInputDialog.intMinimum": (),
    "PySide2.QtWidgets.QInputDialog.intStep": (),
    "PySide2.QtWidgets.QInputDialog.intValue": (),
    "PySide2.QtWidgets.QInputDialog.isComboBoxEditable": (),
    "PySide2.QtWidgets.QInputDialog.labelText": (),
    "PySide2.QtWidgets.QInputDialog.minimumSizeHint": (),
    "PySide2.QtWidgets.QInputDialog.okButtonText": (),
    "PySide2.QtWidgets.QInputDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QInputDialog.setCancelButtonText": ('str',),
    "PySide2.QtWidgets.QInputDialog.setComboBoxEditable": ('bool',),
    "PySide2.QtWidgets.QInputDialog.setComboBoxItems": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QInputDialog.setDoubleDecimals": ('int',),
    "PySide2.QtWidgets.QInputDialog.setDoubleMaximum": ('float',),
    "PySide2.QtWidgets.QInputDialog.setDoubleMinimum": ('float',),
    "PySide2.QtWidgets.QInputDialog.setDoubleRange": ('float', 'float'),
    "PySide2.QtWidgets.QInputDialog.setDoubleStep": ('float',),
    "PySide2.QtWidgets.QInputDialog.setDoubleValue": ('float',),
    "PySide2.QtWidgets.QInputDialog.setInputMode": ('PySide2.QtWidgets.QInputDialog.InputMode',),
    "PySide2.QtWidgets.QInputDialog.setIntMaximum": ('int',),
    "PySide2.QtWidgets.QInputDialog.setIntMinimum": ('int',),
    "PySide2.QtWidgets.QInputDialog.setIntRange": ('int', 'int'),
    "PySide2.QtWidgets.QInputDialog.setIntStep": ('int',),
    "PySide2.QtWidgets.QInputDialog.setIntValue": ('int',),
    "PySide2.QtWidgets.QInputDialog.setLabelText": ('str',),
    "PySide2.QtWidgets.QInputDialog.setOkButtonText": ('str',),
    "PySide2.QtWidgets.QInputDialog.setOption": ('PySide2.QtWidgets.QInputDialog.InputDialogOption', 'bool'),
    "PySide2.QtWidgets.QInputDialog.setTextEchoMode": ('PySide2.QtWidgets.QLineEdit.EchoMode',),
    "PySide2.QtWidgets.QInputDialog.setTextValue": ('str',),
    "PySide2.QtWidgets.QInputDialog.setVisible": ('bool',),
    "PySide2.QtWidgets.QInputDialog.sizeHint": (),
    "PySide2.QtWidgets.QInputDialog.testOption": ('PySide2.QtWidgets.QInputDialog.InputDialogOption',),
    "PySide2.QtWidgets.QInputDialog.textEchoMode": (),
    "PySide2.QtWidgets.QInputDialog.textValue": (),

# class PySide2.QtWidgets.QItemDelegate:
    "PySide2.QtWidgets.QItemDelegate.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QItemDelegate.createEditor": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.decoration": ('PySide2.QtWidgets.QStyleOptionViewItem', 'typing.Any'),
    "PySide2.QtWidgets.QItemDelegate.doCheck": ('PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QRect', 'typing.Any'),
    "PySide2.QtWidgets.QItemDelegate.drawBackground": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.drawCheck": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QRect', 'PySide2.QtCore.Qt.CheckState'),
    "PySide2.QtWidgets.QItemDelegate.drawDecoration": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QItemDelegate.drawDisplay": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QRect', 'str'),
    "PySide2.QtWidgets.QItemDelegate.drawFocus": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QRect'),
    "PySide2.QtWidgets.QItemDelegate.editorEvent": ('PySide2.QtCore.QEvent', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QItemDelegate.hasClipping": (),
    "PySide2.QtWidgets.QItemDelegate.itemEditorFactory": (),
    "PySide2.QtWidgets.QItemDelegate.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.rect": ('PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtWidgets.QItemDelegate.selectedPixmap": ('PySide2.QtGui.QPixmap', 'PySide2.QtGui.QPalette', 'bool'),
    "PySide2.QtWidgets.QItemDelegate.setClipping": ('bool',),
    "PySide2.QtWidgets.QItemDelegate.setEditorData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.setItemEditorFactory": ('PySide2.QtWidgets.QItemEditorFactory',),
    "PySide2.QtWidgets.QItemDelegate.setModelData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.setOptions": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QStyleOptionViewItem'),
    "PySide2.QtWidgets.QItemDelegate.sizeHint": ('PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QItemDelegate.textRectangle": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'PySide2.QtGui.QFont', 'str'),
    "PySide2.QtWidgets.QItemDelegate.updateEditorGeometry": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtWidgets.QItemEditorCreatorBase:
    "PySide2.QtWidgets.QItemEditorCreatorBase.__init__": (),
    "PySide2.QtWidgets.QItemEditorCreatorBase.createWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QItemEditorCreatorBase.valuePropertyName": (),

# class PySide2.QtWidgets.QItemEditorFactory:
    "PySide2.QtWidgets.QItemEditorFactory.__init__": (),
    "PySide2.QtWidgets.QItemEditorFactory.createEditor": ('int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QItemEditorFactory.defaultFactory": (),
    "PySide2.QtWidgets.QItemEditorFactory.registerEditor": ('int', 'PySide2.QtWidgets.QItemEditorCreatorBase'),
    "PySide2.QtWidgets.QItemEditorFactory.setDefaultFactory": ('PySide2.QtWidgets.QItemEditorFactory',),
    "PySide2.QtWidgets.QItemEditorFactory.valuePropertyName": ('int',),

# class PySide2.QtWidgets.QKeyEventTransition:
    "PySide2.QtWidgets.QKeyEventTransition.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent.Type', 'int', 'PySide2.QtCore.QState'), ('PySide2.QtCore.QState',)],
    "PySide2.QtWidgets.QKeyEventTransition.eventTest": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QKeyEventTransition.key": (),
    "PySide2.QtWidgets.QKeyEventTransition.modifierMask": (),
    "PySide2.QtWidgets.QKeyEventTransition.onTransition": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QKeyEventTransition.setKey": ('int',),
    "PySide2.QtWidgets.QKeyEventTransition.setModifierMask": ('PySide2.QtCore.Qt.KeyboardModifiers',),

# class PySide2.QtWidgets.QKeySequenceEdit:
    "PySide2.QtWidgets.QKeySequenceEdit.__init__": [('PySide2.QtGui.QKeySequence', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QKeySequenceEdit.clear": (),
    "PySide2.QtWidgets.QKeySequenceEdit.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QKeySequenceEdit.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QKeySequenceEdit.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QKeySequenceEdit.keySequence": (),
    "PySide2.QtWidgets.QKeySequenceEdit.setKeySequence": ('PySide2.QtGui.QKeySequence',),
    "PySide2.QtWidgets.QKeySequenceEdit.timerEvent": ('PySide2.QtCore.QTimerEvent',),

# class PySide2.QtWidgets.QLCDNumber:

# class PySide2.QtWidgets.QLCDNumber.Mode:

# class PySide2.QtWidgets.QLCDNumber.SegmentStyle:
    "PySide2.QtWidgets.QLCDNumber.__init__": [('PySide2.QtWidgets.QWidget',), ('int', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QLCDNumber.checkOverflow": [('float',), ('int',)],
    "PySide2.QtWidgets.QLCDNumber.digitCount": (),
    "PySide2.QtWidgets.QLCDNumber.display": [('float',), ('int',), ('str',)],
    "PySide2.QtWidgets.QLCDNumber.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QLCDNumber.intValue": (),
    "PySide2.QtWidgets.QLCDNumber.mode": (),
    "PySide2.QtWidgets.QLCDNumber.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QLCDNumber.segmentStyle": (),
    "PySide2.QtWidgets.QLCDNumber.setBinMode": (),
    "PySide2.QtWidgets.QLCDNumber.setDecMode": (),
    "PySide2.QtWidgets.QLCDNumber.setDigitCount": ('int',),
    "PySide2.QtWidgets.QLCDNumber.setHexMode": (),
    "PySide2.QtWidgets.QLCDNumber.setMode": ('PySide2.QtWidgets.QLCDNumber.Mode',),
    "PySide2.QtWidgets.QLCDNumber.setOctMode": (),
    "PySide2.QtWidgets.QLCDNumber.setSegmentStyle": ('PySide2.QtWidgets.QLCDNumber.SegmentStyle',),
    "PySide2.QtWidgets.QLCDNumber.setSmallDecimalPoint": ('bool',),
    "PySide2.QtWidgets.QLCDNumber.sizeHint": (),
    "PySide2.QtWidgets.QLCDNumber.smallDecimalPoint": (),
    "PySide2.QtWidgets.QLCDNumber.value": (),

# class PySide2.QtWidgets.QLabel:
    "PySide2.QtWidgets.QLabel.__init__": [('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('str', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtWidgets.QLabel.alignment": (),
    "PySide2.QtWidgets.QLabel.buddy": (),
    "PySide2.QtWidgets.QLabel.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QLabel.clear": (),
    "PySide2.QtWidgets.QLabel.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QLabel.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QLabel.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QLabel.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QLabel.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QLabel.hasScaledContents": (),
    "PySide2.QtWidgets.QLabel.hasSelectedText": (),
    "PySide2.QtWidgets.QLabel.heightForWidth": ('int',),
    "PySide2.QtWidgets.QLabel.indent": (),
    "PySide2.QtWidgets.QLabel.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QLabel.margin": (),
    "PySide2.QtWidgets.QLabel.minimumSizeHint": (),
    "PySide2.QtWidgets.QLabel.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLabel.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLabel.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLabel.movie": (),
    "PySide2.QtWidgets.QLabel.openExternalLinks": (),
    "PySide2.QtWidgets.QLabel.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QLabel.picture": (),
    "PySide2.QtWidgets.QLabel.pixmap": (),
    "PySide2.QtWidgets.QLabel.selectedText": (),
    "PySide2.QtWidgets.QLabel.selectionStart": (),
    "PySide2.QtWidgets.QLabel.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QLabel.setBuddy": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QLabel.setIndent": ('int',),
    "PySide2.QtWidgets.QLabel.setMargin": ('int',),
    "PySide2.QtWidgets.QLabel.setMovie": ('PySide2.QtGui.QMovie',),
    "PySide2.QtWidgets.QLabel.setNum": [('float',), ('int',)],
    "PySide2.QtWidgets.QLabel.setOpenExternalLinks": ('bool',),
    "PySide2.QtWidgets.QLabel.setPicture": ('PySide2.QtGui.QPicture',),
    "PySide2.QtWidgets.QLabel.setPixmap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtWidgets.QLabel.setScaledContents": ('bool',),
    "PySide2.QtWidgets.QLabel.setSelection": ('int', 'int'),
    "PySide2.QtWidgets.QLabel.setText": ('str',),
    "PySide2.QtWidgets.QLabel.setTextFormat": ('PySide2.QtCore.Qt.TextFormat',),
    "PySide2.QtWidgets.QLabel.setTextInteractionFlags": ('PySide2.QtCore.Qt.TextInteractionFlags',),
    "PySide2.QtWidgets.QLabel.setWordWrap": ('bool',),
    "PySide2.QtWidgets.QLabel.sizeHint": (),
    "PySide2.QtWidgets.QLabel.text": (),
    "PySide2.QtWidgets.QLabel.textFormat": (),
    "PySide2.QtWidgets.QLabel.textInteractionFlags": (),
    "PySide2.QtWidgets.QLabel.wordWrap": (),

# class PySide2.QtWidgets.QLayout:

# class PySide2.QtWidgets.QLayout.SizeConstraint:
    "PySide2.QtWidgets.QLayout.__init__": [(), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QLayout.activate": (),
    "PySide2.QtWidgets.QLayout.addChildLayout": ('PySide2.QtWidgets.QLayout',),
    "PySide2.QtWidgets.QLayout.addChildWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QLayout.addItem": ('PySide2.QtWidgets.QLayoutItem',),
    "PySide2.QtWidgets.QLayout.addWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QLayout.adoptLayout": ('PySide2.QtWidgets.QLayout',),
    "PySide2.QtWidgets.QLayout.alignmentRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QLayout.childEvent": ('PySide2.QtCore.QChildEvent',),
    "PySide2.QtWidgets.QLayout.closestAcceptableSize": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QSize'),
    "PySide2.QtWidgets.QLayout.contentsMargins": (),
    "PySide2.QtWidgets.QLayout.contentsRect": (),
    "PySide2.QtWidgets.QLayout.controlTypes": (),
    "PySide2.QtWidgets.QLayout.count": (),
    "PySide2.QtWidgets.QLayout.expandingDirections": (),
    "PySide2.QtWidgets.QLayout.geometry": (),
    "PySide2.QtWidgets.QLayout.getContentsMargins": (),
    "PySide2.QtWidgets.QLayout.indexOf": [('PySide2.QtWidgets.QLayoutItem',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QLayout.invalidate": (),
    "PySide2.QtWidgets.QLayout.isEmpty": (),
    "PySide2.QtWidgets.QLayout.isEnabled": (),
    "PySide2.QtWidgets.QLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QLayout.layout": (),
    "PySide2.QtWidgets.QLayout.margin": (),
    "PySide2.QtWidgets.QLayout.maximumSize": (),
    "PySide2.QtWidgets.QLayout.menuBar": (),
    "PySide2.QtWidgets.QLayout.minimumSize": (),
    "PySide2.QtWidgets.QLayout.parentWidget": (),
    "PySide2.QtWidgets.QLayout.removeItem": ('PySide2.QtWidgets.QLayoutItem',),
    "PySide2.QtWidgets.QLayout.removeWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QLayout.replaceWidget": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.FindChildOptions'),
    "PySide2.QtWidgets.QLayout.setAlignment": [('PySide2.QtCore.Qt.Alignment',), ('PySide2.QtWidgets.QLayout', 'PySide2.QtCore.Qt.Alignment'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtWidgets.QLayout.setContentsMargins": [('PySide2.QtCore.QMargins',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QLayout.setEnabled": ('bool',),
    "PySide2.QtWidgets.QLayout.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QLayout.setMargin": ('int',),
    "PySide2.QtWidgets.QLayout.setMenuBar": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QLayout.setSizeConstraint": ('PySide2.QtWidgets.QLayout.SizeConstraint',),
    "PySide2.QtWidgets.QLayout.setSpacing": ('int',),
    "PySide2.QtWidgets.QLayout.sizeConstraint": (),
    "PySide2.QtWidgets.QLayout.spacing": (),
    "PySide2.QtWidgets.QLayout.takeAt": ('int',),
    "PySide2.QtWidgets.QLayout.totalHeightForWidth": ('int',),
    "PySide2.QtWidgets.QLayout.totalMaximumSize": (),
    "PySide2.QtWidgets.QLayout.totalMinimumSize": (),
    "PySide2.QtWidgets.QLayout.totalSizeHint": (),
    "PySide2.QtWidgets.QLayout.update": (),
    "PySide2.QtWidgets.QLayout.widgetEvent": ('PySide2.QtCore.QEvent',),

# class PySide2.QtWidgets.QLayoutItem:
    "PySide2.QtWidgets.QLayoutItem.__init__": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QLayoutItem.alignment": (),
    "PySide2.QtWidgets.QLayoutItem.controlTypes": (),
    "PySide2.QtWidgets.QLayoutItem.expandingDirections": (),
    "PySide2.QtWidgets.QLayoutItem.geometry": (),
    "PySide2.QtWidgets.QLayoutItem.hasHeightForWidth": (),
    "PySide2.QtWidgets.QLayoutItem.heightForWidth": ('int',),
    "PySide2.QtWidgets.QLayoutItem.invalidate": (),
    "PySide2.QtWidgets.QLayoutItem.isEmpty": (),
    "PySide2.QtWidgets.QLayoutItem.layout": (),
    "PySide2.QtWidgets.QLayoutItem.maximumSize": (),
    "PySide2.QtWidgets.QLayoutItem.minimumHeightForWidth": ('int',),
    "PySide2.QtWidgets.QLayoutItem.minimumSize": (),
    "PySide2.QtWidgets.QLayoutItem.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QLayoutItem.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QLayoutItem.sizeHint": (),
    "PySide2.QtWidgets.QLayoutItem.spacerItem": (),
    "PySide2.QtWidgets.QLayoutItem.widget": (),

# class PySide2.QtWidgets.QLineEdit:

# class PySide2.QtWidgets.QLineEdit.ActionPosition:

# class PySide2.QtWidgets.QLineEdit.EchoMode:
    "PySide2.QtWidgets.QLineEdit.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QLineEdit.addAction": [('PySide2.QtGui.QIcon', 'PySide2.QtWidgets.QLineEdit.ActionPosition'), ('PySide2.QtWidgets.QAction',), ('PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QLineEdit.ActionPosition')],
    "PySide2.QtWidgets.QLineEdit.alignment": (),
    "PySide2.QtWidgets.QLineEdit.backspace": (),
    "PySide2.QtWidgets.QLineEdit.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QLineEdit.clear": (),
    "PySide2.QtWidgets.QLineEdit.completer": (),
    "PySide2.QtWidgets.QLineEdit.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QLineEdit.copy": (),
    "PySide2.QtWidgets.QLineEdit.createStandardContextMenu": (),
    "PySide2.QtWidgets.QLineEdit.cursorBackward": ('bool', 'int'),
    "PySide2.QtWidgets.QLineEdit.cursorForward": ('bool', 'int'),
    "PySide2.QtWidgets.QLineEdit.cursorMoveStyle": (),
    "PySide2.QtWidgets.QLineEdit.cursorPosition": (),
    "PySide2.QtWidgets.QLineEdit.cursorPositionAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QLineEdit.cursorRect": (),
    "PySide2.QtWidgets.QLineEdit.cursorWordBackward": ('bool',),
    "PySide2.QtWidgets.QLineEdit.cursorWordForward": ('bool',),
    "PySide2.QtWidgets.QLineEdit.cut": (),
    "PySide2.QtWidgets.QLineEdit.del_": (),
    "PySide2.QtWidgets.QLineEdit.deselect": (),
    "PySide2.QtWidgets.QLineEdit.displayText": (),
    "PySide2.QtWidgets.QLineEdit.dragEnabled": (),
    "PySide2.QtWidgets.QLineEdit.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QLineEdit.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QLineEdit.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QLineEdit.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QLineEdit.echoMode": (),
    "PySide2.QtWidgets.QLineEdit.end": ('bool',),
    "PySide2.QtWidgets.QLineEdit.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QLineEdit.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QLineEdit.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QLineEdit.getTextMargins": (),
    "PySide2.QtWidgets.QLineEdit.hasAcceptableInput": (),
    "PySide2.QtWidgets.QLineEdit.hasFrame": (),
    "PySide2.QtWidgets.QLineEdit.hasSelectedText": (),
    "PySide2.QtWidgets.QLineEdit.home": ('bool',),
    "PySide2.QtWidgets.QLineEdit.initStyleOption": ('PySide2.QtWidgets.QStyleOptionFrame',),
    "PySide2.QtWidgets.QLineEdit.inputMask": (),
    "PySide2.QtWidgets.QLineEdit.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QLineEdit.inputMethodQuery": [('PySide2.QtCore.Qt.InputMethodQuery',), ('PySide2.QtCore.Qt.InputMethodQuery', 'typing.Any')],
    "PySide2.QtWidgets.QLineEdit.insert": ('str',),
    "PySide2.QtWidgets.QLineEdit.isClearButtonEnabled": (),
    "PySide2.QtWidgets.QLineEdit.isModified": (),
    "PySide2.QtWidgets.QLineEdit.isReadOnly": (),
    "PySide2.QtWidgets.QLineEdit.isRedoAvailable": (),
    "PySide2.QtWidgets.QLineEdit.isUndoAvailable": (),
    "PySide2.QtWidgets.QLineEdit.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QLineEdit.maxLength": (),
    "PySide2.QtWidgets.QLineEdit.minimumSizeHint": (),
    "PySide2.QtWidgets.QLineEdit.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLineEdit.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLineEdit.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLineEdit.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QLineEdit.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QLineEdit.paste": (),
    "PySide2.QtWidgets.QLineEdit.placeholderText": (),
    "PySide2.QtWidgets.QLineEdit.redo": (),
    "PySide2.QtWidgets.QLineEdit.selectAll": (),
    "PySide2.QtWidgets.QLineEdit.selectedText": (),
    "PySide2.QtWidgets.QLineEdit.selectionEnd": (),
    "PySide2.QtWidgets.QLineEdit.selectionLength": (),
    "PySide2.QtWidgets.QLineEdit.selectionStart": (),
    "PySide2.QtWidgets.QLineEdit.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QLineEdit.setClearButtonEnabled": ('bool',),
    "PySide2.QtWidgets.QLineEdit.setCompleter": ('PySide2.QtWidgets.QCompleter',),
    "PySide2.QtWidgets.QLineEdit.setCursorMoveStyle": ('PySide2.QtCore.Qt.CursorMoveStyle',),
    "PySide2.QtWidgets.QLineEdit.setCursorPosition": ('int',),
    "PySide2.QtWidgets.QLineEdit.setDragEnabled": ('bool',),
    "PySide2.QtWidgets.QLineEdit.setEchoMode": ('PySide2.QtWidgets.QLineEdit.EchoMode',),
    "PySide2.QtWidgets.QLineEdit.setFrame": ('bool',),
    "PySide2.QtWidgets.QLineEdit.setInputMask": ('str',),
    "PySide2.QtWidgets.QLineEdit.setMaxLength": ('int',),
    "PySide2.QtWidgets.QLineEdit.setModified": ('bool',),
    "PySide2.QtWidgets.QLineEdit.setPlaceholderText": ('str',),
    "PySide2.QtWidgets.QLineEdit.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QLineEdit.setSelection": ('int', 'int'),
    "PySide2.QtWidgets.QLineEdit.setText": ('str',),
    "PySide2.QtWidgets.QLineEdit.setTextMargins": [('PySide2.QtCore.QMargins',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QLineEdit.setValidator": ('PySide2.QtGui.QValidator',),
    "PySide2.QtWidgets.QLineEdit.sizeHint": (),
    "PySide2.QtWidgets.QLineEdit.text": (),
    "PySide2.QtWidgets.QLineEdit.textMargins": (),
    "PySide2.QtWidgets.QLineEdit.undo": (),
    "PySide2.QtWidgets.QLineEdit.validator": (),

# class PySide2.QtWidgets.QListView:

# class PySide2.QtWidgets.QListView.Flow:

# class PySide2.QtWidgets.QListView.LayoutMode:

# class PySide2.QtWidgets.QListView.Movement:

# class PySide2.QtWidgets.QListView.ResizeMode:

# class PySide2.QtWidgets.QListView.ViewMode:
    "PySide2.QtWidgets.QListView.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QListView.batchSize": (),
    "PySide2.QtWidgets.QListView.clearPropertyFlags": (),
    "PySide2.QtWidgets.QListView.contentsSize": (),
    "PySide2.QtWidgets.QListView.currentChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QListView.dataChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex', 'typing.List[int]'),
    "PySide2.QtWidgets.QListView.doItemsLayout": (),
    "PySide2.QtWidgets.QListView.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QListView.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QListView.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QListView.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QListView.flow": (),
    "PySide2.QtWidgets.QListView.gridSize": (),
    "PySide2.QtWidgets.QListView.horizontalOffset": (),
    "PySide2.QtWidgets.QListView.indexAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QListView.isIndexHidden": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QListView.isRowHidden": ('int',),
    "PySide2.QtWidgets.QListView.isSelectionRectVisible": (),
    "PySide2.QtWidgets.QListView.isWrapping": (),
    "PySide2.QtWidgets.QListView.itemAlignment": (),
    "PySide2.QtWidgets.QListView.layoutMode": (),
    "PySide2.QtWidgets.QListView.modelColumn": (),
    "PySide2.QtWidgets.QListView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QListView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QListView.moveCursor": ('PySide2.QtWidgets.QAbstractItemView.CursorAction', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtWidgets.QListView.movement": (),
    "PySide2.QtWidgets.QListView.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QListView.rectForIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QListView.reset": (),
    "PySide2.QtWidgets.QListView.resizeContents": ('int', 'int'),
    "PySide2.QtWidgets.QListView.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QListView.resizeMode": (),
    "PySide2.QtWidgets.QListView.rowsAboutToBeRemoved": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QListView.rowsInserted": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QListView.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QListView.scrollTo": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QListView.selectedIndexes": (),
    "PySide2.QtWidgets.QListView.selectionChanged": ('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelection'),
    "PySide2.QtWidgets.QListView.setBatchSize": ('int',),
    "PySide2.QtWidgets.QListView.setFlow": ('PySide2.QtWidgets.QListView.Flow',),
    "PySide2.QtWidgets.QListView.setGridSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QListView.setItemAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QListView.setLayoutMode": ('PySide2.QtWidgets.QListView.LayoutMode',),
    "PySide2.QtWidgets.QListView.setModelColumn": ('int',),
    "PySide2.QtWidgets.QListView.setMovement": ('PySide2.QtWidgets.QListView.Movement',),
    "PySide2.QtWidgets.QListView.setPositionForIndex": ('PySide2.QtCore.QPoint', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QListView.setResizeMode": ('PySide2.QtWidgets.QListView.ResizeMode',),
    "PySide2.QtWidgets.QListView.setRootIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QListView.setRowHidden": ('int', 'bool'),
    "PySide2.QtWidgets.QListView.setSelection": ('PySide2.QtCore.QRect', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtWidgets.QListView.setSelectionRectVisible": ('bool',),
    "PySide2.QtWidgets.QListView.setSpacing": ('int',),
    "PySide2.QtWidgets.QListView.setUniformItemSizes": ('bool',),
    "PySide2.QtWidgets.QListView.setViewMode": ('PySide2.QtWidgets.QListView.ViewMode',),
    "PySide2.QtWidgets.QListView.setWordWrap": ('bool',),
    "PySide2.QtWidgets.QListView.setWrapping": ('bool',),
    "PySide2.QtWidgets.QListView.spacing": (),
    "PySide2.QtWidgets.QListView.startDrag": ('PySide2.QtCore.Qt.DropActions',),
    "PySide2.QtWidgets.QListView.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QListView.uniformItemSizes": (),
    "PySide2.QtWidgets.QListView.updateGeometries": (),
    "PySide2.QtWidgets.QListView.verticalOffset": (),
    "PySide2.QtWidgets.QListView.viewMode": (),
    "PySide2.QtWidgets.QListView.viewOptions": (),
    "PySide2.QtWidgets.QListView.viewportSizeHint": (),
    "PySide2.QtWidgets.QListView.visualRect": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QListView.visualRegionForSelection": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtWidgets.QListView.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtWidgets.QListView.wordWrap": (),

# class PySide2.QtWidgets.QListWidget:
    "PySide2.QtWidgets.QListWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QListWidget.addItem": [('PySide2.QtWidgets.QListWidgetItem',), ('str',)],
    "PySide2.QtWidgets.QListWidget.addItems": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QListWidget.clear": (),
    "PySide2.QtWidgets.QListWidget.closePersistentEditor": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QListWidgetItem',)],
    "PySide2.QtWidgets.QListWidget.count": (),
    "PySide2.QtWidgets.QListWidget.currentItem": (),
    "PySide2.QtWidgets.QListWidget.currentRow": (),
    "PySide2.QtWidgets.QListWidget.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QListWidget.dropMimeData": ('int', 'PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction'),
    "PySide2.QtWidgets.QListWidget.editItem": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QListWidget.findItems": ('str', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtWidgets.QListWidget.indexFromItem": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.insertItem": [('int', 'PySide2.QtWidgets.QListWidgetItem'), ('int', 'str')],
    "PySide2.QtWidgets.QListWidget.insertItems": ('int', 'typing.Sequence[str]'),
    "PySide2.QtWidgets.QListWidget.isItemHidden": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.isItemSelected": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.isPersistentEditorOpen": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QListWidgetItem',)],
    "PySide2.QtWidgets.QListWidget.isSortingEnabled": (),
    "PySide2.QtWidgets.QListWidget.item": ('int',),
    "PySide2.QtWidgets.QListWidget.itemAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QListWidget.itemFromIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QListWidget.itemWidget": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.items": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QListWidget.mimeData": ('typing.Sequence[PySide2.QtWidgets.QListWidgetItem]',),
    "PySide2.QtWidgets.QListWidget.mimeTypes": (),
    "PySide2.QtWidgets.QListWidget.openPersistentEditor": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QListWidgetItem',)],
    "PySide2.QtWidgets.QListWidget.removeItemWidget": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.row": ('PySide2.QtWidgets.QListWidgetItem',),
    "PySide2.QtWidgets.QListWidget.scrollToItem": ('PySide2.QtWidgets.QListWidgetItem', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QListWidget.selectedItems": (),
    "PySide2.QtWidgets.QListWidget.setCurrentItem": [('PySide2.QtWidgets.QListWidgetItem',), ('PySide2.QtWidgets.QListWidgetItem', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags')],
    "PySide2.QtWidgets.QListWidget.setCurrentRow": [('int',), ('int', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags')],
    "PySide2.QtWidgets.QListWidget.setItemHidden": ('PySide2.QtWidgets.QListWidgetItem', 'bool'),
    "PySide2.QtWidgets.QListWidget.setItemSelected": ('PySide2.QtWidgets.QListWidgetItem', 'bool'),
    "PySide2.QtWidgets.QListWidget.setItemWidget": ('PySide2.QtWidgets.QListWidgetItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QListWidget.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QListWidget.setSelectionModel": ('PySide2.QtCore.QItemSelectionModel',),
    "PySide2.QtWidgets.QListWidget.setSortingEnabled": ('bool',),
    "PySide2.QtWidgets.QListWidget.sortItems": ('PySide2.QtCore.Qt.SortOrder',),
    "PySide2.QtWidgets.QListWidget.supportedDropActions": (),
    "PySide2.QtWidgets.QListWidget.takeItem": ('int',),
    "PySide2.QtWidgets.QListWidget.visualItemRect": ('PySide2.QtWidgets.QListWidgetItem',),

# class PySide2.QtWidgets.QListWidgetItem:

# class PySide2.QtWidgets.QListWidgetItem.ItemType:
    "PySide2.QtWidgets.QListWidgetItem.__init__": [('PySide2.QtGui.QIcon', 'str', 'PySide2.QtWidgets.QListWidget', 'int'), ('PySide2.QtWidgets.QListWidget', 'int'), ('PySide2.QtWidgets.QListWidgetItem',), ('str', 'PySide2.QtWidgets.QListWidget', 'int')],
    "PySide2.QtWidgets.QListWidgetItem.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QListWidgetItem.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QListWidgetItem.background": (),
    "PySide2.QtWidgets.QListWidgetItem.backgroundColor": (),
    "PySide2.QtWidgets.QListWidgetItem.checkState": (),
    "PySide2.QtWidgets.QListWidgetItem.clone": (),
    "PySide2.QtWidgets.QListWidgetItem.data": ('int',),
    "PySide2.QtWidgets.QListWidgetItem.flags": (),
    "PySide2.QtWidgets.QListWidgetItem.font": (),
    "PySide2.QtWidgets.QListWidgetItem.foreground": (),
    "PySide2.QtWidgets.QListWidgetItem.icon": (),
    "PySide2.QtWidgets.QListWidgetItem.isHidden": (),
    "PySide2.QtWidgets.QListWidgetItem.isSelected": (),
    "PySide2.QtWidgets.QListWidgetItem.listWidget": (),
    "PySide2.QtWidgets.QListWidgetItem.read": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QListWidgetItem.setBackground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QListWidgetItem.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QListWidgetItem.setCheckState": ('PySide2.QtCore.Qt.CheckState',),
    "PySide2.QtWidgets.QListWidgetItem.setData": ('int', 'typing.Any'),
    "PySide2.QtWidgets.QListWidgetItem.setFlags": ('PySide2.QtCore.Qt.ItemFlags',),
    "PySide2.QtWidgets.QListWidgetItem.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QListWidgetItem.setForeground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QListWidgetItem.setHidden": ('bool',),
    "PySide2.QtWidgets.QListWidgetItem.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QListWidgetItem.setSelected": ('bool',),
    "PySide2.QtWidgets.QListWidgetItem.setSizeHint": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QListWidgetItem.setStatusTip": ('str',),
    "PySide2.QtWidgets.QListWidgetItem.setText": ('str',),
    "PySide2.QtWidgets.QListWidgetItem.setTextAlignment": ('int',),
    "PySide2.QtWidgets.QListWidgetItem.setTextColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QListWidgetItem.setToolTip": ('str',),
    "PySide2.QtWidgets.QListWidgetItem.setWhatsThis": ('str',),
    "PySide2.QtWidgets.QListWidgetItem.sizeHint": (),
    "PySide2.QtWidgets.QListWidgetItem.statusTip": (),
    "PySide2.QtWidgets.QListWidgetItem.text": (),
    "PySide2.QtWidgets.QListWidgetItem.textAlignment": (),
    "PySide2.QtWidgets.QListWidgetItem.textColor": (),
    "PySide2.QtWidgets.QListWidgetItem.toolTip": (),
    "PySide2.QtWidgets.QListWidgetItem.type": (),
    "PySide2.QtWidgets.QListWidgetItem.whatsThis": (),
    "PySide2.QtWidgets.QListWidgetItem.write": ('PySide2.QtCore.QDataStream',),

# class PySide2.QtWidgets.QMainWindow:

# class PySide2.QtWidgets.QMainWindow.DockOption:

# class PySide2.QtWidgets.QMainWindow.DockOptions:
    "PySide2.QtWidgets.QMainWindow.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QMainWindow.addDockWidget": [('PySide2.QtCore.Qt.DockWidgetArea', 'PySide2.QtWidgets.QDockWidget'), ('PySide2.QtCore.Qt.DockWidgetArea', 'PySide2.QtWidgets.QDockWidget', 'PySide2.QtCore.Qt.Orientation')],
    "PySide2.QtWidgets.QMainWindow.addToolBar": [('PySide2.QtCore.Qt.ToolBarArea', 'PySide2.QtWidgets.QToolBar'), ('PySide2.QtWidgets.QToolBar',), ('str',)],
    "PySide2.QtWidgets.QMainWindow.addToolBarBreak": ('PySide2.QtCore.Qt.ToolBarArea',),
    "PySide2.QtWidgets.QMainWindow.centralWidget": (),
    "PySide2.QtWidgets.QMainWindow.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QMainWindow.corner": ('PySide2.QtCore.Qt.Corner',),
    "PySide2.QtWidgets.QMainWindow.createPopupMenu": (),
    "PySide2.QtWidgets.QMainWindow.dockOptions": (),
    "PySide2.QtWidgets.QMainWindow.dockWidgetArea": ('PySide2.QtWidgets.QDockWidget',),
    "PySide2.QtWidgets.QMainWindow.documentMode": (),
    "PySide2.QtWidgets.QMainWindow.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMainWindow.iconSize": (),
    "PySide2.QtWidgets.QMainWindow.insertToolBar": ('PySide2.QtWidgets.QToolBar', 'PySide2.QtWidgets.QToolBar'),
    "PySide2.QtWidgets.QMainWindow.insertToolBarBreak": ('PySide2.QtWidgets.QToolBar',),
    "PySide2.QtWidgets.QMainWindow.isAnimated": (),
    "PySide2.QtWidgets.QMainWindow.isDockNestingEnabled": (),
    "PySide2.QtWidgets.QMainWindow.isSeparator": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QMainWindow.menuBar": (),
    "PySide2.QtWidgets.QMainWindow.menuWidget": (),
    "PySide2.QtWidgets.QMainWindow.removeDockWidget": ('PySide2.QtWidgets.QDockWidget',),
    "PySide2.QtWidgets.QMainWindow.removeToolBar": ('PySide2.QtWidgets.QToolBar',),
    "PySide2.QtWidgets.QMainWindow.removeToolBarBreak": ('PySide2.QtWidgets.QToolBar',),
    "PySide2.QtWidgets.QMainWindow.resizeDocks": ('typing.Sequence[PySide2.QtWidgets.QDockWidget]', 'typing.Sequence[int]', 'PySide2.QtCore.Qt.Orientation'),
    "PySide2.QtWidgets.QMainWindow.restoreDockWidget": ('PySide2.QtWidgets.QDockWidget',),
    "PySide2.QtWidgets.QMainWindow.restoreState": ('PySide2.QtCore.QByteArray', 'int'),
    "PySide2.QtWidgets.QMainWindow.saveState": ('int',),
    "PySide2.QtWidgets.QMainWindow.setAnimated": ('bool',),
    "PySide2.QtWidgets.QMainWindow.setCentralWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMainWindow.setCorner": ('PySide2.QtCore.Qt.Corner', 'PySide2.QtCore.Qt.DockWidgetArea'),
    "PySide2.QtWidgets.QMainWindow.setDockNestingEnabled": ('bool',),
    "PySide2.QtWidgets.QMainWindow.setDockOptions": ('PySide2.QtWidgets.QMainWindow.DockOptions',),
    "PySide2.QtWidgets.QMainWindow.setDocumentMode": ('bool',),
    "PySide2.QtWidgets.QMainWindow.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QMainWindow.setMenuBar": ('PySide2.QtWidgets.QMenuBar',),
    "PySide2.QtWidgets.QMainWindow.setMenuWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMainWindow.setStatusBar": ('PySide2.QtWidgets.QStatusBar',),
    "PySide2.QtWidgets.QMainWindow.setTabPosition": ('PySide2.QtCore.Qt.DockWidgetAreas', 'PySide2.QtWidgets.QTabWidget.TabPosition'),
    "PySide2.QtWidgets.QMainWindow.setTabShape": ('PySide2.QtWidgets.QTabWidget.TabShape',),
    "PySide2.QtWidgets.QMainWindow.setToolButtonStyle": ('PySide2.QtCore.Qt.ToolButtonStyle',),
    "PySide2.QtWidgets.QMainWindow.setUnifiedTitleAndToolBarOnMac": ('bool',),
    "PySide2.QtWidgets.QMainWindow.splitDockWidget": ('PySide2.QtWidgets.QDockWidget', 'PySide2.QtWidgets.QDockWidget', 'PySide2.QtCore.Qt.Orientation'),
    "PySide2.QtWidgets.QMainWindow.statusBar": (),
    "PySide2.QtWidgets.QMainWindow.tabPosition": ('PySide2.QtCore.Qt.DockWidgetArea',),
    "PySide2.QtWidgets.QMainWindow.tabShape": (),
    "PySide2.QtWidgets.QMainWindow.tabifiedDockWidgets": ('PySide2.QtWidgets.QDockWidget',),
    "PySide2.QtWidgets.QMainWindow.tabifyDockWidget": ('PySide2.QtWidgets.QDockWidget', 'PySide2.QtWidgets.QDockWidget'),
    "PySide2.QtWidgets.QMainWindow.takeCentralWidget": (),
    "PySide2.QtWidgets.QMainWindow.toolBarArea": ('PySide2.QtWidgets.QToolBar',),
    "PySide2.QtWidgets.QMainWindow.toolBarBreak": ('PySide2.QtWidgets.QToolBar',),
    "PySide2.QtWidgets.QMainWindow.toolButtonStyle": (),
    "PySide2.QtWidgets.QMainWindow.unifiedTitleAndToolBarOnMac": (),

# class PySide2.QtWidgets.QMdiArea:

# class PySide2.QtWidgets.QMdiArea.AreaOption:

# class PySide2.QtWidgets.QMdiArea.AreaOptions:

# class PySide2.QtWidgets.QMdiArea.ViewMode:

# class PySide2.QtWidgets.QMdiArea.WindowOrder:
    "PySide2.QtWidgets.QMdiArea.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMdiArea.activateNextSubWindow": (),
    "PySide2.QtWidgets.QMdiArea.activatePreviousSubWindow": (),
    "PySide2.QtWidgets.QMdiArea.activationOrder": (),
    "PySide2.QtWidgets.QMdiArea.activeSubWindow": (),
    "PySide2.QtWidgets.QMdiArea.addSubWindow": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QMdiArea.background": (),
    "PySide2.QtWidgets.QMdiArea.cascadeSubWindows": (),
    "PySide2.QtWidgets.QMdiArea.childEvent": ('PySide2.QtCore.QChildEvent',),
    "PySide2.QtWidgets.QMdiArea.closeActiveSubWindow": (),
    "PySide2.QtWidgets.QMdiArea.closeAllSubWindows": (),
    "PySide2.QtWidgets.QMdiArea.currentSubWindow": (),
    "PySide2.QtWidgets.QMdiArea.documentMode": (),
    "PySide2.QtWidgets.QMdiArea.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMdiArea.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QMdiArea.minimumSizeHint": (),
    "PySide2.QtWidgets.QMdiArea.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QMdiArea.removeSubWindow": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMdiArea.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QMdiArea.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QMdiArea.setActivationOrder": ('PySide2.QtWidgets.QMdiArea.WindowOrder',),
    "PySide2.QtWidgets.QMdiArea.setActiveSubWindow": ('PySide2.QtWidgets.QMdiSubWindow',),
    "PySide2.QtWidgets.QMdiArea.setBackground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QMdiArea.setDocumentMode": ('bool',),
    "PySide2.QtWidgets.QMdiArea.setOption": ('PySide2.QtWidgets.QMdiArea.AreaOption', 'bool'),
    "PySide2.QtWidgets.QMdiArea.setTabPosition": ('PySide2.QtWidgets.QTabWidget.TabPosition',),
    "PySide2.QtWidgets.QMdiArea.setTabShape": ('PySide2.QtWidgets.QTabWidget.TabShape',),
    "PySide2.QtWidgets.QMdiArea.setTabsClosable": ('bool',),
    "PySide2.QtWidgets.QMdiArea.setTabsMovable": ('bool',),
    "PySide2.QtWidgets.QMdiArea.setViewMode": ('PySide2.QtWidgets.QMdiArea.ViewMode',),
    "PySide2.QtWidgets.QMdiArea.setupViewport": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMdiArea.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QMdiArea.sizeHint": (),
    "PySide2.QtWidgets.QMdiArea.subWindowList": ('PySide2.QtWidgets.QMdiArea.WindowOrder',),
    "PySide2.QtWidgets.QMdiArea.tabPosition": (),
    "PySide2.QtWidgets.QMdiArea.tabShape": (),
    "PySide2.QtWidgets.QMdiArea.tabsClosable": (),
    "PySide2.QtWidgets.QMdiArea.tabsMovable": (),
    "PySide2.QtWidgets.QMdiArea.testOption": ('PySide2.QtWidgets.QMdiArea.AreaOption',),
    "PySide2.QtWidgets.QMdiArea.tileSubWindows": (),
    "PySide2.QtWidgets.QMdiArea.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QMdiArea.viewMode": (),
    "PySide2.QtWidgets.QMdiArea.viewportEvent": ('PySide2.QtCore.QEvent',),

# class PySide2.QtWidgets.QMdiSubWindow:

# class PySide2.QtWidgets.QMdiSubWindow.SubWindowOption:

# class PySide2.QtWidgets.QMdiSubWindow.SubWindowOptions:
    "PySide2.QtWidgets.QMdiSubWindow.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QMdiSubWindow.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.childEvent": ('PySide2.QtCore.QChildEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QMdiSubWindow.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.isShaded": (),
    "PySide2.QtWidgets.QMdiSubWindow.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.keyboardPageStep": (),
    "PySide2.QtWidgets.QMdiSubWindow.keyboardSingleStep": (),
    "PySide2.QtWidgets.QMdiSubWindow.leaveEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.maximizedButtonsWidget": (),
    "PySide2.QtWidgets.QMdiSubWindow.maximizedSystemMenuIconWidget": (),
    "PySide2.QtWidgets.QMdiSubWindow.mdiArea": (),
    "PySide2.QtWidgets.QMdiSubWindow.minimumSizeHint": (),
    "PySide2.QtWidgets.QMdiSubWindow.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.moveEvent": ('PySide2.QtGui.QMoveEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.setKeyboardPageStep": ('int',),
    "PySide2.QtWidgets.QMdiSubWindow.setKeyboardSingleStep": ('int',),
    "PySide2.QtWidgets.QMdiSubWindow.setOption": ('PySide2.QtWidgets.QMdiSubWindow.SubWindowOption', 'bool'),
    "PySide2.QtWidgets.QMdiSubWindow.setSystemMenu": ('PySide2.QtWidgets.QMenu',),
    "PySide2.QtWidgets.QMdiSubWindow.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMdiSubWindow.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.showShaded": (),
    "PySide2.QtWidgets.QMdiSubWindow.showSystemMenu": (),
    "PySide2.QtWidgets.QMdiSubWindow.sizeHint": (),
    "PySide2.QtWidgets.QMdiSubWindow.systemMenu": (),
    "PySide2.QtWidgets.QMdiSubWindow.testOption": ('PySide2.QtWidgets.QMdiSubWindow.SubWindowOption',),
    "PySide2.QtWidgets.QMdiSubWindow.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QMdiSubWindow.widget": (),

# class PySide2.QtWidgets.QMenu:
    "PySide2.QtWidgets.QMenu.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QMenu.actionAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QMenu.actionEvent": ('PySide2.QtGui.QActionEvent',),
    "PySide2.QtWidgets.QMenu.actionGeometry": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenu.activeAction": (),
    "PySide2.QtWidgets.QMenu.addAction": [('PySide2.QtGui.QIcon', 'str'), ('PySide2.QtGui.QIcon', 'str', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtGui.QKeySequence'), ('PySide2.QtGui.QIcon', 'str', 'object', 'PySide2.QtGui.QKeySequence'), ('PySide2.QtWidgets.QAction',), ('str',), ('str', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtGui.QKeySequence'), ('str', 'object', 'PySide2.QtGui.QKeySequence')],
    "PySide2.QtWidgets.QMenu.addMenu": [('PySide2.QtGui.QIcon', 'str'), ('PySide2.QtWidgets.QMenu',), ('str',)],
    "PySide2.QtWidgets.QMenu.addSection": [('PySide2.QtGui.QIcon', 'str'), ('str',)],
    "PySide2.QtWidgets.QMenu.addSeparator": (),
    "PySide2.QtWidgets.QMenu.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenu.clear": (),
    "PySide2.QtWidgets.QMenu.columnCount": (),
    "PySide2.QtWidgets.QMenu.defaultAction": (),
    "PySide2.QtWidgets.QMenu.enterEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenu.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenu.exec_": [(), ('PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QAction'), ('typing.Sequence[PySide2.QtWidgets.QAction]', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QMenu.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QMenu.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QMenu.hideTearOffMenu": (),
    "PySide2.QtWidgets.QMenu.icon": (),
    "PySide2.QtWidgets.QMenu.initStyleOption": ('PySide2.QtWidgets.QStyleOptionMenuItem', 'PySide2.QtWidgets.QAction'),
    "PySide2.QtWidgets.QMenu.insertMenu": ('PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QMenu'),
    "PySide2.QtWidgets.QMenu.insertSection": [('PySide2.QtWidgets.QAction', 'PySide2.QtGui.QIcon', 'str'), ('PySide2.QtWidgets.QAction', 'str')],
    "PySide2.QtWidgets.QMenu.insertSeparator": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenu.isEmpty": (),
    "PySide2.QtWidgets.QMenu.isTearOffEnabled": (),
    "PySide2.QtWidgets.QMenu.isTearOffMenuVisible": (),
    "PySide2.QtWidgets.QMenu.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QMenu.leaveEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenu.menuAction": (),
    "PySide2.QtWidgets.QMenu.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMenu.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMenu.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMenu.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QMenu.popup": ('PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QAction'),
    "PySide2.QtWidgets.QMenu.separatorsCollapsible": (),
    "PySide2.QtWidgets.QMenu.setActiveAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenu.setAsDockMenu": (),
    "PySide2.QtWidgets.QMenu.setDefaultAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenu.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QMenu.setSeparatorsCollapsible": ('bool',),
    "PySide2.QtWidgets.QMenu.setTearOffEnabled": ('bool',),
    "PySide2.QtWidgets.QMenu.setTitle": ('str',),
    "PySide2.QtWidgets.QMenu.setToolTipsVisible": ('bool',),
    "PySide2.QtWidgets.QMenu.showTearOffMenu": [(), ('PySide2.QtCore.QPoint',)],
    "PySide2.QtWidgets.QMenu.sizeHint": (),
    "PySide2.QtWidgets.QMenu.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QMenu.title": (),
    "PySide2.QtWidgets.QMenu.toolTipsVisible": (),
    "PySide2.QtWidgets.QMenu.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QMenuBar:
    "PySide2.QtWidgets.QMenuBar.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QMenuBar.actionAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QMenuBar.actionEvent": ('PySide2.QtGui.QActionEvent',),
    "PySide2.QtWidgets.QMenuBar.actionGeometry": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenuBar.activeAction": (),
    "PySide2.QtWidgets.QMenuBar.addAction": [('PySide2.QtWidgets.QAction',), ('str',), ('str', 'PySide2.QtCore.QObject', 'str'), ('str', 'object')],
    "PySide2.QtWidgets.QMenuBar.addMenu": [('PySide2.QtGui.QIcon', 'str'), ('PySide2.QtWidgets.QMenu',), ('str',)],
    "PySide2.QtWidgets.QMenuBar.addSeparator": (),
    "PySide2.QtWidgets.QMenuBar.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenuBar.clear": (),
    "PySide2.QtWidgets.QMenuBar.cornerWidget": ('PySide2.QtCore.Qt.Corner',),
    "PySide2.QtWidgets.QMenuBar.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenuBar.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QMenuBar.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QMenuBar.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QMenuBar.heightForWidth": ('int',),
    "PySide2.QtWidgets.QMenuBar.initStyleOption": ('PySide2.QtWidgets.QStyleOptionMenuItem', 'PySide2.QtWidgets.QAction'),
    "PySide2.QtWidgets.QMenuBar.insertMenu": ('PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QMenu'),
    "PySide2.QtWidgets.QMenuBar.insertSeparator": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenuBar.isDefaultUp": (),
    "PySide2.QtWidgets.QMenuBar.isNativeMenuBar": (),
    "PySide2.QtWidgets.QMenuBar.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QMenuBar.leaveEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMenuBar.minimumSizeHint": (),
    "PySide2.QtWidgets.QMenuBar.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMenuBar.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMenuBar.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QMenuBar.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QMenuBar.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QMenuBar.setActiveAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QMenuBar.setCornerWidget": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Corner'),
    "PySide2.QtWidgets.QMenuBar.setDefaultUp": ('bool',),
    "PySide2.QtWidgets.QMenuBar.setNativeMenuBar": ('bool',),
    "PySide2.QtWidgets.QMenuBar.setVisible": ('bool',),
    "PySide2.QtWidgets.QMenuBar.sizeHint": (),
    "PySide2.QtWidgets.QMenuBar.timerEvent": ('PySide2.QtCore.QTimerEvent',),

# class PySide2.QtWidgets.QMessageBox:

# class PySide2.QtWidgets.QMessageBox.ButtonRole:

# class PySide2.QtWidgets.QMessageBox.Icon:

# class PySide2.QtWidgets.QMessageBox.StandardButton:

# class PySide2.QtWidgets.QMessageBox.StandardButtons:
    "PySide2.QtWidgets.QMessageBox.__init__": [('PySide2.QtWidgets.QMessageBox.Icon', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButtons', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QMessageBox.about": ('PySide2.QtWidgets.QWidget', 'str', 'str'),
    "PySide2.QtWidgets.QMessageBox.aboutQt": ('PySide2.QtWidgets.QWidget', 'str'),
    "PySide2.QtWidgets.QMessageBox.addButton": [('PySide2.QtWidgets.QAbstractButton', 'PySide2.QtWidgets.QMessageBox.ButtonRole'), ('PySide2.QtWidgets.QMessageBox.StandardButton',), ('str', 'PySide2.QtWidgets.QMessageBox.ButtonRole')],
    "PySide2.QtWidgets.QMessageBox.button": ('PySide2.QtWidgets.QMessageBox.StandardButton',),
    "PySide2.QtWidgets.QMessageBox.buttonRole": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QMessageBox.buttonText": ('int',),
    "PySide2.QtWidgets.QMessageBox.buttons": (),
    "PySide2.QtWidgets.QMessageBox.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMessageBox.checkBox": (),
    "PySide2.QtWidgets.QMessageBox.clickedButton": (),
    "PySide2.QtWidgets.QMessageBox.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QMessageBox.critical": [('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButton', 'PySide2.QtWidgets.QMessageBox.StandardButton'), ('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButtons', 'PySide2.QtWidgets.QMessageBox.StandardButton')],
    "PySide2.QtWidgets.QMessageBox.defaultButton": (),
    "PySide2.QtWidgets.QMessageBox.detailedText": (),
    "PySide2.QtWidgets.QMessageBox.escapeButton": (),
    "PySide2.QtWidgets.QMessageBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMessageBox.icon": (),
    "PySide2.QtWidgets.QMessageBox.iconPixmap": (),
    "PySide2.QtWidgets.QMessageBox.information": [('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButton', 'PySide2.QtWidgets.QMessageBox.StandardButton'), ('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButtons', 'PySide2.QtWidgets.QMessageBox.StandardButton')],
    "PySide2.QtWidgets.QMessageBox.informativeText": (),
    "PySide2.QtWidgets.QMessageBox.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QMessageBox.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QMessageBox.question": [('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButton', 'PySide2.QtWidgets.QMessageBox.StandardButton'), ('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButtons', 'PySide2.QtWidgets.QMessageBox.StandardButton')],
    "PySide2.QtWidgets.QMessageBox.removeButton": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QMessageBox.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QMessageBox.setButtonText": ('int', 'str'),
    "PySide2.QtWidgets.QMessageBox.setCheckBox": ('PySide2.QtWidgets.QCheckBox',),
    "PySide2.QtWidgets.QMessageBox.setDefaultButton": [('PySide2.QtWidgets.QMessageBox.StandardButton',), ('PySide2.QtWidgets.QPushButton',)],
    "PySide2.QtWidgets.QMessageBox.setDetailedText": ('str',),
    "PySide2.QtWidgets.QMessageBox.setEscapeButton": [('PySide2.QtWidgets.QAbstractButton',), ('PySide2.QtWidgets.QMessageBox.StandardButton',)],
    "PySide2.QtWidgets.QMessageBox.setIcon": ('PySide2.QtWidgets.QMessageBox.Icon',),
    "PySide2.QtWidgets.QMessageBox.setIconPixmap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtWidgets.QMessageBox.setInformativeText": ('str',),
    "PySide2.QtWidgets.QMessageBox.setStandardButtons": ('PySide2.QtWidgets.QMessageBox.StandardButtons',),
    "PySide2.QtWidgets.QMessageBox.setText": ('str',),
    "PySide2.QtWidgets.QMessageBox.setTextFormat": ('PySide2.QtCore.Qt.TextFormat',),
    "PySide2.QtWidgets.QMessageBox.setTextInteractionFlags": ('PySide2.QtCore.Qt.TextInteractionFlags',),
    "PySide2.QtWidgets.QMessageBox.setWindowModality": ('PySide2.QtCore.Qt.WindowModality',),
    "PySide2.QtWidgets.QMessageBox.setWindowTitle": ('str',),
    "PySide2.QtWidgets.QMessageBox.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QMessageBox.standardButton": ('PySide2.QtWidgets.QAbstractButton',),
    "PySide2.QtWidgets.QMessageBox.standardButtons": (),
    "PySide2.QtWidgets.QMessageBox.standardIcon": ('PySide2.QtWidgets.QMessageBox.Icon',),
    "PySide2.QtWidgets.QMessageBox.text": (),
    "PySide2.QtWidgets.QMessageBox.textFormat": (),
    "PySide2.QtWidgets.QMessageBox.textInteractionFlags": (),
    "PySide2.QtWidgets.QMessageBox.warning": [('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButton', 'PySide2.QtWidgets.QMessageBox.StandardButton'), ('PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtWidgets.QMessageBox.StandardButtons', 'PySide2.QtWidgets.QMessageBox.StandardButton')],

# class PySide2.QtWidgets.QMouseEventTransition:
    "PySide2.QtWidgets.QMouseEventTransition.__init__": [('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent.Type', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.QState'), ('PySide2.QtCore.QState',)],
    "PySide2.QtWidgets.QMouseEventTransition.button": (),
    "PySide2.QtWidgets.QMouseEventTransition.eventTest": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMouseEventTransition.hitTestPath": (),
    "PySide2.QtWidgets.QMouseEventTransition.modifierMask": (),
    "PySide2.QtWidgets.QMouseEventTransition.onTransition": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QMouseEventTransition.setButton": ('PySide2.QtCore.Qt.MouseButton',),
    "PySide2.QtWidgets.QMouseEventTransition.setHitTestPath": ('PySide2.QtGui.QPainterPath',),
    "PySide2.QtWidgets.QMouseEventTransition.setModifierMask": ('PySide2.QtCore.Qt.KeyboardModifiers',),

# class PySide2.QtWidgets.QOpenGLWidget:

# class PySide2.QtWidgets.QOpenGLWidget.UpdateBehavior:
    "PySide2.QtWidgets.QOpenGLWidget.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QOpenGLWidget.context": (),
    "PySide2.QtWidgets.QOpenGLWidget.defaultFramebufferObject": (),
    "PySide2.QtWidgets.QOpenGLWidget.doneCurrent": (),
    "PySide2.QtWidgets.QOpenGLWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QOpenGLWidget.format": (),
    "PySide2.QtWidgets.QOpenGLWidget.grabFramebuffer": (),
    "PySide2.QtWidgets.QOpenGLWidget.initializeGL": (),
    "PySide2.QtWidgets.QOpenGLWidget.isValid": (),
    "PySide2.QtWidgets.QOpenGLWidget.makeCurrent": (),
    "PySide2.QtWidgets.QOpenGLWidget.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtWidgets.QOpenGLWidget.paintEngine": (),
    "PySide2.QtWidgets.QOpenGLWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QOpenGLWidget.paintGL": (),
    "PySide2.QtWidgets.QOpenGLWidget.redirected": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QOpenGLWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QOpenGLWidget.resizeGL": ('int', 'int'),
    "PySide2.QtWidgets.QOpenGLWidget.setFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtWidgets.QOpenGLWidget.setTextureFormat": ('int',),
    "PySide2.QtWidgets.QOpenGLWidget.setUpdateBehavior": ('PySide2.QtWidgets.QOpenGLWidget.UpdateBehavior',),
    "PySide2.QtWidgets.QOpenGLWidget.textureFormat": (),
    "PySide2.QtWidgets.QOpenGLWidget.updateBehavior": (),

# class PySide2.QtWidgets.QPanGesture:
    "PySide2.QtWidgets.QPanGesture.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QPanGesture.acceleration": (),
    "PySide2.QtWidgets.QPanGesture.delta": (),
    "PySide2.QtWidgets.QPanGesture.lastOffset": (),
    "PySide2.QtWidgets.QPanGesture.offset": (),
    "PySide2.QtWidgets.QPanGesture.setAcceleration": ('float',),
    "PySide2.QtWidgets.QPanGesture.setLastOffset": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QPanGesture.setOffset": ('PySide2.QtCore.QPointF',),

# class PySide2.QtWidgets.QPinchGesture:

# class PySide2.QtWidgets.QPinchGesture.ChangeFlag:

# class PySide2.QtWidgets.QPinchGesture.ChangeFlags:
    "PySide2.QtWidgets.QPinchGesture.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QPinchGesture.centerPoint": (),
    "PySide2.QtWidgets.QPinchGesture.changeFlags": (),
    "PySide2.QtWidgets.QPinchGesture.lastCenterPoint": (),
    "PySide2.QtWidgets.QPinchGesture.lastRotationAngle": (),
    "PySide2.QtWidgets.QPinchGesture.lastScaleFactor": (),
    "PySide2.QtWidgets.QPinchGesture.rotationAngle": (),
    "PySide2.QtWidgets.QPinchGesture.scaleFactor": (),
    "PySide2.QtWidgets.QPinchGesture.setCenterPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QPinchGesture.setChangeFlags": ('PySide2.QtWidgets.QPinchGesture.ChangeFlags',),
    "PySide2.QtWidgets.QPinchGesture.setLastCenterPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QPinchGesture.setLastRotationAngle": ('float',),
    "PySide2.QtWidgets.QPinchGesture.setLastScaleFactor": ('float',),
    "PySide2.QtWidgets.QPinchGesture.setRotationAngle": ('float',),
    "PySide2.QtWidgets.QPinchGesture.setScaleFactor": ('float',),
    "PySide2.QtWidgets.QPinchGesture.setStartCenterPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QPinchGesture.setTotalChangeFlags": ('PySide2.QtWidgets.QPinchGesture.ChangeFlags',),
    "PySide2.QtWidgets.QPinchGesture.setTotalRotationAngle": ('float',),
    "PySide2.QtWidgets.QPinchGesture.setTotalScaleFactor": ('float',),
    "PySide2.QtWidgets.QPinchGesture.startCenterPoint": (),
    "PySide2.QtWidgets.QPinchGesture.totalChangeFlags": (),
    "PySide2.QtWidgets.QPinchGesture.totalRotationAngle": (),
    "PySide2.QtWidgets.QPinchGesture.totalScaleFactor": (),

# class PySide2.QtWidgets.QPlainTextDocumentLayout:
    "PySide2.QtWidgets.QPlainTextDocumentLayout.__init__": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.blockBoundingRect": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.cursorWidth": (),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.documentChanged": ('int', 'int', 'int'),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.documentSize": (),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.draw": ('PySide2.QtGui.QPainter', 'PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext'),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.ensureBlockLayout": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.frameBoundingRect": ('PySide2.QtGui.QTextFrame',),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.hitTest": ('PySide2.QtCore.QPointF', 'PySide2.QtCore.Qt.HitTestAccuracy'),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.pageCount": (),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.requestUpdate": (),
    "PySide2.QtWidgets.QPlainTextDocumentLayout.setCursorWidth": ('int',),

# class PySide2.QtWidgets.QPlainTextEdit:

# class PySide2.QtWidgets.QPlainTextEdit.LineWrapMode:
    "PySide2.QtWidgets.QPlainTextEdit.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QPlainTextEdit.anchorAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QPlainTextEdit.appendHtml": ('str',),
    "PySide2.QtWidgets.QPlainTextEdit.appendPlainText": ('str',),
    "PySide2.QtWidgets.QPlainTextEdit.backgroundVisible": (),
    "PySide2.QtWidgets.QPlainTextEdit.blockBoundingGeometry": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtWidgets.QPlainTextEdit.blockBoundingRect": ('PySide2.QtGui.QTextBlock',),
    "PySide2.QtWidgets.QPlainTextEdit.blockCount": (),
    "PySide2.QtWidgets.QPlainTextEdit.canInsertFromMimeData": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QPlainTextEdit.canPaste": (),
    "PySide2.QtWidgets.QPlainTextEdit.centerCursor": (),
    "PySide2.QtWidgets.QPlainTextEdit.centerOnScroll": (),
    "PySide2.QtWidgets.QPlainTextEdit.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.clear": (),
    "PySide2.QtWidgets.QPlainTextEdit.contentOffset": (),
    "PySide2.QtWidgets.QPlainTextEdit.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.copy": (),
    "PySide2.QtWidgets.QPlainTextEdit.createMimeDataFromSelection": (),
    "PySide2.QtWidgets.QPlainTextEdit.createStandardContextMenu": [(), ('PySide2.QtCore.QPoint',)],
    "PySide2.QtWidgets.QPlainTextEdit.currentCharFormat": (),
    "PySide2.QtWidgets.QPlainTextEdit.cursorForPosition": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QPlainTextEdit.cursorRect": [(), ('PySide2.QtGui.QTextCursor',)],
    "PySide2.QtWidgets.QPlainTextEdit.cursorWidth": (),
    "PySide2.QtWidgets.QPlainTextEdit.cut": (),
    "PySide2.QtWidgets.QPlainTextEdit.doSetTextCursor": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtWidgets.QPlainTextEdit.document": (),
    "PySide2.QtWidgets.QPlainTextEdit.documentTitle": (),
    "PySide2.QtWidgets.QPlainTextEdit.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.ensureCursorVisible": (),
    "PySide2.QtWidgets.QPlainTextEdit.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.extraSelections": (),
    "PySide2.QtWidgets.QPlainTextEdit.find": [('PySide2.QtCore.QRegExp', 'PySide2.QtGui.QTextDocument.FindFlags'), ('PySide2.QtCore.QRegularExpression', 'PySide2.QtGui.QTextDocument.FindFlags'), ('str', 'PySide2.QtGui.QTextDocument.FindFlags')],
    "PySide2.QtWidgets.QPlainTextEdit.firstVisibleBlock": (),
    "PySide2.QtWidgets.QPlainTextEdit.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.getPaintContext": (),
    "PySide2.QtWidgets.QPlainTextEdit.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.inputMethodQuery": [('PySide2.QtCore.Qt.InputMethodQuery',), ('PySide2.QtCore.Qt.InputMethodQuery', 'typing.Any')],
    "PySide2.QtWidgets.QPlainTextEdit.insertFromMimeData": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QPlainTextEdit.insertPlainText": ('str',),
    "PySide2.QtWidgets.QPlainTextEdit.isReadOnly": (),
    "PySide2.QtWidgets.QPlainTextEdit.isUndoRedoEnabled": (),
    "PySide2.QtWidgets.QPlainTextEdit.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.lineWrapMode": (),
    "PySide2.QtWidgets.QPlainTextEdit.loadResource": ('int', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWidgets.QPlainTextEdit.maximumBlockCount": (),
    "PySide2.QtWidgets.QPlainTextEdit.mergeCurrentCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtWidgets.QPlainTextEdit.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.moveCursor": ('PySide2.QtGui.QTextCursor.MoveOperation', 'PySide2.QtGui.QTextCursor.MoveMode'),
    "PySide2.QtWidgets.QPlainTextEdit.overwriteMode": (),
    "PySide2.QtWidgets.QPlainTextEdit.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.paste": (),
    "PySide2.QtWidgets.QPlainTextEdit.placeholderText": (),
    "PySide2.QtWidgets.QPlainTextEdit.print_": ('PySide2.QtGui.QPagedPaintDevice',),
    "PySide2.QtWidgets.QPlainTextEdit.redo": (),
    "PySide2.QtWidgets.QPlainTextEdit.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QPlainTextEdit.selectAll": (),
    "PySide2.QtWidgets.QPlainTextEdit.setBackgroundVisible": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.setCenterOnScroll": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.setCurrentCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtWidgets.QPlainTextEdit.setCursorWidth": ('int',),
    "PySide2.QtWidgets.QPlainTextEdit.setDocument": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtWidgets.QPlainTextEdit.setDocumentTitle": ('str',),
    "PySide2.QtWidgets.QPlainTextEdit.setExtraSelections": ('typing.Sequence[PySide2.QtWidgets.QTextEdit.ExtraSelection]',),
    "PySide2.QtWidgets.QPlainTextEdit.setLineWrapMode": ('PySide2.QtWidgets.QPlainTextEdit.LineWrapMode',),
    "PySide2.QtWidgets.QPlainTextEdit.setMaximumBlockCount": ('int',),
    "PySide2.QtWidgets.QPlainTextEdit.setOverwriteMode": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.setPlaceholderText": ('str',),
    "PySide2.QtWidgets.QPlainTextEdit.setPlainText": ('str',),
    "PySide2.QtWidgets.QPlainTextEdit.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.setTabChangesFocus": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.setTabStopDistance": ('float',),
    "PySide2.QtWidgets.QPlainTextEdit.setTabStopWidth": ('int',),
    "PySide2.QtWidgets.QPlainTextEdit.setTextCursor": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtWidgets.QPlainTextEdit.setTextInteractionFlags": ('PySide2.QtCore.Qt.TextInteractionFlags',),
    "PySide2.QtWidgets.QPlainTextEdit.setUndoRedoEnabled": ('bool',),
    "PySide2.QtWidgets.QPlainTextEdit.setWordWrapMode": ('PySide2.QtGui.QTextOption.WrapMode',),
    "PySide2.QtWidgets.QPlainTextEdit.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.tabChangesFocus": (),
    "PySide2.QtWidgets.QPlainTextEdit.tabStopDistance": (),
    "PySide2.QtWidgets.QPlainTextEdit.tabStopWidth": (),
    "PySide2.QtWidgets.QPlainTextEdit.textCursor": (),
    "PySide2.QtWidgets.QPlainTextEdit.textInteractionFlags": (),
    "PySide2.QtWidgets.QPlainTextEdit.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.toPlainText": (),
    "PySide2.QtWidgets.QPlainTextEdit.undo": (),
    "PySide2.QtWidgets.QPlainTextEdit.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtWidgets.QPlainTextEdit.wordWrapMode": (),
    "PySide2.QtWidgets.QPlainTextEdit.zoomIn": ('int',),
    "PySide2.QtWidgets.QPlainTextEdit.zoomInF": ('float',),
    "PySide2.QtWidgets.QPlainTextEdit.zoomOut": ('int',),

# class PySide2.QtWidgets.QProgressBar:

# class PySide2.QtWidgets.QProgressBar.Direction:
    "PySide2.QtWidgets.QProgressBar.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QProgressBar.alignment": (),
    "PySide2.QtWidgets.QProgressBar.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QProgressBar.format": (),
    "PySide2.QtWidgets.QProgressBar.initStyleOption": ('PySide2.QtWidgets.QStyleOptionProgressBar',),
    "PySide2.QtWidgets.QProgressBar.invertedAppearance": (),
    "PySide2.QtWidgets.QProgressBar.isTextVisible": (),
    "PySide2.QtWidgets.QProgressBar.maximum": (),
    "PySide2.QtWidgets.QProgressBar.minimum": (),
    "PySide2.QtWidgets.QProgressBar.minimumSizeHint": (),
    "PySide2.QtWidgets.QProgressBar.orientation": (),
    "PySide2.QtWidgets.QProgressBar.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QProgressBar.reset": (),
    "PySide2.QtWidgets.QProgressBar.resetFormat": (),
    "PySide2.QtWidgets.QProgressBar.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QProgressBar.setFormat": ('str',),
    "PySide2.QtWidgets.QProgressBar.setInvertedAppearance": ('bool',),
    "PySide2.QtWidgets.QProgressBar.setMaximum": ('int',),
    "PySide2.QtWidgets.QProgressBar.setMinimum": ('int',),
    "PySide2.QtWidgets.QProgressBar.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QProgressBar.setRange": ('int', 'int'),
    "PySide2.QtWidgets.QProgressBar.setTextDirection": ('PySide2.QtWidgets.QProgressBar.Direction',),
    "PySide2.QtWidgets.QProgressBar.setTextVisible": ('bool',),
    "PySide2.QtWidgets.QProgressBar.setValue": ('int',),
    "PySide2.QtWidgets.QProgressBar.sizeHint": (),
    "PySide2.QtWidgets.QProgressBar.text": (),
    "PySide2.QtWidgets.QProgressBar.textDirection": (),
    "PySide2.QtWidgets.QProgressBar.value": (),

# class PySide2.QtWidgets.QProgressDialog:
    "PySide2.QtWidgets.QProgressDialog.__init__": [('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('str', 'str', 'int', 'int', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtWidgets.QProgressDialog.autoClose": (),
    "PySide2.QtWidgets.QProgressDialog.autoReset": (),
    "PySide2.QtWidgets.QProgressDialog.cancel": (),
    "PySide2.QtWidgets.QProgressDialog.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QProgressDialog.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QProgressDialog.forceShow": (),
    "PySide2.QtWidgets.QProgressDialog.labelText": (),
    "PySide2.QtWidgets.QProgressDialog.maximum": (),
    "PySide2.QtWidgets.QProgressDialog.minimum": (),
    "PySide2.QtWidgets.QProgressDialog.minimumDuration": (),
    "PySide2.QtWidgets.QProgressDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QProgressDialog.reset": (),
    "PySide2.QtWidgets.QProgressDialog.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QProgressDialog.setAutoClose": ('bool',),
    "PySide2.QtWidgets.QProgressDialog.setAutoReset": ('bool',),
    "PySide2.QtWidgets.QProgressDialog.setBar": ('PySide2.QtWidgets.QProgressBar',),
    "PySide2.QtWidgets.QProgressDialog.setCancelButton": ('PySide2.QtWidgets.QPushButton',),
    "PySide2.QtWidgets.QProgressDialog.setCancelButtonText": ('str',),
    "PySide2.QtWidgets.QProgressDialog.setLabel": ('PySide2.QtWidgets.QLabel',),
    "PySide2.QtWidgets.QProgressDialog.setLabelText": ('str',),
    "PySide2.QtWidgets.QProgressDialog.setMaximum": ('int',),
    "PySide2.QtWidgets.QProgressDialog.setMinimum": ('int',),
    "PySide2.QtWidgets.QProgressDialog.setMinimumDuration": ('int',),
    "PySide2.QtWidgets.QProgressDialog.setRange": ('int', 'int'),
    "PySide2.QtWidgets.QProgressDialog.setValue": ('int',),
    "PySide2.QtWidgets.QProgressDialog.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QProgressDialog.sizeHint": (),
    "PySide2.QtWidgets.QProgressDialog.value": (),
    "PySide2.QtWidgets.QProgressDialog.wasCanceled": (),

# class PySide2.QtWidgets.QProxyStyle:
    "PySide2.QtWidgets.QProxyStyle.__init__": [('PySide2.QtWidgets.QStyle',), ('str',)],
    "PySide2.QtWidgets.QProxyStyle.baseStyle": (),
    "PySide2.QtWidgets.QProxyStyle.drawComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.drawControl": ('PySide2.QtWidgets.QStyle.ControlElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.drawItemPixmap": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QProxyStyle.drawItemText": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPalette', 'bool', 'str', 'PySide2.QtGui.QPalette.ColorRole'),
    "PySide2.QtWidgets.QProxyStyle.drawPrimitive": ('PySide2.QtWidgets.QStyle.PrimitiveElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QProxyStyle.generatedIconPixmap": ('PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QPixmap', 'PySide2.QtWidgets.QStyleOption'),
    "PySide2.QtWidgets.QProxyStyle.hitTestComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.itemPixmapRect": ('PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QProxyStyle.itemTextRect": ('PySide2.QtGui.QFontMetrics', 'PySide2.QtCore.QRect', 'int', 'bool', 'str'),
    "PySide2.QtWidgets.QProxyStyle.layoutSpacing": ('PySide2.QtWidgets.QSizePolicy.ControlType', 'PySide2.QtWidgets.QSizePolicy.ControlType', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.pixelMetric": ('PySide2.QtWidgets.QStyle.PixelMetric', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.polish": [('PySide2.QtGui.QPalette',), ('PySide2.QtWidgets.QApplication',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QProxyStyle.setBaseStyle": ('PySide2.QtWidgets.QStyle',),
    "PySide2.QtWidgets.QProxyStyle.sizeFromContents": ('PySide2.QtWidgets.QStyle.ContentsType', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtCore.QSize', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.standardIcon": ('PySide2.QtWidgets.QStyle.StandardPixmap', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.standardPalette": (),
    "PySide2.QtWidgets.QProxyStyle.standardPixmap": ('PySide2.QtWidgets.QStyle.StandardPixmap', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.styleHint": ('PySide2.QtWidgets.QStyle.StyleHint', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleHintReturn'),
    "PySide2.QtWidgets.QProxyStyle.subControlRect": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtWidgets.QStyle.SubControl', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.subElementRect": ('PySide2.QtWidgets.QStyle.SubElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QProxyStyle.unpolish": [('PySide2.QtWidgets.QApplication',), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QPushButton:
    "PySide2.QtWidgets.QPushButton.__init__": [('PySide2.QtGui.QIcon', 'str', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QPushButton.autoDefault": (),
    "PySide2.QtWidgets.QPushButton.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QPushButton.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QPushButton.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QPushButton.initStyleOption": ('PySide2.QtWidgets.QStyleOptionButton',),
    "PySide2.QtWidgets.QPushButton.isDefault": (),
    "PySide2.QtWidgets.QPushButton.isFlat": (),
    "PySide2.QtWidgets.QPushButton.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QPushButton.menu": (),
    "PySide2.QtWidgets.QPushButton.minimumSizeHint": (),
    "PySide2.QtWidgets.QPushButton.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QPushButton.setAutoDefault": ('bool',),
    "PySide2.QtWidgets.QPushButton.setDefault": ('bool',),
    "PySide2.QtWidgets.QPushButton.setFlat": ('bool',),
    "PySide2.QtWidgets.QPushButton.setMenu": ('PySide2.QtWidgets.QMenu',),
    "PySide2.QtWidgets.QPushButton.showMenu": (),
    "PySide2.QtWidgets.QPushButton.sizeHint": (),

# class PySide2.QtWidgets.QRadioButton:
    "PySide2.QtWidgets.QRadioButton.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QRadioButton.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QRadioButton.hitButton": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QRadioButton.initStyleOption": ('PySide2.QtWidgets.QStyleOptionButton',),
    "PySide2.QtWidgets.QRadioButton.minimumSizeHint": (),
    "PySide2.QtWidgets.QRadioButton.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QRadioButton.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QRadioButton.sizeHint": (),

# class PySide2.QtWidgets.QRubberBand:

# class PySide2.QtWidgets.QRubberBand.Shape:
    "PySide2.QtWidgets.QRubberBand.__init__": ('PySide2.QtWidgets.QRubberBand.Shape', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QRubberBand.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QRubberBand.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QRubberBand.initStyleOption": ('PySide2.QtWidgets.QStyleOptionRubberBand',),
    "PySide2.QtWidgets.QRubberBand.move": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QRubberBand.moveEvent": ('PySide2.QtGui.QMoveEvent',),
    "PySide2.QtWidgets.QRubberBand.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QRubberBand.resize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QRubberBand.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QRubberBand.setGeometry": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QRubberBand.shape": (),
    "PySide2.QtWidgets.QRubberBand.showEvent": ('PySide2.QtGui.QShowEvent',),

# class PySide2.QtWidgets.QScrollArea:
    "PySide2.QtWidgets.QScrollArea.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QScrollArea.alignment": (),
    "PySide2.QtWidgets.QScrollArea.ensureVisible": ('int', 'int', 'int', 'int'),
    "PySide2.QtWidgets.QScrollArea.ensureWidgetVisible": ('PySide2.QtWidgets.QWidget', 'int', 'int'),
    "PySide2.QtWidgets.QScrollArea.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QScrollArea.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QScrollArea.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QScrollArea.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QScrollArea.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QScrollArea.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QScrollArea.setWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QScrollArea.setWidgetResizable": ('bool',),
    "PySide2.QtWidgets.QScrollArea.sizeHint": (),
    "PySide2.QtWidgets.QScrollArea.takeWidget": (),
    "PySide2.QtWidgets.QScrollArea.viewportSizeHint": (),
    "PySide2.QtWidgets.QScrollArea.widget": (),
    "PySide2.QtWidgets.QScrollArea.widgetResizable": (),

# class PySide2.QtWidgets.QScrollBar:
    "PySide2.QtWidgets.QScrollBar.__init__": [('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QScrollBar.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QScrollBar.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QScrollBar.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QScrollBar.initStyleOption": ('PySide2.QtWidgets.QStyleOptionSlider',),
    "PySide2.QtWidgets.QScrollBar.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QScrollBar.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QScrollBar.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QScrollBar.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QScrollBar.sizeHint": (),
    "PySide2.QtWidgets.QScrollBar.sliderChange": ('PySide2.QtWidgets.QAbstractSlider.SliderChange',),
    "PySide2.QtWidgets.QScrollBar.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QScroller:

# class PySide2.QtWidgets.QScroller.Input:

# class PySide2.QtWidgets.QScroller.ScrollerGestureType:

# class PySide2.QtWidgets.QScroller.State:
    "PySide2.QtWidgets.QScroller.activeScrollers": (),
    "PySide2.QtWidgets.QScroller.ensureVisible": [('PySide2.QtCore.QRectF', 'float', 'float'), ('PySide2.QtCore.QRectF', 'float', 'float', 'int')],
    "PySide2.QtWidgets.QScroller.finalPosition": (),
    "PySide2.QtWidgets.QScroller.grabGesture": ('PySide2.QtCore.QObject', 'PySide2.QtWidgets.QScroller.ScrollerGestureType'),
    "PySide2.QtWidgets.QScroller.grabbedGesture": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QScroller.handleInput": ('PySide2.QtWidgets.QScroller.Input', 'PySide2.QtCore.QPointF', 'int'),
    "PySide2.QtWidgets.QScroller.hasScroller": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QScroller.pixelPerMeter": (),
    "PySide2.QtWidgets.QScroller.resendPrepareEvent": (),
    "PySide2.QtWidgets.QScroller.scrollTo": [('PySide2.QtCore.QPointF',), ('PySide2.QtCore.QPointF', 'int')],
    "PySide2.QtWidgets.QScroller.scroller": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QScroller.scrollerProperties": (),
    "PySide2.QtWidgets.QScroller.setScrollerProperties": ('PySide2.QtWidgets.QScrollerProperties',),
    "PySide2.QtWidgets.QScroller.setSnapPositionsX": [('float', 'float'), ('typing.Sequence[float]',)],
    "PySide2.QtWidgets.QScroller.setSnapPositionsY": [('float', 'float'), ('typing.Sequence[float]',)],
    "PySide2.QtWidgets.QScroller.state": (),
    "PySide2.QtWidgets.QScroller.stop": (),
    "PySide2.QtWidgets.QScroller.target": (),
    "PySide2.QtWidgets.QScroller.ungrabGesture": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QScroller.velocity": (),

# class PySide2.QtWidgets.QScrollerProperties:

# class PySide2.QtWidgets.QScrollerProperties.FrameRates:

# class PySide2.QtWidgets.QScrollerProperties.OvershootPolicy:

# class PySide2.QtWidgets.QScrollerProperties.ScrollMetric:
    "PySide2.QtWidgets.QScrollerProperties.__init__": [(), ('PySide2.QtWidgets.QScrollerProperties',)],
    "PySide2.QtWidgets.QScrollerProperties.__copy__": (),
    "PySide2.QtWidgets.QScrollerProperties.scrollMetric": ('PySide2.QtWidgets.QScrollerProperties.ScrollMetric',),
    "PySide2.QtWidgets.QScrollerProperties.setDefaultScrollerProperties": ('PySide2.QtWidgets.QScrollerProperties',),
    "PySide2.QtWidgets.QScrollerProperties.setScrollMetric": ('PySide2.QtWidgets.QScrollerProperties.ScrollMetric', 'typing.Any'),
    "PySide2.QtWidgets.QScrollerProperties.unsetDefaultScrollerProperties": (),

# class PySide2.QtWidgets.QShortcut:
    "PySide2.QtWidgets.QShortcut.__init__": [('PySide2.QtGui.QKeySequence', 'PySide2.QtWidgets.QWidget', 'str', 'str', 'PySide2.QtCore.Qt.ShortcutContext'), ('PySide2.QtGui.QKeySequence', 'PySide2.QtWidgets.QWidget', 'typing.Callable', 'PySide2.QtCore.Qt.ShortcutContext'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QShortcut.autoRepeat": (),
    "PySide2.QtWidgets.QShortcut.context": (),
    "PySide2.QtWidgets.QShortcut.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QShortcut.id": (),
    "PySide2.QtWidgets.QShortcut.isEnabled": (),
    "PySide2.QtWidgets.QShortcut.key": (),
    "PySide2.QtWidgets.QShortcut.parentWidget": (),
    "PySide2.QtWidgets.QShortcut.setAutoRepeat": ('bool',),
    "PySide2.QtWidgets.QShortcut.setContext": ('PySide2.QtCore.Qt.ShortcutContext',),
    "PySide2.QtWidgets.QShortcut.setEnabled": ('bool',),
    "PySide2.QtWidgets.QShortcut.setKey": ('PySide2.QtGui.QKeySequence',),
    "PySide2.QtWidgets.QShortcut.setWhatsThis": ('str',),
    "PySide2.QtWidgets.QShortcut.whatsThis": (),

# class PySide2.QtWidgets.QSizeGrip:
    "PySide2.QtWidgets.QSizeGrip.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QSizeGrip.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSizeGrip.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QSizeGrip.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QSizeGrip.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSizeGrip.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSizeGrip.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSizeGrip.moveEvent": ('PySide2.QtGui.QMoveEvent',),
    "PySide2.QtWidgets.QSizeGrip.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QSizeGrip.setVisible": ('bool',),
    "PySide2.QtWidgets.QSizeGrip.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QSizeGrip.sizeHint": (),

# class PySide2.QtWidgets.QSizePolicy:

# class PySide2.QtWidgets.QSizePolicy.ControlType:

# class PySide2.QtWidgets.QSizePolicy.ControlTypes:

# class PySide2.QtWidgets.QSizePolicy.Policy:

# class PySide2.QtWidgets.QSizePolicy.PolicyFlag:
    "PySide2.QtWidgets.QSizePolicy.__init__": [(), ('PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.ControlType')],
    "PySide2.QtWidgets.QSizePolicy.__copy__": (),
    "PySide2.QtWidgets.QSizePolicy.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QSizePolicy.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QSizePolicy.controlType": (),
    "PySide2.QtWidgets.QSizePolicy.expandingDirections": (),
    "PySide2.QtWidgets.QSizePolicy.hasHeightForWidth": (),
    "PySide2.QtWidgets.QSizePolicy.hasWidthForHeight": (),
    "PySide2.QtWidgets.QSizePolicy.horizontalPolicy": (),
    "PySide2.QtWidgets.QSizePolicy.horizontalStretch": (),
    "PySide2.QtWidgets.QSizePolicy.retainSizeWhenHidden": (),
    "PySide2.QtWidgets.QSizePolicy.setControlType": ('PySide2.QtWidgets.QSizePolicy.ControlType',),
    "PySide2.QtWidgets.QSizePolicy.setHeightForWidth": ('bool',),
    "PySide2.QtWidgets.QSizePolicy.setHorizontalPolicy": ('PySide2.QtWidgets.QSizePolicy.Policy',),
    "PySide2.QtWidgets.QSizePolicy.setHorizontalStretch": ('int',),
    "PySide2.QtWidgets.QSizePolicy.setRetainSizeWhenHidden": ('bool',),
    "PySide2.QtWidgets.QSizePolicy.setVerticalPolicy": ('PySide2.QtWidgets.QSizePolicy.Policy',),
    "PySide2.QtWidgets.QSizePolicy.setVerticalStretch": ('int',),
    "PySide2.QtWidgets.QSizePolicy.setWidthForHeight": ('bool',),
    "PySide2.QtWidgets.QSizePolicy.transpose": (),
    "PySide2.QtWidgets.QSizePolicy.transposed": (),
    "PySide2.QtWidgets.QSizePolicy.verticalPolicy": (),
    "PySide2.QtWidgets.QSizePolicy.verticalStretch": (),

# class PySide2.QtWidgets.QSlider:

# class PySide2.QtWidgets.QSlider.TickPosition:
    "PySide2.QtWidgets.QSlider.__init__": [('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QSlider.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSlider.initStyleOption": ('PySide2.QtWidgets.QStyleOptionSlider',),
    "PySide2.QtWidgets.QSlider.minimumSizeHint": (),
    "PySide2.QtWidgets.QSlider.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSlider.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSlider.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSlider.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QSlider.setTickInterval": ('int',),
    "PySide2.QtWidgets.QSlider.setTickPosition": ('PySide2.QtWidgets.QSlider.TickPosition',),
    "PySide2.QtWidgets.QSlider.sizeHint": (),
    "PySide2.QtWidgets.QSlider.tickInterval": (),
    "PySide2.QtWidgets.QSlider.tickPosition": (),

# class PySide2.QtWidgets.QSpacerItem:
    "PySide2.QtWidgets.QSpacerItem.__init__": ('int', 'int', 'PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.Policy'),
    "PySide2.QtWidgets.QSpacerItem.changeSize": ('int', 'int', 'PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.Policy'),
    "PySide2.QtWidgets.QSpacerItem.expandingDirections": (),
    "PySide2.QtWidgets.QSpacerItem.geometry": (),
    "PySide2.QtWidgets.QSpacerItem.isEmpty": (),
    "PySide2.QtWidgets.QSpacerItem.maximumSize": (),
    "PySide2.QtWidgets.QSpacerItem.minimumSize": (),
    "PySide2.QtWidgets.QSpacerItem.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QSpacerItem.sizeHint": (),
    "PySide2.QtWidgets.QSpacerItem.sizePolicy": (),
    "PySide2.QtWidgets.QSpacerItem.spacerItem": (),

# class PySide2.QtWidgets.QSpinBox:
    "PySide2.QtWidgets.QSpinBox.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QSpinBox.cleanText": (),
    "PySide2.QtWidgets.QSpinBox.displayIntegerBase": (),
    "PySide2.QtWidgets.QSpinBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSpinBox.fixup": ('str',),
    "PySide2.QtWidgets.QSpinBox.maximum": (),
    "PySide2.QtWidgets.QSpinBox.minimum": (),
    "PySide2.QtWidgets.QSpinBox.prefix": (),
    "PySide2.QtWidgets.QSpinBox.setDisplayIntegerBase": ('int',),
    "PySide2.QtWidgets.QSpinBox.setMaximum": ('int',),
    "PySide2.QtWidgets.QSpinBox.setMinimum": ('int',),
    "PySide2.QtWidgets.QSpinBox.setPrefix": ('str',),
    "PySide2.QtWidgets.QSpinBox.setRange": ('int', 'int'),
    "PySide2.QtWidgets.QSpinBox.setSingleStep": ('int',),
    "PySide2.QtWidgets.QSpinBox.setStepType": ('PySide2.QtWidgets.QAbstractSpinBox.StepType',),
    "PySide2.QtWidgets.QSpinBox.setSuffix": ('str',),
    "PySide2.QtWidgets.QSpinBox.setValue": ('int',),
    "PySide2.QtWidgets.QSpinBox.singleStep": (),
    "PySide2.QtWidgets.QSpinBox.stepType": (),
    "PySide2.QtWidgets.QSpinBox.suffix": (),
    "PySide2.QtWidgets.QSpinBox.textFromValue": ('int',),
    "PySide2.QtWidgets.QSpinBox.validate": ('str', 'int'),
    "PySide2.QtWidgets.QSpinBox.value": (),
    "PySide2.QtWidgets.QSpinBox.valueFromText": ('str',),

# class PySide2.QtWidgets.QSplashScreen:
    "PySide2.QtWidgets.QSplashScreen.__init__": [('PySide2.QtGui.QPixmap', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QPixmap', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtWidgets.QSplashScreen.clearMessage": (),
    "PySide2.QtWidgets.QSplashScreen.drawContents": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QSplashScreen.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSplashScreen.finish": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QSplashScreen.message": (),
    "PySide2.QtWidgets.QSplashScreen.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSplashScreen.pixmap": (),
    "PySide2.QtWidgets.QSplashScreen.setPixmap": ('PySide2.QtGui.QPixmap',),
    "PySide2.QtWidgets.QSplashScreen.showMessage": ('str', 'int', 'PySide2.QtGui.QColor'),

# class PySide2.QtWidgets.QSplitter:
    "PySide2.QtWidgets.QSplitter.__init__": [('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QSplitter.__lshift__": ('PySide2.QtCore.QTextStream',),
    "PySide2.QtWidgets.QSplitter.__rshift__": ('PySide2.QtCore.QTextStream',),
    "PySide2.QtWidgets.QSplitter.addWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QSplitter.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSplitter.childEvent": ('PySide2.QtCore.QChildEvent',),
    "PySide2.QtWidgets.QSplitter.childrenCollapsible": (),
    "PySide2.QtWidgets.QSplitter.closestLegalPosition": ('int', 'int'),
    "PySide2.QtWidgets.QSplitter.count": (),
    "PySide2.QtWidgets.QSplitter.createHandle": (),
    "PySide2.QtWidgets.QSplitter.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSplitter.getRange": ('int',),
    "PySide2.QtWidgets.QSplitter.handle": ('int',),
    "PySide2.QtWidgets.QSplitter.handleWidth": (),
    "PySide2.QtWidgets.QSplitter.indexOf": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QSplitter.insertWidget": ('int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QSplitter.isCollapsible": ('int',),
    "PySide2.QtWidgets.QSplitter.minimumSizeHint": (),
    "PySide2.QtWidgets.QSplitter.moveSplitter": ('int', 'int'),
    "PySide2.QtWidgets.QSplitter.opaqueResize": (),
    "PySide2.QtWidgets.QSplitter.orientation": (),
    "PySide2.QtWidgets.QSplitter.refresh": (),
    "PySide2.QtWidgets.QSplitter.replaceWidget": ('int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QSplitter.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QSplitter.restoreState": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWidgets.QSplitter.saveState": (),
    "PySide2.QtWidgets.QSplitter.setChildrenCollapsible": ('bool',),
    "PySide2.QtWidgets.QSplitter.setCollapsible": ('int', 'bool'),
    "PySide2.QtWidgets.QSplitter.setHandleWidth": ('int',),
    "PySide2.QtWidgets.QSplitter.setOpaqueResize": ('bool',),
    "PySide2.QtWidgets.QSplitter.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QSplitter.setRubberBand": ('int',),
    "PySide2.QtWidgets.QSplitter.setSizes": ('typing.Sequence[int]',),
    "PySide2.QtWidgets.QSplitter.setStretchFactor": ('int', 'int'),
    "PySide2.QtWidgets.QSplitter.sizeHint": (),
    "PySide2.QtWidgets.QSplitter.sizes": (),
    "PySide2.QtWidgets.QSplitter.widget": ('int',),

# class PySide2.QtWidgets.QSplitterHandle:
    "PySide2.QtWidgets.QSplitterHandle.__init__": ('PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QSplitter'),
    "PySide2.QtWidgets.QSplitterHandle.closestLegalPosition": ('int',),
    "PySide2.QtWidgets.QSplitterHandle.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSplitterHandle.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSplitterHandle.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSplitterHandle.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QSplitterHandle.moveSplitter": ('int',),
    "PySide2.QtWidgets.QSplitterHandle.opaqueResize": (),
    "PySide2.QtWidgets.QSplitterHandle.orientation": (),
    "PySide2.QtWidgets.QSplitterHandle.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QSplitterHandle.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QSplitterHandle.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QSplitterHandle.sizeHint": (),
    "PySide2.QtWidgets.QSplitterHandle.splitter": (),

# class PySide2.QtWidgets.QStackedLayout:

# class PySide2.QtWidgets.QStackedLayout.StackingMode:
    "PySide2.QtWidgets.QStackedLayout.__init__": [(), ('PySide2.QtWidgets.QLayout',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QStackedLayout.addItem": ('PySide2.QtWidgets.QLayoutItem',),
    "PySide2.QtWidgets.QStackedLayout.addWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedLayout.count": (),
    "PySide2.QtWidgets.QStackedLayout.currentIndex": (),
    "PySide2.QtWidgets.QStackedLayout.currentWidget": (),
    "PySide2.QtWidgets.QStackedLayout.hasHeightForWidth": (),
    "PySide2.QtWidgets.QStackedLayout.heightForWidth": ('int',),
    "PySide2.QtWidgets.QStackedLayout.insertWidget": ('int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStackedLayout.itemAt": ('int',),
    "PySide2.QtWidgets.QStackedLayout.minimumSize": (),
    "PySide2.QtWidgets.QStackedLayout.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QStackedLayout.setCurrentWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedLayout.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QStackedLayout.setStackingMode": ('PySide2.QtWidgets.QStackedLayout.StackingMode',),
    "PySide2.QtWidgets.QStackedLayout.sizeHint": (),
    "PySide2.QtWidgets.QStackedLayout.stackingMode": (),
    "PySide2.QtWidgets.QStackedLayout.takeAt": ('int',),
    "PySide2.QtWidgets.QStackedLayout.widget": [(), ('int',)],

# class PySide2.QtWidgets.QStackedWidget:
    "PySide2.QtWidgets.QStackedWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedWidget.addWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedWidget.count": (),
    "PySide2.QtWidgets.QStackedWidget.currentIndex": (),
    "PySide2.QtWidgets.QStackedWidget.currentWidget": (),
    "PySide2.QtWidgets.QStackedWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QStackedWidget.indexOf": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedWidget.insertWidget": ('int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStackedWidget.removeWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedWidget.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QStackedWidget.setCurrentWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStackedWidget.widget": ('int',),

# class PySide2.QtWidgets.QStatusBar:
    "PySide2.QtWidgets.QStatusBar.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStatusBar.addPermanentWidget": ('PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtWidgets.QStatusBar.addWidget": ('PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtWidgets.QStatusBar.clearMessage": (),
    "PySide2.QtWidgets.QStatusBar.currentMessage": (),
    "PySide2.QtWidgets.QStatusBar.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QStatusBar.hideOrShow": (),
    "PySide2.QtWidgets.QStatusBar.insertPermanentWidget": ('int', 'PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtWidgets.QStatusBar.insertWidget": ('int', 'PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtWidgets.QStatusBar.isSizeGripEnabled": (),
    "PySide2.QtWidgets.QStatusBar.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QStatusBar.reformat": (),
    "PySide2.QtWidgets.QStatusBar.removeWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStatusBar.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QStatusBar.setSizeGripEnabled": ('bool',),
    "PySide2.QtWidgets.QStatusBar.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QStatusBar.showMessage": ('str', 'int'),

# class PySide2.QtWidgets.QStyle:

# class PySide2.QtWidgets.QStyle.ComplexControl:

# class PySide2.QtWidgets.QStyle.ContentsType:

# class PySide2.QtWidgets.QStyle.ControlElement:

# class PySide2.QtWidgets.QStyle.PixelMetric:

# class PySide2.QtWidgets.QStyle.PrimitiveElement:

# class PySide2.QtWidgets.QStyle.RequestSoftwareInputPanel:

# class PySide2.QtWidgets.QStyle.StandardPixmap:

# class PySide2.QtWidgets.QStyle.State:

# class PySide2.QtWidgets.QStyle.StateFlag:

# class PySide2.QtWidgets.QStyle.StyleHint:

# class PySide2.QtWidgets.QStyle.SubControl:

# class PySide2.QtWidgets.QStyle.SubControls:

# class PySide2.QtWidgets.QStyle.SubElement:
    "PySide2.QtWidgets.QStyle.__init__": (),
    "PySide2.QtWidgets.QStyle.alignedRect": ('PySide2.QtCore.Qt.LayoutDirection', 'PySide2.QtCore.Qt.Alignment', 'PySide2.QtCore.QSize', 'PySide2.QtCore.QRect'),
    "PySide2.QtWidgets.QStyle.combinedLayoutSpacing": ('PySide2.QtWidgets.QSizePolicy.ControlTypes', 'PySide2.QtWidgets.QSizePolicy.ControlTypes', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.drawComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.drawControl": ('PySide2.QtWidgets.QStyle.ControlElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.drawItemPixmap": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QStyle.drawItemText": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPalette', 'bool', 'str', 'PySide2.QtGui.QPalette.ColorRole'),
    "PySide2.QtWidgets.QStyle.drawPrimitive": ('PySide2.QtWidgets.QStyle.PrimitiveElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.generatedIconPixmap": ('PySide2.QtGui.QIcon.Mode', 'PySide2.QtGui.QPixmap', 'PySide2.QtWidgets.QStyleOption'),
    "PySide2.QtWidgets.QStyle.hitTestComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.itemPixmapRect": ('PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QStyle.itemTextRect": ('PySide2.QtGui.QFontMetrics', 'PySide2.QtCore.QRect', 'int', 'bool', 'str'),
    "PySide2.QtWidgets.QStyle.layoutSpacing": ('PySide2.QtWidgets.QSizePolicy.ControlType', 'PySide2.QtWidgets.QSizePolicy.ControlType', 'PySide2.QtCore.Qt.Orientation', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.pixelMetric": ('PySide2.QtWidgets.QStyle.PixelMetric', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.polish": [('PySide2.QtGui.QPalette',), ('PySide2.QtWidgets.QApplication',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QStyle.proxy": (),
    "PySide2.QtWidgets.QStyle.sizeFromContents": ('PySide2.QtWidgets.QStyle.ContentsType', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtCore.QSize', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.sliderPositionFromValue": ('int', 'int', 'int', 'int', 'bool'),
    "PySide2.QtWidgets.QStyle.sliderValueFromPosition": ('int', 'int', 'int', 'int', 'bool'),
    "PySide2.QtWidgets.QStyle.standardIcon": ('PySide2.QtWidgets.QStyle.StandardPixmap', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.standardPalette": (),
    "PySide2.QtWidgets.QStyle.standardPixmap": ('PySide2.QtWidgets.QStyle.StandardPixmap', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.styleHint": ('PySide2.QtWidgets.QStyle.StyleHint', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleHintReturn'),
    "PySide2.QtWidgets.QStyle.subControlRect": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex', 'PySide2.QtWidgets.QStyle.SubControl', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.subElementRect": ('PySide2.QtWidgets.QStyle.SubElement', 'PySide2.QtWidgets.QStyleOption', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QStyle.unpolish": [('PySide2.QtWidgets.QApplication',), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QStyle.visualAlignment": ('PySide2.QtCore.Qt.LayoutDirection', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtWidgets.QStyle.visualPos": ('PySide2.QtCore.Qt.LayoutDirection', 'PySide2.QtCore.QRect', 'PySide2.QtCore.QPoint'),
    "PySide2.QtWidgets.QStyle.visualRect": ('PySide2.QtCore.Qt.LayoutDirection', 'PySide2.QtCore.QRect', 'PySide2.QtCore.QRect'),

# class PySide2.QtWidgets.QStyleFactory:
    "PySide2.QtWidgets.QStyleFactory.__init__": (),
    "PySide2.QtWidgets.QStyleFactory.create": ('str',),
    "PySide2.QtWidgets.QStyleFactory.keys": (),

# class PySide2.QtWidgets.QStyleHintReturn:

# class PySide2.QtWidgets.QStyleHintReturn.HintReturnType:

# class PySide2.QtWidgets.QStyleHintReturn.StyleOptionType:

# class PySide2.QtWidgets.QStyleHintReturn.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleHintReturn.__init__": ('int', 'int'),

# class PySide2.QtWidgets.QStyleHintReturnMask:

# class PySide2.QtWidgets.QStyleHintReturnMask.StyleOptionType:

# class PySide2.QtWidgets.QStyleHintReturnMask.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleHintReturnMask.__init__": (),

# class PySide2.QtWidgets.QStyleHintReturnVariant:

# class PySide2.QtWidgets.QStyleHintReturnVariant.StyleOptionType:

# class PySide2.QtWidgets.QStyleHintReturnVariant.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleHintReturnVariant.__init__": (),

# class PySide2.QtWidgets.QStyleOption:

# class PySide2.QtWidgets.QStyleOption.OptionType:

# class PySide2.QtWidgets.QStyleOption.StyleOptionType:

# class PySide2.QtWidgets.QStyleOption.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOption.__init__": [('PySide2.QtWidgets.QStyleOption',), ('int', 'int')],
    "PySide2.QtWidgets.QStyleOption.init": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QStyleOption.initFrom": ('PySide2.QtWidgets.QWidget',),

# class PySide2.QtWidgets.QStyleOptionButton:

# class PySide2.QtWidgets.QStyleOptionButton.ButtonFeature:

# class PySide2.QtWidgets.QStyleOptionButton.ButtonFeatures:

# class PySide2.QtWidgets.QStyleOptionButton.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionButton.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionButton.__init__": [(), ('PySide2.QtWidgets.QStyleOptionButton',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionComboBox:

# class PySide2.QtWidgets.QStyleOptionComboBox.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionComboBox.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionComboBox.__init__": [(), ('PySide2.QtWidgets.QStyleOptionComboBox',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionComplex:

# class PySide2.QtWidgets.QStyleOptionComplex.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionComplex.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionComplex.__init__": [('PySide2.QtWidgets.QStyleOptionComplex',), ('int', 'int')],

# class PySide2.QtWidgets.QStyleOptionDockWidget:

# class PySide2.QtWidgets.QStyleOptionDockWidget.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionDockWidget.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionDockWidget.__init__": [(), ('PySide2.QtWidgets.QStyleOptionDockWidget',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionFocusRect:

# class PySide2.QtWidgets.QStyleOptionFocusRect.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionFocusRect.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionFocusRect.__init__": [(), ('PySide2.QtWidgets.QStyleOptionFocusRect',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionFrame:

# class PySide2.QtWidgets.QStyleOptionFrame.FrameFeature:

# class PySide2.QtWidgets.QStyleOptionFrame.FrameFeatures:

# class PySide2.QtWidgets.QStyleOptionFrame.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionFrame.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionFrame.__init__": [(), ('PySide2.QtWidgets.QStyleOptionFrame',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionGraphicsItem:

# class PySide2.QtWidgets.QStyleOptionGraphicsItem.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionGraphicsItem.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionGraphicsItem.__init__": [(), ('PySide2.QtWidgets.QStyleOptionGraphicsItem',), ('int',)],
    "PySide2.QtWidgets.QStyleOptionGraphicsItem.levelOfDetailFromTransform": ('PySide2.QtGui.QTransform',),

# class PySide2.QtWidgets.QStyleOptionGroupBox:

# class PySide2.QtWidgets.QStyleOptionGroupBox.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionGroupBox.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionGroupBox.__init__": [(), ('PySide2.QtWidgets.QStyleOptionGroupBox',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionHeader:

# class PySide2.QtWidgets.QStyleOptionHeader.SectionPosition:

# class PySide2.QtWidgets.QStyleOptionHeader.SelectedPosition:

# class PySide2.QtWidgets.QStyleOptionHeader.SortIndicator:

# class PySide2.QtWidgets.QStyleOptionHeader.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionHeader.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionHeader.__init__": [(), ('PySide2.QtWidgets.QStyleOptionHeader',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionMenuItem:

# class PySide2.QtWidgets.QStyleOptionMenuItem.CheckType:

# class PySide2.QtWidgets.QStyleOptionMenuItem.MenuItemType:

# class PySide2.QtWidgets.QStyleOptionMenuItem.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionMenuItem.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionMenuItem.__init__": [(), ('PySide2.QtWidgets.QStyleOptionMenuItem',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionProgressBar:

# class PySide2.QtWidgets.QStyleOptionProgressBar.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionProgressBar.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionProgressBar.__init__": [(), ('PySide2.QtWidgets.QStyleOptionProgressBar',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionRubberBand:

# class PySide2.QtWidgets.QStyleOptionRubberBand.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionRubberBand.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionRubberBand.__init__": [(), ('PySide2.QtWidgets.QStyleOptionRubberBand',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionSizeGrip:

# class PySide2.QtWidgets.QStyleOptionSizeGrip.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionSizeGrip.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionSizeGrip.__init__": [(), ('PySide2.QtWidgets.QStyleOptionSizeGrip',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionSlider:

# class PySide2.QtWidgets.QStyleOptionSlider.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionSlider.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionSlider.__init__": [(), ('PySide2.QtWidgets.QStyleOptionSlider',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionSpinBox:

# class PySide2.QtWidgets.QStyleOptionSpinBox.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionSpinBox.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionSpinBox.__init__": [(), ('PySide2.QtWidgets.QStyleOptionSpinBox',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionTab:

# class PySide2.QtWidgets.QStyleOptionTab.CornerWidget:

# class PySide2.QtWidgets.QStyleOptionTab.CornerWidgets:

# class PySide2.QtWidgets.QStyleOptionTab.SelectedPosition:

# class PySide2.QtWidgets.QStyleOptionTab.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionTab.StyleOptionVersion:

# class PySide2.QtWidgets.QStyleOptionTab.TabFeature:

# class PySide2.QtWidgets.QStyleOptionTab.TabFeatures:

# class PySide2.QtWidgets.QStyleOptionTab.TabPosition:
    "PySide2.QtWidgets.QStyleOptionTab.__init__": [(), ('PySide2.QtWidgets.QStyleOptionTab',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionTabBarBase:

# class PySide2.QtWidgets.QStyleOptionTabBarBase.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionTabBarBase.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionTabBarBase.__init__": [(), ('PySide2.QtWidgets.QStyleOptionTabBarBase',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionTabWidgetFrame:

# class PySide2.QtWidgets.QStyleOptionTabWidgetFrame.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionTabWidgetFrame.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionTabWidgetFrame.__init__": [(), ('PySide2.QtWidgets.QStyleOptionTabWidgetFrame',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionTitleBar:

# class PySide2.QtWidgets.QStyleOptionTitleBar.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionTitleBar.StyleOptionVersion:
    "PySide2.QtWidgets.QStyleOptionTitleBar.__init__": [(), ('PySide2.QtWidgets.QStyleOptionTitleBar',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionToolBar:

# class PySide2.QtWidgets.QStyleOptionToolBar.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionToolBar.StyleOptionVersion:

# class PySide2.QtWidgets.QStyleOptionToolBar.ToolBarFeature:

# class PySide2.QtWidgets.QStyleOptionToolBar.ToolBarFeatures:

# class PySide2.QtWidgets.QStyleOptionToolBar.ToolBarPosition:
    "PySide2.QtWidgets.QStyleOptionToolBar.__init__": [(), ('PySide2.QtWidgets.QStyleOptionToolBar',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionToolBox:

# class PySide2.QtWidgets.QStyleOptionToolBox.SelectedPosition:

# class PySide2.QtWidgets.QStyleOptionToolBox.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionToolBox.StyleOptionVersion:

# class PySide2.QtWidgets.QStyleOptionToolBox.TabPosition:
    "PySide2.QtWidgets.QStyleOptionToolBox.__init__": [(), ('PySide2.QtWidgets.QStyleOptionToolBox',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionToolButton:

# class PySide2.QtWidgets.QStyleOptionToolButton.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionToolButton.StyleOptionVersion:

# class PySide2.QtWidgets.QStyleOptionToolButton.ToolButtonFeature:

# class PySide2.QtWidgets.QStyleOptionToolButton.ToolButtonFeatures:
    "PySide2.QtWidgets.QStyleOptionToolButton.__init__": [(), ('PySide2.QtWidgets.QStyleOptionToolButton',), ('int',)],

# class PySide2.QtWidgets.QStyleOptionViewItem:

# class PySide2.QtWidgets.QStyleOptionViewItem.Position:

# class PySide2.QtWidgets.QStyleOptionViewItem.StyleOptionType:

# class PySide2.QtWidgets.QStyleOptionViewItem.StyleOptionVersion:

# class PySide2.QtWidgets.QStyleOptionViewItem.ViewItemFeature:

# class PySide2.QtWidgets.QStyleOptionViewItem.ViewItemFeatures:

# class PySide2.QtWidgets.QStyleOptionViewItem.ViewItemPosition:
    "PySide2.QtWidgets.QStyleOptionViewItem.__init__": [(), ('PySide2.QtWidgets.QStyleOptionViewItem',), ('int',)],
    "PySide2.QtWidgets.QStyleOptionViewItem.__copy__": (),

# class PySide2.QtWidgets.QStylePainter:
    "PySide2.QtWidgets.QStylePainter.__init__": [(), ('PySide2.QtGui.QPaintDevice', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QStylePainter.begin": [('PySide2.QtGui.QPaintDevice',), ('PySide2.QtGui.QPaintDevice', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QStylePainter.drawComplexControl": ('PySide2.QtWidgets.QStyle.ComplexControl', 'PySide2.QtWidgets.QStyleOptionComplex'),
    "PySide2.QtWidgets.QStylePainter.drawControl": ('PySide2.QtWidgets.QStyle.ControlElement', 'PySide2.QtWidgets.QStyleOption'),
    "PySide2.QtWidgets.QStylePainter.drawItemPixmap": ('PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QStylePainter.drawItemText": ('PySide2.QtCore.QRect', 'int', 'PySide2.QtGui.QPalette', 'bool', 'str', 'PySide2.QtGui.QPalette.ColorRole'),
    "PySide2.QtWidgets.QStylePainter.drawPrimitive": ('PySide2.QtWidgets.QStyle.PrimitiveElement', 'PySide2.QtWidgets.QStyleOption'),
    "PySide2.QtWidgets.QStylePainter.style": (),

# class PySide2.QtWidgets.QStyledItemDelegate:
    "PySide2.QtWidgets.QStyledItemDelegate.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QStyledItemDelegate.createEditor": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.displayText": ('typing.Any', 'PySide2.QtCore.QLocale'),
    "PySide2.QtWidgets.QStyledItemDelegate.editorEvent": ('PySide2.QtCore.QEvent', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QStyledItemDelegate.initStyleOption": ('PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.itemEditorFactory": (),
    "PySide2.QtWidgets.QStyledItemDelegate.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.setEditorData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.setItemEditorFactory": ('PySide2.QtWidgets.QItemEditorFactory',),
    "PySide2.QtWidgets.QStyledItemDelegate.setModelData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.sizeHint": ('PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QStyledItemDelegate.updateEditorGeometry": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtWidgets.QSwipeGesture:

# class PySide2.QtWidgets.QSwipeGesture.SwipeDirection:
    "PySide2.QtWidgets.QSwipeGesture.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QSwipeGesture.horizontalDirection": (),
    "PySide2.QtWidgets.QSwipeGesture.setSwipeAngle": ('float',),
    "PySide2.QtWidgets.QSwipeGesture.swipeAngle": (),
    "PySide2.QtWidgets.QSwipeGesture.verticalDirection": (),

# class PySide2.QtWidgets.QSystemTrayIcon:

# class PySide2.QtWidgets.QSystemTrayIcon.ActivationReason:

# class PySide2.QtWidgets.QSystemTrayIcon.MessageIcon:
    "PySide2.QtWidgets.QSystemTrayIcon.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtGui.QIcon', 'PySide2.QtCore.QObject')],
    "PySide2.QtWidgets.QSystemTrayIcon.contextMenu": (),
    "PySide2.QtWidgets.QSystemTrayIcon.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QSystemTrayIcon.geometry": (),
    "PySide2.QtWidgets.QSystemTrayIcon.hide": (),
    "PySide2.QtWidgets.QSystemTrayIcon.icon": (),
    "PySide2.QtWidgets.QSystemTrayIcon.isSystemTrayAvailable": (),
    "PySide2.QtWidgets.QSystemTrayIcon.isVisible": (),
    "PySide2.QtWidgets.QSystemTrayIcon.setContextMenu": ('PySide2.QtWidgets.QMenu',),
    "PySide2.QtWidgets.QSystemTrayIcon.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QSystemTrayIcon.setToolTip": ('str',),
    "PySide2.QtWidgets.QSystemTrayIcon.setVisible": ('bool',),
    "PySide2.QtWidgets.QSystemTrayIcon.show": (),
    "PySide2.QtWidgets.QSystemTrayIcon.showMessage": [('str', 'str', 'PySide2.QtGui.QIcon', 'int'), ('str', 'str', 'PySide2.QtWidgets.QSystemTrayIcon.MessageIcon', 'int')],
    "PySide2.QtWidgets.QSystemTrayIcon.supportsMessages": (),
    "PySide2.QtWidgets.QSystemTrayIcon.toolTip": (),

# class PySide2.QtWidgets.QTabBar:

# class PySide2.QtWidgets.QTabBar.ButtonPosition:

# class PySide2.QtWidgets.QTabBar.SelectionBehavior:

# class PySide2.QtWidgets.QTabBar.Shape:
    "PySide2.QtWidgets.QTabBar.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTabBar.accessibleTabName": ('int',),
    "PySide2.QtWidgets.QTabBar.addTab": [('PySide2.QtGui.QIcon', 'str'), ('str',)],
    "PySide2.QtWidgets.QTabBar.autoHide": (),
    "PySide2.QtWidgets.QTabBar.changeCurrentOnDrag": (),
    "PySide2.QtWidgets.QTabBar.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTabBar.count": (),
    "PySide2.QtWidgets.QTabBar.currentIndex": (),
    "PySide2.QtWidgets.QTabBar.documentMode": (),
    "PySide2.QtWidgets.QTabBar.drawBase": (),
    "PySide2.QtWidgets.QTabBar.elideMode": (),
    "PySide2.QtWidgets.QTabBar.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTabBar.expanding": (),
    "PySide2.QtWidgets.QTabBar.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QTabBar.iconSize": (),
    "PySide2.QtWidgets.QTabBar.initStyleOption": ('PySide2.QtWidgets.QStyleOptionTab', 'int'),
    "PySide2.QtWidgets.QTabBar.insertTab": [('int', 'PySide2.QtGui.QIcon', 'str'), ('int', 'str')],
    "PySide2.QtWidgets.QTabBar.isMovable": (),
    "PySide2.QtWidgets.QTabBar.isTabEnabled": ('int',),
    "PySide2.QtWidgets.QTabBar.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QTabBar.minimumSizeHint": (),
    "PySide2.QtWidgets.QTabBar.minimumTabSizeHint": ('int',),
    "PySide2.QtWidgets.QTabBar.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTabBar.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTabBar.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTabBar.moveTab": ('int', 'int'),
    "PySide2.QtWidgets.QTabBar.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QTabBar.removeTab": ('int',),
    "PySide2.QtWidgets.QTabBar.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QTabBar.selectionBehaviorOnRemove": (),
    "PySide2.QtWidgets.QTabBar.setAccessibleTabName": ('int', 'str'),
    "PySide2.QtWidgets.QTabBar.setAutoHide": ('bool',),
    "PySide2.QtWidgets.QTabBar.setChangeCurrentOnDrag": ('bool',),
    "PySide2.QtWidgets.QTabBar.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QTabBar.setDocumentMode": ('bool',),
    "PySide2.QtWidgets.QTabBar.setDrawBase": ('bool',),
    "PySide2.QtWidgets.QTabBar.setElideMode": ('PySide2.QtCore.Qt.TextElideMode',),
    "PySide2.QtWidgets.QTabBar.setExpanding": ('bool',),
    "PySide2.QtWidgets.QTabBar.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QTabBar.setMovable": ('bool',),
    "PySide2.QtWidgets.QTabBar.setSelectionBehaviorOnRemove": ('PySide2.QtWidgets.QTabBar.SelectionBehavior',),
    "PySide2.QtWidgets.QTabBar.setShape": ('PySide2.QtWidgets.QTabBar.Shape',),
    "PySide2.QtWidgets.QTabBar.setTabButton": ('int', 'PySide2.QtWidgets.QTabBar.ButtonPosition', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QTabBar.setTabData": ('int', 'typing.Any'),
    "PySide2.QtWidgets.QTabBar.setTabEnabled": ('int', 'bool'),
    "PySide2.QtWidgets.QTabBar.setTabIcon": ('int', 'PySide2.QtGui.QIcon'),
    "PySide2.QtWidgets.QTabBar.setTabText": ('int', 'str'),
    "PySide2.QtWidgets.QTabBar.setTabTextColor": ('int', 'PySide2.QtGui.QColor'),
    "PySide2.QtWidgets.QTabBar.setTabToolTip": ('int', 'str'),
    "PySide2.QtWidgets.QTabBar.setTabWhatsThis": ('int', 'str'),
    "PySide2.QtWidgets.QTabBar.setTabsClosable": ('bool',),
    "PySide2.QtWidgets.QTabBar.setUsesScrollButtons": ('bool',),
    "PySide2.QtWidgets.QTabBar.shape": (),
    "PySide2.QtWidgets.QTabBar.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QTabBar.sizeHint": (),
    "PySide2.QtWidgets.QTabBar.tabAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QTabBar.tabButton": ('int', 'PySide2.QtWidgets.QTabBar.ButtonPosition'),
    "PySide2.QtWidgets.QTabBar.tabData": ('int',),
    "PySide2.QtWidgets.QTabBar.tabIcon": ('int',),
    "PySide2.QtWidgets.QTabBar.tabInserted": ('int',),
    "PySide2.QtWidgets.QTabBar.tabLayoutChange": (),
    "PySide2.QtWidgets.QTabBar.tabRect": ('int',),
    "PySide2.QtWidgets.QTabBar.tabRemoved": ('int',),
    "PySide2.QtWidgets.QTabBar.tabSizeHint": ('int',),
    "PySide2.QtWidgets.QTabBar.tabText": ('int',),
    "PySide2.QtWidgets.QTabBar.tabTextColor": ('int',),
    "PySide2.QtWidgets.QTabBar.tabToolTip": ('int',),
    "PySide2.QtWidgets.QTabBar.tabWhatsThis": ('int',),
    "PySide2.QtWidgets.QTabBar.tabsClosable": (),
    "PySide2.QtWidgets.QTabBar.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QTabBar.usesScrollButtons": (),
    "PySide2.QtWidgets.QTabBar.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtWidgets.QTabWidget:

# class PySide2.QtWidgets.QTabWidget.TabPosition:

# class PySide2.QtWidgets.QTabWidget.TabShape:
    "PySide2.QtWidgets.QTabWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTabWidget.addTab": [('PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QIcon', 'str'), ('PySide2.QtWidgets.QWidget', 'str')],
    "PySide2.QtWidgets.QTabWidget.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTabWidget.clear": (),
    "PySide2.QtWidgets.QTabWidget.cornerWidget": ('PySide2.QtCore.Qt.Corner',),
    "PySide2.QtWidgets.QTabWidget.count": (),
    "PySide2.QtWidgets.QTabWidget.currentIndex": (),
    "PySide2.QtWidgets.QTabWidget.currentWidget": (),
    "PySide2.QtWidgets.QTabWidget.documentMode": (),
    "PySide2.QtWidgets.QTabWidget.elideMode": (),
    "PySide2.QtWidgets.QTabWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTabWidget.hasHeightForWidth": (),
    "PySide2.QtWidgets.QTabWidget.heightForWidth": ('int',),
    "PySide2.QtWidgets.QTabWidget.iconSize": (),
    "PySide2.QtWidgets.QTabWidget.indexOf": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTabWidget.initStyleOption": ('PySide2.QtWidgets.QStyleOptionTabWidgetFrame',),
    "PySide2.QtWidgets.QTabWidget.insertTab": [('int', 'PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QIcon', 'str'), ('int', 'PySide2.QtWidgets.QWidget', 'str')],
    "PySide2.QtWidgets.QTabWidget.isMovable": (),
    "PySide2.QtWidgets.QTabWidget.isTabEnabled": ('int',),
    "PySide2.QtWidgets.QTabWidget.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QTabWidget.minimumSizeHint": (),
    "PySide2.QtWidgets.QTabWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QTabWidget.removeTab": ('int',),
    "PySide2.QtWidgets.QTabWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QTabWidget.setCornerWidget": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Corner'),
    "PySide2.QtWidgets.QTabWidget.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QTabWidget.setCurrentWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTabWidget.setDocumentMode": ('bool',),
    "PySide2.QtWidgets.QTabWidget.setElideMode": ('PySide2.QtCore.Qt.TextElideMode',),
    "PySide2.QtWidgets.QTabWidget.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QTabWidget.setMovable": ('bool',),
    "PySide2.QtWidgets.QTabWidget.setTabBar": ('PySide2.QtWidgets.QTabBar',),
    "PySide2.QtWidgets.QTabWidget.setTabBarAutoHide": ('bool',),
    "PySide2.QtWidgets.QTabWidget.setTabEnabled": ('int', 'bool'),
    "PySide2.QtWidgets.QTabWidget.setTabIcon": ('int', 'PySide2.QtGui.QIcon'),
    "PySide2.QtWidgets.QTabWidget.setTabPosition": ('PySide2.QtWidgets.QTabWidget.TabPosition',),
    "PySide2.QtWidgets.QTabWidget.setTabShape": ('PySide2.QtWidgets.QTabWidget.TabShape',),
    "PySide2.QtWidgets.QTabWidget.setTabText": ('int', 'str'),
    "PySide2.QtWidgets.QTabWidget.setTabToolTip": ('int', 'str'),
    "PySide2.QtWidgets.QTabWidget.setTabWhatsThis": ('int', 'str'),
    "PySide2.QtWidgets.QTabWidget.setTabsClosable": ('bool',),
    "PySide2.QtWidgets.QTabWidget.setUsesScrollButtons": ('bool',),
    "PySide2.QtWidgets.QTabWidget.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QTabWidget.sizeHint": (),
    "PySide2.QtWidgets.QTabWidget.tabBar": (),
    "PySide2.QtWidgets.QTabWidget.tabBarAutoHide": (),
    "PySide2.QtWidgets.QTabWidget.tabIcon": ('int',),
    "PySide2.QtWidgets.QTabWidget.tabInserted": ('int',),
    "PySide2.QtWidgets.QTabWidget.tabPosition": (),
    "PySide2.QtWidgets.QTabWidget.tabRemoved": ('int',),
    "PySide2.QtWidgets.QTabWidget.tabShape": (),
    "PySide2.QtWidgets.QTabWidget.tabText": ('int',),
    "PySide2.QtWidgets.QTabWidget.tabToolTip": ('int',),
    "PySide2.QtWidgets.QTabWidget.tabWhatsThis": ('int',),
    "PySide2.QtWidgets.QTabWidget.tabsClosable": (),
    "PySide2.QtWidgets.QTabWidget.usesScrollButtons": (),
    "PySide2.QtWidgets.QTabWidget.widget": ('int',),

# class PySide2.QtWidgets.QTableView:
    "PySide2.QtWidgets.QTableView.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTableView.clearSpans": (),
    "PySide2.QtWidgets.QTableView.columnAt": ('int',),
    "PySide2.QtWidgets.QTableView.columnCountChanged": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.columnMoved": ('int', 'int', 'int'),
    "PySide2.QtWidgets.QTableView.columnResized": ('int', 'int', 'int'),
    "PySide2.QtWidgets.QTableView.columnSpan": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.columnViewportPosition": ('int',),
    "PySide2.QtWidgets.QTableView.columnWidth": ('int',),
    "PySide2.QtWidgets.QTableView.currentChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QTableView.doItemsLayout": (),
    "PySide2.QtWidgets.QTableView.gridStyle": (),
    "PySide2.QtWidgets.QTableView.hideColumn": ('int',),
    "PySide2.QtWidgets.QTableView.hideRow": ('int',),
    "PySide2.QtWidgets.QTableView.horizontalHeader": (),
    "PySide2.QtWidgets.QTableView.horizontalOffset": (),
    "PySide2.QtWidgets.QTableView.horizontalScrollbarAction": ('int',),
    "PySide2.QtWidgets.QTableView.indexAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QTableView.isColumnHidden": ('int',),
    "PySide2.QtWidgets.QTableView.isCornerButtonEnabled": (),
    "PySide2.QtWidgets.QTableView.isIndexHidden": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTableView.isRowHidden": ('int',),
    "PySide2.QtWidgets.QTableView.isSortingEnabled": (),
    "PySide2.QtWidgets.QTableView.moveCursor": ('PySide2.QtWidgets.QAbstractItemView.CursorAction', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtWidgets.QTableView.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QTableView.resizeColumnToContents": ('int',),
    "PySide2.QtWidgets.QTableView.resizeColumnsToContents": (),
    "PySide2.QtWidgets.QTableView.resizeRowToContents": ('int',),
    "PySide2.QtWidgets.QTableView.resizeRowsToContents": (),
    "PySide2.QtWidgets.QTableView.rowAt": ('int',),
    "PySide2.QtWidgets.QTableView.rowCountChanged": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.rowHeight": ('int',),
    "PySide2.QtWidgets.QTableView.rowMoved": ('int', 'int', 'int'),
    "PySide2.QtWidgets.QTableView.rowResized": ('int', 'int', 'int'),
    "PySide2.QtWidgets.QTableView.rowSpan": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.rowViewportPosition": ('int',),
    "PySide2.QtWidgets.QTableView.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.scrollTo": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QTableView.selectColumn": ('int',),
    "PySide2.QtWidgets.QTableView.selectRow": ('int',),
    "PySide2.QtWidgets.QTableView.selectedIndexes": (),
    "PySide2.QtWidgets.QTableView.selectionChanged": ('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelection'),
    "PySide2.QtWidgets.QTableView.setColumnHidden": ('int', 'bool'),
    "PySide2.QtWidgets.QTableView.setColumnWidth": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.setCornerButtonEnabled": ('bool',),
    "PySide2.QtWidgets.QTableView.setGridStyle": ('PySide2.QtCore.Qt.PenStyle',),
    "PySide2.QtWidgets.QTableView.setHorizontalHeader": ('PySide2.QtWidgets.QHeaderView',),
    "PySide2.QtWidgets.QTableView.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QTableView.setRootIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTableView.setRowHeight": ('int', 'int'),
    "PySide2.QtWidgets.QTableView.setRowHidden": ('int', 'bool'),
    "PySide2.QtWidgets.QTableView.setSelection": ('PySide2.QtCore.QRect', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtWidgets.QTableView.setSelectionModel": ('PySide2.QtCore.QItemSelectionModel',),
    "PySide2.QtWidgets.QTableView.setShowGrid": ('bool',),
    "PySide2.QtWidgets.QTableView.setSortingEnabled": ('bool',),
    "PySide2.QtWidgets.QTableView.setSpan": ('int', 'int', 'int', 'int'),
    "PySide2.QtWidgets.QTableView.setVerticalHeader": ('PySide2.QtWidgets.QHeaderView',),
    "PySide2.QtWidgets.QTableView.setWordWrap": ('bool',),
    "PySide2.QtWidgets.QTableView.showColumn": ('int',),
    "PySide2.QtWidgets.QTableView.showGrid": (),
    "PySide2.QtWidgets.QTableView.showRow": ('int',),
    "PySide2.QtWidgets.QTableView.sizeHintForColumn": ('int',),
    "PySide2.QtWidgets.QTableView.sizeHintForRow": ('int',),
    "PySide2.QtWidgets.QTableView.sortByColumn": [('int',), ('int', 'PySide2.QtCore.Qt.SortOrder')],
    "PySide2.QtWidgets.QTableView.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QTableView.updateGeometries": (),
    "PySide2.QtWidgets.QTableView.verticalHeader": (),
    "PySide2.QtWidgets.QTableView.verticalOffset": (),
    "PySide2.QtWidgets.QTableView.verticalScrollbarAction": ('int',),
    "PySide2.QtWidgets.QTableView.viewOptions": (),
    "PySide2.QtWidgets.QTableView.viewportSizeHint": (),
    "PySide2.QtWidgets.QTableView.visualRect": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTableView.visualRegionForSelection": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtWidgets.QTableView.wordWrap": (),

# class PySide2.QtWidgets.QTableWidget:
    "PySide2.QtWidgets.QTableWidget.__init__": [('PySide2.QtWidgets.QWidget',), ('int', 'int', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QTableWidget.cellWidget": ('int', 'int'),
    "PySide2.QtWidgets.QTableWidget.clear": (),
    "PySide2.QtWidgets.QTableWidget.clearContents": (),
    "PySide2.QtWidgets.QTableWidget.closePersistentEditor": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QTableWidgetItem',)],
    "PySide2.QtWidgets.QTableWidget.column": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.columnCount": (),
    "PySide2.QtWidgets.QTableWidget.currentColumn": (),
    "PySide2.QtWidgets.QTableWidget.currentItem": (),
    "PySide2.QtWidgets.QTableWidget.currentRow": (),
    "PySide2.QtWidgets.QTableWidget.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QTableWidget.dropMimeData": ('int', 'int', 'PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction'),
    "PySide2.QtWidgets.QTableWidget.editItem": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTableWidget.findItems": ('str', 'PySide2.QtCore.Qt.MatchFlags'),
    "PySide2.QtWidgets.QTableWidget.horizontalHeaderItem": ('int',),
    "PySide2.QtWidgets.QTableWidget.indexFromItem": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.insertColumn": ('int',),
    "PySide2.QtWidgets.QTableWidget.insertRow": ('int',),
    "PySide2.QtWidgets.QTableWidget.isItemSelected": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.isPersistentEditorOpen": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QTableWidgetItem',)],
    "PySide2.QtWidgets.QTableWidget.isSortingEnabled": (),
    "PySide2.QtWidgets.QTableWidget.item": ('int', 'int'),
    "PySide2.QtWidgets.QTableWidget.itemAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QTableWidget.itemFromIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTableWidget.itemPrototype": (),
    "PySide2.QtWidgets.QTableWidget.items": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QTableWidget.mimeData": ('typing.Sequence[PySide2.QtWidgets.QTableWidgetItem]',),
    "PySide2.QtWidgets.QTableWidget.mimeTypes": (),
    "PySide2.QtWidgets.QTableWidget.openPersistentEditor": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QTableWidgetItem',)],
    "PySide2.QtWidgets.QTableWidget.removeCellWidget": ('int', 'int'),
    "PySide2.QtWidgets.QTableWidget.removeColumn": ('int',),
    "PySide2.QtWidgets.QTableWidget.removeRow": ('int',),
    "PySide2.QtWidgets.QTableWidget.row": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.rowCount": (),
    "PySide2.QtWidgets.QTableWidget.scrollToItem": ('PySide2.QtWidgets.QTableWidgetItem', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QTableWidget.selectedItems": (),
    "PySide2.QtWidgets.QTableWidget.selectedRanges": (),
    "PySide2.QtWidgets.QTableWidget.setCellWidget": ('int', 'int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QTableWidget.setColumnCount": ('int',),
    "PySide2.QtWidgets.QTableWidget.setCurrentCell": [('int', 'int'), ('int', 'int', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags')],
    "PySide2.QtWidgets.QTableWidget.setCurrentItem": [('PySide2.QtWidgets.QTableWidgetItem',), ('PySide2.QtWidgets.QTableWidgetItem', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags')],
    "PySide2.QtWidgets.QTableWidget.setHorizontalHeaderItem": ('int', 'PySide2.QtWidgets.QTableWidgetItem'),
    "PySide2.QtWidgets.QTableWidget.setHorizontalHeaderLabels": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QTableWidget.setItem": ('int', 'int', 'PySide2.QtWidgets.QTableWidgetItem'),
    "PySide2.QtWidgets.QTableWidget.setItemPrototype": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.setItemSelected": ('PySide2.QtWidgets.QTableWidgetItem', 'bool'),
    "PySide2.QtWidgets.QTableWidget.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QTableWidget.setRangeSelected": ('PySide2.QtWidgets.QTableWidgetSelectionRange', 'bool'),
    "PySide2.QtWidgets.QTableWidget.setRowCount": ('int',),
    "PySide2.QtWidgets.QTableWidget.setSortingEnabled": ('bool',),
    "PySide2.QtWidgets.QTableWidget.setVerticalHeaderItem": ('int', 'PySide2.QtWidgets.QTableWidgetItem'),
    "PySide2.QtWidgets.QTableWidget.setVerticalHeaderLabels": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QTableWidget.sortItems": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtWidgets.QTableWidget.supportedDropActions": (),
    "PySide2.QtWidgets.QTableWidget.takeHorizontalHeaderItem": ('int',),
    "PySide2.QtWidgets.QTableWidget.takeItem": ('int', 'int'),
    "PySide2.QtWidgets.QTableWidget.takeVerticalHeaderItem": ('int',),
    "PySide2.QtWidgets.QTableWidget.verticalHeaderItem": ('int',),
    "PySide2.QtWidgets.QTableWidget.visualColumn": ('int',),
    "PySide2.QtWidgets.QTableWidget.visualItemRect": ('PySide2.QtWidgets.QTableWidgetItem',),
    "PySide2.QtWidgets.QTableWidget.visualRow": ('int',),

# class PySide2.QtWidgets.QTableWidgetItem:

# class PySide2.QtWidgets.QTableWidgetItem.ItemType:
    "PySide2.QtWidgets.QTableWidgetItem.__init__": [('PySide2.QtGui.QIcon', 'str', 'int'), ('PySide2.QtWidgets.QTableWidgetItem',), ('int',), ('str', 'int')],
    "PySide2.QtWidgets.QTableWidgetItem.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QTableWidgetItem.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QTableWidgetItem.background": (),
    "PySide2.QtWidgets.QTableWidgetItem.backgroundColor": (),
    "PySide2.QtWidgets.QTableWidgetItem.checkState": (),
    "PySide2.QtWidgets.QTableWidgetItem.clone": (),
    "PySide2.QtWidgets.QTableWidgetItem.column": (),
    "PySide2.QtWidgets.QTableWidgetItem.data": ('int',),
    "PySide2.QtWidgets.QTableWidgetItem.flags": (),
    "PySide2.QtWidgets.QTableWidgetItem.font": (),
    "PySide2.QtWidgets.QTableWidgetItem.foreground": (),
    "PySide2.QtWidgets.QTableWidgetItem.icon": (),
    "PySide2.QtWidgets.QTableWidgetItem.isSelected": (),
    "PySide2.QtWidgets.QTableWidgetItem.read": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QTableWidgetItem.row": (),
    "PySide2.QtWidgets.QTableWidgetItem.setBackground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QTableWidgetItem.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QTableWidgetItem.setCheckState": ('PySide2.QtCore.Qt.CheckState',),
    "PySide2.QtWidgets.QTableWidgetItem.setData": ('int', 'typing.Any'),
    "PySide2.QtWidgets.QTableWidgetItem.setFlags": ('PySide2.QtCore.Qt.ItemFlags',),
    "PySide2.QtWidgets.QTableWidgetItem.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QTableWidgetItem.setForeground": ('PySide2.QtGui.QBrush',),
    "PySide2.QtWidgets.QTableWidgetItem.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QTableWidgetItem.setSelected": ('bool',),
    "PySide2.QtWidgets.QTableWidgetItem.setSizeHint": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QTableWidgetItem.setStatusTip": ('str',),
    "PySide2.QtWidgets.QTableWidgetItem.setText": ('str',),
    "PySide2.QtWidgets.QTableWidgetItem.setTextAlignment": ('int',),
    "PySide2.QtWidgets.QTableWidgetItem.setTextColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QTableWidgetItem.setToolTip": ('str',),
    "PySide2.QtWidgets.QTableWidgetItem.setWhatsThis": ('str',),
    "PySide2.QtWidgets.QTableWidgetItem.sizeHint": (),
    "PySide2.QtWidgets.QTableWidgetItem.statusTip": (),
    "PySide2.QtWidgets.QTableWidgetItem.tableWidget": (),
    "PySide2.QtWidgets.QTableWidgetItem.text": (),
    "PySide2.QtWidgets.QTableWidgetItem.textAlignment": (),
    "PySide2.QtWidgets.QTableWidgetItem.textColor": (),
    "PySide2.QtWidgets.QTableWidgetItem.toolTip": (),
    "PySide2.QtWidgets.QTableWidgetItem.type": (),
    "PySide2.QtWidgets.QTableWidgetItem.whatsThis": (),
    "PySide2.QtWidgets.QTableWidgetItem.write": ('PySide2.QtCore.QDataStream',),

# class PySide2.QtWidgets.QTableWidgetSelectionRange:
    "PySide2.QtWidgets.QTableWidgetSelectionRange.__init__": [(), ('PySide2.QtWidgets.QTableWidgetSelectionRange',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QTableWidgetSelectionRange.__copy__": (),
    "PySide2.QtWidgets.QTableWidgetSelectionRange.bottomRow": (),
    "PySide2.QtWidgets.QTableWidgetSelectionRange.columnCount": (),
    "PySide2.QtWidgets.QTableWidgetSelectionRange.leftColumn": (),
    "PySide2.QtWidgets.QTableWidgetSelectionRange.rightColumn": (),
    "PySide2.QtWidgets.QTableWidgetSelectionRange.rowCount": (),
    "PySide2.QtWidgets.QTableWidgetSelectionRange.topRow": (),

# class PySide2.QtWidgets.QTapAndHoldGesture:
    "PySide2.QtWidgets.QTapAndHoldGesture.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QTapAndHoldGesture.position": (),
    "PySide2.QtWidgets.QTapAndHoldGesture.setPosition": ('PySide2.QtCore.QPointF',),
    "PySide2.QtWidgets.QTapAndHoldGesture.setTimeout": ('int',),
    "PySide2.QtWidgets.QTapAndHoldGesture.timeout": (),

# class PySide2.QtWidgets.QTapGesture:
    "PySide2.QtWidgets.QTapGesture.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QTapGesture.position": (),
    "PySide2.QtWidgets.QTapGesture.setPosition": ('PySide2.QtCore.QPointF',),

# class PySide2.QtWidgets.QTextBrowser:
    "PySide2.QtWidgets.QTextBrowser.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTextBrowser.backward": (),
    "PySide2.QtWidgets.QTextBrowser.backwardHistoryCount": (),
    "PySide2.QtWidgets.QTextBrowser.clearHistory": (),
    "PySide2.QtWidgets.QTextBrowser.doSetSource": ('PySide2.QtCore.QUrl', 'PySide2.QtGui.QTextDocument.ResourceType'),
    "PySide2.QtWidgets.QTextBrowser.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTextBrowser.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QTextBrowser.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QTextBrowser.forward": (),
    "PySide2.QtWidgets.QTextBrowser.forwardHistoryCount": (),
    "PySide2.QtWidgets.QTextBrowser.historyTitle": ('int',),
    "PySide2.QtWidgets.QTextBrowser.historyUrl": ('int',),
    "PySide2.QtWidgets.QTextBrowser.home": (),
    "PySide2.QtWidgets.QTextBrowser.isBackwardAvailable": (),
    "PySide2.QtWidgets.QTextBrowser.isForwardAvailable": (),
    "PySide2.QtWidgets.QTextBrowser.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QTextBrowser.loadResource": ('int', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWidgets.QTextBrowser.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextBrowser.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextBrowser.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextBrowser.openExternalLinks": (),
    "PySide2.QtWidgets.QTextBrowser.openLinks": (),
    "PySide2.QtWidgets.QTextBrowser.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QTextBrowser.reload": (),
    "PySide2.QtWidgets.QTextBrowser.searchPaths": (),
    "PySide2.QtWidgets.QTextBrowser.setOpenExternalLinks": ('bool',),
    "PySide2.QtWidgets.QTextBrowser.setOpenLinks": ('bool',),
    "PySide2.QtWidgets.QTextBrowser.setSearchPaths": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QTextBrowser.setSource": [('PySide2.QtCore.QUrl',), ('PySide2.QtCore.QUrl', 'PySide2.QtGui.QTextDocument.ResourceType')],
    "PySide2.QtWidgets.QTextBrowser.source": (),
    "PySide2.QtWidgets.QTextBrowser.sourceType": (),

# class PySide2.QtWidgets.QTextEdit:

# class PySide2.QtWidgets.QTextEdit.AutoFormatting:

# class PySide2.QtWidgets.QTextEdit.AutoFormattingFlag:

# class PySide2.QtWidgets.QTextEdit.ExtraSelection:
    "PySide2.QtWidgets.QTextEdit.ExtraSelection.__init__": [(), ('PySide2.QtWidgets.QTextEdit.ExtraSelection',)],
    "PySide2.QtWidgets.QTextEdit.ExtraSelection.__copy__": (),

# class PySide2.QtWidgets.QTextEdit.LineWrapMode:

    "PySide2.QtWidgets.QTextEdit.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QTextEdit.acceptRichText": (),
    "PySide2.QtWidgets.QTextEdit.alignment": (),
    "PySide2.QtWidgets.QTextEdit.anchorAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QTextEdit.append": ('str',),
    "PySide2.QtWidgets.QTextEdit.autoFormatting": (),
    "PySide2.QtWidgets.QTextEdit.canInsertFromMimeData": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QTextEdit.canPaste": (),
    "PySide2.QtWidgets.QTextEdit.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTextEdit.clear": (),
    "PySide2.QtWidgets.QTextEdit.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QTextEdit.copy": (),
    "PySide2.QtWidgets.QTextEdit.createMimeDataFromSelection": (),
    "PySide2.QtWidgets.QTextEdit.createStandardContextMenu": [(), ('PySide2.QtCore.QPoint',)],
    "PySide2.QtWidgets.QTextEdit.currentCharFormat": (),
    "PySide2.QtWidgets.QTextEdit.currentFont": (),
    "PySide2.QtWidgets.QTextEdit.cursorForPosition": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QTextEdit.cursorRect": [(), ('PySide2.QtGui.QTextCursor',)],
    "PySide2.QtWidgets.QTextEdit.cursorWidth": (),
    "PySide2.QtWidgets.QTextEdit.cut": (),
    "PySide2.QtWidgets.QTextEdit.doSetTextCursor": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtWidgets.QTextEdit.document": (),
    "PySide2.QtWidgets.QTextEdit.documentTitle": (),
    "PySide2.QtWidgets.QTextEdit.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QTextEdit.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QTextEdit.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QTextEdit.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QTextEdit.ensureCursorVisible": (),
    "PySide2.QtWidgets.QTextEdit.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTextEdit.extraSelections": (),
    "PySide2.QtWidgets.QTextEdit.find": [('PySide2.QtCore.QRegExp', 'PySide2.QtGui.QTextDocument.FindFlags'), ('PySide2.QtCore.QRegularExpression', 'PySide2.QtGui.QTextDocument.FindFlags'), ('str', 'PySide2.QtGui.QTextDocument.FindFlags')],
    "PySide2.QtWidgets.QTextEdit.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QTextEdit.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QTextEdit.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QTextEdit.fontFamily": (),
    "PySide2.QtWidgets.QTextEdit.fontItalic": (),
    "PySide2.QtWidgets.QTextEdit.fontPointSize": (),
    "PySide2.QtWidgets.QTextEdit.fontUnderline": (),
    "PySide2.QtWidgets.QTextEdit.fontWeight": (),
    "PySide2.QtWidgets.QTextEdit.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QTextEdit.inputMethodQuery": [('PySide2.QtCore.Qt.InputMethodQuery',), ('PySide2.QtCore.Qt.InputMethodQuery', 'typing.Any')],
    "PySide2.QtWidgets.QTextEdit.insertFromMimeData": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QTextEdit.insertHtml": ('str',),
    "PySide2.QtWidgets.QTextEdit.insertPlainText": ('str',),
    "PySide2.QtWidgets.QTextEdit.isReadOnly": (),
    "PySide2.QtWidgets.QTextEdit.isUndoRedoEnabled": (),
    "PySide2.QtWidgets.QTextEdit.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QTextEdit.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QTextEdit.lineWrapColumnOrWidth": (),
    "PySide2.QtWidgets.QTextEdit.lineWrapMode": (),
    "PySide2.QtWidgets.QTextEdit.loadResource": ('int', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWidgets.QTextEdit.mergeCurrentCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtWidgets.QTextEdit.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextEdit.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextEdit.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextEdit.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTextEdit.moveCursor": ('PySide2.QtGui.QTextCursor.MoveOperation', 'PySide2.QtGui.QTextCursor.MoveMode'),
    "PySide2.QtWidgets.QTextEdit.overwriteMode": (),
    "PySide2.QtWidgets.QTextEdit.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QTextEdit.paste": (),
    "PySide2.QtWidgets.QTextEdit.placeholderText": (),
    "PySide2.QtWidgets.QTextEdit.print_": ('PySide2.QtGui.QPagedPaintDevice',),
    "PySide2.QtWidgets.QTextEdit.redo": (),
    "PySide2.QtWidgets.QTextEdit.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QTextEdit.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QTextEdit.scrollToAnchor": ('str',),
    "PySide2.QtWidgets.QTextEdit.selectAll": (),
    "PySide2.QtWidgets.QTextEdit.setAcceptRichText": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtWidgets.QTextEdit.setAutoFormatting": ('PySide2.QtWidgets.QTextEdit.AutoFormatting',),
    "PySide2.QtWidgets.QTextEdit.setCurrentCharFormat": ('PySide2.QtGui.QTextCharFormat',),
    "PySide2.QtWidgets.QTextEdit.setCurrentFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QTextEdit.setCursorWidth": ('int',),
    "PySide2.QtWidgets.QTextEdit.setDocument": ('PySide2.QtGui.QTextDocument',),
    "PySide2.QtWidgets.QTextEdit.setDocumentTitle": ('str',),
    "PySide2.QtWidgets.QTextEdit.setExtraSelections": ('typing.Sequence[PySide2.QtWidgets.QTextEdit.ExtraSelection]',),
    "PySide2.QtWidgets.QTextEdit.setFontFamily": ('str',),
    "PySide2.QtWidgets.QTextEdit.setFontItalic": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setFontPointSize": ('float',),
    "PySide2.QtWidgets.QTextEdit.setFontUnderline": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setFontWeight": ('int',),
    "PySide2.QtWidgets.QTextEdit.setHtml": ('str',),
    "PySide2.QtWidgets.QTextEdit.setLineWrapColumnOrWidth": ('int',),
    "PySide2.QtWidgets.QTextEdit.setLineWrapMode": ('PySide2.QtWidgets.QTextEdit.LineWrapMode',),
    "PySide2.QtWidgets.QTextEdit.setMarkdown": ('str',),
    "PySide2.QtWidgets.QTextEdit.setOverwriteMode": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setPlaceholderText": ('str',),
    "PySide2.QtWidgets.QTextEdit.setPlainText": ('str',),
    "PySide2.QtWidgets.QTextEdit.setReadOnly": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setTabChangesFocus": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setTabStopDistance": ('float',),
    "PySide2.QtWidgets.QTextEdit.setTabStopWidth": ('int',),
    "PySide2.QtWidgets.QTextEdit.setText": ('str',),
    "PySide2.QtWidgets.QTextEdit.setTextBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QTextEdit.setTextColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWidgets.QTextEdit.setTextCursor": ('PySide2.QtGui.QTextCursor',),
    "PySide2.QtWidgets.QTextEdit.setTextInteractionFlags": ('PySide2.QtCore.Qt.TextInteractionFlags',),
    "PySide2.QtWidgets.QTextEdit.setUndoRedoEnabled": ('bool',),
    "PySide2.QtWidgets.QTextEdit.setWordWrapMode": ('PySide2.QtGui.QTextOption.WrapMode',),
    "PySide2.QtWidgets.QTextEdit.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QTextEdit.tabChangesFocus": (),
    "PySide2.QtWidgets.QTextEdit.tabStopDistance": (),
    "PySide2.QtWidgets.QTextEdit.tabStopWidth": (),
    "PySide2.QtWidgets.QTextEdit.textBackgroundColor": (),
    "PySide2.QtWidgets.QTextEdit.textColor": (),
    "PySide2.QtWidgets.QTextEdit.textCursor": (),
    "PySide2.QtWidgets.QTextEdit.textInteractionFlags": (),
    "PySide2.QtWidgets.QTextEdit.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QTextEdit.toHtml": (),
    "PySide2.QtWidgets.QTextEdit.toMarkdown": ('PySide2.QtGui.QTextDocument.MarkdownFeatures',),
    "PySide2.QtWidgets.QTextEdit.toPlainText": (),
    "PySide2.QtWidgets.QTextEdit.undo": (),
    "PySide2.QtWidgets.QTextEdit.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtWidgets.QTextEdit.wordWrapMode": (),
    "PySide2.QtWidgets.QTextEdit.zoomIn": ('int',),
    "PySide2.QtWidgets.QTextEdit.zoomInF": ('float',),
    "PySide2.QtWidgets.QTextEdit.zoomOut": ('int',),

# class PySide2.QtWidgets.QTileRules:
    "PySide2.QtWidgets.QTileRules.__init__": [('PySide2.QtCore.Qt.TileRule',), ('PySide2.QtCore.Qt.TileRule', 'PySide2.QtCore.Qt.TileRule'), ('PySide2.QtWidgets.QTileRules',)],
    "PySide2.QtWidgets.QTileRules.__copy__": (),

# class PySide2.QtWidgets.QTimeEdit:
    "PySide2.QtWidgets.QTimeEdit.__init__": [('PySide2.QtCore.QTime', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QToolBar:
    "PySide2.QtWidgets.QToolBar.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtWidgets.QToolBar.actionAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QToolBar.actionEvent": ('PySide2.QtGui.QActionEvent',),
    "PySide2.QtWidgets.QToolBar.actionGeometry": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QToolBar.addAction": [('PySide2.QtGui.QIcon', 'str'), ('PySide2.QtGui.QIcon', 'str', 'PySide2.QtCore.QObject', 'str'), ('PySide2.QtWidgets.QAction',), ('str',), ('str', 'PySide2.QtCore.QObject', 'str')],
    "PySide2.QtWidgets.QToolBar.addSeparator": (),
    "PySide2.QtWidgets.QToolBar.addWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QToolBar.allowedAreas": (),
    "PySide2.QtWidgets.QToolBar.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolBar.clear": (),
    "PySide2.QtWidgets.QToolBar.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolBar.iconSize": (),
    "PySide2.QtWidgets.QToolBar.initStyleOption": ('PySide2.QtWidgets.QStyleOptionToolBar',),
    "PySide2.QtWidgets.QToolBar.insertSeparator": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QToolBar.insertWidget": ('PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QToolBar.isAreaAllowed": ('PySide2.QtCore.Qt.ToolBarArea',),
    "PySide2.QtWidgets.QToolBar.isFloatable": (),
    "PySide2.QtWidgets.QToolBar.isFloating": (),
    "PySide2.QtWidgets.QToolBar.isMovable": (),
    "PySide2.QtWidgets.QToolBar.orientation": (),
    "PySide2.QtWidgets.QToolBar.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QToolBar.setAllowedAreas": ('PySide2.QtCore.Qt.ToolBarAreas',),
    "PySide2.QtWidgets.QToolBar.setFloatable": ('bool',),
    "PySide2.QtWidgets.QToolBar.setIconSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtWidgets.QToolBar.setMovable": ('bool',),
    "PySide2.QtWidgets.QToolBar.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtWidgets.QToolBar.setToolButtonStyle": ('PySide2.QtCore.Qt.ToolButtonStyle',),
    "PySide2.QtWidgets.QToolBar.toggleViewAction": (),
    "PySide2.QtWidgets.QToolBar.toolButtonStyle": (),
    "PySide2.QtWidgets.QToolBar.widgetForAction": ('PySide2.QtWidgets.QAction',),

# class PySide2.QtWidgets.QToolBox:
    "PySide2.QtWidgets.QToolBox.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QToolBox.addItem": [('PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QIcon', 'str'), ('PySide2.QtWidgets.QWidget', 'str')],
    "PySide2.QtWidgets.QToolBox.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolBox.count": (),
    "PySide2.QtWidgets.QToolBox.currentIndex": (),
    "PySide2.QtWidgets.QToolBox.currentWidget": (),
    "PySide2.QtWidgets.QToolBox.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolBox.indexOf": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QToolBox.insertItem": [('int', 'PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QIcon', 'str'), ('int', 'PySide2.QtWidgets.QWidget', 'str')],
    "PySide2.QtWidgets.QToolBox.isItemEnabled": ('int',),
    "PySide2.QtWidgets.QToolBox.itemIcon": ('int',),
    "PySide2.QtWidgets.QToolBox.itemInserted": ('int',),
    "PySide2.QtWidgets.QToolBox.itemRemoved": ('int',),
    "PySide2.QtWidgets.QToolBox.itemText": ('int',),
    "PySide2.QtWidgets.QToolBox.itemToolTip": ('int',),
    "PySide2.QtWidgets.QToolBox.removeItem": ('int',),
    "PySide2.QtWidgets.QToolBox.setCurrentIndex": ('int',),
    "PySide2.QtWidgets.QToolBox.setCurrentWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QToolBox.setItemEnabled": ('int', 'bool'),
    "PySide2.QtWidgets.QToolBox.setItemIcon": ('int', 'PySide2.QtGui.QIcon'),
    "PySide2.QtWidgets.QToolBox.setItemText": ('int', 'str'),
    "PySide2.QtWidgets.QToolBox.setItemToolTip": ('int', 'str'),
    "PySide2.QtWidgets.QToolBox.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QToolBox.widget": ('int',),

# class PySide2.QtWidgets.QToolButton:

# class PySide2.QtWidgets.QToolButton.ToolButtonPopupMode:
    "PySide2.QtWidgets.QToolButton.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QToolButton.actionEvent": ('PySide2.QtGui.QActionEvent',),
    "PySide2.QtWidgets.QToolButton.arrowType": (),
    "PySide2.QtWidgets.QToolButton.autoRaise": (),
    "PySide2.QtWidgets.QToolButton.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolButton.defaultAction": (),
    "PySide2.QtWidgets.QToolButton.enterEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolButton.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolButton.hitButton": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QToolButton.initStyleOption": ('PySide2.QtWidgets.QStyleOptionToolButton',),
    "PySide2.QtWidgets.QToolButton.leaveEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QToolButton.menu": (),
    "PySide2.QtWidgets.QToolButton.minimumSizeHint": (),
    "PySide2.QtWidgets.QToolButton.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QToolButton.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QToolButton.nextCheckState": (),
    "PySide2.QtWidgets.QToolButton.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QToolButton.popupMode": (),
    "PySide2.QtWidgets.QToolButton.setArrowType": ('PySide2.QtCore.Qt.ArrowType',),
    "PySide2.QtWidgets.QToolButton.setAutoRaise": ('bool',),
    "PySide2.QtWidgets.QToolButton.setDefaultAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QToolButton.setMenu": ('PySide2.QtWidgets.QMenu',),
    "PySide2.QtWidgets.QToolButton.setPopupMode": ('PySide2.QtWidgets.QToolButton.ToolButtonPopupMode',),
    "PySide2.QtWidgets.QToolButton.setToolButtonStyle": ('PySide2.QtCore.Qt.ToolButtonStyle',),
    "PySide2.QtWidgets.QToolButton.showMenu": (),
    "PySide2.QtWidgets.QToolButton.sizeHint": (),
    "PySide2.QtWidgets.QToolButton.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QToolButton.toolButtonStyle": (),

# class PySide2.QtWidgets.QToolTip:
    "PySide2.QtWidgets.QToolTip.font": (),
    "PySide2.QtWidgets.QToolTip.hideText": (),
    "PySide2.QtWidgets.QToolTip.isVisible": (),
    "PySide2.QtWidgets.QToolTip.palette": (),
    "PySide2.QtWidgets.QToolTip.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QToolTip.setPalette": ('PySide2.QtGui.QPalette',),
    "PySide2.QtWidgets.QToolTip.showText": [('PySide2.QtCore.QPoint', 'str', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtCore.QPoint', 'str', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QRect'), ('PySide2.QtCore.QPoint', 'str', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QRect', 'int')],
    "PySide2.QtWidgets.QToolTip.text": (),

# class PySide2.QtWidgets.QTreeView:
    "PySide2.QtWidgets.QTreeView.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTreeView.allColumnsShowFocus": (),
    "PySide2.QtWidgets.QTreeView.autoExpandDelay": (),
    "PySide2.QtWidgets.QTreeView.collapse": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.collapseAll": (),
    "PySide2.QtWidgets.QTreeView.columnAt": ('int',),
    "PySide2.QtWidgets.QTreeView.columnCountChanged": ('int', 'int'),
    "PySide2.QtWidgets.QTreeView.columnMoved": (),
    "PySide2.QtWidgets.QTreeView.columnResized": ('int', 'int', 'int'),
    "PySide2.QtWidgets.QTreeView.columnViewportPosition": ('int',),
    "PySide2.QtWidgets.QTreeView.columnWidth": ('int',),
    "PySide2.QtWidgets.QTreeView.currentChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QTreeView.dataChanged": ('PySide2.QtCore.QModelIndex', 'PySide2.QtCore.QModelIndex', 'typing.List[int]'),
    "PySide2.QtWidgets.QTreeView.doItemsLayout": (),
    "PySide2.QtWidgets.QTreeView.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QTreeView.drawBranches": ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRect', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QTreeView.drawRow": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QTreeView.drawTree": ('PySide2.QtGui.QPainter', 'PySide2.QtGui.QRegion'),
    "PySide2.QtWidgets.QTreeView.expand": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.expandAll": (),
    "PySide2.QtWidgets.QTreeView.expandRecursively": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtWidgets.QTreeView.expandToDepth": ('int',),
    "PySide2.QtWidgets.QTreeView.expandsOnDoubleClick": (),
    "PySide2.QtWidgets.QTreeView.header": (),
    "PySide2.QtWidgets.QTreeView.hideColumn": ('int',),
    "PySide2.QtWidgets.QTreeView.horizontalOffset": (),
    "PySide2.QtWidgets.QTreeView.horizontalScrollbarAction": ('int',),
    "PySide2.QtWidgets.QTreeView.indentation": (),
    "PySide2.QtWidgets.QTreeView.indexAbove": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.indexAt": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QTreeView.indexBelow": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.indexRowSizeHint": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.isAnimated": (),
    "PySide2.QtWidgets.QTreeView.isColumnHidden": ('int',),
    "PySide2.QtWidgets.QTreeView.isExpanded": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.isFirstColumnSpanned": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QTreeView.isHeaderHidden": (),
    "PySide2.QtWidgets.QTreeView.isIndexHidden": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.isRowHidden": ('int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtWidgets.QTreeView.isSortingEnabled": (),
    "PySide2.QtWidgets.QTreeView.itemsExpandable": (),
    "PySide2.QtWidgets.QTreeView.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QTreeView.keyboardSearch": ('str',),
    "PySide2.QtWidgets.QTreeView.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTreeView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTreeView.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTreeView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QTreeView.moveCursor": ('PySide2.QtWidgets.QAbstractItemView.CursorAction', 'PySide2.QtCore.Qt.KeyboardModifiers'),
    "PySide2.QtWidgets.QTreeView.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QTreeView.reexpand": (),
    "PySide2.QtWidgets.QTreeView.reset": (),
    "PySide2.QtWidgets.QTreeView.resetIndentation": (),
    "PySide2.QtWidgets.QTreeView.resizeColumnToContents": ('int',),
    "PySide2.QtWidgets.QTreeView.rootIsDecorated": (),
    "PySide2.QtWidgets.QTreeView.rowHeight": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.rowsAboutToBeRemoved": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QTreeView.rowsInserted": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QTreeView.rowsRemoved": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtWidgets.QTreeView.scrollContentsBy": ('int', 'int'),
    "PySide2.QtWidgets.QTreeView.scrollTo": ('PySide2.QtCore.QModelIndex', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QTreeView.selectAll": (),
    "PySide2.QtWidgets.QTreeView.selectedIndexes": (),
    "PySide2.QtWidgets.QTreeView.selectionChanged": ('PySide2.QtCore.QItemSelection', 'PySide2.QtCore.QItemSelection'),
    "PySide2.QtWidgets.QTreeView.setAllColumnsShowFocus": ('bool',),
    "PySide2.QtWidgets.QTreeView.setAnimated": ('bool',),
    "PySide2.QtWidgets.QTreeView.setAutoExpandDelay": ('int',),
    "PySide2.QtWidgets.QTreeView.setColumnHidden": ('int', 'bool'),
    "PySide2.QtWidgets.QTreeView.setColumnWidth": ('int', 'int'),
    "PySide2.QtWidgets.QTreeView.setExpanded": ('PySide2.QtCore.QModelIndex', 'bool'),
    "PySide2.QtWidgets.QTreeView.setExpandsOnDoubleClick": ('bool',),
    "PySide2.QtWidgets.QTreeView.setFirstColumnSpanned": ('int', 'PySide2.QtCore.QModelIndex', 'bool'),
    "PySide2.QtWidgets.QTreeView.setHeader": ('PySide2.QtWidgets.QHeaderView',),
    "PySide2.QtWidgets.QTreeView.setHeaderHidden": ('bool',),
    "PySide2.QtWidgets.QTreeView.setIndentation": ('int',),
    "PySide2.QtWidgets.QTreeView.setItemsExpandable": ('bool',),
    "PySide2.QtWidgets.QTreeView.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QTreeView.setRootIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.setRootIsDecorated": ('bool',),
    "PySide2.QtWidgets.QTreeView.setRowHidden": ('int', 'PySide2.QtCore.QModelIndex', 'bool'),
    "PySide2.QtWidgets.QTreeView.setSelection": ('PySide2.QtCore.QRect', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags'),
    "PySide2.QtWidgets.QTreeView.setSelectionModel": ('PySide2.QtCore.QItemSelectionModel',),
    "PySide2.QtWidgets.QTreeView.setSortingEnabled": ('bool',),
    "PySide2.QtWidgets.QTreeView.setTreePosition": ('int',),
    "PySide2.QtWidgets.QTreeView.setUniformRowHeights": ('bool',),
    "PySide2.QtWidgets.QTreeView.setWordWrap": ('bool',),
    "PySide2.QtWidgets.QTreeView.showColumn": ('int',),
    "PySide2.QtWidgets.QTreeView.sizeHintForColumn": ('int',),
    "PySide2.QtWidgets.QTreeView.sortByColumn": [('int',), ('int', 'PySide2.QtCore.Qt.SortOrder')],
    "PySide2.QtWidgets.QTreeView.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtWidgets.QTreeView.treePosition": (),
    "PySide2.QtWidgets.QTreeView.uniformRowHeights": (),
    "PySide2.QtWidgets.QTreeView.updateGeometries": (),
    "PySide2.QtWidgets.QTreeView.verticalOffset": (),
    "PySide2.QtWidgets.QTreeView.verticalScrollbarValueChanged": ('int',),
    "PySide2.QtWidgets.QTreeView.viewportEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTreeView.viewportSizeHint": (),
    "PySide2.QtWidgets.QTreeView.visualRect": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeView.visualRegionForSelection": ('PySide2.QtCore.QItemSelection',),
    "PySide2.QtWidgets.QTreeView.wordWrap": (),

# class PySide2.QtWidgets.QTreeWidget:
    "PySide2.QtWidgets.QTreeWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QTreeWidget.addTopLevelItem": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.addTopLevelItems": ('typing.Sequence[PySide2.QtWidgets.QTreeWidgetItem]',),
    "PySide2.QtWidgets.QTreeWidget.clear": (),
    "PySide2.QtWidgets.QTreeWidget.closePersistentEditor": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QTreeWidgetItem', 'int')],
    "PySide2.QtWidgets.QTreeWidget.collapseItem": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.columnCount": (),
    "PySide2.QtWidgets.QTreeWidget.currentColumn": (),
    "PySide2.QtWidgets.QTreeWidget.currentItem": (),
    "PySide2.QtWidgets.QTreeWidget.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QTreeWidget.dropMimeData": ('PySide2.QtWidgets.QTreeWidgetItem', 'int', 'PySide2.QtCore.QMimeData', 'PySide2.QtCore.Qt.DropAction'),
    "PySide2.QtWidgets.QTreeWidget.editItem": ('PySide2.QtWidgets.QTreeWidgetItem', 'int'),
    "PySide2.QtWidgets.QTreeWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QTreeWidget.expandItem": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.findItems": ('str', 'PySide2.QtCore.Qt.MatchFlags', 'int'),
    "PySide2.QtWidgets.QTreeWidget.headerItem": (),
    "PySide2.QtWidgets.QTreeWidget.indexFromItem": ('PySide2.QtWidgets.QTreeWidgetItem', 'int'),
    "PySide2.QtWidgets.QTreeWidget.indexOfTopLevelItem": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.insertTopLevelItem": ('int', 'PySide2.QtWidgets.QTreeWidgetItem'),
    "PySide2.QtWidgets.QTreeWidget.insertTopLevelItems": ('int', 'typing.Sequence[PySide2.QtWidgets.QTreeWidgetItem]'),
    "PySide2.QtWidgets.QTreeWidget.invisibleRootItem": (),
    "PySide2.QtWidgets.QTreeWidget.isFirstItemColumnSpanned": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.isItemExpanded": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.isItemHidden": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.isItemSelected": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.isPersistentEditorOpen": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QTreeWidgetItem', 'int')],
    "PySide2.QtWidgets.QTreeWidget.itemAbove": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.itemAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QTreeWidget.itemBelow": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.itemFromIndex": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtWidgets.QTreeWidget.itemWidget": ('PySide2.QtWidgets.QTreeWidgetItem', 'int'),
    "PySide2.QtWidgets.QTreeWidget.items": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtWidgets.QTreeWidget.mimeData": ('typing.Sequence[PySide2.QtWidgets.QTreeWidgetItem]',),
    "PySide2.QtWidgets.QTreeWidget.mimeTypes": (),
    "PySide2.QtWidgets.QTreeWidget.openPersistentEditor": [('PySide2.QtCore.QModelIndex',), ('PySide2.QtWidgets.QTreeWidgetItem', 'int')],
    "PySide2.QtWidgets.QTreeWidget.removeItemWidget": ('PySide2.QtWidgets.QTreeWidgetItem', 'int'),
    "PySide2.QtWidgets.QTreeWidget.scrollToItem": ('PySide2.QtWidgets.QTreeWidgetItem', 'PySide2.QtWidgets.QAbstractItemView.ScrollHint'),
    "PySide2.QtWidgets.QTreeWidget.selectedItems": (),
    "PySide2.QtWidgets.QTreeWidget.setColumnCount": ('int',),
    "PySide2.QtWidgets.QTreeWidget.setCurrentItem": [('PySide2.QtWidgets.QTreeWidgetItem',), ('PySide2.QtWidgets.QTreeWidgetItem', 'int'), ('PySide2.QtWidgets.QTreeWidgetItem', 'int', 'PySide2.QtCore.QItemSelectionModel.SelectionFlags')],
    "PySide2.QtWidgets.QTreeWidget.setFirstItemColumnSpanned": ('PySide2.QtWidgets.QTreeWidgetItem', 'bool'),
    "PySide2.QtWidgets.QTreeWidget.setHeaderItem": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidget.setHeaderLabel": ('str',),
    "PySide2.QtWidgets.QTreeWidget.setHeaderLabels": ('typing.Sequence[str]',),
    "PySide2.QtWidgets.QTreeWidget.setItemExpanded": ('PySide2.QtWidgets.QTreeWidgetItem', 'bool'),
    "PySide2.QtWidgets.QTreeWidget.setItemHidden": ('PySide2.QtWidgets.QTreeWidgetItem', 'bool'),
    "PySide2.QtWidgets.QTreeWidget.setItemSelected": ('PySide2.QtWidgets.QTreeWidgetItem', 'bool'),
    "PySide2.QtWidgets.QTreeWidget.setItemWidget": ('PySide2.QtWidgets.QTreeWidgetItem', 'int', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QTreeWidget.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtWidgets.QTreeWidget.setSelectionModel": ('PySide2.QtCore.QItemSelectionModel',),
    "PySide2.QtWidgets.QTreeWidget.sortColumn": (),
    "PySide2.QtWidgets.QTreeWidget.sortItems": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtWidgets.QTreeWidget.supportedDropActions": (),
    "PySide2.QtWidgets.QTreeWidget.takeTopLevelItem": ('int',),
    "PySide2.QtWidgets.QTreeWidget.topLevelItem": ('int',),
    "PySide2.QtWidgets.QTreeWidget.topLevelItemCount": (),
    "PySide2.QtWidgets.QTreeWidget.visualItemRect": ('PySide2.QtWidgets.QTreeWidgetItem',),

# class PySide2.QtWidgets.QTreeWidgetItem:

# class PySide2.QtWidgets.QTreeWidgetItem.ChildIndicatorPolicy:

# class PySide2.QtWidgets.QTreeWidgetItem.ItemType:
    "PySide2.QtWidgets.QTreeWidgetItem.__init__": [('PySide2.QtWidgets.QTreeWidget', 'PySide2.QtWidgets.QTreeWidgetItem', 'int'), ('PySide2.QtWidgets.QTreeWidget', 'int'), ('PySide2.QtWidgets.QTreeWidget', 'typing.Sequence[str]', 'int'), ('PySide2.QtWidgets.QTreeWidgetItem',), ('PySide2.QtWidgets.QTreeWidgetItem', 'PySide2.QtWidgets.QTreeWidgetItem', 'int'), ('PySide2.QtWidgets.QTreeWidgetItem', 'int'), ('PySide2.QtWidgets.QTreeWidgetItem', 'typing.Sequence[str]', 'int'), ('int',), ('typing.Sequence[str]', 'int')],
    "PySide2.QtWidgets.QTreeWidgetItem.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QTreeWidgetItem.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QTreeWidgetItem.addChild": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidgetItem.addChildren": ('typing.Sequence[PySide2.QtWidgets.QTreeWidgetItem]',),
    "PySide2.QtWidgets.QTreeWidgetItem.background": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.backgroundColor": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.checkState": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.child": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.childCount": (),
    "PySide2.QtWidgets.QTreeWidgetItem.childIndicatorPolicy": (),
    "PySide2.QtWidgets.QTreeWidgetItem.clone": (),
    "PySide2.QtWidgets.QTreeWidgetItem.columnCount": (),
    "PySide2.QtWidgets.QTreeWidgetItem.data": ('int', 'int'),
    "PySide2.QtWidgets.QTreeWidgetItem.emitDataChanged": (),
    "PySide2.QtWidgets.QTreeWidgetItem.flags": (),
    "PySide2.QtWidgets.QTreeWidgetItem.font": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.foreground": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.icon": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.indexOfChild": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidgetItem.insertChild": ('int', 'PySide2.QtWidgets.QTreeWidgetItem'),
    "PySide2.QtWidgets.QTreeWidgetItem.insertChildren": ('int', 'typing.Sequence[PySide2.QtWidgets.QTreeWidgetItem]'),
    "PySide2.QtWidgets.QTreeWidgetItem.isDisabled": (),
    "PySide2.QtWidgets.QTreeWidgetItem.isExpanded": (),
    "PySide2.QtWidgets.QTreeWidgetItem.isFirstColumnSpanned": (),
    "PySide2.QtWidgets.QTreeWidgetItem.isHidden": (),
    "PySide2.QtWidgets.QTreeWidgetItem.isSelected": (),
    "PySide2.QtWidgets.QTreeWidgetItem.parent": (),
    "PySide2.QtWidgets.QTreeWidgetItem.read": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWidgets.QTreeWidgetItem.removeChild": ('PySide2.QtWidgets.QTreeWidgetItem',),
    "PySide2.QtWidgets.QTreeWidgetItem.setBackground": ('int', 'PySide2.QtGui.QBrush'),
    "PySide2.QtWidgets.QTreeWidgetItem.setBackgroundColor": ('int', 'PySide2.QtGui.QColor'),
    "PySide2.QtWidgets.QTreeWidgetItem.setCheckState": ('int', 'PySide2.QtCore.Qt.CheckState'),
    "PySide2.QtWidgets.QTreeWidgetItem.setChildIndicatorPolicy": ('PySide2.QtWidgets.QTreeWidgetItem.ChildIndicatorPolicy',),
    "PySide2.QtWidgets.QTreeWidgetItem.setData": ('int', 'int', 'typing.Any'),
    "PySide2.QtWidgets.QTreeWidgetItem.setDisabled": ('bool',),
    "PySide2.QtWidgets.QTreeWidgetItem.setExpanded": ('bool',),
    "PySide2.QtWidgets.QTreeWidgetItem.setFirstColumnSpanned": ('bool',),
    "PySide2.QtWidgets.QTreeWidgetItem.setFlags": ('PySide2.QtCore.Qt.ItemFlags',),
    "PySide2.QtWidgets.QTreeWidgetItem.setFont": ('int', 'PySide2.QtGui.QFont'),
    "PySide2.QtWidgets.QTreeWidgetItem.setForeground": ('int', 'PySide2.QtGui.QBrush'),
    "PySide2.QtWidgets.QTreeWidgetItem.setHidden": ('bool',),
    "PySide2.QtWidgets.QTreeWidgetItem.setIcon": ('int', 'PySide2.QtGui.QIcon'),
    "PySide2.QtWidgets.QTreeWidgetItem.setSelected": ('bool',),
    "PySide2.QtWidgets.QTreeWidgetItem.setSizeHint": ('int', 'PySide2.QtCore.QSize'),
    "PySide2.QtWidgets.QTreeWidgetItem.setStatusTip": ('int', 'str'),
    "PySide2.QtWidgets.QTreeWidgetItem.setText": ('int', 'str'),
    "PySide2.QtWidgets.QTreeWidgetItem.setTextAlignment": ('int', 'int'),
    "PySide2.QtWidgets.QTreeWidgetItem.setTextColor": ('int', 'PySide2.QtGui.QColor'),
    "PySide2.QtWidgets.QTreeWidgetItem.setToolTip": ('int', 'str'),
    "PySide2.QtWidgets.QTreeWidgetItem.setWhatsThis": ('int', 'str'),
    "PySide2.QtWidgets.QTreeWidgetItem.sizeHint": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.sortChildren": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtWidgets.QTreeWidgetItem.statusTip": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.takeChild": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.takeChildren": (),
    "PySide2.QtWidgets.QTreeWidgetItem.text": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.textAlignment": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.textColor": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.toolTip": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.treeWidget": (),
    "PySide2.QtWidgets.QTreeWidgetItem.type": (),
    "PySide2.QtWidgets.QTreeWidgetItem.whatsThis": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItem.write": ('PySide2.QtCore.QDataStream',),

# class PySide2.QtWidgets.QTreeWidgetItemIterator:

# class PySide2.QtWidgets.QTreeWidgetItemIterator.IteratorFlag:

# class PySide2.QtWidgets.QTreeWidgetItemIterator.IteratorFlags:
    "PySide2.QtWidgets.QTreeWidgetItemIterator.__init__": [('PySide2.QtWidgets.QTreeWidget', 'PySide2.QtWidgets.QTreeWidgetItemIterator.IteratorFlags'), ('PySide2.QtWidgets.QTreeWidgetItem', 'PySide2.QtWidgets.QTreeWidgetItemIterator.IteratorFlags'), ('PySide2.QtWidgets.QTreeWidgetItemIterator',)],
    "PySide2.QtWidgets.QTreeWidgetItemIterator.__copy__": (),
    "PySide2.QtWidgets.QTreeWidgetItemIterator.__iadd__": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItemIterator.__isub__": ('int',),
    "PySide2.QtWidgets.QTreeWidgetItemIterator.__iter__": (),
    "PySide2.QtWidgets.QTreeWidgetItemIterator.value": (),

# class PySide2.QtWidgets.QUndoCommand:
    "PySide2.QtWidgets.QUndoCommand.__init__": [('PySide2.QtWidgets.QUndoCommand',), ('str', 'PySide2.QtWidgets.QUndoCommand')],
    "PySide2.QtWidgets.QUndoCommand.actionText": (),
    "PySide2.QtWidgets.QUndoCommand.child": ('int',),
    "PySide2.QtWidgets.QUndoCommand.childCount": (),
    "PySide2.QtWidgets.QUndoCommand.id": (),
    "PySide2.QtWidgets.QUndoCommand.isObsolete": (),
    "PySide2.QtWidgets.QUndoCommand.mergeWith": ('PySide2.QtWidgets.QUndoCommand',),
    "PySide2.QtWidgets.QUndoCommand.redo": (),
    "PySide2.QtWidgets.QUndoCommand.setObsolete": ('bool',),
    "PySide2.QtWidgets.QUndoCommand.setText": ('str',),
    "PySide2.QtWidgets.QUndoCommand.text": (),
    "PySide2.QtWidgets.QUndoCommand.undo": (),

# class PySide2.QtWidgets.QUndoGroup:
    "PySide2.QtWidgets.QUndoGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QUndoGroup.activeStack": (),
    "PySide2.QtWidgets.QUndoGroup.addStack": ('PySide2.QtWidgets.QUndoStack',),
    "PySide2.QtWidgets.QUndoGroup.canRedo": (),
    "PySide2.QtWidgets.QUndoGroup.canUndo": (),
    "PySide2.QtWidgets.QUndoGroup.createRedoAction": ('PySide2.QtCore.QObject', 'str'),
    "PySide2.QtWidgets.QUndoGroup.createUndoAction": ('PySide2.QtCore.QObject', 'str'),
    "PySide2.QtWidgets.QUndoGroup.isClean": (),
    "PySide2.QtWidgets.QUndoGroup.redo": (),
    "PySide2.QtWidgets.QUndoGroup.redoText": (),
    "PySide2.QtWidgets.QUndoGroup.removeStack": ('PySide2.QtWidgets.QUndoStack',),
    "PySide2.QtWidgets.QUndoGroup.setActiveStack": ('PySide2.QtWidgets.QUndoStack',),
    "PySide2.QtWidgets.QUndoGroup.stacks": (),
    "PySide2.QtWidgets.QUndoGroup.undo": (),
    "PySide2.QtWidgets.QUndoGroup.undoText": (),

# class PySide2.QtWidgets.QUndoStack:
    "PySide2.QtWidgets.QUndoStack.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QUndoStack.beginMacro": ('str',),
    "PySide2.QtWidgets.QUndoStack.canRedo": (),
    "PySide2.QtWidgets.QUndoStack.canUndo": (),
    "PySide2.QtWidgets.QUndoStack.cleanIndex": (),
    "PySide2.QtWidgets.QUndoStack.clear": (),
    "PySide2.QtWidgets.QUndoStack.command": ('int',),
    "PySide2.QtWidgets.QUndoStack.count": (),
    "PySide2.QtWidgets.QUndoStack.createRedoAction": ('PySide2.QtCore.QObject', 'str'),
    "PySide2.QtWidgets.QUndoStack.createUndoAction": ('PySide2.QtCore.QObject', 'str'),
    "PySide2.QtWidgets.QUndoStack.endMacro": (),
    "PySide2.QtWidgets.QUndoStack.index": (),
    "PySide2.QtWidgets.QUndoStack.isActive": (),
    "PySide2.QtWidgets.QUndoStack.isClean": (),
    "PySide2.QtWidgets.QUndoStack.push": ('PySide2.QtWidgets.QUndoCommand',),
    "PySide2.QtWidgets.QUndoStack.redo": (),
    "PySide2.QtWidgets.QUndoStack.redoText": (),
    "PySide2.QtWidgets.QUndoStack.resetClean": (),
    "PySide2.QtWidgets.QUndoStack.setActive": ('bool',),
    "PySide2.QtWidgets.QUndoStack.setClean": (),
    "PySide2.QtWidgets.QUndoStack.setIndex": ('int',),
    "PySide2.QtWidgets.QUndoStack.setUndoLimit": ('int',),
    "PySide2.QtWidgets.QUndoStack.text": ('int',),
    "PySide2.QtWidgets.QUndoStack.undo": (),
    "PySide2.QtWidgets.QUndoStack.undoLimit": (),
    "PySide2.QtWidgets.QUndoStack.undoText": (),

# class PySide2.QtWidgets.QUndoView:
    "PySide2.QtWidgets.QUndoView.__init__": [('PySide2.QtWidgets.QUndoGroup', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QUndoStack', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtWidgets.QUndoView.cleanIcon": (),
    "PySide2.QtWidgets.QUndoView.emptyLabel": (),
    "PySide2.QtWidgets.QUndoView.group": (),
    "PySide2.QtWidgets.QUndoView.setCleanIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QUndoView.setEmptyLabel": ('str',),
    "PySide2.QtWidgets.QUndoView.setGroup": ('PySide2.QtWidgets.QUndoGroup',),
    "PySide2.QtWidgets.QUndoView.setStack": ('PySide2.QtWidgets.QUndoStack',),
    "PySide2.QtWidgets.QUndoView.stack": (),

# class PySide2.QtWidgets.QVBoxLayout:
    "PySide2.QtWidgets.QVBoxLayout.__init__": [(), ('PySide2.QtWidgets.QWidget',)],

# class PySide2.QtWidgets.QWhatsThis:
    "PySide2.QtWidgets.QWhatsThis.createAction": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QWhatsThis.enterWhatsThisMode": (),
    "PySide2.QtWidgets.QWhatsThis.hideText": (),
    "PySide2.QtWidgets.QWhatsThis.inWhatsThisMode": (),
    "PySide2.QtWidgets.QWhatsThis.leaveWhatsThisMode": (),
    "PySide2.QtWidgets.QWhatsThis.showText": ('PySide2.QtCore.QPoint', 'str', 'PySide2.QtWidgets.QWidget'),

# class PySide2.QtWidgets.QWidget:

# class PySide2.QtWidgets.QWidget.RenderFlag:

# class PySide2.QtWidgets.QWidget.RenderFlags:
    "PySide2.QtWidgets.QWidget.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QWidget.acceptDrops": (),
    "PySide2.QtWidgets.QWidget.accessibleDescription": (),
    "PySide2.QtWidgets.QWidget.accessibleName": (),
    "PySide2.QtWidgets.QWidget.actionEvent": ('PySide2.QtGui.QActionEvent',),
    "PySide2.QtWidgets.QWidget.actions": (),
    "PySide2.QtWidgets.QWidget.activateWindow": (),
    "PySide2.QtWidgets.QWidget.addAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QWidget.addActions": ('typing.Sequence[PySide2.QtWidgets.QAction]',),
    "PySide2.QtWidgets.QWidget.adjustSize": (),
    "PySide2.QtWidgets.QWidget.autoFillBackground": (),
    "PySide2.QtWidgets.QWidget.backgroundRole": (),
    "PySide2.QtWidgets.QWidget.backingStore": (),
    "PySide2.QtWidgets.QWidget.baseSize": (),
    "PySide2.QtWidgets.QWidget.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QWidget.childAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.childrenRect": (),
    "PySide2.QtWidgets.QWidget.childrenRegion": (),
    "PySide2.QtWidgets.QWidget.clearFocus": (),
    "PySide2.QtWidgets.QWidget.clearMask": (),
    "PySide2.QtWidgets.QWidget.close": (),
    "PySide2.QtWidgets.QWidget.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWidgets.QWidget.contentsMargins": (),
    "PySide2.QtWidgets.QWidget.contentsRect": (),
    "PySide2.QtWidgets.QWidget.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWidgets.QWidget.contextMenuPolicy": (),
    "PySide2.QtWidgets.QWidget.create": ('int', 'bool', 'bool'),
    "PySide2.QtWidgets.QWidget.createWinId": (),
    "PySide2.QtWidgets.QWidget.createWindowContainer": ('PySide2.QtGui.QWindow', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QWidget.cursor": (),
    "PySide2.QtWidgets.QWidget.destroy": ('bool', 'bool'),
    "PySide2.QtWidgets.QWidget.devType": (),
    "PySide2.QtWidgets.QWidget.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWidgets.QWidget.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWidgets.QWidget.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWidgets.QWidget.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWidgets.QWidget.effectiveWinId": (),
    "PySide2.QtWidgets.QWidget.ensurePolished": (),
    "PySide2.QtWidgets.QWidget.enterEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QWidget.find": ('int',),
    "PySide2.QtWidgets.QWidget.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QWidget.focusNextChild": (),
    "PySide2.QtWidgets.QWidget.focusNextPrevChild": ('bool',),
    "PySide2.QtWidgets.QWidget.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtWidgets.QWidget.focusPolicy": (),
    "PySide2.QtWidgets.QWidget.focusPreviousChild": (),
    "PySide2.QtWidgets.QWidget.focusProxy": (),
    "PySide2.QtWidgets.QWidget.focusWidget": (),
    "PySide2.QtWidgets.QWidget.font": (),
    "PySide2.QtWidgets.QWidget.fontInfo": (),
    "PySide2.QtWidgets.QWidget.fontMetrics": (),
    "PySide2.QtWidgets.QWidget.foregroundRole": (),
    "PySide2.QtWidgets.QWidget.frameGeometry": (),
    "PySide2.QtWidgets.QWidget.frameSize": (),
    "PySide2.QtWidgets.QWidget.geometry": (),
    "PySide2.QtWidgets.QWidget.getContentsMargins": (),
    "PySide2.QtWidgets.QWidget.grab": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QWidget.grabGesture": ('PySide2.QtCore.Qt.GestureType', 'PySide2.QtCore.Qt.GestureFlags'),
    "PySide2.QtWidgets.QWidget.grabKeyboard": (),
    "PySide2.QtWidgets.QWidget.grabMouse": [(), ('PySide2.QtGui.QCursor',)],
    "PySide2.QtWidgets.QWidget.grabShortcut": ('PySide2.QtGui.QKeySequence', 'PySide2.QtCore.Qt.ShortcutContext'),
    "PySide2.QtWidgets.QWidget.graphicsEffect": (),
    "PySide2.QtWidgets.QWidget.graphicsProxyWidget": (),
    "PySide2.QtWidgets.QWidget.hasFocus": (),
    "PySide2.QtWidgets.QWidget.hasHeightForWidth": (),
    "PySide2.QtWidgets.QWidget.hasMouseTracking": (),
    "PySide2.QtWidgets.QWidget.hasTabletTracking": (),
    "PySide2.QtWidgets.QWidget.height": (),
    "PySide2.QtWidgets.QWidget.heightForWidth": ('int',),
    "PySide2.QtWidgets.QWidget.hide": (),
    "PySide2.QtWidgets.QWidget.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWidgets.QWidget.initPainter": ('PySide2.QtGui.QPainter',),
    "PySide2.QtWidgets.QWidget.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtWidgets.QWidget.inputMethodHints": (),
    "PySide2.QtWidgets.QWidget.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtWidgets.QWidget.insertAction": ('PySide2.QtWidgets.QAction', 'PySide2.QtWidgets.QAction'),
    "PySide2.QtWidgets.QWidget.insertActions": ('PySide2.QtWidgets.QAction', 'typing.Sequence[PySide2.QtWidgets.QAction]'),
    "PySide2.QtWidgets.QWidget.internalWinId": (),
    "PySide2.QtWidgets.QWidget.isActiveWindow": (),
    "PySide2.QtWidgets.QWidget.isAncestorOf": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidget.isEnabled": (),
    "PySide2.QtWidgets.QWidget.isEnabledTo": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidget.isEnabledToTLW": (),
    "PySide2.QtWidgets.QWidget.isFullScreen": (),
    "PySide2.QtWidgets.QWidget.isHidden": (),
    "PySide2.QtWidgets.QWidget.isLeftToRight": (),
    "PySide2.QtWidgets.QWidget.isMaximized": (),
    "PySide2.QtWidgets.QWidget.isMinimized": (),
    "PySide2.QtWidgets.QWidget.isModal": (),
    "PySide2.QtWidgets.QWidget.isRightToLeft": (),
    "PySide2.QtWidgets.QWidget.isTopLevel": (),
    "PySide2.QtWidgets.QWidget.isVisible": (),
    "PySide2.QtWidgets.QWidget.isVisibleTo": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidget.isWindow": (),
    "PySide2.QtWidgets.QWidget.isWindowModified": (),
    "PySide2.QtWidgets.QWidget.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QWidget.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtWidgets.QWidget.keyboardGrabber": (),
    "PySide2.QtWidgets.QWidget.layout": (),
    "PySide2.QtWidgets.QWidget.layoutDirection": (),
    "PySide2.QtWidgets.QWidget.leaveEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QWidget.locale": (),
    "PySide2.QtWidgets.QWidget.lower": (),
    "PySide2.QtWidgets.QWidget.mapFrom": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QPoint'),
    "PySide2.QtWidgets.QWidget.mapFromGlobal": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QWidget.mapFromParent": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QWidget.mapTo": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QPoint'),
    "PySide2.QtWidgets.QWidget.mapToGlobal": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QWidget.mapToParent": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QWidget.mask": (),
    "PySide2.QtWidgets.QWidget.maximumHeight": (),
    "PySide2.QtWidgets.QWidget.maximumSize": (),
    "PySide2.QtWidgets.QWidget.maximumWidth": (),
    "PySide2.QtWidgets.QWidget.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtWidgets.QWidget.minimumHeight": (),
    "PySide2.QtWidgets.QWidget.minimumSize": (),
    "PySide2.QtWidgets.QWidget.minimumSizeHint": (),
    "PySide2.QtWidgets.QWidget.minimumWidth": (),
    "PySide2.QtWidgets.QWidget.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QWidget.mouseGrabber": (),
    "PySide2.QtWidgets.QWidget.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QWidget.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QWidget.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtWidgets.QWidget.move": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.moveEvent": ('PySide2.QtGui.QMoveEvent',),
    "PySide2.QtWidgets.QWidget.nativeEvent": ('PySide2.QtCore.QByteArray', 'int'),
    "PySide2.QtWidgets.QWidget.nativeParentWidget": (),
    "PySide2.QtWidgets.QWidget.nextInFocusChain": (),
    "PySide2.QtWidgets.QWidget.normalGeometry": (),
    "PySide2.QtWidgets.QWidget.overrideWindowFlags": ('PySide2.QtCore.Qt.WindowFlags',),
    "PySide2.QtWidgets.QWidget.overrideWindowState": ('PySide2.QtCore.Qt.WindowStates',),
    "PySide2.QtWidgets.QWidget.paintEngine": (),
    "PySide2.QtWidgets.QWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QWidget.palette": (),
    "PySide2.QtWidgets.QWidget.parentWidget": (),
    "PySide2.QtWidgets.QWidget.pos": (),
    "PySide2.QtWidgets.QWidget.previousInFocusChain": (),
    "PySide2.QtWidgets.QWidget.raise_": (),
    "PySide2.QtWidgets.QWidget.rect": (),
    "PySide2.QtWidgets.QWidget.redirected": ('PySide2.QtCore.QPoint',),
    "PySide2.QtWidgets.QWidget.releaseKeyboard": (),
    "PySide2.QtWidgets.QWidget.releaseMouse": (),
    "PySide2.QtWidgets.QWidget.releaseShortcut": ('int',),
    "PySide2.QtWidgets.QWidget.removeAction": ('PySide2.QtWidgets.QAction',),
    "PySide2.QtWidgets.QWidget.render": [('PySide2.QtGui.QPaintDevice', 'PySide2.QtCore.QPoint', 'PySide2.QtGui.QRegion', 'PySide2.QtWidgets.QWidget.RenderFlags'), ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QPoint', 'PySide2.QtGui.QRegion', 'PySide2.QtWidgets.QWidget.RenderFlags')],
    "PySide2.QtWidgets.QWidget.repaint": [(), ('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QWidget.resize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QWidget.restoreGeometry": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWidgets.QWidget.saveGeometry": (),
    "PySide2.QtWidgets.QWidget.screen": (),
    "PySide2.QtWidgets.QWidget.scroll": [('int', 'int'), ('int', 'int', 'PySide2.QtCore.QRect')],
    "PySide2.QtWidgets.QWidget.setAcceptDrops": ('bool',),
    "PySide2.QtWidgets.QWidget.setAccessibleDescription": ('str',),
    "PySide2.QtWidgets.QWidget.setAccessibleName": ('str',),
    "PySide2.QtWidgets.QWidget.setAttribute": ('PySide2.QtCore.Qt.WidgetAttribute', 'bool'),
    "PySide2.QtWidgets.QWidget.setAutoFillBackground": ('bool',),
    "PySide2.QtWidgets.QWidget.setBackgroundRole": ('PySide2.QtGui.QPalette.ColorRole',),
    "PySide2.QtWidgets.QWidget.setBaseSize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.setContentsMargins": [('PySide2.QtCore.QMargins',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QWidget.setContextMenuPolicy": ('PySide2.QtCore.Qt.ContextMenuPolicy',),
    "PySide2.QtWidgets.QWidget.setCursor": ('PySide2.QtGui.QCursor',),
    "PySide2.QtWidgets.QWidget.setDisabled": ('bool',),
    "PySide2.QtWidgets.QWidget.setEnabled": ('bool',),
    "PySide2.QtWidgets.QWidget.setFixedHeight": ('int',),
    "PySide2.QtWidgets.QWidget.setFixedSize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.setFixedWidth": ('int',),
    "PySide2.QtWidgets.QWidget.setFocus": [(), ('PySide2.QtCore.Qt.FocusReason',)],
    "PySide2.QtWidgets.QWidget.setFocusPolicy": ('PySide2.QtCore.Qt.FocusPolicy',),
    "PySide2.QtWidgets.QWidget.setFocusProxy": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidget.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtWidgets.QWidget.setForegroundRole": ('PySide2.QtGui.QPalette.ColorRole',),
    "PySide2.QtWidgets.QWidget.setGeometry": [('PySide2.QtCore.QRect',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QWidget.setGraphicsEffect": ('PySide2.QtWidgets.QGraphicsEffect',),
    "PySide2.QtWidgets.QWidget.setHidden": ('bool',),
    "PySide2.QtWidgets.QWidget.setInputMethodHints": ('PySide2.QtCore.Qt.InputMethodHints',),
    "PySide2.QtWidgets.QWidget.setLayout": ('PySide2.QtWidgets.QLayout',),
    "PySide2.QtWidgets.QWidget.setLayoutDirection": ('PySide2.QtCore.Qt.LayoutDirection',),
    "PySide2.QtWidgets.QWidget.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtWidgets.QWidget.setMask": [('PySide2.QtGui.QBitmap',), ('PySide2.QtGui.QRegion',)],
    "PySide2.QtWidgets.QWidget.setMaximumHeight": ('int',),
    "PySide2.QtWidgets.QWidget.setMaximumSize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.setMaximumWidth": ('int',),
    "PySide2.QtWidgets.QWidget.setMinimumHeight": ('int',),
    "PySide2.QtWidgets.QWidget.setMinimumSize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.setMinimumWidth": ('int',),
    "PySide2.QtWidgets.QWidget.setMouseTracking": ('bool',),
    "PySide2.QtWidgets.QWidget.setPalette": ('PySide2.QtGui.QPalette',),
    "PySide2.QtWidgets.QWidget.setParent": [('PySide2.QtWidgets.QWidget',), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtWidgets.QWidget.setShortcutAutoRepeat": ('int', 'bool'),
    "PySide2.QtWidgets.QWidget.setShortcutEnabled": ('int', 'bool'),
    "PySide2.QtWidgets.QWidget.setSizeIncrement": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtWidgets.QWidget.setSizePolicy": [('PySide2.QtWidgets.QSizePolicy',), ('PySide2.QtWidgets.QSizePolicy.Policy', 'PySide2.QtWidgets.QSizePolicy.Policy')],
    "PySide2.QtWidgets.QWidget.setStatusTip": ('str',),
    "PySide2.QtWidgets.QWidget.setStyle": ('PySide2.QtWidgets.QStyle',),
    "PySide2.QtWidgets.QWidget.setStyleSheet": ('str',),
    "PySide2.QtWidgets.QWidget.setTabOrder": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtWidgets.QWidget.setTabletTracking": ('bool',),
    "PySide2.QtWidgets.QWidget.setToolTip": ('str',),
    "PySide2.QtWidgets.QWidget.setToolTipDuration": ('int',),
    "PySide2.QtWidgets.QWidget.setUpdatesEnabled": ('bool',),
    "PySide2.QtWidgets.QWidget.setVisible": ('bool',),
    "PySide2.QtWidgets.QWidget.setWhatsThis": ('str',),
    "PySide2.QtWidgets.QWidget.setWindowFilePath": ('str',),
    "PySide2.QtWidgets.QWidget.setWindowFlag": ('PySide2.QtCore.Qt.WindowType', 'bool'),
    "PySide2.QtWidgets.QWidget.setWindowFlags": ('PySide2.QtCore.Qt.WindowFlags',),
    "PySide2.QtWidgets.QWidget.setWindowIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtWidgets.QWidget.setWindowIconText": ('str',),
    "PySide2.QtWidgets.QWidget.setWindowModality": ('PySide2.QtCore.Qt.WindowModality',),
    "PySide2.QtWidgets.QWidget.setWindowModified": ('bool',),
    "PySide2.QtWidgets.QWidget.setWindowOpacity": ('float',),
    "PySide2.QtWidgets.QWidget.setWindowRole": ('str',),
    "PySide2.QtWidgets.QWidget.setWindowState": ('PySide2.QtCore.Qt.WindowStates',),
    "PySide2.QtWidgets.QWidget.setWindowTitle": ('str',),
    "PySide2.QtWidgets.QWidget.sharedPainter": (),
    "PySide2.QtWidgets.QWidget.show": (),
    "PySide2.QtWidgets.QWidget.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWidgets.QWidget.showFullScreen": (),
    "PySide2.QtWidgets.QWidget.showMaximized": (),
    "PySide2.QtWidgets.QWidget.showMinimized": (),
    "PySide2.QtWidgets.QWidget.showNormal": (),
    "PySide2.QtWidgets.QWidget.size": (),
    "PySide2.QtWidgets.QWidget.sizeHint": (),
    "PySide2.QtWidgets.QWidget.sizeIncrement": (),
    "PySide2.QtWidgets.QWidget.sizePolicy": (),
    "PySide2.QtWidgets.QWidget.stackUnder": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidget.statusTip": (),
    "PySide2.QtWidgets.QWidget.style": (),
    "PySide2.QtWidgets.QWidget.styleSheet": (),
    "PySide2.QtWidgets.QWidget.tabletEvent": ('PySide2.QtGui.QTabletEvent',),
    "PySide2.QtWidgets.QWidget.testAttribute": ('PySide2.QtCore.Qt.WidgetAttribute',),
    "PySide2.QtWidgets.QWidget.toolTip": (),
    "PySide2.QtWidgets.QWidget.toolTipDuration": (),
    "PySide2.QtWidgets.QWidget.topLevelWidget": (),
    "PySide2.QtWidgets.QWidget.underMouse": (),
    "PySide2.QtWidgets.QWidget.ungrabGesture": ('PySide2.QtCore.Qt.GestureType',),
    "PySide2.QtWidgets.QWidget.unsetCursor": (),
    "PySide2.QtWidgets.QWidget.unsetLayoutDirection": (),
    "PySide2.QtWidgets.QWidget.unsetLocale": (),
    "PySide2.QtWidgets.QWidget.update": [(), ('PySide2.QtCore.QRect',), ('PySide2.QtGui.QRegion',), ('int', 'int', 'int', 'int')],
    "PySide2.QtWidgets.QWidget.updateGeometry": (),
    "PySide2.QtWidgets.QWidget.updateMicroFocus": (),
    "PySide2.QtWidgets.QWidget.updatesEnabled": (),
    "PySide2.QtWidgets.QWidget.visibleRegion": (),
    "PySide2.QtWidgets.QWidget.whatsThis": (),
    "PySide2.QtWidgets.QWidget.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtWidgets.QWidget.width": (),
    "PySide2.QtWidgets.QWidget.winId": (),
    "PySide2.QtWidgets.QWidget.window": (),
    "PySide2.QtWidgets.QWidget.windowFilePath": (),
    "PySide2.QtWidgets.QWidget.windowFlags": (),
    "PySide2.QtWidgets.QWidget.windowHandle": (),
    "PySide2.QtWidgets.QWidget.windowIcon": (),
    "PySide2.QtWidgets.QWidget.windowIconText": (),
    "PySide2.QtWidgets.QWidget.windowModality": (),
    "PySide2.QtWidgets.QWidget.windowOpacity": (),
    "PySide2.QtWidgets.QWidget.windowRole": (),
    "PySide2.QtWidgets.QWidget.windowState": (),
    "PySide2.QtWidgets.QWidget.windowTitle": (),
    "PySide2.QtWidgets.QWidget.windowType": (),
    "PySide2.QtWidgets.QWidget.x": (),
    "PySide2.QtWidgets.QWidget.y": (),

# class PySide2.QtWidgets.QWidgetAction:
    "PySide2.QtWidgets.QWidgetAction.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWidgets.QWidgetAction.createWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidgetAction.createdWidgets": (),
    "PySide2.QtWidgets.QWidgetAction.defaultWidget": (),
    "PySide2.QtWidgets.QWidgetAction.deleteWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidgetAction.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QWidgetAction.eventFilter": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QEvent'),
    "PySide2.QtWidgets.QWidgetAction.releaseWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidgetAction.requestWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidgetAction.setDefaultWidget": ('PySide2.QtWidgets.QWidget',),

# class PySide2.QtWidgets.QWidgetItem:
    "PySide2.QtWidgets.QWidgetItem.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWidgetItem.controlTypes": (),
    "PySide2.QtWidgets.QWidgetItem.expandingDirections": (),
    "PySide2.QtWidgets.QWidgetItem.geometry": (),
    "PySide2.QtWidgets.QWidgetItem.hasHeightForWidth": (),
    "PySide2.QtWidgets.QWidgetItem.heightForWidth": ('int',),
    "PySide2.QtWidgets.QWidgetItem.isEmpty": (),
    "PySide2.QtWidgets.QWidgetItem.maximumSize": (),
    "PySide2.QtWidgets.QWidgetItem.minimumSize": (),
    "PySide2.QtWidgets.QWidgetItem.setGeometry": ('PySide2.QtCore.QRect',),
    "PySide2.QtWidgets.QWidgetItem.sizeHint": (),
    "PySide2.QtWidgets.QWidgetItem.widget": (),

# class PySide2.QtWidgets.QWizard:

# class PySide2.QtWidgets.QWizard.WizardButton:

# class PySide2.QtWidgets.QWizard.WizardOption:

# class PySide2.QtWidgets.QWizard.WizardOptions:

# class PySide2.QtWidgets.QWizard.WizardPixmap:

# class PySide2.QtWidgets.QWizard.WizardStyle:
    "PySide2.QtWidgets.QWizard.__init__": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtWidgets.QWizard.addPage": ('PySide2.QtWidgets.QWizardPage',),
    "PySide2.QtWidgets.QWizard.back": (),
    "PySide2.QtWidgets.QWizard.button": ('PySide2.QtWidgets.QWizard.WizardButton',),
    "PySide2.QtWidgets.QWizard.buttonText": ('PySide2.QtWidgets.QWizard.WizardButton',),
    "PySide2.QtWidgets.QWizard.cleanupPage": ('int',),
    "PySide2.QtWidgets.QWizard.currentId": (),
    "PySide2.QtWidgets.QWizard.currentPage": (),
    "PySide2.QtWidgets.QWizard.done": ('int',),
    "PySide2.QtWidgets.QWizard.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWidgets.QWizard.field": ('str',),
    "PySide2.QtWidgets.QWizard.hasVisitedPage": ('int',),
    "PySide2.QtWidgets.QWizard.initializePage": ('int',),
    "PySide2.QtWidgets.QWizard.nextId": (),
    "PySide2.QtWidgets.QWizard.options": (),
    "PySide2.QtWidgets.QWizard.page": ('int',),
    "PySide2.QtWidgets.QWizard.pageIds": (),
    "PySide2.QtWidgets.QWizard.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtWidgets.QWizard.pixmap": ('PySide2.QtWidgets.QWizard.WizardPixmap',),
    "PySide2.QtWidgets.QWizard.removePage": ('int',),
    "PySide2.QtWidgets.QWizard.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtWidgets.QWizard.restart": (),
    "PySide2.QtWidgets.QWizard.setButton": ('PySide2.QtWidgets.QWizard.WizardButton', 'PySide2.QtWidgets.QAbstractButton'),
    "PySide2.QtWidgets.QWizard.setButtonLayout": ('typing.Sequence[PySide2.QtWidgets.QWizard.WizardButton]',),
    "PySide2.QtWidgets.QWizard.setButtonText": ('PySide2.QtWidgets.QWizard.WizardButton', 'str'),
    "PySide2.QtWidgets.QWizard.setDefaultProperty": ('str', 'str', 'str'),
    "PySide2.QtWidgets.QWizard.setField": ('str', 'typing.Any'),
    "PySide2.QtWidgets.QWizard.setOption": ('PySide2.QtWidgets.QWizard.WizardOption', 'bool'),
    "PySide2.QtWidgets.QWizard.setOptions": ('PySide2.QtWidgets.QWizard.WizardOptions',),
    "PySide2.QtWidgets.QWizard.setPage": ('int', 'PySide2.QtWidgets.QWizardPage'),
    "PySide2.QtWidgets.QWizard.setPixmap": ('PySide2.QtWidgets.QWizard.WizardPixmap', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QWizard.setSideWidget": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWizard.setStartId": ('int',),
    "PySide2.QtWidgets.QWizard.setSubTitleFormat": ('PySide2.QtCore.Qt.TextFormat',),
    "PySide2.QtWidgets.QWizard.setTitleFormat": ('PySide2.QtCore.Qt.TextFormat',),
    "PySide2.QtWidgets.QWizard.setVisible": ('bool',),
    "PySide2.QtWidgets.QWizard.setWizardStyle": ('PySide2.QtWidgets.QWizard.WizardStyle',),
    "PySide2.QtWidgets.QWizard.sideWidget": (),
    "PySide2.QtWidgets.QWizard.sizeHint": (),
    "PySide2.QtWidgets.QWizard.startId": (),
    "PySide2.QtWidgets.QWizard.subTitleFormat": (),
    "PySide2.QtWidgets.QWizard.testOption": ('PySide2.QtWidgets.QWizard.WizardOption',),
    "PySide2.QtWidgets.QWizard.titleFormat": (),
    "PySide2.QtWidgets.QWizard.validateCurrentPage": (),
    "PySide2.QtWidgets.QWizard.visitedPages": (),
    "PySide2.QtWidgets.QWizard.wizardStyle": (),

# class PySide2.QtWidgets.QWizardPage:
    "PySide2.QtWidgets.QWizardPage.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWidgets.QWizardPage.buttonText": ('PySide2.QtWidgets.QWizard.WizardButton',),
    "PySide2.QtWidgets.QWizardPage.cleanupPage": (),
    "PySide2.QtWidgets.QWizardPage.field": ('str',),
    "PySide2.QtWidgets.QWizardPage.initializePage": (),
    "PySide2.QtWidgets.QWizardPage.isCommitPage": (),
    "PySide2.QtWidgets.QWizardPage.isComplete": (),
    "PySide2.QtWidgets.QWizardPage.isFinalPage": (),
    "PySide2.QtWidgets.QWizardPage.nextId": (),
    "PySide2.QtWidgets.QWizardPage.pixmap": ('PySide2.QtWidgets.QWizard.WizardPixmap',),
    "PySide2.QtWidgets.QWizardPage.registerField": ('str', 'PySide2.QtWidgets.QWidget', 'str', 'str'),
    "PySide2.QtWidgets.QWizardPage.setButtonText": ('PySide2.QtWidgets.QWizard.WizardButton', 'str'),
    "PySide2.QtWidgets.QWizardPage.setCommitPage": ('bool',),
    "PySide2.QtWidgets.QWizardPage.setField": ('str', 'typing.Any'),
    "PySide2.QtWidgets.QWizardPage.setFinalPage": ('bool',),
    "PySide2.QtWidgets.QWizardPage.setPixmap": ('PySide2.QtWidgets.QWizard.WizardPixmap', 'PySide2.QtGui.QPixmap'),
    "PySide2.QtWidgets.QWizardPage.setSubTitle": ('str',),
    "PySide2.QtWidgets.QWizardPage.setTitle": ('str',),
    "PySide2.QtWidgets.QWizardPage.subTitle": (),
    "PySide2.QtWidgets.QWizardPage.title": (),
    "PySide2.QtWidgets.QWizardPage.validatePage": (),
    "PySide2.QtWidgets.QWizardPage.wizard": (),
    }) if "PySide2.QtWidgets" in sys.modules else None

# Module PySide2.QtPrintSupport
sig_dict.update({

# class PySide2.QtPrintSupport.QAbstractPrintDialog:

# class PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOption:

# class PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOptions:

# class PySide2.QtPrintSupport.QAbstractPrintDialog.PrintRange:
    "PySide2.QtPrintSupport.QAbstractPrintDialog.__init__": ('PySide2.QtPrintSupport.QPrinter', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.addEnabledOption": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOption',),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.enabledOptions": (),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.fromPage": (),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.isOptionEnabled": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOption',),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.maxPage": (),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.minPage": (),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.printRange": (),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.printer": (),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.setEnabledOptions": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOptions',),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.setFromTo": ('int', 'int'),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.setMinMax": ('int', 'int'),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.setOptionTabs": ('typing.Sequence[PySide2.QtWidgets.QWidget]',),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.setPrintRange": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintRange',),
    "PySide2.QtPrintSupport.QAbstractPrintDialog.toPage": (),

# class PySide2.QtPrintSupport.QPageSetupDialog:
    "PySide2.QtPrintSupport.QPageSetupDialog.__init__": [('PySide2.QtPrintSupport.QPrinter', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtPrintSupport.QPageSetupDialog.done": ('int',),
    "PySide2.QtPrintSupport.QPageSetupDialog.exec_": (),
    "PySide2.QtPrintSupport.QPageSetupDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtPrintSupport.QPageSetupDialog.printer": (),
    "PySide2.QtPrintSupport.QPageSetupDialog.setVisible": ('bool',),

# class PySide2.QtPrintSupport.QPrintDialog:
    "PySide2.QtPrintSupport.QPrintDialog.__init__": [('PySide2.QtPrintSupport.QPrinter', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtPrintSupport.QPrintDialog.done": ('int',),
    "PySide2.QtPrintSupport.QPrintDialog.exec_": (),
    "PySide2.QtPrintSupport.QPrintDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtPrintSupport.QPrintDialog.options": (),
    "PySide2.QtPrintSupport.QPrintDialog.setOption": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOption', 'bool'),
    "PySide2.QtPrintSupport.QPrintDialog.setOptions": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOptions',),
    "PySide2.QtPrintSupport.QPrintDialog.setVisible": ('bool',),
    "PySide2.QtPrintSupport.QPrintDialog.testOption": ('PySide2.QtPrintSupport.QAbstractPrintDialog.PrintDialogOption',),

# class PySide2.QtPrintSupport.QPrintEngine:

# class PySide2.QtPrintSupport.QPrintEngine.PrintEnginePropertyKey:
    "PySide2.QtPrintSupport.QPrintEngine.__init__": (),
    "PySide2.QtPrintSupport.QPrintEngine.abort": (),
    "PySide2.QtPrintSupport.QPrintEngine.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtPrintSupport.QPrintEngine.newPage": (),
    "PySide2.QtPrintSupport.QPrintEngine.printerState": (),
    "PySide2.QtPrintSupport.QPrintEngine.property": ('PySide2.QtPrintSupport.QPrintEngine.PrintEnginePropertyKey',),
    "PySide2.QtPrintSupport.QPrintEngine.setProperty": ('PySide2.QtPrintSupport.QPrintEngine.PrintEnginePropertyKey', 'typing.Any'),

# class PySide2.QtPrintSupport.QPrintPreviewDialog:
    "PySide2.QtPrintSupport.QPrintPreviewDialog.__init__": [('PySide2.QtPrintSupport.QPrinter', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtPrintSupport.QPrintPreviewDialog.done": ('int',),
    "PySide2.QtPrintSupport.QPrintPreviewDialog.open": [(), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtPrintSupport.QPrintPreviewDialog.printer": (),
    "PySide2.QtPrintSupport.QPrintPreviewDialog.setVisible": ('bool',),

# class PySide2.QtPrintSupport.QPrintPreviewWidget:

# class PySide2.QtPrintSupport.QPrintPreviewWidget.ViewMode:

# class PySide2.QtPrintSupport.QPrintPreviewWidget.ZoomMode:
    "PySide2.QtPrintSupport.QPrintPreviewWidget.__init__": [('PySide2.QtPrintSupport.QPrinter', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtPrintSupport.QPrintPreviewWidget.currentPage": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.fitInView": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.fitToWidth": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.orientation": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.pageCount": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.print_": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setAllPagesViewMode": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setCurrentPage": ('int',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setFacingPagesViewMode": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setLandscapeOrientation": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setOrientation": ('PySide2.QtPrintSupport.QPrinter.Orientation',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setPortraitOrientation": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setSinglePageViewMode": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setViewMode": ('PySide2.QtPrintSupport.QPrintPreviewWidget.ViewMode',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setVisible": ('bool',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setZoomFactor": ('float',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.setZoomMode": ('PySide2.QtPrintSupport.QPrintPreviewWidget.ZoomMode',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.updatePreview": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.viewMode": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.zoomFactor": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.zoomIn": ('float',),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.zoomMode": (),
    "PySide2.QtPrintSupport.QPrintPreviewWidget.zoomOut": ('float',),

# class PySide2.QtPrintSupport.QPrinter:

# class PySide2.QtPrintSupport.QPrinter.ColorMode:

# class PySide2.QtPrintSupport.QPrinter.DuplexMode:

# class PySide2.QtPrintSupport.QPrinter.Orientation:

# class PySide2.QtPrintSupport.QPrinter.OutputFormat:

# class PySide2.QtPrintSupport.QPrinter.PageOrder:

# class PySide2.QtPrintSupport.QPrinter.PaperSource:

# class PySide2.QtPrintSupport.QPrinter.PrintRange:

# class PySide2.QtPrintSupport.QPrinter.PrinterMode:

# class PySide2.QtPrintSupport.QPrinter.PrinterState:

# class PySide2.QtPrintSupport.QPrinter.Unit:
    "PySide2.QtPrintSupport.QPrinter.__init__": [('PySide2.QtPrintSupport.QPrinter.PrinterMode',), ('PySide2.QtPrintSupport.QPrinterInfo', 'PySide2.QtPrintSupport.QPrinter.PrinterMode')],
    "PySide2.QtPrintSupport.QPrinter.abort": (),
    "PySide2.QtPrintSupport.QPrinter.actualNumCopies": (),
    "PySide2.QtPrintSupport.QPrinter.collateCopies": (),
    "PySide2.QtPrintSupport.QPrinter.colorMode": (),
    "PySide2.QtPrintSupport.QPrinter.copyCount": (),
    "PySide2.QtPrintSupport.QPrinter.creator": (),
    "PySide2.QtPrintSupport.QPrinter.devType": (),
    "PySide2.QtPrintSupport.QPrinter.docName": (),
    "PySide2.QtPrintSupport.QPrinter.doubleSidedPrinting": (),
    "PySide2.QtPrintSupport.QPrinter.duplex": (),
    "PySide2.QtPrintSupport.QPrinter.fontEmbeddingEnabled": (),
    "PySide2.QtPrintSupport.QPrinter.fromPage": (),
    "PySide2.QtPrintSupport.QPrinter.fullPage": (),
    "PySide2.QtPrintSupport.QPrinter.getPageMargins": ('PySide2.QtPrintSupport.QPrinter.Unit',),
    "PySide2.QtPrintSupport.QPrinter.isValid": (),
    "PySide2.QtPrintSupport.QPrinter.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtPrintSupport.QPrinter.newPage": (),
    "PySide2.QtPrintSupport.QPrinter.numCopies": (),
    "PySide2.QtPrintSupport.QPrinter.orientation": (),
    "PySide2.QtPrintSupport.QPrinter.outputFileName": (),
    "PySide2.QtPrintSupport.QPrinter.outputFormat": (),
    "PySide2.QtPrintSupport.QPrinter.pageOrder": (),
    "PySide2.QtPrintSupport.QPrinter.pageRect": [(), ('PySide2.QtPrintSupport.QPrinter.Unit',)],
    "PySide2.QtPrintSupport.QPrinter.pageSize": (),
    "PySide2.QtPrintSupport.QPrinter.paintEngine": (),
    "PySide2.QtPrintSupport.QPrinter.paperName": (),
    "PySide2.QtPrintSupport.QPrinter.paperRect": [(), ('PySide2.QtPrintSupport.QPrinter.Unit',)],
    "PySide2.QtPrintSupport.QPrinter.paperSize": [(), ('PySide2.QtPrintSupport.QPrinter.Unit',)],
    "PySide2.QtPrintSupport.QPrinter.paperSource": (),
    "PySide2.QtPrintSupport.QPrinter.pdfVersion": (),
    "PySide2.QtPrintSupport.QPrinter.printEngine": (),
    "PySide2.QtPrintSupport.QPrinter.printProgram": (),
    "PySide2.QtPrintSupport.QPrinter.printRange": (),
    "PySide2.QtPrintSupport.QPrinter.printerName": (),
    "PySide2.QtPrintSupport.QPrinter.printerState": (),
    "PySide2.QtPrintSupport.QPrinter.resolution": (),
    "PySide2.QtPrintSupport.QPrinter.setCollateCopies": ('bool',),
    "PySide2.QtPrintSupport.QPrinter.setColorMode": ('PySide2.QtPrintSupport.QPrinter.ColorMode',),
    "PySide2.QtPrintSupport.QPrinter.setCopyCount": ('int',),
    "PySide2.QtPrintSupport.QPrinter.setCreator": ('str',),
    "PySide2.QtPrintSupport.QPrinter.setDocName": ('str',),
    "PySide2.QtPrintSupport.QPrinter.setDoubleSidedPrinting": ('bool',),
    "PySide2.QtPrintSupport.QPrinter.setDuplex": ('PySide2.QtPrintSupport.QPrinter.DuplexMode',),
    "PySide2.QtPrintSupport.QPrinter.setEngines": ('PySide2.QtPrintSupport.QPrintEngine', 'PySide2.QtGui.QPaintEngine'),
    "PySide2.QtPrintSupport.QPrinter.setFontEmbeddingEnabled": ('bool',),
    "PySide2.QtPrintSupport.QPrinter.setFromTo": ('int', 'int'),
    "PySide2.QtPrintSupport.QPrinter.setFullPage": ('bool',),
    "PySide2.QtPrintSupport.QPrinter.setMargins": ('PySide2.QtGui.QPagedPaintDevice.Margins',),
    "PySide2.QtPrintSupport.QPrinter.setNumCopies": ('int',),
    "PySide2.QtPrintSupport.QPrinter.setOrientation": ('PySide2.QtPrintSupport.QPrinter.Orientation',),
    "PySide2.QtPrintSupport.QPrinter.setOutputFileName": ('str',),
    "PySide2.QtPrintSupport.QPrinter.setOutputFormat": ('PySide2.QtPrintSupport.QPrinter.OutputFormat',),
    "PySide2.QtPrintSupport.QPrinter.setPageMargins": [('PySide2.QtCore.QMarginsF',), ('float', 'float', 'float', 'float', 'PySide2.QtPrintSupport.QPrinter.Unit')],
    "PySide2.QtPrintSupport.QPrinter.setPageOrder": ('PySide2.QtPrintSupport.QPrinter.PageOrder',),
    "PySide2.QtPrintSupport.QPrinter.setPageSize": [('PySide2.QtGui.QPageSize',), ('PySide2.QtGui.QPagedPaintDevice.PageSize',)],
    "PySide2.QtPrintSupport.QPrinter.setPageSizeMM": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtPrintSupport.QPrinter.setPaperName": ('str',),
    "PySide2.QtPrintSupport.QPrinter.setPaperSize": [('PySide2.QtCore.QSizeF', 'PySide2.QtPrintSupport.QPrinter.Unit'), ('PySide2.QtGui.QPagedPaintDevice.PageSize',)],
    "PySide2.QtPrintSupport.QPrinter.setPaperSource": ('PySide2.QtPrintSupport.QPrinter.PaperSource',),
    "PySide2.QtPrintSupport.QPrinter.setPdfVersion": ('PySide2.QtGui.QPagedPaintDevice.PdfVersion',),
    "PySide2.QtPrintSupport.QPrinter.setPrintProgram": ('str',),
    "PySide2.QtPrintSupport.QPrinter.setPrintRange": ('PySide2.QtPrintSupport.QPrinter.PrintRange',),
    "PySide2.QtPrintSupport.QPrinter.setPrinterName": ('str',),
    "PySide2.QtPrintSupport.QPrinter.setResolution": ('int',),
    "PySide2.QtPrintSupport.QPrinter.setWinPageSize": ('int',),
    "PySide2.QtPrintSupport.QPrinter.supportedResolutions": (),
    "PySide2.QtPrintSupport.QPrinter.supportsMultipleCopies": (),
    "PySide2.QtPrintSupport.QPrinter.toPage": (),
    "PySide2.QtPrintSupport.QPrinter.winPageSize": (),

# class PySide2.QtPrintSupport.QPrinterInfo:
    "PySide2.QtPrintSupport.QPrinterInfo.__init__": [(), ('PySide2.QtPrintSupport.QPrinter',), ('PySide2.QtPrintSupport.QPrinterInfo',)],
    "PySide2.QtPrintSupport.QPrinterInfo.__copy__": (),
    "PySide2.QtPrintSupport.QPrinterInfo.availablePrinterNames": (),
    "PySide2.QtPrintSupport.QPrinterInfo.availablePrinters": (),
    "PySide2.QtPrintSupport.QPrinterInfo.defaultColorMode": (),
    "PySide2.QtPrintSupport.QPrinterInfo.defaultDuplexMode": (),
    "PySide2.QtPrintSupport.QPrinterInfo.defaultPageSize": (),
    "PySide2.QtPrintSupport.QPrinterInfo.defaultPrinter": (),
    "PySide2.QtPrintSupport.QPrinterInfo.defaultPrinterName": (),
    "PySide2.QtPrintSupport.QPrinterInfo.description": (),
    "PySide2.QtPrintSupport.QPrinterInfo.isDefault": (),
    "PySide2.QtPrintSupport.QPrinterInfo.isNull": (),
    "PySide2.QtPrintSupport.QPrinterInfo.isRemote": (),
    "PySide2.QtPrintSupport.QPrinterInfo.location": (),
    "PySide2.QtPrintSupport.QPrinterInfo.makeAndModel": (),
    "PySide2.QtPrintSupport.QPrinterInfo.maximumPhysicalPageSize": (),
    "PySide2.QtPrintSupport.QPrinterInfo.minimumPhysicalPageSize": (),
    "PySide2.QtPrintSupport.QPrinterInfo.printerInfo": ('str',),
    "PySide2.QtPrintSupport.QPrinterInfo.printerName": (),
    "PySide2.QtPrintSupport.QPrinterInfo.state": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportedColorModes": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportedDuplexModes": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportedPageSizes": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportedPaperSizes": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportedResolutions": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportedSizesWithNames": (),
    "PySide2.QtPrintSupport.QPrinterInfo.supportsCustomPageSizes": (),
    }) if "PySide2.QtPrintSupport" in sys.modules else None

# Module PySide2.QtSql
sig_dict.update({

# class PySide2.QtSql.QSql:

# class PySide2.QtSql.QSql.Location:

# class PySide2.QtSql.QSql.NumericalPrecisionPolicy:

# class PySide2.QtSql.QSql.ParamType:

# class PySide2.QtSql.QSql.ParamTypeFlag:

# class PySide2.QtSql.QSql.TableType:

# class PySide2.QtSql.QSqlDatabase:
    "PySide2.QtSql.QSqlDatabase.__init__": [(), ('PySide2.QtSql.QSqlDatabase',), ('PySide2.QtSql.QSqlDriver',), ('str',)],
    "PySide2.QtSql.QSqlDatabase.__copy__": (),
    "PySide2.QtSql.QSqlDatabase.addDatabase": [('PySide2.QtSql.QSqlDriver', 'str'), ('str', 'str')],
    "PySide2.QtSql.QSqlDatabase.cloneDatabase": [('PySide2.QtSql.QSqlDatabase', 'str'), ('str', 'str')],
    "PySide2.QtSql.QSqlDatabase.close": (),
    "PySide2.QtSql.QSqlDatabase.commit": (),
    "PySide2.QtSql.QSqlDatabase.connectOptions": (),
    "PySide2.QtSql.QSqlDatabase.connectionName": (),
    "PySide2.QtSql.QSqlDatabase.connectionNames": (),
    "PySide2.QtSql.QSqlDatabase.contains": ('str',),
    "PySide2.QtSql.QSqlDatabase.database": ('str', 'bool'),
    "PySide2.QtSql.QSqlDatabase.databaseName": (),
    "PySide2.QtSql.QSqlDatabase.driver": (),
    "PySide2.QtSql.QSqlDatabase.driverName": (),
    "PySide2.QtSql.QSqlDatabase.drivers": (),
    "PySide2.QtSql.QSqlDatabase.exec_": ('str',),
    "PySide2.QtSql.QSqlDatabase.hostName": (),
    "PySide2.QtSql.QSqlDatabase.isDriverAvailable": ('str',),
    "PySide2.QtSql.QSqlDatabase.isOpen": (),
    "PySide2.QtSql.QSqlDatabase.isOpenError": (),
    "PySide2.QtSql.QSqlDatabase.isValid": (),
    "PySide2.QtSql.QSqlDatabase.lastError": (),
    "PySide2.QtSql.QSqlDatabase.numericalPrecisionPolicy": (),
    "PySide2.QtSql.QSqlDatabase.open": [(), ('str', 'str')],
    "PySide2.QtSql.QSqlDatabase.password": (),
    "PySide2.QtSql.QSqlDatabase.port": (),
    "PySide2.QtSql.QSqlDatabase.primaryIndex": ('str',),
    "PySide2.QtSql.QSqlDatabase.record": ('str',),
    "PySide2.QtSql.QSqlDatabase.registerSqlDriver": ('str', 'PySide2.QtSql.QSqlDriverCreatorBase'),
    "PySide2.QtSql.QSqlDatabase.removeDatabase": ('str',),
    "PySide2.QtSql.QSqlDatabase.rollback": (),
    "PySide2.QtSql.QSqlDatabase.setConnectOptions": ('str',),
    "PySide2.QtSql.QSqlDatabase.setDatabaseName": ('str',),
    "PySide2.QtSql.QSqlDatabase.setHostName": ('str',),
    "PySide2.QtSql.QSqlDatabase.setNumericalPrecisionPolicy": ('PySide2.QtSql.QSql.NumericalPrecisionPolicy',),
    "PySide2.QtSql.QSqlDatabase.setPassword": ('str',),
    "PySide2.QtSql.QSqlDatabase.setPort": ('int',),
    "PySide2.QtSql.QSqlDatabase.setUserName": ('str',),
    "PySide2.QtSql.QSqlDatabase.tables": ('PySide2.QtSql.QSql.TableType',),
    "PySide2.QtSql.QSqlDatabase.transaction": (),
    "PySide2.QtSql.QSqlDatabase.userName": (),

# class PySide2.QtSql.QSqlDriver:

# class PySide2.QtSql.QSqlDriver.DbmsType:

# class PySide2.QtSql.QSqlDriver.DriverFeature:

# class PySide2.QtSql.QSqlDriver.IdentifierType:

# class PySide2.QtSql.QSqlDriver.NotificationSource:

# class PySide2.QtSql.QSqlDriver.StatementType:
    "PySide2.QtSql.QSqlDriver.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSql.QSqlDriver.beginTransaction": (),
    "PySide2.QtSql.QSqlDriver.cancelQuery": (),
    "PySide2.QtSql.QSqlDriver.close": (),
    "PySide2.QtSql.QSqlDriver.commitTransaction": (),
    "PySide2.QtSql.QSqlDriver.createResult": (),
    "PySide2.QtSql.QSqlDriver.dbmsType": (),
    "PySide2.QtSql.QSqlDriver.escapeIdentifier": ('str', 'PySide2.QtSql.QSqlDriver.IdentifierType'),
    "PySide2.QtSql.QSqlDriver.formatValue": ('PySide2.QtSql.QSqlField', 'bool'),
    "PySide2.QtSql.QSqlDriver.hasFeature": ('PySide2.QtSql.QSqlDriver.DriverFeature',),
    "PySide2.QtSql.QSqlDriver.isIdentifierEscaped": ('str', 'PySide2.QtSql.QSqlDriver.IdentifierType'),
    "PySide2.QtSql.QSqlDriver.isOpen": (),
    "PySide2.QtSql.QSqlDriver.isOpenError": (),
    "PySide2.QtSql.QSqlDriver.lastError": (),
    "PySide2.QtSql.QSqlDriver.numericalPrecisionPolicy": (),
    "PySide2.QtSql.QSqlDriver.open": ('str', 'str', 'str', 'str', 'int', 'str'),
    "PySide2.QtSql.QSqlDriver.primaryIndex": ('str',),
    "PySide2.QtSql.QSqlDriver.record": ('str',),
    "PySide2.QtSql.QSqlDriver.rollbackTransaction": (),
    "PySide2.QtSql.QSqlDriver.setLastError": ('PySide2.QtSql.QSqlError',),
    "PySide2.QtSql.QSqlDriver.setNumericalPrecisionPolicy": ('PySide2.QtSql.QSql.NumericalPrecisionPolicy',),
    "PySide2.QtSql.QSqlDriver.setOpen": ('bool',),
    "PySide2.QtSql.QSqlDriver.setOpenError": ('bool',),
    "PySide2.QtSql.QSqlDriver.sqlStatement": ('PySide2.QtSql.QSqlDriver.StatementType', 'str', 'PySide2.QtSql.QSqlRecord', 'bool'),
    "PySide2.QtSql.QSqlDriver.stripDelimiters": ('str', 'PySide2.QtSql.QSqlDriver.IdentifierType'),
    "PySide2.QtSql.QSqlDriver.subscribeToNotification": ('str',),
    "PySide2.QtSql.QSqlDriver.subscribedToNotifications": (),
    "PySide2.QtSql.QSqlDriver.tables": ('PySide2.QtSql.QSql.TableType',),
    "PySide2.QtSql.QSqlDriver.unsubscribeFromNotification": ('str',),

# class PySide2.QtSql.QSqlDriverCreatorBase:
    "PySide2.QtSql.QSqlDriverCreatorBase.__init__": (),
    "PySide2.QtSql.QSqlDriverCreatorBase.createObject": (),

# class PySide2.QtSql.QSqlError:

# class PySide2.QtSql.QSqlError.ErrorType:
    "PySide2.QtSql.QSqlError.__init__": [('PySide2.QtSql.QSqlError',), ('str', 'str', 'PySide2.QtSql.QSqlError.ErrorType', 'int'), ('str', 'str', 'PySide2.QtSql.QSqlError.ErrorType', 'str')],
    "PySide2.QtSql.QSqlError.__copy__": (),
    "PySide2.QtSql.QSqlError.databaseText": (),
    "PySide2.QtSql.QSqlError.driverText": (),
    "PySide2.QtSql.QSqlError.isValid": (),
    "PySide2.QtSql.QSqlError.nativeErrorCode": (),
    "PySide2.QtSql.QSqlError.number": (),
    "PySide2.QtSql.QSqlError.setDatabaseText": ('str',),
    "PySide2.QtSql.QSqlError.setDriverText": ('str',),
    "PySide2.QtSql.QSqlError.setNumber": ('int',),
    "PySide2.QtSql.QSqlError.setType": ('PySide2.QtSql.QSqlError.ErrorType',),
    "PySide2.QtSql.QSqlError.swap": ('PySide2.QtSql.QSqlError',),
    "PySide2.QtSql.QSqlError.text": (),
    "PySide2.QtSql.QSqlError.type": (),

# class PySide2.QtSql.QSqlField:

# class PySide2.QtSql.QSqlField.RequiredStatus:
    "PySide2.QtSql.QSqlField.__init__": [('PySide2.QtSql.QSqlField',), ('str', 'type'), ('str', 'type', 'str')],
    "PySide2.QtSql.QSqlField.__copy__": (),
    "PySide2.QtSql.QSqlField.clear": (),
    "PySide2.QtSql.QSqlField.defaultValue": (),
    "PySide2.QtSql.QSqlField.isAutoValue": (),
    "PySide2.QtSql.QSqlField.isGenerated": (),
    "PySide2.QtSql.QSqlField.isNull": (),
    "PySide2.QtSql.QSqlField.isReadOnly": (),
    "PySide2.QtSql.QSqlField.isValid": (),
    "PySide2.QtSql.QSqlField.length": (),
    "PySide2.QtSql.QSqlField.name": (),
    "PySide2.QtSql.QSqlField.precision": (),
    "PySide2.QtSql.QSqlField.requiredStatus": (),
    "PySide2.QtSql.QSqlField.setAutoValue": ('bool',),
    "PySide2.QtSql.QSqlField.setDefaultValue": ('typing.Any',),
    "PySide2.QtSql.QSqlField.setGenerated": ('bool',),
    "PySide2.QtSql.QSqlField.setLength": ('int',),
    "PySide2.QtSql.QSqlField.setName": ('str',),
    "PySide2.QtSql.QSqlField.setPrecision": ('int',),
    "PySide2.QtSql.QSqlField.setReadOnly": ('bool',),
    "PySide2.QtSql.QSqlField.setRequired": ('bool',),
    "PySide2.QtSql.QSqlField.setRequiredStatus": ('PySide2.QtSql.QSqlField.RequiredStatus',),
    "PySide2.QtSql.QSqlField.setSqlType": ('int',),
    "PySide2.QtSql.QSqlField.setTableName": ('str',),
    "PySide2.QtSql.QSqlField.setType": ('type',),
    "PySide2.QtSql.QSqlField.setValue": ('typing.Any',),
    "PySide2.QtSql.QSqlField.tableName": (),
    "PySide2.QtSql.QSqlField.type": (),
    "PySide2.QtSql.QSqlField.typeID": (),
    "PySide2.QtSql.QSqlField.value": (),

# class PySide2.QtSql.QSqlIndex:
    "PySide2.QtSql.QSqlIndex.__init__": [('PySide2.QtSql.QSqlIndex',), ('str', 'str')],
    "PySide2.QtSql.QSqlIndex.__copy__": (),
    "PySide2.QtSql.QSqlIndex.append": [('PySide2.QtSql.QSqlField',), ('PySide2.QtSql.QSqlField', 'bool')],
    "PySide2.QtSql.QSqlIndex.cursorName": (),
    "PySide2.QtSql.QSqlIndex.isDescending": ('int',),
    "PySide2.QtSql.QSqlIndex.name": (),
    "PySide2.QtSql.QSqlIndex.setCursorName": ('str',),
    "PySide2.QtSql.QSqlIndex.setDescending": ('int', 'bool'),
    "PySide2.QtSql.QSqlIndex.setName": ('str',),

# class PySide2.QtSql.QSqlQuery:

# class PySide2.QtSql.QSqlQuery.BatchExecutionMode:
    "PySide2.QtSql.QSqlQuery.__init__": [('PySide2.QtSql.QSqlDatabase',), ('PySide2.QtSql.QSqlQuery',), ('PySide2.QtSql.QSqlResult',), ('str', 'PySide2.QtSql.QSqlDatabase')],
    "PySide2.QtSql.QSqlQuery.__copy__": (),
    "PySide2.QtSql.QSqlQuery.addBindValue": ('typing.Any', 'PySide2.QtSql.QSql.ParamType'),
    "PySide2.QtSql.QSqlQuery.at": (),
    "PySide2.QtSql.QSqlQuery.bindValue": [('int', 'typing.Any', 'PySide2.QtSql.QSql.ParamType'), ('str', 'typing.Any', 'PySide2.QtSql.QSql.ParamType')],
    "PySide2.QtSql.QSqlQuery.boundValue": [('int',), ('str',)],
    "PySide2.QtSql.QSqlQuery.boundValues": (),
    "PySide2.QtSql.QSqlQuery.clear": (),
    "PySide2.QtSql.QSqlQuery.driver": (),
    "PySide2.QtSql.QSqlQuery.execBatch": ('PySide2.QtSql.QSqlQuery.BatchExecutionMode',),
    "PySide2.QtSql.QSqlQuery.exec_": [(), ('str',)],
    "PySide2.QtSql.QSqlQuery.executedQuery": (),
    "PySide2.QtSql.QSqlQuery.finish": (),
    "PySide2.QtSql.QSqlQuery.first": (),
    "PySide2.QtSql.QSqlQuery.isActive": (),
    "PySide2.QtSql.QSqlQuery.isForwardOnly": (),
    "PySide2.QtSql.QSqlQuery.isNull": [('int',), ('str',)],
    "PySide2.QtSql.QSqlQuery.isSelect": (),
    "PySide2.QtSql.QSqlQuery.isValid": (),
    "PySide2.QtSql.QSqlQuery.last": (),
    "PySide2.QtSql.QSqlQuery.lastError": (),
    "PySide2.QtSql.QSqlQuery.lastInsertId": (),
    "PySide2.QtSql.QSqlQuery.lastQuery": (),
    "PySide2.QtSql.QSqlQuery.nextResult": (),
    "PySide2.QtSql.QSqlQuery.numRowsAffected": (),
    "PySide2.QtSql.QSqlQuery.numericalPrecisionPolicy": (),
    "PySide2.QtSql.QSqlQuery.prepare": ('str',),
    "PySide2.QtSql.QSqlQuery.previous": (),
    "PySide2.QtSql.QSqlQuery.record": (),
    "PySide2.QtSql.QSqlQuery.result": (),
    "PySide2.QtSql.QSqlQuery.seek": ('int', 'bool'),
    "PySide2.QtSql.QSqlQuery.setForwardOnly": ('bool',),
    "PySide2.QtSql.QSqlQuery.setNumericalPrecisionPolicy": ('PySide2.QtSql.QSql.NumericalPrecisionPolicy',),
    "PySide2.QtSql.QSqlQuery.size": (),
    "PySide2.QtSql.QSqlQuery.value": [('int',), ('str',)],

# class PySide2.QtSql.QSqlQueryModel:
    "PySide2.QtSql.QSqlQueryModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSql.QSqlQueryModel.beginInsertColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtSql.QSqlQueryModel.beginInsertRows": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtSql.QSqlQueryModel.beginRemoveColumns": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtSql.QSqlQueryModel.beginRemoveRows": ('PySide2.QtCore.QModelIndex', 'int', 'int'),
    "PySide2.QtSql.QSqlQueryModel.beginResetModel": (),
    "PySide2.QtSql.QSqlQueryModel.canFetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlQueryModel.clear": (),
    "PySide2.QtSql.QSqlQueryModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlQueryModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtSql.QSqlQueryModel.endInsertColumns": (),
    "PySide2.QtSql.QSqlQueryModel.endInsertRows": (),
    "PySide2.QtSql.QSqlQueryModel.endRemoveColumns": (),
    "PySide2.QtSql.QSqlQueryModel.endRemoveRows": (),
    "PySide2.QtSql.QSqlQueryModel.endResetModel": (),
    "PySide2.QtSql.QSqlQueryModel.fetchMore": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlQueryModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtSql.QSqlQueryModel.indexInQuery": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlQueryModel.insertColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlQueryModel.lastError": (),
    "PySide2.QtSql.QSqlQueryModel.query": (),
    "PySide2.QtSql.QSqlQueryModel.queryChange": (),
    "PySide2.QtSql.QSqlQueryModel.record": [(), ('int',)],
    "PySide2.QtSql.QSqlQueryModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlQueryModel.roleNames": (),
    "PySide2.QtSql.QSqlQueryModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlQueryModel.setHeaderData": ('int', 'PySide2.QtCore.Qt.Orientation', 'typing.Any', 'int'),
    "PySide2.QtSql.QSqlQueryModel.setLastError": ('PySide2.QtSql.QSqlError',),
    "PySide2.QtSql.QSqlQueryModel.setQuery": [('PySide2.QtSql.QSqlQuery',), ('str', 'PySide2.QtSql.QSqlDatabase')],

# class PySide2.QtSql.QSqlRecord:
    "PySide2.QtSql.QSqlRecord.__init__": [(), ('PySide2.QtSql.QSqlRecord',)],
    "PySide2.QtSql.QSqlRecord.__copy__": (),
    "PySide2.QtSql.QSqlRecord.append": ('PySide2.QtSql.QSqlField',),
    "PySide2.QtSql.QSqlRecord.clear": (),
    "PySide2.QtSql.QSqlRecord.clearValues": (),
    "PySide2.QtSql.QSqlRecord.contains": ('str',),
    "PySide2.QtSql.QSqlRecord.count": (),
    "PySide2.QtSql.QSqlRecord.field": [('int',), ('str',)],
    "PySide2.QtSql.QSqlRecord.fieldName": ('int',),
    "PySide2.QtSql.QSqlRecord.indexOf": ('str',),
    "PySide2.QtSql.QSqlRecord.insert": ('int', 'PySide2.QtSql.QSqlField'),
    "PySide2.QtSql.QSqlRecord.isEmpty": (),
    "PySide2.QtSql.QSqlRecord.isGenerated": [('int',), ('str',)],
    "PySide2.QtSql.QSqlRecord.isNull": [('int',), ('str',)],
    "PySide2.QtSql.QSqlRecord.keyValues": ('PySide2.QtSql.QSqlRecord',),
    "PySide2.QtSql.QSqlRecord.remove": ('int',),
    "PySide2.QtSql.QSqlRecord.replace": ('int', 'PySide2.QtSql.QSqlField'),
    "PySide2.QtSql.QSqlRecord.setGenerated": [('int', 'bool'), ('str', 'bool')],
    "PySide2.QtSql.QSqlRecord.setNull": [('int',), ('str',)],
    "PySide2.QtSql.QSqlRecord.setValue": [('int', 'typing.Any'), ('str', 'typing.Any')],
    "PySide2.QtSql.QSqlRecord.value": [('int',), ('str',)],

# class PySide2.QtSql.QSqlRelation:
    "PySide2.QtSql.QSqlRelation.__init__": [(), ('PySide2.QtSql.QSqlRelation',), ('str', 'str', 'str')],
    "PySide2.QtSql.QSqlRelation.__copy__": (),
    "PySide2.QtSql.QSqlRelation.displayColumn": (),
    "PySide2.QtSql.QSqlRelation.indexColumn": (),
    "PySide2.QtSql.QSqlRelation.isValid": (),
    "PySide2.QtSql.QSqlRelation.swap": ('PySide2.QtSql.QSqlRelation',),
    "PySide2.QtSql.QSqlRelation.tableName": (),

# class PySide2.QtSql.QSqlRelationalDelegate:
    "PySide2.QtSql.QSqlRelationalDelegate.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSql.QSqlRelationalDelegate.createEditor": ('PySide2.QtWidgets.QWidget', 'PySide2.QtWidgets.QStyleOptionViewItem', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlRelationalDelegate.setEditorData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlRelationalDelegate.setModelData": ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QModelIndex'),

# class PySide2.QtSql.QSqlRelationalTableModel:

# class PySide2.QtSql.QSqlRelationalTableModel.JoinMode:
    "PySide2.QtSql.QSqlRelationalTableModel.__init__": ('PySide2.QtCore.QObject', 'PySide2.QtSql.QSqlDatabase'),
    "PySide2.QtSql.QSqlRelationalTableModel.clear": (),
    "PySide2.QtSql.QSqlRelationalTableModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtSql.QSqlRelationalTableModel.insertRowIntoTable": ('PySide2.QtSql.QSqlRecord',),
    "PySide2.QtSql.QSqlRelationalTableModel.orderByClause": (),
    "PySide2.QtSql.QSqlRelationalTableModel.relation": ('int',),
    "PySide2.QtSql.QSqlRelationalTableModel.relationModel": ('int',),
    "PySide2.QtSql.QSqlRelationalTableModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlRelationalTableModel.revertRow": ('int',),
    "PySide2.QtSql.QSqlRelationalTableModel.select": (),
    "PySide2.QtSql.QSqlRelationalTableModel.selectStatement": (),
    "PySide2.QtSql.QSqlRelationalTableModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtSql.QSqlRelationalTableModel.setJoinMode": ('PySide2.QtSql.QSqlRelationalTableModel.JoinMode',),
    "PySide2.QtSql.QSqlRelationalTableModel.setRelation": ('int', 'PySide2.QtSql.QSqlRelation'),
    "PySide2.QtSql.QSqlRelationalTableModel.setTable": ('str',),
    "PySide2.QtSql.QSqlRelationalTableModel.updateRowInTable": ('int', 'PySide2.QtSql.QSqlRecord'),

# class PySide2.QtSql.QSqlResult:

# class PySide2.QtSql.QSqlResult.BindingSyntax:
    "PySide2.QtSql.QSqlResult.__init__": ('PySide2.QtSql.QSqlDriver',),
    "PySide2.QtSql.QSqlResult.addBindValue": ('typing.Any', 'PySide2.QtSql.QSql.ParamType'),
    "PySide2.QtSql.QSqlResult.at": (),
    "PySide2.QtSql.QSqlResult.bindValue": [('int', 'typing.Any', 'PySide2.QtSql.QSql.ParamType'), ('str', 'typing.Any', 'PySide2.QtSql.QSql.ParamType')],
    "PySide2.QtSql.QSqlResult.bindValueType": [('int',), ('str',)],
    "PySide2.QtSql.QSqlResult.bindingSyntax": (),
    "PySide2.QtSql.QSqlResult.boundValue": [('int',), ('str',)],
    "PySide2.QtSql.QSqlResult.boundValueCount": (),
    "PySide2.QtSql.QSqlResult.boundValueName": ('int',),
    "PySide2.QtSql.QSqlResult.boundValues": (),
    "PySide2.QtSql.QSqlResult.clear": (),
    "PySide2.QtSql.QSqlResult.data": ('int',),
    "PySide2.QtSql.QSqlResult.detachFromResultSet": (),
    "PySide2.QtSql.QSqlResult.driver": (),
    "PySide2.QtSql.QSqlResult.execBatch": ('bool',),
    "PySide2.QtSql.QSqlResult.exec_": (),
    "PySide2.QtSql.QSqlResult.executedQuery": (),
    "PySide2.QtSql.QSqlResult.fetch": ('int',),
    "PySide2.QtSql.QSqlResult.fetchFirst": (),
    "PySide2.QtSql.QSqlResult.fetchLast": (),
    "PySide2.QtSql.QSqlResult.fetchNext": (),
    "PySide2.QtSql.QSqlResult.fetchPrevious": (),
    "PySide2.QtSql.QSqlResult.handle": (),
    "PySide2.QtSql.QSqlResult.hasOutValues": (),
    "PySide2.QtSql.QSqlResult.isActive": (),
    "PySide2.QtSql.QSqlResult.isForwardOnly": (),
    "PySide2.QtSql.QSqlResult.isNull": ('int',),
    "PySide2.QtSql.QSqlResult.isSelect": (),
    "PySide2.QtSql.QSqlResult.isValid": (),
    "PySide2.QtSql.QSqlResult.lastError": (),
    "PySide2.QtSql.QSqlResult.lastInsertId": (),
    "PySide2.QtSql.QSqlResult.lastQuery": (),
    "PySide2.QtSql.QSqlResult.nextResult": (),
    "PySide2.QtSql.QSqlResult.numRowsAffected": (),
    "PySide2.QtSql.QSqlResult.numericalPrecisionPolicy": (),
    "PySide2.QtSql.QSqlResult.prepare": ('str',),
    "PySide2.QtSql.QSqlResult.record": (),
    "PySide2.QtSql.QSqlResult.reset": ('str',),
    "PySide2.QtSql.QSqlResult.resetBindCount": (),
    "PySide2.QtSql.QSqlResult.savePrepare": ('str',),
    "PySide2.QtSql.QSqlResult.setActive": ('bool',),
    "PySide2.QtSql.QSqlResult.setAt": ('int',),
    "PySide2.QtSql.QSqlResult.setForwardOnly": ('bool',),
    "PySide2.QtSql.QSqlResult.setLastError": ('PySide2.QtSql.QSqlError',),
    "PySide2.QtSql.QSqlResult.setNumericalPrecisionPolicy": ('PySide2.QtSql.QSql.NumericalPrecisionPolicy',),
    "PySide2.QtSql.QSqlResult.setQuery": ('str',),
    "PySide2.QtSql.QSqlResult.setSelect": ('bool',),
    "PySide2.QtSql.QSqlResult.size": (),

# class PySide2.QtSql.QSqlTableModel:

# class PySide2.QtSql.QSqlTableModel.EditStrategy:
    "PySide2.QtSql.QSqlTableModel.__init__": ('PySide2.QtCore.QObject', 'PySide2.QtSql.QSqlDatabase'),
    "PySide2.QtSql.QSqlTableModel.clear": (),
    "PySide2.QtSql.QSqlTableModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtSql.QSqlTableModel.database": (),
    "PySide2.QtSql.QSqlTableModel.deleteRowFromTable": ('int',),
    "PySide2.QtSql.QSqlTableModel.editStrategy": (),
    "PySide2.QtSql.QSqlTableModel.fieldIndex": ('str',),
    "PySide2.QtSql.QSqlTableModel.filter": (),
    "PySide2.QtSql.QSqlTableModel.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlTableModel.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtSql.QSqlTableModel.indexInQuery": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlTableModel.insertRecord": ('int', 'PySide2.QtSql.QSqlRecord'),
    "PySide2.QtSql.QSqlTableModel.insertRowIntoTable": ('PySide2.QtSql.QSqlRecord',),
    "PySide2.QtSql.QSqlTableModel.insertRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlTableModel.isDirty": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtSql.QSqlTableModel.orderByClause": (),
    "PySide2.QtSql.QSqlTableModel.primaryKey": (),
    "PySide2.QtSql.QSqlTableModel.primaryValues": ('int',),
    "PySide2.QtSql.QSqlTableModel.record": [(), ('int',)],
    "PySide2.QtSql.QSqlTableModel.removeColumns": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlTableModel.removeRows": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtSql.QSqlTableModel.revert": (),
    "PySide2.QtSql.QSqlTableModel.revertAll": (),
    "PySide2.QtSql.QSqlTableModel.revertRow": ('int',),
    "PySide2.QtSql.QSqlTableModel.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtSql.QSqlTableModel.select": (),
    "PySide2.QtSql.QSqlTableModel.selectRow": ('int',),
    "PySide2.QtSql.QSqlTableModel.selectStatement": (),
    "PySide2.QtSql.QSqlTableModel.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),
    "PySide2.QtSql.QSqlTableModel.setEditStrategy": ('PySide2.QtSql.QSqlTableModel.EditStrategy',),
    "PySide2.QtSql.QSqlTableModel.setFilter": ('str',),
    "PySide2.QtSql.QSqlTableModel.setPrimaryKey": ('PySide2.QtSql.QSqlIndex',),
    "PySide2.QtSql.QSqlTableModel.setQuery": ('PySide2.QtSql.QSqlQuery',),
    "PySide2.QtSql.QSqlTableModel.setRecord": ('int', 'PySide2.QtSql.QSqlRecord'),
    "PySide2.QtSql.QSqlTableModel.setSort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtSql.QSqlTableModel.setTable": ('str',),
    "PySide2.QtSql.QSqlTableModel.sort": ('int', 'PySide2.QtCore.Qt.SortOrder'),
    "PySide2.QtSql.QSqlTableModel.submit": (),
    "PySide2.QtSql.QSqlTableModel.submitAll": (),
    "PySide2.QtSql.QSqlTableModel.tableName": (),
    "PySide2.QtSql.QSqlTableModel.updateRowInTable": ('int', 'PySide2.QtSql.QSqlRecord'),
    }) if "PySide2.QtSql" in sys.modules else None

# Module PySide2.QtNetwork
sig_dict.update({

# class PySide2.QtNetwork.QAbstractNetworkCache:
    "PySide2.QtNetwork.QAbstractNetworkCache.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QAbstractNetworkCache.cacheSize": (),
    "PySide2.QtNetwork.QAbstractNetworkCache.clear": (),
    "PySide2.QtNetwork.QAbstractNetworkCache.data": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QAbstractNetworkCache.insert": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtNetwork.QAbstractNetworkCache.metaData": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QAbstractNetworkCache.prepare": ('PySide2.QtNetwork.QNetworkCacheMetaData',),
    "PySide2.QtNetwork.QAbstractNetworkCache.remove": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QAbstractNetworkCache.updateMetaData": ('PySide2.QtNetwork.QNetworkCacheMetaData',),

# class PySide2.QtNetwork.QAbstractSocket:

# class PySide2.QtNetwork.QAbstractSocket.BindFlag:

# class PySide2.QtNetwork.QAbstractSocket.BindMode:

# class PySide2.QtNetwork.QAbstractSocket.NetworkLayerProtocol:

# class PySide2.QtNetwork.QAbstractSocket.PauseMode:

# class PySide2.QtNetwork.QAbstractSocket.PauseModes:

# class PySide2.QtNetwork.QAbstractSocket.SocketError:

# class PySide2.QtNetwork.QAbstractSocket.SocketOption:

# class PySide2.QtNetwork.QAbstractSocket.SocketState:

# class PySide2.QtNetwork.QAbstractSocket.SocketType:
    "PySide2.QtNetwork.QAbstractSocket.__init__": ('PySide2.QtNetwork.QAbstractSocket.SocketType', 'PySide2.QtCore.QObject'),
    "PySide2.QtNetwork.QAbstractSocket.abort": (),
    "PySide2.QtNetwork.QAbstractSocket.atEnd": (),
    "PySide2.QtNetwork.QAbstractSocket.bind": [('PySide2.QtNetwork.QHostAddress', 'int', 'PySide2.QtNetwork.QAbstractSocket.BindMode'), ('int', 'PySide2.QtNetwork.QAbstractSocket.BindMode')],
    "PySide2.QtNetwork.QAbstractSocket.bytesAvailable": (),
    "PySide2.QtNetwork.QAbstractSocket.bytesToWrite": (),
    "PySide2.QtNetwork.QAbstractSocket.canReadLine": (),
    "PySide2.QtNetwork.QAbstractSocket.close": (),
    "PySide2.QtNetwork.QAbstractSocket.connectToHost": [('PySide2.QtNetwork.QHostAddress', 'int', 'PySide2.QtCore.QIODevice.OpenMode'), ('str', 'int', 'PySide2.QtCore.QIODevice.OpenMode', 'PySide2.QtNetwork.QAbstractSocket.NetworkLayerProtocol')],
    "PySide2.QtNetwork.QAbstractSocket.disconnectFromHost": (),
    "PySide2.QtNetwork.QAbstractSocket.error": (),
    "PySide2.QtNetwork.QAbstractSocket.flush": (),
    "PySide2.QtNetwork.QAbstractSocket.isSequential": (),
    "PySide2.QtNetwork.QAbstractSocket.isValid": (),
    "PySide2.QtNetwork.QAbstractSocket.localAddress": (),
    "PySide2.QtNetwork.QAbstractSocket.localPort": (),
    "PySide2.QtNetwork.QAbstractSocket.pauseMode": (),
    "PySide2.QtNetwork.QAbstractSocket.peerAddress": (),
    "PySide2.QtNetwork.QAbstractSocket.peerName": (),
    "PySide2.QtNetwork.QAbstractSocket.peerPort": (),
    "PySide2.QtNetwork.QAbstractSocket.protocolTag": (),
    "PySide2.QtNetwork.QAbstractSocket.proxy": (),
    "PySide2.QtNetwork.QAbstractSocket.readBufferSize": (),
    "PySide2.QtNetwork.QAbstractSocket.readData": ('str', 'int'),
    "PySide2.QtNetwork.QAbstractSocket.readLineData": ('str', 'int'),
    "PySide2.QtNetwork.QAbstractSocket.resume": (),
    "PySide2.QtNetwork.QAbstractSocket.setLocalAddress": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QAbstractSocket.setLocalPort": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.setPauseMode": ('PySide2.QtNetwork.QAbstractSocket.PauseModes',),
    "PySide2.QtNetwork.QAbstractSocket.setPeerAddress": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QAbstractSocket.setPeerName": ('str',),
    "PySide2.QtNetwork.QAbstractSocket.setPeerPort": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.setProtocolTag": ('str',),
    "PySide2.QtNetwork.QAbstractSocket.setProxy": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtNetwork.QAbstractSocket.setReadBufferSize": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.setSocketDescriptor": ('int', 'PySide2.QtNetwork.QAbstractSocket.SocketState', 'PySide2.QtCore.QIODevice.OpenMode'),
    "PySide2.QtNetwork.QAbstractSocket.setSocketError": ('PySide2.QtNetwork.QAbstractSocket.SocketError',),
    "PySide2.QtNetwork.QAbstractSocket.setSocketOption": ('PySide2.QtNetwork.QAbstractSocket.SocketOption', 'typing.Any'),
    "PySide2.QtNetwork.QAbstractSocket.setSocketState": ('PySide2.QtNetwork.QAbstractSocket.SocketState',),
    "PySide2.QtNetwork.QAbstractSocket.socketDescriptor": (),
    "PySide2.QtNetwork.QAbstractSocket.socketOption": ('PySide2.QtNetwork.QAbstractSocket.SocketOption',),
    "PySide2.QtNetwork.QAbstractSocket.socketType": (),
    "PySide2.QtNetwork.QAbstractSocket.state": (),
    "PySide2.QtNetwork.QAbstractSocket.waitForBytesWritten": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.waitForConnected": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.waitForDisconnected": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.waitForReadyRead": ('int',),
    "PySide2.QtNetwork.QAbstractSocket.writeData": ('str', 'int'),

# class PySide2.QtNetwork.QAuthenticator:
    "PySide2.QtNetwork.QAuthenticator.__init__": [(), ('PySide2.QtNetwork.QAuthenticator',)],
    "PySide2.QtNetwork.QAuthenticator.__copy__": (),
    "PySide2.QtNetwork.QAuthenticator.isNull": (),
    "PySide2.QtNetwork.QAuthenticator.option": ('str',),
    "PySide2.QtNetwork.QAuthenticator.options": (),
    "PySide2.QtNetwork.QAuthenticator.password": (),
    "PySide2.QtNetwork.QAuthenticator.realm": (),
    "PySide2.QtNetwork.QAuthenticator.setOption": ('str', 'typing.Any'),
    "PySide2.QtNetwork.QAuthenticator.setPassword": ('str',),
    "PySide2.QtNetwork.QAuthenticator.setRealm": ('str',),
    "PySide2.QtNetwork.QAuthenticator.setUser": ('str',),
    "PySide2.QtNetwork.QAuthenticator.user": (),

# class PySide2.QtNetwork.QDnsDomainNameRecord:
    "PySide2.QtNetwork.QDnsDomainNameRecord.__init__": [(), ('PySide2.QtNetwork.QDnsDomainNameRecord',)],
    "PySide2.QtNetwork.QDnsDomainNameRecord.__copy__": (),
    "PySide2.QtNetwork.QDnsDomainNameRecord.name": (),
    "PySide2.QtNetwork.QDnsDomainNameRecord.swap": ('PySide2.QtNetwork.QDnsDomainNameRecord',),
    "PySide2.QtNetwork.QDnsDomainNameRecord.timeToLive": (),
    "PySide2.QtNetwork.QDnsDomainNameRecord.value": (),

# class PySide2.QtNetwork.QDnsHostAddressRecord:
    "PySide2.QtNetwork.QDnsHostAddressRecord.__init__": [(), ('PySide2.QtNetwork.QDnsHostAddressRecord',)],
    "PySide2.QtNetwork.QDnsHostAddressRecord.__copy__": (),
    "PySide2.QtNetwork.QDnsHostAddressRecord.name": (),
    "PySide2.QtNetwork.QDnsHostAddressRecord.swap": ('PySide2.QtNetwork.QDnsHostAddressRecord',),
    "PySide2.QtNetwork.QDnsHostAddressRecord.timeToLive": (),
    "PySide2.QtNetwork.QDnsHostAddressRecord.value": (),

# class PySide2.QtNetwork.QDnsLookup:

# class PySide2.QtNetwork.QDnsLookup.Error:

# class PySide2.QtNetwork.QDnsLookup.Type:
    "PySide2.QtNetwork.QDnsLookup.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtNetwork.QDnsLookup.Type', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtNetwork.QDnsLookup.Type', 'str', 'PySide2.QtNetwork.QHostAddress', 'PySide2.QtCore.QObject')],
    "PySide2.QtNetwork.QDnsLookup.abort": (),
    "PySide2.QtNetwork.QDnsLookup.canonicalNameRecords": (),
    "PySide2.QtNetwork.QDnsLookup.error": (),
    "PySide2.QtNetwork.QDnsLookup.errorString": (),
    "PySide2.QtNetwork.QDnsLookup.hostAddressRecords": (),
    "PySide2.QtNetwork.QDnsLookup.isFinished": (),
    "PySide2.QtNetwork.QDnsLookup.lookup": (),
    "PySide2.QtNetwork.QDnsLookup.mailExchangeRecords": (),
    "PySide2.QtNetwork.QDnsLookup.name": (),
    "PySide2.QtNetwork.QDnsLookup.nameServerRecords": (),
    "PySide2.QtNetwork.QDnsLookup.nameserver": (),
    "PySide2.QtNetwork.QDnsLookup.pointerRecords": (),
    "PySide2.QtNetwork.QDnsLookup.serviceRecords": (),
    "PySide2.QtNetwork.QDnsLookup.setName": ('str',),
    "PySide2.QtNetwork.QDnsLookup.setNameserver": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QDnsLookup.setType": ('PySide2.QtNetwork.QDnsLookup.Type',),
    "PySide2.QtNetwork.QDnsLookup.textRecords": (),
    "PySide2.QtNetwork.QDnsLookup.type": (),

# class PySide2.QtNetwork.QDnsMailExchangeRecord:
    "PySide2.QtNetwork.QDnsMailExchangeRecord.__init__": [(), ('PySide2.QtNetwork.QDnsMailExchangeRecord',)],
    "PySide2.QtNetwork.QDnsMailExchangeRecord.__copy__": (),
    "PySide2.QtNetwork.QDnsMailExchangeRecord.exchange": (),
    "PySide2.QtNetwork.QDnsMailExchangeRecord.name": (),
    "PySide2.QtNetwork.QDnsMailExchangeRecord.preference": (),
    "PySide2.QtNetwork.QDnsMailExchangeRecord.swap": ('PySide2.QtNetwork.QDnsMailExchangeRecord',),
    "PySide2.QtNetwork.QDnsMailExchangeRecord.timeToLive": (),

# class PySide2.QtNetwork.QDnsServiceRecord:
    "PySide2.QtNetwork.QDnsServiceRecord.__init__": [(), ('PySide2.QtNetwork.QDnsServiceRecord',)],
    "PySide2.QtNetwork.QDnsServiceRecord.__copy__": (),
    "PySide2.QtNetwork.QDnsServiceRecord.name": (),
    "PySide2.QtNetwork.QDnsServiceRecord.port": (),
    "PySide2.QtNetwork.QDnsServiceRecord.priority": (),
    "PySide2.QtNetwork.QDnsServiceRecord.swap": ('PySide2.QtNetwork.QDnsServiceRecord',),
    "PySide2.QtNetwork.QDnsServiceRecord.target": (),
    "PySide2.QtNetwork.QDnsServiceRecord.timeToLive": (),
    "PySide2.QtNetwork.QDnsServiceRecord.weight": (),

# class PySide2.QtNetwork.QDnsTextRecord:
    "PySide2.QtNetwork.QDnsTextRecord.__init__": [(), ('PySide2.QtNetwork.QDnsTextRecord',)],
    "PySide2.QtNetwork.QDnsTextRecord.__copy__": (),
    "PySide2.QtNetwork.QDnsTextRecord.name": (),
    "PySide2.QtNetwork.QDnsTextRecord.swap": ('PySide2.QtNetwork.QDnsTextRecord',),
    "PySide2.QtNetwork.QDnsTextRecord.timeToLive": (),
    "PySide2.QtNetwork.QDnsTextRecord.values": (),

# class PySide2.QtNetwork.QHostAddress:

# class PySide2.QtNetwork.QHostAddress.ConversionMode:

# class PySide2.QtNetwork.QHostAddress.ConversionModeFlag:

# class PySide2.QtNetwork.QHostAddress.SpecialAddress:
    "PySide2.QtNetwork.QHostAddress.__init__": [(), ('PySide2.QtNetwork.QHostAddress',), ('PySide2.QtNetwork.QHostAddress.SpecialAddress',), ('PySide2.QtNetwork.QIPv6Address',), ('int',), ('str',)],
    "PySide2.QtNetwork.QHostAddress.__copy__": (),
    "PySide2.QtNetwork.QHostAddress.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtNetwork.QHostAddress.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtNetwork.QHostAddress.clear": (),
    "PySide2.QtNetwork.QHostAddress.isBroadcast": (),
    "PySide2.QtNetwork.QHostAddress.isEqual": ('PySide2.QtNetwork.QHostAddress', 'PySide2.QtNetwork.QHostAddress.ConversionMode'),
    "PySide2.QtNetwork.QHostAddress.isGlobal": (),
    "PySide2.QtNetwork.QHostAddress.isInSubnet": [('PySide2.QtNetwork.QHostAddress', 'int'), ('typing.Tuple[PySide2.QtNetwork.QHostAddress, int]',)],
    "PySide2.QtNetwork.QHostAddress.isLinkLocal": (),
    "PySide2.QtNetwork.QHostAddress.isLoopback": (),
    "PySide2.QtNetwork.QHostAddress.isMulticast": (),
    "PySide2.QtNetwork.QHostAddress.isNull": (),
    "PySide2.QtNetwork.QHostAddress.isSiteLocal": (),
    "PySide2.QtNetwork.QHostAddress.isUniqueLocalUnicast": (),
    "PySide2.QtNetwork.QHostAddress.parseSubnet": ('str',),
    "PySide2.QtNetwork.QHostAddress.protocol": (),
    "PySide2.QtNetwork.QHostAddress.scopeId": (),
    "PySide2.QtNetwork.QHostAddress.setAddress": [('PySide2.QtNetwork.QHostAddress.SpecialAddress',), ('PySide2.QtNetwork.QIPv6Address',), ('int',), ('str',)],
    "PySide2.QtNetwork.QHostAddress.setScopeId": ('str',),
    "PySide2.QtNetwork.QHostAddress.swap": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QHostAddress.toIPv4Address": (),
    "PySide2.QtNetwork.QHostAddress.toIPv6Address": (),
    "PySide2.QtNetwork.QHostAddress.toString": (),

# class PySide2.QtNetwork.QHostInfo:

# class PySide2.QtNetwork.QHostInfo.HostInfoError:
    "PySide2.QtNetwork.QHostInfo.__init__": [('PySide2.QtNetwork.QHostInfo',), ('int',)],
    "PySide2.QtNetwork.QHostInfo.__copy__": (),
    "PySide2.QtNetwork.QHostInfo.abortHostLookup": ('int',),
    "PySide2.QtNetwork.QHostInfo.addresses": (),
    "PySide2.QtNetwork.QHostInfo.error": (),
    "PySide2.QtNetwork.QHostInfo.errorString": (),
    "PySide2.QtNetwork.QHostInfo.fromName": ('str',),
    "PySide2.QtNetwork.QHostInfo.hostName": (),
    "PySide2.QtNetwork.QHostInfo.localDomainName": (),
    "PySide2.QtNetwork.QHostInfo.localHostName": (),
    "PySide2.QtNetwork.QHostInfo.lookupId": (),
    "PySide2.QtNetwork.QHostInfo.setAddresses": ('typing.Sequence[PySide2.QtNetwork.QHostAddress]',),
    "PySide2.QtNetwork.QHostInfo.setError": ('PySide2.QtNetwork.QHostInfo.HostInfoError',),
    "PySide2.QtNetwork.QHostInfo.setErrorString": ('str',),
    "PySide2.QtNetwork.QHostInfo.setHostName": ('str',),
    "PySide2.QtNetwork.QHostInfo.setLookupId": ('int',),
    "PySide2.QtNetwork.QHostInfo.swap": ('PySide2.QtNetwork.QHostInfo',),

# class PySide2.QtNetwork.QHstsPolicy:

# class PySide2.QtNetwork.QHstsPolicy.PolicyFlag:

# class PySide2.QtNetwork.QHstsPolicy.PolicyFlags:
    "PySide2.QtNetwork.QHstsPolicy.__init__": [(), ('PySide2.QtCore.QDateTime', 'PySide2.QtNetwork.QHstsPolicy.PolicyFlags', 'str', 'PySide2.QtCore.QUrl.ParsingMode'), ('PySide2.QtNetwork.QHstsPolicy',)],
    "PySide2.QtNetwork.QHstsPolicy.__copy__": (),
    "PySide2.QtNetwork.QHstsPolicy.expiry": (),
    "PySide2.QtNetwork.QHstsPolicy.host": ('PySide2.QtCore.QUrl.ComponentFormattingOption',),
    "PySide2.QtNetwork.QHstsPolicy.includesSubDomains": (),
    "PySide2.QtNetwork.QHstsPolicy.isExpired": (),
    "PySide2.QtNetwork.QHstsPolicy.setExpiry": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtNetwork.QHstsPolicy.setHost": ('str', 'PySide2.QtCore.QUrl.ParsingMode'),
    "PySide2.QtNetwork.QHstsPolicy.setIncludesSubDomains": ('bool',),
    "PySide2.QtNetwork.QHstsPolicy.swap": ('PySide2.QtNetwork.QHstsPolicy',),

# class PySide2.QtNetwork.QHttpMultiPart:

# class PySide2.QtNetwork.QHttpMultiPart.ContentType:
    "PySide2.QtNetwork.QHttpMultiPart.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtNetwork.QHttpMultiPart.ContentType', 'PySide2.QtCore.QObject')],
    "PySide2.QtNetwork.QHttpMultiPart.append": ('PySide2.QtNetwork.QHttpPart',),
    "PySide2.QtNetwork.QHttpMultiPart.boundary": (),
    "PySide2.QtNetwork.QHttpMultiPart.setBoundary": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QHttpMultiPart.setContentType": ('PySide2.QtNetwork.QHttpMultiPart.ContentType',),

# class PySide2.QtNetwork.QHttpPart:
    "PySide2.QtNetwork.QHttpPart.__init__": [(), ('PySide2.QtNetwork.QHttpPart',)],
    "PySide2.QtNetwork.QHttpPart.__copy__": (),
    "PySide2.QtNetwork.QHttpPart.setBody": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QHttpPart.setBodyDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtNetwork.QHttpPart.setHeader": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders', 'typing.Any'),
    "PySide2.QtNetwork.QHttpPart.setRawHeader": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtNetwork.QHttpPart.swap": ('PySide2.QtNetwork.QHttpPart',),

# class PySide2.QtNetwork.QIPv6Address:
    "PySide2.QtNetwork.QIPv6Address.__init__": [(), ('PySide2.QtNetwork.QIPv6Address',)],
    "PySide2.QtNetwork.QIPv6Address.__copy__": (),

# class PySide2.QtNetwork.QLocalServer:

# class PySide2.QtNetwork.QLocalServer.SocketOption:

# class PySide2.QtNetwork.QLocalServer.SocketOptions:
    "PySide2.QtNetwork.QLocalServer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QLocalServer.close": (),
    "PySide2.QtNetwork.QLocalServer.errorString": (),
    "PySide2.QtNetwork.QLocalServer.fullServerName": (),
    "PySide2.QtNetwork.QLocalServer.hasPendingConnections": (),
    "PySide2.QtNetwork.QLocalServer.incomingConnection": ('int',),
    "PySide2.QtNetwork.QLocalServer.isListening": (),
    "PySide2.QtNetwork.QLocalServer.listen": [('int',), ('str',)],
    "PySide2.QtNetwork.QLocalServer.maxPendingConnections": (),
    "PySide2.QtNetwork.QLocalServer.nextPendingConnection": (),
    "PySide2.QtNetwork.QLocalServer.removeServer": ('str',),
    "PySide2.QtNetwork.QLocalServer.serverError": (),
    "PySide2.QtNetwork.QLocalServer.serverName": (),
    "PySide2.QtNetwork.QLocalServer.setMaxPendingConnections": ('int',),
    "PySide2.QtNetwork.QLocalServer.setSocketOptions": ('PySide2.QtNetwork.QLocalServer.SocketOptions',),
    "PySide2.QtNetwork.QLocalServer.socketDescriptor": (),
    "PySide2.QtNetwork.QLocalServer.socketOptions": (),
    "PySide2.QtNetwork.QLocalServer.waitForNewConnection": ('int',),

# class PySide2.QtNetwork.QLocalSocket:

# class PySide2.QtNetwork.QLocalSocket.LocalSocketError:

# class PySide2.QtNetwork.QLocalSocket.LocalSocketState:
    "PySide2.QtNetwork.QLocalSocket.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QLocalSocket.abort": (),
    "PySide2.QtNetwork.QLocalSocket.bytesAvailable": (),
    "PySide2.QtNetwork.QLocalSocket.bytesToWrite": (),
    "PySide2.QtNetwork.QLocalSocket.canReadLine": (),
    "PySide2.QtNetwork.QLocalSocket.close": (),
    "PySide2.QtNetwork.QLocalSocket.connectToServer": [('PySide2.QtCore.QIODevice.OpenMode',), ('str', 'PySide2.QtCore.QIODevice.OpenMode')],
    "PySide2.QtNetwork.QLocalSocket.disconnectFromServer": (),
    "PySide2.QtNetwork.QLocalSocket.error": (),
    "PySide2.QtNetwork.QLocalSocket.flush": (),
    "PySide2.QtNetwork.QLocalSocket.fullServerName": (),
    "PySide2.QtNetwork.QLocalSocket.isSequential": (),
    "PySide2.QtNetwork.QLocalSocket.isValid": (),
    "PySide2.QtNetwork.QLocalSocket.open": ('PySide2.QtCore.QIODevice.OpenMode',),
    "PySide2.QtNetwork.QLocalSocket.readBufferSize": (),
    "PySide2.QtNetwork.QLocalSocket.readData": ('str', 'int'),
    "PySide2.QtNetwork.QLocalSocket.serverName": (),
    "PySide2.QtNetwork.QLocalSocket.setReadBufferSize": ('int',),
    "PySide2.QtNetwork.QLocalSocket.setServerName": ('str',),
    "PySide2.QtNetwork.QLocalSocket.setSocketDescriptor": ('int', 'PySide2.QtNetwork.QLocalSocket.LocalSocketState', 'PySide2.QtCore.QIODevice.OpenMode'),
    "PySide2.QtNetwork.QLocalSocket.socketDescriptor": (),
    "PySide2.QtNetwork.QLocalSocket.state": (),
    "PySide2.QtNetwork.QLocalSocket.waitForBytesWritten": ('int',),
    "PySide2.QtNetwork.QLocalSocket.waitForConnected": ('int',),
    "PySide2.QtNetwork.QLocalSocket.waitForDisconnected": ('int',),
    "PySide2.QtNetwork.QLocalSocket.waitForReadyRead": ('int',),
    "PySide2.QtNetwork.QLocalSocket.writeData": ('str', 'int'),

# class PySide2.QtNetwork.QNetworkAccessManager:

# class PySide2.QtNetwork.QNetworkAccessManager.NetworkAccessibility:

# class PySide2.QtNetwork.QNetworkAccessManager.Operation:
    "PySide2.QtNetwork.QNetworkAccessManager.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QNetworkAccessManager.activeConfiguration": (),
    "PySide2.QtNetwork.QNetworkAccessManager.addStrictTransportSecurityHosts": ('typing.List[PySide2.QtNetwork.QHstsPolicy]',),
    "PySide2.QtNetwork.QNetworkAccessManager.autoDeleteReplies": (),
    "PySide2.QtNetwork.QNetworkAccessManager.cache": (),
    "PySide2.QtNetwork.QNetworkAccessManager.clearAccessCache": (),
    "PySide2.QtNetwork.QNetworkAccessManager.clearConnectionCache": (),
    "PySide2.QtNetwork.QNetworkAccessManager.configuration": (),
    "PySide2.QtNetwork.QNetworkAccessManager.connectToHost": ('str', 'int'),
    "PySide2.QtNetwork.QNetworkAccessManager.connectToHostEncrypted": [('str', 'int', 'PySide2.QtNetwork.QSslConfiguration'), ('str', 'int', 'PySide2.QtNetwork.QSslConfiguration', 'str')],
    "PySide2.QtNetwork.QNetworkAccessManager.cookieJar": (),
    "PySide2.QtNetwork.QNetworkAccessManager.createRequest": ('PySide2.QtNetwork.QNetworkAccessManager.Operation', 'PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QIODevice'),
    "PySide2.QtNetwork.QNetworkAccessManager.deleteResource": ('PySide2.QtNetwork.QNetworkRequest',),
    "PySide2.QtNetwork.QNetworkAccessManager.enableStrictTransportSecurityStore": ('bool', 'str'),
    "PySide2.QtNetwork.QNetworkAccessManager.get": ('PySide2.QtNetwork.QNetworkRequest',),
    "PySide2.QtNetwork.QNetworkAccessManager.head": ('PySide2.QtNetwork.QNetworkRequest',),
    "PySide2.QtNetwork.QNetworkAccessManager.isStrictTransportSecurityEnabled": (),
    "PySide2.QtNetwork.QNetworkAccessManager.isStrictTransportSecurityStoreEnabled": (),
    "PySide2.QtNetwork.QNetworkAccessManager.networkAccessible": (),
    "PySide2.QtNetwork.QNetworkAccessManager.post": [('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QByteArray'), ('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QIODevice'), ('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtNetwork.QHttpMultiPart')],
    "PySide2.QtNetwork.QNetworkAccessManager.proxy": (),
    "PySide2.QtNetwork.QNetworkAccessManager.proxyFactory": (),
    "PySide2.QtNetwork.QNetworkAccessManager.put": [('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QByteArray'), ('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QIODevice'), ('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtNetwork.QHttpMultiPart')],
    "PySide2.QtNetwork.QNetworkAccessManager.redirectPolicy": (),
    "PySide2.QtNetwork.QNetworkAccessManager.sendCustomRequest": [('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'), ('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QIODevice'), ('PySide2.QtNetwork.QNetworkRequest', 'PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QHttpMultiPart')],
    "PySide2.QtNetwork.QNetworkAccessManager.setAutoDeleteReplies": ('bool',),
    "PySide2.QtNetwork.QNetworkAccessManager.setCache": ('PySide2.QtNetwork.QAbstractNetworkCache',),
    "PySide2.QtNetwork.QNetworkAccessManager.setConfiguration": ('PySide2.QtNetwork.QNetworkConfiguration',),
    "PySide2.QtNetwork.QNetworkAccessManager.setCookieJar": ('PySide2.QtNetwork.QNetworkCookieJar',),
    "PySide2.QtNetwork.QNetworkAccessManager.setNetworkAccessible": ('PySide2.QtNetwork.QNetworkAccessManager.NetworkAccessibility',),
    "PySide2.QtNetwork.QNetworkAccessManager.setProxy": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtNetwork.QNetworkAccessManager.setProxyFactory": ('PySide2.QtNetwork.QNetworkProxyFactory',),
    "PySide2.QtNetwork.QNetworkAccessManager.setRedirectPolicy": ('PySide2.QtNetwork.QNetworkRequest.RedirectPolicy',),
    "PySide2.QtNetwork.QNetworkAccessManager.setStrictTransportSecurityEnabled": ('bool',),
    "PySide2.QtNetwork.QNetworkAccessManager.strictTransportSecurityHosts": (),
    "PySide2.QtNetwork.QNetworkAccessManager.supportedSchemes": (),
    "PySide2.QtNetwork.QNetworkAccessManager.supportedSchemesImplementation": (),

# class PySide2.QtNetwork.QNetworkAddressEntry:

# class PySide2.QtNetwork.QNetworkAddressEntry.DnsEligibilityStatus:
    "PySide2.QtNetwork.QNetworkAddressEntry.__init__": [(), ('PySide2.QtNetwork.QNetworkAddressEntry',)],
    "PySide2.QtNetwork.QNetworkAddressEntry.__copy__": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.broadcast": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.clearAddressLifetime": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.dnsEligibility": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.ip": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.isLifetimeKnown": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.isPermanent": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.isTemporary": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.netmask": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.prefixLength": (),
    "PySide2.QtNetwork.QNetworkAddressEntry.setBroadcast": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QNetworkAddressEntry.setDnsEligibility": ('PySide2.QtNetwork.QNetworkAddressEntry.DnsEligibilityStatus',),
    "PySide2.QtNetwork.QNetworkAddressEntry.setIp": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QNetworkAddressEntry.setNetmask": ('PySide2.QtNetwork.QHostAddress',),
    "PySide2.QtNetwork.QNetworkAddressEntry.setPrefixLength": ('int',),
    "PySide2.QtNetwork.QNetworkAddressEntry.swap": ('PySide2.QtNetwork.QNetworkAddressEntry',),

# class PySide2.QtNetwork.QNetworkCacheMetaData:
    "PySide2.QtNetwork.QNetworkCacheMetaData.__init__": [(), ('PySide2.QtNetwork.QNetworkCacheMetaData',)],
    "PySide2.QtNetwork.QNetworkCacheMetaData.__copy__": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.attributes": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.expirationDate": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.isValid": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.lastModified": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.rawHeaders": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.saveToDisk": (),
    "PySide2.QtNetwork.QNetworkCacheMetaData.setAttributes": ('typing.Dict[PySide2.QtNetwork.QNetworkRequest.Attribute, typing.Any]',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.setExpirationDate": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.setLastModified": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.setRawHeaders": ('typing.Sequence[typing.Tuple]',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.setSaveToDisk": ('bool',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.swap": ('PySide2.QtNetwork.QNetworkCacheMetaData',),
    "PySide2.QtNetwork.QNetworkCacheMetaData.url": (),

# class PySide2.QtNetwork.QNetworkConfiguration:

# class PySide2.QtNetwork.QNetworkConfiguration.BearerType:

# class PySide2.QtNetwork.QNetworkConfiguration.Purpose:

# class PySide2.QtNetwork.QNetworkConfiguration.StateFlag:

# class PySide2.QtNetwork.QNetworkConfiguration.StateFlags:

# class PySide2.QtNetwork.QNetworkConfiguration.Type:
    "PySide2.QtNetwork.QNetworkConfiguration.__init__": [(), ('PySide2.QtNetwork.QNetworkConfiguration',)],
    "PySide2.QtNetwork.QNetworkConfiguration.__copy__": (),
    "PySide2.QtNetwork.QNetworkConfiguration.bearerType": (),
    "PySide2.QtNetwork.QNetworkConfiguration.bearerTypeFamily": (),
    "PySide2.QtNetwork.QNetworkConfiguration.bearerTypeName": (),
    "PySide2.QtNetwork.QNetworkConfiguration.children": (),
    "PySide2.QtNetwork.QNetworkConfiguration.connectTimeout": (),
    "PySide2.QtNetwork.QNetworkConfiguration.identifier": (),
    "PySide2.QtNetwork.QNetworkConfiguration.isRoamingAvailable": (),
    "PySide2.QtNetwork.QNetworkConfiguration.isValid": (),
    "PySide2.QtNetwork.QNetworkConfiguration.name": (),
    "PySide2.QtNetwork.QNetworkConfiguration.purpose": (),
    "PySide2.QtNetwork.QNetworkConfiguration.setConnectTimeout": ('int',),
    "PySide2.QtNetwork.QNetworkConfiguration.state": (),
    "PySide2.QtNetwork.QNetworkConfiguration.swap": ('PySide2.QtNetwork.QNetworkConfiguration',),
    "PySide2.QtNetwork.QNetworkConfiguration.type": (),

# class PySide2.QtNetwork.QNetworkConfigurationManager:

# class PySide2.QtNetwork.QNetworkConfigurationManager.Capabilities:

# class PySide2.QtNetwork.QNetworkConfigurationManager.Capability:
    "PySide2.QtNetwork.QNetworkConfigurationManager.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QNetworkConfigurationManager.allConfigurations": ('PySide2.QtNetwork.QNetworkConfiguration.StateFlags',),
    "PySide2.QtNetwork.QNetworkConfigurationManager.capabilities": (),
    "PySide2.QtNetwork.QNetworkConfigurationManager.configurationFromIdentifier": ('str',),
    "PySide2.QtNetwork.QNetworkConfigurationManager.defaultConfiguration": (),
    "PySide2.QtNetwork.QNetworkConfigurationManager.isOnline": (),
    "PySide2.QtNetwork.QNetworkConfigurationManager.updateConfigurations": (),

# class PySide2.QtNetwork.QNetworkCookie:

# class PySide2.QtNetwork.QNetworkCookie.RawForm:
    "PySide2.QtNetwork.QNetworkCookie.__init__": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'), ('PySide2.QtNetwork.QNetworkCookie',)],
    "PySide2.QtNetwork.QNetworkCookie.__copy__": (),
    "PySide2.QtNetwork.QNetworkCookie.domain": (),
    "PySide2.QtNetwork.QNetworkCookie.expirationDate": (),
    "PySide2.QtNetwork.QNetworkCookie.hasSameIdentifier": ('PySide2.QtNetwork.QNetworkCookie',),
    "PySide2.QtNetwork.QNetworkCookie.isHttpOnly": (),
    "PySide2.QtNetwork.QNetworkCookie.isSecure": (),
    "PySide2.QtNetwork.QNetworkCookie.isSessionCookie": (),
    "PySide2.QtNetwork.QNetworkCookie.name": (),
    "PySide2.QtNetwork.QNetworkCookie.normalize": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkCookie.parseCookies": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkCookie.path": (),
    "PySide2.QtNetwork.QNetworkCookie.setDomain": ('str',),
    "PySide2.QtNetwork.QNetworkCookie.setExpirationDate": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtNetwork.QNetworkCookie.setHttpOnly": ('bool',),
    "PySide2.QtNetwork.QNetworkCookie.setName": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkCookie.setPath": ('str',),
    "PySide2.QtNetwork.QNetworkCookie.setSecure": ('bool',),
    "PySide2.QtNetwork.QNetworkCookie.setValue": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkCookie.swap": ('PySide2.QtNetwork.QNetworkCookie',),
    "PySide2.QtNetwork.QNetworkCookie.toRawForm": ('PySide2.QtNetwork.QNetworkCookie.RawForm',),
    "PySide2.QtNetwork.QNetworkCookie.value": (),

# class PySide2.QtNetwork.QNetworkCookieJar:
    "PySide2.QtNetwork.QNetworkCookieJar.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QNetworkCookieJar.allCookies": (),
    "PySide2.QtNetwork.QNetworkCookieJar.cookiesForUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkCookieJar.deleteCookie": ('PySide2.QtNetwork.QNetworkCookie',),
    "PySide2.QtNetwork.QNetworkCookieJar.insertCookie": ('PySide2.QtNetwork.QNetworkCookie',),
    "PySide2.QtNetwork.QNetworkCookieJar.setAllCookies": ('typing.Sequence[PySide2.QtNetwork.QNetworkCookie]',),
    "PySide2.QtNetwork.QNetworkCookieJar.setCookiesFromUrl": ('typing.Sequence[PySide2.QtNetwork.QNetworkCookie]', 'PySide2.QtCore.QUrl'),
    "PySide2.QtNetwork.QNetworkCookieJar.updateCookie": ('PySide2.QtNetwork.QNetworkCookie',),
    "PySide2.QtNetwork.QNetworkCookieJar.validateCookie": ('PySide2.QtNetwork.QNetworkCookie', 'PySide2.QtCore.QUrl'),

# class PySide2.QtNetwork.QNetworkDatagram:
    "PySide2.QtNetwork.QNetworkDatagram.__init__": [(), ('PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QHostAddress', 'int'), ('PySide2.QtNetwork.QNetworkDatagram',)],
    "PySide2.QtNetwork.QNetworkDatagram.__copy__": (),
    "PySide2.QtNetwork.QNetworkDatagram.clear": (),
    "PySide2.QtNetwork.QNetworkDatagram.data": (),
    "PySide2.QtNetwork.QNetworkDatagram.destinationAddress": (),
    "PySide2.QtNetwork.QNetworkDatagram.destinationPort": (),
    "PySide2.QtNetwork.QNetworkDatagram.hopLimit": (),
    "PySide2.QtNetwork.QNetworkDatagram.interfaceIndex": (),
    "PySide2.QtNetwork.QNetworkDatagram.isNull": (),
    "PySide2.QtNetwork.QNetworkDatagram.isValid": (),
    "PySide2.QtNetwork.QNetworkDatagram.makeReply": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkDatagram.senderAddress": (),
    "PySide2.QtNetwork.QNetworkDatagram.senderPort": (),
    "PySide2.QtNetwork.QNetworkDatagram.setData": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkDatagram.setDestination": ('PySide2.QtNetwork.QHostAddress', 'int'),
    "PySide2.QtNetwork.QNetworkDatagram.setHopLimit": ('int',),
    "PySide2.QtNetwork.QNetworkDatagram.setInterfaceIndex": ('int',),
    "PySide2.QtNetwork.QNetworkDatagram.setSender": ('PySide2.QtNetwork.QHostAddress', 'int'),
    "PySide2.QtNetwork.QNetworkDatagram.swap": ('PySide2.QtNetwork.QNetworkDatagram',),

# class PySide2.QtNetwork.QNetworkDiskCache:
    "PySide2.QtNetwork.QNetworkDiskCache.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QNetworkDiskCache.cacheDirectory": (),
    "PySide2.QtNetwork.QNetworkDiskCache.cacheSize": (),
    "PySide2.QtNetwork.QNetworkDiskCache.clear": (),
    "PySide2.QtNetwork.QNetworkDiskCache.data": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkDiskCache.expire": (),
    "PySide2.QtNetwork.QNetworkDiskCache.fileMetaData": ('str',),
    "PySide2.QtNetwork.QNetworkDiskCache.insert": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtNetwork.QNetworkDiskCache.maximumCacheSize": (),
    "PySide2.QtNetwork.QNetworkDiskCache.metaData": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkDiskCache.prepare": ('PySide2.QtNetwork.QNetworkCacheMetaData',),
    "PySide2.QtNetwork.QNetworkDiskCache.remove": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkDiskCache.setCacheDirectory": ('str',),
    "PySide2.QtNetwork.QNetworkDiskCache.setMaximumCacheSize": ('int',),
    "PySide2.QtNetwork.QNetworkDiskCache.updateMetaData": ('PySide2.QtNetwork.QNetworkCacheMetaData',),

# class PySide2.QtNetwork.QNetworkInterface:

# class PySide2.QtNetwork.QNetworkInterface.InterfaceFlag:

# class PySide2.QtNetwork.QNetworkInterface.InterfaceFlags:

# class PySide2.QtNetwork.QNetworkInterface.InterfaceType:
    "PySide2.QtNetwork.QNetworkInterface.__init__": [(), ('PySide2.QtNetwork.QNetworkInterface',)],
    "PySide2.QtNetwork.QNetworkInterface.__copy__": (),
    "PySide2.QtNetwork.QNetworkInterface.addressEntries": (),
    "PySide2.QtNetwork.QNetworkInterface.allAddresses": (),
    "PySide2.QtNetwork.QNetworkInterface.allInterfaces": (),
    "PySide2.QtNetwork.QNetworkInterface.flags": (),
    "PySide2.QtNetwork.QNetworkInterface.hardwareAddress": (),
    "PySide2.QtNetwork.QNetworkInterface.humanReadableName": (),
    "PySide2.QtNetwork.QNetworkInterface.index": (),
    "PySide2.QtNetwork.QNetworkInterface.interfaceFromIndex": ('int',),
    "PySide2.QtNetwork.QNetworkInterface.interfaceFromName": ('str',),
    "PySide2.QtNetwork.QNetworkInterface.interfaceIndexFromName": ('str',),
    "PySide2.QtNetwork.QNetworkInterface.interfaceNameFromIndex": ('int',),
    "PySide2.QtNetwork.QNetworkInterface.isValid": (),
    "PySide2.QtNetwork.QNetworkInterface.maximumTransmissionUnit": (),
    "PySide2.QtNetwork.QNetworkInterface.name": (),
    "PySide2.QtNetwork.QNetworkInterface.swap": ('PySide2.QtNetwork.QNetworkInterface',),
    "PySide2.QtNetwork.QNetworkInterface.type": (),

# class PySide2.QtNetwork.QNetworkProxy:

# class PySide2.QtNetwork.QNetworkProxy.Capabilities:

# class PySide2.QtNetwork.QNetworkProxy.Capability:

# class PySide2.QtNetwork.QNetworkProxy.ProxyType:
    "PySide2.QtNetwork.QNetworkProxy.__init__": [(), ('PySide2.QtNetwork.QNetworkProxy',), ('PySide2.QtNetwork.QNetworkProxy.ProxyType', 'str', 'int', 'str', 'str')],
    "PySide2.QtNetwork.QNetworkProxy.__copy__": (),
    "PySide2.QtNetwork.QNetworkProxy.applicationProxy": (),
    "PySide2.QtNetwork.QNetworkProxy.capabilities": (),
    "PySide2.QtNetwork.QNetworkProxy.hasRawHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkProxy.header": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders',),
    "PySide2.QtNetwork.QNetworkProxy.hostName": (),
    "PySide2.QtNetwork.QNetworkProxy.isCachingProxy": (),
    "PySide2.QtNetwork.QNetworkProxy.isTransparentProxy": (),
    "PySide2.QtNetwork.QNetworkProxy.password": (),
    "PySide2.QtNetwork.QNetworkProxy.port": (),
    "PySide2.QtNetwork.QNetworkProxy.rawHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkProxy.rawHeaderList": (),
    "PySide2.QtNetwork.QNetworkProxy.setApplicationProxy": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtNetwork.QNetworkProxy.setCapabilities": ('PySide2.QtNetwork.QNetworkProxy.Capabilities',),
    "PySide2.QtNetwork.QNetworkProxy.setHeader": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkProxy.setHostName": ('str',),
    "PySide2.QtNetwork.QNetworkProxy.setPassword": ('str',),
    "PySide2.QtNetwork.QNetworkProxy.setPort": ('int',),
    "PySide2.QtNetwork.QNetworkProxy.setRawHeader": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtNetwork.QNetworkProxy.setType": ('PySide2.QtNetwork.QNetworkProxy.ProxyType',),
    "PySide2.QtNetwork.QNetworkProxy.setUser": ('str',),
    "PySide2.QtNetwork.QNetworkProxy.swap": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtNetwork.QNetworkProxy.type": (),
    "PySide2.QtNetwork.QNetworkProxy.user": (),

# class PySide2.QtNetwork.QNetworkProxyFactory:
    "PySide2.QtNetwork.QNetworkProxyFactory.__init__": (),
    "PySide2.QtNetwork.QNetworkProxyFactory.proxyForQuery": ('PySide2.QtNetwork.QNetworkProxyQuery',),
    "PySide2.QtNetwork.QNetworkProxyFactory.queryProxy": ('PySide2.QtNetwork.QNetworkProxyQuery',),
    "PySide2.QtNetwork.QNetworkProxyFactory.setApplicationProxyFactory": ('PySide2.QtNetwork.QNetworkProxyFactory',),
    "PySide2.QtNetwork.QNetworkProxyFactory.setUseSystemConfiguration": ('bool',),
    "PySide2.QtNetwork.QNetworkProxyFactory.systemProxyForQuery": ('PySide2.QtNetwork.QNetworkProxyQuery',),
    "PySide2.QtNetwork.QNetworkProxyFactory.usesSystemConfiguration": (),

# class PySide2.QtNetwork.QNetworkProxyQuery:

# class PySide2.QtNetwork.QNetworkProxyQuery.QueryType:
    "PySide2.QtNetwork.QNetworkProxyQuery.__init__": [(), ('PySide2.QtCore.QUrl', 'PySide2.QtNetwork.QNetworkProxyQuery.QueryType'), ('PySide2.QtNetwork.QNetworkConfiguration', 'PySide2.QtCore.QUrl', 'PySide2.QtNetwork.QNetworkProxyQuery.QueryType'), ('PySide2.QtNetwork.QNetworkConfiguration', 'int', 'str', 'PySide2.QtNetwork.QNetworkProxyQuery.QueryType'), ('PySide2.QtNetwork.QNetworkConfiguration', 'str', 'int', 'str', 'PySide2.QtNetwork.QNetworkProxyQuery.QueryType'), ('PySide2.QtNetwork.QNetworkProxyQuery',), ('int', 'str', 'PySide2.QtNetwork.QNetworkProxyQuery.QueryType'), ('str', 'int', 'str', 'PySide2.QtNetwork.QNetworkProxyQuery.QueryType')],
    "PySide2.QtNetwork.QNetworkProxyQuery.__copy__": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.localPort": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.networkConfiguration": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.peerHostName": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.peerPort": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.protocolTag": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.queryType": (),
    "PySide2.QtNetwork.QNetworkProxyQuery.setLocalPort": ('int',),
    "PySide2.QtNetwork.QNetworkProxyQuery.setNetworkConfiguration": ('PySide2.QtNetwork.QNetworkConfiguration',),
    "PySide2.QtNetwork.QNetworkProxyQuery.setPeerHostName": ('str',),
    "PySide2.QtNetwork.QNetworkProxyQuery.setPeerPort": ('int',),
    "PySide2.QtNetwork.QNetworkProxyQuery.setProtocolTag": ('str',),
    "PySide2.QtNetwork.QNetworkProxyQuery.setQueryType": ('PySide2.QtNetwork.QNetworkProxyQuery.QueryType',),
    "PySide2.QtNetwork.QNetworkProxyQuery.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkProxyQuery.swap": ('PySide2.QtNetwork.QNetworkProxyQuery',),
    "PySide2.QtNetwork.QNetworkProxyQuery.url": (),

# class PySide2.QtNetwork.QNetworkReply:

# class PySide2.QtNetwork.QNetworkReply.NetworkError:
    "PySide2.QtNetwork.QNetworkReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QNetworkReply.abort": (),
    "PySide2.QtNetwork.QNetworkReply.attribute": ('PySide2.QtNetwork.QNetworkRequest.Attribute',),
    "PySide2.QtNetwork.QNetworkReply.close": (),
    "PySide2.QtNetwork.QNetworkReply.error": (),
    "PySide2.QtNetwork.QNetworkReply.hasRawHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkReply.header": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders',),
    "PySide2.QtNetwork.QNetworkReply.ignoreSslErrors": [(), ('typing.Sequence[PySide2.QtNetwork.QSslError]',)],
    "PySide2.QtNetwork.QNetworkReply.ignoreSslErrorsImplementation": ('typing.Sequence[PySide2.QtNetwork.QSslError]',),
    "PySide2.QtNetwork.QNetworkReply.isFinished": (),
    "PySide2.QtNetwork.QNetworkReply.isRunning": (),
    "PySide2.QtNetwork.QNetworkReply.isSequential": (),
    "PySide2.QtNetwork.QNetworkReply.manager": (),
    "PySide2.QtNetwork.QNetworkReply.operation": (),
    "PySide2.QtNetwork.QNetworkReply.rawHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkReply.rawHeaderList": (),
    "PySide2.QtNetwork.QNetworkReply.rawHeaderPairs": (),
    "PySide2.QtNetwork.QNetworkReply.readBufferSize": (),
    "PySide2.QtNetwork.QNetworkReply.request": (),
    "PySide2.QtNetwork.QNetworkReply.setAttribute": ('PySide2.QtNetwork.QNetworkRequest.Attribute', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkReply.setError": ('PySide2.QtNetwork.QNetworkReply.NetworkError', 'str'),
    "PySide2.QtNetwork.QNetworkReply.setFinished": ('bool',),
    "PySide2.QtNetwork.QNetworkReply.setHeader": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkReply.setOperation": ('PySide2.QtNetwork.QNetworkAccessManager.Operation',),
    "PySide2.QtNetwork.QNetworkReply.setRawHeader": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtNetwork.QNetworkReply.setReadBufferSize": ('int',),
    "PySide2.QtNetwork.QNetworkReply.setRequest": ('PySide2.QtNetwork.QNetworkRequest',),
    "PySide2.QtNetwork.QNetworkReply.setSslConfiguration": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QNetworkReply.setSslConfigurationImplementation": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QNetworkReply.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkReply.sslConfiguration": (),
    "PySide2.QtNetwork.QNetworkReply.sslConfigurationImplementation": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QNetworkReply.url": (),
    "PySide2.QtNetwork.QNetworkReply.writeData": ('str', 'int'),

# class PySide2.QtNetwork.QNetworkRequest:

# class PySide2.QtNetwork.QNetworkRequest.Attribute:

# class PySide2.QtNetwork.QNetworkRequest.CacheLoadControl:

# class PySide2.QtNetwork.QNetworkRequest.KnownHeaders:

# class PySide2.QtNetwork.QNetworkRequest.LoadControl:

# class PySide2.QtNetwork.QNetworkRequest.Priority:

# class PySide2.QtNetwork.QNetworkRequest.RedirectPolicy:
    "PySide2.QtNetwork.QNetworkRequest.__init__": [(), ('PySide2.QtCore.QUrl',), ('PySide2.QtNetwork.QNetworkRequest',)],
    "PySide2.QtNetwork.QNetworkRequest.__copy__": (),
    "PySide2.QtNetwork.QNetworkRequest.attribute": ('PySide2.QtNetwork.QNetworkRequest.Attribute', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkRequest.hasRawHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkRequest.header": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders',),
    "PySide2.QtNetwork.QNetworkRequest.maximumRedirectsAllowed": (),
    "PySide2.QtNetwork.QNetworkRequest.originatingObject": (),
    "PySide2.QtNetwork.QNetworkRequest.peerVerifyName": (),
    "PySide2.QtNetwork.QNetworkRequest.priority": (),
    "PySide2.QtNetwork.QNetworkRequest.rawHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QNetworkRequest.rawHeaderList": (),
    "PySide2.QtNetwork.QNetworkRequest.setAttribute": ('PySide2.QtNetwork.QNetworkRequest.Attribute', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkRequest.setHeader": ('PySide2.QtNetwork.QNetworkRequest.KnownHeaders', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkRequest.setMaximumRedirectsAllowed": ('int',),
    "PySide2.QtNetwork.QNetworkRequest.setOriginatingObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QNetworkRequest.setPeerVerifyName": ('str',),
    "PySide2.QtNetwork.QNetworkRequest.setPriority": ('PySide2.QtNetwork.QNetworkRequest.Priority',),
    "PySide2.QtNetwork.QNetworkRequest.setRawHeader": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtNetwork.QNetworkRequest.setSslConfiguration": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QNetworkRequest.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtNetwork.QNetworkRequest.sslConfiguration": (),
    "PySide2.QtNetwork.QNetworkRequest.swap": ('PySide2.QtNetwork.QNetworkRequest',),
    "PySide2.QtNetwork.QNetworkRequest.url": (),

# class PySide2.QtNetwork.QNetworkSession:

# class PySide2.QtNetwork.QNetworkSession.SessionError:

# class PySide2.QtNetwork.QNetworkSession.State:

# class PySide2.QtNetwork.QNetworkSession.UsagePolicies:

# class PySide2.QtNetwork.QNetworkSession.UsagePolicy:
    "PySide2.QtNetwork.QNetworkSession.__init__": ('PySide2.QtNetwork.QNetworkConfiguration', 'PySide2.QtCore.QObject'),
    "PySide2.QtNetwork.QNetworkSession.accept": (),
    "PySide2.QtNetwork.QNetworkSession.activeTime": (),
    "PySide2.QtNetwork.QNetworkSession.bytesReceived": (),
    "PySide2.QtNetwork.QNetworkSession.bytesWritten": (),
    "PySide2.QtNetwork.QNetworkSession.close": (),
    "PySide2.QtNetwork.QNetworkSession.configuration": (),
    "PySide2.QtNetwork.QNetworkSession.connectNotify": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtNetwork.QNetworkSession.disconnectNotify": ('PySide2.QtCore.QMetaMethod',),
    "PySide2.QtNetwork.QNetworkSession.error": (),
    "PySide2.QtNetwork.QNetworkSession.errorString": (),
    "PySide2.QtNetwork.QNetworkSession.ignore": (),
    "PySide2.QtNetwork.QNetworkSession.interface": (),
    "PySide2.QtNetwork.QNetworkSession.isOpen": (),
    "PySide2.QtNetwork.QNetworkSession.migrate": (),
    "PySide2.QtNetwork.QNetworkSession.open": (),
    "PySide2.QtNetwork.QNetworkSession.reject": (),
    "PySide2.QtNetwork.QNetworkSession.sessionProperty": ('str',),
    "PySide2.QtNetwork.QNetworkSession.setSessionProperty": ('str', 'typing.Any'),
    "PySide2.QtNetwork.QNetworkSession.state": (),
    "PySide2.QtNetwork.QNetworkSession.stop": (),
    "PySide2.QtNetwork.QNetworkSession.usagePolicies": (),
    "PySide2.QtNetwork.QNetworkSession.waitForOpened": ('int',),

# class PySide2.QtNetwork.QOcspCertificateStatus:

# class PySide2.QtNetwork.QOcspResponse:
    "PySide2.QtNetwork.QOcspResponse.__init__": [(), ('PySide2.QtNetwork.QOcspResponse',)],
    "PySide2.QtNetwork.QOcspResponse.__copy__": (),
    "PySide2.QtNetwork.QOcspResponse.certificateStatus": (),
    "PySide2.QtNetwork.QOcspResponse.revocationReason": (),
    "PySide2.QtNetwork.QOcspResponse.subject": (),
    "PySide2.QtNetwork.QOcspResponse.swap": ('PySide2.QtNetwork.QOcspResponse',),

# class PySide2.QtNetwork.QOcspRevocationReason:

# class PySide2.QtNetwork.QPasswordDigestor:
    "PySide2.QtNetwork.QPasswordDigestor.deriveKeyPbkdf1": ('PySide2.QtCore.QCryptographicHash.Algorithm', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray', 'int', 'int'),
    "PySide2.QtNetwork.QPasswordDigestor.deriveKeyPbkdf2": ('PySide2.QtCore.QCryptographicHash.Algorithm', 'PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray', 'int', 'int'),

# class PySide2.QtNetwork.QSsl:

# class PySide2.QtNetwork.QSsl.AlternativeNameEntryType:

# class PySide2.QtNetwork.QSsl.EncodingFormat:

# class PySide2.QtNetwork.QSsl.KeyAlgorithm:

# class PySide2.QtNetwork.QSsl.KeyType:

# class PySide2.QtNetwork.QSsl.SslOption:

# class PySide2.QtNetwork.QSsl.SslOptions:

# class PySide2.QtNetwork.QSsl.SslProtocol:

# class PySide2.QtNetwork.QSslCertificate:

# class PySide2.QtNetwork.QSslCertificate.SubjectInfo:
    "PySide2.QtNetwork.QSslCertificate.__init__": [('PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QSsl.EncodingFormat'), ('PySide2.QtCore.QIODevice', 'PySide2.QtNetwork.QSsl.EncodingFormat'), ('PySide2.QtNetwork.QSslCertificate',)],
    "PySide2.QtNetwork.QSslCertificate.__copy__": (),
    "PySide2.QtNetwork.QSslCertificate.clear": (),
    "PySide2.QtNetwork.QSslCertificate.digest": ('PySide2.QtCore.QCryptographicHash.Algorithm',),
    "PySide2.QtNetwork.QSslCertificate.effectiveDate": (),
    "PySide2.QtNetwork.QSslCertificate.expiryDate": (),
    "PySide2.QtNetwork.QSslCertificate.extensions": (),
    "PySide2.QtNetwork.QSslCertificate.fromData": ('PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QSsl.EncodingFormat'),
    "PySide2.QtNetwork.QSslCertificate.fromDevice": ('PySide2.QtCore.QIODevice', 'PySide2.QtNetwork.QSsl.EncodingFormat'),
    "PySide2.QtNetwork.QSslCertificate.fromPath": ('str', 'PySide2.QtNetwork.QSsl.EncodingFormat', 'PySide2.QtCore.QRegExp.PatternSyntax'),
    "PySide2.QtNetwork.QSslCertificate.handle": (),
    "PySide2.QtNetwork.QSslCertificate.importPkcs12": ('PySide2.QtCore.QIODevice', 'PySide2.QtNetwork.QSslKey', 'PySide2.QtNetwork.QSslCertificate', 'typing.Sequence[PySide2.QtNetwork.QSslCertificate]', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtNetwork.QSslCertificate.isBlacklisted": (),
    "PySide2.QtNetwork.QSslCertificate.isNull": (),
    "PySide2.QtNetwork.QSslCertificate.isSelfSigned": (),
    "PySide2.QtNetwork.QSslCertificate.issuerDisplayName": (),
    "PySide2.QtNetwork.QSslCertificate.issuerInfo": [('PySide2.QtCore.QByteArray',), ('PySide2.QtNetwork.QSslCertificate.SubjectInfo',)],
    "PySide2.QtNetwork.QSslCertificate.issuerInfoAttributes": (),
    "PySide2.QtNetwork.QSslCertificate.publicKey": (),
    "PySide2.QtNetwork.QSslCertificate.serialNumber": (),
    "PySide2.QtNetwork.QSslCertificate.subjectAlternativeNames": (),
    "PySide2.QtNetwork.QSslCertificate.subjectDisplayName": (),
    "PySide2.QtNetwork.QSslCertificate.subjectInfo": [('PySide2.QtCore.QByteArray',), ('PySide2.QtNetwork.QSslCertificate.SubjectInfo',)],
    "PySide2.QtNetwork.QSslCertificate.subjectInfoAttributes": (),
    "PySide2.QtNetwork.QSslCertificate.swap": ('PySide2.QtNetwork.QSslCertificate',),
    "PySide2.QtNetwork.QSslCertificate.toDer": (),
    "PySide2.QtNetwork.QSslCertificate.toPem": (),
    "PySide2.QtNetwork.QSslCertificate.toText": (),
    "PySide2.QtNetwork.QSslCertificate.verify": ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]', 'str'),
    "PySide2.QtNetwork.QSslCertificate.version": (),

# class PySide2.QtNetwork.QSslCertificateExtension:
    "PySide2.QtNetwork.QSslCertificateExtension.__init__": [(), ('PySide2.QtNetwork.QSslCertificateExtension',)],
    "PySide2.QtNetwork.QSslCertificateExtension.__copy__": (),
    "PySide2.QtNetwork.QSslCertificateExtension.isCritical": (),
    "PySide2.QtNetwork.QSslCertificateExtension.isSupported": (),
    "PySide2.QtNetwork.QSslCertificateExtension.name": (),
    "PySide2.QtNetwork.QSslCertificateExtension.oid": (),
    "PySide2.QtNetwork.QSslCertificateExtension.swap": ('PySide2.QtNetwork.QSslCertificateExtension',),
    "PySide2.QtNetwork.QSslCertificateExtension.value": (),

# class PySide2.QtNetwork.QSslCipher:
    "PySide2.QtNetwork.QSslCipher.__init__": [(), ('PySide2.QtNetwork.QSslCipher',), ('str',), ('str', 'PySide2.QtNetwork.QSsl.SslProtocol')],
    "PySide2.QtNetwork.QSslCipher.__copy__": (),
    "PySide2.QtNetwork.QSslCipher.authenticationMethod": (),
    "PySide2.QtNetwork.QSslCipher.encryptionMethod": (),
    "PySide2.QtNetwork.QSslCipher.isNull": (),
    "PySide2.QtNetwork.QSslCipher.keyExchangeMethod": (),
    "PySide2.QtNetwork.QSslCipher.name": (),
    "PySide2.QtNetwork.QSslCipher.protocol": (),
    "PySide2.QtNetwork.QSslCipher.protocolString": (),
    "PySide2.QtNetwork.QSslCipher.supportedBits": (),
    "PySide2.QtNetwork.QSslCipher.swap": ('PySide2.QtNetwork.QSslCipher',),
    "PySide2.QtNetwork.QSslCipher.usedBits": (),

# class PySide2.QtNetwork.QSslConfiguration:

# class PySide2.QtNetwork.QSslConfiguration.NextProtocolNegotiationStatus:
    "PySide2.QtNetwork.QSslConfiguration.__init__": [(), ('PySide2.QtNetwork.QSslConfiguration',)],
    "PySide2.QtNetwork.QSslConfiguration.__copy__": (),
    "PySide2.QtNetwork.QSslConfiguration.allowedNextProtocols": (),
    "PySide2.QtNetwork.QSslConfiguration.backendConfiguration": (),
    "PySide2.QtNetwork.QSslConfiguration.caCertificates": (),
    "PySide2.QtNetwork.QSslConfiguration.ciphers": (),
    "PySide2.QtNetwork.QSslConfiguration.defaultConfiguration": (),
    "PySide2.QtNetwork.QSslConfiguration.diffieHellmanParameters": (),
    "PySide2.QtNetwork.QSslConfiguration.ephemeralServerKey": (),
    "PySide2.QtNetwork.QSslConfiguration.isNull": (),
    "PySide2.QtNetwork.QSslConfiguration.localCertificate": (),
    "PySide2.QtNetwork.QSslConfiguration.localCertificateChain": (),
    "PySide2.QtNetwork.QSslConfiguration.nextNegotiatedProtocol": (),
    "PySide2.QtNetwork.QSslConfiguration.nextProtocolNegotiationStatus": (),
    "PySide2.QtNetwork.QSslConfiguration.ocspStaplingEnabled": (),
    "PySide2.QtNetwork.QSslConfiguration.peerCertificate": (),
    "PySide2.QtNetwork.QSslConfiguration.peerCertificateChain": (),
    "PySide2.QtNetwork.QSslConfiguration.peerVerifyDepth": (),
    "PySide2.QtNetwork.QSslConfiguration.peerVerifyMode": (),
    "PySide2.QtNetwork.QSslConfiguration.preSharedKeyIdentityHint": (),
    "PySide2.QtNetwork.QSslConfiguration.privateKey": (),
    "PySide2.QtNetwork.QSslConfiguration.protocol": (),
    "PySide2.QtNetwork.QSslConfiguration.sessionCipher": (),
    "PySide2.QtNetwork.QSslConfiguration.sessionProtocol": (),
    "PySide2.QtNetwork.QSslConfiguration.sessionTicket": (),
    "PySide2.QtNetwork.QSslConfiguration.sessionTicketLifeTimeHint": (),
    "PySide2.QtNetwork.QSslConfiguration.setAllowedNextProtocols": ('typing.Sequence[PySide2.QtCore.QByteArray]',),
    "PySide2.QtNetwork.QSslConfiguration.setBackendConfiguration": ('typing.Dict[PySide2.QtCore.QByteArray, typing.Any]',),
    "PySide2.QtNetwork.QSslConfiguration.setBackendConfigurationOption": ('PySide2.QtCore.QByteArray', 'typing.Any'),
    "PySide2.QtNetwork.QSslConfiguration.setCaCertificates": ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',),
    "PySide2.QtNetwork.QSslConfiguration.setCiphers": ('typing.Sequence[PySide2.QtNetwork.QSslCipher]',),
    "PySide2.QtNetwork.QSslConfiguration.setDefaultConfiguration": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QSslConfiguration.setDiffieHellmanParameters": ('PySide2.QtNetwork.QSslDiffieHellmanParameters',),
    "PySide2.QtNetwork.QSslConfiguration.setLocalCertificate": ('PySide2.QtNetwork.QSslCertificate',),
    "PySide2.QtNetwork.QSslConfiguration.setLocalCertificateChain": ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',),
    "PySide2.QtNetwork.QSslConfiguration.setOcspStaplingEnabled": ('bool',),
    "PySide2.QtNetwork.QSslConfiguration.setPeerVerifyDepth": ('int',),
    "PySide2.QtNetwork.QSslConfiguration.setPeerVerifyMode": ('PySide2.QtNetwork.QSslSocket.PeerVerifyMode',),
    "PySide2.QtNetwork.QSslConfiguration.setPreSharedKeyIdentityHint": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QSslConfiguration.setPrivateKey": ('PySide2.QtNetwork.QSslKey',),
    "PySide2.QtNetwork.QSslConfiguration.setProtocol": ('PySide2.QtNetwork.QSsl.SslProtocol',),
    "PySide2.QtNetwork.QSslConfiguration.setSessionTicket": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QSslConfiguration.setSslOption": ('PySide2.QtNetwork.QSsl.SslOption', 'bool'),
    "PySide2.QtNetwork.QSslConfiguration.supportedCiphers": (),
    "PySide2.QtNetwork.QSslConfiguration.swap": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QSslConfiguration.systemCaCertificates": (),
    "PySide2.QtNetwork.QSslConfiguration.testSslOption": ('PySide2.QtNetwork.QSsl.SslOption',),

# class PySide2.QtNetwork.QSslDiffieHellmanParameters:

# class PySide2.QtNetwork.QSslDiffieHellmanParameters.Error:
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.__init__": [(), ('PySide2.QtNetwork.QSslDiffieHellmanParameters',)],
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.__copy__": (),
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.defaultParameters": (),
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.error": (),
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.errorString": (),
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.fromEncoded": [('PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QSsl.EncodingFormat'), ('PySide2.QtCore.QIODevice', 'PySide2.QtNetwork.QSsl.EncodingFormat')],
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.isEmpty": (),
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.isValid": (),
    "PySide2.QtNetwork.QSslDiffieHellmanParameters.swap": ('PySide2.QtNetwork.QSslDiffieHellmanParameters',),

# class PySide2.QtNetwork.QSslError:

# class PySide2.QtNetwork.QSslError.SslError:
    "PySide2.QtNetwork.QSslError.__init__": [(), ('PySide2.QtNetwork.QSslError',), ('PySide2.QtNetwork.QSslError.SslError',), ('PySide2.QtNetwork.QSslError.SslError', 'PySide2.QtNetwork.QSslCertificate')],
    "PySide2.QtNetwork.QSslError.__copy__": (),
    "PySide2.QtNetwork.QSslError.certificate": (),
    "PySide2.QtNetwork.QSslError.error": (),
    "PySide2.QtNetwork.QSslError.errorString": (),
    "PySide2.QtNetwork.QSslError.swap": ('PySide2.QtNetwork.QSslError',),

# class PySide2.QtNetwork.QSslKey:
    "PySide2.QtNetwork.QSslKey.__init__": [(), ('PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QSsl.KeyAlgorithm', 'PySide2.QtNetwork.QSsl.EncodingFormat', 'PySide2.QtNetwork.QSsl.KeyType', 'PySide2.QtCore.QByteArray'), ('PySide2.QtCore.QIODevice', 'PySide2.QtNetwork.QSsl.KeyAlgorithm', 'PySide2.QtNetwork.QSsl.EncodingFormat', 'PySide2.QtNetwork.QSsl.KeyType', 'PySide2.QtCore.QByteArray'), ('PySide2.QtNetwork.QSslKey',), ('int', 'PySide2.QtNetwork.QSsl.KeyType')],
    "PySide2.QtNetwork.QSslKey.__copy__": (),
    "PySide2.QtNetwork.QSslKey.algorithm": (),
    "PySide2.QtNetwork.QSslKey.clear": (),
    "PySide2.QtNetwork.QSslKey.handle": (),
    "PySide2.QtNetwork.QSslKey.isNull": (),
    "PySide2.QtNetwork.QSslKey.length": (),
    "PySide2.QtNetwork.QSslKey.swap": ('PySide2.QtNetwork.QSslKey',),
    "PySide2.QtNetwork.QSslKey.toDer": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QSslKey.toPem": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QSslKey.type": (),

# class PySide2.QtNetwork.QSslPreSharedKeyAuthenticator:
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.__init__": [(), ('PySide2.QtNetwork.QSslPreSharedKeyAuthenticator',)],
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.__copy__": (),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.identity": (),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.identityHint": (),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.maximumIdentityLength": (),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.maximumPreSharedKeyLength": (),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.preSharedKey": (),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.setIdentity": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.setPreSharedKey": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtNetwork.QSslPreSharedKeyAuthenticator.swap": ('PySide2.QtNetwork.QSslPreSharedKeyAuthenticator',),

# class PySide2.QtNetwork.QSslSocket:

# class PySide2.QtNetwork.QSslSocket.PeerVerifyMode:

# class PySide2.QtNetwork.QSslSocket.SslMode:
    "PySide2.QtNetwork.QSslSocket.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QSslSocket.abort": (),
    "PySide2.QtNetwork.QSslSocket.addCaCertificate": ('PySide2.QtNetwork.QSslCertificate',),
    "PySide2.QtNetwork.QSslSocket.addCaCertificates": [('str', 'PySide2.QtNetwork.QSsl.EncodingFormat', 'PySide2.QtCore.QRegExp.PatternSyntax'), ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',)],
    "PySide2.QtNetwork.QSslSocket.addDefaultCaCertificate": ('PySide2.QtNetwork.QSslCertificate',),
    "PySide2.QtNetwork.QSslSocket.addDefaultCaCertificates": [('str', 'PySide2.QtNetwork.QSsl.EncodingFormat', 'PySide2.QtCore.QRegExp.PatternSyntax'), ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',)],
    "PySide2.QtNetwork.QSslSocket.atEnd": (),
    "PySide2.QtNetwork.QSslSocket.bytesAvailable": (),
    "PySide2.QtNetwork.QSslSocket.bytesToWrite": (),
    "PySide2.QtNetwork.QSslSocket.caCertificates": (),
    "PySide2.QtNetwork.QSslSocket.canReadLine": (),
    "PySide2.QtNetwork.QSslSocket.ciphers": (),
    "PySide2.QtNetwork.QSslSocket.close": (),
    "PySide2.QtNetwork.QSslSocket.connectToHost": [('PySide2.QtNetwork.QHostAddress', 'int', 'PySide2.QtCore.QIODevice.OpenMode'), ('str', 'int', 'PySide2.QtCore.QIODevice.OpenMode', 'PySide2.QtNetwork.QAbstractSocket.NetworkLayerProtocol')],
    "PySide2.QtNetwork.QSslSocket.connectToHostEncrypted": [('str', 'int', 'PySide2.QtCore.QIODevice.OpenMode', 'PySide2.QtNetwork.QAbstractSocket.NetworkLayerProtocol'), ('str', 'int', 'str', 'PySide2.QtCore.QIODevice.OpenMode', 'PySide2.QtNetwork.QAbstractSocket.NetworkLayerProtocol')],
    "PySide2.QtNetwork.QSslSocket.defaultCaCertificates": (),
    "PySide2.QtNetwork.QSslSocket.defaultCiphers": (),
    "PySide2.QtNetwork.QSslSocket.disconnectFromHost": (),
    "PySide2.QtNetwork.QSslSocket.encryptedBytesAvailable": (),
    "PySide2.QtNetwork.QSslSocket.encryptedBytesToWrite": (),
    "PySide2.QtNetwork.QSslSocket.flush": (),
    "PySide2.QtNetwork.QSslSocket.ignoreSslErrors": [(), ('typing.Sequence[PySide2.QtNetwork.QSslError]',)],
    "PySide2.QtNetwork.QSslSocket.isEncrypted": (),
    "PySide2.QtNetwork.QSslSocket.localCertificate": (),
    "PySide2.QtNetwork.QSslSocket.localCertificateChain": (),
    "PySide2.QtNetwork.QSslSocket.mode": (),
    "PySide2.QtNetwork.QSslSocket.ocspResponses": (),
    "PySide2.QtNetwork.QSslSocket.peerCertificate": (),
    "PySide2.QtNetwork.QSslSocket.peerCertificateChain": (),
    "PySide2.QtNetwork.QSslSocket.peerVerifyDepth": (),
    "PySide2.QtNetwork.QSslSocket.peerVerifyMode": (),
    "PySide2.QtNetwork.QSslSocket.peerVerifyName": (),
    "PySide2.QtNetwork.QSslSocket.privateKey": (),
    "PySide2.QtNetwork.QSslSocket.protocol": (),
    "PySide2.QtNetwork.QSslSocket.readData": ('str', 'int'),
    "PySide2.QtNetwork.QSslSocket.resume": (),
    "PySide2.QtNetwork.QSslSocket.sessionCipher": (),
    "PySide2.QtNetwork.QSslSocket.sessionProtocol": (),
    "PySide2.QtNetwork.QSslSocket.setCaCertificates": ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',),
    "PySide2.QtNetwork.QSslSocket.setCiphers": [('str',), ('typing.Sequence[PySide2.QtNetwork.QSslCipher]',)],
    "PySide2.QtNetwork.QSslSocket.setDefaultCaCertificates": ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',),
    "PySide2.QtNetwork.QSslSocket.setDefaultCiphers": ('typing.Sequence[PySide2.QtNetwork.QSslCipher]',),
    "PySide2.QtNetwork.QSslSocket.setLocalCertificate": [('PySide2.QtNetwork.QSslCertificate',), ('str', 'PySide2.QtNetwork.QSsl.EncodingFormat')],
    "PySide2.QtNetwork.QSslSocket.setLocalCertificateChain": ('typing.Sequence[PySide2.QtNetwork.QSslCertificate]',),
    "PySide2.QtNetwork.QSslSocket.setPeerVerifyDepth": ('int',),
    "PySide2.QtNetwork.QSslSocket.setPeerVerifyMode": ('PySide2.QtNetwork.QSslSocket.PeerVerifyMode',),
    "PySide2.QtNetwork.QSslSocket.setPeerVerifyName": ('str',),
    "PySide2.QtNetwork.QSslSocket.setPrivateKey": [('PySide2.QtNetwork.QSslKey',), ('str', 'PySide2.QtNetwork.QSsl.KeyAlgorithm', 'PySide2.QtNetwork.QSsl.EncodingFormat', 'PySide2.QtCore.QByteArray')],
    "PySide2.QtNetwork.QSslSocket.setProtocol": ('PySide2.QtNetwork.QSsl.SslProtocol',),
    "PySide2.QtNetwork.QSslSocket.setReadBufferSize": ('int',),
    "PySide2.QtNetwork.QSslSocket.setSocketDescriptor": ('int', 'PySide2.QtNetwork.QAbstractSocket.SocketState', 'PySide2.QtCore.QIODevice.OpenMode'),
    "PySide2.QtNetwork.QSslSocket.setSocketOption": ('PySide2.QtNetwork.QAbstractSocket.SocketOption', 'typing.Any'),
    "PySide2.QtNetwork.QSslSocket.setSslConfiguration": ('PySide2.QtNetwork.QSslConfiguration',),
    "PySide2.QtNetwork.QSslSocket.socketOption": ('PySide2.QtNetwork.QAbstractSocket.SocketOption',),
    "PySide2.QtNetwork.QSslSocket.sslConfiguration": (),
    "PySide2.QtNetwork.QSslSocket.sslErrors": (),
    "PySide2.QtNetwork.QSslSocket.sslLibraryBuildVersionNumber": (),
    "PySide2.QtNetwork.QSslSocket.sslLibraryBuildVersionString": (),
    "PySide2.QtNetwork.QSslSocket.sslLibraryVersionNumber": (),
    "PySide2.QtNetwork.QSslSocket.sslLibraryVersionString": (),
    "PySide2.QtNetwork.QSslSocket.startClientEncryption": (),
    "PySide2.QtNetwork.QSslSocket.startServerEncryption": (),
    "PySide2.QtNetwork.QSslSocket.supportedCiphers": (),
    "PySide2.QtNetwork.QSslSocket.supportsSsl": (),
    "PySide2.QtNetwork.QSslSocket.systemCaCertificates": (),
    "PySide2.QtNetwork.QSslSocket.waitForBytesWritten": ('int',),
    "PySide2.QtNetwork.QSslSocket.waitForConnected": ('int',),
    "PySide2.QtNetwork.QSslSocket.waitForDisconnected": ('int',),
    "PySide2.QtNetwork.QSslSocket.waitForEncrypted": ('int',),
    "PySide2.QtNetwork.QSslSocket.waitForReadyRead": ('int',),
    "PySide2.QtNetwork.QSslSocket.writeData": ('str', 'int'),

# class PySide2.QtNetwork.QTcpServer:
    "PySide2.QtNetwork.QTcpServer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QTcpServer.addPendingConnection": ('PySide2.QtNetwork.QTcpSocket',),
    "PySide2.QtNetwork.QTcpServer.close": (),
    "PySide2.QtNetwork.QTcpServer.errorString": (),
    "PySide2.QtNetwork.QTcpServer.hasPendingConnections": (),
    "PySide2.QtNetwork.QTcpServer.incomingConnection": ('int',),
    "PySide2.QtNetwork.QTcpServer.isListening": (),
    "PySide2.QtNetwork.QTcpServer.listen": ('PySide2.QtNetwork.QHostAddress', 'int'),
    "PySide2.QtNetwork.QTcpServer.maxPendingConnections": (),
    "PySide2.QtNetwork.QTcpServer.nextPendingConnection": (),
    "PySide2.QtNetwork.QTcpServer.pauseAccepting": (),
    "PySide2.QtNetwork.QTcpServer.proxy": (),
    "PySide2.QtNetwork.QTcpServer.resumeAccepting": (),
    "PySide2.QtNetwork.QTcpServer.serverAddress": (),
    "PySide2.QtNetwork.QTcpServer.serverError": (),
    "PySide2.QtNetwork.QTcpServer.serverPort": (),
    "PySide2.QtNetwork.QTcpServer.setMaxPendingConnections": ('int',),
    "PySide2.QtNetwork.QTcpServer.setProxy": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtNetwork.QTcpServer.setSocketDescriptor": ('int',),
    "PySide2.QtNetwork.QTcpServer.socketDescriptor": (),
    "PySide2.QtNetwork.QTcpServer.waitForNewConnection": ('int',),

# class PySide2.QtNetwork.QTcpSocket:
    "PySide2.QtNetwork.QTcpSocket.__init__": ('PySide2.QtCore.QObject',),

# class PySide2.QtNetwork.QUdpSocket:
    "PySide2.QtNetwork.QUdpSocket.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtNetwork.QUdpSocket.hasPendingDatagrams": (),
    "PySide2.QtNetwork.QUdpSocket.joinMulticastGroup": [('PySide2.QtNetwork.QHostAddress',), ('PySide2.QtNetwork.QHostAddress', 'PySide2.QtNetwork.QNetworkInterface')],
    "PySide2.QtNetwork.QUdpSocket.leaveMulticastGroup": [('PySide2.QtNetwork.QHostAddress',), ('PySide2.QtNetwork.QHostAddress', 'PySide2.QtNetwork.QNetworkInterface')],
    "PySide2.QtNetwork.QUdpSocket.multicastInterface": (),
    "PySide2.QtNetwork.QUdpSocket.pendingDatagramSize": (),
    "PySide2.QtNetwork.QUdpSocket.readDatagram": ('str', 'int', 'PySide2.QtNetwork.QHostAddress'),
    "PySide2.QtNetwork.QUdpSocket.receiveDatagram": ('int',),
    "PySide2.QtNetwork.QUdpSocket.setMulticastInterface": ('PySide2.QtNetwork.QNetworkInterface',),
    "PySide2.QtNetwork.QUdpSocket.writeDatagram": [('PySide2.QtCore.QByteArray', 'PySide2.QtNetwork.QHostAddress', 'int'), ('PySide2.QtNetwork.QNetworkDatagram',)],
    }) if "PySide2.QtNetwork" in sys.modules else None

# Module PySide2.QtTest
sig_dict.update({

# class PySide2.QtTest.QTest:

# class PySide2.QtTest.QTest.KeyAction:

# class PySide2.QtTest.QTest.MouseAction:

# class PySide2.QtTest.QTest.QBenchmarkMetric:

# class PySide2.QtTest.QTest.QTouchEventSequence:
    "PySide2.QtTest.QTest.QTouchEventSequence.commit": ('bool',),
    "PySide2.QtTest.QTest.QTouchEventSequence.move": [('int', 'PySide2.QtCore.QPoint', 'PySide2.QtGui.QWindow'), ('int', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtTest.QTest.QTouchEventSequence.press": [('int', 'PySide2.QtCore.QPoint', 'PySide2.QtGui.QWindow'), ('int', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtTest.QTest.QTouchEventSequence.release": [('int', 'PySide2.QtCore.QPoint', 'PySide2.QtGui.QWindow'), ('int', 'PySide2.QtCore.QPoint', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtTest.QTest.QTouchEventSequence.stationary": ('int',),

# class PySide2.QtTest.QTest.TestFailMode:

    "PySide2.QtTest.QTest.addColumnInternal": ('int', 'str'),
    "PySide2.QtTest.QTest.asciiToKey": ('typing.Char',),
    "PySide2.QtTest.QTest.compare_ptr_helper": ('int', 'int', 'str', 'str', 'str', 'int'),
    "PySide2.QtTest.QTest.compare_string_helper": ('str', 'str', 'str', 'str', 'str', 'int'),
    "PySide2.QtTest.QTest.createTouchDevice": ('PySide2.QtGui.QTouchDevice.DeviceType',),
    "PySide2.QtTest.QTest.currentAppName": (),
    "PySide2.QtTest.QTest.currentDataTag": (),
    "PySide2.QtTest.QTest.currentTestFailed": (),
    "PySide2.QtTest.QTest.currentTestFunction": (),
    "PySide2.QtTest.QTest.ignoreMessage": [('PySide2.QtCore.QtMsgType', 'PySide2.QtCore.QRegularExpression'), ('PySide2.QtCore.QtMsgType', 'str')],
    "PySide2.QtTest.QTest.keyClick": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtGui.QWindow', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtWidgets.QWidget', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int')],
    "PySide2.QtTest.QTest.keyClicks": ('PySide2.QtWidgets.QWidget', 'str', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'),
    "PySide2.QtTest.QTest.keyEvent": [('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtGui.QWindow', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtWidgets.QWidget', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int')],
    "PySide2.QtTest.QTest.keyPress": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtGui.QWindow', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtWidgets.QWidget', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int')],
    "PySide2.QtTest.QTest.keyRelease": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtGui.QWindow', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Key', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtWidgets.QWidget', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int')],
    "PySide2.QtTest.QTest.keySequence": [('PySide2.QtGui.QWindow', 'PySide2.QtGui.QKeySequence'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QKeySequence')],
    "PySide2.QtTest.QTest.keyToAscii": ('PySide2.QtCore.Qt.Key',),
    "PySide2.QtTest.QTest.mouseClick": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int')],
    "PySide2.QtTest.QTest.mouseDClick": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int')],
    "PySide2.QtTest.QTest.mouseEvent": [('PySide2.QtTest.QTest.MouseAction', 'PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int'), ('PySide2.QtTest.QTest.MouseAction', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int')],
    "PySide2.QtTest.QTest.mouseMove": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.QPoint', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.QPoint', 'int')],
    "PySide2.QtTest.QTest.mousePress": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int')],
    "PySide2.QtTest.QTest.mouseRelease": [('PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.MouseButton', 'PySide2.QtCore.Qt.KeyboardModifiers', 'PySide2.QtCore.QPoint', 'int')],
    "PySide2.QtTest.QTest.qCleanup": (),
    "PySide2.QtTest.QTest.qElementData": ('str', 'int'),
    "PySide2.QtTest.QTest.qExpectFail": ('str', 'str', 'PySide2.QtTest.QTest.TestFailMode', 'str', 'int'),
    "PySide2.QtTest.QTest.qFindTestData": ('str', 'str', 'int', 'str'),
    "PySide2.QtTest.QTest.qGlobalData": ('str', 'int'),
    "PySide2.QtTest.QTest.qRun": (),
    "PySide2.QtTest.QTest.qSkip": ('str', 'str', 'int'),
    "PySide2.QtTest.QTest.qWaitForWindowActive": ('PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtTest.QTest.qWaitForWindowExposed": ('PySide2.QtWidgets.QWidget', 'int'),
    "PySide2.QtTest.QTest.sendKeyEvent": [('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.Key', 'str', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtGui.QWindow', 'PySide2.QtCore.Qt.Key', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Key', 'str', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int'), ('PySide2.QtTest.QTest.KeyAction', 'PySide2.QtWidgets.QWidget', 'PySide2.QtCore.Qt.Key', 'typing.Char', 'PySide2.QtCore.Qt.KeyboardModifiers', 'int')],
    "PySide2.QtTest.QTest.setBenchmarkResult": ('float', 'PySide2.QtTest.QTest.QBenchmarkMetric'),
    "PySide2.QtTest.QTest.setMainSourcePath": ('str', 'str'),
    "PySide2.QtTest.QTest.simulateEvent": [('PySide2.QtGui.QWindow', 'bool', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'str', 'bool', 'int'), ('PySide2.QtWidgets.QWidget', 'bool', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'str', 'bool', 'int')],
    "PySide2.QtTest.QTest.testObject": (),
    "PySide2.QtTest.QTest.toPrettyCString": ('str', 'int'),
    "PySide2.QtTest.QTest.touchEvent": [('PySide2.QtGui.QWindow', 'PySide2.QtGui.QTouchDevice', 'bool'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtGui.QTouchDevice', 'bool')],
    }) if "PySide2.QtTest" in sys.modules else None

# Module PySide2.QtConcurrent
sig_dict.update({

# class PySide2.QtConcurrent.QtConcurrent:

# class PySide2.QtConcurrent.QtConcurrent.ReduceOption:

# class PySide2.QtConcurrent.QtConcurrent.ReduceOptions:

# class PySide2.QtConcurrent.QtConcurrent.ThreadFunctionResult:
    }) if "PySide2.QtConcurrent" in sys.modules else None

# Module PySide2.QtMacExtras
sig_dict.update({

# class PySide2.QtMacExtras.QMacPasteboardMime:

# class PySide2.QtMacExtras.QMacPasteboardMime.QMacPasteboardMimeType:
    "PySide2.QtMacExtras.QMacPasteboardMime.__init__": ('typing.Char',),
    "PySide2.QtMacExtras.QMacPasteboardMime.canConvert": ('str', 'str'),
    "PySide2.QtMacExtras.QMacPasteboardMime.convertFromMime": ('str', 'typing.Any', 'str'),
    "PySide2.QtMacExtras.QMacPasteboardMime.convertToMime": ('str', 'typing.Sequence[PySide2.QtCore.QByteArray]', 'str'),
    "PySide2.QtMacExtras.QMacPasteboardMime.convertorName": (),
    "PySide2.QtMacExtras.QMacPasteboardMime.count": ('PySide2.QtCore.QMimeData',),
    "PySide2.QtMacExtras.QMacPasteboardMime.flavorFor": ('str',),
    "PySide2.QtMacExtras.QMacPasteboardMime.mimeFor": ('str',),

# class PySide2.QtMacExtras.QMacToolBar:
    "PySide2.QtMacExtras.QMacToolBar.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtMacExtras.QMacToolBar.addAllowedItem": ('PySide2.QtGui.QIcon', 'str'),
    "PySide2.QtMacExtras.QMacToolBar.addAllowedStandardItem": ('PySide2.QtMacExtras.QMacToolBarItem.StandardItem',),
    "PySide2.QtMacExtras.QMacToolBar.addItem": ('PySide2.QtGui.QIcon', 'str'),
    "PySide2.QtMacExtras.QMacToolBar.addSeparator": (),
    "PySide2.QtMacExtras.QMacToolBar.addStandardItem": ('PySide2.QtMacExtras.QMacToolBarItem.StandardItem',),
    "PySide2.QtMacExtras.QMacToolBar.allowedItems": (),
    "PySide2.QtMacExtras.QMacToolBar.attachToWindow": ('PySide2.QtGui.QWindow',),
    "PySide2.QtMacExtras.QMacToolBar.detachFromWindow": (),
    "PySide2.QtMacExtras.QMacToolBar.items": (),
    "PySide2.QtMacExtras.QMacToolBar.setAllowedItems": ('typing.Sequence[PySide2.QtMacExtras.QMacToolBarItem]',),
    "PySide2.QtMacExtras.QMacToolBar.setItems": ('typing.Sequence[PySide2.QtMacExtras.QMacToolBarItem]',),

# class PySide2.QtMacExtras.QMacToolBarItem:

# class PySide2.QtMacExtras.QMacToolBarItem.StandardItem:
    "PySide2.QtMacExtras.QMacToolBarItem.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMacExtras.QMacToolBarItem.icon": (),
    "PySide2.QtMacExtras.QMacToolBarItem.selectable": (),
    "PySide2.QtMacExtras.QMacToolBarItem.setIcon": ('PySide2.QtGui.QIcon',),
    "PySide2.QtMacExtras.QMacToolBarItem.setSelectable": ('bool',),
    "PySide2.QtMacExtras.QMacToolBarItem.setStandardItem": ('PySide2.QtMacExtras.QMacToolBarItem.StandardItem',),
    "PySide2.QtMacExtras.QMacToolBarItem.setText": ('str',),
    "PySide2.QtMacExtras.QMacToolBarItem.standardItem": (),
    "PySide2.QtMacExtras.QMacToolBarItem.text": (),

    "PySide2.QtMacExtras.QMacToolBarItem.qRegisterDraggedTypes": ('typing.Sequence[str]',),
    }) if "PySide2.QtMacExtras" in sys.modules else None

# Module PySide2.QtXml
sig_dict.update({

# class PySide2.QtXml.QDomAttr:
    "PySide2.QtXml.QDomAttr.__init__": [(), ('PySide2.QtXml.QDomAttr',)],
    "PySide2.QtXml.QDomAttr.__copy__": (),
    "PySide2.QtXml.QDomAttr.name": (),
    "PySide2.QtXml.QDomAttr.nodeType": (),
    "PySide2.QtXml.QDomAttr.ownerElement": (),
    "PySide2.QtXml.QDomAttr.setValue": ('str',),
    "PySide2.QtXml.QDomAttr.specified": (),
    "PySide2.QtXml.QDomAttr.value": (),

# class PySide2.QtXml.QDomCDATASection:
    "PySide2.QtXml.QDomCDATASection.__init__": [(), ('PySide2.QtXml.QDomCDATASection',)],
    "PySide2.QtXml.QDomCDATASection.__copy__": (),
    "PySide2.QtXml.QDomCDATASection.nodeType": (),

# class PySide2.QtXml.QDomCharacterData:
    "PySide2.QtXml.QDomCharacterData.__init__": [(), ('PySide2.QtXml.QDomCharacterData',)],
    "PySide2.QtXml.QDomCharacterData.__copy__": (),
    "PySide2.QtXml.QDomCharacterData.appendData": ('str',),
    "PySide2.QtXml.QDomCharacterData.data": (),
    "PySide2.QtXml.QDomCharacterData.deleteData": ('int', 'int'),
    "PySide2.QtXml.QDomCharacterData.insertData": ('int', 'str'),
    "PySide2.QtXml.QDomCharacterData.length": (),
    "PySide2.QtXml.QDomCharacterData.nodeType": (),
    "PySide2.QtXml.QDomCharacterData.replaceData": ('int', 'int', 'str'),
    "PySide2.QtXml.QDomCharacterData.setData": ('str',),
    "PySide2.QtXml.QDomCharacterData.substringData": ('int', 'int'),

# class PySide2.QtXml.QDomComment:
    "PySide2.QtXml.QDomComment.__init__": [(), ('PySide2.QtXml.QDomComment',)],
    "PySide2.QtXml.QDomComment.__copy__": (),
    "PySide2.QtXml.QDomComment.nodeType": (),

# class PySide2.QtXml.QDomDocument:
    "PySide2.QtXml.QDomDocument.__init__": [(), ('PySide2.QtXml.QDomDocument',), ('PySide2.QtXml.QDomDocumentType',), ('str',)],
    "PySide2.QtXml.QDomDocument.__copy__": (),
    "PySide2.QtXml.QDomDocument.createAttribute": ('str',),
    "PySide2.QtXml.QDomDocument.createAttributeNS": ('str', 'str'),
    "PySide2.QtXml.QDomDocument.createCDATASection": ('str',),
    "PySide2.QtXml.QDomDocument.createComment": ('str',),
    "PySide2.QtXml.QDomDocument.createDocumentFragment": (),
    "PySide2.QtXml.QDomDocument.createElement": ('str',),
    "PySide2.QtXml.QDomDocument.createElementNS": ('str', 'str'),
    "PySide2.QtXml.QDomDocument.createEntityReference": ('str',),
    "PySide2.QtXml.QDomDocument.createProcessingInstruction": ('str', 'str'),
    "PySide2.QtXml.QDomDocument.createTextNode": ('str',),
    "PySide2.QtXml.QDomDocument.doctype": (),
    "PySide2.QtXml.QDomDocument.documentElement": (),
    "PySide2.QtXml.QDomDocument.elementById": ('str',),
    "PySide2.QtXml.QDomDocument.elementsByTagName": ('str',),
    "PySide2.QtXml.QDomDocument.elementsByTagNameNS": ('str', 'str'),
    "PySide2.QtXml.QDomDocument.implementation": (),
    "PySide2.QtXml.QDomDocument.importNode": ('PySide2.QtXml.QDomNode', 'bool'),
    "PySide2.QtXml.QDomDocument.nodeType": (),
    "PySide2.QtXml.QDomDocument.setContent": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QByteArray', 'bool'), ('PySide2.QtCore.QIODevice',), ('PySide2.QtCore.QIODevice', 'bool'), ('PySide2.QtXml.QXmlInputSource', 'PySide2.QtXml.QXmlReader'), ('PySide2.QtXml.QXmlInputSource', 'bool'), ('str',), ('str', 'bool')],
    "PySide2.QtXml.QDomDocument.toByteArray": ('int',),
    "PySide2.QtXml.QDomDocument.toString": ('int',),

# class PySide2.QtXml.QDomDocumentFragment:
    "PySide2.QtXml.QDomDocumentFragment.__init__": [(), ('PySide2.QtXml.QDomDocumentFragment',)],
    "PySide2.QtXml.QDomDocumentFragment.__copy__": (),
    "PySide2.QtXml.QDomDocumentFragment.nodeType": (),

# class PySide2.QtXml.QDomDocumentType:
    "PySide2.QtXml.QDomDocumentType.__init__": [(), ('PySide2.QtXml.QDomDocumentType',)],
    "PySide2.QtXml.QDomDocumentType.__copy__": (),
    "PySide2.QtXml.QDomDocumentType.entities": (),
    "PySide2.QtXml.QDomDocumentType.internalSubset": (),
    "PySide2.QtXml.QDomDocumentType.name": (),
    "PySide2.QtXml.QDomDocumentType.nodeType": (),
    "PySide2.QtXml.QDomDocumentType.notations": (),
    "PySide2.QtXml.QDomDocumentType.publicId": (),
    "PySide2.QtXml.QDomDocumentType.systemId": (),

# class PySide2.QtXml.QDomElement:
    "PySide2.QtXml.QDomElement.__init__": [(), ('PySide2.QtXml.QDomElement',)],
    "PySide2.QtXml.QDomElement.__copy__": (),
    "PySide2.QtXml.QDomElement.attribute": ('str', 'str'),
    "PySide2.QtXml.QDomElement.attributeNS": ('str', 'str', 'str'),
    "PySide2.QtXml.QDomElement.attributeNode": ('str',),
    "PySide2.QtXml.QDomElement.attributeNodeNS": ('str', 'str'),
    "PySide2.QtXml.QDomElement.attributes": (),
    "PySide2.QtXml.QDomElement.elementsByTagName": ('str',),
    "PySide2.QtXml.QDomElement.elementsByTagNameNS": ('str', 'str'),
    "PySide2.QtXml.QDomElement.hasAttribute": ('str',),
    "PySide2.QtXml.QDomElement.hasAttributeNS": ('str', 'str'),
    "PySide2.QtXml.QDomElement.nodeType": (),
    "PySide2.QtXml.QDomElement.removeAttribute": ('str',),
    "PySide2.QtXml.QDomElement.removeAttributeNS": ('str', 'str'),
    "PySide2.QtXml.QDomElement.removeAttributeNode": ('PySide2.QtXml.QDomAttr',),
    "PySide2.QtXml.QDomElement.setAttribute": [('str', 'float'), ('str', 'int'), ('str', 'str')],
    "PySide2.QtXml.QDomElement.setAttributeNS": [('str', 'str', 'float'), ('str', 'str', 'int'), ('str', 'str', 'str')],
    "PySide2.QtXml.QDomElement.setAttributeNode": ('PySide2.QtXml.QDomAttr',),
    "PySide2.QtXml.QDomElement.setAttributeNodeNS": ('PySide2.QtXml.QDomAttr',),
    "PySide2.QtXml.QDomElement.setTagName": ('str',),
    "PySide2.QtXml.QDomElement.tagName": (),
    "PySide2.QtXml.QDomElement.text": (),

# class PySide2.QtXml.QDomEntity:
    "PySide2.QtXml.QDomEntity.__init__": [(), ('PySide2.QtXml.QDomEntity',)],
    "PySide2.QtXml.QDomEntity.__copy__": (),
    "PySide2.QtXml.QDomEntity.nodeType": (),
    "PySide2.QtXml.QDomEntity.notationName": (),
    "PySide2.QtXml.QDomEntity.publicId": (),
    "PySide2.QtXml.QDomEntity.systemId": (),

# class PySide2.QtXml.QDomEntityReference:
    "PySide2.QtXml.QDomEntityReference.__init__": [(), ('PySide2.QtXml.QDomEntityReference',)],
    "PySide2.QtXml.QDomEntityReference.__copy__": (),
    "PySide2.QtXml.QDomEntityReference.nodeType": (),

# class PySide2.QtXml.QDomImplementation:

# class PySide2.QtXml.QDomImplementation.InvalidDataPolicy:
    "PySide2.QtXml.QDomImplementation.__init__": [(), ('PySide2.QtXml.QDomImplementation',)],
    "PySide2.QtXml.QDomImplementation.__copy__": (),
    "PySide2.QtXml.QDomImplementation.createDocument": ('str', 'str', 'PySide2.QtXml.QDomDocumentType'),
    "PySide2.QtXml.QDomImplementation.createDocumentType": ('str', 'str', 'str'),
    "PySide2.QtXml.QDomImplementation.hasFeature": ('str', 'str'),
    "PySide2.QtXml.QDomImplementation.invalidDataPolicy": (),
    "PySide2.QtXml.QDomImplementation.isNull": (),
    "PySide2.QtXml.QDomImplementation.setInvalidDataPolicy": ('PySide2.QtXml.QDomImplementation.InvalidDataPolicy',),

# class PySide2.QtXml.QDomNamedNodeMap:
    "PySide2.QtXml.QDomNamedNodeMap.__init__": [(), ('PySide2.QtXml.QDomNamedNodeMap',)],
    "PySide2.QtXml.QDomNamedNodeMap.__copy__": (),
    "PySide2.QtXml.QDomNamedNodeMap.contains": ('str',),
    "PySide2.QtXml.QDomNamedNodeMap.count": (),
    "PySide2.QtXml.QDomNamedNodeMap.isEmpty": (),
    "PySide2.QtXml.QDomNamedNodeMap.item": ('int',),
    "PySide2.QtXml.QDomNamedNodeMap.length": (),
    "PySide2.QtXml.QDomNamedNodeMap.namedItem": ('str',),
    "PySide2.QtXml.QDomNamedNodeMap.namedItemNS": ('str', 'str'),
    "PySide2.QtXml.QDomNamedNodeMap.removeNamedItem": ('str',),
    "PySide2.QtXml.QDomNamedNodeMap.removeNamedItemNS": ('str', 'str'),
    "PySide2.QtXml.QDomNamedNodeMap.setNamedItem": ('PySide2.QtXml.QDomNode',),
    "PySide2.QtXml.QDomNamedNodeMap.setNamedItemNS": ('PySide2.QtXml.QDomNode',),
    "PySide2.QtXml.QDomNamedNodeMap.size": (),

# class PySide2.QtXml.QDomNode:

# class PySide2.QtXml.QDomNode.EncodingPolicy:

# class PySide2.QtXml.QDomNode.NodeType:
    "PySide2.QtXml.QDomNode.__init__": [(), ('PySide2.QtXml.QDomNode',)],
    "PySide2.QtXml.QDomNode.__copy__": (),
    "PySide2.QtXml.QDomNode.__lshift__": ('PySide2.QtCore.QTextStream',),
    "PySide2.QtXml.QDomNode.appendChild": ('PySide2.QtXml.QDomNode',),
    "PySide2.QtXml.QDomNode.attributes": (),
    "PySide2.QtXml.QDomNode.childNodes": (),
    "PySide2.QtXml.QDomNode.clear": (),
    "PySide2.QtXml.QDomNode.cloneNode": ('bool',),
    "PySide2.QtXml.QDomNode.columnNumber": (),
    "PySide2.QtXml.QDomNode.firstChild": (),
    "PySide2.QtXml.QDomNode.firstChildElement": ('str',),
    "PySide2.QtXml.QDomNode.hasAttributes": (),
    "PySide2.QtXml.QDomNode.hasChildNodes": (),
    "PySide2.QtXml.QDomNode.insertAfter": ('PySide2.QtXml.QDomNode', 'PySide2.QtXml.QDomNode'),
    "PySide2.QtXml.QDomNode.insertBefore": ('PySide2.QtXml.QDomNode', 'PySide2.QtXml.QDomNode'),
    "PySide2.QtXml.QDomNode.isAttr": (),
    "PySide2.QtXml.QDomNode.isCDATASection": (),
    "PySide2.QtXml.QDomNode.isCharacterData": (),
    "PySide2.QtXml.QDomNode.isComment": (),
    "PySide2.QtXml.QDomNode.isDocument": (),
    "PySide2.QtXml.QDomNode.isDocumentFragment": (),
    "PySide2.QtXml.QDomNode.isDocumentType": (),
    "PySide2.QtXml.QDomNode.isElement": (),
    "PySide2.QtXml.QDomNode.isEntity": (),
    "PySide2.QtXml.QDomNode.isEntityReference": (),
    "PySide2.QtXml.QDomNode.isNotation": (),
    "PySide2.QtXml.QDomNode.isNull": (),
    "PySide2.QtXml.QDomNode.isProcessingInstruction": (),
    "PySide2.QtXml.QDomNode.isSupported": ('str', 'str'),
    "PySide2.QtXml.QDomNode.isText": (),
    "PySide2.QtXml.QDomNode.lastChild": (),
    "PySide2.QtXml.QDomNode.lastChildElement": ('str',),
    "PySide2.QtXml.QDomNode.lineNumber": (),
    "PySide2.QtXml.QDomNode.localName": (),
    "PySide2.QtXml.QDomNode.namedItem": ('str',),
    "PySide2.QtXml.QDomNode.namespaceURI": (),
    "PySide2.QtXml.QDomNode.nextSibling": (),
    "PySide2.QtXml.QDomNode.nextSiblingElement": ('str',),
    "PySide2.QtXml.QDomNode.nodeName": (),
    "PySide2.QtXml.QDomNode.nodeType": (),
    "PySide2.QtXml.QDomNode.nodeValue": (),
    "PySide2.QtXml.QDomNode.normalize": (),
    "PySide2.QtXml.QDomNode.ownerDocument": (),
    "PySide2.QtXml.QDomNode.parentNode": (),
    "PySide2.QtXml.QDomNode.prefix": (),
    "PySide2.QtXml.QDomNode.previousSibling": (),
    "PySide2.QtXml.QDomNode.previousSiblingElement": ('str',),
    "PySide2.QtXml.QDomNode.removeChild": ('PySide2.QtXml.QDomNode',),
    "PySide2.QtXml.QDomNode.replaceChild": ('PySide2.QtXml.QDomNode', 'PySide2.QtXml.QDomNode'),
    "PySide2.QtXml.QDomNode.save": ('PySide2.QtCore.QTextStream', 'int', 'PySide2.QtXml.QDomNode.EncodingPolicy'),
    "PySide2.QtXml.QDomNode.setNodeValue": ('str',),
    "PySide2.QtXml.QDomNode.setPrefix": ('str',),
    "PySide2.QtXml.QDomNode.toAttr": (),
    "PySide2.QtXml.QDomNode.toCDATASection": (),
    "PySide2.QtXml.QDomNode.toCharacterData": (),
    "PySide2.QtXml.QDomNode.toComment": (),
    "PySide2.QtXml.QDomNode.toDocument": (),
    "PySide2.QtXml.QDomNode.toDocumentFragment": (),
    "PySide2.QtXml.QDomNode.toDocumentType": (),
    "PySide2.QtXml.QDomNode.toElement": (),
    "PySide2.QtXml.QDomNode.toEntity": (),
    "PySide2.QtXml.QDomNode.toEntityReference": (),
    "PySide2.QtXml.QDomNode.toNotation": (),
    "PySide2.QtXml.QDomNode.toProcessingInstruction": (),
    "PySide2.QtXml.QDomNode.toText": (),

# class PySide2.QtXml.QDomNodeList:
    "PySide2.QtXml.QDomNodeList.__init__": [(), ('PySide2.QtXml.QDomNodeList',)],
    "PySide2.QtXml.QDomNodeList.__copy__": (),
    "PySide2.QtXml.QDomNodeList.at": ('int',),
    "PySide2.QtXml.QDomNodeList.count": (),
    "PySide2.QtXml.QDomNodeList.isEmpty": (),
    "PySide2.QtXml.QDomNodeList.item": ('int',),
    "PySide2.QtXml.QDomNodeList.length": (),
    "PySide2.QtXml.QDomNodeList.size": (),

# class PySide2.QtXml.QDomNotation:
    "PySide2.QtXml.QDomNotation.__init__": [(), ('PySide2.QtXml.QDomNotation',)],
    "PySide2.QtXml.QDomNotation.__copy__": (),
    "PySide2.QtXml.QDomNotation.nodeType": (),
    "PySide2.QtXml.QDomNotation.publicId": (),
    "PySide2.QtXml.QDomNotation.systemId": (),

# class PySide2.QtXml.QDomProcessingInstruction:
    "PySide2.QtXml.QDomProcessingInstruction.__init__": [(), ('PySide2.QtXml.QDomProcessingInstruction',)],
    "PySide2.QtXml.QDomProcessingInstruction.__copy__": (),
    "PySide2.QtXml.QDomProcessingInstruction.data": (),
    "PySide2.QtXml.QDomProcessingInstruction.nodeType": (),
    "PySide2.QtXml.QDomProcessingInstruction.setData": ('str',),
    "PySide2.QtXml.QDomProcessingInstruction.target": (),

# class PySide2.QtXml.QDomText:
    "PySide2.QtXml.QDomText.__init__": [(), ('PySide2.QtXml.QDomText',)],
    "PySide2.QtXml.QDomText.__copy__": (),
    "PySide2.QtXml.QDomText.nodeType": (),
    "PySide2.QtXml.QDomText.splitText": ('int',),

# class PySide2.QtXml.QXmlAttributes:
    "PySide2.QtXml.QXmlAttributes.__init__": [(), ('PySide2.QtXml.QXmlAttributes',)],
    "PySide2.QtXml.QXmlAttributes.__copy__": (),
    "PySide2.QtXml.QXmlAttributes.append": ('str', 'str', 'str', 'str'),
    "PySide2.QtXml.QXmlAttributes.clear": (),
    "PySide2.QtXml.QXmlAttributes.count": (),
    "PySide2.QtXml.QXmlAttributes.index": [('str',), ('str', 'str')],
    "PySide2.QtXml.QXmlAttributes.length": (),
    "PySide2.QtXml.QXmlAttributes.localName": ('int',),
    "PySide2.QtXml.QXmlAttributes.qName": ('int',),
    "PySide2.QtXml.QXmlAttributes.swap": ('PySide2.QtXml.QXmlAttributes',),
    "PySide2.QtXml.QXmlAttributes.type": [('int',), ('str',), ('str', 'str')],
    "PySide2.QtXml.QXmlAttributes.uri": ('int',),
    "PySide2.QtXml.QXmlAttributes.value": [('int',), ('str',), ('str', 'str')],

# class PySide2.QtXml.QXmlContentHandler:
    "PySide2.QtXml.QXmlContentHandler.__init__": (),
    "PySide2.QtXml.QXmlContentHandler.characters": ('str',),
    "PySide2.QtXml.QXmlContentHandler.endDocument": (),
    "PySide2.QtXml.QXmlContentHandler.endElement": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlContentHandler.endPrefixMapping": ('str',),
    "PySide2.QtXml.QXmlContentHandler.errorString": (),
    "PySide2.QtXml.QXmlContentHandler.ignorableWhitespace": ('str',),
    "PySide2.QtXml.QXmlContentHandler.processingInstruction": ('str', 'str'),
    "PySide2.QtXml.QXmlContentHandler.setDocumentLocator": ('PySide2.QtXml.QXmlLocator',),
    "PySide2.QtXml.QXmlContentHandler.skippedEntity": ('str',),
    "PySide2.QtXml.QXmlContentHandler.startDocument": (),
    "PySide2.QtXml.QXmlContentHandler.startElement": ('str', 'str', 'str', 'PySide2.QtXml.QXmlAttributes'),
    "PySide2.QtXml.QXmlContentHandler.startPrefixMapping": ('str', 'str'),

# class PySide2.QtXml.QXmlDTDHandler:
    "PySide2.QtXml.QXmlDTDHandler.__init__": (),
    "PySide2.QtXml.QXmlDTDHandler.errorString": (),
    "PySide2.QtXml.QXmlDTDHandler.notationDecl": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlDTDHandler.unparsedEntityDecl": ('str', 'str', 'str', 'str'),

# class PySide2.QtXml.QXmlDeclHandler:
    "PySide2.QtXml.QXmlDeclHandler.__init__": (),
    "PySide2.QtXml.QXmlDeclHandler.attributeDecl": ('str', 'str', 'str', 'str', 'str'),
    "PySide2.QtXml.QXmlDeclHandler.errorString": (),
    "PySide2.QtXml.QXmlDeclHandler.externalEntityDecl": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlDeclHandler.internalEntityDecl": ('str', 'str'),

# class PySide2.QtXml.QXmlDefaultHandler:
    "PySide2.QtXml.QXmlDefaultHandler.__init__": (),
    "PySide2.QtXml.QXmlDefaultHandler.attributeDecl": ('str', 'str', 'str', 'str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.characters": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.comment": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.endCDATA": (),
    "PySide2.QtXml.QXmlDefaultHandler.endDTD": (),
    "PySide2.QtXml.QXmlDefaultHandler.endDocument": (),
    "PySide2.QtXml.QXmlDefaultHandler.endElement": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.endEntity": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.endPrefixMapping": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.error": ('PySide2.QtXml.QXmlParseException',),
    "PySide2.QtXml.QXmlDefaultHandler.errorString": (),
    "PySide2.QtXml.QXmlDefaultHandler.externalEntityDecl": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.fatalError": ('PySide2.QtXml.QXmlParseException',),
    "PySide2.QtXml.QXmlDefaultHandler.ignorableWhitespace": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.internalEntityDecl": ('str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.notationDecl": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.processingInstruction": ('str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.resolveEntity": ('str', 'str', 'PySide2.QtXml.QXmlInputSource'),
    "PySide2.QtXml.QXmlDefaultHandler.setDocumentLocator": ('PySide2.QtXml.QXmlLocator',),
    "PySide2.QtXml.QXmlDefaultHandler.skippedEntity": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.startCDATA": (),
    "PySide2.QtXml.QXmlDefaultHandler.startDTD": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.startDocument": (),
    "PySide2.QtXml.QXmlDefaultHandler.startElement": ('str', 'str', 'str', 'PySide2.QtXml.QXmlAttributes'),
    "PySide2.QtXml.QXmlDefaultHandler.startEntity": ('str',),
    "PySide2.QtXml.QXmlDefaultHandler.startPrefixMapping": ('str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.unparsedEntityDecl": ('str', 'str', 'str', 'str'),
    "PySide2.QtXml.QXmlDefaultHandler.warning": ('PySide2.QtXml.QXmlParseException',),

# class PySide2.QtXml.QXmlEntityResolver:
    "PySide2.QtXml.QXmlEntityResolver.__init__": (),
    "PySide2.QtXml.QXmlEntityResolver.errorString": (),
    "PySide2.QtXml.QXmlEntityResolver.resolveEntity": ('str', 'str', 'PySide2.QtXml.QXmlInputSource'),

# class PySide2.QtXml.QXmlErrorHandler:
    "PySide2.QtXml.QXmlErrorHandler.__init__": (),
    "PySide2.QtXml.QXmlErrorHandler.error": ('PySide2.QtXml.QXmlParseException',),
    "PySide2.QtXml.QXmlErrorHandler.errorString": (),
    "PySide2.QtXml.QXmlErrorHandler.fatalError": ('PySide2.QtXml.QXmlParseException',),
    "PySide2.QtXml.QXmlErrorHandler.warning": ('PySide2.QtXml.QXmlParseException',),

# class PySide2.QtXml.QXmlInputSource:
    "PySide2.QtXml.QXmlInputSource.__init__": [(), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtXml.QXmlInputSource.data": (),
    "PySide2.QtXml.QXmlInputSource.fetchData": (),
    "PySide2.QtXml.QXmlInputSource.fromRawData": ('PySide2.QtCore.QByteArray', 'bool'),
    "PySide2.QtXml.QXmlInputSource.reset": (),
    "PySide2.QtXml.QXmlInputSource.setData": [('PySide2.QtCore.QByteArray',), ('str',)],

# class PySide2.QtXml.QXmlLexicalHandler:
    "PySide2.QtXml.QXmlLexicalHandler.__init__": (),
    "PySide2.QtXml.QXmlLexicalHandler.comment": ('str',),
    "PySide2.QtXml.QXmlLexicalHandler.endCDATA": (),
    "PySide2.QtXml.QXmlLexicalHandler.endDTD": (),
    "PySide2.QtXml.QXmlLexicalHandler.endEntity": ('str',),
    "PySide2.QtXml.QXmlLexicalHandler.errorString": (),
    "PySide2.QtXml.QXmlLexicalHandler.startCDATA": (),
    "PySide2.QtXml.QXmlLexicalHandler.startDTD": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlLexicalHandler.startEntity": ('str',),

# class PySide2.QtXml.QXmlLocator:
    "PySide2.QtXml.QXmlLocator.__init__": (),
    "PySide2.QtXml.QXmlLocator.columnNumber": (),
    "PySide2.QtXml.QXmlLocator.lineNumber": (),

# class PySide2.QtXml.QXmlNamespaceSupport:
    "PySide2.QtXml.QXmlNamespaceSupport.__init__": (),
    "PySide2.QtXml.QXmlNamespaceSupport.popContext": (),
    "PySide2.QtXml.QXmlNamespaceSupport.prefix": ('str',),
    "PySide2.QtXml.QXmlNamespaceSupport.prefixes": [(), ('str',)],
    "PySide2.QtXml.QXmlNamespaceSupport.processName": ('str', 'bool', 'str', 'str'),
    "PySide2.QtXml.QXmlNamespaceSupport.pushContext": (),
    "PySide2.QtXml.QXmlNamespaceSupport.reset": (),
    "PySide2.QtXml.QXmlNamespaceSupport.setPrefix": ('str', 'str'),
    "PySide2.QtXml.QXmlNamespaceSupport.splitName": ('str', 'str', 'str'),
    "PySide2.QtXml.QXmlNamespaceSupport.uri": ('str',),

# class PySide2.QtXml.QXmlParseException:
    "PySide2.QtXml.QXmlParseException.__init__": [('PySide2.QtXml.QXmlParseException',), ('str', 'int', 'int', 'str', 'str')],
    "PySide2.QtXml.QXmlParseException.columnNumber": (),
    "PySide2.QtXml.QXmlParseException.lineNumber": (),
    "PySide2.QtXml.QXmlParseException.message": (),
    "PySide2.QtXml.QXmlParseException.publicId": (),
    "PySide2.QtXml.QXmlParseException.systemId": (),

# class PySide2.QtXml.QXmlReader:
    "PySide2.QtXml.QXmlReader.__init__": (),
    "PySide2.QtXml.QXmlReader.DTDHandler": (),
    "PySide2.QtXml.QXmlReader.contentHandler": (),
    "PySide2.QtXml.QXmlReader.declHandler": (),
    "PySide2.QtXml.QXmlReader.entityResolver": (),
    "PySide2.QtXml.QXmlReader.errorHandler": (),
    "PySide2.QtXml.QXmlReader.feature": ('str',),
    "PySide2.QtXml.QXmlReader.hasFeature": ('str',),
    "PySide2.QtXml.QXmlReader.hasProperty": ('str',),
    "PySide2.QtXml.QXmlReader.lexicalHandler": (),
    "PySide2.QtXml.QXmlReader.parse": ('PySide2.QtXml.QXmlInputSource',),
    "PySide2.QtXml.QXmlReader.property": ('str',),
    "PySide2.QtXml.QXmlReader.setContentHandler": ('PySide2.QtXml.QXmlContentHandler',),
    "PySide2.QtXml.QXmlReader.setDTDHandler": ('PySide2.QtXml.QXmlDTDHandler',),
    "PySide2.QtXml.QXmlReader.setDeclHandler": ('PySide2.QtXml.QXmlDeclHandler',),
    "PySide2.QtXml.QXmlReader.setEntityResolver": ('PySide2.QtXml.QXmlEntityResolver',),
    "PySide2.QtXml.QXmlReader.setErrorHandler": ('PySide2.QtXml.QXmlErrorHandler',),
    "PySide2.QtXml.QXmlReader.setFeature": ('str', 'bool'),
    "PySide2.QtXml.QXmlReader.setLexicalHandler": ('PySide2.QtXml.QXmlLexicalHandler',),
    "PySide2.QtXml.QXmlReader.setProperty": ('str', 'int'),

# class PySide2.QtXml.QXmlSimpleReader:
    "PySide2.QtXml.QXmlSimpleReader.__init__": (),
    "PySide2.QtXml.QXmlSimpleReader.DTDHandler": (),
    "PySide2.QtXml.QXmlSimpleReader.contentHandler": (),
    "PySide2.QtXml.QXmlSimpleReader.declHandler": (),
    "PySide2.QtXml.QXmlSimpleReader.entityResolver": (),
    "PySide2.QtXml.QXmlSimpleReader.errorHandler": (),
    "PySide2.QtXml.QXmlSimpleReader.feature": ('str',),
    "PySide2.QtXml.QXmlSimpleReader.hasFeature": ('str',),
    "PySide2.QtXml.QXmlSimpleReader.hasProperty": ('str',),
    "PySide2.QtXml.QXmlSimpleReader.lexicalHandler": (),
    "PySide2.QtXml.QXmlSimpleReader.parse": [('PySide2.QtXml.QXmlInputSource',), ('PySide2.QtXml.QXmlInputSource', 'bool')],
    "PySide2.QtXml.QXmlSimpleReader.parseContinue": (),
    "PySide2.QtXml.QXmlSimpleReader.property": ('str',),
    "PySide2.QtXml.QXmlSimpleReader.setContentHandler": ('PySide2.QtXml.QXmlContentHandler',),
    "PySide2.QtXml.QXmlSimpleReader.setDTDHandler": ('PySide2.QtXml.QXmlDTDHandler',),
    "PySide2.QtXml.QXmlSimpleReader.setDeclHandler": ('PySide2.QtXml.QXmlDeclHandler',),
    "PySide2.QtXml.QXmlSimpleReader.setEntityResolver": ('PySide2.QtXml.QXmlEntityResolver',),
    "PySide2.QtXml.QXmlSimpleReader.setErrorHandler": ('PySide2.QtXml.QXmlErrorHandler',),
    "PySide2.QtXml.QXmlSimpleReader.setFeature": ('str', 'bool'),
    "PySide2.QtXml.QXmlSimpleReader.setLexicalHandler": ('PySide2.QtXml.QXmlLexicalHandler',),
    "PySide2.QtXml.QXmlSimpleReader.setProperty": ('str', 'int'),
    }) if "PySide2.QtXml" in sys.modules else None

# Module PySide2.QtXmlPatterns
sig_dict.update({

# class PySide2.QtXmlPatterns.QAbstractMessageHandler:
    "PySide2.QtXmlPatterns.QAbstractMessageHandler.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtXmlPatterns.QAbstractMessageHandler.handleMessage": ('PySide2.QtCore.QtMsgType', 'str', 'PySide2.QtCore.QUrl', 'PySide2.QtXmlPatterns.QSourceLocation'),
    "PySide2.QtXmlPatterns.QAbstractMessageHandler.message": ('PySide2.QtCore.QtMsgType', 'str', 'PySide2.QtCore.QUrl', 'PySide2.QtXmlPatterns.QSourceLocation'),

# class PySide2.QtXmlPatterns.QAbstractUriResolver:
    "PySide2.QtXmlPatterns.QAbstractUriResolver.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtXmlPatterns.QAbstractUriResolver.resolve": ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QUrl'),

# class PySide2.QtXmlPatterns.QAbstractXmlNodeModel:

# class PySide2.QtXmlPatterns.QAbstractXmlNodeModel.NodeCopySetting:

# class PySide2.QtXmlPatterns.QAbstractXmlNodeModel.SimpleAxis:
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.__init__": (),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.attributes": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.baseUri": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.compareOrder": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex', 'PySide2.QtXmlPatterns.QXmlNodeModelIndex'),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.createIndex": [('int',), ('int', 'int')],
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.documentUri": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.elementById": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.isDeepEqual": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex', 'PySide2.QtXmlPatterns.QXmlNodeModelIndex'),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.kind": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.name": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.namespaceBindings": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.namespaceForPrefix": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex', 'Missing("PySide2.QtXmlPatterns.QXmlName.PrefixCode")'),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.nextFromSimpleAxis": ('PySide2.QtXmlPatterns.QAbstractXmlNodeModel.SimpleAxis', 'PySide2.QtXmlPatterns.QXmlNodeModelIndex'),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.nodesByIdref": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.root": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.sendNamespaces": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex', 'PySide2.QtXmlPatterns.QAbstractXmlReceiver'),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.sourceLocation": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.stringValue": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),
    "PySide2.QtXmlPatterns.QAbstractXmlNodeModel.typedValue": ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',),

# class PySide2.QtXmlPatterns.QAbstractXmlReceiver:
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.__init__": (),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.atomicValue": ('typing.Any',),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.attribute": ('PySide2.QtXmlPatterns.QXmlName', 'str'),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.characters": ('str',),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.comment": ('str',),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.endDocument": (),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.endElement": (),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.endOfSequence": (),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.namespaceBinding": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.processingInstruction": ('PySide2.QtXmlPatterns.QXmlName', 'str'),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.startDocument": (),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.startElement": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.startOfSequence": (),
    "PySide2.QtXmlPatterns.QAbstractXmlReceiver.whitespaceOnly": ('str',),

# class PySide2.QtXmlPatterns.QSourceLocation:
    "PySide2.QtXmlPatterns.QSourceLocation.__init__": [(), ('PySide2.QtCore.QUrl', 'int', 'int'), ('PySide2.QtXmlPatterns.QSourceLocation',)],
    "PySide2.QtXmlPatterns.QSourceLocation.__copy__": (),
    "PySide2.QtXmlPatterns.QSourceLocation.column": (),
    "PySide2.QtXmlPatterns.QSourceLocation.isNull": (),
    "PySide2.QtXmlPatterns.QSourceLocation.line": (),
    "PySide2.QtXmlPatterns.QSourceLocation.setColumn": ('int',),
    "PySide2.QtXmlPatterns.QSourceLocation.setLine": ('int',),
    "PySide2.QtXmlPatterns.QSourceLocation.setUri": ('PySide2.QtCore.QUrl',),
    "PySide2.QtXmlPatterns.QSourceLocation.uri": (),

# class PySide2.QtXmlPatterns.QXmlFormatter:
    "PySide2.QtXmlPatterns.QXmlFormatter.__init__": ('PySide2.QtXmlPatterns.QXmlQuery', 'PySide2.QtCore.QIODevice'),
    "PySide2.QtXmlPatterns.QXmlFormatter.atomicValue": ('typing.Any',),
    "PySide2.QtXmlPatterns.QXmlFormatter.attribute": ('PySide2.QtXmlPatterns.QXmlName', 'str'),
    "PySide2.QtXmlPatterns.QXmlFormatter.characters": ('str',),
    "PySide2.QtXmlPatterns.QXmlFormatter.comment": ('str',),
    "PySide2.QtXmlPatterns.QXmlFormatter.endDocument": (),
    "PySide2.QtXmlPatterns.QXmlFormatter.endElement": (),
    "PySide2.QtXmlPatterns.QXmlFormatter.endOfSequence": (),
    "PySide2.QtXmlPatterns.QXmlFormatter.indentationDepth": (),
    "PySide2.QtXmlPatterns.QXmlFormatter.processingInstruction": ('PySide2.QtXmlPatterns.QXmlName', 'str'),
    "PySide2.QtXmlPatterns.QXmlFormatter.setIndentationDepth": ('int',),
    "PySide2.QtXmlPatterns.QXmlFormatter.startDocument": (),
    "PySide2.QtXmlPatterns.QXmlFormatter.startElement": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QXmlFormatter.startOfSequence": (),

# class PySide2.QtXmlPatterns.QXmlItem:
    "PySide2.QtXmlPatterns.QXmlItem.__init__": [(), ('PySide2.QtXmlPatterns.QXmlItem',), ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',), ('typing.Any',)],
    "PySide2.QtXmlPatterns.QXmlItem.__copy__": (),
    "PySide2.QtXmlPatterns.QXmlItem.isAtomicValue": (),
    "PySide2.QtXmlPatterns.QXmlItem.isNode": (),
    "PySide2.QtXmlPatterns.QXmlItem.isNull": (),
    "PySide2.QtXmlPatterns.QXmlItem.toAtomicValue": (),
    "PySide2.QtXmlPatterns.QXmlItem.toNodeModelIndex": (),

# class PySide2.QtXmlPatterns.QXmlName:
    "PySide2.QtXmlPatterns.QXmlName.__init__": [(), ('PySide2.QtXmlPatterns.QXmlName',), ('PySide2.QtXmlPatterns.QXmlNamePool', 'str', 'str', 'str')],
    "PySide2.QtXmlPatterns.QXmlName.__copy__": (),
    "PySide2.QtXmlPatterns.QXmlName.fromClarkName": ('str', 'PySide2.QtXmlPatterns.QXmlNamePool'),
    "PySide2.QtXmlPatterns.QXmlName.isNCName": ('str',),
    "PySide2.QtXmlPatterns.QXmlName.isNull": (),
    "PySide2.QtXmlPatterns.QXmlName.localName": ('PySide2.QtXmlPatterns.QXmlNamePool',),
    "PySide2.QtXmlPatterns.QXmlName.namespaceUri": ('PySide2.QtXmlPatterns.QXmlNamePool',),
    "PySide2.QtXmlPatterns.QXmlName.prefix": ('PySide2.QtXmlPatterns.QXmlNamePool',),
    "PySide2.QtXmlPatterns.QXmlName.toClarkName": ('PySide2.QtXmlPatterns.QXmlNamePool',),

# class PySide2.QtXmlPatterns.QXmlNamePool:
    "PySide2.QtXmlPatterns.QXmlNamePool.__init__": [(), ('PySide2.QtXmlPatterns.QXmlNamePool',)],
    "PySide2.QtXmlPatterns.QXmlNamePool.__copy__": (),

# class PySide2.QtXmlPatterns.QXmlNodeModelIndex:

# class PySide2.QtXmlPatterns.QXmlNodeModelIndex.DocumentOrder:

# class PySide2.QtXmlPatterns.QXmlNodeModelIndex.NodeKind:
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.__init__": [(), ('PySide2.QtXmlPatterns.QXmlNodeModelIndex',)],
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.__copy__": (),
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.additionalData": (),
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.data": (),
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.internalPointer": (),
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.isNull": (),
    "PySide2.QtXmlPatterns.QXmlNodeModelIndex.model": (),

# class PySide2.QtXmlPatterns.QXmlQuery:

# class PySide2.QtXmlPatterns.QXmlQuery.QueryLanguage:
    "PySide2.QtXmlPatterns.QXmlQuery.__init__": [(), ('PySide2.QtXmlPatterns.QXmlNamePool',), ('PySide2.QtXmlPatterns.QXmlQuery',), ('PySide2.QtXmlPatterns.QXmlQuery.QueryLanguage', 'PySide2.QtXmlPatterns.QXmlNamePool')],
    "PySide2.QtXmlPatterns.QXmlQuery.__copy__": (),
    "PySide2.QtXmlPatterns.QXmlQuery.bindVariable": [('PySide2.QtXmlPatterns.QXmlName', 'PySide2.QtCore.QIODevice'), ('PySide2.QtXmlPatterns.QXmlName', 'PySide2.QtXmlPatterns.QXmlItem'), ('PySide2.QtXmlPatterns.QXmlName', 'PySide2.QtXmlPatterns.QXmlQuery'), ('str', 'PySide2.QtCore.QIODevice'), ('str', 'PySide2.QtXmlPatterns.QXmlItem'), ('str', 'PySide2.QtXmlPatterns.QXmlQuery')],
    "PySide2.QtXmlPatterns.QXmlQuery.evaluateTo": [('PySide2.QtCore.QIODevice',), ('PySide2.QtXmlPatterns.QAbstractXmlReceiver',), ('PySide2.QtXmlPatterns.QXmlResultItems',)],
    "PySide2.QtXmlPatterns.QXmlQuery.initialTemplateName": (),
    "PySide2.QtXmlPatterns.QXmlQuery.isValid": (),
    "PySide2.QtXmlPatterns.QXmlQuery.messageHandler": (),
    "PySide2.QtXmlPatterns.QXmlQuery.namePool": (),
    "PySide2.QtXmlPatterns.QXmlQuery.queryLanguage": (),
    "PySide2.QtXmlPatterns.QXmlQuery.setFocus": [('PySide2.QtCore.QIODevice',), ('PySide2.QtCore.QUrl',), ('PySide2.QtXmlPatterns.QXmlItem',), ('str',)],
    "PySide2.QtXmlPatterns.QXmlQuery.setInitialTemplateName": [('PySide2.QtXmlPatterns.QXmlName',), ('str',)],
    "PySide2.QtXmlPatterns.QXmlQuery.setMessageHandler": ('PySide2.QtXmlPatterns.QAbstractMessageHandler',),
    "PySide2.QtXmlPatterns.QXmlQuery.setQuery": [('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QUrl'), ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QUrl'), ('str', 'PySide2.QtCore.QUrl')],
    "PySide2.QtXmlPatterns.QXmlQuery.setUriResolver": ('PySide2.QtXmlPatterns.QAbstractUriResolver',),
    "PySide2.QtXmlPatterns.QXmlQuery.uriResolver": (),

# class PySide2.QtXmlPatterns.QXmlResultItems:
    "PySide2.QtXmlPatterns.QXmlResultItems.__init__": (),
    "PySide2.QtXmlPatterns.QXmlResultItems.current": (),
    "PySide2.QtXmlPatterns.QXmlResultItems.hasError": (),

# class PySide2.QtXmlPatterns.QXmlSchema:
    "PySide2.QtXmlPatterns.QXmlSchema.__init__": [(), ('PySide2.QtXmlPatterns.QXmlSchema',)],
    "PySide2.QtXmlPatterns.QXmlSchema.documentUri": (),
    "PySide2.QtXmlPatterns.QXmlSchema.isValid": (),
    "PySide2.QtXmlPatterns.QXmlSchema.load": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QUrl'), ('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QUrl'), ('PySide2.QtCore.QUrl',)],
    "PySide2.QtXmlPatterns.QXmlSchema.messageHandler": (),
    "PySide2.QtXmlPatterns.QXmlSchema.namePool": (),
    "PySide2.QtXmlPatterns.QXmlSchema.setMessageHandler": ('PySide2.QtXmlPatterns.QAbstractMessageHandler',),
    "PySide2.QtXmlPatterns.QXmlSchema.setUriResolver": ('PySide2.QtXmlPatterns.QAbstractUriResolver',),
    "PySide2.QtXmlPatterns.QXmlSchema.uriResolver": (),

# class PySide2.QtXmlPatterns.QXmlSchemaValidator:
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.__init__": [(), ('PySide2.QtXmlPatterns.QXmlSchema',)],
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.messageHandler": (),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.namePool": (),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.schema": (),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.setMessageHandler": ('PySide2.QtXmlPatterns.QAbstractMessageHandler',),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.setSchema": ('PySide2.QtXmlPatterns.QXmlSchema',),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.setUriResolver": ('PySide2.QtXmlPatterns.QAbstractUriResolver',),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.uriResolver": (),
    "PySide2.QtXmlPatterns.QXmlSchemaValidator.validate": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QUrl'), ('PySide2.QtCore.QIODevice', 'PySide2.QtCore.QUrl'), ('PySide2.QtCore.QUrl',)],

# class PySide2.QtXmlPatterns.QXmlSerializer:
    "PySide2.QtXmlPatterns.QXmlSerializer.__init__": ('PySide2.QtXmlPatterns.QXmlQuery', 'PySide2.QtCore.QIODevice'),
    "PySide2.QtXmlPatterns.QXmlSerializer.atomicValue": ('typing.Any',),
    "PySide2.QtXmlPatterns.QXmlSerializer.attribute": ('PySide2.QtXmlPatterns.QXmlName', 'str'),
    "PySide2.QtXmlPatterns.QXmlSerializer.characters": ('str',),
    "PySide2.QtXmlPatterns.QXmlSerializer.codec": (),
    "PySide2.QtXmlPatterns.QXmlSerializer.comment": ('str',),
    "PySide2.QtXmlPatterns.QXmlSerializer.endDocument": (),
    "PySide2.QtXmlPatterns.QXmlSerializer.endElement": (),
    "PySide2.QtXmlPatterns.QXmlSerializer.endOfSequence": (),
    "PySide2.QtXmlPatterns.QXmlSerializer.namespaceBinding": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QXmlSerializer.outputDevice": (),
    "PySide2.QtXmlPatterns.QXmlSerializer.processingInstruction": ('PySide2.QtXmlPatterns.QXmlName', 'str'),
    "PySide2.QtXmlPatterns.QXmlSerializer.setCodec": ('PySide2.QtCore.QTextCodec',),
    "PySide2.QtXmlPatterns.QXmlSerializer.startDocument": (),
    "PySide2.QtXmlPatterns.QXmlSerializer.startElement": ('PySide2.QtXmlPatterns.QXmlName',),
    "PySide2.QtXmlPatterns.QXmlSerializer.startOfSequence": (),
    }) if "PySide2.QtXmlPatterns" in sys.modules else None

# Module PySide2.QtHelp
sig_dict.update({

# class PySide2.QtHelp.QCompressedHelpInfo:
    "PySide2.QtHelp.QCompressedHelpInfo.__init__": [(), ('PySide2.QtHelp.QCompressedHelpInfo',)],
    "PySide2.QtHelp.QCompressedHelpInfo.__copy__": (),
    "PySide2.QtHelp.QCompressedHelpInfo.component": (),
    "PySide2.QtHelp.QCompressedHelpInfo.fromCompressedHelpFile": ('str',),
    "PySide2.QtHelp.QCompressedHelpInfo.namespaceName": (),
    "PySide2.QtHelp.QCompressedHelpInfo.swap": ('PySide2.QtHelp.QCompressedHelpInfo',),
    "PySide2.QtHelp.QCompressedHelpInfo.version": (),

# class PySide2.QtHelp.QHelpContentItem:
    "PySide2.QtHelp.QHelpContentItem.__copy__": (),
    "PySide2.QtHelp.QHelpContentItem.child": ('int',),
    "PySide2.QtHelp.QHelpContentItem.childCount": (),
    "PySide2.QtHelp.QHelpContentItem.childPosition": ('PySide2.QtHelp.QHelpContentItem',),
    "PySide2.QtHelp.QHelpContentItem.parent": (),
    "PySide2.QtHelp.QHelpContentItem.row": (),
    "PySide2.QtHelp.QHelpContentItem.title": (),
    "PySide2.QtHelp.QHelpContentItem.url": (),

# class PySide2.QtHelp.QHelpContentModel:
    "PySide2.QtHelp.QHelpContentModel.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtHelp.QHelpContentModel.contentItemAt": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtHelp.QHelpContentModel.createContents": ('str',),
    "PySide2.QtHelp.QHelpContentModel.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtHelp.QHelpContentModel.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtHelp.QHelpContentModel.isCreatingContents": (),
    "PySide2.QtHelp.QHelpContentModel.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtHelp.QHelpContentModel.rowCount": ('PySide2.QtCore.QModelIndex',),

# class PySide2.QtHelp.QHelpContentWidget:
    "PySide2.QtHelp.QHelpContentWidget.indexOf": ('PySide2.QtCore.QUrl',),

# class PySide2.QtHelp.QHelpEngine:
    "PySide2.QtHelp.QHelpEngine.__init__": ('str', 'PySide2.QtCore.QObject'),
    "PySide2.QtHelp.QHelpEngine.contentModel": (),
    "PySide2.QtHelp.QHelpEngine.contentWidget": (),
    "PySide2.QtHelp.QHelpEngine.indexModel": (),
    "PySide2.QtHelp.QHelpEngine.indexWidget": (),
    "PySide2.QtHelp.QHelpEngine.searchEngine": (),

# class PySide2.QtHelp.QHelpEngineCore:
    "PySide2.QtHelp.QHelpEngineCore.__init__": ('str', 'PySide2.QtCore.QObject'),
    "PySide2.QtHelp.QHelpEngineCore.addCustomFilter": ('str', 'typing.Sequence[str]'),
    "PySide2.QtHelp.QHelpEngineCore.autoSaveFilter": (),
    "PySide2.QtHelp.QHelpEngineCore.collectionFile": (),
    "PySide2.QtHelp.QHelpEngineCore.copyCollectionFile": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.currentFilter": (),
    "PySide2.QtHelp.QHelpEngineCore.customFilters": (),
    "PySide2.QtHelp.QHelpEngineCore.customValue": ('str', 'typing.Any'),
    "PySide2.QtHelp.QHelpEngineCore.documentationFileName": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.error": (),
    "PySide2.QtHelp.QHelpEngineCore.fileData": ('PySide2.QtCore.QUrl',),
    "PySide2.QtHelp.QHelpEngineCore.files": [('str', 'str', 'str'), ('str', 'typing.Sequence[str]', 'str')],
    "PySide2.QtHelp.QHelpEngineCore.filterAttributeSets": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.filterAttributes": [(), ('str',)],
    "PySide2.QtHelp.QHelpEngineCore.filterEngine": (),
    "PySide2.QtHelp.QHelpEngineCore.findFile": ('PySide2.QtCore.QUrl',),
    "PySide2.QtHelp.QHelpEngineCore.linksForIdentifier": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.linksForKeyword": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.metaData": ('str', 'str'),
    "PySide2.QtHelp.QHelpEngineCore.namespaceName": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.registerDocumentation": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.registeredDocumentations": (),
    "PySide2.QtHelp.QHelpEngineCore.removeCustomFilter": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.removeCustomValue": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.setAutoSaveFilter": ('bool',),
    "PySide2.QtHelp.QHelpEngineCore.setCollectionFile": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.setCurrentFilter": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.setCustomValue": ('str', 'typing.Any'),
    "PySide2.QtHelp.QHelpEngineCore.setUsesFilterEngine": ('bool',),
    "PySide2.QtHelp.QHelpEngineCore.setupData": (),
    "PySide2.QtHelp.QHelpEngineCore.unregisterDocumentation": ('str',),
    "PySide2.QtHelp.QHelpEngineCore.usesFilterEngine": (),

# class PySide2.QtHelp.QHelpFilterData:
    "PySide2.QtHelp.QHelpFilterData.__init__": [(), ('PySide2.QtHelp.QHelpFilterData',)],
    "PySide2.QtHelp.QHelpFilterData.__copy__": (),
    "PySide2.QtHelp.QHelpFilterData.components": (),
    "PySide2.QtHelp.QHelpFilterData.setComponents": ('typing.Sequence[str]',),
    "PySide2.QtHelp.QHelpFilterData.setVersions": ('typing.Sequence[PySide2.QtCore.QVersionNumber]',),
    "PySide2.QtHelp.QHelpFilterData.swap": ('PySide2.QtHelp.QHelpFilterData',),
    "PySide2.QtHelp.QHelpFilterData.versions": (),

# class PySide2.QtHelp.QHelpFilterEngine:
    "PySide2.QtHelp.QHelpFilterEngine.__init__": ('PySide2.QtHelp.QHelpEngineCore',),
    "PySide2.QtHelp.QHelpFilterEngine.activeFilter": (),
    "PySide2.QtHelp.QHelpFilterEngine.availableComponents": (),
    "PySide2.QtHelp.QHelpFilterEngine.filterData": ('str',),
    "PySide2.QtHelp.QHelpFilterEngine.filters": (),
    "PySide2.QtHelp.QHelpFilterEngine.namespaceToComponent": (),
    "PySide2.QtHelp.QHelpFilterEngine.namespaceToVersion": (),
    "PySide2.QtHelp.QHelpFilterEngine.namespacesForFilter": ('str',),
    "PySide2.QtHelp.QHelpFilterEngine.removeFilter": ('str',),
    "PySide2.QtHelp.QHelpFilterEngine.setActiveFilter": ('str',),
    "PySide2.QtHelp.QHelpFilterEngine.setFilterData": ('str', 'PySide2.QtHelp.QHelpFilterData'),

# class PySide2.QtHelp.QHelpIndexModel:
    "PySide2.QtHelp.QHelpIndexModel.createIndex": [('int', 'int', 'int'), ('int', 'int', 'object'), ('str',)],
    "PySide2.QtHelp.QHelpIndexModel.filter": ('str', 'str'),
    "PySide2.QtHelp.QHelpIndexModel.isCreatingIndex": (),
    "PySide2.QtHelp.QHelpIndexModel.linksForKeyword": ('str',),

# class PySide2.QtHelp.QHelpIndexWidget:
    "PySide2.QtHelp.QHelpIndexWidget.activateCurrentItem": (),
    "PySide2.QtHelp.QHelpIndexWidget.filterIndices": ('str', 'str'),

# class PySide2.QtHelp.QHelpSearchEngine:
    "PySide2.QtHelp.QHelpSearchEngine.__init__": ('PySide2.QtHelp.QHelpEngineCore', 'PySide2.QtCore.QObject'),
    "PySide2.QtHelp.QHelpSearchEngine.cancelIndexing": (),
    "PySide2.QtHelp.QHelpSearchEngine.cancelSearching": (),
    "PySide2.QtHelp.QHelpSearchEngine.hitCount": (),
    "PySide2.QtHelp.QHelpSearchEngine.hits": ('int', 'int'),
    "PySide2.QtHelp.QHelpSearchEngine.hitsCount": (),
    "PySide2.QtHelp.QHelpSearchEngine.query": (),
    "PySide2.QtHelp.QHelpSearchEngine.queryWidget": (),
    "PySide2.QtHelp.QHelpSearchEngine.reindexDocumentation": (),
    "PySide2.QtHelp.QHelpSearchEngine.resultWidget": (),
    "PySide2.QtHelp.QHelpSearchEngine.scheduleIndexDocumentation": (),
    "PySide2.QtHelp.QHelpSearchEngine.search": [('str',), ('typing.Sequence[PySide2.QtHelp.QHelpSearchQuery]',)],
    "PySide2.QtHelp.QHelpSearchEngine.searchInput": (),
    "PySide2.QtHelp.QHelpSearchEngine.searchResultCount": (),
    "PySide2.QtHelp.QHelpSearchEngine.searchResults": ('int', 'int'),

# class PySide2.QtHelp.QHelpSearchQuery:

# class PySide2.QtHelp.QHelpSearchQuery.FieldName:
    "PySide2.QtHelp.QHelpSearchQuery.__init__": [(), ('PySide2.QtHelp.QHelpSearchQuery',), ('PySide2.QtHelp.QHelpSearchQuery.FieldName', 'typing.Sequence[str]')],
    "PySide2.QtHelp.QHelpSearchQuery.__copy__": (),

# class PySide2.QtHelp.QHelpSearchQueryWidget:
    "PySide2.QtHelp.QHelpSearchQueryWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtHelp.QHelpSearchQueryWidget.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtHelp.QHelpSearchQueryWidget.collapseExtendedSearch": (),
    "PySide2.QtHelp.QHelpSearchQueryWidget.expandExtendedSearch": (),
    "PySide2.QtHelp.QHelpSearchQueryWidget.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtHelp.QHelpSearchQueryWidget.isCompactMode": (),
    "PySide2.QtHelp.QHelpSearchQueryWidget.query": (),
    "PySide2.QtHelp.QHelpSearchQueryWidget.searchInput": (),
    "PySide2.QtHelp.QHelpSearchQueryWidget.setCompactMode": ('bool',),
    "PySide2.QtHelp.QHelpSearchQueryWidget.setQuery": ('typing.Sequence[PySide2.QtHelp.QHelpSearchQuery]',),
    "PySide2.QtHelp.QHelpSearchQueryWidget.setSearchInput": ('str',),

# class PySide2.QtHelp.QHelpSearchResult:
    "PySide2.QtHelp.QHelpSearchResult.__init__": [(), ('PySide2.QtCore.QUrl', 'str', 'str'), ('PySide2.QtHelp.QHelpSearchResult',)],
    "PySide2.QtHelp.QHelpSearchResult.snippet": (),
    "PySide2.QtHelp.QHelpSearchResult.title": (),
    "PySide2.QtHelp.QHelpSearchResult.url": (),

# class PySide2.QtHelp.QHelpSearchResultWidget:
    "PySide2.QtHelp.QHelpSearchResultWidget.changeEvent": ('PySide2.QtCore.QEvent',),
    "PySide2.QtHelp.QHelpSearchResultWidget.linkAt": ('PySide2.QtCore.QPoint',),
    }) if "PySide2.QtHelp" in sys.modules else None

# Module PySide2.QtMultimedia
sig_dict.update({

# class PySide2.QtMultimedia.QAbstractAudioDeviceInfo:
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.__init__": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.deviceName": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.isFormatSupported": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.preferredFormat": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.supportedByteOrders": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.supportedChannelCounts": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.supportedCodecs": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.supportedSampleRates": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.supportedSampleSizes": (),
    "PySide2.QtMultimedia.QAbstractAudioDeviceInfo.supportedSampleTypes": (),

# class PySide2.QtMultimedia.QAbstractAudioInput:
    "PySide2.QtMultimedia.QAbstractAudioInput.__init__": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.bufferSize": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.bytesReady": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.elapsedUSecs": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.error": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.format": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.notifyInterval": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.periodSize": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.processedUSecs": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.reset": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.resume": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.setBufferSize": ('int',),
    "PySide2.QtMultimedia.QAbstractAudioInput.setFormat": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAbstractAudioInput.setNotifyInterval": ('int',),
    "PySide2.QtMultimedia.QAbstractAudioInput.setVolume": ('float',),
    "PySide2.QtMultimedia.QAbstractAudioInput.start": [(), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtMultimedia.QAbstractAudioInput.state": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.stop": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.suspend": (),
    "PySide2.QtMultimedia.QAbstractAudioInput.volume": (),

# class PySide2.QtMultimedia.QAbstractAudioOutput:
    "PySide2.QtMultimedia.QAbstractAudioOutput.__init__": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.bufferSize": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.bytesFree": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.category": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.elapsedUSecs": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.error": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.format": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.notifyInterval": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.periodSize": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.processedUSecs": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.reset": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.resume": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.setBufferSize": ('int',),
    "PySide2.QtMultimedia.QAbstractAudioOutput.setCategory": ('str',),
    "PySide2.QtMultimedia.QAbstractAudioOutput.setFormat": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAbstractAudioOutput.setNotifyInterval": ('int',),
    "PySide2.QtMultimedia.QAbstractAudioOutput.setVolume": ('float',),
    "PySide2.QtMultimedia.QAbstractAudioOutput.start": [(), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtMultimedia.QAbstractAudioOutput.state": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.stop": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.suspend": (),
    "PySide2.QtMultimedia.QAbstractAudioOutput.volume": (),

# class PySide2.QtMultimedia.QAbstractVideoBuffer:

# class PySide2.QtMultimedia.QAbstractVideoBuffer.HandleType:

# class PySide2.QtMultimedia.QAbstractVideoBuffer.MapMode:
    "PySide2.QtMultimedia.QAbstractVideoBuffer.__init__": ('PySide2.QtMultimedia.QAbstractVideoBuffer.HandleType',),
    "PySide2.QtMultimedia.QAbstractVideoBuffer.handle": (),
    "PySide2.QtMultimedia.QAbstractVideoBuffer.handleType": (),
    "PySide2.QtMultimedia.QAbstractVideoBuffer.mapMode": (),
    "PySide2.QtMultimedia.QAbstractVideoBuffer.release": (),
    "PySide2.QtMultimedia.QAbstractVideoBuffer.unmap": (),

# class PySide2.QtMultimedia.QAbstractVideoFilter:
    "PySide2.QtMultimedia.QAbstractVideoFilter.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAbstractVideoFilter.createFilterRunnable": (),
    "PySide2.QtMultimedia.QAbstractVideoFilter.isActive": (),
    "PySide2.QtMultimedia.QAbstractVideoFilter.setActive": ('bool',),

# class PySide2.QtMultimedia.QAbstractVideoSurface:

# class PySide2.QtMultimedia.QAbstractVideoSurface.Error:
    "PySide2.QtMultimedia.QAbstractVideoSurface.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.error": (),
    "PySide2.QtMultimedia.QAbstractVideoSurface.isActive": (),
    "PySide2.QtMultimedia.QAbstractVideoSurface.isFormatSupported": ('PySide2.QtMultimedia.QVideoSurfaceFormat',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.nativeResolution": (),
    "PySide2.QtMultimedia.QAbstractVideoSurface.nearestFormat": ('PySide2.QtMultimedia.QVideoSurfaceFormat',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.present": ('PySide2.QtMultimedia.QVideoFrame',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.setError": ('PySide2.QtMultimedia.QAbstractVideoSurface.Error',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.setNativeResolution": ('PySide2.QtCore.QSize',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.start": ('PySide2.QtMultimedia.QVideoSurfaceFormat',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.stop": (),
    "PySide2.QtMultimedia.QAbstractVideoSurface.supportedPixelFormats": ('PySide2.QtMultimedia.QAbstractVideoBuffer.HandleType',),
    "PySide2.QtMultimedia.QAbstractVideoSurface.surfaceFormat": (),

# class PySide2.QtMultimedia.QAudio:

# class PySide2.QtMultimedia.QAudio.Error:

# class PySide2.QtMultimedia.QAudio.Mode:

# class PySide2.QtMultimedia.QAudio.Role:

# class PySide2.QtMultimedia.QAudio.State:

# class PySide2.QtMultimedia.QAudio.VolumeScale:
    "PySide2.QtMultimedia.QAudio.convertVolume": ('float', 'PySide2.QtMultimedia.QAudio.VolumeScale', 'PySide2.QtMultimedia.QAudio.VolumeScale'),

# class PySide2.QtMultimedia.QAudioBuffer:
    "PySide2.QtMultimedia.QAudioBuffer.__init__": [(), ('PySide2.QtCore.QByteArray', 'PySide2.QtMultimedia.QAudioFormat', 'int'), ('PySide2.QtMultimedia.QAudioBuffer',), ('int', 'PySide2.QtMultimedia.QAudioFormat', 'int')],
    "PySide2.QtMultimedia.QAudioBuffer.__copy__": (),
    "PySide2.QtMultimedia.QAudioBuffer.byteCount": (),
    "PySide2.QtMultimedia.QAudioBuffer.constData": (),
    "PySide2.QtMultimedia.QAudioBuffer.data": (),
    "PySide2.QtMultimedia.QAudioBuffer.duration": (),
    "PySide2.QtMultimedia.QAudioBuffer.format": (),
    "PySide2.QtMultimedia.QAudioBuffer.frameCount": (),
    "PySide2.QtMultimedia.QAudioBuffer.isValid": (),
    "PySide2.QtMultimedia.QAudioBuffer.sampleCount": (),
    "PySide2.QtMultimedia.QAudioBuffer.startTime": (),

# class PySide2.QtMultimedia.QAudioDecoder:

# class PySide2.QtMultimedia.QAudioDecoder.Error:

# class PySide2.QtMultimedia.QAudioDecoder.State:
    "PySide2.QtMultimedia.QAudioDecoder.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioDecoder.audioFormat": (),
    "PySide2.QtMultimedia.QAudioDecoder.bind": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioDecoder.bufferAvailable": (),
    "PySide2.QtMultimedia.QAudioDecoder.duration": (),
    "PySide2.QtMultimedia.QAudioDecoder.error": (),
    "PySide2.QtMultimedia.QAudioDecoder.errorString": (),
    "PySide2.QtMultimedia.QAudioDecoder.hasSupport": ('str', 'typing.Sequence[str]'),
    "PySide2.QtMultimedia.QAudioDecoder.position": (),
    "PySide2.QtMultimedia.QAudioDecoder.read": (),
    "PySide2.QtMultimedia.QAudioDecoder.setAudioFormat": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAudioDecoder.setSourceDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtMultimedia.QAudioDecoder.setSourceFilename": ('str',),
    "PySide2.QtMultimedia.QAudioDecoder.sourceDevice": (),
    "PySide2.QtMultimedia.QAudioDecoder.sourceFilename": (),
    "PySide2.QtMultimedia.QAudioDecoder.start": (),
    "PySide2.QtMultimedia.QAudioDecoder.state": (),
    "PySide2.QtMultimedia.QAudioDecoder.stop": (),
    "PySide2.QtMultimedia.QAudioDecoder.unbind": ('PySide2.QtCore.QObject',),

# class PySide2.QtMultimedia.QAudioDecoderControl:
    "PySide2.QtMultimedia.QAudioDecoderControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioDecoderControl.audioFormat": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.bufferAvailable": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.duration": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.position": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.read": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.setAudioFormat": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAudioDecoderControl.setSourceDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtMultimedia.QAudioDecoderControl.setSourceFilename": ('str',),
    "PySide2.QtMultimedia.QAudioDecoderControl.sourceDevice": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.sourceFilename": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.start": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.state": (),
    "PySide2.QtMultimedia.QAudioDecoderControl.stop": (),

# class PySide2.QtMultimedia.QAudioDeviceInfo:
    "PySide2.QtMultimedia.QAudioDeviceInfo.__init__": [(), ('PySide2.QtMultimedia.QAudioDeviceInfo',)],
    "PySide2.QtMultimedia.QAudioDeviceInfo.__copy__": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.availableDevices": ('PySide2.QtMultimedia.QAudio.Mode',),
    "PySide2.QtMultimedia.QAudioDeviceInfo.defaultInputDevice": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.defaultOutputDevice": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.deviceName": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.isFormatSupported": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAudioDeviceInfo.isNull": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.nearestFormat": ('PySide2.QtMultimedia.QAudioFormat',),
    "PySide2.QtMultimedia.QAudioDeviceInfo.preferredFormat": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.realm": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.supportedByteOrders": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.supportedChannelCounts": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.supportedCodecs": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.supportedSampleRates": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.supportedSampleSizes": (),
    "PySide2.QtMultimedia.QAudioDeviceInfo.supportedSampleTypes": (),

# class PySide2.QtMultimedia.QAudioEncoderSettings:
    "PySide2.QtMultimedia.QAudioEncoderSettings.__init__": [(), ('PySide2.QtMultimedia.QAudioEncoderSettings',)],
    "PySide2.QtMultimedia.QAudioEncoderSettings.__copy__": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.bitRate": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.channelCount": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.codec": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.encodingMode": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.encodingOption": ('str',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.encodingOptions": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.isNull": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.quality": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.sampleRate": (),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setBitRate": ('int',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setChannelCount": ('int',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setCodec": ('str',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setEncodingMode": ('PySide2.QtMultimedia.QMultimedia.EncodingMode',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setEncodingOption": ('str', 'typing.Any'),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setEncodingOptions": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setQuality": ('PySide2.QtMultimedia.QMultimedia.EncodingQuality',),
    "PySide2.QtMultimedia.QAudioEncoderSettings.setSampleRate": ('int',),

# class PySide2.QtMultimedia.QAudioEncoderSettingsControl:
    "PySide2.QtMultimedia.QAudioEncoderSettingsControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioEncoderSettingsControl.audioSettings": (),
    "PySide2.QtMultimedia.QAudioEncoderSettingsControl.codecDescription": ('str',),
    "PySide2.QtMultimedia.QAudioEncoderSettingsControl.setAudioSettings": ('PySide2.QtMultimedia.QAudioEncoderSettings',),
    "PySide2.QtMultimedia.QAudioEncoderSettingsControl.supportedAudioCodecs": (),

# class PySide2.QtMultimedia.QAudioFormat:

# class PySide2.QtMultimedia.QAudioFormat.Endian:

# class PySide2.QtMultimedia.QAudioFormat.SampleType:
    "PySide2.QtMultimedia.QAudioFormat.__init__": [(), ('PySide2.QtMultimedia.QAudioFormat',)],
    "PySide2.QtMultimedia.QAudioFormat.__copy__": (),
    "PySide2.QtMultimedia.QAudioFormat.byteOrder": (),
    "PySide2.QtMultimedia.QAudioFormat.bytesForDuration": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.bytesForFrames": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.bytesPerFrame": (),
    "PySide2.QtMultimedia.QAudioFormat.channelCount": (),
    "PySide2.QtMultimedia.QAudioFormat.codec": (),
    "PySide2.QtMultimedia.QAudioFormat.durationForBytes": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.durationForFrames": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.framesForBytes": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.framesForDuration": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.isValid": (),
    "PySide2.QtMultimedia.QAudioFormat.sampleRate": (),
    "PySide2.QtMultimedia.QAudioFormat.sampleSize": (),
    "PySide2.QtMultimedia.QAudioFormat.sampleType": (),
    "PySide2.QtMultimedia.QAudioFormat.setByteOrder": ('PySide2.QtMultimedia.QAudioFormat.Endian',),
    "PySide2.QtMultimedia.QAudioFormat.setChannelCount": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.setCodec": ('str',),
    "PySide2.QtMultimedia.QAudioFormat.setSampleRate": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.setSampleSize": ('int',),
    "PySide2.QtMultimedia.QAudioFormat.setSampleType": ('PySide2.QtMultimedia.QAudioFormat.SampleType',),

# class PySide2.QtMultimedia.QAudioInput:
    "PySide2.QtMultimedia.QAudioInput.__init__": [('PySide2.QtMultimedia.QAudioDeviceInfo', 'PySide2.QtMultimedia.QAudioFormat', 'PySide2.QtCore.QObject'), ('PySide2.QtMultimedia.QAudioFormat', 'PySide2.QtCore.QObject')],
    "PySide2.QtMultimedia.QAudioInput.bufferSize": (),
    "PySide2.QtMultimedia.QAudioInput.bytesReady": (),
    "PySide2.QtMultimedia.QAudioInput.elapsedUSecs": (),
    "PySide2.QtMultimedia.QAudioInput.error": (),
    "PySide2.QtMultimedia.QAudioInput.format": (),
    "PySide2.QtMultimedia.QAudioInput.notifyInterval": (),
    "PySide2.QtMultimedia.QAudioInput.periodSize": (),
    "PySide2.QtMultimedia.QAudioInput.processedUSecs": (),
    "PySide2.QtMultimedia.QAudioInput.reset": (),
    "PySide2.QtMultimedia.QAudioInput.resume": (),
    "PySide2.QtMultimedia.QAudioInput.setBufferSize": ('int',),
    "PySide2.QtMultimedia.QAudioInput.setNotifyInterval": ('int',),
    "PySide2.QtMultimedia.QAudioInput.setVolume": ('float',),
    "PySide2.QtMultimedia.QAudioInput.start": [(), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtMultimedia.QAudioInput.state": (),
    "PySide2.QtMultimedia.QAudioInput.stop": (),
    "PySide2.QtMultimedia.QAudioInput.suspend": (),
    "PySide2.QtMultimedia.QAudioInput.volume": (),

# class PySide2.QtMultimedia.QAudioInputSelectorControl:
    "PySide2.QtMultimedia.QAudioInputSelectorControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioInputSelectorControl.activeInput": (),
    "PySide2.QtMultimedia.QAudioInputSelectorControl.availableInputs": (),
    "PySide2.QtMultimedia.QAudioInputSelectorControl.defaultInput": (),
    "PySide2.QtMultimedia.QAudioInputSelectorControl.inputDescription": ('str',),
    "PySide2.QtMultimedia.QAudioInputSelectorControl.setActiveInput": ('str',),

# class PySide2.QtMultimedia.QAudioOutput:
    "PySide2.QtMultimedia.QAudioOutput.__init__": [('PySide2.QtMultimedia.QAudioDeviceInfo', 'PySide2.QtMultimedia.QAudioFormat', 'PySide2.QtCore.QObject'), ('PySide2.QtMultimedia.QAudioFormat', 'PySide2.QtCore.QObject')],
    "PySide2.QtMultimedia.QAudioOutput.bufferSize": (),
    "PySide2.QtMultimedia.QAudioOutput.bytesFree": (),
    "PySide2.QtMultimedia.QAudioOutput.category": (),
    "PySide2.QtMultimedia.QAudioOutput.elapsedUSecs": (),
    "PySide2.QtMultimedia.QAudioOutput.error": (),
    "PySide2.QtMultimedia.QAudioOutput.format": (),
    "PySide2.QtMultimedia.QAudioOutput.notifyInterval": (),
    "PySide2.QtMultimedia.QAudioOutput.periodSize": (),
    "PySide2.QtMultimedia.QAudioOutput.processedUSecs": (),
    "PySide2.QtMultimedia.QAudioOutput.reset": (),
    "PySide2.QtMultimedia.QAudioOutput.resume": (),
    "PySide2.QtMultimedia.QAudioOutput.setBufferSize": ('int',),
    "PySide2.QtMultimedia.QAudioOutput.setCategory": ('str',),
    "PySide2.QtMultimedia.QAudioOutput.setNotifyInterval": ('int',),
    "PySide2.QtMultimedia.QAudioOutput.setVolume": ('float',),
    "PySide2.QtMultimedia.QAudioOutput.start": [(), ('PySide2.QtCore.QIODevice',)],
    "PySide2.QtMultimedia.QAudioOutput.state": (),
    "PySide2.QtMultimedia.QAudioOutput.stop": (),
    "PySide2.QtMultimedia.QAudioOutput.suspend": (),
    "PySide2.QtMultimedia.QAudioOutput.volume": (),

# class PySide2.QtMultimedia.QAudioOutputSelectorControl:
    "PySide2.QtMultimedia.QAudioOutputSelectorControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioOutputSelectorControl.activeOutput": (),
    "PySide2.QtMultimedia.QAudioOutputSelectorControl.availableOutputs": (),
    "PySide2.QtMultimedia.QAudioOutputSelectorControl.defaultOutput": (),
    "PySide2.QtMultimedia.QAudioOutputSelectorControl.outputDescription": ('str',),
    "PySide2.QtMultimedia.QAudioOutputSelectorControl.setActiveOutput": ('str',),

# class PySide2.QtMultimedia.QAudioProbe:
    "PySide2.QtMultimedia.QAudioProbe.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioProbe.isActive": (),
    "PySide2.QtMultimedia.QAudioProbe.setSource": [('PySide2.QtMultimedia.QMediaObject',), ('PySide2.QtMultimedia.QMediaRecorder',)],

# class PySide2.QtMultimedia.QAudioRecorder:
    "PySide2.QtMultimedia.QAudioRecorder.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioRecorder.audioInput": (),
    "PySide2.QtMultimedia.QAudioRecorder.audioInputDescription": ('str',),
    "PySide2.QtMultimedia.QAudioRecorder.audioInputs": (),
    "PySide2.QtMultimedia.QAudioRecorder.defaultAudioInput": (),
    "PySide2.QtMultimedia.QAudioRecorder.setAudioInput": ('str',),

# class PySide2.QtMultimedia.QAudioRoleControl:
    "PySide2.QtMultimedia.QAudioRoleControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QAudioRoleControl.audioRole": (),
    "PySide2.QtMultimedia.QAudioRoleControl.setAudioRole": ('PySide2.QtMultimedia.QAudio.Role',),
    "PySide2.QtMultimedia.QAudioRoleControl.supportedAudioRoles": (),

# class PySide2.QtMultimedia.QCamera:

# class PySide2.QtMultimedia.QCamera.CaptureMode:

# class PySide2.QtMultimedia.QCamera.CaptureModes:

# class PySide2.QtMultimedia.QCamera.Error:

# class PySide2.QtMultimedia.QCamera.FrameRateRange:
    "PySide2.QtMultimedia.QCamera.FrameRateRange.__init__": [(), ('PySide2.QtMultimedia.QCamera.FrameRateRange',), ('float', 'float')],
    "PySide2.QtMultimedia.QCamera.FrameRateRange.__copy__": (),

# class PySide2.QtMultimedia.QCamera.LockChangeReason:

# class PySide2.QtMultimedia.QCamera.LockStatus:

# class PySide2.QtMultimedia.QCamera.LockType:

# class PySide2.QtMultimedia.QCamera.LockTypes:

# class PySide2.QtMultimedia.QCamera.Position:

# class PySide2.QtMultimedia.QCamera.State:

# class PySide2.QtMultimedia.QCamera.Status:

    "PySide2.QtMultimedia.QCamera.__init__": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',), ('PySide2.QtMultimedia.QCamera.Position', 'PySide2.QtCore.QObject'), ('PySide2.QtMultimedia.QCameraInfo', 'PySide2.QtCore.QObject')],
    "PySide2.QtMultimedia.QCamera.availability": (),
    "PySide2.QtMultimedia.QCamera.availableDevices": (),
    "PySide2.QtMultimedia.QCamera.captureMode": (),
    "PySide2.QtMultimedia.QCamera.deviceDescription": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtMultimedia.QCamera.error": (),
    "PySide2.QtMultimedia.QCamera.errorString": (),
    "PySide2.QtMultimedia.QCamera.exposure": (),
    "PySide2.QtMultimedia.QCamera.focus": (),
    "PySide2.QtMultimedia.QCamera.imageProcessing": (),
    "PySide2.QtMultimedia.QCamera.isCaptureModeSupported": ('PySide2.QtMultimedia.QCamera.CaptureModes',),
    "PySide2.QtMultimedia.QCamera.load": (),
    "PySide2.QtMultimedia.QCamera.lockStatus": [(), ('PySide2.QtMultimedia.QCamera.LockType',)],
    "PySide2.QtMultimedia.QCamera.requestedLocks": (),
    "PySide2.QtMultimedia.QCamera.searchAndLock": [(), ('PySide2.QtMultimedia.QCamera.LockTypes',)],
    "PySide2.QtMultimedia.QCamera.setCaptureMode": ('PySide2.QtMultimedia.QCamera.CaptureModes',),
    "PySide2.QtMultimedia.QCamera.setViewfinder": [('PySide2.QtMultimedia.QAbstractVideoSurface',), ('PySide2.QtMultimediaWidgets.QGraphicsVideoItem',), ('PySide2.QtMultimediaWidgets.QVideoWidget',)],
    "PySide2.QtMultimedia.QCamera.setViewfinderSettings": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),
    "PySide2.QtMultimedia.QCamera.start": (),
    "PySide2.QtMultimedia.QCamera.state": (),
    "PySide2.QtMultimedia.QCamera.status": (),
    "PySide2.QtMultimedia.QCamera.stop": (),
    "PySide2.QtMultimedia.QCamera.supportedLocks": (),
    "PySide2.QtMultimedia.QCamera.supportedViewfinderFrameRateRanges": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),
    "PySide2.QtMultimedia.QCamera.supportedViewfinderPixelFormats": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),
    "PySide2.QtMultimedia.QCamera.supportedViewfinderResolutions": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),
    "PySide2.QtMultimedia.QCamera.supportedViewfinderSettings": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),
    "PySide2.QtMultimedia.QCamera.unload": (),
    "PySide2.QtMultimedia.QCamera.unlock": [(), ('PySide2.QtMultimedia.QCamera.LockTypes',)],
    "PySide2.QtMultimedia.QCamera.viewfinderSettings": (),

# class PySide2.QtMultimedia.QCameraCaptureBufferFormatControl:
    "PySide2.QtMultimedia.QCameraCaptureBufferFormatControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraCaptureBufferFormatControl.bufferFormat": (),
    "PySide2.QtMultimedia.QCameraCaptureBufferFormatControl.setBufferFormat": ('PySide2.QtMultimedia.QVideoFrame.PixelFormat',),
    "PySide2.QtMultimedia.QCameraCaptureBufferFormatControl.supportedBufferFormats": (),

# class PySide2.QtMultimedia.QCameraCaptureDestinationControl:
    "PySide2.QtMultimedia.QCameraCaptureDestinationControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraCaptureDestinationControl.captureDestination": (),
    "PySide2.QtMultimedia.QCameraCaptureDestinationControl.isCaptureDestinationSupported": ('PySide2.QtMultimedia.QCameraImageCapture.CaptureDestinations',),
    "PySide2.QtMultimedia.QCameraCaptureDestinationControl.setCaptureDestination": ('PySide2.QtMultimedia.QCameraImageCapture.CaptureDestinations',),

# class PySide2.QtMultimedia.QCameraControl:

# class PySide2.QtMultimedia.QCameraControl.PropertyChangeType:
    "PySide2.QtMultimedia.QCameraControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraControl.canChangeProperty": ('PySide2.QtMultimedia.QCameraControl.PropertyChangeType', 'PySide2.QtMultimedia.QCamera.Status'),
    "PySide2.QtMultimedia.QCameraControl.captureMode": (),
    "PySide2.QtMultimedia.QCameraControl.isCaptureModeSupported": ('PySide2.QtMultimedia.QCamera.CaptureModes',),
    "PySide2.QtMultimedia.QCameraControl.setCaptureMode": ('PySide2.QtMultimedia.QCamera.CaptureModes',),
    "PySide2.QtMultimedia.QCameraControl.setState": ('PySide2.QtMultimedia.QCamera.State',),
    "PySide2.QtMultimedia.QCameraControl.state": (),
    "PySide2.QtMultimedia.QCameraControl.status": (),

# class PySide2.QtMultimedia.QCameraExposure:

# class PySide2.QtMultimedia.QCameraExposure.ExposureMode:

# class PySide2.QtMultimedia.QCameraExposure.FlashMode:

# class PySide2.QtMultimedia.QCameraExposure.FlashModes:

# class PySide2.QtMultimedia.QCameraExposure.MeteringMode:
    "PySide2.QtMultimedia.QCameraExposure.aperture": (),
    "PySide2.QtMultimedia.QCameraExposure.exposureCompensation": (),
    "PySide2.QtMultimedia.QCameraExposure.exposureMode": (),
    "PySide2.QtMultimedia.QCameraExposure.flashMode": (),
    "PySide2.QtMultimedia.QCameraExposure.isAvailable": (),
    "PySide2.QtMultimedia.QCameraExposure.isExposureModeSupported": ('PySide2.QtMultimedia.QCameraExposure.ExposureMode',),
    "PySide2.QtMultimedia.QCameraExposure.isFlashModeSupported": ('PySide2.QtMultimedia.QCameraExposure.FlashModes',),
    "PySide2.QtMultimedia.QCameraExposure.isFlashReady": (),
    "PySide2.QtMultimedia.QCameraExposure.isMeteringModeSupported": ('PySide2.QtMultimedia.QCameraExposure.MeteringMode',),
    "PySide2.QtMultimedia.QCameraExposure.isoSensitivity": (),
    "PySide2.QtMultimedia.QCameraExposure.meteringMode": (),
    "PySide2.QtMultimedia.QCameraExposure.requestedAperture": (),
    "PySide2.QtMultimedia.QCameraExposure.requestedIsoSensitivity": (),
    "PySide2.QtMultimedia.QCameraExposure.requestedShutterSpeed": (),
    "PySide2.QtMultimedia.QCameraExposure.setAutoAperture": (),
    "PySide2.QtMultimedia.QCameraExposure.setAutoIsoSensitivity": (),
    "PySide2.QtMultimedia.QCameraExposure.setAutoShutterSpeed": (),
    "PySide2.QtMultimedia.QCameraExposure.setExposureCompensation": ('float',),
    "PySide2.QtMultimedia.QCameraExposure.setExposureMode": ('PySide2.QtMultimedia.QCameraExposure.ExposureMode',),
    "PySide2.QtMultimedia.QCameraExposure.setFlashMode": ('PySide2.QtMultimedia.QCameraExposure.FlashModes',),
    "PySide2.QtMultimedia.QCameraExposure.setManualAperture": ('float',),
    "PySide2.QtMultimedia.QCameraExposure.setManualIsoSensitivity": ('int',),
    "PySide2.QtMultimedia.QCameraExposure.setManualShutterSpeed": ('float',),
    "PySide2.QtMultimedia.QCameraExposure.setMeteringMode": ('PySide2.QtMultimedia.QCameraExposure.MeteringMode',),
    "PySide2.QtMultimedia.QCameraExposure.setSpotMeteringPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtMultimedia.QCameraExposure.shutterSpeed": (),
    "PySide2.QtMultimedia.QCameraExposure.spotMeteringPoint": (),

# class PySide2.QtMultimedia.QCameraExposureControl:

# class PySide2.QtMultimedia.QCameraExposureControl.ExposureParameter:
    "PySide2.QtMultimedia.QCameraExposureControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraExposureControl.actualValue": ('PySide2.QtMultimedia.QCameraExposureControl.ExposureParameter',),
    "PySide2.QtMultimedia.QCameraExposureControl.isParameterSupported": ('PySide2.QtMultimedia.QCameraExposureControl.ExposureParameter',),
    "PySide2.QtMultimedia.QCameraExposureControl.requestedValue": ('PySide2.QtMultimedia.QCameraExposureControl.ExposureParameter',),
    "PySide2.QtMultimedia.QCameraExposureControl.setValue": ('PySide2.QtMultimedia.QCameraExposureControl.ExposureParameter', 'typing.Any'),

# class PySide2.QtMultimedia.QCameraFeedbackControl:

# class PySide2.QtMultimedia.QCameraFeedbackControl.EventType:
    "PySide2.QtMultimedia.QCameraFeedbackControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraFeedbackControl.isEventFeedbackEnabled": ('PySide2.QtMultimedia.QCameraFeedbackControl.EventType',),
    "PySide2.QtMultimedia.QCameraFeedbackControl.isEventFeedbackLocked": ('PySide2.QtMultimedia.QCameraFeedbackControl.EventType',),
    "PySide2.QtMultimedia.QCameraFeedbackControl.resetEventFeedback": ('PySide2.QtMultimedia.QCameraFeedbackControl.EventType',),
    "PySide2.QtMultimedia.QCameraFeedbackControl.setEventFeedbackEnabled": ('PySide2.QtMultimedia.QCameraFeedbackControl.EventType', 'bool'),
    "PySide2.QtMultimedia.QCameraFeedbackControl.setEventFeedbackSound": ('PySide2.QtMultimedia.QCameraFeedbackControl.EventType', 'str'),

# class PySide2.QtMultimedia.QCameraFlashControl:
    "PySide2.QtMultimedia.QCameraFlashControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraFlashControl.flashMode": (),
    "PySide2.QtMultimedia.QCameraFlashControl.isFlashModeSupported": ('PySide2.QtMultimedia.QCameraExposure.FlashModes',),
    "PySide2.QtMultimedia.QCameraFlashControl.isFlashReady": (),
    "PySide2.QtMultimedia.QCameraFlashControl.setFlashMode": ('PySide2.QtMultimedia.QCameraExposure.FlashModes',),

# class PySide2.QtMultimedia.QCameraFocus:

# class PySide2.QtMultimedia.QCameraFocus.FocusMode:

# class PySide2.QtMultimedia.QCameraFocus.FocusModes:

# class PySide2.QtMultimedia.QCameraFocus.FocusPointMode:
    "PySide2.QtMultimedia.QCameraFocus.customFocusPoint": (),
    "PySide2.QtMultimedia.QCameraFocus.digitalZoom": (),
    "PySide2.QtMultimedia.QCameraFocus.focusMode": (),
    "PySide2.QtMultimedia.QCameraFocus.focusPointMode": (),
    "PySide2.QtMultimedia.QCameraFocus.focusZones": (),
    "PySide2.QtMultimedia.QCameraFocus.isAvailable": (),
    "PySide2.QtMultimedia.QCameraFocus.isFocusModeSupported": ('PySide2.QtMultimedia.QCameraFocus.FocusModes',),
    "PySide2.QtMultimedia.QCameraFocus.isFocusPointModeSupported": ('PySide2.QtMultimedia.QCameraFocus.FocusPointMode',),
    "PySide2.QtMultimedia.QCameraFocus.maximumDigitalZoom": (),
    "PySide2.QtMultimedia.QCameraFocus.maximumOpticalZoom": (),
    "PySide2.QtMultimedia.QCameraFocus.opticalZoom": (),
    "PySide2.QtMultimedia.QCameraFocus.setCustomFocusPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtMultimedia.QCameraFocus.setFocusMode": ('PySide2.QtMultimedia.QCameraFocus.FocusModes',),
    "PySide2.QtMultimedia.QCameraFocus.setFocusPointMode": ('PySide2.QtMultimedia.QCameraFocus.FocusPointMode',),
    "PySide2.QtMultimedia.QCameraFocus.zoomTo": ('float', 'float'),

# class PySide2.QtMultimedia.QCameraFocusControl:
    "PySide2.QtMultimedia.QCameraFocusControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraFocusControl.customFocusPoint": (),
    "PySide2.QtMultimedia.QCameraFocusControl.focusMode": (),
    "PySide2.QtMultimedia.QCameraFocusControl.focusPointMode": (),
    "PySide2.QtMultimedia.QCameraFocusControl.focusZones": (),
    "PySide2.QtMultimedia.QCameraFocusControl.isFocusModeSupported": ('PySide2.QtMultimedia.QCameraFocus.FocusModes',),
    "PySide2.QtMultimedia.QCameraFocusControl.isFocusPointModeSupported": ('PySide2.QtMultimedia.QCameraFocus.FocusPointMode',),
    "PySide2.QtMultimedia.QCameraFocusControl.setCustomFocusPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtMultimedia.QCameraFocusControl.setFocusMode": ('PySide2.QtMultimedia.QCameraFocus.FocusModes',),
    "PySide2.QtMultimedia.QCameraFocusControl.setFocusPointMode": ('PySide2.QtMultimedia.QCameraFocus.FocusPointMode',),

# class PySide2.QtMultimedia.QCameraFocusZone:

# class PySide2.QtMultimedia.QCameraFocusZone.FocusZoneStatus:
    "PySide2.QtMultimedia.QCameraFocusZone.__init__": [(), ('PySide2.QtCore.QRectF', 'PySide2.QtMultimedia.QCameraFocusZone.FocusZoneStatus'), ('PySide2.QtMultimedia.QCameraFocusZone',)],
    "PySide2.QtMultimedia.QCameraFocusZone.__copy__": (),
    "PySide2.QtMultimedia.QCameraFocusZone.area": (),
    "PySide2.QtMultimedia.QCameraFocusZone.isValid": (),
    "PySide2.QtMultimedia.QCameraFocusZone.setStatus": ('PySide2.QtMultimedia.QCameraFocusZone.FocusZoneStatus',),
    "PySide2.QtMultimedia.QCameraFocusZone.status": (),

# class PySide2.QtMultimedia.QCameraImageCapture:

# class PySide2.QtMultimedia.QCameraImageCapture.CaptureDestination:

# class PySide2.QtMultimedia.QCameraImageCapture.CaptureDestinations:

# class PySide2.QtMultimedia.QCameraImageCapture.DriveMode:

# class PySide2.QtMultimedia.QCameraImageCapture.Error:
    "PySide2.QtMultimedia.QCameraImageCapture.__init__": ('PySide2.QtMultimedia.QMediaObject', 'PySide2.QtCore.QObject'),
    "PySide2.QtMultimedia.QCameraImageCapture.availability": (),
    "PySide2.QtMultimedia.QCameraImageCapture.bufferFormat": (),
    "PySide2.QtMultimedia.QCameraImageCapture.cancelCapture": (),
    "PySide2.QtMultimedia.QCameraImageCapture.capture": ('str',),
    "PySide2.QtMultimedia.QCameraImageCapture.captureDestination": (),
    "PySide2.QtMultimedia.QCameraImageCapture.encodingSettings": (),
    "PySide2.QtMultimedia.QCameraImageCapture.error": (),
    "PySide2.QtMultimedia.QCameraImageCapture.errorString": (),
    "PySide2.QtMultimedia.QCameraImageCapture.imageCodecDescription": ('str',),
    "PySide2.QtMultimedia.QCameraImageCapture.isAvailable": (),
    "PySide2.QtMultimedia.QCameraImageCapture.isCaptureDestinationSupported": ('PySide2.QtMultimedia.QCameraImageCapture.CaptureDestinations',),
    "PySide2.QtMultimedia.QCameraImageCapture.isReadyForCapture": (),
    "PySide2.QtMultimedia.QCameraImageCapture.mediaObject": (),
    "PySide2.QtMultimedia.QCameraImageCapture.setBufferFormat": ('PySide2.QtMultimedia.QVideoFrame.PixelFormat',),
    "PySide2.QtMultimedia.QCameraImageCapture.setCaptureDestination": ('PySide2.QtMultimedia.QCameraImageCapture.CaptureDestinations',),
    "PySide2.QtMultimedia.QCameraImageCapture.setEncodingSettings": ('PySide2.QtMultimedia.QImageEncoderSettings',),
    "PySide2.QtMultimedia.QCameraImageCapture.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),
    "PySide2.QtMultimedia.QCameraImageCapture.supportedBufferFormats": (),
    "PySide2.QtMultimedia.QCameraImageCapture.supportedImageCodecs": (),

# class PySide2.QtMultimedia.QCameraImageCaptureControl:
    "PySide2.QtMultimedia.QCameraImageCaptureControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraImageCaptureControl.cancelCapture": (),
    "PySide2.QtMultimedia.QCameraImageCaptureControl.capture": ('str',),
    "PySide2.QtMultimedia.QCameraImageCaptureControl.driveMode": (),
    "PySide2.QtMultimedia.QCameraImageCaptureControl.isReadyForCapture": (),
    "PySide2.QtMultimedia.QCameraImageCaptureControl.setDriveMode": ('PySide2.QtMultimedia.QCameraImageCapture.DriveMode',),

# class PySide2.QtMultimedia.QCameraImageProcessing:

# class PySide2.QtMultimedia.QCameraImageProcessing.ColorFilter:

# class PySide2.QtMultimedia.QCameraImageProcessing.WhiteBalanceMode:
    "PySide2.QtMultimedia.QCameraImageProcessing.brightness": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.colorFilter": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.contrast": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.denoisingLevel": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.isAvailable": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.isColorFilterSupported": ('PySide2.QtMultimedia.QCameraImageProcessing.ColorFilter',),
    "PySide2.QtMultimedia.QCameraImageProcessing.isWhiteBalanceModeSupported": ('PySide2.QtMultimedia.QCameraImageProcessing.WhiteBalanceMode',),
    "PySide2.QtMultimedia.QCameraImageProcessing.manualWhiteBalance": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.saturation": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.setBrightness": ('float',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setColorFilter": ('PySide2.QtMultimedia.QCameraImageProcessing.ColorFilter',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setContrast": ('float',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setDenoisingLevel": ('float',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setManualWhiteBalance": ('float',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setSaturation": ('float',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setSharpeningLevel": ('float',),
    "PySide2.QtMultimedia.QCameraImageProcessing.setWhiteBalanceMode": ('PySide2.QtMultimedia.QCameraImageProcessing.WhiteBalanceMode',),
    "PySide2.QtMultimedia.QCameraImageProcessing.sharpeningLevel": (),
    "PySide2.QtMultimedia.QCameraImageProcessing.whiteBalanceMode": (),

# class PySide2.QtMultimedia.QCameraImageProcessingControl:

# class PySide2.QtMultimedia.QCameraImageProcessingControl.ProcessingParameter:
    "PySide2.QtMultimedia.QCameraImageProcessingControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraImageProcessingControl.isParameterSupported": ('PySide2.QtMultimedia.QCameraImageProcessingControl.ProcessingParameter',),
    "PySide2.QtMultimedia.QCameraImageProcessingControl.isParameterValueSupported": ('PySide2.QtMultimedia.QCameraImageProcessingControl.ProcessingParameter', 'typing.Any'),
    "PySide2.QtMultimedia.QCameraImageProcessingControl.parameter": ('PySide2.QtMultimedia.QCameraImageProcessingControl.ProcessingParameter',),
    "PySide2.QtMultimedia.QCameraImageProcessingControl.setParameter": ('PySide2.QtMultimedia.QCameraImageProcessingControl.ProcessingParameter', 'typing.Any'),

# class PySide2.QtMultimedia.QCameraInfo:
    "PySide2.QtMultimedia.QCameraInfo.__init__": [('PySide2.QtCore.QByteArray',), ('PySide2.QtMultimedia.QCamera',), ('PySide2.QtMultimedia.QCameraInfo',)],
    "PySide2.QtMultimedia.QCameraInfo.__copy__": (),
    "PySide2.QtMultimedia.QCameraInfo.availableCameras": ('PySide2.QtMultimedia.QCamera.Position',),
    "PySide2.QtMultimedia.QCameraInfo.defaultCamera": (),
    "PySide2.QtMultimedia.QCameraInfo.description": (),
    "PySide2.QtMultimedia.QCameraInfo.deviceName": (),
    "PySide2.QtMultimedia.QCameraInfo.isNull": (),
    "PySide2.QtMultimedia.QCameraInfo.orientation": (),
    "PySide2.QtMultimedia.QCameraInfo.position": (),

# class PySide2.QtMultimedia.QCameraInfoControl:
    "PySide2.QtMultimedia.QCameraInfoControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraInfoControl.cameraOrientation": ('str',),
    "PySide2.QtMultimedia.QCameraInfoControl.cameraPosition": ('str',),

# class PySide2.QtMultimedia.QCameraLocksControl:
    "PySide2.QtMultimedia.QCameraLocksControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraLocksControl.lockStatus": ('PySide2.QtMultimedia.QCamera.LockType',),
    "PySide2.QtMultimedia.QCameraLocksControl.searchAndLock": ('PySide2.QtMultimedia.QCamera.LockTypes',),
    "PySide2.QtMultimedia.QCameraLocksControl.supportedLocks": (),
    "PySide2.QtMultimedia.QCameraLocksControl.unlock": ('PySide2.QtMultimedia.QCamera.LockTypes',),

# class PySide2.QtMultimedia.QCameraViewfinderSettings:
    "PySide2.QtMultimedia.QCameraViewfinderSettings.__init__": [(), ('PySide2.QtMultimedia.QCameraViewfinderSettings',)],
    "PySide2.QtMultimedia.QCameraViewfinderSettings.__copy__": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.isNull": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.maximumFrameRate": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.minimumFrameRate": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.pixelAspectRatio": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.pixelFormat": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.resolution": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.setMaximumFrameRate": ('float',),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.setMinimumFrameRate": ('float',),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.setPixelAspectRatio": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtMultimedia.QCameraViewfinderSettings.setPixelFormat": ('PySide2.QtMultimedia.QVideoFrame.PixelFormat',),
    "PySide2.QtMultimedia.QCameraViewfinderSettings.setResolution": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtMultimedia.QCameraViewfinderSettings.swap": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),

# class PySide2.QtMultimedia.QCameraViewfinderSettingsControl:

# class PySide2.QtMultimedia.QCameraViewfinderSettingsControl.ViewfinderParameter:
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl.isViewfinderParameterSupported": ('PySide2.QtMultimedia.QCameraViewfinderSettingsControl.ViewfinderParameter',),
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl.setViewfinderParameter": ('PySide2.QtMultimedia.QCameraViewfinderSettingsControl.ViewfinderParameter', 'typing.Any'),
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl.viewfinderParameter": ('PySide2.QtMultimedia.QCameraViewfinderSettingsControl.ViewfinderParameter',),

# class PySide2.QtMultimedia.QCameraViewfinderSettingsControl2:
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl2.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl2.setViewfinderSettings": ('PySide2.QtMultimedia.QCameraViewfinderSettings',),
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl2.supportedViewfinderSettings": (),
    "PySide2.QtMultimedia.QCameraViewfinderSettingsControl2.viewfinderSettings": (),

# class PySide2.QtMultimedia.QCameraZoomControl:
    "PySide2.QtMultimedia.QCameraZoomControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCameraZoomControl.currentDigitalZoom": (),
    "PySide2.QtMultimedia.QCameraZoomControl.currentOpticalZoom": (),
    "PySide2.QtMultimedia.QCameraZoomControl.maximumDigitalZoom": (),
    "PySide2.QtMultimedia.QCameraZoomControl.maximumOpticalZoom": (),
    "PySide2.QtMultimedia.QCameraZoomControl.requestedDigitalZoom": (),
    "PySide2.QtMultimedia.QCameraZoomControl.requestedOpticalZoom": (),
    "PySide2.QtMultimedia.QCameraZoomControl.zoomTo": ('float', 'float'),

# class PySide2.QtMultimedia.QCustomAudioRoleControl:
    "PySide2.QtMultimedia.QCustomAudioRoleControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QCustomAudioRoleControl.customAudioRole": (),
    "PySide2.QtMultimedia.QCustomAudioRoleControl.setCustomAudioRole": ('str',),
    "PySide2.QtMultimedia.QCustomAudioRoleControl.supportedCustomAudioRoles": (),

# class PySide2.QtMultimedia.QImageEncoderControl:
    "PySide2.QtMultimedia.QImageEncoderControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QImageEncoderControl.imageCodecDescription": ('str',),
    "PySide2.QtMultimedia.QImageEncoderControl.imageSettings": (),
    "PySide2.QtMultimedia.QImageEncoderControl.setImageSettings": ('PySide2.QtMultimedia.QImageEncoderSettings',),
    "PySide2.QtMultimedia.QImageEncoderControl.supportedImageCodecs": (),

# class PySide2.QtMultimedia.QImageEncoderSettings:
    "PySide2.QtMultimedia.QImageEncoderSettings.__init__": [(), ('PySide2.QtMultimedia.QImageEncoderSettings',)],
    "PySide2.QtMultimedia.QImageEncoderSettings.__copy__": (),
    "PySide2.QtMultimedia.QImageEncoderSettings.codec": (),
    "PySide2.QtMultimedia.QImageEncoderSettings.encodingOption": ('str',),
    "PySide2.QtMultimedia.QImageEncoderSettings.encodingOptions": (),
    "PySide2.QtMultimedia.QImageEncoderSettings.isNull": (),
    "PySide2.QtMultimedia.QImageEncoderSettings.quality": (),
    "PySide2.QtMultimedia.QImageEncoderSettings.resolution": (),
    "PySide2.QtMultimedia.QImageEncoderSettings.setCodec": ('str',),
    "PySide2.QtMultimedia.QImageEncoderSettings.setEncodingOption": ('str', 'typing.Any'),
    "PySide2.QtMultimedia.QImageEncoderSettings.setEncodingOptions": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtMultimedia.QImageEncoderSettings.setQuality": ('PySide2.QtMultimedia.QMultimedia.EncodingQuality',),
    "PySide2.QtMultimedia.QImageEncoderSettings.setResolution": [('PySide2.QtCore.QSize',), ('int', 'int')],

# class PySide2.QtMultimedia.QMediaAudioProbeControl:
    "PySide2.QtMultimedia.QMediaAudioProbeControl.__init__": ('PySide2.QtCore.QObject',),

# class PySide2.QtMultimedia.QMediaAvailabilityControl:
    "PySide2.QtMultimedia.QMediaAvailabilityControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaAvailabilityControl.availability": (),

# class PySide2.QtMultimedia.QMediaBindableInterface:
    "PySide2.QtMultimedia.QMediaBindableInterface.__init__": (),
    "PySide2.QtMultimedia.QMediaBindableInterface.mediaObject": (),
    "PySide2.QtMultimedia.QMediaBindableInterface.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),

# class PySide2.QtMultimedia.QMediaContainerControl:
    "PySide2.QtMultimedia.QMediaContainerControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaContainerControl.containerDescription": ('str',),
    "PySide2.QtMultimedia.QMediaContainerControl.containerFormat": (),
    "PySide2.QtMultimedia.QMediaContainerControl.setContainerFormat": ('str',),
    "PySide2.QtMultimedia.QMediaContainerControl.supportedContainers": (),

# class PySide2.QtMultimedia.QMediaContent:
    "PySide2.QtMultimedia.QMediaContent.__init__": [(), ('PySide2.QtCore.QUrl',), ('PySide2.QtMultimedia.QMediaContent',), ('PySide2.QtMultimedia.QMediaPlaylist', 'PySide2.QtCore.QUrl', 'bool'), ('PySide2.QtMultimedia.QMediaResource',), ('PySide2.QtNetwork.QNetworkRequest',), ('typing.Sequence[PySide2.QtMultimedia.QMediaResource]',)],
    "PySide2.QtMultimedia.QMediaContent.__copy__": (),
    "PySide2.QtMultimedia.QMediaContent.canonicalRequest": (),
    "PySide2.QtMultimedia.QMediaContent.canonicalResource": (),
    "PySide2.QtMultimedia.QMediaContent.canonicalUrl": (),
    "PySide2.QtMultimedia.QMediaContent.isNull": (),
    "PySide2.QtMultimedia.QMediaContent.playlist": (),
    "PySide2.QtMultimedia.QMediaContent.request": (),
    "PySide2.QtMultimedia.QMediaContent.resources": (),

# class PySide2.QtMultimedia.QMediaControl:
    "PySide2.QtMultimedia.QMediaControl.__init__": ('PySide2.QtCore.QObject',),

# class PySide2.QtMultimedia.QMediaGaplessPlaybackControl:
    "PySide2.QtMultimedia.QMediaGaplessPlaybackControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaGaplessPlaybackControl.crossfadeTime": (),
    "PySide2.QtMultimedia.QMediaGaplessPlaybackControl.isCrossfadeSupported": (),
    "PySide2.QtMultimedia.QMediaGaplessPlaybackControl.nextMedia": (),
    "PySide2.QtMultimedia.QMediaGaplessPlaybackControl.setCrossfadeTime": ('float',),
    "PySide2.QtMultimedia.QMediaGaplessPlaybackControl.setNextMedia": ('PySide2.QtMultimedia.QMediaContent',),

# class PySide2.QtMultimedia.QMediaNetworkAccessControl:
    "PySide2.QtMultimedia.QMediaNetworkAccessControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaNetworkAccessControl.currentConfiguration": (),
    "PySide2.QtMultimedia.QMediaNetworkAccessControl.setConfigurations": ('typing.Sequence[PySide2.QtNetwork.QNetworkConfiguration]',),

# class PySide2.QtMultimedia.QMediaObject:
    "PySide2.QtMultimedia.QMediaObject.__init__": ('PySide2.QtCore.QObject', 'PySide2.QtMultimedia.QMediaService'),
    "PySide2.QtMultimedia.QMediaObject.addPropertyWatch": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtMultimedia.QMediaObject.availability": (),
    "PySide2.QtMultimedia.QMediaObject.availableMetaData": (),
    "PySide2.QtMultimedia.QMediaObject.bind": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaObject.isAvailable": (),
    "PySide2.QtMultimedia.QMediaObject.isMetaDataAvailable": (),
    "PySide2.QtMultimedia.QMediaObject.metaData": ('str',),
    "PySide2.QtMultimedia.QMediaObject.notifyInterval": (),
    "PySide2.QtMultimedia.QMediaObject.removePropertyWatch": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtMultimedia.QMediaObject.service": (),
    "PySide2.QtMultimedia.QMediaObject.setNotifyInterval": ('int',),
    "PySide2.QtMultimedia.QMediaObject.unbind": ('PySide2.QtCore.QObject',),

# class PySide2.QtMultimedia.QMediaPlayer:

# class PySide2.QtMultimedia.QMediaPlayer.Error:

# class PySide2.QtMultimedia.QMediaPlayer.Flag:

# class PySide2.QtMultimedia.QMediaPlayer.Flags:

# class PySide2.QtMultimedia.QMediaPlayer.MediaStatus:

# class PySide2.QtMultimedia.QMediaPlayer.State:
    "PySide2.QtMultimedia.QMediaPlayer.__init__": ('PySide2.QtCore.QObject', 'PySide2.QtMultimedia.QMediaPlayer.Flags'),
    "PySide2.QtMultimedia.QMediaPlayer.audioRole": (),
    "PySide2.QtMultimedia.QMediaPlayer.availability": (),
    "PySide2.QtMultimedia.QMediaPlayer.bind": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaPlayer.bufferStatus": (),
    "PySide2.QtMultimedia.QMediaPlayer.currentMedia": (),
    "PySide2.QtMultimedia.QMediaPlayer.currentNetworkConfiguration": (),
    "PySide2.QtMultimedia.QMediaPlayer.customAudioRole": (),
    "PySide2.QtMultimedia.QMediaPlayer.duration": (),
    "PySide2.QtMultimedia.QMediaPlayer.error": (),
    "PySide2.QtMultimedia.QMediaPlayer.errorString": (),
    "PySide2.QtMultimedia.QMediaPlayer.hasSupport": ('str', 'typing.Sequence[str]', 'PySide2.QtMultimedia.QMediaPlayer.Flags'),
    "PySide2.QtMultimedia.QMediaPlayer.isAudioAvailable": (),
    "PySide2.QtMultimedia.QMediaPlayer.isMuted": (),
    "PySide2.QtMultimedia.QMediaPlayer.isSeekable": (),
    "PySide2.QtMultimedia.QMediaPlayer.isVideoAvailable": (),
    "PySide2.QtMultimedia.QMediaPlayer.media": (),
    "PySide2.QtMultimedia.QMediaPlayer.mediaStatus": (),
    "PySide2.QtMultimedia.QMediaPlayer.mediaStream": (),
    "PySide2.QtMultimedia.QMediaPlayer.pause": (),
    "PySide2.QtMultimedia.QMediaPlayer.play": (),
    "PySide2.QtMultimedia.QMediaPlayer.playbackRate": (),
    "PySide2.QtMultimedia.QMediaPlayer.playlist": (),
    "PySide2.QtMultimedia.QMediaPlayer.position": (),
    "PySide2.QtMultimedia.QMediaPlayer.setAudioRole": ('PySide2.QtMultimedia.QAudio.Role',),
    "PySide2.QtMultimedia.QMediaPlayer.setCustomAudioRole": ('str',),
    "PySide2.QtMultimedia.QMediaPlayer.setMedia": ('PySide2.QtMultimedia.QMediaContent', 'PySide2.QtCore.QIODevice'),
    "PySide2.QtMultimedia.QMediaPlayer.setMuted": ('bool',),
    "PySide2.QtMultimedia.QMediaPlayer.setNetworkConfigurations": ('typing.Sequence[PySide2.QtNetwork.QNetworkConfiguration]',),
    "PySide2.QtMultimedia.QMediaPlayer.setPlaybackRate": ('float',),
    "PySide2.QtMultimedia.QMediaPlayer.setPlaylist": ('PySide2.QtMultimedia.QMediaPlaylist',),
    "PySide2.QtMultimedia.QMediaPlayer.setPosition": ('int',),
    "PySide2.QtMultimedia.QMediaPlayer.setVideoOutput": [('PySide2.QtMultimedia.QAbstractVideoSurface',), ('PySide2.QtMultimediaWidgets.QGraphicsVideoItem',), ('PySide2.QtMultimediaWidgets.QVideoWidget',)],
    "PySide2.QtMultimedia.QMediaPlayer.setVolume": ('int',),
    "PySide2.QtMultimedia.QMediaPlayer.state": (),
    "PySide2.QtMultimedia.QMediaPlayer.stop": (),
    "PySide2.QtMultimedia.QMediaPlayer.supportedAudioRoles": (),
    "PySide2.QtMultimedia.QMediaPlayer.supportedCustomAudioRoles": (),
    "PySide2.QtMultimedia.QMediaPlayer.supportedMimeTypes": ('PySide2.QtMultimedia.QMediaPlayer.Flags',),
    "PySide2.QtMultimedia.QMediaPlayer.unbind": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaPlayer.volume": (),

# class PySide2.QtMultimedia.QMediaPlayerControl:
    "PySide2.QtMultimedia.QMediaPlayerControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaPlayerControl.availablePlaybackRanges": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.bufferStatus": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.duration": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.isAudioAvailable": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.isMuted": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.isSeekable": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.isVideoAvailable": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.media": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.mediaStatus": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.mediaStream": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.pause": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.play": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.playbackRate": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.position": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.setMedia": ('PySide2.QtMultimedia.QMediaContent', 'PySide2.QtCore.QIODevice'),
    "PySide2.QtMultimedia.QMediaPlayerControl.setMuted": ('bool',),
    "PySide2.QtMultimedia.QMediaPlayerControl.setPlaybackRate": ('float',),
    "PySide2.QtMultimedia.QMediaPlayerControl.setPosition": ('int',),
    "PySide2.QtMultimedia.QMediaPlayerControl.setVolume": ('int',),
    "PySide2.QtMultimedia.QMediaPlayerControl.state": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.stop": (),
    "PySide2.QtMultimedia.QMediaPlayerControl.volume": (),

# class PySide2.QtMultimedia.QMediaPlaylist:

# class PySide2.QtMultimedia.QMediaPlaylist.Error:

# class PySide2.QtMultimedia.QMediaPlaylist.PlaybackMode:
    "PySide2.QtMultimedia.QMediaPlaylist.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaPlaylist.addMedia": [('PySide2.QtMultimedia.QMediaContent',), ('typing.Sequence[PySide2.QtMultimedia.QMediaContent]',)],
    "PySide2.QtMultimedia.QMediaPlaylist.clear": (),
    "PySide2.QtMultimedia.QMediaPlaylist.currentIndex": (),
    "PySide2.QtMultimedia.QMediaPlaylist.currentMedia": (),
    "PySide2.QtMultimedia.QMediaPlaylist.error": (),
    "PySide2.QtMultimedia.QMediaPlaylist.errorString": (),
    "PySide2.QtMultimedia.QMediaPlaylist.insertMedia": [('int', 'PySide2.QtMultimedia.QMediaContent'), ('int', 'typing.Sequence[PySide2.QtMultimedia.QMediaContent]')],
    "PySide2.QtMultimedia.QMediaPlaylist.isEmpty": (),
    "PySide2.QtMultimedia.QMediaPlaylist.isReadOnly": (),
    "PySide2.QtMultimedia.QMediaPlaylist.load": [('PySide2.QtCore.QIODevice', 'str'), ('PySide2.QtCore.QUrl', 'str'), ('PySide2.QtNetwork.QNetworkRequest', 'str')],
    "PySide2.QtMultimedia.QMediaPlaylist.media": ('int',),
    "PySide2.QtMultimedia.QMediaPlaylist.mediaCount": (),
    "PySide2.QtMultimedia.QMediaPlaylist.mediaObject": (),
    "PySide2.QtMultimedia.QMediaPlaylist.moveMedia": ('int', 'int'),
    "PySide2.QtMultimedia.QMediaPlaylist.nextIndex": ('int',),
    "PySide2.QtMultimedia.QMediaPlaylist.playbackMode": (),
    "PySide2.QtMultimedia.QMediaPlaylist.previous": (),
    "PySide2.QtMultimedia.QMediaPlaylist.previousIndex": ('int',),
    "PySide2.QtMultimedia.QMediaPlaylist.removeMedia": [('int',), ('int', 'int')],
    "PySide2.QtMultimedia.QMediaPlaylist.save": [('PySide2.QtCore.QIODevice', 'str'), ('PySide2.QtCore.QUrl', 'str')],
    "PySide2.QtMultimedia.QMediaPlaylist.setCurrentIndex": ('int',),
    "PySide2.QtMultimedia.QMediaPlaylist.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),
    "PySide2.QtMultimedia.QMediaPlaylist.setPlaybackMode": ('PySide2.QtMultimedia.QMediaPlaylist.PlaybackMode',),
    "PySide2.QtMultimedia.QMediaPlaylist.shuffle": (),

# class PySide2.QtMultimedia.QMediaRecorder:

# class PySide2.QtMultimedia.QMediaRecorder.Error:

# class PySide2.QtMultimedia.QMediaRecorder.State:

# class PySide2.QtMultimedia.QMediaRecorder.Status:
    "PySide2.QtMultimedia.QMediaRecorder.__init__": ('PySide2.QtMultimedia.QMediaObject', 'PySide2.QtCore.QObject'),
    "PySide2.QtMultimedia.QMediaRecorder.actualLocation": (),
    "PySide2.QtMultimedia.QMediaRecorder.audioCodecDescription": ('str',),
    "PySide2.QtMultimedia.QMediaRecorder.audioSettings": (),
    "PySide2.QtMultimedia.QMediaRecorder.availability": (),
    "PySide2.QtMultimedia.QMediaRecorder.availableMetaData": (),
    "PySide2.QtMultimedia.QMediaRecorder.containerDescription": ('str',),
    "PySide2.QtMultimedia.QMediaRecorder.containerFormat": (),
    "PySide2.QtMultimedia.QMediaRecorder.duration": (),
    "PySide2.QtMultimedia.QMediaRecorder.error": (),
    "PySide2.QtMultimedia.QMediaRecorder.errorString": (),
    "PySide2.QtMultimedia.QMediaRecorder.isAvailable": (),
    "PySide2.QtMultimedia.QMediaRecorder.isMetaDataAvailable": (),
    "PySide2.QtMultimedia.QMediaRecorder.isMetaDataWritable": (),
    "PySide2.QtMultimedia.QMediaRecorder.isMuted": (),
    "PySide2.QtMultimedia.QMediaRecorder.mediaObject": (),
    "PySide2.QtMultimedia.QMediaRecorder.metaData": ('str',),
    "PySide2.QtMultimedia.QMediaRecorder.outputLocation": (),
    "PySide2.QtMultimedia.QMediaRecorder.pause": (),
    "PySide2.QtMultimedia.QMediaRecorder.record": (),
    "PySide2.QtMultimedia.QMediaRecorder.setAudioSettings": ('PySide2.QtMultimedia.QAudioEncoderSettings',),
    "PySide2.QtMultimedia.QMediaRecorder.setContainerFormat": ('str',),
    "PySide2.QtMultimedia.QMediaRecorder.setEncodingSettings": ('PySide2.QtMultimedia.QAudioEncoderSettings', 'PySide2.QtMultimedia.QVideoEncoderSettings', 'str'),
    "PySide2.QtMultimedia.QMediaRecorder.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),
    "PySide2.QtMultimedia.QMediaRecorder.setMetaData": ('str', 'typing.Any'),
    "PySide2.QtMultimedia.QMediaRecorder.setMuted": ('bool',),
    "PySide2.QtMultimedia.QMediaRecorder.setOutputLocation": ('PySide2.QtCore.QUrl',),
    "PySide2.QtMultimedia.QMediaRecorder.setVideoSettings": ('PySide2.QtMultimedia.QVideoEncoderSettings',),
    "PySide2.QtMultimedia.QMediaRecorder.setVolume": ('float',),
    "PySide2.QtMultimedia.QMediaRecorder.state": (),
    "PySide2.QtMultimedia.QMediaRecorder.status": (),
    "PySide2.QtMultimedia.QMediaRecorder.stop": (),
    "PySide2.QtMultimedia.QMediaRecorder.supportedAudioCodecs": (),
    "PySide2.QtMultimedia.QMediaRecorder.supportedContainers": (),
    "PySide2.QtMultimedia.QMediaRecorder.supportedVideoCodecs": (),
    "PySide2.QtMultimedia.QMediaRecorder.videoCodecDescription": ('str',),
    "PySide2.QtMultimedia.QMediaRecorder.videoSettings": (),
    "PySide2.QtMultimedia.QMediaRecorder.volume": (),

# class PySide2.QtMultimedia.QMediaRecorderControl:
    "PySide2.QtMultimedia.QMediaRecorderControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaRecorderControl.applySettings": (),
    "PySide2.QtMultimedia.QMediaRecorderControl.duration": (),
    "PySide2.QtMultimedia.QMediaRecorderControl.isMuted": (),
    "PySide2.QtMultimedia.QMediaRecorderControl.outputLocation": (),
    "PySide2.QtMultimedia.QMediaRecorderControl.setMuted": ('bool',),
    "PySide2.QtMultimedia.QMediaRecorderControl.setOutputLocation": ('PySide2.QtCore.QUrl',),
    "PySide2.QtMultimedia.QMediaRecorderControl.setState": ('PySide2.QtMultimedia.QMediaRecorder.State',),
    "PySide2.QtMultimedia.QMediaRecorderControl.setVolume": ('float',),
    "PySide2.QtMultimedia.QMediaRecorderControl.state": (),
    "PySide2.QtMultimedia.QMediaRecorderControl.status": (),
    "PySide2.QtMultimedia.QMediaRecorderControl.volume": (),

# class PySide2.QtMultimedia.QMediaResource:
    "PySide2.QtMultimedia.QMediaResource.__init__": [(), ('PySide2.QtCore.QUrl', 'str'), ('PySide2.QtMultimedia.QMediaResource',), ('PySide2.QtNetwork.QNetworkRequest', 'str')],
    "PySide2.QtMultimedia.QMediaResource.__copy__": (),
    "PySide2.QtMultimedia.QMediaResource.audioBitRate": (),
    "PySide2.QtMultimedia.QMediaResource.audioCodec": (),
    "PySide2.QtMultimedia.QMediaResource.channelCount": (),
    "PySide2.QtMultimedia.QMediaResource.dataSize": (),
    "PySide2.QtMultimedia.QMediaResource.isNull": (),
    "PySide2.QtMultimedia.QMediaResource.language": (),
    "PySide2.QtMultimedia.QMediaResource.mimeType": (),
    "PySide2.QtMultimedia.QMediaResource.request": (),
    "PySide2.QtMultimedia.QMediaResource.resolution": (),
    "PySide2.QtMultimedia.QMediaResource.sampleRate": (),
    "PySide2.QtMultimedia.QMediaResource.setAudioBitRate": ('int',),
    "PySide2.QtMultimedia.QMediaResource.setAudioCodec": ('str',),
    "PySide2.QtMultimedia.QMediaResource.setChannelCount": ('int',),
    "PySide2.QtMultimedia.QMediaResource.setDataSize": ('int',),
    "PySide2.QtMultimedia.QMediaResource.setLanguage": ('str',),
    "PySide2.QtMultimedia.QMediaResource.setResolution": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtMultimedia.QMediaResource.setSampleRate": ('int',),
    "PySide2.QtMultimedia.QMediaResource.setVideoBitRate": ('int',),
    "PySide2.QtMultimedia.QMediaResource.setVideoCodec": ('str',),
    "PySide2.QtMultimedia.QMediaResource.url": (),
    "PySide2.QtMultimedia.QMediaResource.videoBitRate": (),
    "PySide2.QtMultimedia.QMediaResource.videoCodec": (),

# class PySide2.QtMultimedia.QMediaService:
    "PySide2.QtMultimedia.QMediaService.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaService.releaseControl": ('PySide2.QtMultimedia.QMediaControl',),
    "PySide2.QtMultimedia.QMediaService.requestControl": ('str',),

# class PySide2.QtMultimedia.QMediaServiceCameraInfoInterface:
    "PySide2.QtMultimedia.QMediaServiceCameraInfoInterface.__init__": (),
    "PySide2.QtMultimedia.QMediaServiceCameraInfoInterface.cameraOrientation": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtMultimedia.QMediaServiceCameraInfoInterface.cameraPosition": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtMultimedia.QMediaServiceDefaultDeviceInterface:
    "PySide2.QtMultimedia.QMediaServiceDefaultDeviceInterface.__init__": (),
    "PySide2.QtMultimedia.QMediaServiceDefaultDeviceInterface.defaultDevice": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtMultimedia.QMediaServiceFeaturesInterface:
    "PySide2.QtMultimedia.QMediaServiceFeaturesInterface.__init__": (),
    "PySide2.QtMultimedia.QMediaServiceFeaturesInterface.supportedFeatures": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtMultimedia.QMediaServiceProviderHint:

# class PySide2.QtMultimedia.QMediaServiceProviderHint.Feature:

# class PySide2.QtMultimedia.QMediaServiceProviderHint.Features:

# class PySide2.QtMultimedia.QMediaServiceProviderHint.Type:
    "PySide2.QtMultimedia.QMediaServiceProviderHint.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtMultimedia.QCamera.Position',), ('PySide2.QtMultimedia.QMediaServiceProviderHint',), ('PySide2.QtMultimedia.QMediaServiceProviderHint.Features',), ('str', 'typing.Sequence[str]')],
    "PySide2.QtMultimedia.QMediaServiceProviderHint.__copy__": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.cameraPosition": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.codecs": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.device": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.features": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.isNull": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.mimeType": (),
    "PySide2.QtMultimedia.QMediaServiceProviderHint.type": (),

# class PySide2.QtMultimedia.QMediaServiceSupportedDevicesInterface:
    "PySide2.QtMultimedia.QMediaServiceSupportedDevicesInterface.__init__": (),
    "PySide2.QtMultimedia.QMediaServiceSupportedDevicesInterface.deviceDescription": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtMultimedia.QMediaServiceSupportedDevicesInterface.devices": ('PySide2.QtCore.QByteArray',),

# class PySide2.QtMultimedia.QMediaServiceSupportedFormatsInterface:
    "PySide2.QtMultimedia.QMediaServiceSupportedFormatsInterface.__init__": (),
    "PySide2.QtMultimedia.QMediaServiceSupportedFormatsInterface.hasSupport": ('str', 'typing.Sequence[str]'),
    "PySide2.QtMultimedia.QMediaServiceSupportedFormatsInterface.supportedMimeTypes": (),

# class PySide2.QtMultimedia.QMediaStreamsControl:

# class PySide2.QtMultimedia.QMediaStreamsControl.StreamType:
    "PySide2.QtMultimedia.QMediaStreamsControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMediaStreamsControl.isActive": ('int',),
    "PySide2.QtMultimedia.QMediaStreamsControl.metaData": ('int', 'str'),
    "PySide2.QtMultimedia.QMediaStreamsControl.setActive": ('int', 'bool'),
    "PySide2.QtMultimedia.QMediaStreamsControl.streamCount": (),
    "PySide2.QtMultimedia.QMediaStreamsControl.streamType": ('int',),

# class PySide2.QtMultimedia.QMediaTimeInterval:
    "PySide2.QtMultimedia.QMediaTimeInterval.__init__": [(), ('PySide2.QtMultimedia.QMediaTimeInterval',), ('int', 'int')],
    "PySide2.QtMultimedia.QMediaTimeInterval.__copy__": (),
    "PySide2.QtMultimedia.QMediaTimeInterval.contains": ('int',),
    "PySide2.QtMultimedia.QMediaTimeInterval.end": (),
    "PySide2.QtMultimedia.QMediaTimeInterval.isNormal": (),
    "PySide2.QtMultimedia.QMediaTimeInterval.normalized": (),
    "PySide2.QtMultimedia.QMediaTimeInterval.start": (),
    "PySide2.QtMultimedia.QMediaTimeInterval.translated": ('int',),

# class PySide2.QtMultimedia.QMediaTimeRange:
    "PySide2.QtMultimedia.QMediaTimeRange.__init__": [(), ('PySide2.QtMultimedia.QMediaTimeInterval',), ('PySide2.QtMultimedia.QMediaTimeRange',), ('int', 'int')],
    "PySide2.QtMultimedia.QMediaTimeRange.__add__": ('PySide2.QtMultimedia.QMediaTimeRange',),
    "PySide2.QtMultimedia.QMediaTimeRange.__copy__": (),
    "PySide2.QtMultimedia.QMediaTimeRange.__iadd__": [('PySide2.QtMultimedia.QMediaTimeInterval',), ('PySide2.QtMultimedia.QMediaTimeRange',)],
    "PySide2.QtMultimedia.QMediaTimeRange.__isub__": [('PySide2.QtMultimedia.QMediaTimeInterval',), ('PySide2.QtMultimedia.QMediaTimeRange',)],
    "PySide2.QtMultimedia.QMediaTimeRange.__sub__": ('PySide2.QtMultimedia.QMediaTimeRange',),
    "PySide2.QtMultimedia.QMediaTimeRange.addInterval": [('PySide2.QtMultimedia.QMediaTimeInterval',), ('int', 'int')],
    "PySide2.QtMultimedia.QMediaTimeRange.addTimeRange": ('PySide2.QtMultimedia.QMediaTimeRange',),
    "PySide2.QtMultimedia.QMediaTimeRange.clear": (),
    "PySide2.QtMultimedia.QMediaTimeRange.contains": ('int',),
    "PySide2.QtMultimedia.QMediaTimeRange.earliestTime": (),
    "PySide2.QtMultimedia.QMediaTimeRange.intervals": (),
    "PySide2.QtMultimedia.QMediaTimeRange.isContinuous": (),
    "PySide2.QtMultimedia.QMediaTimeRange.isEmpty": (),
    "PySide2.QtMultimedia.QMediaTimeRange.latestTime": (),
    "PySide2.QtMultimedia.QMediaTimeRange.removeInterval": [('PySide2.QtMultimedia.QMediaTimeInterval',), ('int', 'int')],
    "PySide2.QtMultimedia.QMediaTimeRange.removeTimeRange": ('PySide2.QtMultimedia.QMediaTimeRange',),

# class PySide2.QtMultimedia.QMediaVideoProbeControl:
    "PySide2.QtMultimedia.QMediaVideoProbeControl.__init__": ('PySide2.QtCore.QObject',),

# class PySide2.QtMultimedia.QMetaDataReaderControl:
    "PySide2.QtMultimedia.QMetaDataReaderControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMetaDataReaderControl.availableMetaData": (),
    "PySide2.QtMultimedia.QMetaDataReaderControl.isMetaDataAvailable": (),
    "PySide2.QtMultimedia.QMetaDataReaderControl.metaData": ('str',),

# class PySide2.QtMultimedia.QMetaDataWriterControl:
    "PySide2.QtMultimedia.QMetaDataWriterControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QMetaDataWriterControl.availableMetaData": (),
    "PySide2.QtMultimedia.QMetaDataWriterControl.isMetaDataAvailable": (),
    "PySide2.QtMultimedia.QMetaDataWriterControl.isWritable": (),
    "PySide2.QtMultimedia.QMetaDataWriterControl.metaData": ('str',),
    "PySide2.QtMultimedia.QMetaDataWriterControl.setMetaData": ('str', 'typing.Any'),

# class PySide2.QtMultimedia.QMultimedia:

# class PySide2.QtMultimedia.QMultimedia.AvailabilityStatus:

# class PySide2.QtMultimedia.QMultimedia.EncodingMode:

# class PySide2.QtMultimedia.QMultimedia.EncodingQuality:

# class PySide2.QtMultimedia.QMultimedia.SupportEstimate:

# class PySide2.QtMultimedia.QRadioData:

# class PySide2.QtMultimedia.QRadioData.Error:

# class PySide2.QtMultimedia.QRadioData.ProgramType:
    "PySide2.QtMultimedia.QRadioData.__init__": ('PySide2.QtMultimedia.QMediaObject', 'PySide2.QtCore.QObject'),
    "PySide2.QtMultimedia.QRadioData.availability": (),
    "PySide2.QtMultimedia.QRadioData.error": (),
    "PySide2.QtMultimedia.QRadioData.errorString": (),
    "PySide2.QtMultimedia.QRadioData.isAlternativeFrequenciesEnabled": (),
    "PySide2.QtMultimedia.QRadioData.mediaObject": (),
    "PySide2.QtMultimedia.QRadioData.programType": (),
    "PySide2.QtMultimedia.QRadioData.programTypeName": (),
    "PySide2.QtMultimedia.QRadioData.radioText": (),
    "PySide2.QtMultimedia.QRadioData.setAlternativeFrequenciesEnabled": ('bool',),
    "PySide2.QtMultimedia.QRadioData.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),
    "PySide2.QtMultimedia.QRadioData.stationId": (),
    "PySide2.QtMultimedia.QRadioData.stationName": (),

# class PySide2.QtMultimedia.QRadioDataControl:
    "PySide2.QtMultimedia.QRadioDataControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QRadioDataControl.error": (),
    "PySide2.QtMultimedia.QRadioDataControl.errorString": (),
    "PySide2.QtMultimedia.QRadioDataControl.isAlternativeFrequenciesEnabled": (),
    "PySide2.QtMultimedia.QRadioDataControl.programType": (),
    "PySide2.QtMultimedia.QRadioDataControl.programTypeName": (),
    "PySide2.QtMultimedia.QRadioDataControl.radioText": (),
    "PySide2.QtMultimedia.QRadioDataControl.setAlternativeFrequenciesEnabled": ('bool',),
    "PySide2.QtMultimedia.QRadioDataControl.stationId": (),
    "PySide2.QtMultimedia.QRadioDataControl.stationName": (),

# class PySide2.QtMultimedia.QRadioTuner:

# class PySide2.QtMultimedia.QRadioTuner.Band:

# class PySide2.QtMultimedia.QRadioTuner.Error:

# class PySide2.QtMultimedia.QRadioTuner.SearchMode:

# class PySide2.QtMultimedia.QRadioTuner.State:

# class PySide2.QtMultimedia.QRadioTuner.StereoMode:
    "PySide2.QtMultimedia.QRadioTuner.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QRadioTuner.availability": (),
    "PySide2.QtMultimedia.QRadioTuner.band": (),
    "PySide2.QtMultimedia.QRadioTuner.cancelSearch": (),
    "PySide2.QtMultimedia.QRadioTuner.error": (),
    "PySide2.QtMultimedia.QRadioTuner.errorString": (),
    "PySide2.QtMultimedia.QRadioTuner.frequency": (),
    "PySide2.QtMultimedia.QRadioTuner.frequencyRange": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTuner.frequencyStep": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTuner.isAntennaConnected": (),
    "PySide2.QtMultimedia.QRadioTuner.isBandSupported": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTuner.isMuted": (),
    "PySide2.QtMultimedia.QRadioTuner.isSearching": (),
    "PySide2.QtMultimedia.QRadioTuner.isStereo": (),
    "PySide2.QtMultimedia.QRadioTuner.radioData": (),
    "PySide2.QtMultimedia.QRadioTuner.searchAllStations": ('PySide2.QtMultimedia.QRadioTuner.SearchMode',),
    "PySide2.QtMultimedia.QRadioTuner.searchBackward": (),
    "PySide2.QtMultimedia.QRadioTuner.searchForward": (),
    "PySide2.QtMultimedia.QRadioTuner.setBand": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTuner.setFrequency": ('int',),
    "PySide2.QtMultimedia.QRadioTuner.setMuted": ('bool',),
    "PySide2.QtMultimedia.QRadioTuner.setStereoMode": ('PySide2.QtMultimedia.QRadioTuner.StereoMode',),
    "PySide2.QtMultimedia.QRadioTuner.setVolume": ('int',),
    "PySide2.QtMultimedia.QRadioTuner.signalStrength": (),
    "PySide2.QtMultimedia.QRadioTuner.start": (),
    "PySide2.QtMultimedia.QRadioTuner.state": (),
    "PySide2.QtMultimedia.QRadioTuner.stereoMode": (),
    "PySide2.QtMultimedia.QRadioTuner.stop": (),
    "PySide2.QtMultimedia.QRadioTuner.volume": (),

# class PySide2.QtMultimedia.QRadioTunerControl:
    "PySide2.QtMultimedia.QRadioTunerControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QRadioTunerControl.band": (),
    "PySide2.QtMultimedia.QRadioTunerControl.cancelSearch": (),
    "PySide2.QtMultimedia.QRadioTunerControl.error": (),
    "PySide2.QtMultimedia.QRadioTunerControl.errorString": (),
    "PySide2.QtMultimedia.QRadioTunerControl.frequency": (),
    "PySide2.QtMultimedia.QRadioTunerControl.frequencyRange": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTunerControl.frequencyStep": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTunerControl.isAntennaConnected": (),
    "PySide2.QtMultimedia.QRadioTunerControl.isBandSupported": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTunerControl.isMuted": (),
    "PySide2.QtMultimedia.QRadioTunerControl.isSearching": (),
    "PySide2.QtMultimedia.QRadioTunerControl.isStereo": (),
    "PySide2.QtMultimedia.QRadioTunerControl.searchAllStations": ('PySide2.QtMultimedia.QRadioTuner.SearchMode',),
    "PySide2.QtMultimedia.QRadioTunerControl.searchBackward": (),
    "PySide2.QtMultimedia.QRadioTunerControl.searchForward": (),
    "PySide2.QtMultimedia.QRadioTunerControl.setBand": ('PySide2.QtMultimedia.QRadioTuner.Band',),
    "PySide2.QtMultimedia.QRadioTunerControl.setFrequency": ('int',),
    "PySide2.QtMultimedia.QRadioTunerControl.setMuted": ('bool',),
    "PySide2.QtMultimedia.QRadioTunerControl.setStereoMode": ('PySide2.QtMultimedia.QRadioTuner.StereoMode',),
    "PySide2.QtMultimedia.QRadioTunerControl.setVolume": ('int',),
    "PySide2.QtMultimedia.QRadioTunerControl.signalStrength": (),
    "PySide2.QtMultimedia.QRadioTunerControl.start": (),
    "PySide2.QtMultimedia.QRadioTunerControl.state": (),
    "PySide2.QtMultimedia.QRadioTunerControl.stereoMode": (),
    "PySide2.QtMultimedia.QRadioTunerControl.stop": (),
    "PySide2.QtMultimedia.QRadioTunerControl.volume": (),

# class PySide2.QtMultimedia.QSound:

# class PySide2.QtMultimedia.QSound.Loop:
    "PySide2.QtMultimedia.QSound.__init__": ('str', 'PySide2.QtCore.QObject'),
    "PySide2.QtMultimedia.QSound.fileName": (),
    "PySide2.QtMultimedia.QSound.isFinished": (),
    "PySide2.QtMultimedia.QSound.loops": (),
    "PySide2.QtMultimedia.QSound.loopsRemaining": (),
    "PySide2.QtMultimedia.QSound.play": [(), ('str',)],
    "PySide2.QtMultimedia.QSound.setLoops": ('int',),
    "PySide2.QtMultimedia.QSound.stop": (),

# class PySide2.QtMultimedia.QSoundEffect:

# class PySide2.QtMultimedia.QSoundEffect.Loop:

# class PySide2.QtMultimedia.QSoundEffect.Status:
    "PySide2.QtMultimedia.QSoundEffect.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtMultimedia.QAudioDeviceInfo', 'PySide2.QtCore.QObject')],
    "PySide2.QtMultimedia.QSoundEffect.category": (),
    "PySide2.QtMultimedia.QSoundEffect.isLoaded": (),
    "PySide2.QtMultimedia.QSoundEffect.isMuted": (),
    "PySide2.QtMultimedia.QSoundEffect.isPlaying": (),
    "PySide2.QtMultimedia.QSoundEffect.loopCount": (),
    "PySide2.QtMultimedia.QSoundEffect.loopsRemaining": (),
    "PySide2.QtMultimedia.QSoundEffect.play": (),
    "PySide2.QtMultimedia.QSoundEffect.setCategory": ('str',),
    "PySide2.QtMultimedia.QSoundEffect.setLoopCount": ('int',),
    "PySide2.QtMultimedia.QSoundEffect.setMuted": ('bool',),
    "PySide2.QtMultimedia.QSoundEffect.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.QtMultimedia.QSoundEffect.setVolume": ('float',),
    "PySide2.QtMultimedia.QSoundEffect.source": (),
    "PySide2.QtMultimedia.QSoundEffect.status": (),
    "PySide2.QtMultimedia.QSoundEffect.stop": (),
    "PySide2.QtMultimedia.QSoundEffect.supportedMimeTypes": (),
    "PySide2.QtMultimedia.QSoundEffect.volume": (),

# class PySide2.QtMultimedia.QVideoDeviceSelectorControl:
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.defaultDevice": (),
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.deviceCount": (),
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.deviceDescription": ('int',),
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.deviceName": ('int',),
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.selectedDevice": (),
    "PySide2.QtMultimedia.QVideoDeviceSelectorControl.setSelectedDevice": ('int',),

# class PySide2.QtMultimedia.QVideoEncoderSettings:
    "PySide2.QtMultimedia.QVideoEncoderSettings.__init__": [(), ('PySide2.QtMultimedia.QVideoEncoderSettings',)],
    "PySide2.QtMultimedia.QVideoEncoderSettings.__copy__": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.bitRate": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.codec": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.encodingMode": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.encodingOption": ('str',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.encodingOptions": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.frameRate": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.isNull": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.quality": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.resolution": (),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setBitRate": ('int',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setCodec": ('str',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setEncodingMode": ('PySide2.QtMultimedia.QMultimedia.EncodingMode',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setEncodingOption": ('str', 'typing.Any'),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setEncodingOptions": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setFrameRate": ('float',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setQuality": ('PySide2.QtMultimedia.QMultimedia.EncodingQuality',),
    "PySide2.QtMultimedia.QVideoEncoderSettings.setResolution": [('PySide2.QtCore.QSize',), ('int', 'int')],

# class PySide2.QtMultimedia.QVideoEncoderSettingsControl:
    "PySide2.QtMultimedia.QVideoEncoderSettingsControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QVideoEncoderSettingsControl.setVideoSettings": ('PySide2.QtMultimedia.QVideoEncoderSettings',),
    "PySide2.QtMultimedia.QVideoEncoderSettingsControl.supportedVideoCodecs": (),
    "PySide2.QtMultimedia.QVideoEncoderSettingsControl.videoCodecDescription": ('str',),
    "PySide2.QtMultimedia.QVideoEncoderSettingsControl.videoSettings": (),

# class PySide2.QtMultimedia.QVideoFilterRunnable:

# class PySide2.QtMultimedia.QVideoFilterRunnable.RunFlag:

# class PySide2.QtMultimedia.QVideoFilterRunnable.RunFlags:
    "PySide2.QtMultimedia.QVideoFilterRunnable.__init__": (),
    "PySide2.QtMultimedia.QVideoFilterRunnable.run": ('PySide2.QtMultimedia.QVideoFrame', 'PySide2.QtMultimedia.QVideoSurfaceFormat', 'PySide2.QtMultimedia.QVideoFilterRunnable.RunFlags'),

# class PySide2.QtMultimedia.QVideoFrame:

# class PySide2.QtMultimedia.QVideoFrame.FieldType:

# class PySide2.QtMultimedia.QVideoFrame.PixelFormat:
    "PySide2.QtMultimedia.QVideoFrame.__init__": [(), ('PySide2.QtGui.QImage',), ('PySide2.QtMultimedia.QAbstractVideoBuffer', 'PySide2.QtCore.QSize', 'PySide2.QtMultimedia.QVideoFrame.PixelFormat'), ('PySide2.QtMultimedia.QVideoFrame',), ('int', 'PySide2.QtCore.QSize', 'int', 'PySide2.QtMultimedia.QVideoFrame.PixelFormat')],
    "PySide2.QtMultimedia.QVideoFrame.__copy__": (),
    "PySide2.QtMultimedia.QVideoFrame.availableMetaData": (),
    "PySide2.QtMultimedia.QVideoFrame.bits": (),
    "PySide2.QtMultimedia.QVideoFrame.buffer": (),
    "PySide2.QtMultimedia.QVideoFrame.bytesPerLine": [(), ('int',)],
    "PySide2.QtMultimedia.QVideoFrame.endTime": (),
    "PySide2.QtMultimedia.QVideoFrame.fieldType": (),
    "PySide2.QtMultimedia.QVideoFrame.handle": (),
    "PySide2.QtMultimedia.QVideoFrame.handleType": (),
    "PySide2.QtMultimedia.QVideoFrame.height": (),
    "PySide2.QtMultimedia.QVideoFrame.imageFormatFromPixelFormat": ('PySide2.QtMultimedia.QVideoFrame.PixelFormat',),
    "PySide2.QtMultimedia.QVideoFrame.isMapped": (),
    "PySide2.QtMultimedia.QVideoFrame.isReadable": (),
    "PySide2.QtMultimedia.QVideoFrame.isValid": (),
    "PySide2.QtMultimedia.QVideoFrame.isWritable": (),
    "PySide2.QtMultimedia.QVideoFrame.map": ('PySide2.QtMultimedia.QAbstractVideoBuffer.MapMode',),
    "PySide2.QtMultimedia.QVideoFrame.mapMode": (),
    "PySide2.QtMultimedia.QVideoFrame.mappedBytes": (),
    "PySide2.QtMultimedia.QVideoFrame.metaData": ('str',),
    "PySide2.QtMultimedia.QVideoFrame.pixelFormat": (),
    "PySide2.QtMultimedia.QVideoFrame.pixelFormatFromImageFormat": ('PySide2.QtGui.QImage.Format',),
    "PySide2.QtMultimedia.QVideoFrame.planeCount": (),
    "PySide2.QtMultimedia.QVideoFrame.setEndTime": ('int',),
    "PySide2.QtMultimedia.QVideoFrame.setFieldType": ('PySide2.QtMultimedia.QVideoFrame.FieldType',),
    "PySide2.QtMultimedia.QVideoFrame.setMetaData": ('str', 'typing.Any'),
    "PySide2.QtMultimedia.QVideoFrame.setStartTime": ('int',),
    "PySide2.QtMultimedia.QVideoFrame.size": (),
    "PySide2.QtMultimedia.QVideoFrame.startTime": (),
    "PySide2.QtMultimedia.QVideoFrame.unmap": (),
    "PySide2.QtMultimedia.QVideoFrame.width": (),

# class PySide2.QtMultimedia.QVideoProbe:
    "PySide2.QtMultimedia.QVideoProbe.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QVideoProbe.isActive": (),
    "PySide2.QtMultimedia.QVideoProbe.setSource": [('PySide2.QtMultimedia.QMediaObject',), ('PySide2.QtMultimedia.QMediaRecorder',)],

# class PySide2.QtMultimedia.QVideoRendererControl:
    "PySide2.QtMultimedia.QVideoRendererControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QVideoRendererControl.setSurface": ('PySide2.QtMultimedia.QAbstractVideoSurface',),
    "PySide2.QtMultimedia.QVideoRendererControl.surface": (),

# class PySide2.QtMultimedia.QVideoSurfaceFormat:

# class PySide2.QtMultimedia.QVideoSurfaceFormat.Direction:

# class PySide2.QtMultimedia.QVideoSurfaceFormat.YCbCrColorSpace:
    "PySide2.QtMultimedia.QVideoSurfaceFormat.__init__": [(), ('PySide2.QtCore.QSize', 'PySide2.QtMultimedia.QVideoFrame.PixelFormat', 'PySide2.QtMultimedia.QAbstractVideoBuffer.HandleType'), ('PySide2.QtMultimedia.QVideoSurfaceFormat',)],
    "PySide2.QtMultimedia.QVideoSurfaceFormat.__copy__": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.frameHeight": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.frameRate": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.frameSize": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.frameWidth": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.handleType": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.isMirrored": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.isValid": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.pixelAspectRatio": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.pixelFormat": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.property": ('str',),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.propertyNames": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.scanLineDirection": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setFrameRate": ('float',),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setFrameSize": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setMirrored": ('bool',),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setPixelAspectRatio": [('PySide2.QtCore.QSize',), ('int', 'int')],
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setProperty": ('str', 'typing.Any'),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setScanLineDirection": ('PySide2.QtMultimedia.QVideoSurfaceFormat.Direction',),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setViewport": ('PySide2.QtCore.QRect',),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.setYCbCrColorSpace": ('PySide2.QtMultimedia.QVideoSurfaceFormat.YCbCrColorSpace',),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.sizeHint": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.viewport": (),
    "PySide2.QtMultimedia.QVideoSurfaceFormat.yCbCrColorSpace": (),

# class PySide2.QtMultimedia.QVideoWindowControl:
    "PySide2.QtMultimedia.QVideoWindowControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimedia.QVideoWindowControl.aspectRatioMode": (),
    "PySide2.QtMultimedia.QVideoWindowControl.brightness": (),
    "PySide2.QtMultimedia.QVideoWindowControl.contrast": (),
    "PySide2.QtMultimedia.QVideoWindowControl.displayRect": (),
    "PySide2.QtMultimedia.QVideoWindowControl.hue": (),
    "PySide2.QtMultimedia.QVideoWindowControl.isFullScreen": (),
    "PySide2.QtMultimedia.QVideoWindowControl.nativeSize": (),
    "PySide2.QtMultimedia.QVideoWindowControl.repaint": (),
    "PySide2.QtMultimedia.QVideoWindowControl.saturation": (),
    "PySide2.QtMultimedia.QVideoWindowControl.setAspectRatioMode": ('PySide2.QtCore.Qt.AspectRatioMode',),
    "PySide2.QtMultimedia.QVideoWindowControl.setBrightness": ('int',),
    "PySide2.QtMultimedia.QVideoWindowControl.setContrast": ('int',),
    "PySide2.QtMultimedia.QVideoWindowControl.setDisplayRect": ('PySide2.QtCore.QRect',),
    "PySide2.QtMultimedia.QVideoWindowControl.setFullScreen": ('bool',),
    "PySide2.QtMultimedia.QVideoWindowControl.setHue": ('int',),
    "PySide2.QtMultimedia.QVideoWindowControl.setSaturation": ('int',),
    "PySide2.QtMultimedia.QVideoWindowControl.setWinId": ('int',),
    "PySide2.QtMultimedia.QVideoWindowControl.winId": (),
    }) if "PySide2.QtMultimedia" in sys.modules else None

# Module PySide2.QtMultimediaWidgets
sig_dict.update({

# class PySide2.QtMultimediaWidgets.QCameraViewfinder:
    "PySide2.QtMultimediaWidgets.QCameraViewfinder.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtMultimediaWidgets.QCameraViewfinder.mediaObject": (),
    "PySide2.QtMultimediaWidgets.QCameraViewfinder.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),

# class PySide2.QtMultimediaWidgets.QGraphicsVideoItem:
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.__init__": ('PySide2.QtWidgets.QGraphicsItem',),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.aspectRatioMode": (),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.boundingRect": (),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.itemChange": ('PySide2.QtWidgets.QGraphicsItem.GraphicsItemChange', 'typing.Any'),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.mediaObject": (),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.nativeSize": (),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.offset": (),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.setAspectRatioMode": ('PySide2.QtCore.Qt.AspectRatioMode',),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.setOffset": ('PySide2.QtCore.QPointF',),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.setSize": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.size": (),
    "PySide2.QtMultimediaWidgets.QGraphicsVideoItem.timerEvent": ('PySide2.QtCore.QTimerEvent',),

# class PySide2.QtMultimediaWidgets.QVideoWidget:
    "PySide2.QtMultimediaWidgets.QVideoWidget.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.aspectRatioMode": (),
    "PySide2.QtMultimediaWidgets.QVideoWidget.brightness": (),
    "PySide2.QtMultimediaWidgets.QVideoWidget.contrast": (),
    "PySide2.QtMultimediaWidgets.QVideoWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.hue": (),
    "PySide2.QtMultimediaWidgets.QVideoWidget.mediaObject": (),
    "PySide2.QtMultimediaWidgets.QVideoWidget.moveEvent": ('PySide2.QtGui.QMoveEvent',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.saturation": (),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setAspectRatioMode": ('PySide2.QtCore.Qt.AspectRatioMode',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setBrightness": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setContrast": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setFullScreen": ('bool',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setHue": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setMediaObject": ('PySide2.QtMultimedia.QMediaObject',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.setSaturation": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtMultimediaWidgets.QVideoWidget.sizeHint": (),

# class PySide2.QtMultimediaWidgets.QVideoWidgetControl:
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.aspectRatioMode": (),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.brightness": (),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.contrast": (),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.hue": (),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.isFullScreen": (),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.saturation": (),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.setAspectRatioMode": ('PySide2.QtCore.Qt.AspectRatioMode',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.setBrightness": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.setContrast": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.setFullScreen": ('bool',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.setHue": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.setSaturation": ('int',),
    "PySide2.QtMultimediaWidgets.QVideoWidgetControl.videoWidget": (),
    }) if "PySide2.QtMultimediaWidgets" in sys.modules else None

# Module PySide2.QtOpenGL
sig_dict.update({

# class PySide2.QtOpenGL.QGL:

# class PySide2.QtOpenGL.QGL.FormatOption:

# class PySide2.QtOpenGL.QGL.FormatOptions:

# class PySide2.QtOpenGL.QGLBuffer:

# class PySide2.QtOpenGL.QGLBuffer.Access:

# class PySide2.QtOpenGL.QGLBuffer.Type:

# class PySide2.QtOpenGL.QGLBuffer.UsagePattern:
    "PySide2.QtOpenGL.QGLBuffer.__init__": [(), ('PySide2.QtOpenGL.QGLBuffer',), ('PySide2.QtOpenGL.QGLBuffer.Type',)],
    "PySide2.QtOpenGL.QGLBuffer.allocate": [('int',), ('int', 'int')],
    "PySide2.QtOpenGL.QGLBuffer.bind": (),
    "PySide2.QtOpenGL.QGLBuffer.bufferId": (),
    "PySide2.QtOpenGL.QGLBuffer.create": (),
    "PySide2.QtOpenGL.QGLBuffer.destroy": (),
    "PySide2.QtOpenGL.QGLBuffer.isCreated": (),
    "PySide2.QtOpenGL.QGLBuffer.map": ('PySide2.QtOpenGL.QGLBuffer.Access',),
    "PySide2.QtOpenGL.QGLBuffer.read": ('int', 'int', 'int'),
    "PySide2.QtOpenGL.QGLBuffer.release": [(), ('PySide2.QtOpenGL.QGLBuffer.Type',)],
    "PySide2.QtOpenGL.QGLBuffer.setUsagePattern": ('PySide2.QtOpenGL.QGLBuffer.UsagePattern',),
    "PySide2.QtOpenGL.QGLBuffer.size": (),
    "PySide2.QtOpenGL.QGLBuffer.type": (),
    "PySide2.QtOpenGL.QGLBuffer.unmap": (),
    "PySide2.QtOpenGL.QGLBuffer.usagePattern": (),
    "PySide2.QtOpenGL.QGLBuffer.write": ('int', 'int', 'int'),

# class PySide2.QtOpenGL.QGLColormap:
    "PySide2.QtOpenGL.QGLColormap.__init__": [(), ('PySide2.QtOpenGL.QGLColormap',)],
    "PySide2.QtOpenGL.QGLColormap.__copy__": (),
    "PySide2.QtOpenGL.QGLColormap.entryColor": ('int',),
    "PySide2.QtOpenGL.QGLColormap.entryRgb": ('int',),
    "PySide2.QtOpenGL.QGLColormap.find": ('int',),
    "PySide2.QtOpenGL.QGLColormap.findNearest": ('int',),
    "PySide2.QtOpenGL.QGLColormap.handle": (),
    "PySide2.QtOpenGL.QGLColormap.isEmpty": (),
    "PySide2.QtOpenGL.QGLColormap.setEntry": [('int', 'PySide2.QtGui.QColor'), ('int', 'int')],
    "PySide2.QtOpenGL.QGLColormap.setHandle": ('int',),
    "PySide2.QtOpenGL.QGLColormap.size": (),

# class PySide2.QtOpenGL.QGLContext:

# class PySide2.QtOpenGL.QGLContext.BindOption:

# class PySide2.QtOpenGL.QGLContext.BindOptions:
    "PySide2.QtOpenGL.QGLContext.__init__": ('PySide2.QtOpenGL.QGLFormat',),
    "PySide2.QtOpenGL.QGLContext.areSharing": ('PySide2.QtOpenGL.QGLContext', 'PySide2.QtOpenGL.QGLContext'),
    "PySide2.QtOpenGL.QGLContext.bindTexture": [('PySide2.QtGui.QImage', 'int', 'int'), ('PySide2.QtGui.QImage', 'int', 'int', 'PySide2.QtOpenGL.QGLContext.BindOptions'), ('PySide2.QtGui.QPixmap', 'int', 'int'), ('PySide2.QtGui.QPixmap', 'int', 'int', 'PySide2.QtOpenGL.QGLContext.BindOptions'), ('str',)],
    "PySide2.QtOpenGL.QGLContext.chooseContext": ('PySide2.QtOpenGL.QGLContext',),
    "PySide2.QtOpenGL.QGLContext.colorIndex": ('PySide2.QtGui.QColor',),
    "PySide2.QtOpenGL.QGLContext.contextHandle": (),
    "PySide2.QtOpenGL.QGLContext.create": ('PySide2.QtOpenGL.QGLContext',),
    "PySide2.QtOpenGL.QGLContext.currentContext": (),
    "PySide2.QtOpenGL.QGLContext.deleteTexture": ('int',),
    "PySide2.QtOpenGL.QGLContext.device": (),
    "PySide2.QtOpenGL.QGLContext.deviceIsPixmap": (),
    "PySide2.QtOpenGL.QGLContext.doneCurrent": (),
    "PySide2.QtOpenGL.QGLContext.drawTexture": [('PySide2.QtCore.QPointF', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int')],
    "PySide2.QtOpenGL.QGLContext.format": (),
    "PySide2.QtOpenGL.QGLContext.fromOpenGLContext": ('PySide2.QtGui.QOpenGLContext',),
    "PySide2.QtOpenGL.QGLContext.initialized": (),
    "PySide2.QtOpenGL.QGLContext.isSharing": (),
    "PySide2.QtOpenGL.QGLContext.isValid": (),
    "PySide2.QtOpenGL.QGLContext.makeCurrent": (),
    "PySide2.QtOpenGL.QGLContext.moveToThread": ('PySide2.QtCore.QThread',),
    "PySide2.QtOpenGL.QGLContext.overlayTransparentColor": (),
    "PySide2.QtOpenGL.QGLContext.requestedFormat": (),
    "PySide2.QtOpenGL.QGLContext.reset": (),
    "PySide2.QtOpenGL.QGLContext.setDevice": ('PySide2.QtGui.QPaintDevice',),
    "PySide2.QtOpenGL.QGLContext.setFormat": ('PySide2.QtOpenGL.QGLFormat',),
    "PySide2.QtOpenGL.QGLContext.setInitialized": ('bool',),
    "PySide2.QtOpenGL.QGLContext.setTextureCacheLimit": ('int',),
    "PySide2.QtOpenGL.QGLContext.setValid": ('bool',),
    "PySide2.QtOpenGL.QGLContext.setWindowCreated": ('bool',),
    "PySide2.QtOpenGL.QGLContext.swapBuffers": (),
    "PySide2.QtOpenGL.QGLContext.textureCacheLimit": (),
    "PySide2.QtOpenGL.QGLContext.windowCreated": (),

# class PySide2.QtOpenGL.QGLFormat:

# class PySide2.QtOpenGL.QGLFormat.OpenGLContextProfile:

# class PySide2.QtOpenGL.QGLFormat.OpenGLVersionFlag:

# class PySide2.QtOpenGL.QGLFormat.OpenGLVersionFlags:
    "PySide2.QtOpenGL.QGLFormat.__init__": [(), ('PySide2.QtOpenGL.QGL.FormatOptions', 'int'), ('PySide2.QtOpenGL.QGLFormat',)],
    "PySide2.QtOpenGL.QGLFormat.__copy__": (),
    "PySide2.QtOpenGL.QGLFormat.accum": (),
    "PySide2.QtOpenGL.QGLFormat.accumBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.alpha": (),
    "PySide2.QtOpenGL.QGLFormat.alphaBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.blueBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.defaultFormat": (),
    "PySide2.QtOpenGL.QGLFormat.defaultOverlayFormat": (),
    "PySide2.QtOpenGL.QGLFormat.depth": (),
    "PySide2.QtOpenGL.QGLFormat.depthBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.directRendering": (),
    "PySide2.QtOpenGL.QGLFormat.doubleBuffer": (),
    "PySide2.QtOpenGL.QGLFormat.fromSurfaceFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtOpenGL.QGLFormat.greenBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.hasOpenGL": (),
    "PySide2.QtOpenGL.QGLFormat.hasOpenGLOverlays": (),
    "PySide2.QtOpenGL.QGLFormat.hasOverlay": (),
    "PySide2.QtOpenGL.QGLFormat.majorVersion": (),
    "PySide2.QtOpenGL.QGLFormat.minorVersion": (),
    "PySide2.QtOpenGL.QGLFormat.openGLVersionFlags": (),
    "PySide2.QtOpenGL.QGLFormat.plane": (),
    "PySide2.QtOpenGL.QGLFormat.profile": (),
    "PySide2.QtOpenGL.QGLFormat.redBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.rgba": (),
    "PySide2.QtOpenGL.QGLFormat.sampleBuffers": (),
    "PySide2.QtOpenGL.QGLFormat.samples": (),
    "PySide2.QtOpenGL.QGLFormat.setAccum": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setAccumBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setAlpha": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setAlphaBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setBlueBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setDefaultFormat": ('PySide2.QtOpenGL.QGLFormat',),
    "PySide2.QtOpenGL.QGLFormat.setDefaultOverlayFormat": ('PySide2.QtOpenGL.QGLFormat',),
    "PySide2.QtOpenGL.QGLFormat.setDepth": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setDepthBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setDirectRendering": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setDoubleBuffer": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setGreenBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setOption": ('PySide2.QtOpenGL.QGL.FormatOptions',),
    "PySide2.QtOpenGL.QGLFormat.setOverlay": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setPlane": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setProfile": ('PySide2.QtOpenGL.QGLFormat.OpenGLContextProfile',),
    "PySide2.QtOpenGL.QGLFormat.setRedBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setRgba": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setSampleBuffers": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setSamples": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setStencil": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setStencilBufferSize": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setStereo": ('bool',),
    "PySide2.QtOpenGL.QGLFormat.setSwapInterval": ('int',),
    "PySide2.QtOpenGL.QGLFormat.setVersion": ('int', 'int'),
    "PySide2.QtOpenGL.QGLFormat.stencil": (),
    "PySide2.QtOpenGL.QGLFormat.stencilBufferSize": (),
    "PySide2.QtOpenGL.QGLFormat.stereo": (),
    "PySide2.QtOpenGL.QGLFormat.swapInterval": (),
    "PySide2.QtOpenGL.QGLFormat.testOption": ('PySide2.QtOpenGL.QGL.FormatOptions',),
    "PySide2.QtOpenGL.QGLFormat.toSurfaceFormat": ('PySide2.QtOpenGL.QGLFormat',),

# class PySide2.QtOpenGL.QGLFramebufferObject:

# class PySide2.QtOpenGL.QGLFramebufferObject.Attachment:
    "PySide2.QtOpenGL.QGLFramebufferObject.__init__": [('PySide2.QtCore.QSize', 'PySide2.QtOpenGL.QGLFramebufferObject.Attachment', 'int', 'int'), ('PySide2.QtCore.QSize', 'PySide2.QtOpenGL.QGLFramebufferObjectFormat'), ('PySide2.QtCore.QSize', 'int'), ('int', 'int', 'PySide2.QtOpenGL.QGLFramebufferObject.Attachment', 'int', 'int'), ('int', 'int', 'PySide2.QtOpenGL.QGLFramebufferObjectFormat'), ('int', 'int', 'int')],
    "PySide2.QtOpenGL.QGLFramebufferObject.attachment": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.bind": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.bindDefault": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.blitFramebuffer": ('PySide2.QtOpenGL.QGLFramebufferObject', 'PySide2.QtCore.QRect', 'PySide2.QtOpenGL.QGLFramebufferObject', 'PySide2.QtCore.QRect', 'int', 'int'),
    "PySide2.QtOpenGL.QGLFramebufferObject.devType": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.drawTexture": [('PySide2.QtCore.QPointF', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int')],
    "PySide2.QtOpenGL.QGLFramebufferObject.format": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.handle": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.hasOpenGLFramebufferBlit": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.hasOpenGLFramebufferObjects": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.isBound": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.isValid": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtOpenGL.QGLFramebufferObject.paintEngine": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.release": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.size": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.texture": (),
    "PySide2.QtOpenGL.QGLFramebufferObject.toImage": (),

# class PySide2.QtOpenGL.QGLFramebufferObjectFormat:
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.__init__": [(), ('PySide2.QtOpenGL.QGLFramebufferObjectFormat',)],
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.__copy__": (),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.attachment": (),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.internalTextureFormat": (),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.mipmap": (),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.samples": (),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.setAttachment": ('PySide2.QtOpenGL.QGLFramebufferObject.Attachment',),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.setInternalTextureFormat": ('int',),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.setMipmap": ('bool',),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.setSamples": ('int',),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.setTextureTarget": ('int',),
    "PySide2.QtOpenGL.QGLFramebufferObjectFormat.textureTarget": (),

# class PySide2.QtOpenGL.QGLPixelBuffer:
    "PySide2.QtOpenGL.QGLPixelBuffer.__init__": [('PySide2.QtCore.QSize', 'PySide2.QtOpenGL.QGLFormat', 'PySide2.QtOpenGL.QGLWidget'), ('int', 'int', 'PySide2.QtOpenGL.QGLFormat', 'PySide2.QtOpenGL.QGLWidget')],
    "PySide2.QtOpenGL.QGLPixelBuffer.bindTexture": [('PySide2.QtGui.QImage', 'int'), ('PySide2.QtGui.QPixmap', 'int'), ('str',)],
    "PySide2.QtOpenGL.QGLPixelBuffer.bindToDynamicTexture": ('int',),
    "PySide2.QtOpenGL.QGLPixelBuffer.context": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.deleteTexture": ('int',),
    "PySide2.QtOpenGL.QGLPixelBuffer.devType": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.doneCurrent": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.drawTexture": [('PySide2.QtCore.QPointF', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int')],
    "PySide2.QtOpenGL.QGLPixelBuffer.format": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.generateDynamicTexture": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.handle": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.hasOpenGLPbuffers": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.isValid": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.makeCurrent": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtOpenGL.QGLPixelBuffer.paintEngine": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.releaseFromDynamicTexture": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.size": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.toImage": (),
    "PySide2.QtOpenGL.QGLPixelBuffer.updateDynamicTexture": ('int',),

# class PySide2.QtOpenGL.QGLShader:

# class PySide2.QtOpenGL.QGLShader.ShaderType:

# class PySide2.QtOpenGL.QGLShader.ShaderTypeBit:
    "PySide2.QtOpenGL.QGLShader.__init__": [('PySide2.QtOpenGL.QGLShader.ShaderType', 'PySide2.QtCore.QObject'), ('PySide2.QtOpenGL.QGLShader.ShaderType', 'PySide2.QtOpenGL.QGLContext', 'PySide2.QtCore.QObject')],
    "PySide2.QtOpenGL.QGLShader.compileSourceCode": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtOpenGL.QGLShader.compileSourceFile": ('str',),
    "PySide2.QtOpenGL.QGLShader.hasOpenGLShaders": ('PySide2.QtOpenGL.QGLShader.ShaderType', 'PySide2.QtOpenGL.QGLContext'),
    "PySide2.QtOpenGL.QGLShader.isCompiled": (),
    "PySide2.QtOpenGL.QGLShader.log": (),
    "PySide2.QtOpenGL.QGLShader.shaderId": (),
    "PySide2.QtOpenGL.QGLShader.shaderType": (),
    "PySide2.QtOpenGL.QGLShader.sourceCode": (),

# class PySide2.QtOpenGL.QGLShaderProgram:
    "PySide2.QtOpenGL.QGLShaderProgram.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtOpenGL.QGLContext', 'PySide2.QtCore.QObject')],
    "PySide2.QtOpenGL.QGLShaderProgram.addShader": ('PySide2.QtOpenGL.QGLShader',),
    "PySide2.QtOpenGL.QGLShaderProgram.addShaderFromSourceCode": [('PySide2.QtOpenGL.QGLShader.ShaderType', 'PySide2.QtCore.QByteArray'), ('PySide2.QtOpenGL.QGLShader.ShaderType', 'str')],
    "PySide2.QtOpenGL.QGLShaderProgram.addShaderFromSourceFile": ('PySide2.QtOpenGL.QGLShader.ShaderType', 'str'),
    "PySide2.QtOpenGL.QGLShaderProgram.attributeLocation": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtOpenGL.QGLShaderProgram.bind": (),
    "PySide2.QtOpenGL.QGLShaderProgram.bindAttributeLocation": [('PySide2.QtCore.QByteArray', 'int'), ('str', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.disableAttributeArray": [('int',), ('str',)],
    "PySide2.QtOpenGL.QGLShaderProgram.enableAttributeArray": [('int',), ('str',)],
    "PySide2.QtOpenGL.QGLShaderProgram.geometryInputType": (),
    "PySide2.QtOpenGL.QGLShaderProgram.geometryOutputType": (),
    "PySide2.QtOpenGL.QGLShaderProgram.geometryOutputVertexCount": (),
    "PySide2.QtOpenGL.QGLShaderProgram.hasOpenGLShaderPrograms": ('PySide2.QtOpenGL.QGLContext',),
    "PySide2.QtOpenGL.QGLShaderProgram.isLinked": (),
    "PySide2.QtOpenGL.QGLShaderProgram.link": (),
    "PySide2.QtOpenGL.QGLShaderProgram.log": (),
    "PySide2.QtOpenGL.QGLShaderProgram.maxGeometryOutputVertices": (),
    "PySide2.QtOpenGL.QGLShaderProgram.programId": (),
    "PySide2.QtOpenGL.QGLShaderProgram.release": (),
    "PySide2.QtOpenGL.QGLShaderProgram.removeAllShaders": (),
    "PySide2.QtOpenGL.QGLShaderProgram.removeShader": ('PySide2.QtOpenGL.QGLShader',),
    "PySide2.QtOpenGL.QGLShaderProgram.setAttributeArray2D": [('int', 'PySide2.QtGui.QVector2D', 'int'), ('str', 'PySide2.QtGui.QVector2D', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setAttributeArray3D": [('int', 'PySide2.QtGui.QVector3D', 'int'), ('str', 'PySide2.QtGui.QVector3D', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setAttributeArray4D": [('int', 'PySide2.QtGui.QVector4D', 'int'), ('str', 'PySide2.QtGui.QVector4D', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setAttributeBuffer": [('int', 'int', 'int', 'int', 'int'), ('str', 'int', 'int', 'int', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setAttributeValue": [('int', 'PySide2.QtGui.QColor'), ('int', 'PySide2.QtGui.QVector2D'), ('int', 'PySide2.QtGui.QVector3D'), ('int', 'PySide2.QtGui.QVector4D'), ('int', 'float'), ('int', 'float', 'float'), ('int', 'float', 'float', 'float'), ('int', 'float', 'float', 'float', 'float'), ('str', 'PySide2.QtGui.QColor'), ('str', 'PySide2.QtGui.QVector2D'), ('str', 'PySide2.QtGui.QVector3D'), ('str', 'PySide2.QtGui.QVector4D'), ('str', 'float'), ('str', 'float', 'float'), ('str', 'float', 'float', 'float'), ('str', 'float', 'float', 'float', 'float')],
    "PySide2.QtOpenGL.QGLShaderProgram.setGeometryInputType": ('int',),
    "PySide2.QtOpenGL.QGLShaderProgram.setGeometryOutputType": ('int',),
    "PySide2.QtOpenGL.QGLShaderProgram.setGeometryOutputVertexCount": ('int',),
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValue": [('int', 'PySide2.QtCore.QPoint'), ('int', 'PySide2.QtCore.QPointF'), ('int', 'PySide2.QtCore.QSize'), ('int', 'PySide2.QtCore.QSizeF'), ('int', 'PySide2.QtGui.QColor'), ('int', 'PySide2.QtGui.QMatrix2x2'), ('int', 'PySide2.QtGui.QMatrix2x3'), ('int', 'PySide2.QtGui.QMatrix2x4'), ('int', 'PySide2.QtGui.QMatrix3x2'), ('int', 'PySide2.QtGui.QMatrix3x3'), ('int', 'PySide2.QtGui.QMatrix3x4'), ('int', 'PySide2.QtGui.QMatrix4x2'), ('int', 'PySide2.QtGui.QMatrix4x3'), ('int', 'PySide2.QtGui.QMatrix4x4'), ('int', 'PySide2.QtGui.QTransform'), ('int', 'PySide2.QtGui.QVector2D'), ('int', 'PySide2.QtGui.QVector3D'), ('int', 'PySide2.QtGui.QVector4D'), ('int', 'float'), ('int', 'float', 'float'), ('int', 'float', 'float', 'float'), ('int', 'float', 'float', 'float', 'float'), ('int', 'int'), ('str', 'PySide2.QtCore.QPoint'), ('str', 'PySide2.QtCore.QPointF'), ('str', 'PySide2.QtCore.QSize'), ('str', 'PySide2.QtCore.QSizeF'), ('str', 'PySide2.QtGui.QColor'), ('str', 'PySide2.QtGui.QMatrix2x2'), ('str', 'PySide2.QtGui.QMatrix2x3'), ('str', 'PySide2.QtGui.QMatrix2x4'), ('str', 'PySide2.QtGui.QMatrix3x2'), ('str', 'PySide2.QtGui.QMatrix3x3'), ('str', 'PySide2.QtGui.QMatrix3x4'), ('str', 'PySide2.QtGui.QMatrix4x2'), ('str', 'PySide2.QtGui.QMatrix4x3'), ('str', 'PySide2.QtGui.QMatrix4x4'), ('str', 'PySide2.QtGui.QTransform'), ('str', 'PySide2.QtGui.QVector2D'), ('str', 'PySide2.QtGui.QVector3D'), ('str', 'PySide2.QtGui.QVector4D'), ('str', 'float'), ('str', 'float', 'float'), ('str', 'float', 'float', 'float'), ('str', 'float', 'float', 'float', 'float'), ('str', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray2D": [('int', 'PySide2.QtGui.QVector2D', 'int'), ('str', 'PySide2.QtGui.QVector2D', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray2x2": [('int', 'PySide2.QtGui.QMatrix2x2', 'int'), ('str', 'PySide2.QtGui.QMatrix2x2', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray2x3": [('int', 'PySide2.QtGui.QMatrix2x3', 'int'), ('str', 'PySide2.QtGui.QMatrix2x3', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray2x4": [('int', 'PySide2.QtGui.QMatrix2x4', 'int'), ('str', 'PySide2.QtGui.QMatrix2x4', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray3D": [('int', 'PySide2.QtGui.QVector3D', 'int'), ('str', 'PySide2.QtGui.QVector3D', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray3x2": [('int', 'PySide2.QtGui.QMatrix3x2', 'int'), ('str', 'PySide2.QtGui.QMatrix3x2', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray3x3": [('int', 'PySide2.QtGui.QMatrix3x3', 'int'), ('str', 'PySide2.QtGui.QMatrix3x3', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray3x4": [('int', 'PySide2.QtGui.QMatrix3x4', 'int'), ('str', 'PySide2.QtGui.QMatrix3x4', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray4D": [('int', 'PySide2.QtGui.QVector4D', 'int'), ('str', 'PySide2.QtGui.QVector4D', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray4x2": [('int', 'PySide2.QtGui.QMatrix4x2', 'int'), ('str', 'PySide2.QtGui.QMatrix4x2', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray4x3": [('int', 'PySide2.QtGui.QMatrix4x3', 'int'), ('str', 'PySide2.QtGui.QMatrix4x3', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArray4x4": [('int', 'PySide2.QtGui.QMatrix4x4', 'int'), ('str', 'PySide2.QtGui.QMatrix4x4', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArrayInt": [('int', 'typing.Sequence[int]', 'int'), ('str', 'typing.Sequence[int]', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.setUniformValueArrayUint": [('int', 'typing.Sequence[int]', 'int'), ('str', 'typing.Sequence[int]', 'int')],
    "PySide2.QtOpenGL.QGLShaderProgram.shaders": (),
    "PySide2.QtOpenGL.QGLShaderProgram.uniformLocation": [('PySide2.QtCore.QByteArray',), ('str',)],

# class PySide2.QtOpenGL.QGLWidget:
    "PySide2.QtOpenGL.QGLWidget.__init__": [('PySide2.QtOpenGL.QGLContext', 'PySide2.QtWidgets.QWidget', 'PySide2.QtOpenGL.QGLWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtOpenGL.QGLFormat', 'PySide2.QtWidgets.QWidget', 'PySide2.QtOpenGL.QGLWidget', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QWidget', 'PySide2.QtOpenGL.QGLWidget', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtOpenGL.QGLWidget.autoBufferSwap": (),
    "PySide2.QtOpenGL.QGLWidget.bindTexture": [('PySide2.QtGui.QImage', 'int', 'int'), ('PySide2.QtGui.QImage', 'int', 'int', 'PySide2.QtOpenGL.QGLContext.BindOptions'), ('PySide2.QtGui.QPixmap', 'int', 'int'), ('PySide2.QtGui.QPixmap', 'int', 'int', 'PySide2.QtOpenGL.QGLContext.BindOptions'), ('str',)],
    "PySide2.QtOpenGL.QGLWidget.colormap": (),
    "PySide2.QtOpenGL.QGLWidget.context": (),
    "PySide2.QtOpenGL.QGLWidget.convertToGLFormat": ('PySide2.QtGui.QImage',),
    "PySide2.QtOpenGL.QGLWidget.deleteTexture": ('int',),
    "PySide2.QtOpenGL.QGLWidget.doneCurrent": (),
    "PySide2.QtOpenGL.QGLWidget.doubleBuffer": (),
    "PySide2.QtOpenGL.QGLWidget.drawTexture": [('PySide2.QtCore.QPointF', 'int', 'int'), ('PySide2.QtCore.QRectF', 'int', 'int')],
    "PySide2.QtOpenGL.QGLWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtOpenGL.QGLWidget.format": (),
    "PySide2.QtOpenGL.QGLWidget.glDraw": (),
    "PySide2.QtOpenGL.QGLWidget.glInit": (),
    "PySide2.QtOpenGL.QGLWidget.grabFrameBuffer": ('bool',),
    "PySide2.QtOpenGL.QGLWidget.initializeGL": (),
    "PySide2.QtOpenGL.QGLWidget.initializeOverlayGL": (),
    "PySide2.QtOpenGL.QGLWidget.isSharing": (),
    "PySide2.QtOpenGL.QGLWidget.isValid": (),
    "PySide2.QtOpenGL.QGLWidget.makeCurrent": (),
    "PySide2.QtOpenGL.QGLWidget.makeOverlayCurrent": (),
    "PySide2.QtOpenGL.QGLWidget.overlayContext": (),
    "PySide2.QtOpenGL.QGLWidget.paintEngine": (),
    "PySide2.QtOpenGL.QGLWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtOpenGL.QGLWidget.paintGL": (),
    "PySide2.QtOpenGL.QGLWidget.paintOverlayGL": (),
    "PySide2.QtOpenGL.QGLWidget.qglClearColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtOpenGL.QGLWidget.qglColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtOpenGL.QGLWidget.renderPixmap": ('int', 'int', 'bool'),
    "PySide2.QtOpenGL.QGLWidget.renderText": [('float', 'float', 'float', 'str', 'PySide2.QtGui.QFont'), ('int', 'int', 'str', 'PySide2.QtGui.QFont')],
    "PySide2.QtOpenGL.QGLWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtOpenGL.QGLWidget.resizeGL": ('int', 'int'),
    "PySide2.QtOpenGL.QGLWidget.resizeOverlayGL": ('int', 'int'),
    "PySide2.QtOpenGL.QGLWidget.setAutoBufferSwap": ('bool',),
    "PySide2.QtOpenGL.QGLWidget.setColormap": ('PySide2.QtOpenGL.QGLColormap',),
    "PySide2.QtOpenGL.QGLWidget.swapBuffers": (),
    "PySide2.QtOpenGL.QGLWidget.updateGL": (),
    "PySide2.QtOpenGL.QGLWidget.updateOverlayGL": (),
    }) if "PySide2.QtOpenGL" in sys.modules else None

# Module PySide2.QtOpenGLFunctions
sig_dict.update({

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_0.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_1.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_2.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_3.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_4.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_1_5.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_0.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_2_1.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_0.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_1.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_2_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_3_3_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_0_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_1_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_2_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetProgramResourceLocationIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInvalidateBufferData": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInvalidateFramebuffer": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInvalidateSubFramebuffer": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInvalidateTexImage": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glInvalidateTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiDrawArraysIndirect": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glShaderStorageBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTextureView": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribLFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexBindingDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetProgramResourceLocationIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glInvalidateBufferData": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glInvalidateFramebuffer": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glInvalidateSubFramebuffer": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glInvalidateTexImage": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glInvalidateTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiDrawArraysIndirect": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glShaderStorageBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glTextureView": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribLFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexBindingDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_3_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindBuffersBase": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindImageTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindSamplers": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClearTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDebugMessageControl": ('int', 'int', 'int', 'int', 'typing.Sequence[int]', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDebugMessageInsert": ('int', 'int', 'int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetColorTable": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetCompressedTexImage": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetConvolutionFilter": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetHistogram": ('int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetMinmax": ('int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetProgramResourceLocationIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetSeparableFilter": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInvalidateBufferData": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInvalidateFramebuffer": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInvalidateSubFramebuffer": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInvalidateTexImage": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glInvalidateTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiDrawArraysIndirect": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glObjectLabel": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glObjectPtrLabel": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPopDebugGroup": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPushDebugGroup": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glReadPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glShaderStorageBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTextureView": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribLFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexBindingDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindBuffersBase": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindImageTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindSamplers": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glClearTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDebugMessageControl": ('int', 'int', 'int', 'int', 'typing.Sequence[int]', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDebugMessageInsert": ('int', 'int', 'int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetCompressedTexImage": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetProgramResourceLocationIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glInvalidateBufferData": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glInvalidateFramebuffer": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glInvalidateSubFramebuffer": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glInvalidateTexImage": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glInvalidateTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glMultiDrawArraysIndirect": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glObjectLabel": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glObjectPtrLabel": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPopDebugGroup": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glPushDebugGroup": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glReadPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glShaderStorageBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glTextureView": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribLFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glVertexBindingDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_4_Core.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glAccum": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glAlphaFunc": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glArrayElement": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBegin": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindBuffersBase": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindImageTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindSamplers": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindTextureUnit": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glBlitNamedFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCallList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCallLists": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCheckNamedFramebufferStatus": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearAccum": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearIndex": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearNamedBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearNamedFramebufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearNamedFramebufferfv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearNamedFramebufferiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearNamedFramebufferuiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClearTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClientActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClipControl": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glClipPlane": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4b": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4ub": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4us": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColor4usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorMaterial": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorSubTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorTable": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorTableParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glColorTableParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTextureSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTextureSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCompressedTextureSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glConvolutionParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glConvolutionParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glConvolutionParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glConvolutionParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyColorSubTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyConvolutionFilter1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyConvolutionFilter2D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTextureSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTextureSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCopyTextureSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDebugMessageControl": ('int', 'int', 'int', 'int', 'typing.Sequence[int]', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDebugMessageInsert": ('int', 'int', 'int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteLists": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDisableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDisableVertexArrayAttrib": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawPixels": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEdgeFlag": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEdgeFlagPointer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEnableClientState": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEnableVertexArrayAttrib": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEnd": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEndList": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalMesh1": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalMesh2": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalPoint1": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glEvalPoint2": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogCoordPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogCoordd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogCoorddv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogCoordf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogCoordfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFogiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glFrustum": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGenLists": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGenerateTextureMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetColorTable": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetCompressedTexImage": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetCompressedTextureImage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetCompressedTextureSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetConvolutionFilter": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetGraphicsResetStatus": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetHistogram": ('int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetMinmax": ('int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetProgramResourceLocationIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetSeparableFilter": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetTextureImage": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetTextureSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnColorTable": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnCompressedTexImage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnConvolutionFilter": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnHistogram": ('int', 'typing.Char', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnMinmax": ('int', 'typing.Char', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnSeparableFilter": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glGetnTexImage": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glHistogram": ('int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexd": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexdv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexfv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexi": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexs": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexsv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexub": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIndexubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInitNames": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInterleavedArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateBufferData": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateFramebuffer": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateNamedFramebufferData": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateNamedFramebufferSubData": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateSubFramebuffer": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateTexImage": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glInvalidateTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsList": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightModelf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightModelfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightModeli": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightModeliv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLighti": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLightiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLineStipple": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glListBase": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLoadIdentity": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLoadMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLoadMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLoadName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLoadTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLoadTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMap1d": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMap1f": ('int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMap2d": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMap2f": ('int', 'float', 'float', 'int', 'int', 'float', 'float', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMapGrid1d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMapGrid1f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMapGrid2d": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMapGrid2f": ('int', 'float', 'float', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMapNamedBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMaterialf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMaterialfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMateriali": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMaterialiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMatrixMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMemoryBarrierByRegion": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMinmax": ('int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultTransposeMatrixd": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultTransposeMatrixf": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiDrawArraysIndirect": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoord4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP4ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glMultiTexCoordP4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedBufferData": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedBufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferDrawBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferDrawBuffers": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferReadBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNamedRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNewList": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormal3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormalP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormalP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glNormalPointer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glObjectLabel": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glObjectPtrLabel": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glOrtho": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPassThrough": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelMapfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelMapuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelMapusv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelTransferf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelTransferi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPixelZoom": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPopAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPopClientAttrib": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPopDebugGroup": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPopMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPopName": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPrioritizeTextures": ('int', 'typing.Sequence[int]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPushAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPushClientAttrib": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPushDebugGroup": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPushMatrix": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glPushName": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRasterPos4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glReadPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glReadnPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRectd": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRectdv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRectf": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRectfv": ('typing.Sequence[float]', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRecti": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRectiv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRects": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRectsv": ('typing.Sequence[int]', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRenderMode": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glResetHistogram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glResetMinmax": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRotated": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glRotatef": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glScaled": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glScalef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3b": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3bv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3ub": ('typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3ubv": ('str',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3uiv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3us": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColor3usv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColorP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColorP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSecondaryColorPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glSeparableFilter2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glShadeModel": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glShaderStorageBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1d": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1f": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1i": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1s": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord1sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoord4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexCoordPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexEnvf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexEnvfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexEnvi": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexEnviv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexGend": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexGendv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexGenf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexGenfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexGeni": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexGeniv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureBarrier": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTextureView": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTransformFeedbackBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTranslated": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glTranslatef": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUnmapNamedBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4d": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4f": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertex4sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexArrayAttribBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexArrayAttribFormat": ('int', 'int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexArrayAttribIFormat": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexArrayAttribLFormat": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexArrayBindingDivisor": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexArrayElementBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribLFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexBindingDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexP2ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexP2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexP3ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexP3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexP4ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexP4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glVertexPointer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2d": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2f": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos2sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3d": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3dv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3f": ('float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3fv": ('typing.Sequence[float]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3iv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.glWindowPos3sv": ('typing.Sequence[int]',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Compatibility.initializeOpenGLFunctions": (),

# class PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core:
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.__init__": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glActiveShaderProgram": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glActiveTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glAttachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBeginConditionalRender": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBeginQuery": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBeginQueryIndexed": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBeginTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindAttribLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindBuffersBase": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindFragDataLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindFragDataLocationIndexed": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindFramebuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindImageTexture": ('int', 'int', 'int', 'typing.Char', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindImageTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindRenderbuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindSampler": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindSamplers": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindTexture": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindTextureUnit": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindTextures": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBindVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendEquation": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendEquationSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendEquationSeparatei": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendEquationi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendFunc": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendFuncSeparatei": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlendFunci": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlitFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glBlitNamedFramebuffer": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCheckFramebufferStatus": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCheckNamedFramebufferStatus": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClampColor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClear": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearBufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearBufferfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearBufferiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearBufferuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearColor": ('float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearDepth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearDepthf": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearNamedBufferData": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearNamedFramebufferfi": ('int', 'int', 'float', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearNamedFramebufferfv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearNamedFramebufferiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearNamedFramebufferuiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearStencil": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClearTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glClipControl": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glColorMask": ('typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glColorMaski": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompileShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTextureSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTextureSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCompressedTextureSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyImageSubData": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTextureSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTextureSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCopyTextureSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCreateProgram": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCreateShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glCullFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDebugMessageControl": ('int', 'int', 'int', 'int', 'typing.Sequence[int]', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDebugMessageInsert": ('int', 'int', 'int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteFramebuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteProgramPipelines": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteQueries": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteRenderbuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteSamplers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteTextures": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteTransformFeedbacks": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDeleteVertexArrays": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDepthFunc": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDepthMask": ('typing.Char',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDepthRange": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDepthRangeArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDepthRangeIndexed": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDepthRangef": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDetachShader": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDisable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDisableVertexArrayAttrib": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDisableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDisablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDispatchCompute": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawArrays": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawArraysIndirect": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawArraysInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawArraysInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawBuffers": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElements": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElementsBaseVertex": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElementsIndirect": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElementsInstanced": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElementsInstancedBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElementsInstancedBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawElementsInstancedBaseVertexBaseInstance": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawRangeElements": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawRangeElementsBaseVertex": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawTransformFeedback": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawTransformFeedbackInstanced": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawTransformFeedbackStream": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glDrawTransformFeedbackStreamInstanced": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEnable": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEnableVertexArrayAttrib": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEnableVertexAttribArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEnablei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEndConditionalRender": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEndQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEndQueryIndexed": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glEndTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFinish": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFlush": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferTexture1D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferTexture2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferTexture3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glFrontFace": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGenerateMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGenerateTextureMipmap": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetAttribLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetCompressedTexImage": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetCompressedTextureImage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetCompressedTextureSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetError": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetFragDataIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetFragDataLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetGraphicsResetStatus": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetProgramResourceIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetProgramResourceLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetProgramResourceLocationIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetString": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetStringi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetSubroutineIndex": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetSubroutineUniformLocation": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetTexImage": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetTextureImage": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetTextureSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetUniformBlockIndex": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetUniformLocation": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetnCompressedTexImage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glGetnTexImage": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glHint": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateBufferData": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateFramebuffer": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateNamedFramebufferData": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateNamedFramebufferSubData": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateSubFramebuffer": ('int', 'int', 'typing.Sequence[int]', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateTexImage": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glInvalidateTexSubImage": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsEnabled": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsEnabledi": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsFramebuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsQuery": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsRenderbuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsSampler": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsShader": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsTexture": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsTransformFeedback": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glIsVertexArray": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glLineWidth": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glLinkProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glLogicOp": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMapBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMapNamedBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMemoryBarrier": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMemoryBarrierByRegion": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMinSampleShading": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMultiDrawArrays": ('int', 'typing.Sequence[int]', 'typing.Sequence[int]', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glMultiDrawArraysIndirect": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedBufferData": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedBufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferDrawBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferDrawBuffers": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferReadBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferRenderbuffer": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferTexture": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedFramebufferTextureLayer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glNamedRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glObjectLabel": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glObjectPtrLabel": ('int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPatchParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPatchParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPauseTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPixelStoref": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPixelStorei": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPointParameterf": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPointParameterfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPointParameteri": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPointParameteriv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPointSize": ('float',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPolygonMode": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPolygonOffset": ('float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPopDebugGroup": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPrimitiveRestartIndex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramBinary": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1d": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1f": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform1uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2d": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2f": ('int', 'int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform2uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3d": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3f": ('int', 'int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform3uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4d": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4dv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4f": ('int', 'int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4fv": ('int', 'int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4i": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4iv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4ui": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniform4uiv": ('int', 'int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix2x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix2x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix2x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix2x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix3x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix3x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix3x4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix3x4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix4dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix4fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix4x2dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix4x2fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix4x3dv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProgramUniformMatrix4x3fv": ('int', 'int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glProvokingVertex": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glPushDebugGroup": ('int', 'int', 'int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glQueryCounter": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glReadBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glReadPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glReadnPixels": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glReleaseShaderCompiler": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glRenderbufferStorage": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glRenderbufferStorageMultisample": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glResumeTransformFeedback": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSampleCoverage": ('float', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSampleMaski": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSamplerParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSamplerParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSamplerParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSamplerParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSamplerParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glSamplerParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glScissor": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glScissorArrayv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glScissorIndexed": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glScissorIndexedv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glShaderBinary": ('int', 'typing.Sequence[int]', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glShaderStorageBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glStencilFunc": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glStencilFuncSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glStencilMask": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glStencilMaskSeparate": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glStencilOp": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glStencilOpSeparate": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexImage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexImage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTexSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureBarrier": (),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureBuffer": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureParameterIiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureParameterIuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureParameterf": ('int', 'int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureParameterfv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureParameteri": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureParameteriv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureStorage1D": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureStorage2D": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureStorage2DMultisample": ('int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureStorage3D": ('int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureStorage3DMultisample": ('int', 'int', 'int', 'int', 'int', 'int', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureSubImage1D": ('int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureSubImage2D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureSubImage3D": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTextureView": ('int', 'int', 'int', 'int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glTransformFeedbackBufferBase": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform1uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform2uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform3uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4dv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4fv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4iv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniform4uiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformBlockBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix2x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix2x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix2x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix2x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix3x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix3x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix3x4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix3x4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix4dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix4fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix4x2dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix4x2fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix4x3dv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformMatrix4x3fv": ('int', 'int', 'typing.Char', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUniformSubroutinesuiv": ('int', 'int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUnmapBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUnmapNamedBuffer": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUseProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glUseProgramStages": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glValidateProgram": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glValidateProgramPipeline": ('int',),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexArrayAttribBinding": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexArrayAttribFormat": ('int', 'int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexArrayAttribIFormat": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexArrayAttribLFormat": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexArrayBindingDivisor": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexArrayElementBuffer": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib1f": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib1fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib1s": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib1sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib2f": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib2fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib2s": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib2sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib3f": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib3fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib3s": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib3sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Nbv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Niv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Nsv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Nub": ('int', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Nubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Nuiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4Nusv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4f": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4fv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4s": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttrib4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribBinding": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribFormat": ('int', 'int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI1i": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI1iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI1ui": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI1uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI2i": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI2iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI2ui": ('int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI2uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI3i": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI3iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI3ui": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI3uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4bv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4i": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4iv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4sv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4ubv": ('int', 'str'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4ui": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4uiv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribI4usv": ('int', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribIFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribIPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL1d": ('int', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL1dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL2d": ('int', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL2dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL3d": ('int', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL3dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL4d": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribL4dv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribLFormat": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribLPointer": ('int', 'int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP1ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP1uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP2ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP2uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP3ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP3uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP4ui": ('int', 'int', 'typing.Char', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribP4uiv": ('int', 'int', 'typing.Char', 'typing.Sequence[int]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexAttribPointer": ('int', 'int', 'int', 'typing.Char', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glVertexBindingDivisor": ('int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glViewport": ('int', 'int', 'int', 'int'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glViewportArrayv": ('int', 'int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glViewportIndexedf": ('int', 'float', 'float', 'float', 'float'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.glViewportIndexedfv": ('int', 'typing.Sequence[float]'),
    "PySide2.QtOpenGLFunctions.QOpenGLFunctions_4_5_Core.initializeOpenGLFunctions": (),
    }) if "PySide2.QtOpenGLFunctions" in sys.modules else None

# Module PySide2.QtPositioning
sig_dict.update({

# class PySide2.QtPositioning.QGeoAddress:
    "PySide2.QtPositioning.QGeoAddress.__init__": [(), ('PySide2.QtPositioning.QGeoAddress',)],
    "PySide2.QtPositioning.QGeoAddress.__copy__": (),
    "PySide2.QtPositioning.QGeoAddress.city": (),
    "PySide2.QtPositioning.QGeoAddress.clear": (),
    "PySide2.QtPositioning.QGeoAddress.country": (),
    "PySide2.QtPositioning.QGeoAddress.countryCode": (),
    "PySide2.QtPositioning.QGeoAddress.county": (),
    "PySide2.QtPositioning.QGeoAddress.district": (),
    "PySide2.QtPositioning.QGeoAddress.isEmpty": (),
    "PySide2.QtPositioning.QGeoAddress.isTextGenerated": (),
    "PySide2.QtPositioning.QGeoAddress.postalCode": (),
    "PySide2.QtPositioning.QGeoAddress.setCity": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setCountry": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setCountryCode": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setCounty": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setDistrict": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setPostalCode": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setState": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setStreet": ('str',),
    "PySide2.QtPositioning.QGeoAddress.setText": ('str',),
    "PySide2.QtPositioning.QGeoAddress.state": (),
    "PySide2.QtPositioning.QGeoAddress.street": (),
    "PySide2.QtPositioning.QGeoAddress.text": (),

# class PySide2.QtPositioning.QGeoAreaMonitorInfo:
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.__init__": [('PySide2.QtPositioning.QGeoAreaMonitorInfo',), ('str',)],
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.__copy__": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.area": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.expiration": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.identifier": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.isPersistent": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.isValid": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.name": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.notificationParameters": (),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.setArea": ('PySide2.QtPositioning.QGeoShape',),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.setExpiration": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.setName": ('str',),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.setNotificationParameters": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtPositioning.QGeoAreaMonitorInfo.setPersistent": ('bool',),

# class PySide2.QtPositioning.QGeoAreaMonitorSource:

# class PySide2.QtPositioning.QGeoAreaMonitorSource.AreaMonitorFeature:

# class PySide2.QtPositioning.QGeoAreaMonitorSource.AreaMonitorFeatures:

# class PySide2.QtPositioning.QGeoAreaMonitorSource.Error:
    "PySide2.QtPositioning.QGeoAreaMonitorSource.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.activeMonitors": [(), ('PySide2.QtPositioning.QGeoShape',)],
    "PySide2.QtPositioning.QGeoAreaMonitorSource.availableSources": (),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.createDefaultSource": ('PySide2.QtCore.QObject',),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.createSource": ('str', 'PySide2.QtCore.QObject'),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.error": (),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.positionInfoSource": (),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.requestUpdate": ('PySide2.QtPositioning.QGeoAreaMonitorInfo', 'str'),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.setPositionInfoSource": ('PySide2.QtPositioning.QGeoPositionInfoSource',),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.sourceName": (),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.startMonitoring": ('PySide2.QtPositioning.QGeoAreaMonitorInfo',),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.stopMonitoring": ('PySide2.QtPositioning.QGeoAreaMonitorInfo',),
    "PySide2.QtPositioning.QGeoAreaMonitorSource.supportedAreaMonitorFeatures": (),

# class PySide2.QtPositioning.QGeoCircle:
    "PySide2.QtPositioning.QGeoCircle.__init__": [(), ('PySide2.QtPositioning.QGeoCircle',), ('PySide2.QtPositioning.QGeoCoordinate', 'float'), ('PySide2.QtPositioning.QGeoShape',)],
    "PySide2.QtPositioning.QGeoCircle.__copy__": (),
    "PySide2.QtPositioning.QGeoCircle.center": (),
    "PySide2.QtPositioning.QGeoCircle.extendCircle": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoCircle.radius": (),
    "PySide2.QtPositioning.QGeoCircle.setCenter": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoCircle.setRadius": ('float',),
    "PySide2.QtPositioning.QGeoCircle.toString": (),
    "PySide2.QtPositioning.QGeoCircle.translate": ('float', 'float'),
    "PySide2.QtPositioning.QGeoCircle.translated": ('float', 'float'),

# class PySide2.QtPositioning.QGeoCoordinate:

# class PySide2.QtPositioning.QGeoCoordinate.CoordinateFormat:

# class PySide2.QtPositioning.QGeoCoordinate.CoordinateType:
    "PySide2.QtPositioning.QGeoCoordinate.__init__": [(), ('PySide2.QtPositioning.QGeoCoordinate',), ('float', 'float'), ('float', 'float', 'float')],
    "PySide2.QtPositioning.QGeoCoordinate.__copy__": (),
    "PySide2.QtPositioning.QGeoCoordinate.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoCoordinate.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoCoordinate.altitude": (),
    "PySide2.QtPositioning.QGeoCoordinate.atDistanceAndAzimuth": ('float', 'float', 'float'),
    "PySide2.QtPositioning.QGeoCoordinate.azimuthTo": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoCoordinate.distanceTo": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoCoordinate.isValid": (),
    "PySide2.QtPositioning.QGeoCoordinate.latitude": (),
    "PySide2.QtPositioning.QGeoCoordinate.longitude": (),
    "PySide2.QtPositioning.QGeoCoordinate.setAltitude": ('float',),
    "PySide2.QtPositioning.QGeoCoordinate.setLatitude": ('float',),
    "PySide2.QtPositioning.QGeoCoordinate.setLongitude": ('float',),
    "PySide2.QtPositioning.QGeoCoordinate.toString": ('PySide2.QtPositioning.QGeoCoordinate.CoordinateFormat',),
    "PySide2.QtPositioning.QGeoCoordinate.type": (),

# class PySide2.QtPositioning.QGeoLocation:
    "PySide2.QtPositioning.QGeoLocation.__init__": [(), ('PySide2.QtPositioning.QGeoLocation',)],
    "PySide2.QtPositioning.QGeoLocation.__copy__": (),
    "PySide2.QtPositioning.QGeoLocation.address": (),
    "PySide2.QtPositioning.QGeoLocation.boundingBox": (),
    "PySide2.QtPositioning.QGeoLocation.coordinate": (),
    "PySide2.QtPositioning.QGeoLocation.extendedAttributes": (),
    "PySide2.QtPositioning.QGeoLocation.isEmpty": (),
    "PySide2.QtPositioning.QGeoLocation.setAddress": ('PySide2.QtPositioning.QGeoAddress',),
    "PySide2.QtPositioning.QGeoLocation.setBoundingBox": ('PySide2.QtPositioning.QGeoRectangle',),
    "PySide2.QtPositioning.QGeoLocation.setCoordinate": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoLocation.setExtendedAttributes": ('typing.Dict[str, typing.Any]',),

# class PySide2.QtPositioning.QGeoPath:
    "PySide2.QtPositioning.QGeoPath.__init__": [(), ('PySide2.QtPositioning.QGeoPath',), ('PySide2.QtPositioning.QGeoShape',), ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]', 'float')],
    "PySide2.QtPositioning.QGeoPath.__copy__": (),
    "PySide2.QtPositioning.QGeoPath.addCoordinate": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoPath.clearPath": (),
    "PySide2.QtPositioning.QGeoPath.containsCoordinate": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoPath.coordinateAt": ('int',),
    "PySide2.QtPositioning.QGeoPath.insertCoordinate": ('int', 'PySide2.QtPositioning.QGeoCoordinate'),
    "PySide2.QtPositioning.QGeoPath.length": ('int', 'int'),
    "PySide2.QtPositioning.QGeoPath.path": (),
    "PySide2.QtPositioning.QGeoPath.removeCoordinate": [('PySide2.QtPositioning.QGeoCoordinate',), ('int',)],
    "PySide2.QtPositioning.QGeoPath.replaceCoordinate": ('int', 'PySide2.QtPositioning.QGeoCoordinate'),
    "PySide2.QtPositioning.QGeoPath.setPath": ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',),
    "PySide2.QtPositioning.QGeoPath.setVariantPath": ('typing.Sequence[typing.Any]',),
    "PySide2.QtPositioning.QGeoPath.setWidth": ('float',),
    "PySide2.QtPositioning.QGeoPath.size": (),
    "PySide2.QtPositioning.QGeoPath.toString": (),
    "PySide2.QtPositioning.QGeoPath.translate": ('float', 'float'),
    "PySide2.QtPositioning.QGeoPath.translated": ('float', 'float'),
    "PySide2.QtPositioning.QGeoPath.variantPath": (),
    "PySide2.QtPositioning.QGeoPath.width": (),

# class PySide2.QtPositioning.QGeoPolygon:
    "PySide2.QtPositioning.QGeoPolygon.__init__": [(), ('PySide2.QtPositioning.QGeoPolygon',), ('PySide2.QtPositioning.QGeoShape',), ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',)],
    "PySide2.QtPositioning.QGeoPolygon.__copy__": (),
    "PySide2.QtPositioning.QGeoPolygon.addCoordinate": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoPolygon.addHole": [('typing.Any',), ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',)],
    "PySide2.QtPositioning.QGeoPolygon.containsCoordinate": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoPolygon.coordinateAt": ('int',),
    "PySide2.QtPositioning.QGeoPolygon.hole": ('int',),
    "PySide2.QtPositioning.QGeoPolygon.holePath": ('int',),
    "PySide2.QtPositioning.QGeoPolygon.holesCount": (),
    "PySide2.QtPositioning.QGeoPolygon.insertCoordinate": ('int', 'PySide2.QtPositioning.QGeoCoordinate'),
    "PySide2.QtPositioning.QGeoPolygon.length": ('int', 'int'),
    "PySide2.QtPositioning.QGeoPolygon.path": (),
    "PySide2.QtPositioning.QGeoPolygon.perimeter": (),
    "PySide2.QtPositioning.QGeoPolygon.removeCoordinate": [('PySide2.QtPositioning.QGeoCoordinate',), ('int',)],
    "PySide2.QtPositioning.QGeoPolygon.removeHole": ('int',),
    "PySide2.QtPositioning.QGeoPolygon.replaceCoordinate": ('int', 'PySide2.QtPositioning.QGeoCoordinate'),
    "PySide2.QtPositioning.QGeoPolygon.setPath": ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',),
    "PySide2.QtPositioning.QGeoPolygon.setPerimeter": ('typing.Sequence[typing.Any]',),
    "PySide2.QtPositioning.QGeoPolygon.size": (),
    "PySide2.QtPositioning.QGeoPolygon.toString": (),
    "PySide2.QtPositioning.QGeoPolygon.translate": ('float', 'float'),
    "PySide2.QtPositioning.QGeoPolygon.translated": ('float', 'float'),

# class PySide2.QtPositioning.QGeoPositionInfo:

# class PySide2.QtPositioning.QGeoPositionInfo.Attribute:
    "PySide2.QtPositioning.QGeoPositionInfo.__init__": [(), ('PySide2.QtPositioning.QGeoCoordinate', 'PySide2.QtCore.QDateTime'), ('PySide2.QtPositioning.QGeoPositionInfo',)],
    "PySide2.QtPositioning.QGeoPositionInfo.__copy__": (),
    "PySide2.QtPositioning.QGeoPositionInfo.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoPositionInfo.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoPositionInfo.attribute": ('PySide2.QtPositioning.QGeoPositionInfo.Attribute',),
    "PySide2.QtPositioning.QGeoPositionInfo.coordinate": (),
    "PySide2.QtPositioning.QGeoPositionInfo.hasAttribute": ('PySide2.QtPositioning.QGeoPositionInfo.Attribute',),
    "PySide2.QtPositioning.QGeoPositionInfo.isValid": (),
    "PySide2.QtPositioning.QGeoPositionInfo.removeAttribute": ('PySide2.QtPositioning.QGeoPositionInfo.Attribute',),
    "PySide2.QtPositioning.QGeoPositionInfo.setAttribute": ('PySide2.QtPositioning.QGeoPositionInfo.Attribute', 'float'),
    "PySide2.QtPositioning.QGeoPositionInfo.setCoordinate": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoPositionInfo.setTimestamp": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtPositioning.QGeoPositionInfo.timestamp": (),

# class PySide2.QtPositioning.QGeoPositionInfoSource:

# class PySide2.QtPositioning.QGeoPositionInfoSource.Error:

# class PySide2.QtPositioning.QGeoPositionInfoSource.PositioningMethod:

# class PySide2.QtPositioning.QGeoPositionInfoSource.PositioningMethods:
    "PySide2.QtPositioning.QGeoPositionInfoSource.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtPositioning.QGeoPositionInfoSource.availableSources": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.backendProperty": ('str',),
    "PySide2.QtPositioning.QGeoPositionInfoSource.createDefaultSource": [('PySide2.QtCore.QObject',), ('typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject')],
    "PySide2.QtPositioning.QGeoPositionInfoSource.createSource": [('str', 'PySide2.QtCore.QObject'), ('str', 'typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject')],
    "PySide2.QtPositioning.QGeoPositionInfoSource.error": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.lastKnownPosition": ('bool',),
    "PySide2.QtPositioning.QGeoPositionInfoSource.minimumUpdateInterval": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.preferredPositioningMethods": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.requestUpdate": ('int',),
    "PySide2.QtPositioning.QGeoPositionInfoSource.setBackendProperty": ('str', 'typing.Any'),
    "PySide2.QtPositioning.QGeoPositionInfoSource.setPreferredPositioningMethods": ('PySide2.QtPositioning.QGeoPositionInfoSource.PositioningMethods',),
    "PySide2.QtPositioning.QGeoPositionInfoSource.setUpdateInterval": ('int',),
    "PySide2.QtPositioning.QGeoPositionInfoSource.sourceName": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.startUpdates": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.stopUpdates": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.supportedPositioningMethods": (),
    "PySide2.QtPositioning.QGeoPositionInfoSource.updateInterval": (),

# class PySide2.QtPositioning.QGeoPositionInfoSourceFactory:
    "PySide2.QtPositioning.QGeoPositionInfoSourceFactory.__init__": (),
    "PySide2.QtPositioning.QGeoPositionInfoSourceFactory.areaMonitor": ('PySide2.QtCore.QObject',),
    "PySide2.QtPositioning.QGeoPositionInfoSourceFactory.positionInfoSource": ('PySide2.QtCore.QObject',),
    "PySide2.QtPositioning.QGeoPositionInfoSourceFactory.satelliteInfoSource": ('PySide2.QtCore.QObject',),

# class PySide2.QtPositioning.QGeoRectangle:
    "PySide2.QtPositioning.QGeoRectangle.__init__": [(), ('PySide2.QtPositioning.QGeoCoordinate', 'PySide2.QtPositioning.QGeoCoordinate'), ('PySide2.QtPositioning.QGeoCoordinate', 'float', 'float'), ('PySide2.QtPositioning.QGeoRectangle',), ('PySide2.QtPositioning.QGeoShape',), ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',)],
    "PySide2.QtPositioning.QGeoRectangle.__copy__": (),
    "PySide2.QtPositioning.QGeoRectangle.__ior__": ('PySide2.QtPositioning.QGeoRectangle',),
    "PySide2.QtPositioning.QGeoRectangle.__or__": ('PySide2.QtPositioning.QGeoRectangle',),
    "PySide2.QtPositioning.QGeoRectangle.bottomLeft": (),
    "PySide2.QtPositioning.QGeoRectangle.bottomRight": (),
    "PySide2.QtPositioning.QGeoRectangle.center": (),
    "PySide2.QtPositioning.QGeoRectangle.contains": [('PySide2.QtPositioning.QGeoCoordinate',), ('PySide2.QtPositioning.QGeoRectangle',)],
    "PySide2.QtPositioning.QGeoRectangle.extendRectangle": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoRectangle.height": (),
    "PySide2.QtPositioning.QGeoRectangle.intersects": ('PySide2.QtPositioning.QGeoRectangle',),
    "PySide2.QtPositioning.QGeoRectangle.setBottomLeft": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoRectangle.setBottomRight": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoRectangle.setCenter": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoRectangle.setHeight": ('float',),
    "PySide2.QtPositioning.QGeoRectangle.setTopLeft": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoRectangle.setTopRight": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoRectangle.setWidth": ('float',),
    "PySide2.QtPositioning.QGeoRectangle.toString": (),
    "PySide2.QtPositioning.QGeoRectangle.topLeft": (),
    "PySide2.QtPositioning.QGeoRectangle.topRight": (),
    "PySide2.QtPositioning.QGeoRectangle.translate": ('float', 'float'),
    "PySide2.QtPositioning.QGeoRectangle.translated": ('float', 'float'),
    "PySide2.QtPositioning.QGeoRectangle.united": ('PySide2.QtPositioning.QGeoRectangle',),
    "PySide2.QtPositioning.QGeoRectangle.width": (),

# class PySide2.QtPositioning.QGeoSatelliteInfo:

# class PySide2.QtPositioning.QGeoSatelliteInfo.Attribute:

# class PySide2.QtPositioning.QGeoSatelliteInfo.SatelliteSystem:
    "PySide2.QtPositioning.QGeoSatelliteInfo.__init__": [(), ('PySide2.QtPositioning.QGeoSatelliteInfo',)],
    "PySide2.QtPositioning.QGeoSatelliteInfo.__copy__": (),
    "PySide2.QtPositioning.QGeoSatelliteInfo.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.attribute": ('PySide2.QtPositioning.QGeoSatelliteInfo.Attribute',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.hasAttribute": ('PySide2.QtPositioning.QGeoSatelliteInfo.Attribute',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.removeAttribute": ('PySide2.QtPositioning.QGeoSatelliteInfo.Attribute',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.satelliteIdentifier": (),
    "PySide2.QtPositioning.QGeoSatelliteInfo.satelliteSystem": (),
    "PySide2.QtPositioning.QGeoSatelliteInfo.setAttribute": ('PySide2.QtPositioning.QGeoSatelliteInfo.Attribute', 'float'),
    "PySide2.QtPositioning.QGeoSatelliteInfo.setSatelliteIdentifier": ('int',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.setSatelliteSystem": ('PySide2.QtPositioning.QGeoSatelliteInfo.SatelliteSystem',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.setSignalStrength": ('int',),
    "PySide2.QtPositioning.QGeoSatelliteInfo.signalStrength": (),

# class PySide2.QtPositioning.QGeoSatelliteInfoSource:

# class PySide2.QtPositioning.QGeoSatelliteInfoSource.Error:
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.availableSources": (),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.createDefaultSource": [('PySide2.QtCore.QObject',), ('typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject')],
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.createSource": [('str', 'PySide2.QtCore.QObject'), ('str', 'typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject')],
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.error": (),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.minimumUpdateInterval": (),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.requestUpdate": ('int',),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.setUpdateInterval": ('int',),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.sourceName": (),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.startUpdates": (),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.stopUpdates": (),
    "PySide2.QtPositioning.QGeoSatelliteInfoSource.updateInterval": (),

# class PySide2.QtPositioning.QGeoShape:

# class PySide2.QtPositioning.QGeoShape.ShapeType:
    "PySide2.QtPositioning.QGeoShape.__init__": [(), ('PySide2.QtPositioning.QGeoShape',)],
    "PySide2.QtPositioning.QGeoShape.__copy__": (),
    "PySide2.QtPositioning.QGeoShape.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoShape.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtPositioning.QGeoShape.boundingGeoRectangle": (),
    "PySide2.QtPositioning.QGeoShape.center": (),
    "PySide2.QtPositioning.QGeoShape.contains": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoShape.extendShape": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtPositioning.QGeoShape.isEmpty": (),
    "PySide2.QtPositioning.QGeoShape.isValid": (),
    "PySide2.QtPositioning.QGeoShape.toString": (),
    "PySide2.QtPositioning.QGeoShape.type": (),

# class PySide2.QtPositioning.QNmeaPositionInfoSource:

# class PySide2.QtPositioning.QNmeaPositionInfoSource.UpdateMode:
    "PySide2.QtPositioning.QNmeaPositionInfoSource.__init__": ('PySide2.QtPositioning.QNmeaPositionInfoSource.UpdateMode', 'PySide2.QtCore.QObject'),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.device": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.error": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.lastKnownPosition": ('bool',),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.minimumUpdateInterval": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.parsePosInfoFromNmeaData": ('str', 'int', 'PySide2.QtPositioning.QGeoPositionInfo'),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.requestUpdate": ('int',),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.setDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.setUpdateInterval": ('int',),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.setUserEquivalentRangeError": ('float',),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.startUpdates": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.stopUpdates": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.supportedPositioningMethods": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.updateMode": (),
    "PySide2.QtPositioning.QNmeaPositionInfoSource.userEquivalentRangeError": (),
    }) if "PySide2.QtPositioning" in sys.modules else None

# Module PySide2.QtLocation
sig_dict.update({

# class PySide2.QtLocation.QGeoCodeReply:

# class PySide2.QtLocation.QGeoCodeReply.Error:
    "PySide2.QtLocation.QGeoCodeReply.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtLocation.QGeoCodeReply.Error', 'str', 'PySide2.QtCore.QObject')],
    "PySide2.QtLocation.QGeoCodeReply.abort": (),
    "PySide2.QtLocation.QGeoCodeReply.addLocation": ('PySide2.QtPositioning.QGeoLocation',),
    "PySide2.QtLocation.QGeoCodeReply.error": (),
    "PySide2.QtLocation.QGeoCodeReply.errorString": (),
    "PySide2.QtLocation.QGeoCodeReply.isFinished": (),
    "PySide2.QtLocation.QGeoCodeReply.limit": (),
    "PySide2.QtLocation.QGeoCodeReply.locations": (),
    "PySide2.QtLocation.QGeoCodeReply.offset": (),
    "PySide2.QtLocation.QGeoCodeReply.setError": ('PySide2.QtLocation.QGeoCodeReply.Error', 'str'),
    "PySide2.QtLocation.QGeoCodeReply.setFinished": ('bool',),
    "PySide2.QtLocation.QGeoCodeReply.setLimit": ('int',),
    "PySide2.QtLocation.QGeoCodeReply.setLocations": ('typing.Sequence[PySide2.QtPositioning.QGeoLocation]',),
    "PySide2.QtLocation.QGeoCodeReply.setOffset": ('int',),
    "PySide2.QtLocation.QGeoCodeReply.setViewport": ('PySide2.QtPositioning.QGeoShape',),
    "PySide2.QtLocation.QGeoCodeReply.viewport": (),

# class PySide2.QtLocation.QGeoCodingManager:
    "PySide2.QtLocation.QGeoCodingManager.geocode": [('PySide2.QtPositioning.QGeoAddress', 'PySide2.QtPositioning.QGeoShape'), ('str', 'int', 'int', 'PySide2.QtPositioning.QGeoShape')],
    "PySide2.QtLocation.QGeoCodingManager.locale": (),
    "PySide2.QtLocation.QGeoCodingManager.managerName": (),
    "PySide2.QtLocation.QGeoCodingManager.managerVersion": (),
    "PySide2.QtLocation.QGeoCodingManager.reverseGeocode": ('PySide2.QtPositioning.QGeoCoordinate', 'PySide2.QtPositioning.QGeoShape'),
    "PySide2.QtLocation.QGeoCodingManager.setLocale": ('PySide2.QtCore.QLocale',),

# class PySide2.QtLocation.QGeoCodingManagerEngine:
    "PySide2.QtLocation.QGeoCodingManagerEngine.__init__": ('typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject'),
    "PySide2.QtLocation.QGeoCodingManagerEngine.geocode": [('PySide2.QtPositioning.QGeoAddress', 'PySide2.QtPositioning.QGeoShape'), ('str', 'int', 'int', 'PySide2.QtPositioning.QGeoShape')],
    "PySide2.QtLocation.QGeoCodingManagerEngine.locale": (),
    "PySide2.QtLocation.QGeoCodingManagerEngine.managerName": (),
    "PySide2.QtLocation.QGeoCodingManagerEngine.managerVersion": (),
    "PySide2.QtLocation.QGeoCodingManagerEngine.reverseGeocode": ('PySide2.QtPositioning.QGeoCoordinate', 'PySide2.QtPositioning.QGeoShape'),
    "PySide2.QtLocation.QGeoCodingManagerEngine.setLocale": ('PySide2.QtCore.QLocale',),

# class PySide2.QtLocation.QGeoManeuver:

# class PySide2.QtLocation.QGeoManeuver.InstructionDirection:
    "PySide2.QtLocation.QGeoManeuver.__init__": [(), ('PySide2.QtLocation.QGeoManeuver',)],
    "PySide2.QtLocation.QGeoManeuver.__copy__": (),
    "PySide2.QtLocation.QGeoManeuver.direction": (),
    "PySide2.QtLocation.QGeoManeuver.distanceToNextInstruction": (),
    "PySide2.QtLocation.QGeoManeuver.extendedAttributes": (),
    "PySide2.QtLocation.QGeoManeuver.instructionText": (),
    "PySide2.QtLocation.QGeoManeuver.isValid": (),
    "PySide2.QtLocation.QGeoManeuver.position": (),
    "PySide2.QtLocation.QGeoManeuver.setDirection": ('PySide2.QtLocation.QGeoManeuver.InstructionDirection',),
    "PySide2.QtLocation.QGeoManeuver.setDistanceToNextInstruction": ('float',),
    "PySide2.QtLocation.QGeoManeuver.setExtendedAttributes": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtLocation.QGeoManeuver.setInstructionText": ('str',),
    "PySide2.QtLocation.QGeoManeuver.setPosition": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtLocation.QGeoManeuver.setTimeToNextInstruction": ('int',),
    "PySide2.QtLocation.QGeoManeuver.setWaypoint": ('PySide2.QtPositioning.QGeoCoordinate',),
    "PySide2.QtLocation.QGeoManeuver.timeToNextInstruction": (),
    "PySide2.QtLocation.QGeoManeuver.waypoint": (),

# class PySide2.QtLocation.QGeoRoute:
    "PySide2.QtLocation.QGeoRoute.__init__": [(), ('PySide2.QtLocation.QGeoRoute',)],
    "PySide2.QtLocation.QGeoRoute.__copy__": (),
    "PySide2.QtLocation.QGeoRoute.bounds": (),
    "PySide2.QtLocation.QGeoRoute.distance": (),
    "PySide2.QtLocation.QGeoRoute.extendedAttributes": (),
    "PySide2.QtLocation.QGeoRoute.firstRouteSegment": (),
    "PySide2.QtLocation.QGeoRoute.path": (),
    "PySide2.QtLocation.QGeoRoute.request": (),
    "PySide2.QtLocation.QGeoRoute.routeId": (),
    "PySide2.QtLocation.QGeoRoute.setBounds": ('PySide2.QtPositioning.QGeoRectangle',),
    "PySide2.QtLocation.QGeoRoute.setDistance": ('float',),
    "PySide2.QtLocation.QGeoRoute.setExtendedAttributes": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtLocation.QGeoRoute.setFirstRouteSegment": ('PySide2.QtLocation.QGeoRouteSegment',),
    "PySide2.QtLocation.QGeoRoute.setPath": ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',),
    "PySide2.QtLocation.QGeoRoute.setRequest": ('PySide2.QtLocation.QGeoRouteRequest',),
    "PySide2.QtLocation.QGeoRoute.setRouteId": ('str',),
    "PySide2.QtLocation.QGeoRoute.setTravelMode": ('PySide2.QtLocation.QGeoRouteRequest.TravelMode',),
    "PySide2.QtLocation.QGeoRoute.setTravelTime": ('int',),
    "PySide2.QtLocation.QGeoRoute.travelMode": (),
    "PySide2.QtLocation.QGeoRoute.travelTime": (),

# class PySide2.QtLocation.QGeoRouteReply:

# class PySide2.QtLocation.QGeoRouteReply.Error:
    "PySide2.QtLocation.QGeoRouteReply.__init__": [('PySide2.QtLocation.QGeoRouteReply.Error', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtLocation.QGeoRouteRequest', 'PySide2.QtCore.QObject')],
    "PySide2.QtLocation.QGeoRouteReply.abort": (),
    "PySide2.QtLocation.QGeoRouteReply.addRoutes": ('typing.Sequence[PySide2.QtLocation.QGeoRoute]',),
    "PySide2.QtLocation.QGeoRouteReply.error": (),
    "PySide2.QtLocation.QGeoRouteReply.errorString": (),
    "PySide2.QtLocation.QGeoRouteReply.isFinished": (),
    "PySide2.QtLocation.QGeoRouteReply.request": (),
    "PySide2.QtLocation.QGeoRouteReply.routes": (),
    "PySide2.QtLocation.QGeoRouteReply.setError": ('PySide2.QtLocation.QGeoRouteReply.Error', 'str'),
    "PySide2.QtLocation.QGeoRouteReply.setFinished": ('bool',),
    "PySide2.QtLocation.QGeoRouteReply.setRoutes": ('typing.Sequence[PySide2.QtLocation.QGeoRoute]',),

# class PySide2.QtLocation.QGeoRouteRequest:

# class PySide2.QtLocation.QGeoRouteRequest.FeatureType:

# class PySide2.QtLocation.QGeoRouteRequest.FeatureTypes:

# class PySide2.QtLocation.QGeoRouteRequest.FeatureWeight:

# class PySide2.QtLocation.QGeoRouteRequest.FeatureWeights:

# class PySide2.QtLocation.QGeoRouteRequest.ManeuverDetail:

# class PySide2.QtLocation.QGeoRouteRequest.ManeuverDetails:

# class PySide2.QtLocation.QGeoRouteRequest.RouteOptimization:

# class PySide2.QtLocation.QGeoRouteRequest.RouteOptimizations:

# class PySide2.QtLocation.QGeoRouteRequest.SegmentDetail:

# class PySide2.QtLocation.QGeoRouteRequest.SegmentDetails:

# class PySide2.QtLocation.QGeoRouteRequest.TravelMode:

# class PySide2.QtLocation.QGeoRouteRequest.TravelModes:
    "PySide2.QtLocation.QGeoRouteRequest.__init__": [('PySide2.QtLocation.QGeoRouteRequest',), ('PySide2.QtPositioning.QGeoCoordinate', 'PySide2.QtPositioning.QGeoCoordinate'), ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',)],
    "PySide2.QtLocation.QGeoRouteRequest.departureTime": (),
    "PySide2.QtLocation.QGeoRouteRequest.excludeAreas": (),
    "PySide2.QtLocation.QGeoRouteRequest.extraParameters": (),
    "PySide2.QtLocation.QGeoRouteRequest.featureTypes": (),
    "PySide2.QtLocation.QGeoRouteRequest.featureWeight": ('PySide2.QtLocation.QGeoRouteRequest.FeatureType',),
    "PySide2.QtLocation.QGeoRouteRequest.maneuverDetail": (),
    "PySide2.QtLocation.QGeoRouteRequest.numberAlternativeRoutes": (),
    "PySide2.QtLocation.QGeoRouteRequest.routeOptimization": (),
    "PySide2.QtLocation.QGeoRouteRequest.segmentDetail": (),
    "PySide2.QtLocation.QGeoRouteRequest.setDepartureTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtLocation.QGeoRouteRequest.setExcludeAreas": ('typing.Sequence[PySide2.QtPositioning.QGeoRectangle]',),
    "PySide2.QtLocation.QGeoRouteRequest.setExtraParameters": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtLocation.QGeoRouteRequest.setFeatureWeight": ('PySide2.QtLocation.QGeoRouteRequest.FeatureType', 'PySide2.QtLocation.QGeoRouteRequest.FeatureWeight'),
    "PySide2.QtLocation.QGeoRouteRequest.setManeuverDetail": ('PySide2.QtLocation.QGeoRouteRequest.ManeuverDetail',),
    "PySide2.QtLocation.QGeoRouteRequest.setNumberAlternativeRoutes": ('int',),
    "PySide2.QtLocation.QGeoRouteRequest.setRouteOptimization": ('PySide2.QtLocation.QGeoRouteRequest.RouteOptimizations',),
    "PySide2.QtLocation.QGeoRouteRequest.setSegmentDetail": ('PySide2.QtLocation.QGeoRouteRequest.SegmentDetail',),
    "PySide2.QtLocation.QGeoRouteRequest.setTravelModes": ('PySide2.QtLocation.QGeoRouteRequest.TravelModes',),
    "PySide2.QtLocation.QGeoRouteRequest.setWaypoints": ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',),
    "PySide2.QtLocation.QGeoRouteRequest.setWaypointsMetadata": ('typing.Sequence[typing.Dict]',),
    "PySide2.QtLocation.QGeoRouteRequest.travelModes": (),
    "PySide2.QtLocation.QGeoRouteRequest.waypoints": (),
    "PySide2.QtLocation.QGeoRouteRequest.waypointsMetadata": (),

# class PySide2.QtLocation.QGeoRouteSegment:
    "PySide2.QtLocation.QGeoRouteSegment.__init__": [(), ('PySide2.QtLocation.QGeoRouteSegment',)],
    "PySide2.QtLocation.QGeoRouteSegment.__copy__": (),
    "PySide2.QtLocation.QGeoRouteSegment.distance": (),
    "PySide2.QtLocation.QGeoRouteSegment.isLegLastSegment": (),
    "PySide2.QtLocation.QGeoRouteSegment.isValid": (),
    "PySide2.QtLocation.QGeoRouteSegment.maneuver": (),
    "PySide2.QtLocation.QGeoRouteSegment.nextRouteSegment": (),
    "PySide2.QtLocation.QGeoRouteSegment.path": (),
    "PySide2.QtLocation.QGeoRouteSegment.setDistance": ('float',),
    "PySide2.QtLocation.QGeoRouteSegment.setManeuver": ('PySide2.QtLocation.QGeoManeuver',),
    "PySide2.QtLocation.QGeoRouteSegment.setNextRouteSegment": ('PySide2.QtLocation.QGeoRouteSegment',),
    "PySide2.QtLocation.QGeoRouteSegment.setPath": ('typing.Sequence[PySide2.QtPositioning.QGeoCoordinate]',),
    "PySide2.QtLocation.QGeoRouteSegment.setTravelTime": ('int',),
    "PySide2.QtLocation.QGeoRouteSegment.travelTime": (),

# class PySide2.QtLocation.QGeoRoutingManager:
    "PySide2.QtLocation.QGeoRoutingManager.calculateRoute": ('PySide2.QtLocation.QGeoRouteRequest',),
    "PySide2.QtLocation.QGeoRoutingManager.locale": (),
    "PySide2.QtLocation.QGeoRoutingManager.managerName": (),
    "PySide2.QtLocation.QGeoRoutingManager.managerVersion": (),
    "PySide2.QtLocation.QGeoRoutingManager.measurementSystem": (),
    "PySide2.QtLocation.QGeoRoutingManager.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtLocation.QGeoRoutingManager.setMeasurementSystem": ('PySide2.QtCore.QLocale.MeasurementSystem',),
    "PySide2.QtLocation.QGeoRoutingManager.supportedFeatureTypes": (),
    "PySide2.QtLocation.QGeoRoutingManager.supportedFeatureWeights": (),
    "PySide2.QtLocation.QGeoRoutingManager.supportedManeuverDetails": (),
    "PySide2.QtLocation.QGeoRoutingManager.supportedRouteOptimizations": (),
    "PySide2.QtLocation.QGeoRoutingManager.supportedSegmentDetails": (),
    "PySide2.QtLocation.QGeoRoutingManager.supportedTravelModes": (),
    "PySide2.QtLocation.QGeoRoutingManager.updateRoute": ('PySide2.QtLocation.QGeoRoute', 'PySide2.QtPositioning.QGeoCoordinate'),

# class PySide2.QtLocation.QGeoRoutingManagerEngine:
    "PySide2.QtLocation.QGeoRoutingManagerEngine.__init__": ('typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject'),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.calculateRoute": ('PySide2.QtLocation.QGeoRouteRequest',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.locale": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.managerName": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.managerVersion": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.measurementSystem": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setMeasurementSystem": ('PySide2.QtCore.QLocale.MeasurementSystem',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setSupportedFeatureTypes": ('PySide2.QtLocation.QGeoRouteRequest.FeatureTypes',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setSupportedFeatureWeights": ('PySide2.QtLocation.QGeoRouteRequest.FeatureWeights',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setSupportedManeuverDetails": ('PySide2.QtLocation.QGeoRouteRequest.ManeuverDetails',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setSupportedRouteOptimizations": ('PySide2.QtLocation.QGeoRouteRequest.RouteOptimizations',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setSupportedSegmentDetails": ('PySide2.QtLocation.QGeoRouteRequest.SegmentDetails',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.setSupportedTravelModes": ('PySide2.QtLocation.QGeoRouteRequest.TravelModes',),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.supportedFeatureTypes": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.supportedFeatureWeights": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.supportedManeuverDetails": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.supportedRouteOptimizations": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.supportedSegmentDetails": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.supportedTravelModes": (),
    "PySide2.QtLocation.QGeoRoutingManagerEngine.updateRoute": ('PySide2.QtLocation.QGeoRoute', 'PySide2.QtPositioning.QGeoCoordinate'),

# class PySide2.QtLocation.QGeoServiceProvider:

# class PySide2.QtLocation.QGeoServiceProvider.Error:

# class PySide2.QtLocation.QGeoServiceProvider.GeocodingFeature:

# class PySide2.QtLocation.QGeoServiceProvider.GeocodingFeatures:

# class PySide2.QtLocation.QGeoServiceProvider.MappingFeature:

# class PySide2.QtLocation.QGeoServiceProvider.MappingFeatures:

# class PySide2.QtLocation.QGeoServiceProvider.NavigationFeature:

# class PySide2.QtLocation.QGeoServiceProvider.NavigationFeatures:

# class PySide2.QtLocation.QGeoServiceProvider.PlacesFeature:

# class PySide2.QtLocation.QGeoServiceProvider.PlacesFeatures:

# class PySide2.QtLocation.QGeoServiceProvider.RoutingFeature:

# class PySide2.QtLocation.QGeoServiceProvider.RoutingFeatures:
    "PySide2.QtLocation.QGeoServiceProvider.__init__": ('str', 'typing.Dict[str, typing.Any]', 'bool'),
    "PySide2.QtLocation.QGeoServiceProvider.availableServiceProviders": (),
    "PySide2.QtLocation.QGeoServiceProvider.error": (),
    "PySide2.QtLocation.QGeoServiceProvider.errorString": (),
    "PySide2.QtLocation.QGeoServiceProvider.geocodingError": (),
    "PySide2.QtLocation.QGeoServiceProvider.geocodingErrorString": (),
    "PySide2.QtLocation.QGeoServiceProvider.geocodingFeatures": (),
    "PySide2.QtLocation.QGeoServiceProvider.geocodingManager": (),
    "PySide2.QtLocation.QGeoServiceProvider.mappingError": (),
    "PySide2.QtLocation.QGeoServiceProvider.mappingErrorString": (),
    "PySide2.QtLocation.QGeoServiceProvider.mappingFeatures": (),
    "PySide2.QtLocation.QGeoServiceProvider.navigationError": (),
    "PySide2.QtLocation.QGeoServiceProvider.navigationErrorString": (),
    "PySide2.QtLocation.QGeoServiceProvider.navigationFeatures": (),
    "PySide2.QtLocation.QGeoServiceProvider.placeManager": (),
    "PySide2.QtLocation.QGeoServiceProvider.placesError": (),
    "PySide2.QtLocation.QGeoServiceProvider.placesErrorString": (),
    "PySide2.QtLocation.QGeoServiceProvider.placesFeatures": (),
    "PySide2.QtLocation.QGeoServiceProvider.routingError": (),
    "PySide2.QtLocation.QGeoServiceProvider.routingErrorString": (),
    "PySide2.QtLocation.QGeoServiceProvider.routingFeatures": (),
    "PySide2.QtLocation.QGeoServiceProvider.routingManager": (),
    "PySide2.QtLocation.QGeoServiceProvider.setAllowExperimental": ('bool',),
    "PySide2.QtLocation.QGeoServiceProvider.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtLocation.QGeoServiceProvider.setParameters": ('typing.Dict[str, typing.Any]',),

# class PySide2.QtLocation.QGeoServiceProviderFactory:
    "PySide2.QtLocation.QGeoServiceProviderFactory.__init__": (),
    "PySide2.QtLocation.QGeoServiceProviderFactory.createGeocodingManagerEngine": ('typing.Dict[str, typing.Any]', 'PySide2.QtLocation.QGeoServiceProvider.Error'),
    "PySide2.QtLocation.QGeoServiceProviderFactory.createPlaceManagerEngine": ('typing.Dict[str, typing.Any]', 'PySide2.QtLocation.QGeoServiceProvider.Error'),
    "PySide2.QtLocation.QGeoServiceProviderFactory.createRoutingManagerEngine": ('typing.Dict[str, typing.Any]', 'PySide2.QtLocation.QGeoServiceProvider.Error'),

# class PySide2.QtLocation.QGeoServiceProviderFactoryV2:
    "PySide2.QtLocation.QGeoServiceProviderFactoryV2.__init__": (),

# class PySide2.QtLocation.QPlace:
    "PySide2.QtLocation.QPlace.__init__": [(), ('PySide2.QtLocation.QPlace',)],
    "PySide2.QtLocation.QPlace.__copy__": (),
    "PySide2.QtLocation.QPlace.appendContactDetail": ('str', 'PySide2.QtLocation.QPlaceContactDetail'),
    "PySide2.QtLocation.QPlace.attribution": (),
    "PySide2.QtLocation.QPlace.categories": (),
    "PySide2.QtLocation.QPlace.contactDetails": ('str',),
    "PySide2.QtLocation.QPlace.contactTypes": (),
    "PySide2.QtLocation.QPlace.content": ('PySide2.QtLocation.QPlaceContent.Type',),
    "PySide2.QtLocation.QPlace.detailsFetched": (),
    "PySide2.QtLocation.QPlace.extendedAttribute": ('str',),
    "PySide2.QtLocation.QPlace.extendedAttributeTypes": (),
    "PySide2.QtLocation.QPlace.icon": (),
    "PySide2.QtLocation.QPlace.insertContent": ('PySide2.QtLocation.QPlaceContent.Type', 'typing.Dict[int, PySide2.QtLocation.QPlaceContent]'),
    "PySide2.QtLocation.QPlace.isEmpty": (),
    "PySide2.QtLocation.QPlace.location": (),
    "PySide2.QtLocation.QPlace.name": (),
    "PySide2.QtLocation.QPlace.placeId": (),
    "PySide2.QtLocation.QPlace.primaryEmail": (),
    "PySide2.QtLocation.QPlace.primaryFax": (),
    "PySide2.QtLocation.QPlace.primaryPhone": (),
    "PySide2.QtLocation.QPlace.primaryWebsite": (),
    "PySide2.QtLocation.QPlace.ratings": (),
    "PySide2.QtLocation.QPlace.removeContactDetails": ('str',),
    "PySide2.QtLocation.QPlace.removeExtendedAttribute": ('str',),
    "PySide2.QtLocation.QPlace.setAttribution": ('str',),
    "PySide2.QtLocation.QPlace.setCategories": ('typing.Sequence[PySide2.QtLocation.QPlaceCategory]',),
    "PySide2.QtLocation.QPlace.setCategory": ('PySide2.QtLocation.QPlaceCategory',),
    "PySide2.QtLocation.QPlace.setContactDetails": ('str', 'typing.Sequence[PySide2.QtLocation.QPlaceContactDetail]'),
    "PySide2.QtLocation.QPlace.setContent": ('PySide2.QtLocation.QPlaceContent.Type', 'typing.Dict[int, PySide2.QtLocation.QPlaceContent]'),
    "PySide2.QtLocation.QPlace.setDetailsFetched": ('bool',),
    "PySide2.QtLocation.QPlace.setExtendedAttribute": ('str', 'PySide2.QtLocation.QPlaceAttribute'),
    "PySide2.QtLocation.QPlace.setIcon": ('PySide2.QtLocation.QPlaceIcon',),
    "PySide2.QtLocation.QPlace.setLocation": ('PySide2.QtPositioning.QGeoLocation',),
    "PySide2.QtLocation.QPlace.setName": ('str',),
    "PySide2.QtLocation.QPlace.setPlaceId": ('str',),
    "PySide2.QtLocation.QPlace.setRatings": ('PySide2.QtLocation.QPlaceRatings',),
    "PySide2.QtLocation.QPlace.setSupplier": ('PySide2.QtLocation.QPlaceSupplier',),
    "PySide2.QtLocation.QPlace.setTotalContentCount": ('PySide2.QtLocation.QPlaceContent.Type', 'int'),
    "PySide2.QtLocation.QPlace.supplier": (),
    "PySide2.QtLocation.QPlace.totalContentCount": ('PySide2.QtLocation.QPlaceContent.Type',),

# class PySide2.QtLocation.QPlaceAttribute:
    "PySide2.QtLocation.QPlaceAttribute.__init__": [(), ('PySide2.QtLocation.QPlaceAttribute',)],
    "PySide2.QtLocation.QPlaceAttribute.__copy__": (),
    "PySide2.QtLocation.QPlaceAttribute.isEmpty": (),
    "PySide2.QtLocation.QPlaceAttribute.label": (),
    "PySide2.QtLocation.QPlaceAttribute.setLabel": ('str',),
    "PySide2.QtLocation.QPlaceAttribute.setText": ('str',),
    "PySide2.QtLocation.QPlaceAttribute.text": (),

# class PySide2.QtLocation.QPlaceCategory:
    "PySide2.QtLocation.QPlaceCategory.__init__": [(), ('PySide2.QtLocation.QPlaceCategory',)],
    "PySide2.QtLocation.QPlaceCategory.__copy__": (),
    "PySide2.QtLocation.QPlaceCategory.categoryId": (),
    "PySide2.QtLocation.QPlaceCategory.icon": (),
    "PySide2.QtLocation.QPlaceCategory.isEmpty": (),
    "PySide2.QtLocation.QPlaceCategory.name": (),
    "PySide2.QtLocation.QPlaceCategory.setCategoryId": ('str',),
    "PySide2.QtLocation.QPlaceCategory.setIcon": ('PySide2.QtLocation.QPlaceIcon',),
    "PySide2.QtLocation.QPlaceCategory.setName": ('str',),

# class PySide2.QtLocation.QPlaceContactDetail:
    "PySide2.QtLocation.QPlaceContactDetail.__init__": [(), ('PySide2.QtLocation.QPlaceContactDetail',)],
    "PySide2.QtLocation.QPlaceContactDetail.__copy__": (),
    "PySide2.QtLocation.QPlaceContactDetail.clear": (),
    "PySide2.QtLocation.QPlaceContactDetail.label": (),
    "PySide2.QtLocation.QPlaceContactDetail.setLabel": ('str',),
    "PySide2.QtLocation.QPlaceContactDetail.setValue": ('str',),
    "PySide2.QtLocation.QPlaceContactDetail.value": (),

# class PySide2.QtLocation.QPlaceContent:

# class PySide2.QtLocation.QPlaceContent.Type:
    "PySide2.QtLocation.QPlaceContent.__init__": [(), ('PySide2.QtLocation.QPlaceContent',)],
    "PySide2.QtLocation.QPlaceContent.__copy__": (),
    "PySide2.QtLocation.QPlaceContent.attribution": (),
    "PySide2.QtLocation.QPlaceContent.setAttribution": ('str',),
    "PySide2.QtLocation.QPlaceContent.setSupplier": ('PySide2.QtLocation.QPlaceSupplier',),
    "PySide2.QtLocation.QPlaceContent.setUser": ('PySide2.QtLocation.QPlaceUser',),
    "PySide2.QtLocation.QPlaceContent.supplier": (),
    "PySide2.QtLocation.QPlaceContent.type": (),
    "PySide2.QtLocation.QPlaceContent.user": (),

# class PySide2.QtLocation.QPlaceContentReply:
    "PySide2.QtLocation.QPlaceContentReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtLocation.QPlaceContentReply.content": (),
    "PySide2.QtLocation.QPlaceContentReply.nextPageRequest": (),
    "PySide2.QtLocation.QPlaceContentReply.previousPageRequest": (),
    "PySide2.QtLocation.QPlaceContentReply.request": (),
    "PySide2.QtLocation.QPlaceContentReply.setContent": ('typing.Dict[int, PySide2.QtLocation.QPlaceContent]',),
    "PySide2.QtLocation.QPlaceContentReply.setNextPageRequest": ('PySide2.QtLocation.QPlaceContentRequest',),
    "PySide2.QtLocation.QPlaceContentReply.setPreviousPageRequest": ('PySide2.QtLocation.QPlaceContentRequest',),
    "PySide2.QtLocation.QPlaceContentReply.setRequest": ('PySide2.QtLocation.QPlaceContentRequest',),
    "PySide2.QtLocation.QPlaceContentReply.setTotalCount": ('int',),
    "PySide2.QtLocation.QPlaceContentReply.totalCount": (),
    "PySide2.QtLocation.QPlaceContentReply.type": (),

# class PySide2.QtLocation.QPlaceContentRequest:
    "PySide2.QtLocation.QPlaceContentRequest.__init__": [(), ('PySide2.QtLocation.QPlaceContentRequest',)],
    "PySide2.QtLocation.QPlaceContentRequest.__copy__": (),
    "PySide2.QtLocation.QPlaceContentRequest.clear": (),
    "PySide2.QtLocation.QPlaceContentRequest.contentContext": (),
    "PySide2.QtLocation.QPlaceContentRequest.contentType": (),
    "PySide2.QtLocation.QPlaceContentRequest.limit": (),
    "PySide2.QtLocation.QPlaceContentRequest.placeId": (),
    "PySide2.QtLocation.QPlaceContentRequest.setContentContext": ('typing.Any',),
    "PySide2.QtLocation.QPlaceContentRequest.setContentType": ('PySide2.QtLocation.QPlaceContent.Type',),
    "PySide2.QtLocation.QPlaceContentRequest.setLimit": ('int',),
    "PySide2.QtLocation.QPlaceContentRequest.setPlaceId": ('str',),

# class PySide2.QtLocation.QPlaceDetailsReply:
    "PySide2.QtLocation.QPlaceDetailsReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtLocation.QPlaceDetailsReply.place": (),
    "PySide2.QtLocation.QPlaceDetailsReply.setPlace": ('PySide2.QtLocation.QPlace',),
    "PySide2.QtLocation.QPlaceDetailsReply.type": (),

# class PySide2.QtLocation.QPlaceEditorial:
    "PySide2.QtLocation.QPlaceEditorial.__init__": [(), ('PySide2.QtLocation.QPlaceContent',)],
    "PySide2.QtLocation.QPlaceEditorial.language": (),
    "PySide2.QtLocation.QPlaceEditorial.setLanguage": ('str',),
    "PySide2.QtLocation.QPlaceEditorial.setText": ('str',),
    "PySide2.QtLocation.QPlaceEditorial.setTitle": ('str',),
    "PySide2.QtLocation.QPlaceEditorial.text": (),
    "PySide2.QtLocation.QPlaceEditorial.title": (),

# class PySide2.QtLocation.QPlaceIcon:
    "PySide2.QtLocation.QPlaceIcon.__init__": [(), ('PySide2.QtLocation.QPlaceIcon',)],
    "PySide2.QtLocation.QPlaceIcon.__copy__": (),
    "PySide2.QtLocation.QPlaceIcon.isEmpty": (),
    "PySide2.QtLocation.QPlaceIcon.manager": (),
    "PySide2.QtLocation.QPlaceIcon.parameters": (),
    "PySide2.QtLocation.QPlaceIcon.setManager": ('PySide2.QtLocation.QPlaceManager',),
    "PySide2.QtLocation.QPlaceIcon.setParameters": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtLocation.QPlaceIcon.url": ('PySide2.QtCore.QSize',),

# class PySide2.QtLocation.QPlaceIdReply:

# class PySide2.QtLocation.QPlaceIdReply.OperationType:
    "PySide2.QtLocation.QPlaceIdReply.__init__": ('PySide2.QtLocation.QPlaceIdReply.OperationType', 'PySide2.QtCore.QObject'),
    "PySide2.QtLocation.QPlaceIdReply.id": (),
    "PySide2.QtLocation.QPlaceIdReply.operationType": (),
    "PySide2.QtLocation.QPlaceIdReply.setId": ('str',),
    "PySide2.QtLocation.QPlaceIdReply.type": (),

# class PySide2.QtLocation.QPlaceImage:
    "PySide2.QtLocation.QPlaceImage.__init__": [(), ('PySide2.QtLocation.QPlaceContent',)],
    "PySide2.QtLocation.QPlaceImage.imageId": (),
    "PySide2.QtLocation.QPlaceImage.mimeType": (),
    "PySide2.QtLocation.QPlaceImage.setImageId": ('str',),
    "PySide2.QtLocation.QPlaceImage.setMimeType": ('str',),
    "PySide2.QtLocation.QPlaceImage.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtLocation.QPlaceImage.url": (),

# class PySide2.QtLocation.QPlaceManager:
    "PySide2.QtLocation.QPlaceManager.category": ('str',),
    "PySide2.QtLocation.QPlaceManager.childCategories": ('str',),
    "PySide2.QtLocation.QPlaceManager.childCategoryIds": ('str',),
    "PySide2.QtLocation.QPlaceManager.compatiblePlace": ('PySide2.QtLocation.QPlace',),
    "PySide2.QtLocation.QPlaceManager.getPlaceContent": ('PySide2.QtLocation.QPlaceContentRequest',),
    "PySide2.QtLocation.QPlaceManager.getPlaceDetails": ('str',),
    "PySide2.QtLocation.QPlaceManager.initializeCategories": (),
    "PySide2.QtLocation.QPlaceManager.locales": (),
    "PySide2.QtLocation.QPlaceManager.managerName": (),
    "PySide2.QtLocation.QPlaceManager.managerVersion": (),
    "PySide2.QtLocation.QPlaceManager.matchingPlaces": ('PySide2.QtLocation.QPlaceMatchRequest',),
    "PySide2.QtLocation.QPlaceManager.parentCategoryId": ('str',),
    "PySide2.QtLocation.QPlaceManager.removeCategory": ('str',),
    "PySide2.QtLocation.QPlaceManager.removePlace": ('str',),
    "PySide2.QtLocation.QPlaceManager.saveCategory": ('PySide2.QtLocation.QPlaceCategory', 'str'),
    "PySide2.QtLocation.QPlaceManager.savePlace": ('PySide2.QtLocation.QPlace',),
    "PySide2.QtLocation.QPlaceManager.search": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceManager.searchSuggestions": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceManager.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtLocation.QPlaceManager.setLocales": ('typing.Sequence[PySide2.QtCore.QLocale]',),

# class PySide2.QtLocation.QPlaceManagerEngine:
    "PySide2.QtLocation.QPlaceManagerEngine.__init__": ('typing.Dict[str, typing.Any]', 'PySide2.QtCore.QObject'),
    "PySide2.QtLocation.QPlaceManagerEngine.category": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.childCategories": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.childCategoryIds": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.compatiblePlace": ('PySide2.QtLocation.QPlace',),
    "PySide2.QtLocation.QPlaceManagerEngine.constructIconUrl": ('PySide2.QtLocation.QPlaceIcon', 'PySide2.QtCore.QSize'),
    "PySide2.QtLocation.QPlaceManagerEngine.getPlaceContent": ('PySide2.QtLocation.QPlaceContentRequest',),
    "PySide2.QtLocation.QPlaceManagerEngine.getPlaceDetails": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.initializeCategories": (),
    "PySide2.QtLocation.QPlaceManagerEngine.locales": (),
    "PySide2.QtLocation.QPlaceManagerEngine.manager": (),
    "PySide2.QtLocation.QPlaceManagerEngine.managerName": (),
    "PySide2.QtLocation.QPlaceManagerEngine.managerVersion": (),
    "PySide2.QtLocation.QPlaceManagerEngine.matchingPlaces": ('PySide2.QtLocation.QPlaceMatchRequest',),
    "PySide2.QtLocation.QPlaceManagerEngine.parentCategoryId": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.removeCategory": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.removePlace": ('str',),
    "PySide2.QtLocation.QPlaceManagerEngine.saveCategory": ('PySide2.QtLocation.QPlaceCategory', 'str'),
    "PySide2.QtLocation.QPlaceManagerEngine.savePlace": ('PySide2.QtLocation.QPlace',),
    "PySide2.QtLocation.QPlaceManagerEngine.search": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceManagerEngine.searchSuggestions": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceManagerEngine.setLocales": ('typing.Sequence[PySide2.QtCore.QLocale]',),

# class PySide2.QtLocation.QPlaceMatchReply:
    "PySide2.QtLocation.QPlaceMatchReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtLocation.QPlaceMatchReply.places": (),
    "PySide2.QtLocation.QPlaceMatchReply.request": (),
    "PySide2.QtLocation.QPlaceMatchReply.setPlaces": ('typing.Sequence[PySide2.QtLocation.QPlace]',),
    "PySide2.QtLocation.QPlaceMatchReply.setRequest": ('PySide2.QtLocation.QPlaceMatchRequest',),
    "PySide2.QtLocation.QPlaceMatchReply.type": (),

# class PySide2.QtLocation.QPlaceMatchRequest:
    "PySide2.QtLocation.QPlaceMatchRequest.__init__": [(), ('PySide2.QtLocation.QPlaceMatchRequest',)],
    "PySide2.QtLocation.QPlaceMatchRequest.__copy__": (),
    "PySide2.QtLocation.QPlaceMatchRequest.clear": (),
    "PySide2.QtLocation.QPlaceMatchRequest.parameters": (),
    "PySide2.QtLocation.QPlaceMatchRequest.places": (),
    "PySide2.QtLocation.QPlaceMatchRequest.setParameters": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtLocation.QPlaceMatchRequest.setPlaces": ('typing.Sequence[PySide2.QtLocation.QPlace]',),
    "PySide2.QtLocation.QPlaceMatchRequest.setResults": ('typing.Sequence[PySide2.QtLocation.QPlaceSearchResult]',),

# class PySide2.QtLocation.QPlaceProposedSearchResult:
    "PySide2.QtLocation.QPlaceProposedSearchResult.__init__": [(), ('PySide2.QtLocation.QPlaceSearchResult',)],
    "PySide2.QtLocation.QPlaceProposedSearchResult.searchRequest": (),
    "PySide2.QtLocation.QPlaceProposedSearchResult.setSearchRequest": ('PySide2.QtLocation.QPlaceSearchRequest',),

# class PySide2.QtLocation.QPlaceRatings:
    "PySide2.QtLocation.QPlaceRatings.__init__": [(), ('PySide2.QtLocation.QPlaceRatings',)],
    "PySide2.QtLocation.QPlaceRatings.__copy__": (),
    "PySide2.QtLocation.QPlaceRatings.average": (),
    "PySide2.QtLocation.QPlaceRatings.count": (),
    "PySide2.QtLocation.QPlaceRatings.isEmpty": (),
    "PySide2.QtLocation.QPlaceRatings.maximum": (),
    "PySide2.QtLocation.QPlaceRatings.setAverage": ('float',),
    "PySide2.QtLocation.QPlaceRatings.setCount": ('int',),
    "PySide2.QtLocation.QPlaceRatings.setMaximum": ('float',),

# class PySide2.QtLocation.QPlaceReply:

# class PySide2.QtLocation.QPlaceReply.Error:

# class PySide2.QtLocation.QPlaceReply.Type:
    "PySide2.QtLocation.QPlaceReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtLocation.QPlaceReply.abort": (),
    "PySide2.QtLocation.QPlaceReply.error": (),
    "PySide2.QtLocation.QPlaceReply.errorString": (),
    "PySide2.QtLocation.QPlaceReply.isFinished": (),
    "PySide2.QtLocation.QPlaceReply.setError": ('PySide2.QtLocation.QPlaceReply.Error', 'str'),
    "PySide2.QtLocation.QPlaceReply.setFinished": ('bool',),
    "PySide2.QtLocation.QPlaceReply.type": (),

# class PySide2.QtLocation.QPlaceResult:
    "PySide2.QtLocation.QPlaceResult.__init__": [(), ('PySide2.QtLocation.QPlaceSearchResult',)],
    "PySide2.QtLocation.QPlaceResult.distance": (),
    "PySide2.QtLocation.QPlaceResult.isSponsored": (),
    "PySide2.QtLocation.QPlaceResult.place": (),
    "PySide2.QtLocation.QPlaceResult.setDistance": ('float',),
    "PySide2.QtLocation.QPlaceResult.setPlace": ('PySide2.QtLocation.QPlace',),
    "PySide2.QtLocation.QPlaceResult.setSponsored": ('bool',),

# class PySide2.QtLocation.QPlaceReview:
    "PySide2.QtLocation.QPlaceReview.__init__": [(), ('PySide2.QtLocation.QPlaceContent',)],
    "PySide2.QtLocation.QPlaceReview.dateTime": (),
    "PySide2.QtLocation.QPlaceReview.language": (),
    "PySide2.QtLocation.QPlaceReview.rating": (),
    "PySide2.QtLocation.QPlaceReview.reviewId": (),
    "PySide2.QtLocation.QPlaceReview.setDateTime": ('PySide2.QtCore.QDateTime',),
    "PySide2.QtLocation.QPlaceReview.setLanguage": ('str',),
    "PySide2.QtLocation.QPlaceReview.setRating": ('float',),
    "PySide2.QtLocation.QPlaceReview.setReviewId": ('str',),
    "PySide2.QtLocation.QPlaceReview.setText": ('str',),
    "PySide2.QtLocation.QPlaceReview.setTitle": ('str',),
    "PySide2.QtLocation.QPlaceReview.text": (),
    "PySide2.QtLocation.QPlaceReview.title": (),

# class PySide2.QtLocation.QPlaceSearchReply:
    "PySide2.QtLocation.QPlaceSearchReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtLocation.QPlaceSearchReply.nextPageRequest": (),
    "PySide2.QtLocation.QPlaceSearchReply.previousPageRequest": (),
    "PySide2.QtLocation.QPlaceSearchReply.request": (),
    "PySide2.QtLocation.QPlaceSearchReply.results": (),
    "PySide2.QtLocation.QPlaceSearchReply.setNextPageRequest": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceSearchReply.setPreviousPageRequest": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceSearchReply.setRequest": ('PySide2.QtLocation.QPlaceSearchRequest',),
    "PySide2.QtLocation.QPlaceSearchReply.setResults": ('typing.Sequence[PySide2.QtLocation.QPlaceSearchResult]',),
    "PySide2.QtLocation.QPlaceSearchReply.type": (),

# class PySide2.QtLocation.QPlaceSearchRequest:

# class PySide2.QtLocation.QPlaceSearchRequest.RelevanceHint:
    "PySide2.QtLocation.QPlaceSearchRequest.__init__": [(), ('PySide2.QtLocation.QPlaceSearchRequest',)],
    "PySide2.QtLocation.QPlaceSearchRequest.categories": (),
    "PySide2.QtLocation.QPlaceSearchRequest.clear": (),
    "PySide2.QtLocation.QPlaceSearchRequest.limit": (),
    "PySide2.QtLocation.QPlaceSearchRequest.recommendationId": (),
    "PySide2.QtLocation.QPlaceSearchRequest.relevanceHint": (),
    "PySide2.QtLocation.QPlaceSearchRequest.searchArea": (),
    "PySide2.QtLocation.QPlaceSearchRequest.searchContext": (),
    "PySide2.QtLocation.QPlaceSearchRequest.searchTerm": (),
    "PySide2.QtLocation.QPlaceSearchRequest.setCategories": ('typing.Sequence[PySide2.QtLocation.QPlaceCategory]',),
    "PySide2.QtLocation.QPlaceSearchRequest.setCategory": ('PySide2.QtLocation.QPlaceCategory',),
    "PySide2.QtLocation.QPlaceSearchRequest.setLimit": ('int',),
    "PySide2.QtLocation.QPlaceSearchRequest.setRecommendationId": ('str',),
    "PySide2.QtLocation.QPlaceSearchRequest.setRelevanceHint": ('PySide2.QtLocation.QPlaceSearchRequest.RelevanceHint',),
    "PySide2.QtLocation.QPlaceSearchRequest.setSearchArea": ('PySide2.QtPositioning.QGeoShape',),
    "PySide2.QtLocation.QPlaceSearchRequest.setSearchContext": ('typing.Any',),
    "PySide2.QtLocation.QPlaceSearchRequest.setSearchTerm": ('str',),

# class PySide2.QtLocation.QPlaceSearchResult:

# class PySide2.QtLocation.QPlaceSearchResult.SearchResultType:
    "PySide2.QtLocation.QPlaceSearchResult.__init__": [(), ('PySide2.QtLocation.QPlaceSearchResult',)],
    "PySide2.QtLocation.QPlaceSearchResult.icon": (),
    "PySide2.QtLocation.QPlaceSearchResult.setIcon": ('PySide2.QtLocation.QPlaceIcon',),
    "PySide2.QtLocation.QPlaceSearchResult.setTitle": ('str',),
    "PySide2.QtLocation.QPlaceSearchResult.title": (),
    "PySide2.QtLocation.QPlaceSearchResult.type": (),

# class PySide2.QtLocation.QPlaceSearchSuggestionReply:
    "PySide2.QtLocation.QPlaceSearchSuggestionReply.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtLocation.QPlaceSearchSuggestionReply.setSuggestions": ('typing.Sequence[str]',),
    "PySide2.QtLocation.QPlaceSearchSuggestionReply.suggestions": (),
    "PySide2.QtLocation.QPlaceSearchSuggestionReply.type": (),

# class PySide2.QtLocation.QPlaceSupplier:
    "PySide2.QtLocation.QPlaceSupplier.__init__": [(), ('PySide2.QtLocation.QPlaceSupplier',)],
    "PySide2.QtLocation.QPlaceSupplier.__copy__": (),
    "PySide2.QtLocation.QPlaceSupplier.icon": (),
    "PySide2.QtLocation.QPlaceSupplier.isEmpty": (),
    "PySide2.QtLocation.QPlaceSupplier.name": (),
    "PySide2.QtLocation.QPlaceSupplier.setIcon": ('PySide2.QtLocation.QPlaceIcon',),
    "PySide2.QtLocation.QPlaceSupplier.setName": ('str',),
    "PySide2.QtLocation.QPlaceSupplier.setSupplierId": ('str',),
    "PySide2.QtLocation.QPlaceSupplier.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtLocation.QPlaceSupplier.supplierId": (),
    "PySide2.QtLocation.QPlaceSupplier.url": (),

# class PySide2.QtLocation.QPlaceUser:
    "PySide2.QtLocation.QPlaceUser.__init__": [(), ('PySide2.QtLocation.QPlaceUser',)],
    "PySide2.QtLocation.QPlaceUser.__copy__": (),
    "PySide2.QtLocation.QPlaceUser.name": (),
    "PySide2.QtLocation.QPlaceUser.setName": ('str',),
    "PySide2.QtLocation.QPlaceUser.setUserId": ('str',),
    "PySide2.QtLocation.QPlaceUser.userId": (),
    }) if "PySide2.QtLocation" in sys.modules else None

# Module PySide2.QtQml
sig_dict.update({

# class PySide2.QtQml.ListProperty:
    "PySide2.QtQml.ListProperty.__init__": ('type', 'typing.Callable', 'typing.Callable', 'typing.Callable', 'typing.Callable'),

# class PySide2.QtQml.QJSEngine:

# class PySide2.QtQml.QJSEngine.Extension:

# class PySide2.QtQml.QJSEngine.Extensions:
    "PySide2.QtQml.QJSEngine.__init__": [(), ('PySide2.QtCore.QObject',)],
    "PySide2.QtQml.QJSEngine.collectGarbage": (),
    "PySide2.QtQml.QJSEngine.evaluate": ('str', 'str', 'int'),
    "PySide2.QtQml.QJSEngine.globalObject": (),
    "PySide2.QtQml.QJSEngine.importModule": ('str',),
    "PySide2.QtQml.QJSEngine.installExtensions": ('PySide2.QtQml.QJSEngine.Extensions', 'PySide2.QtQml.QJSValue'),
    "PySide2.QtQml.QJSEngine.installTranslatorFunctions": ('PySide2.QtQml.QJSValue',),
    "PySide2.QtQml.QJSEngine.isInterrupted": (),
    "PySide2.QtQml.QJSEngine.newArray": ('int',),
    "PySide2.QtQml.QJSEngine.newErrorObject": ('PySide2.QtQml.QJSValue.ErrorType', 'str'),
    "PySide2.QtQml.QJSEngine.newObject": (),
    "PySide2.QtQml.QJSEngine.newQMetaObject": ('PySide2.QtCore.QMetaObject',),
    "PySide2.QtQml.QJSEngine.newQObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QJSEngine.setInterrupted": ('bool',),
    "PySide2.QtQml.QJSEngine.throwError": [('PySide2.QtQml.QJSValue.ErrorType', 'str'), ('str',)],
    "PySide2.QtQml.QJSEngine.toScriptValue": ('typing.Any',),

# class PySide2.QtQml.QJSValue:

# class PySide2.QtQml.QJSValue.ErrorType:

# class PySide2.QtQml.QJSValue.SpecialValue:
    "PySide2.QtQml.QJSValue.__init__": [('PySide2.QtQml.QJSValue',), ('PySide2.QtQml.QJSValue.SpecialValue',), ('bool',), ('float',), ('int',), ('str',)],
    "PySide2.QtQml.QJSValue.__copy__": (),
    "PySide2.QtQml.QJSValue.call": ('typing.Sequence[PySide2.QtQml.QJSValue]',),
    "PySide2.QtQml.QJSValue.callAsConstructor": ('typing.Sequence[PySide2.QtQml.QJSValue]',),
    "PySide2.QtQml.QJSValue.callWithInstance": ('PySide2.QtQml.QJSValue', 'typing.Sequence[PySide2.QtQml.QJSValue]'),
    "PySide2.QtQml.QJSValue.deleteProperty": ('str',),
    "PySide2.QtQml.QJSValue.engine": (),
    "PySide2.QtQml.QJSValue.equals": ('PySide2.QtQml.QJSValue',),
    "PySide2.QtQml.QJSValue.errorType": (),
    "PySide2.QtQml.QJSValue.hasOwnProperty": ('str',),
    "PySide2.QtQml.QJSValue.hasProperty": ('str',),
    "PySide2.QtQml.QJSValue.isArray": (),
    "PySide2.QtQml.QJSValue.isBool": (),
    "PySide2.QtQml.QJSValue.isCallable": (),
    "PySide2.QtQml.QJSValue.isDate": (),
    "PySide2.QtQml.QJSValue.isError": (),
    "PySide2.QtQml.QJSValue.isNull": (),
    "PySide2.QtQml.QJSValue.isNumber": (),
    "PySide2.QtQml.QJSValue.isObject": (),
    "PySide2.QtQml.QJSValue.isQMetaObject": (),
    "PySide2.QtQml.QJSValue.isQObject": (),
    "PySide2.QtQml.QJSValue.isRegExp": (),
    "PySide2.QtQml.QJSValue.isString": (),
    "PySide2.QtQml.QJSValue.isUndefined": (),
    "PySide2.QtQml.QJSValue.isVariant": (),
    "PySide2.QtQml.QJSValue.property": [('int',), ('str',)],
    "PySide2.QtQml.QJSValue.prototype": (),
    "PySide2.QtQml.QJSValue.setProperty": [('int', 'PySide2.QtQml.QJSValue'), ('str', 'PySide2.QtQml.QJSValue')],
    "PySide2.QtQml.QJSValue.setPrototype": ('PySide2.QtQml.QJSValue',),
    "PySide2.QtQml.QJSValue.strictlyEquals": ('PySide2.QtQml.QJSValue',),
    "PySide2.QtQml.QJSValue.toBool": (),
    "PySide2.QtQml.QJSValue.toDateTime": (),
    "PySide2.QtQml.QJSValue.toInt": (),
    "PySide2.QtQml.QJSValue.toNumber": (),
    "PySide2.QtQml.QJSValue.toQMetaObject": (),
    "PySide2.QtQml.QJSValue.toQObject": (),
    "PySide2.QtQml.QJSValue.toString": (),
    "PySide2.QtQml.QJSValue.toUInt": (),
    "PySide2.QtQml.QJSValue.toVariant": (),

# class PySide2.QtQml.QJSValueIterator:
    "PySide2.QtQml.QJSValueIterator.__init__": ('PySide2.QtQml.QJSValue',),
    "PySide2.QtQml.QJSValueIterator.hasNext": (),
    "PySide2.QtQml.QJSValueIterator.name": (),
    "PySide2.QtQml.QJSValueIterator.value": (),

# class PySide2.QtQml.QQmlAbstractUrlInterceptor:

# class PySide2.QtQml.QQmlAbstractUrlInterceptor.DataType:
    "PySide2.QtQml.QQmlAbstractUrlInterceptor.__init__": (),
    "PySide2.QtQml.QQmlAbstractUrlInterceptor.intercept": ('PySide2.QtCore.QUrl', 'PySide2.QtQml.QQmlAbstractUrlInterceptor.DataType'),

# class PySide2.QtQml.QQmlApplicationEngine:
    "PySide2.QtQml.QQmlApplicationEngine.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QObject'), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtQml.QQmlApplicationEngine.load": [('PySide2.QtCore.QUrl',), ('str',)],
    "PySide2.QtQml.QQmlApplicationEngine.loadData": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QUrl'),
    "PySide2.QtQml.QQmlApplicationEngine.rootObjects": (),
    "PySide2.QtQml.QQmlApplicationEngine.setInitialProperties": ('typing.Dict[str, typing.Any]',),

# class PySide2.QtQml.QQmlComponent:

# class PySide2.QtQml.QQmlComponent.CompilationMode:

# class PySide2.QtQml.QQmlComponent.Status:
    "PySide2.QtQml.QQmlComponent.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QObject'), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QUrl', 'PySide2.QtCore.QObject'), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QUrl', 'PySide2.QtQml.QQmlComponent.CompilationMode', 'PySide2.QtCore.QObject'), ('PySide2.QtQml.QQmlEngine', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtQml.QQmlEngine', 'str', 'PySide2.QtQml.QQmlComponent.CompilationMode', 'PySide2.QtCore.QObject')],
    "PySide2.QtQml.QQmlComponent.beginCreate": ('PySide2.QtQml.QQmlContext',),
    "PySide2.QtQml.QQmlComponent.completeCreate": (),
    "PySide2.QtQml.QQmlComponent.create": [('PySide2.QtQml.QQmlContext',), ('PySide2.QtQml.QQmlIncubator', 'PySide2.QtQml.QQmlContext', 'PySide2.QtQml.QQmlContext')],
    "PySide2.QtQml.QQmlComponent.createWithInitialProperties": ('typing.Dict[str, typing.Any]', 'PySide2.QtQml.QQmlContext'),
    "PySide2.QtQml.QQmlComponent.creationContext": (),
    "PySide2.QtQml.QQmlComponent.engine": (),
    "PySide2.QtQml.QQmlComponent.errorString": (),
    "PySide2.QtQml.QQmlComponent.errors": (),
    "PySide2.QtQml.QQmlComponent.isError": (),
    "PySide2.QtQml.QQmlComponent.isLoading": (),
    "PySide2.QtQml.QQmlComponent.isNull": (),
    "PySide2.QtQml.QQmlComponent.isReady": (),
    "PySide2.QtQml.QQmlComponent.loadUrl": [('PySide2.QtCore.QUrl',), ('PySide2.QtCore.QUrl', 'PySide2.QtQml.QQmlComponent.CompilationMode')],
    "PySide2.QtQml.QQmlComponent.progress": (),
    "PySide2.QtQml.QQmlComponent.setData": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QUrl'),
    "PySide2.QtQml.QQmlComponent.setInitialProperties": ('PySide2.QtCore.QObject', 'typing.Dict[str, typing.Any]'),
    "PySide2.QtQml.QQmlComponent.status": (),
    "PySide2.QtQml.QQmlComponent.url": (),

# class PySide2.QtQml.QQmlContext:
    "PySide2.QtQml.QQmlContext.__init__": [('PySide2.QtQml.QQmlContext', 'PySide2.QtCore.QObject'), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QObject')],
    "PySide2.QtQml.QQmlContext.baseUrl": (),
    "PySide2.QtQml.QQmlContext.contextObject": (),
    "PySide2.QtQml.QQmlContext.contextProperty": ('str',),
    "PySide2.QtQml.QQmlContext.engine": (),
    "PySide2.QtQml.QQmlContext.isValid": (),
    "PySide2.QtQml.QQmlContext.nameForObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlContext.parentContext": (),
    "PySide2.QtQml.QQmlContext.resolvedUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtQml.QQmlContext.setBaseUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtQml.QQmlContext.setContextObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlContext.setContextProperty": [('str', 'PySide2.QtCore.QObject'), ('str', 'typing.Any')],

# class PySide2.QtQml.QQmlDebuggingEnabler:

# class PySide2.QtQml.QQmlDebuggingEnabler.StartMode:
    "PySide2.QtQml.QQmlDebuggingEnabler.__init__": ('bool',),
    "PySide2.QtQml.QQmlDebuggingEnabler.connectToLocalDebugger": ('str', 'PySide2.QtQml.QQmlDebuggingEnabler.StartMode'),
    "PySide2.QtQml.QQmlDebuggingEnabler.debuggerServices": (),
    "PySide2.QtQml.QQmlDebuggingEnabler.inspectorServices": (),
    "PySide2.QtQml.QQmlDebuggingEnabler.nativeDebuggerServices": (),
    "PySide2.QtQml.QQmlDebuggingEnabler.profilerServices": (),
    "PySide2.QtQml.QQmlDebuggingEnabler.setServices": ('typing.Sequence[str]',),
    "PySide2.QtQml.QQmlDebuggingEnabler.startDebugConnector": ('str', 'typing.Dict[str, typing.Any]'),
    "PySide2.QtQml.QQmlDebuggingEnabler.startTcpDebugServer": ('int', 'PySide2.QtQml.QQmlDebuggingEnabler.StartMode', 'str'),

# class PySide2.QtQml.QQmlEngine:

# class PySide2.QtQml.QQmlEngine.ObjectOwnership:
    "PySide2.QtQml.QQmlEngine.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlEngine.addImageProvider": ('str', 'PySide2.QtQml.QQmlImageProviderBase'),
    "PySide2.QtQml.QQmlEngine.addImportPath": ('str',),
    "PySide2.QtQml.QQmlEngine.addNamedBundle": ('str', 'str'),
    "PySide2.QtQml.QQmlEngine.addPluginPath": ('str',),
    "PySide2.QtQml.QQmlEngine.baseUrl": (),
    "PySide2.QtQml.QQmlEngine.clearComponentCache": (),
    "PySide2.QtQml.QQmlEngine.contextForObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlEngine.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtQml.QQmlEngine.imageProvider": ('str',),
    "PySide2.QtQml.QQmlEngine.importPathList": (),
    "PySide2.QtQml.QQmlEngine.importPlugin": ('str', 'str', 'typing.Sequence[PySide2.QtQml.QQmlError]'),
    "PySide2.QtQml.QQmlEngine.incubationController": (),
    "PySide2.QtQml.QQmlEngine.networkAccessManager": (),
    "PySide2.QtQml.QQmlEngine.networkAccessManagerFactory": (),
    "PySide2.QtQml.QQmlEngine.objectOwnership": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlEngine.offlineStorageDatabaseFilePath": ('str',),
    "PySide2.QtQml.QQmlEngine.offlineStoragePath": (),
    "PySide2.QtQml.QQmlEngine.outputWarningsToStandardError": (),
    "PySide2.QtQml.QQmlEngine.pluginPathList": (),
    "PySide2.QtQml.QQmlEngine.removeImageProvider": ('str',),
    "PySide2.QtQml.QQmlEngine.retranslate": (),
    "PySide2.QtQml.QQmlEngine.rootContext": (),
    "PySide2.QtQml.QQmlEngine.setBaseUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtQml.QQmlEngine.setContextForObject": ('PySide2.QtCore.QObject', 'PySide2.QtQml.QQmlContext'),
    "PySide2.QtQml.QQmlEngine.setImportPathList": ('typing.Sequence[str]',),
    "PySide2.QtQml.QQmlEngine.setIncubationController": ('PySide2.QtQml.QQmlIncubationController',),
    "PySide2.QtQml.QQmlEngine.setNetworkAccessManagerFactory": ('PySide2.QtQml.QQmlNetworkAccessManagerFactory',),
    "PySide2.QtQml.QQmlEngine.setObjectOwnership": ('PySide2.QtCore.QObject', 'PySide2.QtQml.QQmlEngine.ObjectOwnership'),
    "PySide2.QtQml.QQmlEngine.setOfflineStoragePath": ('str',),
    "PySide2.QtQml.QQmlEngine.setOutputWarningsToStandardError": ('bool',),
    "PySide2.QtQml.QQmlEngine.setPluginPathList": ('typing.Sequence[str]',),
    "PySide2.QtQml.QQmlEngine.setUrlInterceptor": ('PySide2.QtQml.QQmlAbstractUrlInterceptor',),
    "PySide2.QtQml.QQmlEngine.trimComponentCache": (),
    "PySide2.QtQml.QQmlEngine.urlInterceptor": (),

# class PySide2.QtQml.QQmlError:
    "PySide2.QtQml.QQmlError.__init__": [(), ('PySide2.QtQml.QQmlError',)],
    "PySide2.QtQml.QQmlError.__copy__": (),
    "PySide2.QtQml.QQmlError.column": (),
    "PySide2.QtQml.QQmlError.description": (),
    "PySide2.QtQml.QQmlError.isValid": (),
    "PySide2.QtQml.QQmlError.line": (),
    "PySide2.QtQml.QQmlError.messageType": (),
    "PySide2.QtQml.QQmlError.object": (),
    "PySide2.QtQml.QQmlError.setColumn": ('int',),
    "PySide2.QtQml.QQmlError.setDescription": ('str',),
    "PySide2.QtQml.QQmlError.setLine": ('int',),
    "PySide2.QtQml.QQmlError.setMessageType": ('PySide2.QtCore.QtMsgType',),
    "PySide2.QtQml.QQmlError.setObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlError.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtQml.QQmlError.toString": (),
    "PySide2.QtQml.QQmlError.url": (),

# class PySide2.QtQml.QQmlExpression:
    "PySide2.QtQml.QQmlExpression.__init__": [(), ('PySide2.QtQml.QQmlContext', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtQml.QQmlScriptString', 'PySide2.QtQml.QQmlContext', 'PySide2.QtCore.QObject', 'PySide2.QtCore.QObject')],
    "PySide2.QtQml.QQmlExpression.clearError": (),
    "PySide2.QtQml.QQmlExpression.columnNumber": (),
    "PySide2.QtQml.QQmlExpression.context": (),
    "PySide2.QtQml.QQmlExpression.engine": (),
    "PySide2.QtQml.QQmlExpression.error": (),
    "PySide2.QtQml.QQmlExpression.evaluate": (),
    "PySide2.QtQml.QQmlExpression.expression": (),
    "PySide2.QtQml.QQmlExpression.hasError": (),
    "PySide2.QtQml.QQmlExpression.lineNumber": (),
    "PySide2.QtQml.QQmlExpression.notifyOnValueChanged": (),
    "PySide2.QtQml.QQmlExpression.scopeObject": (),
    "PySide2.QtQml.QQmlExpression.setExpression": ('str',),
    "PySide2.QtQml.QQmlExpression.setNotifyOnValueChanged": ('bool',),
    "PySide2.QtQml.QQmlExpression.setSourceLocation": ('str', 'int', 'int'),
    "PySide2.QtQml.QQmlExpression.sourceFile": (),

# class PySide2.QtQml.QQmlExtensionInterface:
    "PySide2.QtQml.QQmlExtensionInterface.__init__": (),
    "PySide2.QtQml.QQmlExtensionInterface.initializeEngine": ('PySide2.QtQml.QQmlEngine', 'str'),

# class PySide2.QtQml.QQmlExtensionPlugin:
    "PySide2.QtQml.QQmlExtensionPlugin.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlExtensionPlugin.baseUrl": (),
    "PySide2.QtQml.QQmlExtensionPlugin.initializeEngine": ('PySide2.QtQml.QQmlEngine', 'str'),
    "PySide2.QtQml.QQmlExtensionPlugin.registerTypes": ('str',),

# class PySide2.QtQml.QQmlFile:

# class PySide2.QtQml.QQmlFile.Status:
    "PySide2.QtQml.QQmlFile.__init__": [(), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QUrl'), ('PySide2.QtQml.QQmlEngine', 'str')],
    "PySide2.QtQml.QQmlFile.clear": [(), ('PySide2.QtCore.QObject',)],
    "PySide2.QtQml.QQmlFile.connectDownloadProgress": [('PySide2.QtCore.QObject', 'int'), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtQml.QQmlFile.connectFinished": [('PySide2.QtCore.QObject', 'int'), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtQml.QQmlFile.data": (),
    "PySide2.QtQml.QQmlFile.dataByteArray": (),
    "PySide2.QtQml.QQmlFile.error": (),
    "PySide2.QtQml.QQmlFile.isError": (),
    "PySide2.QtQml.QQmlFile.isLoading": (),
    "PySide2.QtQml.QQmlFile.isLocalFile": [('PySide2.QtCore.QUrl',), ('str',)],
    "PySide2.QtQml.QQmlFile.isNull": (),
    "PySide2.QtQml.QQmlFile.isReady": (),
    "PySide2.QtQml.QQmlFile.isSynchronous": [('PySide2.QtCore.QUrl',), ('str',)],
    "PySide2.QtQml.QQmlFile.load": [('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QUrl'), ('PySide2.QtQml.QQmlEngine', 'str')],
    "PySide2.QtQml.QQmlFile.size": (),
    "PySide2.QtQml.QQmlFile.status": (),
    "PySide2.QtQml.QQmlFile.url": (),
    "PySide2.QtQml.QQmlFile.urlToLocalFileOrQrc": [('PySide2.QtCore.QUrl',), ('str',)],

# class PySide2.QtQml.QQmlFileSelector:
    "PySide2.QtQml.QQmlFileSelector.__init__": ('PySide2.QtQml.QQmlEngine', 'PySide2.QtCore.QObject'),
    "PySide2.QtQml.QQmlFileSelector.get": ('PySide2.QtQml.QQmlEngine',),
    "PySide2.QtQml.QQmlFileSelector.selector": (),
    "PySide2.QtQml.QQmlFileSelector.setExtraSelectors": ('typing.Sequence[str]',),
    "PySide2.QtQml.QQmlFileSelector.setSelector": ('PySide2.QtCore.QFileSelector',),

# class PySide2.QtQml.QQmlImageProviderBase:

# class PySide2.QtQml.QQmlImageProviderBase.Flag:

# class PySide2.QtQml.QQmlImageProviderBase.Flags:

# class PySide2.QtQml.QQmlImageProviderBase.ImageType:
    "PySide2.QtQml.QQmlImageProviderBase.flags": (),
    "PySide2.QtQml.QQmlImageProviderBase.imageType": (),

# class PySide2.QtQml.QQmlIncubationController:
    "PySide2.QtQml.QQmlIncubationController.__init__": (),
    "PySide2.QtQml.QQmlIncubationController.engine": (),
    "PySide2.QtQml.QQmlIncubationController.incubateFor": ('int',),
    "PySide2.QtQml.QQmlIncubationController.incubateWhile": ('int',),
    "PySide2.QtQml.QQmlIncubationController.incubatingObjectCount": (),
    "PySide2.QtQml.QQmlIncubationController.incubatingObjectCountChanged": ('int',),

# class PySide2.QtQml.QQmlIncubator:

# class PySide2.QtQml.QQmlIncubator.IncubationMode:

# class PySide2.QtQml.QQmlIncubator.Status:
    "PySide2.QtQml.QQmlIncubator.__init__": ('PySide2.QtQml.QQmlIncubator.IncubationMode',),
    "PySide2.QtQml.QQmlIncubator.clear": (),
    "PySide2.QtQml.QQmlIncubator.errors": (),
    "PySide2.QtQml.QQmlIncubator.forceCompletion": (),
    "PySide2.QtQml.QQmlIncubator.incubationMode": (),
    "PySide2.QtQml.QQmlIncubator.isError": (),
    "PySide2.QtQml.QQmlIncubator.isLoading": (),
    "PySide2.QtQml.QQmlIncubator.isNull": (),
    "PySide2.QtQml.QQmlIncubator.isReady": (),
    "PySide2.QtQml.QQmlIncubator.object": (),
    "PySide2.QtQml.QQmlIncubator.setInitialState": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlIncubator.status": (),
    "PySide2.QtQml.QQmlIncubator.statusChanged": ('PySide2.QtQml.QQmlIncubator.Status',),

# class PySide2.QtQml.QQmlListReference:
    "PySide2.QtQml.QQmlListReference.__init__": [(), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtQml.QQmlEngine'), ('PySide2.QtQml.QQmlListReference',)],
    "PySide2.QtQml.QQmlListReference.__copy__": (),
    "PySide2.QtQml.QQmlListReference.append": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlListReference.at": ('int',),
    "PySide2.QtQml.QQmlListReference.canAppend": (),
    "PySide2.QtQml.QQmlListReference.canAt": (),
    "PySide2.QtQml.QQmlListReference.canClear": (),
    "PySide2.QtQml.QQmlListReference.canCount": (),
    "PySide2.QtQml.QQmlListReference.clear": (),
    "PySide2.QtQml.QQmlListReference.count": (),
    "PySide2.QtQml.QQmlListReference.isManipulable": (),
    "PySide2.QtQml.QQmlListReference.isReadable": (),
    "PySide2.QtQml.QQmlListReference.isValid": (),
    "PySide2.QtQml.QQmlListReference.listElementType": (),
    "PySide2.QtQml.QQmlListReference.object": (),

# class PySide2.QtQml.QQmlNetworkAccessManagerFactory:
    "PySide2.QtQml.QQmlNetworkAccessManagerFactory.__init__": (),
    "PySide2.QtQml.QQmlNetworkAccessManagerFactory.create": ('PySide2.QtCore.QObject',),

# class PySide2.QtQml.QQmlParserStatus:
    "PySide2.QtQml.QQmlParserStatus.__init__": (),
    "PySide2.QtQml.QQmlParserStatus.classBegin": (),
    "PySide2.QtQml.QQmlParserStatus.componentComplete": (),

# class PySide2.QtQml.QQmlProperty:

# class PySide2.QtQml.QQmlProperty.PropertyTypeCategory:

# class PySide2.QtQml.QQmlProperty.Type:
    "PySide2.QtQml.QQmlProperty.__init__": [(), ('PySide2.QtCore.QObject',), ('PySide2.QtCore.QObject', 'PySide2.QtQml.QQmlContext'), ('PySide2.QtCore.QObject', 'PySide2.QtQml.QQmlEngine'), ('PySide2.QtCore.QObject', 'str'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtQml.QQmlContext'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtQml.QQmlEngine'), ('PySide2.QtQml.QQmlProperty',)],
    "PySide2.QtQml.QQmlProperty.__copy__": (),
    "PySide2.QtQml.QQmlProperty.connectNotifySignal": [('PySide2.QtCore.QObject', 'int'), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtQml.QQmlProperty.hasNotifySignal": (),
    "PySide2.QtQml.QQmlProperty.index": (),
    "PySide2.QtQml.QQmlProperty.isDesignable": (),
    "PySide2.QtQml.QQmlProperty.isProperty": (),
    "PySide2.QtQml.QQmlProperty.isResettable": (),
    "PySide2.QtQml.QQmlProperty.isSignalProperty": (),
    "PySide2.QtQml.QQmlProperty.isValid": (),
    "PySide2.QtQml.QQmlProperty.isWritable": (),
    "PySide2.QtQml.QQmlProperty.method": (),
    "PySide2.QtQml.QQmlProperty.name": (),
    "PySide2.QtQml.QQmlProperty.needsNotifySignal": (),
    "PySide2.QtQml.QQmlProperty.object": (),
    "PySide2.QtQml.QQmlProperty.property": (),
    "PySide2.QtQml.QQmlProperty.propertyType": (),
    "PySide2.QtQml.QQmlProperty.propertyTypeCategory": (),
    "PySide2.QtQml.QQmlProperty.propertyTypeName": (),
    "PySide2.QtQml.QQmlProperty.read": [(), ('PySide2.QtCore.QObject', 'str'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtQml.QQmlContext'), ('PySide2.QtCore.QObject', 'str', 'PySide2.QtQml.QQmlEngine')],
    "PySide2.QtQml.QQmlProperty.reset": (),
    "PySide2.QtQml.QQmlProperty.type": (),
    "PySide2.QtQml.QQmlProperty.write": [('PySide2.QtCore.QObject', 'str', 'typing.Any'), ('PySide2.QtCore.QObject', 'str', 'typing.Any', 'PySide2.QtQml.QQmlContext'), ('PySide2.QtCore.QObject', 'str', 'typing.Any', 'PySide2.QtQml.QQmlEngine'), ('typing.Any',)],

# class PySide2.QtQml.QQmlPropertyMap:
    "PySide2.QtQml.QQmlPropertyMap.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QQmlPropertyMap.clear": ('str',),
    "PySide2.QtQml.QQmlPropertyMap.contains": ('str',),
    "PySide2.QtQml.QQmlPropertyMap.count": (),
    "PySide2.QtQml.QQmlPropertyMap.insert": ('str', 'typing.Any'),
    "PySide2.QtQml.QQmlPropertyMap.isEmpty": (),
    "PySide2.QtQml.QQmlPropertyMap.keys": (),
    "PySide2.QtQml.QQmlPropertyMap.size": (),
    "PySide2.QtQml.QQmlPropertyMap.updateValue": ('str', 'typing.Any'),
    "PySide2.QtQml.QQmlPropertyMap.value": ('str',),

# class PySide2.QtQml.QQmlPropertyValueSource:
    "PySide2.QtQml.QQmlPropertyValueSource.__init__": (),
    "PySide2.QtQml.QQmlPropertyValueSource.setTarget": ('PySide2.QtQml.QQmlProperty',),

# class PySide2.QtQml.QQmlScriptString:
    "PySide2.QtQml.QQmlScriptString.__init__": [(), ('PySide2.QtQml.QQmlScriptString',)],
    "PySide2.QtQml.QQmlScriptString.__copy__": (),
    "PySide2.QtQml.QQmlScriptString.booleanLiteral": (),
    "PySide2.QtQml.QQmlScriptString.isEmpty": (),
    "PySide2.QtQml.QQmlScriptString.isNullLiteral": (),
    "PySide2.QtQml.QQmlScriptString.isUndefinedLiteral": (),
    "PySide2.QtQml.QQmlScriptString.numberLiteral": (),
    "PySide2.QtQml.QQmlScriptString.stringLiteral": (),

# class PySide2.QtQml.QQmlTypesExtensionInterface:
    "PySide2.QtQml.QQmlTypesExtensionInterface.__init__": (),
    "PySide2.QtQml.QQmlTypesExtensionInterface.registerTypes": ('str',),

# class PySide2.QtQml.QtQml:
    "PySide2.QtQml.QtQml.qmlAttachedPropertiesObject": ('PySide2.QtCore.QObject', 'PySide2.QtCore.QMetaObject', 'bool'),
    "PySide2.QtQml.QtQml.qmlAttachedPropertiesObjectById": ('int', 'PySide2.QtCore.QObject', 'bool'),
    "PySide2.QtQml.QtQml.qmlContext": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QtQml.qmlEngine": ('PySide2.QtCore.QObject',),
    "PySide2.QtQml.QtQml.qmlExecuteDeferred": ('PySide2.QtCore.QObject',),

# class PySide2.QtQml.VolatileBool:
    "PySide2.QtQml.VolatileBool.get": (),
    "PySide2.QtQml.VolatileBool.set": ('object',),

    "PySide2.QtQml.VolatileBool.qmlRegisterType": ('type', 'str', 'int', 'int', 'str'),
    }) if "PySide2.QtQml" in sys.modules else None

# Module PySide2.QtQuick
sig_dict.update({

# class PySide2.QtQuick.QQuickAsyncImageProvider:
    "PySide2.QtQuick.QQuickAsyncImageProvider.__init__": (),
    "PySide2.QtQuick.QQuickAsyncImageProvider.requestImageResponse": ('str', 'PySide2.QtCore.QSize'),

# class PySide2.QtQuick.QQuickFramebufferObject:

# class PySide2.QtQuick.QQuickFramebufferObject.Renderer:
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.__init__": (),
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.createFramebufferObject": ('PySide2.QtCore.QSize',),
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.framebufferObject": (),
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.invalidateFramebufferObject": (),
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.render": (),
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.synchronize": ('PySide2.QtQuick.QQuickFramebufferObject',),
    "PySide2.QtQuick.QQuickFramebufferObject.Renderer.update": (),

    "PySide2.QtQuick.QQuickFramebufferObject.__init__": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickFramebufferObject.createRenderer": (),
    "PySide2.QtQuick.QQuickFramebufferObject.geometryChanged": ('PySide2.QtCore.QRectF', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QQuickFramebufferObject.isTextureProvider": (),
    "PySide2.QtQuick.QQuickFramebufferObject.mirrorVertically": (),
    "PySide2.QtQuick.QQuickFramebufferObject.releaseResources": (),
    "PySide2.QtQuick.QQuickFramebufferObject.setMirrorVertically": ('bool',),
    "PySide2.QtQuick.QQuickFramebufferObject.setTextureFollowsItemSize": ('bool',),
    "PySide2.QtQuick.QQuickFramebufferObject.textureFollowsItemSize": (),
    "PySide2.QtQuick.QQuickFramebufferObject.textureProvider": (),
    "PySide2.QtQuick.QQuickFramebufferObject.updatePaintNode": ('PySide2.QtQuick.QSGNode', 'PySide2.QtQuick.QQuickItem.UpdatePaintNodeData'),

# class PySide2.QtQuick.QQuickImageProvider:
    "PySide2.QtQuick.QQuickImageProvider.__init__": ('PySide2.QtQml.QQmlImageProviderBase.ImageType', 'PySide2.QtQml.QQmlImageProviderBase.Flags'),
    "PySide2.QtQuick.QQuickImageProvider.flags": (),
    "PySide2.QtQuick.QQuickImageProvider.imageType": (),
    "PySide2.QtQuick.QQuickImageProvider.requestImage": ('str', 'PySide2.QtCore.QSize', 'PySide2.QtCore.QSize'),
    "PySide2.QtQuick.QQuickImageProvider.requestPixmap": ('str', 'PySide2.QtCore.QSize', 'PySide2.QtCore.QSize'),
    "PySide2.QtQuick.QQuickImageProvider.requestTexture": ('str', 'PySide2.QtCore.QSize', 'PySide2.QtCore.QSize'),

# class PySide2.QtQuick.QQuickImageResponse:
    "PySide2.QtQuick.QQuickImageResponse.__init__": (),
    "PySide2.QtQuick.QQuickImageResponse.cancel": (),
    "PySide2.QtQuick.QQuickImageResponse.errorString": (),
    "PySide2.QtQuick.QQuickImageResponse.textureFactory": (),

# class PySide2.QtQuick.QQuickItem:

# class PySide2.QtQuick.QQuickItem.Flag:

# class PySide2.QtQuick.QQuickItem.Flags:

# class PySide2.QtQuick.QQuickItem.ItemChange:

# class PySide2.QtQuick.QQuickItem.TransformOrigin:

# class PySide2.QtQuick.QQuickItem.UpdatePaintNodeData:
    "PySide2.QtQuick.QQuickItem.UpdatePaintNodeData.__copy__": (),

    "PySide2.QtQuick.QQuickItem.__init__": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickItem.acceptHoverEvents": (),
    "PySide2.QtQuick.QQuickItem.acceptTouchEvents": (),
    "PySide2.QtQuick.QQuickItem.acceptedMouseButtons": (),
    "PySide2.QtQuick.QQuickItem.activeFocusOnTab": (),
    "PySide2.QtQuick.QQuickItem.antialiasing": (),
    "PySide2.QtQuick.QQuickItem.baselineOffset": (),
    "PySide2.QtQuick.QQuickItem.boundingRect": (),
    "PySide2.QtQuick.QQuickItem.childAt": ('float', 'float'),
    "PySide2.QtQuick.QQuickItem.childItems": (),
    "PySide2.QtQuick.QQuickItem.childMouseEventFilter": ('PySide2.QtQuick.QQuickItem', 'PySide2.QtCore.QEvent'),
    "PySide2.QtQuick.QQuickItem.childrenRect": (),
    "PySide2.QtQuick.QQuickItem.classBegin": (),
    "PySide2.QtQuick.QQuickItem.clip": (),
    "PySide2.QtQuick.QQuickItem.clipRect": (),
    "PySide2.QtQuick.QQuickItem.componentComplete": (),
    "PySide2.QtQuick.QQuickItem.containmentMask": (),
    "PySide2.QtQuick.QQuickItem.contains": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.cursor": (),
    "PySide2.QtQuick.QQuickItem.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtQuick.QQuickItem.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtQuick.QQuickItem.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtQuick.QQuickItem.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtQuick.QQuickItem.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtQuick.QQuickItem.filtersChildMouseEvents": (),
    "PySide2.QtQuick.QQuickItem.flags": (),
    "PySide2.QtQuick.QQuickItem.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtQuick.QQuickItem.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtQuick.QQuickItem.forceActiveFocus": [(), ('PySide2.QtCore.Qt.FocusReason',)],
    "PySide2.QtQuick.QQuickItem.geometryChanged": ('PySide2.QtCore.QRectF', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QQuickItem.grabMouse": (),
    "PySide2.QtQuick.QQuickItem.grabToImage": [('PySide2.QtCore.QSize',), ('PySide2.QtQml.QJSValue', 'PySide2.QtCore.QSize')],
    "PySide2.QtQuick.QQuickItem.grabTouchPoints": ('typing.List[int]',),
    "PySide2.QtQuick.QQuickItem.hasActiveFocus": (),
    "PySide2.QtQuick.QQuickItem.hasFocus": (),
    "PySide2.QtQuick.QQuickItem.height": (),
    "PySide2.QtQuick.QQuickItem.heightValid": (),
    "PySide2.QtQuick.QQuickItem.hoverEnterEvent": ('PySide2.QtGui.QHoverEvent',),
    "PySide2.QtQuick.QQuickItem.hoverLeaveEvent": ('PySide2.QtGui.QHoverEvent',),
    "PySide2.QtQuick.QQuickItem.hoverMoveEvent": ('PySide2.QtGui.QHoverEvent',),
    "PySide2.QtQuick.QQuickItem.implicitHeight": (),
    "PySide2.QtQuick.QQuickItem.implicitWidth": (),
    "PySide2.QtQuick.QQuickItem.inputMethodEvent": ('PySide2.QtGui.QInputMethodEvent',),
    "PySide2.QtQuick.QQuickItem.inputMethodQuery": ('PySide2.QtCore.Qt.InputMethodQuery',),
    "PySide2.QtQuick.QQuickItem.isAncestorOf": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickItem.isComponentComplete": (),
    "PySide2.QtQuick.QQuickItem.isEnabled": (),
    "PySide2.QtQuick.QQuickItem.isFocusScope": (),
    "PySide2.QtQuick.QQuickItem.isTextureProvider": (),
    "PySide2.QtQuick.QQuickItem.isUnderMouse": (),
    "PySide2.QtQuick.QQuickItem.isVisible": (),
    "PySide2.QtQuick.QQuickItem.itemTransform": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickItem.keepMouseGrab": (),
    "PySide2.QtQuick.QQuickItem.keepTouchGrab": (),
    "PySide2.QtQuick.QQuickItem.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuick.QQuickItem.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuick.QQuickItem.mapFromGlobal": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.mapFromItem": ('PySide2.QtQuick.QQuickItem', 'PySide2.QtCore.QPointF'),
    "PySide2.QtQuick.QQuickItem.mapFromScene": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.mapRectFromItem": ('PySide2.QtQuick.QQuickItem', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QQuickItem.mapRectFromScene": ('PySide2.QtCore.QRectF',),
    "PySide2.QtQuick.QQuickItem.mapRectToItem": ('PySide2.QtQuick.QQuickItem', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QQuickItem.mapRectToScene": ('PySide2.QtCore.QRectF',),
    "PySide2.QtQuick.QQuickItem.mapToGlobal": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.mapToItem": ('PySide2.QtQuick.QQuickItem', 'PySide2.QtCore.QPointF'),
    "PySide2.QtQuick.QQuickItem.mapToScene": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickItem.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickItem.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickItem.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickItem.mouseUngrabEvent": (),
    "PySide2.QtQuick.QQuickItem.nextItemInFocusChain": ('bool',),
    "PySide2.QtQuick.QQuickItem.opacity": (),
    "PySide2.QtQuick.QQuickItem.parentItem": (),
    "PySide2.QtQuick.QQuickItem.polish": (),
    "PySide2.QtQuick.QQuickItem.position": (),
    "PySide2.QtQuick.QQuickItem.releaseResources": (),
    "PySide2.QtQuick.QQuickItem.resetAntialiasing": (),
    "PySide2.QtQuick.QQuickItem.resetHeight": (),
    "PySide2.QtQuick.QQuickItem.resetWidth": (),
    "PySide2.QtQuick.QQuickItem.rotation": (),
    "PySide2.QtQuick.QQuickItem.scale": (),
    "PySide2.QtQuick.QQuickItem.scopedFocusItem": (),
    "PySide2.QtQuick.QQuickItem.setAcceptHoverEvents": ('bool',),
    "PySide2.QtQuick.QQuickItem.setAcceptTouchEvents": ('bool',),
    "PySide2.QtQuick.QQuickItem.setAcceptedMouseButtons": ('PySide2.QtCore.Qt.MouseButtons',),
    "PySide2.QtQuick.QQuickItem.setActiveFocusOnTab": ('bool',),
    "PySide2.QtQuick.QQuickItem.setAntialiasing": ('bool',),
    "PySide2.QtQuick.QQuickItem.setBaselineOffset": ('float',),
    "PySide2.QtQuick.QQuickItem.setClip": ('bool',),
    "PySide2.QtQuick.QQuickItem.setContainmentMask": ('PySide2.QtCore.QObject',),
    "PySide2.QtQuick.QQuickItem.setCursor": ('PySide2.QtGui.QCursor',),
    "PySide2.QtQuick.QQuickItem.setEnabled": ('bool',),
    "PySide2.QtQuick.QQuickItem.setFiltersChildMouseEvents": ('bool',),
    "PySide2.QtQuick.QQuickItem.setFlag": ('PySide2.QtQuick.QQuickItem.Flag', 'bool'),
    "PySide2.QtQuick.QQuickItem.setFlags": ('PySide2.QtQuick.QQuickItem.Flags',),
    "PySide2.QtQuick.QQuickItem.setFocus": [('bool',), ('bool', 'PySide2.QtCore.Qt.FocusReason')],
    "PySide2.QtQuick.QQuickItem.setHeight": ('float',),
    "PySide2.QtQuick.QQuickItem.setImplicitHeight": ('float',),
    "PySide2.QtQuick.QQuickItem.setImplicitSize": ('float', 'float'),
    "PySide2.QtQuick.QQuickItem.setImplicitWidth": ('float',),
    "PySide2.QtQuick.QQuickItem.setKeepMouseGrab": ('bool',),
    "PySide2.QtQuick.QQuickItem.setKeepTouchGrab": ('bool',),
    "PySide2.QtQuick.QQuickItem.setOpacity": ('float',),
    "PySide2.QtQuick.QQuickItem.setParentItem": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickItem.setPosition": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.setRotation": ('float',),
    "PySide2.QtQuick.QQuickItem.setScale": ('float',),
    "PySide2.QtQuick.QQuickItem.setSize": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtQuick.QQuickItem.setSmooth": ('bool',),
    "PySide2.QtQuick.QQuickItem.setState": ('str',),
    "PySide2.QtQuick.QQuickItem.setTransformOrigin": ('PySide2.QtQuick.QQuickItem.TransformOrigin',),
    "PySide2.QtQuick.QQuickItem.setTransformOriginPoint": ('PySide2.QtCore.QPointF',),
    "PySide2.QtQuick.QQuickItem.setVisible": ('bool',),
    "PySide2.QtQuick.QQuickItem.setWidth": ('float',),
    "PySide2.QtQuick.QQuickItem.setX": ('float',),
    "PySide2.QtQuick.QQuickItem.setY": ('float',),
    "PySide2.QtQuick.QQuickItem.setZ": ('float',),
    "PySide2.QtQuick.QQuickItem.size": (),
    "PySide2.QtQuick.QQuickItem.smooth": (),
    "PySide2.QtQuick.QQuickItem.stackAfter": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickItem.stackBefore": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickItem.state": (),
    "PySide2.QtQuick.QQuickItem.textureProvider": (),
    "PySide2.QtQuick.QQuickItem.touchEvent": ('PySide2.QtGui.QTouchEvent',),
    "PySide2.QtQuick.QQuickItem.touchUngrabEvent": (),
    "PySide2.QtQuick.QQuickItem.transformOrigin": (),
    "PySide2.QtQuick.QQuickItem.transformOriginPoint": (),
    "PySide2.QtQuick.QQuickItem.ungrabMouse": (),
    "PySide2.QtQuick.QQuickItem.ungrabTouchPoints": (),
    "PySide2.QtQuick.QQuickItem.unsetCursor": (),
    "PySide2.QtQuick.QQuickItem.update": (),
    "PySide2.QtQuick.QQuickItem.updateInputMethod": ('PySide2.QtCore.Qt.InputMethodQueries',),
    "PySide2.QtQuick.QQuickItem.updatePaintNode": ('PySide2.QtQuick.QSGNode', 'PySide2.QtQuick.QQuickItem.UpdatePaintNodeData'),
    "PySide2.QtQuick.QQuickItem.updatePolish": (),
    "PySide2.QtQuick.QQuickItem.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    "PySide2.QtQuick.QQuickItem.width": (),
    "PySide2.QtQuick.QQuickItem.widthValid": (),
    "PySide2.QtQuick.QQuickItem.window": (),
    "PySide2.QtQuick.QQuickItem.windowDeactivateEvent": (),
    "PySide2.QtQuick.QQuickItem.x": (),
    "PySide2.QtQuick.QQuickItem.y": (),
    "PySide2.QtQuick.QQuickItem.z": (),

# class PySide2.QtQuick.QQuickItemGrabResult:
    "PySide2.QtQuick.QQuickItemGrabResult.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtQuick.QQuickItemGrabResult.image": (),
    "PySide2.QtQuick.QQuickItemGrabResult.saveToFile": ('str',),
    "PySide2.QtQuick.QQuickItemGrabResult.url": (),

# class PySide2.QtQuick.QQuickPaintedItem:

# class PySide2.QtQuick.QQuickPaintedItem.PerformanceHint:

# class PySide2.QtQuick.QQuickPaintedItem.PerformanceHints:

# class PySide2.QtQuick.QQuickPaintedItem.RenderTarget:
    "PySide2.QtQuick.QQuickPaintedItem.__init__": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickPaintedItem.antialiasing": (),
    "PySide2.QtQuick.QQuickPaintedItem.contentsBoundingRect": (),
    "PySide2.QtQuick.QQuickPaintedItem.contentsScale": (),
    "PySide2.QtQuick.QQuickPaintedItem.contentsSize": (),
    "PySide2.QtQuick.QQuickPaintedItem.fillColor": (),
    "PySide2.QtQuick.QQuickPaintedItem.isTextureProvider": (),
    "PySide2.QtQuick.QQuickPaintedItem.mipmap": (),
    "PySide2.QtQuick.QQuickPaintedItem.opaquePainting": (),
    "PySide2.QtQuick.QQuickPaintedItem.paint": ('PySide2.QtGui.QPainter',),
    "PySide2.QtQuick.QQuickPaintedItem.performanceHints": (),
    "PySide2.QtQuick.QQuickPaintedItem.releaseResources": (),
    "PySide2.QtQuick.QQuickPaintedItem.renderTarget": (),
    "PySide2.QtQuick.QQuickPaintedItem.resetContentsSize": (),
    "PySide2.QtQuick.QQuickPaintedItem.setAntialiasing": ('bool',),
    "PySide2.QtQuick.QQuickPaintedItem.setContentsScale": ('float',),
    "PySide2.QtQuick.QQuickPaintedItem.setContentsSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtQuick.QQuickPaintedItem.setFillColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtQuick.QQuickPaintedItem.setMipmap": ('bool',),
    "PySide2.QtQuick.QQuickPaintedItem.setOpaquePainting": ('bool',),
    "PySide2.QtQuick.QQuickPaintedItem.setPerformanceHint": ('PySide2.QtQuick.QQuickPaintedItem.PerformanceHint', 'bool'),
    "PySide2.QtQuick.QQuickPaintedItem.setPerformanceHints": ('PySide2.QtQuick.QQuickPaintedItem.PerformanceHints',),
    "PySide2.QtQuick.QQuickPaintedItem.setRenderTarget": ('PySide2.QtQuick.QQuickPaintedItem.RenderTarget',),
    "PySide2.QtQuick.QQuickPaintedItem.setTextureSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtQuick.QQuickPaintedItem.textureProvider": (),
    "PySide2.QtQuick.QQuickPaintedItem.textureSize": (),
    "PySide2.QtQuick.QQuickPaintedItem.update": [(), ('PySide2.QtCore.QRect',)],
    "PySide2.QtQuick.QQuickPaintedItem.updatePaintNode": ('PySide2.QtQuick.QSGNode', 'PySide2.QtQuick.QQuickItem.UpdatePaintNodeData'),

# class PySide2.QtQuick.QQuickRenderControl:
    "PySide2.QtQuick.QQuickRenderControl.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQuick.QQuickRenderControl.grab": (),
    "PySide2.QtQuick.QQuickRenderControl.initialize": ('PySide2.QtGui.QOpenGLContext',),
    "PySide2.QtQuick.QQuickRenderControl.invalidate": (),
    "PySide2.QtQuick.QQuickRenderControl.polishItems": (),
    "PySide2.QtQuick.QQuickRenderControl.prepareThread": ('PySide2.QtCore.QThread',),
    "PySide2.QtQuick.QQuickRenderControl.render": (),
    "PySide2.QtQuick.QQuickRenderControl.renderWindow": ('PySide2.QtCore.QPoint',),
    "PySide2.QtQuick.QQuickRenderControl.renderWindowFor": ('PySide2.QtQuick.QQuickWindow', 'PySide2.QtCore.QPoint'),
    "PySide2.QtQuick.QQuickRenderControl.sync": (),

# class PySide2.QtQuick.QQuickTextDocument:
    "PySide2.QtQuick.QQuickTextDocument.__init__": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickTextDocument.textDocument": (),

# class PySide2.QtQuick.QQuickTextureFactory:
    "PySide2.QtQuick.QQuickTextureFactory.__init__": (),
    "PySide2.QtQuick.QQuickTextureFactory.createTexture": ('PySide2.QtQuick.QQuickWindow',),
    "PySide2.QtQuick.QQuickTextureFactory.image": (),
    "PySide2.QtQuick.QQuickTextureFactory.textureByteCount": (),
    "PySide2.QtQuick.QQuickTextureFactory.textureFactoryForImage": ('PySide2.QtGui.QImage',),
    "PySide2.QtQuick.QQuickTextureFactory.textureSize": (),

# class PySide2.QtQuick.QQuickTransform:
    "PySide2.QtQuick.QQuickTransform.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQuick.QQuickTransform.appendToItem": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickTransform.applyTo": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtQuick.QQuickTransform.prependToItem": ('PySide2.QtQuick.QQuickItem',),
    "PySide2.QtQuick.QQuickTransform.update": (),

# class PySide2.QtQuick.QQuickView:

# class PySide2.QtQuick.QQuickView.ResizeMode:

# class PySide2.QtQuick.QQuickView.Status:
    "PySide2.QtQuick.QQuickView.__init__": [('PySide2.QtCore.QUrl', 'PySide2.QtGui.QWindow'), ('PySide2.QtCore.QUrl', 'PySide2.QtQuick.QQuickRenderControl'), ('PySide2.QtGui.QWindow',), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtGui.QWindow')],
    "PySide2.QtQuick.QQuickView.engine": (),
    "PySide2.QtQuick.QQuickView.errors": (),
    "PySide2.QtQuick.QQuickView.initialSize": (),
    "PySide2.QtQuick.QQuickView.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuick.QQuickView.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuick.QQuickView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickView.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickView.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtQuick.QQuickView.resizeMode": (),
    "PySide2.QtQuick.QQuickView.rootContext": (),
    "PySide2.QtQuick.QQuickView.rootObject": (),
    "PySide2.QtQuick.QQuickView.setContent": ('PySide2.QtCore.QUrl', 'PySide2.QtQml.QQmlComponent', 'PySide2.QtCore.QObject'),
    "PySide2.QtQuick.QQuickView.setInitialProperties": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtQuick.QQuickView.setResizeMode": ('PySide2.QtQuick.QQuickView.ResizeMode',),
    "PySide2.QtQuick.QQuickView.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.QtQuick.QQuickView.sizeHint": (),
    "PySide2.QtQuick.QQuickView.source": (),
    "PySide2.QtQuick.QQuickView.status": (),
    "PySide2.QtQuick.QQuickView.timerEvent": ('PySide2.QtCore.QTimerEvent',),

# class PySide2.QtQuick.QQuickWindow:

# class PySide2.QtQuick.QQuickWindow.CreateTextureOption:

# class PySide2.QtQuick.QQuickWindow.CreateTextureOptions:

# class PySide2.QtQuick.QQuickWindow.NativeObjectType:

# class PySide2.QtQuick.QQuickWindow.RenderStage:

# class PySide2.QtQuick.QQuickWindow.SceneGraphError:

# class PySide2.QtQuick.QQuickWindow.TextRenderType:
    "PySide2.QtQuick.QQuickWindow.__init__": [('PySide2.QtGui.QWindow',), ('PySide2.QtQuick.QQuickRenderControl',)],
    "PySide2.QtQuick.QQuickWindow.accessibleRoot": (),
    "PySide2.QtQuick.QQuickWindow.activeFocusItem": (),
    "PySide2.QtQuick.QQuickWindow.beginExternalCommands": (),
    "PySide2.QtQuick.QQuickWindow.clearBeforeRendering": (),
    "PySide2.QtQuick.QQuickWindow.color": (),
    "PySide2.QtQuick.QQuickWindow.contentItem": (),
    "PySide2.QtQuick.QQuickWindow.createTextureFromId": ('int', 'PySide2.QtCore.QSize', 'PySide2.QtQuick.QQuickWindow.CreateTextureOptions'),
    "PySide2.QtQuick.QQuickWindow.createTextureFromImage": [('PySide2.QtGui.QImage',), ('PySide2.QtGui.QImage', 'PySide2.QtQuick.QQuickWindow.CreateTextureOptions')],
    "PySide2.QtQuick.QQuickWindow.createTextureFromNativeObject": ('PySide2.QtQuick.QQuickWindow.NativeObjectType', 'int', 'int', 'PySide2.QtCore.QSize', 'PySide2.QtQuick.QQuickWindow.CreateTextureOptions'),
    "PySide2.QtQuick.QQuickWindow.effectiveDevicePixelRatio": (),
    "PySide2.QtQuick.QQuickWindow.endExternalCommands": (),
    "PySide2.QtQuick.QQuickWindow.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtQuick.QQuickWindow.exposeEvent": ('PySide2.QtGui.QExposeEvent',),
    "PySide2.QtQuick.QQuickWindow.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtQuick.QQuickWindow.focusObject": (),
    "PySide2.QtQuick.QQuickWindow.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtQuick.QQuickWindow.grabWindow": (),
    "PySide2.QtQuick.QQuickWindow.hasDefaultAlphaBuffer": (),
    "PySide2.QtQuick.QQuickWindow.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtQuick.QQuickWindow.incubationController": (),
    "PySide2.QtQuick.QQuickWindow.isPersistentOpenGLContext": (),
    "PySide2.QtQuick.QQuickWindow.isPersistentSceneGraph": (),
    "PySide2.QtQuick.QQuickWindow.isSceneGraphInitialized": (),
    "PySide2.QtQuick.QQuickWindow.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuick.QQuickWindow.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuick.QQuickWindow.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickWindow.mouseGrabberItem": (),
    "PySide2.QtQuick.QQuickWindow.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickWindow.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickWindow.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuick.QQuickWindow.openglContext": (),
    "PySide2.QtQuick.QQuickWindow.releaseResources": (),
    "PySide2.QtQuick.QQuickWindow.renderTarget": (),
    "PySide2.QtQuick.QQuickWindow.renderTargetId": (),
    "PySide2.QtQuick.QQuickWindow.renderTargetSize": (),
    "PySide2.QtQuick.QQuickWindow.resetOpenGLState": (),
    "PySide2.QtQuick.QQuickWindow.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtQuick.QQuickWindow.sceneGraphBackend": (),
    "PySide2.QtQuick.QQuickWindow.scheduleRenderJob": ('PySide2.QtCore.QRunnable', 'PySide2.QtQuick.QQuickWindow.RenderStage'),
    "PySide2.QtQuick.QQuickWindow.sendEvent": ('PySide2.QtQuick.QQuickItem', 'PySide2.QtCore.QEvent'),
    "PySide2.QtQuick.QQuickWindow.setClearBeforeRendering": ('bool',),
    "PySide2.QtQuick.QQuickWindow.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtQuick.QQuickWindow.setDefaultAlphaBuffer": ('bool',),
    "PySide2.QtQuick.QQuickWindow.setPersistentOpenGLContext": ('bool',),
    "PySide2.QtQuick.QQuickWindow.setPersistentSceneGraph": ('bool',),
    "PySide2.QtQuick.QQuickWindow.setRenderTarget": [('PySide2.QtGui.QOpenGLFramebufferObject',), ('int', 'PySide2.QtCore.QSize')],
    "PySide2.QtQuick.QQuickWindow.setSceneGraphBackend": ('str',),
    "PySide2.QtQuick.QQuickWindow.setTextRenderType": ('PySide2.QtQuick.QQuickWindow.TextRenderType',),
    "PySide2.QtQuick.QQuickWindow.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtQuick.QQuickWindow.textRenderType": (),
    "PySide2.QtQuick.QQuickWindow.update": (),
    "PySide2.QtQuick.QQuickWindow.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtQuick.QSGAbstractRenderer:

# class PySide2.QtQuick.QSGAbstractRenderer.ClearMode:

# class PySide2.QtQuick.QSGAbstractRenderer.ClearModeBit:

# class PySide2.QtQuick.QSGAbstractRenderer.MatrixTransformFlag:

# class PySide2.QtQuick.QSGAbstractRenderer.MatrixTransformFlags:
    "PySide2.QtQuick.QSGAbstractRenderer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQuick.QSGAbstractRenderer.clearColor": (),
    "PySide2.QtQuick.QSGAbstractRenderer.clearMode": (),
    "PySide2.QtQuick.QSGAbstractRenderer.deviceRect": (),
    "PySide2.QtQuick.QSGAbstractRenderer.nodeChanged": ('PySide2.QtQuick.QSGNode', 'PySide2.QtQuick.QSGNode.DirtyState'),
    "PySide2.QtQuick.QSGAbstractRenderer.projectionMatrix": (),
    "PySide2.QtQuick.QSGAbstractRenderer.projectionMatrixWithNativeNDC": (),
    "PySide2.QtQuick.QSGAbstractRenderer.renderScene": ('int',),
    "PySide2.QtQuick.QSGAbstractRenderer.setClearColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtQuick.QSGAbstractRenderer.setClearMode": ('PySide2.QtQuick.QSGAbstractRenderer.ClearMode',),
    "PySide2.QtQuick.QSGAbstractRenderer.setDeviceRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QSize',)],
    "PySide2.QtQuick.QSGAbstractRenderer.setProjectionMatrix": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtQuick.QSGAbstractRenderer.setProjectionMatrixToRect": [('PySide2.QtCore.QRectF',), ('PySide2.QtCore.QRectF', 'PySide2.QtQuick.QSGAbstractRenderer.MatrixTransformFlags')],
    "PySide2.QtQuick.QSGAbstractRenderer.setProjectionMatrixWithNativeNDC": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtQuick.QSGAbstractRenderer.setViewportRect": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QSize',)],
    "PySide2.QtQuick.QSGAbstractRenderer.viewportRect": (),

# class PySide2.QtQuick.QSGBasicGeometryNode:
    "PySide2.QtQuick.QSGBasicGeometryNode.__init__": ('PySide2.QtQuick.QSGNode.NodeType',),
    "PySide2.QtQuick.QSGBasicGeometryNode.clipList": (),
    "PySide2.QtQuick.QSGBasicGeometryNode.geometry": (),
    "PySide2.QtQuick.QSGBasicGeometryNode.matrix": (),
    "PySide2.QtQuick.QSGBasicGeometryNode.setGeometry": ('PySide2.QtQuick.QSGGeometry',),
    "PySide2.QtQuick.QSGBasicGeometryNode.setRendererClipList": ('PySide2.QtQuick.QSGClipNode',),
    "PySide2.QtQuick.QSGBasicGeometryNode.setRendererMatrix": ('PySide2.QtGui.QMatrix4x4',),

# class PySide2.QtQuick.QSGClipNode:
    "PySide2.QtQuick.QSGClipNode.__init__": (),
    "PySide2.QtQuick.QSGClipNode.clipRect": (),
    "PySide2.QtQuick.QSGClipNode.isRectangular": (),
    "PySide2.QtQuick.QSGClipNode.setClipRect": ('PySide2.QtCore.QRectF',),
    "PySide2.QtQuick.QSGClipNode.setIsRectangular": ('bool',),

# class PySide2.QtQuick.QSGDynamicTexture:
    "PySide2.QtQuick.QSGDynamicTexture.__init__": (),
    "PySide2.QtQuick.QSGDynamicTexture.updateTexture": (),

# class PySide2.QtQuick.QSGEngine:

# class PySide2.QtQuick.QSGEngine.CreateTextureOption:

# class PySide2.QtQuick.QSGEngine.CreateTextureOptions:
    "PySide2.QtQuick.QSGEngine.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtQuick.QSGEngine.createRenderer": (),
    "PySide2.QtQuick.QSGEngine.createTextureFromId": ('int', 'PySide2.QtCore.QSize', 'PySide2.QtQuick.QSGEngine.CreateTextureOptions'),
    "PySide2.QtQuick.QSGEngine.createTextureFromImage": ('PySide2.QtGui.QImage', 'PySide2.QtQuick.QSGEngine.CreateTextureOptions'),
    "PySide2.QtQuick.QSGEngine.initialize": ('PySide2.QtGui.QOpenGLContext',),
    "PySide2.QtQuick.QSGEngine.invalidate": (),

# class PySide2.QtQuick.QSGGeometry:

# class PySide2.QtQuick.QSGGeometry.Attribute:
    "PySide2.QtQuick.QSGGeometry.Attribute.__init__": [(), ('PySide2.QtQuick.QSGGeometry.Attribute',)],
    "PySide2.QtQuick.QSGGeometry.Attribute.__copy__": (),
    "PySide2.QtQuick.QSGGeometry.Attribute.create": ('int', 'int', 'int', 'bool'),
    "PySide2.QtQuick.QSGGeometry.Attribute.createWithAttributeType": ('int', 'int', 'int', 'PySide2.QtQuick.QSGGeometry.AttributeType'),

# class PySide2.QtQuick.QSGGeometry.AttributeSet:
    "PySide2.QtQuick.QSGGeometry.AttributeSet.__init__": [(), ('PySide2.QtQuick.QSGGeometry.AttributeSet',)],
    "PySide2.QtQuick.QSGGeometry.AttributeSet.__copy__": (),

# class PySide2.QtQuick.QSGGeometry.AttributeType:

# class PySide2.QtQuick.QSGGeometry.ColoredPoint2D:
    "PySide2.QtQuick.QSGGeometry.ColoredPoint2D.__init__": [(), ('PySide2.QtQuick.QSGGeometry.ColoredPoint2D',)],
    "PySide2.QtQuick.QSGGeometry.ColoredPoint2D.__copy__": (),
    "PySide2.QtQuick.QSGGeometry.ColoredPoint2D.set": ('float', 'float', 'typing.Char', 'typing.Char', 'typing.Char', 'typing.Char'),

# class PySide2.QtQuick.QSGGeometry.DataPattern:

# class PySide2.QtQuick.QSGGeometry.DrawingMode:

# class PySide2.QtQuick.QSGGeometry.Point2D:
    "PySide2.QtQuick.QSGGeometry.Point2D.__init__": [(), ('PySide2.QtQuick.QSGGeometry.Point2D',)],
    "PySide2.QtQuick.QSGGeometry.Point2D.__copy__": (),
    "PySide2.QtQuick.QSGGeometry.Point2D.set": ('float', 'float'),

# class PySide2.QtQuick.QSGGeometry.TexturedPoint2D:
    "PySide2.QtQuick.QSGGeometry.TexturedPoint2D.__init__": [(), ('PySide2.QtQuick.QSGGeometry.TexturedPoint2D',)],
    "PySide2.QtQuick.QSGGeometry.TexturedPoint2D.__copy__": (),
    "PySide2.QtQuick.QSGGeometry.TexturedPoint2D.set": ('float', 'float', 'float', 'float'),

# class PySide2.QtQuick.QSGGeometry.Type:

    "PySide2.QtQuick.QSGGeometry.__init__": ('PySide2.QtQuick.QSGGeometry.AttributeSet', 'int', 'int', 'int'),
    "PySide2.QtQuick.QSGGeometry.allocate": ('int', 'int'),
    "PySide2.QtQuick.QSGGeometry.attributeCount": (),
    "PySide2.QtQuick.QSGGeometry.attributes": (),
    "PySide2.QtQuick.QSGGeometry.defaultAttributes_ColoredPoint2D": (),
    "PySide2.QtQuick.QSGGeometry.defaultAttributes_Point2D": (),
    "PySide2.QtQuick.QSGGeometry.defaultAttributes_TexturedPoint2D": (),
    "PySide2.QtQuick.QSGGeometry.drawingMode": (),
    "PySide2.QtQuick.QSGGeometry.indexCount": (),
    "PySide2.QtQuick.QSGGeometry.indexData": (),
    "PySide2.QtQuick.QSGGeometry.indexDataAsUInt": (),
    "PySide2.QtQuick.QSGGeometry.indexDataAsUShort": (),
    "PySide2.QtQuick.QSGGeometry.indexDataPattern": (),
    "PySide2.QtQuick.QSGGeometry.indexType": (),
    "PySide2.QtQuick.QSGGeometry.lineWidth": (),
    "PySide2.QtQuick.QSGGeometry.markIndexDataDirty": (),
    "PySide2.QtQuick.QSGGeometry.markVertexDataDirty": (),
    "PySide2.QtQuick.QSGGeometry.setDrawingMode": ('int',),
    "PySide2.QtQuick.QSGGeometry.setIndexDataPattern": ('PySide2.QtQuick.QSGGeometry.DataPattern',),
    "PySide2.QtQuick.QSGGeometry.setLineWidth": ('float',),
    "PySide2.QtQuick.QSGGeometry.setVertexDataPattern": ('PySide2.QtQuick.QSGGeometry.DataPattern',),
    "PySide2.QtQuick.QSGGeometry.sizeOfIndex": (),
    "PySide2.QtQuick.QSGGeometry.sizeOfVertex": (),
    "PySide2.QtQuick.QSGGeometry.updateColoredRectGeometry": ('PySide2.QtQuick.QSGGeometry', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QSGGeometry.updateRectGeometry": ('PySide2.QtQuick.QSGGeometry', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QSGGeometry.updateTexturedRectGeometry": ('PySide2.QtQuick.QSGGeometry', 'PySide2.QtCore.QRectF', 'PySide2.QtCore.QRectF'),
    "PySide2.QtQuick.QSGGeometry.vertexCount": (),
    "PySide2.QtQuick.QSGGeometry.vertexData": (),
    "PySide2.QtQuick.QSGGeometry.vertexDataAsColoredPoint2D": (),
    "PySide2.QtQuick.QSGGeometry.vertexDataAsPoint2D": (),
    "PySide2.QtQuick.QSGGeometry.vertexDataAsTexturedPoint2D": (),
    "PySide2.QtQuick.QSGGeometry.vertexDataPattern": (),

# class PySide2.QtQuick.QSGGeometryNode:
    "PySide2.QtQuick.QSGGeometryNode.__init__": (),
    "PySide2.QtQuick.QSGGeometryNode.inheritedOpacity": (),
    "PySide2.QtQuick.QSGGeometryNode.renderOrder": (),
    "PySide2.QtQuick.QSGGeometryNode.setInheritedOpacity": ('float',),
    "PySide2.QtQuick.QSGGeometryNode.setRenderOrder": ('int',),

# class PySide2.QtQuick.QSGMaterialType:
    "PySide2.QtQuick.QSGMaterialType.__init__": (),

# class PySide2.QtQuick.QSGNode:

# class PySide2.QtQuick.QSGNode.DirtyState:

# class PySide2.QtQuick.QSGNode.DirtyStateBit:

# class PySide2.QtQuick.QSGNode.Flag:

# class PySide2.QtQuick.QSGNode.Flags:

# class PySide2.QtQuick.QSGNode.NodeType:
    "PySide2.QtQuick.QSGNode.__init__": [(), ('PySide2.QtQuick.QSGNode.NodeType',)],
    "PySide2.QtQuick.QSGNode.appendChildNode": ('PySide2.QtQuick.QSGNode',),
    "PySide2.QtQuick.QSGNode.childAtIndex": ('int',),
    "PySide2.QtQuick.QSGNode.childCount": (),
    "PySide2.QtQuick.QSGNode.clearDirty": (),
    "PySide2.QtQuick.QSGNode.dirtyState": (),
    "PySide2.QtQuick.QSGNode.firstChild": (),
    "PySide2.QtQuick.QSGNode.flags": (),
    "PySide2.QtQuick.QSGNode.insertChildNodeAfter": ('PySide2.QtQuick.QSGNode', 'PySide2.QtQuick.QSGNode'),
    "PySide2.QtQuick.QSGNode.insertChildNodeBefore": ('PySide2.QtQuick.QSGNode', 'PySide2.QtQuick.QSGNode'),
    "PySide2.QtQuick.QSGNode.isSubtreeBlocked": (),
    "PySide2.QtQuick.QSGNode.lastChild": (),
    "PySide2.QtQuick.QSGNode.markDirty": ('PySide2.QtQuick.QSGNode.DirtyState',),
    "PySide2.QtQuick.QSGNode.nextSibling": (),
    "PySide2.QtQuick.QSGNode.parent": (),
    "PySide2.QtQuick.QSGNode.prependChildNode": ('PySide2.QtQuick.QSGNode',),
    "PySide2.QtQuick.QSGNode.preprocess": (),
    "PySide2.QtQuick.QSGNode.previousSibling": (),
    "PySide2.QtQuick.QSGNode.removeAllChildNodes": (),
    "PySide2.QtQuick.QSGNode.removeChildNode": ('PySide2.QtQuick.QSGNode',),
    "PySide2.QtQuick.QSGNode.reparentChildNodesTo": ('PySide2.QtQuick.QSGNode',),
    "PySide2.QtQuick.QSGNode.setFlag": ('PySide2.QtQuick.QSGNode.Flag', 'bool'),
    "PySide2.QtQuick.QSGNode.setFlags": ('PySide2.QtQuick.QSGNode.Flags', 'bool'),
    "PySide2.QtQuick.QSGNode.type": (),

# class PySide2.QtQuick.QSGOpacityNode:
    "PySide2.QtQuick.QSGOpacityNode.__init__": (),
    "PySide2.QtQuick.QSGOpacityNode.combinedOpacity": (),
    "PySide2.QtQuick.QSGOpacityNode.isSubtreeBlocked": (),
    "PySide2.QtQuick.QSGOpacityNode.opacity": (),
    "PySide2.QtQuick.QSGOpacityNode.setCombinedOpacity": ('float',),
    "PySide2.QtQuick.QSGOpacityNode.setOpacity": ('float',),

# class PySide2.QtQuick.QSGSimpleRectNode:
    "PySide2.QtQuick.QSGSimpleRectNode.__init__": [(), ('PySide2.QtCore.QRectF', 'PySide2.QtGui.QColor')],
    "PySide2.QtQuick.QSGSimpleRectNode.color": (),
    "PySide2.QtQuick.QSGSimpleRectNode.rect": (),
    "PySide2.QtQuick.QSGSimpleRectNode.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtQuick.QSGSimpleRectNode.setRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],

# class PySide2.QtQuick.QSGSimpleTextureNode:

# class PySide2.QtQuick.QSGSimpleTextureNode.TextureCoordinatesTransformFlag:

# class PySide2.QtQuick.QSGSimpleTextureNode.TextureCoordinatesTransformMode:
    "PySide2.QtQuick.QSGSimpleTextureNode.__init__": (),
    "PySide2.QtQuick.QSGSimpleTextureNode.filtering": (),
    "PySide2.QtQuick.QSGSimpleTextureNode.ownsTexture": (),
    "PySide2.QtQuick.QSGSimpleTextureNode.rect": (),
    "PySide2.QtQuick.QSGSimpleTextureNode.setFiltering": ('PySide2.QtQuick.QSGTexture.Filtering',),
    "PySide2.QtQuick.QSGSimpleTextureNode.setOwnsTexture": ('bool',),
    "PySide2.QtQuick.QSGSimpleTextureNode.setRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtQuick.QSGSimpleTextureNode.setSourceRect": [('PySide2.QtCore.QRectF',), ('float', 'float', 'float', 'float')],
    "PySide2.QtQuick.QSGSimpleTextureNode.setTexture": ('PySide2.QtQuick.QSGTexture',),
    "PySide2.QtQuick.QSGSimpleTextureNode.setTextureCoordinatesTransform": ('PySide2.QtQuick.QSGSimpleTextureNode.TextureCoordinatesTransformMode',),
    "PySide2.QtQuick.QSGSimpleTextureNode.sourceRect": (),
    "PySide2.QtQuick.QSGSimpleTextureNode.texture": (),
    "PySide2.QtQuick.QSGSimpleTextureNode.textureCoordinatesTransform": (),

# class PySide2.QtQuick.QSGTexture:

# class PySide2.QtQuick.QSGTexture.AnisotropyLevel:

# class PySide2.QtQuick.QSGTexture.Filtering:

# class PySide2.QtQuick.QSGTexture.WrapMode:
    "PySide2.QtQuick.QSGTexture.__init__": (),
    "PySide2.QtQuick.QSGTexture.anisotropyLevel": (),
    "PySide2.QtQuick.QSGTexture.bind": (),
    "PySide2.QtQuick.QSGTexture.comparisonKey": (),
    "PySide2.QtQuick.QSGTexture.convertToNormalizedSourceRect": ('PySide2.QtCore.QRectF',),
    "PySide2.QtQuick.QSGTexture.filtering": (),
    "PySide2.QtQuick.QSGTexture.hasAlphaChannel": (),
    "PySide2.QtQuick.QSGTexture.hasMipmaps": (),
    "PySide2.QtQuick.QSGTexture.horizontalWrapMode": (),
    "PySide2.QtQuick.QSGTexture.isAtlasTexture": (),
    "PySide2.QtQuick.QSGTexture.mipmapFiltering": (),
    "PySide2.QtQuick.QSGTexture.normalizedTextureSubRect": (),
    "PySide2.QtQuick.QSGTexture.removedFromAtlas": (),
    "PySide2.QtQuick.QSGTexture.setAnisotropyLevel": ('PySide2.QtQuick.QSGTexture.AnisotropyLevel',),
    "PySide2.QtQuick.QSGTexture.setFiltering": ('PySide2.QtQuick.QSGTexture.Filtering',),
    "PySide2.QtQuick.QSGTexture.setHorizontalWrapMode": ('PySide2.QtQuick.QSGTexture.WrapMode',),
    "PySide2.QtQuick.QSGTexture.setMipmapFiltering": ('PySide2.QtQuick.QSGTexture.Filtering',),
    "PySide2.QtQuick.QSGTexture.setVerticalWrapMode": ('PySide2.QtQuick.QSGTexture.WrapMode',),
    "PySide2.QtQuick.QSGTexture.textureId": (),
    "PySide2.QtQuick.QSGTexture.textureSize": (),
    "PySide2.QtQuick.QSGTexture.updateBindOptions": ('bool',),
    "PySide2.QtQuick.QSGTexture.verticalWrapMode": (),

# class PySide2.QtQuick.QSGTextureProvider:
    "PySide2.QtQuick.QSGTextureProvider.__init__": (),
    "PySide2.QtQuick.QSGTextureProvider.texture": (),

# class PySide2.QtQuick.QSGTransformNode:
    "PySide2.QtQuick.QSGTransformNode.__init__": (),
    "PySide2.QtQuick.QSGTransformNode.combinedMatrix": (),
    "PySide2.QtQuick.QSGTransformNode.matrix": (),
    "PySide2.QtQuick.QSGTransformNode.setCombinedMatrix": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.QtQuick.QSGTransformNode.setMatrix": ('PySide2.QtGui.QMatrix4x4',),

# class PySide2.QtQuick.QSharedPointer<QQuickItemGrabResult >:
    "PySide2.QtQuick.QSharedPointer<QQuickItemGrabResult >.__copy__": (),
    "PySide2.QtQuick.QSharedPointer<QQuickItemGrabResult >.data": (),
    }) if "PySide2.QtQuick" in sys.modules else None

# Module PySide2.QtQuickWidgets
sig_dict.update({

# class PySide2.QtQuickWidgets.QQuickWidget:

# class PySide2.QtQuickWidgets.QQuickWidget.ResizeMode:

# class PySide2.QtQuickWidgets.QQuickWidget.Status:
    "PySide2.QtQuickWidgets.QQuickWidget.__init__": [('PySide2.QtCore.QUrl', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtQml.QQmlEngine', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtQuickWidgets.QQuickWidget.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.engine": (),
    "PySide2.QtQuickWidgets.QQuickWidget.errors": (),
    "PySide2.QtQuickWidgets.QQuickWidget.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.focusInEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.focusNextPrevChild": ('bool',),
    "PySide2.QtQuickWidgets.QQuickWidget.focusOutEvent": ('PySide2.QtGui.QFocusEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.format": (),
    "PySide2.QtQuickWidgets.QQuickWidget.grabFramebuffer": (),
    "PySide2.QtQuickWidgets.QQuickWidget.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.initialSize": (),
    "PySide2.QtQuickWidgets.QQuickWidget.keyPressEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.keyReleaseEvent": ('PySide2.QtGui.QKeyEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.quickWindow": (),
    "PySide2.QtQuickWidgets.QQuickWidget.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.resizeMode": (),
    "PySide2.QtQuickWidgets.QQuickWidget.rootContext": (),
    "PySide2.QtQuickWidgets.QQuickWidget.rootObject": (),
    "PySide2.QtQuickWidgets.QQuickWidget.setClearColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtQuickWidgets.QQuickWidget.setContent": ('PySide2.QtCore.QUrl', 'PySide2.QtQml.QQmlComponent', 'PySide2.QtCore.QObject'),
    "PySide2.QtQuickWidgets.QQuickWidget.setFormat": ('PySide2.QtGui.QSurfaceFormat',),
    "PySide2.QtQuickWidgets.QQuickWidget.setResizeMode": ('PySide2.QtQuickWidgets.QQuickWidget.ResizeMode',),
    "PySide2.QtQuickWidgets.QQuickWidget.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.QtQuickWidgets.QQuickWidget.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.sizeHint": (),
    "PySide2.QtQuickWidgets.QQuickWidget.source": (),
    "PySide2.QtQuickWidgets.QQuickWidget.status": (),
    "PySide2.QtQuickWidgets.QQuickWidget.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtQuickWidgets.QQuickWidget.wheelEvent": ('PySide2.QtGui.QWheelEvent',),
    }) if "PySide2.QtQuickWidgets" in sys.modules else None

# Module PySide2.QtRemoteObjects
sig_dict.update({

# class PySide2.QtRemoteObjects.QAbstractItemModelReplica:
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.availableRoles": (),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.columnCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.data": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.flags": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.hasChildren": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.hasData": ('PySide2.QtCore.QModelIndex', 'int'),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.headerData": ('int', 'PySide2.QtCore.Qt.Orientation', 'int'),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.index": ('int', 'int', 'PySide2.QtCore.QModelIndex'),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.isInitialized": (),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.parent": [(), ('PySide2.QtCore.QModelIndex',)],
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.roleNames": (),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.rowCount": ('PySide2.QtCore.QModelIndex',),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.selectionModel": (),
    "PySide2.QtRemoteObjects.QAbstractItemModelReplica.setData": ('PySide2.QtCore.QModelIndex', 'typing.Any', 'int'),

# class PySide2.QtRemoteObjects.QRemoteObjectAbstractPersistedStore:
    "PySide2.QtRemoteObjects.QRemoteObjectAbstractPersistedStore.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtRemoteObjects.QRemoteObjectAbstractPersistedStore.restoreProperties": ('str', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtRemoteObjects.QRemoteObjectAbstractPersistedStore.saveProperties": ('str', 'PySide2.QtCore.QByteArray', 'typing.Sequence[typing.Any]'),

# class PySide2.QtRemoteObjects.QRemoteObjectDynamicReplica:

# class PySide2.QtRemoteObjects.QRemoteObjectHost:
    "PySide2.QtRemoteObjects.QRemoteObjectHost.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QUrl', 'PySide2.QtRemoteObjects.QRemoteObjectHostBase.AllowedSchemas', 'PySide2.QtCore.QObject')],
    "PySide2.QtRemoteObjects.QRemoteObjectHost.hostUrl": (),
    "PySide2.QtRemoteObjects.QRemoteObjectHost.setHostUrl": ('PySide2.QtCore.QUrl', 'PySide2.QtRemoteObjects.QRemoteObjectHostBase.AllowedSchemas'),

# class PySide2.QtRemoteObjects.QRemoteObjectHostBase:

# class PySide2.QtRemoteObjects.QRemoteObjectHostBase.AllowedSchemas:
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.addHostSideConnection": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.disableRemoting": ('PySide2.QtCore.QObject',),
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.enableRemoting": [('PySide2.QtCore.QAbstractItemModel', 'str', 'typing.List[int]', 'PySide2.QtCore.QItemSelectionModel'), ('PySide2.QtCore.QObject', 'str')],
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.hostUrl": (),
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.proxy": ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QUrl'),
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.reverseProxy": (),
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.setHostUrl": ('PySide2.QtCore.QUrl', 'PySide2.QtRemoteObjects.QRemoteObjectHostBase.AllowedSchemas'),
    "PySide2.QtRemoteObjects.QRemoteObjectHostBase.setName": ('str',),

# class PySide2.QtRemoteObjects.QRemoteObjectNode:

# class PySide2.QtRemoteObjects.QRemoteObjectNode.ErrorCode:
    "PySide2.QtRemoteObjects.QRemoteObjectNode.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QObject')],
    "PySide2.QtRemoteObjects.QRemoteObjectNode.acquireDynamic": ('str',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.acquireModel": ('str',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.addClientSideConnection": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.connectToNode": ('PySide2.QtCore.QUrl',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.heartbeatInterval": (),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.instances": ('str',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.lastError": (),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.persistedStore": (),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.registry": (),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.registryUrl": (),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.setHeartbeatInterval": ('int',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.setName": ('str',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.setPersistedStore": ('PySide2.QtRemoteObjects.QRemoteObjectAbstractPersistedStore',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.setRegistryUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.timerEvent": ('PySide2.QtCore.QTimerEvent',),
    "PySide2.QtRemoteObjects.QRemoteObjectNode.waitForRegistry": ('int',),

# class PySide2.QtRemoteObjects.QRemoteObjectPendingCall:

# class PySide2.QtRemoteObjects.QRemoteObjectPendingCall.Error:
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCall.__init__": [(), ('PySide2.QtRemoteObjects.QRemoteObjectPendingCall',)],
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCall.error": (),
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCall.fromCompletedCall": ('typing.Any',),
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCall.isFinished": (),
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCall.returnValue": (),
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCall.waitForFinished": ('int',),

# class PySide2.QtRemoteObjects.QRemoteObjectPendingCallWatcher:
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCallWatcher.__init__": ('PySide2.QtRemoteObjects.QRemoteObjectPendingCall', 'PySide2.QtCore.QObject'),
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCallWatcher.isFinished": (),
    "PySide2.QtRemoteObjects.QRemoteObjectPendingCallWatcher.waitForFinished": [(), ('int',)],

# class PySide2.QtRemoteObjects.QRemoteObjectRegistry:
    "PySide2.QtRemoteObjects.QRemoteObjectRegistry.initialize": (),
    "PySide2.QtRemoteObjects.QRemoteObjectRegistry.pushToRegistryIfNeeded": (),
    "PySide2.QtRemoteObjects.QRemoteObjectRegistry.registerMetatypes": (),

# class PySide2.QtRemoteObjects.QRemoteObjectRegistryHost:
    "PySide2.QtRemoteObjects.QRemoteObjectRegistryHost.__init__": ('PySide2.QtCore.QUrl', 'PySide2.QtCore.QObject'),
    "PySide2.QtRemoteObjects.QRemoteObjectRegistryHost.setRegistryUrl": ('PySide2.QtCore.QUrl',),

# class PySide2.QtRemoteObjects.QRemoteObjectReplica:

# class PySide2.QtRemoteObjects.QRemoteObjectReplica.State:
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.__init__": (),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.initialize": (),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.initializeNode": ('PySide2.QtRemoteObjects.QRemoteObjectNode', 'str'),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.isInitialized": (),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.isReplicaValid": (),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.node": (),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.persistProperties": ('str', 'PySide2.QtCore.QByteArray', 'typing.Sequence[typing.Any]'),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.propAsVariant": ('int',),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.retrieveProperties": ('str', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.send": ('PySide2.QtCore.QMetaObject.Call', 'int', 'typing.Sequence[typing.Any]'),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.sendWithReply": ('PySide2.QtCore.QMetaObject.Call', 'int', 'typing.Sequence[typing.Any]'),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.setChild": ('int', 'typing.Any'),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.setNode": ('PySide2.QtRemoteObjects.QRemoteObjectNode',),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.setProperties": ('typing.Sequence[typing.Any]',),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.state": (),
    "PySide2.QtRemoteObjects.QRemoteObjectReplica.waitForSource": ('int',),

# class PySide2.QtRemoteObjects.QRemoteObjectSettingsStore:
    "PySide2.QtRemoteObjects.QRemoteObjectSettingsStore.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtRemoteObjects.QRemoteObjectSettingsStore.restoreProperties": ('str', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtRemoteObjects.QRemoteObjectSettingsStore.saveProperties": ('str', 'PySide2.QtCore.QByteArray', 'typing.Sequence[typing.Any]'),
    }) if "PySide2.QtRemoteObjects" in sys.modules else None

# Module PySide2.QtScxml
sig_dict.update({

# class PySide2.QtScxml.QScxmlCompiler:

# class PySide2.QtScxml.QScxmlCompiler.Loader:
    "PySide2.QtScxml.QScxmlCompiler.Loader.__init__": (),
    "PySide2.QtScxml.QScxmlCompiler.Loader.load": ('str', 'str'),

    "PySide2.QtScxml.QScxmlCompiler.__init__": ('PySide2.QtCore.QXmlStreamReader',),
    "PySide2.QtScxml.QScxmlCompiler.compile": (),
    "PySide2.QtScxml.QScxmlCompiler.errors": (),
    "PySide2.QtScxml.QScxmlCompiler.fileName": (),
    "PySide2.QtScxml.QScxmlCompiler.loader": (),
    "PySide2.QtScxml.QScxmlCompiler.setFileName": ('str',),
    "PySide2.QtScxml.QScxmlCompiler.setLoader": ('PySide2.QtScxml.QScxmlCompiler.Loader',),

# class PySide2.QtScxml.QScxmlCppDataModel:
    "PySide2.QtScxml.QScxmlCppDataModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtScxml.QScxmlCppDataModel.evaluateAssignment": ('int',),
    "PySide2.QtScxml.QScxmlCppDataModel.evaluateForeach": ('int', 'PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody'),
    "PySide2.QtScxml.QScxmlCppDataModel.evaluateInitialization": ('int',),
    "PySide2.QtScxml.QScxmlCppDataModel.hasScxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlCppDataModel.inState": ('str',),
    "PySide2.QtScxml.QScxmlCppDataModel.scxmlEvent": (),
    "PySide2.QtScxml.QScxmlCppDataModel.scxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlCppDataModel.setScxmlEvent": ('PySide2.QtScxml.QScxmlEvent',),
    "PySide2.QtScxml.QScxmlCppDataModel.setScxmlProperty": ('str', 'typing.Any', 'str'),
    "PySide2.QtScxml.QScxmlCppDataModel.setup": ('typing.Dict[str, typing.Any]',),

# class PySide2.QtScxml.QScxmlDataModel:

# class PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody:
    "PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody.__init__": (),
    "PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody.run": (),

    "PySide2.QtScxml.QScxmlDataModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtScxml.QScxmlDataModel.evaluateAssignment": ('int',),
    "PySide2.QtScxml.QScxmlDataModel.evaluateForeach": ('int', 'PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody'),
    "PySide2.QtScxml.QScxmlDataModel.evaluateInitialization": ('int',),
    "PySide2.QtScxml.QScxmlDataModel.evaluateToBool": ('int',),
    "PySide2.QtScxml.QScxmlDataModel.evaluateToString": ('int',),
    "PySide2.QtScxml.QScxmlDataModel.evaluateToVariant": ('int',),
    "PySide2.QtScxml.QScxmlDataModel.evaluateToVoid": ('int',),
    "PySide2.QtScxml.QScxmlDataModel.hasScxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlDataModel.scxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlDataModel.setScxmlEvent": ('PySide2.QtScxml.QScxmlEvent',),
    "PySide2.QtScxml.QScxmlDataModel.setScxmlProperty": ('str', 'typing.Any', 'str'),
    "PySide2.QtScxml.QScxmlDataModel.setStateMachine": ('PySide2.QtScxml.QScxmlStateMachine',),
    "PySide2.QtScxml.QScxmlDataModel.setup": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtScxml.QScxmlDataModel.stateMachine": (),

# class PySide2.QtScxml.QScxmlDynamicScxmlServiceFactory:
    "PySide2.QtScxml.QScxmlDynamicScxmlServiceFactory.__init__": ('PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo', 'typing.List[int]', 'typing.List[PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo]', 'PySide2.QtCore.QObject'),
    "PySide2.QtScxml.QScxmlDynamicScxmlServiceFactory.invoke": ('PySide2.QtScxml.QScxmlStateMachine',),

# class PySide2.QtScxml.QScxmlEcmaScriptDataModel:
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateAssignment": ('int',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateForeach": ('int', 'PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody'),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateInitialization": ('int',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateToBool": ('int',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateToString": ('int',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateToVariant": ('int',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.evaluateToVoid": ('int',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.hasScxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.scxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.setScxmlEvent": ('PySide2.QtScxml.QScxmlEvent',),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.setScxmlProperty": ('str', 'typing.Any', 'str'),
    "PySide2.QtScxml.QScxmlEcmaScriptDataModel.setup": ('typing.Dict[str, typing.Any]',),

# class PySide2.QtScxml.QScxmlError:
    "PySide2.QtScxml.QScxmlError.__init__": [(), ('PySide2.QtScxml.QScxmlError',), ('str', 'int', 'int', 'str')],
    "PySide2.QtScxml.QScxmlError.__copy__": (),
    "PySide2.QtScxml.QScxmlError.column": (),
    "PySide2.QtScxml.QScxmlError.description": (),
    "PySide2.QtScxml.QScxmlError.fileName": (),
    "PySide2.QtScxml.QScxmlError.isValid": (),
    "PySide2.QtScxml.QScxmlError.line": (),
    "PySide2.QtScxml.QScxmlError.toString": (),

# class PySide2.QtScxml.QScxmlEvent:

# class PySide2.QtScxml.QScxmlEvent.EventType:
    "PySide2.QtScxml.QScxmlEvent.__init__": [(), ('PySide2.QtScxml.QScxmlEvent',)],
    "PySide2.QtScxml.QScxmlEvent.clear": (),
    "PySide2.QtScxml.QScxmlEvent.data": (),
    "PySide2.QtScxml.QScxmlEvent.delay": (),
    "PySide2.QtScxml.QScxmlEvent.errorMessage": (),
    "PySide2.QtScxml.QScxmlEvent.eventType": (),
    "PySide2.QtScxml.QScxmlEvent.invokeId": (),
    "PySide2.QtScxml.QScxmlEvent.isErrorEvent": (),
    "PySide2.QtScxml.QScxmlEvent.name": (),
    "PySide2.QtScxml.QScxmlEvent.origin": (),
    "PySide2.QtScxml.QScxmlEvent.originType": (),
    "PySide2.QtScxml.QScxmlEvent.scxmlType": (),
    "PySide2.QtScxml.QScxmlEvent.sendId": (),
    "PySide2.QtScxml.QScxmlEvent.setData": ('typing.Any',),
    "PySide2.QtScxml.QScxmlEvent.setDelay": ('int',),
    "PySide2.QtScxml.QScxmlEvent.setErrorMessage": ('str',),
    "PySide2.QtScxml.QScxmlEvent.setEventType": ('PySide2.QtScxml.QScxmlEvent.EventType',),
    "PySide2.QtScxml.QScxmlEvent.setInvokeId": ('str',),
    "PySide2.QtScxml.QScxmlEvent.setName": ('str',),
    "PySide2.QtScxml.QScxmlEvent.setOrigin": ('str',),
    "PySide2.QtScxml.QScxmlEvent.setOriginType": ('str',),
    "PySide2.QtScxml.QScxmlEvent.setSendId": ('str',),

# class PySide2.QtScxml.QScxmlExecutableContent:

# class PySide2.QtScxml.QScxmlExecutableContent.AssignmentInfo:
    "PySide2.QtScxml.QScxmlExecutableContent.AssignmentInfo.__init__": [(), ('PySide2.QtScxml.QScxmlExecutableContent.AssignmentInfo',)],
    "PySide2.QtScxml.QScxmlExecutableContent.AssignmentInfo.__copy__": (),

# class PySide2.QtScxml.QScxmlExecutableContent.EvaluatorInfo:
    "PySide2.QtScxml.QScxmlExecutableContent.EvaluatorInfo.__init__": [(), ('PySide2.QtScxml.QScxmlExecutableContent.EvaluatorInfo',)],
    "PySide2.QtScxml.QScxmlExecutableContent.EvaluatorInfo.__copy__": (),

# class PySide2.QtScxml.QScxmlExecutableContent.ForeachInfo:
    "PySide2.QtScxml.QScxmlExecutableContent.ForeachInfo.__init__": [(), ('PySide2.QtScxml.QScxmlExecutableContent.ForeachInfo',)],
    "PySide2.QtScxml.QScxmlExecutableContent.ForeachInfo.__copy__": (),

# class PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo:
    "PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo.__init__": [(), ('PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo',)],
    "PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo.__copy__": (),

# class PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo:
    "PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo.__init__": [(), ('PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo',)],
    "PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo.__copy__": (),

# class PySide2.QtScxml.QScxmlInvokableService:

    "PySide2.QtScxml.QScxmlInvokableService.__init__": ('PySide2.QtScxml.QScxmlStateMachine', 'PySide2.QtScxml.QScxmlInvokableServiceFactory'),
    "PySide2.QtScxml.QScxmlInvokableService.id": (),
    "PySide2.QtScxml.QScxmlInvokableService.name": (),
    "PySide2.QtScxml.QScxmlInvokableService.parentStateMachine": (),
    "PySide2.QtScxml.QScxmlInvokableService.postEvent": ('PySide2.QtScxml.QScxmlEvent',),
    "PySide2.QtScxml.QScxmlInvokableService.start": (),

# class PySide2.QtScxml.QScxmlInvokableServiceFactory:
    "PySide2.QtScxml.QScxmlInvokableServiceFactory.__init__": ('PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo', 'typing.List[int]', 'typing.List[PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo]', 'PySide2.QtCore.QObject'),
    "PySide2.QtScxml.QScxmlInvokableServiceFactory.invoke": ('PySide2.QtScxml.QScxmlStateMachine',),
    "PySide2.QtScxml.QScxmlInvokableServiceFactory.invokeInfo": (),
    "PySide2.QtScxml.QScxmlInvokableServiceFactory.names": (),
    "PySide2.QtScxml.QScxmlInvokableServiceFactory.parameters": (),

# class PySide2.QtScxml.QScxmlNullDataModel:
    "PySide2.QtScxml.QScxmlNullDataModel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateAssignment": ('int',),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateForeach": ('int', 'PySide2.QtScxml.QScxmlDataModel.ForeachLoopBody'),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateInitialization": ('int',),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateToBool": ('int',),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateToString": ('int',),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateToVariant": ('int',),
    "PySide2.QtScxml.QScxmlNullDataModel.evaluateToVoid": ('int',),
    "PySide2.QtScxml.QScxmlNullDataModel.hasScxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlNullDataModel.scxmlProperty": ('str',),
    "PySide2.QtScxml.QScxmlNullDataModel.setScxmlEvent": ('PySide2.QtScxml.QScxmlEvent',),
    "PySide2.QtScxml.QScxmlNullDataModel.setScxmlProperty": ('str', 'typing.Any', 'str'),
    "PySide2.QtScxml.QScxmlNullDataModel.setup": ('typing.Dict[str, typing.Any]',),

# class PySide2.QtScxml.QScxmlStateMachine:
    "PySide2.QtScxml.QScxmlStateMachine.__init__": ('PySide2.QtCore.QMetaObject', 'PySide2.QtCore.QObject'),
    "PySide2.QtScxml.QScxmlStateMachine.activeStateNames": ('bool',),
    "PySide2.QtScxml.QScxmlStateMachine.cancelDelayedEvent": ('str',),
    "PySide2.QtScxml.QScxmlStateMachine.connectToEvent": ('str', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.Qt.ConnectionType'),
    "PySide2.QtScxml.QScxmlStateMachine.connectToState": ('str', 'PySide2.QtCore.QObject', 'str', 'PySide2.QtCore.Qt.ConnectionType'),
    "PySide2.QtScxml.QScxmlStateMachine.dataModel": (),
    "PySide2.QtScxml.QScxmlStateMachine.fromData": ('PySide2.QtCore.QIODevice', 'str'),
    "PySide2.QtScxml.QScxmlStateMachine.fromFile": ('str',),
    "PySide2.QtScxml.QScxmlStateMachine.init": (),
    "PySide2.QtScxml.QScxmlStateMachine.initialValues": (),
    "PySide2.QtScxml.QScxmlStateMachine.invokedServices": (),
    "PySide2.QtScxml.QScxmlStateMachine.isActive": [('int',), ('str',)],
    "PySide2.QtScxml.QScxmlStateMachine.isDispatchableTarget": ('str',),
    "PySide2.QtScxml.QScxmlStateMachine.isInitialized": (),
    "PySide2.QtScxml.QScxmlStateMachine.isInvoked": (),
    "PySide2.QtScxml.QScxmlStateMachine.isRunning": (),
    "PySide2.QtScxml.QScxmlStateMachine.loader": (),
    "PySide2.QtScxml.QScxmlStateMachine.name": (),
    "PySide2.QtScxml.QScxmlStateMachine.parseErrors": (),
    "PySide2.QtScxml.QScxmlStateMachine.sessionId": (),
    "PySide2.QtScxml.QScxmlStateMachine.setDataModel": ('PySide2.QtScxml.QScxmlDataModel',),
    "PySide2.QtScxml.QScxmlStateMachine.setInitialValues": ('typing.Dict[str, typing.Any]',),
    "PySide2.QtScxml.QScxmlStateMachine.setLoader": ('PySide2.QtScxml.QScxmlCompiler.Loader',),
    "PySide2.QtScxml.QScxmlStateMachine.setRunning": ('bool',),
    "PySide2.QtScxml.QScxmlStateMachine.setTableData": ('PySide2.QtScxml.QScxmlTableData',),
    "PySide2.QtScxml.QScxmlStateMachine.start": (),
    "PySide2.QtScxml.QScxmlStateMachine.stateNames": ('bool',),
    "PySide2.QtScxml.QScxmlStateMachine.stop": (),
    "PySide2.QtScxml.QScxmlStateMachine.submitEvent": [('PySide2.QtScxml.QScxmlEvent',), ('str',), ('str', 'typing.Any')],
    "PySide2.QtScxml.QScxmlStateMachine.tableData": (),

# class PySide2.QtScxml.QScxmlStaticScxmlServiceFactory:
    "PySide2.QtScxml.QScxmlStaticScxmlServiceFactory.__init__": ('PySide2.QtCore.QMetaObject', 'PySide2.QtScxml.QScxmlExecutableContent.InvokeInfo', 'typing.List[int]', 'typing.List[PySide2.QtScxml.QScxmlExecutableContent.ParameterInfo]', 'PySide2.QtCore.QObject'),
    "PySide2.QtScxml.QScxmlStaticScxmlServiceFactory.invoke": ('PySide2.QtScxml.QScxmlStateMachine',),

# class PySide2.QtScxml.QScxmlTableData:
    "PySide2.QtScxml.QScxmlTableData.__init__": (),
    "PySide2.QtScxml.QScxmlTableData.assignmentInfo": ('int',),
    "PySide2.QtScxml.QScxmlTableData.dataNames": (),
    "PySide2.QtScxml.QScxmlTableData.evaluatorInfo": ('int',),
    "PySide2.QtScxml.QScxmlTableData.foreachInfo": ('int',),
    "PySide2.QtScxml.QScxmlTableData.initialSetup": (),
    "PySide2.QtScxml.QScxmlTableData.instructions": (),
    "PySide2.QtScxml.QScxmlTableData.name": (),
    "PySide2.QtScxml.QScxmlTableData.serviceFactory": ('int',),
    "PySide2.QtScxml.QScxmlTableData.stateMachineTable": (),
    "PySide2.QtScxml.QScxmlTableData.string": ('int',),
    }) if "PySide2.QtScxml" in sys.modules else None

# Module PySide2.QtScript
sig_dict.update({

# class PySide2.QtScript.QScriptClass:

# class PySide2.QtScript.QScriptClass.Extension:

# class PySide2.QtScript.QScriptClass.QueryFlag:
    "PySide2.QtScript.QScriptClass.__init__": ('PySide2.QtScript.QScriptEngine',),
    "PySide2.QtScript.QScriptClass.engine": (),
    "PySide2.QtScript.QScriptClass.extension": ('PySide2.QtScript.QScriptClass.Extension', 'typing.Any'),
    "PySide2.QtScript.QScriptClass.name": (),
    "PySide2.QtScript.QScriptClass.newIterator": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptClass.property": ('PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptString', 'int'),
    "PySide2.QtScript.QScriptClass.propertyFlags": ('PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptString', 'int'),
    "PySide2.QtScript.QScriptClass.prototype": (),
    "PySide2.QtScript.QScriptClass.setProperty": ('PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptString', 'int', 'PySide2.QtScript.QScriptValue'),
    "PySide2.QtScript.QScriptClass.supportsExtension": ('PySide2.QtScript.QScriptClass.Extension',),

# class PySide2.QtScript.QScriptClassPropertyIterator:
    "PySide2.QtScript.QScriptClassPropertyIterator.__init__": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptClassPropertyIterator.flags": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.hasNext": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.hasPrevious": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.id": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.name": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.object": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.previous": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.toBack": (),
    "PySide2.QtScript.QScriptClassPropertyIterator.toFront": (),

# class PySide2.QtScript.QScriptContext:

# class PySide2.QtScript.QScriptContext.Error:

# class PySide2.QtScript.QScriptContext.ExecutionState:
    "PySide2.QtScript.QScriptContext.activationObject": (),
    "PySide2.QtScript.QScriptContext.argument": ('int',),
    "PySide2.QtScript.QScriptContext.argumentCount": (),
    "PySide2.QtScript.QScriptContext.argumentsObject": (),
    "PySide2.QtScript.QScriptContext.backtrace": (),
    "PySide2.QtScript.QScriptContext.callee": (),
    "PySide2.QtScript.QScriptContext.engine": (),
    "PySide2.QtScript.QScriptContext.isCalledAsConstructor": (),
    "PySide2.QtScript.QScriptContext.parentContext": (),
    "PySide2.QtScript.QScriptContext.popScope": (),
    "PySide2.QtScript.QScriptContext.pushScope": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptContext.returnValue": (),
    "PySide2.QtScript.QScriptContext.scopeChain": (),
    "PySide2.QtScript.QScriptContext.setActivationObject": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptContext.setReturnValue": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptContext.setThisObject": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptContext.state": (),
    "PySide2.QtScript.QScriptContext.thisObject": (),
    "PySide2.QtScript.QScriptContext.throwError": [('PySide2.QtScript.QScriptContext.Error', 'str'), ('str',)],
    "PySide2.QtScript.QScriptContext.throwValue": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptContext.toString": (),

# class PySide2.QtScript.QScriptContextInfo:

# class PySide2.QtScript.QScriptContextInfo.FunctionType:
    "PySide2.QtScript.QScriptContextInfo.__init__": [(), ('PySide2.QtScript.QScriptContext',), ('PySide2.QtScript.QScriptContextInfo',)],
    "PySide2.QtScript.QScriptContextInfo.__copy__": (),
    "PySide2.QtScript.QScriptContextInfo.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtScript.QScriptContextInfo.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtScript.QScriptContextInfo.columnNumber": (),
    "PySide2.QtScript.QScriptContextInfo.fileName": (),
    "PySide2.QtScript.QScriptContextInfo.functionEndLineNumber": (),
    "PySide2.QtScript.QScriptContextInfo.functionMetaIndex": (),
    "PySide2.QtScript.QScriptContextInfo.functionName": (),
    "PySide2.QtScript.QScriptContextInfo.functionParameterNames": (),
    "PySide2.QtScript.QScriptContextInfo.functionStartLineNumber": (),
    "PySide2.QtScript.QScriptContextInfo.functionType": (),
    "PySide2.QtScript.QScriptContextInfo.isNull": (),
    "PySide2.QtScript.QScriptContextInfo.lineNumber": (),
    "PySide2.QtScript.QScriptContextInfo.scriptId": (),

# class PySide2.QtScript.QScriptEngine:

# class PySide2.QtScript.QScriptEngine.QObjectWrapOption:

# class PySide2.QtScript.QScriptEngine.QObjectWrapOptions:

# class PySide2.QtScript.QScriptEngine.ValueOwnership:
    "PySide2.QtScript.QScriptEngine.__init__": [(), ('PySide2.QtCore.QObject',)],
    "PySide2.QtScript.QScriptEngine.abortEvaluation": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptEngine.agent": (),
    "PySide2.QtScript.QScriptEngine.availableExtensions": (),
    "PySide2.QtScript.QScriptEngine.canEvaluate": ('str',),
    "PySide2.QtScript.QScriptEngine.clearExceptions": (),
    "PySide2.QtScript.QScriptEngine.collectGarbage": (),
    "PySide2.QtScript.QScriptEngine.currentContext": (),
    "PySide2.QtScript.QScriptEngine.defaultPrototype": ('int',),
    "PySide2.QtScript.QScriptEngine.evaluate": [('PySide2.QtScript.QScriptProgram',), ('str', 'str', 'int')],
    "PySide2.QtScript.QScriptEngine.globalObject": (),
    "PySide2.QtScript.QScriptEngine.hasUncaughtException": (),
    "PySide2.QtScript.QScriptEngine.importExtension": ('str',),
    "PySide2.QtScript.QScriptEngine.importedExtensions": (),
    "PySide2.QtScript.QScriptEngine.installTranslatorFunctions": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptEngine.isEvaluating": (),
    "PySide2.QtScript.QScriptEngine.newActivationObject": (),
    "PySide2.QtScript.QScriptEngine.newArray": ('int',),
    "PySide2.QtScript.QScriptEngine.newDate": [('PySide2.QtCore.QDateTime',), ('float',)],
    "PySide2.QtScript.QScriptEngine.newObject": [(), ('PySide2.QtScript.QScriptClass', 'PySide2.QtScript.QScriptValue')],
    "PySide2.QtScript.QScriptEngine.newQMetaObject": ('PySide2.QtCore.QMetaObject', 'PySide2.QtScript.QScriptValue'),
    "PySide2.QtScript.QScriptEngine.newQObject": [('PySide2.QtCore.QObject', 'PySide2.QtScript.QScriptEngine.ValueOwnership', 'PySide2.QtScript.QScriptEngine.QObjectWrapOptions'), ('PySide2.QtScript.QScriptValue', 'PySide2.QtCore.QObject', 'PySide2.QtScript.QScriptEngine.ValueOwnership', 'PySide2.QtScript.QScriptEngine.QObjectWrapOptions')],
    "PySide2.QtScript.QScriptEngine.newRegExp": [('PySide2.QtCore.QRegExp',), ('str', 'str')],
    "PySide2.QtScript.QScriptEngine.newVariant": [('PySide2.QtScript.QScriptValue', 'typing.Any'), ('typing.Any',)],
    "PySide2.QtScript.QScriptEngine.nullValue": (),
    "PySide2.QtScript.QScriptEngine.objectById": ('int',),
    "PySide2.QtScript.QScriptEngine.popContext": (),
    "PySide2.QtScript.QScriptEngine.processEventsInterval": (),
    "PySide2.QtScript.QScriptEngine.pushContext": (),
    "PySide2.QtScript.QScriptEngine.reportAdditionalMemoryCost": ('int',),
    "PySide2.QtScript.QScriptEngine.setAgent": ('PySide2.QtScript.QScriptEngineAgent',),
    "PySide2.QtScript.QScriptEngine.setDefaultPrototype": ('int', 'PySide2.QtScript.QScriptValue'),
    "PySide2.QtScript.QScriptEngine.setGlobalObject": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptEngine.setProcessEventsInterval": ('int',),
    "PySide2.QtScript.QScriptEngine.toObject": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptEngine.toStringHandle": ('str',),
    "PySide2.QtScript.QScriptEngine.uncaughtException": (),
    "PySide2.QtScript.QScriptEngine.uncaughtExceptionBacktrace": (),
    "PySide2.QtScript.QScriptEngine.uncaughtExceptionLineNumber": (),
    "PySide2.QtScript.QScriptEngine.undefinedValue": (),

# class PySide2.QtScript.QScriptEngineAgent:

# class PySide2.QtScript.QScriptEngineAgent.Extension:
    "PySide2.QtScript.QScriptEngineAgent.__init__": ('PySide2.QtScript.QScriptEngine',),
    "PySide2.QtScript.QScriptEngineAgent.contextPop": (),
    "PySide2.QtScript.QScriptEngineAgent.contextPush": (),
    "PySide2.QtScript.QScriptEngineAgent.engine": (),
    "PySide2.QtScript.QScriptEngineAgent.exceptionCatch": ('int', 'PySide2.QtScript.QScriptValue'),
    "PySide2.QtScript.QScriptEngineAgent.exceptionThrow": ('int', 'PySide2.QtScript.QScriptValue', 'bool'),
    "PySide2.QtScript.QScriptEngineAgent.extension": ('PySide2.QtScript.QScriptEngineAgent.Extension', 'typing.Any'),
    "PySide2.QtScript.QScriptEngineAgent.functionEntry": ('int',),
    "PySide2.QtScript.QScriptEngineAgent.functionExit": ('int', 'PySide2.QtScript.QScriptValue'),
    "PySide2.QtScript.QScriptEngineAgent.positionChange": ('int', 'int', 'int'),
    "PySide2.QtScript.QScriptEngineAgent.scriptLoad": ('int', 'str', 'str', 'int'),
    "PySide2.QtScript.QScriptEngineAgent.scriptUnload": ('int',),
    "PySide2.QtScript.QScriptEngineAgent.supportsExtension": ('PySide2.QtScript.QScriptEngineAgent.Extension',),

# class PySide2.QtScript.QScriptExtensionInterface:
    "PySide2.QtScript.QScriptExtensionInterface.__init__": (),
    "PySide2.QtScript.QScriptExtensionInterface.initialize": ('str', 'PySide2.QtScript.QScriptEngine'),

# class PySide2.QtScript.QScriptExtensionPlugin:
    "PySide2.QtScript.QScriptExtensionPlugin.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtScript.QScriptExtensionPlugin.initialize": ('str', 'PySide2.QtScript.QScriptEngine'),
    "PySide2.QtScript.QScriptExtensionPlugin.keys": (),
    "PySide2.QtScript.QScriptExtensionPlugin.setupPackage": ('str', 'PySide2.QtScript.QScriptEngine'),

# class PySide2.QtScript.QScriptProgram:
    "PySide2.QtScript.QScriptProgram.__init__": [(), ('PySide2.QtScript.QScriptProgram',), ('str', 'str', 'int')],
    "PySide2.QtScript.QScriptProgram.__copy__": (),
    "PySide2.QtScript.QScriptProgram.fileName": (),
    "PySide2.QtScript.QScriptProgram.firstLineNumber": (),
    "PySide2.QtScript.QScriptProgram.isNull": (),
    "PySide2.QtScript.QScriptProgram.sourceCode": (),

# class PySide2.QtScript.QScriptString:
    "PySide2.QtScript.QScriptString.__init__": [(), ('PySide2.QtScript.QScriptString',)],
    "PySide2.QtScript.QScriptString.__copy__": (),
    "PySide2.QtScript.QScriptString.isValid": (),
    "PySide2.QtScript.QScriptString.toArrayIndex": (),
    "PySide2.QtScript.QScriptString.toString": (),

# class PySide2.QtScript.QScriptValue:

# class PySide2.QtScript.QScriptValue.PropertyFlag:

# class PySide2.QtScript.QScriptValue.PropertyFlags:

# class PySide2.QtScript.QScriptValue.ResolveFlag:

# class PySide2.QtScript.QScriptValue.ResolveFlags:

# class PySide2.QtScript.QScriptValue.SpecialValue:
    "PySide2.QtScript.QScriptValue.__init__": [(), ('PySide2.QtScript.QScriptEngine', 'PySide2.QtScript.QScriptValue.SpecialValue'), ('PySide2.QtScript.QScriptEngine', 'bool'), ('PySide2.QtScript.QScriptEngine', 'float'), ('PySide2.QtScript.QScriptEngine', 'int'), ('PySide2.QtScript.QScriptEngine', 'str'), ('PySide2.QtScript.QScriptValue',), ('PySide2.QtScript.QScriptValue.SpecialValue',), ('bool',), ('float',), ('int',), ('str',)],
    "PySide2.QtScript.QScriptValue.__copy__": (),
    "PySide2.QtScript.QScriptValue.__iter__": (),
    "PySide2.QtScript.QScriptValue.__repr__": (),
    "PySide2.QtScript.QScriptValue.call": [('PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptValue'), ('PySide2.QtScript.QScriptValue', 'typing.Sequence[PySide2.QtScript.QScriptValue]')],
    "PySide2.QtScript.QScriptValue.construct": [('PySide2.QtScript.QScriptValue',), ('typing.Sequence[PySide2.QtScript.QScriptValue]',)],
    "PySide2.QtScript.QScriptValue.data": (),
    "PySide2.QtScript.QScriptValue.engine": (),
    "PySide2.QtScript.QScriptValue.equals": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.instanceOf": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.isArray": (),
    "PySide2.QtScript.QScriptValue.isBool": (),
    "PySide2.QtScript.QScriptValue.isBoolean": (),
    "PySide2.QtScript.QScriptValue.isDate": (),
    "PySide2.QtScript.QScriptValue.isError": (),
    "PySide2.QtScript.QScriptValue.isFunction": (),
    "PySide2.QtScript.QScriptValue.isNull": (),
    "PySide2.QtScript.QScriptValue.isNumber": (),
    "PySide2.QtScript.QScriptValue.isObject": (),
    "PySide2.QtScript.QScriptValue.isQMetaObject": (),
    "PySide2.QtScript.QScriptValue.isQObject": (),
    "PySide2.QtScript.QScriptValue.isRegExp": (),
    "PySide2.QtScript.QScriptValue.isString": (),
    "PySide2.QtScript.QScriptValue.isUndefined": (),
    "PySide2.QtScript.QScriptValue.isValid": (),
    "PySide2.QtScript.QScriptValue.isVariant": (),
    "PySide2.QtScript.QScriptValue.lessThan": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.objectId": (),
    "PySide2.QtScript.QScriptValue.property": [('PySide2.QtScript.QScriptString', 'PySide2.QtScript.QScriptValue.ResolveFlags'), ('int', 'PySide2.QtScript.QScriptValue.ResolveFlags'), ('str', 'PySide2.QtScript.QScriptValue.ResolveFlags')],
    "PySide2.QtScript.QScriptValue.propertyFlags": [('PySide2.QtScript.QScriptString', 'PySide2.QtScript.QScriptValue.ResolveFlags'), ('str', 'PySide2.QtScript.QScriptValue.ResolveFlags')],
    "PySide2.QtScript.QScriptValue.prototype": (),
    "PySide2.QtScript.QScriptValue.scope": (),
    "PySide2.QtScript.QScriptValue.scriptClass": (),
    "PySide2.QtScript.QScriptValue.setData": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.setProperty": [('PySide2.QtScript.QScriptString', 'PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptValue.PropertyFlags'), ('int', 'PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptValue.PropertyFlags'), ('str', 'PySide2.QtScript.QScriptValue', 'PySide2.QtScript.QScriptValue.PropertyFlags')],
    "PySide2.QtScript.QScriptValue.setPrototype": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.setScope": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.setScriptClass": ('PySide2.QtScript.QScriptClass',),
    "PySide2.QtScript.QScriptValue.strictlyEquals": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValue.toBool": (),
    "PySide2.QtScript.QScriptValue.toBoolean": (),
    "PySide2.QtScript.QScriptValue.toDateTime": (),
    "PySide2.QtScript.QScriptValue.toInt32": (),
    "PySide2.QtScript.QScriptValue.toInteger": (),
    "PySide2.QtScript.QScriptValue.toNumber": (),
    "PySide2.QtScript.QScriptValue.toObject": (),
    "PySide2.QtScript.QScriptValue.toQMetaObject": (),
    "PySide2.QtScript.QScriptValue.toQObject": (),
    "PySide2.QtScript.QScriptValue.toRegExp": (),
    "PySide2.QtScript.QScriptValue.toString": (),
    "PySide2.QtScript.QScriptValue.toUInt16": (),
    "PySide2.QtScript.QScriptValue.toUInt32": (),
    "PySide2.QtScript.QScriptValue.toVariant": (),

# class PySide2.QtScript.QScriptValueIterator:
    "PySide2.QtScript.QScriptValueIterator.__init__": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValueIterator.__iter__": (),
    "PySide2.QtScript.QScriptValueIterator.flags": (),
    "PySide2.QtScript.QScriptValueIterator.hasNext": (),
    "PySide2.QtScript.QScriptValueIterator.hasPrevious": (),
    "PySide2.QtScript.QScriptValueIterator.name": (),
    "PySide2.QtScript.QScriptValueIterator.previous": (),
    "PySide2.QtScript.QScriptValueIterator.remove": (),
    "PySide2.QtScript.QScriptValueIterator.scriptName": (),
    "PySide2.QtScript.QScriptValueIterator.setValue": ('PySide2.QtScript.QScriptValue',),
    "PySide2.QtScript.QScriptValueIterator.toBack": (),
    "PySide2.QtScript.QScriptValueIterator.toFront": (),
    "PySide2.QtScript.QScriptValueIterator.value": (),

# class PySide2.QtScript.QScriptable:
    "PySide2.QtScript.QScriptable.__init__": (),
    "PySide2.QtScript.QScriptable.argument": ('int',),
    "PySide2.QtScript.QScriptable.argumentCount": (),
    "PySide2.QtScript.QScriptable.context": (),
    "PySide2.QtScript.QScriptable.engine": (),
    "PySide2.QtScript.QScriptable.thisObject": (),
    }) if "PySide2.QtScript" in sys.modules else None

# Module PySide2.QtScriptTools
sig_dict.update({

# class PySide2.QtScriptTools.QScriptEngineDebugger:

# class PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerAction:

# class PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerState:

# class PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerWidget:
    "PySide2.QtScriptTools.QScriptEngineDebugger.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtScriptTools.QScriptEngineDebugger.action": ('PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerAction',),
    "PySide2.QtScriptTools.QScriptEngineDebugger.attachTo": ('PySide2.QtScript.QScriptEngine',),
    "PySide2.QtScriptTools.QScriptEngineDebugger.autoShowStandardWindow": (),
    "PySide2.QtScriptTools.QScriptEngineDebugger.createStandardMenu": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtScriptTools.QScriptEngineDebugger.createStandardToolBar": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtScriptTools.QScriptEngineDebugger.setAutoShowStandardWindow": ('bool',),
    "PySide2.QtScriptTools.QScriptEngineDebugger.standardWindow": (),
    "PySide2.QtScriptTools.QScriptEngineDebugger.state": (),
    "PySide2.QtScriptTools.QScriptEngineDebugger.widget": ('PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerWidget',),
    }) if "PySide2.QtScriptTools" in sys.modules else None

# Module PySide2.QtSensors
sig_dict.update({

# class PySide2.QtSensors.QAccelerometer:

# class PySide2.QtSensors.QAccelerometer.AccelerationMode:
    "PySide2.QtSensors.QAccelerometer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAccelerometer.accelerationMode": (),
    "PySide2.QtSensors.QAccelerometer.reading": (),
    "PySide2.QtSensors.QAccelerometer.setAccelerationMode": ('PySide2.QtSensors.QAccelerometer.AccelerationMode',),

# class PySide2.QtSensors.QAccelerometerFilter:
    "PySide2.QtSensors.QAccelerometerFilter.__init__": (),
    "PySide2.QtSensors.QAccelerometerFilter.filter": [('PySide2.QtSensors.QAccelerometerReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QAccelerometerReading:
    "PySide2.QtSensors.QAccelerometerReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAccelerometerReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QAccelerometerReading.setX": ('float',),
    "PySide2.QtSensors.QAccelerometerReading.setY": ('float',),
    "PySide2.QtSensors.QAccelerometerReading.setZ": ('float',),
    "PySide2.QtSensors.QAccelerometerReading.x": (),
    "PySide2.QtSensors.QAccelerometerReading.y": (),
    "PySide2.QtSensors.QAccelerometerReading.z": (),

# class PySide2.QtSensors.QAltimeter:
    "PySide2.QtSensors.QAltimeter.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAltimeter.reading": (),

# class PySide2.QtSensors.QAltimeterFilter:
    "PySide2.QtSensors.QAltimeterFilter.__init__": (),
    "PySide2.QtSensors.QAltimeterFilter.filter": [('PySide2.QtSensors.QAltimeterReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QAltimeterReading:
    "PySide2.QtSensors.QAltimeterReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAltimeterReading.altitude": (),
    "PySide2.QtSensors.QAltimeterReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QAltimeterReading.setAltitude": ('float',),

# class PySide2.QtSensors.QAmbientLightFilter:
    "PySide2.QtSensors.QAmbientLightFilter.__init__": (),
    "PySide2.QtSensors.QAmbientLightFilter.filter": [('PySide2.QtSensors.QAmbientLightReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QAmbientLightReading:

# class PySide2.QtSensors.QAmbientLightReading.LightLevel:
    "PySide2.QtSensors.QAmbientLightReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAmbientLightReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QAmbientLightReading.lightLevel": (),
    "PySide2.QtSensors.QAmbientLightReading.setLightLevel": ('PySide2.QtSensors.QAmbientLightReading.LightLevel',),

# class PySide2.QtSensors.QAmbientLightSensor:
    "PySide2.QtSensors.QAmbientLightSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAmbientLightSensor.reading": (),

# class PySide2.QtSensors.QAmbientTemperatureFilter:
    "PySide2.QtSensors.QAmbientTemperatureFilter.__init__": (),
    "PySide2.QtSensors.QAmbientTemperatureFilter.filter": [('PySide2.QtSensors.QAmbientTemperatureReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QAmbientTemperatureReading:
    "PySide2.QtSensors.QAmbientTemperatureReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAmbientTemperatureReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QAmbientTemperatureReading.setTemperature": ('float',),
    "PySide2.QtSensors.QAmbientTemperatureReading.temperature": (),

# class PySide2.QtSensors.QAmbientTemperatureSensor:
    "PySide2.QtSensors.QAmbientTemperatureSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QAmbientTemperatureSensor.reading": (),

# class PySide2.QtSensors.QCompass:
    "PySide2.QtSensors.QCompass.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QCompass.reading": (),

# class PySide2.QtSensors.QCompassFilter:
    "PySide2.QtSensors.QCompassFilter.__init__": (),
    "PySide2.QtSensors.QCompassFilter.filter": [('PySide2.QtSensors.QCompassReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QCompassReading:
    "PySide2.QtSensors.QCompassReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QCompassReading.azimuth": (),
    "PySide2.QtSensors.QCompassReading.calibrationLevel": (),
    "PySide2.QtSensors.QCompassReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QCompassReading.setAzimuth": ('float',),
    "PySide2.QtSensors.QCompassReading.setCalibrationLevel": ('float',),

# class PySide2.QtSensors.QDistanceFilter:
    "PySide2.QtSensors.QDistanceFilter.__init__": (),
    "PySide2.QtSensors.QDistanceFilter.filter": [('PySide2.QtSensors.QDistanceReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QDistanceReading:
    "PySide2.QtSensors.QDistanceReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QDistanceReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QDistanceReading.distance": (),
    "PySide2.QtSensors.QDistanceReading.setDistance": ('float',),

# class PySide2.QtSensors.QDistanceSensor:
    "PySide2.QtSensors.QDistanceSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QDistanceSensor.reading": (),

# class PySide2.QtSensors.QGyroscope:
    "PySide2.QtSensors.QGyroscope.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QGyroscope.reading": (),

# class PySide2.QtSensors.QGyroscopeFilter:
    "PySide2.QtSensors.QGyroscopeFilter.__init__": (),
    "PySide2.QtSensors.QGyroscopeFilter.filter": [('PySide2.QtSensors.QGyroscopeReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QGyroscopeReading:
    "PySide2.QtSensors.QGyroscopeReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QGyroscopeReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QGyroscopeReading.setX": ('float',),
    "PySide2.QtSensors.QGyroscopeReading.setY": ('float',),
    "PySide2.QtSensors.QGyroscopeReading.setZ": ('float',),
    "PySide2.QtSensors.QGyroscopeReading.x": (),
    "PySide2.QtSensors.QGyroscopeReading.y": (),
    "PySide2.QtSensors.QGyroscopeReading.z": (),

# class PySide2.QtSensors.QHolsterFilter:
    "PySide2.QtSensors.QHolsterFilter.__init__": (),
    "PySide2.QtSensors.QHolsterFilter.filter": [('PySide2.QtSensors.QHolsterReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QHolsterReading:
    "PySide2.QtSensors.QHolsterReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QHolsterReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QHolsterReading.holstered": (),
    "PySide2.QtSensors.QHolsterReading.setHolstered": ('bool',),

# class PySide2.QtSensors.QHolsterSensor:
    "PySide2.QtSensors.QHolsterSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QHolsterSensor.reading": (),

# class PySide2.QtSensors.QHumidityFilter:
    "PySide2.QtSensors.QHumidityFilter.__init__": (),
    "PySide2.QtSensors.QHumidityFilter.filter": [('PySide2.QtSensors.QHumidityReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QHumidityReading:
    "PySide2.QtSensors.QHumidityReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QHumidityReading.absoluteHumidity": (),
    "PySide2.QtSensors.QHumidityReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QHumidityReading.relativeHumidity": (),
    "PySide2.QtSensors.QHumidityReading.setAbsoluteHumidity": ('float',),
    "PySide2.QtSensors.QHumidityReading.setRelativeHumidity": ('float',),

# class PySide2.QtSensors.QHumiditySensor:
    "PySide2.QtSensors.QHumiditySensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QHumiditySensor.reading": (),

# class PySide2.QtSensors.QIRProximityFilter:
    "PySide2.QtSensors.QIRProximityFilter.__init__": (),
    "PySide2.QtSensors.QIRProximityFilter.filter": [('PySide2.QtSensors.QIRProximityReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QIRProximityReading:
    "PySide2.QtSensors.QIRProximityReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QIRProximityReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QIRProximityReading.reflectance": (),
    "PySide2.QtSensors.QIRProximityReading.setReflectance": ('float',),

# class PySide2.QtSensors.QIRProximitySensor:
    "PySide2.QtSensors.QIRProximitySensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QIRProximitySensor.reading": (),

# class PySide2.QtSensors.QLidFilter:
    "PySide2.QtSensors.QLidFilter.__init__": (),
    "PySide2.QtSensors.QLidFilter.filter": [('PySide2.QtSensors.QLidReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QLidReading:
    "PySide2.QtSensors.QLidReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QLidReading.backLidClosed": (),
    "PySide2.QtSensors.QLidReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QLidReading.frontLidClosed": (),
    "PySide2.QtSensors.QLidReading.setBackLidClosed": ('bool',),
    "PySide2.QtSensors.QLidReading.setFrontLidClosed": ('bool',),

# class PySide2.QtSensors.QLidSensor:
    "PySide2.QtSensors.QLidSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QLidSensor.reading": (),

# class PySide2.QtSensors.QLightFilter:
    "PySide2.QtSensors.QLightFilter.__init__": (),
    "PySide2.QtSensors.QLightFilter.filter": [('PySide2.QtSensors.QLightReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QLightReading:
    "PySide2.QtSensors.QLightReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QLightReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QLightReading.lux": (),
    "PySide2.QtSensors.QLightReading.setLux": ('float',),

# class PySide2.QtSensors.QLightSensor:
    "PySide2.QtSensors.QLightSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QLightSensor.fieldOfView": (),
    "PySide2.QtSensors.QLightSensor.reading": (),
    "PySide2.QtSensors.QLightSensor.setFieldOfView": ('float',),

# class PySide2.QtSensors.QMagnetometer:
    "PySide2.QtSensors.QMagnetometer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QMagnetometer.reading": (),
    "PySide2.QtSensors.QMagnetometer.returnGeoValues": (),
    "PySide2.QtSensors.QMagnetometer.setReturnGeoValues": ('bool',),

# class PySide2.QtSensors.QMagnetometerFilter:
    "PySide2.QtSensors.QMagnetometerFilter.__init__": (),
    "PySide2.QtSensors.QMagnetometerFilter.filter": [('PySide2.QtSensors.QMagnetometerReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QMagnetometerReading:
    "PySide2.QtSensors.QMagnetometerReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QMagnetometerReading.calibrationLevel": (),
    "PySide2.QtSensors.QMagnetometerReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QMagnetometerReading.setCalibrationLevel": ('float',),
    "PySide2.QtSensors.QMagnetometerReading.setX": ('float',),
    "PySide2.QtSensors.QMagnetometerReading.setY": ('float',),
    "PySide2.QtSensors.QMagnetometerReading.setZ": ('float',),
    "PySide2.QtSensors.QMagnetometerReading.x": (),
    "PySide2.QtSensors.QMagnetometerReading.y": (),
    "PySide2.QtSensors.QMagnetometerReading.z": (),

# class PySide2.QtSensors.QOrientationFilter:
    "PySide2.QtSensors.QOrientationFilter.__init__": (),
    "PySide2.QtSensors.QOrientationFilter.filter": [('PySide2.QtSensors.QOrientationReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QOrientationReading:

# class PySide2.QtSensors.QOrientationReading.Orientation:
    "PySide2.QtSensors.QOrientationReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QOrientationReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QOrientationReading.orientation": (),
    "PySide2.QtSensors.QOrientationReading.setOrientation": ('PySide2.QtSensors.QOrientationReading.Orientation',),

# class PySide2.QtSensors.QOrientationSensor:
    "PySide2.QtSensors.QOrientationSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QOrientationSensor.reading": (),

# class PySide2.QtSensors.QPressureFilter:
    "PySide2.QtSensors.QPressureFilter.__init__": (),
    "PySide2.QtSensors.QPressureFilter.filter": [('PySide2.QtSensors.QPressureReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QPressureReading:
    "PySide2.QtSensors.QPressureReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QPressureReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QPressureReading.pressure": (),
    "PySide2.QtSensors.QPressureReading.setPressure": ('float',),
    "PySide2.QtSensors.QPressureReading.setTemperature": ('float',),
    "PySide2.QtSensors.QPressureReading.temperature": (),

# class PySide2.QtSensors.QPressureSensor:
    "PySide2.QtSensors.QPressureSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QPressureSensor.reading": (),

# class PySide2.QtSensors.QProximityFilter:
    "PySide2.QtSensors.QProximityFilter.__init__": (),
    "PySide2.QtSensors.QProximityFilter.filter": [('PySide2.QtSensors.QProximityReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QProximityReading:
    "PySide2.QtSensors.QProximityReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QProximityReading.close": (),
    "PySide2.QtSensors.QProximityReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QProximityReading.setClose": ('bool',),

# class PySide2.QtSensors.QProximitySensor:
    "PySide2.QtSensors.QProximitySensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QProximitySensor.reading": (),

# class PySide2.QtSensors.QRotationFilter:
    "PySide2.QtSensors.QRotationFilter.__init__": (),
    "PySide2.QtSensors.QRotationFilter.filter": [('PySide2.QtSensors.QRotationReading',), ('PySide2.QtSensors.QSensorReading',)],

# class PySide2.QtSensors.QRotationReading:
    "PySide2.QtSensors.QRotationReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QRotationReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QRotationReading.setFromEuler": ('float', 'float', 'float'),
    "PySide2.QtSensors.QRotationReading.x": (),
    "PySide2.QtSensors.QRotationReading.y": (),
    "PySide2.QtSensors.QRotationReading.z": (),

# class PySide2.QtSensors.QRotationSensor:
    "PySide2.QtSensors.QRotationSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QRotationSensor.hasZ": (),
    "PySide2.QtSensors.QRotationSensor.reading": (),
    "PySide2.QtSensors.QRotationSensor.setHasZ": ('bool',),

# class PySide2.QtSensors.QSensor:

# class PySide2.QtSensors.QSensor.AxesOrientationMode:

# class PySide2.QtSensors.QSensor.Feature:
    "PySide2.QtSensors.QSensor.__init__": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject'),
    "PySide2.QtSensors.QSensor.addFilter": ('PySide2.QtSensors.QSensorFilter',),
    "PySide2.QtSensors.QSensor.availableDataRates": (),
    "PySide2.QtSensors.QSensor.axesOrientationMode": (),
    "PySide2.QtSensors.QSensor.backend": (),
    "PySide2.QtSensors.QSensor.bufferSize": (),
    "PySide2.QtSensors.QSensor.connectToBackend": (),
    "PySide2.QtSensors.QSensor.currentOrientation": (),
    "PySide2.QtSensors.QSensor.dataRate": (),
    "PySide2.QtSensors.QSensor.defaultSensorForType": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtSensors.QSensor.description": (),
    "PySide2.QtSensors.QSensor.efficientBufferSize": (),
    "PySide2.QtSensors.QSensor.error": (),
    "PySide2.QtSensors.QSensor.filters": (),
    "PySide2.QtSensors.QSensor.identifier": (),
    "PySide2.QtSensors.QSensor.isActive": (),
    "PySide2.QtSensors.QSensor.isAlwaysOn": (),
    "PySide2.QtSensors.QSensor.isBusy": (),
    "PySide2.QtSensors.QSensor.isConnectedToBackend": (),
    "PySide2.QtSensors.QSensor.isFeatureSupported": ('PySide2.QtSensors.QSensor.Feature',),
    "PySide2.QtSensors.QSensor.maxBufferSize": (),
    "PySide2.QtSensors.QSensor.outputRange": (),
    "PySide2.QtSensors.QSensor.outputRanges": (),
    "PySide2.QtSensors.QSensor.reading": (),
    "PySide2.QtSensors.QSensor.removeFilter": ('PySide2.QtSensors.QSensorFilter',),
    "PySide2.QtSensors.QSensor.sensorTypes": (),
    "PySide2.QtSensors.QSensor.sensorsForType": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtSensors.QSensor.setActive": ('bool',),
    "PySide2.QtSensors.QSensor.setAlwaysOn": ('bool',),
    "PySide2.QtSensors.QSensor.setAxesOrientationMode": ('PySide2.QtSensors.QSensor.AxesOrientationMode',),
    "PySide2.QtSensors.QSensor.setBufferSize": ('int',),
    "PySide2.QtSensors.QSensor.setCurrentOrientation": ('int',),
    "PySide2.QtSensors.QSensor.setDataRate": ('int',),
    "PySide2.QtSensors.QSensor.setEfficientBufferSize": ('int',),
    "PySide2.QtSensors.QSensor.setIdentifier": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtSensors.QSensor.setMaxBufferSize": ('int',),
    "PySide2.QtSensors.QSensor.setOutputRange": ('int',),
    "PySide2.QtSensors.QSensor.setSkipDuplicates": ('bool',),
    "PySide2.QtSensors.QSensor.setUserOrientation": ('int',),
    "PySide2.QtSensors.QSensor.skipDuplicates": (),
    "PySide2.QtSensors.QSensor.start": (),
    "PySide2.QtSensors.QSensor.stop": (),
    "PySide2.QtSensors.QSensor.type": (),
    "PySide2.QtSensors.QSensor.userOrientation": (),

# class PySide2.QtSensors.QSensorBackend:
    "PySide2.QtSensors.QSensorBackend.__init__": ('PySide2.QtSensors.QSensor', 'PySide2.QtCore.QObject'),
    "PySide2.QtSensors.QSensorBackend.addDataRate": ('float', 'float'),
    "PySide2.QtSensors.QSensorBackend.addOutputRange": ('float', 'float', 'float'),
    "PySide2.QtSensors.QSensorBackend.isFeatureSupported": ('PySide2.QtSensors.QSensor.Feature',),
    "PySide2.QtSensors.QSensorBackend.newReadingAvailable": (),
    "PySide2.QtSensors.QSensorBackend.reading": (),
    "PySide2.QtSensors.QSensorBackend.sensor": (),
    "PySide2.QtSensors.QSensorBackend.sensorBusy": (),
    "PySide2.QtSensors.QSensorBackend.sensorError": ('int',),
    "PySide2.QtSensors.QSensorBackend.sensorStopped": (),
    "PySide2.QtSensors.QSensorBackend.setDataRates": ('PySide2.QtSensors.QSensor',),
    "PySide2.QtSensors.QSensorBackend.setDescription": ('str',),
    "PySide2.QtSensors.QSensorBackend.start": (),
    "PySide2.QtSensors.QSensorBackend.stop": (),

# class PySide2.QtSensors.QSensorBackendFactory:
    "PySide2.QtSensors.QSensorBackendFactory.__init__": (),
    "PySide2.QtSensors.QSensorBackendFactory.createBackend": ('PySide2.QtSensors.QSensor',),

# class PySide2.QtSensors.QSensorChangesInterface:
    "PySide2.QtSensors.QSensorChangesInterface.__init__": (),
    "PySide2.QtSensors.QSensorChangesInterface.sensorsChanged": (),

# class PySide2.QtSensors.QSensorFilter:
    "PySide2.QtSensors.QSensorFilter.__init__": (),
    "PySide2.QtSensors.QSensorFilter.filter": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QSensorFilter.setSensor": ('PySide2.QtSensors.QSensor',),

# class PySide2.QtSensors.QSensorGestureManager:
    "PySide2.QtSensors.QSensorGestureManager.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QSensorGestureManager.gestureIds": (),
    "PySide2.QtSensors.QSensorGestureManager.recognizerSignals": ('str',),
    "PySide2.QtSensors.QSensorGestureManager.registerSensorGestureRecognizer": ('PySide2.QtSensors.QSensorGestureRecognizer',),
    "PySide2.QtSensors.QSensorGestureManager.sensorGestureRecognizer": ('str',),

# class PySide2.QtSensors.QSensorGesturePluginInterface:
    "PySide2.QtSensors.QSensorGesturePluginInterface.__init__": (),
    "PySide2.QtSensors.QSensorGesturePluginInterface.createRecognizers": (),
    "PySide2.QtSensors.QSensorGesturePluginInterface.name": (),
    "PySide2.QtSensors.QSensorGesturePluginInterface.supportedIds": (),

# class PySide2.QtSensors.QSensorGestureRecognizer:
    "PySide2.QtSensors.QSensorGestureRecognizer.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QSensorGestureRecognizer.create": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.createBackend": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.gestureSignals": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.id": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.isActive": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.start": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.startBackend": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.stop": (),
    "PySide2.QtSensors.QSensorGestureRecognizer.stopBackend": (),

# class PySide2.QtSensors.QSensorManager:
    "PySide2.QtSensors.QSensorManager.__init__": (),
    "PySide2.QtSensors.QSensorManager.createBackend": ('PySide2.QtSensors.QSensor',),
    "PySide2.QtSensors.QSensorManager.isBackendRegistered": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtSensors.QSensorManager.registerBackend": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray', 'PySide2.QtSensors.QSensorBackendFactory'),
    "PySide2.QtSensors.QSensorManager.setDefaultBackend": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtSensors.QSensorManager.unregisterBackend": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),

# class PySide2.QtSensors.QSensorPluginInterface:
    "PySide2.QtSensors.QSensorPluginInterface.__init__": (),
    "PySide2.QtSensors.QSensorPluginInterface.registerSensors": (),

# class PySide2.QtSensors.QSensorReading:
    "PySide2.QtSensors.QSensorReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QSensorReading.setTimestamp": ('int',),
    "PySide2.QtSensors.QSensorReading.timestamp": (),
    "PySide2.QtSensors.QSensorReading.value": ('int',),
    "PySide2.QtSensors.QSensorReading.valueCount": (),

# class PySide2.QtSensors.QTapFilter:
    "PySide2.QtSensors.QTapFilter.__init__": (),
    "PySide2.QtSensors.QTapFilter.filter": [('PySide2.QtSensors.QSensorReading',), ('PySide2.QtSensors.QTapReading',)],

# class PySide2.QtSensors.QTapReading:

# class PySide2.QtSensors.QTapReading.TapDirection:
    "PySide2.QtSensors.QTapReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QTapReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QTapReading.isDoubleTap": (),
    "PySide2.QtSensors.QTapReading.setDoubleTap": ('bool',),
    "PySide2.QtSensors.QTapReading.setTapDirection": ('PySide2.QtSensors.QTapReading.TapDirection',),
    "PySide2.QtSensors.QTapReading.tapDirection": (),

# class PySide2.QtSensors.QTapSensor:
    "PySide2.QtSensors.QTapSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QTapSensor.reading": (),
    "PySide2.QtSensors.QTapSensor.returnDoubleTapEvents": (),
    "PySide2.QtSensors.QTapSensor.setReturnDoubleTapEvents": ('bool',),

# class PySide2.QtSensors.QTiltFilter:
    "PySide2.QtSensors.QTiltFilter.__init__": (),
    "PySide2.QtSensors.QTiltFilter.filter": [('PySide2.QtSensors.QSensorReading',), ('PySide2.QtSensors.QTiltReading',)],

# class PySide2.QtSensors.QTiltReading:
    "PySide2.QtSensors.QTiltReading.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QTiltReading.copyValuesFrom": ('PySide2.QtSensors.QSensorReading',),
    "PySide2.QtSensors.QTiltReading.setXRotation": ('float',),
    "PySide2.QtSensors.QTiltReading.setYRotation": ('float',),
    "PySide2.QtSensors.QTiltReading.xRotation": (),
    "PySide2.QtSensors.QTiltReading.yRotation": (),

# class PySide2.QtSensors.QTiltSensor:
    "PySide2.QtSensors.QTiltSensor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtSensors.QTiltSensor.calibrate": (),
    "PySide2.QtSensors.QTiltSensor.reading": (),

# class PySide2.QtSensors.qoutputrange:
    "PySide2.QtSensors.qoutputrange.__init__": [(), ('PySide2.QtSensors.qoutputrange',)],
    "PySide2.QtSensors.qoutputrange.__copy__": (),
    }) if "PySide2.QtSensors" in sys.modules else None

# Module PySide2.QtTextToSpeech
sig_dict.update({

# class PySide2.QtTextToSpeech.QTextToSpeech:

# class PySide2.QtTextToSpeech.QTextToSpeech.State:
    "PySide2.QtTextToSpeech.QTextToSpeech.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtTextToSpeech.QTextToSpeech.availableEngines": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.availableLocales": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.availableVoices": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.locale": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.pause": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.pitch": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.rate": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.resume": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.say": ('str',),
    "PySide2.QtTextToSpeech.QTextToSpeech.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtTextToSpeech.QTextToSpeech.setPitch": ('float',),
    "PySide2.QtTextToSpeech.QTextToSpeech.setRate": ('float',),
    "PySide2.QtTextToSpeech.QTextToSpeech.setVoice": ('PySide2.QtTextToSpeech.QVoice',),
    "PySide2.QtTextToSpeech.QTextToSpeech.setVolume": ('float',),
    "PySide2.QtTextToSpeech.QTextToSpeech.state": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.stop": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.voice": (),
    "PySide2.QtTextToSpeech.QTextToSpeech.volume": (),

# class PySide2.QtTextToSpeech.QTextToSpeechEngine:
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.availableLocales": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.availableVoices": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.createVoice": ('str', 'PySide2.QtTextToSpeech.QVoice.Gender', 'PySide2.QtTextToSpeech.QVoice.Age', 'typing.Any'),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.locale": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.pause": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.pitch": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.rate": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.resume": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.say": ('str',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.setPitch": ('float',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.setRate": ('float',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.setVoice": ('PySide2.QtTextToSpeech.QVoice',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.setVolume": ('float',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.state": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.stop": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.voice": (),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.voiceData": ('PySide2.QtTextToSpeech.QVoice',),
    "PySide2.QtTextToSpeech.QTextToSpeechEngine.volume": (),

# class PySide2.QtTextToSpeech.QVoice:

# class PySide2.QtTextToSpeech.QVoice.Age:

# class PySide2.QtTextToSpeech.QVoice.Gender:
    "PySide2.QtTextToSpeech.QVoice.__init__": [(), ('PySide2.QtTextToSpeech.QVoice',)],
    "PySide2.QtTextToSpeech.QVoice.__copy__": (),
    "PySide2.QtTextToSpeech.QVoice.age": (),
    "PySide2.QtTextToSpeech.QVoice.ageName": ('PySide2.QtTextToSpeech.QVoice.Age',),
    "PySide2.QtTextToSpeech.QVoice.gender": (),
    "PySide2.QtTextToSpeech.QVoice.genderName": ('PySide2.QtTextToSpeech.QVoice.Gender',),
    "PySide2.QtTextToSpeech.QVoice.name": (),
    }) if "PySide2.QtTextToSpeech" in sys.modules else None

# Module PySide2.QtCharts
sig_dict.update({

# class PySide2.QtCharts.QtCharts:

# class PySide2.QtCharts.QtCharts.QAbstractAxis:

# class PySide2.QtCharts.QtCharts.QAbstractAxis.AxisType:
    "PySide2.QtCharts.QtCharts.QAbstractAxis.alignment": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.gridLineColor": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.gridLinePen": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.hide": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.isGridLineVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.isLineVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.isMinorGridLineVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.isReverse": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.isTitleVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.isVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.labelsAngle": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.labelsBrush": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.labelsColor": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.labelsEditable": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.labelsFont": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.labelsVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.linePen": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.linePenColor": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.minorGridLineColor": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.minorGridLinePen": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.orientation": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setGridLineColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setGridLinePen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setGridLineVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLabelsAngle": ('int',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLabelsBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLabelsColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLabelsEditable": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLabelsFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLabelsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLinePen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLinePenColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setLineVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setMax": ('typing.Any',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setMin": ('typing.Any',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setMinorGridLineColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setMinorGridLinePen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setMinorGridLineVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setRange": ('typing.Any', 'typing.Any'),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setReverse": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setShadesBorderColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setShadesBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setShadesColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setShadesPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setShadesVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setTitleBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setTitleFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setTitleText": ('str',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setTitleVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.setVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.shadesBorderColor": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.shadesBrush": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.shadesColor": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.shadesPen": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.shadesVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.show": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.titleBrush": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.titleFont": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.titleText": (),
    "PySide2.QtCharts.QtCharts.QAbstractAxis.type": (),

# class PySide2.QtCharts.QtCharts.QAbstractBarSeries:

# class PySide2.QtCharts.QtCharts.QAbstractBarSeries.LabelsPosition:
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.append": [('PySide2.QtCharts.QtCharts.QBarSet',), ('typing.Sequence[PySide2.QtCharts.QtCharts.QBarSet]',)],
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.barSets": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.barWidth": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.clear": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.count": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.insert": ('int', 'PySide2.QtCharts.QtCharts.QBarSet'),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.isLabelsVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.labelsAngle": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.labelsFormat": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.labelsPosition": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.labelsPrecision": (),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.remove": ('PySide2.QtCharts.QtCharts.QBarSet',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.setBarWidth": ('float',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.setLabelsAngle": ('float',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.setLabelsFormat": ('str',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.setLabelsPosition": ('PySide2.QtCharts.QtCharts.QAbstractBarSeries.LabelsPosition',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.setLabelsPrecision": ('int',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.setLabelsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractBarSeries.take": ('PySide2.QtCharts.QtCharts.QBarSet',),

# class PySide2.QtCharts.QtCharts.QAbstractSeries:

# class PySide2.QtCharts.QtCharts.QAbstractSeries.SeriesType:
    "PySide2.QtCharts.QtCharts.QAbstractSeries.attachAxis": ('PySide2.QtCharts.QtCharts.QAbstractAxis',),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.attachedAxes": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.chart": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.detachAxis": ('PySide2.QtCharts.QtCharts.QAbstractAxis',),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.hide": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.isVisible": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.name": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.opacity": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.setName": ('str',),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.setOpacity": ('float',),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.setUseOpenGL": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.setVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.show": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.type": (),
    "PySide2.QtCharts.QtCharts.QAbstractSeries.useOpenGL": (),

# class PySide2.QtCharts.QtCharts.QAreaLegendMarker:
    "PySide2.QtCharts.QtCharts.QAreaLegendMarker.__init__": ('PySide2.QtCharts.QtCharts.QAreaSeries', 'PySide2.QtCharts.QtCharts.QLegend', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QAreaLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QAreaLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QAreaSeries:
    "PySide2.QtCharts.QtCharts.QAreaSeries.__init__": [('PySide2.QtCharts.QtCharts.QLineSeries', 'PySide2.QtCharts.QtCharts.QLineSeries'), ('PySide2.QtCore.QObject',)],
    "PySide2.QtCharts.QtCharts.QAreaSeries.borderColor": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.brush": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.color": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.lowerSeries": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pen": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pointLabelsClipping": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pointLabelsColor": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pointLabelsFont": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pointLabelsFormat": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pointLabelsVisible": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.pointsVisible": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setBorderColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setLowerSeries": ('PySide2.QtCharts.QtCharts.QLineSeries',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPointLabelsClipping": ('bool',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPointLabelsColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPointLabelsFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPointLabelsFormat": ('str',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPointLabelsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setPointsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.setUpperSeries": ('PySide2.QtCharts.QtCharts.QLineSeries',),
    "PySide2.QtCharts.QtCharts.QAreaSeries.type": (),
    "PySide2.QtCharts.QtCharts.QAreaSeries.upperSeries": (),

# class PySide2.QtCharts.QtCharts.QBarCategoryAxis:
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.append": [('str',), ('typing.Sequence[str]',)],
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.at": ('int',),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.categories": (),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.clear": (),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.count": (),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.insert": ('int', 'str'),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.max": (),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.min": (),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.remove": ('str',),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.replace": ('str', 'str'),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.setCategories": ('typing.Sequence[str]',),
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.setMax": [('str',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.setMin": [('str',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.setRange": [('str', 'str'), ('typing.Any', 'typing.Any')],
    "PySide2.QtCharts.QtCharts.QBarCategoryAxis.type": (),

# class PySide2.QtCharts.QtCharts.QBarLegendMarker:
    "PySide2.QtCharts.QtCharts.QBarLegendMarker.__init__": ('PySide2.QtCharts.QtCharts.QAbstractBarSeries', 'PySide2.QtCharts.QtCharts.QBarSet', 'PySide2.QtCharts.QtCharts.QLegend', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QBarLegendMarker.barset": (),
    "PySide2.QtCharts.QtCharts.QBarLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QBarLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QBarModelMapper:
    "PySide2.QtCharts.QtCharts.QBarModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.count": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.first": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.firstBarSetSection": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.lastBarSetSection": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setCount": ('int',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setFirst": ('int',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setFirstBarSetSection": ('int',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setLastBarSetSection": ('int',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtCharts.QtCharts.QBarModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QAbstractBarSeries',),

# class PySide2.QtCharts.QtCharts.QBarSeries:
    "PySide2.QtCharts.QtCharts.QBarSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QBarSeries.type": (),

# class PySide2.QtCharts.QtCharts.QBarSet:
    "PySide2.QtCharts.QtCharts.QBarSet.__init__": ('str', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QBarSet.__lshift__": ('float',),
    "PySide2.QtCharts.QtCharts.QBarSet.append": [('float',), ('typing.Sequence[float]',)],
    "PySide2.QtCharts.QtCharts.QBarSet.at": ('int',),
    "PySide2.QtCharts.QtCharts.QBarSet.borderColor": (),
    "PySide2.QtCharts.QtCharts.QBarSet.brush": (),
    "PySide2.QtCharts.QtCharts.QBarSet.color": (),
    "PySide2.QtCharts.QtCharts.QBarSet.count": (),
    "PySide2.QtCharts.QtCharts.QBarSet.insert": ('int', 'float'),
    "PySide2.QtCharts.QtCharts.QBarSet.label": (),
    "PySide2.QtCharts.QtCharts.QBarSet.labelBrush": (),
    "PySide2.QtCharts.QtCharts.QBarSet.labelColor": (),
    "PySide2.QtCharts.QtCharts.QBarSet.labelFont": (),
    "PySide2.QtCharts.QtCharts.QBarSet.pen": (),
    "PySide2.QtCharts.QtCharts.QBarSet.remove": ('int', 'int'),
    "PySide2.QtCharts.QtCharts.QBarSet.replace": ('int', 'float'),
    "PySide2.QtCharts.QtCharts.QBarSet.setBorderColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QBarSet.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QBarSet.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QBarSet.setLabel": ('str',),
    "PySide2.QtCharts.QtCharts.QBarSet.setLabelBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QBarSet.setLabelColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QBarSet.setLabelFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QBarSet.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QBarSet.sum": (),

# class PySide2.QtCharts.QtCharts.QBoxPlotLegendMarker:
    "PySide2.QtCharts.QtCharts.QBoxPlotLegendMarker.__init__": ('PySide2.QtCharts.QtCharts.QBoxPlotSeries', 'PySide2.QtCharts.QtCharts.QLegend', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QBoxPlotLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QBoxPlotModelMapper:
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.count": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.first": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.firstBoxSetSection": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.lastBoxSetSection": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setCount": ('int',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setFirst": ('int',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setFirstBoxSetSection": ('int',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setLastBoxSetSection": ('int',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtCharts.QtCharts.QBoxPlotModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QBoxPlotSeries',),

# class PySide2.QtCharts.QtCharts.QBoxPlotSeries:
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.append": [('PySide2.QtCharts.QtCharts.QBoxSet',), ('typing.Sequence[PySide2.QtCharts.QtCharts.QBoxSet]',)],
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.boxOutlineVisible": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.boxSets": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.boxWidth": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.brush": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.clear": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.count": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.insert": ('int', 'PySide2.QtCharts.QtCharts.QBoxSet'),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.pen": (),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.remove": ('PySide2.QtCharts.QtCharts.QBoxSet',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.setBoxOutlineVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.setBoxWidth": ('float',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.take": ('PySide2.QtCharts.QtCharts.QBoxSet',),
    "PySide2.QtCharts.QtCharts.QBoxPlotSeries.type": (),

# class PySide2.QtCharts.QtCharts.QBoxSet:

# class PySide2.QtCharts.QtCharts.QBoxSet.ValuePositions:
    "PySide2.QtCharts.QtCharts.QBoxSet.__init__": [('float', 'float', 'float', 'float', 'float', 'str', 'PySide2.QtCore.QObject'), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtCharts.QtCharts.QBoxSet.__lshift__": ('float',),
    "PySide2.QtCharts.QtCharts.QBoxSet.append": [('float',), ('typing.Sequence[float]',)],
    "PySide2.QtCharts.QtCharts.QBoxSet.at": ('int',),
    "PySide2.QtCharts.QtCharts.QBoxSet.brush": (),
    "PySide2.QtCharts.QtCharts.QBoxSet.clear": (),
    "PySide2.QtCharts.QtCharts.QBoxSet.count": (),
    "PySide2.QtCharts.QtCharts.QBoxSet.label": (),
    "PySide2.QtCharts.QtCharts.QBoxSet.pen": (),
    "PySide2.QtCharts.QtCharts.QBoxSet.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QBoxSet.setLabel": ('str',),
    "PySide2.QtCharts.QtCharts.QBoxSet.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QBoxSet.setValue": ('int', 'float'),

# class PySide2.QtCharts.QtCharts.QCandlestickLegendMarker:
    "PySide2.QtCharts.QtCharts.QCandlestickLegendMarker.__init__": ('PySide2.QtCharts.QtCharts.QCandlestickSeries', 'PySide2.QtCharts.QtCharts.QLegend', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QCandlestickLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QCandlestickLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QCandlestickModelMapper:
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.close": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.firstSetSection": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.high": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.lastSetSection": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.low": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.open": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setClose": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setFirstSetSection": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setHigh": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setLastSetSection": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setLow": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setOpen": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QCandlestickSeries',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.setTimestamp": ('int',),
    "PySide2.QtCharts.QtCharts.QCandlestickModelMapper.timestamp": (),

# class PySide2.QtCharts.QtCharts.QCandlestickSeries:
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.append": [('PySide2.QtCharts.QtCharts.QCandlestickSet',), ('typing.Sequence[PySide2.QtCharts.QtCharts.QCandlestickSet]',)],
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.bodyOutlineVisible": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.bodyWidth": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.brush": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.capsVisible": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.capsWidth": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.clear": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.count": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.decreasingColor": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.increasingColor": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.insert": ('int', 'PySide2.QtCharts.QtCharts.QCandlestickSet'),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.maximumColumnWidth": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.minimumColumnWidth": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.pen": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.remove": [('PySide2.QtCharts.QtCharts.QCandlestickSet',), ('typing.Sequence[PySide2.QtCharts.QtCharts.QCandlestickSet]',)],
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setBodyOutlineVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setBodyWidth": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setCapsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setCapsWidth": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setDecreasingColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setIncreasingColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setMaximumColumnWidth": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setMinimumColumnWidth": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.sets": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.take": ('PySide2.QtCharts.QtCharts.QCandlestickSet',),
    "PySide2.QtCharts.QtCharts.QCandlestickSeries.type": (),

# class PySide2.QtCharts.QtCharts.QCandlestickSet:
    "PySide2.QtCharts.QtCharts.QCandlestickSet.__init__": [('float', 'PySide2.QtCore.QObject'), ('float', 'float', 'float', 'float', 'float', 'PySide2.QtCore.QObject')],
    "PySide2.QtCharts.QtCharts.QCandlestickSet.brush": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.close": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.high": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.low": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.open": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.pen": (),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setClose": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setHigh": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setLow": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setOpen": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.setTimestamp": ('float',),
    "PySide2.QtCharts.QtCharts.QCandlestickSet.timestamp": (),

# class PySide2.QtCharts.QtCharts.QCategoryAxis:

# class PySide2.QtCharts.QtCharts.QCategoryAxis.AxisLabelsPosition:
    "PySide2.QtCharts.QtCharts.QCategoryAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.append": ('str', 'float'),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.categoriesLabels": (),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.count": (),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.endValue": ('str',),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.labelsPosition": (),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.remove": ('str',),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.replaceLabel": ('str', 'str'),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.setLabelsPosition": ('PySide2.QtCharts.QtCharts.QCategoryAxis.AxisLabelsPosition',),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.setStartValue": ('float',),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.startValue": ('str',),
    "PySide2.QtCharts.QtCharts.QCategoryAxis.type": (),

# class PySide2.QtCharts.QtCharts.QChart:

# class PySide2.QtCharts.QtCharts.QChart.AnimationOption:

# class PySide2.QtCharts.QtCharts.QChart.AnimationOptions:

# class PySide2.QtCharts.QtCharts.QChart.ChartTheme:

# class PySide2.QtCharts.QtCharts.QChart.ChartType:
    "PySide2.QtCharts.QtCharts.QChart.__init__": [('PySide2.QtCharts.QtCharts.QChart.ChartType', 'PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.WindowFlags'), ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.WindowFlags')],
    "PySide2.QtCharts.QtCharts.QChart.addAxis": ('PySide2.QtCharts.QtCharts.QAbstractAxis', 'PySide2.QtCore.Qt.Alignment'),
    "PySide2.QtCharts.QtCharts.QChart.addSeries": ('PySide2.QtCharts.QtCharts.QAbstractSeries',),
    "PySide2.QtCharts.QtCharts.QChart.animationDuration": (),
    "PySide2.QtCharts.QtCharts.QChart.animationEasingCurve": (),
    "PySide2.QtCharts.QtCharts.QChart.animationOptions": (),
    "PySide2.QtCharts.QtCharts.QChart.axes": ('PySide2.QtCore.Qt.Orientations', 'PySide2.QtCharts.QtCharts.QAbstractSeries'),
    "PySide2.QtCharts.QtCharts.QChart.axisX": ('PySide2.QtCharts.QtCharts.QAbstractSeries',),
    "PySide2.QtCharts.QtCharts.QChart.axisY": ('PySide2.QtCharts.QtCharts.QAbstractSeries',),
    "PySide2.QtCharts.QtCharts.QChart.backgroundBrush": (),
    "PySide2.QtCharts.QtCharts.QChart.backgroundPen": (),
    "PySide2.QtCharts.QtCharts.QChart.backgroundRoundness": (),
    "PySide2.QtCharts.QtCharts.QChart.chartType": (),
    "PySide2.QtCharts.QtCharts.QChart.createDefaultAxes": (),
    "PySide2.QtCharts.QtCharts.QChart.isBackgroundVisible": (),
    "PySide2.QtCharts.QtCharts.QChart.isDropShadowEnabled": (),
    "PySide2.QtCharts.QtCharts.QChart.isPlotAreaBackgroundVisible": (),
    "PySide2.QtCharts.QtCharts.QChart.isZoomed": (),
    "PySide2.QtCharts.QtCharts.QChart.legend": (),
    "PySide2.QtCharts.QtCharts.QChart.locale": (),
    "PySide2.QtCharts.QtCharts.QChart.localizeNumbers": (),
    "PySide2.QtCharts.QtCharts.QChart.mapToPosition": ('PySide2.QtCore.QPointF', 'PySide2.QtCharts.QtCharts.QAbstractSeries'),
    "PySide2.QtCharts.QtCharts.QChart.mapToValue": ('PySide2.QtCore.QPointF', 'PySide2.QtCharts.QtCharts.QAbstractSeries'),
    "PySide2.QtCharts.QtCharts.QChart.margins": (),
    "PySide2.QtCharts.QtCharts.QChart.plotArea": (),
    "PySide2.QtCharts.QtCharts.QChart.plotAreaBackgroundBrush": (),
    "PySide2.QtCharts.QtCharts.QChart.plotAreaBackgroundPen": (),
    "PySide2.QtCharts.QtCharts.QChart.removeAllSeries": (),
    "PySide2.QtCharts.QtCharts.QChart.removeAxis": ('PySide2.QtCharts.QtCharts.QAbstractAxis',),
    "PySide2.QtCharts.QtCharts.QChart.removeSeries": ('PySide2.QtCharts.QtCharts.QAbstractSeries',),
    "PySide2.QtCharts.QtCharts.QChart.scroll": ('float', 'float'),
    "PySide2.QtCharts.QtCharts.QChart.series": (),
    "PySide2.QtCharts.QtCharts.QChart.setAnimationDuration": ('int',),
    "PySide2.QtCharts.QtCharts.QChart.setAnimationEasingCurve": ('PySide2.QtCore.QEasingCurve',),
    "PySide2.QtCharts.QtCharts.QChart.setAnimationOptions": ('PySide2.QtCharts.QtCharts.QChart.AnimationOptions',),
    "PySide2.QtCharts.QtCharts.QChart.setAxisX": ('PySide2.QtCharts.QtCharts.QAbstractAxis', 'PySide2.QtCharts.QtCharts.QAbstractSeries'),
    "PySide2.QtCharts.QtCharts.QChart.setAxisY": ('PySide2.QtCharts.QtCharts.QAbstractAxis', 'PySide2.QtCharts.QtCharts.QAbstractSeries'),
    "PySide2.QtCharts.QtCharts.QChart.setBackgroundBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QChart.setBackgroundPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QChart.setBackgroundRoundness": ('float',),
    "PySide2.QtCharts.QtCharts.QChart.setBackgroundVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QChart.setDropShadowEnabled": ('bool',),
    "PySide2.QtCharts.QtCharts.QChart.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtCharts.QtCharts.QChart.setLocalizeNumbers": ('bool',),
    "PySide2.QtCharts.QtCharts.QChart.setMargins": ('PySide2.QtCore.QMargins',),
    "PySide2.QtCharts.QtCharts.QChart.setPlotArea": ('PySide2.QtCore.QRectF',),
    "PySide2.QtCharts.QtCharts.QChart.setPlotAreaBackgroundBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QChart.setPlotAreaBackgroundPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QChart.setPlotAreaBackgroundVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QChart.setTheme": ('PySide2.QtCharts.QtCharts.QChart.ChartTheme',),
    "PySide2.QtCharts.QtCharts.QChart.setTitle": ('str',),
    "PySide2.QtCharts.QtCharts.QChart.setTitleBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QChart.setTitleFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QChart.theme": (),
    "PySide2.QtCharts.QtCharts.QChart.title": (),
    "PySide2.QtCharts.QtCharts.QChart.titleBrush": (),
    "PySide2.QtCharts.QtCharts.QChart.titleFont": (),
    "PySide2.QtCharts.QtCharts.QChart.zoom": ('float',),
    "PySide2.QtCharts.QtCharts.QChart.zoomIn": [(), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtCharts.QtCharts.QChart.zoomOut": (),
    "PySide2.QtCharts.QtCharts.QChart.zoomReset": (),

# class PySide2.QtCharts.QtCharts.QChartView:

# class PySide2.QtCharts.QtCharts.QChartView.RubberBand:

# class PySide2.QtCharts.QtCharts.QChartView.RubberBands:
    "PySide2.QtCharts.QtCharts.QChartView.__init__": [('PySide2.QtCharts.QtCharts.QChart', 'PySide2.QtWidgets.QWidget'), ('PySide2.QtWidgets.QWidget',)],
    "PySide2.QtCharts.QtCharts.QChartView.chart": (),
    "PySide2.QtCharts.QtCharts.QChartView.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtCharts.QtCharts.QChartView.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtCharts.QtCharts.QChartView.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtCharts.QtCharts.QChartView.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtCharts.QtCharts.QChartView.rubberBand": (),
    "PySide2.QtCharts.QtCharts.QChartView.setChart": ('PySide2.QtCharts.QtCharts.QChart',),
    "PySide2.QtCharts.QtCharts.QChartView.setRubberBand": ('PySide2.QtCharts.QtCharts.QChartView.RubberBands',),
    "PySide2.QtCharts.QtCharts.QChartView.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtCharts.QtCharts.QDateTimeAxis:
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.format": (),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.max": (),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.min": (),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.setFormat": ('str',),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.setMax": [('PySide2.QtCore.QDateTime',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.setMin": [('PySide2.QtCore.QDateTime',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.setRange": [('PySide2.QtCore.QDateTime', 'PySide2.QtCore.QDateTime'), ('typing.Any', 'typing.Any')],
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.setTickCount": ('int',),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.tickCount": (),
    "PySide2.QtCharts.QtCharts.QDateTimeAxis.type": (),

# class PySide2.QtCharts.QtCharts.QHBarModelMapper:
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.columnCount": (),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.firstBarSetRow": (),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.firstColumn": (),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.lastBarSetRow": (),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.setColumnCount": ('int',),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.setFirstBarSetRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.setFirstColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.setLastBarSetRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QHBarModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QAbstractBarSeries',),

# class PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper:
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.columnCount": (),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.firstBoxSetRow": (),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.firstColumn": (),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.lastBoxSetRow": (),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.setColumnCount": ('int',),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.setFirstBoxSetRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.setFirstColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.setLastBoxSetRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QHBoxPlotModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QBoxPlotSeries',),

# class PySide2.QtCharts.QtCharts.QHCandlestickModelMapper:
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.closeColumn": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.firstSetRow": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.highColumn": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.lastSetRow": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.lowColumn": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.openColumn": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setCloseColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setFirstSetRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setHighColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setLastSetRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setLowColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setOpenColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.setTimestampColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHCandlestickModelMapper.timestampColumn": (),

# class PySide2.QtCharts.QtCharts.QHPieModelMapper:
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.columnCount": (),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.firstColumn": (),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.labelsRow": (),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.setColumnCount": ('int',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.setFirstColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.setLabelsRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QPieSeries',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.setValuesRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHPieModelMapper.valuesRow": (),

# class PySide2.QtCharts.QtCharts.QHXYModelMapper:
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.columnCount": (),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.firstColumn": (),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.setColumnCount": ('int',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.setFirstColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QXYSeries',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.setXRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.setYRow": ('int',),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.xRow": (),
    "PySide2.QtCharts.QtCharts.QHXYModelMapper.yRow": (),

# class PySide2.QtCharts.QtCharts.QHorizontalBarSeries:
    "PySide2.QtCharts.QtCharts.QHorizontalBarSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHorizontalBarSeries.type": (),

# class PySide2.QtCharts.QtCharts.QHorizontalPercentBarSeries:
    "PySide2.QtCharts.QtCharts.QHorizontalPercentBarSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHorizontalPercentBarSeries.type": (),

# class PySide2.QtCharts.QtCharts.QHorizontalStackedBarSeries:
    "PySide2.QtCharts.QtCharts.QHorizontalStackedBarSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QHorizontalStackedBarSeries.type": (),

# class PySide2.QtCharts.QtCharts.QLegend:

# class PySide2.QtCharts.QtCharts.QLegend.MarkerShape:
    "PySide2.QtCharts.QtCharts.QLegend.alignment": (),
    "PySide2.QtCharts.QtCharts.QLegend.attachToChart": (),
    "PySide2.QtCharts.QtCharts.QLegend.borderColor": (),
    "PySide2.QtCharts.QtCharts.QLegend.brush": (),
    "PySide2.QtCharts.QtCharts.QLegend.color": (),
    "PySide2.QtCharts.QtCharts.QLegend.detachFromChart": (),
    "PySide2.QtCharts.QtCharts.QLegend.font": (),
    "PySide2.QtCharts.QtCharts.QLegend.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtCharts.QtCharts.QLegend.isAttachedToChart": (),
    "PySide2.QtCharts.QtCharts.QLegend.isBackgroundVisible": (),
    "PySide2.QtCharts.QtCharts.QLegend.labelBrush": (),
    "PySide2.QtCharts.QtCharts.QLegend.labelColor": (),
    "PySide2.QtCharts.QtCharts.QLegend.markerShape": (),
    "PySide2.QtCharts.QtCharts.QLegend.markers": ('PySide2.QtCharts.QtCharts.QAbstractSeries',),
    "PySide2.QtCharts.QtCharts.QLegend.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtCharts.QtCharts.QLegend.pen": (),
    "PySide2.QtCharts.QtCharts.QLegend.reverseMarkers": (),
    "PySide2.QtCharts.QtCharts.QLegend.setAlignment": ('PySide2.QtCore.Qt.Alignment',),
    "PySide2.QtCharts.QtCharts.QLegend.setBackgroundVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QLegend.setBorderColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QLegend.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QLegend.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QLegend.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QLegend.setLabelBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QLegend.setLabelColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QLegend.setMarkerShape": ('PySide2.QtCharts.QtCharts.QLegend.MarkerShape',),
    "PySide2.QtCharts.QtCharts.QLegend.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QLegend.setReverseMarkers": ('bool',),
    "PySide2.QtCharts.QtCharts.QLegend.setShowToolTips": ('bool',),
    "PySide2.QtCharts.QtCharts.QLegend.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtCharts.QtCharts.QLegend.showToolTips": (),

# class PySide2.QtCharts.QtCharts.QLegendMarker:

# class PySide2.QtCharts.QtCharts.QLegendMarker.LegendMarkerType:
    "PySide2.QtCharts.QtCharts.QLegendMarker.brush": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.font": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.isVisible": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.label": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.labelBrush": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.pen": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setLabel": ('str',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setLabelBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setShape": ('PySide2.QtCharts.QtCharts.QLegend.MarkerShape',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.setVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QLegendMarker.shape": (),
    "PySide2.QtCharts.QtCharts.QLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QLineSeries:
    "PySide2.QtCharts.QtCharts.QLineSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QLineSeries.type": (),

# class PySide2.QtCharts.QtCharts.QLogValueAxis:
    "PySide2.QtCharts.QtCharts.QLogValueAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.base": (),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.labelFormat": (),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.max": (),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.min": (),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.minorTickCount": (),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.setBase": ('float',),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.setLabelFormat": ('str',),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.setMax": [('float',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QLogValueAxis.setMin": [('float',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QLogValueAxis.setMinorTickCount": ('int',),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.setRange": [('float', 'float'), ('typing.Any', 'typing.Any')],
    "PySide2.QtCharts.QtCharts.QLogValueAxis.tickCount": (),
    "PySide2.QtCharts.QtCharts.QLogValueAxis.type": (),

# class PySide2.QtCharts.QtCharts.QPercentBarSeries:
    "PySide2.QtCharts.QtCharts.QPercentBarSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QPercentBarSeries.type": (),

# class PySide2.QtCharts.QtCharts.QPieLegendMarker:
    "PySide2.QtCharts.QtCharts.QPieLegendMarker.__init__": ('PySide2.QtCharts.QtCharts.QPieSeries', 'PySide2.QtCharts.QtCharts.QPieSlice', 'PySide2.QtCharts.QtCharts.QLegend', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QPieLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QPieLegendMarker.slice": (),
    "PySide2.QtCharts.QtCharts.QPieLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QPieModelMapper:
    "PySide2.QtCharts.QtCharts.QPieModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.count": (),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.first": (),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.labelsSection": (),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setCount": ('int',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setFirst": ('int',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setLabelsSection": ('int',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QPieSeries',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.setValuesSection": ('int',),
    "PySide2.QtCharts.QtCharts.QPieModelMapper.valuesSection": (),

# class PySide2.QtCharts.QtCharts.QPieSeries:
    "PySide2.QtCharts.QtCharts.QPieSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QPieSeries.__lshift__": ('PySide2.QtCharts.QtCharts.QPieSlice',),
    "PySide2.QtCharts.QtCharts.QPieSeries.append": [('PySide2.QtCharts.QtCharts.QPieSlice',), ('str', 'float'), ('typing.Sequence[PySide2.QtCharts.QtCharts.QPieSlice]',)],
    "PySide2.QtCharts.QtCharts.QPieSeries.clear": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.count": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.holeSize": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.horizontalPosition": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.insert": ('int', 'PySide2.QtCharts.QtCharts.QPieSlice'),
    "PySide2.QtCharts.QtCharts.QPieSeries.isEmpty": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.pieEndAngle": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.pieSize": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.pieStartAngle": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.remove": ('PySide2.QtCharts.QtCharts.QPieSlice',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setHoleSize": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setHorizontalPosition": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setLabelsPosition": ('PySide2.QtCharts.QtCharts.QPieSlice.LabelPosition',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setLabelsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setPieEndAngle": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setPieSize": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setPieStartAngle": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSeries.setVerticalPosition": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSeries.slices": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.sum": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.take": ('PySide2.QtCharts.QtCharts.QPieSlice',),
    "PySide2.QtCharts.QtCharts.QPieSeries.type": (),
    "PySide2.QtCharts.QtCharts.QPieSeries.verticalPosition": (),

# class PySide2.QtCharts.QtCharts.QPieSlice:

# class PySide2.QtCharts.QtCharts.QPieSlice.LabelPosition:
    "PySide2.QtCharts.QtCharts.QPieSlice.__init__": [('PySide2.QtCore.QObject',), ('str', 'float', 'PySide2.QtCore.QObject')],
    "PySide2.QtCharts.QtCharts.QPieSlice.angleSpan": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.borderColor": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.borderWidth": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.brush": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.color": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.explodeDistanceFactor": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.isExploded": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.isLabelVisible": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.label": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.labelArmLengthFactor": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.labelBrush": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.labelColor": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.labelFont": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.labelPosition": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.pen": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.percentage": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.series": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.setBorderColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setBorderWidth": ('int',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setExplodeDistanceFactor": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setExploded": ('bool',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabel": ('str',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabelArmLengthFactor": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabelBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabelColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabelFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabelPosition": ('PySide2.QtCharts.QtCharts.QPieSlice.LabelPosition',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setLabelVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QPieSlice.setValue": ('float',),
    "PySide2.QtCharts.QtCharts.QPieSlice.startAngle": (),
    "PySide2.QtCharts.QtCharts.QPieSlice.value": (),

# class PySide2.QtCharts.QtCharts.QPolarChart:

# class PySide2.QtCharts.QtCharts.QPolarChart.PolarOrientation:

# class PySide2.QtCharts.QtCharts.QPolarChart.PolarOrientations:
    "PySide2.QtCharts.QtCharts.QPolarChart.__init__": ('PySide2.QtWidgets.QGraphicsItem', 'PySide2.QtCore.Qt.WindowFlags'),
    "PySide2.QtCharts.QtCharts.QPolarChart.addAxis": [('PySide2.QtCharts.QtCharts.QAbstractAxis', 'PySide2.QtCharts.QtCharts.QPolarChart.PolarOrientation'), ('PySide2.QtCharts.QtCharts.QAbstractAxis', 'PySide2.QtCore.Qt.Alignment')],
    "PySide2.QtCharts.QtCharts.QPolarChart.axisPolarOrientation": ('PySide2.QtCharts.QtCharts.QAbstractAxis',),

# class PySide2.QtCharts.QtCharts.QScatterSeries:

# class PySide2.QtCharts.QtCharts.QScatterSeries.MarkerShape:
    "PySide2.QtCharts.QtCharts.QScatterSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.borderColor": (),
    "PySide2.QtCharts.QtCharts.QScatterSeries.brush": (),
    "PySide2.QtCharts.QtCharts.QScatterSeries.color": (),
    "PySide2.QtCharts.QtCharts.QScatterSeries.markerShape": (),
    "PySide2.QtCharts.QtCharts.QScatterSeries.markerSize": (),
    "PySide2.QtCharts.QtCharts.QScatterSeries.setBorderColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.setMarkerShape": ('PySide2.QtCharts.QtCharts.QScatterSeries.MarkerShape',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.setMarkerSize": ('float',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QScatterSeries.type": (),

# class PySide2.QtCharts.QtCharts.QSplineSeries:
    "PySide2.QtCharts.QtCharts.QSplineSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QSplineSeries.type": (),

# class PySide2.QtCharts.QtCharts.QStackedBarSeries:
    "PySide2.QtCharts.QtCharts.QStackedBarSeries.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QStackedBarSeries.type": (),

# class PySide2.QtCharts.QtCharts.QVBarModelMapper:
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.firstBarSetColumn": (),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.firstRow": (),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.lastBarSetColumn": (),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.rowCount": (),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.setFirstBarSetColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.setFirstRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.setLastBarSetColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.setRowCount": ('int',),
    "PySide2.QtCharts.QtCharts.QVBarModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QAbstractBarSeries',),

# class PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper:
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.firstBoxSetColumn": (),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.firstRow": (),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.lastBoxSetColumn": (),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.rowCount": (),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.setFirstBoxSetColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.setFirstRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.setLastBoxSetColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.setRowCount": ('int',),
    "PySide2.QtCharts.QtCharts.QVBoxPlotModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QBoxPlotSeries',),

# class PySide2.QtCharts.QtCharts.QVCandlestickModelMapper:
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.closeRow": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.firstSetColumn": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.highRow": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.lastSetColumn": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.lowRow": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.openRow": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setCloseRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setFirstSetColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setHighRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setLastSetColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setLowRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setOpenRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.setTimestampRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVCandlestickModelMapper.timestampRow": (),

# class PySide2.QtCharts.QtCharts.QVPieModelMapper:
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.firstRow": (),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.labelsColumn": (),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.rowCount": (),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.setFirstRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.setLabelsColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.setRowCount": ('int',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QPieSeries',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.setValuesColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVPieModelMapper.valuesColumn": (),

# class PySide2.QtCharts.QtCharts.QVXYModelMapper:
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.firstRow": (),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.rowCount": (),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.setFirstRow": ('int',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.setRowCount": ('int',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QXYSeries',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.setXColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.setYColumn": ('int',),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.xColumn": (),
    "PySide2.QtCharts.QtCharts.QVXYModelMapper.yColumn": (),

# class PySide2.QtCharts.QtCharts.QValueAxis:
    "PySide2.QtCharts.QtCharts.QValueAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QValueAxis.applyNiceNumbers": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.labelFormat": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.max": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.min": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.minorTickCount": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.setLabelFormat": ('str',),
    "PySide2.QtCharts.QtCharts.QValueAxis.setMax": [('float',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QValueAxis.setMin": [('float',), ('typing.Any',)],
    "PySide2.QtCharts.QtCharts.QValueAxis.setMinorTickCount": ('int',),
    "PySide2.QtCharts.QtCharts.QValueAxis.setRange": [('float', 'float'), ('typing.Any', 'typing.Any')],
    "PySide2.QtCharts.QtCharts.QValueAxis.setTickAnchor": ('float',),
    "PySide2.QtCharts.QtCharts.QValueAxis.setTickCount": ('int',),
    "PySide2.QtCharts.QtCharts.QValueAxis.setTickInterval": ('float',),
    "PySide2.QtCharts.QtCharts.QValueAxis.tickAnchor": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.tickCount": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.tickInterval": (),
    "PySide2.QtCharts.QtCharts.QValueAxis.type": (),

# class PySide2.QtCharts.QtCharts.QXYLegendMarker:
    "PySide2.QtCharts.QtCharts.QXYLegendMarker.__init__": ('PySide2.QtCharts.QtCharts.QXYSeries', 'PySide2.QtCharts.QtCharts.QLegend', 'PySide2.QtCore.QObject'),
    "PySide2.QtCharts.QtCharts.QXYLegendMarker.series": (),
    "PySide2.QtCharts.QtCharts.QXYLegendMarker.type": (),

# class PySide2.QtCharts.QtCharts.QXYModelMapper:
    "PySide2.QtCharts.QtCharts.QXYModelMapper.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.count": (),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.first": (),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.model": (),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.orientation": (),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.series": (),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setCount": ('int',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setFirst": ('int',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setOrientation": ('PySide2.QtCore.Qt.Orientation',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setSeries": ('PySide2.QtCharts.QtCharts.QXYSeries',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setXSection": ('int',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.setYSection": ('int',),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.xSection": (),
    "PySide2.QtCharts.QtCharts.QXYModelMapper.ySection": (),

# class PySide2.QtCharts.QtCharts.QXYSeries:
    "PySide2.QtCharts.QtCharts.QXYSeries.__lshift__": [('PySide2.QtCore.QPointF',), ('typing.Sequence[PySide2.QtCore.QPointF]',)],
    "PySide2.QtCharts.QtCharts.QXYSeries.append": [('PySide2.QtCore.QPointF',), ('float', 'float'), ('typing.Sequence[PySide2.QtCore.QPointF]',)],
    "PySide2.QtCharts.QtCharts.QXYSeries.at": ('int',),
    "PySide2.QtCharts.QtCharts.QXYSeries.brush": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.clear": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.color": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.count": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.insert": ('int', 'PySide2.QtCore.QPointF'),
    "PySide2.QtCharts.QtCharts.QXYSeries.pen": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointLabelsClipping": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointLabelsColor": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointLabelsFont": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointLabelsFormat": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointLabelsVisible": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.points": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointsVector": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.pointsVisible": (),
    "PySide2.QtCharts.QtCharts.QXYSeries.remove": [('PySide2.QtCore.QPointF',), ('float', 'float'), ('int',)],
    "PySide2.QtCharts.QtCharts.QXYSeries.removePoints": ('int', 'int'),
    "PySide2.QtCharts.QtCharts.QXYSeries.replace": [('PySide2.QtCore.QPointF', 'PySide2.QtCore.QPointF'), ('float', 'float', 'float', 'float'), ('int', 'PySide2.QtCore.QPointF'), ('int', 'float', 'float'), ('typing.List[PySide2.QtCore.QPointF]',), ('typing.Sequence[PySide2.QtCore.QPointF]',)],
    "PySide2.QtCharts.QtCharts.QXYSeries.setBrush": ('PySide2.QtGui.QBrush',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPen": ('PySide2.QtGui.QPen',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPointLabelsClipping": ('bool',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPointLabelsColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPointLabelsFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPointLabelsFormat": ('str',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPointLabelsVisible": ('bool',),
    "PySide2.QtCharts.QtCharts.QXYSeries.setPointsVisible": ('bool',),
    }) if "PySide2.QtCharts" in sys.modules else None

# Module PySide2.QtSvg
sig_dict.update({

# class PySide2.QtSvg.QGraphicsSvgItem:

    "PySide2.QtSvg.QGraphicsSvgItem.__init__": [('PySide2.QtWidgets.QGraphicsItem',), ('str', 'PySide2.QtWidgets.QGraphicsItem')],
    "PySide2.QtSvg.QGraphicsSvgItem.boundingRect": (),
    "PySide2.QtSvg.QGraphicsSvgItem.elementId": (),
    "PySide2.QtSvg.QGraphicsSvgItem.isCachingEnabled": (),
    "PySide2.QtSvg.QGraphicsSvgItem.maximumCacheSize": (),
    "PySide2.QtSvg.QGraphicsSvgItem.paint": ('PySide2.QtGui.QPainter', 'PySide2.QtWidgets.QStyleOptionGraphicsItem', 'PySide2.QtWidgets.QWidget'),
    "PySide2.QtSvg.QGraphicsSvgItem.renderer": (),
    "PySide2.QtSvg.QGraphicsSvgItem.setCachingEnabled": ('bool',),
    "PySide2.QtSvg.QGraphicsSvgItem.setElementId": ('str',),
    "PySide2.QtSvg.QGraphicsSvgItem.setMaximumCacheSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtSvg.QGraphicsSvgItem.setSharedRenderer": ('PySide2.QtSvg.QSvgRenderer',),
    "PySide2.QtSvg.QGraphicsSvgItem.type": (),

# class PySide2.QtSvg.QSvgGenerator:
    "PySide2.QtSvg.QSvgGenerator.__init__": (),
    "PySide2.QtSvg.QSvgGenerator.description": (),
    "PySide2.QtSvg.QSvgGenerator.fileName": (),
    "PySide2.QtSvg.QSvgGenerator.metric": ('PySide2.QtGui.QPaintDevice.PaintDeviceMetric',),
    "PySide2.QtSvg.QSvgGenerator.outputDevice": (),
    "PySide2.QtSvg.QSvgGenerator.paintEngine": (),
    "PySide2.QtSvg.QSvgGenerator.resolution": (),
    "PySide2.QtSvg.QSvgGenerator.setDescription": ('str',),
    "PySide2.QtSvg.QSvgGenerator.setFileName": ('str',),
    "PySide2.QtSvg.QSvgGenerator.setOutputDevice": ('PySide2.QtCore.QIODevice',),
    "PySide2.QtSvg.QSvgGenerator.setResolution": ('int',),
    "PySide2.QtSvg.QSvgGenerator.setSize": ('PySide2.QtCore.QSize',),
    "PySide2.QtSvg.QSvgGenerator.setTitle": ('str',),
    "PySide2.QtSvg.QSvgGenerator.setViewBox": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtSvg.QSvgGenerator.size": (),
    "PySide2.QtSvg.QSvgGenerator.title": (),
    "PySide2.QtSvg.QSvgGenerator.viewBox": (),
    "PySide2.QtSvg.QSvgGenerator.viewBoxF": (),

# class PySide2.QtSvg.QSvgRenderer:
    "PySide2.QtSvg.QSvgRenderer.__init__": [('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',), ('PySide2.QtCore.QXmlStreamReader', 'PySide2.QtCore.QObject'), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtSvg.QSvgRenderer.animated": (),
    "PySide2.QtSvg.QSvgRenderer.animationDuration": (),
    "PySide2.QtSvg.QSvgRenderer.boundsOnElement": ('str',),
    "PySide2.QtSvg.QSvgRenderer.currentFrame": (),
    "PySide2.QtSvg.QSvgRenderer.defaultSize": (),
    "PySide2.QtSvg.QSvgRenderer.elementExists": ('str',),
    "PySide2.QtSvg.QSvgRenderer.framesPerSecond": (),
    "PySide2.QtSvg.QSvgRenderer.isValid": (),
    "PySide2.QtSvg.QSvgRenderer.load": [('PySide2.QtCore.QByteArray',), ('PySide2.QtCore.QXmlStreamReader',), ('str',)],
    "PySide2.QtSvg.QSvgRenderer.matrixForElement": ('str',),
    "PySide2.QtSvg.QSvgRenderer.render": [('PySide2.QtGui.QPainter',), ('PySide2.QtGui.QPainter', 'PySide2.QtCore.QRectF'), ('PySide2.QtGui.QPainter', 'str', 'PySide2.QtCore.QRectF')],
    "PySide2.QtSvg.QSvgRenderer.setCurrentFrame": ('int',),
    "PySide2.QtSvg.QSvgRenderer.setFramesPerSecond": ('int',),
    "PySide2.QtSvg.QSvgRenderer.setViewBox": [('PySide2.QtCore.QRect',), ('PySide2.QtCore.QRectF',)],
    "PySide2.QtSvg.QSvgRenderer.viewBox": (),
    "PySide2.QtSvg.QSvgRenderer.viewBoxF": (),

# class PySide2.QtSvg.QSvgWidget:
    "PySide2.QtSvg.QSvgWidget.__init__": [('PySide2.QtWidgets.QWidget',), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtSvg.QSvgWidget.load": [('PySide2.QtCore.QByteArray',), ('str',)],
    "PySide2.QtSvg.QSvgWidget.paintEvent": ('PySide2.QtGui.QPaintEvent',),
    "PySide2.QtSvg.QSvgWidget.renderer": (),
    "PySide2.QtSvg.QSvgWidget.sizeHint": (),
    }) if "PySide2.QtSvg" in sys.modules else None

# Module PySide2.QtDataVisualization
sig_dict.update({

# class PySide2.QtDataVisualization.QtDataVisualization:

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DBars:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.__init__": ('PySide2.QtGui.QSurfaceFormat', 'PySide2.QtGui.QWindow'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.addAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.addSeries": ('PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.axes": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.barSpacing": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.barThickness": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.columnAxis": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.floorLevel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.insertSeries": ('int', 'PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.isBarSpacingRelative": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.isMultiSeriesUniform": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.primarySeries": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.releaseAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.removeSeries": ('PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.rowAxis": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.selectedSeries": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.seriesList": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setBarSpacing": ('PySide2.QtCore.QSizeF',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setBarSpacingRelative": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setBarThickness": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setColumnAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QCategory3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setFloorLevel": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setMultiSeriesUniform": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setPrimarySeries": ('PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setRowAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QCategory3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.setValueAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DBars.valueAxis": (),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera:

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.CameraPreset:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.cameraPreset": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.copyValuesFrom": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.maxZoomLevel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.minZoomLevel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setCameraPosition": ('float', 'float', 'float'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setCameraPreset": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.CameraPreset',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setMaxZoomLevel": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setMinZoomLevel": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setTarget": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setWrapXRotation": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setWrapYRotation": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setXRotation": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setYRotation": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.setZoomLevel": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.target": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.wrapXRotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.wrapYRotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.xRotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.yRotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera.zoomLevel": (),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.isRotationEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.isSelectionEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.isZoomAtTargetEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.isZoomEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent', 'PySide2.QtCore.QPoint'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.mousePressEvent": ('PySide2.QtGui.QMouseEvent', 'PySide2.QtCore.QPoint'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent', 'PySide2.QtCore.QPoint'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.setRotationEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.setSelectionEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.setZoomAtTargetEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.setZoomEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DInputHandler.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DLight:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DLight.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DLight.isAutoPosition": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DLight.setAutoPosition": ('bool',),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DObject:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.copyValuesFrom": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.isDirty": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.parentScene": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.position": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.setDirty": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DObject.setPosition": ('PySide2.QtGui.QVector3D',),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.__init__": ('PySide2.QtGui.QSurfaceFormat', 'PySide2.QtGui.QWindow'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.addAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.addSeries": ('PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.axes": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.axisX": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.axisY": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.axisZ": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.releaseAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.removeSeries": ('PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.selectedSeries": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.seriesList": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.setAxisX": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.setAxisY": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScatter.setAxisZ": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DScene:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.activeCamera": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.activeLight": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.devicePixelRatio": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.graphPositionQuery": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.invalidSelectionPoint": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.isPointInPrimarySubView": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.isPointInSecondarySubView": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.isSecondarySubviewOnTop": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.isSlicingActive": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.primarySubViewport": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.secondarySubViewport": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.selectionQueryPosition": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setActiveCamera": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DCamera',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setActiveLight": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DLight',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setDevicePixelRatio": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setGraphPositionQuery": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setPrimarySubViewport": ('PySide2.QtCore.QRect',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setSecondarySubViewport": ('PySide2.QtCore.QRect',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setSecondarySubviewOnTop": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setSelectionQueryPosition": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.setSlicingActive": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DScene.viewport": (),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.__init__": ('PySide2.QtGui.QSurfaceFormat', 'PySide2.QtGui.QWindow'),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.addAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.addSeries": ('PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.axes": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.axisX": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.axisY": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.axisZ": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.flipHorizontalGrid": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.releaseAxis": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.removeSeries": ('PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.selectedSeries": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.seriesList": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.setAxisX": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.setAxisY": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.setAxisZ": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DSurface.setFlipHorizontalGrid": ('bool',),

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme:

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.ColorStyle:

# class PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.Theme:
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.Theme', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.ambientLightStrength": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.backgroundColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.baseColors": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.baseGradients": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.colorStyle": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.font": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.gridLineColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.highlightLightStrength": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.isBackgroundEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.isGridEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.isLabelBackgroundEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.isLabelBorderEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.labelBackgroundColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.labelTextColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.lightColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.lightStrength": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.multiHighlightColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.multiHighlightGradient": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setAmbientLightStrength": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setBackgroundEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setBaseColors": ('typing.Sequence[PySide2.QtGui.QColor]',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setBaseGradients": ('typing.Sequence[PySide2.QtGui.QLinearGradient]',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setColorStyle": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.ColorStyle',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setGridEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setGridLineColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setHighlightLightStrength": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setLabelBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setLabelBackgroundEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setLabelBorderEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setLabelTextColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setLightColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setLightStrength": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setMultiHighlightColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setMultiHighlightGradient": ('PySide2.QtGui.QLinearGradient',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setSingleHighlightColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setSingleHighlightGradient": ('PySide2.QtGui.QLinearGradient',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setType": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.Theme',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.setWindowColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.singleHighlightColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.singleHighlightGradient": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.type": (),
    "PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.windowColor": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.AxisOrientation:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.AxisType:
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.isAutoAdjustRange": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.isTitleFixed": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.isTitleVisible": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.labelAutoRotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.labels": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.max": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.min": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.orientation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setAutoAdjustRange": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setLabelAutoRotation": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setLabels": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setMax": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setMin": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setRange": ('float', 'float'),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setTitle": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setTitleFixed": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.setTitleVisible": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.title": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DAxis.type": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.ElementType:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.OptimizationHint:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.OptimizationHints:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.SelectionFlag:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.SelectionFlags:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.ShadowQuality:
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.activeInputHandler": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.activeTheme": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.addCustomItem": ('PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.addInputHandler": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.addTheme": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.aspectRatio": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.clearSelection": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.currentFps": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.customItems": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.exposeEvent": ('PySide2.QtGui.QExposeEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.hasContext": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.horizontalAspectRatio": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.inputHandlers": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.isOrthoProjection": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.isPolar": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.isReflection": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.locale": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.margin": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.measureFps": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.mousePressEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.optimizationHints": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.queriedGraphPosition": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.radialLabelOffset": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.reflectivity": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.releaseCustomItem": ('PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.releaseInputHandler": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.releaseTheme": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.removeCustomItem": ('PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.removeCustomItemAt": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.removeCustomItems": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.renderToImage": ('int', 'PySide2.QtCore.QSize'),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.scene": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.selectedAxis": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.selectedCustomItem": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.selectedCustomItemIndex": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.selectedElement": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.selectedLabelIndex": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.selectionMode": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setActiveInputHandler": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setActiveTheme": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setAspectRatio": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setHorizontalAspectRatio": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setMargin": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setMeasureFps": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setOptimizationHints": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.OptimizationHints',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setOrthoProjection": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setPolar": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setRadialLabelOffset": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setReflection": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setReflectivity": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setSelectionMode": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.SelectionFlags',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.setShadowQuality": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.ShadowQuality',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.shadowQuality": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.shadowsSupported": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.themes": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.touchEvent": ('PySide2.QtGui.QTouchEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DGraph.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.InputView:
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.inputPosition": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.inputView": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.mouseDoubleClickEvent": ('PySide2.QtGui.QMouseEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.mouseMoveEvent": ('PySide2.QtGui.QMouseEvent', 'PySide2.QtCore.QPoint'),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.mousePressEvent": ('PySide2.QtGui.QMouseEvent', 'PySide2.QtCore.QPoint'),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.mouseReleaseEvent": ('PySide2.QtGui.QMouseEvent', 'PySide2.QtCore.QPoint'),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.prevDistance": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.previousInputPos": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.scene": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.setInputPosition": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.setInputView": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.InputView',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.setPrevDistance": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.setPreviousInputPos": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.setScene": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DScene',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.touchEvent": ('PySide2.QtGui.QTouchEvent',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DInputHandler.wheelEvent": ('PySide2.QtGui.QWheelEvent',),

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.Mesh:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.SeriesType:
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.baseColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.baseGradient": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.colorStyle": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.isItemLabelVisible": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.isMeshSmooth": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.isVisible": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.itemLabel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.itemLabelFormat": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.mesh": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.meshRotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.multiHighlightColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.multiHighlightGradient": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.name": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setBaseColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setBaseGradient": ('PySide2.QtGui.QLinearGradient',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setColorStyle": ('PySide2.QtDataVisualization.QtDataVisualization.Q3DTheme.ColorStyle',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setItemLabelFormat": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setItemLabelVisible": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setMesh": ('PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.Mesh',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setMeshAxisAndAngle": ('PySide2.QtGui.QVector3D', 'float'),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setMeshRotation": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setMeshSmooth": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setMultiHighlightColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setMultiHighlightGradient": ('PySide2.QtGui.QLinearGradient',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setName": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setSingleHighlightColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setSingleHighlightGradient": ('PySide2.QtGui.QLinearGradient',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setUserDefinedMesh": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.setVisible": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.singleHighlightColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.singleHighlightGradient": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.type": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstract3DSeries.userDefinedMesh": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstractDataProxy:

# class PySide2.QtDataVisualization.QtDataVisualization.QAbstractDataProxy.DataType:
    "PySide2.QtDataVisualization.QtDataVisualization.QAbstractDataProxy.type": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries:
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.dataProxy": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.invalidSelectionPosition": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.meshAngle": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.selectedBar": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.setDataProxy": ('PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.setMeshAngle": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBar3DSeries.setSelectedBar": ('PySide2.QtCore.QPoint',),

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray.__origin__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray.__origin__.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray.__origin__.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray._gorg:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray._gorg.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataArray._gorg.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem:
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.__init__": [(), ('PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem',), ('float',), ('float', 'float')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.__copy__": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.createExtraData": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.rotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.setRotation": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.setValue": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem.value": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy:
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.addRow": [('typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]',), ('typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]', 'str')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.addRows": [('typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]',), ('typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]', 'typing.Sequence[str]')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.array": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.columnLabels": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.insertRow": [('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]'), ('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]', 'str')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.insertRows": [('int', 'typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]'), ('int', 'typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]', 'typing.Sequence[str]')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.itemAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.removeRows": ('int', 'int', 'bool'),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.resetArray": [(), ('typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]',), ('typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]', 'typing.Sequence[str]', 'typing.Sequence[str]')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.rowAt": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.rowCount": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.rowLabels": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.series": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.setColumnLabels": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.setItem": [('PySide2.QtCore.QPoint', 'PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem'), ('int', 'int', 'PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.setRow": [('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]'), ('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]', 'str')],
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.setRowLabels": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QBarDataProxy.setRows": [('int', 'typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]'), ('int', 'typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QBarDataItem]]', 'typing.Sequence[str]')],

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow.__origin__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow.__origin__.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow.__origin__.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow._gorg:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow._gorg.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QBarDataRow._gorg.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QCategory3DAxis:
    "PySide2.QtDataVisualization.QtDataVisualization.QCategory3DAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCategory3DAxis.labels": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCategory3DAxis.setLabels": ('typing.Sequence[str]',),

# class PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem:
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QQuaternion', 'PySide2.QtGui.QImage', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.isPositionAbsolute": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.isScalingAbsolute": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.isShadowCasting": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.isVisible": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.meshFile": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.position": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.rotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.scaling": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setMeshFile": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setPosition": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setPositionAbsolute": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setRotation": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setRotationAxisAndAngle": ('PySide2.QtGui.QVector3D', 'float'),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setScaling": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setScalingAbsolute": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setShadowCasting": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setTextureFile": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setTextureImage": ('PySide2.QtGui.QImage',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.setVisible": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DItem.textureFile": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel:
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtGui.QFont', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QQuaternion', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.backgroundColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.font": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.isBackgroundEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.isBorderEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.isFacingCamera": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setBackgroundEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setBorderEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setFacingCamera": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setText": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.setTextColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.text": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DLabel.textColor": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume:
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QQuaternion', 'int', 'int', 'int', 'typing.List[typing.Char]', 'PySide2.QtGui.QImage.Format', 'typing.List[int]', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.alphaMultiplier": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.colorTable": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.createTextureData": ('typing.List[PySide2.QtGui.QImage]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.drawSliceFrames": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.drawSlices": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.preserveOpacity": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.renderSlice": ('PySide2.QtCore.Qt.Axis', 'int'),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setAlphaMultiplier": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setColorTable": ('typing.List[int]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setDrawSliceFrames": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setDrawSlices": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setPreserveOpacity": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceFrameColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceFrameGaps": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceFrameThicknesses": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceFrameWidths": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceIndexX": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceIndexY": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceIndexZ": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSliceIndices": ('int', 'int', 'int'),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setSubTextureData": [('PySide2.QtCore.Qt.Axis', 'int', 'PySide2.QtGui.QImage'), ('PySide2.QtCore.Qt.Axis', 'int', 'str')],
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setTextureData": ('typing.List[typing.Char]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setTextureDepth": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setTextureDimensions": ('int', 'int', 'int'),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setTextureFormat": ('PySide2.QtGui.QImage.Format',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setTextureHeight": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setTextureWidth": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.setUseHighDefShader": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceFrameColor": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceFrameGaps": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceFrameThicknesses": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceFrameWidths": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceIndexX": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceIndexY": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.sliceIndexZ": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.textureData": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.textureDataWidth": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.textureDepth": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.textureFormat": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.textureHeight": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.textureWidth": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QCustom3DVolume.useHighDefShader": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy:
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtGui.QImage', 'PySide2.QtCore.QObject'), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.heightMap": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.heightMapFile": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.maxXValue": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.maxZValue": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.minXValue": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.minZValue": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setHeightMap": ('PySide2.QtGui.QImage',),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setHeightMapFile": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setMaxXValue": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setMaxZValue": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setMinXValue": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setMinZValue": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QHeightMapSurfaceDataProxy.setValueRanges": ('float', 'float', 'float', 'float'),

# class PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy:

# class PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.MultiMatchBehavior:
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.__init__": [('PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'str', 'typing.Sequence[str]', 'typing.Sequence[str]', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'typing.Sequence[str]', 'typing.Sequence[str]', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',)],
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.autoColumnCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.autoRowCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.columnCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.columnCategoryIndex": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.columnRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.columnRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.columnRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.itemModel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.multiMatchBehavior": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.remap": ('str', 'str', 'str', 'str', 'typing.Sequence[str]', 'typing.Sequence[str]'),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rotationRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rotationRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rotationRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rowCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rowCategoryIndex": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rowRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rowRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.rowRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setAutoColumnCategories": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setAutoRowCategories": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setColumnCategories": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setColumnRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setColumnRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setColumnRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setItemModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setMultiMatchBehavior": ('PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.MultiMatchBehavior',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRotationRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRotationRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRotationRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRowCategories": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRowRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRowRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setRowRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setUseModelCategories": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setValueRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setValueRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.setValueRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.useModelCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.valueRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.valueRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelBarDataProxy.valueRoleReplace": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy:
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.__init__": [('PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',)],
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.itemModel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.remap": ('str', 'str', 'str', 'str'),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.rotationRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.rotationRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.rotationRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setItemModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setRotationRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setRotationRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setRotationRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setXPosRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setXPosRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setXPosRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setYPosRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setYPosRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setYPosRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setZPosRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setZPosRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.setZPosRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.xPosRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.xPosRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.xPosRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.yPosRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.yPosRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.yPosRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.zPosRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.zPosRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelScatterDataProxy.zPosRoleReplace": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy:

# class PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.MultiMatchBehavior:
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.__init__": [('PySide2.QtCore.QAbstractItemModel', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'str', 'str', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'str', 'str', 'typing.Sequence[str]', 'typing.Sequence[str]', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QAbstractItemModel', 'str', 'str', 'str', 'typing.Sequence[str]', 'typing.Sequence[str]', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',)],
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.autoColumnCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.autoRowCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.columnCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.columnCategoryIndex": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.columnRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.columnRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.columnRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.itemModel": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.multiMatchBehavior": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.remap": ('str', 'str', 'str', 'str', 'str', 'typing.Sequence[str]', 'typing.Sequence[str]'),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.rowCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.rowCategoryIndex": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.rowRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.rowRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.rowRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setAutoColumnCategories": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setAutoRowCategories": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setColumnCategories": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setColumnRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setColumnRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setColumnRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setItemModel": ('PySide2.QtCore.QAbstractItemModel',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setMultiMatchBehavior": ('PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.MultiMatchBehavior',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setRowCategories": ('typing.Sequence[str]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setRowRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setRowRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setRowRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setUseModelCategories": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setXPosRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setXPosRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setXPosRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setYPosRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setYPosRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setYPosRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setZPosRole": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setZPosRolePattern": ('PySide2.QtCore.QRegExp',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.setZPosRoleReplace": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.useModelCategories": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.xPosRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.xPosRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.xPosRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.yPosRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.yPosRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.yPosRoleReplace": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.zPosRole": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.zPosRolePattern": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QItemModelSurfaceDataProxy.zPosRoleReplace": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter:
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.autoSubGrid": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.base": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.createNewInstance": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.populateCopy": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter',),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.positionAt": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.recalculate": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.setAutoSubGrid": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.setBase": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.setShowEdgeLabels": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.showEdgeLabels": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QLogValue3DAxisFormatter.valueAt": ('float',),

# class PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries:
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.dataProxy": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.invalidSelectionIndex": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.itemSize": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.selectedItem": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.setDataProxy": ('PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.setItemSize": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatter3DSeries.setSelectedItem": ('int',),

# class PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem:
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.__init__": [(), ('PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem',), ('PySide2.QtGui.QVector3D',), ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QQuaternion')],
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.__copy__": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.createExtraData": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.position": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.rotation": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.setPosition": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.setRotation": ('PySide2.QtGui.QQuaternion',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.setX": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.setY": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.setZ": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.x": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.y": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem.z": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy:
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.addItem": ('PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.addItems": ('typing.List[PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.array": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.insertItem": ('int', 'PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem'),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.insertItems": ('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem]'),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.itemAt": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.itemCount": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.removeItems": ('int', 'int'),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.resetArray": ('typing.List[PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.series": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.setItem": ('int', 'PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem'),
    "PySide2.QtDataVisualization.QtDataVisualization.QScatterDataProxy.setItems": ('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QScatterDataItem]'),

# class PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.DrawFlag:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.DrawFlags:
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy', 'PySide2.QtCore.QObject')],
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.dataProxy": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.drawMode": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.invalidSelectionPosition": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.isFlatShadingEnabled": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.isFlatShadingSupported": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.selectedPoint": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.setDataProxy": ('PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.setDrawMode": ('PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.DrawFlags',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.setFlatShadingEnabled": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.setSelectedPoint": ('PySide2.QtCore.QPoint',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.setTexture": ('PySide2.QtGui.QImage',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.setTextureFile": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.texture": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurface3DSeries.textureFile": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray.__origin__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray.__origin__.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray.__origin__.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray._gorg:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray._gorg.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataArray._gorg.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem:
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.__init__": [(), ('PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem',), ('PySide2.QtGui.QVector3D',)],
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.__copy__": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.createExtraData": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.position": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.setPosition": ('PySide2.QtGui.QVector3D',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.setX": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.setY": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.setZ": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.x": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.y": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem.z": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy:
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.addRow": ('typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.addRows": ('typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.array": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.columnCount": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.insertRow": ('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]'),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.insertRows": ('int', 'typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]]'),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.itemAt": [('PySide2.QtCore.QPoint',), ('int', 'int')],
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.removeRows": ('int', 'int'),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.resetArray": ('typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]]',),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.rowCount": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.series": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.setItem": [('PySide2.QtCore.QPoint', 'PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem'), ('int', 'int', 'PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem')],
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.setRow": ('int', 'typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]'),
    "PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataProxy.setRows": ('int', 'typing.List[typing.List[PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataItem]]'),

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow.__origin__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow.__origin__.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow.__origin__.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow._gorg:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow._gorg.__extra__:

# class PySide2.QtDataVisualization.QtDataVisualization.QSurfaceDataRow._gorg.__next_in_mro__:

# class PySide2.QtDataVisualization.QtDataVisualization.QTouch3DInputHandler:
    "PySide2.QtDataVisualization.QtDataVisualization.QTouch3DInputHandler.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QTouch3DInputHandler.touchEvent": ('PySide2.QtGui.QTouchEvent',),

# class PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis:
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.formatter": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.labelFormat": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.reversed": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.segmentCount": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.setFormatter": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.setLabelFormat": ('str',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.setReversed": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.setSegmentCount": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.setSubSegmentCount": ('int',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxis.subSegmentCount": (),

# class PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter:
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.allowNegatives": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.allowZero": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.axis": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.createNewInstance": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.gridPositions": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.labelPositions": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.labelStrings": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.locale": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.markDirty": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.populateCopy": ('PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.positionAt": ('float',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.recalculate": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.setAllowNegatives": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.setAllowZero": ('bool',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.setLocale": ('PySide2.QtCore.QLocale',),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.stringForValue": ('float', 'str'),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.subGridPositions": (),
    "PySide2.QtDataVisualization.QtDataVisualization.QValue3DAxisFormatter.valueAt": ('float',),

    "PySide2.QtDataVisualization.QtDataVisualization.qDefaultSurfaceFormat": ('bool',),
    }) if "PySide2.QtDataVisualization" in sys.modules else None

# Module PySide2.QtUiTools
sig_dict.update({

# class PySide2.QtUiTools.QUiLoader:
    "PySide2.QtUiTools.QUiLoader.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtUiTools.QUiLoader.addPluginPath": ('str',),
    "PySide2.QtUiTools.QUiLoader.availableLayouts": (),
    "PySide2.QtUiTools.QUiLoader.availableWidgets": (),
    "PySide2.QtUiTools.QUiLoader.clearPluginPaths": (),
    "PySide2.QtUiTools.QUiLoader.createAction": ('PySide2.QtCore.QObject', 'str'),
    "PySide2.QtUiTools.QUiLoader.createActionGroup": ('PySide2.QtCore.QObject', 'str'),
    "PySide2.QtUiTools.QUiLoader.createLayout": ('str', 'PySide2.QtCore.QObject', 'str'),
    "PySide2.QtUiTools.QUiLoader.createWidget": ('str', 'PySide2.QtWidgets.QWidget', 'str'),
    "PySide2.QtUiTools.QUiLoader.errorString": (),
    "PySide2.QtUiTools.QUiLoader.isLanguageChangeEnabled": (),
    "PySide2.QtUiTools.QUiLoader.isTranslationEnabled": (),
    "PySide2.QtUiTools.QUiLoader.load": [('PySide2.QtCore.QIODevice', 'PySide2.QtWidgets.QWidget'), ('str', 'PySide2.QtWidgets.QWidget')],
    "PySide2.QtUiTools.QUiLoader.pluginPaths": (),
    "PySide2.QtUiTools.QUiLoader.registerCustomWidget": ('object',),
    "PySide2.QtUiTools.QUiLoader.setLanguageChangeEnabled": ('bool',),
    "PySide2.QtUiTools.QUiLoader.setTranslationEnabled": ('bool',),
    "PySide2.QtUiTools.QUiLoader.setWorkingDirectory": ('PySide2.QtCore.QDir',),
    "PySide2.QtUiTools.QUiLoader.workingDirectory": (),
    }) if "PySide2.QtUiTools" in sys.modules else None

# Module PySide2.QtWebChannel
sig_dict.update({

# class PySide2.QtWebChannel.QWebChannel:
    "PySide2.QtWebChannel.QWebChannel.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWebChannel.QWebChannel.blockUpdates": (),
    "PySide2.QtWebChannel.QWebChannel.connectTo": ('PySide2.QtWebChannel.QWebChannelAbstractTransport',),
    "PySide2.QtWebChannel.QWebChannel.deregisterObject": ('PySide2.QtCore.QObject',),
    "PySide2.QtWebChannel.QWebChannel.disconnectFrom": ('PySide2.QtWebChannel.QWebChannelAbstractTransport',),
    "PySide2.QtWebChannel.QWebChannel.registerObject": ('str', 'PySide2.QtCore.QObject'),
    "PySide2.QtWebChannel.QWebChannel.registerObjects": ('typing.Dict[str, PySide2.QtCore.QObject]',),
    "PySide2.QtWebChannel.QWebChannel.registeredObjects": (),
    "PySide2.QtWebChannel.QWebChannel.setBlockUpdates": ('bool',),

# class PySide2.QtWebChannel.QWebChannelAbstractTransport:
    "PySide2.QtWebChannel.QWebChannelAbstractTransport.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWebChannel.QWebChannelAbstractTransport.sendMessage": ('typing.Dict[str, PySide2.QtCore.QJsonValue]',),
    }) if "PySide2.QtWebChannel" in sys.modules else None

# Module PySide2.QtWebEngineCore
sig_dict.update({

# class PySide2.QtWebEngineCore.QWebEngineCookieStore:
    "PySide2.QtWebEngineCore.QWebEngineCookieStore.deleteAllCookies": (),
    "PySide2.QtWebEngineCore.QWebEngineCookieStore.deleteSessionCookies": (),
    "PySide2.QtWebEngineCore.QWebEngineCookieStore.loadAllCookies": (),

# class PySide2.QtWebEngineCore.QWebEngineHttpRequest:

# class PySide2.QtWebEngineCore.QWebEngineHttpRequest.Method:
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.__init__": [('PySide2.QtCore.QUrl', 'PySide2.QtWebEngineCore.QWebEngineHttpRequest.Method'), ('PySide2.QtWebEngineCore.QWebEngineHttpRequest',)],
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.hasHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.header": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.headers": (),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.method": (),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.postData": (),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.postRequest": ('PySide2.QtCore.QUrl', 'typing.Dict[str, str]'),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.setHeader": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.setMethod": ('PySide2.QtWebEngineCore.QWebEngineHttpRequest.Method',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.setPostData": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.swap": ('PySide2.QtWebEngineCore.QWebEngineHttpRequest',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.unsetHeader": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineCore.QWebEngineHttpRequest.url": (),

# class PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo:

# class PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.NavigationType:

# class PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.ResourceType:
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.block": ('bool',),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.changed": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.firstPartyUrl": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.initiator": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.navigationType": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.redirect": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.requestMethod": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.requestUrl": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.resourceType": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo.setHttpHeader": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QByteArray'),

# class PySide2.QtWebEngineCore.QWebEngineUrlRequestInterceptor:
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInterceptor.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestInterceptor.interceptRequest": ('PySide2.QtWebEngineCore.QWebEngineUrlRequestInfo',),

# class PySide2.QtWebEngineCore.QWebEngineUrlRequestJob:

# class PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.Error:
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.fail": ('PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.Error',),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.initiator": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.redirect": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.reply": ('PySide2.QtCore.QByteArray', 'PySide2.QtCore.QIODevice'),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.requestHeaders": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.requestMethod": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlRequestJob.requestUrl": (),

# class PySide2.QtWebEngineCore.QWebEngineUrlScheme:

# class PySide2.QtWebEngineCore.QWebEngineUrlScheme.Flag:

# class PySide2.QtWebEngineCore.QWebEngineUrlScheme.Flags:

# class PySide2.QtWebEngineCore.QWebEngineUrlScheme.SpecialPort:

# class PySide2.QtWebEngineCore.QWebEngineUrlScheme.Syntax:
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.__init__": [(), ('PySide2.QtCore.QByteArray',), ('PySide2.QtWebEngineCore.QWebEngineUrlScheme',)],
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.__copy__": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.defaultPort": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.flags": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.name": (),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.registerScheme": ('PySide2.QtWebEngineCore.QWebEngineUrlScheme',),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.schemeByName": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.setDefaultPort": ('int',),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.setFlags": ('PySide2.QtWebEngineCore.QWebEngineUrlScheme.Flags',),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.setName": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.setSyntax": ('PySide2.QtWebEngineCore.QWebEngineUrlScheme.Syntax',),
    "PySide2.QtWebEngineCore.QWebEngineUrlScheme.syntax": (),

# class PySide2.QtWebEngineCore.QWebEngineUrlSchemeHandler:
    "PySide2.QtWebEngineCore.QWebEngineUrlSchemeHandler.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWebEngineCore.QWebEngineUrlSchemeHandler.requestStarted": ('PySide2.QtWebEngineCore.QWebEngineUrlRequestJob',),
    }) if "PySide2.QtWebEngineCore" in sys.modules else None

# Module PySide2.QtWebEngine
sig_dict.update({

# class PySide2.QtWebEngine.QtWebEngine:
    "PySide2.QtWebEngine.QtWebEngine.initialize": (),
    }) if "PySide2.QtWebEngine" in sys.modules else None

# Module PySide2.QtWebEngineWidgets
sig_dict.update({

# class PySide2.QtWebEngineWidgets.QWebEngineCertificateError:

# class PySide2.QtWebEngineWidgets.QWebEngineCertificateError.Error:
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.__init__": [('PySide2.QtWebEngineWidgets.QWebEngineCertificateError',), ('int', 'PySide2.QtCore.QUrl', 'bool', 'str')],
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.answered": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.certificateChain": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.defer": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.deferred": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.error": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.errorDescription": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.ignoreCertificateError": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.isOverridable": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.rejectCertificate": (),
    "PySide2.QtWebEngineWidgets.QWebEngineCertificateError.url": (),

# class PySide2.QtWebEngineWidgets.QWebEngineContextMenuData:

# class PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.EditFlag:

# class PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.EditFlags:

# class PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.MediaFlag:

# class PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.MediaFlags:

# class PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.MediaType:
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.__init__": [(), ('PySide2.QtWebEngineWidgets.QWebEngineContextMenuData',)],
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.__copy__": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.editFlags": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.isContentEditable": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.isValid": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.linkText": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.linkUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.mediaFlags": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.mediaType": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.mediaUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.misspelledWord": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.position": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.selectedText": (),
    "PySide2.QtWebEngineWidgets.QWebEngineContextMenuData.spellCheckerSuggestions": (),

# class PySide2.QtWebEngineWidgets.QWebEngineDownloadItem:

# class PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.DownloadInterruptReason:

# class PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.DownloadState:

# class PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.DownloadType:

# class PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.SavePageFormat:
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.accept": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.cancel": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.downloadDirectory": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.downloadFileName": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.id": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.interruptReason": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.interruptReasonString": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.isFinished": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.isPaused": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.isSavePageDownload": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.mimeType": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.page": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.path": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.pause": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.receivedBytes": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.resume": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.savePageFormat": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.setDownloadDirectory": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.setDownloadFileName": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.setPath": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.setSavePageFormat": ('PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.SavePageFormat',),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.state": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.suggestedFileName": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.totalBytes": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.type": (),
    "PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.url": (),

# class PySide2.QtWebEngineWidgets.QWebEngineFullScreenRequest:
    "PySide2.QtWebEngineWidgets.QWebEngineFullScreenRequest.accept": (),
    "PySide2.QtWebEngineWidgets.QWebEngineFullScreenRequest.origin": (),
    "PySide2.QtWebEngineWidgets.QWebEngineFullScreenRequest.reject": (),
    "PySide2.QtWebEngineWidgets.QWebEngineFullScreenRequest.toggleOn": (),

# class PySide2.QtWebEngineWidgets.QWebEngineHistory:
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.__lshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.__rshift__": ('PySide2.QtCore.QDataStream',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.back": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.backItem": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.backItems": ('int',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.canGoBack": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.canGoForward": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.clear": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.count": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.currentItem": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.currentItemIndex": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.forward": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.forwardItem": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.forwardItems": ('int',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.goToItem": ('PySide2.QtWebEngineWidgets.QWebEngineHistoryItem',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.itemAt": ('int',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistory.items": (),

# class PySide2.QtWebEngineWidgets.QWebEngineHistoryItem:
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.__init__": ('PySide2.QtWebEngineWidgets.QWebEngineHistoryItem',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.__copy__": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.iconUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.isValid": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.lastVisited": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.originalUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.swap": ('PySide2.QtWebEngineWidgets.QWebEngineHistoryItem',),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.title": (),
    "PySide2.QtWebEngineWidgets.QWebEngineHistoryItem.url": (),

# class PySide2.QtWebEngineWidgets.QWebEnginePage:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.Feature:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.FileSelectionMode:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.FindFlag:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.FindFlags:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.JavaScriptConsoleMessageLevel:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.NavigationType:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.PermissionPolicy:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.RenderProcessTerminationStatus:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.WebAction:

# class PySide2.QtWebEngineWidgets.QWebEnginePage.WebWindowType:
    "PySide2.QtWebEngineWidgets.QWebEnginePage.__init__": [('PySide2.QtCore.QObject',), ('PySide2.QtWebEngineWidgets.QWebEngineProfile', 'PySide2.QtCore.QObject')],
    "PySide2.QtWebEngineWidgets.QWebEnginePage.acceptNavigationRequest": ('PySide2.QtCore.QUrl', 'PySide2.QtWebEngineWidgets.QWebEnginePage.NavigationType', 'bool'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.action": ('PySide2.QtWebEngineWidgets.QWebEnginePage.WebAction',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.backgroundColor": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.certificateError": ('PySide2.QtWebEngineWidgets.QWebEngineCertificateError',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.chooseFiles": ('PySide2.QtWebEngineWidgets.QWebEnginePage.FileSelectionMode', 'typing.Sequence[str]', 'typing.Sequence[str]'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.contentsSize": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.contextMenuData": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.createStandardContextMenu": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.createWindow": ('PySide2.QtWebEngineWidgets.QWebEnginePage.WebWindowType',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.devToolsPage": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.download": ('PySide2.QtCore.QUrl', 'str'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.findText": ('str', 'PySide2.QtWebEngineWidgets.QWebEnginePage.FindFlags'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.hasSelection": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.history": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.icon": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.iconUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.inspectedPage": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.isAudioMuted": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.isVisible": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.javaScriptAlert": ('PySide2.QtCore.QUrl', 'str'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.javaScriptConfirm": ('PySide2.QtCore.QUrl', 'str'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.javaScriptConsoleMessage": ('PySide2.QtWebEngineWidgets.QWebEnginePage.JavaScriptConsoleMessageLevel', 'str', 'int', 'str'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.javaScriptPrompt": ('PySide2.QtCore.QUrl', 'str', 'str'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.load": [('PySide2.QtCore.QUrl',), ('PySide2.QtWebEngineCore.QWebEngineHttpRequest',)],
    "PySide2.QtWebEngineWidgets.QWebEnginePage.printToPdf": ('str', 'PySide2.QtGui.QPageLayout'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.profile": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.recentlyAudible": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.replaceMisspelledWord": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.requestedUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.runJavaScript": [('str',), ('str', 'int')],
    "PySide2.QtWebEngineWidgets.QWebEnginePage.save": ('str', 'PySide2.QtWebEngineWidgets.QWebEngineDownloadItem.SavePageFormat'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.scripts": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.scrollPosition": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.selectedText": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setAudioMuted": ('bool',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setBackgroundColor": ('PySide2.QtGui.QColor',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setContent": ('PySide2.QtCore.QByteArray', 'str', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setDevToolsPage": ('PySide2.QtWebEngineWidgets.QWebEnginePage',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setFeaturePermission": ('PySide2.QtCore.QUrl', 'PySide2.QtWebEngineWidgets.QWebEnginePage.Feature', 'PySide2.QtWebEngineWidgets.QWebEnginePage.PermissionPolicy'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setHtml": ('str', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setInspectedPage": ('PySide2.QtWebEngineWidgets.QWebEnginePage',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setUrlRequestInterceptor": ('PySide2.QtWebEngineCore.QWebEngineUrlRequestInterceptor',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setView": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setVisible": ('bool',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setWebChannel": [('PySide2.QtWebChannel.QWebChannel',), ('PySide2.QtWebChannel.QWebChannel', 'int')],
    "PySide2.QtWebEngineWidgets.QWebEnginePage.setZoomFactor": ('float',),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.settings": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.title": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.triggerAction": ('PySide2.QtWebEngineWidgets.QWebEnginePage.WebAction', 'bool'),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.url": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.view": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.webChannel": (),
    "PySide2.QtWebEngineWidgets.QWebEnginePage.zoomFactor": (),

# class PySide2.QtWebEngineWidgets.QWebEngineProfile:

# class PySide2.QtWebEngineWidgets.QWebEngineProfile.HttpCacheType:

# class PySide2.QtWebEngineWidgets.QWebEngineProfile.PersistentCookiesPolicy:
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.__init__": [('PySide2.QtCore.QObject',), ('str', 'PySide2.QtCore.QObject')],
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.cachePath": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.clearAllVisitedLinks": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.clearHttpCache": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.clearVisitedLinks": ('typing.Sequence[PySide2.QtCore.QUrl]',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.cookieStore": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.defaultProfile": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.downloadPath": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.httpAcceptLanguage": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.httpCacheMaximumSize": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.httpCacheType": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.httpUserAgent": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.installUrlSchemeHandler": ('PySide2.QtCore.QByteArray', 'PySide2.QtWebEngineCore.QWebEngineUrlSchemeHandler'),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.isOffTheRecord": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.isSpellCheckEnabled": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.isUsedForGlobalCertificateVerification": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.persistentCookiesPolicy": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.persistentStoragePath": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.removeAllUrlSchemeHandlers": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.removeUrlScheme": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.removeUrlSchemeHandler": ('PySide2.QtWebEngineCore.QWebEngineUrlSchemeHandler',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.scripts": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setCachePath": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setDownloadPath": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setHttpAcceptLanguage": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setHttpCacheMaximumSize": ('int',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setHttpCacheType": ('PySide2.QtWebEngineWidgets.QWebEngineProfile.HttpCacheType',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setHttpUserAgent": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setPersistentCookiesPolicy": ('PySide2.QtWebEngineWidgets.QWebEngineProfile.PersistentCookiesPolicy',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setPersistentStoragePath": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setRequestInterceptor": ('PySide2.QtWebEngineCore.QWebEngineUrlRequestInterceptor',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setSpellCheckEnabled": ('bool',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setSpellCheckLanguages": ('typing.Sequence[str]',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setUrlRequestInterceptor": ('PySide2.QtWebEngineCore.QWebEngineUrlRequestInterceptor',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.setUseForGlobalCertificateVerification": ('bool',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.settings": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.spellCheckLanguages": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.storageName": (),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.urlSchemeHandler": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebEngineWidgets.QWebEngineProfile.visitedLinksContainsUrl": ('PySide2.QtCore.QUrl',),

# class PySide2.QtWebEngineWidgets.QWebEngineScript:

# class PySide2.QtWebEngineWidgets.QWebEngineScript.InjectionPoint:

# class PySide2.QtWebEngineWidgets.QWebEngineScript.ScriptWorldId:
    "PySide2.QtWebEngineWidgets.QWebEngineScript.__init__": [(), ('PySide2.QtWebEngineWidgets.QWebEngineScript',)],
    "PySide2.QtWebEngineWidgets.QWebEngineScript.__copy__": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.injectionPoint": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.isNull": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.name": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.runsOnSubFrames": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.setInjectionPoint": ('PySide2.QtWebEngineWidgets.QWebEngineScript.InjectionPoint',),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.setName": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.setRunsOnSubFrames": ('bool',),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.setSourceCode": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.setWorldId": ('int',),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.sourceCode": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.swap": ('PySide2.QtWebEngineWidgets.QWebEngineScript',),
    "PySide2.QtWebEngineWidgets.QWebEngineScript.worldId": (),

# class PySide2.QtWebEngineWidgets.QWebEngineScriptCollection:
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.clear": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.contains": ('PySide2.QtWebEngineWidgets.QWebEngineScript',),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.count": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.findScript": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.findScripts": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.insert": [('PySide2.QtWebEngineWidgets.QWebEngineScript',), ('typing.Sequence[PySide2.QtWebEngineWidgets.QWebEngineScript]',)],
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.isEmpty": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.remove": ('PySide2.QtWebEngineWidgets.QWebEngineScript',),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.size": (),
    "PySide2.QtWebEngineWidgets.QWebEngineScriptCollection.toList": (),

# class PySide2.QtWebEngineWidgets.QWebEngineSettings:

# class PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily:

# class PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize:

# class PySide2.QtWebEngineWidgets.QWebEngineSettings.UnknownUrlSchemePolicy:

# class PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute:
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.defaultSettings": (),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.defaultTextEncoding": (),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.fontFamily": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.fontSize": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.globalSettings": (),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.resetAttribute": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.resetFontFamily": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.resetFontSize": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.resetUnknownUrlSchemePolicy": (),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.setAttribute": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute', 'bool'),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.setDefaultTextEncoding": ('str',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.setFontFamily": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily', 'str'),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.setFontSize": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize', 'int'),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.setUnknownUrlSchemePolicy": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.UnknownUrlSchemePolicy',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.testAttribute": ('PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute',),
    "PySide2.QtWebEngineWidgets.QWebEngineSettings.unknownUrlSchemePolicy": (),

# class PySide2.QtWebEngineWidgets.QWebEngineView:
    "PySide2.QtWebEngineWidgets.QWebEngineView.__init__": ('PySide2.QtWidgets.QWidget',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.back": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.closeEvent": ('PySide2.QtGui.QCloseEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.contextMenuEvent": ('PySide2.QtGui.QContextMenuEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.createWindow": ('PySide2.QtWebEngineWidgets.QWebEnginePage.WebWindowType',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.dragEnterEvent": ('PySide2.QtGui.QDragEnterEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.dragLeaveEvent": ('PySide2.QtGui.QDragLeaveEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.dragMoveEvent": ('PySide2.QtGui.QDragMoveEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.dropEvent": ('PySide2.QtGui.QDropEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.event": ('PySide2.QtCore.QEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.findText": ('str', 'PySide2.QtWebEngineWidgets.QWebEnginePage.FindFlags'),
    "PySide2.QtWebEngineWidgets.QWebEngineView.forward": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.hasSelection": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.hideEvent": ('PySide2.QtGui.QHideEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.history": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.icon": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.iconUrl": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.load": [('PySide2.QtCore.QUrl',), ('PySide2.QtWebEngineCore.QWebEngineHttpRequest',)],
    "PySide2.QtWebEngineWidgets.QWebEngineView.page": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.pageAction": ('PySide2.QtWebEngineWidgets.QWebEnginePage.WebAction',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.reload": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.selectedText": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.setContent": ('PySide2.QtCore.QByteArray', 'str', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWebEngineWidgets.QWebEngineView.setHtml": ('str', 'PySide2.QtCore.QUrl'),
    "PySide2.QtWebEngineWidgets.QWebEngineView.setPage": ('PySide2.QtWebEngineWidgets.QWebEnginePage',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.setUrl": ('PySide2.QtCore.QUrl',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.setZoomFactor": ('float',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.settings": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.showEvent": ('PySide2.QtGui.QShowEvent',),
    "PySide2.QtWebEngineWidgets.QWebEngineView.sizeHint": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.stop": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.title": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.triggerPageAction": ('PySide2.QtWebEngineWidgets.QWebEnginePage.WebAction', 'bool'),
    "PySide2.QtWebEngineWidgets.QWebEngineView.url": (),
    "PySide2.QtWebEngineWidgets.QWebEngineView.zoomFactor": (),
    }) if "PySide2.QtWebEngineWidgets" in sys.modules else None

# Module PySide2.QtWebSockets
sig_dict.update({

# class PySide2.QtWebSockets.QMaskGenerator:
    "PySide2.QtWebSockets.QMaskGenerator.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.QtWebSockets.QMaskGenerator.nextMask": (),
    "PySide2.QtWebSockets.QMaskGenerator.seed": (),

# class PySide2.QtWebSockets.QWebSocket:
    "PySide2.QtWebSockets.QWebSocket.__init__": ('str', 'PySide2.QtWebSockets.QWebSocketProtocol.Version', 'PySide2.QtCore.QObject'),
    "PySide2.QtWebSockets.QWebSocket.abort": (),
    "PySide2.QtWebSockets.QWebSocket.bytesToWrite": (),
    "PySide2.QtWebSockets.QWebSocket.close": ('PySide2.QtWebSockets.QWebSocketProtocol.CloseCode', 'str'),
    "PySide2.QtWebSockets.QWebSocket.closeCode": (),
    "PySide2.QtWebSockets.QWebSocket.closeReason": (),
    "PySide2.QtWebSockets.QWebSocket.error": (),
    "PySide2.QtWebSockets.QWebSocket.errorString": (),
    "PySide2.QtWebSockets.QWebSocket.flush": (),
    "PySide2.QtWebSockets.QWebSocket.isValid": (),
    "PySide2.QtWebSockets.QWebSocket.localAddress": (),
    "PySide2.QtWebSockets.QWebSocket.localPort": (),
    "PySide2.QtWebSockets.QWebSocket.maskGenerator": (),
    "PySide2.QtWebSockets.QWebSocket.open": [('PySide2.QtCore.QUrl',), ('PySide2.QtNetwork.QNetworkRequest',)],
    "PySide2.QtWebSockets.QWebSocket.origin": (),
    "PySide2.QtWebSockets.QWebSocket.pauseMode": (),
    "PySide2.QtWebSockets.QWebSocket.peerAddress": (),
    "PySide2.QtWebSockets.QWebSocket.peerName": (),
    "PySide2.QtWebSockets.QWebSocket.peerPort": (),
    "PySide2.QtWebSockets.QWebSocket.ping": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebSockets.QWebSocket.proxy": (),
    "PySide2.QtWebSockets.QWebSocket.readBufferSize": (),
    "PySide2.QtWebSockets.QWebSocket.request": (),
    "PySide2.QtWebSockets.QWebSocket.requestUrl": (),
    "PySide2.QtWebSockets.QWebSocket.resourceName": (),
    "PySide2.QtWebSockets.QWebSocket.resume": (),
    "PySide2.QtWebSockets.QWebSocket.sendBinaryMessage": ('PySide2.QtCore.QByteArray',),
    "PySide2.QtWebSockets.QWebSocket.sendTextMessage": ('str',),
    "PySide2.QtWebSockets.QWebSocket.setMaskGenerator": ('PySide2.QtWebSockets.QMaskGenerator',),
    "PySide2.QtWebSockets.QWebSocket.setPauseMode": ('PySide2.QtNetwork.QAbstractSocket.PauseModes',),
    "PySide2.QtWebSockets.QWebSocket.setProxy": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtWebSockets.QWebSocket.setReadBufferSize": ('int',),
    "PySide2.QtWebSockets.QWebSocket.state": (),
    "PySide2.QtWebSockets.QWebSocket.version": (),

# class PySide2.QtWebSockets.QWebSocketCorsAuthenticator:
    "PySide2.QtWebSockets.QWebSocketCorsAuthenticator.__init__": [('PySide2.QtWebSockets.QWebSocketCorsAuthenticator',), ('str',)],
    "PySide2.QtWebSockets.QWebSocketCorsAuthenticator.allowed": (),
    "PySide2.QtWebSockets.QWebSocketCorsAuthenticator.origin": (),
    "PySide2.QtWebSockets.QWebSocketCorsAuthenticator.setAllowed": ('bool',),
    "PySide2.QtWebSockets.QWebSocketCorsAuthenticator.swap": ('PySide2.QtWebSockets.QWebSocketCorsAuthenticator',),

# class PySide2.QtWebSockets.QWebSocketProtocol:

# class PySide2.QtWebSockets.QWebSocketProtocol.CloseCode:

# class PySide2.QtWebSockets.QWebSocketProtocol.Version:

# class PySide2.QtWebSockets.QWebSocketServer:

# class PySide2.QtWebSockets.QWebSocketServer.SslMode:
    "PySide2.QtWebSockets.QWebSocketServer.__init__": ('str', 'PySide2.QtWebSockets.QWebSocketServer.SslMode', 'PySide2.QtCore.QObject'),
    "PySide2.QtWebSockets.QWebSocketServer.close": (),
    "PySide2.QtWebSockets.QWebSocketServer.error": (),
    "PySide2.QtWebSockets.QWebSocketServer.errorString": (),
    "PySide2.QtWebSockets.QWebSocketServer.handleConnection": ('PySide2.QtNetwork.QTcpSocket',),
    "PySide2.QtWebSockets.QWebSocketServer.handshakeTimeoutMS": (),
    "PySide2.QtWebSockets.QWebSocketServer.hasPendingConnections": (),
    "PySide2.QtWebSockets.QWebSocketServer.isListening": (),
    "PySide2.QtWebSockets.QWebSocketServer.listen": ('PySide2.QtNetwork.QHostAddress', 'int'),
    "PySide2.QtWebSockets.QWebSocketServer.maxPendingConnections": (),
    "PySide2.QtWebSockets.QWebSocketServer.nativeDescriptor": (),
    "PySide2.QtWebSockets.QWebSocketServer.nextPendingConnection": (),
    "PySide2.QtWebSockets.QWebSocketServer.pauseAccepting": (),
    "PySide2.QtWebSockets.QWebSocketServer.proxy": (),
    "PySide2.QtWebSockets.QWebSocketServer.resumeAccepting": (),
    "PySide2.QtWebSockets.QWebSocketServer.secureMode": (),
    "PySide2.QtWebSockets.QWebSocketServer.serverAddress": (),
    "PySide2.QtWebSockets.QWebSocketServer.serverName": (),
    "PySide2.QtWebSockets.QWebSocketServer.serverPort": (),
    "PySide2.QtWebSockets.QWebSocketServer.serverUrl": (),
    "PySide2.QtWebSockets.QWebSocketServer.setHandshakeTimeout": ('int',),
    "PySide2.QtWebSockets.QWebSocketServer.setMaxPendingConnections": ('int',),
    "PySide2.QtWebSockets.QWebSocketServer.setNativeDescriptor": ('int',),
    "PySide2.QtWebSockets.QWebSocketServer.setProxy": ('PySide2.QtNetwork.QNetworkProxy',),
    "PySide2.QtWebSockets.QWebSocketServer.setServerName": ('str',),
    "PySide2.QtWebSockets.QWebSocketServer.setSocketDescriptor": ('int',),
    "PySide2.QtWebSockets.QWebSocketServer.socketDescriptor": (),
    "PySide2.QtWebSockets.QWebSocketServer.supportedVersions": (),
    }) if "PySide2.QtWebSockets" in sys.modules else None

# Module PySide2.Qt3DCore
sig_dict.update({

# class PySide2.Qt3DCore.Qt3DCore:

# class PySide2.Qt3DCore.Qt3DCore.ChangeFlag:

# class PySide2.Qt3DCore.Qt3DCore.ChangeFlags:

# class PySide2.Qt3DCore.Qt3DCore.QAbstractAspect:
    "PySide2.Qt3DCore.Qt3DCore.QAbstractAspect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DCore.Qt3DCore.QAbstractAspect.rootEntityId": (),
    "PySide2.Qt3DCore.Qt3DCore.QAbstractAspect.unregisterBackendType": ('PySide2.QtCore.QMetaObject',),

# class PySide2.Qt3DCore.Qt3DCore.QAbstractSkeleton:
    "PySide2.Qt3DCore.Qt3DCore.QAbstractSkeleton.jointCount": (),

# class PySide2.Qt3DCore.Qt3DCore.QArmature:
    "PySide2.Qt3DCore.Qt3DCore.QArmature.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QArmature.setSkeleton": ('PySide2.Qt3DCore.Qt3DCore.QAbstractSkeleton',),
    "PySide2.Qt3DCore.Qt3DCore.QArmature.skeleton": (),

# class PySide2.Qt3DCore.Qt3DCore.QAspectEngine:

# class PySide2.Qt3DCore.Qt3DCore.QAspectEngine.RunMode:
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.aspects": (),
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.executeCommand": ('str',),
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.processFrame": (),
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.registerAspect": [('PySide2.Qt3DCore.Qt3DCore.QAbstractAspect',), ('str',)],
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.runMode": (),
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.setRunMode": ('PySide2.Qt3DCore.Qt3DCore.QAspectEngine.RunMode',),
    "PySide2.Qt3DCore.Qt3DCore.QAspectEngine.unregisterAspect": [('PySide2.Qt3DCore.Qt3DCore.QAbstractAspect',), ('str',)],

# class PySide2.Qt3DCore.Qt3DCore.QAspectJob:
    "PySide2.Qt3DCore.Qt3DCore.QAspectJob.__init__": (),
    "PySide2.Qt3DCore.Qt3DCore.QAspectJob.run": (),

# class PySide2.Qt3DCore.Qt3DCore.QBackendNode:

# class PySide2.Qt3DCore.Qt3DCore.QBackendNode.Mode:
    "PySide2.Qt3DCore.Qt3DCore.QBackendNode.__init__": ('PySide2.Qt3DCore.Qt3DCore.QBackendNode.Mode',),
    "PySide2.Qt3DCore.Qt3DCore.QBackendNode.isEnabled": (),
    "PySide2.Qt3DCore.Qt3DCore.QBackendNode.mode": (),
    "PySide2.Qt3DCore.Qt3DCore.QBackendNode.peerId": (),
    "PySide2.Qt3DCore.Qt3DCore.QBackendNode.setEnabled": ('bool',),

# class PySide2.Qt3DCore.Qt3DCore.QComponent:
    "PySide2.Qt3DCore.Qt3DCore.QComponent.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QComponent.entities": (),
    "PySide2.Qt3DCore.Qt3DCore.QComponent.isShareable": (),
    "PySide2.Qt3DCore.Qt3DCore.QComponent.setShareable": ('bool',),

# class PySide2.Qt3DCore.Qt3DCore.QComponentAddedChange:
    "PySide2.Qt3DCore.Qt3DCore.QComponentAddedChange.__init__": [('PySide2.Qt3DCore.Qt3DCore.QComponent', 'PySide2.Qt3DCore.Qt3DCore.QEntity'), ('PySide2.Qt3DCore.Qt3DCore.QEntity', 'PySide2.Qt3DCore.Qt3DCore.QComponent')],
    "PySide2.Qt3DCore.Qt3DCore.QComponentAddedChange.componentId": (),
    "PySide2.Qt3DCore.Qt3DCore.QComponentAddedChange.componentMetaObject": (),
    "PySide2.Qt3DCore.Qt3DCore.QComponentAddedChange.entityId": (),

# class PySide2.Qt3DCore.Qt3DCore.QComponentRemovedChange:
    "PySide2.Qt3DCore.Qt3DCore.QComponentRemovedChange.__init__": [('PySide2.Qt3DCore.Qt3DCore.QComponent', 'PySide2.Qt3DCore.Qt3DCore.QEntity'), ('PySide2.Qt3DCore.Qt3DCore.QEntity', 'PySide2.Qt3DCore.Qt3DCore.QComponent')],
    "PySide2.Qt3DCore.Qt3DCore.QComponentRemovedChange.componentId": (),
    "PySide2.Qt3DCore.Qt3DCore.QComponentRemovedChange.componentMetaObject": (),
    "PySide2.Qt3DCore.Qt3DCore.QComponentRemovedChange.entityId": (),

# class PySide2.Qt3DCore.Qt3DCore.QDynamicPropertyUpdatedChange:
    "PySide2.Qt3DCore.Qt3DCore.QDynamicPropertyUpdatedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QDynamicPropertyUpdatedChange.propertyName": (),
    "PySide2.Qt3DCore.Qt3DCore.QDynamicPropertyUpdatedChange.setPropertyName": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DCore.Qt3DCore.QDynamicPropertyUpdatedChange.setValue": ('typing.Any',),
    "PySide2.Qt3DCore.Qt3DCore.QDynamicPropertyUpdatedChange.value": (),

# class PySide2.Qt3DCore.Qt3DCore.QEntity:
    "PySide2.Qt3DCore.Qt3DCore.QEntity.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QEntity.addComponent": ('PySide2.Qt3DCore.Qt3DCore.QComponent',),
    "PySide2.Qt3DCore.Qt3DCore.QEntity.components": (),
    "PySide2.Qt3DCore.Qt3DCore.QEntity.parentEntity": (),
    "PySide2.Qt3DCore.Qt3DCore.QEntity.removeComponent": ('PySide2.Qt3DCore.Qt3DCore.QComponent',),

# class PySide2.Qt3DCore.Qt3DCore.QJoint:
    "PySide2.Qt3DCore.Qt3DCore.QJoint.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.addChildJoint": ('PySide2.Qt3DCore.Qt3DCore.QJoint',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.childJoints": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.inverseBindMatrix": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.name": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.removeChildJoint": ('PySide2.Qt3DCore.Qt3DCore.QJoint',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.rotation": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.rotationX": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.rotationY": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.rotationZ": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.scale": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setInverseBindMatrix": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setName": ('str',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setRotation": ('PySide2.QtGui.QQuaternion',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setRotationX": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setRotationY": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setRotationZ": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setScale": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setToIdentity": (),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.setTranslation": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DCore.Qt3DCore.QJoint.translation": (),

# class PySide2.Qt3DCore.Qt3DCore.QNode:

# class PySide2.Qt3DCore.Qt3DCore.QNode.PropertyTrackingMode:
    "PySide2.Qt3DCore.Qt3DCore.QNode.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QNode.blockNotifications": ('bool',),
    "PySide2.Qt3DCore.Qt3DCore.QNode.childNodes": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.clearPropertyTracking": ('str',),
    "PySide2.Qt3DCore.Qt3DCore.QNode.clearPropertyTrackings": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.defaultPropertyTrackingMode": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.id": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.isEnabled": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.notificationsBlocked": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.parentNode": (),
    "PySide2.Qt3DCore.Qt3DCore.QNode.propertyTracking": ('str',),
    "PySide2.Qt3DCore.Qt3DCore.QNode.setDefaultPropertyTrackingMode": ('PySide2.Qt3DCore.Qt3DCore.QNode.PropertyTrackingMode',),
    "PySide2.Qt3DCore.Qt3DCore.QNode.setEnabled": ('bool',),
    "PySide2.Qt3DCore.Qt3DCore.QNode.setParent": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('PySide2.QtCore.QObject',)],
    "PySide2.Qt3DCore.Qt3DCore.QNode.setPropertyTracking": ('str', 'PySide2.Qt3DCore.Qt3DCore.QNode.PropertyTrackingMode'),

# class PySide2.Qt3DCore.Qt3DCore.QNodeCommand:
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.commandId": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.data": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.inReplyTo": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.name": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.setData": ('typing.Any',),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.setName": ('str',),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCommand.setReplyToCommandId": ('int',),

# class PySide2.Qt3DCore.Qt3DCore.QNodeCreatedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QNodeCreatedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCreatedChangeBase.isNodeEnabled": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeCreatedChangeBase.parentId": (),

# class PySide2.Qt3DCore.Qt3DCore.QNodeDestroyedChange:
    "PySide2.Qt3DCore.Qt3DCore.QNodeDestroyedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode', 'typing.List[PySide2.Qt3DCore.Qt3DCore.QNodeIdTypePair]'),
    "PySide2.Qt3DCore.Qt3DCore.QNodeDestroyedChange.subtreeIdsAndTypes": (),

# class PySide2.Qt3DCore.Qt3DCore.QNodeId:
    "PySide2.Qt3DCore.Qt3DCore.QNodeId.__init__": [(), ('PySide2.Qt3DCore.Qt3DCore.QNodeId',)],
    "PySide2.Qt3DCore.Qt3DCore.QNodeId.__copy__": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeId.createId": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeId.id": (),
    "PySide2.Qt3DCore.Qt3DCore.QNodeId.isNull": (),

# class PySide2.Qt3DCore.Qt3DCore.QNodeIdTypePair:
    "PySide2.Qt3DCore.Qt3DCore.QNodeIdTypePair.__init__": [(), ('PySide2.Qt3DCore.Qt3DCore.QNodeId', 'PySide2.QtCore.QMetaObject'), ('PySide2.Qt3DCore.Qt3DCore.QNodeIdTypePair',)],
    "PySide2.Qt3DCore.Qt3DCore.QNodeIdTypePair.__copy__": (),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyNodeAddedChange:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyNodeAddedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId', 'PySide2.Qt3DCore.Qt3DCore.QNode'),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyNodeAddedChange.addedNodeId": (),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyNodeRemovedChange:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyNodeRemovedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId', 'PySide2.Qt3DCore.Qt3DCore.QNode'),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyNodeRemovedChange.removedNodeId": (),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyUpdatedChange:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyUpdatedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyUpdatedChange.setValue": ('typing.Any',),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyUpdatedChange.value": (),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyUpdatedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyUpdatedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyValueAddedChange:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueAddedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueAddedChange.addedValue": (),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueAddedChange.setAddedValue": ('typing.Any',),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyValueAddedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueAddedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyValueRemovedChange:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueRemovedChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueRemovedChange.removedValue": (),
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueRemovedChange.setRemovedValue": ('typing.Any',),

# class PySide2.Qt3DCore.Qt3DCore.QPropertyValueRemovedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QPropertyValueRemovedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),

# class PySide2.Qt3DCore.Qt3DCore.QSceneChange:

# class PySide2.Qt3DCore.Qt3DCore.QSceneChange.DeliveryFlag:

# class PySide2.Qt3DCore.Qt3DCore.QSceneChange.DeliveryFlags:
    "PySide2.Qt3DCore.Qt3DCore.QSceneChange.__init__": ('PySide2.Qt3DCore.Qt3DCore.ChangeFlag', 'PySide2.Qt3DCore.Qt3DCore.QNodeId'),
    "PySide2.Qt3DCore.Qt3DCore.QSceneChange.deliveryFlags": (),
    "PySide2.Qt3DCore.Qt3DCore.QSceneChange.setDeliveryFlags": ('PySide2.Qt3DCore.Qt3DCore.QSceneChange.DeliveryFlags',),
    "PySide2.Qt3DCore.Qt3DCore.QSceneChange.subjectId": (),
    "PySide2.Qt3DCore.Qt3DCore.QSceneChange.type": (),

# class PySide2.Qt3DCore.Qt3DCore.QSkeleton:
    "PySide2.Qt3DCore.Qt3DCore.QSkeleton.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QSkeleton.rootJoint": (),
    "PySide2.Qt3DCore.Qt3DCore.QSkeleton.setRootJoint": ('PySide2.Qt3DCore.Qt3DCore.QJoint',),

# class PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader:

# class PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.Status:
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.__init__": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('PySide2.QtCore.QUrl', 'PySide2.Qt3DCore.Qt3DCore.QNode')],
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.isCreateJointsEnabled": (),
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.rootJoint": (),
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.setCreateJointsEnabled": ('bool',),
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.source": (),
    "PySide2.Qt3DCore.Qt3DCore.QSkeletonLoader.status": (),

# class PySide2.Qt3DCore.Qt3DCore.QStaticPropertyUpdatedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyUpdatedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyUpdatedChangeBase.propertyName": (),
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyUpdatedChangeBase.setPropertyName": ('str',),

# class PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueAddedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueAddedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueAddedChangeBase.propertyName": (),
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueAddedChangeBase.setPropertyName": ('str',),

# class PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueRemovedChangeBase:
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueRemovedChangeBase.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueRemovedChangeBase.propertyName": (),
    "PySide2.Qt3DCore.Qt3DCore.QStaticPropertyValueRemovedChangeBase.setPropertyName": ('str',),

# class PySide2.Qt3DCore.Qt3DCore.QTransform:
    "PySide2.Qt3DCore.Qt3DCore.QTransform.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.fromAxes": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.fromAxesAndAngles": [('PySide2.QtGui.QVector3D', 'float', 'PySide2.QtGui.QVector3D', 'float'), ('PySide2.QtGui.QVector3D', 'float', 'PySide2.QtGui.QVector3D', 'float', 'PySide2.QtGui.QVector3D', 'float')],
    "PySide2.Qt3DCore.Qt3DCore.QTransform.fromAxisAndAngle": [('PySide2.QtGui.QVector3D', 'float'), ('float', 'float', 'float', 'float')],
    "PySide2.Qt3DCore.Qt3DCore.QTransform.fromEulerAngles": [('PySide2.QtGui.QVector3D',), ('float', 'float', 'float')],
    "PySide2.Qt3DCore.Qt3DCore.QTransform.matrix": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.rotateAround": ('PySide2.QtGui.QVector3D', 'float', 'PySide2.QtGui.QVector3D'),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.rotateFromAxes": ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D'),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.rotation": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.rotationX": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.rotationY": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.rotationZ": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.scale": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.scale3D": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setMatrix": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setRotation": ('PySide2.QtGui.QQuaternion',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setRotationX": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setRotationY": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setRotationZ": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setScale": ('float',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setScale3D": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.setTranslation": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.translation": (),
    "PySide2.Qt3DCore.Qt3DCore.QTransform.worldMatrix": (),

    "PySide2.Qt3DCore.Qt3DCore.qHash": ('PySide2.Qt3DCore.Qt3DCore.QNodeId', 'int'),
    "PySide2.Qt3DCore.Qt3DCore.qIdForNode": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    }) if "PySide2.Qt3DCore" in sys.modules else None

# Module PySide2.Qt3DRender
sig_dict.update({

# class PySide2.Qt3DRender.Qt3DRender:

# class PySide2.Qt3DRender.Qt3DRender.PropertyReaderInterface:
    "PySide2.Qt3DRender.Qt3DRender.PropertyReaderInterface.__init__": (),
    "PySide2.Qt3DRender.Qt3DRender.PropertyReaderInterface.readProperty": ('typing.Any',),

# class PySide2.Qt3DRender.Qt3DRender.QAbstractFunctor:
    "PySide2.Qt3DRender.Qt3DRender.QAbstractFunctor.__init__": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractFunctor.id": (),

# class PySide2.Qt3DRender.Qt3DRender.QAbstractLight:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractLight.Type:
    "PySide2.Qt3DRender.Qt3DRender.QAbstractLight.color": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractLight.intensity": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractLight.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractLight.setIntensity": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractLight.type": (),

# class PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.FilterMode:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.RunMode:
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.addLayer": ('PySide2.Qt3DRender.Qt3DRender.QLayer',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.filterMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.hits": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.layers": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.removeLayer": ('PySide2.Qt3DRender.Qt3DRender.QLayer',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.runMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.setFilterMode": ('PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.FilterMode',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.setRunMode": ('PySide2.Qt3DRender.Qt3DRender.QAbstractRayCaster.RunMode',),

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.ComparisonFunction:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.ComparisonMode:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.CubeMapFace:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Filter:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.HandleType:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Status:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Target:

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.TextureFormat:
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.__init__": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Target', 'PySide2.Qt3DCore.Qt3DCore.QNode')],
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.addTextureImage": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.comparisonFunction": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.comparisonMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.depth": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.format": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.generateMipMaps": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.handle": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.handleType": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.height": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.layers": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.magnificationFilter": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.maximumAnisotropy": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.minificationFilter": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.removeTextureImage": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.samples": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setComparisonFunction": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.ComparisonFunction',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setComparisonMode": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.ComparisonMode',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setDepth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setFormat": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.TextureFormat',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setGenerateMipMaps": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setHandle": ('typing.Any',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setHandleType": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.HandleType',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setHeight": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setLayers": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setMagnificationFilter": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Filter',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setMaximumAnisotropy": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setMinificationFilter": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Filter',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setSamples": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setSize": ('int', 'int', 'int'),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setStatus": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Status',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setWidth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.setWrapMode": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.status": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.target": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.textureImages": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.width": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.wrapMode": (),

# class PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage:
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.face": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.layer": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.mipLevel": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.notifyDataGeneratorChanged": (),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.setFace": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.CubeMapFace',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.setLayer": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAbstractTextureImage.setMipLevel": ('int',),

# class PySide2.Qt3DRender.Qt3DRender.QAlphaCoverage:
    "PySide2.Qt3DRender.Qt3DRender.QAlphaCoverage.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QAlphaTest:

# class PySide2.Qt3DRender.Qt3DRender.QAlphaTest.AlphaFunction:
    "PySide2.Qt3DRender.Qt3DRender.QAlphaTest.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QAlphaTest.alphaFunction": (),
    "PySide2.Qt3DRender.Qt3DRender.QAlphaTest.referenceValue": (),
    "PySide2.Qt3DRender.Qt3DRender.QAlphaTest.setAlphaFunction": ('PySide2.Qt3DRender.Qt3DRender.QAlphaTest.AlphaFunction',),
    "PySide2.Qt3DRender.Qt3DRender.QAlphaTest.setReferenceValue": ('float',),

# class PySide2.Qt3DRender.Qt3DRender.QAttribute:

# class PySide2.Qt3DRender.Qt3DRender.QAttribute.AttributeType:

# class PySide2.Qt3DRender.Qt3DRender.QAttribute.VertexBaseType:
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.__init__": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('PySide2.Qt3DRender.Qt3DRender.QBuffer', 'PySide2.Qt3DRender.Qt3DRender.QAttribute.VertexBaseType', 'int', 'int', 'int', 'int', 'PySide2.Qt3DCore.Qt3DCore.QNode'), ('PySide2.Qt3DRender.Qt3DRender.QBuffer', 'str', 'PySide2.Qt3DRender.Qt3DRender.QAttribute.VertexBaseType', 'int', 'int', 'int', 'int', 'PySide2.Qt3DCore.Qt3DCore.QNode')],
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.attributeType": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.buffer": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.byteOffset": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.byteStride": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.count": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultColorAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultJointIndicesAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultJointWeightsAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultNormalAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultPositionAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultTangentAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultTextureCoordinate1AttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultTextureCoordinate2AttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.defaultTextureCoordinateAttributeName": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.divisor": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.name": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setAttributeType": ('PySide2.Qt3DRender.Qt3DRender.QAttribute.AttributeType',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setBuffer": ('PySide2.Qt3DRender.Qt3DRender.QBuffer',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setByteOffset": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setByteStride": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setCount": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setDataSize": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setDataType": ('PySide2.Qt3DRender.Qt3DRender.QAttribute.VertexBaseType',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setDivisor": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setName": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setVertexBaseType": ('PySide2.Qt3DRender.Qt3DRender.QAttribute.VertexBaseType',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.setVertexSize": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.vertexBaseType": (),
    "PySide2.Qt3DRender.Qt3DRender.QAttribute.vertexSize": (),

# class PySide2.Qt3DRender.Qt3DRender.QBlendEquation:

# class PySide2.Qt3DRender.Qt3DRender.QBlendEquation.BlendFunction:
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquation.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquation.blendFunction": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquation.setBlendFunction": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquation.BlendFunction',),

# class PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments:

# class PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending:
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.bufferIndex": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.destinationAlpha": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.destinationRgb": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setBufferIndex": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setDestinationAlpha": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setDestinationRgb": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setDestinationRgba": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setSourceAlpha": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setSourceRgb": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.setSourceRgba": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.sourceAlpha": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.sourceRgb": (),

# class PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer:

# class PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.InterpolationMethod:
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.destination": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.destinationAttachmentPoint": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.destinationRect": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.interpolationMethod": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setDestination": ('PySide2.Qt3DRender.Qt3DRender.QRenderTarget',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setDestinationAttachmentPoint": ('PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.AttachmentPoint',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setDestinationRect": ('PySide2.QtCore.QRectF',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setInterpolationMethod": ('PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.InterpolationMethod',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setSource": ('PySide2.Qt3DRender.Qt3DRender.QRenderTarget',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setSourceAttachmentPoint": ('PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.AttachmentPoint',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.setSourceRect": ('PySide2.QtCore.QRectF',),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.source": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.sourceAttachmentPoint": (),
    "PySide2.Qt3DRender.Qt3DRender.QBlitFramebuffer.sourceRect": (),

# class PySide2.Qt3DRender.Qt3DRender.QBuffer:

# class PySide2.Qt3DRender.Qt3DRender.QBuffer.AccessType:

# class PySide2.Qt3DRender.Qt3DRender.QBuffer.BufferType:

# class PySide2.Qt3DRender.Qt3DRender.QBuffer.UsageType:
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.__init__": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('PySide2.Qt3DRender.Qt3DRender.QBuffer.BufferType', 'PySide2.Qt3DCore.Qt3DCore.QNode')],
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.accessType": (),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.data": (),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.isSyncData": (),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.setAccessType": ('PySide2.Qt3DRender.Qt3DRender.QBuffer.AccessType',),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.setData": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.setSyncData": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.setType": ('PySide2.Qt3DRender.Qt3DRender.QBuffer.BufferType',),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.setUsage": ('PySide2.Qt3DRender.Qt3DRender.QBuffer.UsageType',),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.type": (),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.updateData": ('int', 'PySide2.QtCore.QByteArray'),
    "PySide2.Qt3DRender.Qt3DRender.QBuffer.usage": (),

# class PySide2.Qt3DRender.Qt3DRender.QBufferCapture:
    "PySide2.Qt3DRender.Qt3DRender.QBufferCapture.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QBufferDataGenerator:
    "PySide2.Qt3DRender.Qt3DRender.QBufferDataGenerator.__init__": (),

# class PySide2.Qt3DRender.Qt3DRender.QCamera:

# class PySide2.Qt3DRender.Qt3DRender.QCamera.CameraTranslationOption:
    "PySide2.Qt3DRender.Qt3DRender.QCamera.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.aspectRatio": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.bottom": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.exposure": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.farPlane": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.fieldOfView": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.left": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.lens": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.nearPlane": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.pan": [('float',), ('float', 'PySide2.QtGui.QVector3D')],
    "PySide2.Qt3DRender.Qt3DRender.QCamera.panAboutViewCenter": [('float',), ('float', 'PySide2.QtGui.QVector3D')],
    "PySide2.Qt3DRender.Qt3DRender.QCamera.panRotation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.position": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.projectionMatrix": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.projectionType": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.right": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.roll": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.rollAboutViewCenter": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.rollRotation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.rotate": ('PySide2.QtGui.QQuaternion',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.rotateAboutViewCenter": ('PySide2.QtGui.QQuaternion',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.rotation": ('float', 'PySide2.QtGui.QVector3D'),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setAspectRatio": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setBottom": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setExposure": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setFarPlane": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setFieldOfView": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setLeft": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setNearPlane": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setPosition": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setProjectionMatrix": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setProjectionType": ('PySide2.Qt3DRender.Qt3DRender.QCameraLens.ProjectionType',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setRight": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setTop": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setUpVector": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.setViewCenter": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.tilt": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.tiltAboutViewCenter": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.tiltRotation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.top": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.transform": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.translate": ('PySide2.QtGui.QVector3D', 'PySide2.Qt3DRender.Qt3DRender.QCamera.CameraTranslationOption'),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.translateWorld": ('PySide2.QtGui.QVector3D', 'PySide2.Qt3DRender.Qt3DRender.QCamera.CameraTranslationOption'),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.upVector": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.viewAll": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.viewCenter": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.viewEntity": ('PySide2.Qt3DCore.Qt3DCore.QEntity',),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.viewMatrix": (),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.viewSphere": ('PySide2.QtGui.QVector3D', 'float'),
    "PySide2.Qt3DRender.Qt3DRender.QCamera.viewVector": (),

# class PySide2.Qt3DRender.Qt3DRender.QCameraLens:

# class PySide2.Qt3DRender.Qt3DRender.QCameraLens.ProjectionType:
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.aspectRatio": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.bottom": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.exposure": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.farPlane": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.fieldOfView": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.left": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.nearPlane": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.projectionMatrix": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.projectionType": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.right": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setAspectRatio": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setBottom": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setExposure": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setFarPlane": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setFieldOfView": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setFrustumProjection": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setLeft": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setNearPlane": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setOrthographicProjection": ('float', 'float', 'float', 'float', 'float', 'float'),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setPerspectiveProjection": ('float', 'float', 'float', 'float'),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setProjectionMatrix": ('PySide2.QtGui.QMatrix4x4',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setProjectionType": ('PySide2.Qt3DRender.Qt3DRender.QCameraLens.ProjectionType',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setRight": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.setTop": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.top": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.viewAll": ('PySide2.Qt3DCore.Qt3DCore.QNodeId',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraLens.viewEntity": ('PySide2.Qt3DCore.Qt3DCore.QNodeId', 'PySide2.Qt3DCore.Qt3DCore.QNodeId'),

# class PySide2.Qt3DRender.Qt3DRender.QCameraSelector:
    "PySide2.Qt3DRender.Qt3DRender.QCameraSelector.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QCameraSelector.camera": (),
    "PySide2.Qt3DRender.Qt3DRender.QCameraSelector.setCamera": ('PySide2.Qt3DCore.Qt3DCore.QEntity',),

# class PySide2.Qt3DRender.Qt3DRender.QClearBuffers:

# class PySide2.Qt3DRender.Qt3DRender.QClearBuffers.BufferType:

# class PySide2.Qt3DRender.Qt3DRender.QClearBuffers.BufferTypeFlags:
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.buffers": (),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.clearColor": (),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.clearDepthValue": (),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.clearStencilValue": (),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.colorBuffer": (),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.setBuffers": ('PySide2.Qt3DRender.Qt3DRender.QClearBuffers.BufferType',),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.setClearColor": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.setClearDepthValue": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.setClearStencilValue": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QClearBuffers.setColorBuffer": ('PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput',),

# class PySide2.Qt3DRender.Qt3DRender.QClipPlane:
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.distance": (),
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.normal": (),
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.planeIndex": (),
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.setDistance": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.setNormal": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QClipPlane.setPlaneIndex": ('int',),

# class PySide2.Qt3DRender.Qt3DRender.QColorMask:
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.isAlphaMasked": (),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.isBlueMasked": (),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.isGreenMasked": (),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.isRedMasked": (),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.setAlphaMasked": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.setBlueMasked": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.setGreenMasked": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QColorMask.setRedMasked": ('bool',),

# class PySide2.Qt3DRender.Qt3DRender.QComputeCommand:

# class PySide2.Qt3DRender.Qt3DRender.QComputeCommand.RunType:
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.runType": (),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.setRunType": ('PySide2.Qt3DRender.Qt3DRender.QComputeCommand.RunType',),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.setWorkGroupX": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.setWorkGroupY": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.setWorkGroupZ": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.trigger": [('int',), ('int', 'int', 'int', 'int')],
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.workGroupX": (),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.workGroupY": (),
    "PySide2.Qt3DRender.Qt3DRender.QComputeCommand.workGroupZ": (),

# class PySide2.Qt3DRender.Qt3DRender.QCullFace:

# class PySide2.Qt3DRender.Qt3DRender.QCullFace.CullingMode:
    "PySide2.Qt3DRender.Qt3DRender.QCullFace.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QCullFace.mode": (),
    "PySide2.Qt3DRender.Qt3DRender.QCullFace.setMode": ('PySide2.Qt3DRender.Qt3DRender.QCullFace.CullingMode',),

# class PySide2.Qt3DRender.Qt3DRender.QDepthTest:

# class PySide2.Qt3DRender.Qt3DRender.QDepthTest.DepthFunction:
    "PySide2.Qt3DRender.Qt3DRender.QDepthTest.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QDepthTest.depthFunction": (),
    "PySide2.Qt3DRender.Qt3DRender.QDepthTest.setDepthFunction": ('PySide2.Qt3DRender.Qt3DRender.QDepthTest.DepthFunction',),

# class PySide2.Qt3DRender.Qt3DRender.QDirectionalLight:
    "PySide2.Qt3DRender.Qt3DRender.QDirectionalLight.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QDirectionalLight.setWorldDirection": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QDirectionalLight.worldDirection": (),

# class PySide2.Qt3DRender.Qt3DRender.QDispatchCompute:
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.setWorkGroupX": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.setWorkGroupY": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.setWorkGroupZ": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.workGroupX": (),
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.workGroupY": (),
    "PySide2.Qt3DRender.Qt3DRender.QDispatchCompute.workGroupZ": (),

# class PySide2.Qt3DRender.Qt3DRender.QDithering:
    "PySide2.Qt3DRender.Qt3DRender.QDithering.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QEffect:
    "PySide2.Qt3DRender.Qt3DRender.QEffect.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QEffect.addParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QEffect.addTechnique": ('PySide2.Qt3DRender.Qt3DRender.QTechnique',),
    "PySide2.Qt3DRender.Qt3DRender.QEffect.parameters": (),
    "PySide2.Qt3DRender.Qt3DRender.QEffect.removeParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QEffect.removeTechnique": ('PySide2.Qt3DRender.Qt3DRender.QTechnique',),
    "PySide2.Qt3DRender.Qt3DRender.QEffect.techniques": (),

# class PySide2.Qt3DRender.Qt3DRender.QEnvironmentLight:
    "PySide2.Qt3DRender.Qt3DRender.QEnvironmentLight.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QEnvironmentLight.irradiance": (),
    "PySide2.Qt3DRender.Qt3DRender.QEnvironmentLight.setIrradiance": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DRender.Qt3DRender.QEnvironmentLight.setSpecular": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DRender.Qt3DRender.QEnvironmentLight.specular": (),

# class PySide2.Qt3DRender.Qt3DRender.QFilterKey:
    "PySide2.Qt3DRender.Qt3DRender.QFilterKey.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QFilterKey.name": (),
    "PySide2.Qt3DRender.Qt3DRender.QFilterKey.setName": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QFilterKey.setValue": ('typing.Any',),
    "PySide2.Qt3DRender.Qt3DRender.QFilterKey.value": (),

# class PySide2.Qt3DRender.Qt3DRender.QFrameGraphNode:
    "PySide2.Qt3DRender.Qt3DRender.QFrameGraphNode.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QFrameGraphNode.parentFrameGraphNode": (),

# class PySide2.Qt3DRender.Qt3DRender.QFrameGraphNodeCreatedChangeBase:
    "PySide2.Qt3DRender.Qt3DRender.QFrameGraphNodeCreatedChangeBase.__init__": ('PySide2.Qt3DRender.Qt3DRender.QFrameGraphNode',),
    "PySide2.Qt3DRender.Qt3DRender.QFrameGraphNodeCreatedChangeBase.parentFrameGraphNodeId": (),

# class PySide2.Qt3DRender.Qt3DRender.QFrontFace:

# class PySide2.Qt3DRender.Qt3DRender.QFrontFace.WindingDirection:
    "PySide2.Qt3DRender.Qt3DRender.QFrontFace.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QFrontFace.direction": (),
    "PySide2.Qt3DRender.Qt3DRender.QFrontFace.setDirection": ('PySide2.Qt3DRender.Qt3DRender.QFrontFace.WindingDirection',),

# class PySide2.Qt3DRender.Qt3DRender.QFrustumCulling:
    "PySide2.Qt3DRender.Qt3DRender.QFrustumCulling.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QGeometry:
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.addAttribute": ('PySide2.Qt3DRender.Qt3DRender.QAttribute',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.attributes": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.boundingVolumePositionAttribute": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.maxExtent": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.minExtent": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.removeAttribute": ('PySide2.Qt3DRender.Qt3DRender.QAttribute',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometry.setBoundingVolumePositionAttribute": ('PySide2.Qt3DRender.Qt3DRender.QAttribute',),

# class PySide2.Qt3DRender.Qt3DRender.QGeometryFactory:
    "PySide2.Qt3DRender.Qt3DRender.QGeometryFactory.__init__": (),

# class PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer:

# class PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType:
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.firstInstance": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.firstVertex": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.geometry": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.indexBufferByteOffset": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.indexOffset": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.instanceCount": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.primitiveRestartEnabled": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.primitiveType": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.restartIndexValue": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setFirstInstance": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setFirstVertex": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setIndexBufferByteOffset": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setIndexOffset": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setInstanceCount": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setRestartIndexValue": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setVertexCount": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.setVerticesPerPatch": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.vertexCount": (),
    "PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.verticesPerPatch": (),

# class PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter:

# class PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.Api:

# class PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.OpenGLProfile:
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.api": (),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.extensions": (),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.majorVersion": (),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.minorVersion": (),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.profile": (),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.setApi": ('PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.Api',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.setExtensions": ('typing.Sequence[str]',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.setMajorVersion": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.setMinorVersion": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.setProfile": ('PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.OpenGLProfile',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.setVendor": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QGraphicsApiFilter.vendor": (),

# class PySide2.Qt3DRender.Qt3DRender.QLayer:
    "PySide2.Qt3DRender.Qt3DRender.QLayer.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QLayer.recursive": (),
    "PySide2.Qt3DRender.Qt3DRender.QLayer.setRecursive": ('bool',),

# class PySide2.Qt3DRender.Qt3DRender.QLayerFilter:

# class PySide2.Qt3DRender.Qt3DRender.QLayerFilter.FilterMode:
    "PySide2.Qt3DRender.Qt3DRender.QLayerFilter.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QLayerFilter.addLayer": ('PySide2.Qt3DRender.Qt3DRender.QLayer',),
    "PySide2.Qt3DRender.Qt3DRender.QLayerFilter.filterMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QLayerFilter.layers": (),
    "PySide2.Qt3DRender.Qt3DRender.QLayerFilter.removeLayer": ('PySide2.Qt3DRender.Qt3DRender.QLayer',),
    "PySide2.Qt3DRender.Qt3DRender.QLayerFilter.setFilterMode": ('PySide2.Qt3DRender.Qt3DRender.QLayerFilter.FilterMode',),

# class PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail:

# class PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.ThresholdType:
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.camera": (),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.createBoundingSphere": ('PySide2.QtGui.QVector3D', 'float'),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.currentIndex": (),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.setCamera": ('PySide2.Qt3DRender.Qt3DRender.QCamera',),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.setCurrentIndex": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.setThresholdType": ('PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.ThresholdType',),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.setThresholds": ('typing.List[float]',),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.setVolumeOverride": ('PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere',),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.thresholdType": (),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.thresholds": (),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetail.volumeOverride": (),

# class PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere:
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.__init__": [('PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere',), ('PySide2.QtGui.QVector3D', 'float')],
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.center": (),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.isEmpty": (),
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailBoundingSphere.radius": (),

# class PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailSwitch:
    "PySide2.Qt3DRender.Qt3DRender.QLevelOfDetailSwitch.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QLineWidth:
    "PySide2.Qt3DRender.Qt3DRender.QLineWidth.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QLineWidth.setSmooth": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QLineWidth.setValue": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QLineWidth.smooth": (),
    "PySide2.Qt3DRender.Qt3DRender.QLineWidth.value": (),

# class PySide2.Qt3DRender.Qt3DRender.QMaterial:
    "PySide2.Qt3DRender.Qt3DRender.QMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QMaterial.addParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QMaterial.effect": (),
    "PySide2.Qt3DRender.Qt3DRender.QMaterial.parameters": (),
    "PySide2.Qt3DRender.Qt3DRender.QMaterial.removeParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QMaterial.setEffect": ('PySide2.Qt3DRender.Qt3DRender.QEffect',),

# class PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier:

# class PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier.Operation:

# class PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier.Operations:
    "PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier.setWaitOperations": ('PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier.Operations',),
    "PySide2.Qt3DRender.Qt3DRender.QMemoryBarrier.waitOperations": (),

# class PySide2.Qt3DRender.Qt3DRender.QMesh:

# class PySide2.Qt3DRender.Qt3DRender.QMesh.Status:
    "PySide2.Qt3DRender.Qt3DRender.QMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QMesh.meshName": (),
    "PySide2.Qt3DRender.Qt3DRender.QMesh.setMeshName": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QMesh.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QMesh.source": (),
    "PySide2.Qt3DRender.Qt3DRender.QMesh.status": (),

# class PySide2.Qt3DRender.Qt3DRender.QMultiSampleAntiAliasing:
    "PySide2.Qt3DRender.Qt3DRender.QMultiSampleAntiAliasing.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QNoDepthMask:
    "PySide2.Qt3DRender.Qt3DRender.QNoDepthMask.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QNoDraw:
    "PySide2.Qt3DRender.Qt3DRender.QNoDraw.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QNoPicking:
    "PySide2.Qt3DRender.Qt3DRender.QNoPicking.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QObjectPicker:
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.containsMouse": (),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.isDragEnabled": (),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.isHoverEnabled": (),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.isPressed": (),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.priority": (),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.setDragEnabled": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.setHoverEnabled": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QObjectPicker.setPriority": ('int',),

# class PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage:
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.height": (),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.paint": ('PySide2.QtGui.QPainter',),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.setHeight": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.setSize": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.setWidth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.size": (),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.update": ('PySide2.QtCore.QRect',),
    "PySide2.Qt3DRender.Qt3DRender.QPaintedTextureImage.width": (),

# class PySide2.Qt3DRender.Qt3DRender.QParameter:
    "PySide2.Qt3DRender.Qt3DRender.QParameter.__init__": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('str', 'PySide2.Qt3DRender.Qt3DRender.QAbstractTexture', 'PySide2.Qt3DCore.Qt3DCore.QNode'), ('str', 'typing.Any', 'PySide2.Qt3DCore.Qt3DCore.QNode')],
    "PySide2.Qt3DRender.Qt3DRender.QParameter.name": (),
    "PySide2.Qt3DRender.Qt3DRender.QParameter.setName": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QParameter.setValue": ('typing.Any',),
    "PySide2.Qt3DRender.Qt3DRender.QParameter.value": (),

# class PySide2.Qt3DRender.Qt3DRender.QPickEvent:

# class PySide2.Qt3DRender.Qt3DRender.QPickEvent.Buttons:

# class PySide2.Qt3DRender.Qt3DRender.QPickEvent.Modifiers:
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float', 'PySide2.Qt3DRender.Qt3DRender.QPickEvent.Buttons', 'int', 'int')],
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.button": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.buttons": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.distance": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.entity": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.isAccepted": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.localIntersection": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.modifiers": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.position": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.setAccepted": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.viewport": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickEvent.worldIntersection": (),

# class PySide2.Qt3DRender.Qt3DRender.QPickLineEvent:
    "PySide2.Qt3DRender.Qt3DRender.QPickLineEvent.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float', 'int', 'int', 'int', 'PySide2.Qt3DRender.Qt3DRender.QPickEvent.Buttons', 'int', 'int')],
    "PySide2.Qt3DRender.Qt3DRender.QPickLineEvent.edgeIndex": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickLineEvent.vertex1Index": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickLineEvent.vertex2Index": (),

# class PySide2.Qt3DRender.Qt3DRender.QPickPointEvent:
    "PySide2.Qt3DRender.Qt3DRender.QPickPointEvent.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float', 'int', 'PySide2.Qt3DRender.Qt3DRender.QPickEvent.Buttons', 'int', 'int')],
    "PySide2.Qt3DRender.Qt3DRender.QPickPointEvent.pointIndex": (),

# class PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent:
    "PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent.__init__": [(), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float', 'int', 'int', 'int', 'int'), ('PySide2.QtCore.QPointF', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float', 'int', 'int', 'int', 'int', 'PySide2.Qt3DRender.Qt3DRender.QPickEvent.Buttons', 'int', 'int', 'PySide2.QtGui.QVector3D')],
    "PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent.triangleIndex": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent.uvw": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent.vertex1Index": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent.vertex2Index": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickTriangleEvent.vertex3Index": (),

# class PySide2.Qt3DRender.Qt3DRender.QPickingSettings:

# class PySide2.Qt3DRender.Qt3DRender.QPickingSettings.FaceOrientationPickingMode:

# class PySide2.Qt3DRender.Qt3DRender.QPickingSettings.PickMethod:

# class PySide2.Qt3DRender.Qt3DRender.QPickingSettings.PickResultMode:
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.faceOrientationPickingMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.pickMethod": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.pickResultMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.setFaceOrientationPickingMode": ('PySide2.Qt3DRender.Qt3DRender.QPickingSettings.FaceOrientationPickingMode',),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.setPickMethod": ('PySide2.Qt3DRender.Qt3DRender.QPickingSettings.PickMethod',),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.setPickResultMode": ('PySide2.Qt3DRender.Qt3DRender.QPickingSettings.PickResultMode',),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.setWorldSpaceTolerance": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QPickingSettings.worldSpaceTolerance": (),

# class PySide2.Qt3DRender.Qt3DRender.QPointLight:
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.constantAttenuation": (),
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.linearAttenuation": (),
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.quadraticAttenuation": (),
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.setConstantAttenuation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.setLinearAttenuation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QPointLight.setQuadraticAttenuation": ('float',),

# class PySide2.Qt3DRender.Qt3DRender.QPointSize:

# class PySide2.Qt3DRender.Qt3DRender.QPointSize.SizeMode:
    "PySide2.Qt3DRender.Qt3DRender.QPointSize.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QPointSize.setSizeMode": ('PySide2.Qt3DRender.Qt3DRender.QPointSize.SizeMode',),
    "PySide2.Qt3DRender.Qt3DRender.QPointSize.setValue": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QPointSize.sizeMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QPointSize.value": (),

# class PySide2.Qt3DRender.Qt3DRender.QPolygonOffset:
    "PySide2.Qt3DRender.Qt3DRender.QPolygonOffset.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QPolygonOffset.depthSteps": (),
    "PySide2.Qt3DRender.Qt3DRender.QPolygonOffset.scaleFactor": (),
    "PySide2.Qt3DRender.Qt3DRender.QPolygonOffset.setDepthSteps": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QPolygonOffset.setScaleFactor": ('float',),

# class PySide2.Qt3DRender.Qt3DRender.QProximityFilter:
    "PySide2.Qt3DRender.Qt3DRender.QProximityFilter.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QProximityFilter.distanceThreshold": (),
    "PySide2.Qt3DRender.Qt3DRender.QProximityFilter.entity": (),
    "PySide2.Qt3DRender.Qt3DRender.QProximityFilter.setDistanceThreshold": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QProximityFilter.setEntity": ('PySide2.Qt3DCore.Qt3DCore.QEntity',),

# class PySide2.Qt3DRender.Qt3DRender.QRayCaster:
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.direction": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.length": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.origin": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.setDirection": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.setLength": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.setOrigin": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QRayCaster.trigger": [(), ('PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'float')],

# class PySide2.Qt3DRender.Qt3DRender.QRayCasterHit:

# class PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.HitType:
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.__init__": [(), ('PySide2.Qt3DRender.Qt3DRender.QRayCasterHit',), ('PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.HitType', 'PySide2.Qt3DCore.Qt3DCore.QNodeId', 'float', 'PySide2.QtGui.QVector3D', 'PySide2.QtGui.QVector3D', 'int', 'int', 'int', 'int')],
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.__copy__": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.distance": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.entity": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.entityId": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.localIntersection": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.primitiveIndex": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.type": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.vertex1Index": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.vertex2Index": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.vertex3Index": (),
    "PySide2.Qt3DRender.Qt3DRender.QRayCasterHit.worldIntersection": (),

# class PySide2.Qt3DRender.Qt3DRender.QRenderAspect:

# class PySide2.Qt3DRender.Qt3DRender.QRenderAspect.RenderType:
    "PySide2.Qt3DRender.Qt3DRender.QRenderAspect.__init__": [('PySide2.Qt3DRender.Qt3DRender.QRenderAspect.RenderType', 'PySide2.QtCore.QObject'), ('PySide2.QtCore.QObject',)],

# class PySide2.Qt3DRender.Qt3DRender.QRenderCapture:
    "PySide2.Qt3DRender.Qt3DRender.QRenderCapture.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderCapture.requestCapture": [(), ('PySide2.QtCore.QRect',), ('int',)],

# class PySide2.Qt3DRender.Qt3DRender.QRenderCaptureReply:
    "PySide2.Qt3DRender.Qt3DRender.QRenderCaptureReply.captureId": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderCaptureReply.image": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderCaptureReply.isComplete": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderCaptureReply.saveImage": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderCaptureReply.saveToFile": ('str',),

# class PySide2.Qt3DRender.Qt3DRender.QRenderPass:
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.addFilterKey": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.addParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.addRenderState": ('PySide2.Qt3DRender.Qt3DRender.QRenderState',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.filterKeys": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.parameters": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.removeFilterKey": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.removeParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.removeRenderState": ('PySide2.Qt3DRender.Qt3DRender.QRenderState',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.renderStates": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.setShaderProgram": ('PySide2.Qt3DRender.Qt3DRender.QShaderProgram',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPass.shaderProgram": (),

# class PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter:
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.addMatch": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.addParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.matchAny": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.parameters": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.removeMatch": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderPassFilter.removeParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),

# class PySide2.Qt3DRender.Qt3DRender.QRenderSettings:

# class PySide2.Qt3DRender.Qt3DRender.QRenderSettings.RenderPolicy:
    "PySide2.Qt3DRender.Qt3DRender.QRenderSettings.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSettings.activeFrameGraph": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSettings.pickingSettings": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSettings.renderPolicy": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSettings.setActiveFrameGraph": ('PySide2.Qt3DRender.Qt3DRender.QFrameGraphNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSettings.setRenderPolicy": ('PySide2.Qt3DRender.Qt3DRender.QRenderSettings.RenderPolicy',),

# class PySide2.Qt3DRender.Qt3DRender.QRenderState:

# class PySide2.Qt3DRender.Qt3DRender.QRenderStateSet:
    "PySide2.Qt3DRender.Qt3DRender.QRenderStateSet.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderStateSet.addRenderState": ('PySide2.Qt3DRender.Qt3DRender.QRenderState',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderStateSet.removeRenderState": ('PySide2.Qt3DRender.Qt3DRender.QRenderState',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderStateSet.renderStates": (),

# class PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector:
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.externalRenderTargetSize": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.setExternalRenderTargetSize": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.setSurface": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.setSurfacePixelRatio": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.surface": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderSurfaceSelector.surfacePixelRatio": (),

# class PySide2.Qt3DRender.Qt3DRender.QRenderTarget:
    "PySide2.Qt3DRender.Qt3DRender.QRenderTarget.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTarget.addOutput": ('PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTarget.outputs": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTarget.removeOutput": ('PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput',),

# class PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput:

# class PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.AttachmentPoint:
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.attachmentPoint": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.face": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.layer": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.mipLevel": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.setAttachmentPoint": ('PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.AttachmentPoint',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.setFace": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.CubeMapFace',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.setLayer": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.setMipLevel": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.setTexture": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.texture": (),

# class PySide2.Qt3DRender.Qt3DRender.QRenderTargetSelector:
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetSelector.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetSelector.outputs": (),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetSelector.setOutputs": ('typing.List[PySide2.Qt3DRender.Qt3DRender.QRenderTargetOutput.AttachmentPoint]',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetSelector.setTarget": ('PySide2.Qt3DRender.Qt3DRender.QRenderTarget',),
    "PySide2.Qt3DRender.Qt3DRender.QRenderTargetSelector.target": (),

# class PySide2.Qt3DRender.Qt3DRender.QSceneLoader:

# class PySide2.Qt3DRender.Qt3DRender.QSceneLoader.ComponentType:

# class PySide2.Qt3DRender.Qt3DRender.QSceneLoader.Status:
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.component": ('str', 'PySide2.Qt3DRender.Qt3DRender.QSceneLoader.ComponentType'),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.entity": ('str',),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.entityNames": (),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.setStatus": ('PySide2.Qt3DRender.Qt3DRender.QSceneLoader.Status',),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.source": (),
    "PySide2.Qt3DRender.Qt3DRender.QSceneLoader.status": (),

# class PySide2.Qt3DRender.Qt3DRender.QScissorTest:
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.bottom": (),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.height": (),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.left": (),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.setBottom": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.setHeight": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.setLeft": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.setWidth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QScissorTest.width": (),

# class PySide2.Qt3DRender.Qt3DRender.QScreenRayCaster:
    "PySide2.Qt3DRender.Qt3DRender.QScreenRayCaster.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QScreenRayCaster.position": (),
    "PySide2.Qt3DRender.Qt3DRender.QScreenRayCaster.setPosition": ('PySide2.QtCore.QPoint',),
    "PySide2.Qt3DRender.Qt3DRender.QScreenRayCaster.trigger": [(), ('PySide2.QtCore.QPoint',)],

# class PySide2.Qt3DRender.Qt3DRender.QSeamlessCubemap:
    "PySide2.Qt3DRender.Qt3DRender.QSeamlessCubemap.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QSetFence:

# class PySide2.Qt3DRender.Qt3DRender.QSetFence.HandleType:
    "PySide2.Qt3DRender.Qt3DRender.QSetFence.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QSetFence.handle": (),
    "PySide2.Qt3DRender.Qt3DRender.QSetFence.handleType": (),

# class PySide2.Qt3DRender.Qt3DRender.QShaderData:
    "PySide2.Qt3DRender.Qt3DRender.QShaderData.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderData.event": ('PySide2.QtCore.QEvent',),

# class PySide2.Qt3DRender.Qt3DRender.QShaderImage:

# class PySide2.Qt3DRender.Qt3DRender.QShaderImage.Access:

# class PySide2.Qt3DRender.Qt3DRender.QShaderImage.ImageFormat:
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.access": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.format": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.layer": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.layered": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.mipLevel": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.setAccess": ('PySide2.Qt3DRender.Qt3DRender.QShaderImage.Access',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.setFormat": ('PySide2.Qt3DRender.Qt3DRender.QShaderImage.ImageFormat',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.setLayer": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.setLayered": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.setMipLevel": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.setTexture": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderImage.texture": (),

# class PySide2.Qt3DRender.Qt3DRender.QShaderProgram:

# class PySide2.Qt3DRender.Qt3DRender.QShaderProgram.ShaderType:

# class PySide2.Qt3DRender.Qt3DRender.QShaderProgram.Status:
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.computeShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.fragmentShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.geometryShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.loadSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.log": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setComputeShaderCode": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setFragmentShaderCode": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setGeometryShaderCode": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setShaderCode": ('PySide2.Qt3DRender.Qt3DRender.QShaderProgram.ShaderType', 'PySide2.QtCore.QByteArray'),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setTessellationControlShaderCode": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setTessellationEvaluationShaderCode": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.setVertexShaderCode": ('PySide2.QtCore.QByteArray',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.shaderCode": ('PySide2.Qt3DRender.Qt3DRender.QShaderProgram.ShaderType',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.status": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.tessellationControlShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.tessellationEvaluationShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgram.vertexShaderCode": (),

# class PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder:
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.computeShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.computeShaderGraph": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.enabledLayers": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.fragmentShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.fragmentShaderGraph": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.geometryShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.geometryShaderGraph": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setComputeShaderGraph": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setEnabledLayers": ('typing.Sequence[str]',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setFragmentShaderGraph": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setGeometryShaderGraph": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setShaderProgram": ('PySide2.Qt3DRender.Qt3DRender.QShaderProgram',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setTessellationControlShaderGraph": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setTessellationEvaluationShaderGraph": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.setVertexShaderGraph": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.shaderProgram": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.tessellationControlShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.tessellationControlShaderGraph": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.tessellationEvaluationShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.tessellationEvaluationShaderGraph": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.vertexShaderCode": (),
    "PySide2.Qt3DRender.Qt3DRender.QShaderProgramBuilder.vertexShaderGraph": (),

# class PySide2.Qt3DRender.Qt3DRender.QSharedGLTexture:
    "PySide2.Qt3DRender.Qt3DRender.QSharedGLTexture.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QSharedGLTexture.setTextureId": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QSharedGLTexture.textureId": (),

# class PySide2.Qt3DRender.Qt3DRender.QSortPolicy:

# class PySide2.Qt3DRender.Qt3DRender.QSortPolicy.SortType:
    "PySide2.Qt3DRender.Qt3DRender.QSortPolicy.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QSortPolicy.setSortTypes": [('typing.List[PySide2.Qt3DRender.Qt3DRender.QSortPolicy.SortType]',), ('typing.List[int]',)],
    "PySide2.Qt3DRender.Qt3DRender.QSortPolicy.sortTypes": (),
    "PySide2.Qt3DRender.Qt3DRender.QSortPolicy.sortTypesInt": (),

# class PySide2.Qt3DRender.Qt3DRender.QSpotLight:
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.constantAttenuation": (),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.cutOffAngle": (),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.linearAttenuation": (),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.localDirection": (),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.quadraticAttenuation": (),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.setConstantAttenuation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.setCutOffAngle": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.setLinearAttenuation": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.setLocalDirection": ('PySide2.QtGui.QVector3D',),
    "PySide2.Qt3DRender.Qt3DRender.QSpotLight.setQuadraticAttenuation": ('float',),

# class PySide2.Qt3DRender.Qt3DRender.QStencilMask:
    "PySide2.Qt3DRender.Qt3DRender.QStencilMask.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilMask.backOutputMask": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilMask.frontOutputMask": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilMask.setBackOutputMask": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilMask.setFrontOutputMask": ('int',),

# class PySide2.Qt3DRender.Qt3DRender.QStencilOperation:
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperation.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperation.back": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperation.front": (),

# class PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments:

# class PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.FaceMode:

# class PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.Operation:
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.allTestsPassOperation": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.depthTestFailureOperation": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.faceMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.setAllTestsPassOperation": ('PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.Operation',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.setDepthTestFailureOperation": ('PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.Operation',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.setStencilTestFailureOperation": ('PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.Operation',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilOperationArguments.stencilTestFailureOperation": (),

# class PySide2.Qt3DRender.Qt3DRender.QStencilTest:
    "PySide2.Qt3DRender.Qt3DRender.QStencilTest.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTest.back": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTest.front": (),

# class PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments:

# class PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.StencilFaceMode:

# class PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.StencilFunction:
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.comparisonMask": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.faceMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.referenceValue": (),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.setComparisonMask": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.setReferenceValue": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.setStencilFunction": ('PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.StencilFunction',),
    "PySide2.Qt3DRender.Qt3DRender.QStencilTestArguments.stencilFunction": (),

# class PySide2.Qt3DRender.Qt3DRender.QTechnique:
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.addFilterKey": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.addParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.addRenderPass": ('PySide2.Qt3DRender.Qt3DRender.QRenderPass',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.filterKeys": (),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.graphicsApiFilter": (),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.parameters": (),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.removeFilterKey": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.removeParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.removeRenderPass": ('PySide2.Qt3DRender.Qt3DRender.QRenderPass',),
    "PySide2.Qt3DRender.Qt3DRender.QTechnique.renderPasses": (),

# class PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter:
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.addMatch": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.addParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.matchAll": (),
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.parameters": (),
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.removeMatch": ('PySide2.Qt3DRender.Qt3DRender.QFilterKey',),
    "PySide2.Qt3DRender.Qt3DRender.QTechniqueFilter.removeParameter": ('PySide2.Qt3DRender.Qt3DRender.QParameter',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture1D:
    "PySide2.Qt3DRender.Qt3DRender.QTexture1D.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture1DArray:
    "PySide2.Qt3DRender.Qt3DRender.QTexture1DArray.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture2D:
    "PySide2.Qt3DRender.Qt3DRender.QTexture2D.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture2DArray:
    "PySide2.Qt3DRender.Qt3DRender.QTexture2DArray.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture2DMultisample:
    "PySide2.Qt3DRender.Qt3DRender.QTexture2DMultisample.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture2DMultisampleArray:
    "PySide2.Qt3DRender.Qt3DRender.QTexture2DMultisampleArray.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTexture3D:
    "PySide2.Qt3DRender.Qt3DRender.QTexture3D.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTextureBuffer:
    "PySide2.Qt3DRender.Qt3DRender.QTextureBuffer.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTextureCubeMap:
    "PySide2.Qt3DRender.Qt3DRender.QTextureCubeMap.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTextureCubeMapArray:
    "PySide2.Qt3DRender.Qt3DRender.QTextureCubeMapArray.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTextureData:
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.__init__": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.comparisonFunction": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.comparisonMode": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.depth": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.format": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.height": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.isAutoMipMapGenerationEnabled": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.layers": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.magnificationFilter": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.maximumAnisotropy": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.minificationFilter": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setAutoMipMapGenerationEnabled": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setComparisonFunction": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.ComparisonFunction',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setComparisonMode": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.ComparisonMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setDepth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setFormat": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.TextureFormat',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setHeight": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setLayers": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setMagnificationFilter": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Filter',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setMaximumAnisotropy": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setMinificationFilter": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Filter',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setTarget": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture.Target',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setWidth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setWrapModeX": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setWrapModeY": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.setWrapModeZ": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.target": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.width": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.wrapModeX": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.wrapModeY": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureData.wrapModeZ": (),

# class PySide2.Qt3DRender.Qt3DRender.QTextureGenerator:

# class PySide2.Qt3DRender.Qt3DRender.QTextureImage:

# class PySide2.Qt3DRender.Qt3DRender.QTextureImage.Status:
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.isMirrored": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.setMirrored": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.setStatus": ('PySide2.Qt3DRender.Qt3DRender.QTextureImage.Status',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.source": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImage.status": (),

# class PySide2.Qt3DRender.Qt3DRender.QTextureImageData:
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.__init__": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.cleanup": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.data": ('int', 'int', 'int'),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.depth": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.faces": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.format": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.height": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.isCompressed": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.layers": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.mipLevels": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.pixelFormat": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.pixelType": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setData": ('PySide2.QtCore.QByteArray', 'int', 'bool'),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setDepth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setFaces": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setFormat": ('PySide2.QtGui.QOpenGLTexture.TextureFormat',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setHeight": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setImage": ('PySide2.QtGui.QImage',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setLayers": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setMipLevels": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setPixelFormat": ('PySide2.QtGui.QOpenGLTexture.PixelFormat',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setPixelType": ('PySide2.QtGui.QOpenGLTexture.PixelType',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setTarget": ('PySide2.QtGui.QOpenGLTexture.Target',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.setWidth": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.target": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureImageData.width": (),

# class PySide2.Qt3DRender.Qt3DRender.QTextureImageDataGenerator:

# class PySide2.Qt3DRender.Qt3DRender.QTextureLoader:
    "PySide2.Qt3DRender.Qt3DRender.QTextureLoader.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureLoader.isMirrored": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureLoader.setMirrored": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureLoader.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureLoader.source": (),

# class PySide2.Qt3DRender.Qt3DRender.QTextureRectangle:
    "PySide2.Qt3DRender.Qt3DRender.QTextureRectangle.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode:

# class PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode:
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.__init__": [('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode', 'PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode', 'PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode', 'PySide2.QtCore.QObject'), ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode', 'PySide2.QtCore.QObject')],
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.setX": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.setY": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.setZ": ('PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.WrapMode',),
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.x": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.y": (),
    "PySide2.Qt3DRender.Qt3DRender.QTextureWrapMode.z": (),

# class PySide2.Qt3DRender.Qt3DRender.QViewport:
    "PySide2.Qt3DRender.Qt3DRender.QViewport.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QViewport.gamma": (),
    "PySide2.Qt3DRender.Qt3DRender.QViewport.normalizedRect": (),
    "PySide2.Qt3DRender.Qt3DRender.QViewport.setGamma": ('float',),
    "PySide2.Qt3DRender.Qt3DRender.QViewport.setNormalizedRect": ('PySide2.QtCore.QRectF',),

# class PySide2.Qt3DRender.Qt3DRender.QWaitFence:

# class PySide2.Qt3DRender.Qt3DRender.QWaitFence.HandleType:
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.handle": (),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.handleType": (),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.setHandle": ('typing.Any',),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.setHandleType": ('PySide2.Qt3DRender.Qt3DRender.QWaitFence.HandleType',),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.setTimeout": ('int',),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.setWaitOnCPU": ('bool',),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.timeout": (),
    "PySide2.Qt3DRender.Qt3DRender.QWaitFence.waitOnCPU": (),
    }) if "PySide2.Qt3DRender" in sys.modules else None

# Module PySide2.Qt3DInput
sig_dict.update({

# class PySide2.Qt3DInput.Qt3DInput:

# class PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput:

# class PySide2.Qt3DInput.Qt3DInput.QAbstractAxisInput:
    "PySide2.Qt3DInput.Qt3DInput.QAbstractAxisInput.setSourceDevice": ('PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice',),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractAxisInput.sourceDevice": (),

# class PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice:
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.addAxisSetting": ('PySide2.Qt3DInput.Qt3DInput.QAxisSetting',),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.axisCount": (),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.axisIdentifier": ('str',),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.axisNames": (),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.axisSettings": (),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.buttonCount": (),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.buttonIdentifier": ('str',),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.buttonNames": (),
    "PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice.removeAxisSetting": ('PySide2.Qt3DInput.Qt3DInput.QAxisSetting',),

# class PySide2.Qt3DInput.Qt3DInput.QAction:
    "PySide2.Qt3DInput.Qt3DInput.QAction.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QAction.addInput": ('PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput',),
    "PySide2.Qt3DInput.Qt3DInput.QAction.inputs": (),
    "PySide2.Qt3DInput.Qt3DInput.QAction.isActive": (),
    "PySide2.Qt3DInput.Qt3DInput.QAction.removeInput": ('PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput',),

# class PySide2.Qt3DInput.Qt3DInput.QActionInput:
    "PySide2.Qt3DInput.Qt3DInput.QActionInput.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QActionInput.buttons": (),
    "PySide2.Qt3DInput.Qt3DInput.QActionInput.setButtons": ('typing.List[int]',),
    "PySide2.Qt3DInput.Qt3DInput.QActionInput.setSourceDevice": ('PySide2.Qt3DInput.Qt3DInput.QAbstractPhysicalDevice',),
    "PySide2.Qt3DInput.Qt3DInput.QActionInput.sourceDevice": (),

# class PySide2.Qt3DInput.Qt3DInput.QAnalogAxisInput:
    "PySide2.Qt3DInput.Qt3DInput.QAnalogAxisInput.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QAnalogAxisInput.axis": (),
    "PySide2.Qt3DInput.Qt3DInput.QAnalogAxisInput.setAxis": ('int',),

# class PySide2.Qt3DInput.Qt3DInput.QAxis:
    "PySide2.Qt3DInput.Qt3DInput.QAxis.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QAxis.addInput": ('PySide2.Qt3DInput.Qt3DInput.QAbstractAxisInput',),
    "PySide2.Qt3DInput.Qt3DInput.QAxis.inputs": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxis.removeInput": ('PySide2.Qt3DInput.Qt3DInput.QAbstractAxisInput',),
    "PySide2.Qt3DInput.Qt3DInput.QAxis.value": (),

# class PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator:

# class PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.SourceAxisType:
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.scale": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.setScale": ('float',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.setSourceAxis": ('PySide2.Qt3DInput.Qt3DInput.QAxis',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.setSourceAxisType": ('PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.SourceAxisType',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.sourceAxis": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.sourceAxisType": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.value": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisAccumulator.velocity": (),

# class PySide2.Qt3DInput.Qt3DInput.QAxisSetting:
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.axes": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.deadZoneRadius": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.isSmoothEnabled": (),
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.setAxes": ('typing.List[int]',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.setDeadZoneRadius": ('float',),
    "PySide2.Qt3DInput.Qt3DInput.QAxisSetting.setSmoothEnabled": ('bool',),

# class PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput:
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.acceleration": (),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.buttons": (),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.deceleration": (),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.scale": (),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.setAcceleration": ('float',),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.setButtons": ('typing.List[int]',),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.setDeceleration": ('float',),
    "PySide2.Qt3DInput.Qt3DInput.QButtonAxisInput.setScale": ('float',),

# class PySide2.Qt3DInput.Qt3DInput.QInputAspect:
    "PySide2.Qt3DInput.Qt3DInput.QInputAspect.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DInput.Qt3DInput.QInputAspect.availablePhysicalDevices": (),
    "PySide2.Qt3DInput.Qt3DInput.QInputAspect.createPhysicalDevice": ('str',),

# class PySide2.Qt3DInput.Qt3DInput.QInputChord:
    "PySide2.Qt3DInput.Qt3DInput.QInputChord.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QInputChord.addChord": ('PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput',),
    "PySide2.Qt3DInput.Qt3DInput.QInputChord.chords": (),
    "PySide2.Qt3DInput.Qt3DInput.QInputChord.removeChord": ('PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput',),
    "PySide2.Qt3DInput.Qt3DInput.QInputChord.setTimeout": ('int',),
    "PySide2.Qt3DInput.Qt3DInput.QInputChord.timeout": (),

# class PySide2.Qt3DInput.Qt3DInput.QInputSequence:
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.addSequence": ('PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput',),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.buttonInterval": (),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.removeSequence": ('PySide2.Qt3DInput.Qt3DInput.QAbstractActionInput',),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.sequences": (),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.setButtonInterval": ('int',),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.setTimeout": ('int',),
    "PySide2.Qt3DInput.Qt3DInput.QInputSequence.timeout": (),

# class PySide2.Qt3DInput.Qt3DInput.QInputSettings:
    "PySide2.Qt3DInput.Qt3DInput.QInputSettings.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QInputSettings.eventSource": (),
    "PySide2.Qt3DInput.Qt3DInput.QInputSettings.setEventSource": ('PySide2.QtCore.QObject',),

# class PySide2.Qt3DInput.Qt3DInput.QKeyEvent:
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.__init__": ('PySide2.QtCore.QEvent.Type', 'int', 'PySide2.QtCore.Qt.KeyboardModifiers', 'str', 'bool', 'int'),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.count": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.isAccepted": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.isAutoRepeat": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.key": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.matches": ('PySide2.QtGui.QKeySequence.StandardKey',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.modifiers": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.nativeScanCode": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.setAccepted": ('bool',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.text": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyEvent.type": (),

# class PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice:
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.activeInput": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.axisCount": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.axisIdentifier": ('str',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.axisNames": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.buttonCount": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.buttonIdentifier": ('str',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice.buttonNames": (),

# class PySide2.Qt3DInput.Qt3DInput.QKeyboardHandler:
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardHandler.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardHandler.focus": (),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardHandler.setFocus": ('bool',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardHandler.setSourceDevice": ('PySide2.Qt3DInput.Qt3DInput.QKeyboardDevice',),
    "PySide2.Qt3DInput.Qt3DInput.QKeyboardHandler.sourceDevice": (),

# class PySide2.Qt3DInput.Qt3DInput.QLogicalDevice:
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.actions": (),
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.addAction": ('PySide2.Qt3DInput.Qt3DInput.QAction',),
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.addAxis": ('PySide2.Qt3DInput.Qt3DInput.QAxis',),
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.axes": (),
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.removeAction": ('PySide2.Qt3DInput.Qt3DInput.QAction',),
    "PySide2.Qt3DInput.Qt3DInput.QLogicalDevice.removeAxis": ('PySide2.Qt3DInput.Qt3DInput.QAxis',),

# class PySide2.Qt3DInput.Qt3DInput.QMouseDevice:

# class PySide2.Qt3DInput.Qt3DInput.QMouseDevice.Axis:
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.axisCount": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.axisIdentifier": ('str',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.axisNames": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.buttonCount": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.buttonIdentifier": ('str',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.buttonNames": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.sensitivity": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseDevice.setSensitivity": ('float',),

# class PySide2.Qt3DInput.Qt3DInput.QMouseEvent:

# class PySide2.Qt3DInput.Qt3DInput.QMouseEvent.Buttons:

# class PySide2.Qt3DInput.Qt3DInput.QMouseEvent.Modifier:

# class PySide2.Qt3DInput.Qt3DInput.QMouseEvent.Modifiers:
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.button": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.buttons": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.isAccepted": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.modifiers": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.setAccepted": ('bool',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.type": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.wasHeld": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.x": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseEvent.y": (),

# class PySide2.Qt3DInput.Qt3DInput.QMouseHandler:
    "PySide2.Qt3DInput.Qt3DInput.QMouseHandler.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseHandler.containsMouse": (),
    "PySide2.Qt3DInput.Qt3DInput.QMouseHandler.setContainsMouse": ('bool',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseHandler.setSourceDevice": ('PySide2.Qt3DInput.Qt3DInput.QMouseDevice',),
    "PySide2.Qt3DInput.Qt3DInput.QMouseHandler.sourceDevice": (),

# class PySide2.Qt3DInput.Qt3DInput.QWheelEvent:

# class PySide2.Qt3DInput.Qt3DInput.QWheelEvent.Buttons:

# class PySide2.Qt3DInput.Qt3DInput.QWheelEvent.Modifier:

# class PySide2.Qt3DInput.Qt3DInput.QWheelEvent.Modifiers:
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.angleDelta": (),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.buttons": (),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.isAccepted": (),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.modifiers": (),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.setAccepted": ('bool',),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.type": (),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.x": (),
    "PySide2.Qt3DInput.Qt3DInput.QWheelEvent.y": (),
    }) if "PySide2.Qt3DInput" in sys.modules else None

# Module PySide2.Qt3DLogic
sig_dict.update({

# class PySide2.Qt3DLogic.Qt3DLogic:

# class PySide2.Qt3DLogic.Qt3DLogic.QFrameAction:
    "PySide2.Qt3DLogic.Qt3DLogic.QFrameAction.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DLogic.Qt3DLogic.QLogicAspect:
    "PySide2.Qt3DLogic.Qt3DLogic.QLogicAspect.__init__": ('PySide2.QtCore.QObject',),
    }) if "PySide2.Qt3DLogic" in sys.modules else None

# Module PySide2.Qt3DAnimation
sig_dict.update({

# class PySide2.Qt3DAnimation.Qt3DAnimation:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.AnimationType:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.animationName": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.animationType": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.duration": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.position": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.setAnimationName": ('str',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.setDuration": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation.setPosition": ('float',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimationClip:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimationClip.duration": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractChannelMapping:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.Loops:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.clock": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.isRunning": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.loopCount": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.normalizedTime": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.setClock": ('PySide2.Qt3DAnimation.Qt3DAnimation.QClock',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.setLoopCount": ('int',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.setNormalizedTime": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.setRunning": ('bool',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.start": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipAnimator.stop": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.additiveClip": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.additiveFactor": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.baseClip": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.setAdditiveClip": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.setAdditiveFactor": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAdditiveClipBlend.setBaseClip": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationAspect:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationAspect.__init__": ('PySide2.QtCore.QObject',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationCallback:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationCallback.Flag:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationCallback.__init__": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationCallback.valueChanged": ('typing.Any',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClip:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClip.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClipLoader:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClipLoader.Status:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClipLoader.__init__": [('PySide2.Qt3DCore.Qt3DCore.QNode',), ('PySide2.QtCore.QUrl', 'PySide2.Qt3DCore.Qt3DCore.QNode')],
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClipLoader.setSource": ('PySide2.QtCore.QUrl',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClipLoader.source": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationClipLoader.status": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.activeAnimationGroup": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.addAnimationGroup": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.animationGroupList": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.entity": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.getAnimationIndex": ('str',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.getGroup": ('int',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.position": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.positionOffset": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.positionScale": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.recursive": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.removeAnimationGroup": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setActiveAnimationGroup": ('int',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setAnimationGroups": ('typing.List[PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setEntity": ('PySide2.Qt3DCore.Qt3DCore.QEntity',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setPosition": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setPositionOffset": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setPositionScale": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationController.setRecursive": ('bool',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.addAnimation": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.animationList": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.duration": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.name": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.position": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.removeAnimation": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.setAnimations": ('typing.List[PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimation]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.setName": ('str',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QAnimationGroup.setPosition": ('float',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QBlendedClipAnimator:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QBlendedClipAnimator.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QBlendedClipAnimator.blendTree": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QBlendedClipAnimator.setBlendTree": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QClipAnimator:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QClipAnimator.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QClipAnimator.clip": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QClipAnimator.setClip": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractAnimationClip',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QClock:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QClock.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QClock.playbackRate": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QClock.setPlaybackRate": ('float',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.InterpolationType:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.__init__": [(), ('PySide2.QtGui.QVector2D',), ('PySide2.QtGui.QVector2D', 'PySide2.QtGui.QVector2D', 'PySide2.QtGui.QVector2D')],
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.coordinates": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.interpolationType": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.leftControlPoint": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.rightControlPoint": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setCoordinates": ('PySide2.QtGui.QVector2D',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setInterpolationType": ('PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.InterpolationType',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setLeftControlPoint": ('PySide2.QtGui.QVector2D',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyFrame.setRightControlPoint": ('PySide2.QtGui.QVector2D',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.RepeatMode:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.addKeyframe": ('PySide2.Qt3DCore.Qt3DCore.QTransform',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.easing": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.endMode": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.framePositions": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.keyframeList": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.removeKeyframe": ('PySide2.Qt3DCore.Qt3DCore.QTransform',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setEasing": ('PySide2.QtCore.QEasingCurve',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setEndMode": ('PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.RepeatMode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setFramePositions": ('typing.List[float]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setKeyframes": ('typing.List[PySide2.Qt3DCore.Qt3DCore.QTransform]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setStartMode": ('PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.RepeatMode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setTarget": ('PySide2.Qt3DCore.Qt3DCore.QTransform',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.setTargetName": ('str',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.startMode": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.target": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QKeyframeAnimation.targetName": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.blendFactor": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.endClip": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.setBlendFactor": ('float',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.setEndClip": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.setStartClip": ('PySide2.Qt3DAnimation.Qt3DAnimation.QAbstractClipBlendNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QLerpClipBlend.startClip": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.addAttribute": ('PySide2.Qt3DRender.Qt3DRender.QAttribute',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.attributeList": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.attributeNames": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.fromGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry', 'typing.Sequence[str]'),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.removeAttribute": ('PySide2.Qt3DRender.Qt3DRender.QAttribute',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget.setAttributes": ('typing.List[PySide2.Qt3DRender.Qt3DRender.QAttribute]',),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation:

# class PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.Method:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.addMorphTarget": ('PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.easing": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.getWeights": ('int',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.interpolator": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.method": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.morphTargetList": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.removeMorphTarget": ('PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setEasing": ('PySide2.QtCore.QEasingCurve',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setMethod": ('PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.Method',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setMorphTargets": ('typing.List[PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setTarget": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setTargetName": ('str',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setTargetPositions": ('typing.List[float]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.setWeights": ('int', 'typing.List[float]'),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.target": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.targetName": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QMorphingAnimation.targetPositions": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QSkeletonMapping:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QSkeletonMapping.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QSkeletonMapping.setSkeleton": ('PySide2.Qt3DCore.Qt3DCore.QAbstractSkeleton',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QSkeletonMapping.skeleton": (),

# class PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation:
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.__init__": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.addMorphTarget": ('PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.interpolator": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.morphTargetList": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.removeMorphTarget": ('PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.setMorphTargets": ('typing.List[PySide2.Qt3DAnimation.Qt3DAnimation.QMorphTarget]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.setTarget": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.setTargetName": ('str',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.setTargetPositions": ('typing.List[float]',),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.target": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.targetName": (),
    "PySide2.Qt3DAnimation.Qt3DAnimation.QVertexBlendAnimation.targetPositions": (),
    }) if "PySide2.Qt3DAnimation" in sys.modules else None

# Module PySide2.Qt3DExtras
sig_dict.update({

# class PySide2.Qt3DExtras.Qt3DExtras:

# class PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController:

# class PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState:
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState.__init__": [(), ('PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState',)],
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.InputState.__copy__": (),

    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.acceleration": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.camera": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.deceleration": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.linearSpeed": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.lookSpeed": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.setAcceleration": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.setCamera": ('PySide2.Qt3DRender.Qt3DRender.QCamera',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.setDeceleration": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.setLinearSpeed": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractCameraController.setLookSpeed": ('float',),

# class PySide2.Qt3DExtras.Qt3DExtras.QAbstractSpriteSheet:
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractSpriteSheet.currentIndex": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractSpriteSheet.setCurrentIndex": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractSpriteSheet.setTexture": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractSpriteSheet.texture": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QAbstractSpriteSheet.textureTransform": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.bottomRadius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.hasBottomEndcap": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.hasTopEndcap": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.length": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setBottomRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setHasBottomEndcap": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setHasTopEndcap": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setLength": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.setTopRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.slices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.texCoordAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.topRadius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.updateIndices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeGeometry.updateVertices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QConeMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.bottomRadius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.hasBottomEndcap": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.hasTopEndcap": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.length": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setBottomRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setFirstInstance": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setHasBottomEndcap": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setHasTopEndcap": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setIndexOffset": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setInstanceCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setLength": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setRestartIndexValue": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setTopRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.setVertexCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.slices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QConeMesh.topRadius": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.setXExtent": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.setXYMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.setXZMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.setYExtent": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.setYZMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.setZExtent": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.tangentAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.texCoordAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.updateIndices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.updateVertices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.xExtent": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.xyMeshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.xzMeshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.yExtent": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.yzMeshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidGeometry.zExtent": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setFirstInstance": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setIndexOffset": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setInstanceCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setRestartIndexValue": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setVertexCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setXExtent": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setXYMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setXZMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setYExtent": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setYZMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.setZExtent": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.xExtent": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.xyMeshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.xzMeshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.yExtent": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.yzMeshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCuboidMesh.zExtent": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.length": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.radius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.setLength": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.setRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.slices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.texCoordAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.updateIndices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderGeometry.updateVertices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.length": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.radius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setFirstInstance": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setIndexOffset": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setInstanceCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setLength": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setRestartIndexValue": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.setVertexCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QCylinderMesh.slices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.setDiffuse": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.setSpecular": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.setTextureScale": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.specular": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseMapMaterial.textureScale": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.setDiffuse": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.setSpecular": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.setTextureScale": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.specular": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMapMaterial.textureScale": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.isAlphaBlendingEnabled": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.normal": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setAlphaBlendingEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setDiffuse": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setNormal": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setSpecular": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.setTextureScale": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.specular": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QDiffuseSpecularMaterial.textureScale": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.extrusionLength": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.font": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.setDepth": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.setText": ('str',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextGeometry.text": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.depth": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.font": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.setDepth": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.setText": ('str',),
    "PySide2.Qt3DExtras.Qt3DExtras.QExtrudedTextMesh.text": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QFirstPersonCameraController:
    "PySide2.Qt3DExtras.Qt3DExtras.QFirstPersonCameraController.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer:
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.buffersToClear": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.camera": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.clearColor": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.externalRenderTargetSize": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.gamma": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.isFrustumCullingEnabled": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setBuffersToClear": ('PySide2.Qt3DRender.Qt3DRender.QClearBuffers.BufferType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setCamera": ('PySide2.Qt3DCore.Qt3DCore.QEntity',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setClearColor": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setExternalRenderTargetSize": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setFrustumCullingEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setGamma": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setSurface": ('PySide2.QtCore.QObject',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.setViewportRect": ('PySide2.QtCore.QRectF',),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.surface": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QForwardRenderer.viewportRect": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.alpha": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.beta": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.cool": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setAlpha": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setBeta": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setCool": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setDiffuse": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setSpecular": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.setWarm": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.specular": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QGoochMaterial.warm": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.ambientOcclusion": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.baseColor": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.metalness": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.normal": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.roughness": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.setAmbientOcclusion": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.setBaseColor": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.setMetalness": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.setNormal": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.setRoughness": ('typing.Any',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.setTextureScale": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMetalRoughMaterial.textureScale": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.interpolator": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.setDiffuse": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.setInterpolator": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.setSpecular": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QMorphPhongMaterial.specular": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.normal": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.setDiffuse": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.setNormal": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.setSpecular": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.setTextureScale": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.specular": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseMapMaterial.textureScale": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.normal": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.setDiffuse": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.setNormal": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.setSpecular": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.setTextureScale": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.specular": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QNormalDiffuseSpecularMapMaterial.textureScale": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QOrbitCameraController:
    "PySide2.Qt3DExtras.Qt3DExtras.QOrbitCameraController.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QOrbitCameraController.setZoomInLimit": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QOrbitCameraController.zoomInLimit": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QPerVertexColorMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QPerVertexColorMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),

# class PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.alpha": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.blendFunctionArg": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.destinationAlphaArg": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.destinationRgbArg": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setAlpha": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setBlendFunctionArg": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquation.BlendFunction',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setDestinationAlphaArg": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setDestinationRgbArg": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setDiffuse": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setSourceAlphaArg": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setSourceRgbArg": ('PySide2.Qt3DRender.Qt3DRender.QBlendEquationArguments.Blending',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.setSpecular": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.sourceAlphaArg": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.sourceRgbArg": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongAlphaMaterial.specular": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.ambient": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.diffuse": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.setAmbient": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.setDiffuse": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.setShininess": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.setSpecular": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.shininess": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPhongMaterial.specular": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.height": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.mirrored": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.resolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.setHeight": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.setMirrored": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.setResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.setWidth": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.tangentAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.texCoordAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.updateIndices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.updateVertices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneGeometry.width": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.height": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.meshResolution": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.mirrored": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setFirstInstance": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setHeight": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setIndexOffset": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setInstanceCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setMeshResolution": ('PySide2.QtCore.QSize',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setMirrored": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setRestartIndexValue": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setVertexCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.setWidth": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QPlaneMesh.width": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity:
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.baseName": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.extension": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.isGammaCorrectEnabled": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.setBaseName": ('str',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.setExtension": ('str',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSkyboxEntity.setGammaCorrectEnabled": ('bool',),

# class PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.generateTangents": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.radius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.setGenerateTangents": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.setRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.slices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.tangentAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.texCoordAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.updateIndices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereGeometry.updateVertices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.generateTangents": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.radius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setFirstInstance": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setGenerateTangents": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setIndexOffset": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setRestartIndexValue": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.setVertexCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSphereMesh.slices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QSpriteGrid:
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteGrid.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteGrid.columns": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteGrid.rows": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteGrid.setColumns": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteGrid.setRows": ('int',),

# class PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheet:
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheet.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheet.addSprite": [('PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem',), ('int', 'int', 'int', 'int')],
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheet.removeSprite": ('PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheet.setSprites": ('typing.List[PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem]',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheet.sprites": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem:
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.height": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.setHeight": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.setWidth": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.setX": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.setY": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.width": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.x": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QSpriteSheetItem.y": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity:
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.color": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.font": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.height": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.setColor": ('PySide2.QtGui.QColor',),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.setFont": ('PySide2.QtGui.QFont',),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.setHeight": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.setText": ('str',),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.setWidth": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.text": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QText2DEntity.width": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial:
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.isAlphaBlendingEnabled": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.setAlphaBlendingEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.setTexture": ('PySide2.Qt3DRender.Qt3DRender.QAbstractTexture',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.setTextureOffset": ('PySide2.QtGui.QVector2D',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.setTextureTransform": ('PySide2.QtGui.QMatrix3x3',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.texture": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.textureOffset": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTextureMaterial.textureTransform": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry:
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.indexAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.minorRadius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.normalAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.positionAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.radius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.setMinorRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.setRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.slices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.texCoordAttribute": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.updateIndices": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusGeometry.updateVertices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh:
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.__init__": ('PySide2.Qt3DCore.Qt3DCore.QNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.minorRadius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.radius": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.rings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setFirstInstance": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setGeometry": ('PySide2.Qt3DRender.Qt3DRender.QGeometry',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setIndexOffset": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setInstanceCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setMinorRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setPrimitiveRestartEnabled": ('bool',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setPrimitiveType": ('PySide2.Qt3DRender.Qt3DRender.QGeometryRenderer.PrimitiveType',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setRadius": ('float',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setRestartIndexValue": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setRings": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setSlices": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.setVertexCount": ('int',),
    "PySide2.Qt3DExtras.Qt3DExtras.QTorusMesh.slices": (),

# class PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow:
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.__init__": ('PySide2.QtGui.QScreen',),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.activeFrameGraph": (),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.camera": (),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.defaultFrameGraph": (),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.event": ('PySide2.QtCore.QEvent',),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.registerAspect": [('PySide2.Qt3DCore.Qt3DCore.QAbstractAspect',), ('str',)],
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.renderSettings": (),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.resizeEvent": ('PySide2.QtGui.QResizeEvent',),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.setActiveFrameGraph": ('PySide2.Qt3DRender.Qt3DRender.QFrameGraphNode',),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.setRootEntity": ('PySide2.Qt3DCore.Qt3DCore.QEntity',),
    "PySide2.Qt3DExtras.Qt3DExtras.Qt3DWindow.showEvent": ('PySide2.QtGui.QShowEvent',),
    }) if "PySide2.Qt3DExtras" in sys.modules else None

# Module testbinding
sig_dict.update({

# class testbinding.Enum1:

# class testbinding.IntValue:

    "testbinding.IntValue.__init__": [(), ('int',), ('testbinding.IntValue',)],
    "testbinding.IntValue.__copy__": (),

# class testbinding.PySideCPP:

# class testbinding.PySideCPP.TestObject2WithNamespace:
    "testbinding.PySideCPP.TestObject2WithNamespace.__init__": ('PySide2.QtCore.QObject',),
    "testbinding.PySideCPP.TestObject2WithNamespace.__repr__": (),
    "testbinding.PySideCPP.TestObject2WithNamespace.name": (),

# class testbinding.PySideCPP.TestObjectWithNamespace:
    "testbinding.PySideCPP.TestObjectWithNamespace.__init__": ('PySide2.QtCore.QObject',),
    "testbinding.PySideCPP.TestObjectWithNamespace.callSignal": ('testbinding.PySideCPP.TestObjectWithNamespace',),
    "testbinding.PySideCPP.TestObjectWithNamespace.callSignalWithNamespace": ('testbinding.PySideCPP.TestObjectWithNamespace',),
    "testbinding.PySideCPP.TestObjectWithNamespace.callSignalWithTypedef": ('int',),
    "testbinding.PySideCPP.TestObjectWithNamespace.name": (),

# class testbinding.TestObject:

    "testbinding.TestObject.__init__": ('int', 'PySide2.QtCore.QObject'),
    "testbinding.TestObject.addChild": ('PySide2.QtCore.QObject',),
    "testbinding.TestObject.checkType": ('typing.Any',),
    "testbinding.TestObject.createApp": (),
    "testbinding.TestObject.emitIdValueSignal": (),
    "testbinding.TestObject.emitSignalWithDefaultValue_bool": (),
    "testbinding.TestObject.emitSignalWithDefaultValue_void": (),
    "testbinding.TestObject.emitSignalWithTypedefValue": ('int',),
    "testbinding.TestObject.emitStaticMethodDoubleSignal": (),
    "testbinding.TestObject.idValue": (),
    "testbinding.TestObject.staticMethodDouble": ('int',),

# class testbinding.TestObjectWithoutNamespace:

# class testbinding.TestObjectWithoutNamespace.Enum2:
    "testbinding.TestObjectWithoutNamespace.__init__": ('PySide2.QtCore.QObject',),
    "testbinding.TestObjectWithoutNamespace.callSignal": ('testbinding.PySideCPP2.TestObjectWithoutNamespace',),
    "testbinding.TestObjectWithoutNamespace.callSignalWithNamespace": ('testbinding.PySideCPP2.TestObjectWithoutNamespace',),
    "testbinding.TestObjectWithoutNamespace.callSignalWithTypedef": ('int',),
    "testbinding.TestObjectWithoutNamespace.name": (),

# class testbinding.TestView:
    "testbinding.TestView.__init__": ('PySide2.QtCore.QAbstractListModel', 'PySide2.QtCore.QObject'),
    "testbinding.TestView.getData": (),
    "testbinding.TestView.getEditorWidgetFromItemDelegate": (),
    "testbinding.TestView.model": (),
    "testbinding.TestView.setItemDelegate": ('PySide2.QtWidgets.QAbstractItemDelegate',),

    "testbinding.TestView.getHiddenObject": (),
    }) if "testbinding" in sys.modules else None

# Module Shiboken
sig_dict.update({

# class Shiboken.VoidPtr:
    }) if "Shiboken" in sys.modules else None

# Module minimal
sig_dict.update({

# class minimal.ListUser:
    "minimal.ListUser.__init__": [(), ('minimal.ListUser',)],
    "minimal.ListUser.__copy__": (),
    "minimal.ListUser.callCreateIntList": ('int',),
    "minimal.ListUser.callCreateListOfIntLists": ('int',),
    "minimal.ListUser.callCreateMinBoolList": ('bool', 'bool'),
    "minimal.ListUser.callCreateObjList": ('minimal.Obj', 'minimal.Obj'),
    "minimal.ListUser.callCreateValList": ('int',),
    "minimal.ListUser.callOredMinBoolList": ('typing.List[bool]',),
    "minimal.ListUser.callSumIntList": ('typing.List[int]',),
    "minimal.ListUser.callSumListOfIntLists": ('typing.List[typing.List]',),
    "minimal.ListUser.callSumObjList": ('typing.List[minimal.Obj]',),
    "minimal.ListUser.callSumValList": ('typing.List[minimal.Val]',),
    "minimal.ListUser.createIntList": ('int',),
    "minimal.ListUser.createListOfIntLists": ('int',),
    "minimal.ListUser.createMinBoolList": ('bool', 'bool'),
    "minimal.ListUser.createObjList": ('minimal.Obj', 'minimal.Obj'),
    "minimal.ListUser.createValList": ('int',),
    "minimal.ListUser.oredMinBoolList": ('typing.List[bool]',),
    "minimal.ListUser.sumIntList": ('typing.List[int]',),
    "minimal.ListUser.sumListOfIntLists": ('typing.List[typing.List]',),
    "minimal.ListUser.sumObjList": ('typing.List[minimal.Obj]',),
    "minimal.ListUser.sumValList": ('typing.List[minimal.Val]',),

# class minimal.MinBoolUser:
    "minimal.MinBoolUser.__init__": [(), ('minimal.MinBoolUser',)],
    "minimal.MinBoolUser.__copy__": (),
    "minimal.MinBoolUser.callInvertedMinBool": (),
    "minimal.MinBoolUser.invertedMinBool": (),
    "minimal.MinBoolUser.minBool": (),
    "minimal.MinBoolUser.setMinBool": ('bool',),

# class minimal.Obj:
    "minimal.Obj.__init__": ('int',),
    "minimal.Obj.callPassObjectType": ('minimal.Obj',),
    "minimal.Obj.callPassObjectTypeReference": ('minimal.Obj',),
    "minimal.Obj.callVirtualMethod": ('int',),
    "minimal.Obj.objId": (),
    "minimal.Obj.passObjectType": ('minimal.Obj',),
    "minimal.Obj.passObjectTypeReference": ('minimal.Obj',),
    "minimal.Obj.setObjId": ('int',),
    "minimal.Obj.virtualMethod": ('int',),

# class minimal.Val:

# class minimal.Val.ValEnum:
    "minimal.Val.__init__": [('int',), ('minimal.Val',)],
    "minimal.Val.__copy__": (),
    "minimal.Val.callPassValueType": ('minimal.Val',),
    "minimal.Val.callPassValueTypePointer": ('minimal.Val',),
    "minimal.Val.callPassValueTypeReference": ('minimal.Val',),
    "minimal.Val.oneOrTheOtherEnumValue": ('minimal.Val.ValEnum',),
    "minimal.Val.passValueType": ('minimal.Val',),
    "minimal.Val.passValueTypePointer": ('minimal.Val',),
    "minimal.Val.passValueTypeReference": ('minimal.Val',),
    "minimal.Val.setValId": ('int',),
    "minimal.Val.valId": (),

    "minimal.Val.arrayFunc": ('typing.List[int]',),
    "minimal.Val.arrayFuncInt": ('typing.List[int]',),
    "minimal.Val.arrayFuncIntReturn": ('int',),
    "minimal.Val.arrayFuncIntReturnTypedef": ('int',),
    "minimal.Val.arrayFuncIntTypedef": ('typing.List[int]',),
    "minimal.Val.arrayFuncReturn": ('int',),
    "minimal.Val.arrayFuncReturnTypedef": ('int',),
    "minimal.Val.arrayFuncTypedef": ('typing.List[int]',),
    }) if "minimal" in sys.modules else None

# Module sample
sig_dict.update({

# class sample.Abstract:

# class sample.Abstract.PrintFormat:

# class sample.Abstract.Type:
    "sample.Abstract.__init__": ('int',),
    "sample.Abstract.callPureVirtual": (),
    "sample.Abstract.callUnpureVirtual": (),
    "sample.Abstract.callVirtualGettingEnum": ('sample.Abstract.PrintFormat',),
    "sample.Abstract.className": (),
    "sample.Abstract.createObject": (),
    "sample.Abstract.getObjectId": ('sample.Abstract',),
    "sample.Abstract.id_": (),
    "sample.Abstract.pureVirtual": (),
    "sample.Abstract.pureVirtualReturningVoidPtr": (),
    "sample.Abstract.returnAnEnum": (),
    "sample.Abstract.show": ('sample.Abstract.PrintFormat',),
    "sample.Abstract.type": (),
    "sample.Abstract.unpureVirtual": (),
    "sample.Abstract.virtualGettingAEnum": ('sample.Abstract.PrintFormat',),

# class sample.AbstractModifications:
    "sample.AbstractModifications.__init__": (),
    "sample.AbstractModifications.invert": ('bool',),
    "sample.AbstractModifications.pointlessPureVirtualMethod": (),

# class sample.ArrayModifyTest:
    "sample.ArrayModifyTest.__init__": [(), ('sample.ArrayModifyTest',)],
    "sample.ArrayModifyTest.__copy__": (),
    "sample.ArrayModifyTest.sumIntArray": ('int', 'typing.Sequence[int]'),

# class sample.Base1:
    "sample.Base1.__init__": (),
    "sample.Base1.base1Method": (),
    "sample.Base1.publicMethod": (),

# class sample.Base2:
    "sample.Base2.__init__": (),
    "sample.Base2.base2Method": (),

# class sample.Base3:
    "sample.Base3.__init__": ('int',),
    "sample.Base3.base3Method": (),

# class sample.Base4:
    "sample.Base4.__init__": (),
    "sample.Base4.base4Method": (),

# class sample.Base5:
    "sample.Base5.__init__": (),
    "sample.Base5.base5Method": (),

# class sample.Base6:
    "sample.Base6.__init__": (),
    "sample.Base6.base6Method": (),

# class sample.BlackBox:
    "sample.BlackBox.__init__": [(), ('sample.BlackBox',)],
    "sample.BlackBox.__copy__": (),
    "sample.BlackBox.disposeObjectType": ('int',),
    "sample.BlackBox.disposePoint": ('int',),
    "sample.BlackBox.keepObjectType": ('object',),
    "sample.BlackBox.keepPoint": ('typing.Tuple[float, float]',),
    "sample.BlackBox.objects": (),
    "sample.BlackBox.points": (),
    "sample.BlackBox.referenceToObjectPointer": ('object',),
    "sample.BlackBox.referenceToValuePointer": ('typing.Tuple[float, float]',),
    "sample.BlackBox.retrieveObjectType": ('int',),
    "sample.BlackBox.retrievePoint": ('int',),

# class sample.Bucket:
    "sample.Bucket.__init__": (),
    "sample.Bucket.callVirtualBlockerMethodButYouDontKnowThis": (),
    "sample.Bucket.empty": (),
    "sample.Bucket.lock": (),
    "sample.Bucket.locked": (),
    "sample.Bucket.pop": (),
    "sample.Bucket.push": ('int',),
    "sample.Bucket.unlock": (),
    "sample.Bucket.virtualBlockerMethod": (),

# class sample.ByteArray:
    "sample.ByteArray.__init__": [(), ('sample.ByteArray',), ('typing.Char',)],
    "sample.ByteArray.__add__": [('sample.ByteArray',), ('str',), ('typing.Char',), ('unicode',)],
    "sample.ByteArray.__copy__": (),
    "sample.ByteArray.__iadd__": [('sample.ByteArray',), ('typing.Char',)],
    "sample.ByteArray.__repr__": (),
    "sample.ByteArray.__str__": (),
    "sample.ByteArray.append": [('sample.ByteArray',), ('typing.Char',)],
    "sample.ByteArray.at": ('int',),
    "sample.ByteArray.data": (),
    "sample.ByteArray.size": (),

# class sample.CVListUser:
    "sample.CVListUser.__init__": [(), ('sample.CVListUser',)],
    "sample.CVListUser.__copy__": (),
    "sample.CVListUser.consume": ('typing.List[sample.CVValueType]',),
    "sample.CVListUser.produce": (),

# class sample.CVValueType:
    "sample.CVValueType.__copy__": (),

# class sample.ClassWithFunctionPointer:
    "sample.ClassWithFunctionPointer.__init__": [(), ('sample.ClassWithFunctionPointer',)],
    "sample.ClassWithFunctionPointer.__copy__": (),
    "sample.ClassWithFunctionPointer.doNothing": ('int',),

# class sample.Collector:
    "sample.Collector.__init__": (),
    "sample.Collector.__lshift__": [('Missing("sample.ObjectType.Identifier")',), ('object',), ('sample.IntWrapper',)],
    "sample.Collector.clear": (),
    "sample.Collector.items": (),
    "sample.Collector.size": (),

# class sample.Color:
    "sample.Color.__init__": [(), ('int',), ('sample.Color',), ('sample.SampleNamespace.InValue',)],
    "sample.Color.__copy__": (),
    "sample.Color.isNull": (),

# class sample.CtorConvRule:
    "sample.CtorConvRule.__init__": [('int',), ('sample.CtorConvRule',)],
    "sample.CtorConvRule.__copy__": (),
    "sample.CtorConvRule.dummyVirtualMethod": (),
    "sample.CtorConvRule.value": (),

# class sample.Data:

# class sample.Data.Field:
    "sample.Data.__init__": [('sample.Data',), ('sample.Data.Field', 'str')],
    "sample.Data.__and__": ('sample.Union',),
    "sample.Data.__copy__": (),
    "sample.Data.field": (),
    "sample.Data.value": (),

# class sample.Derived:

# class sample.Derived.OtherOverloadedFuncEnum:

# class sample.Derived.SomeInnerClass:
    "sample.Derived.SomeInnerClass.__init__": [(), ('sample.Derived.SomeInnerClass',)],
    "sample.Derived.SomeInnerClass.__add__": ('sample.Derived.SomeInnerClass',),
    "sample.Derived.SomeInnerClass.__copy__": (),
    "sample.Derived.SomeInnerClass.uselessMethod": (),

    "sample.Derived.__init__": ('int',),
    "sample.Derived.className": (),
    "sample.Derived.createObject": (),
    "sample.Derived.defaultValue": ('int',),
    "sample.Derived.getClassName": (),
    "sample.Derived.otherOverloaded": [('int', 'float'), ('int', 'int', 'bool', 'float')],
    "sample.Derived.overloaded": [('float',), ('int', 'int')],
    "sample.Derived.pureVirtual": (),
    "sample.Derived.pureVirtualReturningVoidPtr": (),
    "sample.Derived.returnAnEnum": (),
    "sample.Derived.returnMyParameter": ('sample.Derived.SomeInnerClass',),
    "sample.Derived.singleArgument": ('bool',),
    "sample.Derived.triggerAnotherImpossibleTypeDiscovery": (),
    "sample.Derived.triggerImpossibleTypeDiscovery": (),
    "sample.Derived.type": (),
    "sample.Derived.unpureVirtual": (),

# class sample.Echo:
    "sample.Echo.__init__": [(), ('sample.Echo',)],
    "sample.Echo.__call__": ('sample.Str', 'int'),
    "sample.Echo.__copy__": (),
    "sample.Echo.__lshift__": [('int',), ('object',), ('sample.Str',)],
    "sample.Echo.doNothingWithConstBool": ('bool',),
    "sample.Echo.echo": ('str',),
    "sample.Echo.methodWithNamedArg": ('sample.Str',),

# class sample.EnumOnNamespace:

# class sample.Event:

# class sample.Event.EventType:

# class sample.Event.EventTypeClass:
    "sample.Event.__init__": [('sample.Event',), ('sample.Event.EventType',)],
    "sample.Event.__copy__": (),
    "sample.Event.eventType": (),
    "sample.Event.setEventType": ('sample.Event.EventType',),
    "sample.Event.setEventTypeByConstRef": ('sample.Event.EventType',),

# class sample.ExceptionTest:
    "sample.ExceptionTest.__init__": (),
    "sample.ExceptionTest.intThrowInt": ('bool',),
    "sample.ExceptionTest.intThrowStdException": ('bool',),
    "sample.ExceptionTest.voidThrowInt": ('bool',),
    "sample.ExceptionTest.voidThrowStdException": ('bool',),

# class sample.Expression:
    "sample.Expression.__init__": [('int',), ('sample.Expression',)],
    "sample.Expression.__add__": ('sample.Expression',),
    "sample.Expression.__copy__": (),
    "sample.Expression.__sub__": ('sample.Expression',),
    "sample.Expression.toString": (),

# class sample.Filter:
    "sample.Filter.__init__": [(), ('sample.Filter',)],
    "sample.Filter.__copy__": (),

# class sample.FriendOfOnlyCopy:
    "sample.FriendOfOnlyCopy.__init__": [(), ('sample.FriendOfOnlyCopy',)],
    "sample.FriendOfOnlyCopy.__copy__": (),
    "sample.FriendOfOnlyCopy.createListOfOnlyCopy": ('int',),
    "sample.FriendOfOnlyCopy.createOnlyCopy": ('int',),

# class sample.GlobalEnum:

# class sample.GlobalOverloadFuncEnum:

# class sample.HandleHolder:
    "sample.HandleHolder.__init__": ('int',),
    "sample.HandleHolder.compare": ('sample.HandleHolder',),
    "sample.HandleHolder.compare2": ('sample.HandleHolder',),
    "sample.HandleHolder.createHandle": (),
    "sample.HandleHolder.handle": (),
    "sample.HandleHolder.handle2": (),
    "sample.HandleHolder.set": ('int',),

# class sample.ImplicitBase:
    "sample.ImplicitBase.__init__": [(), ('sample.ImplicitBase',), ('sample.ImplicitTarget',)],
    "sample.ImplicitBase.__copy__": (),

# class sample.ImplicitConv:

# class sample.ImplicitConv.CtorEnum:

# class sample.ImplicitConv.ICOverloadedFuncEnum:
    "sample.ImplicitConv.__init__": [(), ('None',), ('float', 'bool'), ('int',), ('object',), ('sample.ImplicitConv',), ('sample.ImplicitConv.CtorEnum',)],
    "sample.ImplicitConv.__copy__": (),
    "sample.ImplicitConv.ctorEnum": (),
    "sample.ImplicitConv.implicitConvCommon": ('sample.ImplicitConv',),
    "sample.ImplicitConv.implicitConvDefault": ('sample.ImplicitConv',),
    "sample.ImplicitConv.implicitConvOverloading": [('int',), ('sample.ImplicitConv', 'bool'), ('sample.ImplicitConv', 'int'), ('sample.ImplicitConv.CtorEnum',)],
    "sample.ImplicitConv.objId": (),
    "sample.ImplicitConv.value": (),

# class sample.ImplicitTarget:
    "sample.ImplicitTarget.__init__": [(), ('sample.ImplicitTarget',)],
    "sample.ImplicitTarget.__copy__": (),

# class sample.InjectCode:
    "sample.InjectCode.__init__": [(), ('sample.InjectCode',)],
    "sample.InjectCode.__copy__": (),
    "sample.InjectCode.arrayMethod": ('int',),
    "sample.InjectCode.callArrayMethod": ('int',),
    "sample.InjectCode.overloadedMethod": [('int', 'bool'), ('int', 'float'), ('int', 'typing.List[str]')],
    "sample.InjectCode.simpleMethod1": ('int', 'int'),
    "sample.InjectCode.simpleMethod2": (),
    "sample.InjectCode.simpleMethod3": ('int', 'typing.List[str]'),
    "sample.InjectCode.sumArrayAndLength": (),
    "sample.InjectCode.virtualMethod": ('int',),

# class sample.IntArray2:
    "sample.IntArray2.__init__": [('int',), ('sample.IntArray2',), ('typing.Sequence[int]',)],
    "sample.IntArray2.__copy__": (),
    "sample.IntArray2.sum": (),

# class sample.IntArray3:
    "sample.IntArray3.__init__": [('int',), ('sample.IntArray3',), ('typing.Sequence[int]',)],
    "sample.IntArray3.__copy__": (),
    "sample.IntArray3.sum": (),

# class sample.IntList:

# class sample.IntList.CtorEnum:
    "sample.IntList.__init__": [(), ('int',), ('sample.IntList',), ('typing.Sequence[int]',)],
    "sample.IntList.__copy__": (),
    "sample.IntList.append": ('int',),
    "sample.IntList.constructorUsed": (),

# class sample.IntWrapper:
    "sample.IntWrapper.__init__": [('int',), ('sample.IntWrapper',)],
    "sample.IntWrapper.__copy__": (),

# class sample.Intersection:
    "sample.Intersection.__init__": [(), ('sample.Data',), ('sample.Intersection',), ('sample.Union',)],
    "sample.Intersection.__and__": ('sample.Intersection',),
    "sample.Intersection.__copy__": (),
    "sample.Intersection.addFilter": ('sample.Filter',),
    "sample.Intersection.filters": (),

# class sample.ListUser:

# class sample.ListUser.ListOfSomething:
    "sample.ListUser.__init__": [(), ('sample.ListUser',)],
    "sample.ListUser.__copy__": (),
    "sample.ListUser.callCreateList": (),
    "sample.ListUser.createComplexList": ('complex', 'complex'),
    "sample.ListUser.createList": (),
    "sample.ListUser.getList": (),
    "sample.ListUser.listOfPoints": [('typing.List[sample.PointF]',), ('typing.List[typing.Tuple]',)],
    "sample.ListUser.multiplyPointList": ('typing.List[typing.Tuple]', 'float'),
    "sample.ListUser.setList": ('typing.List[int]',),
    "sample.ListUser.sumList": [('typing.List[float]',), ('typing.List[int]',)],

# class sample.MDerived1:
    "sample.MDerived1.__init__": (),
    "sample.MDerived1.base1Method": (),
    "sample.MDerived1.base2Method": (),
    "sample.MDerived1.castToBase1": (),
    "sample.MDerived1.castToBase2": (),
    "sample.MDerived1.mderived1Method": (),
    "sample.MDerived1.publicMethod": (),
    "sample.MDerived1.transformFromBase1": ('sample.Base1',),
    "sample.MDerived1.transformFromBase2": ('sample.Base2',),

# class sample.MDerived2:
    "sample.MDerived2.__init__": (),
    "sample.MDerived2.base4Method": (),
    "sample.MDerived2.castToBase3": (),
    "sample.MDerived2.castToBase4": (),
    "sample.MDerived2.castToBase5": (),
    "sample.MDerived2.castToBase6": (),
    "sample.MDerived2.mderived2Method": (),

# class sample.MDerived3:
    "sample.MDerived3.__init__": (),
    "sample.MDerived3.castToBase3": (),
    "sample.MDerived3.castToMDerived1": (),
    "sample.MDerived3.castToMDerived2": (),
    "sample.MDerived3.mderived3Method": (),

# class sample.MDerived4:
    "sample.MDerived4.__init__": (),
    "sample.MDerived4.castToBase3": (),
    "sample.MDerived4.castToBase4": (),
    "sample.MDerived4.justDummyMethod": (),
    "sample.MDerived4.mderived4Method": (),

# class sample.MDerived5:
    "sample.MDerived5.__init__": (),
    "sample.MDerived5.castToBase3": (),
    "sample.MDerived5.castToBase4": (),
    "sample.MDerived5.mderived5Method": (),

# class sample.MapUser:
    "sample.MapUser.__init__": [(), ('sample.MapUser',)],
    "sample.MapUser.__copy__": (),
    "sample.MapUser.callCreateMap": (),
    "sample.MapUser.createMap": (),
    "sample.MapUser.foo": (),
    "sample.MapUser.getMap": (),
    "sample.MapUser.passMapIntValueType": ('typing.Dict[int, sample.ByteArray]',),
    "sample.MapUser.pointerToMap": ('typing.Dict[str, str]',),
    "sample.MapUser.referenceToMap": ('typing.Dict[str, str]',),
    "sample.MapUser.setMap": ('typing.Dict[str, typing.List]',),
    "sample.MapUser.showMap": ('typing.Dict[str, int]',),

# class sample.ModelIndex:
    "sample.ModelIndex.__init__": [(), ('sample.ModelIndex',)],
    "sample.ModelIndex.__copy__": (),
    "sample.ModelIndex.getValue": ('sample.ModelIndex',),
    "sample.ModelIndex.setValue": ('int',),
    "sample.ModelIndex.value": (),

# class sample.Modifications:

# class sample.Modifications.OverloadedModFunc:

# class sample.Modifications.TestEnum:
    "sample.Modifications.__init__": (),
    "sample.Modifications.argRemoval0": [('int', 'bool', 'int', 'bool'), ('int', 'bool', 'int', 'int')],
    "sample.Modifications.argRemoval1": [('int', 'bool', 'int', 'bool'), ('int', 'bool', 'typing.Tuple[float, float]', 'typing.Tuple[float, float]', 'int')],
    "sample.Modifications.argRemoval2": ('int', 'bool', 'typing.Tuple[float, float]', 'typing.Tuple[float, float]', 'int'),
    "sample.Modifications.argRemoval3": ('int', 'typing.Tuple[float, float]', 'bool', 'typing.Tuple[float, float]', 'int'),
    "sample.Modifications.argRemoval4": ('int', 'typing.Tuple[float, float]', 'bool', 'typing.Tuple[float, float]', 'int'),
    "sample.Modifications.argRemoval5": [('int', 'bool', 'int', 'bool'), ('int', 'bool', 'typing.Tuple[float, float]', 'typing.Tuple[float, float]', 'int')],
    "sample.Modifications.calculateArea": ('int', 'int'),
    "sample.Modifications.callDifferenceOfPointCoordinates": ('typing.Tuple[float, float]',),
    "sample.Modifications.defaultEnumValue": (),
    "sample.Modifications.differenceOfPointCoordinates": ('typing.Tuple[float, float]',),
    "sample.Modifications.doublePlus": ('int', 'int'),
    "sample.Modifications.enumValue": (),
    "sample.Modifications.getObject": (),
    "sample.Modifications.getSize": ('int', 'int'),
    "sample.Modifications.increment": ('int',),
    "sample.Modifications.invertBoolean": ('bool',),
    "sample.Modifications.multiplyPointCoordsPlusValue": ('typing.Tuple[float, float]', 'float'),
    "sample.Modifications.name": (),
    "sample.Modifications.nonConversionRuleForArgumentWithDefaultValue": ('object',),
    "sample.Modifications.over": ('int', 'bool', 'typing.Tuple[float, float]', 'typing.Tuple[float, float]'),
    "sample.Modifications.overloaded": [('int', 'bool', 'int', 'bool'), ('int', 'bool', 'int', 'float'), ('int', 'bool', 'int', 'int'), ('int', 'bool', 'int', 'typing.Tuple[float, float]')],
    "sample.Modifications.pointToPair": ('typing.Tuple[float, float]',),
    "sample.Modifications.power": ('int', 'int'),
    "sample.Modifications.setEnumValue": ('sample.Modifications.TestEnum',),
    "sample.Modifications.sumPointArray": ('int', 'typing.Sequence[typing.Tuple]'),
    "sample.Modifications.sumPointCoordinates": ('typing.Tuple[float, float]',),
    "sample.Modifications.timesTen": ('int',),

# class sample.ModifiedConstructor:
    "sample.ModifiedConstructor.__init__": ('int',),
    "sample.ModifiedConstructor.retrieveValue": (),

# class sample.NoImplicitConversion:
    "sample.NoImplicitConversion.__init__": [('int',), ('sample.NoImplicitConversion',)],
    "sample.NoImplicitConversion.__copy__": (),
    "sample.NoImplicitConversion.objId": (),
    "sample.NoImplicitConversion.receivesNoImplicitConversionByPointer": ('sample.NoImplicitConversion',),
    "sample.NoImplicitConversion.receivesNoImplicitConversionByReference": ('sample.NoImplicitConversion',),
    "sample.NoImplicitConversion.receivesNoImplicitConversionByValue": ('sample.NoImplicitConversion',),

# class sample.NonDefaultCtor:
    "sample.NonDefaultCtor.__init__": [('int',), ('sample.NonDefaultCtor',)],
    "sample.NonDefaultCtor.__copy__": (),
    "sample.NonDefaultCtor.callReturnMyselfVirtual": (),
    "sample.NonDefaultCtor.returnMyself": [(), ('int',), ('int', 'sample.NonDefaultCtor')],
    "sample.NonDefaultCtor.returnMyselfVirtual": (),
    "sample.NonDefaultCtor.value": (),

# class sample.ObjTypeReference:
    "sample.ObjTypeReference.__init__": [(), ('sample.ObjTypeReference',)],
    "sample.ObjTypeReference.justAPureVirtualFunc": ('sample.ObjTypeReference',),
    "sample.ObjTypeReference.returnMyFirstArg": ('sample.ObjTypeReference',),
    "sample.ObjTypeReference.returnMySecondArg": ('int', 'sample.ObjTypeReference'),

# class sample.ObjectModel:

# class sample.ObjectModel.MethodCalled:
    "sample.ObjectModel.__init__": ('object',),
    "sample.ObjectModel.data": (),
    "sample.ObjectModel.receivesObjectTypeFamily": [('object',), ('sample.ObjectModel',)],
    "sample.ObjectModel.setData": ('object',),

# class sample.ObjectType:
    "sample.ObjectType.__init__": ('object',),
    "sample.ObjectType.callId": (),
    "sample.ObjectType.callInvalidateEvent": ('sample.Event',),
    "sample.ObjectType.callVirtualCreateChild": (),
    "sample.ObjectType.callWithEnum": [('sample.Str', 'sample.Event.EventType', 'typing.Char'), ('sample.Str', 'typing.Char')],
    "sample.ObjectType.causeEvent": ('sample.Event.EventType',),
    "sample.ObjectType.children": (),
    "sample.ObjectType.create": (),
    "sample.ObjectType.createChild": ('object',),
    "sample.ObjectType.createObjectType": (),
    "sample.ObjectType.createWithChild": (),
    "sample.ObjectType.deprecatedFunction": (),
    "sample.ObjectType.destroyCppParent": (),
    "sample.ObjectType.event": ('sample.Event',),
    "sample.ObjectType.findChild": ('sample.Str',),
    "sample.ObjectType.getCppParent": (),
    "sample.ObjectType.identifier": (),
    "sample.ObjectType.invalidateEvent": ('sample.Event',),
    "sample.ObjectType.isLayoutType": (),
    "sample.ObjectType.isPython": (),
    "sample.ObjectType.killChild": ('sample.Str',),
    "sample.ObjectType.layout": (),
    "sample.ObjectType.nextInFocusChain": (),
    "sample.ObjectType.objectName": (),
    "sample.ObjectType.parent": (),
    "sample.ObjectType.processEvent": ('typing.List[object]', 'sample.Event'),
    "sample.ObjectType.removeChild": ('object',),
    "sample.ObjectType.setLayout": ('sample.ObjectTypeLayout',),
    "sample.ObjectType.setNullObject": ('None',),
    "sample.ObjectType.setObject": ('object',),
    "sample.ObjectType.setObjectName": ('sample.Str',),
    "sample.ObjectType.setObjectNameWithSize": [('sample.Str', 'int'), ('str', 'int', 'sample.Str')],
    "sample.ObjectType.setObjectSplittedName": ('str', 'sample.Str', 'sample.Str'),
    "sample.ObjectType.setParent": ('object',),
    "sample.ObjectType.takeChild": [('object',), ('sample.Str',)],

# class sample.ObjectTypeByValue:
    "sample.ObjectTypeByValue.__init__": (),
    "sample.ObjectTypeByValue.acceptKindOfMeAsValue": ('sample.ObjectTypeByValue',),
    "sample.ObjectTypeByValue.acceptListOfObjectTypeByValue": ('typing.List[sample.ObjectTypeByValue]',),
    "sample.ObjectTypeByValue.returnSomeKindOfMe": (),

# class sample.ObjectTypeDerived:
    "sample.ObjectTypeDerived.__init__": (),
    "sample.ObjectTypeDerived.event": ('sample.Event',),

# class sample.ObjectTypeHolder:
    "sample.ObjectTypeHolder.__init__": [('sample.ObjectTypeHolder',), ('str',)],
    "sample.ObjectTypeHolder.__copy__": (),
    "sample.ObjectTypeHolder.callPassObjectTypeAsReference": (),
    "sample.ObjectTypeHolder.getObjecType": (),
    "sample.ObjectTypeHolder.passObjectTypeAsReference": ('object',),

# class sample.ObjectTypeLayout:
    "sample.ObjectTypeLayout.__init__": (),
    "sample.ObjectTypeLayout.addObject": ('object',),
    "sample.ObjectTypeLayout.create": (),
    "sample.ObjectTypeLayout.isLayoutType": (),
    "sample.ObjectTypeLayout.objects": (),
    "sample.ObjectTypeLayout.takeChild": [('object',), ('sample.Str',)],

# class sample.ObjectTypeOperators:
    "sample.ObjectTypeOperators.__init__": ('str',),
    "sample.ObjectTypeOperators.__add__": ('str',),
    "sample.ObjectTypeOperators.key": (),

# class sample.ObjectTypePtrList:

# class sample.ObjectTypePtrList.CtorEnum:
    "sample.ObjectTypePtrList.__init__": [(), ('object',), ('sample.ObjectTypePtrList',), ('typing.Sequence[object]',)],
    "sample.ObjectTypePtrList.__copy__": (),
    "sample.ObjectTypePtrList.append": ('object',),
    "sample.ObjectTypePtrList.constructorUsed": (),

# class sample.ObjectView:
    "sample.ObjectView.__init__": ('sample.ObjectModel', 'object'),
    "sample.ObjectView.displayModelData": (),
    "sample.ObjectView.getRawModelData": (),
    "sample.ObjectView.model": (),
    "sample.ObjectView.modifyModelData": ('sample.Str',),
    "sample.ObjectView.setModel": ('sample.ObjectModel',),

# class sample.OddBoolUser:
    "sample.OddBoolUser.__init__": [(), ('bool',), ('sample.OddBoolUser',)],
    "sample.OddBoolUser.__copy__": (),
    "sample.OddBoolUser.callInvertedOddBool": (),
    "sample.OddBoolUser.getOddBool": ('sample.OddBoolUser',),
    "sample.OddBoolUser.invertedOddBool": (),
    "sample.OddBoolUser.oddBool": (),
    "sample.OddBoolUser.setOddBool": ('bool',),

# class sample.OnlyCopy:
    "sample.OnlyCopy.__init__": ('sample.OnlyCopy',),
    "sample.OnlyCopy.__copy__": (),
    "sample.OnlyCopy.getValue": ('sample.OnlyCopy',),
    "sample.OnlyCopy.getValueFromReference": ('sample.OnlyCopy',),
    "sample.OnlyCopy.value": (),

# class sample.OtherBase:
    "sample.OtherBase.__init__": (),

# class sample.Overload:

# class sample.Overload.FunctionEnum:

# class sample.Overload.ParamEnum:
    "sample.Overload.__init__": (),
    "sample.Overload.acceptSequence": [(), ('int',), ('int', 'int'), ('sample.Size',), ('sample.Str', 'sample.Overload.ParamEnum'), ('typing.Sequence[str]',)],
    "sample.Overload.differentReturnTypes": [('sample.Overload.ParamEnum',), ('sample.Overload.ParamEnum', 'int')],
    "sample.Overload.drawText": [('int', 'int', 'int', 'int', 'int', 'sample.Str'), ('int', 'int', 'sample.Str'), ('sample.PointF', 'sample.Str'), ('sample.Rect', 'int', 'sample.Str'), ('sample.RectF', 'int', 'sample.Str'), ('sample.RectF', 'sample.Str', 'sample.Echo'), ('typing.Tuple[float, float]', 'sample.Str')],
    "sample.Overload.drawText2": [('int', 'int', 'int', 'int', 'int', 'sample.Str'), ('int', 'int', 'sample.Str'), ('sample.PointF', 'sample.Str'), ('sample.Rect', 'int', 'sample.Str'), ('sample.RectF', 'int', 'sample.Str'), ('sample.RectF', 'sample.Str', 'sample.Echo'), ('typing.Tuple[float, float]', 'sample.Str')],
    "sample.Overload.drawText3": [('int', 'int', 'int', 'int', 'int'), ('sample.Str', 'sample.Str', 'sample.Str')],
    "sample.Overload.drawText4": [('int', 'int', 'int'), ('int', 'int', 'int', 'int', 'int')],
    "sample.Overload.intDoubleOverloads": [('float', 'float'), ('int', 'int')],
    "sample.Overload.intOverloads": [('int', 'int'), ('int', 'int', 'float'), ('typing.Tuple[float, float]', 'float')],
    "sample.Overload.overloaded": [(), ('sample.Size',), ('typing.Tuple[float, float]',), ('typing.Tuple[float, float]', 'sample.Overload.ParamEnum')],
    "sample.Overload.singleOverload": [(), ('typing.Tuple[float, float]',)],
    "sample.Overload.strBufferOverloads": [(), ('sample.Str', 'int'), ('sample.Str', 'str', 'bool'), ('str', 'int')],
    "sample.Overload.wrapperIntIntOverloads": [('sample.Polygon', 'int', 'int'), ('typing.Tuple[float, float]', 'int', 'int')],

# class sample.Overload2:
    "sample.Overload2.__init__": (),
    "sample.Overload2.doNothingInPublic": [(), ('int',)],
    "sample.Overload2.doNothingInPublic2": [(), ('int',)],
    "sample.Overload2.doNothingInPublic3": [(), ('int',)],

# class sample.OverloadedFuncEnum:

# class sample.PairUser:
    "sample.PairUser.__init__": [(), ('sample.PairUser',)],
    "sample.PairUser.__copy__": (),
    "sample.PairUser.callCreatePair": (),
    "sample.PairUser.createComplexPair": ('complex', 'complex'),
    "sample.PairUser.createPair": (),
    "sample.PairUser.getPair": (),
    "sample.PairUser.setPair": ('typing.Tuple[int, int]',),
    "sample.PairUser.sumPair": ('typing.Tuple[int, float]',),

# class sample.Pen:
    "sample.Pen.__init__": [(), ('sample.Color',), ('sample.Pen',), ('sample.SampleNamespace.Option',)],
    "sample.Pen.__copy__": (),
    "sample.Pen.ctorType": (),

# class sample.PersistentModelIndex:
    "sample.PersistentModelIndex.__init__": [(), ('sample.ModelIndex',), ('sample.PersistentModelIndex',)],
    "sample.PersistentModelIndex.__copy__": (),
    "sample.PersistentModelIndex.setValue": ('int',),
    "sample.PersistentModelIndex.value": (),

# class sample.Photon:

# class sample.Photon.Base:
    "sample.Photon.Base.__init__": [('int',), ('sample.Photon.Base',)],
    "sample.Photon.Base.__copy__": (),
    "sample.Photon.Base.isType": ('sample.Photon.ClassType',),
    "sample.Photon.Base.setValue": ('int',),
    "sample.Photon.Base.type": (),
    "sample.Photon.Base.value": (),

# class sample.Photon.ClassType:

# class sample.Photon.ValueDuplicator:
    "sample.Photon.ValueDuplicator.__init__": [('int',), ('sample.Photon.ValueDuplicator',)],
    "sample.Photon.ValueDuplicator.__copy__": (),
    "sample.Photon.ValueDuplicator.calculate": (),
    "sample.Photon.ValueDuplicator.classType": (),
    "sample.Photon.ValueDuplicator.getListOfThisTemplateBase": (),
    "sample.Photon.ValueDuplicator.multiplicator": (),
    "sample.Photon.ValueDuplicator.passPointerThrough": ('sample.Photon.ValueDuplicator',),
    "sample.Photon.ValueDuplicator.sumValueUsingPointer": ('sample.Photon.ValueDuplicator',),
    "sample.Photon.ValueDuplicator.sumValueUsingReference": ('sample.Photon.ValueDuplicator',),
    "sample.Photon.ValueDuplicator.type": (),

# class sample.Photon.ValueIdentity:
    "sample.Photon.ValueIdentity.__init__": [('int',), ('sample.Photon.ValueIdentity',)],
    "sample.Photon.ValueIdentity.__copy__": (),
    "sample.Photon.ValueIdentity.calculate": (),
    "sample.Photon.ValueIdentity.classType": (),
    "sample.Photon.ValueIdentity.getListOfThisTemplateBase": (),
    "sample.Photon.ValueIdentity.multiplicator": (),
    "sample.Photon.ValueIdentity.passPointerThrough": ('sample.Photon.ValueIdentity',),
    "sample.Photon.ValueIdentity.sumValueUsingPointer": ('sample.Photon.ValueIdentity',),
    "sample.Photon.ValueIdentity.sumValueUsingReference": ('sample.Photon.ValueIdentity',),
    "sample.Photon.ValueIdentity.type": (),

    "sample.Photon.callCalculateForValueDuplicatorPointer": ('sample.Photon.ValueDuplicator',),
    "sample.Photon.callCalculateForValueDuplicatorReference": ('sample.Photon.ValueDuplicator',),
    "sample.Photon.countValueDuplicators": ('typing.List[sample.Photon.ValueDuplicator]',),
    "sample.Photon.countValueIdentities": ('typing.List[sample.Photon.ValueIdentity]',),

# class sample.Point:
    "sample.Point.__init__": [('float', 'float'), ('int', 'int'), ('typing.Tuple[float, float]',)],
    "sample.Point.__add__": ('typing.Tuple[float, float]',),
    "sample.Point.__copy__": (),
    "sample.Point.__iadd__": ('typing.Tuple[float, float]',),
    "sample.Point.__isub__": ('typing.Tuple[float, float]',),
    "sample.Point.__mul__": [('float',), ('int',)],
    "sample.Point.__neg__": (),
    "sample.Point.__reduce__": (),
    "sample.Point.__repr__": (),
    "sample.Point.__str__": (),
    "sample.Point.__sub__": [('typing.Tuple[float, float]',), ('unicode',)],
    "sample.Point.copy": (),
    "sample.Point.getConstReferenceToSelf": (),
    "sample.Point.getSelf": (),
    "sample.Point.midpoint": ('typing.Tuple[float, float]', 'typing.Tuple[float, float]'),
    "sample.Point.setX": ('float',),
    "sample.Point.setXAsUint": ('int',),
    "sample.Point.setY": ('float',),
    "sample.Point.setYAsUint": ('int',),
    "sample.Point.show": (),
    "sample.Point.x": (),
    "sample.Point.y": (),

# class sample.PointF:
    "sample.PointF.__init__": [('float', 'float'), ('sample.PointF',), ('typing.Tuple[float, float]',)],
    "sample.PointF.__add__": ('sample.PointF',),
    "sample.PointF.__copy__": (),
    "sample.PointF.__iadd__": ('sample.PointF',),
    "sample.PointF.__isub__": ('sample.PointF',),
    "sample.PointF.__mul__": [('float',), ('int',)],
    "sample.PointF.__neg__": (),
    "sample.PointF.__reduce__": (),
    "sample.PointF.__repr__": (),
    "sample.PointF.__str__": (),
    "sample.PointF.__sub__": ('sample.PointF',),
    "sample.PointF.midpoint": ('sample.PointF', 'sample.PointF'),
    "sample.PointF.setX": ('float',),
    "sample.PointF.setY": ('float',),
    "sample.PointF.show": (),
    "sample.PointF.x": (),
    "sample.PointF.y": (),

# class sample.PointValueList:

# class sample.PointValueList.CtorEnum:
    "sample.PointValueList.__init__": [(), ('sample.PointValueList',), ('typing.Sequence[typing.Tuple]',), ('typing.Tuple[float, float]',)],
    "sample.PointValueList.__copy__": (),
    "sample.PointValueList.append": ('typing.Tuple[float, float]',),
    "sample.PointValueList.constructorUsed": (),

# class sample.PointerHolder:
    "sample.PointerHolder.__init__": [('object',), ('sample.PointerHolder',)],
    "sample.PointerHolder.__copy__": (),
    "sample.PointerHolder.pointer": (),

# class sample.Polygon:
    "sample.Polygon.__init__": [(), ('float', 'float'), ('sample.Polygon',), ('typing.List[typing.Tuple]',), ('typing.Tuple[float, float]',)],
    "sample.Polygon.__copy__": (),
    "sample.Polygon.addPoint": ('typing.Tuple[float, float]',),
    "sample.Polygon.doublePolygonScale": ('sample.Polygon',),
    "sample.Polygon.points": (),
    "sample.Polygon.stealOwnershipFromPython": [('sample.Polygon',), ('typing.Tuple[float, float]',)],

# class sample.PrimitiveStructPointerHolder:
    "sample.PrimitiveStructPointerHolder.__init__": [(), ('sample.PrimitiveStructPointerHolder',)],
    "sample.PrimitiveStructPointerHolder.__copy__": (),

# class sample.PrivateCtor:
    "sample.PrivateCtor.instance": (),
    "sample.PrivateCtor.instanceCalls": (),

# class sample.PrivateDtor:
    "sample.PrivateDtor.instance": (),
    "sample.PrivateDtor.instanceCalls": (),
    "sample.PrivateDtor.protectedInstanceCalls": (),

# class sample.ProtectedEnumClass:

# class sample.ProtectedEnumClass.ProtectedEnum:

# class sample.ProtectedEnumClass.PublicEnum:
    "sample.ProtectedEnumClass.__init__": (),
    "sample.ProtectedEnumClass.callProtectedEnumMethod": ('sample.ProtectedEnumClass.ProtectedEnum',),
    "sample.ProtectedEnumClass.callPublicEnumMethod": ('sample.ProtectedEnumClass.PublicEnum',),
    "sample.ProtectedEnumClass.protectedEnumMethod": ('sample.ProtectedEnumClass.ProtectedEnum',),
    "sample.ProtectedEnumClass.publicEnumMethod": ('sample.ProtectedEnumClass.PublicEnum',),

# class sample.ProtectedNonPolymorphic:
    "sample.ProtectedNonPolymorphic.__init__": [('sample.ProtectedNonPolymorphic',), ('str',)],
    "sample.ProtectedNonPolymorphic.__copy__": (),
    "sample.ProtectedNonPolymorphic.create": (),
    "sample.ProtectedNonPolymorphic.dataTypeName": [('int',), ('object',)],
    "sample.ProtectedNonPolymorphic.modifiedProtectedSum": ('int', 'int'),
    "sample.ProtectedNonPolymorphic.protectedName": (),
    "sample.ProtectedNonPolymorphic.protectedStatic": (),
    "sample.ProtectedNonPolymorphic.protectedSum": ('int', 'int'),
    "sample.ProtectedNonPolymorphic.publicName": (),

# class sample.ProtectedPolymorphic:
    "sample.ProtectedPolymorphic.__init__": [('sample.ProtectedPolymorphic',), ('str',)],
    "sample.ProtectedPolymorphic.__copy__": (),
    "sample.ProtectedPolymorphic.callProtectedName": (),
    "sample.ProtectedPolymorphic.create": (),
    "sample.ProtectedPolymorphic.protectedName": (),
    "sample.ProtectedPolymorphic.publicName": (),

# class sample.ProtectedPolymorphicDaughter:
    "sample.ProtectedPolymorphicDaughter.__init__": [('sample.ProtectedPolymorphicDaughter',), ('str',)],
    "sample.ProtectedPolymorphicDaughter.__copy__": (),
    "sample.ProtectedPolymorphicDaughter.create": (),

# class sample.ProtectedPolymorphicGrandDaughter:
    "sample.ProtectedPolymorphicGrandDaughter.__init__": [('sample.ProtectedPolymorphicGrandDaughter',), ('str',)],
    "sample.ProtectedPolymorphicGrandDaughter.__copy__": (),
    "sample.ProtectedPolymorphicGrandDaughter.create": (),

# class sample.ProtectedProperty:
    "sample.ProtectedProperty.__init__": [(), ('sample.ProtectedProperty',)],
    "sample.ProtectedProperty.__copy__": (),

# class sample.ProtectedVirtualDestructor:
    "sample.ProtectedVirtualDestructor.__init__": (),
    "sample.ProtectedVirtualDestructor.create": (),
    "sample.ProtectedVirtualDestructor.dtorCalled": (),
    "sample.ProtectedVirtualDestructor.resetDtorCounter": (),

# class sample.Rect:
    "sample.Rect.__init__": [(), ('int', 'int', 'int', 'int'), ('sample.Rect',)],
    "sample.Rect.__copy__": (),
    "sample.Rect.bottom": (),
    "sample.Rect.left": (),
    "sample.Rect.right": (),
    "sample.Rect.top": (),

# class sample.RectF:
    "sample.RectF.__init__": [(), ('int', 'int', 'int', 'int'), ('sample.Rect',), ('sample.RectF',)],
    "sample.RectF.__copy__": (),
    "sample.RectF.bottom": (),
    "sample.RectF.left": (),
    "sample.RectF.right": (),
    "sample.RectF.top": (),

# class sample.Reference:
    "sample.Reference.__init__": [('int',), ('sample.Reference',)],
    "sample.Reference.__copy__": (),
    "sample.Reference.alterReferenceIdVirtual": ('sample.Reference',),
    "sample.Reference.callAlterReferenceIdVirtual": ('sample.Reference',),
    "sample.Reference.callUsesConstReferenceVirtual": ('sample.Reference', 'int'),
    "sample.Reference.callUsesReferenceVirtual": ('sample.Reference', 'int'),
    "sample.Reference.multiplier": (),
    "sample.Reference.objId": (),
    "sample.Reference.returnMyFirstArg": ('sample.Reference',),
    "sample.Reference.returnMySecondArg": ('int', 'sample.Reference'),
    "sample.Reference.setObjId": ('int',),
    "sample.Reference.show": (),
    "sample.Reference.usesConstReference": ('sample.Reference',),
    "sample.Reference.usesConstReferenceVirtual": ('sample.Reference', 'int'),
    "sample.Reference.usesReference": ('sample.Reference',),
    "sample.Reference.usesReferenceVirtual": ('sample.Reference', 'int'),

# class sample.ReferentModelIndex:
    "sample.ReferentModelIndex.__init__": [(), ('sample.ModelIndex',), ('sample.ReferentModelIndex',)],
    "sample.ReferentModelIndex.__copy__": (),
    "sample.ReferentModelIndex.setValue": ('int',),
    "sample.ReferentModelIndex.value": (),

# class sample.RemovedNamespace1_Enum:

# class sample.RemovedNamespace2_Enum:

# class sample.SampleNamespace:

# class sample.SampleNamespace.DerivedFromNamespace:
    "sample.SampleNamespace.DerivedFromNamespace.__init__": (),
    "sample.SampleNamespace.DerivedFromNamespace.methodReturningTypeFromParentScope": (),
    "sample.SampleNamespace.DerivedFromNamespace.someVirtualMethod": ('sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough',),

# class sample.SampleNamespace.InValue:

# class sample.SampleNamespace.Option:

# class sample.SampleNamespace.OutValue:

# class sample.SampleNamespace.SomeClass:

# class sample.SampleNamespace.SomeClass.ProtectedEnum:

# class sample.SampleNamespace.SomeClass.PublicScopedEnum:

# class sample.SampleNamespace.SomeClass.SomeInnerClass:

# class sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough:

# class sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough.NiceEnum:

# class sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough.NiceEnumClass:
    "sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough.__init__": (),
    "sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough.someMethod": ('sample.SampleNamespace.SomeClass.SomeInnerClass',),
    "sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough.someVirtualMethod": ('sample.SampleNamespace.SomeClass.SomeInnerClass.OkThisIsRecursiveEnough',),

# class sample.SampleNamespace.SomeClass.SomeInnerClass.ProtectedEnum:

    "sample.SampleNamespace.SomeClass.SomeInnerClass.__init__": [(), ('sample.SampleNamespace.SomeClass.SomeInnerClass',)],
    "sample.SampleNamespace.SomeClass.SomeInnerClass.__copy__": (),

# class sample.SampleNamespace.SomeClass.SomeOtherInnerClass:
    "sample.SampleNamespace.SomeClass.SomeOtherInnerClass.__init__": [(), ('sample.SampleNamespace.SomeClass.SomeOtherInnerClass',)],
    "sample.SampleNamespace.SomeClass.SomeOtherInnerClass.__copy__": (),

    "sample.SampleNamespace.SomeClass.__init__": [(), ('sample.SampleNamespace.SomeClass',)],
    "sample.SampleNamespace.SomeClass.__copy__": (),
    "sample.SampleNamespace.SomeClass.protectedMethodReturningPublicScopedEnum": (),

    "sample.SampleNamespace.ImInsideANamespace": ('int', 'int'),
    "sample.SampleNamespace.doSomethingWithArray": ('str', 'int', 'str'),
    "sample.SampleNamespace.enumArgumentWithDefaultValue": ('sample.SampleNamespace.Option',),
    "sample.SampleNamespace.enumInEnumOut": ('sample.SampleNamespace.InValue',),
    "sample.SampleNamespace.enumItemAsDefaultValueToIntArgument": ('int',),
    "sample.SampleNamespace.forceDecisorSideA": [('object',), ('typing.Tuple[float, float]', 'sample.Str', 'object')],
    "sample.SampleNamespace.forceDecisorSideB": [('int', 'object'), ('int', 'typing.Tuple[float, float]', 'sample.Str', 'object')],
    "sample.SampleNamespace.getNumber": ('sample.SampleNamespace.Option',),
    "sample.SampleNamespace.passReferenceToObjectType": [('object',), ('object', 'int')],
    "sample.SampleNamespace.passReferenceToValueType": [('typing.Tuple[float, float]',), ('typing.Tuple[float, float]', 'float')],
    "sample.SampleNamespace.powerOfTwo": ('float',),

# class sample.SbkDate:
    "sample.SbkDate.__init__": [('int', 'int', 'int'), ('sample.SbkDate',)],
    "sample.SbkDate.__copy__": (),
    "sample.SbkDate.day": (),
    "sample.SbkDate.month": (),
    "sample.SbkDate.toPython": (),
    "sample.SbkDate.year": (),

# class sample.SimpleFile:
    "sample.SimpleFile.__init__": [('sample.SimpleFile',), ('str',)],
    "sample.SimpleFile.__copy__": (),
    "sample.SimpleFile.close": (),
    "sample.SimpleFile.exists": [(), ('str',)],
    "sample.SimpleFile.filename": (),
    "sample.SimpleFile.open": (),
    "sample.SimpleFile.size": (),

# class sample.Size:
    "sample.Size.__init__": [('float', 'float'), ('sample.Size',), ('str',)],
    "sample.Size.__add__": ('sample.Size',),
    "sample.Size.__copy__": (),
    "sample.Size.__iadd__": ('sample.Size',),
    "sample.Size.__imul__": ('float',),
    "sample.Size.__isub__": ('sample.Size',),
    "sample.Size.__mul__": ('float',),
    "sample.Size.__sub__": ('sample.Size',),
    "sample.Size.calculateArea": (),
    "sample.Size.height": (),
    "sample.Size.setHeight": ('float',),
    "sample.Size.setWidth": ('float',),
    "sample.Size.show": (),
    "sample.Size.width": (),

# class sample.SizeF:
    "sample.SizeF.__init__": [('float', 'float'), ('sample.SizeF',)],
    "sample.SizeF.__copy__": (),
    "sample.SizeF.height": (),
    "sample.SizeF.passTypedefOfUnsignedShort": ('int',),
    "sample.SizeF.width": (),

# class sample.SonOfMDerived1:
    "sample.SonOfMDerived1.__init__": (),
    "sample.SonOfMDerived1.castToMDerived1": (),
    "sample.SonOfMDerived1.sonOfMDerived1Method": (),

# class sample.SortedOverload:
    "sample.SortedOverload.__init__": [(), ('sample.SortedOverload',)],
    "sample.SortedOverload.__copy__": (),
    "sample.SortedOverload.implicit_overload": ('sample.ImplicitBase',),
    "sample.SortedOverload.overload": [('float',), ('int',), ('object',), ('sample.ImplicitBase',), ('sample.ImplicitTarget',), ('typing.List[sample.ImplicitBase]',)],
    "sample.SortedOverload.overloadDeep": [('int', 'object'), ('int', 'sample.ImplicitBase')],
    "sample.SortedOverload.pyObjOverload": [('int', 'int'), ('str', 'int')],

# class sample.Str:
    "sample.Str.__init__": [('sample.Str',), ('str',), ('typing.Char',)],
    "sample.Str.__add__": ('int',),
    "sample.Str.__copy__": (),
    "sample.Str.__str__": (),
    "sample.Str.append": ('sample.Str',),
    "sample.Str.arg": ('sample.Str',),
    "sample.Str.cstring": (),
    "sample.Str.get_char": ('int',),
    "sample.Str.prepend": ('sample.Str',),
    "sample.Str.set_char": ('int', 'typing.Char'),
    "sample.Str.show": (),
    "sample.Str.size": (),
    "sample.Str.toInt": ('int',),

# class sample.StrList:

# class sample.StrList.CtorEnum:
    "sample.StrList.__init__": [(), ('sample.Str',), ('sample.StrList',), ('typing.List[sample.Str]',)],
    "sample.StrList.__copy__": (),
    "sample.StrList.append": ('sample.Str',),
    "sample.StrList.constructorUsed": (),
    "sample.StrList.join": ('sample.Str',),

# class sample.TemplatePtr:
    "sample.TemplatePtr.__init__": (),
    "sample.TemplatePtr.dummy_method": ('typing.List[typing.Tuple]',),

# class sample.Time:

# class sample.Time.NumArgs:
    "sample.Time.__init__": [(), ('int', 'int', 'int', 'int'), ('sample.Time',)],
    "sample.Time.__copy__": (),
    "sample.Time.hour": (),
    "sample.Time.isNull": (),
    "sample.Time.minute": (),
    "sample.Time.msec": (),
    "sample.Time.second": (),
    "sample.Time.setTime": [(), ('int', 'int', 'int', 'int')],
    "sample.Time.somethingCompletelyDifferent": [(), ('int', 'int', 'sample.ImplicitConv', 'object')],
    "sample.Time.toString": (),

# class sample.Union:
    "sample.Union.__init__": [(), ('sample.Data',), ('sample.Intersection',), ('sample.Union',)],
    "sample.Union.__and__": ('sample.Data',),
    "sample.Union.__copy__": (),
    "sample.Union.addFilter": ('sample.Filter',),
    "sample.Union.filters": (),

# class sample.UnremovedNamespace:

# class sample.UnremovedNamespace.RemovedNamespace3_Enum:

# class sample.ValueAndVirtual:
    "sample.ValueAndVirtual.__init__": [('int',), ('sample.ValueAndVirtual',)],
    "sample.ValueAndVirtual.__call__": ('int', 'int'),
    "sample.ValueAndVirtual.__copy__": (),
    "sample.ValueAndVirtual.id": (),

# class sample.VirtualDaughter:
    "sample.VirtualDaughter.__init__": [(), ('sample.Str',), ('sample.VirtualDaughter',)],
    "sample.VirtualDaughter.__copy__": (),

# class sample.VirtualDaughter2:
    "sample.VirtualDaughter2.__init__": (),
    "sample.VirtualDaughter2.sumThree": ('int', 'int', 'int'),
    "sample.VirtualDaughter2.virtualMethod0": ('typing.Tuple[float, float]', 'int', 'complex', 'bool'),

# class sample.VirtualDtor:
    "sample.VirtualDtor.__init__": [(), ('sample.VirtualDtor',)],
    "sample.VirtualDtor.__copy__": (),
    "sample.VirtualDtor.create": (),
    "sample.VirtualDtor.dtorCalled": (),
    "sample.VirtualDtor.resetDtorCounter": (),

# class sample.VirtualFinalDaughter:
    "sample.VirtualFinalDaughter.__init__": (),
    "sample.VirtualFinalDaughter.sumThree": ('int', 'int', 'int'),
    "sample.VirtualFinalDaughter.virtualMethod0": ('typing.Tuple[float, float]', 'int', 'complex', 'bool'),

# class sample.VirtualMethods:
    "sample.VirtualMethods.__init__": [('sample.Str',), ('sample.VirtualMethods',)],
    "sample.VirtualMethods.__copy__": (),
    "sample.VirtualMethods.callCallMe": (),
    "sample.VirtualMethods.callCreateStr": ('str', 'sample.Str'),
    "sample.VirtualMethods.callGetMargins": (),
    "sample.VirtualMethods.callMe": (),
    "sample.VirtualMethods.callName": (),
    "sample.VirtualMethods.callRecursionOnModifiedVirtual": ('sample.Str',),
    "sample.VirtualMethods.callStrListToStdList": ('sample.StrList',),
    "sample.VirtualMethods.callSum0": ('int', 'int', 'int'),
    "sample.VirtualMethods.callSum1": ('int', 'int', 'int'),
    "sample.VirtualMethods.callSum2": ('int', 'int', 'int'),
    "sample.VirtualMethods.callSum3": ('int', 'int', 'int'),
    "sample.VirtualMethods.callSum4": ('int', 'int', 'int'),
    "sample.VirtualMethods.callVirtualMethod0": ('typing.Tuple[float, float]', 'int', 'complex', 'bool'),
    "sample.VirtualMethods.createStr": ('str', 'sample.Str'),
    "sample.VirtualMethods.getMargins": (),
    "sample.VirtualMethods.name": (),
    "sample.VirtualMethods.recursionOnModifiedVirtual": ('sample.Str',),
    "sample.VirtualMethods.setMargins": ('int', 'int', 'int', 'int'),
    "sample.VirtualMethods.strListToStdList": ('sample.StrList',),
    "sample.VirtualMethods.sum1": ('int', 'int', 'int'),
    "sample.VirtualMethods.sum2": ('int', 'int', 'int'),
    "sample.VirtualMethods.sum3": ('int', 'int', 'int'),
    "sample.VirtualMethods.sum4": ('int', 'int', 'int'),
    "sample.VirtualMethods.sumThree": ('int', 'int', 'int'),
    "sample.VirtualMethods.virtualMethod0": ('typing.Tuple[float, float]', 'int', 'complex', 'bool'),

# class sample.VoidHolder:
    "sample.VoidHolder.__init__": [('int',), ('sample.VoidHolder',)],
    "sample.VoidHolder.__copy__": (),
    "sample.VoidHolder.gimmeMeSomeVoidPointer": (),
    "sample.VoidHolder.takeVoidPointer": ('int',),
    "sample.VoidHolder.voidPointer": (),

# class sample.sample:

# class sample.sample.sample:
    "sample.sample.sample.__init__": [('int',), ('sample.sample.sample',)],
    "sample.sample.sample.__copy__": (),
    "sample.sample.sample.value": (),

    "sample.sample.acceptDouble": ('float',),
    "sample.sample.acceptInt": ('int',),
    "sample.sample.acceptIntReference": ('int',),
    "sample.sample.acceptLong": ('int',),
    "sample.sample.acceptOddBoolReference": ('bool',),
    "sample.sample.acceptUInt": ('int',),
    "sample.sample.acceptULong": ('int',),
    "sample.sample.applyHomogeneousTransform": ('typing.Tuple[float, float]', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float', 'float'),
    "sample.sample.cacheSize": (),
    "sample.sample.changePStr": ('str',),
    "sample.sample.convertIntegersToCppAndThenToPython": ('int', 'int'),
    "sample.sample.convertListOfIntegersToCppAndThenToPython": ('typing.List[int]',),
    "sample.sample.convertObjectTypeToCppAndThenToPython": ('object', 'object'),
    "sample.sample.convertValueTypeToCppAndThenToPython": ('typing.Tuple[float, float]', 'typing.Tuple[float, float]', 'typing.Tuple[float, float]'),
    "sample.sample.countCharacters": ('str',),
    "sample.sample.countVarargs": ('int', 'None'),
    "sample.sample.cppTypeIsObjectType": ('str',),
    "sample.sample.cppTypeIsValueType": ('str',),
    "sample.sample.createListOfPStr": ('str', 'str'),
    "sample.sample.createPStrList": ('str', 'str'),
    "sample.sample.createProtectedProperty": (),
    "sample.sample.doubleLongLong": ('int',),
    "sample.sample.doubleShort": ('int',),
    "sample.sample.doubleUnsignedInt": ('int',),
    "sample.sample.doubleUnsignedLongLong": ('int',),
    "sample.sample.duplicatePStr": (),
    "sample.sample.getConversionTypeString": ('str',),
    "sample.sample.getPythonType": ('str',),
    "sample.sample.gimmeComplexList": (),
    "sample.sample.gimmeDouble": (),
    "sample.sample.gimmeInt": (),
    "sample.sample.makeCString": (),
    "sample.sample.multiplyPair": ('typing.Tuple[float, float]',),
    "sample.sample.multiplyString": ('str', 'int'),
    "sample.sample.overloadedFunc": [('float',), ('int',)],
    "sample.sample.returnCString": (),
    "sample.sample.returnNullObjectTypePointer": (),
    "sample.sample.returnNullPrimitivePointer": (),
    "sample.sample.returnNullValueTypePointer": (),
    "sample.sample.sum2d": ('typing.List[typing.List]',),
    "sample.sample.sumComplexPair": ('typing.Tuple[complex, complex]',),
    "sample.sample.sumDoubleArray": ('typing.Tuple[float, float, float, float]',),
    "sample.sample.sumDoubleMatrix": ('typing.Tuple[typing.Tuple, typing.Tuple, typing.Tuple]',),
    "sample.sample.sumIntArray": ('typing.Tuple[int, int, int, int]',),
    "sample.sample.sumIntMatrix": ('typing.Tuple[typing.Tuple, typing.Tuple, typing.Tuple]',),
    "sample.sample.sumproduct": ('typing.List[typing.Tuple]',),
    "sample.sample.transmuteComplexIntoPoint": ('complex',),
    "sample.sample.transmutePointIntoComplex": ('typing.Tuple[float, float]',),
    }) if "sample" in sys.modules else None

# Module other
sig_dict.update({

# class other.ExtendsNoImplicitConversion:
    "other.ExtendsNoImplicitConversion.__init__": [('Missing("other.ExtendsNoImplicitConversion")',), ('int',)],
    "other.ExtendsNoImplicitConversion.__copy__": (),
    "other.ExtendsNoImplicitConversion.objId": (),

# class other.Number:
    "other.Number.__init__": [('int',), ('numbers.Number',)],
    "other.Number.__copy__": (),
    "other.Number.__mul__": ('typing.Tuple[float, float]',),
    "other.Number.fromComplex": ('complex',),
    "other.Number.toComplex": (),
    "other.Number.toStr": (),
    "other.Number.value": (),

# class other.OtherDerived:
    "other.OtherDerived.__init__": ('int',),
    "other.OtherDerived.className": (),
    "other.OtherDerived.createObject": (),
    "other.OtherDerived.getClassName": (),
    "other.OtherDerived.pureVirtual": (),
    "other.OtherDerived.pureVirtualReturningVoidPtr": (),
    "other.OtherDerived.returnAnEnum": (),
    "other.OtherDerived.unpureVirtual": (),
    "other.OtherDerived.useEnumTypeFromOtherModule": ('sample.OverloadedFuncEnum',),
    "other.OtherDerived.useObjectTypeFromOtherModule": ('object',),
    "other.OtherDerived.useValueTypeFromOtherModule": [('complex',), ('sample.Event',)],

# class other.OtherMultipleDerived:
    "other.OtherMultipleDerived.__init__": (),
    "other.OtherMultipleDerived.createObject": ('str',),
    "other.OtherMultipleDerived.returnUselessClass": (),

# class other.OtherObjectType:
    "other.OtherObjectType.__init__": (),
    "other.OtherObjectType.__lshift__": ('sample.Collector',),
    }) if "other" in sys.modules else None

# Module smart
sig_dict.update({

# class smart.Integer:
    "smart.Integer.__init__": [(), ('smart.Integer',)],
    "smart.Integer.__copy__": (),
    "smart.Integer.printInteger": (),

# class smart.Integer2:
    "smart.Integer2.__init__": [(), ('int',)],
    "smart.Integer2.__copy__": (),

# class smart.Obj:
    "smart.Obj.__init__": (),
    "smart.Obj.giveSharedPtrToInteger": (),
    "smart.Obj.giveSharedPtrToInteger2": (),
    "smart.Obj.giveSharedPtrToObj": (),
    "smart.Obj.giveSharedPtrToObjList": ('int',),
    "smart.Obj.printObj": (),
    "smart.Obj.takeInteger": ('smart.Integer',),
    "smart.Obj.takeSharedPtrToInteger": ('smart.SharedPtr',),
    "smart.Obj.takeSharedPtrToObj": ('smart.SharedPtr',),

# class smart.Registry:
    "smart.Registry.__init__": (),
    "smart.Registry.add": [('smart.Integer',), ('smart.Obj',)],
    "smart.Registry.countIntegers": (),
    "smart.Registry.countObjects": (),
    "smart.Registry.getInstance": (),
    "smart.Registry.remove": [('smart.Integer',), ('smart.Obj',)],
    "smart.Registry.setShouldPrint": ('bool',),
    "smart.Registry.shouldPrint": (),

# class smart.SharedPtr:

# class smart.SharedPtr.__next_in_mro__:

# class smart.SharedPtr<Integer >:
    "smart.SharedPtr<Integer >.__copy__": (),
    "smart.SharedPtr<Integer >.data": (),
    "smart.SharedPtr<Integer >.useCount": (),

# class smart.SharedPtr<Obj >:
    "smart.SharedPtr<Obj >.__copy__": (),
    "smart.SharedPtr<Obj >.data": (),
    "smart.SharedPtr<Obj >.useCount": (),

# class smart.SharedPtr<Smart::Integer2 >:
    "smart.SharedPtr<Smart::Integer2 >.__copy__": (),
    "smart.SharedPtr<Smart::Integer2 >.data": (),
    "smart.SharedPtr<Smart::Integer2 >.useCount": (),
    }) if "smart" in sys.modules else None
# eof
